#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2711
#define LARGE_STATE_COUNT 578
#define SYMBOL_COUNT 406
#define ALIAS_COUNT 0
#define TOKEN_COUNT 194
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 26
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 189

enum ts_symbol_identifiers {
  sym_name = 1,
  sym_php_tag = 2,
  anon_sym_QMARK_GT = 3,
  aux_sym_text_token1 = 4,
  aux_sym_text_token2 = 5,
  anon_sym_SEMI = 6,
  anon_sym_AMP = 7,
  aux_sym_function_static_declaration_token1 = 8,
  anon_sym_COMMA = 9,
  anon_sym_EQ = 10,
  aux_sym_global_declaration_token1 = 11,
  aux_sym_namespace_definition_token1 = 12,
  aux_sym_namespace_use_declaration_token1 = 13,
  aux_sym_namespace_use_declaration_token2 = 14,
  aux_sym_namespace_use_declaration_token3 = 15,
  anon_sym_BSLASH = 16,
  aux_sym_namespace_aliasing_clause_token1 = 17,
  anon_sym_LBRACE = 18,
  anon_sym_RBRACE = 19,
  aux_sym_trait_declaration_token1 = 20,
  aux_sym_interface_declaration_token1 = 21,
  aux_sym_base_clause_token1 = 22,
  aux_sym_enum_declaration_token1 = 23,
  anon_sym_COLON = 24,
  anon_sym_string = 25,
  anon_sym_int = 26,
  aux_sym_enum_case_token1 = 27,
  aux_sym_class_declaration_token1 = 28,
  aux_sym_final_modifier_token1 = 29,
  aux_sym_abstract_modifier_token1 = 30,
  aux_sym_readonly_modifier_token1 = 31,
  aux_sym_class_interface_clause_token1 = 32,
  sym_var_modifier = 33,
  aux_sym_use_instead_of_clause_token1 = 34,
  aux_sym_visibility_modifier_token1 = 35,
  aux_sym_visibility_modifier_token2 = 36,
  aux_sym_visibility_modifier_token3 = 37,
  aux_sym__arrow_function_header_token1 = 38,
  anon_sym_EQ_GT = 39,
  anon_sym_LPAREN = 40,
  anon_sym_RPAREN = 41,
  anon_sym_DOT_DOT_DOT = 42,
  anon_sym_QMARK = 43,
  sym_bottom_type = 44,
  anon_sym_PIPE = 45,
  anon_sym_array = 46,
  aux_sym_primitive_type_token1 = 47,
  anon_sym_iterable = 48,
  anon_sym_bool = 49,
  anon_sym_float = 50,
  anon_sym_void = 51,
  anon_sym_mixed = 52,
  anon_sym_static = 53,
  anon_sym_false = 54,
  anon_sym_null = 55,
  anon_sym_true = 56,
  aux_sym_cast_type_token1 = 57,
  aux_sym_cast_type_token2 = 58,
  aux_sym_cast_type_token3 = 59,
  aux_sym_cast_type_token4 = 60,
  aux_sym_cast_type_token5 = 61,
  aux_sym_cast_type_token6 = 62,
  aux_sym_cast_type_token7 = 63,
  aux_sym_cast_type_token8 = 64,
  aux_sym_cast_type_token9 = 65,
  aux_sym_cast_type_token10 = 66,
  aux_sym_cast_type_token11 = 67,
  aux_sym_cast_type_token12 = 68,
  aux_sym_echo_statement_token1 = 69,
  anon_sym_unset = 70,
  aux_sym_declare_statement_token1 = 71,
  aux_sym_declare_statement_token2 = 72,
  anon_sym_ticks = 73,
  anon_sym_encoding = 74,
  anon_sym_strict_types = 75,
  sym_float = 76,
  aux_sym_try_statement_token1 = 77,
  aux_sym_catch_clause_token1 = 78,
  aux_sym_finally_clause_token1 = 79,
  aux_sym_goto_statement_token1 = 80,
  aux_sym_continue_statement_token1 = 81,
  aux_sym_break_statement_token1 = 82,
  sym_integer = 83,
  aux_sym_return_statement_token1 = 84,
  aux_sym_throw_expression_token1 = 85,
  aux_sym_while_statement_token1 = 86,
  aux_sym_while_statement_token2 = 87,
  aux_sym_do_statement_token1 = 88,
  aux_sym_for_statement_token1 = 89,
  aux_sym_for_statement_token2 = 90,
  aux_sym_foreach_statement_token1 = 91,
  aux_sym_foreach_statement_token2 = 92,
  aux_sym_if_statement_token1 = 93,
  aux_sym_if_statement_token2 = 94,
  aux_sym_else_if_clause_token1 = 95,
  aux_sym_else_clause_token1 = 96,
  aux_sym_match_expression_token1 = 97,
  aux_sym_match_default_expression_token1 = 98,
  aux_sym_switch_statement_token1 = 99,
  aux_sym_switch_block_token1 = 100,
  anon_sym_PLUS = 101,
  anon_sym_DASH = 102,
  anon_sym_TILDE = 103,
  anon_sym_BANG = 104,
  anon_sym_AT = 105,
  aux_sym_clone_expression_token1 = 106,
  anon_sym_COLON_COLON = 107,
  aux_sym_print_intrinsic_token1 = 108,
  aux_sym_object_creation_expression_token1 = 109,
  anon_sym_DASH_DASH = 110,
  anon_sym_PLUS_PLUS = 111,
  anon_sym_STAR_STAR_EQ = 112,
  anon_sym_STAR_EQ = 113,
  anon_sym_SLASH_EQ = 114,
  anon_sym_PERCENT_EQ = 115,
  anon_sym_PLUS_EQ = 116,
  anon_sym_DASH_EQ = 117,
  anon_sym_DOT_EQ = 118,
  anon_sym_LT_LT_EQ = 119,
  anon_sym_GT_GT_EQ = 120,
  anon_sym_AMP_EQ = 121,
  anon_sym_CARET_EQ = 122,
  anon_sym_PIPE_EQ = 123,
  anon_sym_QMARK_QMARK_EQ = 124,
  anon_sym_DASH_GT = 125,
  anon_sym_QMARK_DASH_GT = 126,
  aux_sym__list_destructing_token1 = 127,
  anon_sym_LBRACK = 128,
  anon_sym_RBRACK = 129,
  anon_sym_self = 130,
  anon_sym_parent = 131,
  aux_sym__argument_name_token1 = 132,
  aux_sym__argument_name_token2 = 133,
  anon_sym_POUND_LBRACK = 134,
  sym_escape_sequence = 135,
  anon_sym_BSLASHu = 136,
  aux_sym_encapsed_string_token1 = 137,
  anon_sym_DQUOTE = 138,
  aux_sym_string_token1 = 139,
  anon_sym_SQUOTE = 140,
  aux_sym_string_token2 = 141,
  sym_string_value = 142,
  anon_sym_LT_LT_LT = 143,
  anon_sym_DQUOTE2 = 144,
  sym__new_line = 145,
  anon_sym_ = 146,
  anon_sym_SQUOTE2 = 147,
  anon_sym_BQUOTE = 148,
  anon_sym_DOLLAR = 149,
  aux_sym_yield_expression_token1 = 150,
  aux_sym_yield_expression_token2 = 151,
  aux_sym_binary_expression_token1 = 152,
  anon_sym_QMARK_QMARK = 153,
  anon_sym_STAR_STAR = 154,
  aux_sym_binary_expression_token2 = 155,
  aux_sym_binary_expression_token3 = 156,
  aux_sym_binary_expression_token4 = 157,
  anon_sym_PIPE_PIPE = 158,
  anon_sym_AMP_AMP = 159,
  anon_sym_CARET = 160,
  anon_sym_EQ_EQ = 161,
  anon_sym_BANG_EQ = 162,
  anon_sym_LT_GT = 163,
  anon_sym_EQ_EQ_EQ = 164,
  anon_sym_BANG_EQ_EQ = 165,
  anon_sym_LT = 166,
  anon_sym_GT = 167,
  anon_sym_LT_EQ = 168,
  anon_sym_GT_EQ = 169,
  anon_sym_LT_EQ_GT = 170,
  anon_sym_LT_LT = 171,
  anon_sym_GT_GT = 172,
  anon_sym_DOT = 173,
  anon_sym_STAR = 174,
  anon_sym_SLASH = 175,
  anon_sym_PERCENT = 176,
  aux_sym_include_expression_token1 = 177,
  aux_sym_include_once_expression_token1 = 178,
  aux_sym_require_expression_token1 = 179,
  aux_sym_require_once_expression_token1 = 180,
  sym_comment = 181,
  sym__automatic_semicolon = 182,
  sym_encapsed_string_chars = 183,
  sym_encapsed_string_chars_after_variable = 184,
  sym_execution_string_chars = 185,
  sym_execution_string_chars_after_variable = 186,
  sym_encapsed_string_chars_heredoc = 187,
  sym_encapsed_string_chars_after_variable_heredoc = 188,
  sym__eof = 189,
  sym_heredoc_start = 190,
  sym_heredoc_end = 191,
  sym_nowdoc_string = 192,
  sym_sentinel_error = 193,
  sym_program = 194,
  sym_text_interpolation = 195,
  sym_text = 196,
  sym_empty_statement = 197,
  sym_reference_modifier = 198,
  sym_function_static_declaration = 199,
  sym_static_variable_declaration = 200,
  sym_global_declaration = 201,
  sym_namespace_definition = 202,
  sym_namespace_use_declaration = 203,
  sym_namespace_use_clause = 204,
  sym_qualified_name = 205,
  sym_namespace_name_as_prefix = 206,
  sym_namespace_name = 207,
  sym_namespace_aliasing_clause = 208,
  sym_namespace_use_group = 209,
  sym_namespace_use_group_clause = 210,
  sym_trait_declaration = 211,
  sym_interface_declaration = 212,
  sym_base_clause = 213,
  sym_enum_declaration = 214,
  sym_enum_declaration_list = 215,
  sym__enum_member_declaration = 216,
  sym_enum_case = 217,
  sym_class_declaration = 218,
  sym_declaration_list = 219,
  sym_final_modifier = 220,
  sym_abstract_modifier = 221,
  sym_readonly_modifier = 222,
  sym_class_interface_clause = 223,
  sym__member_declaration = 224,
  sym_const_declaration = 225,
  sym__class_const_declaration = 226,
  sym__const_declaration = 227,
  sym_property_declaration = 228,
  sym__modifier = 229,
  sym_property_element = 230,
  sym_property_initializer = 231,
  sym_method_declaration = 232,
  sym_static_modifier = 233,
  sym_use_declaration = 234,
  sym_use_list = 235,
  sym_use_instead_of_clause = 236,
  sym_use_as_clause = 237,
  sym_visibility_modifier = 238,
  sym_function_definition = 239,
  sym__function_definition_header = 240,
  sym__arrow_function_header = 241,
  sym_arrow_function = 242,
  sym_formal_parameters = 243,
  sym_property_promotion_parameter = 244,
  sym_simple_parameter = 245,
  sym_variadic_parameter = 246,
  sym__type = 247,
  sym__types = 248,
  sym_named_type = 249,
  sym_optional_type = 250,
  sym_union_type = 251,
  sym_intersection_type = 252,
  sym_disjunctive_normal_form_type = 253,
  sym_primitive_type = 254,
  sym_cast_type = 255,
  sym__return_type = 256,
  sym_const_element = 257,
  sym_echo_statement = 258,
  sym_unset_statement = 259,
  sym_declare_statement = 260,
  sym_declare_directive = 261,
  sym_try_statement = 262,
  sym_catch_clause = 263,
  sym_type_list = 264,
  sym_finally_clause = 265,
  sym_goto_statement = 266,
  sym_continue_statement = 267,
  sym_break_statement = 268,
  sym_return_statement = 269,
  sym_throw_expression = 270,
  sym_while_statement = 271,
  sym_do_statement = 272,
  sym_for_statement = 273,
  sym__expressions = 274,
  sym_sequence_expression = 275,
  sym_foreach_statement = 276,
  sym_foreach_pair = 277,
  sym_if_statement = 278,
  sym_colon_block = 279,
  sym_else_if_clause = 280,
  sym_else_clause = 281,
  sym_else_if_clause_2 = 282,
  sym_else_clause_2 = 283,
  sym_match_expression = 284,
  sym_match_block = 285,
  sym_match_condition_list = 286,
  sym_match_conditional_expression = 287,
  sym_match_default_expression = 288,
  sym_switch_statement = 289,
  sym_switch_block = 290,
  sym_case_statement = 291,
  sym_default_statement = 292,
  sym_compound_statement = 293,
  sym_named_label_statement = 294,
  sym_expression_statement = 295,
  sym__expression = 296,
  sym__unary_expression = 297,
  sym_unary_op_expression = 298,
  sym_error_suppression_expression = 299,
  sym_clone_expression = 300,
  sym__primary_expression = 301,
  sym_parenthesized_expression = 302,
  sym_class_constant_access_expression = 303,
  sym_print_intrinsic = 304,
  sym_anonymous_function_creation_expression = 305,
  sym_anonymous_function_use_clause = 306,
  sym_object_creation_expression = 307,
  sym_update_expression = 308,
  sym_cast_expression = 309,
  sym_cast_variable = 310,
  sym_assignment_expression = 311,
  sym_reference_assignment_expression = 312,
  sym_conditional_expression = 313,
  sym_augmented_assignment_expression = 314,
  sym_member_access_expression = 315,
  sym_nullsafe_member_access_expression = 316,
  sym_scoped_property_access_expression = 317,
  sym_list_literal = 318,
  sym__list_destructing = 319,
  sym__array_destructing = 320,
  sym__array_destructing_element = 321,
  sym_function_call_expression = 322,
  sym_scoped_call_expression = 323,
  sym__scope_resolution_qualifier = 324,
  sym_relative_scope = 325,
  sym_variadic_placeholder = 326,
  sym_arguments = 327,
  sym_argument = 328,
  sym__argument_name = 329,
  sym_member_call_expression = 330,
  sym_nullsafe_member_call_expression = 331,
  sym_variadic_unpacking = 332,
  sym_subscript_expression = 333,
  sym__dereferencable_expression = 334,
  sym_array_creation_expression = 335,
  sym_attribute_group = 336,
  sym_attribute_list = 337,
  sym_attribute = 338,
  sym__complex_string_part = 339,
  sym__simple_string_member_access_expression = 340,
  sym__simple_string_subscript_unary_expression = 341,
  sym__simple_string_array_access_argument = 342,
  sym__simple_string_subscript_expression = 343,
  sym__simple_string_part = 344,
  aux_sym__interpolated_string_body = 345,
  aux_sym__interpolated_string_body_heredoc = 346,
  sym_encapsed_string = 347,
  sym_string = 348,
  sym_heredoc_body = 349,
  sym_heredoc = 350,
  sym_nowdoc_body = 351,
  sym_nowdoc = 352,
  aux_sym__interpolated_execution_operator_body = 353,
  sym_shell_command_expression = 354,
  sym_boolean = 355,
  sym_null = 356,
  sym__string = 357,
  sym_dynamic_variable_name = 358,
  sym_variable_name = 359,
  sym_variable_reference = 360,
  sym_by_ref = 361,
  sym_yield_expression = 362,
  sym_array_element_initializer = 363,
  sym_binary_expression = 364,
  sym_include_expression = 365,
  sym_include_once_expression = 366,
  sym_require_expression = 367,
  sym_require_once_expression = 368,
  sym__reserved_identifier = 369,
  aux_sym_program_repeat1 = 370,
  aux_sym_text_repeat1 = 371,
  aux_sym_function_static_declaration_repeat1 = 372,
  aux_sym_global_declaration_repeat1 = 373,
  aux_sym_namespace_use_declaration_repeat1 = 374,
  aux_sym_namespace_name_repeat1 = 375,
  aux_sym_namespace_use_group_repeat1 = 376,
  aux_sym_base_clause_repeat1 = 377,
  aux_sym_enum_declaration_list_repeat1 = 378,
  aux_sym_declaration_list_repeat1 = 379,
  aux_sym__const_declaration_repeat1 = 380,
  aux_sym_property_declaration_repeat1 = 381,
  aux_sym_property_declaration_repeat2 = 382,
  aux_sym_use_list_repeat1 = 383,
  aux_sym_formal_parameters_repeat1 = 384,
  aux_sym_union_type_repeat1 = 385,
  aux_sym_intersection_type_repeat1 = 386,
  aux_sym_disjunctive_normal_form_type_repeat1 = 387,
  aux_sym_unset_statement_repeat1 = 388,
  aux_sym_try_statement_repeat1 = 389,
  aux_sym_type_list_repeat1 = 390,
  aux_sym_if_statement_repeat1 = 391,
  aux_sym_if_statement_repeat2 = 392,
  aux_sym_match_block_repeat1 = 393,
  aux_sym_match_condition_list_repeat1 = 394,
  aux_sym_switch_block_repeat1 = 395,
  aux_sym_anonymous_function_use_clause_repeat1 = 396,
  aux_sym__list_destructing_repeat1 = 397,
  aux_sym__array_destructing_repeat1 = 398,
  aux_sym_arguments_repeat1 = 399,
  aux_sym_array_creation_expression_repeat1 = 400,
  aux_sym_attribute_group_repeat1 = 401,
  aux_sym_attribute_list_repeat1 = 402,
  aux_sym_string_repeat1 = 403,
  aux_sym_heredoc_body_repeat1 = 404,
  aux_sym_nowdoc_body_repeat1 = 405,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_name] = "name",
  [sym_php_tag] = "php_tag",
  [anon_sym_QMARK_GT] = "\?>",
  [aux_sym_text_token1] = "text_token1",
  [aux_sym_text_token2] = "text_token2",
  [anon_sym_SEMI] = ";",
  [anon_sym_AMP] = "&",
  [aux_sym_function_static_declaration_token1] = "static",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [aux_sym_global_declaration_token1] = "global",
  [aux_sym_namespace_definition_token1] = "namespace",
  [aux_sym_namespace_use_declaration_token1] = "use",
  [aux_sym_namespace_use_declaration_token2] = "function",
  [aux_sym_namespace_use_declaration_token3] = "const",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_namespace_aliasing_clause_token1] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym_trait_declaration_token1] = "trait",
  [aux_sym_interface_declaration_token1] = "interface",
  [aux_sym_base_clause_token1] = "extends",
  [aux_sym_enum_declaration_token1] = "enum",
  [anon_sym_COLON] = ":",
  [anon_sym_string] = "string",
  [anon_sym_int] = "int",
  [aux_sym_enum_case_token1] = "case",
  [aux_sym_class_declaration_token1] = "class",
  [aux_sym_final_modifier_token1] = "final",
  [aux_sym_abstract_modifier_token1] = "abstract",
  [aux_sym_readonly_modifier_token1] = "readonly",
  [aux_sym_class_interface_clause_token1] = "implements",
  [sym_var_modifier] = "var_modifier",
  [aux_sym_use_instead_of_clause_token1] = "insteadof",
  [aux_sym_visibility_modifier_token1] = "public",
  [aux_sym_visibility_modifier_token2] = "protected",
  [aux_sym_visibility_modifier_token3] = "private",
  [aux_sym__arrow_function_header_token1] = "fn",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [sym_bottom_type] = "bottom_type",
  [anon_sym_PIPE] = "|",
  [anon_sym_array] = "array",
  [aux_sym_primitive_type_token1] = "callable",
  [anon_sym_iterable] = "iterable",
  [anon_sym_bool] = "bool",
  [anon_sym_float] = "float",
  [anon_sym_void] = "void",
  [anon_sym_mixed] = "mixed",
  [anon_sym_static] = "static",
  [anon_sym_false] = "false",
  [anon_sym_null] = "null",
  [anon_sym_true] = "true",
  [aux_sym_cast_type_token1] = "cast_type_token1",
  [aux_sym_cast_type_token2] = "cast_type_token2",
  [aux_sym_cast_type_token3] = "cast_type_token3",
  [aux_sym_cast_type_token4] = "cast_type_token4",
  [aux_sym_cast_type_token5] = "cast_type_token5",
  [aux_sym_cast_type_token6] = "cast_type_token6",
  [aux_sym_cast_type_token7] = "cast_type_token7",
  [aux_sym_cast_type_token8] = "cast_type_token8",
  [aux_sym_cast_type_token9] = "cast_type_token9",
  [aux_sym_cast_type_token10] = "cast_type_token10",
  [aux_sym_cast_type_token11] = "cast_type_token11",
  [aux_sym_cast_type_token12] = "cast_type_token12",
  [aux_sym_echo_statement_token1] = "echo",
  [anon_sym_unset] = "unset",
  [aux_sym_declare_statement_token1] = "declare",
  [aux_sym_declare_statement_token2] = "enddeclare",
  [anon_sym_ticks] = "ticks",
  [anon_sym_encoding] = "encoding",
  [anon_sym_strict_types] = "strict_types",
  [sym_float] = "float",
  [aux_sym_try_statement_token1] = "try",
  [aux_sym_catch_clause_token1] = "catch",
  [aux_sym_finally_clause_token1] = "finally",
  [aux_sym_goto_statement_token1] = "goto",
  [aux_sym_continue_statement_token1] = "continue",
  [aux_sym_break_statement_token1] = "break",
  [sym_integer] = "integer",
  [aux_sym_return_statement_token1] = "return",
  [aux_sym_throw_expression_token1] = "throw",
  [aux_sym_while_statement_token1] = "while",
  [aux_sym_while_statement_token2] = "endwhile",
  [aux_sym_do_statement_token1] = "do",
  [aux_sym_for_statement_token1] = "for",
  [aux_sym_for_statement_token2] = "endfor",
  [aux_sym_foreach_statement_token1] = "foreach",
  [aux_sym_foreach_statement_token2] = "endforeach",
  [aux_sym_if_statement_token1] = "if",
  [aux_sym_if_statement_token2] = "endif",
  [aux_sym_else_if_clause_token1] = "elseif",
  [aux_sym_else_clause_token1] = "else",
  [aux_sym_match_expression_token1] = "match",
  [aux_sym_match_default_expression_token1] = "default",
  [aux_sym_switch_statement_token1] = "switch",
  [aux_sym_switch_block_token1] = "endswitch",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_AT] = "@",
  [aux_sym_clone_expression_token1] = "clone",
  [anon_sym_COLON_COLON] = "::",
  [aux_sym_print_intrinsic_token1] = "print",
  [aux_sym_object_creation_expression_token1] = "new",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_QMARK_DASH_GT] = "\?->",
  [aux_sym__list_destructing_token1] = "list",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_self] = "self",
  [anon_sym_parent] = "parent",
  [aux_sym__argument_name_token1] = "_argument_name_token1",
  [aux_sym__argument_name_token2] = "_argument_name_token2",
  [anon_sym_POUND_LBRACK] = "#[",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_BSLASHu] = "string_value",
  [aux_sym_encapsed_string_token1] = "encapsed_string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "escape_sequence",
  [sym_string_value] = "string_value",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_DQUOTE2] = "\"",
  [sym__new_line] = "_new_line",
  [anon_sym_] = "nowdoc_string",
  [anon_sym_SQUOTE2] = "'",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_yield_expression_token1] = "yield",
  [aux_sym_yield_expression_token2] = "from",
  [aux_sym_binary_expression_token1] = "instanceof",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_STAR_STAR] = "**",
  [aux_sym_binary_expression_token2] = "and",
  [aux_sym_binary_expression_token3] = "or",
  [aux_sym_binary_expression_token4] = "xor",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_CARET] = "^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [aux_sym_include_expression_token1] = "include",
  [aux_sym_include_once_expression_token1] = "include_once",
  [aux_sym_require_expression_token1] = "require",
  [aux_sym_require_once_expression_token1] = "require_once",
  [sym_comment] = "comment",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym_encapsed_string_chars] = "string_value",
  [sym_encapsed_string_chars_after_variable] = "string_value",
  [sym_execution_string_chars] = "string_value",
  [sym_execution_string_chars_after_variable] = "string_value",
  [sym_encapsed_string_chars_heredoc] = "string_value",
  [sym_encapsed_string_chars_after_variable_heredoc] = "string_value",
  [sym__eof] = "_eof",
  [sym_heredoc_start] = "heredoc_start",
  [sym_heredoc_end] = "heredoc_end",
  [sym_nowdoc_string] = "nowdoc_string",
  [sym_sentinel_error] = "sentinel_error",
  [sym_program] = "program",
  [sym_text_interpolation] = "text_interpolation",
  [sym_text] = "text",
  [sym_empty_statement] = "empty_statement",
  [sym_reference_modifier] = "reference_modifier",
  [sym_function_static_declaration] = "function_static_declaration",
  [sym_static_variable_declaration] = "static_variable_declaration",
  [sym_global_declaration] = "global_declaration",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_use_declaration] = "namespace_use_declaration",
  [sym_namespace_use_clause] = "namespace_use_clause",
  [sym_qualified_name] = "qualified_name",
  [sym_namespace_name_as_prefix] = "namespace_name_as_prefix",
  [sym_namespace_name] = "namespace_name",
  [sym_namespace_aliasing_clause] = "namespace_aliasing_clause",
  [sym_namespace_use_group] = "namespace_use_group",
  [sym_namespace_use_group_clause] = "namespace_use_group_clause",
  [sym_trait_declaration] = "trait_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_base_clause] = "base_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_declaration_list] = "enum_declaration_list",
  [sym__enum_member_declaration] = "_enum_member_declaration",
  [sym_enum_case] = "enum_case",
  [sym_class_declaration] = "class_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_final_modifier] = "final_modifier",
  [sym_abstract_modifier] = "abstract_modifier",
  [sym_readonly_modifier] = "readonly_modifier",
  [sym_class_interface_clause] = "class_interface_clause",
  [sym__member_declaration] = "_member_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym__class_const_declaration] = "const_declaration",
  [sym__const_declaration] = "_const_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym__modifier] = "_modifier",
  [sym_property_element] = "property_element",
  [sym_property_initializer] = "property_initializer",
  [sym_method_declaration] = "method_declaration",
  [sym_static_modifier] = "static_modifier",
  [sym_use_declaration] = "use_declaration",
  [sym_use_list] = "use_list",
  [sym_use_instead_of_clause] = "use_instead_of_clause",
  [sym_use_as_clause] = "use_as_clause",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym_function_definition] = "function_definition",
  [sym__function_definition_header] = "_function_definition_header",
  [sym__arrow_function_header] = "_arrow_function_header",
  [sym_arrow_function] = "arrow_function",
  [sym_formal_parameters] = "formal_parameters",
  [sym_property_promotion_parameter] = "property_promotion_parameter",
  [sym_simple_parameter] = "simple_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym__type] = "_type",
  [sym__types] = "_types",
  [sym_named_type] = "named_type",
  [sym_optional_type] = "optional_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_disjunctive_normal_form_type] = "disjunctive_normal_form_type",
  [sym_primitive_type] = "primitive_type",
  [sym_cast_type] = "cast_type",
  [sym__return_type] = "_return_type",
  [sym_const_element] = "const_element",
  [sym_echo_statement] = "echo_statement",
  [sym_unset_statement] = "unset_statement",
  [sym_declare_statement] = "declare_statement",
  [sym_declare_directive] = "declare_directive",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_type_list] = "type_list",
  [sym_finally_clause] = "finally_clause",
  [sym_goto_statement] = "goto_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_expression] = "throw_expression",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__expressions] = "_expressions",
  [sym_sequence_expression] = "sequence_expression",
  [sym_foreach_statement] = "foreach_statement",
  [sym_foreach_pair] = "pair",
  [sym_if_statement] = "if_statement",
  [sym_colon_block] = "colon_block",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_else_if_clause_2] = "else_if_clause",
  [sym_else_clause_2] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_condition_list] = "match_condition_list",
  [sym_match_conditional_expression] = "match_conditional_expression",
  [sym_match_default_expression] = "match_default_expression",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_block] = "switch_block",
  [sym_case_statement] = "case_statement",
  [sym_default_statement] = "default_statement",
  [sym_compound_statement] = "compound_statement",
  [sym_named_label_statement] = "named_label_statement",
  [sym_expression_statement] = "expression_statement",
  [sym__expression] = "_expression",
  [sym__unary_expression] = "_unary_expression",
  [sym_unary_op_expression] = "unary_op_expression",
  [sym_error_suppression_expression] = "error_suppression_expression",
  [sym_clone_expression] = "clone_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_constant_access_expression] = "class_constant_access_expression",
  [sym_print_intrinsic] = "print_intrinsic",
  [sym_anonymous_function_creation_expression] = "anonymous_function_creation_expression",
  [sym_anonymous_function_use_clause] = "anonymous_function_use_clause",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_cast_variable] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_reference_assignment_expression] = "reference_assignment_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_member_access_expression] = "member_access_expression",
  [sym_nullsafe_member_access_expression] = "nullsafe_member_access_expression",
  [sym_scoped_property_access_expression] = "scoped_property_access_expression",
  [sym_list_literal] = "list_literal",
  [sym__list_destructing] = "_list_destructing",
  [sym__array_destructing] = "_array_destructing",
  [sym__array_destructing_element] = "_array_destructing_element",
  [sym_function_call_expression] = "function_call_expression",
  [sym_scoped_call_expression] = "scoped_call_expression",
  [sym__scope_resolution_qualifier] = "_scope_resolution_qualifier",
  [sym_relative_scope] = "relative_scope",
  [sym_variadic_placeholder] = "variadic_placeholder",
  [sym_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym__argument_name] = "_argument_name",
  [sym_member_call_expression] = "member_call_expression",
  [sym_nullsafe_member_call_expression] = "nullsafe_member_call_expression",
  [sym_variadic_unpacking] = "variadic_unpacking",
  [sym_subscript_expression] = "subscript_expression",
  [sym__dereferencable_expression] = "_dereferencable_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_attribute_group] = "attribute_group",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute] = "attribute",
  [sym__complex_string_part] = "_complex_string_part",
  [sym__simple_string_member_access_expression] = "member_access_expression",
  [sym__simple_string_subscript_unary_expression] = "unary_op_expression",
  [sym__simple_string_array_access_argument] = "_simple_string_array_access_argument",
  [sym__simple_string_subscript_expression] = "subscript_expression",
  [sym__simple_string_part] = "_simple_string_part",
  [aux_sym__interpolated_string_body] = "_interpolated_string_body",
  [aux_sym__interpolated_string_body_heredoc] = "_interpolated_string_body_heredoc",
  [sym_encapsed_string] = "encapsed_string",
  [sym_string] = "string",
  [sym_heredoc_body] = "heredoc_body",
  [sym_heredoc] = "heredoc",
  [sym_nowdoc_body] = "nowdoc_body",
  [sym_nowdoc] = "nowdoc",
  [aux_sym__interpolated_execution_operator_body] = "_interpolated_execution_operator_body",
  [sym_shell_command_expression] = "shell_command_expression",
  [sym_boolean] = "boolean",
  [sym_null] = "null",
  [sym__string] = "_string",
  [sym_dynamic_variable_name] = "dynamic_variable_name",
  [sym_variable_name] = "variable_name",
  [sym_variable_reference] = "by_ref",
  [sym_by_ref] = "by_ref",
  [sym_yield_expression] = "yield_expression",
  [sym_array_element_initializer] = "array_element_initializer",
  [sym_binary_expression] = "binary_expression",
  [sym_include_expression] = "include_expression",
  [sym_include_once_expression] = "include_once_expression",
  [sym_require_expression] = "require_expression",
  [sym_require_once_expression] = "require_once_expression",
  [sym__reserved_identifier] = "name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_text_repeat1] = "text_repeat1",
  [aux_sym_function_static_declaration_repeat1] = "function_static_declaration_repeat1",
  [aux_sym_global_declaration_repeat1] = "global_declaration_repeat1",
  [aux_sym_namespace_use_declaration_repeat1] = "namespace_use_declaration_repeat1",
  [aux_sym_namespace_name_repeat1] = "namespace_name_repeat1",
  [aux_sym_namespace_use_group_repeat1] = "namespace_use_group_repeat1",
  [aux_sym_base_clause_repeat1] = "base_clause_repeat1",
  [aux_sym_enum_declaration_list_repeat1] = "enum_declaration_list_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym__const_declaration_repeat1] = "_const_declaration_repeat1",
  [aux_sym_property_declaration_repeat1] = "property_declaration_repeat1",
  [aux_sym_property_declaration_repeat2] = "property_declaration_repeat2",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_union_type_repeat1] = "union_type_repeat1",
  [aux_sym_intersection_type_repeat1] = "intersection_type_repeat1",
  [aux_sym_disjunctive_normal_form_type_repeat1] = "disjunctive_normal_form_type_repeat1",
  [aux_sym_unset_statement_repeat1] = "unset_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_if_statement_repeat2] = "if_statement_repeat2",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_match_condition_list_repeat1] = "match_condition_list_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_anonymous_function_use_clause_repeat1] = "anonymous_function_use_clause_repeat1",
  [aux_sym__list_destructing_repeat1] = "_list_destructing_repeat1",
  [aux_sym__array_destructing_repeat1] = "_array_destructing_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [aux_sym_attribute_group_repeat1] = "attribute_group_repeat1",
  [aux_sym_attribute_list_repeat1] = "attribute_list_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_nowdoc_body_repeat1] = "nowdoc_body_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_name] = sym_name,
  [sym_php_tag] = sym_php_tag,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [aux_sym_text_token1] = aux_sym_text_token1,
  [aux_sym_text_token2] = aux_sym_text_token2,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_AMP] = anon_sym_AMP,
  [aux_sym_function_static_declaration_token1] = anon_sym_static,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym_global_declaration_token1] = aux_sym_global_declaration_token1,
  [aux_sym_namespace_definition_token1] = aux_sym_namespace_definition_token1,
  [aux_sym_namespace_use_declaration_token1] = aux_sym_namespace_use_declaration_token1,
  [aux_sym_namespace_use_declaration_token2] = aux_sym_namespace_use_declaration_token2,
  [aux_sym_namespace_use_declaration_token3] = aux_sym_namespace_use_declaration_token3,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym_namespace_aliasing_clause_token1] = aux_sym_namespace_aliasing_clause_token1,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym_trait_declaration_token1] = aux_sym_trait_declaration_token1,
  [aux_sym_interface_declaration_token1] = aux_sym_interface_declaration_token1,
  [aux_sym_base_clause_token1] = aux_sym_base_clause_token1,
  [aux_sym_enum_declaration_token1] = aux_sym_enum_declaration_token1,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_int] = anon_sym_int,
  [aux_sym_enum_case_token1] = aux_sym_enum_case_token1,
  [aux_sym_class_declaration_token1] = aux_sym_class_declaration_token1,
  [aux_sym_final_modifier_token1] = aux_sym_final_modifier_token1,
  [aux_sym_abstract_modifier_token1] = aux_sym_abstract_modifier_token1,
  [aux_sym_readonly_modifier_token1] = aux_sym_readonly_modifier_token1,
  [aux_sym_class_interface_clause_token1] = aux_sym_class_interface_clause_token1,
  [sym_var_modifier] = sym_var_modifier,
  [aux_sym_use_instead_of_clause_token1] = aux_sym_use_instead_of_clause_token1,
  [aux_sym_visibility_modifier_token1] = aux_sym_visibility_modifier_token1,
  [aux_sym_visibility_modifier_token2] = aux_sym_visibility_modifier_token2,
  [aux_sym_visibility_modifier_token3] = aux_sym_visibility_modifier_token3,
  [aux_sym__arrow_function_header_token1] = aux_sym__arrow_function_header_token1,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym_bottom_type] = sym_bottom_type,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_array] = anon_sym_array,
  [aux_sym_primitive_type_token1] = aux_sym_primitive_type_token1,
  [anon_sym_iterable] = anon_sym_iterable,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_mixed] = anon_sym_mixed,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_true] = anon_sym_true,
  [aux_sym_cast_type_token1] = aux_sym_cast_type_token1,
  [aux_sym_cast_type_token2] = aux_sym_cast_type_token2,
  [aux_sym_cast_type_token3] = aux_sym_cast_type_token3,
  [aux_sym_cast_type_token4] = aux_sym_cast_type_token4,
  [aux_sym_cast_type_token5] = aux_sym_cast_type_token5,
  [aux_sym_cast_type_token6] = aux_sym_cast_type_token6,
  [aux_sym_cast_type_token7] = aux_sym_cast_type_token7,
  [aux_sym_cast_type_token8] = aux_sym_cast_type_token8,
  [aux_sym_cast_type_token9] = aux_sym_cast_type_token9,
  [aux_sym_cast_type_token10] = aux_sym_cast_type_token10,
  [aux_sym_cast_type_token11] = aux_sym_cast_type_token11,
  [aux_sym_cast_type_token12] = aux_sym_cast_type_token12,
  [aux_sym_echo_statement_token1] = aux_sym_echo_statement_token1,
  [anon_sym_unset] = anon_sym_unset,
  [aux_sym_declare_statement_token1] = aux_sym_declare_statement_token1,
  [aux_sym_declare_statement_token2] = aux_sym_declare_statement_token2,
  [anon_sym_ticks] = anon_sym_ticks,
  [anon_sym_encoding] = anon_sym_encoding,
  [anon_sym_strict_types] = anon_sym_strict_types,
  [sym_float] = sym_float,
  [aux_sym_try_statement_token1] = aux_sym_try_statement_token1,
  [aux_sym_catch_clause_token1] = aux_sym_catch_clause_token1,
  [aux_sym_finally_clause_token1] = aux_sym_finally_clause_token1,
  [aux_sym_goto_statement_token1] = aux_sym_goto_statement_token1,
  [aux_sym_continue_statement_token1] = aux_sym_continue_statement_token1,
  [aux_sym_break_statement_token1] = aux_sym_break_statement_token1,
  [sym_integer] = sym_integer,
  [aux_sym_return_statement_token1] = aux_sym_return_statement_token1,
  [aux_sym_throw_expression_token1] = aux_sym_throw_expression_token1,
  [aux_sym_while_statement_token1] = aux_sym_while_statement_token1,
  [aux_sym_while_statement_token2] = aux_sym_while_statement_token2,
  [aux_sym_do_statement_token1] = aux_sym_do_statement_token1,
  [aux_sym_for_statement_token1] = aux_sym_for_statement_token1,
  [aux_sym_for_statement_token2] = aux_sym_for_statement_token2,
  [aux_sym_foreach_statement_token1] = aux_sym_foreach_statement_token1,
  [aux_sym_foreach_statement_token2] = aux_sym_foreach_statement_token2,
  [aux_sym_if_statement_token1] = aux_sym_if_statement_token1,
  [aux_sym_if_statement_token2] = aux_sym_if_statement_token2,
  [aux_sym_else_if_clause_token1] = aux_sym_else_if_clause_token1,
  [aux_sym_else_clause_token1] = aux_sym_else_clause_token1,
  [aux_sym_match_expression_token1] = aux_sym_match_expression_token1,
  [aux_sym_match_default_expression_token1] = aux_sym_match_default_expression_token1,
  [aux_sym_switch_statement_token1] = aux_sym_switch_statement_token1,
  [aux_sym_switch_block_token1] = aux_sym_switch_block_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_AT] = anon_sym_AT,
  [aux_sym_clone_expression_token1] = aux_sym_clone_expression_token1,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [aux_sym_print_intrinsic_token1] = aux_sym_print_intrinsic_token1,
  [aux_sym_object_creation_expression_token1] = aux_sym_object_creation_expression_token1,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_QMARK_DASH_GT] = anon_sym_QMARK_DASH_GT,
  [aux_sym__list_destructing_token1] = aux_sym__list_destructing_token1,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_self] = anon_sym_self,
  [anon_sym_parent] = anon_sym_parent,
  [aux_sym__argument_name_token1] = aux_sym__argument_name_token1,
  [aux_sym__argument_name_token2] = aux_sym__argument_name_token2,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_BSLASHu] = sym_string_value,
  [aux_sym_encapsed_string_token1] = aux_sym_encapsed_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = sym_escape_sequence,
  [sym_string_value] = sym_string_value,
  [anon_sym_LT_LT_LT] = anon_sym_LT_LT_LT,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [sym__new_line] = sym__new_line,
  [anon_sym_] = sym_nowdoc_string,
  [anon_sym_SQUOTE2] = anon_sym_SQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_yield_expression_token1] = aux_sym_yield_expression_token1,
  [aux_sym_yield_expression_token2] = aux_sym_yield_expression_token2,
  [aux_sym_binary_expression_token1] = aux_sym_binary_expression_token1,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [aux_sym_binary_expression_token2] = aux_sym_binary_expression_token2,
  [aux_sym_binary_expression_token3] = aux_sym_binary_expression_token3,
  [aux_sym_binary_expression_token4] = aux_sym_binary_expression_token4,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym_include_expression_token1] = aux_sym_include_expression_token1,
  [aux_sym_include_once_expression_token1] = aux_sym_include_once_expression_token1,
  [aux_sym_require_expression_token1] = aux_sym_require_expression_token1,
  [aux_sym_require_once_expression_token1] = aux_sym_require_once_expression_token1,
  [sym_comment] = sym_comment,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym_encapsed_string_chars] = sym_string_value,
  [sym_encapsed_string_chars_after_variable] = sym_string_value,
  [sym_execution_string_chars] = sym_string_value,
  [sym_execution_string_chars_after_variable] = sym_string_value,
  [sym_encapsed_string_chars_heredoc] = sym_string_value,
  [sym_encapsed_string_chars_after_variable_heredoc] = sym_string_value,
  [sym__eof] = sym__eof,
  [sym_heredoc_start] = sym_heredoc_start,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_nowdoc_string] = sym_nowdoc_string,
  [sym_sentinel_error] = sym_sentinel_error,
  [sym_program] = sym_program,
  [sym_text_interpolation] = sym_text_interpolation,
  [sym_text] = sym_text,
  [sym_empty_statement] = sym_empty_statement,
  [sym_reference_modifier] = sym_reference_modifier,
  [sym_function_static_declaration] = sym_function_static_declaration,
  [sym_static_variable_declaration] = sym_static_variable_declaration,
  [sym_global_declaration] = sym_global_declaration,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_use_declaration] = sym_namespace_use_declaration,
  [sym_namespace_use_clause] = sym_namespace_use_clause,
  [sym_qualified_name] = sym_qualified_name,
  [sym_namespace_name_as_prefix] = sym_namespace_name_as_prefix,
  [sym_namespace_name] = sym_namespace_name,
  [sym_namespace_aliasing_clause] = sym_namespace_aliasing_clause,
  [sym_namespace_use_group] = sym_namespace_use_group,
  [sym_namespace_use_group_clause] = sym_namespace_use_group_clause,
  [sym_trait_declaration] = sym_trait_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_base_clause] = sym_base_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_declaration_list] = sym_enum_declaration_list,
  [sym__enum_member_declaration] = sym__enum_member_declaration,
  [sym_enum_case] = sym_enum_case,
  [sym_class_declaration] = sym_class_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_final_modifier] = sym_final_modifier,
  [sym_abstract_modifier] = sym_abstract_modifier,
  [sym_readonly_modifier] = sym_readonly_modifier,
  [sym_class_interface_clause] = sym_class_interface_clause,
  [sym__member_declaration] = sym__member_declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym__class_const_declaration] = sym_const_declaration,
  [sym__const_declaration] = sym__const_declaration,
  [sym_property_declaration] = sym_property_declaration,
  [sym__modifier] = sym__modifier,
  [sym_property_element] = sym_property_element,
  [sym_property_initializer] = sym_property_initializer,
  [sym_method_declaration] = sym_method_declaration,
  [sym_static_modifier] = sym_static_modifier,
  [sym_use_declaration] = sym_use_declaration,
  [sym_use_list] = sym_use_list,
  [sym_use_instead_of_clause] = sym_use_instead_of_clause,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym_function_definition] = sym_function_definition,
  [sym__function_definition_header] = sym__function_definition_header,
  [sym__arrow_function_header] = sym__arrow_function_header,
  [sym_arrow_function] = sym_arrow_function,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_property_promotion_parameter] = sym_property_promotion_parameter,
  [sym_simple_parameter] = sym_simple_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym__type] = sym__type,
  [sym__types] = sym__types,
  [sym_named_type] = sym_named_type,
  [sym_optional_type] = sym_optional_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_disjunctive_normal_form_type] = sym_disjunctive_normal_form_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_cast_type] = sym_cast_type,
  [sym__return_type] = sym__return_type,
  [sym_const_element] = sym_const_element,
  [sym_echo_statement] = sym_echo_statement,
  [sym_unset_statement] = sym_unset_statement,
  [sym_declare_statement] = sym_declare_statement,
  [sym_declare_directive] = sym_declare_directive,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_type_list] = sym_type_list,
  [sym_finally_clause] = sym_finally_clause,
  [sym_goto_statement] = sym_goto_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_expression] = sym_throw_expression,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__expressions] = sym__expressions,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_foreach_pair] = sym_foreach_pair,
  [sym_if_statement] = sym_if_statement,
  [sym_colon_block] = sym_colon_block,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_else_if_clause_2] = sym_else_if_clause,
  [sym_else_clause_2] = sym_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_condition_list] = sym_match_condition_list,
  [sym_match_conditional_expression] = sym_match_conditional_expression,
  [sym_match_default_expression] = sym_match_default_expression,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_block] = sym_switch_block,
  [sym_case_statement] = sym_case_statement,
  [sym_default_statement] = sym_default_statement,
  [sym_compound_statement] = sym_compound_statement,
  [sym_named_label_statement] = sym_named_label_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym__expression] = sym__expression,
  [sym__unary_expression] = sym__unary_expression,
  [sym_unary_op_expression] = sym_unary_op_expression,
  [sym_error_suppression_expression] = sym_error_suppression_expression,
  [sym_clone_expression] = sym_clone_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_constant_access_expression] = sym_class_constant_access_expression,
  [sym_print_intrinsic] = sym_print_intrinsic,
  [sym_anonymous_function_creation_expression] = sym_anonymous_function_creation_expression,
  [sym_anonymous_function_use_clause] = sym_anonymous_function_use_clause,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_cast_variable] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_reference_assignment_expression] = sym_reference_assignment_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_nullsafe_member_access_expression] = sym_nullsafe_member_access_expression,
  [sym_scoped_property_access_expression] = sym_scoped_property_access_expression,
  [sym_list_literal] = sym_list_literal,
  [sym__list_destructing] = sym__list_destructing,
  [sym__array_destructing] = sym__array_destructing,
  [sym__array_destructing_element] = sym__array_destructing_element,
  [sym_function_call_expression] = sym_function_call_expression,
  [sym_scoped_call_expression] = sym_scoped_call_expression,
  [sym__scope_resolution_qualifier] = sym__scope_resolution_qualifier,
  [sym_relative_scope] = sym_relative_scope,
  [sym_variadic_placeholder] = sym_variadic_placeholder,
  [sym_arguments] = sym_arguments,
  [sym_argument] = sym_argument,
  [sym__argument_name] = sym__argument_name,
  [sym_member_call_expression] = sym_member_call_expression,
  [sym_nullsafe_member_call_expression] = sym_nullsafe_member_call_expression,
  [sym_variadic_unpacking] = sym_variadic_unpacking,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym__dereferencable_expression] = sym__dereferencable_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_attribute_group] = sym_attribute_group,
  [sym_attribute_list] = sym_attribute_list,
  [sym_attribute] = sym_attribute,
  [sym__complex_string_part] = sym__complex_string_part,
  [sym__simple_string_member_access_expression] = sym_member_access_expression,
  [sym__simple_string_subscript_unary_expression] = sym_unary_op_expression,
  [sym__simple_string_array_access_argument] = sym__simple_string_array_access_argument,
  [sym__simple_string_subscript_expression] = sym_subscript_expression,
  [sym__simple_string_part] = sym__simple_string_part,
  [aux_sym__interpolated_string_body] = aux_sym__interpolated_string_body,
  [aux_sym__interpolated_string_body_heredoc] = aux_sym__interpolated_string_body_heredoc,
  [sym_encapsed_string] = sym_encapsed_string,
  [sym_string] = sym_string,
  [sym_heredoc_body] = sym_heredoc_body,
  [sym_heredoc] = sym_heredoc,
  [sym_nowdoc_body] = sym_nowdoc_body,
  [sym_nowdoc] = sym_nowdoc,
  [aux_sym__interpolated_execution_operator_body] = aux_sym__interpolated_execution_operator_body,
  [sym_shell_command_expression] = sym_shell_command_expression,
  [sym_boolean] = sym_boolean,
  [sym_null] = sym_null,
  [sym__string] = sym__string,
  [sym_dynamic_variable_name] = sym_dynamic_variable_name,
  [sym_variable_name] = sym_variable_name,
  [sym_variable_reference] = sym_by_ref,
  [sym_by_ref] = sym_by_ref,
  [sym_yield_expression] = sym_yield_expression,
  [sym_array_element_initializer] = sym_array_element_initializer,
  [sym_binary_expression] = sym_binary_expression,
  [sym_include_expression] = sym_include_expression,
  [sym_include_once_expression] = sym_include_once_expression,
  [sym_require_expression] = sym_require_expression,
  [sym_require_once_expression] = sym_require_once_expression,
  [sym__reserved_identifier] = sym_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_text_repeat1] = aux_sym_text_repeat1,
  [aux_sym_function_static_declaration_repeat1] = aux_sym_function_static_declaration_repeat1,
  [aux_sym_global_declaration_repeat1] = aux_sym_global_declaration_repeat1,
  [aux_sym_namespace_use_declaration_repeat1] = aux_sym_namespace_use_declaration_repeat1,
  [aux_sym_namespace_name_repeat1] = aux_sym_namespace_name_repeat1,
  [aux_sym_namespace_use_group_repeat1] = aux_sym_namespace_use_group_repeat1,
  [aux_sym_base_clause_repeat1] = aux_sym_base_clause_repeat1,
  [aux_sym_enum_declaration_list_repeat1] = aux_sym_enum_declaration_list_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym__const_declaration_repeat1] = aux_sym__const_declaration_repeat1,
  [aux_sym_property_declaration_repeat1] = aux_sym_property_declaration_repeat1,
  [aux_sym_property_declaration_repeat2] = aux_sym_property_declaration_repeat2,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_union_type_repeat1] = aux_sym_union_type_repeat1,
  [aux_sym_intersection_type_repeat1] = aux_sym_intersection_type_repeat1,
  [aux_sym_disjunctive_normal_form_type_repeat1] = aux_sym_disjunctive_normal_form_type_repeat1,
  [aux_sym_unset_statement_repeat1] = aux_sym_unset_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_if_statement_repeat2] = aux_sym_if_statement_repeat2,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_match_condition_list_repeat1] = aux_sym_match_condition_list_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_anonymous_function_use_clause_repeat1] = aux_sym_anonymous_function_use_clause_repeat1,
  [aux_sym__list_destructing_repeat1] = aux_sym__list_destructing_repeat1,
  [aux_sym__array_destructing_repeat1] = aux_sym__array_destructing_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [aux_sym_attribute_group_repeat1] = aux_sym_attribute_group_repeat1,
  [aux_sym_attribute_list_repeat1] = aux_sym_attribute_list_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_nowdoc_body_repeat1] = aux_sym_nowdoc_body_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [sym_php_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_text_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_function_static_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_global_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_definition_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_aliasing_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_trait_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interface_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_base_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_case_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_final_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_abstract_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_readonly_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_interface_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_var_modifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_use_instead_of_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__arrow_function_header_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym_bottom_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_array] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_primitive_type_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iterable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_cast_type_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token6] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token7] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token8] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token9] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token10] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token11] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token12] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_echo_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_declare_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_declare_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ticks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_encoding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strict_types] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_try_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_catch_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_finally_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_goto_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_continue_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_break_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_return_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_throw_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_do_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_foreach_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_foreach_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_else_if_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_else_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_match_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_match_default_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_switch_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_switch_block_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_clone_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_print_intrinsic_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_object_creation_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__list_destructing_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_self] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__argument_name_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_name_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHu] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_encapsed_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = true,
    .named = true,
  },
  [sym_string_value] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym__new_line] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_yield_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_yield_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_once_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_require_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_require_once_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_encapsed_string_chars] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_after_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_execution_string_chars] = {
    .visible = true,
    .named = true,
  },
  [sym_execution_string_chars_after_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_after_variable_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc_string] = {
    .visible = true,
    .named = true,
  },
  [sym_sentinel_error] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_text_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_text] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_static_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name_as_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_aliasing_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_base_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_case] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_final_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_interface_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__class_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__const_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__modifier] = {
    .visible = false,
    .named = true,
  },
  [sym_property_element] = {
    .visible = true,
    .named = true,
  },
  [sym_property_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_instead_of_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_definition_header] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow_function_header] = {
    .visible = false,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_property_promotion_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__types] = {
    .visible = false,
    .named = true,
  },
  [sym_named_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunctive_normal_form_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_type] = {
    .visible = true,
    .named = true,
  },
  [sym__return_type] = {
    .visible = false,
    .named = true,
  },
  [sym_const_element] = {
    .visible = true,
    .named = true,
  },
  [sym_echo_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expressions] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_colon_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_condition_list] = {
    .visible = true,
    .named = true,
  },
  [sym_match_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_default_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_default_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_op_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_error_suppression_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_clone_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_constant_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_print_intrinsic] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_nullsafe_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_property_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__list_destructing] = {
    .visible = false,
    .named = true,
  },
  [sym__array_destructing] = {
    .visible = false,
    .named = true,
  },
  [sym__array_destructing_element] = {
    .visible = false,
    .named = true,
  },
  [sym_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution_qualifier] = {
    .visible = false,
    .named = true,
  },
  [sym_relative_scope] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_placeholder] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_name] = {
    .visible = false,
    .named = true,
  },
  [sym_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_nullsafe_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_unpacking] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__dereferencable_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_group] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__complex_string_part] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_string_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_subscript_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_array_access_argument] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_string_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_part] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__interpolated_string_body] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpolated_string_body_heredoc] = {
    .visible = false,
    .named = false,
  },
  [sym_encapsed_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpolated_execution_operator_body] = {
    .visible = false,
    .named = false,
  },
  [sym_shell_command_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_dynamic_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_by_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_element_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_static_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_intersection_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_disjunctive_normal_form_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_condition_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_function_use_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_destructing_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__array_destructing_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_nowdoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_attributes = 4,
  field_body = 5,
  field_condition = 6,
  field_conditional_expressions = 7,
  field_default_value = 8,
  field_end_tag = 9,
  field_function = 10,
  field_identifier = 11,
  field_left = 12,
  field_modifier = 13,
  field_name = 14,
  field_object = 15,
  field_operator = 16,
  field_parameters = 17,
  field_readonly = 18,
  field_reference_modifier = 19,
  field_return_expression = 20,
  field_return_type = 21,
  field_right = 22,
  field_scope = 23,
  field_type = 24,
  field_value = 25,
  field_visibility = 26,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attributes] = "attributes",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_conditional_expressions] = "conditional_expressions",
  [field_default_value] = "default_value",
  [field_end_tag] = "end_tag",
  [field_function] = "function",
  [field_identifier] = "identifier",
  [field_left] = "left",
  [field_modifier] = "modifier",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_readonly] = "readonly",
  [field_reference_modifier] = "reference_modifier",
  [field_return_expression] = "return_expression",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_type] = "type",
  [field_value] = "value",
  [field_visibility] = "visibility",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 2},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 5},
  [10] = {.index = 15, .length = 2},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 2},
  [13] = {.index = 20, .length = 2},
  [14] = {.index = 22, .length = 2},
  [15] = {.index = 24, .length = 2},
  [16] = {.index = 26, .length = 2},
  [18] = {.index = 28, .length = 2},
  [19] = {.index = 30, .length = 2},
  [20] = {.index = 32, .length = 1},
  [21] = {.index = 33, .length = 5},
  [22] = {.index = 38, .length = 3},
  [23] = {.index = 41, .length = 2},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 2},
  [26] = {.index = 47, .length = 2},
  [27] = {.index = 49, .length = 6},
  [28] = {.index = 55, .length = 2},
  [29] = {.index = 57, .length = 2},
  [30] = {.index = 59, .length = 2},
  [31] = {.index = 61, .length = 2},
  [32] = {.index = 63, .length = 2},
  [33] = {.index = 65, .length = 2},
  [34] = {.index = 67, .length = 3},
  [35] = {.index = 70, .length = 3},
  [36] = {.index = 73, .length = 3},
  [37] = {.index = 76, .length = 1},
  [38] = {.index = 77, .length = 3},
  [39] = {.index = 80, .length = 2},
  [40] = {.index = 82, .length = 1},
  [41] = {.index = 83, .length = 3},
  [42] = {.index = 86, .length = 2},
  [43] = {.index = 88, .length = 3},
  [44] = {.index = 91, .length = 2},
  [45] = {.index = 93, .length = 1},
  [46] = {.index = 94, .length = 3},
  [47] = {.index = 97, .length = 3},
  [48] = {.index = 100, .length = 1},
  [51] = {.index = 101, .length = 3},
  [52] = {.index = 1, .length = 1},
  [53] = {.index = 104, .length = 1},
  [54] = {.index = 105, .length = 1},
  [55] = {.index = 106, .length = 3},
  [56] = {.index = 109, .length = 2},
  [57] = {.index = 111, .length = 2},
  [58] = {.index = 113, .length = 2},
  [59] = {.index = 115, .length = 2},
  [60] = {.index = 117, .length = 3},
  [61] = {.index = 120, .length = 3},
  [62] = {.index = 123, .length = 3},
  [63] = {.index = 126, .length = 3},
  [64] = {.index = 129, .length = 3},
  [65] = {.index = 132, .length = 3},
  [66] = {.index = 135, .length = 2},
  [67] = {.index = 137, .length = 3},
  [68] = {.index = 140, .length = 3},
  [69] = {.index = 143, .length = 2},
  [70] = {.index = 145, .length = 2},
  [71] = {.index = 147, .length = 3},
  [72] = {.index = 150, .length = 3},
  [73] = {.index = 153, .length = 2},
  [74] = {.index = 155, .length = 3},
  [75] = {.index = 158, .length = 2},
  [76] = {.index = 160, .length = 3},
  [77] = {.index = 163, .length = 3},
  [78] = {.index = 166, .length = 3},
  [79] = {.index = 169, .length = 2},
  [80] = {.index = 171, .length = 4},
  [81] = {.index = 175, .length = 4},
  [82] = {.index = 179, .length = 3},
  [83] = {.index = 182, .length = 3},
  [84] = {.index = 185, .length = 2},
  [85] = {.index = 187, .length = 4},
  [86] = {.index = 191, .length = 2},
  [87] = {.index = 193, .length = 2},
  [88] = {.index = 193, .length = 2},
  [89] = {.index = 195, .length = 2},
  [90] = {.index = 197, .length = 4},
  [91] = {.index = 201, .length = 2},
  [92] = {.index = 203, .length = 3},
  [93] = {.index = 206, .length = 4},
  [94] = {.index = 210, .length = 2},
  [95] = {.index = 212, .length = 2},
  [96] = {.index = 214, .length = 3},
  [97] = {.index = 217, .length = 4},
  [98] = {.index = 221, .length = 3},
  [99] = {.index = 224, .length = 1},
  [100] = {.index = 225, .length = 3},
  [102] = {.index = 228, .length = 2},
  [103] = {.index = 230, .length = 3},
  [104] = {.index = 233, .length = 4},
  [105] = {.index = 237, .length = 4},
  [106] = {.index = 241, .length = 3},
  [107] = {.index = 244, .length = 3},
  [108] = {.index = 247, .length = 4},
  [109] = {.index = 251, .length = 4},
  [110] = {.index = 255, .length = 3},
  [111] = {.index = 258, .length = 3},
  [112] = {.index = 261, .length = 4},
  [113] = {.index = 265, .length = 3},
  [114] = {.index = 268, .length = 3},
  [115] = {.index = 271, .length = 3},
  [116] = {.index = 274, .length = 4},
  [117] = {.index = 278, .length = 3},
  [118] = {.index = 281, .length = 3},
  [119] = {.index = 284, .length = 3},
  [120] = {.index = 287, .length = 3},
  [121] = {.index = 290, .length = 4},
  [122] = {.index = 294, .length = 4},
  [123] = {.index = 298, .length = 3},
  [124] = {.index = 301, .length = 4},
  [125] = {.index = 305, .length = 3},
  [126] = {.index = 308, .length = 4},
  [127] = {.index = 312, .length = 3},
  [128] = {.index = 315, .length = 5},
  [129] = {.index = 320, .length = 4},
  [130] = {.index = 324, .length = 5},
  [131] = {.index = 329, .length = 2},
  [132] = {.index = 331, .length = 1},
  [133] = {.index = 332, .length = 2},
  [134] = {.index = 334, .length = 1},
  [137] = {.index = 335, .length = 5},
  [138] = {.index = 340, .length = 3},
  [139] = {.index = 343, .length = 3},
  [140] = {.index = 346, .length = 4},
  [141] = {.index = 350, .length = 3},
  [142] = {.index = 353, .length = 3},
  [143] = {.index = 356, .length = 4},
  [144] = {.index = 360, .length = 4},
  [145] = {.index = 364, .length = 3},
  [146] = {.index = 367, .length = 5},
  [147] = {.index = 372, .length = 4},
  [148] = {.index = 376, .length = 4},
  [149] = {.index = 380, .length = 3},
  [150] = {.index = 380, .length = 3},
  [151] = {.index = 383, .length = 4},
  [152] = {.index = 387, .length = 5},
  [153] = {.index = 392, .length = 4},
  [154] = {.index = 396, .length = 4},
  [155] = {.index = 400, .length = 4},
  [156] = {.index = 404, .length = 4},
  [157] = {.index = 408, .length = 4},
  [158] = {.index = 412, .length = 4},
  [159] = {.index = 416, .length = 5},
  [160] = {.index = 421, .length = 4},
  [161] = {.index = 425, .length = 4},
  [162] = {.index = 429, .length = 4},
  [163] = {.index = 433, .length = 1},
  [164] = {.index = 434, .length = 5},
  [165] = {.index = 439, .length = 6},
  [166] = {.index = 445, .length = 2},
  [167] = {.index = 447, .length = 1},
  [168] = {.index = 448, .length = 5},
  [169] = {.index = 453, .length = 3},
  [170] = {.index = 456, .length = 4},
  [171] = {.index = 460, .length = 5},
  [172] = {.index = 465, .length = 4},
  [173] = {.index = 469, .length = 4},
  [174] = {.index = 473, .length = 5},
  [175] = {.index = 478, .length = 3},
  [176] = {.index = 481, .length = 4},
  [177] = {.index = 485, .length = 5},
  [178] = {.index = 490, .length = 5},
  [179] = {.index = 495, .length = 5},
  [180] = {.index = 500, .length = 5},
  [181] = {.index = 505, .length = 5},
  [182] = {.index = 510, .length = 2},
  [183] = {.index = 512, .length = 2},
  [184] = {.index = 514, .length = 3},
  [185] = {.index = 517, .length = 5},
  [186] = {.index = 522, .length = 5},
  [187] = {.index = 527, .length = 6},
  [188] = {.index = 533, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_body, 1},
  [3] =
    {field_parameters, 1},
  [4] =
    {field_argument, 1},
    {field_operator, 0},
  [6] =
    {field_name, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [8] =
    {field_arguments, 1},
    {field_function, 0},
  [10] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [15] =
    {field_argument, 0},
    {field_operator, 1},
  [17] =
    {field_name, 1},
  [18] =
    {field_body, 2},
    {field_name, 1},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_body, 2},
    {field_parameters, 1},
  [24] =
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [26] =
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [28] =
    {field_body, 2},
    {field_condition, 1},
  [30] =
    {field_end_tag, 2},
    {field_identifier, 1},
  [32] =
    {field_parameters, 2},
  [33] =
    {field_attributes, 0, .inherited = true},
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [38] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [41] =
    {field_left, 0},
    {field_right, 2},
  [43] =
    {field_name, 2},
    {field_scope, 0},
  [45] =
    {field_name, 2},
    {field_object, 0},
  [47] =
    {field_attributes, 0},
    {field_parameters, 2},
  [49] =
    {field_attributes, 0},
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [55] =
    {field_body, 3},
    {field_parameters, 2},
  [57] =
    {field_name, 0},
    {field_value, 2},
  [59] =
    {field_name, 1},
    {field_reference_modifier, 0},
  [61] =
    {field_name, 1},
    {field_visibility, 0},
  [63] =
    {field_name, 1},
    {field_type, 0},
  [65] =
    {field_attributes, 0},
    {field_name, 1},
  [67] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [70] =
    {field_name, 2},
    {field_parameters, 3},
    {field_reference_modifier, 1},
  [73] =
    {field_body, 3},
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [76] =
    {field_return_type, 1},
  [77] =
    {field_body, 3},
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [80] =
    {field_body, 3},
    {field_parameters, 1},
  [82] =
    {field_type, 1},
  [83] =
    {field_attributes, 0, .inherited = true},
    {field_modifier, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [86] =
    {field_body, 3},
    {field_name, 1},
  [88] =
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 3, .inherited = true},
  [91] =
    {field_type, 1},
    {field_value, 3},
  [93] =
    {field_alternative, 0},
  [94] =
    {field_alternative, 3},
    {field_body, 2},
    {field_condition, 1},
  [97] =
    {field_alternative, 3, .inherited = true},
    {field_body, 2},
    {field_condition, 1},
  [100] =
    {field_attributes, 1},
  [101] =
    {field_end_tag, 3},
    {field_identifier, 1},
    {field_value, 2},
  [104] =
    {field_reference_modifier, 0},
  [105] =
    {field_name, 0, .inherited = true},
  [106] =
    {field_body, 3},
    {field_modifier, 0},
    {field_name, 2},
  [109] =
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [111] =
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [113] =
    {field_alternative, 3},
    {field_condition, 0},
  [115] =
    {field_left, 0},
    {field_right, 3},
  [117] =
    {field_arguments, 3},
    {field_name, 2},
    {field_scope, 0},
  [120] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [123] =
    {field_attributes, 0},
    {field_body, 3},
    {field_parameters, 2},
  [126] =
    {field_attributes, 0},
    {field_body, 3},
    {field_name, 2},
  [129] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [132] =
    {field_attributes, 0},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [135] =
    {field_attributes, 0},
    {field_parameters, 3},
  [137] =
    {field_body, 4},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [140] =
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [143] =
    {field_body, 4},
    {field_parameters, 2},
  [145] =
    {field_name, 2},
    {field_reference_modifier, 0},
  [147] =
    {field_name, 2},
    {field_readonly, 1},
    {field_visibility, 0},
  [150] =
    {field_name, 2},
    {field_type, 1},
    {field_visibility, 0},
  [153] =
    {field_name, 2},
    {field_type, 0},
  [155] =
    {field_name, 2},
    {field_reference_modifier, 1},
    {field_type, 0},
  [158] =
    {field_attributes, 0},
    {field_name, 2},
  [160] =
    {field_attributes, 0},
    {field_name, 2},
    {field_reference_modifier, 1},
  [163] =
    {field_attributes, 0},
    {field_name, 2},
    {field_visibility, 1},
  [166] =
    {field_attributes, 0},
    {field_name, 2},
    {field_type, 1},
  [169] =
    {field_default_value, 2},
    {field_name, 0},
  [171] =
    {field_name, 2},
    {field_parameters, 3},
    {field_reference_modifier, 1},
    {field_return_type, 4, .inherited = true},
  [175] =
    {field_body, 4},
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 3, .inherited = true},
  [179] =
    {field_body, 4},
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [182] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3, .inherited = true},
  [185] =
    {field_modifier, 0},
    {field_type, 1, .inherited = true},
  [187] =
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [191] =
    {field_attributes, 0},
    {field_type, 1, .inherited = true},
  [193] =
    {field_body, 4},
    {field_name, 1},
  [195] =
    {field_body, 1},
    {field_condition, 3},
  [197] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 1},
  [201] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [203] =
    {field_end_tag, 4},
    {field_identifier, 1},
    {field_value, 2},
  [206] =
    {field_end_tag, 4},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
  [210] =
    {field_end_tag, 4},
    {field_identifier, 2},
  [212] =
    {field_name, 0, .inherited = true},
    {field_reference_modifier, 1},
  [214] =
    {field_body, 4},
    {field_modifier, 0},
    {field_name, 2},
  [217] =
    {field_body, 4},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [221] =
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [224] =
    {field_type, 2},
  [225] =
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 0},
  [228] =
    {field_name, 3},
    {field_object, 0},
  [230] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 3},
  [233] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [237] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [241] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 2},
  [244] =
    {field_attributes, 0},
    {field_body, 4},
    {field_name, 2},
  [247] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [251] =
    {field_attributes, 0},
    {field_body, 4},
    {field_modifier, 1},
    {field_name, 3},
  [255] =
    {field_attributes, 0},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [258] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [261] =
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [265] =
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [268] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [271] =
    {field_default_value, 3},
    {field_name, 1},
    {field_reference_modifier, 0},
  [274] =
    {field_name, 3},
    {field_readonly, 1},
    {field_type, 2},
    {field_visibility, 0},
  [278] =
    {field_default_value, 3},
    {field_name, 1},
    {field_visibility, 0},
  [281] =
    {field_name, 3},
    {field_reference_modifier, 1},
    {field_type, 0},
  [284] =
    {field_default_value, 3},
    {field_name, 1},
    {field_type, 0},
  [287] =
    {field_attributes, 0},
    {field_name, 3},
    {field_reference_modifier, 1},
  [290] =
    {field_attributes, 0},
    {field_name, 3},
    {field_readonly, 2},
    {field_visibility, 1},
  [294] =
    {field_attributes, 0},
    {field_name, 3},
    {field_type, 2},
    {field_visibility, 1},
  [298] =
    {field_attributes, 0},
    {field_name, 3},
    {field_type, 1},
  [301] =
    {field_attributes, 0},
    {field_name, 3},
    {field_reference_modifier, 2},
    {field_type, 1},
  [305] =
    {field_attributes, 0},
    {field_default_value, 3},
    {field_name, 1},
  [308] =
    {field_body, 5},
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 4, .inherited = true},
  [312] =
    {field_attributes, 0},
    {field_modifier, 1},
    {field_type, 2, .inherited = true},
  [315] =
    {field_attributes, 0},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [320] =
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [324] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [329] =
    {field_body, 5},
    {field_name, 1},
  [331] =
    {field_return_expression, 2},
  [332] =
    {field_conditional_expressions, 0},
    {field_return_expression, 2},
  [334] =
    {field_value, 1},
  [335] =
    {field_end_tag, 5},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
    {field_value, 4},
  [340] =
    {field_end_tag, 5},
    {field_identifier, 2},
    {field_value, 4},
  [343] =
    {field_body, 5},
    {field_modifier, 0},
    {field_name, 2},
  [346] =
    {field_body, 5},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [350] =
    {field_arguments, 5},
    {field_name, 3},
    {field_scope, 0},
  [353] =
    {field_arguments, 5},
    {field_name, 3},
    {field_object, 0},
  [356] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [360] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [364] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
  [367] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [372] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [376] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [380] =
    {field_attributes, 0},
    {field_body, 5},
    {field_name, 2},
  [383] =
    {field_attributes, 0},
    {field_body, 5},
    {field_modifier, 1},
    {field_name, 3},
  [387] =
    {field_attributes, 0},
    {field_body, 5},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [392] =
    {field_attributes, 0},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 5, .inherited = true},
  [396] =
    {field_body, 6},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 5, .inherited = true},
  [400] =
    {field_default_value, 4},
    {field_name, 2},
    {field_readonly, 1},
    {field_visibility, 0},
  [404] =
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 1},
    {field_visibility, 0},
  [408] =
    {field_default_value, 4},
    {field_name, 2},
    {field_reference_modifier, 1},
    {field_type, 0},
  [412] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_reference_modifier, 1},
  [416] =
    {field_attributes, 0},
    {field_name, 4},
    {field_readonly, 2},
    {field_type, 3},
    {field_visibility, 1},
  [421] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_visibility, 1},
  [425] =
    {field_attributes, 0},
    {field_name, 4},
    {field_reference_modifier, 2},
    {field_type, 1},
  [429] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 1},
  [433] =
    {field_attributes, 0},
  [434] =
    {field_attributes, 0},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_reference_modifier, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
  [439] =
    {field_attributes, 0},
    {field_body, 3},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_reference_modifier, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
  [445] =
    {field_body, 4},
    {field_type, 2},
  [447] =
    {field_body, 6},
  [448] =
    {field_end_tag, 6},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
    {field_value, 4},
  [453] =
    {field_end_tag, 6},
    {field_identifier, 2},
    {field_value, 4},
  [456] =
    {field_body, 6},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [460] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 5, .inherited = true},
  [465] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [469] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 3},
    {field_return_type, 5, .inherited = true},
  [473] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 5, .inherited = true},
  [478] =
    {field_attributes, 0},
    {field_body, 6},
    {field_name, 2},
  [481] =
    {field_attributes, 0},
    {field_body, 6},
    {field_modifier, 1},
    {field_name, 3},
  [485] =
    {field_attributes, 0},
    {field_body, 6},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [490] =
    {field_default_value, 5},
    {field_name, 3},
    {field_readonly, 1},
    {field_type, 2},
    {field_visibility, 0},
  [495] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_readonly, 2},
    {field_visibility, 1},
  [500] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_type, 2},
    {field_visibility, 1},
  [505] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_reference_modifier, 2},
    {field_type, 1},
  [510] =
    {field_attributes, 0},
    {field_type, 2},
  [512] =
    {field_name, 1},
    {field_value, 3},
  [514] =
    {field_body, 5},
    {field_name, 3},
    {field_type, 2},
  [517] =
    {field_attributes, 0},
    {field_body, 7},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 6, .inherited = true},
  [522] =
    {field_attributes, 0},
    {field_body, 7},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [527] =
    {field_attributes, 0},
    {field_default_value, 6},
    {field_name, 4},
    {field_readonly, 2},
    {field_type, 3},
    {field_visibility, 1},
  [533] =
    {field_attributes, 0},
    {field_name, 2},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [6] = {
    [0] = sym_list_literal,
  },
  [17] = {
    [0] = anon_sym_array,
  },
  [49] = {
    [1] = sym_list_literal,
  },
  [50] = {
    [2] = sym_list_literal,
  },
  [52] = {
    [0] = sym_name,
  },
  [87] = {
    [3] = sym_primitive_type,
  },
  [101] = {
    [3] = sym_name,
  },
  [131] = {
    [3] = sym_primitive_type,
  },
  [135] = {
    [3] = sym_list_literal,
  },
  [136] = {
    [4] = sym_list_literal,
  },
  [149] = {
    [4] = sym_primitive_type,
  },
  [175] = {
    [4] = sym_primitive_type,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__expression, 2,
    sym__expression,
    sym_name,
  sym__list_destructing, 2,
    sym__list_destructing,
    sym_list_literal,
  sym__array_destructing, 2,
    sym__array_destructing,
    sym_list_literal,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 7,
  [10] = 2,
  [11] = 8,
  [12] = 12,
  [13] = 12,
  [14] = 12,
  [15] = 12,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 16,
  [25] = 22,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 29,
  [31] = 31,
  [32] = 16,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 35,
  [38] = 22,
  [39] = 27,
  [40] = 23,
  [41] = 35,
  [42] = 18,
  [43] = 43,
  [44] = 31,
  [45] = 36,
  [46] = 35,
  [47] = 47,
  [48] = 29,
  [49] = 36,
  [50] = 20,
  [51] = 34,
  [52] = 16,
  [53] = 53,
  [54] = 18,
  [55] = 33,
  [56] = 36,
  [57] = 47,
  [58] = 58,
  [59] = 22,
  [60] = 60,
  [61] = 34,
  [62] = 33,
  [63] = 29,
  [64] = 33,
  [65] = 27,
  [66] = 58,
  [67] = 67,
  [68] = 67,
  [69] = 34,
  [70] = 43,
  [71] = 53,
  [72] = 16,
  [73] = 60,
  [74] = 17,
  [75] = 29,
  [76] = 18,
  [77] = 27,
  [78] = 78,
  [79] = 79,
  [80] = 78,
  [81] = 78,
  [82] = 78,
  [83] = 83,
  [84] = 83,
  [85] = 79,
  [86] = 86,
  [87] = 86,
  [88] = 86,
  [89] = 86,
  [90] = 90,
  [91] = 91,
  [92] = 90,
  [93] = 91,
  [94] = 90,
  [95] = 91,
  [96] = 91,
  [97] = 91,
  [98] = 91,
  [99] = 90,
  [100] = 90,
  [101] = 101,
  [102] = 101,
  [103] = 101,
  [104] = 101,
  [105] = 105,
  [106] = 101,
  [107] = 105,
  [108] = 101,
  [109] = 105,
  [110] = 101,
  [111] = 105,
  [112] = 101,
  [113] = 105,
  [114] = 114,
  [115] = 114,
  [116] = 116,
  [117] = 117,
  [118] = 116,
  [119] = 114,
  [120] = 120,
  [121] = 114,
  [122] = 120,
  [123] = 120,
  [124] = 114,
  [125] = 114,
  [126] = 120,
  [127] = 120,
  [128] = 117,
  [129] = 120,
  [130] = 120,
  [131] = 120,
  [132] = 114,
  [133] = 114,
  [134] = 134,
  [135] = 134,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 136,
  [142] = 138,
  [143] = 139,
  [144] = 140,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 146,
  [150] = 150,
  [151] = 151,
  [152] = 145,
  [153] = 151,
  [154] = 147,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 161,
  [164] = 161,
  [165] = 158,
  [166] = 166,
  [167] = 162,
  [168] = 159,
  [169] = 161,
  [170] = 170,
  [171] = 159,
  [172] = 166,
  [173] = 170,
  [174] = 160,
  [175] = 170,
  [176] = 166,
  [177] = 166,
  [178] = 159,
  [179] = 162,
  [180] = 158,
  [181] = 160,
  [182] = 170,
  [183] = 158,
  [184] = 160,
  [185] = 162,
  [186] = 186,
  [187] = 187,
  [188] = 186,
  [189] = 187,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 192,
  [194] = 192,
  [195] = 192,
  [196] = 196,
  [197] = 192,
  [198] = 191,
  [199] = 199,
  [200] = 200,
  [201] = 192,
  [202] = 202,
  [203] = 202,
  [204] = 204,
  [205] = 205,
  [206] = 205,
  [207] = 207,
  [208] = 207,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 211,
  [213] = 207,
  [214] = 214,
  [215] = 209,
  [216] = 205,
  [217] = 209,
  [218] = 211,
  [219] = 205,
  [220] = 205,
  [221] = 211,
  [222] = 205,
  [223] = 209,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 224,
  [235] = 235,
  [236] = 225,
  [237] = 237,
  [238] = 235,
  [239] = 225,
  [240] = 240,
  [241] = 231,
  [242] = 235,
  [243] = 243,
  [244] = 225,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 230,
  [271] = 271,
  [272] = 245,
  [273] = 273,
  [274] = 235,
  [275] = 275,
  [276] = 225,
  [277] = 231,
  [278] = 278,
  [279] = 279,
  [280] = 235,
  [281] = 231,
  [282] = 275,
  [283] = 231,
  [284] = 273,
  [285] = 235,
  [286] = 269,
  [287] = 268,
  [288] = 225,
  [289] = 233,
  [290] = 275,
  [291] = 267,
  [292] = 266,
  [293] = 293,
  [294] = 265,
  [295] = 264,
  [296] = 296,
  [297] = 231,
  [298] = 263,
  [299] = 262,
  [300] = 261,
  [301] = 237,
  [302] = 260,
  [303] = 293,
  [304] = 259,
  [305] = 258,
  [306] = 257,
  [307] = 256,
  [308] = 255,
  [309] = 254,
  [310] = 310,
  [311] = 231,
  [312] = 252,
  [313] = 224,
  [314] = 224,
  [315] = 271,
  [316] = 230,
  [317] = 275,
  [318] = 253,
  [319] = 235,
  [320] = 251,
  [321] = 252,
  [322] = 254,
  [323] = 250,
  [324] = 255,
  [325] = 249,
  [326] = 248,
  [327] = 246,
  [328] = 256,
  [329] = 257,
  [330] = 258,
  [331] = 259,
  [332] = 260,
  [333] = 310,
  [334] = 261,
  [335] = 335,
  [336] = 235,
  [337] = 262,
  [338] = 263,
  [339] = 339,
  [340] = 264,
  [341] = 265,
  [342] = 266,
  [343] = 225,
  [344] = 233,
  [345] = 267,
  [346] = 268,
  [347] = 225,
  [348] = 269,
  [349] = 233,
  [350] = 225,
  [351] = 235,
  [352] = 275,
  [353] = 273,
  [354] = 354,
  [355] = 355,
  [356] = 231,
  [357] = 233,
  [358] = 310,
  [359] = 293,
  [360] = 275,
  [361] = 231,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 246,
  [366] = 237,
  [367] = 245,
  [368] = 246,
  [369] = 271,
  [370] = 370,
  [371] = 371,
  [372] = 339,
  [373] = 248,
  [374] = 249,
  [375] = 240,
  [376] = 250,
  [377] = 233,
  [378] = 251,
  [379] = 253,
  [380] = 230,
  [381] = 271,
  [382] = 382,
  [383] = 252,
  [384] = 384,
  [385] = 240,
  [386] = 254,
  [387] = 235,
  [388] = 225,
  [389] = 233,
  [390] = 339,
  [391] = 391,
  [392] = 392,
  [393] = 245,
  [394] = 339,
  [395] = 395,
  [396] = 253,
  [397] = 397,
  [398] = 247,
  [399] = 255,
  [400] = 256,
  [401] = 257,
  [402] = 248,
  [403] = 258,
  [404] = 249,
  [405] = 259,
  [406] = 260,
  [407] = 261,
  [408] = 262,
  [409] = 263,
  [410] = 251,
  [411] = 264,
  [412] = 265,
  [413] = 266,
  [414] = 267,
  [415] = 268,
  [416] = 247,
  [417] = 269,
  [418] = 250,
  [419] = 273,
  [420] = 240,
  [421] = 293,
  [422] = 247,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 425,
  [427] = 427,
  [428] = 427,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 437,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 429,
  [495] = 495,
  [496] = 491,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 491,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 491,
  [550] = 436,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 432,
  [562] = 562,
  [563] = 563,
  [564] = 491,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 570,
  [572] = 570,
  [573] = 570,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 597,
  [600] = 600,
  [601] = 583,
  [602] = 579,
  [603] = 603,
  [604] = 578,
  [605] = 579,
  [606] = 597,
  [607] = 582,
  [608] = 580,
  [609] = 581,
  [610] = 588,
  [611] = 590,
  [612] = 591,
  [613] = 596,
  [614] = 584,
  [615] = 575,
  [616] = 592,
  [617] = 574,
  [618] = 618,
  [619] = 595,
  [620] = 593,
  [621] = 589,
  [622] = 622,
  [623] = 585,
  [624] = 587,
  [625] = 576,
  [626] = 586,
  [627] = 597,
  [628] = 577,
  [629] = 594,
  [630] = 600,
  [631] = 622,
  [632] = 632,
  [633] = 598,
  [634] = 598,
  [635] = 635,
  [636] = 600,
  [637] = 637,
  [638] = 600,
  [639] = 637,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 580,
  [646] = 646,
  [647] = 593,
  [648] = 646,
  [649] = 649,
  [650] = 650,
  [651] = 649,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 582,
  [656] = 578,
  [657] = 581,
  [658] = 583,
  [659] = 585,
  [660] = 589,
  [661] = 584,
  [662] = 577,
  [663] = 663,
  [664] = 664,
  [665] = 595,
  [666] = 596,
  [667] = 664,
  [668] = 668,
  [669] = 668,
  [670] = 574,
  [671] = 592,
  [672] = 588,
  [673] = 587,
  [674] = 674,
  [675] = 591,
  [676] = 576,
  [677] = 674,
  [678] = 575,
  [679] = 590,
  [680] = 594,
  [681] = 593,
  [682] = 682,
  [683] = 586,
  [684] = 581,
  [685] = 682,
  [686] = 653,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 580,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 583,
  [702] = 694,
  [703] = 703,
  [704] = 580,
  [705] = 705,
  [706] = 581,
  [707] = 707,
  [708] = 708,
  [709] = 578,
  [710] = 710,
  [711] = 581,
  [712] = 663,
  [713] = 582,
  [714] = 582,
  [715] = 578,
  [716] = 583,
  [717] = 580,
  [718] = 583,
  [719] = 582,
  [720] = 688,
  [721] = 578,
  [722] = 574,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 584,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 591,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 595,
  [740] = 740,
  [741] = 569,
  [742] = 585,
  [743] = 592,
  [744] = 744,
  [745] = 594,
  [746] = 746,
  [747] = 589,
  [748] = 586,
  [749] = 576,
  [750] = 590,
  [751] = 577,
  [752] = 752,
  [753] = 753,
  [754] = 596,
  [755] = 588,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 575,
  [762] = 587,
  [763] = 763,
  [764] = 578,
  [765] = 580,
  [766] = 766,
  [767] = 692,
  [768] = 768,
  [769] = 582,
  [770] = 770,
  [771] = 771,
  [772] = 646,
  [773] = 581,
  [774] = 774,
  [775] = 429,
  [776] = 654,
  [777] = 646,
  [778] = 652,
  [779] = 583,
  [780] = 432,
  [781] = 653,
  [782] = 650,
  [783] = 703,
  [784] = 577,
  [785] = 595,
  [786] = 584,
  [787] = 594,
  [788] = 586,
  [789] = 589,
  [790] = 574,
  [791] = 575,
  [792] = 593,
  [793] = 793,
  [794] = 576,
  [795] = 795,
  [796] = 796,
  [797] = 596,
  [798] = 796,
  [799] = 592,
  [800] = 591,
  [801] = 587,
  [802] = 588,
  [803] = 585,
  [804] = 590,
  [805] = 688,
  [806] = 806,
  [807] = 578,
  [808] = 682,
  [809] = 688,
  [810] = 694,
  [811] = 811,
  [812] = 582,
  [813] = 580,
  [814] = 814,
  [815] = 593,
  [816] = 581,
  [817] = 692,
  [818] = 818,
  [819] = 811,
  [820] = 690,
  [821] = 581,
  [822] = 580,
  [823] = 436,
  [824] = 682,
  [825] = 699,
  [826] = 708,
  [827] = 437,
  [828] = 811,
  [829] = 814,
  [830] = 710,
  [831] = 580,
  [832] = 811,
  [833] = 818,
  [834] = 642,
  [835] = 663,
  [836] = 663,
  [837] = 694,
  [838] = 578,
  [839] = 703,
  [840] = 583,
  [841] = 582,
  [842] = 578,
  [843] = 811,
  [844] = 806,
  [845] = 583,
  [846] = 581,
  [847] = 847,
  [848] = 847,
  [849] = 695,
  [850] = 698,
  [851] = 693,
  [852] = 583,
  [853] = 689,
  [854] = 854,
  [855] = 847,
  [856] = 653,
  [857] = 582,
  [858] = 728,
  [859] = 577,
  [860] = 734,
  [861] = 744,
  [862] = 703,
  [863] = 723,
  [864] = 592,
  [865] = 596,
  [866] = 733,
  [867] = 575,
  [868] = 589,
  [869] = 725,
  [870] = 584,
  [871] = 576,
  [872] = 703,
  [873] = 758,
  [874] = 759,
  [875] = 736,
  [876] = 763,
  [877] = 752,
  [878] = 586,
  [879] = 735,
  [880] = 724,
  [881] = 737,
  [882] = 594,
  [883] = 731,
  [884] = 590,
  [885] = 757,
  [886] = 738,
  [887] = 753,
  [888] = 740,
  [889] = 588,
  [890] = 587,
  [891] = 569,
  [892] = 591,
  [893] = 726,
  [894] = 585,
  [895] = 756,
  [896] = 746,
  [897] = 574,
  [898] = 760,
  [899] = 730,
  [900] = 595,
  [901] = 768,
  [902] = 770,
  [903] = 771,
  [904] = 766,
  [905] = 692,
  [906] = 906,
  [907] = 907,
  [908] = 575,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 574,
  [923] = 923,
  [924] = 924,
  [925] = 577,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 576,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 436,
  [973] = 437,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 994,
  [1007] = 986,
  [1008] = 1002,
  [1009] = 975,
  [1010] = 992,
  [1011] = 991,
  [1012] = 980,
  [1013] = 979,
  [1014] = 999,
  [1015] = 989,
  [1016] = 977,
  [1017] = 1003,
  [1018] = 997,
  [1019] = 1005,
  [1020] = 976,
  [1021] = 993,
  [1022] = 988,
  [1023] = 996,
  [1024] = 984,
  [1025] = 1001,
  [1026] = 987,
  [1027] = 982,
  [1028] = 974,
  [1029] = 1000,
  [1030] = 983,
  [1031] = 985,
  [1032] = 981,
  [1033] = 978,
  [1034] = 1004,
  [1035] = 998,
  [1036] = 990,
  [1037] = 1037,
  [1038] = 995,
  [1039] = 965,
  [1040] = 960,
  [1041] = 941,
  [1042] = 1042,
  [1043] = 982,
  [1044] = 956,
  [1045] = 942,
  [1046] = 915,
  [1047] = 953,
  [1048] = 574,
  [1049] = 577,
  [1050] = 576,
  [1051] = 929,
  [1052] = 916,
  [1053] = 939,
  [1054] = 948,
  [1055] = 947,
  [1056] = 575,
  [1057] = 1042,
  [1058] = 937,
  [1059] = 961,
  [1060] = 907,
  [1061] = 950,
  [1062] = 909,
  [1063] = 963,
  [1064] = 906,
  [1065] = 962,
  [1066] = 1066,
  [1067] = 429,
  [1068] = 928,
  [1069] = 935,
  [1070] = 910,
  [1071] = 920,
  [1072] = 917,
  [1073] = 914,
  [1074] = 970,
  [1075] = 978,
  [1076] = 964,
  [1077] = 432,
  [1078] = 934,
  [1079] = 931,
  [1080] = 938,
  [1081] = 932,
  [1082] = 930,
  [1083] = 981,
  [1084] = 918,
  [1085] = 911,
  [1086] = 912,
  [1087] = 924,
  [1088] = 995,
  [1089] = 1002,
  [1090] = 985,
  [1091] = 975,
  [1092] = 971,
  [1093] = 1005,
  [1094] = 968,
  [1095] = 967,
  [1096] = 966,
  [1097] = 1003,
  [1098] = 923,
  [1099] = 989,
  [1100] = 936,
  [1101] = 957,
  [1102] = 944,
  [1103] = 946,
  [1104] = 999,
  [1105] = 949,
  [1106] = 955,
  [1107] = 994,
  [1108] = 992,
  [1109] = 990,
  [1110] = 991,
  [1111] = 958,
  [1112] = 954,
  [1113] = 952,
  [1114] = 951,
  [1115] = 987,
  [1116] = 980,
  [1117] = 979,
  [1118] = 969,
  [1119] = 977,
  [1120] = 993,
  [1121] = 1001,
  [1122] = 959,
  [1123] = 1004,
  [1124] = 983,
  [1125] = 998,
  [1126] = 996,
  [1127] = 1000,
  [1128] = 976,
  [1129] = 921,
  [1130] = 974,
  [1131] = 984,
  [1132] = 997,
  [1133] = 986,
  [1134] = 988,
  [1135] = 933,
  [1136] = 927,
  [1137] = 1042,
  [1138] = 940,
  [1139] = 1066,
  [1140] = 926,
  [1141] = 1066,
  [1142] = 913,
  [1143] = 919,
  [1144] = 995,
  [1145] = 991,
  [1146] = 1146,
  [1147] = 997,
  [1148] = 988,
  [1149] = 986,
  [1150] = 984,
  [1151] = 974,
  [1152] = 983,
  [1153] = 1000,
  [1154] = 996,
  [1155] = 998,
  [1156] = 981,
  [1157] = 975,
  [1158] = 1004,
  [1159] = 1001,
  [1160] = 978,
  [1161] = 990,
  [1162] = 976,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1005,
  [1166] = 1003,
  [1167] = 989,
  [1168] = 999,
  [1169] = 994,
  [1170] = 1170,
  [1171] = 987,
  [1172] = 993,
  [1173] = 977,
  [1174] = 979,
  [1175] = 982,
  [1176] = 985,
  [1177] = 980,
  [1178] = 1002,
  [1179] = 992,
  [1180] = 983,
  [1181] = 983,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1190,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1190,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1185,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1195,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1200,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1202,
  [1219] = 1184,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1204,
  [1223] = 1200,
  [1224] = 1184,
  [1225] = 1190,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1202,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1185,
  [1234] = 1234,
  [1235] = 1200,
  [1236] = 1214,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1202,
  [1240] = 1240,
  [1241] = 1207,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1245,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1243,
  [1250] = 1250,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1242,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1250,
  [1257] = 1243,
  [1258] = 1244,
  [1259] = 1251,
  [1260] = 1252,
  [1261] = 1244,
  [1262] = 1243,
  [1263] = 1250,
  [1264] = 1244,
  [1265] = 1251,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1255,
  [1269] = 1267,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1245,
  [1273] = 1254,
  [1274] = 1266,
  [1275] = 1255,
  [1276] = 1255,
  [1277] = 1245,
  [1278] = 1250,
  [1279] = 1254,
  [1280] = 1255,
  [1281] = 1251,
  [1282] = 1252,
  [1283] = 1266,
  [1284] = 1252,
  [1285] = 1244,
  [1286] = 1243,
  [1287] = 1250,
  [1288] = 1251,
  [1289] = 1267,
  [1290] = 1255,
  [1291] = 1255,
  [1292] = 1250,
  [1293] = 1243,
  [1294] = 1243,
  [1295] = 1250,
  [1296] = 1296,
  [1297] = 1266,
  [1298] = 1251,
  [1299] = 1250,
  [1300] = 1252,
  [1301] = 1252,
  [1302] = 1243,
  [1303] = 1250,
  [1304] = 1255,
  [1305] = 1255,
  [1306] = 1243,
  [1307] = 1244,
  [1308] = 1244,
  [1309] = 1250,
  [1310] = 1243,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1312,
  [1317] = 1311,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1328,
  [1331] = 1326,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1327,
  [1336] = 1328,
  [1337] = 1334,
  [1338] = 1326,
  [1339] = 1334,
  [1340] = 1340,
  [1341] = 1340,
  [1342] = 1340,
  [1343] = 1343,
  [1344] = 1343,
  [1345] = 1343,
  [1346] = 1346,
  [1347] = 1346,
  [1348] = 1315,
  [1349] = 1346,
  [1350] = 1319,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1324,
  [1354] = 1354,
  [1355] = 1323,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1037,
  [1360] = 1360,
  [1361] = 1332,
  [1362] = 1362,
  [1363] = 1325,
  [1364] = 1329,
  [1365] = 1333,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 429,
  [1387] = 432,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1389,
  [1391] = 1391,
  [1392] = 556,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 505,
  [1402] = 499,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 487,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1391,
  [1418] = 1400,
  [1419] = 1419,
  [1420] = 554,
  [1421] = 1421,
  [1422] = 1405,
  [1423] = 559,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 560,
  [1427] = 1397,
  [1428] = 1404,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1431,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1434,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1439,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1437,
  [1452] = 1438,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 653,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1460,
  [1466] = 1456,
  [1467] = 1467,
  [1468] = 594,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 698,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1474,
  [1475] = 594,
  [1476] = 1476,
  [1477] = 1474,
  [1478] = 1474,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1479,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1322,
  [1485] = 1473,
  [1486] = 1321,
  [1487] = 1320,
  [1488] = 1473,
  [1489] = 1483,
  [1490] = 1474,
  [1491] = 1479,
  [1492] = 1492,
  [1493] = 1473,
  [1494] = 1479,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1474,
  [1500] = 1479,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1474,
  [1504] = 1474,
  [1505] = 1473,
  [1506] = 1479,
  [1507] = 1507,
  [1508] = 1479,
  [1509] = 1247,
  [1510] = 1479,
  [1511] = 1511,
  [1512] = 1479,
  [1513] = 1313,
  [1514] = 1483,
  [1515] = 1515,
  [1516] = 1315,
  [1517] = 1517,
  [1518] = 1473,
  [1519] = 594,
  [1520] = 1474,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1483,
  [1524] = 1473,
  [1525] = 1479,
  [1526] = 1474,
  [1527] = 1473,
  [1528] = 1474,
  [1529] = 1529,
  [1530] = 1319,
  [1531] = 1473,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1479,
  [1535] = 1479,
  [1536] = 1479,
  [1537] = 1537,
  [1538] = 1473,
  [1539] = 1483,
  [1540] = 1473,
  [1541] = 1474,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1433,
  [1548] = 1454,
  [1549] = 423,
  [1550] = 424,
  [1551] = 1551,
  [1552] = 1546,
  [1553] = 1545,
  [1554] = 1551,
  [1555] = 1542,
  [1556] = 592,
  [1557] = 1557,
  [1558] = 1433,
  [1559] = 594,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 793,
  [1563] = 1563,
  [1564] = 595,
  [1565] = 1565,
  [1566] = 1565,
  [1567] = 663,
  [1568] = 682,
  [1569] = 1569,
  [1570] = 1569,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1565,
  [1574] = 1572,
  [1575] = 1565,
  [1576] = 1576,
  [1577] = 583,
  [1578] = 1578,
  [1579] = 1569,
  [1580] = 1580,
  [1581] = 1572,
  [1582] = 682,
  [1583] = 1583,
  [1584] = 1410,
  [1585] = 1585,
  [1586] = 583,
  [1587] = 1569,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 663,
  [1591] = 1565,
  [1592] = 1569,
  [1593] = 1565,
  [1594] = 663,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 682,
  [1601] = 1601,
  [1602] = 1583,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1599,
  [1609] = 1609,
  [1610] = 1597,
  [1611] = 1578,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1606,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1616,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1616,
  [1632] = 1620,
  [1633] = 1618,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1606,
  [1637] = 1630,
  [1638] = 1638,
  [1639] = 1629,
  [1640] = 1583,
  [1641] = 1585,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1644,
  [1645] = 1645,
  [1646] = 1646,
  [1647] = 1599,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1645,
  [1651] = 1644,
  [1652] = 1643,
  [1653] = 1642,
  [1654] = 1648,
  [1655] = 1601,
  [1656] = 1638,
  [1657] = 1628,
  [1658] = 1627,
  [1659] = 1635,
  [1660] = 1625,
  [1661] = 1622,
  [1662] = 1619,
  [1663] = 1649,
  [1664] = 1614,
  [1665] = 1613,
  [1666] = 1666,
  [1667] = 1605,
  [1668] = 1603,
  [1669] = 594,
  [1670] = 594,
  [1671] = 595,
  [1672] = 592,
  [1673] = 595,
  [1674] = 592,
  [1675] = 1597,
  [1676] = 1578,
  [1677] = 427,
  [1678] = 425,
  [1679] = 425,
  [1680] = 427,
  [1681] = 1585,
  [1682] = 1682,
  [1683] = 1495,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 439,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 431,
  [1693] = 1693,
  [1694] = 1691,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1453,
  [1698] = 1495,
  [1699] = 1696,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 450,
  [1703] = 1703,
  [1704] = 445,
  [1705] = 1705,
  [1706] = 441,
  [1707] = 1707,
  [1708] = 435,
  [1709] = 1515,
  [1710] = 1686,
  [1711] = 440,
  [1712] = 1707,
  [1713] = 1501,
  [1714] = 1498,
  [1715] = 1715,
  [1716] = 1529,
  [1717] = 1455,
  [1718] = 1532,
  [1719] = 434,
  [1720] = 1696,
  [1721] = 1691,
  [1722] = 1515,
  [1723] = 1696,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 451,
  [1727] = 433,
  [1728] = 1691,
  [1729] = 1696,
  [1730] = 1696,
  [1731] = 1691,
  [1732] = 1732,
  [1733] = 444,
  [1734] = 1705,
  [1735] = 1696,
  [1736] = 1691,
  [1737] = 446,
  [1738] = 1696,
  [1739] = 452,
  [1740] = 1700,
  [1741] = 1696,
  [1742] = 430,
  [1743] = 1743,
  [1744] = 442,
  [1745] = 443,
  [1746] = 1691,
  [1747] = 438,
  [1748] = 1687,
  [1749] = 1691,
  [1750] = 1501,
  [1751] = 1691,
  [1752] = 1498,
  [1753] = 1449,
  [1754] = 1754,
  [1755] = 454,
  [1756] = 1691,
  [1757] = 1691,
  [1758] = 1691,
  [1759] = 1696,
  [1760] = 1760,
  [1761] = 455,
  [1762] = 1762,
  [1763] = 1695,
  [1764] = 447,
  [1765] = 449,
  [1766] = 1766,
  [1767] = 1621,
  [1768] = 453,
  [1769] = 1769,
  [1770] = 1696,
  [1771] = 1529,
  [1772] = 1772,
  [1773] = 1442,
  [1774] = 1446,
  [1775] = 1443,
  [1776] = 1776,
  [1777] = 1732,
  [1778] = 448,
  [1779] = 1701,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1684,
  [1783] = 1685,
  [1784] = 1532,
  [1785] = 1785,
  [1786] = 1461,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1463,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1455,
  [1812] = 1800,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1807,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1794,
  [1819] = 1819,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1787,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1836,
  [1837] = 1829,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1453,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 1797,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1810,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1848,
  [1866] = 1866,
  [1867] = 1464,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1847,
  [1871] = 1863,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1869,
  [1875] = 1859,
  [1876] = 1876,
  [1877] = 1852,
  [1878] = 1858,
  [1879] = 1879,
  [1880] = 1851,
  [1881] = 1854,
  [1882] = 1868,
  [1883] = 1883,
  [1884] = 1816,
  [1885] = 1799,
  [1886] = 1824,
  [1887] = 1830,
  [1888] = 1825,
  [1889] = 1889,
  [1890] = 1859,
  [1891] = 1861,
  [1892] = 642,
  [1893] = 1893,
  [1894] = 1469,
  [1895] = 1895,
  [1896] = 1835,
  [1897] = 1843,
  [1898] = 1781,
  [1899] = 1864,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1844,
  [1907] = 1907,
  [1908] = 1907,
  [1909] = 1864,
  [1910] = 1895,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 1900,
  [1914] = 1904,
  [1915] = 1903,
  [1916] = 1916,
  [1917] = 1857,
  [1918] = 1834,
  [1919] = 1833,
  [1920] = 1832,
  [1921] = 1856,
  [1922] = 1831,
  [1923] = 1901,
  [1924] = 1852,
  [1925] = 1851,
  [1926] = 1472,
  [1927] = 1850,
  [1928] = 1827,
  [1929] = 1840,
  [1930] = 1825,
  [1931] = 1824,
  [1932] = 1847,
  [1933] = 1839,
  [1934] = 1853,
  [1935] = 1935,
  [1936] = 1866,
  [1937] = 1828,
  [1938] = 1938,
  [1939] = 1816,
  [1940] = 1814,
  [1941] = 1916,
  [1942] = 1791,
  [1943] = 1799,
  [1944] = 1788,
  [1945] = 1847,
  [1946] = 1802,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 535,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 532,
  [1955] = 1955,
  [1956] = 504,
  [1957] = 556,
  [1958] = 501,
  [1959] = 1959,
  [1960] = 490,
  [1961] = 495,
  [1962] = 489,
  [1963] = 1963,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 472,
  [1967] = 557,
  [1968] = 469,
  [1969] = 465,
  [1970] = 484,
  [1971] = 1971,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 538,
  [1975] = 1975,
  [1976] = 514,
  [1977] = 1977,
  [1978] = 1978,
  [1979] = 1979,
  [1980] = 500,
  [1981] = 506,
  [1982] = 507,
  [1983] = 520,
  [1984] = 521,
  [1985] = 1985,
  [1986] = 539,
  [1987] = 540,
  [1988] = 554,
  [1989] = 1989,
  [1990] = 559,
  [1991] = 1991,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 1973,
  [1995] = 1995,
  [1996] = 457,
  [1997] = 537,
  [1998] = 534,
  [1999] = 530,
  [2000] = 526,
  [2001] = 458,
  [2002] = 497,
  [2003] = 2003,
  [2004] = 543,
  [2005] = 565,
  [2006] = 1948,
  [2007] = 2007,
  [2008] = 558,
  [2009] = 1972,
  [2010] = 2010,
  [2011] = 518,
  [2012] = 467,
  [2013] = 541,
  [2014] = 527,
  [2015] = 523,
  [2016] = 2016,
  [2017] = 524,
  [2018] = 470,
  [2019] = 473,
  [2020] = 525,
  [2021] = 512,
  [2022] = 533,
  [2023] = 2023,
  [2024] = 563,
  [2025] = 481,
  [2026] = 2026,
  [2027] = 567,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 568,
  [2032] = 562,
  [2033] = 2033,
  [2034] = 511,
  [2035] = 461,
  [2036] = 505,
  [2037] = 2037,
  [2038] = 560,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 499,
  [2042] = 529,
  [2043] = 528,
  [2044] = 2044,
  [2045] = 1989,
  [2046] = 464,
  [2047] = 2047,
  [2048] = 519,
  [2049] = 551,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 517,
  [2053] = 482,
  [2054] = 513,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2039,
  [2058] = 477,
  [2059] = 2033,
  [2060] = 2060,
  [2061] = 2029,
  [2062] = 474,
  [2063] = 488,
  [2064] = 2064,
  [2065] = 2016,
  [2066] = 463,
  [2067] = 2067,
  [2068] = 1754,
  [2069] = 460,
  [2070] = 485,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 548,
  [2074] = 475,
  [2075] = 552,
  [2076] = 493,
  [2077] = 1790,
  [2078] = 555,
  [2079] = 2079,
  [2080] = 547,
  [2081] = 1480,
  [2082] = 2082,
  [2083] = 1977,
  [2084] = 544,
  [2085] = 503,
  [2086] = 1315,
  [2087] = 483,
  [2088] = 466,
  [2089] = 522,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 1951,
  [2093] = 2093,
  [2094] = 1953,
  [2095] = 480,
  [2096] = 478,
  [2097] = 542,
  [2098] = 2098,
  [2099] = 2099,
  [2100] = 2100,
  [2101] = 1959,
  [2102] = 2102,
  [2103] = 471,
  [2104] = 476,
  [2105] = 2105,
  [2106] = 486,
  [2107] = 509,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 462,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2040,
  [2118] = 2023,
  [2119] = 502,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 1975,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2112,
  [2134] = 2134,
  [2135] = 2131,
  [2136] = 510,
  [2137] = 536,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 1724,
  [2145] = 1959,
  [2146] = 2123,
  [2147] = 2122,
  [2148] = 2148,
  [2149] = 492,
  [2150] = 2150,
  [2151] = 566,
  [2152] = 516,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 1972,
  [2156] = 2156,
  [2157] = 531,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2060,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 1985,
  [2165] = 2165,
  [2166] = 498,
  [2167] = 2142,
  [2168] = 1963,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 1955,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 487,
  [2176] = 1993,
  [2177] = 515,
  [2178] = 479,
  [2179] = 1972,
  [2180] = 2180,
  [2181] = 1959,
  [2182] = 468,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 1972,
  [2189] = 2189,
  [2190] = 1959,
  [2191] = 1959,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 1978,
  [2200] = 1972,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 1959,
  [2204] = 545,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 553,
  [2209] = 2209,
  [2210] = 1959,
  [2211] = 2211,
  [2212] = 1972,
  [2213] = 2213,
  [2214] = 459,
  [2215] = 2215,
  [2216] = 1972,
  [2217] = 2007,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2219,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2239,
  [2242] = 2238,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2247,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2296,
  [2299] = 2293,
  [2300] = 2300,
  [2301] = 2237,
  [2302] = 2272,
  [2303] = 2239,
  [2304] = 2240,
  [2305] = 2243,
  [2306] = 2238,
  [2307] = 2307,
  [2308] = 2235,
  [2309] = 2309,
  [2310] = 2294,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2286,
  [2314] = 2282,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2124,
  [2319] = 2319,
  [2320] = 2281,
  [2321] = 2268,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2263,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2319,
  [2337] = 2337,
  [2338] = 2337,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2226,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2277,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 1992,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2259,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2270,
  [2357] = 2354,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2220,
  [2362] = 2317,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2229,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2246,
  [2369] = 2363,
  [2370] = 2370,
  [2371] = 2255,
  [2372] = 2342,
  [2373] = 2223,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2315,
  [2378] = 2355,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2275,
  [2382] = 2366,
  [2383] = 2383,
  [2384] = 2275,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2254,
  [2394] = 2394,
  [2395] = 1695,
  [2396] = 2387,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2380,
  [2402] = 2402,
  [2403] = 2218,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2364,
  [2407] = 2407,
  [2408] = 2388,
  [2409] = 2409,
  [2410] = 2248,
  [2411] = 2239,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2234,
  [2416] = 2416,
  [2417] = 2392,
  [2418] = 2330,
  [2419] = 2394,
  [2420] = 2420,
  [2421] = 2397,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2404,
  [2426] = 2385,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2398,
  [2430] = 2400,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2375,
  [2436] = 2436,
  [2437] = 2409,
  [2438] = 2438,
  [2439] = 2312,
  [2440] = 2227,
  [2441] = 2370,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 2358,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2436,
  [2448] = 2420,
  [2449] = 2446,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2413,
  [2453] = 2289,
  [2454] = 2266,
  [2455] = 2405,
  [2456] = 2402,
  [2457] = 2251,
  [2458] = 2443,
  [2459] = 2399,
  [2460] = 2414,
  [2461] = 1686,
  [2462] = 2359,
  [2463] = 2325,
  [2464] = 2297,
  [2465] = 2340,
  [2466] = 2253,
  [2467] = 2238,
  [2468] = 2351,
  [2469] = 2288,
  [2470] = 2280,
  [2471] = 2360,
  [2472] = 2284,
  [2473] = 2278,
  [2474] = 2283,
  [2475] = 2267,
  [2476] = 2300,
  [2477] = 2333,
  [2478] = 2438,
  [2479] = 2326,
  [2480] = 2264,
  [2481] = 2250,
  [2482] = 2275,
  [2483] = 2334,
  [2484] = 2343,
  [2485] = 2352,
  [2486] = 2345,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2487,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2503,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2526,
  [2527] = 2508,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2493,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2538,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2488,
  [2542] = 2542,
  [2543] = 2502,
  [2544] = 2526,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2500,
  [2551] = 2545,
  [2552] = 2487,
  [2553] = 2525,
  [2554] = 2497,
  [2555] = 2495,
  [2556] = 2556,
  [2557] = 2497,
  [2558] = 2558,
  [2559] = 2495,
  [2560] = 2560,
  [2561] = 2500,
  [2562] = 2562,
  [2563] = 2491,
  [2564] = 2492,
  [2565] = 2493,
  [2566] = 2487,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2539,
  [2570] = 2518,
  [2571] = 2571,
  [2572] = 2513,
  [2573] = 2509,
  [2574] = 2517,
  [2575] = 2514,
  [2576] = 2502,
  [2577] = 1995,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 2487,
  [2581] = 2509,
  [2582] = 2498,
  [2583] = 2522,
  [2584] = 2516,
  [2585] = 2515,
  [2586] = 2509,
  [2587] = 2587,
  [2588] = 2496,
  [2589] = 2589,
  [2590] = 2587,
  [2591] = 2591,
  [2592] = 2490,
  [2593] = 2593,
  [2594] = 2594,
  [2595] = 2503,
  [2596] = 2536,
  [2597] = 2537,
  [2598] = 2509,
  [2599] = 2556,
  [2600] = 2600,
  [2601] = 2562,
  [2602] = 2602,
  [2603] = 1971,
  [2604] = 2493,
  [2605] = 2605,
  [2606] = 2606,
  [2607] = 2607,
  [2608] = 2600,
  [2609] = 2609,
  [2610] = 2610,
  [2611] = 2611,
  [2612] = 2571,
  [2613] = 2547,
  [2614] = 2546,
  [2615] = 2540,
  [2616] = 2616,
  [2617] = 2617,
  [2618] = 2533,
  [2619] = 2520,
  [2620] = 2519,
  [2621] = 2621,
  [2622] = 2622,
  [2623] = 2503,
  [2624] = 2624,
  [2625] = 2625,
  [2626] = 2568,
  [2627] = 2528,
  [2628] = 2531,
  [2629] = 2493,
  [2630] = 2493,
  [2631] = 2610,
  [2632] = 2611,
  [2633] = 2633,
  [2634] = 2634,
  [2635] = 2635,
  [2636] = 2489,
  [2637] = 2495,
  [2638] = 2558,
  [2639] = 2497,
  [2640] = 2493,
  [2641] = 2493,
  [2642] = 2500,
  [2643] = 2643,
  [2644] = 2492,
  [2645] = 2502,
  [2646] = 2646,
  [2647] = 2493,
  [2648] = 2517,
  [2649] = 2492,
  [2650] = 2491,
  [2651] = 2493,
  [2652] = 2607,
  [2653] = 2653,
  [2654] = 2606,
  [2655] = 2517,
  [2656] = 2656,
  [2657] = 2607,
  [2658] = 2517,
  [2659] = 2534,
  [2660] = 2491,
  [2661] = 2611,
  [2662] = 2493,
  [2663] = 2510,
  [2664] = 2664,
  [2665] = 2558,
  [2666] = 2494,
  [2667] = 2560,
  [2668] = 2634,
  [2669] = 2643,
  [2670] = 2670,
  [2671] = 2517,
  [2672] = 2609,
  [2673] = 2673,
  [2674] = 2674,
  [2675] = 2675,
  [2676] = 2616,
  [2677] = 2675,
  [2678] = 2674,
  [2679] = 2679,
  [2680] = 2587,
  [2681] = 2517,
  [2682] = 2617,
  [2683] = 2589,
  [2684] = 2496,
  [2685] = 2506,
  [2686] = 2621,
  [2687] = 2512,
  [2688] = 2622,
  [2689] = 2611,
  [2690] = 2624,
  [2691] = 2534,
  [2692] = 2558,
  [2693] = 2674,
  [2694] = 2517,
  [2695] = 2512,
  [2696] = 2493,
  [2697] = 2674,
  [2698] = 2670,
  [2699] = 2699,
  [2700] = 2643,
  [2701] = 2513,
  [2702] = 2512,
  [2703] = 2493,
  [2704] = 2670,
  [2705] = 2705,
  [2706] = 2670,
  [2707] = 2643,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2710,
};

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < 'e'
    ? (c < '\\'
      ? (c < '$'
        ? c == '"'
        : c <= '$')
      : (c <= '\\' || c == '`'))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static inline bool sym_name_character_set_1(int32_t c) {
  return (c < 161
    ? (c < '_'
      ? (c < 'A'
        ? (c >= '0' && c <= '9')
        : c <= 'Z')
      : (c <= '_' || (c < 128
        ? (c >= 'a' && c <= 'z')
        : c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static inline bool sym_name_character_set_2(int32_t c) {
  return (c < 161
    ? (c < 'a'
      ? (c < '_'
        ? (c >= 'A' && c <= 'Z')
        : c <= '_')
      : (c <= 'z' || (c >= 128 && c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static inline bool sym_name_character_set_3(int32_t c) {
  return (c < 161
    ? (c < '_'
      ? (c < 'B'
        ? (c >= '0' && c <= '9')
        : c <= 'Z')
      : (c <= '_' || (c < 128
        ? (c >= 'b' && c <= 'z')
        : c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(138);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(228);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(190);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(223);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == '/') ADVANCE(226);
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(209);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(210);
      if (lookahead == '?') ADVANCE(103);
      if (lookahead == '@') ADVANCE(139);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(200);
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(108);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(229);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(233);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(251);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(266);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(259);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(249);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(271);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(271);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(272);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead == '\r') ADVANCE(188);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '{') ADVANCE(95);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead == '\r') ADVANCE(188);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(38);
      if (lookahead == '{') ADVANCE(95);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(138);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(211);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(139);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(199);
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(230);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(234);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(266);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(5)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(137);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '&') ADVANCE(87);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '@') ADVANCE(139);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(230);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(234);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(266);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(137);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '@') ADVANCE(139);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(229);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(233);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(251);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(266);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(259);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(249);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '\'') ADVANCE(190);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(135);
      if (lookahead == '.') ADVANCE(220);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(211);
      if (lookahead == '?') ADVANCE(104);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(199);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(134);
      if (lookahead == '.') ADVANCE(220);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(211);
      if (lookahead == '?') ADVANCE(104);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(199);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(96);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('A' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(134);
      if (lookahead == '.') ADVANCE(220);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(211);
      if (lookahead == '?') ADVANCE(104);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(38);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(199);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(96);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('A' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(135);
      if (lookahead == '.') ADVANCE(220);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == '0') ADVANCE(125);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(211);
      if (lookahead == '?') ADVANCE(104);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(199);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(96);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(135);
      if (lookahead == '.') ADVANCE(220);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(211);
      if (lookahead == '?') ADVANCE(104);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(199);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(224);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(220);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(211);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(199);
      if (lookahead == '|') ADVANCE(109);
      if (lookahead == '}') ADVANCE(96);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(173);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(230);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '&') ADVANCE(87);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(125);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(230);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '_') ADVANCE(59);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(14);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(42);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(52);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(49);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '&') ADVANCE(87);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '?') ADVANCE(105);
      if (lookahead == '\\') ADVANCE(93);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 19:
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 20:
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '&') ADVANCE(87);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '?') ADVANCE(105);
      if (lookahead == '\\') ADVANCE(93);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '/') ADVANCE(179);
      if (lookahead == '?') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(178);
      if (lookahead != 0) ADVANCE(185);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(272);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '/') ADVANCE(271);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(23);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(180);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(24);
      if (lookahead != 0) ADVANCE(181);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '_') ADVANCE(59);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(102);
      END_STATE();
    case 29:
      if (lookahead == '<') ADVANCE(186);
      END_STATE();
    case 30:
      if (lookahead == '<') ADVANCE(29);
      END_STATE();
    case 31:
      if (lookahead == '=') ADVANCE(202);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(201);
      if (lookahead == '>') ADVANCE(99);
      END_STATE();
    case 33:
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 34:
      if (lookahead == '>') ADVANCE(99);
      END_STATE();
    case 35:
      if (lookahead == '>') ADVANCE(74);
      END_STATE();
    case 36:
      if (lookahead == '>') ADVANCE(157);
      END_STATE();
    case 37:
      if (lookahead == '?') ADVANCE(73);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(169);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(175);
      if (lookahead != 0) ADVANCE(185);
      END_STATE();
    case 41:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 42:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 43:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 44:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(48);
      END_STATE();
    case 45:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(50);
      END_STATE();
    case 46:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 47:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(46);
      END_STATE();
    case 48:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(72);
      END_STATE();
    case 49:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 50:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(43);
      END_STATE();
    case 51:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(43);
      END_STATE();
    case 52:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(47);
      END_STATE();
    case 53:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(123);
      END_STATE();
    case 54:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(121);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(126);
      END_STATE();
    case 56:
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(165);
      if (lookahead == 'u') ADVANCE(170);
      if (lookahead == 'x') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(167);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(122);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(117);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(124);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 65:
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(185);
      END_STATE();
    case 66:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(138);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(228);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(223);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(221);
      if (lookahead == '/') ADVANCE(226);
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(209);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(210);
      if (lookahead == '?') ADVANCE(103);
      if (lookahead == '@') ADVANCE(139);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(94);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(200);
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(108);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(229);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(233);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(251);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(266);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(259);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(249);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(66)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 67:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(137);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(274);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '&') ADVANCE(87);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '+') ADVANCE(129);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '0') ADVANCE(120);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '?') ADVANCE(35);
      if (lookahead == '@') ADVANCE(139);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == '`') ADVANCE(191);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '}') ADVANCE(96);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(230);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(234);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(266);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(122);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(67)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 68:
      if (eof) ADVANCE(71);
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '"') ADVANCE(172);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '%') ADVANCE(228);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(174);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '*') ADVANCE(223);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(91);
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(222);
      if (lookahead == '/') ADVANCE(226);
      if (lookahead == '0') ADVANCE(125);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(86);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(210);
      if (lookahead == '?') ADVANCE(103);
      if (lookahead == '[') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == ']') ADVANCE(159);
      if (lookahead == '^') ADVANCE(200);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(108);
      if (lookahead == '}') ADVANCE(96);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(127);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(68)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 69:
      if (eof) ADVANCE(71);
      if (lookahead == '#') ADVANCE(84);
      if (lookahead == '/') ADVANCE(79);
      if (lookahead == '<') ADVANCE(75);
      if (lookahead == '?') ADVANCE(82);
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(69)
      if (lookahead != 0) ADVANCE(85);
      END_STATE();
    case 70:
      if (eof) ADVANCE(71);
      if (lookahead == '#') ADVANCE(275);
      if (lookahead == '$') ADVANCE(192);
      if (lookahead == '&') ADVANCE(87);
      if (lookahead == '(') ADVANCE(100);
      if (lookahead == ')') ADVANCE(101);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '<') ADVANCE(37);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '?') ADVANCE(105);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == '{') ADVANCE(95);
      if (lookahead == '|') ADVANCE(107);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(264);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(70)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_php_tag);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_php_tag);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(44);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_text_token1);
      if (lookahead == '?') ADVANCE(73);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '\n') ADVANCE(85);
      if (lookahead == '\r') ADVANCE(77);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(83);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '\n') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(85);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '#') ADVANCE(84);
      if (lookahead == '/') ADVANCE(79);
      if (lookahead == '?') ADVANCE(82);
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(85);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(81);
      if (lookahead == '/') ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(85);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(80);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(85);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '?') ADVANCE(76);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == '?' ||
          lookahead == '[') ADVANCE(85);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(83);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(198);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(198);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym_function_static_declaration_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(201);
      if (lookahead == '>') ADVANCE(99);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(175);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(140);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '>') ADVANCE(74);
      if (lookahead == '?') ADVANCE(194);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(36);
      if (lookahead == '>') ADVANCE(74);
      if (lookahead == '?') ADVANCE(193);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(74);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(74);
      if (lookahead == '?') ADVANCE(193);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '|') ADVANCE(197);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(197);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_cast_type_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_cast_type_token3);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(aux_sym_cast_type_token6);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_cast_type_token8);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(aux_sym_cast_type_token11);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(aux_sym_cast_type_token12);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '_') ADVANCE(58);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(58);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(269);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 159) ||
          (161 <= lookahead && lookahead <= 8202) ||
          (8204 <= lookahead && lookahead <= 8287) ||
          (8289 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65278) ||
          (65280 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(53);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(126);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(62);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '_') ADVANCE(57);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(53);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(53);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(126);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(142);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(142);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(141);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '=') ADVANCE(148);
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(202);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_QMARK_DASH_GT);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym__argument_name_token1);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym__argument_name_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym__argument_name_token2);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym__argument_name_token2);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(165);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      if (lookahead == '{') ADVANCE(64);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_encapsed_string_token1);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\n') ADVANCE(185);
      if (lookahead == '\r') ADVANCE(177);
      if (lookahead == '>') ADVANCE(185);
      if (lookahead == '\\') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(183);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\n') ADVANCE(185);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(185);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '#') ADVANCE(184);
      if (lookahead == '/') ADVANCE(179);
      if (lookahead == '?') ADVANCE(182);
      if (lookahead == '\\') ADVANCE(40);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(185);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(181);
      if (lookahead == '/') ADVANCE(183);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(185);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(180);
      if (lookahead == '/') ADVANCE(185);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(181);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(180);
      if (lookahead == '\\') ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '>') ADVANCE(185);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(185);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\\') ADVANCE(273);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\\') ADVANCE(273);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == '?' ||
          lookahead == '[') ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(183);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym__new_line);
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead == '\r') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_SQUOTE2);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(204);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(205);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(216);
      if (lookahead == '=') ADVANCE(212);
      if (lookahead == '>') ADVANCE(203);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(217);
      if (lookahead == '=') ADVANCE(212);
      if (lookahead == '>') ADVANCE(203);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(215);
      if (lookahead == '=') ADVANCE(212);
      if (lookahead == '>') ADVANCE(203);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '?') ADVANCE(73);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(213);
      if (lookahead == '>') ADVANCE(219);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(213);
      if (lookahead == '>') ADVANCE(218);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(214);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '<') ADVANCE(186);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '_') ADVANCE(58);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(117);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(196);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(195);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(272);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(272);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(173);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(253);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(171);
      if (lookahead == '\'') ADVANCE(173);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '_') ADVANCE(268);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(231);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 159) ||
          (161 <= lookahead && lookahead <= 8202) ||
          (8204 <= lookahead && lookahead <= 8287) ||
          (8289 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65278) ||
          (65280 <= lookahead && lookahead <= 65535)) ADVANCE(270);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (sym_name_character_set_2(lookahead)) ADVANCE(270);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(248);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(252);
      if (sym_name_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(248);
      if (sym_name_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(267);
      if (sym_name_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(263);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(244);
      if (sym_name_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(263);
      if (sym_name_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(261);
      if (sym_name_character_set_3(lookahead)) ADVANCE(270);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(90);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(163);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(262);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(114);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(239);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(250);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(111);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(161);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(246);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(257);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(258);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(242);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(260);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(238);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(245);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(235);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(265);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(254);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(240);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(241);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(236);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(112);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(113);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(115);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(243);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(237);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(240);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(247);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(110);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(231);
      if (sym_name_character_set_2(lookahead)) ADVANCE(270);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(118);
      if (sym_name_character_set_2(lookahead)) ADVANCE(270);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_name);
      if (sym_name_character_set_1(lookahead)) ADVANCE(270);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(185);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(272);
      if (lookahead != 0) ADVANCE(183);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '[') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '?') ADVANCE(272);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '?' &&
          lookahead != '[') ADVANCE(272);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'B') ADVANCE(2);
      if (lookahead == 'E') ADVANCE(3);
      if (lookahead == 'F') ADVANCE(4);
      if (lookahead == 'I') ADVANCE(5);
      if (lookahead == 'M') ADVANCE(6);
      if (lookahead == 'N') ADVANCE(7);
      if (lookahead == 'P') ADVANCE(8);
      if (lookahead == 'S') ADVANCE(9);
      if (lookahead == 'T') ADVANCE(10);
      if (lookahead == 'U') ADVANCE(11);
      if (lookahead == 'V') ADVANCE(12);
      if (lookahead == 'a') ADVANCE(13);
      if (lookahead == 'b') ADVANCE(14);
      if (lookahead == 'e') ADVANCE(15);
      if (lookahead == 'f') ADVANCE(16);
      if (lookahead == 'i') ADVANCE(17);
      if (lookahead == 'm') ADVANCE(18);
      if (lookahead == 'n') ADVANCE(19);
      if (lookahead == 'p') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(25);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(26);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(28);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(29);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(30);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(31);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(32);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(33);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(34);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(35);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(36);
      END_STATE();
    case 2:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(37);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(38);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 3:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(41);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(42);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(43);
      END_STATE();
    case 4:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(44);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(47);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 5:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(50);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 6:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 7:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 8:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(55);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 9:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 10:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(58);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 11:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(60);
      END_STATE();
    case 12:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 13:
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(34);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(35);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(36);
      END_STATE();
    case 14:
      if (lookahead == 'O') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(63);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(37);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 15:
      if (lookahead == 'N') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(64);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(41);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(43);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'l') ADVANCE(66);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(44);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(47);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 17:
      if (lookahead == 'N') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(50);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(69);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 19:
      if (lookahead == 'E') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(70);
      if (lookahead == 'u') ADVANCE(71);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(72);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(55);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 22:
      if (lookahead == 'R') ADVANCE(59);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(58);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(77);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(60);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(78);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 25:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(80);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 26:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(82);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 27:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(84);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(87);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 31:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(90);
      END_STATE();
    case 32:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(91);
      END_STATE();
    case 33:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 34:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(93);
      END_STATE();
    case 35:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(94);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(aux_sym_namespace_aliasing_clause_token1);
      END_STATE();
    case 37:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 38:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 39:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(99);
      END_STATE();
    case 42:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(100);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 43:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(102);
      END_STATE();
    case 44:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym__arrow_function_header_token1);
      END_STATE();
    case 46:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 47:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 48:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(106);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_if_statement_token1);
      END_STATE();
    case 50:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 51:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(108);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(109);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(110);
      END_STATE();
    case 52:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(111);
      END_STATE();
    case 53:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 54:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 55:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(114);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 56:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(116);
      END_STATE();
    case 57:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 58:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(118);
      END_STATE();
    case 59:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(119);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 61:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 63:
      if (lookahead == 'O') ADVANCE(96);
      if (lookahead == 'o') ADVANCE(124);
      END_STATE();
    case 64:
      if (lookahead == 'c') ADVANCE(125);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(100);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 67:
      if (lookahead == 'T') ADVANCE(110);
      if (lookahead == 't') ADVANCE(128);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(108);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(109);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 69:
      if (lookahead == 'x') ADVANCE(130);
      END_STATE();
    case 70:
      if (lookahead == 'v') ADVANCE(131);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 73:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(135);
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 75:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 76:
      if (lookahead == 'u') ADVANCE(138);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(119);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(120);
      END_STATE();
    case 77:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(140);
      END_STATE();
    case 79:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(141);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(142);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(143);
      END_STATE();
    case 80:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(144);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(145);
      END_STATE();
    case 81:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(146);
      END_STATE();
    case 82:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(147);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym_do_statement_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 84:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 85:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(151);
      END_STATE();
    case 86:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(152);
      END_STATE();
    case 87:
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(153);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_binary_expression_token3);
      END_STATE();
    case 89:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(154);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(155);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(156);
      END_STATE();
    case 90:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(157);
      END_STATE();
    case 91:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(158);
      END_STATE();
    case 92:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 93:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(160);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_binary_expression_token2);
      END_STATE();
    case 95:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 96:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 97:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 98:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 99:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 100:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(166);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(167);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(168);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(169);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(170);
      END_STATE();
    case 101:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(171);
      END_STATE();
    case 102:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 103:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_for_statement_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 105:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(175);
      END_STATE();
    case 106:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(176);
      END_STATE();
    case 107:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 108:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 109:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(179);
      END_STATE();
    case 110:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 111:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(181);
      END_STATE();
    case 112:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_object_creation_expression_token1);
      END_STATE();
    case 114:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(183);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(184);
      END_STATE();
    case 115:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(185);
      END_STATE();
    case 116:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 117:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(187);
      END_STATE();
    case 118:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(188);
      END_STATE();
    case 119:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_try_statement_token1);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token1);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_var_modifier);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 124:
      if (lookahead == 'L') ADVANCE(162);
      if (lookahead == 'l') ADVANCE(191);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(192);
      END_STATE();
    case 126:
      if (lookahead == 's') ADVANCE(193);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 134:
      if (lookahead == 'f') ADVANCE(200);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 136:
      if (lookahead == 'i') ADVANCE(202);
      END_STATE();
    case 137:
      if (lookahead == 'k') ADVANCE(203);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 140:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 141:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 142:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 143:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(209);
      END_STATE();
    case 144:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(210);
      END_STATE();
    case 145:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 146:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(212);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(213);
      END_STATE();
    case 147:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 148:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 149:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(216);
      END_STATE();
    case 150:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(217);
      END_STATE();
    case 151:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 152:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(219);
      END_STATE();
    case 153:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 154:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(221);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(222);
      END_STATE();
    case 155:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(223);
      END_STATE();
    case 156:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(224);
      END_STATE();
    case 157:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_binary_expression_token4);
      END_STATE();
    case 159:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(226);
      END_STATE();
    case 160:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 161:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 162:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 163:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(230);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_echo_statement_token1);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_else_clause_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 166:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 167:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 168:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(234);
      END_STATE();
    case 169:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(235);
      END_STATE();
    case 170:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(236);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_enum_declaration_token1);
      END_STATE();
    case 172:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 173:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 174:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_yield_expression_token2);
      END_STATE();
    case 176:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(240);
      END_STATE();
    case 177:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 178:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(242);
      END_STATE();
    case 179:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(243);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 180:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(245);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 181:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(247);
      END_STATE();
    case 182:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(248);
      END_STATE();
    case 183:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(249);
      END_STATE();
    case 184:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 185:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 186:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(252);
      END_STATE();
    case 187:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 188:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(254);
      END_STATE();
    case 189:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      END_STATE();
    case 190:
      if (lookahead == 'y') ADVANCE(256);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_bool);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 192:
      if (lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(258);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 196:
      if (lookahead == 'd') ADVANCE(261);
      END_STATE();
    case 197:
      if (lookahead == 'r') ADVANCE(262);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(263);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_self);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(264);
      END_STATE();
    case 202:
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 203:
      if (lookahead == 's') ADVANCE(267);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 207:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_enum_case_token1);
      END_STATE();
    case 209:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(270);
      END_STATE();
    case 210:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(271);
      END_STATE();
    case 211:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 212:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(273);
      END_STATE();
    case 213:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(274);
      END_STATE();
    case 214:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(275);
      END_STATE();
    case 215:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(276);
      END_STATE();
    case 216:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(277);
      END_STATE();
    case 217:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(278);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_goto_statement_token1);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym__list_destructing_token1);
      END_STATE();
    case 220:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(279);
      END_STATE();
    case 221:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(280);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_cast_type_token10);
      END_STATE();
    case 223:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 224:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(282);
      END_STATE();
    case 225:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 226:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(284);
      END_STATE();
    case 227:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(285);
      END_STATE();
    case 228:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(286);
      END_STATE();
    case 229:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym_break_statement_token1);
      END_STATE();
    case 231:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(288);
      END_STATE();
    case 232:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 233:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym_if_statement_token2);
      END_STATE();
    case 235:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 236:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(292);
      END_STATE();
    case 237:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_final_modifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(294);
      END_STATE();
    case 239:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(295);
      END_STATE();
    case 240:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(296);
      END_STATE();
    case 241:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(297);
      END_STATE();
    case 242:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 243:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(299);
      END_STATE();
    case 244:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(300);
      END_STATE();
    case 245:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(301);
      END_STATE();
    case 246:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(302);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(aux_sym_match_expression_token1);
      END_STATE();
    case 248:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(303);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_print_intrinsic_token1);
      END_STATE();
    case 250:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(304);
      END_STATE();
    case 251:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(305);
      END_STATE();
    case 252:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(306);
      END_STATE();
    case 253:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(307);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_throw_expression_token1);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_trait_declaration_token1);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_array);
      END_STATE();
    case 257:
      if (lookahead == 'i') ADVANCE(308);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 260:
      if (lookahead == 'b') ADVANCE(309);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_mixed);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_bottom_type);
      END_STATE();
    case 263:
      if (lookahead == 't') ADVANCE(310);
      END_STATE();
    case 264:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 265:
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 266:
      if (lookahead == 'g') ADVANCE(313);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_ticks);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_unset);
      END_STATE();
    case 269:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(314);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_catch_clause_token1);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_class_declaration_token1);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_clone_expression_token1);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token3);
      END_STATE();
    case 274:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(315);
      END_STATE();
    case 275:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(316);
      END_STATE();
    case 276:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(317);
      END_STATE();
    case 277:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 278:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(319);
      END_STATE();
    case 279:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(320);
      END_STATE();
    case 280:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(321);
      END_STATE();
    case 281:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(322);
      END_STATE();
    case 282:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(323);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_while_statement_token1);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_yield_expression_token1);
      END_STATE();
    case 285:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(324);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_cast_type_token2);
      END_STATE();
    case 287:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_else_if_clause_token1);
      END_STATE();
    case 289:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_for_statement_token2);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 291:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(328);
      END_STATE();
    case 292:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 293:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(330);
      END_STATE();
    case 294:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(331);
      END_STATE();
    case 295:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(332);
      END_STATE();
    case 296:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 297:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(334);
      END_STATE();
    case 298:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 299:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 300:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(337);
      END_STATE();
    case 301:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(338);
      END_STATE();
    case 302:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(339);
      END_STATE();
    case 303:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(340);
      END_STATE();
    case 304:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 305:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(342);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token1);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_switch_statement_token1);
      END_STATE();
    case 308:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 309:
      if (lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 312:
      if (lookahead == '_') ADVANCE(345);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 314:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(346);
      END_STATE();
    case 315:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(347);
      END_STATE();
    case 316:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(348);
      END_STATE();
    case 317:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(349);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_cast_type_token5);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_global_declaration_token1);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_cast_type_token9);
      END_STATE();
    case 321:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(350);
      END_STATE();
    case 322:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_return_statement_token1);
      END_STATE();
    case 324:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(352);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_cast_type_token4);
      END_STATE();
    case 326:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(353);
      END_STATE();
    case 327:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(354);
      END_STATE();
    case 328:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(355);
      END_STATE();
    case 329:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_base_clause_token1);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(aux_sym_finally_clause_token1);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_foreach_statement_token1);
      END_STATE();
    case 333:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(357);
      END_STATE();
    case 334:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(358);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(aux_sym_include_expression_token1);
      if (lookahead == '_') ADVANCE(359);
      END_STATE();
    case 336:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 337:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(361);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_cast_type_token7);
      END_STATE();
    case 339:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(362);
      END_STATE();
    case 340:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(363);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token3);
      END_STATE();
    case 342:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 343:
      if (lookahead == 'g') ADVANCE(365);
      END_STATE();
    case 344:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 345:
      if (lookahead == 't') ADVANCE(367);
      END_STATE();
    case 346:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 347:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_declare_statement_token1);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_match_default_expression_token1);
      END_STATE();
    case 350:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(370);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_require_expression_token1);
      if (lookahead == '_') ADVANCE(371);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_abstract_modifier_token1);
      END_STATE();
    case 353:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(372);
      END_STATE();
    case 354:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(373);
      END_STATE();
    case 355:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(374);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_while_statement_token2);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token2);
      END_STATE();
    case 358:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(375);
      END_STATE();
    case 359:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(376);
      END_STATE();
    case 360:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(377);
      END_STATE();
    case 361:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(378);
      END_STATE();
    case 362:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(379);
      END_STATE();
    case 363:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(380);
      END_STATE();
    case 364:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(381);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_encoding);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_iterable);
      END_STATE();
    case 367:
      if (lookahead == 'y') ADVANCE(382);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_primitive_type_token1);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_continue_statement_token1);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_readonly_modifier_token1);
      END_STATE();
    case 371:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(383);
      END_STATE();
    case 372:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(384);
      END_STATE();
    case 373:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(385);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(aux_sym_switch_block_token1);
      END_STATE();
    case 375:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(386);
      END_STATE();
    case 376:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(387);
      END_STATE();
    case 377:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(388);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_use_instead_of_clause_token1);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(aux_sym_interface_declaration_token1);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_namespace_definition_token1);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token2);
      END_STATE();
    case 382:
      if (lookahead == 'p') ADVANCE(389);
      END_STATE();
    case 383:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(390);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(aux_sym_declare_statement_token2);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(aux_sym_foreach_statement_token2);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(aux_sym_class_interface_clause_token1);
      END_STATE();
    case 387:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(391);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_binary_expression_token1);
      END_STATE();
    case 389:
      if (lookahead == 'e') ADVANCE(392);
      END_STATE();
    case 390:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(393);
      END_STATE();
    case 391:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(394);
      END_STATE();
    case 392:
      if (lookahead == 's') ADVANCE(395);
      END_STATE();
    case 393:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym_include_once_expression_token1);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_strict_types);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_require_once_expression_token1);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 69},
  [2] = {.lex_state = 67},
  [3] = {.lex_state = 67},
  [4] = {.lex_state = 67},
  [5] = {.lex_state = 67},
  [6] = {.lex_state = 67},
  [7] = {.lex_state = 67},
  [8] = {.lex_state = 67},
  [9] = {.lex_state = 67},
  [10] = {.lex_state = 67},
  [11] = {.lex_state = 67},
  [12] = {.lex_state = 67, .external_lex_state = 2},
  [13] = {.lex_state = 67, .external_lex_state = 2},
  [14] = {.lex_state = 67, .external_lex_state = 2},
  [15] = {.lex_state = 67, .external_lex_state = 2},
  [16] = {.lex_state = 67},
  [17] = {.lex_state = 67},
  [18] = {.lex_state = 67, .external_lex_state = 2},
  [19] = {.lex_state = 67},
  [20] = {.lex_state = 67},
  [21] = {.lex_state = 67},
  [22] = {.lex_state = 67, .external_lex_state = 2},
  [23] = {.lex_state = 67},
  [24] = {.lex_state = 67},
  [25] = {.lex_state = 67, .external_lex_state = 2},
  [26] = {.lex_state = 67},
  [27] = {.lex_state = 67},
  [28] = {.lex_state = 67},
  [29] = {.lex_state = 67},
  [30] = {.lex_state = 67},
  [31] = {.lex_state = 67},
  [32] = {.lex_state = 67},
  [33] = {.lex_state = 67, .external_lex_state = 2},
  [34] = {.lex_state = 67, .external_lex_state = 2},
  [35] = {.lex_state = 67},
  [36] = {.lex_state = 67, .external_lex_state = 2},
  [37] = {.lex_state = 67},
  [38] = {.lex_state = 67, .external_lex_state = 2},
  [39] = {.lex_state = 67},
  [40] = {.lex_state = 67},
  [41] = {.lex_state = 67},
  [42] = {.lex_state = 67, .external_lex_state = 2},
  [43] = {.lex_state = 67},
  [44] = {.lex_state = 67},
  [45] = {.lex_state = 67, .external_lex_state = 2},
  [46] = {.lex_state = 67},
  [47] = {.lex_state = 67},
  [48] = {.lex_state = 67},
  [49] = {.lex_state = 67, .external_lex_state = 2},
  [50] = {.lex_state = 67},
  [51] = {.lex_state = 67, .external_lex_state = 2},
  [52] = {.lex_state = 67},
  [53] = {.lex_state = 67},
  [54] = {.lex_state = 67, .external_lex_state = 2},
  [55] = {.lex_state = 67, .external_lex_state = 2},
  [56] = {.lex_state = 67, .external_lex_state = 2},
  [57] = {.lex_state = 67},
  [58] = {.lex_state = 67},
  [59] = {.lex_state = 67, .external_lex_state = 2},
  [60] = {.lex_state = 67},
  [61] = {.lex_state = 67, .external_lex_state = 2},
  [62] = {.lex_state = 67, .external_lex_state = 2},
  [63] = {.lex_state = 67},
  [64] = {.lex_state = 67, .external_lex_state = 2},
  [65] = {.lex_state = 67},
  [66] = {.lex_state = 67},
  [67] = {.lex_state = 67},
  [68] = {.lex_state = 67},
  [69] = {.lex_state = 67, .external_lex_state = 2},
  [70] = {.lex_state = 67},
  [71] = {.lex_state = 67},
  [72] = {.lex_state = 67},
  [73] = {.lex_state = 67},
  [74] = {.lex_state = 67},
  [75] = {.lex_state = 67},
  [76] = {.lex_state = 67, .external_lex_state = 2},
  [77] = {.lex_state = 67},
  [78] = {.lex_state = 67},
  [79] = {.lex_state = 67},
  [80] = {.lex_state = 67},
  [81] = {.lex_state = 67},
  [82] = {.lex_state = 67},
  [83] = {.lex_state = 67},
  [84] = {.lex_state = 67},
  [85] = {.lex_state = 67},
  [86] = {.lex_state = 5},
  [87] = {.lex_state = 5},
  [88] = {.lex_state = 5, .external_lex_state = 2},
  [89] = {.lex_state = 5},
  [90] = {.lex_state = 7},
  [91] = {.lex_state = 7},
  [92] = {.lex_state = 7},
  [93] = {.lex_state = 7},
  [94] = {.lex_state = 7},
  [95] = {.lex_state = 7},
  [96] = {.lex_state = 7},
  [97] = {.lex_state = 7},
  [98] = {.lex_state = 7},
  [99] = {.lex_state = 7},
  [100] = {.lex_state = 7},
  [101] = {.lex_state = 6},
  [102] = {.lex_state = 6},
  [103] = {.lex_state = 6},
  [104] = {.lex_state = 6},
  [105] = {.lex_state = 6},
  [106] = {.lex_state = 6},
  [107] = {.lex_state = 6},
  [108] = {.lex_state = 6},
  [109] = {.lex_state = 6},
  [110] = {.lex_state = 6},
  [111] = {.lex_state = 6},
  [112] = {.lex_state = 6},
  [113] = {.lex_state = 6},
  [114] = {.lex_state = 6},
  [115] = {.lex_state = 6},
  [116] = {.lex_state = 6},
  [117] = {.lex_state = 6},
  [118] = {.lex_state = 6},
  [119] = {.lex_state = 6},
  [120] = {.lex_state = 6},
  [121] = {.lex_state = 6},
  [122] = {.lex_state = 6},
  [123] = {.lex_state = 6},
  [124] = {.lex_state = 6},
  [125] = {.lex_state = 6},
  [126] = {.lex_state = 6},
  [127] = {.lex_state = 6},
  [128] = {.lex_state = 6},
  [129] = {.lex_state = 6},
  [130] = {.lex_state = 6},
  [131] = {.lex_state = 6},
  [132] = {.lex_state = 6},
  [133] = {.lex_state = 6},
  [134] = {.lex_state = 6},
  [135] = {.lex_state = 6},
  [136] = {.lex_state = 6},
  [137] = {.lex_state = 6},
  [138] = {.lex_state = 6},
  [139] = {.lex_state = 67},
  [140] = {.lex_state = 6},
  [141] = {.lex_state = 6},
  [142] = {.lex_state = 6},
  [143] = {.lex_state = 67},
  [144] = {.lex_state = 6},
  [145] = {.lex_state = 6},
  [146] = {.lex_state = 67},
  [147] = {.lex_state = 67},
  [148] = {.lex_state = 67},
  [149] = {.lex_state = 67},
  [150] = {.lex_state = 67},
  [151] = {.lex_state = 67},
  [152] = {.lex_state = 6},
  [153] = {.lex_state = 67},
  [154] = {.lex_state = 67},
  [155] = {.lex_state = 67},
  [156] = {.lex_state = 67},
  [157] = {.lex_state = 6},
  [158] = {.lex_state = 67},
  [159] = {.lex_state = 67},
  [160] = {.lex_state = 67},
  [161] = {.lex_state = 67},
  [162] = {.lex_state = 67},
  [163] = {.lex_state = 67},
  [164] = {.lex_state = 67},
  [165] = {.lex_state = 67},
  [166] = {.lex_state = 67},
  [167] = {.lex_state = 67},
  [168] = {.lex_state = 67},
  [169] = {.lex_state = 67},
  [170] = {.lex_state = 67},
  [171] = {.lex_state = 67},
  [172] = {.lex_state = 67},
  [173] = {.lex_state = 67},
  [174] = {.lex_state = 67},
  [175] = {.lex_state = 67},
  [176] = {.lex_state = 67},
  [177] = {.lex_state = 67},
  [178] = {.lex_state = 67},
  [179] = {.lex_state = 67},
  [180] = {.lex_state = 67},
  [181] = {.lex_state = 67},
  [182] = {.lex_state = 67},
  [183] = {.lex_state = 67},
  [184] = {.lex_state = 67},
  [185] = {.lex_state = 67},
  [186] = {.lex_state = 67, .external_lex_state = 2},
  [187] = {.lex_state = 67, .external_lex_state = 2},
  [188] = {.lex_state = 67, .external_lex_state = 2},
  [189] = {.lex_state = 67, .external_lex_state = 2},
  [190] = {.lex_state = 6},
  [191] = {.lex_state = 67, .external_lex_state = 2},
  [192] = {.lex_state = 67},
  [193] = {.lex_state = 67},
  [194] = {.lex_state = 67},
  [195] = {.lex_state = 67},
  [196] = {.lex_state = 6},
  [197] = {.lex_state = 67},
  [198] = {.lex_state = 67, .external_lex_state = 2},
  [199] = {.lex_state = 67},
  [200] = {.lex_state = 67},
  [201] = {.lex_state = 67},
  [202] = {.lex_state = 67},
  [203] = {.lex_state = 67},
  [204] = {.lex_state = 67},
  [205] = {.lex_state = 67},
  [206] = {.lex_state = 67},
  [207] = {.lex_state = 67},
  [208] = {.lex_state = 67},
  [209] = {.lex_state = 67},
  [210] = {.lex_state = 67},
  [211] = {.lex_state = 67},
  [212] = {.lex_state = 67},
  [213] = {.lex_state = 67},
  [214] = {.lex_state = 67},
  [215] = {.lex_state = 67},
  [216] = {.lex_state = 67},
  [217] = {.lex_state = 67},
  [218] = {.lex_state = 67},
  [219] = {.lex_state = 67},
  [220] = {.lex_state = 67},
  [221] = {.lex_state = 67},
  [222] = {.lex_state = 67},
  [223] = {.lex_state = 67},
  [224] = {.lex_state = 67},
  [225] = {.lex_state = 67},
  [226] = {.lex_state = 67},
  [227] = {.lex_state = 67},
  [228] = {.lex_state = 67},
  [229] = {.lex_state = 67},
  [230] = {.lex_state = 67},
  [231] = {.lex_state = 67},
  [232] = {.lex_state = 67},
  [233] = {.lex_state = 67},
  [234] = {.lex_state = 67},
  [235] = {.lex_state = 67},
  [236] = {.lex_state = 67},
  [237] = {.lex_state = 67},
  [238] = {.lex_state = 67},
  [239] = {.lex_state = 67},
  [240] = {.lex_state = 67},
  [241] = {.lex_state = 67},
  [242] = {.lex_state = 67},
  [243] = {.lex_state = 67},
  [244] = {.lex_state = 67},
  [245] = {.lex_state = 67},
  [246] = {.lex_state = 67},
  [247] = {.lex_state = 67},
  [248] = {.lex_state = 67},
  [249] = {.lex_state = 67},
  [250] = {.lex_state = 67},
  [251] = {.lex_state = 67},
  [252] = {.lex_state = 67},
  [253] = {.lex_state = 67},
  [254] = {.lex_state = 67},
  [255] = {.lex_state = 67},
  [256] = {.lex_state = 67},
  [257] = {.lex_state = 67},
  [258] = {.lex_state = 67},
  [259] = {.lex_state = 67},
  [260] = {.lex_state = 67},
  [261] = {.lex_state = 67},
  [262] = {.lex_state = 67},
  [263] = {.lex_state = 67},
  [264] = {.lex_state = 67},
  [265] = {.lex_state = 67},
  [266] = {.lex_state = 67},
  [267] = {.lex_state = 67},
  [268] = {.lex_state = 67},
  [269] = {.lex_state = 67},
  [270] = {.lex_state = 67},
  [271] = {.lex_state = 67},
  [272] = {.lex_state = 67},
  [273] = {.lex_state = 67},
  [274] = {.lex_state = 67},
  [275] = {.lex_state = 67},
  [276] = {.lex_state = 67},
  [277] = {.lex_state = 67},
  [278] = {.lex_state = 67},
  [279] = {.lex_state = 67},
  [280] = {.lex_state = 67},
  [281] = {.lex_state = 67},
  [282] = {.lex_state = 67},
  [283] = {.lex_state = 67},
  [284] = {.lex_state = 67},
  [285] = {.lex_state = 67},
  [286] = {.lex_state = 67},
  [287] = {.lex_state = 67},
  [288] = {.lex_state = 67},
  [289] = {.lex_state = 67},
  [290] = {.lex_state = 67},
  [291] = {.lex_state = 67},
  [292] = {.lex_state = 67},
  [293] = {.lex_state = 67},
  [294] = {.lex_state = 67},
  [295] = {.lex_state = 67},
  [296] = {.lex_state = 67},
  [297] = {.lex_state = 67},
  [298] = {.lex_state = 67},
  [299] = {.lex_state = 67},
  [300] = {.lex_state = 67},
  [301] = {.lex_state = 67},
  [302] = {.lex_state = 67},
  [303] = {.lex_state = 67},
  [304] = {.lex_state = 67},
  [305] = {.lex_state = 67},
  [306] = {.lex_state = 67},
  [307] = {.lex_state = 67},
  [308] = {.lex_state = 67},
  [309] = {.lex_state = 67},
  [310] = {.lex_state = 67},
  [311] = {.lex_state = 67},
  [312] = {.lex_state = 67},
  [313] = {.lex_state = 67},
  [314] = {.lex_state = 67},
  [315] = {.lex_state = 67},
  [316] = {.lex_state = 67},
  [317] = {.lex_state = 67},
  [318] = {.lex_state = 67},
  [319] = {.lex_state = 67},
  [320] = {.lex_state = 67},
  [321] = {.lex_state = 67},
  [322] = {.lex_state = 67},
  [323] = {.lex_state = 67},
  [324] = {.lex_state = 67},
  [325] = {.lex_state = 67},
  [326] = {.lex_state = 67},
  [327] = {.lex_state = 67},
  [328] = {.lex_state = 67},
  [329] = {.lex_state = 67},
  [330] = {.lex_state = 67},
  [331] = {.lex_state = 67},
  [332] = {.lex_state = 67},
  [333] = {.lex_state = 67},
  [334] = {.lex_state = 67},
  [335] = {.lex_state = 67},
  [336] = {.lex_state = 67},
  [337] = {.lex_state = 67},
  [338] = {.lex_state = 67},
  [339] = {.lex_state = 67},
  [340] = {.lex_state = 67},
  [341] = {.lex_state = 67},
  [342] = {.lex_state = 67},
  [343] = {.lex_state = 67},
  [344] = {.lex_state = 67},
  [345] = {.lex_state = 67},
  [346] = {.lex_state = 67},
  [347] = {.lex_state = 67},
  [348] = {.lex_state = 67},
  [349] = {.lex_state = 67},
  [350] = {.lex_state = 67},
  [351] = {.lex_state = 67},
  [352] = {.lex_state = 67},
  [353] = {.lex_state = 67},
  [354] = {.lex_state = 67},
  [355] = {.lex_state = 67},
  [356] = {.lex_state = 67},
  [357] = {.lex_state = 67},
  [358] = {.lex_state = 67},
  [359] = {.lex_state = 67},
  [360] = {.lex_state = 67},
  [361] = {.lex_state = 67},
  [362] = {.lex_state = 67},
  [363] = {.lex_state = 67},
  [364] = {.lex_state = 67},
  [365] = {.lex_state = 67},
  [366] = {.lex_state = 67},
  [367] = {.lex_state = 67},
  [368] = {.lex_state = 67},
  [369] = {.lex_state = 67},
  [370] = {.lex_state = 67},
  [371] = {.lex_state = 67},
  [372] = {.lex_state = 67},
  [373] = {.lex_state = 67},
  [374] = {.lex_state = 67},
  [375] = {.lex_state = 67},
  [376] = {.lex_state = 67},
  [377] = {.lex_state = 67},
  [378] = {.lex_state = 67},
  [379] = {.lex_state = 67},
  [380] = {.lex_state = 67},
  [381] = {.lex_state = 67},
  [382] = {.lex_state = 67},
  [383] = {.lex_state = 67},
  [384] = {.lex_state = 67},
  [385] = {.lex_state = 67},
  [386] = {.lex_state = 67},
  [387] = {.lex_state = 67},
  [388] = {.lex_state = 67},
  [389] = {.lex_state = 67},
  [390] = {.lex_state = 67},
  [391] = {.lex_state = 67},
  [392] = {.lex_state = 67},
  [393] = {.lex_state = 67},
  [394] = {.lex_state = 67},
  [395] = {.lex_state = 67},
  [396] = {.lex_state = 67},
  [397] = {.lex_state = 67},
  [398] = {.lex_state = 67},
  [399] = {.lex_state = 67},
  [400] = {.lex_state = 67},
  [401] = {.lex_state = 67},
  [402] = {.lex_state = 67},
  [403] = {.lex_state = 67},
  [404] = {.lex_state = 67},
  [405] = {.lex_state = 67},
  [406] = {.lex_state = 67},
  [407] = {.lex_state = 67},
  [408] = {.lex_state = 67},
  [409] = {.lex_state = 67},
  [410] = {.lex_state = 67},
  [411] = {.lex_state = 67},
  [412] = {.lex_state = 67},
  [413] = {.lex_state = 67},
  [414] = {.lex_state = 67},
  [415] = {.lex_state = 67},
  [416] = {.lex_state = 67},
  [417] = {.lex_state = 67},
  [418] = {.lex_state = 67},
  [419] = {.lex_state = 67},
  [420] = {.lex_state = 67},
  [421] = {.lex_state = 67},
  [422] = {.lex_state = 67},
  [423] = {.lex_state = 67},
  [424] = {.lex_state = 67},
  [425] = {.lex_state = 67},
  [426] = {.lex_state = 67},
  [427] = {.lex_state = 67},
  [428] = {.lex_state = 67},
  [429] = {.lex_state = 67},
  [430] = {.lex_state = 67},
  [431] = {.lex_state = 67},
  [432] = {.lex_state = 67},
  [433] = {.lex_state = 67},
  [434] = {.lex_state = 67},
  [435] = {.lex_state = 67},
  [436] = {.lex_state = 67, .external_lex_state = 2},
  [437] = {.lex_state = 67, .external_lex_state = 2},
  [438] = {.lex_state = 67, .external_lex_state = 2},
  [439] = {.lex_state = 67, .external_lex_state = 2},
  [440] = {.lex_state = 67, .external_lex_state = 2},
  [441] = {.lex_state = 67, .external_lex_state = 2},
  [442] = {.lex_state = 67, .external_lex_state = 2},
  [443] = {.lex_state = 67, .external_lex_state = 2},
  [444] = {.lex_state = 67, .external_lex_state = 2},
  [445] = {.lex_state = 67, .external_lex_state = 2},
  [446] = {.lex_state = 67, .external_lex_state = 2},
  [447] = {.lex_state = 67, .external_lex_state = 2},
  [448] = {.lex_state = 67, .external_lex_state = 2},
  [449] = {.lex_state = 67, .external_lex_state = 2},
  [450] = {.lex_state = 67, .external_lex_state = 2},
  [451] = {.lex_state = 67, .external_lex_state = 2},
  [452] = {.lex_state = 67, .external_lex_state = 2},
  [453] = {.lex_state = 67, .external_lex_state = 2},
  [454] = {.lex_state = 67, .external_lex_state = 2},
  [455] = {.lex_state = 67, .external_lex_state = 2},
  [456] = {.lex_state = 67},
  [457] = {.lex_state = 67},
  [458] = {.lex_state = 67},
  [459] = {.lex_state = 67},
  [460] = {.lex_state = 67},
  [461] = {.lex_state = 67},
  [462] = {.lex_state = 67},
  [463] = {.lex_state = 67},
  [464] = {.lex_state = 67},
  [465] = {.lex_state = 67},
  [466] = {.lex_state = 67},
  [467] = {.lex_state = 67},
  [468] = {.lex_state = 67},
  [469] = {.lex_state = 67},
  [470] = {.lex_state = 67},
  [471] = {.lex_state = 67},
  [472] = {.lex_state = 67},
  [473] = {.lex_state = 67},
  [474] = {.lex_state = 67},
  [475] = {.lex_state = 67},
  [476] = {.lex_state = 67},
  [477] = {.lex_state = 67},
  [478] = {.lex_state = 67},
  [479] = {.lex_state = 67},
  [480] = {.lex_state = 67},
  [481] = {.lex_state = 67},
  [482] = {.lex_state = 67},
  [483] = {.lex_state = 67},
  [484] = {.lex_state = 67},
  [485] = {.lex_state = 67},
  [486] = {.lex_state = 67},
  [487] = {.lex_state = 67},
  [488] = {.lex_state = 67},
  [489] = {.lex_state = 67},
  [490] = {.lex_state = 67},
  [491] = {.lex_state = 67},
  [492] = {.lex_state = 67},
  [493] = {.lex_state = 67},
  [494] = {.lex_state = 67},
  [495] = {.lex_state = 67},
  [496] = {.lex_state = 67},
  [497] = {.lex_state = 67},
  [498] = {.lex_state = 67},
  [499] = {.lex_state = 67},
  [500] = {.lex_state = 67},
  [501] = {.lex_state = 67},
  [502] = {.lex_state = 67},
  [503] = {.lex_state = 67},
  [504] = {.lex_state = 67},
  [505] = {.lex_state = 67},
  [506] = {.lex_state = 67},
  [507] = {.lex_state = 67},
  [508] = {.lex_state = 67},
  [509] = {.lex_state = 67},
  [510] = {.lex_state = 67},
  [511] = {.lex_state = 67},
  [512] = {.lex_state = 67},
  [513] = {.lex_state = 67},
  [514] = {.lex_state = 67},
  [515] = {.lex_state = 67},
  [516] = {.lex_state = 67},
  [517] = {.lex_state = 67},
  [518] = {.lex_state = 67},
  [519] = {.lex_state = 67},
  [520] = {.lex_state = 67},
  [521] = {.lex_state = 67},
  [522] = {.lex_state = 67},
  [523] = {.lex_state = 67},
  [524] = {.lex_state = 67},
  [525] = {.lex_state = 67},
  [526] = {.lex_state = 67},
  [527] = {.lex_state = 67},
  [528] = {.lex_state = 67},
  [529] = {.lex_state = 67},
  [530] = {.lex_state = 67},
  [531] = {.lex_state = 67},
  [532] = {.lex_state = 67},
  [533] = {.lex_state = 67},
  [534] = {.lex_state = 67},
  [535] = {.lex_state = 67},
  [536] = {.lex_state = 67},
  [537] = {.lex_state = 67},
  [538] = {.lex_state = 67},
  [539] = {.lex_state = 67},
  [540] = {.lex_state = 67},
  [541] = {.lex_state = 67},
  [542] = {.lex_state = 67},
  [543] = {.lex_state = 67},
  [544] = {.lex_state = 67},
  [545] = {.lex_state = 67},
  [546] = {.lex_state = 67},
  [547] = {.lex_state = 67},
  [548] = {.lex_state = 67},
  [549] = {.lex_state = 67},
  [550] = {.lex_state = 67},
  [551] = {.lex_state = 67},
  [552] = {.lex_state = 67},
  [553] = {.lex_state = 67},
  [554] = {.lex_state = 67},
  [555] = {.lex_state = 67},
  [556] = {.lex_state = 67},
  [557] = {.lex_state = 67},
  [558] = {.lex_state = 67},
  [559] = {.lex_state = 67},
  [560] = {.lex_state = 67},
  [561] = {.lex_state = 67},
  [562] = {.lex_state = 67},
  [563] = {.lex_state = 67},
  [564] = {.lex_state = 67},
  [565] = {.lex_state = 67},
  [566] = {.lex_state = 67},
  [567] = {.lex_state = 67},
  [568] = {.lex_state = 67},
  [569] = {.lex_state = 67},
  [570] = {.lex_state = 67},
  [571] = {.lex_state = 67},
  [572] = {.lex_state = 67},
  [573] = {.lex_state = 67},
  [574] = {.lex_state = 68},
  [575] = {.lex_state = 68},
  [576] = {.lex_state = 68},
  [577] = {.lex_state = 68},
  [578] = {.lex_state = 68},
  [579] = {.lex_state = 68},
  [580] = {.lex_state = 68},
  [581] = {.lex_state = 68},
  [582] = {.lex_state = 68},
  [583] = {.lex_state = 68},
  [584] = {.lex_state = 68},
  [585] = {.lex_state = 68},
  [586] = {.lex_state = 68},
  [587] = {.lex_state = 68},
  [588] = {.lex_state = 68},
  [589] = {.lex_state = 68},
  [590] = {.lex_state = 68},
  [591] = {.lex_state = 68},
  [592] = {.lex_state = 68},
  [593] = {.lex_state = 68},
  [594] = {.lex_state = 68},
  [595] = {.lex_state = 68},
  [596] = {.lex_state = 68},
  [597] = {.lex_state = 68},
  [598] = {.lex_state = 68},
  [599] = {.lex_state = 68},
  [600] = {.lex_state = 68},
  [601] = {.lex_state = 68, .external_lex_state = 2},
  [602] = {.lex_state = 68},
  [603] = {.lex_state = 68},
  [604] = {.lex_state = 68, .external_lex_state = 2},
  [605] = {.lex_state = 68, .external_lex_state = 2},
  [606] = {.lex_state = 68, .external_lex_state = 2},
  [607] = {.lex_state = 68, .external_lex_state = 2},
  [608] = {.lex_state = 68, .external_lex_state = 2},
  [609] = {.lex_state = 68, .external_lex_state = 2},
  [610] = {.lex_state = 68, .external_lex_state = 2},
  [611] = {.lex_state = 68, .external_lex_state = 2},
  [612] = {.lex_state = 68, .external_lex_state = 2},
  [613] = {.lex_state = 68, .external_lex_state = 2},
  [614] = {.lex_state = 68, .external_lex_state = 2},
  [615] = {.lex_state = 68, .external_lex_state = 2},
  [616] = {.lex_state = 68, .external_lex_state = 2},
  [617] = {.lex_state = 68, .external_lex_state = 2},
  [618] = {.lex_state = 68},
  [619] = {.lex_state = 68, .external_lex_state = 2},
  [620] = {.lex_state = 68, .external_lex_state = 2},
  [621] = {.lex_state = 68, .external_lex_state = 2},
  [622] = {.lex_state = 68},
  [623] = {.lex_state = 68, .external_lex_state = 2},
  [624] = {.lex_state = 68, .external_lex_state = 2},
  [625] = {.lex_state = 68, .external_lex_state = 2},
  [626] = {.lex_state = 68, .external_lex_state = 2},
  [627] = {.lex_state = 68},
  [628] = {.lex_state = 68, .external_lex_state = 2},
  [629] = {.lex_state = 68, .external_lex_state = 2},
  [630] = {.lex_state = 68},
  [631] = {.lex_state = 68},
  [632] = {.lex_state = 68},
  [633] = {.lex_state = 68, .external_lex_state = 2},
  [634] = {.lex_state = 68},
  [635] = {.lex_state = 68},
  [636] = {.lex_state = 68, .external_lex_state = 2},
  [637] = {.lex_state = 68},
  [638] = {.lex_state = 68},
  [639] = {.lex_state = 68},
  [640] = {.lex_state = 68},
  [641] = {.lex_state = 68},
  [642] = {.lex_state = 8},
  [643] = {.lex_state = 70},
  [644] = {.lex_state = 70},
  [645] = {.lex_state = 9},
  [646] = {.lex_state = 11},
  [647] = {.lex_state = 11},
  [648] = {.lex_state = 11},
  [649] = {.lex_state = 18},
  [650] = {.lex_state = 11},
  [651] = {.lex_state = 18},
  [652] = {.lex_state = 11},
  [653] = {.lex_state = 9},
  [654] = {.lex_state = 9},
  [655] = {.lex_state = 9},
  [656] = {.lex_state = 9},
  [657] = {.lex_state = 9},
  [658] = {.lex_state = 9},
  [659] = {.lex_state = 9},
  [660] = {.lex_state = 9},
  [661] = {.lex_state = 9},
  [662] = {.lex_state = 9},
  [663] = {.lex_state = 11},
  [664] = {.lex_state = 18},
  [665] = {.lex_state = 9},
  [666] = {.lex_state = 9},
  [667] = {.lex_state = 18},
  [668] = {.lex_state = 15},
  [669] = {.lex_state = 15},
  [670] = {.lex_state = 9},
  [671] = {.lex_state = 9},
  [672] = {.lex_state = 9},
  [673] = {.lex_state = 9},
  [674] = {.lex_state = 18},
  [675] = {.lex_state = 9},
  [676] = {.lex_state = 9},
  [677] = {.lex_state = 18},
  [678] = {.lex_state = 9},
  [679] = {.lex_state = 9},
  [680] = {.lex_state = 9},
  [681] = {.lex_state = 9},
  [682] = {.lex_state = 11},
  [683] = {.lex_state = 9},
  [684] = {.lex_state = 11},
  [685] = {.lex_state = 11},
  [686] = {.lex_state = 11},
  [687] = {.lex_state = 16},
  [688] = {.lex_state = 11},
  [689] = {.lex_state = 11},
  [690] = {.lex_state = 9},
  [691] = {.lex_state = 11},
  [692] = {.lex_state = 9},
  [693] = {.lex_state = 11},
  [694] = {.lex_state = 11},
  [695] = {.lex_state = 11},
  [696] = {.lex_state = 16},
  [697] = {.lex_state = 16},
  [698] = {.lex_state = 11},
  [699] = {.lex_state = 11},
  [700] = {.lex_state = 16},
  [701] = {.lex_state = 11},
  [702] = {.lex_state = 11},
  [703] = {.lex_state = 11},
  [704] = {.lex_state = 11},
  [705] = {.lex_state = 18},
  [706] = {.lex_state = 11},
  [707] = {.lex_state = 16},
  [708] = {.lex_state = 11},
  [709] = {.lex_state = 11},
  [710] = {.lex_state = 11},
  [711] = {.lex_state = 11},
  [712] = {.lex_state = 11},
  [713] = {.lex_state = 11},
  [714] = {.lex_state = 11},
  [715] = {.lex_state = 11},
  [716] = {.lex_state = 11},
  [717] = {.lex_state = 11},
  [718] = {.lex_state = 11},
  [719] = {.lex_state = 11},
  [720] = {.lex_state = 11},
  [721] = {.lex_state = 11},
  [722] = {.lex_state = 11},
  [723] = {.lex_state = 11},
  [724] = {.lex_state = 11},
  [725] = {.lex_state = 11},
  [726] = {.lex_state = 11},
  [727] = {.lex_state = 11},
  [728] = {.lex_state = 11},
  [729] = {.lex_state = 16},
  [730] = {.lex_state = 11},
  [731] = {.lex_state = 11},
  [732] = {.lex_state = 11},
  [733] = {.lex_state = 11},
  [734] = {.lex_state = 11},
  [735] = {.lex_state = 11},
  [736] = {.lex_state = 11},
  [737] = {.lex_state = 11},
  [738] = {.lex_state = 11},
  [739] = {.lex_state = 11},
  [740] = {.lex_state = 11},
  [741] = {.lex_state = 11},
  [742] = {.lex_state = 11},
  [743] = {.lex_state = 11},
  [744] = {.lex_state = 11},
  [745] = {.lex_state = 11},
  [746] = {.lex_state = 11},
  [747] = {.lex_state = 11},
  [748] = {.lex_state = 11},
  [749] = {.lex_state = 11},
  [750] = {.lex_state = 11},
  [751] = {.lex_state = 11},
  [752] = {.lex_state = 11},
  [753] = {.lex_state = 11},
  [754] = {.lex_state = 11},
  [755] = {.lex_state = 11},
  [756] = {.lex_state = 11},
  [757] = {.lex_state = 11},
  [758] = {.lex_state = 11},
  [759] = {.lex_state = 11},
  [760] = {.lex_state = 11},
  [761] = {.lex_state = 11},
  [762] = {.lex_state = 11},
  [763] = {.lex_state = 11},
  [764] = {.lex_state = 9, .external_lex_state = 2},
  [765] = {.lex_state = 9, .external_lex_state = 2},
  [766] = {.lex_state = 11},
  [767] = {.lex_state = 11},
  [768] = {.lex_state = 11},
  [769] = {.lex_state = 9, .external_lex_state = 2},
  [770] = {.lex_state = 11},
  [771] = {.lex_state = 11},
  [772] = {.lex_state = 11, .external_lex_state = 2},
  [773] = {.lex_state = 9, .external_lex_state = 2},
  [774] = {.lex_state = 6},
  [775] = {.lex_state = 13},
  [776] = {.lex_state = 9, .external_lex_state = 2},
  [777] = {.lex_state = 11, .external_lex_state = 2},
  [778] = {.lex_state = 11, .external_lex_state = 2},
  [779] = {.lex_state = 9, .external_lex_state = 2},
  [780] = {.lex_state = 13},
  [781] = {.lex_state = 9, .external_lex_state = 2},
  [782] = {.lex_state = 11, .external_lex_state = 2},
  [783] = {.lex_state = 11},
  [784] = {.lex_state = 9, .external_lex_state = 2},
  [785] = {.lex_state = 9, .external_lex_state = 2},
  [786] = {.lex_state = 9, .external_lex_state = 2},
  [787] = {.lex_state = 9, .external_lex_state = 2},
  [788] = {.lex_state = 9, .external_lex_state = 2},
  [789] = {.lex_state = 9, .external_lex_state = 2},
  [790] = {.lex_state = 9, .external_lex_state = 2},
  [791] = {.lex_state = 9, .external_lex_state = 2},
  [792] = {.lex_state = 9, .external_lex_state = 2},
  [793] = {.lex_state = 6},
  [794] = {.lex_state = 9, .external_lex_state = 2},
  [795] = {.lex_state = 11},
  [796] = {.lex_state = 11, .external_lex_state = 2},
  [797] = {.lex_state = 9, .external_lex_state = 2},
  [798] = {.lex_state = 11, .external_lex_state = 2},
  [799] = {.lex_state = 9, .external_lex_state = 2},
  [800] = {.lex_state = 9, .external_lex_state = 2},
  [801] = {.lex_state = 9, .external_lex_state = 2},
  [802] = {.lex_state = 9, .external_lex_state = 2},
  [803] = {.lex_state = 9, .external_lex_state = 2},
  [804] = {.lex_state = 9, .external_lex_state = 2},
  [805] = {.lex_state = 11, .external_lex_state = 2},
  [806] = {.lex_state = 16},
  [807] = {.lex_state = 11, .external_lex_state = 2},
  [808] = {.lex_state = 11, .external_lex_state = 2},
  [809] = {.lex_state = 11, .external_lex_state = 2},
  [810] = {.lex_state = 11, .external_lex_state = 2},
  [811] = {.lex_state = 16},
  [812] = {.lex_state = 11, .external_lex_state = 2},
  [813] = {.lex_state = 11, .external_lex_state = 2},
  [814] = {.lex_state = 16},
  [815] = {.lex_state = 11, .external_lex_state = 2},
  [816] = {.lex_state = 11, .external_lex_state = 2},
  [817] = {.lex_state = 9, .external_lex_state = 2},
  [818] = {.lex_state = 16},
  [819] = {.lex_state = 16},
  [820] = {.lex_state = 9, .external_lex_state = 2},
  [821] = {.lex_state = 11, .external_lex_state = 2},
  [822] = {.lex_state = 11, .external_lex_state = 2},
  [823] = {.lex_state = 13},
  [824] = {.lex_state = 11, .external_lex_state = 2},
  [825] = {.lex_state = 11, .external_lex_state = 2},
  [826] = {.lex_state = 11, .external_lex_state = 2},
  [827] = {.lex_state = 13},
  [828] = {.lex_state = 16},
  [829] = {.lex_state = 16},
  [830] = {.lex_state = 11, .external_lex_state = 2},
  [831] = {.lex_state = 11, .external_lex_state = 2},
  [832] = {.lex_state = 16},
  [833] = {.lex_state = 16},
  [834] = {.lex_state = 11, .external_lex_state = 2},
  [835] = {.lex_state = 11, .external_lex_state = 2},
  [836] = {.lex_state = 11, .external_lex_state = 2},
  [837] = {.lex_state = 11, .external_lex_state = 2},
  [838] = {.lex_state = 11, .external_lex_state = 2},
  [839] = {.lex_state = 11, .external_lex_state = 2},
  [840] = {.lex_state = 11, .external_lex_state = 2},
  [841] = {.lex_state = 11, .external_lex_state = 2},
  [842] = {.lex_state = 11, .external_lex_state = 2},
  [843] = {.lex_state = 16},
  [844] = {.lex_state = 16},
  [845] = {.lex_state = 11, .external_lex_state = 2},
  [846] = {.lex_state = 11, .external_lex_state = 2},
  [847] = {.lex_state = 16},
  [848] = {.lex_state = 16},
  [849] = {.lex_state = 11, .external_lex_state = 2},
  [850] = {.lex_state = 11, .external_lex_state = 2},
  [851] = {.lex_state = 11, .external_lex_state = 2},
  [852] = {.lex_state = 11, .external_lex_state = 2},
  [853] = {.lex_state = 11, .external_lex_state = 2},
  [854] = {.lex_state = 16},
  [855] = {.lex_state = 16},
  [856] = {.lex_state = 11, .external_lex_state = 2},
  [857] = {.lex_state = 11, .external_lex_state = 2},
  [858] = {.lex_state = 11, .external_lex_state = 2},
  [859] = {.lex_state = 11, .external_lex_state = 2},
  [860] = {.lex_state = 11, .external_lex_state = 2},
  [861] = {.lex_state = 11, .external_lex_state = 2},
  [862] = {.lex_state = 11},
  [863] = {.lex_state = 11, .external_lex_state = 2},
  [864] = {.lex_state = 11, .external_lex_state = 2},
  [865] = {.lex_state = 11, .external_lex_state = 2},
  [866] = {.lex_state = 11, .external_lex_state = 2},
  [867] = {.lex_state = 11, .external_lex_state = 2},
  [868] = {.lex_state = 11, .external_lex_state = 2},
  [869] = {.lex_state = 11, .external_lex_state = 2},
  [870] = {.lex_state = 11, .external_lex_state = 2},
  [871] = {.lex_state = 11, .external_lex_state = 2},
  [872] = {.lex_state = 11},
  [873] = {.lex_state = 11, .external_lex_state = 2},
  [874] = {.lex_state = 11, .external_lex_state = 2},
  [875] = {.lex_state = 11, .external_lex_state = 2},
  [876] = {.lex_state = 11, .external_lex_state = 2},
  [877] = {.lex_state = 11, .external_lex_state = 2},
  [878] = {.lex_state = 11, .external_lex_state = 2},
  [879] = {.lex_state = 11, .external_lex_state = 2},
  [880] = {.lex_state = 11, .external_lex_state = 2},
  [881] = {.lex_state = 11, .external_lex_state = 2},
  [882] = {.lex_state = 11, .external_lex_state = 2},
  [883] = {.lex_state = 11, .external_lex_state = 2},
  [884] = {.lex_state = 11, .external_lex_state = 2},
  [885] = {.lex_state = 11, .external_lex_state = 2},
  [886] = {.lex_state = 11, .external_lex_state = 2},
  [887] = {.lex_state = 11, .external_lex_state = 2},
  [888] = {.lex_state = 11, .external_lex_state = 2},
  [889] = {.lex_state = 11, .external_lex_state = 2},
  [890] = {.lex_state = 11, .external_lex_state = 2},
  [891] = {.lex_state = 11, .external_lex_state = 2},
  [892] = {.lex_state = 11, .external_lex_state = 2},
  [893] = {.lex_state = 11, .external_lex_state = 2},
  [894] = {.lex_state = 11, .external_lex_state = 2},
  [895] = {.lex_state = 11, .external_lex_state = 2},
  [896] = {.lex_state = 11, .external_lex_state = 2},
  [897] = {.lex_state = 11, .external_lex_state = 2},
  [898] = {.lex_state = 11, .external_lex_state = 2},
  [899] = {.lex_state = 11, .external_lex_state = 2},
  [900] = {.lex_state = 11, .external_lex_state = 2},
  [901] = {.lex_state = 11, .external_lex_state = 2},
  [902] = {.lex_state = 11, .external_lex_state = 2},
  [903] = {.lex_state = 11, .external_lex_state = 2},
  [904] = {.lex_state = 11, .external_lex_state = 2},
  [905] = {.lex_state = 11, .external_lex_state = 2},
  [906] = {.lex_state = 13},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 13},
  [909] = {.lex_state = 13},
  [910] = {.lex_state = 13},
  [911] = {.lex_state = 13},
  [912] = {.lex_state = 13},
  [913] = {.lex_state = 13},
  [914] = {.lex_state = 13},
  [915] = {.lex_state = 13},
  [916] = {.lex_state = 13},
  [917] = {.lex_state = 13},
  [918] = {.lex_state = 13},
  [919] = {.lex_state = 13},
  [920] = {.lex_state = 13},
  [921] = {.lex_state = 13},
  [922] = {.lex_state = 13},
  [923] = {.lex_state = 13},
  [924] = {.lex_state = 13},
  [925] = {.lex_state = 13},
  [926] = {.lex_state = 13},
  [927] = {.lex_state = 13},
  [928] = {.lex_state = 13},
  [929] = {.lex_state = 13},
  [930] = {.lex_state = 13},
  [931] = {.lex_state = 13},
  [932] = {.lex_state = 13},
  [933] = {.lex_state = 13},
  [934] = {.lex_state = 13},
  [935] = {.lex_state = 13},
  [936] = {.lex_state = 13},
  [937] = {.lex_state = 13},
  [938] = {.lex_state = 13},
  [939] = {.lex_state = 13},
  [940] = {.lex_state = 13},
  [941] = {.lex_state = 13},
  [942] = {.lex_state = 13},
  [943] = {.lex_state = 13},
  [944] = {.lex_state = 13},
  [945] = {.lex_state = 20},
  [946] = {.lex_state = 13},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 13},
  [949] = {.lex_state = 13},
  [950] = {.lex_state = 13},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 13},
  [953] = {.lex_state = 13},
  [954] = {.lex_state = 13},
  [955] = {.lex_state = 13},
  [956] = {.lex_state = 13},
  [957] = {.lex_state = 13},
  [958] = {.lex_state = 13},
  [959] = {.lex_state = 13},
  [960] = {.lex_state = 13},
  [961] = {.lex_state = 13},
  [962] = {.lex_state = 13},
  [963] = {.lex_state = 13},
  [964] = {.lex_state = 13},
  [965] = {.lex_state = 13},
  [966] = {.lex_state = 13},
  [967] = {.lex_state = 13},
  [968] = {.lex_state = 13},
  [969] = {.lex_state = 13},
  [970] = {.lex_state = 13},
  [971] = {.lex_state = 13},
  [972] = {.lex_state = 13, .external_lex_state = 2},
  [973] = {.lex_state = 13, .external_lex_state = 2},
  [974] = {.lex_state = 13},
  [975] = {.lex_state = 13},
  [976] = {.lex_state = 13},
  [977] = {.lex_state = 13},
  [978] = {.lex_state = 13},
  [979] = {.lex_state = 13},
  [980] = {.lex_state = 13},
  [981] = {.lex_state = 13},
  [982] = {.lex_state = 13},
  [983] = {.lex_state = 13},
  [984] = {.lex_state = 13},
  [985] = {.lex_state = 13},
  [986] = {.lex_state = 13},
  [987] = {.lex_state = 13},
  [988] = {.lex_state = 13},
  [989] = {.lex_state = 13},
  [990] = {.lex_state = 13},
  [991] = {.lex_state = 13},
  [992] = {.lex_state = 13},
  [993] = {.lex_state = 13},
  [994] = {.lex_state = 13},
  [995] = {.lex_state = 13},
  [996] = {.lex_state = 13},
  [997] = {.lex_state = 13},
  [998] = {.lex_state = 13},
  [999] = {.lex_state = 13},
  [1000] = {.lex_state = 13},
  [1001] = {.lex_state = 13},
  [1002] = {.lex_state = 13},
  [1003] = {.lex_state = 13},
  [1004] = {.lex_state = 13},
  [1005] = {.lex_state = 13},
  [1006] = {.lex_state = 13},
  [1007] = {.lex_state = 13},
  [1008] = {.lex_state = 13},
  [1009] = {.lex_state = 13},
  [1010] = {.lex_state = 13},
  [1011] = {.lex_state = 13},
  [1012] = {.lex_state = 13},
  [1013] = {.lex_state = 13},
  [1014] = {.lex_state = 13},
  [1015] = {.lex_state = 13},
  [1016] = {.lex_state = 13},
  [1017] = {.lex_state = 13},
  [1018] = {.lex_state = 13},
  [1019] = {.lex_state = 13},
  [1020] = {.lex_state = 13},
  [1021] = {.lex_state = 13},
  [1022] = {.lex_state = 13},
  [1023] = {.lex_state = 13},
  [1024] = {.lex_state = 13},
  [1025] = {.lex_state = 13},
  [1026] = {.lex_state = 13},
  [1027] = {.lex_state = 13},
  [1028] = {.lex_state = 13},
  [1029] = {.lex_state = 13},
  [1030] = {.lex_state = 13},
  [1031] = {.lex_state = 13},
  [1032] = {.lex_state = 13},
  [1033] = {.lex_state = 13},
  [1034] = {.lex_state = 13},
  [1035] = {.lex_state = 13},
  [1036] = {.lex_state = 13},
  [1037] = {.lex_state = 70},
  [1038] = {.lex_state = 13},
  [1039] = {.lex_state = 13, .external_lex_state = 2},
  [1040] = {.lex_state = 13, .external_lex_state = 2},
  [1041] = {.lex_state = 13, .external_lex_state = 2},
  [1042] = {.lex_state = 70},
  [1043] = {.lex_state = 13, .external_lex_state = 2},
  [1044] = {.lex_state = 13, .external_lex_state = 2},
  [1045] = {.lex_state = 13, .external_lex_state = 2},
  [1046] = {.lex_state = 13, .external_lex_state = 2},
  [1047] = {.lex_state = 13, .external_lex_state = 2},
  [1048] = {.lex_state = 13, .external_lex_state = 2},
  [1049] = {.lex_state = 13, .external_lex_state = 2},
  [1050] = {.lex_state = 13, .external_lex_state = 2},
  [1051] = {.lex_state = 13, .external_lex_state = 2},
  [1052] = {.lex_state = 13, .external_lex_state = 2},
  [1053] = {.lex_state = 13, .external_lex_state = 2},
  [1054] = {.lex_state = 13, .external_lex_state = 2},
  [1055] = {.lex_state = 13, .external_lex_state = 2},
  [1056] = {.lex_state = 13, .external_lex_state = 2},
  [1057] = {.lex_state = 70},
  [1058] = {.lex_state = 13, .external_lex_state = 2},
  [1059] = {.lex_state = 13, .external_lex_state = 2},
  [1060] = {.lex_state = 13, .external_lex_state = 2},
  [1061] = {.lex_state = 13, .external_lex_state = 2},
  [1062] = {.lex_state = 13, .external_lex_state = 2},
  [1063] = {.lex_state = 13, .external_lex_state = 2},
  [1064] = {.lex_state = 13, .external_lex_state = 2},
  [1065] = {.lex_state = 13, .external_lex_state = 2},
  [1066] = {.lex_state = 70},
  [1067] = {.lex_state = 13, .external_lex_state = 2},
  [1068] = {.lex_state = 13, .external_lex_state = 2},
  [1069] = {.lex_state = 13, .external_lex_state = 2},
  [1070] = {.lex_state = 13, .external_lex_state = 2},
  [1071] = {.lex_state = 13, .external_lex_state = 2},
  [1072] = {.lex_state = 13, .external_lex_state = 2},
  [1073] = {.lex_state = 13, .external_lex_state = 2},
  [1074] = {.lex_state = 13, .external_lex_state = 2},
  [1075] = {.lex_state = 13, .external_lex_state = 2},
  [1076] = {.lex_state = 13, .external_lex_state = 2},
  [1077] = {.lex_state = 13, .external_lex_state = 2},
  [1078] = {.lex_state = 13, .external_lex_state = 2},
  [1079] = {.lex_state = 13, .external_lex_state = 2},
  [1080] = {.lex_state = 13, .external_lex_state = 2},
  [1081] = {.lex_state = 13, .external_lex_state = 2},
  [1082] = {.lex_state = 13, .external_lex_state = 2},
  [1083] = {.lex_state = 13, .external_lex_state = 2},
  [1084] = {.lex_state = 13, .external_lex_state = 2},
  [1085] = {.lex_state = 13, .external_lex_state = 2},
  [1086] = {.lex_state = 13, .external_lex_state = 2},
  [1087] = {.lex_state = 13, .external_lex_state = 2},
  [1088] = {.lex_state = 13, .external_lex_state = 2},
  [1089] = {.lex_state = 13, .external_lex_state = 2},
  [1090] = {.lex_state = 13, .external_lex_state = 2},
  [1091] = {.lex_state = 13, .external_lex_state = 2},
  [1092] = {.lex_state = 13, .external_lex_state = 2},
  [1093] = {.lex_state = 13, .external_lex_state = 2},
  [1094] = {.lex_state = 13, .external_lex_state = 2},
  [1095] = {.lex_state = 13, .external_lex_state = 2},
  [1096] = {.lex_state = 13, .external_lex_state = 2},
  [1097] = {.lex_state = 13, .external_lex_state = 2},
  [1098] = {.lex_state = 13, .external_lex_state = 2},
  [1099] = {.lex_state = 13, .external_lex_state = 2},
  [1100] = {.lex_state = 13, .external_lex_state = 2},
  [1101] = {.lex_state = 13, .external_lex_state = 2},
  [1102] = {.lex_state = 13, .external_lex_state = 2},
  [1103] = {.lex_state = 13, .external_lex_state = 2},
  [1104] = {.lex_state = 13, .external_lex_state = 2},
  [1105] = {.lex_state = 13, .external_lex_state = 2},
  [1106] = {.lex_state = 13, .external_lex_state = 2},
  [1107] = {.lex_state = 13, .external_lex_state = 2},
  [1108] = {.lex_state = 13, .external_lex_state = 2},
  [1109] = {.lex_state = 13, .external_lex_state = 2},
  [1110] = {.lex_state = 13, .external_lex_state = 2},
  [1111] = {.lex_state = 13, .external_lex_state = 2},
  [1112] = {.lex_state = 13, .external_lex_state = 2},
  [1113] = {.lex_state = 13, .external_lex_state = 2},
  [1114] = {.lex_state = 13, .external_lex_state = 2},
  [1115] = {.lex_state = 13, .external_lex_state = 2},
  [1116] = {.lex_state = 13, .external_lex_state = 2},
  [1117] = {.lex_state = 13, .external_lex_state = 2},
  [1118] = {.lex_state = 13, .external_lex_state = 2},
  [1119] = {.lex_state = 13, .external_lex_state = 2},
  [1120] = {.lex_state = 13, .external_lex_state = 2},
  [1121] = {.lex_state = 13, .external_lex_state = 2},
  [1122] = {.lex_state = 13, .external_lex_state = 2},
  [1123] = {.lex_state = 13, .external_lex_state = 2},
  [1124] = {.lex_state = 13, .external_lex_state = 2},
  [1125] = {.lex_state = 13, .external_lex_state = 2},
  [1126] = {.lex_state = 13, .external_lex_state = 2},
  [1127] = {.lex_state = 13, .external_lex_state = 2},
  [1128] = {.lex_state = 13, .external_lex_state = 2},
  [1129] = {.lex_state = 13, .external_lex_state = 2},
  [1130] = {.lex_state = 13, .external_lex_state = 2},
  [1131] = {.lex_state = 13, .external_lex_state = 2},
  [1132] = {.lex_state = 13, .external_lex_state = 2},
  [1133] = {.lex_state = 13, .external_lex_state = 2},
  [1134] = {.lex_state = 13, .external_lex_state = 2},
  [1135] = {.lex_state = 13, .external_lex_state = 2},
  [1136] = {.lex_state = 13, .external_lex_state = 2},
  [1137] = {.lex_state = 70},
  [1138] = {.lex_state = 13, .external_lex_state = 2},
  [1139] = {.lex_state = 70},
  [1140] = {.lex_state = 13, .external_lex_state = 2},
  [1141] = {.lex_state = 70},
  [1142] = {.lex_state = 13, .external_lex_state = 2},
  [1143] = {.lex_state = 13, .external_lex_state = 2},
  [1144] = {.lex_state = 13},
  [1145] = {.lex_state = 13},
  [1146] = {.lex_state = 13},
  [1147] = {.lex_state = 13},
  [1148] = {.lex_state = 13},
  [1149] = {.lex_state = 13},
  [1150] = {.lex_state = 13},
  [1151] = {.lex_state = 13},
  [1152] = {.lex_state = 13},
  [1153] = {.lex_state = 13},
  [1154] = {.lex_state = 13},
  [1155] = {.lex_state = 13},
  [1156] = {.lex_state = 13},
  [1157] = {.lex_state = 13},
  [1158] = {.lex_state = 13},
  [1159] = {.lex_state = 13},
  [1160] = {.lex_state = 13},
  [1161] = {.lex_state = 13},
  [1162] = {.lex_state = 13},
  [1163] = {.lex_state = 13},
  [1164] = {.lex_state = 13},
  [1165] = {.lex_state = 13},
  [1166] = {.lex_state = 13},
  [1167] = {.lex_state = 13},
  [1168] = {.lex_state = 13},
  [1169] = {.lex_state = 13},
  [1170] = {.lex_state = 13},
  [1171] = {.lex_state = 13},
  [1172] = {.lex_state = 13},
  [1173] = {.lex_state = 13},
  [1174] = {.lex_state = 13},
  [1175] = {.lex_state = 13},
  [1176] = {.lex_state = 13},
  [1177] = {.lex_state = 13},
  [1178] = {.lex_state = 13},
  [1179] = {.lex_state = 13},
  [1180] = {.lex_state = 13},
  [1181] = {.lex_state = 13},
  [1182] = {.lex_state = 13},
  [1183] = {.lex_state = 13, .external_lex_state = 2},
  [1184] = {.lex_state = 13, .external_lex_state = 2},
  [1185] = {.lex_state = 13, .external_lex_state = 2},
  [1186] = {.lex_state = 13},
  [1187] = {.lex_state = 13, .external_lex_state = 2},
  [1188] = {.lex_state = 13, .external_lex_state = 2},
  [1189] = {.lex_state = 13},
  [1190] = {.lex_state = 19},
  [1191] = {.lex_state = 19},
  [1192] = {.lex_state = 70},
  [1193] = {.lex_state = 19},
  [1194] = {.lex_state = 13},
  [1195] = {.lex_state = 13, .external_lex_state = 2},
  [1196] = {.lex_state = 13},
  [1197] = {.lex_state = 19},
  [1198] = {.lex_state = 13},
  [1199] = {.lex_state = 13},
  [1200] = {.lex_state = 19},
  [1201] = {.lex_state = 13},
  [1202] = {.lex_state = 13},
  [1203] = {.lex_state = 13},
  [1204] = {.lex_state = 13, .external_lex_state = 2},
  [1205] = {.lex_state = 13},
  [1206] = {.lex_state = 13, .external_lex_state = 2},
  [1207] = {.lex_state = 13, .external_lex_state = 2},
  [1208] = {.lex_state = 13},
  [1209] = {.lex_state = 13},
  [1210] = {.lex_state = 13},
  [1211] = {.lex_state = 13},
  [1212] = {.lex_state = 13},
  [1213] = {.lex_state = 70},
  [1214] = {.lex_state = 13, .external_lex_state = 2},
  [1215] = {.lex_state = 19},
  [1216] = {.lex_state = 13},
  [1217] = {.lex_state = 13},
  [1218] = {.lex_state = 13},
  [1219] = {.lex_state = 13},
  [1220] = {.lex_state = 13},
  [1221] = {.lex_state = 13},
  [1222] = {.lex_state = 13, .external_lex_state = 2},
  [1223] = {.lex_state = 19},
  [1224] = {.lex_state = 13},
  [1225] = {.lex_state = 19},
  [1226] = {.lex_state = 13},
  [1227] = {.lex_state = 13},
  [1228] = {.lex_state = 13},
  [1229] = {.lex_state = 13},
  [1230] = {.lex_state = 13},
  [1231] = {.lex_state = 13},
  [1232] = {.lex_state = 13},
  [1233] = {.lex_state = 13},
  [1234] = {.lex_state = 13},
  [1235] = {.lex_state = 19},
  [1236] = {.lex_state = 13, .external_lex_state = 2},
  [1237] = {.lex_state = 13},
  [1238] = {.lex_state = 13},
  [1239] = {.lex_state = 13},
  [1240] = {.lex_state = 13},
  [1241] = {.lex_state = 13, .external_lex_state = 2},
  [1242] = {.lex_state = 13},
  [1243] = {.lex_state = 13},
  [1244] = {.lex_state = 13},
  [1245] = {.lex_state = 13},
  [1246] = {.lex_state = 13},
  [1247] = {.lex_state = 70},
  [1248] = {.lex_state = 13},
  [1249] = {.lex_state = 13},
  [1250] = {.lex_state = 13},
  [1251] = {.lex_state = 13},
  [1252] = {.lex_state = 13},
  [1253] = {.lex_state = 13},
  [1254] = {.lex_state = 13},
  [1255] = {.lex_state = 13},
  [1256] = {.lex_state = 13},
  [1257] = {.lex_state = 13},
  [1258] = {.lex_state = 13},
  [1259] = {.lex_state = 13},
  [1260] = {.lex_state = 13},
  [1261] = {.lex_state = 13},
  [1262] = {.lex_state = 13},
  [1263] = {.lex_state = 13},
  [1264] = {.lex_state = 13},
  [1265] = {.lex_state = 13},
  [1266] = {.lex_state = 13},
  [1267] = {.lex_state = 13},
  [1268] = {.lex_state = 13},
  [1269] = {.lex_state = 13},
  [1270] = {.lex_state = 13},
  [1271] = {.lex_state = 13},
  [1272] = {.lex_state = 13},
  [1273] = {.lex_state = 13},
  [1274] = {.lex_state = 13},
  [1275] = {.lex_state = 13},
  [1276] = {.lex_state = 13},
  [1277] = {.lex_state = 13},
  [1278] = {.lex_state = 13},
  [1279] = {.lex_state = 13},
  [1280] = {.lex_state = 13},
  [1281] = {.lex_state = 13},
  [1282] = {.lex_state = 13},
  [1283] = {.lex_state = 13},
  [1284] = {.lex_state = 13},
  [1285] = {.lex_state = 13},
  [1286] = {.lex_state = 13},
  [1287] = {.lex_state = 13},
  [1288] = {.lex_state = 13},
  [1289] = {.lex_state = 13},
  [1290] = {.lex_state = 13},
  [1291] = {.lex_state = 13},
  [1292] = {.lex_state = 13},
  [1293] = {.lex_state = 13},
  [1294] = {.lex_state = 13},
  [1295] = {.lex_state = 13},
  [1296] = {.lex_state = 13},
  [1297] = {.lex_state = 13},
  [1298] = {.lex_state = 13},
  [1299] = {.lex_state = 13},
  [1300] = {.lex_state = 13},
  [1301] = {.lex_state = 13},
  [1302] = {.lex_state = 13},
  [1303] = {.lex_state = 13},
  [1304] = {.lex_state = 13},
  [1305] = {.lex_state = 13},
  [1306] = {.lex_state = 13},
  [1307] = {.lex_state = 13},
  [1308] = {.lex_state = 13},
  [1309] = {.lex_state = 13},
  [1310] = {.lex_state = 13},
  [1311] = {.lex_state = 19},
  [1312] = {.lex_state = 19},
  [1313] = {.lex_state = 70},
  [1314] = {.lex_state = 70},
  [1315] = {.lex_state = 70},
  [1316] = {.lex_state = 19},
  [1317] = {.lex_state = 19},
  [1318] = {.lex_state = 19},
  [1319] = {.lex_state = 70},
  [1320] = {.lex_state = 70},
  [1321] = {.lex_state = 70},
  [1322] = {.lex_state = 70},
  [1323] = {.lex_state = 18},
  [1324] = {.lex_state = 18},
  [1325] = {.lex_state = 18},
  [1326] = {.lex_state = 13},
  [1327] = {.lex_state = 13},
  [1328] = {.lex_state = 13},
  [1329] = {.lex_state = 18},
  [1330] = {.lex_state = 13},
  [1331] = {.lex_state = 13},
  [1332] = {.lex_state = 18},
  [1333] = {.lex_state = 18},
  [1334] = {.lex_state = 13},
  [1335] = {.lex_state = 13},
  [1336] = {.lex_state = 13},
  [1337] = {.lex_state = 13},
  [1338] = {.lex_state = 13},
  [1339] = {.lex_state = 13},
  [1340] = {.lex_state = 13},
  [1341] = {.lex_state = 13},
  [1342] = {.lex_state = 13},
  [1343] = {.lex_state = 13},
  [1344] = {.lex_state = 13},
  [1345] = {.lex_state = 13},
  [1346] = {.lex_state = 68},
  [1347] = {.lex_state = 68},
  [1348] = {.lex_state = 13},
  [1349] = {.lex_state = 68},
  [1350] = {.lex_state = 13},
  [1351] = {.lex_state = 8},
  [1352] = {.lex_state = 8},
  [1353] = {.lex_state = 19},
  [1354] = {.lex_state = 8},
  [1355] = {.lex_state = 19},
  [1356] = {.lex_state = 8},
  [1357] = {.lex_state = 16},
  [1358] = {.lex_state = 17},
  [1359] = {.lex_state = 8},
  [1360] = {.lex_state = 3, .external_lex_state = 3},
  [1361] = {.lex_state = 19},
  [1362] = {.lex_state = 3, .external_lex_state = 3},
  [1363] = {.lex_state = 19},
  [1364] = {.lex_state = 19},
  [1365] = {.lex_state = 19},
  [1366] = {.lex_state = 3, .external_lex_state = 3},
  [1367] = {.lex_state = 19},
  [1368] = {.lex_state = 19},
  [1369] = {.lex_state = 19},
  [1370] = {.lex_state = 3, .external_lex_state = 3},
  [1371] = {.lex_state = 19},
  [1372] = {.lex_state = 19},
  [1373] = {.lex_state = 19},
  [1374] = {.lex_state = 3, .external_lex_state = 3},
  [1375] = {.lex_state = 19},
  [1376] = {.lex_state = 19},
  [1377] = {.lex_state = 19},
  [1378] = {.lex_state = 19},
  [1379] = {.lex_state = 19},
  [1380] = {.lex_state = 19},
  [1381] = {.lex_state = 19},
  [1382] = {.lex_state = 19},
  [1383] = {.lex_state = 19},
  [1384] = {.lex_state = 19},
  [1385] = {.lex_state = 3, .external_lex_state = 4},
  [1386] = {.lex_state = 19},
  [1387] = {.lex_state = 19},
  [1388] = {.lex_state = 19},
  [1389] = {.lex_state = 8},
  [1390] = {.lex_state = 8},
  [1391] = {.lex_state = 8},
  [1392] = {.lex_state = 19},
  [1393] = {.lex_state = 19},
  [1394] = {.lex_state = 19},
  [1395] = {.lex_state = 19},
  [1396] = {.lex_state = 19},
  [1397] = {.lex_state = 9, .external_lex_state = 5},
  [1398] = {.lex_state = 19},
  [1399] = {.lex_state = 19},
  [1400] = {.lex_state = 9, .external_lex_state = 6},
  [1401] = {.lex_state = 19},
  [1402] = {.lex_state = 19},
  [1403] = {.lex_state = 19},
  [1404] = {.lex_state = 9, .external_lex_state = 5},
  [1405] = {.lex_state = 9, .external_lex_state = 6},
  [1406] = {.lex_state = 19},
  [1407] = {.lex_state = 19},
  [1408] = {.lex_state = 19},
  [1409] = {.lex_state = 19},
  [1410] = {.lex_state = 70},
  [1411] = {.lex_state = 19},
  [1412] = {.lex_state = 19},
  [1413] = {.lex_state = 19},
  [1414] = {.lex_state = 19},
  [1415] = {.lex_state = 19},
  [1416] = {.lex_state = 19},
  [1417] = {.lex_state = 8},
  [1418] = {.lex_state = 9, .external_lex_state = 6},
  [1419] = {.lex_state = 19},
  [1420] = {.lex_state = 19},
  [1421] = {.lex_state = 19},
  [1422] = {.lex_state = 9, .external_lex_state = 6},
  [1423] = {.lex_state = 19},
  [1424] = {.lex_state = 9, .external_lex_state = 6},
  [1425] = {.lex_state = 19},
  [1426] = {.lex_state = 19},
  [1427] = {.lex_state = 9, .external_lex_state = 5},
  [1428] = {.lex_state = 9, .external_lex_state = 5},
  [1429] = {.lex_state = 9, .external_lex_state = 5},
  [1430] = {.lex_state = 19},
  [1431] = {.lex_state = 8},
  [1432] = {.lex_state = 8},
  [1433] = {.lex_state = 8},
  [1434] = {.lex_state = 8},
  [1435] = {.lex_state = 9, .external_lex_state = 4},
  [1436] = {.lex_state = 8},
  [1437] = {.lex_state = 8},
  [1438] = {.lex_state = 8},
  [1439] = {.lex_state = 68},
  [1440] = {.lex_state = 8},
  [1441] = {.lex_state = 8},
  [1442] = {.lex_state = 70},
  [1443] = {.lex_state = 70},
  [1444] = {.lex_state = 16},
  [1445] = {.lex_state = 16},
  [1446] = {.lex_state = 70},
  [1447] = {.lex_state = 68},
  [1448] = {.lex_state = 68},
  [1449] = {.lex_state = 70},
  [1450] = {.lex_state = 68},
  [1451] = {.lex_state = 8},
  [1452] = {.lex_state = 8},
  [1453] = {.lex_state = 8},
  [1454] = {.lex_state = 68},
  [1455] = {.lex_state = 8},
  [1456] = {.lex_state = 8},
  [1457] = {.lex_state = 8},
  [1458] = {.lex_state = 8},
  [1459] = {.lex_state = 3, .external_lex_state = 7},
  [1460] = {.lex_state = 68},
  [1461] = {.lex_state = 70},
  [1462] = {.lex_state = 68},
  [1463] = {.lex_state = 70},
  [1464] = {.lex_state = 70},
  [1465] = {.lex_state = 68},
  [1466] = {.lex_state = 8},
  [1467] = {.lex_state = 8},
  [1468] = {.lex_state = 3, .external_lex_state = 7},
  [1469] = {.lex_state = 70},
  [1470] = {.lex_state = 68},
  [1471] = {.lex_state = 68},
  [1472] = {.lex_state = 70},
  [1473] = {.lex_state = 8},
  [1474] = {.lex_state = 8},
  [1475] = {.lex_state = 9, .external_lex_state = 8},
  [1476] = {.lex_state = 8},
  [1477] = {.lex_state = 8},
  [1478] = {.lex_state = 8},
  [1479] = {.lex_state = 8},
  [1480] = {.lex_state = 70},
  [1481] = {.lex_state = 8},
  [1482] = {.lex_state = 8},
  [1483] = {.lex_state = 68},
  [1484] = {.lex_state = 8},
  [1485] = {.lex_state = 8},
  [1486] = {.lex_state = 8},
  [1487] = {.lex_state = 8},
  [1488] = {.lex_state = 8},
  [1489] = {.lex_state = 68},
  [1490] = {.lex_state = 8},
  [1491] = {.lex_state = 8},
  [1492] = {.lex_state = 68},
  [1493] = {.lex_state = 8},
  [1494] = {.lex_state = 8},
  [1495] = {.lex_state = 8},
  [1496] = {.lex_state = 9, .external_lex_state = 8},
  [1497] = {.lex_state = 68},
  [1498] = {.lex_state = 8},
  [1499] = {.lex_state = 8},
  [1500] = {.lex_state = 8},
  [1501] = {.lex_state = 8},
  [1502] = {.lex_state = 68},
  [1503] = {.lex_state = 8},
  [1504] = {.lex_state = 8},
  [1505] = {.lex_state = 8},
  [1506] = {.lex_state = 8},
  [1507] = {.lex_state = 68},
  [1508] = {.lex_state = 8},
  [1509] = {.lex_state = 8},
  [1510] = {.lex_state = 8},
  [1511] = {.lex_state = 9, .external_lex_state = 9},
  [1512] = {.lex_state = 8},
  [1513] = {.lex_state = 8},
  [1514] = {.lex_state = 68},
  [1515] = {.lex_state = 8},
  [1516] = {.lex_state = 8},
  [1517] = {.lex_state = 68},
  [1518] = {.lex_state = 8},
  [1519] = {.lex_state = 9, .external_lex_state = 9},
  [1520] = {.lex_state = 8},
  [1521] = {.lex_state = 68},
  [1522] = {.lex_state = 8},
  [1523] = {.lex_state = 68},
  [1524] = {.lex_state = 8},
  [1525] = {.lex_state = 8},
  [1526] = {.lex_state = 8},
  [1527] = {.lex_state = 8},
  [1528] = {.lex_state = 8},
  [1529] = {.lex_state = 8},
  [1530] = {.lex_state = 8},
  [1531] = {.lex_state = 8},
  [1532] = {.lex_state = 8},
  [1533] = {.lex_state = 68},
  [1534] = {.lex_state = 8},
  [1535] = {.lex_state = 8},
  [1536] = {.lex_state = 8},
  [1537] = {.lex_state = 68},
  [1538] = {.lex_state = 8},
  [1539] = {.lex_state = 68},
  [1540] = {.lex_state = 8},
  [1541] = {.lex_state = 8},
  [1542] = {.lex_state = 68},
  [1543] = {.lex_state = 68, .external_lex_state = 2},
  [1544] = {.lex_state = 68},
  [1545] = {.lex_state = 68},
  [1546] = {.lex_state = 68},
  [1547] = {.lex_state = 68, .external_lex_state = 2},
  [1548] = {.lex_state = 68},
  [1549] = {.lex_state = 68},
  [1550] = {.lex_state = 68},
  [1551] = {.lex_state = 68},
  [1552] = {.lex_state = 68},
  [1553] = {.lex_state = 68},
  [1554] = {.lex_state = 68},
  [1555] = {.lex_state = 68},
  [1556] = {.lex_state = 3, .external_lex_state = 3},
  [1557] = {.lex_state = 3, .external_lex_state = 3},
  [1558] = {.lex_state = 70},
  [1559] = {.lex_state = 3, .external_lex_state = 3},
  [1560] = {.lex_state = 68},
  [1561] = {.lex_state = 8},
  [1562] = {.lex_state = 70},
  [1563] = {.lex_state = 68, .external_lex_state = 2},
  [1564] = {.lex_state = 3, .external_lex_state = 3},
  [1565] = {.lex_state = 68},
  [1566] = {.lex_state = 68},
  [1567] = {.lex_state = 68},
  [1568] = {.lex_state = 68},
  [1569] = {.lex_state = 68},
  [1570] = {.lex_state = 68},
  [1571] = {.lex_state = 8},
  [1572] = {.lex_state = 11},
  [1573] = {.lex_state = 68},
  [1574] = {.lex_state = 11},
  [1575] = {.lex_state = 68},
  [1576] = {.lex_state = 3, .external_lex_state = 3},
  [1577] = {.lex_state = 68},
  [1578] = {.lex_state = 3, .external_lex_state = 3},
  [1579] = {.lex_state = 68},
  [1580] = {.lex_state = 68},
  [1581] = {.lex_state = 11},
  [1582] = {.lex_state = 68},
  [1583] = {.lex_state = 3, .external_lex_state = 3},
  [1584] = {.lex_state = 68, .external_lex_state = 2},
  [1585] = {.lex_state = 3, .external_lex_state = 3},
  [1586] = {.lex_state = 68},
  [1587] = {.lex_state = 68},
  [1588] = {.lex_state = 8},
  [1589] = {.lex_state = 68},
  [1590] = {.lex_state = 68},
  [1591] = {.lex_state = 68},
  [1592] = {.lex_state = 68},
  [1593] = {.lex_state = 68},
  [1594] = {.lex_state = 68},
  [1595] = {.lex_state = 68},
  [1596] = {.lex_state = 68},
  [1597] = {.lex_state = 3, .external_lex_state = 3},
  [1598] = {.lex_state = 68},
  [1599] = {.lex_state = 3, .external_lex_state = 3},
  [1600] = {.lex_state = 68},
  [1601] = {.lex_state = 68},
  [1602] = {.lex_state = 9, .external_lex_state = 6},
  [1603] = {.lex_state = 68},
  [1604] = {.lex_state = 69, .external_lex_state = 10},
  [1605] = {.lex_state = 68},
  [1606] = {.lex_state = 8},
  [1607] = {.lex_state = 68},
  [1608] = {.lex_state = 9, .external_lex_state = 6},
  [1609] = {.lex_state = 9, .external_lex_state = 5},
  [1610] = {.lex_state = 9, .external_lex_state = 5},
  [1611] = {.lex_state = 9, .external_lex_state = 5},
  [1612] = {.lex_state = 9, .external_lex_state = 6},
  [1613] = {.lex_state = 68},
  [1614] = {.lex_state = 68},
  [1615] = {.lex_state = 8},
  [1616] = {.lex_state = 8},
  [1617] = {.lex_state = 8},
  [1618] = {.lex_state = 68},
  [1619] = {.lex_state = 68},
  [1620] = {.lex_state = 68},
  [1621] = {.lex_state = 68, .external_lex_state = 2},
  [1622] = {.lex_state = 68},
  [1623] = {.lex_state = 9, .external_lex_state = 5},
  [1624] = {.lex_state = 9, .external_lex_state = 6},
  [1625] = {.lex_state = 68},
  [1626] = {.lex_state = 8},
  [1627] = {.lex_state = 68},
  [1628] = {.lex_state = 68},
  [1629] = {.lex_state = 68},
  [1630] = {.lex_state = 68},
  [1631] = {.lex_state = 8},
  [1632] = {.lex_state = 68},
  [1633] = {.lex_state = 68},
  [1634] = {.lex_state = 68},
  [1635] = {.lex_state = 68},
  [1636] = {.lex_state = 8},
  [1637] = {.lex_state = 68},
  [1638] = {.lex_state = 68},
  [1639] = {.lex_state = 68},
  [1640] = {.lex_state = 9, .external_lex_state = 5},
  [1641] = {.lex_state = 9, .external_lex_state = 5},
  [1642] = {.lex_state = 68},
  [1643] = {.lex_state = 68},
  [1644] = {.lex_state = 68},
  [1645] = {.lex_state = 68},
  [1646] = {.lex_state = 68, .external_lex_state = 2},
  [1647] = {.lex_state = 9, .external_lex_state = 5},
  [1648] = {.lex_state = 68},
  [1649] = {.lex_state = 68},
  [1650] = {.lex_state = 68},
  [1651] = {.lex_state = 68},
  [1652] = {.lex_state = 68},
  [1653] = {.lex_state = 68},
  [1654] = {.lex_state = 68},
  [1655] = {.lex_state = 68},
  [1656] = {.lex_state = 68},
  [1657] = {.lex_state = 68},
  [1658] = {.lex_state = 68},
  [1659] = {.lex_state = 68},
  [1660] = {.lex_state = 68},
  [1661] = {.lex_state = 68},
  [1662] = {.lex_state = 68},
  [1663] = {.lex_state = 68},
  [1664] = {.lex_state = 68},
  [1665] = {.lex_state = 68},
  [1666] = {.lex_state = 68, .external_lex_state = 2},
  [1667] = {.lex_state = 68},
  [1668] = {.lex_state = 68},
  [1669] = {.lex_state = 9, .external_lex_state = 6},
  [1670] = {.lex_state = 9, .external_lex_state = 5},
  [1671] = {.lex_state = 9, .external_lex_state = 6},
  [1672] = {.lex_state = 9, .external_lex_state = 6},
  [1673] = {.lex_state = 9, .external_lex_state = 5},
  [1674] = {.lex_state = 9, .external_lex_state = 5},
  [1675] = {.lex_state = 9, .external_lex_state = 6},
  [1676] = {.lex_state = 9, .external_lex_state = 6},
  [1677] = {.lex_state = 68},
  [1678] = {.lex_state = 68},
  [1679] = {.lex_state = 68},
  [1680] = {.lex_state = 68},
  [1681] = {.lex_state = 9, .external_lex_state = 6},
  [1682] = {.lex_state = 68},
  [1683] = {.lex_state = 70},
  [1684] = {.lex_state = 68},
  [1685] = {.lex_state = 69},
  [1686] = {.lex_state = 68},
  [1687] = {.lex_state = 68},
  [1688] = {.lex_state = 68},
  [1689] = {.lex_state = 68, .external_lex_state = 2},
  [1690] = {.lex_state = 68},
  [1691] = {.lex_state = 68},
  [1692] = {.lex_state = 68},
  [1693] = {.lex_state = 68},
  [1694] = {.lex_state = 68},
  [1695] = {.lex_state = 68},
  [1696] = {.lex_state = 68},
  [1697] = {.lex_state = 68, .external_lex_state = 2},
  [1698] = {.lex_state = 68, .external_lex_state = 2},
  [1699] = {.lex_state = 68},
  [1700] = {.lex_state = 68},
  [1701] = {.lex_state = 69},
  [1702] = {.lex_state = 68, .external_lex_state = 2},
  [1703] = {.lex_state = 68, .external_lex_state = 2},
  [1704] = {.lex_state = 68, .external_lex_state = 2},
  [1705] = {.lex_state = 68},
  [1706] = {.lex_state = 68, .external_lex_state = 2},
  [1707] = {.lex_state = 68, .external_lex_state = 2},
  [1708] = {.lex_state = 68},
  [1709] = {.lex_state = 70},
  [1710] = {.lex_state = 68, .external_lex_state = 2},
  [1711] = {.lex_state = 68, .external_lex_state = 2},
  [1712] = {.lex_state = 68, .external_lex_state = 2},
  [1713] = {.lex_state = 70},
  [1714] = {.lex_state = 70},
  [1715] = {.lex_state = 8},
  [1716] = {.lex_state = 68, .external_lex_state = 2},
  [1717] = {.lex_state = 68, .external_lex_state = 2},
  [1718] = {.lex_state = 68, .external_lex_state = 2},
  [1719] = {.lex_state = 68},
  [1720] = {.lex_state = 68},
  [1721] = {.lex_state = 68},
  [1722] = {.lex_state = 68, .external_lex_state = 2},
  [1723] = {.lex_state = 68},
  [1724] = {.lex_state = 68, .external_lex_state = 2},
  [1725] = {.lex_state = 68, .external_lex_state = 2},
  [1726] = {.lex_state = 68, .external_lex_state = 2},
  [1727] = {.lex_state = 68},
  [1728] = {.lex_state = 68},
  [1729] = {.lex_state = 68},
  [1730] = {.lex_state = 68},
  [1731] = {.lex_state = 68},
  [1732] = {.lex_state = 68, .external_lex_state = 2},
  [1733] = {.lex_state = 68, .external_lex_state = 2},
  [1734] = {.lex_state = 68},
  [1735] = {.lex_state = 68},
  [1736] = {.lex_state = 68},
  [1737] = {.lex_state = 68, .external_lex_state = 2},
  [1738] = {.lex_state = 68},
  [1739] = {.lex_state = 68, .external_lex_state = 2},
  [1740] = {.lex_state = 68},
  [1741] = {.lex_state = 68},
  [1742] = {.lex_state = 68},
  [1743] = {.lex_state = 68},
  [1744] = {.lex_state = 68, .external_lex_state = 2},
  [1745] = {.lex_state = 68, .external_lex_state = 2},
  [1746] = {.lex_state = 68},
  [1747] = {.lex_state = 68, .external_lex_state = 2},
  [1748] = {.lex_state = 68},
  [1749] = {.lex_state = 68},
  [1750] = {.lex_state = 68, .external_lex_state = 2},
  [1751] = {.lex_state = 68},
  [1752] = {.lex_state = 68, .external_lex_state = 2},
  [1753] = {.lex_state = 68, .external_lex_state = 2},
  [1754] = {.lex_state = 68, .external_lex_state = 2},
  [1755] = {.lex_state = 68, .external_lex_state = 2},
  [1756] = {.lex_state = 68},
  [1757] = {.lex_state = 68},
  [1758] = {.lex_state = 68},
  [1759] = {.lex_state = 68},
  [1760] = {.lex_state = 68},
  [1761] = {.lex_state = 68, .external_lex_state = 2},
  [1762] = {.lex_state = 70},
  [1763] = {.lex_state = 68, .external_lex_state = 2},
  [1764] = {.lex_state = 68, .external_lex_state = 2},
  [1765] = {.lex_state = 68, .external_lex_state = 2},
  [1766] = {.lex_state = 68},
  [1767] = {.lex_state = 68},
  [1768] = {.lex_state = 68, .external_lex_state = 2},
  [1769] = {.lex_state = 70},
  [1770] = {.lex_state = 68},
  [1771] = {.lex_state = 70},
  [1772] = {.lex_state = 68},
  [1773] = {.lex_state = 68, .external_lex_state = 2},
  [1774] = {.lex_state = 68, .external_lex_state = 2},
  [1775] = {.lex_state = 68, .external_lex_state = 2},
  [1776] = {.lex_state = 68},
  [1777] = {.lex_state = 68},
  [1778] = {.lex_state = 68, .external_lex_state = 2},
  [1779] = {.lex_state = 69, .external_lex_state = 10},
  [1780] = {.lex_state = 68},
  [1781] = {.lex_state = 68, .external_lex_state = 2},
  [1782] = {.lex_state = 68},
  [1783] = {.lex_state = 69, .external_lex_state = 10},
  [1784] = {.lex_state = 70},
  [1785] = {.lex_state = 68},
  [1786] = {.lex_state = 68, .external_lex_state = 2},
  [1787] = {.lex_state = 68},
  [1788] = {.lex_state = 68, .external_lex_state = 2},
  [1789] = {.lex_state = 68, .external_lex_state = 2},
  [1790] = {.lex_state = 68, .external_lex_state = 2},
  [1791] = {.lex_state = 68},
  [1792] = {.lex_state = 68},
  [1793] = {.lex_state = 68},
  [1794] = {.lex_state = 69, .external_lex_state = 10},
  [1795] = {.lex_state = 68},
  [1796] = {.lex_state = 21},
  [1797] = {.lex_state = 68},
  [1798] = {.lex_state = 68},
  [1799] = {.lex_state = 68, .external_lex_state = 2},
  [1800] = {.lex_state = 68},
  [1801] = {.lex_state = 68},
  [1802] = {.lex_state = 68},
  [1803] = {.lex_state = 68, .external_lex_state = 2},
  [1804] = {.lex_state = 68, .external_lex_state = 2},
  [1805] = {.lex_state = 68},
  [1806] = {.lex_state = 68, .external_lex_state = 2},
  [1807] = {.lex_state = 68, .external_lex_state = 2},
  [1808] = {.lex_state = 68, .external_lex_state = 2},
  [1809] = {.lex_state = 3, .external_lex_state = 11},
  [1810] = {.lex_state = 68},
  [1811] = {.lex_state = 70},
  [1812] = {.lex_state = 68},
  [1813] = {.lex_state = 68, .external_lex_state = 2},
  [1814] = {.lex_state = 68},
  [1815] = {.lex_state = 68, .external_lex_state = 2},
  [1816] = {.lex_state = 68, .external_lex_state = 2},
  [1817] = {.lex_state = 68, .external_lex_state = 2},
  [1818] = {.lex_state = 69},
  [1819] = {.lex_state = 68, .external_lex_state = 2},
  [1820] = {.lex_state = 68, .external_lex_state = 2},
  [1821] = {.lex_state = 68, .external_lex_state = 2},
  [1822] = {.lex_state = 68},
  [1823] = {.lex_state = 68, .external_lex_state = 2},
  [1824] = {.lex_state = 68, .external_lex_state = 2},
  [1825] = {.lex_state = 68, .external_lex_state = 2},
  [1826] = {.lex_state = 68},
  [1827] = {.lex_state = 68},
  [1828] = {.lex_state = 68},
  [1829] = {.lex_state = 68},
  [1830] = {.lex_state = 68},
  [1831] = {.lex_state = 68, .external_lex_state = 2},
  [1832] = {.lex_state = 68, .external_lex_state = 2},
  [1833] = {.lex_state = 68, .external_lex_state = 2},
  [1834] = {.lex_state = 68, .external_lex_state = 2},
  [1835] = {.lex_state = 68},
  [1836] = {.lex_state = 68},
  [1837] = {.lex_state = 68, .external_lex_state = 2},
  [1838] = {.lex_state = 68},
  [1839] = {.lex_state = 68},
  [1840] = {.lex_state = 68},
  [1841] = {.lex_state = 70},
  [1842] = {.lex_state = 68},
  [1843] = {.lex_state = 68},
  [1844] = {.lex_state = 21},
  [1845] = {.lex_state = 68},
  [1846] = {.lex_state = 68},
  [1847] = {.lex_state = 68},
  [1848] = {.lex_state = 8},
  [1849] = {.lex_state = 3, .external_lex_state = 11},
  [1850] = {.lex_state = 68},
  [1851] = {.lex_state = 68, .external_lex_state = 2},
  [1852] = {.lex_state = 68, .external_lex_state = 2},
  [1853] = {.lex_state = 21},
  [1854] = {.lex_state = 68},
  [1855] = {.lex_state = 68, .external_lex_state = 2},
  [1856] = {.lex_state = 68},
  [1857] = {.lex_state = 68},
  [1858] = {.lex_state = 68},
  [1859] = {.lex_state = 68, .external_lex_state = 2},
  [1860] = {.lex_state = 68},
  [1861] = {.lex_state = 68},
  [1862] = {.lex_state = 68, .external_lex_state = 2},
  [1863] = {.lex_state = 68, .external_lex_state = 2},
  [1864] = {.lex_state = 68, .external_lex_state = 2},
  [1865] = {.lex_state = 8},
  [1866] = {.lex_state = 68},
  [1867] = {.lex_state = 68, .external_lex_state = 2},
  [1868] = {.lex_state = 68, .external_lex_state = 2},
  [1869] = {.lex_state = 68, .external_lex_state = 2},
  [1870] = {.lex_state = 68},
  [1871] = {.lex_state = 68, .external_lex_state = 2},
  [1872] = {.lex_state = 68, .external_lex_state = 2},
  [1873] = {.lex_state = 68, .external_lex_state = 2},
  [1874] = {.lex_state = 68, .external_lex_state = 2},
  [1875] = {.lex_state = 68, .external_lex_state = 2},
  [1876] = {.lex_state = 68, .external_lex_state = 2},
  [1877] = {.lex_state = 68, .external_lex_state = 2},
  [1878] = {.lex_state = 68},
  [1879] = {.lex_state = 68, .external_lex_state = 2},
  [1880] = {.lex_state = 68, .external_lex_state = 2},
  [1881] = {.lex_state = 68},
  [1882] = {.lex_state = 68, .external_lex_state = 2},
  [1883] = {.lex_state = 68},
  [1884] = {.lex_state = 68, .external_lex_state = 2},
  [1885] = {.lex_state = 68, .external_lex_state = 2},
  [1886] = {.lex_state = 68, .external_lex_state = 2},
  [1887] = {.lex_state = 68},
  [1888] = {.lex_state = 68, .external_lex_state = 2},
  [1889] = {.lex_state = 68},
  [1890] = {.lex_state = 68, .external_lex_state = 2},
  [1891] = {.lex_state = 68, .external_lex_state = 2},
  [1892] = {.lex_state = 70},
  [1893] = {.lex_state = 68},
  [1894] = {.lex_state = 68, .external_lex_state = 2},
  [1895] = {.lex_state = 68},
  [1896] = {.lex_state = 68},
  [1897] = {.lex_state = 68},
  [1898] = {.lex_state = 68},
  [1899] = {.lex_state = 68, .external_lex_state = 2},
  [1900] = {.lex_state = 68},
  [1901] = {.lex_state = 68},
  [1902] = {.lex_state = 68, .external_lex_state = 2},
  [1903] = {.lex_state = 68},
  [1904] = {.lex_state = 68},
  [1905] = {.lex_state = 68, .external_lex_state = 2},
  [1906] = {.lex_state = 21},
  [1907] = {.lex_state = 68},
  [1908] = {.lex_state = 68},
  [1909] = {.lex_state = 68, .external_lex_state = 2},
  [1910] = {.lex_state = 68},
  [1911] = {.lex_state = 68, .external_lex_state = 2},
  [1912] = {.lex_state = 68, .external_lex_state = 2},
  [1913] = {.lex_state = 68},
  [1914] = {.lex_state = 68},
  [1915] = {.lex_state = 68},
  [1916] = {.lex_state = 68},
  [1917] = {.lex_state = 68},
  [1918] = {.lex_state = 68, .external_lex_state = 2},
  [1919] = {.lex_state = 68, .external_lex_state = 2},
  [1920] = {.lex_state = 68, .external_lex_state = 2},
  [1921] = {.lex_state = 68},
  [1922] = {.lex_state = 68, .external_lex_state = 2},
  [1923] = {.lex_state = 68},
  [1924] = {.lex_state = 68, .external_lex_state = 2},
  [1925] = {.lex_state = 68, .external_lex_state = 2},
  [1926] = {.lex_state = 68, .external_lex_state = 2},
  [1927] = {.lex_state = 68},
  [1928] = {.lex_state = 68},
  [1929] = {.lex_state = 68},
  [1930] = {.lex_state = 68, .external_lex_state = 2},
  [1931] = {.lex_state = 68, .external_lex_state = 2},
  [1932] = {.lex_state = 68},
  [1933] = {.lex_state = 68},
  [1934] = {.lex_state = 21},
  [1935] = {.lex_state = 68},
  [1936] = {.lex_state = 68},
  [1937] = {.lex_state = 68},
  [1938] = {.lex_state = 68},
  [1939] = {.lex_state = 68, .external_lex_state = 2},
  [1940] = {.lex_state = 68},
  [1941] = {.lex_state = 68},
  [1942] = {.lex_state = 68},
  [1943] = {.lex_state = 68, .external_lex_state = 2},
  [1944] = {.lex_state = 68},
  [1945] = {.lex_state = 68},
  [1946] = {.lex_state = 68},
  [1947] = {.lex_state = 68},
  [1948] = {.lex_state = 3, .external_lex_state = 12},
  [1949] = {.lex_state = 68},
  [1950] = {.lex_state = 68},
  [1951] = {.lex_state = 68},
  [1952] = {.lex_state = 68},
  [1953] = {.lex_state = 68},
  [1954] = {.lex_state = 68},
  [1955] = {.lex_state = 68},
  [1956] = {.lex_state = 68},
  [1957] = {.lex_state = 68},
  [1958] = {.lex_state = 68},
  [1959] = {.lex_state = 68},
  [1960] = {.lex_state = 68},
  [1961] = {.lex_state = 68},
  [1962] = {.lex_state = 68},
  [1963] = {.lex_state = 68, .external_lex_state = 13},
  [1964] = {.lex_state = 68},
  [1965] = {.lex_state = 68},
  [1966] = {.lex_state = 68},
  [1967] = {.lex_state = 68},
  [1968] = {.lex_state = 68},
  [1969] = {.lex_state = 68},
  [1970] = {.lex_state = 68},
  [1971] = {.lex_state = 68, .external_lex_state = 2},
  [1972] = {.lex_state = 68},
  [1973] = {.lex_state = 68},
  [1974] = {.lex_state = 68},
  [1975] = {.lex_state = 68},
  [1976] = {.lex_state = 68},
  [1977] = {.lex_state = 68},
  [1978] = {.lex_state = 68},
  [1979] = {.lex_state = 68, .external_lex_state = 2},
  [1980] = {.lex_state = 68},
  [1981] = {.lex_state = 68},
  [1982] = {.lex_state = 68},
  [1983] = {.lex_state = 68},
  [1984] = {.lex_state = 68},
  [1985] = {.lex_state = 68},
  [1986] = {.lex_state = 68},
  [1987] = {.lex_state = 68},
  [1988] = {.lex_state = 68},
  [1989] = {.lex_state = 68},
  [1990] = {.lex_state = 68},
  [1991] = {.lex_state = 68},
  [1992] = {.lex_state = 68, .external_lex_state = 2},
  [1993] = {.lex_state = 68},
  [1994] = {.lex_state = 68},
  [1995] = {.lex_state = 68, .external_lex_state = 2},
  [1996] = {.lex_state = 68},
  [1997] = {.lex_state = 68},
  [1998] = {.lex_state = 68},
  [1999] = {.lex_state = 68},
  [2000] = {.lex_state = 68},
  [2001] = {.lex_state = 68},
  [2002] = {.lex_state = 68},
  [2003] = {.lex_state = 68},
  [2004] = {.lex_state = 68},
  [2005] = {.lex_state = 68},
  [2006] = {.lex_state = 3, .external_lex_state = 12},
  [2007] = {.lex_state = 3, .external_lex_state = 12},
  [2008] = {.lex_state = 68},
  [2009] = {.lex_state = 68},
  [2010] = {.lex_state = 68},
  [2011] = {.lex_state = 68},
  [2012] = {.lex_state = 68},
  [2013] = {.lex_state = 68},
  [2014] = {.lex_state = 68},
  [2015] = {.lex_state = 68},
  [2016] = {.lex_state = 68},
  [2017] = {.lex_state = 68},
  [2018] = {.lex_state = 68},
  [2019] = {.lex_state = 68},
  [2020] = {.lex_state = 68},
  [2021] = {.lex_state = 68},
  [2022] = {.lex_state = 68},
  [2023] = {.lex_state = 68},
  [2024] = {.lex_state = 68},
  [2025] = {.lex_state = 68},
  [2026] = {.lex_state = 68},
  [2027] = {.lex_state = 68},
  [2028] = {.lex_state = 68},
  [2029] = {.lex_state = 68},
  [2030] = {.lex_state = 68},
  [2031] = {.lex_state = 68},
  [2032] = {.lex_state = 68},
  [2033] = {.lex_state = 68},
  [2034] = {.lex_state = 68},
  [2035] = {.lex_state = 68},
  [2036] = {.lex_state = 68},
  [2037] = {.lex_state = 21},
  [2038] = {.lex_state = 68},
  [2039] = {.lex_state = 3, .external_lex_state = 12},
  [2040] = {.lex_state = 68},
  [2041] = {.lex_state = 68},
  [2042] = {.lex_state = 68},
  [2043] = {.lex_state = 68},
  [2044] = {.lex_state = 68},
  [2045] = {.lex_state = 68},
  [2046] = {.lex_state = 68},
  [2047] = {.lex_state = 68},
  [2048] = {.lex_state = 68},
  [2049] = {.lex_state = 68},
  [2050] = {.lex_state = 68},
  [2051] = {.lex_state = 68},
  [2052] = {.lex_state = 68},
  [2053] = {.lex_state = 68},
  [2054] = {.lex_state = 68},
  [2055] = {.lex_state = 68},
  [2056] = {.lex_state = 68, .external_lex_state = 2},
  [2057] = {.lex_state = 3, .external_lex_state = 12},
  [2058] = {.lex_state = 68},
  [2059] = {.lex_state = 68},
  [2060] = {.lex_state = 68},
  [2061] = {.lex_state = 68},
  [2062] = {.lex_state = 68},
  [2063] = {.lex_state = 68},
  [2064] = {.lex_state = 70},
  [2065] = {.lex_state = 68},
  [2066] = {.lex_state = 68},
  [2067] = {.lex_state = 68},
  [2068] = {.lex_state = 68},
  [2069] = {.lex_state = 68},
  [2070] = {.lex_state = 68},
  [2071] = {.lex_state = 68},
  [2072] = {.lex_state = 68},
  [2073] = {.lex_state = 68},
  [2074] = {.lex_state = 68},
  [2075] = {.lex_state = 68},
  [2076] = {.lex_state = 68},
  [2077] = {.lex_state = 68},
  [2078] = {.lex_state = 68},
  [2079] = {.lex_state = 68},
  [2080] = {.lex_state = 68},
  [2081] = {.lex_state = 68, .external_lex_state = 2},
  [2082] = {.lex_state = 68, .external_lex_state = 2},
  [2083] = {.lex_state = 68},
  [2084] = {.lex_state = 68},
  [2085] = {.lex_state = 68},
  [2086] = {.lex_state = 68, .external_lex_state = 2},
  [2087] = {.lex_state = 68},
  [2088] = {.lex_state = 68},
  [2089] = {.lex_state = 68},
  [2090] = {.lex_state = 68},
  [2091] = {.lex_state = 68},
  [2092] = {.lex_state = 68},
  [2093] = {.lex_state = 68},
  [2094] = {.lex_state = 68},
  [2095] = {.lex_state = 68},
  [2096] = {.lex_state = 68},
  [2097] = {.lex_state = 68},
  [2098] = {.lex_state = 68, .external_lex_state = 2},
  [2099] = {.lex_state = 68},
  [2100] = {.lex_state = 68},
  [2101] = {.lex_state = 68},
  [2102] = {.lex_state = 189, .external_lex_state = 14},
  [2103] = {.lex_state = 68},
  [2104] = {.lex_state = 68},
  [2105] = {.lex_state = 68},
  [2106] = {.lex_state = 68},
  [2107] = {.lex_state = 68},
  [2108] = {.lex_state = 68},
  [2109] = {.lex_state = 68},
  [2110] = {.lex_state = 68},
  [2111] = {.lex_state = 68},
  [2112] = {.lex_state = 68},
  [2113] = {.lex_state = 68},
  [2114] = {.lex_state = 68},
  [2115] = {.lex_state = 68},
  [2116] = {.lex_state = 68},
  [2117] = {.lex_state = 68},
  [2118] = {.lex_state = 68},
  [2119] = {.lex_state = 68},
  [2120] = {.lex_state = 68, .external_lex_state = 2},
  [2121] = {.lex_state = 68, .external_lex_state = 2},
  [2122] = {.lex_state = 68},
  [2123] = {.lex_state = 68},
  [2124] = {.lex_state = 68, .external_lex_state = 2},
  [2125] = {.lex_state = 68, .external_lex_state = 2},
  [2126] = {.lex_state = 68},
  [2127] = {.lex_state = 68},
  [2128] = {.lex_state = 68},
  [2129] = {.lex_state = 68},
  [2130] = {.lex_state = 68},
  [2131] = {.lex_state = 68},
  [2132] = {.lex_state = 70},
  [2133] = {.lex_state = 68},
  [2134] = {.lex_state = 68},
  [2135] = {.lex_state = 68},
  [2136] = {.lex_state = 68},
  [2137] = {.lex_state = 68},
  [2138] = {.lex_state = 68},
  [2139] = {.lex_state = 70},
  [2140] = {.lex_state = 68},
  [2141] = {.lex_state = 68},
  [2142] = {.lex_state = 68},
  [2143] = {.lex_state = 68},
  [2144] = {.lex_state = 68},
  [2145] = {.lex_state = 68},
  [2146] = {.lex_state = 68},
  [2147] = {.lex_state = 68},
  [2148] = {.lex_state = 68},
  [2149] = {.lex_state = 68},
  [2150] = {.lex_state = 68, .external_lex_state = 2},
  [2151] = {.lex_state = 68},
  [2152] = {.lex_state = 68},
  [2153] = {.lex_state = 68, .external_lex_state = 2},
  [2154] = {.lex_state = 68},
  [2155] = {.lex_state = 68},
  [2156] = {.lex_state = 68},
  [2157] = {.lex_state = 68},
  [2158] = {.lex_state = 68, .external_lex_state = 2},
  [2159] = {.lex_state = 68},
  [2160] = {.lex_state = 68},
  [2161] = {.lex_state = 68},
  [2162] = {.lex_state = 68},
  [2163] = {.lex_state = 68},
  [2164] = {.lex_state = 68},
  [2165] = {.lex_state = 68},
  [2166] = {.lex_state = 68},
  [2167] = {.lex_state = 68},
  [2168] = {.lex_state = 68, .external_lex_state = 13},
  [2169] = {.lex_state = 68},
  [2170] = {.lex_state = 70},
  [2171] = {.lex_state = 68},
  [2172] = {.lex_state = 68},
  [2173] = {.lex_state = 68},
  [2174] = {.lex_state = 68},
  [2175] = {.lex_state = 68},
  [2176] = {.lex_state = 68},
  [2177] = {.lex_state = 68},
  [2178] = {.lex_state = 68},
  [2179] = {.lex_state = 68},
  [2180] = {.lex_state = 68},
  [2181] = {.lex_state = 68},
  [2182] = {.lex_state = 68},
  [2183] = {.lex_state = 68},
  [2184] = {.lex_state = 68},
  [2185] = {.lex_state = 68},
  [2186] = {.lex_state = 68},
  [2187] = {.lex_state = 68},
  [2188] = {.lex_state = 68},
  [2189] = {.lex_state = 68},
  [2190] = {.lex_state = 68},
  [2191] = {.lex_state = 68},
  [2192] = {.lex_state = 68},
  [2193] = {.lex_state = 68},
  [2194] = {.lex_state = 68},
  [2195] = {.lex_state = 68},
  [2196] = {.lex_state = 68},
  [2197] = {.lex_state = 68},
  [2198] = {.lex_state = 68},
  [2199] = {.lex_state = 68},
  [2200] = {.lex_state = 68},
  [2201] = {.lex_state = 68},
  [2202] = {.lex_state = 68},
  [2203] = {.lex_state = 68},
  [2204] = {.lex_state = 68},
  [2205] = {.lex_state = 68},
  [2206] = {.lex_state = 68},
  [2207] = {.lex_state = 68},
  [2208] = {.lex_state = 68},
  [2209] = {.lex_state = 68},
  [2210] = {.lex_state = 68},
  [2211] = {.lex_state = 68},
  [2212] = {.lex_state = 68},
  [2213] = {.lex_state = 68},
  [2214] = {.lex_state = 68},
  [2215] = {.lex_state = 3, .external_lex_state = 11},
  [2216] = {.lex_state = 68},
  [2217] = {.lex_state = 3, .external_lex_state = 12},
  [2218] = {.lex_state = 68},
  [2219] = {.lex_state = 68},
  [2220] = {.lex_state = 68},
  [2221] = {.lex_state = 68},
  [2222] = {.lex_state = 70},
  [2223] = {.lex_state = 68},
  [2224] = {.lex_state = 70, .external_lex_state = 10},
  [2225] = {.lex_state = 68},
  [2226] = {.lex_state = 68},
  [2227] = {.lex_state = 3, .external_lex_state = 12},
  [2228] = {.lex_state = 68},
  [2229] = {.lex_state = 68},
  [2230] = {.lex_state = 68},
  [2231] = {.lex_state = 3, .external_lex_state = 12},
  [2232] = {.lex_state = 68},
  [2233] = {.lex_state = 68},
  [2234] = {.lex_state = 68},
  [2235] = {.lex_state = 68},
  [2236] = {.lex_state = 68},
  [2237] = {.lex_state = 68},
  [2238] = {.lex_state = 68},
  [2239] = {.lex_state = 68},
  [2240] = {.lex_state = 68},
  [2241] = {.lex_state = 68},
  [2242] = {.lex_state = 68},
  [2243] = {.lex_state = 68},
  [2244] = {.lex_state = 68},
  [2245] = {.lex_state = 68},
  [2246] = {.lex_state = 68},
  [2247] = {.lex_state = 68, .external_lex_state = 2},
  [2248] = {.lex_state = 68},
  [2249] = {.lex_state = 68},
  [2250] = {.lex_state = 68},
  [2251] = {.lex_state = 68},
  [2252] = {.lex_state = 68, .external_lex_state = 2},
  [2253] = {.lex_state = 68},
  [2254] = {.lex_state = 68, .external_lex_state = 2},
  [2255] = {.lex_state = 68, .external_lex_state = 2},
  [2256] = {.lex_state = 68, .external_lex_state = 2},
  [2257] = {.lex_state = 68},
  [2258] = {.lex_state = 68},
  [2259] = {.lex_state = 68},
  [2260] = {.lex_state = 68},
  [2261] = {.lex_state = 68},
  [2262] = {.lex_state = 68},
  [2263] = {.lex_state = 68},
  [2264] = {.lex_state = 68},
  [2265] = {.lex_state = 68},
  [2266] = {.lex_state = 68},
  [2267] = {.lex_state = 68},
  [2268] = {.lex_state = 68},
  [2269] = {.lex_state = 68},
  [2270] = {.lex_state = 68},
  [2271] = {.lex_state = 68},
  [2272] = {.lex_state = 68, .external_lex_state = 2},
  [2273] = {.lex_state = 68},
  [2274] = {.lex_state = 68},
  [2275] = {.lex_state = 68},
  [2276] = {.lex_state = 68},
  [2277] = {.lex_state = 68},
  [2278] = {.lex_state = 68},
  [2279] = {.lex_state = 68},
  [2280] = {.lex_state = 68},
  [2281] = {.lex_state = 68},
  [2282] = {.lex_state = 68},
  [2283] = {.lex_state = 68},
  [2284] = {.lex_state = 68},
  [2285] = {.lex_state = 68},
  [2286] = {.lex_state = 68, .external_lex_state = 2},
  [2287] = {.lex_state = 68},
  [2288] = {.lex_state = 68},
  [2289] = {.lex_state = 68, .external_lex_state = 2},
  [2290] = {.lex_state = 68},
  [2291] = {.lex_state = 68},
  [2292] = {.lex_state = 68},
  [2293] = {.lex_state = 68, .external_lex_state = 2},
  [2294] = {.lex_state = 68, .external_lex_state = 2},
  [2295] = {.lex_state = 68, .external_lex_state = 2},
  [2296] = {.lex_state = 68},
  [2297] = {.lex_state = 68},
  [2298] = {.lex_state = 68},
  [2299] = {.lex_state = 68, .external_lex_state = 2},
  [2300] = {.lex_state = 68},
  [2301] = {.lex_state = 68},
  [2302] = {.lex_state = 68, .external_lex_state = 2},
  [2303] = {.lex_state = 68},
  [2304] = {.lex_state = 68},
  [2305] = {.lex_state = 68},
  [2306] = {.lex_state = 68},
  [2307] = {.lex_state = 68},
  [2308] = {.lex_state = 68},
  [2309] = {.lex_state = 68},
  [2310] = {.lex_state = 68, .external_lex_state = 2},
  [2311] = {.lex_state = 68},
  [2312] = {.lex_state = 68},
  [2313] = {.lex_state = 68, .external_lex_state = 2},
  [2314] = {.lex_state = 68, .external_lex_state = 2},
  [2315] = {.lex_state = 68},
  [2316] = {.lex_state = 68},
  [2317] = {.lex_state = 68},
  [2318] = {.lex_state = 68},
  [2319] = {.lex_state = 68},
  [2320] = {.lex_state = 68},
  [2321] = {.lex_state = 68},
  [2322] = {.lex_state = 68, .external_lex_state = 2},
  [2323] = {.lex_state = 68},
  [2324] = {.lex_state = 68},
  [2325] = {.lex_state = 68},
  [2326] = {.lex_state = 68},
  [2327] = {.lex_state = 68},
  [2328] = {.lex_state = 68},
  [2329] = {.lex_state = 68},
  [2330] = {.lex_state = 68, .external_lex_state = 2},
  [2331] = {.lex_state = 68},
  [2332] = {.lex_state = 68},
  [2333] = {.lex_state = 68},
  [2334] = {.lex_state = 68},
  [2335] = {.lex_state = 68, .external_lex_state = 2},
  [2336] = {.lex_state = 68},
  [2337] = {.lex_state = 68},
  [2338] = {.lex_state = 68},
  [2339] = {.lex_state = 68},
  [2340] = {.lex_state = 68},
  [2341] = {.lex_state = 68},
  [2342] = {.lex_state = 68},
  [2343] = {.lex_state = 68},
  [2344] = {.lex_state = 68},
  [2345] = {.lex_state = 68},
  [2346] = {.lex_state = 68},
  [2347] = {.lex_state = 68},
  [2348] = {.lex_state = 68},
  [2349] = {.lex_state = 68},
  [2350] = {.lex_state = 68, .external_lex_state = 2},
  [2351] = {.lex_state = 68, .external_lex_state = 2},
  [2352] = {.lex_state = 68, .external_lex_state = 2},
  [2353] = {.lex_state = 68},
  [2354] = {.lex_state = 68, .external_lex_state = 2},
  [2355] = {.lex_state = 68},
  [2356] = {.lex_state = 68},
  [2357] = {.lex_state = 68, .external_lex_state = 2},
  [2358] = {.lex_state = 68, .external_lex_state = 2},
  [2359] = {.lex_state = 68, .external_lex_state = 2},
  [2360] = {.lex_state = 68, .external_lex_state = 2},
  [2361] = {.lex_state = 68},
  [2362] = {.lex_state = 68},
  [2363] = {.lex_state = 68, .external_lex_state = 2},
  [2364] = {.lex_state = 68},
  [2365] = {.lex_state = 68},
  [2366] = {.lex_state = 68, .external_lex_state = 2},
  [2367] = {.lex_state = 68},
  [2368] = {.lex_state = 68},
  [2369] = {.lex_state = 68, .external_lex_state = 2},
  [2370] = {.lex_state = 68},
  [2371] = {.lex_state = 68, .external_lex_state = 2},
  [2372] = {.lex_state = 68},
  [2373] = {.lex_state = 68},
  [2374] = {.lex_state = 68},
  [2375] = {.lex_state = 68},
  [2376] = {.lex_state = 68},
  [2377] = {.lex_state = 68},
  [2378] = {.lex_state = 68},
  [2379] = {.lex_state = 68},
  [2380] = {.lex_state = 68},
  [2381] = {.lex_state = 68},
  [2382] = {.lex_state = 68, .external_lex_state = 2},
  [2383] = {.lex_state = 68},
  [2384] = {.lex_state = 68},
  [2385] = {.lex_state = 68},
  [2386] = {.lex_state = 68},
  [2387] = {.lex_state = 68, .external_lex_state = 2},
  [2388] = {.lex_state = 68, .external_lex_state = 2},
  [2389] = {.lex_state = 68},
  [2390] = {.lex_state = 68},
  [2391] = {.lex_state = 68},
  [2392] = {.lex_state = 68, .external_lex_state = 2},
  [2393] = {.lex_state = 68, .external_lex_state = 2},
  [2394] = {.lex_state = 68},
  [2395] = {.lex_state = 68},
  [2396] = {.lex_state = 68, .external_lex_state = 2},
  [2397] = {.lex_state = 68},
  [2398] = {.lex_state = 3, .external_lex_state = 12},
  [2399] = {.lex_state = 68},
  [2400] = {.lex_state = 3, .external_lex_state = 12},
  [2401] = {.lex_state = 68},
  [2402] = {.lex_state = 68},
  [2403] = {.lex_state = 68},
  [2404] = {.lex_state = 68},
  [2405] = {.lex_state = 68},
  [2406] = {.lex_state = 68},
  [2407] = {.lex_state = 68},
  [2408] = {.lex_state = 68, .external_lex_state = 2},
  [2409] = {.lex_state = 68},
  [2410] = {.lex_state = 68},
  [2411] = {.lex_state = 68},
  [2412] = {.lex_state = 68, .external_lex_state = 2},
  [2413] = {.lex_state = 68},
  [2414] = {.lex_state = 68},
  [2415] = {.lex_state = 68},
  [2416] = {.lex_state = 68},
  [2417] = {.lex_state = 68, .external_lex_state = 2},
  [2418] = {.lex_state = 68, .external_lex_state = 2},
  [2419] = {.lex_state = 68},
  [2420] = {.lex_state = 68, .external_lex_state = 2},
  [2421] = {.lex_state = 68},
  [2422] = {.lex_state = 68},
  [2423] = {.lex_state = 68},
  [2424] = {.lex_state = 68},
  [2425] = {.lex_state = 68},
  [2426] = {.lex_state = 68},
  [2427] = {.lex_state = 68, .external_lex_state = 2},
  [2428] = {.lex_state = 68},
  [2429] = {.lex_state = 3, .external_lex_state = 12},
  [2430] = {.lex_state = 3, .external_lex_state = 12},
  [2431] = {.lex_state = 68},
  [2432] = {.lex_state = 68},
  [2433] = {.lex_state = 68},
  [2434] = {.lex_state = 68, .external_lex_state = 2},
  [2435] = {.lex_state = 68},
  [2436] = {.lex_state = 68, .external_lex_state = 2},
  [2437] = {.lex_state = 68},
  [2438] = {.lex_state = 68},
  [2439] = {.lex_state = 68},
  [2440] = {.lex_state = 3, .external_lex_state = 12},
  [2441] = {.lex_state = 68},
  [2442] = {.lex_state = 68},
  [2443] = {.lex_state = 68, .external_lex_state = 2},
  [2444] = {.lex_state = 68, .external_lex_state = 2},
  [2445] = {.lex_state = 68},
  [2446] = {.lex_state = 68, .external_lex_state = 2},
  [2447] = {.lex_state = 68, .external_lex_state = 2},
  [2448] = {.lex_state = 68, .external_lex_state = 2},
  [2449] = {.lex_state = 68, .external_lex_state = 2},
  [2450] = {.lex_state = 68},
  [2451] = {.lex_state = 68},
  [2452] = {.lex_state = 68},
  [2453] = {.lex_state = 68, .external_lex_state = 2},
  [2454] = {.lex_state = 68},
  [2455] = {.lex_state = 68},
  [2456] = {.lex_state = 68},
  [2457] = {.lex_state = 68},
  [2458] = {.lex_state = 68, .external_lex_state = 2},
  [2459] = {.lex_state = 68},
  [2460] = {.lex_state = 68},
  [2461] = {.lex_state = 68},
  [2462] = {.lex_state = 68, .external_lex_state = 2},
  [2463] = {.lex_state = 68},
  [2464] = {.lex_state = 68},
  [2465] = {.lex_state = 68},
  [2466] = {.lex_state = 68},
  [2467] = {.lex_state = 68},
  [2468] = {.lex_state = 68, .external_lex_state = 2},
  [2469] = {.lex_state = 68},
  [2470] = {.lex_state = 68},
  [2471] = {.lex_state = 68},
  [2472] = {.lex_state = 68},
  [2473] = {.lex_state = 68},
  [2474] = {.lex_state = 68},
  [2475] = {.lex_state = 68},
  [2476] = {.lex_state = 68},
  [2477] = {.lex_state = 68},
  [2478] = {.lex_state = 68},
  [2479] = {.lex_state = 68},
  [2480] = {.lex_state = 68},
  [2481] = {.lex_state = 68},
  [2482] = {.lex_state = 68},
  [2483] = {.lex_state = 68},
  [2484] = {.lex_state = 68},
  [2485] = {.lex_state = 68, .external_lex_state = 2},
  [2486] = {.lex_state = 68},
  [2487] = {.lex_state = 68},
  [2488] = {.lex_state = 68},
  [2489] = {.lex_state = 68},
  [2490] = {.lex_state = 68},
  [2491] = {.lex_state = 68},
  [2492] = {.lex_state = 68},
  [2493] = {.lex_state = 68},
  [2494] = {.lex_state = 68, .external_lex_state = 12},
  [2495] = {.lex_state = 68},
  [2496] = {.lex_state = 68},
  [2497] = {.lex_state = 68},
  [2498] = {.lex_state = 68, .external_lex_state = 12},
  [2499] = {.lex_state = 68},
  [2500] = {.lex_state = 68},
  [2501] = {.lex_state = 68},
  [2502] = {.lex_state = 68},
  [2503] = {.lex_state = 68},
  [2504] = {.lex_state = 68},
  [2505] = {.lex_state = 68},
  [2506] = {.lex_state = 68},
  [2507] = {.lex_state = 68},
  [2508] = {.lex_state = 68},
  [2509] = {.lex_state = 68},
  [2510] = {.lex_state = 68},
  [2511] = {.lex_state = 68},
  [2512] = {.lex_state = 68},
  [2513] = {.lex_state = 68},
  [2514] = {.lex_state = 68},
  [2515] = {.lex_state = 8},
  [2516] = {.lex_state = 8},
  [2517] = {.lex_state = 68},
  [2518] = {.lex_state = 68},
  [2519] = {.lex_state = 68},
  [2520] = {.lex_state = 68},
  [2521] = {.lex_state = 68},
  [2522] = {.lex_state = 68},
  [2523] = {.lex_state = 68},
  [2524] = {.lex_state = 68},
  [2525] = {.lex_state = 68},
  [2526] = {.lex_state = 68},
  [2527] = {.lex_state = 68},
  [2528] = {.lex_state = 68},
  [2529] = {.lex_state = 68},
  [2530] = {.lex_state = 68},
  [2531] = {.lex_state = 68},
  [2532] = {.lex_state = 68},
  [2533] = {.lex_state = 68},
  [2534] = {.lex_state = 68},
  [2535] = {.lex_state = 68},
  [2536] = {.lex_state = 68},
  [2537] = {.lex_state = 68},
  [2538] = {.lex_state = 68},
  [2539] = {.lex_state = 68},
  [2540] = {.lex_state = 68},
  [2541] = {.lex_state = 68},
  [2542] = {.lex_state = 68},
  [2543] = {.lex_state = 68},
  [2544] = {.lex_state = 68},
  [2545] = {.lex_state = 68},
  [2546] = {.lex_state = 68, .external_lex_state = 13},
  [2547] = {.lex_state = 68, .external_lex_state = 13},
  [2548] = {.lex_state = 68},
  [2549] = {.lex_state = 68},
  [2550] = {.lex_state = 68},
  [2551] = {.lex_state = 68},
  [2552] = {.lex_state = 68},
  [2553] = {.lex_state = 68},
  [2554] = {.lex_state = 68},
  [2555] = {.lex_state = 68},
  [2556] = {.lex_state = 68},
  [2557] = {.lex_state = 68},
  [2558] = {.lex_state = 68},
  [2559] = {.lex_state = 68},
  [2560] = {.lex_state = 68},
  [2561] = {.lex_state = 68},
  [2562] = {.lex_state = 68},
  [2563] = {.lex_state = 68},
  [2564] = {.lex_state = 68},
  [2565] = {.lex_state = 68},
  [2566] = {.lex_state = 68},
  [2567] = {.lex_state = 68},
  [2568] = {.lex_state = 68},
  [2569] = {.lex_state = 68},
  [2570] = {.lex_state = 68},
  [2571] = {.lex_state = 68},
  [2572] = {.lex_state = 68},
  [2573] = {.lex_state = 68},
  [2574] = {.lex_state = 68},
  [2575] = {.lex_state = 68},
  [2576] = {.lex_state = 68},
  [2577] = {.lex_state = 68},
  [2578] = {.lex_state = 68},
  [2579] = {.lex_state = 68},
  [2580] = {.lex_state = 68},
  [2581] = {.lex_state = 68},
  [2582] = {.lex_state = 68, .external_lex_state = 12},
  [2583] = {.lex_state = 68},
  [2584] = {.lex_state = 8},
  [2585] = {.lex_state = 8},
  [2586] = {.lex_state = 68},
  [2587] = {.lex_state = 68},
  [2588] = {.lex_state = 68},
  [2589] = {.lex_state = 68, .external_lex_state = 12},
  [2590] = {.lex_state = 68},
  [2591] = {.lex_state = 68},
  [2592] = {.lex_state = 68},
  [2593] = {.lex_state = 68},
  [2594] = {.lex_state = 68},
  [2595] = {.lex_state = 68},
  [2596] = {.lex_state = 68},
  [2597] = {.lex_state = 68},
  [2598] = {.lex_state = 68},
  [2599] = {.lex_state = 68},
  [2600] = {.lex_state = 68},
  [2601] = {.lex_state = 68},
  [2602] = {.lex_state = 68},
  [2603] = {.lex_state = 68},
  [2604] = {.lex_state = 68},
  [2605] = {.lex_state = 68},
  [2606] = {.lex_state = 68},
  [2607] = {.lex_state = 68},
  [2608] = {.lex_state = 68},
  [2609] = {.lex_state = 68},
  [2610] = {.lex_state = 68},
  [2611] = {.lex_state = 68},
  [2612] = {.lex_state = 68},
  [2613] = {.lex_state = 68, .external_lex_state = 13},
  [2614] = {.lex_state = 68, .external_lex_state = 13},
  [2615] = {.lex_state = 68},
  [2616] = {.lex_state = 68},
  [2617] = {.lex_state = 68},
  [2618] = {.lex_state = 68},
  [2619] = {.lex_state = 68},
  [2620] = {.lex_state = 68},
  [2621] = {.lex_state = 68},
  [2622] = {.lex_state = 68},
  [2623] = {.lex_state = 68},
  [2624] = {.lex_state = 68},
  [2625] = {.lex_state = 68},
  [2626] = {.lex_state = 68},
  [2627] = {.lex_state = 68},
  [2628] = {.lex_state = 68},
  [2629] = {.lex_state = 68},
  [2630] = {.lex_state = 68},
  [2631] = {.lex_state = 68},
  [2632] = {.lex_state = 68},
  [2633] = {.lex_state = 68},
  [2634] = {.lex_state = 68},
  [2635] = {.lex_state = 68},
  [2636] = {.lex_state = 68},
  [2637] = {.lex_state = 68},
  [2638] = {.lex_state = 68},
  [2639] = {.lex_state = 68},
  [2640] = {.lex_state = 68},
  [2641] = {.lex_state = 68},
  [2642] = {.lex_state = 68},
  [2643] = {.lex_state = 68},
  [2644] = {.lex_state = 68},
  [2645] = {.lex_state = 68},
  [2646] = {.lex_state = 68},
  [2647] = {.lex_state = 68},
  [2648] = {.lex_state = 68},
  [2649] = {.lex_state = 68},
  [2650] = {.lex_state = 68},
  [2651] = {.lex_state = 68},
  [2652] = {.lex_state = 68},
  [2653] = {.lex_state = 68},
  [2654] = {.lex_state = 68},
  [2655] = {.lex_state = 68},
  [2656] = {.lex_state = 68},
  [2657] = {.lex_state = 68},
  [2658] = {.lex_state = 68},
  [2659] = {.lex_state = 68},
  [2660] = {.lex_state = 68},
  [2661] = {.lex_state = 68},
  [2662] = {.lex_state = 68},
  [2663] = {.lex_state = 68},
  [2664] = {.lex_state = 68},
  [2665] = {.lex_state = 68},
  [2666] = {.lex_state = 68, .external_lex_state = 12},
  [2667] = {.lex_state = 68},
  [2668] = {.lex_state = 68},
  [2669] = {.lex_state = 68},
  [2670] = {.lex_state = 68},
  [2671] = {.lex_state = 68},
  [2672] = {.lex_state = 68},
  [2673] = {.lex_state = 68},
  [2674] = {.lex_state = 68},
  [2675] = {.lex_state = 68},
  [2676] = {.lex_state = 68},
  [2677] = {.lex_state = 68},
  [2678] = {.lex_state = 68},
  [2679] = {.lex_state = 68},
  [2680] = {.lex_state = 68},
  [2681] = {.lex_state = 68},
  [2682] = {.lex_state = 68},
  [2683] = {.lex_state = 68, .external_lex_state = 12},
  [2684] = {.lex_state = 68},
  [2685] = {.lex_state = 68},
  [2686] = {.lex_state = 68},
  [2687] = {.lex_state = 68},
  [2688] = {.lex_state = 68},
  [2689] = {.lex_state = 68},
  [2690] = {.lex_state = 68},
  [2691] = {.lex_state = 68},
  [2692] = {.lex_state = 68},
  [2693] = {.lex_state = 68},
  [2694] = {.lex_state = 68},
  [2695] = {.lex_state = 68},
  [2696] = {.lex_state = 68},
  [2697] = {.lex_state = 68},
  [2698] = {.lex_state = 68},
  [2699] = {.lex_state = 68},
  [2700] = {.lex_state = 68},
  [2701] = {.lex_state = 68},
  [2702] = {.lex_state = 68},
  [2703] = {.lex_state = 68},
  [2704] = {.lex_state = 68},
  [2705] = {.lex_state = 68},
  [2706] = {.lex_state = 68},
  [2707] = {.lex_state = 68},
  [2708] = {.lex_state = 68},
  [2709] = {(TSStateId)(-1)},
  [2710] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_text_interpolation] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_name] = ACTIONS(1),
    [sym_php_tag] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_text_token1] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [aux_sym_global_declaration_token1] = ACTIONS(1),
    [aux_sym_namespace_definition_token1] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [aux_sym_trait_declaration_token1] = ACTIONS(1),
    [aux_sym_interface_declaration_token1] = ACTIONS(1),
    [aux_sym_base_clause_token1] = ACTIONS(1),
    [aux_sym_enum_declaration_token1] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [aux_sym_enum_case_token1] = ACTIONS(1),
    [aux_sym_class_declaration_token1] = ACTIONS(1),
    [aux_sym_final_modifier_token1] = ACTIONS(1),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1),
    [aux_sym_class_interface_clause_token1] = ACTIONS(1),
    [sym_var_modifier] = ACTIONS(1),
    [aux_sym_use_instead_of_clause_token1] = ACTIONS(1),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym_bottom_type] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_array] = ACTIONS(1),
    [aux_sym_primitive_type_token1] = ACTIONS(1),
    [anon_sym_iterable] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_mixed] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [aux_sym_cast_type_token1] = ACTIONS(1),
    [aux_sym_cast_type_token2] = ACTIONS(1),
    [aux_sym_cast_type_token3] = ACTIONS(1),
    [aux_sym_cast_type_token4] = ACTIONS(1),
    [aux_sym_cast_type_token5] = ACTIONS(1),
    [aux_sym_cast_type_token6] = ACTIONS(1),
    [aux_sym_cast_type_token7] = ACTIONS(1),
    [aux_sym_cast_type_token8] = ACTIONS(1),
    [aux_sym_cast_type_token9] = ACTIONS(1),
    [aux_sym_cast_type_token10] = ACTIONS(1),
    [aux_sym_cast_type_token11] = ACTIONS(1),
    [aux_sym_cast_type_token12] = ACTIONS(1),
    [aux_sym_echo_statement_token1] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [aux_sym_declare_statement_token1] = ACTIONS(1),
    [aux_sym_declare_statement_token2] = ACTIONS(1),
    [anon_sym_ticks] = ACTIONS(1),
    [anon_sym_encoding] = ACTIONS(1),
    [anon_sym_strict_types] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [aux_sym_try_statement_token1] = ACTIONS(1),
    [aux_sym_catch_clause_token1] = ACTIONS(1),
    [aux_sym_finally_clause_token1] = ACTIONS(1),
    [aux_sym_goto_statement_token1] = ACTIONS(1),
    [aux_sym_continue_statement_token1] = ACTIONS(1),
    [aux_sym_break_statement_token1] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [aux_sym_return_statement_token1] = ACTIONS(1),
    [aux_sym_throw_expression_token1] = ACTIONS(1),
    [aux_sym_while_statement_token1] = ACTIONS(1),
    [aux_sym_while_statement_token2] = ACTIONS(1),
    [aux_sym_do_statement_token1] = ACTIONS(1),
    [aux_sym_for_statement_token1] = ACTIONS(1),
    [aux_sym_for_statement_token2] = ACTIONS(1),
    [aux_sym_foreach_statement_token1] = ACTIONS(1),
    [aux_sym_foreach_statement_token2] = ACTIONS(1),
    [aux_sym_if_statement_token1] = ACTIONS(1),
    [aux_sym_if_statement_token2] = ACTIONS(1),
    [aux_sym_else_if_clause_token1] = ACTIONS(1),
    [aux_sym_else_clause_token1] = ACTIONS(1),
    [aux_sym_match_expression_token1] = ACTIONS(1),
    [aux_sym_match_default_expression_token1] = ACTIONS(1),
    [aux_sym_switch_statement_token1] = ACTIONS(1),
    [aux_sym_switch_block_token1] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [aux_sym_clone_expression_token1] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_QMARK_DASH_GT] = ACTIONS(1),
    [aux_sym__list_destructing_token1] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_self] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [aux_sym__argument_name_token1] = ACTIONS(1),
    [aux_sym__argument_name_token2] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(1),
    [aux_sym_encapsed_string_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_string_token1] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym_string_token2] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_SQUOTE2] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [aux_sym_yield_expression_token1] = ACTIONS(1),
    [aux_sym_yield_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token1] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [aux_sym_binary_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token3] = ACTIONS(1),
    [aux_sym_binary_expression_token4] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [aux_sym_include_expression_token1] = ACTIONS(1),
    [aux_sym_include_once_expression_token1] = ACTIONS(1),
    [aux_sym_require_expression_token1] = ACTIONS(1),
    [aux_sym_require_once_expression_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym_encapsed_string_chars] = ACTIONS(1),
    [sym_encapsed_string_chars_after_variable] = ACTIONS(1),
    [sym_execution_string_chars] = ACTIONS(1),
    [sym_execution_string_chars_after_variable] = ACTIONS(1),
    [sym_encapsed_string_chars_heredoc] = ACTIONS(1),
    [sym_encapsed_string_chars_after_variable_heredoc] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
    [sym_heredoc_start] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_nowdoc_string] = ACTIONS(1),
    [sym_sentinel_error] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2705),
    [sym_text_interpolation] = STATE(1),
    [sym_text] = STATE(2222),
    [aux_sym_text_repeat1] = STATE(1685),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_php_tag] = ACTIONS(9),
    [anon_sym_QMARK_GT] = ACTIONS(11),
    [aux_sym_text_token1] = ACTIONS(13),
    [aux_sym_text_token2] = ACTIONS(15),
    [sym_comment] = ACTIONS(5),
  },
  [2] = {
    [sym_text_interpolation] = STATE(2),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [ts_builtin_sym_end] = ACTIONS(17),
    [sym_name] = ACTIONS(19),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(22),
    [aux_sym_function_static_declaration_token1] = ACTIONS(25),
    [aux_sym_global_declaration_token1] = ACTIONS(28),
    [aux_sym_namespace_definition_token1] = ACTIONS(31),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(34),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(37),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(40),
    [anon_sym_BSLASH] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(46),
    [anon_sym_RBRACE] = ACTIONS(17),
    [aux_sym_trait_declaration_token1] = ACTIONS(49),
    [aux_sym_interface_declaration_token1] = ACTIONS(52),
    [aux_sym_enum_declaration_token1] = ACTIONS(55),
    [aux_sym_enum_case_token1] = ACTIONS(58),
    [aux_sym_class_declaration_token1] = ACTIONS(60),
    [aux_sym_final_modifier_token1] = ACTIONS(63),
    [aux_sym_abstract_modifier_token1] = ACTIONS(66),
    [aux_sym_readonly_modifier_token1] = ACTIONS(69),
    [aux_sym_visibility_modifier_token1] = ACTIONS(72),
    [aux_sym_visibility_modifier_token2] = ACTIONS(72),
    [aux_sym_visibility_modifier_token3] = ACTIONS(72),
    [aux_sym__arrow_function_header_token1] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(78),
    [aux_sym_cast_type_token1] = ACTIONS(81),
    [aux_sym_echo_statement_token1] = ACTIONS(84),
    [anon_sym_unset] = ACTIONS(87),
    [aux_sym_declare_statement_token1] = ACTIONS(90),
    [aux_sym_declare_statement_token2] = ACTIONS(58),
    [sym_float] = ACTIONS(93),
    [aux_sym_try_statement_token1] = ACTIONS(96),
    [aux_sym_goto_statement_token1] = ACTIONS(99),
    [aux_sym_continue_statement_token1] = ACTIONS(102),
    [aux_sym_break_statement_token1] = ACTIONS(105),
    [sym_integer] = ACTIONS(93),
    [aux_sym_return_statement_token1] = ACTIONS(108),
    [aux_sym_throw_expression_token1] = ACTIONS(111),
    [aux_sym_while_statement_token1] = ACTIONS(114),
    [aux_sym_while_statement_token2] = ACTIONS(58),
    [aux_sym_do_statement_token1] = ACTIONS(117),
    [aux_sym_for_statement_token1] = ACTIONS(120),
    [aux_sym_for_statement_token2] = ACTIONS(58),
    [aux_sym_foreach_statement_token1] = ACTIONS(123),
    [aux_sym_foreach_statement_token2] = ACTIONS(58),
    [aux_sym_if_statement_token1] = ACTIONS(126),
    [aux_sym_if_statement_token2] = ACTIONS(58),
    [aux_sym_match_expression_token1] = ACTIONS(129),
    [aux_sym_match_default_expression_token1] = ACTIONS(58),
    [aux_sym_switch_statement_token1] = ACTIONS(132),
    [aux_sym_switch_block_token1] = ACTIONS(58),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(141),
    [aux_sym_clone_expression_token1] = ACTIONS(144),
    [aux_sym_print_intrinsic_token1] = ACTIONS(147),
    [aux_sym_object_creation_expression_token1] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(153),
    [aux_sym__list_destructing_token1] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_self] = ACTIONS(162),
    [anon_sym_parent] = ACTIONS(162),
    [aux_sym__argument_name_token1] = ACTIONS(165),
    [aux_sym__argument_name_token2] = ACTIONS(168),
    [anon_sym_POUND_LBRACK] = ACTIONS(171),
    [aux_sym_encapsed_string_token1] = ACTIONS(174),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [aux_sym_string_token1] = ACTIONS(177),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_LT_LT_LT] = ACTIONS(180),
    [anon_sym_BQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(186),
    [aux_sym_yield_expression_token1] = ACTIONS(189),
    [aux_sym_include_expression_token1] = ACTIONS(192),
    [aux_sym_include_once_expression_token1] = ACTIONS(195),
    [aux_sym_require_expression_token1] = ACTIONS(198),
    [aux_sym_require_once_expression_token1] = ACTIONS(201),
    [sym_comment] = ACTIONS(5),
  },
  [3] = {
    [sym_text_interpolation] = STATE(3),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(224),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_enum_case_token1] = ACTIONS(232),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_match_default_expression_token1] = ACTIONS(232),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [aux_sym_switch_block_token1] = ACTIONS(232),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [4] = {
    [sym_text_interpolation] = STATE(4),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(330),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_enum_case_token1] = ACTIONS(332),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_match_default_expression_token1] = ACTIONS(332),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [aux_sym_switch_block_token1] = ACTIONS(332),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [5] = {
    [sym_text_interpolation] = STATE(5),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(334),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_enum_case_token1] = ACTIONS(336),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_match_default_expression_token1] = ACTIONS(336),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [aux_sym_switch_block_token1] = ACTIONS(336),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [6] = {
    [sym_text_interpolation] = STATE(6),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(3),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(338),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_enum_case_token1] = ACTIONS(340),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_match_default_expression_token1] = ACTIONS(340),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [aux_sym_switch_block_token1] = ACTIONS(340),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [7] = {
    [sym_text_interpolation] = STATE(7),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_while_statement_token2] = ACTIONS(342),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_foreach_statement_token2] = ACTIONS(342),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_if_statement_token2] = ACTIONS(342),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [8] = {
    [sym_text_interpolation] = STATE(8),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_if_statement_token2] = ACTIONS(354),
    [aux_sym_else_if_clause_token1] = ACTIONS(354),
    [aux_sym_else_clause_token1] = ACTIONS(354),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [9] = {
    [sym_text_interpolation] = STATE(9),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_if_statement_token2] = ACTIONS(342),
    [aux_sym_else_if_clause_token1] = ACTIONS(342),
    [aux_sym_else_clause_token1] = ACTIONS(342),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [10] = {
    [sym_text_interpolation] = STATE(10),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(19),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(22),
    [aux_sym_function_static_declaration_token1] = ACTIONS(25),
    [aux_sym_global_declaration_token1] = ACTIONS(28),
    [aux_sym_namespace_definition_token1] = ACTIONS(31),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(34),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(37),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(40),
    [anon_sym_BSLASH] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(46),
    [aux_sym_trait_declaration_token1] = ACTIONS(49),
    [aux_sym_interface_declaration_token1] = ACTIONS(52),
    [aux_sym_enum_declaration_token1] = ACTIONS(55),
    [aux_sym_class_declaration_token1] = ACTIONS(60),
    [aux_sym_final_modifier_token1] = ACTIONS(63),
    [aux_sym_abstract_modifier_token1] = ACTIONS(66),
    [aux_sym_readonly_modifier_token1] = ACTIONS(69),
    [aux_sym_visibility_modifier_token1] = ACTIONS(72),
    [aux_sym_visibility_modifier_token2] = ACTIONS(72),
    [aux_sym_visibility_modifier_token3] = ACTIONS(72),
    [aux_sym__arrow_function_header_token1] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(78),
    [aux_sym_cast_type_token1] = ACTIONS(81),
    [aux_sym_echo_statement_token1] = ACTIONS(84),
    [anon_sym_unset] = ACTIONS(87),
    [aux_sym_declare_statement_token1] = ACTIONS(356),
    [sym_float] = ACTIONS(93),
    [aux_sym_try_statement_token1] = ACTIONS(96),
    [aux_sym_goto_statement_token1] = ACTIONS(99),
    [aux_sym_continue_statement_token1] = ACTIONS(102),
    [aux_sym_break_statement_token1] = ACTIONS(105),
    [sym_integer] = ACTIONS(93),
    [aux_sym_return_statement_token1] = ACTIONS(108),
    [aux_sym_throw_expression_token1] = ACTIONS(111),
    [aux_sym_while_statement_token1] = ACTIONS(359),
    [aux_sym_do_statement_token1] = ACTIONS(117),
    [aux_sym_for_statement_token1] = ACTIONS(362),
    [aux_sym_foreach_statement_token1] = ACTIONS(365),
    [aux_sym_if_statement_token1] = ACTIONS(368),
    [aux_sym_if_statement_token2] = ACTIONS(58),
    [aux_sym_else_if_clause_token1] = ACTIONS(58),
    [aux_sym_else_clause_token1] = ACTIONS(58),
    [aux_sym_match_expression_token1] = ACTIONS(129),
    [aux_sym_switch_statement_token1] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(138),
    [anon_sym_BANG] = ACTIONS(138),
    [anon_sym_AT] = ACTIONS(141),
    [aux_sym_clone_expression_token1] = ACTIONS(144),
    [aux_sym_print_intrinsic_token1] = ACTIONS(147),
    [aux_sym_object_creation_expression_token1] = ACTIONS(150),
    [anon_sym_DASH_DASH] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(153),
    [aux_sym__list_destructing_token1] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_self] = ACTIONS(162),
    [anon_sym_parent] = ACTIONS(162),
    [aux_sym__argument_name_token1] = ACTIONS(165),
    [aux_sym__argument_name_token2] = ACTIONS(168),
    [anon_sym_POUND_LBRACK] = ACTIONS(171),
    [aux_sym_encapsed_string_token1] = ACTIONS(174),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [aux_sym_string_token1] = ACTIONS(177),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_LT_LT_LT] = ACTIONS(180),
    [anon_sym_BQUOTE] = ACTIONS(183),
    [anon_sym_DOLLAR] = ACTIONS(186),
    [aux_sym_yield_expression_token1] = ACTIONS(189),
    [aux_sym_include_expression_token1] = ACTIONS(192),
    [aux_sym_include_once_expression_token1] = ACTIONS(195),
    [aux_sym_require_expression_token1] = ACTIONS(198),
    [aux_sym_require_once_expression_token1] = ACTIONS(201),
    [sym_comment] = ACTIONS(5),
  },
  [11] = {
    [sym_text_interpolation] = STATE(11),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_while_statement_token2] = ACTIONS(354),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_foreach_statement_token2] = ACTIONS(354),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_if_statement_token2] = ACTIONS(354),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [12] = {
    [sym_text_interpolation] = STATE(12),
    [sym_empty_statement] = STATE(473),
    [sym_function_static_declaration] = STATE(473),
    [sym_global_declaration] = STATE(473),
    [sym_namespace_definition] = STATE(473),
    [sym_namespace_use_declaration] = STATE(473),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(473),
    [sym_interface_declaration] = STATE(473),
    [sym_enum_declaration] = STATE(473),
    [sym_class_declaration] = STATE(473),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(473),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(473),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(473),
    [sym_unset_statement] = STATE(473),
    [sym_declare_statement] = STATE(473),
    [sym_try_statement] = STATE(473),
    [sym_goto_statement] = STATE(473),
    [sym_continue_statement] = STATE(473),
    [sym_break_statement] = STATE(473),
    [sym_return_statement] = STATE(473),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(473),
    [sym_do_statement] = STATE(473),
    [sym_for_statement] = STATE(473),
    [sym_foreach_statement] = STATE(473),
    [sym_if_statement] = STATE(473),
    [sym_colon_block] = STATE(2569),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(473),
    [sym_compound_statement] = STATE(473),
    [sym_named_label_statement] = STATE(473),
    [sym_expression_statement] = STATE(473),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(371),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(375),
  },
  [13] = {
    [sym_text_interpolation] = STATE(13),
    [sym_empty_statement] = STATE(473),
    [sym_function_static_declaration] = STATE(473),
    [sym_global_declaration] = STATE(473),
    [sym_namespace_definition] = STATE(473),
    [sym_namespace_use_declaration] = STATE(473),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(473),
    [sym_interface_declaration] = STATE(473),
    [sym_enum_declaration] = STATE(473),
    [sym_class_declaration] = STATE(473),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(473),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(473),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(473),
    [sym_unset_statement] = STATE(473),
    [sym_declare_statement] = STATE(473),
    [sym_try_statement] = STATE(473),
    [sym_goto_statement] = STATE(473),
    [sym_continue_statement] = STATE(473),
    [sym_break_statement] = STATE(473),
    [sym_return_statement] = STATE(473),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(473),
    [sym_do_statement] = STATE(473),
    [sym_for_statement] = STATE(473),
    [sym_foreach_statement] = STATE(473),
    [sym_if_statement] = STATE(473),
    [sym_colon_block] = STATE(2569),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(473),
    [sym_compound_statement] = STATE(473),
    [sym_named_label_statement] = STATE(473),
    [sym_expression_statement] = STATE(473),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(371),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(375),
  },
  [14] = {
    [sym_text_interpolation] = STATE(14),
    [sym_empty_statement] = STATE(2019),
    [sym_function_static_declaration] = STATE(2019),
    [sym_global_declaration] = STATE(2019),
    [sym_namespace_definition] = STATE(2019),
    [sym_namespace_use_declaration] = STATE(2019),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2019),
    [sym_interface_declaration] = STATE(2019),
    [sym_enum_declaration] = STATE(2019),
    [sym_class_declaration] = STATE(2019),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2019),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2019),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2019),
    [sym_unset_statement] = STATE(2019),
    [sym_declare_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_goto_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_break_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_colon_block] = STATE(2539),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2019),
    [sym_compound_statement] = STATE(2019),
    [sym_named_label_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(379),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(429),
  },
  [15] = {
    [sym_text_interpolation] = STATE(15),
    [sym_empty_statement] = STATE(2019),
    [sym_function_static_declaration] = STATE(2019),
    [sym_global_declaration] = STATE(2019),
    [sym_namespace_definition] = STATE(2019),
    [sym_namespace_use_declaration] = STATE(2019),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2019),
    [sym_interface_declaration] = STATE(2019),
    [sym_enum_declaration] = STATE(2019),
    [sym_class_declaration] = STATE(2019),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2019),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2019),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2019),
    [sym_unset_statement] = STATE(2019),
    [sym_declare_statement] = STATE(2019),
    [sym_try_statement] = STATE(2019),
    [sym_goto_statement] = STATE(2019),
    [sym_continue_statement] = STATE(2019),
    [sym_break_statement] = STATE(2019),
    [sym_return_statement] = STATE(2019),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2019),
    [sym_do_statement] = STATE(2019),
    [sym_for_statement] = STATE(2019),
    [sym_foreach_statement] = STATE(2019),
    [sym_if_statement] = STATE(2019),
    [sym_colon_block] = STATE(2539),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2019),
    [sym_compound_statement] = STATE(2019),
    [sym_named_label_statement] = STATE(2019),
    [sym_expression_statement] = STATE(2019),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(379),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(429),
  },
  [16] = {
    [sym_text_interpolation] = STATE(16),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(63),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(441),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [17] = {
    [sym_text_interpolation] = STATE(17),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(50),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [aux_sym_declare_statement_token2] = ACTIONS(443),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [18] = {
    [sym_text_interpolation] = STATE(18),
    [sym_empty_statement] = STATE(486),
    [sym_function_static_declaration] = STATE(486),
    [sym_global_declaration] = STATE(486),
    [sym_namespace_definition] = STATE(486),
    [sym_namespace_use_declaration] = STATE(486),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(486),
    [sym_interface_declaration] = STATE(486),
    [sym_enum_declaration] = STATE(486),
    [sym_class_declaration] = STATE(486),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(486),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(486),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(486),
    [sym_unset_statement] = STATE(486),
    [sym_declare_statement] = STATE(486),
    [sym_try_statement] = STATE(486),
    [sym_goto_statement] = STATE(486),
    [sym_continue_statement] = STATE(486),
    [sym_break_statement] = STATE(486),
    [sym_return_statement] = STATE(486),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(486),
    [sym_do_statement] = STATE(486),
    [sym_for_statement] = STATE(486),
    [sym_foreach_statement] = STATE(486),
    [sym_if_statement] = STATE(486),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(486),
    [sym_compound_statement] = STATE(486),
    [sym_named_label_statement] = STATE(486),
    [sym_expression_statement] = STATE(486),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(445),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(447),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(449),
  },
  [19] = {
    [sym_text_interpolation] = STATE(19),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [ts_builtin_sym_end] = ACTIONS(451),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [20] = {
    [sym_text_interpolation] = STATE(20),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [aux_sym_declare_statement_token2] = ACTIONS(453),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [21] = {
    [sym_text_interpolation] = STATE(21),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [ts_builtin_sym_end] = ACTIONS(455),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [22] = {
    [sym_text_interpolation] = STATE(22),
    [sym_empty_statement] = STATE(490),
    [sym_function_static_declaration] = STATE(490),
    [sym_global_declaration] = STATE(490),
    [sym_namespace_definition] = STATE(490),
    [sym_namespace_use_declaration] = STATE(490),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(490),
    [sym_interface_declaration] = STATE(490),
    [sym_enum_declaration] = STATE(490),
    [sym_class_declaration] = STATE(490),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(490),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(490),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(490),
    [sym_unset_statement] = STATE(490),
    [sym_declare_statement] = STATE(490),
    [sym_try_statement] = STATE(490),
    [sym_goto_statement] = STATE(490),
    [sym_continue_statement] = STATE(490),
    [sym_break_statement] = STATE(490),
    [sym_return_statement] = STATE(490),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(490),
    [sym_do_statement] = STATE(490),
    [sym_for_statement] = STATE(490),
    [sym_foreach_statement] = STATE(490),
    [sym_if_statement] = STATE(490),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(490),
    [sym_compound_statement] = STATE(490),
    [sym_named_label_statement] = STATE(490),
    [sym_expression_statement] = STATE(490),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(457),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(459),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(461),
  },
  [23] = {
    [sym_text_interpolation] = STATE(23),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(66),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(463),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [24] = {
    [sym_text_interpolation] = STATE(24),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(48),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(465),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [25] = {
    [sym_text_interpolation] = STATE(25),
    [sym_empty_statement] = STATE(490),
    [sym_function_static_declaration] = STATE(490),
    [sym_global_declaration] = STATE(490),
    [sym_namespace_definition] = STATE(490),
    [sym_namespace_use_declaration] = STATE(490),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(490),
    [sym_interface_declaration] = STATE(490),
    [sym_enum_declaration] = STATE(490),
    [sym_class_declaration] = STATE(490),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(490),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(490),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(490),
    [sym_unset_statement] = STATE(490),
    [sym_declare_statement] = STATE(490),
    [sym_try_statement] = STATE(490),
    [sym_goto_statement] = STATE(490),
    [sym_continue_statement] = STATE(490),
    [sym_break_statement] = STATE(490),
    [sym_return_statement] = STATE(490),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(490),
    [sym_do_statement] = STATE(490),
    [sym_for_statement] = STATE(490),
    [sym_foreach_statement] = STATE(490),
    [sym_if_statement] = STATE(490),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(490),
    [sym_compound_statement] = STATE(490),
    [sym_named_label_statement] = STATE(490),
    [sym_expression_statement] = STATE(490),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(457),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(459),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(461),
  },
  [26] = {
    [sym_text_interpolation] = STATE(26),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [ts_builtin_sym_end] = ACTIONS(467),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [27] = {
    [sym_text_interpolation] = STATE(27),
    [sym_empty_statement] = STATE(425),
    [sym_function_static_declaration] = STATE(425),
    [sym_global_declaration] = STATE(425),
    [sym_namespace_definition] = STATE(425),
    [sym_namespace_use_declaration] = STATE(425),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(425),
    [sym_interface_declaration] = STATE(425),
    [sym_enum_declaration] = STATE(425),
    [sym_class_declaration] = STATE(425),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(425),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(425),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(425),
    [sym_unset_statement] = STATE(425),
    [sym_declare_statement] = STATE(425),
    [sym_try_statement] = STATE(425),
    [sym_goto_statement] = STATE(425),
    [sym_continue_statement] = STATE(425),
    [sym_break_statement] = STATE(425),
    [sym_return_statement] = STATE(425),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(425),
    [sym_do_statement] = STATE(425),
    [sym_for_statement] = STATE(425),
    [sym_foreach_statement] = STATE(425),
    [sym_if_statement] = STATE(425),
    [sym_colon_block] = STATE(1618),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(425),
    [sym_compound_statement] = STATE(425),
    [sym_named_label_statement] = STATE(425),
    [sym_expression_statement] = STATE(425),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [28] = {
    [sym_text_interpolation] = STATE(28),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [ts_builtin_sym_end] = ACTIONS(467),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [29] = {
    [sym_text_interpolation] = STATE(29),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(471),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [30] = {
    [sym_text_interpolation] = STATE(30),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(473),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [31] = {
    [sym_text_interpolation] = STATE(31),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(70),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(475),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [32] = {
    [sym_text_interpolation] = STATE(32),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(477),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [33] = {
    [sym_text_interpolation] = STATE(33),
    [sym_empty_statement] = STATE(2107),
    [sym_function_static_declaration] = STATE(2107),
    [sym_global_declaration] = STATE(2107),
    [sym_namespace_definition] = STATE(2107),
    [sym_namespace_use_declaration] = STATE(2107),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2107),
    [sym_interface_declaration] = STATE(2107),
    [sym_enum_declaration] = STATE(2107),
    [sym_class_declaration] = STATE(2107),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2107),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2107),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2107),
    [sym_unset_statement] = STATE(2107),
    [sym_declare_statement] = STATE(2107),
    [sym_try_statement] = STATE(2107),
    [sym_goto_statement] = STATE(2107),
    [sym_continue_statement] = STATE(2107),
    [sym_break_statement] = STATE(2107),
    [sym_return_statement] = STATE(2107),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2107),
    [sym_do_statement] = STATE(2107),
    [sym_for_statement] = STATE(2107),
    [sym_foreach_statement] = STATE(2107),
    [sym_if_statement] = STATE(2107),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2107),
    [sym_compound_statement] = STATE(2107),
    [sym_named_label_statement] = STATE(2107),
    [sym_expression_statement] = STATE(2107),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(479),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(481),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(483),
  },
  [34] = {
    [sym_text_interpolation] = STATE(34),
    [sym_empty_statement] = STATE(2027),
    [sym_function_static_declaration] = STATE(2027),
    [sym_global_declaration] = STATE(2027),
    [sym_namespace_definition] = STATE(2027),
    [sym_namespace_use_declaration] = STATE(2027),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2027),
    [sym_interface_declaration] = STATE(2027),
    [sym_enum_declaration] = STATE(2027),
    [sym_class_declaration] = STATE(2027),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2027),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2027),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2027),
    [sym_unset_statement] = STATE(2027),
    [sym_declare_statement] = STATE(2027),
    [sym_try_statement] = STATE(2027),
    [sym_goto_statement] = STATE(2027),
    [sym_continue_statement] = STATE(2027),
    [sym_break_statement] = STATE(2027),
    [sym_return_statement] = STATE(2027),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2027),
    [sym_do_statement] = STATE(2027),
    [sym_for_statement] = STATE(2027),
    [sym_foreach_statement] = STATE(2027),
    [sym_if_statement] = STATE(2027),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2027),
    [sym_compound_statement] = STATE(2027),
    [sym_named_label_statement] = STATE(2027),
    [sym_expression_statement] = STATE(2027),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(485),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(487),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(489),
  },
  [35] = {
    [sym_text_interpolation] = STATE(35),
    [sym_empty_statement] = STATE(518),
    [sym_function_static_declaration] = STATE(518),
    [sym_global_declaration] = STATE(518),
    [sym_namespace_definition] = STATE(518),
    [sym_namespace_use_declaration] = STATE(518),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(518),
    [sym_interface_declaration] = STATE(518),
    [sym_enum_declaration] = STATE(518),
    [sym_class_declaration] = STATE(518),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(518),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(518),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(518),
    [sym_unset_statement] = STATE(518),
    [sym_declare_statement] = STATE(518),
    [sym_try_statement] = STATE(518),
    [sym_goto_statement] = STATE(518),
    [sym_continue_statement] = STATE(518),
    [sym_break_statement] = STATE(518),
    [sym_return_statement] = STATE(518),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(518),
    [sym_do_statement] = STATE(518),
    [sym_for_statement] = STATE(518),
    [sym_foreach_statement] = STATE(518),
    [sym_if_statement] = STATE(518),
    [sym_colon_block] = STATE(2490),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(518),
    [sym_compound_statement] = STATE(518),
    [sym_named_label_statement] = STATE(518),
    [sym_expression_statement] = STATE(518),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [36] = {
    [sym_text_interpolation] = STATE(36),
    [sym_empty_statement] = STATE(532),
    [sym_function_static_declaration] = STATE(532),
    [sym_global_declaration] = STATE(532),
    [sym_namespace_definition] = STATE(532),
    [sym_namespace_use_declaration] = STATE(532),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(532),
    [sym_interface_declaration] = STATE(532),
    [sym_enum_declaration] = STATE(532),
    [sym_class_declaration] = STATE(532),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(532),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(532),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(532),
    [sym_unset_statement] = STATE(532),
    [sym_declare_statement] = STATE(532),
    [sym_try_statement] = STATE(532),
    [sym_goto_statement] = STATE(532),
    [sym_continue_statement] = STATE(532),
    [sym_break_statement] = STATE(532),
    [sym_return_statement] = STATE(532),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(532),
    [sym_do_statement] = STATE(532),
    [sym_for_statement] = STATE(532),
    [sym_foreach_statement] = STATE(532),
    [sym_if_statement] = STATE(532),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(532),
    [sym_compound_statement] = STATE(532),
    [sym_named_label_statement] = STATE(532),
    [sym_expression_statement] = STATE(532),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(491),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(493),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(495),
  },
  [37] = {
    [sym_text_interpolation] = STATE(37),
    [sym_empty_statement] = STATE(518),
    [sym_function_static_declaration] = STATE(518),
    [sym_global_declaration] = STATE(518),
    [sym_namespace_definition] = STATE(518),
    [sym_namespace_use_declaration] = STATE(518),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(518),
    [sym_interface_declaration] = STATE(518),
    [sym_enum_declaration] = STATE(518),
    [sym_class_declaration] = STATE(518),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(518),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(518),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(518),
    [sym_unset_statement] = STATE(518),
    [sym_declare_statement] = STATE(518),
    [sym_try_statement] = STATE(518),
    [sym_goto_statement] = STATE(518),
    [sym_continue_statement] = STATE(518),
    [sym_break_statement] = STATE(518),
    [sym_return_statement] = STATE(518),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(518),
    [sym_do_statement] = STATE(518),
    [sym_for_statement] = STATE(518),
    [sym_foreach_statement] = STATE(518),
    [sym_if_statement] = STATE(518),
    [sym_colon_block] = STATE(2490),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(518),
    [sym_compound_statement] = STATE(518),
    [sym_named_label_statement] = STATE(518),
    [sym_expression_statement] = STATE(518),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [38] = {
    [sym_text_interpolation] = STATE(38),
    [sym_empty_statement] = STATE(1960),
    [sym_function_static_declaration] = STATE(1960),
    [sym_global_declaration] = STATE(1960),
    [sym_namespace_definition] = STATE(1960),
    [sym_namespace_use_declaration] = STATE(1960),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(1960),
    [sym_interface_declaration] = STATE(1960),
    [sym_enum_declaration] = STATE(1960),
    [sym_class_declaration] = STATE(1960),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(1960),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(1960),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(1960),
    [sym_unset_statement] = STATE(1960),
    [sym_declare_statement] = STATE(1960),
    [sym_try_statement] = STATE(1960),
    [sym_goto_statement] = STATE(1960),
    [sym_continue_statement] = STATE(1960),
    [sym_break_statement] = STATE(1960),
    [sym_return_statement] = STATE(1960),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(1960),
    [sym_do_statement] = STATE(1960),
    [sym_for_statement] = STATE(1960),
    [sym_foreach_statement] = STATE(1960),
    [sym_if_statement] = STATE(1960),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(1960),
    [sym_compound_statement] = STATE(1960),
    [sym_named_label_statement] = STATE(1960),
    [sym_expression_statement] = STATE(1960),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(497),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(499),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [39] = {
    [sym_text_interpolation] = STATE(39),
    [sym_empty_statement] = STATE(1679),
    [sym_function_static_declaration] = STATE(1679),
    [sym_global_declaration] = STATE(1679),
    [sym_namespace_definition] = STATE(1679),
    [sym_namespace_use_declaration] = STATE(1679),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(1679),
    [sym_interface_declaration] = STATE(1679),
    [sym_enum_declaration] = STATE(1679),
    [sym_class_declaration] = STATE(1679),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(1679),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(1679),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(1679),
    [sym_unset_statement] = STATE(1679),
    [sym_declare_statement] = STATE(1679),
    [sym_try_statement] = STATE(1679),
    [sym_goto_statement] = STATE(1679),
    [sym_continue_statement] = STATE(1679),
    [sym_break_statement] = STATE(1679),
    [sym_return_statement] = STATE(1679),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(1679),
    [sym_do_statement] = STATE(1679),
    [sym_for_statement] = STATE(1679),
    [sym_foreach_statement] = STATE(1679),
    [sym_if_statement] = STATE(1679),
    [sym_colon_block] = STATE(1633),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(1679),
    [sym_compound_statement] = STATE(1679),
    [sym_named_label_statement] = STATE(1679),
    [sym_expression_statement] = STATE(1679),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [40] = {
    [sym_text_interpolation] = STATE(40),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(505),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [41] = {
    [sym_text_interpolation] = STATE(41),
    [sym_empty_statement] = STATE(2011),
    [sym_function_static_declaration] = STATE(2011),
    [sym_global_declaration] = STATE(2011),
    [sym_namespace_definition] = STATE(2011),
    [sym_namespace_use_declaration] = STATE(2011),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2011),
    [sym_interface_declaration] = STATE(2011),
    [sym_enum_declaration] = STATE(2011),
    [sym_class_declaration] = STATE(2011),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2011),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2011),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2011),
    [sym_unset_statement] = STATE(2011),
    [sym_declare_statement] = STATE(2011),
    [sym_try_statement] = STATE(2011),
    [sym_goto_statement] = STATE(2011),
    [sym_continue_statement] = STATE(2011),
    [sym_break_statement] = STATE(2011),
    [sym_return_statement] = STATE(2011),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2011),
    [sym_do_statement] = STATE(2011),
    [sym_for_statement] = STATE(2011),
    [sym_foreach_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_colon_block] = STATE(2592),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2011),
    [sym_compound_statement] = STATE(2011),
    [sym_named_label_statement] = STATE(2011),
    [sym_expression_statement] = STATE(2011),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [42] = {
    [sym_text_interpolation] = STATE(42),
    [sym_empty_statement] = STATE(2106),
    [sym_function_static_declaration] = STATE(2106),
    [sym_global_declaration] = STATE(2106),
    [sym_namespace_definition] = STATE(2106),
    [sym_namespace_use_declaration] = STATE(2106),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2106),
    [sym_interface_declaration] = STATE(2106),
    [sym_enum_declaration] = STATE(2106),
    [sym_class_declaration] = STATE(2106),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2106),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2106),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2106),
    [sym_unset_statement] = STATE(2106),
    [sym_declare_statement] = STATE(2106),
    [sym_try_statement] = STATE(2106),
    [sym_goto_statement] = STATE(2106),
    [sym_continue_statement] = STATE(2106),
    [sym_break_statement] = STATE(2106),
    [sym_return_statement] = STATE(2106),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2106),
    [sym_do_statement] = STATE(2106),
    [sym_for_statement] = STATE(2106),
    [sym_foreach_statement] = STATE(2106),
    [sym_if_statement] = STATE(2106),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2106),
    [sym_compound_statement] = STATE(2106),
    [sym_named_label_statement] = STATE(2106),
    [sym_expression_statement] = STATE(2106),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(507),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(509),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(511),
  },
  [43] = {
    [sym_text_interpolation] = STATE(43),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(513),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [44] = {
    [sym_text_interpolation] = STATE(44),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(43),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(515),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [45] = {
    [sym_text_interpolation] = STATE(45),
    [sym_empty_statement] = STATE(1954),
    [sym_function_static_declaration] = STATE(1954),
    [sym_global_declaration] = STATE(1954),
    [sym_namespace_definition] = STATE(1954),
    [sym_namespace_use_declaration] = STATE(1954),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(1954),
    [sym_interface_declaration] = STATE(1954),
    [sym_enum_declaration] = STATE(1954),
    [sym_class_declaration] = STATE(1954),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(1954),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(1954),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(1954),
    [sym_unset_statement] = STATE(1954),
    [sym_declare_statement] = STATE(1954),
    [sym_try_statement] = STATE(1954),
    [sym_goto_statement] = STATE(1954),
    [sym_continue_statement] = STATE(1954),
    [sym_break_statement] = STATE(1954),
    [sym_return_statement] = STATE(1954),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(1954),
    [sym_do_statement] = STATE(1954),
    [sym_for_statement] = STATE(1954),
    [sym_foreach_statement] = STATE(1954),
    [sym_if_statement] = STATE(1954),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(1954),
    [sym_compound_statement] = STATE(1954),
    [sym_named_label_statement] = STATE(1954),
    [sym_expression_statement] = STATE(1954),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(517),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(519),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(521),
  },
  [46] = {
    [sym_text_interpolation] = STATE(46),
    [sym_empty_statement] = STATE(2011),
    [sym_function_static_declaration] = STATE(2011),
    [sym_global_declaration] = STATE(2011),
    [sym_namespace_definition] = STATE(2011),
    [sym_namespace_use_declaration] = STATE(2011),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2011),
    [sym_interface_declaration] = STATE(2011),
    [sym_enum_declaration] = STATE(2011),
    [sym_class_declaration] = STATE(2011),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2011),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2011),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2011),
    [sym_unset_statement] = STATE(2011),
    [sym_declare_statement] = STATE(2011),
    [sym_try_statement] = STATE(2011),
    [sym_goto_statement] = STATE(2011),
    [sym_continue_statement] = STATE(2011),
    [sym_break_statement] = STATE(2011),
    [sym_return_statement] = STATE(2011),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2011),
    [sym_do_statement] = STATE(2011),
    [sym_for_statement] = STATE(2011),
    [sym_foreach_statement] = STATE(2011),
    [sym_if_statement] = STATE(2011),
    [sym_colon_block] = STATE(2592),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2011),
    [sym_compound_statement] = STATE(2011),
    [sym_named_label_statement] = STATE(2011),
    [sym_expression_statement] = STATE(2011),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(373),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [47] = {
    [sym_text_interpolation] = STATE(47),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(515),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [48] = {
    [sym_text_interpolation] = STATE(48),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(523),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [49] = {
    [sym_text_interpolation] = STATE(49),
    [sym_empty_statement] = STATE(1954),
    [sym_function_static_declaration] = STATE(1954),
    [sym_global_declaration] = STATE(1954),
    [sym_namespace_definition] = STATE(1954),
    [sym_namespace_use_declaration] = STATE(1954),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(1954),
    [sym_interface_declaration] = STATE(1954),
    [sym_enum_declaration] = STATE(1954),
    [sym_class_declaration] = STATE(1954),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(1954),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(1954),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(1954),
    [sym_unset_statement] = STATE(1954),
    [sym_declare_statement] = STATE(1954),
    [sym_try_statement] = STATE(1954),
    [sym_goto_statement] = STATE(1954),
    [sym_continue_statement] = STATE(1954),
    [sym_break_statement] = STATE(1954),
    [sym_return_statement] = STATE(1954),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(1954),
    [sym_do_statement] = STATE(1954),
    [sym_for_statement] = STATE(1954),
    [sym_foreach_statement] = STATE(1954),
    [sym_if_statement] = STATE(1954),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(1954),
    [sym_compound_statement] = STATE(1954),
    [sym_named_label_statement] = STATE(1954),
    [sym_expression_statement] = STATE(1954),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(517),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(519),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(521),
  },
  [50] = {
    [sym_text_interpolation] = STATE(50),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [aux_sym_declare_statement_token2] = ACTIONS(525),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [51] = {
    [sym_text_interpolation] = STATE(51),
    [sym_empty_statement] = STATE(567),
    [sym_function_static_declaration] = STATE(567),
    [sym_global_declaration] = STATE(567),
    [sym_namespace_definition] = STATE(567),
    [sym_namespace_use_declaration] = STATE(567),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(567),
    [sym_interface_declaration] = STATE(567),
    [sym_enum_declaration] = STATE(567),
    [sym_class_declaration] = STATE(567),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(567),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(567),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(567),
    [sym_unset_statement] = STATE(567),
    [sym_declare_statement] = STATE(567),
    [sym_try_statement] = STATE(567),
    [sym_goto_statement] = STATE(567),
    [sym_continue_statement] = STATE(567),
    [sym_break_statement] = STATE(567),
    [sym_return_statement] = STATE(567),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(567),
    [sym_do_statement] = STATE(567),
    [sym_for_statement] = STATE(567),
    [sym_foreach_statement] = STATE(567),
    [sym_if_statement] = STATE(567),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(567),
    [sym_compound_statement] = STATE(567),
    [sym_named_label_statement] = STATE(567),
    [sym_expression_statement] = STATE(567),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(527),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(529),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(531),
  },
  [52] = {
    [sym_text_interpolation] = STATE(52),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(533),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [53] = {
    [sym_text_interpolation] = STATE(53),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(67),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(535),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [54] = {
    [sym_text_interpolation] = STATE(54),
    [sym_empty_statement] = STATE(2106),
    [sym_function_static_declaration] = STATE(2106),
    [sym_global_declaration] = STATE(2106),
    [sym_namespace_definition] = STATE(2106),
    [sym_namespace_use_declaration] = STATE(2106),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2106),
    [sym_interface_declaration] = STATE(2106),
    [sym_enum_declaration] = STATE(2106),
    [sym_class_declaration] = STATE(2106),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2106),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2106),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2106),
    [sym_unset_statement] = STATE(2106),
    [sym_declare_statement] = STATE(2106),
    [sym_try_statement] = STATE(2106),
    [sym_goto_statement] = STATE(2106),
    [sym_continue_statement] = STATE(2106),
    [sym_break_statement] = STATE(2106),
    [sym_return_statement] = STATE(2106),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2106),
    [sym_do_statement] = STATE(2106),
    [sym_for_statement] = STATE(2106),
    [sym_foreach_statement] = STATE(2106),
    [sym_if_statement] = STATE(2106),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2106),
    [sym_compound_statement] = STATE(2106),
    [sym_named_label_statement] = STATE(2106),
    [sym_expression_statement] = STATE(2106),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(507),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(509),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(511),
  },
  [55] = {
    [sym_text_interpolation] = STATE(55),
    [sym_empty_statement] = STATE(509),
    [sym_function_static_declaration] = STATE(509),
    [sym_global_declaration] = STATE(509),
    [sym_namespace_definition] = STATE(509),
    [sym_namespace_use_declaration] = STATE(509),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(509),
    [sym_interface_declaration] = STATE(509),
    [sym_enum_declaration] = STATE(509),
    [sym_class_declaration] = STATE(509),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(509),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(509),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(509),
    [sym_unset_statement] = STATE(509),
    [sym_declare_statement] = STATE(509),
    [sym_try_statement] = STATE(509),
    [sym_goto_statement] = STATE(509),
    [sym_continue_statement] = STATE(509),
    [sym_break_statement] = STATE(509),
    [sym_return_statement] = STATE(509),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(509),
    [sym_do_statement] = STATE(509),
    [sym_for_statement] = STATE(509),
    [sym_foreach_statement] = STATE(509),
    [sym_if_statement] = STATE(509),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(509),
    [sym_compound_statement] = STATE(509),
    [sym_named_label_statement] = STATE(509),
    [sym_expression_statement] = STATE(509),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(537),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(539),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(541),
  },
  [56] = {
    [sym_text_interpolation] = STATE(56),
    [sym_empty_statement] = STATE(532),
    [sym_function_static_declaration] = STATE(532),
    [sym_global_declaration] = STATE(532),
    [sym_namespace_definition] = STATE(532),
    [sym_namespace_use_declaration] = STATE(532),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(532),
    [sym_interface_declaration] = STATE(532),
    [sym_enum_declaration] = STATE(532),
    [sym_class_declaration] = STATE(532),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(532),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(532),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(532),
    [sym_unset_statement] = STATE(532),
    [sym_declare_statement] = STATE(532),
    [sym_try_statement] = STATE(532),
    [sym_goto_statement] = STATE(532),
    [sym_continue_statement] = STATE(532),
    [sym_break_statement] = STATE(532),
    [sym_return_statement] = STATE(532),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(532),
    [sym_do_statement] = STATE(532),
    [sym_for_statement] = STATE(532),
    [sym_foreach_statement] = STATE(532),
    [sym_if_statement] = STATE(532),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(532),
    [sym_compound_statement] = STATE(532),
    [sym_named_label_statement] = STATE(532),
    [sym_expression_statement] = STATE(532),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(491),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(493),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(495),
  },
  [57] = {
    [sym_text_interpolation] = STATE(57),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(475),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [58] = {
    [sym_text_interpolation] = STATE(58),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(535),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [59] = {
    [sym_text_interpolation] = STATE(59),
    [sym_empty_statement] = STATE(1960),
    [sym_function_static_declaration] = STATE(1960),
    [sym_global_declaration] = STATE(1960),
    [sym_namespace_definition] = STATE(1960),
    [sym_namespace_use_declaration] = STATE(1960),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(1960),
    [sym_interface_declaration] = STATE(1960),
    [sym_enum_declaration] = STATE(1960),
    [sym_class_declaration] = STATE(1960),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(1960),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(1960),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(1960),
    [sym_unset_statement] = STATE(1960),
    [sym_declare_statement] = STATE(1960),
    [sym_try_statement] = STATE(1960),
    [sym_goto_statement] = STATE(1960),
    [sym_continue_statement] = STATE(1960),
    [sym_break_statement] = STATE(1960),
    [sym_return_statement] = STATE(1960),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(1960),
    [sym_do_statement] = STATE(1960),
    [sym_for_statement] = STATE(1960),
    [sym_foreach_statement] = STATE(1960),
    [sym_if_statement] = STATE(1960),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(1960),
    [sym_compound_statement] = STATE(1960),
    [sym_named_label_statement] = STATE(1960),
    [sym_expression_statement] = STATE(1960),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(497),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(499),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [60] = {
    [sym_text_interpolation] = STATE(60),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(47),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(543),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [61] = {
    [sym_text_interpolation] = STATE(61),
    [sym_empty_statement] = STATE(2027),
    [sym_function_static_declaration] = STATE(2027),
    [sym_global_declaration] = STATE(2027),
    [sym_namespace_definition] = STATE(2027),
    [sym_namespace_use_declaration] = STATE(2027),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2027),
    [sym_interface_declaration] = STATE(2027),
    [sym_enum_declaration] = STATE(2027),
    [sym_class_declaration] = STATE(2027),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2027),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2027),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2027),
    [sym_unset_statement] = STATE(2027),
    [sym_declare_statement] = STATE(2027),
    [sym_try_statement] = STATE(2027),
    [sym_goto_statement] = STATE(2027),
    [sym_continue_statement] = STATE(2027),
    [sym_break_statement] = STATE(2027),
    [sym_return_statement] = STATE(2027),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2027),
    [sym_do_statement] = STATE(2027),
    [sym_for_statement] = STATE(2027),
    [sym_foreach_statement] = STATE(2027),
    [sym_if_statement] = STATE(2027),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2027),
    [sym_compound_statement] = STATE(2027),
    [sym_named_label_statement] = STATE(2027),
    [sym_expression_statement] = STATE(2027),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(485),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(487),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(489),
  },
  [62] = {
    [sym_text_interpolation] = STATE(62),
    [sym_empty_statement] = STATE(2107),
    [sym_function_static_declaration] = STATE(2107),
    [sym_global_declaration] = STATE(2107),
    [sym_namespace_definition] = STATE(2107),
    [sym_namespace_use_declaration] = STATE(2107),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2107),
    [sym_interface_declaration] = STATE(2107),
    [sym_enum_declaration] = STATE(2107),
    [sym_class_declaration] = STATE(2107),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2107),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2107),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2107),
    [sym_unset_statement] = STATE(2107),
    [sym_declare_statement] = STATE(2107),
    [sym_try_statement] = STATE(2107),
    [sym_goto_statement] = STATE(2107),
    [sym_continue_statement] = STATE(2107),
    [sym_break_statement] = STATE(2107),
    [sym_return_statement] = STATE(2107),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2107),
    [sym_do_statement] = STATE(2107),
    [sym_for_statement] = STATE(2107),
    [sym_foreach_statement] = STATE(2107),
    [sym_if_statement] = STATE(2107),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2107),
    [sym_compound_statement] = STATE(2107),
    [sym_named_label_statement] = STATE(2107),
    [sym_expression_statement] = STATE(2107),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(479),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(481),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(483),
  },
  [63] = {
    [sym_text_interpolation] = STATE(63),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(545),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [64] = {
    [sym_text_interpolation] = STATE(64),
    [sym_empty_statement] = STATE(509),
    [sym_function_static_declaration] = STATE(509),
    [sym_global_declaration] = STATE(509),
    [sym_namespace_definition] = STATE(509),
    [sym_namespace_use_declaration] = STATE(509),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(509),
    [sym_interface_declaration] = STATE(509),
    [sym_enum_declaration] = STATE(509),
    [sym_class_declaration] = STATE(509),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(509),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(509),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(509),
    [sym_unset_statement] = STATE(509),
    [sym_declare_statement] = STATE(509),
    [sym_try_statement] = STATE(509),
    [sym_goto_statement] = STATE(509),
    [sym_continue_statement] = STATE(509),
    [sym_break_statement] = STATE(509),
    [sym_return_statement] = STATE(509),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(509),
    [sym_do_statement] = STATE(509),
    [sym_for_statement] = STATE(509),
    [sym_foreach_statement] = STATE(509),
    [sym_if_statement] = STATE(509),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(509),
    [sym_compound_statement] = STATE(509),
    [sym_named_label_statement] = STATE(509),
    [sym_expression_statement] = STATE(509),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(537),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(539),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(541),
  },
  [65] = {
    [sym_text_interpolation] = STATE(65),
    [sym_empty_statement] = STATE(1678),
    [sym_function_static_declaration] = STATE(1678),
    [sym_global_declaration] = STATE(1678),
    [sym_namespace_definition] = STATE(1678),
    [sym_namespace_use_declaration] = STATE(1678),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(1678),
    [sym_interface_declaration] = STATE(1678),
    [sym_enum_declaration] = STATE(1678),
    [sym_class_declaration] = STATE(1678),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(1678),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(1678),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(1678),
    [sym_unset_statement] = STATE(1678),
    [sym_declare_statement] = STATE(1678),
    [sym_try_statement] = STATE(1678),
    [sym_goto_statement] = STATE(1678),
    [sym_continue_statement] = STATE(1678),
    [sym_break_statement] = STATE(1678),
    [sym_return_statement] = STATE(1678),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(1678),
    [sym_do_statement] = STATE(1678),
    [sym_for_statement] = STATE(1678),
    [sym_foreach_statement] = STATE(1678),
    [sym_if_statement] = STATE(1678),
    [sym_colon_block] = STATE(1633),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(1678),
    [sym_compound_statement] = STATE(1678),
    [sym_named_label_statement] = STATE(1678),
    [sym_expression_statement] = STATE(1678),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [66] = {
    [sym_text_interpolation] = STATE(66),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(547),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [67] = {
    [sym_text_interpolation] = STATE(67),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(549),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [68] = {
    [sym_text_interpolation] = STATE(68),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(543),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [69] = {
    [sym_text_interpolation] = STATE(69),
    [sym_empty_statement] = STATE(567),
    [sym_function_static_declaration] = STATE(567),
    [sym_global_declaration] = STATE(567),
    [sym_namespace_definition] = STATE(567),
    [sym_namespace_use_declaration] = STATE(567),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(567),
    [sym_interface_declaration] = STATE(567),
    [sym_enum_declaration] = STATE(567),
    [sym_class_declaration] = STATE(567),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(567),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(567),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(567),
    [sym_unset_statement] = STATE(567),
    [sym_declare_statement] = STATE(567),
    [sym_try_statement] = STATE(567),
    [sym_goto_statement] = STATE(567),
    [sym_continue_statement] = STATE(567),
    [sym_break_statement] = STATE(567),
    [sym_return_statement] = STATE(567),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(567),
    [sym_do_statement] = STATE(567),
    [sym_for_statement] = STATE(567),
    [sym_foreach_statement] = STATE(567),
    [sym_if_statement] = STATE(567),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(567),
    [sym_compound_statement] = STATE(567),
    [sym_named_label_statement] = STATE(567),
    [sym_expression_statement] = STATE(567),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(527),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(529),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(531),
  },
  [70] = {
    [sym_text_interpolation] = STATE(70),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(551),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [71] = {
    [sym_text_interpolation] = STATE(71),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(68),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(547),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [72] = {
    [sym_text_interpolation] = STATE(72),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(75),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(553),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [73] = {
    [sym_text_interpolation] = STATE(73),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_for_statement_token2] = ACTIONS(549),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [74] = {
    [sym_text_interpolation] = STATE(74),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [aux_sym_declare_statement_token2] = ACTIONS(555),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [75] = {
    [sym_text_interpolation] = STATE(75),
    [sym_empty_statement] = STATE(546),
    [sym_function_static_declaration] = STATE(546),
    [sym_global_declaration] = STATE(546),
    [sym_namespace_definition] = STATE(546),
    [sym_namespace_use_declaration] = STATE(546),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(546),
    [sym_interface_declaration] = STATE(546),
    [sym_enum_declaration] = STATE(546),
    [sym_class_declaration] = STATE(546),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(546),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(546),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(546),
    [sym_unset_statement] = STATE(546),
    [sym_declare_statement] = STATE(546),
    [sym_try_statement] = STATE(546),
    [sym_goto_statement] = STATE(546),
    [sym_continue_statement] = STATE(546),
    [sym_break_statement] = STATE(546),
    [sym_return_statement] = STATE(546),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(546),
    [sym_do_statement] = STATE(546),
    [sym_for_statement] = STATE(546),
    [sym_foreach_statement] = STATE(546),
    [sym_if_statement] = STATE(546),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(546),
    [sym_compound_statement] = STATE(546),
    [sym_named_label_statement] = STATE(546),
    [sym_expression_statement] = STATE(546),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [anon_sym_RBRACE] = ACTIONS(557),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [76] = {
    [sym_text_interpolation] = STATE(76),
    [sym_empty_statement] = STATE(486),
    [sym_function_static_declaration] = STATE(486),
    [sym_global_declaration] = STATE(486),
    [sym_namespace_definition] = STATE(486),
    [sym_namespace_use_declaration] = STATE(486),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(486),
    [sym_interface_declaration] = STATE(486),
    [sym_enum_declaration] = STATE(486),
    [sym_class_declaration] = STATE(486),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(486),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(486),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(486),
    [sym_unset_statement] = STATE(486),
    [sym_declare_statement] = STATE(486),
    [sym_try_statement] = STATE(486),
    [sym_goto_statement] = STATE(486),
    [sym_continue_statement] = STATE(486),
    [sym_break_statement] = STATE(486),
    [sym_return_statement] = STATE(486),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(486),
    [sym_do_statement] = STATE(486),
    [sym_for_statement] = STATE(486),
    [sym_foreach_statement] = STATE(486),
    [sym_if_statement] = STATE(486),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(486),
    [sym_compound_statement] = STATE(486),
    [sym_named_label_statement] = STATE(486),
    [sym_expression_statement] = STATE(486),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(445),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(447),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(449),
  },
  [77] = {
    [sym_text_interpolation] = STATE(77),
    [sym_empty_statement] = STATE(426),
    [sym_function_static_declaration] = STATE(426),
    [sym_global_declaration] = STATE(426),
    [sym_namespace_definition] = STATE(426),
    [sym_namespace_use_declaration] = STATE(426),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(426),
    [sym_interface_declaration] = STATE(426),
    [sym_enum_declaration] = STATE(426),
    [sym_class_declaration] = STATE(426),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(426),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(426),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(426),
    [sym_unset_statement] = STATE(426),
    [sym_declare_statement] = STATE(426),
    [sym_try_statement] = STATE(426),
    [sym_goto_statement] = STATE(426),
    [sym_continue_statement] = STATE(426),
    [sym_break_statement] = STATE(426),
    [sym_return_statement] = STATE(426),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(426),
    [sym_do_statement] = STATE(426),
    [sym_for_statement] = STATE(426),
    [sym_foreach_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_colon_block] = STATE(1618),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(426),
    [sym_compound_statement] = STATE(426),
    [sym_named_label_statement] = STATE(426),
    [sym_expression_statement] = STATE(426),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [78] = {
    [sym_text_interpolation] = STATE(78),
    [sym_empty_statement] = STATE(2080),
    [sym_function_static_declaration] = STATE(2080),
    [sym_global_declaration] = STATE(2080),
    [sym_namespace_definition] = STATE(2080),
    [sym_namespace_use_declaration] = STATE(2080),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2080),
    [sym_interface_declaration] = STATE(2080),
    [sym_enum_declaration] = STATE(2080),
    [sym_class_declaration] = STATE(2080),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2080),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2080),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2080),
    [sym_unset_statement] = STATE(2080),
    [sym_declare_statement] = STATE(2080),
    [sym_try_statement] = STATE(2080),
    [sym_goto_statement] = STATE(2080),
    [sym_continue_statement] = STATE(2080),
    [sym_break_statement] = STATE(2080),
    [sym_return_statement] = STATE(2080),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2080),
    [sym_do_statement] = STATE(2080),
    [sym_for_statement] = STATE(2080),
    [sym_foreach_statement] = STATE(2080),
    [sym_if_statement] = STATE(2080),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2080),
    [sym_compound_statement] = STATE(2080),
    [sym_named_label_statement] = STATE(2080),
    [sym_expression_statement] = STATE(2080),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [79] = {
    [sym_text_interpolation] = STATE(79),
    [sym_empty_statement] = STATE(2612),
    [sym_function_static_declaration] = STATE(2612),
    [sym_global_declaration] = STATE(2612),
    [sym_namespace_definition] = STATE(2612),
    [sym_namespace_use_declaration] = STATE(2612),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2612),
    [sym_interface_declaration] = STATE(2612),
    [sym_enum_declaration] = STATE(2612),
    [sym_class_declaration] = STATE(2612),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2612),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2612),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2612),
    [sym_unset_statement] = STATE(2612),
    [sym_declare_statement] = STATE(2612),
    [sym_try_statement] = STATE(2612),
    [sym_goto_statement] = STATE(2612),
    [sym_continue_statement] = STATE(2612),
    [sym_break_statement] = STATE(2612),
    [sym_return_statement] = STATE(2612),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2612),
    [sym_do_statement] = STATE(2612),
    [sym_for_statement] = STATE(2612),
    [sym_foreach_statement] = STATE(2612),
    [sym_if_statement] = STATE(2612),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2612),
    [sym_compound_statement] = STATE(2612),
    [sym_named_label_statement] = STATE(2612),
    [sym_expression_statement] = STATE(2612),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [80] = {
    [sym_text_interpolation] = STATE(80),
    [sym_empty_statement] = STATE(2080),
    [sym_function_static_declaration] = STATE(2080),
    [sym_global_declaration] = STATE(2080),
    [sym_namespace_definition] = STATE(2080),
    [sym_namespace_use_declaration] = STATE(2080),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2080),
    [sym_interface_declaration] = STATE(2080),
    [sym_enum_declaration] = STATE(2080),
    [sym_class_declaration] = STATE(2080),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2080),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2080),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2080),
    [sym_unset_statement] = STATE(2080),
    [sym_declare_statement] = STATE(2080),
    [sym_try_statement] = STATE(2080),
    [sym_goto_statement] = STATE(2080),
    [sym_continue_statement] = STATE(2080),
    [sym_break_statement] = STATE(2080),
    [sym_return_statement] = STATE(2080),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2080),
    [sym_do_statement] = STATE(2080),
    [sym_for_statement] = STATE(2080),
    [sym_foreach_statement] = STATE(2080),
    [sym_if_statement] = STATE(2080),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2080),
    [sym_compound_statement] = STATE(2080),
    [sym_named_label_statement] = STATE(2080),
    [sym_expression_statement] = STATE(2080),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [81] = {
    [sym_text_interpolation] = STATE(81),
    [sym_empty_statement] = STATE(547),
    [sym_function_static_declaration] = STATE(547),
    [sym_global_declaration] = STATE(547),
    [sym_namespace_definition] = STATE(547),
    [sym_namespace_use_declaration] = STATE(547),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(547),
    [sym_interface_declaration] = STATE(547),
    [sym_enum_declaration] = STATE(547),
    [sym_class_declaration] = STATE(547),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(547),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(547),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(547),
    [sym_unset_statement] = STATE(547),
    [sym_declare_statement] = STATE(547),
    [sym_try_statement] = STATE(547),
    [sym_goto_statement] = STATE(547),
    [sym_continue_statement] = STATE(547),
    [sym_break_statement] = STATE(547),
    [sym_return_statement] = STATE(547),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(547),
    [sym_do_statement] = STATE(547),
    [sym_for_statement] = STATE(547),
    [sym_foreach_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(547),
    [sym_compound_statement] = STATE(547),
    [sym_named_label_statement] = STATE(547),
    [sym_expression_statement] = STATE(547),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(254),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(270),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(274),
    [aux_sym_foreach_statement_token1] = ACTIONS(276),
    [aux_sym_if_statement_token1] = ACTIONS(278),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [82] = {
    [sym_text_interpolation] = STATE(82),
    [sym_empty_statement] = STATE(547),
    [sym_function_static_declaration] = STATE(547),
    [sym_global_declaration] = STATE(547),
    [sym_namespace_definition] = STATE(547),
    [sym_namespace_use_declaration] = STATE(547),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(547),
    [sym_interface_declaration] = STATE(547),
    [sym_enum_declaration] = STATE(547),
    [sym_class_declaration] = STATE(547),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(547),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(547),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(547),
    [sym_unset_statement] = STATE(547),
    [sym_declare_statement] = STATE(547),
    [sym_try_statement] = STATE(547),
    [sym_goto_statement] = STATE(547),
    [sym_continue_statement] = STATE(547),
    [sym_break_statement] = STATE(547),
    [sym_return_statement] = STATE(547),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(547),
    [sym_do_statement] = STATE(547),
    [sym_for_statement] = STATE(547),
    [sym_foreach_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(547),
    [sym_compound_statement] = STATE(547),
    [sym_named_label_statement] = STATE(547),
    [sym_expression_statement] = STATE(547),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [83] = {
    [sym_text_interpolation] = STATE(83),
    [sym_empty_statement] = STATE(502),
    [sym_function_static_declaration] = STATE(502),
    [sym_global_declaration] = STATE(502),
    [sym_namespace_definition] = STATE(502),
    [sym_namespace_use_declaration] = STATE(502),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(502),
    [sym_interface_declaration] = STATE(502),
    [sym_enum_declaration] = STATE(502),
    [sym_class_declaration] = STATE(502),
    [sym_final_modifier] = STATE(1973),
    [sym_abstract_modifier] = STATE(1973),
    [sym_readonly_modifier] = STATE(2654),
    [sym_const_declaration] = STATE(502),
    [sym__const_declaration] = STATE(543),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2652),
    [sym_function_definition] = STATE(502),
    [sym__function_definition_header] = STATE(2259),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(502),
    [sym_unset_statement] = STATE(502),
    [sym_declare_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_goto_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_foreach_statement] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(502),
    [sym_compound_statement] = STATE(502),
    [sym_named_label_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym__expression] = STATE(1222),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1389),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(208),
    [aux_sym_global_declaration_token1] = ACTIONS(210),
    [aux_sym_namespace_definition_token1] = ACTIONS(212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(214),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(218),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(222),
    [aux_sym_trait_declaration_token1] = ACTIONS(226),
    [aux_sym_interface_declaration_token1] = ACTIONS(228),
    [aux_sym_enum_declaration_token1] = ACTIONS(230),
    [aux_sym_class_declaration_token1] = ACTIONS(234),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(250),
    [anon_sym_unset] = ACTIONS(252),
    [aux_sym_declare_statement_token1] = ACTIONS(344),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(258),
    [aux_sym_goto_statement_token1] = ACTIONS(260),
    [aux_sym_continue_statement_token1] = ACTIONS(262),
    [aux_sym_break_statement_token1] = ACTIONS(264),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(266),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(346),
    [aux_sym_do_statement_token1] = ACTIONS(272),
    [aux_sym_for_statement_token1] = ACTIONS(348),
    [aux_sym_foreach_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token1] = ACTIONS(352),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(282),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [84] = {
    [sym_text_interpolation] = STATE(84),
    [sym_empty_statement] = STATE(2119),
    [sym_function_static_declaration] = STATE(2119),
    [sym_global_declaration] = STATE(2119),
    [sym_namespace_definition] = STATE(2119),
    [sym_namespace_use_declaration] = STATE(2119),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2119),
    [sym_interface_declaration] = STATE(2119),
    [sym_enum_declaration] = STATE(2119),
    [sym_class_declaration] = STATE(2119),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2119),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2119),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2119),
    [sym_unset_statement] = STATE(2119),
    [sym_declare_statement] = STATE(2119),
    [sym_try_statement] = STATE(2119),
    [sym_goto_statement] = STATE(2119),
    [sym_continue_statement] = STATE(2119),
    [sym_break_statement] = STATE(2119),
    [sym_return_statement] = STATE(2119),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2119),
    [sym_do_statement] = STATE(2119),
    [sym_for_statement] = STATE(2119),
    [sym_foreach_statement] = STATE(2119),
    [sym_if_statement] = STATE(2119),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2119),
    [sym_compound_statement] = STATE(2119),
    [sym_named_label_statement] = STATE(2119),
    [sym_expression_statement] = STATE(2119),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(405),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(417),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(421),
    [aux_sym_foreach_statement_token1] = ACTIONS(423),
    [aux_sym_if_statement_token1] = ACTIONS(425),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [85] = {
    [sym_text_interpolation] = STATE(85),
    [sym_empty_statement] = STATE(2571),
    [sym_function_static_declaration] = STATE(2571),
    [sym_global_declaration] = STATE(2571),
    [sym_namespace_definition] = STATE(2571),
    [sym_namespace_use_declaration] = STATE(2571),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_trait_declaration] = STATE(2571),
    [sym_interface_declaration] = STATE(2571),
    [sym_enum_declaration] = STATE(2571),
    [sym_class_declaration] = STATE(2571),
    [sym_final_modifier] = STATE(1994),
    [sym_abstract_modifier] = STATE(1994),
    [sym_readonly_modifier] = STATE(2606),
    [sym_const_declaration] = STATE(2571),
    [sym__const_declaration] = STATE(2004),
    [sym_static_modifier] = STATE(2653),
    [sym_visibility_modifier] = STATE(2607),
    [sym_function_definition] = STATE(2571),
    [sym__function_definition_header] = STATE(2353),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_echo_statement] = STATE(2571),
    [sym_unset_statement] = STATE(2571),
    [sym_declare_statement] = STATE(2571),
    [sym_try_statement] = STATE(2571),
    [sym_goto_statement] = STATE(2571),
    [sym_continue_statement] = STATE(2571),
    [sym_break_statement] = STATE(2571),
    [sym_return_statement] = STATE(2571),
    [sym_throw_expression] = STATE(1047),
    [sym_while_statement] = STATE(2571),
    [sym_do_statement] = STATE(2571),
    [sym_for_statement] = STATE(2571),
    [sym_foreach_statement] = STATE(2571),
    [sym_if_statement] = STATE(2571),
    [sym_match_expression] = STATE(1060),
    [sym_switch_statement] = STATE(2571),
    [sym_compound_statement] = STATE(2571),
    [sym_named_label_statement] = STATE(2571),
    [sym_expression_statement] = STATE(2571),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1390),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(377),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(503),
    [aux_sym_function_static_declaration_token1] = ACTIONS(381),
    [aux_sym_global_declaration_token1] = ACTIONS(383),
    [aux_sym_namespace_definition_token1] = ACTIONS(385),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(389),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(391),
    [aux_sym_trait_declaration_token1] = ACTIONS(393),
    [aux_sym_interface_declaration_token1] = ACTIONS(395),
    [aux_sym_enum_declaration_token1] = ACTIONS(397),
    [aux_sym_class_declaration_token1] = ACTIONS(399),
    [aux_sym_final_modifier_token1] = ACTIONS(236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(238),
    [aux_sym_readonly_modifier_token1] = ACTIONS(240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(242),
    [aux_sym_visibility_modifier_token2] = ACTIONS(242),
    [aux_sym_visibility_modifier_token3] = ACTIONS(242),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [aux_sym_echo_statement_token1] = ACTIONS(401),
    [anon_sym_unset] = ACTIONS(403),
    [aux_sym_declare_statement_token1] = ACTIONS(431),
    [sym_float] = ACTIONS(256),
    [aux_sym_try_statement_token1] = ACTIONS(407),
    [aux_sym_goto_statement_token1] = ACTIONS(409),
    [aux_sym_continue_statement_token1] = ACTIONS(411),
    [aux_sym_break_statement_token1] = ACTIONS(413),
    [sym_integer] = ACTIONS(256),
    [aux_sym_return_statement_token1] = ACTIONS(415),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_while_statement_token1] = ACTIONS(433),
    [aux_sym_do_statement_token1] = ACTIONS(419),
    [aux_sym_for_statement_token1] = ACTIONS(435),
    [aux_sym_foreach_statement_token1] = ACTIONS(437),
    [aux_sym_if_statement_token1] = ACTIONS(439),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [aux_sym_switch_statement_token1] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [86] = {
    [sym_text_interpolation] = STATE(86),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(983),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(921),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(571),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(561),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(561),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(575),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(571),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_yield_expression_token2] = ACTIONS(617),
    [aux_sym_binary_expression_token1] = ACTIONS(571),
    [anon_sym_QMARK_QMARK] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [aux_sym_binary_expression_token2] = ACTIONS(571),
    [aux_sym_binary_expression_token3] = ACTIONS(571),
    [aux_sym_binary_expression_token4] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_LT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(561),
    [anon_sym_LT_EQ_GT] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_STAR] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(561),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [87] = {
    [sym_text_interpolation] = STATE(87),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1030),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(921),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(563),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(561),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(561),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(571),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(561),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_yield_expression_token2] = ACTIONS(647),
    [aux_sym_binary_expression_token1] = ACTIONS(571),
    [anon_sym_QMARK_QMARK] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [aux_sym_binary_expression_token2] = ACTIONS(571),
    [aux_sym_binary_expression_token3] = ACTIONS(571),
    [aux_sym_binary_expression_token4] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_LT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(561),
    [anon_sym_LT_EQ_GT] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_STAR] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(561),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [88] = {
    [sym_text_interpolation] = STATE(88),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1124),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_variadic_unpacking] = STATE(1061),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_by_ref] = STATE(1061),
    [sym_yield_expression] = STATE(1060),
    [sym_array_element_initializer] = STATE(1129),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(659),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(561),
    [anon_sym_LPAREN] = ACTIONS(246),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(665),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(571),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(284),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_yield_expression_token2] = ACTIONS(667),
    [aux_sym_binary_expression_token1] = ACTIONS(571),
    [anon_sym_QMARK_QMARK] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [aux_sym_binary_expression_token2] = ACTIONS(571),
    [aux_sym_binary_expression_token3] = ACTIONS(571),
    [aux_sym_binary_expression_token4] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_LT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(561),
    [anon_sym_LT_EQ_GT] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_STAR] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(561),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(561),
  },
  [89] = {
    [sym_text_interpolation] = STATE(89),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1152),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(921),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(563),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(561),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [anon_sym_QMARK] = ACTIONS(571),
    [anon_sym_PIPE] = ACTIONS(571),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(675),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_yield_expression_token2] = ACTIONS(689),
    [aux_sym_binary_expression_token1] = ACTIONS(571),
    [anon_sym_QMARK_QMARK] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [aux_sym_binary_expression_token2] = ACTIONS(571),
    [aux_sym_binary_expression_token3] = ACTIONS(571),
    [aux_sym_binary_expression_token4] = ACTIONS(571),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(571),
    [anon_sym_LT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(561),
    [anon_sym_LT_EQ_GT] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_STAR] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(561),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [90] = {
    [sym_text_interpolation] = STATE(90),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2487),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [91] = {
    [sym_text_interpolation] = STATE(91),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2598),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [92] = {
    [sym_text_interpolation] = STATE(92),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2566),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [93] = {
    [sym_text_interpolation] = STATE(93),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2573),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [94] = {
    [sym_text_interpolation] = STATE(94),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2580),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1279),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [95] = {
    [sym_text_interpolation] = STATE(95),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2581),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [96] = {
    [sym_text_interpolation] = STATE(96),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2509),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1279),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [97] = {
    [sym_text_interpolation] = STATE(97),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2509),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [98] = {
    [sym_text_interpolation] = STATE(98),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2586),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [99] = {
    [sym_text_interpolation] = STATE(99),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2501),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [100] = {
    [sym_text_interpolation] = STATE(100),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_cast_type] = STATE(2552),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(699),
    [aux_sym_cast_type_token2] = ACTIONS(701),
    [aux_sym_cast_type_token3] = ACTIONS(701),
    [aux_sym_cast_type_token4] = ACTIONS(701),
    [aux_sym_cast_type_token5] = ACTIONS(701),
    [aux_sym_cast_type_token6] = ACTIONS(701),
    [aux_sym_cast_type_token7] = ACTIONS(701),
    [aux_sym_cast_type_token8] = ACTIONS(701),
    [aux_sym_cast_type_token9] = ACTIONS(701),
    [aux_sym_cast_type_token10] = ACTIONS(701),
    [aux_sym_cast_type_token11] = ACTIONS(701),
    [aux_sym_cast_type_token12] = ACTIONS(701),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [101] = {
    [sym_text_interpolation] = STATE(101),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2517),
    [sym_argument] = STATE(2101),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(709),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [102] = {
    [sym_text_interpolation] = STATE(102),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2648),
    [sym_argument] = STATE(2181),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(731),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [103] = {
    [sym_text_interpolation] = STATE(103),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2681),
    [sym_argument] = STATE(1959),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(735),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [104] = {
    [sym_text_interpolation] = STATE(104),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2655),
    [sym_argument] = STATE(2190),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(739),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [105] = {
    [sym_text_interpolation] = STATE(105),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1182),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(639),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(639),
    [sym_nullsafe_member_access_expression] = STATE(639),
    [sym_scoped_property_access_expression] = STATE(639),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2028),
    [sym_function_call_expression] = STATE(622),
    [sym_scoped_call_expression] = STATE(622),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(622),
    [sym_nullsafe_member_call_expression] = STATE(622),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(622),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(622),
    [sym_variable_name] = STATE(622),
    [sym_by_ref] = STATE(2374),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2061),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym__array_destructing_repeat1] = STATE(2030),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(745),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(747),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [106] = {
    [sym_text_interpolation] = STATE(106),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2658),
    [sym_argument] = STATE(2191),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(749),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [107] = {
    [sym_text_interpolation] = STATE(107),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1182),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(639),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(639),
    [sym_nullsafe_member_access_expression] = STATE(639),
    [sym_scoped_property_access_expression] = STATE(639),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2028),
    [sym_function_call_expression] = STATE(622),
    [sym_scoped_call_expression] = STATE(622),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(622),
    [sym_nullsafe_member_call_expression] = STATE(622),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(622),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(622),
    [sym_variable_name] = STATE(622),
    [sym_by_ref] = STATE(2374),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2061),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym__array_destructing_repeat1] = STATE(2030),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(745),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(753),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [108] = {
    [sym_text_interpolation] = STATE(108),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2671),
    [sym_argument] = STATE(2203),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(755),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [109] = {
    [sym_text_interpolation] = STATE(109),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1182),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(639),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(639),
    [sym_nullsafe_member_access_expression] = STATE(639),
    [sym_scoped_property_access_expression] = STATE(639),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2028),
    [sym_function_call_expression] = STATE(622),
    [sym_scoped_call_expression] = STATE(622),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(622),
    [sym_nullsafe_member_call_expression] = STATE(622),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(622),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(622),
    [sym_variable_name] = STATE(622),
    [sym_by_ref] = STATE(2374),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2029),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym__array_destructing_repeat1] = STATE(2030),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(759),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(761),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [110] = {
    [sym_text_interpolation] = STATE(110),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2574),
    [sym_argument] = STATE(2145),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(763),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(765),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [111] = {
    [sym_text_interpolation] = STATE(111),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1182),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(639),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(639),
    [sym_nullsafe_member_access_expression] = STATE(639),
    [sym_scoped_property_access_expression] = STATE(639),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2028),
    [sym_function_call_expression] = STATE(622),
    [sym_scoped_call_expression] = STATE(622),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(622),
    [sym_nullsafe_member_call_expression] = STATE(622),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(622),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(622),
    [sym_variable_name] = STATE(622),
    [sym_by_ref] = STATE(2374),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2061),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym__array_destructing_repeat1] = STATE(2030),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(745),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(767),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [112] = {
    [sym_text_interpolation] = STATE(112),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_variadic_placeholder] = STATE(2694),
    [sym_argument] = STATE(2210),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [anon_sym_COMMA] = ACTIONS(769),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(719),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [113] = {
    [sym_text_interpolation] = STATE(113),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1182),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(639),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(639),
    [sym_nullsafe_member_access_expression] = STATE(639),
    [sym_scoped_property_access_expression] = STATE(639),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2028),
    [sym_function_call_expression] = STATE(622),
    [sym_scoped_call_expression] = STATE(622),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(622),
    [sym_nullsafe_member_call_expression] = STATE(622),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(622),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(622),
    [sym_variable_name] = STATE(622),
    [sym_by_ref] = STATE(2374),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2061),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym__array_destructing_repeat1] = STATE(2030),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(745),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_RBRACK] = ACTIONS(773),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [114] = {
    [sym_text_interpolation] = STATE(114),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [115] = {
    [sym_text_interpolation] = STATE(115),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [116] = {
    [sym_text_interpolation] = STATE(116),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2029),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(779),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(781),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [117] = {
    [sym_text_interpolation] = STATE(117),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(1977),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(783),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [118] = {
    [sym_text_interpolation] = STATE(118),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2061),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(787),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(789),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [119] = {
    [sym_text_interpolation] = STATE(119),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [120] = {
    [sym_text_interpolation] = STATE(120),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [121] = {
    [sym_text_interpolation] = STATE(121),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [122] = {
    [sym_text_interpolation] = STATE(122),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [123] = {
    [sym_text_interpolation] = STATE(123),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [124] = {
    [sym_text_interpolation] = STATE(124),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [125] = {
    [sym_text_interpolation] = STATE(125),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [126] = {
    [sym_text_interpolation] = STATE(126),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [127] = {
    [sym_text_interpolation] = STATE(127),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [128] = {
    [sym_text_interpolation] = STATE(128),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2083),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(809),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [129] = {
    [sym_text_interpolation] = STATE(129),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [130] = {
    [sym_text_interpolation] = STATE(130),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [131] = {
    [sym_text_interpolation] = STATE(131),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [132] = {
    [sym_text_interpolation] = STATE(132),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [133] = {
    [sym_text_interpolation] = STATE(133),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [134] = {
    [sym_text_interpolation] = STATE(134),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(823),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [135] = {
    [sym_text_interpolation] = STATE(135),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(825),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [136] = {
    [sym_text_interpolation] = STATE(136),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [137] = {
    [sym_text_interpolation] = STATE(137),
    [sym_reference_modifier] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_argument] = STATE(2432),
    [sym__argument_name] = STATE(157),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2428),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1517),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(703),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(707),
    [aux_sym_namespace_definition_token1] = ACTIONS(711),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(713),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(721),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(725),
    [anon_sym_parent] = ACTIONS(725),
    [aux_sym__argument_name_token1] = ACTIONS(727),
    [aux_sym__argument_name_token2] = ACTIONS(729),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [138] = {
    [sym_text_interpolation] = STATE(138),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [139] = {
    [sym_text_interpolation] = STATE(139),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym_match_condition_list] = STATE(2635),
    [sym_match_conditional_expression] = STATE(1993),
    [sym_match_default_expression] = STATE(1993),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(831),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(833),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [aux_sym_match_default_expression_token1] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [140] = {
    [sym_text_interpolation] = STATE(140),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [141] = {
    [sym_text_interpolation] = STATE(141),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [142] = {
    [sym_text_interpolation] = STATE(142),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [143] = {
    [sym_text_interpolation] = STATE(143),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym_match_condition_list] = STATE(2635),
    [sym_match_conditional_expression] = STATE(2176),
    [sym_match_default_expression] = STATE(2176),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(843),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(845),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [aux_sym_match_default_expression_token1] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [144] = {
    [sym_text_interpolation] = STATE(144),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [145] = {
    [sym_text_interpolation] = STATE(145),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [146] = {
    [sym_text_interpolation] = STATE(146),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1270),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2451),
    [sym_function_call_expression] = STATE(631),
    [sym_scoped_call_expression] = STATE(631),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(631),
    [sym_nullsafe_member_call_expression] = STATE(631),
    [sym_subscript_expression] = STATE(631),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(631),
    [sym_variable_name] = STATE(631),
    [sym_by_ref] = STATE(2450),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(849),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(851),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(855),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [147] = {
    [sym_text_interpolation] = STATE(147),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym_match_condition_list] = STATE(2635),
    [sym_match_conditional_expression] = STATE(2348),
    [sym_match_default_expression] = STATE(2348),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(858),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [aux_sym_match_default_expression_token1] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [148] = {
    [sym_text_interpolation] = STATE(148),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1270),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2451),
    [sym_function_call_expression] = STATE(631),
    [sym_scoped_call_expression] = STATE(631),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(631),
    [sym_nullsafe_member_call_expression] = STATE(631),
    [sym_subscript_expression] = STATE(631),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(631),
    [sym_variable_name] = STATE(631),
    [sym_by_ref] = STATE(2450),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(849),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(851),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [149] = {
    [sym_text_interpolation] = STATE(149),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1270),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2026),
    [sym__array_destructing_element] = STATE(2451),
    [sym_function_call_expression] = STATE(631),
    [sym_scoped_call_expression] = STATE(631),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(631),
    [sym_nullsafe_member_call_expression] = STATE(631),
    [sym_subscript_expression] = STATE(631),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(631),
    [sym_variable_name] = STATE(631),
    [sym_by_ref] = STATE(2450),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(849),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(851),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(853),
    [anon_sym_RBRACK] = ACTIONS(860),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [150] = {
    [sym_text_interpolation] = STATE(150),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1271),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(1793),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(603),
    [sym_scoped_call_expression] = STATE(603),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(603),
    [sym_nullsafe_member_call_expression] = STATE(603),
    [sym_subscript_expression] = STATE(603),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(603),
    [sym_variable_name] = STATE(603),
    [sym_by_ref] = STATE(2113),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym__list_destructing_repeat1] = STATE(2090),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(863),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(865),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [151] = {
    [sym_text_interpolation] = STATE(151),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym_match_condition_list] = STATE(2635),
    [sym_match_conditional_expression] = STATE(2348),
    [sym_match_default_expression] = STATE(2348),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(867),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [aux_sym_match_default_expression_token1] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [152] = {
    [sym_text_interpolation] = STATE(152),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(950),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(950),
    [sym_yield_expression] = STATE(907),
    [sym_array_element_initializer] = STATE(2198),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [153] = {
    [sym_text_interpolation] = STATE(153),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym_match_condition_list] = STATE(2635),
    [sym_match_conditional_expression] = STATE(2348),
    [sym_match_default_expression] = STATE(2348),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(869),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [aux_sym_match_default_expression_token1] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [154] = {
    [sym_text_interpolation] = STATE(154),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym_match_condition_list] = STATE(2635),
    [sym_match_conditional_expression] = STATE(2348),
    [sym_match_default_expression] = STATE(2348),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(871),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [aux_sym_match_default_expression_token1] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [155] = {
    [sym_text_interpolation] = STATE(155),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym_match_condition_list] = STATE(2635),
    [sym_match_conditional_expression] = STATE(2348),
    [sym_match_default_expression] = STATE(2348),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [aux_sym_match_default_expression_token1] = ACTIONS(835),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [156] = {
    [sym_text_interpolation] = STATE(156),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1296),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(640),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(640),
    [sym_nullsafe_member_access_expression] = STATE(640),
    [sym_scoped_property_access_expression] = STATE(640),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2184),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(618),
    [sym_scoped_call_expression] = STATE(618),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(618),
    [sym_nullsafe_member_call_expression] = STATE(618),
    [sym_subscript_expression] = STATE(618),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(618),
    [sym_variable_name] = STATE(618),
    [sym_by_ref] = STATE(2261),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(873),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(873),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [157] = {
    [sym_text_interpolation] = STATE(157),
    [sym_reference_modifier] = STATE(196),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1231),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2228),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1497),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(705),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [158] = {
    [sym_text_interpolation] = STATE(158),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2611),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(875),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [159] = {
    [sym_text_interpolation] = STATE(159),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2665),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(877),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [160] = {
    [sym_text_interpolation] = STATE(160),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2695),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(879),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [161] = {
    [sym_text_interpolation] = STATE(161),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_foreach_pair] = STATE(2497),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1239),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2482),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_by_ref] = STATE(2497),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [162] = {
    [sym_text_interpolation] = STATE(162),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2555),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(881),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [163] = {
    [sym_text_interpolation] = STATE(163),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_foreach_pair] = STATE(2639),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1218),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2275),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_by_ref] = STATE(2639),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [164] = {
    [sym_text_interpolation] = STATE(164),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_foreach_pair] = STATE(2557),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1230),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2381),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_by_ref] = STATE(2557),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [165] = {
    [sym_text_interpolation] = STATE(165),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2632),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(883),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [166] = {
    [sym_text_interpolation] = STATE(166),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2550),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(885),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [167] = {
    [sym_text_interpolation] = STATE(167),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2637),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(887),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [168] = {
    [sym_text_interpolation] = STATE(168),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2638),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(889),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [169] = {
    [sym_text_interpolation] = STATE(169),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_foreach_pair] = STATE(2554),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1202),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2384),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_by_ref] = STATE(2554),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [170] = {
    [sym_text_interpolation] = STATE(170),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2543),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(891),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [171] = {
    [sym_text_interpolation] = STATE(171),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2692),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(893),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [172] = {
    [sym_text_interpolation] = STATE(172),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2642),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(895),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [173] = {
    [sym_text_interpolation] = STATE(173),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2645),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(897),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [174] = {
    [sym_text_interpolation] = STATE(174),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2512),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(899),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [175] = {
    [sym_text_interpolation] = STATE(175),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2502),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(901),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [176] = {
    [sym_text_interpolation] = STATE(176),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2561),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(903),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [177] = {
    [sym_text_interpolation] = STATE(177),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2500),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(905),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [178] = {
    [sym_text_interpolation] = STATE(178),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2558),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(907),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [179] = {
    [sym_text_interpolation] = STATE(179),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2559),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(909),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [180] = {
    [sym_text_interpolation] = STATE(180),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2661),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(911),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [181] = {
    [sym_text_interpolation] = STATE(181),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2687),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(913),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [182] = {
    [sym_text_interpolation] = STATE(182),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2576),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(915),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [183] = {
    [sym_text_interpolation] = STATE(183),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2689),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(917),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [184] = {
    [sym_text_interpolation] = STATE(184),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2702),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1224),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(919),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [185] = {
    [sym_text_interpolation] = STATE(185),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__expressions] = STATE(2495),
    [sym_sequence_expression] = STATE(2471),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(921),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [186] = {
    [sym_text_interpolation] = STATE(186),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1206),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(923),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(923),
  },
  [187] = {
    [sym_text_interpolation] = STATE(187),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1207),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(925),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(925),
  },
  [188] = {
    [sym_text_interpolation] = STATE(188),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(927),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(927),
  },
  [189] = {
    [sym_text_interpolation] = STATE(189),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1241),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(929),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(929),
  },
  [190] = {
    [sym_text_interpolation] = STATE(190),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1237),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2230),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1502),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [191] = {
    [sym_text_interpolation] = STATE(191),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1236),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(931),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(931),
  },
  [192] = {
    [sym_text_interpolation] = STATE(192),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1036),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(956),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [193] = {
    [sym_text_interpolation] = STATE(193),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1109),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_by_ref] = STATE(1044),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(933),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [194] = {
    [sym_text_interpolation] = STATE(194),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1161),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(956),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [195] = {
    [sym_text_interpolation] = STATE(195),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(990),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_by_ref] = STATE(956),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(935),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [196] = {
    [sym_text_interpolation] = STATE(196),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2433),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1507),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(671),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [197] = {
    [sym_text_interpolation] = STATE(197),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1036),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_by_ref] = STATE(956),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(935),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [198] = {
    [sym_text_interpolation] = STATE(198),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1214),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(937),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(937),
  },
  [199] = {
    [sym_text_interpolation] = STATE(199),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1248),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2376),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_by_ref] = STATE(2549),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [200] = {
    [sym_text_interpolation] = STATE(200),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1036),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(641),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(641),
    [sym_nullsafe_member_access_expression] = STATE(641),
    [sym_scoped_property_access_expression] = STATE(641),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2197),
    [sym_function_call_expression] = STATE(635),
    [sym_scoped_call_expression] = STATE(635),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(635),
    [sym_nullsafe_member_call_expression] = STATE(635),
    [sym_subscript_expression] = STATE(635),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(635),
    [sym_variable_name] = STATE(635),
    [sym_by_ref] = STATE(2249),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(743),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [201] = {
    [sym_text_interpolation] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1161),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(956),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(935),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [202] = {
    [sym_text_interpolation] = STATE(202),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym__expressions] = STATE(2357),
    [sym_sequence_expression] = STATE(2360),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1184),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [203] = {
    [sym_text_interpolation] = STATE(203),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym__expressions] = STATE(2354),
    [sym_sequence_expression] = STATE(2360),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1184),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [204] = {
    [sym_text_interpolation] = STATE(204),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1162),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_RPAREN] = ACTIONS(939),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [205] = {
    [sym_text_interpolation] = STATE(205),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1301),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [206] = {
    [sym_text_interpolation] = STATE(206),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1282),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(943),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [207] = {
    [sym_text_interpolation] = STATE(207),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_sequence_expression] = STATE(2282),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [208] = {
    [sym_text_interpolation] = STATE(208),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_sequence_expression] = STATE(2314),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1185),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [209] = {
    [sym_text_interpolation] = STATE(209),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1274),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(945),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [210] = {
    [sym_text_interpolation] = STATE(210),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1220),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [211] = {
    [sym_text_interpolation] = STATE(211),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1008),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(949),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [212] = {
    [sym_text_interpolation] = STATE(212),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1002),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(951),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [213] = {
    [sym_text_interpolation] = STATE(213),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_sequence_expression] = STATE(2282),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1203),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [214] = {
    [sym_text_interpolation] = STATE(214),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1220),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [215] = {
    [sym_text_interpolation] = STATE(215),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1297),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(955),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [216] = {
    [sym_text_interpolation] = STATE(216),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1300),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(957),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [217] = {
    [sym_text_interpolation] = STATE(217),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1283),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(959),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [218] = {
    [sym_text_interpolation] = STATE(218),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(961),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [219] = {
    [sym_text_interpolation] = STATE(219),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1284),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(963),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [220] = {
    [sym_text_interpolation] = STATE(220),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1252),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(965),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [221] = {
    [sym_text_interpolation] = STATE(221),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1089),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(967),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [222] = {
    [sym_text_interpolation] = STATE(222),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1260),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_RBRACK] = ACTIONS(969),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [223] = {
    [sym_text_interpolation] = STATE(223),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1266),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [anon_sym_COLON] = ACTIONS(971),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [224] = {
    [sym_text_interpolation] = STATE(224),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1018),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [225] = {
    [sym_text_interpolation] = STATE(225),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1286),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [226] = {
    [sym_text_interpolation] = STATE(226),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [227] = {
    [sym_text_interpolation] = STATE(227),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1196),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [228] = {
    [sym_text_interpolation] = STATE(228),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1240),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [229] = {
    [sym_text_interpolation] = STATE(229),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1194),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [230] = {
    [sym_text_interpolation] = STATE(230),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1133),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [231] = {
    [sym_text_interpolation] = STATE(231),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1268),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [232] = {
    [sym_text_interpolation] = STATE(232),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1238),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [233] = {
    [sym_text_interpolation] = STATE(233),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1264),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [234] = {
    [sym_text_interpolation] = STATE(234),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1132),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [235] = {
    [sym_text_interpolation] = STATE(235),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1292),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [236] = {
    [sym_text_interpolation] = STATE(236),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1294),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [237] = {
    [sym_text_interpolation] = STATE(237),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1279),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [238] = {
    [sym_text_interpolation] = STATE(238),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1299),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [239] = {
    [sym_text_interpolation] = STATE(239),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1243),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [240] = {
    [sym_text_interpolation] = STATE(240),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1115),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [241] = {
    [sym_text_interpolation] = STATE(241),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1304),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [242] = {
    [sym_text_interpolation] = STATE(242),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1309),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [243] = {
    [sym_text_interpolation] = STATE(243),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1220),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [244] = {
    [sym_text_interpolation] = STATE(244),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1306),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [245] = {
    [sym_text_interpolation] = STATE(245),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1245),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [246] = {
    [sym_text_interpolation] = STATE(246),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(978),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [247] = {
    [sym_text_interpolation] = STATE(247),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [248] = {
    [sym_text_interpolation] = STATE(248),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(934),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [249] = {
    [sym_text_interpolation] = STATE(249),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(932),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [250] = {
    [sym_text_interpolation] = STATE(250),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(981),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [251] = {
    [sym_text_interpolation] = STATE(251),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(974),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [252] = {
    [sym_text_interpolation] = STATE(252),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1127),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [253] = {
    [sym_text_interpolation] = STATE(253),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(984),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [254] = {
    [sym_text_interpolation] = STATE(254),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1126),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [255] = {
    [sym_text_interpolation] = STATE(255),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1125),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [256] = {
    [sym_text_interpolation] = STATE(256),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1123),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [257] = {
    [sym_text_interpolation] = STATE(257),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1121),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [258] = {
    [sym_text_interpolation] = STATE(258),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1120),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [259] = {
    [sym_text_interpolation] = STATE(259),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1119),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [260] = {
    [sym_text_interpolation] = STATE(260),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1117),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [261] = {
    [sym_text_interpolation] = STATE(261),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1116),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [262] = {
    [sym_text_interpolation] = STATE(262),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1110),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [263] = {
    [sym_text_interpolation] = STATE(263),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1108),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [264] = {
    [sym_text_interpolation] = STATE(264),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1107),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [265] = {
    [sym_text_interpolation] = STATE(265),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1104),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [266] = {
    [sym_text_interpolation] = STATE(266),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1099),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [267] = {
    [sym_text_interpolation] = STATE(267),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1097),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [268] = {
    [sym_text_interpolation] = STATE(268),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1093),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [269] = {
    [sym_text_interpolation] = STATE(269),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1091),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [270] = {
    [sym_text_interpolation] = STATE(270),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(986),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [271] = {
    [sym_text_interpolation] = STATE(271),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(988),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [272] = {
    [sym_text_interpolation] = STATE(272),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1246),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [273] = {
    [sym_text_interpolation] = STATE(273),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1088),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [274] = {
    [sym_text_interpolation] = STATE(274),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1295),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [275] = {
    [sym_text_interpolation] = STATE(275),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1251),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [276] = {
    [sym_text_interpolation] = STATE(276),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1293),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [277] = {
    [sym_text_interpolation] = STATE(277),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1291),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [278] = {
    [sym_text_interpolation] = STATE(278),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1187),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [279] = {
    [sym_text_interpolation] = STATE(279),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1234),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [280] = {
    [sym_text_interpolation] = STATE(280),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1287),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [281] = {
    [sym_text_interpolation] = STATE(281),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1305),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [282] = {
    [sym_text_interpolation] = STATE(282),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1281),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [283] = {
    [sym_text_interpolation] = STATE(283),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1280),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [284] = {
    [sym_text_interpolation] = STATE(284),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1144),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [285] = {
    [sym_text_interpolation] = STATE(285),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1263),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [286] = {
    [sym_text_interpolation] = STATE(286),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1157),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [287] = {
    [sym_text_interpolation] = STATE(287),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1165),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [288] = {
    [sym_text_interpolation] = STATE(288),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1262),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [289] = {
    [sym_text_interpolation] = STATE(289),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1261),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [290] = {
    [sym_text_interpolation] = STATE(290),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1259),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [291] = {
    [sym_text_interpolation] = STATE(291),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1166),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [292] = {
    [sym_text_interpolation] = STATE(292),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1167),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [293] = {
    [sym_text_interpolation] = STATE(293),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1128),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [294] = {
    [sym_text_interpolation] = STATE(294),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1168),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [295] = {
    [sym_text_interpolation] = STATE(295),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1169),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [296] = {
    [sym_text_interpolation] = STATE(296),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1188),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [297] = {
    [sym_text_interpolation] = STATE(297),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1255),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [298] = {
    [sym_text_interpolation] = STATE(298),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [299] = {
    [sym_text_interpolation] = STATE(299),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1145),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [300] = {
    [sym_text_interpolation] = STATE(300),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [301] = {
    [sym_text_interpolation] = STATE(301),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [302] = {
    [sym_text_interpolation] = STATE(302),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1174),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [303] = {
    [sym_text_interpolation] = STATE(303),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(976),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [304] = {
    [sym_text_interpolation] = STATE(304),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1173),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [305] = {
    [sym_text_interpolation] = STATE(305),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1172),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [306] = {
    [sym_text_interpolation] = STATE(306),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1159),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [307] = {
    [sym_text_interpolation] = STATE(307),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1158),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [308] = {
    [sym_text_interpolation] = STATE(308),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1155),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [309] = {
    [sym_text_interpolation] = STATE(309),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1154),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [310] = {
    [sym_text_interpolation] = STATE(310),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1289),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [311] = {
    [sym_text_interpolation] = STATE(311),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1290),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [312] = {
    [sym_text_interpolation] = STATE(312),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1153),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [313] = {
    [sym_text_interpolation] = STATE(313),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(997),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [314] = {
    [sym_text_interpolation] = STATE(314),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1147),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [315] = {
    [sym_text_interpolation] = STATE(315),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1148),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [316] = {
    [sym_text_interpolation] = STATE(316),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1149),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [317] = {
    [sym_text_interpolation] = STATE(317),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1298),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [318] = {
    [sym_text_interpolation] = STATE(318),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1150),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [319] = {
    [sym_text_interpolation] = STATE(319),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [320] = {
    [sym_text_interpolation] = STATE(320),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1151),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [321] = {
    [sym_text_interpolation] = STATE(321),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1000),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [322] = {
    [sym_text_interpolation] = STATE(322),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(996),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [323] = {
    [sym_text_interpolation] = STATE(323),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1156),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [324] = {
    [sym_text_interpolation] = STATE(324),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(998),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [325] = {
    [sym_text_interpolation] = STATE(325),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(932),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [326] = {
    [sym_text_interpolation] = STATE(326),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(934),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [327] = {
    [sym_text_interpolation] = STATE(327),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1160),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [328] = {
    [sym_text_interpolation] = STATE(328),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1004),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [329] = {
    [sym_text_interpolation] = STATE(329),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1001),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [330] = {
    [sym_text_interpolation] = STATE(330),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(993),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [331] = {
    [sym_text_interpolation] = STATE(331),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(977),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [332] = {
    [sym_text_interpolation] = STATE(332),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(979),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [333] = {
    [sym_text_interpolation] = STATE(333),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1269),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [334] = {
    [sym_text_interpolation] = STATE(334),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(980),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [335] = {
    [sym_text_interpolation] = STATE(335),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1183),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [336] = {
    [sym_text_interpolation] = STATE(336),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1250),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [337] = {
    [sym_text_interpolation] = STATE(337),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(991),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [338] = {
    [sym_text_interpolation] = STATE(338),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(992),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [339] = {
    [sym_text_interpolation] = STATE(339),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(982),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [340] = {
    [sym_text_interpolation] = STATE(340),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(994),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [341] = {
    [sym_text_interpolation] = STATE(341),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(999),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [342] = {
    [sym_text_interpolation] = STATE(342),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(989),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [343] = {
    [sym_text_interpolation] = STATE(343),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1249),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [344] = {
    [sym_text_interpolation] = STATE(344),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1244),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [345] = {
    [sym_text_interpolation] = STATE(345),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1003),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [346] = {
    [sym_text_interpolation] = STATE(346),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1005),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [347] = {
    [sym_text_interpolation] = STATE(347),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [348] = {
    [sym_text_interpolation] = STATE(348),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(975),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [349] = {
    [sym_text_interpolation] = STATE(349),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1308),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [350] = {
    [sym_text_interpolation] = STATE(350),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1310),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [351] = {
    [sym_text_interpolation] = STATE(351),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1303),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [352] = {
    [sym_text_interpolation] = STATE(352),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1265),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [353] = {
    [sym_text_interpolation] = STATE(353),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(995),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [354] = {
    [sym_text_interpolation] = STATE(354),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1199),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [355] = {
    [sym_text_interpolation] = STATE(355),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1232),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [356] = {
    [sym_text_interpolation] = STATE(356),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1276),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [357] = {
    [sym_text_interpolation] = STATE(357),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1307),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [358] = {
    [sym_text_interpolation] = STATE(358),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1267),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [359] = {
    [sym_text_interpolation] = STATE(359),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1162),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [360] = {
    [sym_text_interpolation] = STATE(360),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1288),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [361] = {
    [sym_text_interpolation] = STATE(361),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1275),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [362] = {
    [sym_text_interpolation] = STATE(362),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1228),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [363] = {
    [sym_text_interpolation] = STATE(363),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1229),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [364] = {
    [sym_text_interpolation] = STATE(364),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1227),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [365] = {
    [sym_text_interpolation] = STATE(365),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1075),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [366] = {
    [sym_text_interpolation] = STATE(366),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1273),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [367] = {
    [sym_text_interpolation] = STATE(367),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1272),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [368] = {
    [sym_text_interpolation] = STATE(368),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1033),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [369] = {
    [sym_text_interpolation] = STATE(369),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1134),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [370] = {
    [sym_text_interpolation] = STATE(370),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1221),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [371] = {
    [sym_text_interpolation] = STATE(371),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1217),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [372] = {
    [sym_text_interpolation] = STATE(372),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1175),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [373] = {
    [sym_text_interpolation] = STATE(373),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(934),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [374] = {
    [sym_text_interpolation] = STATE(374),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(932),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [375] = {
    [sym_text_interpolation] = STATE(375),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1026),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [376] = {
    [sym_text_interpolation] = STATE(376),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1032),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [377] = {
    [sym_text_interpolation] = STATE(377),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1285),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [378] = {
    [sym_text_interpolation] = STATE(378),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1028),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [379] = {
    [sym_text_interpolation] = STATE(379),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1024),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [380] = {
    [sym_text_interpolation] = STATE(380),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1007),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [381] = {
    [sym_text_interpolation] = STATE(381),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1022),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [382] = {
    [sym_text_interpolation] = STATE(382),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1189),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [383] = {
    [sym_text_interpolation] = STATE(383),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1029),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [384] = {
    [sym_text_interpolation] = STATE(384),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1209),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [385] = {
    [sym_text_interpolation] = STATE(385),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(987),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [386] = {
    [sym_text_interpolation] = STATE(386),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1023),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [387] = {
    [sym_text_interpolation] = STATE(387),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1256),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [388] = {
    [sym_text_interpolation] = STATE(388),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1257),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [389] = {
    [sym_text_interpolation] = STATE(389),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1258),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [390] = {
    [sym_text_interpolation] = STATE(390),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1043),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [391] = {
    [sym_text_interpolation] = STATE(391),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1212),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [392] = {
    [sym_text_interpolation] = STATE(392),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1211),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [393] = {
    [sym_text_interpolation] = STATE(393),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1277),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [394] = {
    [sym_text_interpolation] = STATE(394),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1027),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [395] = {
    [sym_text_interpolation] = STATE(395),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1210),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [396] = {
    [sym_text_interpolation] = STATE(396),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1131),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [397] = {
    [sym_text_interpolation] = STATE(397),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1208),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [398] = {
    [sym_text_interpolation] = STATE(398),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1090),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [399] = {
    [sym_text_interpolation] = STATE(399),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1035),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [400] = {
    [sym_text_interpolation] = STATE(400),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1034),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [401] = {
    [sym_text_interpolation] = STATE(401),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1025),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [402] = {
    [sym_text_interpolation] = STATE(402),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1078),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [403] = {
    [sym_text_interpolation] = STATE(403),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1021),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [404] = {
    [sym_text_interpolation] = STATE(404),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1081),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [405] = {
    [sym_text_interpolation] = STATE(405),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1016),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [406] = {
    [sym_text_interpolation] = STATE(406),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1013),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [407] = {
    [sym_text_interpolation] = STATE(407),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1012),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [408] = {
    [sym_text_interpolation] = STATE(408),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1011),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [409] = {
    [sym_text_interpolation] = STATE(409),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1010),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [410] = {
    [sym_text_interpolation] = STATE(410),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1130),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [411] = {
    [sym_text_interpolation] = STATE(411),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1006),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [412] = {
    [sym_text_interpolation] = STATE(412),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1014),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [413] = {
    [sym_text_interpolation] = STATE(413),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1015),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [414] = {
    [sym_text_interpolation] = STATE(414),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1017),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [415] = {
    [sym_text_interpolation] = STATE(415),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1019),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [416] = {
    [sym_text_interpolation] = STATE(416),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(985),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(600),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(600),
    [sym_nullsafe_member_access_expression] = STATE(600),
    [sym_scoped_property_access_expression] = STATE(600),
    [sym_list_literal] = STATE(2644),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(597),
    [sym_scoped_call_expression] = STATE(597),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(597),
    [sym_nullsafe_member_call_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(597),
    [sym_variable_name] = STATE(597),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(589),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(599),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(615),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [aux_sym_require_expression_token1] = ACTIONS(623),
    [aux_sym_require_once_expression_token1] = ACTIONS(625),
    [sym_comment] = ACTIONS(5),
  },
  [417] = {
    [sym_text_interpolation] = STATE(417),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1009),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [418] = {
    [sym_text_interpolation] = STATE(418),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym_match_expression] = STATE(1060),
    [sym__expression] = STATE(1083),
    [sym__unary_expression] = STATE(1063),
    [sym_unary_op_expression] = STATE(1064),
    [sym_error_suppression_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(1060),
    [sym_reference_assignment_expression] = STATE(1060),
    [sym_conditional_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2649),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym_require_expression] = STATE(1060),
    [sym_require_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_match_expression_token1] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(288),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_yield_expression_token1] = ACTIONS(320),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [aux_sym_require_expression_token1] = ACTIONS(326),
    [aux_sym_require_once_expression_token1] = ACTIONS(328),
    [sym_comment] = ACTIONS(5),
  },
  [419] = {
    [sym_text_interpolation] = STATE(419),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1038),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [420] = {
    [sym_text_interpolation] = STATE(420),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1171),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2564),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_AT] = ACTIONS(679),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(685),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(687),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [aux_sym_require_expression_token1] = ACTIONS(695),
    [aux_sym_require_once_expression_token1] = ACTIONS(697),
    [sym_comment] = ACTIONS(5),
  },
  [421] = {
    [sym_text_interpolation] = STATE(421),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1020),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [422] = {
    [sym_text_interpolation] = STATE(422),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym_match_expression] = STATE(907),
    [sym__expression] = STATE(1031),
    [sym__unary_expression] = STATE(963),
    [sym_unary_op_expression] = STATE(906),
    [sym_error_suppression_expression] = STATE(907),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(630),
    [sym_assignment_expression] = STATE(907),
    [sym_reference_assignment_expression] = STATE(907),
    [sym_conditional_expression] = STATE(907),
    [sym_augmented_assignment_expression] = STATE(907),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_list_literal] = STATE(2492),
    [sym__list_destructing] = STATE(2265),
    [sym__array_destructing] = STATE(2265),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_yield_expression] = STATE(907),
    [sym_binary_expression] = STATE(907),
    [sym_include_expression] = STATE(907),
    [sym_include_once_expression] = STATE(907),
    [sym_require_expression] = STATE(907),
    [sym_require_once_expression] = STATE(907),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_match_expression_token1] = ACTIONS(583),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(637),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [aux_sym__list_destructing_token1] = ACTIONS(298),
    [anon_sym_LBRACK] = ACTIONS(643),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_yield_expression_token1] = ACTIONS(645),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [aux_sym_require_expression_token1] = ACTIONS(653),
    [aux_sym_require_once_expression_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(5),
  },
  [423] = {
    [sym_text_interpolation] = STATE(423),
    [sym_catch_clause] = STATE(430),
    [sym_finally_clause] = STATE(430),
    [aux_sym_try_statement_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_name] = ACTIONS(975),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(973),
    [aux_sym_function_static_declaration_token1] = ACTIONS(975),
    [aux_sym_global_declaration_token1] = ACTIONS(975),
    [aux_sym_namespace_definition_token1] = ACTIONS(975),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(975),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(975),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [aux_sym_trait_declaration_token1] = ACTIONS(975),
    [aux_sym_interface_declaration_token1] = ACTIONS(975),
    [aux_sym_enum_declaration_token1] = ACTIONS(975),
    [aux_sym_enum_case_token1] = ACTIONS(975),
    [aux_sym_class_declaration_token1] = ACTIONS(975),
    [aux_sym_final_modifier_token1] = ACTIONS(975),
    [aux_sym_abstract_modifier_token1] = ACTIONS(975),
    [aux_sym_readonly_modifier_token1] = ACTIONS(975),
    [aux_sym_visibility_modifier_token1] = ACTIONS(975),
    [aux_sym_visibility_modifier_token2] = ACTIONS(975),
    [aux_sym_visibility_modifier_token3] = ACTIONS(975),
    [aux_sym__arrow_function_header_token1] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(973),
    [aux_sym_cast_type_token1] = ACTIONS(975),
    [aux_sym_echo_statement_token1] = ACTIONS(975),
    [anon_sym_unset] = ACTIONS(975),
    [aux_sym_declare_statement_token1] = ACTIONS(975),
    [aux_sym_declare_statement_token2] = ACTIONS(975),
    [sym_float] = ACTIONS(975),
    [aux_sym_try_statement_token1] = ACTIONS(975),
    [aux_sym_catch_clause_token1] = ACTIONS(977),
    [aux_sym_finally_clause_token1] = ACTIONS(980),
    [aux_sym_goto_statement_token1] = ACTIONS(975),
    [aux_sym_continue_statement_token1] = ACTIONS(975),
    [aux_sym_break_statement_token1] = ACTIONS(975),
    [sym_integer] = ACTIONS(975),
    [aux_sym_return_statement_token1] = ACTIONS(975),
    [aux_sym_throw_expression_token1] = ACTIONS(975),
    [aux_sym_while_statement_token1] = ACTIONS(975),
    [aux_sym_while_statement_token2] = ACTIONS(975),
    [aux_sym_do_statement_token1] = ACTIONS(975),
    [aux_sym_for_statement_token1] = ACTIONS(975),
    [aux_sym_for_statement_token2] = ACTIONS(975),
    [aux_sym_foreach_statement_token1] = ACTIONS(975),
    [aux_sym_foreach_statement_token2] = ACTIONS(975),
    [aux_sym_if_statement_token1] = ACTIONS(975),
    [aux_sym_if_statement_token2] = ACTIONS(975),
    [aux_sym_else_if_clause_token1] = ACTIONS(975),
    [aux_sym_else_clause_token1] = ACTIONS(975),
    [aux_sym_match_expression_token1] = ACTIONS(975),
    [aux_sym_match_default_expression_token1] = ACTIONS(975),
    [aux_sym_switch_statement_token1] = ACTIONS(975),
    [aux_sym_switch_block_token1] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_AT] = ACTIONS(973),
    [aux_sym_clone_expression_token1] = ACTIONS(975),
    [aux_sym_print_intrinsic_token1] = ACTIONS(975),
    [aux_sym_object_creation_expression_token1] = ACTIONS(975),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [aux_sym__list_destructing_token1] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(973),
    [anon_sym_self] = ACTIONS(975),
    [anon_sym_parent] = ACTIONS(975),
    [aux_sym__argument_name_token1] = ACTIONS(975),
    [aux_sym__argument_name_token2] = ACTIONS(975),
    [anon_sym_POUND_LBRACK] = ACTIONS(973),
    [aux_sym_encapsed_string_token1] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [aux_sym_string_token1] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_LT_LT_LT] = ACTIONS(973),
    [anon_sym_BQUOTE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(973),
    [aux_sym_yield_expression_token1] = ACTIONS(975),
    [aux_sym_include_expression_token1] = ACTIONS(975),
    [aux_sym_include_once_expression_token1] = ACTIONS(975),
    [aux_sym_require_expression_token1] = ACTIONS(975),
    [aux_sym_require_once_expression_token1] = ACTIONS(975),
    [sym_comment] = ACTIONS(5),
  },
  [424] = {
    [sym_text_interpolation] = STATE(424),
    [sym_catch_clause] = STATE(430),
    [sym_finally_clause] = STATE(430),
    [aux_sym_try_statement_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(983),
    [sym_name] = ACTIONS(985),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(983),
    [aux_sym_function_static_declaration_token1] = ACTIONS(985),
    [aux_sym_global_declaration_token1] = ACTIONS(985),
    [aux_sym_namespace_definition_token1] = ACTIONS(985),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(985),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(985),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(985),
    [anon_sym_BSLASH] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [aux_sym_trait_declaration_token1] = ACTIONS(985),
    [aux_sym_interface_declaration_token1] = ACTIONS(985),
    [aux_sym_enum_declaration_token1] = ACTIONS(985),
    [aux_sym_enum_case_token1] = ACTIONS(985),
    [aux_sym_class_declaration_token1] = ACTIONS(985),
    [aux_sym_final_modifier_token1] = ACTIONS(985),
    [aux_sym_abstract_modifier_token1] = ACTIONS(985),
    [aux_sym_readonly_modifier_token1] = ACTIONS(985),
    [aux_sym_visibility_modifier_token1] = ACTIONS(985),
    [aux_sym_visibility_modifier_token2] = ACTIONS(985),
    [aux_sym_visibility_modifier_token3] = ACTIONS(985),
    [aux_sym__arrow_function_header_token1] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(983),
    [aux_sym_cast_type_token1] = ACTIONS(985),
    [aux_sym_echo_statement_token1] = ACTIONS(985),
    [anon_sym_unset] = ACTIONS(985),
    [aux_sym_declare_statement_token1] = ACTIONS(985),
    [aux_sym_declare_statement_token2] = ACTIONS(985),
    [sym_float] = ACTIONS(985),
    [aux_sym_try_statement_token1] = ACTIONS(985),
    [aux_sym_catch_clause_token1] = ACTIONS(987),
    [aux_sym_finally_clause_token1] = ACTIONS(989),
    [aux_sym_goto_statement_token1] = ACTIONS(985),
    [aux_sym_continue_statement_token1] = ACTIONS(985),
    [aux_sym_break_statement_token1] = ACTIONS(985),
    [sym_integer] = ACTIONS(985),
    [aux_sym_return_statement_token1] = ACTIONS(985),
    [aux_sym_throw_expression_token1] = ACTIONS(985),
    [aux_sym_while_statement_token1] = ACTIONS(985),
    [aux_sym_while_statement_token2] = ACTIONS(985),
    [aux_sym_do_statement_token1] = ACTIONS(985),
    [aux_sym_for_statement_token1] = ACTIONS(985),
    [aux_sym_for_statement_token2] = ACTIONS(985),
    [aux_sym_foreach_statement_token1] = ACTIONS(985),
    [aux_sym_foreach_statement_token2] = ACTIONS(985),
    [aux_sym_if_statement_token1] = ACTIONS(985),
    [aux_sym_if_statement_token2] = ACTIONS(985),
    [aux_sym_else_if_clause_token1] = ACTIONS(985),
    [aux_sym_else_clause_token1] = ACTIONS(985),
    [aux_sym_match_expression_token1] = ACTIONS(985),
    [aux_sym_match_default_expression_token1] = ACTIONS(985),
    [aux_sym_switch_statement_token1] = ACTIONS(985),
    [aux_sym_switch_block_token1] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(985),
    [anon_sym_DASH] = ACTIONS(985),
    [anon_sym_TILDE] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(983),
    [aux_sym_clone_expression_token1] = ACTIONS(985),
    [aux_sym_print_intrinsic_token1] = ACTIONS(985),
    [aux_sym_object_creation_expression_token1] = ACTIONS(985),
    [anon_sym_DASH_DASH] = ACTIONS(983),
    [anon_sym_PLUS_PLUS] = ACTIONS(983),
    [aux_sym__list_destructing_token1] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_self] = ACTIONS(985),
    [anon_sym_parent] = ACTIONS(985),
    [aux_sym__argument_name_token1] = ACTIONS(985),
    [aux_sym__argument_name_token2] = ACTIONS(985),
    [anon_sym_POUND_LBRACK] = ACTIONS(983),
    [aux_sym_encapsed_string_token1] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [aux_sym_string_token1] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [anon_sym_LT_LT_LT] = ACTIONS(983),
    [anon_sym_BQUOTE] = ACTIONS(983),
    [anon_sym_DOLLAR] = ACTIONS(983),
    [aux_sym_yield_expression_token1] = ACTIONS(985),
    [aux_sym_include_expression_token1] = ACTIONS(985),
    [aux_sym_include_once_expression_token1] = ACTIONS(985),
    [aux_sym_require_expression_token1] = ACTIONS(985),
    [aux_sym_require_once_expression_token1] = ACTIONS(985),
    [sym_comment] = ACTIONS(5),
  },
  [425] = {
    [sym_text_interpolation] = STATE(425),
    [sym_else_if_clause] = STATE(507),
    [sym_else_clause] = STATE(506),
    [aux_sym_if_statement_repeat1] = STATE(427),
    [ts_builtin_sym_end] = ACTIONS(991),
    [sym_name] = ACTIONS(993),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(991),
    [aux_sym_function_static_declaration_token1] = ACTIONS(993),
    [aux_sym_global_declaration_token1] = ACTIONS(993),
    [aux_sym_namespace_definition_token1] = ACTIONS(993),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(993),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(993),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(993),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(991),
    [anon_sym_RBRACE] = ACTIONS(991),
    [aux_sym_trait_declaration_token1] = ACTIONS(993),
    [aux_sym_interface_declaration_token1] = ACTIONS(993),
    [aux_sym_enum_declaration_token1] = ACTIONS(993),
    [aux_sym_enum_case_token1] = ACTIONS(993),
    [aux_sym_class_declaration_token1] = ACTIONS(993),
    [aux_sym_final_modifier_token1] = ACTIONS(993),
    [aux_sym_abstract_modifier_token1] = ACTIONS(993),
    [aux_sym_readonly_modifier_token1] = ACTIONS(993),
    [aux_sym_visibility_modifier_token1] = ACTIONS(993),
    [aux_sym_visibility_modifier_token2] = ACTIONS(993),
    [aux_sym_visibility_modifier_token3] = ACTIONS(993),
    [aux_sym__arrow_function_header_token1] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(991),
    [aux_sym_cast_type_token1] = ACTIONS(993),
    [aux_sym_echo_statement_token1] = ACTIONS(993),
    [anon_sym_unset] = ACTIONS(993),
    [aux_sym_declare_statement_token1] = ACTIONS(993),
    [aux_sym_declare_statement_token2] = ACTIONS(993),
    [sym_float] = ACTIONS(993),
    [aux_sym_try_statement_token1] = ACTIONS(993),
    [aux_sym_goto_statement_token1] = ACTIONS(993),
    [aux_sym_continue_statement_token1] = ACTIONS(993),
    [aux_sym_break_statement_token1] = ACTIONS(993),
    [sym_integer] = ACTIONS(993),
    [aux_sym_return_statement_token1] = ACTIONS(993),
    [aux_sym_throw_expression_token1] = ACTIONS(993),
    [aux_sym_while_statement_token1] = ACTIONS(993),
    [aux_sym_while_statement_token2] = ACTIONS(993),
    [aux_sym_do_statement_token1] = ACTIONS(993),
    [aux_sym_for_statement_token1] = ACTIONS(993),
    [aux_sym_for_statement_token2] = ACTIONS(993),
    [aux_sym_foreach_statement_token1] = ACTIONS(993),
    [aux_sym_foreach_statement_token2] = ACTIONS(993),
    [aux_sym_if_statement_token1] = ACTIONS(993),
    [aux_sym_if_statement_token2] = ACTIONS(993),
    [aux_sym_else_if_clause_token1] = ACTIONS(995),
    [aux_sym_else_clause_token1] = ACTIONS(998),
    [aux_sym_match_expression_token1] = ACTIONS(993),
    [aux_sym_match_default_expression_token1] = ACTIONS(993),
    [aux_sym_switch_statement_token1] = ACTIONS(993),
    [aux_sym_switch_block_token1] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(991),
    [aux_sym_clone_expression_token1] = ACTIONS(993),
    [aux_sym_print_intrinsic_token1] = ACTIONS(993),
    [aux_sym_object_creation_expression_token1] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(991),
    [aux_sym__list_destructing_token1] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_self] = ACTIONS(993),
    [anon_sym_parent] = ACTIONS(993),
    [aux_sym__argument_name_token1] = ACTIONS(993),
    [aux_sym__argument_name_token2] = ACTIONS(993),
    [anon_sym_POUND_LBRACK] = ACTIONS(991),
    [aux_sym_encapsed_string_token1] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [aux_sym_string_token1] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(991),
    [anon_sym_LT_LT_LT] = ACTIONS(991),
    [anon_sym_BQUOTE] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(991),
    [aux_sym_yield_expression_token1] = ACTIONS(993),
    [aux_sym_include_expression_token1] = ACTIONS(993),
    [aux_sym_include_once_expression_token1] = ACTIONS(993),
    [aux_sym_require_expression_token1] = ACTIONS(993),
    [aux_sym_require_once_expression_token1] = ACTIONS(993),
    [sym_comment] = ACTIONS(5),
  },
  [426] = {
    [sym_text_interpolation] = STATE(426),
    [sym_else_if_clause] = STATE(507),
    [sym_else_clause] = STATE(506),
    [aux_sym_if_statement_repeat1] = STATE(428),
    [ts_builtin_sym_end] = ACTIONS(991),
    [sym_name] = ACTIONS(993),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(991),
    [aux_sym_function_static_declaration_token1] = ACTIONS(993),
    [aux_sym_global_declaration_token1] = ACTIONS(993),
    [aux_sym_namespace_definition_token1] = ACTIONS(993),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(993),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(993),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(993),
    [anon_sym_BSLASH] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(991),
    [anon_sym_RBRACE] = ACTIONS(991),
    [aux_sym_trait_declaration_token1] = ACTIONS(993),
    [aux_sym_interface_declaration_token1] = ACTIONS(993),
    [aux_sym_enum_declaration_token1] = ACTIONS(993),
    [aux_sym_enum_case_token1] = ACTIONS(993),
    [aux_sym_class_declaration_token1] = ACTIONS(993),
    [aux_sym_final_modifier_token1] = ACTIONS(993),
    [aux_sym_abstract_modifier_token1] = ACTIONS(993),
    [aux_sym_readonly_modifier_token1] = ACTIONS(993),
    [aux_sym_visibility_modifier_token1] = ACTIONS(993),
    [aux_sym_visibility_modifier_token2] = ACTIONS(993),
    [aux_sym_visibility_modifier_token3] = ACTIONS(993),
    [aux_sym__arrow_function_header_token1] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(991),
    [aux_sym_cast_type_token1] = ACTIONS(993),
    [aux_sym_echo_statement_token1] = ACTIONS(993),
    [anon_sym_unset] = ACTIONS(993),
    [aux_sym_declare_statement_token1] = ACTIONS(993),
    [aux_sym_declare_statement_token2] = ACTIONS(993),
    [sym_float] = ACTIONS(993),
    [aux_sym_try_statement_token1] = ACTIONS(993),
    [aux_sym_goto_statement_token1] = ACTIONS(993),
    [aux_sym_continue_statement_token1] = ACTIONS(993),
    [aux_sym_break_statement_token1] = ACTIONS(993),
    [sym_integer] = ACTIONS(993),
    [aux_sym_return_statement_token1] = ACTIONS(993),
    [aux_sym_throw_expression_token1] = ACTIONS(993),
    [aux_sym_while_statement_token1] = ACTIONS(993),
    [aux_sym_while_statement_token2] = ACTIONS(993),
    [aux_sym_do_statement_token1] = ACTIONS(993),
    [aux_sym_for_statement_token1] = ACTIONS(993),
    [aux_sym_for_statement_token2] = ACTIONS(993),
    [aux_sym_foreach_statement_token1] = ACTIONS(993),
    [aux_sym_foreach_statement_token2] = ACTIONS(993),
    [aux_sym_if_statement_token1] = ACTIONS(993),
    [aux_sym_if_statement_token2] = ACTIONS(993),
    [aux_sym_else_if_clause_token1] = ACTIONS(1001),
    [aux_sym_else_clause_token1] = ACTIONS(1003),
    [aux_sym_match_expression_token1] = ACTIONS(993),
    [aux_sym_match_default_expression_token1] = ACTIONS(993),
    [aux_sym_switch_statement_token1] = ACTIONS(993),
    [aux_sym_switch_block_token1] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(993),
    [anon_sym_DASH] = ACTIONS(993),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(991),
    [aux_sym_clone_expression_token1] = ACTIONS(993),
    [aux_sym_print_intrinsic_token1] = ACTIONS(993),
    [aux_sym_object_creation_expression_token1] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(991),
    [aux_sym__list_destructing_token1] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_self] = ACTIONS(993),
    [anon_sym_parent] = ACTIONS(993),
    [aux_sym__argument_name_token1] = ACTIONS(993),
    [aux_sym__argument_name_token2] = ACTIONS(993),
    [anon_sym_POUND_LBRACK] = ACTIONS(991),
    [aux_sym_encapsed_string_token1] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [aux_sym_string_token1] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(991),
    [anon_sym_LT_LT_LT] = ACTIONS(991),
    [anon_sym_BQUOTE] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(991),
    [aux_sym_yield_expression_token1] = ACTIONS(993),
    [aux_sym_include_expression_token1] = ACTIONS(993),
    [aux_sym_include_once_expression_token1] = ACTIONS(993),
    [aux_sym_require_expression_token1] = ACTIONS(993),
    [aux_sym_require_once_expression_token1] = ACTIONS(993),
    [sym_comment] = ACTIONS(5),
  },
  [427] = {
    [sym_text_interpolation] = STATE(427),
    [sym_else_if_clause] = STATE(507),
    [sym_else_clause] = STATE(457),
    [aux_sym_if_statement_repeat1] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [sym_name] = ACTIONS(1007),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1005),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1007),
    [aux_sym_global_declaration_token1] = ACTIONS(1007),
    [aux_sym_namespace_definition_token1] = ACTIONS(1007),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1007),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1007),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [aux_sym_trait_declaration_token1] = ACTIONS(1007),
    [aux_sym_interface_declaration_token1] = ACTIONS(1007),
    [aux_sym_enum_declaration_token1] = ACTIONS(1007),
    [aux_sym_enum_case_token1] = ACTIONS(1007),
    [aux_sym_class_declaration_token1] = ACTIONS(1007),
    [aux_sym_final_modifier_token1] = ACTIONS(1007),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1007),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1007),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1007),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1007),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1007),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [aux_sym_cast_type_token1] = ACTIONS(1007),
    [aux_sym_echo_statement_token1] = ACTIONS(1007),
    [anon_sym_unset] = ACTIONS(1007),
    [aux_sym_declare_statement_token1] = ACTIONS(1007),
    [aux_sym_declare_statement_token2] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [aux_sym_try_statement_token1] = ACTIONS(1007),
    [aux_sym_goto_statement_token1] = ACTIONS(1007),
    [aux_sym_continue_statement_token1] = ACTIONS(1007),
    [aux_sym_break_statement_token1] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1007),
    [aux_sym_return_statement_token1] = ACTIONS(1007),
    [aux_sym_throw_expression_token1] = ACTIONS(1007),
    [aux_sym_while_statement_token1] = ACTIONS(1007),
    [aux_sym_while_statement_token2] = ACTIONS(1007),
    [aux_sym_do_statement_token1] = ACTIONS(1007),
    [aux_sym_for_statement_token1] = ACTIONS(1007),
    [aux_sym_for_statement_token2] = ACTIONS(1007),
    [aux_sym_foreach_statement_token1] = ACTIONS(1007),
    [aux_sym_foreach_statement_token2] = ACTIONS(1007),
    [aux_sym_if_statement_token1] = ACTIONS(1007),
    [aux_sym_if_statement_token2] = ACTIONS(1007),
    [aux_sym_else_if_clause_token1] = ACTIONS(1009),
    [aux_sym_else_clause_token1] = ACTIONS(1012),
    [aux_sym_match_expression_token1] = ACTIONS(1007),
    [aux_sym_match_default_expression_token1] = ACTIONS(1007),
    [aux_sym_switch_statement_token1] = ACTIONS(1007),
    [aux_sym_switch_block_token1] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1005),
    [aux_sym_clone_expression_token1] = ACTIONS(1007),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1007),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1007),
    [anon_sym_DASH_DASH] = ACTIONS(1005),
    [anon_sym_PLUS_PLUS] = ACTIONS(1005),
    [aux_sym__list_destructing_token1] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_self] = ACTIONS(1007),
    [anon_sym_parent] = ACTIONS(1007),
    [aux_sym__argument_name_token1] = ACTIONS(1007),
    [aux_sym__argument_name_token2] = ACTIONS(1007),
    [anon_sym_POUND_LBRACK] = ACTIONS(1005),
    [aux_sym_encapsed_string_token1] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1005),
    [aux_sym_string_token1] = ACTIONS(1005),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LT_LT] = ACTIONS(1005),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_DOLLAR] = ACTIONS(1005),
    [aux_sym_yield_expression_token1] = ACTIONS(1007),
    [aux_sym_include_expression_token1] = ACTIONS(1007),
    [aux_sym_include_once_expression_token1] = ACTIONS(1007),
    [aux_sym_require_expression_token1] = ACTIONS(1007),
    [aux_sym_require_once_expression_token1] = ACTIONS(1007),
    [sym_comment] = ACTIONS(5),
  },
  [428] = {
    [sym_text_interpolation] = STATE(428),
    [sym_else_if_clause] = STATE(507),
    [sym_else_clause] = STATE(457),
    [aux_sym_if_statement_repeat1] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [sym_name] = ACTIONS(1007),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1005),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1007),
    [aux_sym_global_declaration_token1] = ACTIONS(1007),
    [aux_sym_namespace_definition_token1] = ACTIONS(1007),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1007),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1007),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(1005),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [aux_sym_trait_declaration_token1] = ACTIONS(1007),
    [aux_sym_interface_declaration_token1] = ACTIONS(1007),
    [aux_sym_enum_declaration_token1] = ACTIONS(1007),
    [aux_sym_enum_case_token1] = ACTIONS(1007),
    [aux_sym_class_declaration_token1] = ACTIONS(1007),
    [aux_sym_final_modifier_token1] = ACTIONS(1007),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1007),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1007),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1007),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1007),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1007),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [aux_sym_cast_type_token1] = ACTIONS(1007),
    [aux_sym_echo_statement_token1] = ACTIONS(1007),
    [anon_sym_unset] = ACTIONS(1007),
    [aux_sym_declare_statement_token1] = ACTIONS(1007),
    [aux_sym_declare_statement_token2] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [aux_sym_try_statement_token1] = ACTIONS(1007),
    [aux_sym_goto_statement_token1] = ACTIONS(1007),
    [aux_sym_continue_statement_token1] = ACTIONS(1007),
    [aux_sym_break_statement_token1] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1007),
    [aux_sym_return_statement_token1] = ACTIONS(1007),
    [aux_sym_throw_expression_token1] = ACTIONS(1007),
    [aux_sym_while_statement_token1] = ACTIONS(1007),
    [aux_sym_while_statement_token2] = ACTIONS(1007),
    [aux_sym_do_statement_token1] = ACTIONS(1007),
    [aux_sym_for_statement_token1] = ACTIONS(1007),
    [aux_sym_for_statement_token2] = ACTIONS(1007),
    [aux_sym_foreach_statement_token1] = ACTIONS(1007),
    [aux_sym_foreach_statement_token2] = ACTIONS(1007),
    [aux_sym_if_statement_token1] = ACTIONS(1007),
    [aux_sym_if_statement_token2] = ACTIONS(1007),
    [aux_sym_else_if_clause_token1] = ACTIONS(1001),
    [aux_sym_else_clause_token1] = ACTIONS(1003),
    [aux_sym_match_expression_token1] = ACTIONS(1007),
    [aux_sym_match_default_expression_token1] = ACTIONS(1007),
    [aux_sym_switch_statement_token1] = ACTIONS(1007),
    [aux_sym_switch_block_token1] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1005),
    [aux_sym_clone_expression_token1] = ACTIONS(1007),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1007),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1007),
    [anon_sym_DASH_DASH] = ACTIONS(1005),
    [anon_sym_PLUS_PLUS] = ACTIONS(1005),
    [aux_sym__list_destructing_token1] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_self] = ACTIONS(1007),
    [anon_sym_parent] = ACTIONS(1007),
    [aux_sym__argument_name_token1] = ACTIONS(1007),
    [aux_sym__argument_name_token2] = ACTIONS(1007),
    [anon_sym_POUND_LBRACK] = ACTIONS(1005),
    [aux_sym_encapsed_string_token1] = ACTIONS(1005),
    [anon_sym_DQUOTE] = ACTIONS(1005),
    [aux_sym_string_token1] = ACTIONS(1005),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [anon_sym_LT_LT_LT] = ACTIONS(1005),
    [anon_sym_BQUOTE] = ACTIONS(1005),
    [anon_sym_DOLLAR] = ACTIONS(1005),
    [aux_sym_yield_expression_token1] = ACTIONS(1007),
    [aux_sym_include_expression_token1] = ACTIONS(1007),
    [aux_sym_include_once_expression_token1] = ACTIONS(1007),
    [aux_sym_require_expression_token1] = ACTIONS(1007),
    [aux_sym_require_once_expression_token1] = ACTIONS(1007),
    [sym_comment] = ACTIONS(5),
  },
  [429] = {
    [sym_text_interpolation] = STATE(429),
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_name] = ACTIONS(1017),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1015),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1017),
    [aux_sym_global_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_definition_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1017),
    [anon_sym_BSLASH] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [aux_sym_trait_declaration_token1] = ACTIONS(1017),
    [aux_sym_interface_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_case_token1] = ACTIONS(1017),
    [aux_sym_class_declaration_token1] = ACTIONS(1017),
    [aux_sym_final_modifier_token1] = ACTIONS(1017),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1017),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1017),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [aux_sym_cast_type_token1] = ACTIONS(1017),
    [aux_sym_echo_statement_token1] = ACTIONS(1017),
    [anon_sym_unset] = ACTIONS(1017),
    [aux_sym_declare_statement_token1] = ACTIONS(1017),
    [aux_sym_declare_statement_token2] = ACTIONS(1017),
    [sym_float] = ACTIONS(1017),
    [aux_sym_try_statement_token1] = ACTIONS(1017),
    [aux_sym_catch_clause_token1] = ACTIONS(1017),
    [aux_sym_finally_clause_token1] = ACTIONS(1017),
    [aux_sym_goto_statement_token1] = ACTIONS(1017),
    [aux_sym_continue_statement_token1] = ACTIONS(1017),
    [aux_sym_break_statement_token1] = ACTIONS(1017),
    [sym_integer] = ACTIONS(1017),
    [aux_sym_return_statement_token1] = ACTIONS(1017),
    [aux_sym_throw_expression_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token2] = ACTIONS(1017),
    [aux_sym_do_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token2] = ACTIONS(1017),
    [aux_sym_foreach_statement_token1] = ACTIONS(1017),
    [aux_sym_foreach_statement_token2] = ACTIONS(1017),
    [aux_sym_if_statement_token1] = ACTIONS(1017),
    [aux_sym_if_statement_token2] = ACTIONS(1017),
    [aux_sym_else_if_clause_token1] = ACTIONS(1017),
    [aux_sym_else_clause_token1] = ACTIONS(1017),
    [aux_sym_match_expression_token1] = ACTIONS(1017),
    [aux_sym_match_default_expression_token1] = ACTIONS(1017),
    [aux_sym_switch_statement_token1] = ACTIONS(1017),
    [aux_sym_switch_block_token1] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1015),
    [aux_sym_clone_expression_token1] = ACTIONS(1017),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1017),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [aux_sym__list_destructing_token1] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_self] = ACTIONS(1017),
    [anon_sym_parent] = ACTIONS(1017),
    [aux_sym__argument_name_token1] = ACTIONS(1017),
    [aux_sym__argument_name_token2] = ACTIONS(1017),
    [anon_sym_POUND_LBRACK] = ACTIONS(1015),
    [aux_sym_encapsed_string_token1] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [aux_sym_string_token1] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1015),
    [aux_sym_yield_expression_token1] = ACTIONS(1017),
    [aux_sym_include_expression_token1] = ACTIONS(1017),
    [aux_sym_include_once_expression_token1] = ACTIONS(1017),
    [aux_sym_require_expression_token1] = ACTIONS(1017),
    [aux_sym_require_once_expression_token1] = ACTIONS(1017),
    [sym_comment] = ACTIONS(5),
  },
  [430] = {
    [sym_text_interpolation] = STATE(430),
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym_name] = ACTIONS(1021),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1019),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1021),
    [aux_sym_global_declaration_token1] = ACTIONS(1021),
    [aux_sym_namespace_definition_token1] = ACTIONS(1021),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1021),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1021),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1021),
    [anon_sym_BSLASH] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [aux_sym_trait_declaration_token1] = ACTIONS(1021),
    [aux_sym_interface_declaration_token1] = ACTIONS(1021),
    [aux_sym_enum_declaration_token1] = ACTIONS(1021),
    [aux_sym_enum_case_token1] = ACTIONS(1021),
    [aux_sym_class_declaration_token1] = ACTIONS(1021),
    [aux_sym_final_modifier_token1] = ACTIONS(1021),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1021),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1021),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1021),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1021),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1021),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [aux_sym_cast_type_token1] = ACTIONS(1021),
    [aux_sym_echo_statement_token1] = ACTIONS(1021),
    [anon_sym_unset] = ACTIONS(1021),
    [aux_sym_declare_statement_token1] = ACTIONS(1021),
    [aux_sym_declare_statement_token2] = ACTIONS(1021),
    [sym_float] = ACTIONS(1021),
    [aux_sym_try_statement_token1] = ACTIONS(1021),
    [aux_sym_catch_clause_token1] = ACTIONS(1021),
    [aux_sym_finally_clause_token1] = ACTIONS(1021),
    [aux_sym_goto_statement_token1] = ACTIONS(1021),
    [aux_sym_continue_statement_token1] = ACTIONS(1021),
    [aux_sym_break_statement_token1] = ACTIONS(1021),
    [sym_integer] = ACTIONS(1021),
    [aux_sym_return_statement_token1] = ACTIONS(1021),
    [aux_sym_throw_expression_token1] = ACTIONS(1021),
    [aux_sym_while_statement_token1] = ACTIONS(1021),
    [aux_sym_while_statement_token2] = ACTIONS(1021),
    [aux_sym_do_statement_token1] = ACTIONS(1021),
    [aux_sym_for_statement_token1] = ACTIONS(1021),
    [aux_sym_for_statement_token2] = ACTIONS(1021),
    [aux_sym_foreach_statement_token1] = ACTIONS(1021),
    [aux_sym_foreach_statement_token2] = ACTIONS(1021),
    [aux_sym_if_statement_token1] = ACTIONS(1021),
    [aux_sym_if_statement_token2] = ACTIONS(1021),
    [aux_sym_else_if_clause_token1] = ACTIONS(1021),
    [aux_sym_else_clause_token1] = ACTIONS(1021),
    [aux_sym_match_expression_token1] = ACTIONS(1021),
    [aux_sym_match_default_expression_token1] = ACTIONS(1021),
    [aux_sym_switch_statement_token1] = ACTIONS(1021),
    [aux_sym_switch_block_token1] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(1019),
    [aux_sym_clone_expression_token1] = ACTIONS(1021),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1021),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1021),
    [anon_sym_DASH_DASH] = ACTIONS(1019),
    [anon_sym_PLUS_PLUS] = ACTIONS(1019),
    [aux_sym__list_destructing_token1] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_self] = ACTIONS(1021),
    [anon_sym_parent] = ACTIONS(1021),
    [aux_sym__argument_name_token1] = ACTIONS(1021),
    [aux_sym__argument_name_token2] = ACTIONS(1021),
    [anon_sym_POUND_LBRACK] = ACTIONS(1019),
    [aux_sym_encapsed_string_token1] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [aux_sym_string_token1] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [anon_sym_LT_LT_LT] = ACTIONS(1019),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [aux_sym_yield_expression_token1] = ACTIONS(1021),
    [aux_sym_include_expression_token1] = ACTIONS(1021),
    [aux_sym_include_once_expression_token1] = ACTIONS(1021),
    [aux_sym_require_expression_token1] = ACTIONS(1021),
    [aux_sym_require_once_expression_token1] = ACTIONS(1021),
    [sym_comment] = ACTIONS(5),
  },
  [431] = {
    [sym_text_interpolation] = STATE(431),
    [ts_builtin_sym_end] = ACTIONS(1023),
    [sym_name] = ACTIONS(1025),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1023),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1025),
    [aux_sym_global_declaration_token1] = ACTIONS(1025),
    [aux_sym_namespace_definition_token1] = ACTIONS(1025),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1025),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1025),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1025),
    [anon_sym_BSLASH] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [aux_sym_trait_declaration_token1] = ACTIONS(1025),
    [aux_sym_interface_declaration_token1] = ACTIONS(1025),
    [aux_sym_enum_declaration_token1] = ACTIONS(1025),
    [aux_sym_enum_case_token1] = ACTIONS(1025),
    [aux_sym_class_declaration_token1] = ACTIONS(1025),
    [aux_sym_final_modifier_token1] = ACTIONS(1025),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1025),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1025),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1025),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1025),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1025),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [aux_sym_cast_type_token1] = ACTIONS(1025),
    [aux_sym_echo_statement_token1] = ACTIONS(1025),
    [anon_sym_unset] = ACTIONS(1025),
    [aux_sym_declare_statement_token1] = ACTIONS(1025),
    [aux_sym_declare_statement_token2] = ACTIONS(1025),
    [sym_float] = ACTIONS(1025),
    [aux_sym_try_statement_token1] = ACTIONS(1025),
    [aux_sym_catch_clause_token1] = ACTIONS(1025),
    [aux_sym_finally_clause_token1] = ACTIONS(1025),
    [aux_sym_goto_statement_token1] = ACTIONS(1025),
    [aux_sym_continue_statement_token1] = ACTIONS(1025),
    [aux_sym_break_statement_token1] = ACTIONS(1025),
    [sym_integer] = ACTIONS(1025),
    [aux_sym_return_statement_token1] = ACTIONS(1025),
    [aux_sym_throw_expression_token1] = ACTIONS(1025),
    [aux_sym_while_statement_token1] = ACTIONS(1025),
    [aux_sym_while_statement_token2] = ACTIONS(1025),
    [aux_sym_do_statement_token1] = ACTIONS(1025),
    [aux_sym_for_statement_token1] = ACTIONS(1025),
    [aux_sym_for_statement_token2] = ACTIONS(1025),
    [aux_sym_foreach_statement_token1] = ACTIONS(1025),
    [aux_sym_foreach_statement_token2] = ACTIONS(1025),
    [aux_sym_if_statement_token1] = ACTIONS(1025),
    [aux_sym_if_statement_token2] = ACTIONS(1025),
    [aux_sym_else_if_clause_token1] = ACTIONS(1025),
    [aux_sym_else_clause_token1] = ACTIONS(1025),
    [aux_sym_match_expression_token1] = ACTIONS(1025),
    [aux_sym_match_default_expression_token1] = ACTIONS(1025),
    [aux_sym_switch_statement_token1] = ACTIONS(1025),
    [aux_sym_switch_block_token1] = ACTIONS(1025),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1023),
    [aux_sym_clone_expression_token1] = ACTIONS(1025),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1025),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [aux_sym__list_destructing_token1] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [anon_sym_self] = ACTIONS(1025),
    [anon_sym_parent] = ACTIONS(1025),
    [aux_sym__argument_name_token1] = ACTIONS(1025),
    [aux_sym__argument_name_token2] = ACTIONS(1025),
    [anon_sym_POUND_LBRACK] = ACTIONS(1023),
    [aux_sym_encapsed_string_token1] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [aux_sym_string_token1] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LT_LT] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [aux_sym_yield_expression_token1] = ACTIONS(1025),
    [aux_sym_include_expression_token1] = ACTIONS(1025),
    [aux_sym_include_once_expression_token1] = ACTIONS(1025),
    [aux_sym_require_expression_token1] = ACTIONS(1025),
    [aux_sym_require_once_expression_token1] = ACTIONS(1025),
    [sym_comment] = ACTIONS(5),
  },
  [432] = {
    [sym_text_interpolation] = STATE(432),
    [ts_builtin_sym_end] = ACTIONS(1027),
    [sym_name] = ACTIONS(1029),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1027),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1029),
    [aux_sym_global_declaration_token1] = ACTIONS(1029),
    [aux_sym_namespace_definition_token1] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1029),
    [anon_sym_BSLASH] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [aux_sym_trait_declaration_token1] = ACTIONS(1029),
    [aux_sym_interface_declaration_token1] = ACTIONS(1029),
    [aux_sym_enum_declaration_token1] = ACTIONS(1029),
    [aux_sym_enum_case_token1] = ACTIONS(1029),
    [aux_sym_class_declaration_token1] = ACTIONS(1029),
    [aux_sym_final_modifier_token1] = ACTIONS(1029),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1029),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1029),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [aux_sym_cast_type_token1] = ACTIONS(1029),
    [aux_sym_echo_statement_token1] = ACTIONS(1029),
    [anon_sym_unset] = ACTIONS(1029),
    [aux_sym_declare_statement_token1] = ACTIONS(1029),
    [aux_sym_declare_statement_token2] = ACTIONS(1029),
    [sym_float] = ACTIONS(1029),
    [aux_sym_try_statement_token1] = ACTIONS(1029),
    [aux_sym_catch_clause_token1] = ACTIONS(1029),
    [aux_sym_finally_clause_token1] = ACTIONS(1029),
    [aux_sym_goto_statement_token1] = ACTIONS(1029),
    [aux_sym_continue_statement_token1] = ACTIONS(1029),
    [aux_sym_break_statement_token1] = ACTIONS(1029),
    [sym_integer] = ACTIONS(1029),
    [aux_sym_return_statement_token1] = ACTIONS(1029),
    [aux_sym_throw_expression_token1] = ACTIONS(1029),
    [aux_sym_while_statement_token1] = ACTIONS(1029),
    [aux_sym_while_statement_token2] = ACTIONS(1029),
    [aux_sym_do_statement_token1] = ACTIONS(1029),
    [aux_sym_for_statement_token1] = ACTIONS(1029),
    [aux_sym_for_statement_token2] = ACTIONS(1029),
    [aux_sym_foreach_statement_token1] = ACTIONS(1029),
    [aux_sym_foreach_statement_token2] = ACTIONS(1029),
    [aux_sym_if_statement_token1] = ACTIONS(1029),
    [aux_sym_if_statement_token2] = ACTIONS(1029),
    [aux_sym_else_if_clause_token1] = ACTIONS(1029),
    [aux_sym_else_clause_token1] = ACTIONS(1029),
    [aux_sym_match_expression_token1] = ACTIONS(1029),
    [aux_sym_match_default_expression_token1] = ACTIONS(1029),
    [aux_sym_switch_statement_token1] = ACTIONS(1029),
    [aux_sym_switch_block_token1] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(1027),
    [aux_sym_clone_expression_token1] = ACTIONS(1029),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1029),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [aux_sym__list_destructing_token1] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_self] = ACTIONS(1029),
    [anon_sym_parent] = ACTIONS(1029),
    [aux_sym__argument_name_token1] = ACTIONS(1029),
    [aux_sym__argument_name_token2] = ACTIONS(1029),
    [anon_sym_POUND_LBRACK] = ACTIONS(1027),
    [aux_sym_encapsed_string_token1] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [aux_sym_string_token1] = ACTIONS(1027),
    [anon_sym_SQUOTE] = ACTIONS(1027),
    [anon_sym_LT_LT_LT] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1027),
    [aux_sym_yield_expression_token1] = ACTIONS(1029),
    [aux_sym_include_expression_token1] = ACTIONS(1029),
    [aux_sym_include_once_expression_token1] = ACTIONS(1029),
    [aux_sym_require_expression_token1] = ACTIONS(1029),
    [aux_sym_require_once_expression_token1] = ACTIONS(1029),
    [sym_comment] = ACTIONS(5),
  },
  [433] = {
    [sym_text_interpolation] = STATE(433),
    [sym_else_if_clause] = STATE(507),
    [aux_sym_if_statement_repeat1] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(1031),
    [sym_name] = ACTIONS(1033),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1031),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1033),
    [aux_sym_global_declaration_token1] = ACTIONS(1033),
    [aux_sym_namespace_definition_token1] = ACTIONS(1033),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1033),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1033),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1033),
    [anon_sym_BSLASH] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [aux_sym_trait_declaration_token1] = ACTIONS(1033),
    [aux_sym_interface_declaration_token1] = ACTIONS(1033),
    [aux_sym_enum_declaration_token1] = ACTIONS(1033),
    [aux_sym_enum_case_token1] = ACTIONS(1033),
    [aux_sym_class_declaration_token1] = ACTIONS(1033),
    [aux_sym_final_modifier_token1] = ACTIONS(1033),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1033),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1033),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1033),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1033),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1033),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [aux_sym_cast_type_token1] = ACTIONS(1033),
    [aux_sym_echo_statement_token1] = ACTIONS(1033),
    [anon_sym_unset] = ACTIONS(1033),
    [aux_sym_declare_statement_token1] = ACTIONS(1033),
    [aux_sym_declare_statement_token2] = ACTIONS(1033),
    [sym_float] = ACTIONS(1033),
    [aux_sym_try_statement_token1] = ACTIONS(1033),
    [aux_sym_goto_statement_token1] = ACTIONS(1033),
    [aux_sym_continue_statement_token1] = ACTIONS(1033),
    [aux_sym_break_statement_token1] = ACTIONS(1033),
    [sym_integer] = ACTIONS(1033),
    [aux_sym_return_statement_token1] = ACTIONS(1033),
    [aux_sym_throw_expression_token1] = ACTIONS(1033),
    [aux_sym_while_statement_token1] = ACTIONS(1033),
    [aux_sym_while_statement_token2] = ACTIONS(1033),
    [aux_sym_do_statement_token1] = ACTIONS(1033),
    [aux_sym_for_statement_token1] = ACTIONS(1033),
    [aux_sym_for_statement_token2] = ACTIONS(1033),
    [aux_sym_foreach_statement_token1] = ACTIONS(1033),
    [aux_sym_foreach_statement_token2] = ACTIONS(1033),
    [aux_sym_if_statement_token1] = ACTIONS(1033),
    [aux_sym_if_statement_token2] = ACTIONS(1033),
    [aux_sym_else_if_clause_token1] = ACTIONS(1035),
    [aux_sym_else_clause_token1] = ACTIONS(1033),
    [aux_sym_match_expression_token1] = ACTIONS(1033),
    [aux_sym_match_default_expression_token1] = ACTIONS(1033),
    [aux_sym_switch_statement_token1] = ACTIONS(1033),
    [aux_sym_switch_block_token1] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1031),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1031),
    [aux_sym_clone_expression_token1] = ACTIONS(1033),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1033),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1031),
    [aux_sym__list_destructing_token1] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_self] = ACTIONS(1033),
    [anon_sym_parent] = ACTIONS(1033),
    [aux_sym__argument_name_token1] = ACTIONS(1033),
    [aux_sym__argument_name_token2] = ACTIONS(1033),
    [anon_sym_POUND_LBRACK] = ACTIONS(1031),
    [aux_sym_encapsed_string_token1] = ACTIONS(1031),
    [anon_sym_DQUOTE] = ACTIONS(1031),
    [aux_sym_string_token1] = ACTIONS(1031),
    [anon_sym_SQUOTE] = ACTIONS(1031),
    [anon_sym_LT_LT_LT] = ACTIONS(1031),
    [anon_sym_BQUOTE] = ACTIONS(1031),
    [anon_sym_DOLLAR] = ACTIONS(1031),
    [aux_sym_yield_expression_token1] = ACTIONS(1033),
    [aux_sym_include_expression_token1] = ACTIONS(1033),
    [aux_sym_include_once_expression_token1] = ACTIONS(1033),
    [aux_sym_require_expression_token1] = ACTIONS(1033),
    [aux_sym_require_once_expression_token1] = ACTIONS(1033),
    [sym_comment] = ACTIONS(5),
  },
  [434] = {
    [sym_text_interpolation] = STATE(434),
    [ts_builtin_sym_end] = ACTIONS(1038),
    [sym_name] = ACTIONS(1040),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1038),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1040),
    [aux_sym_global_declaration_token1] = ACTIONS(1040),
    [aux_sym_namespace_definition_token1] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1040),
    [anon_sym_BSLASH] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [aux_sym_trait_declaration_token1] = ACTIONS(1040),
    [aux_sym_interface_declaration_token1] = ACTIONS(1040),
    [aux_sym_enum_declaration_token1] = ACTIONS(1040),
    [aux_sym_enum_case_token1] = ACTIONS(1040),
    [aux_sym_class_declaration_token1] = ACTIONS(1040),
    [aux_sym_final_modifier_token1] = ACTIONS(1040),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1040),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1040),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_cast_type_token1] = ACTIONS(1040),
    [aux_sym_echo_statement_token1] = ACTIONS(1040),
    [anon_sym_unset] = ACTIONS(1040),
    [aux_sym_declare_statement_token1] = ACTIONS(1040),
    [aux_sym_declare_statement_token2] = ACTIONS(1040),
    [sym_float] = ACTIONS(1040),
    [aux_sym_try_statement_token1] = ACTIONS(1040),
    [aux_sym_catch_clause_token1] = ACTIONS(1040),
    [aux_sym_finally_clause_token1] = ACTIONS(1040),
    [aux_sym_goto_statement_token1] = ACTIONS(1040),
    [aux_sym_continue_statement_token1] = ACTIONS(1040),
    [aux_sym_break_statement_token1] = ACTIONS(1040),
    [sym_integer] = ACTIONS(1040),
    [aux_sym_return_statement_token1] = ACTIONS(1040),
    [aux_sym_throw_expression_token1] = ACTIONS(1040),
    [aux_sym_while_statement_token1] = ACTIONS(1040),
    [aux_sym_while_statement_token2] = ACTIONS(1040),
    [aux_sym_do_statement_token1] = ACTIONS(1040),
    [aux_sym_for_statement_token1] = ACTIONS(1040),
    [aux_sym_for_statement_token2] = ACTIONS(1040),
    [aux_sym_foreach_statement_token1] = ACTIONS(1040),
    [aux_sym_foreach_statement_token2] = ACTIONS(1040),
    [aux_sym_if_statement_token1] = ACTIONS(1040),
    [aux_sym_if_statement_token2] = ACTIONS(1040),
    [aux_sym_else_if_clause_token1] = ACTIONS(1040),
    [aux_sym_else_clause_token1] = ACTIONS(1040),
    [aux_sym_match_expression_token1] = ACTIONS(1040),
    [aux_sym_match_default_expression_token1] = ACTIONS(1040),
    [aux_sym_switch_statement_token1] = ACTIONS(1040),
    [aux_sym_switch_block_token1] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(1038),
    [aux_sym_clone_expression_token1] = ACTIONS(1040),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1040),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [aux_sym__list_destructing_token1] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1038),
    [anon_sym_self] = ACTIONS(1040),
    [anon_sym_parent] = ACTIONS(1040),
    [aux_sym__argument_name_token1] = ACTIONS(1040),
    [aux_sym__argument_name_token2] = ACTIONS(1040),
    [anon_sym_POUND_LBRACK] = ACTIONS(1038),
    [aux_sym_encapsed_string_token1] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [aux_sym_string_token1] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [aux_sym_yield_expression_token1] = ACTIONS(1040),
    [aux_sym_include_expression_token1] = ACTIONS(1040),
    [aux_sym_include_once_expression_token1] = ACTIONS(1040),
    [aux_sym_require_expression_token1] = ACTIONS(1040),
    [aux_sym_require_once_expression_token1] = ACTIONS(1040),
    [sym_comment] = ACTIONS(5),
  },
  [435] = {
    [sym_text_interpolation] = STATE(435),
    [ts_builtin_sym_end] = ACTIONS(1042),
    [sym_name] = ACTIONS(1044),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1042),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1044),
    [aux_sym_global_declaration_token1] = ACTIONS(1044),
    [aux_sym_namespace_definition_token1] = ACTIONS(1044),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1044),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1044),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1044),
    [anon_sym_BSLASH] = ACTIONS(1042),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [aux_sym_trait_declaration_token1] = ACTIONS(1044),
    [aux_sym_interface_declaration_token1] = ACTIONS(1044),
    [aux_sym_enum_declaration_token1] = ACTIONS(1044),
    [aux_sym_enum_case_token1] = ACTIONS(1044),
    [aux_sym_class_declaration_token1] = ACTIONS(1044),
    [aux_sym_final_modifier_token1] = ACTIONS(1044),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1044),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1044),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1044),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1044),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1044),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1044),
    [anon_sym_LPAREN] = ACTIONS(1042),
    [aux_sym_cast_type_token1] = ACTIONS(1044),
    [aux_sym_echo_statement_token1] = ACTIONS(1044),
    [anon_sym_unset] = ACTIONS(1044),
    [aux_sym_declare_statement_token1] = ACTIONS(1044),
    [aux_sym_declare_statement_token2] = ACTIONS(1044),
    [sym_float] = ACTIONS(1044),
    [aux_sym_try_statement_token1] = ACTIONS(1044),
    [aux_sym_catch_clause_token1] = ACTIONS(1044),
    [aux_sym_finally_clause_token1] = ACTIONS(1044),
    [aux_sym_goto_statement_token1] = ACTIONS(1044),
    [aux_sym_continue_statement_token1] = ACTIONS(1044),
    [aux_sym_break_statement_token1] = ACTIONS(1044),
    [sym_integer] = ACTIONS(1044),
    [aux_sym_return_statement_token1] = ACTIONS(1044),
    [aux_sym_throw_expression_token1] = ACTIONS(1044),
    [aux_sym_while_statement_token1] = ACTIONS(1044),
    [aux_sym_while_statement_token2] = ACTIONS(1044),
    [aux_sym_do_statement_token1] = ACTIONS(1044),
    [aux_sym_for_statement_token1] = ACTIONS(1044),
    [aux_sym_for_statement_token2] = ACTIONS(1044),
    [aux_sym_foreach_statement_token1] = ACTIONS(1044),
    [aux_sym_foreach_statement_token2] = ACTIONS(1044),
    [aux_sym_if_statement_token1] = ACTIONS(1044),
    [aux_sym_if_statement_token2] = ACTIONS(1044),
    [aux_sym_else_if_clause_token1] = ACTIONS(1044),
    [aux_sym_else_clause_token1] = ACTIONS(1044),
    [aux_sym_match_expression_token1] = ACTIONS(1044),
    [aux_sym_match_default_expression_token1] = ACTIONS(1044),
    [aux_sym_switch_statement_token1] = ACTIONS(1044),
    [aux_sym_switch_block_token1] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1044),
    [anon_sym_TILDE] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1042),
    [anon_sym_AT] = ACTIONS(1042),
    [aux_sym_clone_expression_token1] = ACTIONS(1044),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1044),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [aux_sym__list_destructing_token1] = ACTIONS(1044),
    [anon_sym_LBRACK] = ACTIONS(1042),
    [anon_sym_self] = ACTIONS(1044),
    [anon_sym_parent] = ACTIONS(1044),
    [aux_sym__argument_name_token1] = ACTIONS(1044),
    [aux_sym__argument_name_token2] = ACTIONS(1044),
    [anon_sym_POUND_LBRACK] = ACTIONS(1042),
    [aux_sym_encapsed_string_token1] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [aux_sym_string_token1] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [aux_sym_yield_expression_token1] = ACTIONS(1044),
    [aux_sym_include_expression_token1] = ACTIONS(1044),
    [aux_sym_include_once_expression_token1] = ACTIONS(1044),
    [aux_sym_require_expression_token1] = ACTIONS(1044),
    [aux_sym_require_once_expression_token1] = ACTIONS(1044),
    [sym_comment] = ACTIONS(5),
  },
  [436] = {
    [sym_text_interpolation] = STATE(436),
    [ts_builtin_sym_end] = ACTIONS(1046),
    [sym_name] = ACTIONS(1048),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1046),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1048),
    [aux_sym_global_declaration_token1] = ACTIONS(1048),
    [aux_sym_namespace_definition_token1] = ACTIONS(1048),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1048),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1048),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1048),
    [anon_sym_BSLASH] = ACTIONS(1046),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [aux_sym_trait_declaration_token1] = ACTIONS(1048),
    [aux_sym_interface_declaration_token1] = ACTIONS(1048),
    [aux_sym_enum_declaration_token1] = ACTIONS(1048),
    [aux_sym_enum_case_token1] = ACTIONS(1048),
    [aux_sym_class_declaration_token1] = ACTIONS(1048),
    [aux_sym_final_modifier_token1] = ACTIONS(1048),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1048),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1048),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1048),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1048),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1048),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [aux_sym_cast_type_token1] = ACTIONS(1048),
    [aux_sym_echo_statement_token1] = ACTIONS(1048),
    [anon_sym_unset] = ACTIONS(1048),
    [aux_sym_declare_statement_token1] = ACTIONS(1048),
    [aux_sym_declare_statement_token2] = ACTIONS(1048),
    [sym_float] = ACTIONS(1048),
    [aux_sym_try_statement_token1] = ACTIONS(1048),
    [aux_sym_goto_statement_token1] = ACTIONS(1048),
    [aux_sym_continue_statement_token1] = ACTIONS(1048),
    [aux_sym_break_statement_token1] = ACTIONS(1048),
    [sym_integer] = ACTIONS(1048),
    [aux_sym_return_statement_token1] = ACTIONS(1048),
    [aux_sym_throw_expression_token1] = ACTIONS(1048),
    [aux_sym_while_statement_token1] = ACTIONS(1048),
    [aux_sym_while_statement_token2] = ACTIONS(1048),
    [aux_sym_do_statement_token1] = ACTIONS(1048),
    [aux_sym_for_statement_token1] = ACTIONS(1048),
    [aux_sym_for_statement_token2] = ACTIONS(1048),
    [aux_sym_foreach_statement_token1] = ACTIONS(1048),
    [aux_sym_foreach_statement_token2] = ACTIONS(1048),
    [aux_sym_if_statement_token1] = ACTIONS(1048),
    [aux_sym_if_statement_token2] = ACTIONS(1048),
    [aux_sym_else_if_clause_token1] = ACTIONS(1048),
    [aux_sym_else_clause_token1] = ACTIONS(1048),
    [aux_sym_match_expression_token1] = ACTIONS(1048),
    [aux_sym_match_default_expression_token1] = ACTIONS(1048),
    [aux_sym_switch_statement_token1] = ACTIONS(1048),
    [aux_sym_switch_block_token1] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(1046),
    [aux_sym_clone_expression_token1] = ACTIONS(1048),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1048),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [aux_sym__list_destructing_token1] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_self] = ACTIONS(1048),
    [anon_sym_parent] = ACTIONS(1048),
    [aux_sym__argument_name_token1] = ACTIONS(1048),
    [aux_sym__argument_name_token2] = ACTIONS(1048),
    [anon_sym_POUND_LBRACK] = ACTIONS(1046),
    [aux_sym_encapsed_string_token1] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [aux_sym_string_token1] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LT_LT] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1046),
    [aux_sym_yield_expression_token1] = ACTIONS(1048),
    [aux_sym_include_expression_token1] = ACTIONS(1048),
    [aux_sym_include_once_expression_token1] = ACTIONS(1048),
    [aux_sym_require_expression_token1] = ACTIONS(1048),
    [aux_sym_require_once_expression_token1] = ACTIONS(1048),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1046),
  },
  [437] = {
    [sym_text_interpolation] = STATE(437),
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_name] = ACTIONS(1052),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1050),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1052),
    [aux_sym_global_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_definition_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1052),
    [anon_sym_BSLASH] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [aux_sym_trait_declaration_token1] = ACTIONS(1052),
    [aux_sym_interface_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_case_token1] = ACTIONS(1052),
    [aux_sym_class_declaration_token1] = ACTIONS(1052),
    [aux_sym_final_modifier_token1] = ACTIONS(1052),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1052),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1052),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [aux_sym_cast_type_token1] = ACTIONS(1052),
    [aux_sym_echo_statement_token1] = ACTIONS(1052),
    [anon_sym_unset] = ACTIONS(1052),
    [aux_sym_declare_statement_token1] = ACTIONS(1052),
    [aux_sym_declare_statement_token2] = ACTIONS(1052),
    [sym_float] = ACTIONS(1052),
    [aux_sym_try_statement_token1] = ACTIONS(1052),
    [aux_sym_goto_statement_token1] = ACTIONS(1052),
    [aux_sym_continue_statement_token1] = ACTIONS(1052),
    [aux_sym_break_statement_token1] = ACTIONS(1052),
    [sym_integer] = ACTIONS(1052),
    [aux_sym_return_statement_token1] = ACTIONS(1052),
    [aux_sym_throw_expression_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token2] = ACTIONS(1052),
    [aux_sym_do_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token2] = ACTIONS(1052),
    [aux_sym_foreach_statement_token1] = ACTIONS(1052),
    [aux_sym_foreach_statement_token2] = ACTIONS(1052),
    [aux_sym_if_statement_token1] = ACTIONS(1052),
    [aux_sym_if_statement_token2] = ACTIONS(1052),
    [aux_sym_else_if_clause_token1] = ACTIONS(1052),
    [aux_sym_else_clause_token1] = ACTIONS(1052),
    [aux_sym_match_expression_token1] = ACTIONS(1052),
    [aux_sym_match_default_expression_token1] = ACTIONS(1052),
    [aux_sym_switch_statement_token1] = ACTIONS(1052),
    [aux_sym_switch_block_token1] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1050),
    [aux_sym_clone_expression_token1] = ACTIONS(1052),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1052),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [aux_sym__list_destructing_token1] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1050),
    [anon_sym_self] = ACTIONS(1052),
    [anon_sym_parent] = ACTIONS(1052),
    [aux_sym__argument_name_token1] = ACTIONS(1052),
    [aux_sym__argument_name_token2] = ACTIONS(1052),
    [anon_sym_POUND_LBRACK] = ACTIONS(1050),
    [aux_sym_encapsed_string_token1] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [aux_sym_string_token1] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_LT_LT_LT] = ACTIONS(1050),
    [anon_sym_BQUOTE] = ACTIONS(1050),
    [anon_sym_DOLLAR] = ACTIONS(1050),
    [aux_sym_yield_expression_token1] = ACTIONS(1052),
    [aux_sym_include_expression_token1] = ACTIONS(1052),
    [aux_sym_include_once_expression_token1] = ACTIONS(1052),
    [aux_sym_require_expression_token1] = ACTIONS(1052),
    [aux_sym_require_once_expression_token1] = ACTIONS(1052),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1050),
  },
  [438] = {
    [sym_text_interpolation] = STATE(438),
    [ts_builtin_sym_end] = ACTIONS(1054),
    [sym_name] = ACTIONS(1056),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1058),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1056),
    [aux_sym_global_declaration_token1] = ACTIONS(1056),
    [aux_sym_namespace_definition_token1] = ACTIONS(1056),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1056),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1056),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1056),
    [anon_sym_BSLASH] = ACTIONS(1054),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [aux_sym_trait_declaration_token1] = ACTIONS(1056),
    [aux_sym_interface_declaration_token1] = ACTIONS(1056),
    [aux_sym_enum_declaration_token1] = ACTIONS(1056),
    [aux_sym_enum_case_token1] = ACTIONS(1056),
    [aux_sym_class_declaration_token1] = ACTIONS(1056),
    [aux_sym_final_modifier_token1] = ACTIONS(1056),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1056),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1056),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1056),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1056),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1056),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1054),
    [aux_sym_cast_type_token1] = ACTIONS(1056),
    [aux_sym_echo_statement_token1] = ACTIONS(1056),
    [anon_sym_unset] = ACTIONS(1056),
    [aux_sym_declare_statement_token1] = ACTIONS(1056),
    [aux_sym_declare_statement_token2] = ACTIONS(1056),
    [sym_float] = ACTIONS(1056),
    [aux_sym_try_statement_token1] = ACTIONS(1056),
    [aux_sym_goto_statement_token1] = ACTIONS(1056),
    [aux_sym_continue_statement_token1] = ACTIONS(1056),
    [aux_sym_break_statement_token1] = ACTIONS(1056),
    [sym_integer] = ACTIONS(1056),
    [aux_sym_return_statement_token1] = ACTIONS(1056),
    [aux_sym_throw_expression_token1] = ACTIONS(1056),
    [aux_sym_while_statement_token1] = ACTIONS(1056),
    [aux_sym_while_statement_token2] = ACTIONS(1056),
    [aux_sym_do_statement_token1] = ACTIONS(1056),
    [aux_sym_for_statement_token1] = ACTIONS(1056),
    [aux_sym_for_statement_token2] = ACTIONS(1056),
    [aux_sym_foreach_statement_token1] = ACTIONS(1056),
    [aux_sym_foreach_statement_token2] = ACTIONS(1056),
    [aux_sym_if_statement_token1] = ACTIONS(1056),
    [aux_sym_if_statement_token2] = ACTIONS(1056),
    [aux_sym_else_if_clause_token1] = ACTIONS(1056),
    [aux_sym_else_clause_token1] = ACTIONS(1056),
    [aux_sym_match_expression_token1] = ACTIONS(1056),
    [aux_sym_match_default_expression_token1] = ACTIONS(1056),
    [aux_sym_switch_statement_token1] = ACTIONS(1056),
    [aux_sym_switch_block_token1] = ACTIONS(1056),
    [anon_sym_PLUS] = ACTIONS(1056),
    [anon_sym_DASH] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1054),
    [anon_sym_BANG] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1054),
    [aux_sym_clone_expression_token1] = ACTIONS(1056),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1056),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1056),
    [anon_sym_DASH_DASH] = ACTIONS(1054),
    [anon_sym_PLUS_PLUS] = ACTIONS(1054),
    [aux_sym__list_destructing_token1] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1054),
    [anon_sym_self] = ACTIONS(1056),
    [anon_sym_parent] = ACTIONS(1056),
    [aux_sym__argument_name_token1] = ACTIONS(1056),
    [aux_sym__argument_name_token2] = ACTIONS(1056),
    [anon_sym_POUND_LBRACK] = ACTIONS(1054),
    [aux_sym_encapsed_string_token1] = ACTIONS(1054),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [aux_sym_string_token1] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [anon_sym_LT_LT_LT] = ACTIONS(1054),
    [anon_sym_BQUOTE] = ACTIONS(1054),
    [anon_sym_DOLLAR] = ACTIONS(1054),
    [aux_sym_yield_expression_token1] = ACTIONS(1056),
    [aux_sym_include_expression_token1] = ACTIONS(1056),
    [aux_sym_include_once_expression_token1] = ACTIONS(1056),
    [aux_sym_require_expression_token1] = ACTIONS(1056),
    [aux_sym_require_once_expression_token1] = ACTIONS(1056),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1058),
  },
  [439] = {
    [sym_text_interpolation] = STATE(439),
    [ts_builtin_sym_end] = ACTIONS(1060),
    [sym_name] = ACTIONS(1062),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1064),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1062),
    [aux_sym_global_declaration_token1] = ACTIONS(1062),
    [aux_sym_namespace_definition_token1] = ACTIONS(1062),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1062),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1062),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1062),
    [anon_sym_BSLASH] = ACTIONS(1060),
    [anon_sym_LBRACE] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [aux_sym_trait_declaration_token1] = ACTIONS(1062),
    [aux_sym_interface_declaration_token1] = ACTIONS(1062),
    [aux_sym_enum_declaration_token1] = ACTIONS(1062),
    [aux_sym_enum_case_token1] = ACTIONS(1062),
    [aux_sym_class_declaration_token1] = ACTIONS(1062),
    [aux_sym_final_modifier_token1] = ACTIONS(1062),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1062),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1062),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1062),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1062),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1062),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1062),
    [anon_sym_LPAREN] = ACTIONS(1060),
    [aux_sym_cast_type_token1] = ACTIONS(1062),
    [aux_sym_echo_statement_token1] = ACTIONS(1062),
    [anon_sym_unset] = ACTIONS(1062),
    [aux_sym_declare_statement_token1] = ACTIONS(1062),
    [aux_sym_declare_statement_token2] = ACTIONS(1062),
    [sym_float] = ACTIONS(1062),
    [aux_sym_try_statement_token1] = ACTIONS(1062),
    [aux_sym_goto_statement_token1] = ACTIONS(1062),
    [aux_sym_continue_statement_token1] = ACTIONS(1062),
    [aux_sym_break_statement_token1] = ACTIONS(1062),
    [sym_integer] = ACTIONS(1062),
    [aux_sym_return_statement_token1] = ACTIONS(1062),
    [aux_sym_throw_expression_token1] = ACTIONS(1062),
    [aux_sym_while_statement_token1] = ACTIONS(1062),
    [aux_sym_while_statement_token2] = ACTIONS(1062),
    [aux_sym_do_statement_token1] = ACTIONS(1062),
    [aux_sym_for_statement_token1] = ACTIONS(1062),
    [aux_sym_for_statement_token2] = ACTIONS(1062),
    [aux_sym_foreach_statement_token1] = ACTIONS(1062),
    [aux_sym_foreach_statement_token2] = ACTIONS(1062),
    [aux_sym_if_statement_token1] = ACTIONS(1062),
    [aux_sym_if_statement_token2] = ACTIONS(1062),
    [aux_sym_else_if_clause_token1] = ACTIONS(1062),
    [aux_sym_else_clause_token1] = ACTIONS(1062),
    [aux_sym_match_expression_token1] = ACTIONS(1062),
    [aux_sym_match_default_expression_token1] = ACTIONS(1062),
    [aux_sym_switch_statement_token1] = ACTIONS(1062),
    [aux_sym_switch_block_token1] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_TILDE] = ACTIONS(1060),
    [anon_sym_BANG] = ACTIONS(1060),
    [anon_sym_AT] = ACTIONS(1060),
    [aux_sym_clone_expression_token1] = ACTIONS(1062),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1062),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1062),
    [anon_sym_DASH_DASH] = ACTIONS(1060),
    [anon_sym_PLUS_PLUS] = ACTIONS(1060),
    [aux_sym__list_destructing_token1] = ACTIONS(1062),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [anon_sym_self] = ACTIONS(1062),
    [anon_sym_parent] = ACTIONS(1062),
    [aux_sym__argument_name_token1] = ACTIONS(1062),
    [aux_sym__argument_name_token2] = ACTIONS(1062),
    [anon_sym_POUND_LBRACK] = ACTIONS(1060),
    [aux_sym_encapsed_string_token1] = ACTIONS(1060),
    [anon_sym_DQUOTE] = ACTIONS(1060),
    [aux_sym_string_token1] = ACTIONS(1060),
    [anon_sym_SQUOTE] = ACTIONS(1060),
    [anon_sym_LT_LT_LT] = ACTIONS(1060),
    [anon_sym_BQUOTE] = ACTIONS(1060),
    [anon_sym_DOLLAR] = ACTIONS(1060),
    [aux_sym_yield_expression_token1] = ACTIONS(1062),
    [aux_sym_include_expression_token1] = ACTIONS(1062),
    [aux_sym_include_once_expression_token1] = ACTIONS(1062),
    [aux_sym_require_expression_token1] = ACTIONS(1062),
    [aux_sym_require_once_expression_token1] = ACTIONS(1062),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1064),
  },
  [440] = {
    [sym_text_interpolation] = STATE(440),
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_name] = ACTIONS(1068),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1070),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1068),
    [aux_sym_global_declaration_token1] = ACTIONS(1068),
    [aux_sym_namespace_definition_token1] = ACTIONS(1068),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1068),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1068),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1068),
    [anon_sym_BSLASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [aux_sym_trait_declaration_token1] = ACTIONS(1068),
    [aux_sym_interface_declaration_token1] = ACTIONS(1068),
    [aux_sym_enum_declaration_token1] = ACTIONS(1068),
    [aux_sym_enum_case_token1] = ACTIONS(1068),
    [aux_sym_class_declaration_token1] = ACTIONS(1068),
    [aux_sym_final_modifier_token1] = ACTIONS(1068),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1068),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1068),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1068),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1068),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1068),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [aux_sym_cast_type_token1] = ACTIONS(1068),
    [aux_sym_echo_statement_token1] = ACTIONS(1068),
    [anon_sym_unset] = ACTIONS(1068),
    [aux_sym_declare_statement_token1] = ACTIONS(1068),
    [aux_sym_declare_statement_token2] = ACTIONS(1068),
    [sym_float] = ACTIONS(1068),
    [aux_sym_try_statement_token1] = ACTIONS(1068),
    [aux_sym_goto_statement_token1] = ACTIONS(1068),
    [aux_sym_continue_statement_token1] = ACTIONS(1068),
    [aux_sym_break_statement_token1] = ACTIONS(1068),
    [sym_integer] = ACTIONS(1068),
    [aux_sym_return_statement_token1] = ACTIONS(1068),
    [aux_sym_throw_expression_token1] = ACTIONS(1068),
    [aux_sym_while_statement_token1] = ACTIONS(1068),
    [aux_sym_while_statement_token2] = ACTIONS(1068),
    [aux_sym_do_statement_token1] = ACTIONS(1068),
    [aux_sym_for_statement_token1] = ACTIONS(1068),
    [aux_sym_for_statement_token2] = ACTIONS(1068),
    [aux_sym_foreach_statement_token1] = ACTIONS(1068),
    [aux_sym_foreach_statement_token2] = ACTIONS(1068),
    [aux_sym_if_statement_token1] = ACTIONS(1068),
    [aux_sym_if_statement_token2] = ACTIONS(1068),
    [aux_sym_else_if_clause_token1] = ACTIONS(1068),
    [aux_sym_else_clause_token1] = ACTIONS(1068),
    [aux_sym_match_expression_token1] = ACTIONS(1068),
    [aux_sym_match_default_expression_token1] = ACTIONS(1068),
    [aux_sym_switch_statement_token1] = ACTIONS(1068),
    [aux_sym_switch_block_token1] = ACTIONS(1068),
    [anon_sym_PLUS] = ACTIONS(1068),
    [anon_sym_DASH] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [aux_sym_clone_expression_token1] = ACTIONS(1068),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1068),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1068),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [aux_sym__list_destructing_token1] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_self] = ACTIONS(1068),
    [anon_sym_parent] = ACTIONS(1068),
    [aux_sym__argument_name_token1] = ACTIONS(1068),
    [aux_sym__argument_name_token2] = ACTIONS(1068),
    [anon_sym_POUND_LBRACK] = ACTIONS(1066),
    [aux_sym_encapsed_string_token1] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [aux_sym_string_token1] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [anon_sym_LT_LT_LT] = ACTIONS(1066),
    [anon_sym_BQUOTE] = ACTIONS(1066),
    [anon_sym_DOLLAR] = ACTIONS(1066),
    [aux_sym_yield_expression_token1] = ACTIONS(1068),
    [aux_sym_include_expression_token1] = ACTIONS(1068),
    [aux_sym_include_once_expression_token1] = ACTIONS(1068),
    [aux_sym_require_expression_token1] = ACTIONS(1068),
    [aux_sym_require_once_expression_token1] = ACTIONS(1068),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1070),
  },
  [441] = {
    [sym_text_interpolation] = STATE(441),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [sym_name] = ACTIONS(1074),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1076),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1074),
    [aux_sym_global_declaration_token1] = ACTIONS(1074),
    [aux_sym_namespace_definition_token1] = ACTIONS(1074),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1074),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1074),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1074),
    [anon_sym_BSLASH] = ACTIONS(1072),
    [anon_sym_LBRACE] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [aux_sym_trait_declaration_token1] = ACTIONS(1074),
    [aux_sym_interface_declaration_token1] = ACTIONS(1074),
    [aux_sym_enum_declaration_token1] = ACTIONS(1074),
    [aux_sym_enum_case_token1] = ACTIONS(1074),
    [aux_sym_class_declaration_token1] = ACTIONS(1074),
    [aux_sym_final_modifier_token1] = ACTIONS(1074),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1074),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1074),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1074),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1074),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1074),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [aux_sym_cast_type_token1] = ACTIONS(1074),
    [aux_sym_echo_statement_token1] = ACTIONS(1074),
    [anon_sym_unset] = ACTIONS(1074),
    [aux_sym_declare_statement_token1] = ACTIONS(1074),
    [aux_sym_declare_statement_token2] = ACTIONS(1074),
    [sym_float] = ACTIONS(1074),
    [aux_sym_try_statement_token1] = ACTIONS(1074),
    [aux_sym_goto_statement_token1] = ACTIONS(1074),
    [aux_sym_continue_statement_token1] = ACTIONS(1074),
    [aux_sym_break_statement_token1] = ACTIONS(1074),
    [sym_integer] = ACTIONS(1074),
    [aux_sym_return_statement_token1] = ACTIONS(1074),
    [aux_sym_throw_expression_token1] = ACTIONS(1074),
    [aux_sym_while_statement_token1] = ACTIONS(1074),
    [aux_sym_while_statement_token2] = ACTIONS(1074),
    [aux_sym_do_statement_token1] = ACTIONS(1074),
    [aux_sym_for_statement_token1] = ACTIONS(1074),
    [aux_sym_for_statement_token2] = ACTIONS(1074),
    [aux_sym_foreach_statement_token1] = ACTIONS(1074),
    [aux_sym_foreach_statement_token2] = ACTIONS(1074),
    [aux_sym_if_statement_token1] = ACTIONS(1074),
    [aux_sym_if_statement_token2] = ACTIONS(1074),
    [aux_sym_else_if_clause_token1] = ACTIONS(1074),
    [aux_sym_else_clause_token1] = ACTIONS(1074),
    [aux_sym_match_expression_token1] = ACTIONS(1074),
    [aux_sym_match_default_expression_token1] = ACTIONS(1074),
    [aux_sym_switch_statement_token1] = ACTIONS(1074),
    [aux_sym_switch_block_token1] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_TILDE] = ACTIONS(1072),
    [anon_sym_BANG] = ACTIONS(1072),
    [anon_sym_AT] = ACTIONS(1072),
    [aux_sym_clone_expression_token1] = ACTIONS(1074),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1074),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1074),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [aux_sym__list_destructing_token1] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_self] = ACTIONS(1074),
    [anon_sym_parent] = ACTIONS(1074),
    [aux_sym__argument_name_token1] = ACTIONS(1074),
    [aux_sym__argument_name_token2] = ACTIONS(1074),
    [anon_sym_POUND_LBRACK] = ACTIONS(1072),
    [aux_sym_encapsed_string_token1] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [aux_sym_string_token1] = ACTIONS(1072),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [anon_sym_LT_LT_LT] = ACTIONS(1072),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [anon_sym_DOLLAR] = ACTIONS(1072),
    [aux_sym_yield_expression_token1] = ACTIONS(1074),
    [aux_sym_include_expression_token1] = ACTIONS(1074),
    [aux_sym_include_once_expression_token1] = ACTIONS(1074),
    [aux_sym_require_expression_token1] = ACTIONS(1074),
    [aux_sym_require_once_expression_token1] = ACTIONS(1074),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1076),
  },
  [442] = {
    [sym_text_interpolation] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(1078),
    [sym_name] = ACTIONS(1080),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1082),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1080),
    [aux_sym_global_declaration_token1] = ACTIONS(1080),
    [aux_sym_namespace_definition_token1] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1080),
    [anon_sym_BSLASH] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [aux_sym_trait_declaration_token1] = ACTIONS(1080),
    [aux_sym_interface_declaration_token1] = ACTIONS(1080),
    [aux_sym_enum_declaration_token1] = ACTIONS(1080),
    [aux_sym_enum_case_token1] = ACTIONS(1080),
    [aux_sym_class_declaration_token1] = ACTIONS(1080),
    [aux_sym_final_modifier_token1] = ACTIONS(1080),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1080),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1080),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [aux_sym_cast_type_token1] = ACTIONS(1080),
    [aux_sym_echo_statement_token1] = ACTIONS(1080),
    [anon_sym_unset] = ACTIONS(1080),
    [aux_sym_declare_statement_token1] = ACTIONS(1080),
    [aux_sym_declare_statement_token2] = ACTIONS(1080),
    [sym_float] = ACTIONS(1080),
    [aux_sym_try_statement_token1] = ACTIONS(1080),
    [aux_sym_goto_statement_token1] = ACTIONS(1080),
    [aux_sym_continue_statement_token1] = ACTIONS(1080),
    [aux_sym_break_statement_token1] = ACTIONS(1080),
    [sym_integer] = ACTIONS(1080),
    [aux_sym_return_statement_token1] = ACTIONS(1080),
    [aux_sym_throw_expression_token1] = ACTIONS(1080),
    [aux_sym_while_statement_token1] = ACTIONS(1080),
    [aux_sym_while_statement_token2] = ACTIONS(1080),
    [aux_sym_do_statement_token1] = ACTIONS(1080),
    [aux_sym_for_statement_token1] = ACTIONS(1080),
    [aux_sym_for_statement_token2] = ACTIONS(1080),
    [aux_sym_foreach_statement_token1] = ACTIONS(1080),
    [aux_sym_foreach_statement_token2] = ACTIONS(1080),
    [aux_sym_if_statement_token1] = ACTIONS(1080),
    [aux_sym_if_statement_token2] = ACTIONS(1080),
    [aux_sym_else_if_clause_token1] = ACTIONS(1080),
    [aux_sym_else_clause_token1] = ACTIONS(1080),
    [aux_sym_match_expression_token1] = ACTIONS(1080),
    [aux_sym_match_default_expression_token1] = ACTIONS(1080),
    [aux_sym_switch_statement_token1] = ACTIONS(1080),
    [aux_sym_switch_block_token1] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1078),
    [aux_sym_clone_expression_token1] = ACTIONS(1080),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1080),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [aux_sym__list_destructing_token1] = ACTIONS(1080),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_self] = ACTIONS(1080),
    [anon_sym_parent] = ACTIONS(1080),
    [aux_sym__argument_name_token1] = ACTIONS(1080),
    [aux_sym__argument_name_token2] = ACTIONS(1080),
    [anon_sym_POUND_LBRACK] = ACTIONS(1078),
    [aux_sym_encapsed_string_token1] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [aux_sym_string_token1] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_LT_LT_LT] = ACTIONS(1078),
    [anon_sym_BQUOTE] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1078),
    [aux_sym_yield_expression_token1] = ACTIONS(1080),
    [aux_sym_include_expression_token1] = ACTIONS(1080),
    [aux_sym_include_once_expression_token1] = ACTIONS(1080),
    [aux_sym_require_expression_token1] = ACTIONS(1080),
    [aux_sym_require_once_expression_token1] = ACTIONS(1080),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1082),
  },
  [443] = {
    [sym_text_interpolation] = STATE(443),
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_name] = ACTIONS(1086),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1088),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1086),
    [aux_sym_global_declaration_token1] = ACTIONS(1086),
    [aux_sym_namespace_definition_token1] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1086),
    [anon_sym_BSLASH] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [aux_sym_trait_declaration_token1] = ACTIONS(1086),
    [aux_sym_interface_declaration_token1] = ACTIONS(1086),
    [aux_sym_enum_declaration_token1] = ACTIONS(1086),
    [aux_sym_enum_case_token1] = ACTIONS(1086),
    [aux_sym_class_declaration_token1] = ACTIONS(1086),
    [aux_sym_final_modifier_token1] = ACTIONS(1086),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1086),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1086),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [aux_sym_cast_type_token1] = ACTIONS(1086),
    [aux_sym_echo_statement_token1] = ACTIONS(1086),
    [anon_sym_unset] = ACTIONS(1086),
    [aux_sym_declare_statement_token1] = ACTIONS(1086),
    [aux_sym_declare_statement_token2] = ACTIONS(1086),
    [sym_float] = ACTIONS(1086),
    [aux_sym_try_statement_token1] = ACTIONS(1086),
    [aux_sym_goto_statement_token1] = ACTIONS(1086),
    [aux_sym_continue_statement_token1] = ACTIONS(1086),
    [aux_sym_break_statement_token1] = ACTIONS(1086),
    [sym_integer] = ACTIONS(1086),
    [aux_sym_return_statement_token1] = ACTIONS(1086),
    [aux_sym_throw_expression_token1] = ACTIONS(1086),
    [aux_sym_while_statement_token1] = ACTIONS(1086),
    [aux_sym_while_statement_token2] = ACTIONS(1086),
    [aux_sym_do_statement_token1] = ACTIONS(1086),
    [aux_sym_for_statement_token1] = ACTIONS(1086),
    [aux_sym_for_statement_token2] = ACTIONS(1086),
    [aux_sym_foreach_statement_token1] = ACTIONS(1086),
    [aux_sym_foreach_statement_token2] = ACTIONS(1086),
    [aux_sym_if_statement_token1] = ACTIONS(1086),
    [aux_sym_if_statement_token2] = ACTIONS(1086),
    [aux_sym_else_if_clause_token1] = ACTIONS(1086),
    [aux_sym_else_clause_token1] = ACTIONS(1086),
    [aux_sym_match_expression_token1] = ACTIONS(1086),
    [aux_sym_match_default_expression_token1] = ACTIONS(1086),
    [aux_sym_switch_statement_token1] = ACTIONS(1086),
    [aux_sym_switch_block_token1] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_BANG] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1084),
    [aux_sym_clone_expression_token1] = ACTIONS(1086),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1086),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1086),
    [anon_sym_DASH_DASH] = ACTIONS(1084),
    [anon_sym_PLUS_PLUS] = ACTIONS(1084),
    [aux_sym__list_destructing_token1] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_self] = ACTIONS(1086),
    [anon_sym_parent] = ACTIONS(1086),
    [aux_sym__argument_name_token1] = ACTIONS(1086),
    [aux_sym__argument_name_token2] = ACTIONS(1086),
    [anon_sym_POUND_LBRACK] = ACTIONS(1084),
    [aux_sym_encapsed_string_token1] = ACTIONS(1084),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [aux_sym_string_token1] = ACTIONS(1084),
    [anon_sym_SQUOTE] = ACTIONS(1084),
    [anon_sym_LT_LT_LT] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1084),
    [anon_sym_DOLLAR] = ACTIONS(1084),
    [aux_sym_yield_expression_token1] = ACTIONS(1086),
    [aux_sym_include_expression_token1] = ACTIONS(1086),
    [aux_sym_include_once_expression_token1] = ACTIONS(1086),
    [aux_sym_require_expression_token1] = ACTIONS(1086),
    [aux_sym_require_once_expression_token1] = ACTIONS(1086),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1088),
  },
  [444] = {
    [sym_text_interpolation] = STATE(444),
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_name] = ACTIONS(1092),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1094),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1092),
    [aux_sym_global_declaration_token1] = ACTIONS(1092),
    [aux_sym_namespace_definition_token1] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1092),
    [anon_sym_BSLASH] = ACTIONS(1090),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [aux_sym_trait_declaration_token1] = ACTIONS(1092),
    [aux_sym_interface_declaration_token1] = ACTIONS(1092),
    [aux_sym_enum_declaration_token1] = ACTIONS(1092),
    [aux_sym_enum_case_token1] = ACTIONS(1092),
    [aux_sym_class_declaration_token1] = ACTIONS(1092),
    [aux_sym_final_modifier_token1] = ACTIONS(1092),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1092),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1092),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1092),
    [anon_sym_LPAREN] = ACTIONS(1090),
    [aux_sym_cast_type_token1] = ACTIONS(1092),
    [aux_sym_echo_statement_token1] = ACTIONS(1092),
    [anon_sym_unset] = ACTIONS(1092),
    [aux_sym_declare_statement_token1] = ACTIONS(1092),
    [aux_sym_declare_statement_token2] = ACTIONS(1092),
    [sym_float] = ACTIONS(1092),
    [aux_sym_try_statement_token1] = ACTIONS(1092),
    [aux_sym_goto_statement_token1] = ACTIONS(1092),
    [aux_sym_continue_statement_token1] = ACTIONS(1092),
    [aux_sym_break_statement_token1] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1092),
    [aux_sym_return_statement_token1] = ACTIONS(1092),
    [aux_sym_throw_expression_token1] = ACTIONS(1092),
    [aux_sym_while_statement_token1] = ACTIONS(1092),
    [aux_sym_while_statement_token2] = ACTIONS(1092),
    [aux_sym_do_statement_token1] = ACTIONS(1092),
    [aux_sym_for_statement_token1] = ACTIONS(1092),
    [aux_sym_for_statement_token2] = ACTIONS(1092),
    [aux_sym_foreach_statement_token1] = ACTIONS(1092),
    [aux_sym_foreach_statement_token2] = ACTIONS(1092),
    [aux_sym_if_statement_token1] = ACTIONS(1092),
    [aux_sym_if_statement_token2] = ACTIONS(1092),
    [aux_sym_else_if_clause_token1] = ACTIONS(1092),
    [aux_sym_else_clause_token1] = ACTIONS(1092),
    [aux_sym_match_expression_token1] = ACTIONS(1092),
    [aux_sym_match_default_expression_token1] = ACTIONS(1092),
    [aux_sym_switch_statement_token1] = ACTIONS(1092),
    [aux_sym_switch_block_token1] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_AT] = ACTIONS(1090),
    [aux_sym_clone_expression_token1] = ACTIONS(1092),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1092),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [aux_sym__list_destructing_token1] = ACTIONS(1092),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_self] = ACTIONS(1092),
    [anon_sym_parent] = ACTIONS(1092),
    [aux_sym__argument_name_token1] = ACTIONS(1092),
    [aux_sym__argument_name_token2] = ACTIONS(1092),
    [anon_sym_POUND_LBRACK] = ACTIONS(1090),
    [aux_sym_encapsed_string_token1] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [aux_sym_string_token1] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_LT_LT_LT] = ACTIONS(1090),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [anon_sym_DOLLAR] = ACTIONS(1090),
    [aux_sym_yield_expression_token1] = ACTIONS(1092),
    [aux_sym_include_expression_token1] = ACTIONS(1092),
    [aux_sym_include_once_expression_token1] = ACTIONS(1092),
    [aux_sym_require_expression_token1] = ACTIONS(1092),
    [aux_sym_require_once_expression_token1] = ACTIONS(1092),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1094),
  },
  [445] = {
    [sym_text_interpolation] = STATE(445),
    [ts_builtin_sym_end] = ACTIONS(1096),
    [sym_name] = ACTIONS(1098),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1100),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1098),
    [aux_sym_global_declaration_token1] = ACTIONS(1098),
    [aux_sym_namespace_definition_token1] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1098),
    [anon_sym_BSLASH] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1096),
    [aux_sym_trait_declaration_token1] = ACTIONS(1098),
    [aux_sym_interface_declaration_token1] = ACTIONS(1098),
    [aux_sym_enum_declaration_token1] = ACTIONS(1098),
    [aux_sym_enum_case_token1] = ACTIONS(1098),
    [aux_sym_class_declaration_token1] = ACTIONS(1098),
    [aux_sym_final_modifier_token1] = ACTIONS(1098),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1098),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1098),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [aux_sym_cast_type_token1] = ACTIONS(1098),
    [aux_sym_echo_statement_token1] = ACTIONS(1098),
    [anon_sym_unset] = ACTIONS(1098),
    [aux_sym_declare_statement_token1] = ACTIONS(1098),
    [aux_sym_declare_statement_token2] = ACTIONS(1098),
    [sym_float] = ACTIONS(1098),
    [aux_sym_try_statement_token1] = ACTIONS(1098),
    [aux_sym_goto_statement_token1] = ACTIONS(1098),
    [aux_sym_continue_statement_token1] = ACTIONS(1098),
    [aux_sym_break_statement_token1] = ACTIONS(1098),
    [sym_integer] = ACTIONS(1098),
    [aux_sym_return_statement_token1] = ACTIONS(1098),
    [aux_sym_throw_expression_token1] = ACTIONS(1098),
    [aux_sym_while_statement_token1] = ACTIONS(1098),
    [aux_sym_while_statement_token2] = ACTIONS(1098),
    [aux_sym_do_statement_token1] = ACTIONS(1098),
    [aux_sym_for_statement_token1] = ACTIONS(1098),
    [aux_sym_for_statement_token2] = ACTIONS(1098),
    [aux_sym_foreach_statement_token1] = ACTIONS(1098),
    [aux_sym_foreach_statement_token2] = ACTIONS(1098),
    [aux_sym_if_statement_token1] = ACTIONS(1098),
    [aux_sym_if_statement_token2] = ACTIONS(1098),
    [aux_sym_else_if_clause_token1] = ACTIONS(1098),
    [aux_sym_else_clause_token1] = ACTIONS(1098),
    [aux_sym_match_expression_token1] = ACTIONS(1098),
    [aux_sym_match_default_expression_token1] = ACTIONS(1098),
    [aux_sym_switch_statement_token1] = ACTIONS(1098),
    [aux_sym_switch_block_token1] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1096),
    [aux_sym_clone_expression_token1] = ACTIONS(1098),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1098),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1096),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [aux_sym__list_destructing_token1] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1096),
    [anon_sym_self] = ACTIONS(1098),
    [anon_sym_parent] = ACTIONS(1098),
    [aux_sym__argument_name_token1] = ACTIONS(1098),
    [aux_sym__argument_name_token2] = ACTIONS(1098),
    [anon_sym_POUND_LBRACK] = ACTIONS(1096),
    [aux_sym_encapsed_string_token1] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [aux_sym_string_token1] = ACTIONS(1096),
    [anon_sym_SQUOTE] = ACTIONS(1096),
    [anon_sym_LT_LT_LT] = ACTIONS(1096),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [aux_sym_yield_expression_token1] = ACTIONS(1098),
    [aux_sym_include_expression_token1] = ACTIONS(1098),
    [aux_sym_include_once_expression_token1] = ACTIONS(1098),
    [aux_sym_require_expression_token1] = ACTIONS(1098),
    [aux_sym_require_once_expression_token1] = ACTIONS(1098),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1100),
  },
  [446] = {
    [sym_text_interpolation] = STATE(446),
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_name] = ACTIONS(1104),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1106),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1104),
    [aux_sym_global_declaration_token1] = ACTIONS(1104),
    [aux_sym_namespace_definition_token1] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1104),
    [anon_sym_BSLASH] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [aux_sym_trait_declaration_token1] = ACTIONS(1104),
    [aux_sym_interface_declaration_token1] = ACTIONS(1104),
    [aux_sym_enum_declaration_token1] = ACTIONS(1104),
    [aux_sym_enum_case_token1] = ACTIONS(1104),
    [aux_sym_class_declaration_token1] = ACTIONS(1104),
    [aux_sym_final_modifier_token1] = ACTIONS(1104),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1104),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1104),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [aux_sym_cast_type_token1] = ACTIONS(1104),
    [aux_sym_echo_statement_token1] = ACTIONS(1104),
    [anon_sym_unset] = ACTIONS(1104),
    [aux_sym_declare_statement_token1] = ACTIONS(1104),
    [aux_sym_declare_statement_token2] = ACTIONS(1104),
    [sym_float] = ACTIONS(1104),
    [aux_sym_try_statement_token1] = ACTIONS(1104),
    [aux_sym_goto_statement_token1] = ACTIONS(1104),
    [aux_sym_continue_statement_token1] = ACTIONS(1104),
    [aux_sym_break_statement_token1] = ACTIONS(1104),
    [sym_integer] = ACTIONS(1104),
    [aux_sym_return_statement_token1] = ACTIONS(1104),
    [aux_sym_throw_expression_token1] = ACTIONS(1104),
    [aux_sym_while_statement_token1] = ACTIONS(1104),
    [aux_sym_while_statement_token2] = ACTIONS(1104),
    [aux_sym_do_statement_token1] = ACTIONS(1104),
    [aux_sym_for_statement_token1] = ACTIONS(1104),
    [aux_sym_for_statement_token2] = ACTIONS(1104),
    [aux_sym_foreach_statement_token1] = ACTIONS(1104),
    [aux_sym_foreach_statement_token2] = ACTIONS(1104),
    [aux_sym_if_statement_token1] = ACTIONS(1104),
    [aux_sym_if_statement_token2] = ACTIONS(1104),
    [aux_sym_else_if_clause_token1] = ACTIONS(1104),
    [aux_sym_else_clause_token1] = ACTIONS(1104),
    [aux_sym_match_expression_token1] = ACTIONS(1104),
    [aux_sym_match_default_expression_token1] = ACTIONS(1104),
    [aux_sym_switch_statement_token1] = ACTIONS(1104),
    [aux_sym_switch_block_token1] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [aux_sym_clone_expression_token1] = ACTIONS(1104),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1104),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [aux_sym__list_destructing_token1] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_self] = ACTIONS(1104),
    [anon_sym_parent] = ACTIONS(1104),
    [aux_sym__argument_name_token1] = ACTIONS(1104),
    [aux_sym__argument_name_token2] = ACTIONS(1104),
    [anon_sym_POUND_LBRACK] = ACTIONS(1102),
    [aux_sym_encapsed_string_token1] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [aux_sym_string_token1] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_LT_LT_LT] = ACTIONS(1102),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [anon_sym_DOLLAR] = ACTIONS(1102),
    [aux_sym_yield_expression_token1] = ACTIONS(1104),
    [aux_sym_include_expression_token1] = ACTIONS(1104),
    [aux_sym_include_once_expression_token1] = ACTIONS(1104),
    [aux_sym_require_expression_token1] = ACTIONS(1104),
    [aux_sym_require_once_expression_token1] = ACTIONS(1104),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1106),
  },
  [447] = {
    [sym_text_interpolation] = STATE(447),
    [ts_builtin_sym_end] = ACTIONS(1108),
    [sym_name] = ACTIONS(1110),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1112),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1110),
    [aux_sym_global_declaration_token1] = ACTIONS(1110),
    [aux_sym_namespace_definition_token1] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1110),
    [anon_sym_BSLASH] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1108),
    [aux_sym_trait_declaration_token1] = ACTIONS(1110),
    [aux_sym_interface_declaration_token1] = ACTIONS(1110),
    [aux_sym_enum_declaration_token1] = ACTIONS(1110),
    [aux_sym_enum_case_token1] = ACTIONS(1110),
    [aux_sym_class_declaration_token1] = ACTIONS(1110),
    [aux_sym_final_modifier_token1] = ACTIONS(1110),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1110),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1110),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [aux_sym_cast_type_token1] = ACTIONS(1110),
    [aux_sym_echo_statement_token1] = ACTIONS(1110),
    [anon_sym_unset] = ACTIONS(1110),
    [aux_sym_declare_statement_token1] = ACTIONS(1110),
    [aux_sym_declare_statement_token2] = ACTIONS(1110),
    [sym_float] = ACTIONS(1110),
    [aux_sym_try_statement_token1] = ACTIONS(1110),
    [aux_sym_goto_statement_token1] = ACTIONS(1110),
    [aux_sym_continue_statement_token1] = ACTIONS(1110),
    [aux_sym_break_statement_token1] = ACTIONS(1110),
    [sym_integer] = ACTIONS(1110),
    [aux_sym_return_statement_token1] = ACTIONS(1110),
    [aux_sym_throw_expression_token1] = ACTIONS(1110),
    [aux_sym_while_statement_token1] = ACTIONS(1110),
    [aux_sym_while_statement_token2] = ACTIONS(1110),
    [aux_sym_do_statement_token1] = ACTIONS(1110),
    [aux_sym_for_statement_token1] = ACTIONS(1110),
    [aux_sym_for_statement_token2] = ACTIONS(1110),
    [aux_sym_foreach_statement_token1] = ACTIONS(1110),
    [aux_sym_foreach_statement_token2] = ACTIONS(1110),
    [aux_sym_if_statement_token1] = ACTIONS(1110),
    [aux_sym_if_statement_token2] = ACTIONS(1110),
    [aux_sym_else_if_clause_token1] = ACTIONS(1110),
    [aux_sym_else_clause_token1] = ACTIONS(1110),
    [aux_sym_match_expression_token1] = ACTIONS(1110),
    [aux_sym_match_default_expression_token1] = ACTIONS(1110),
    [aux_sym_switch_statement_token1] = ACTIONS(1110),
    [aux_sym_switch_block_token1] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1108),
    [aux_sym_clone_expression_token1] = ACTIONS(1110),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1110),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1110),
    [anon_sym_DASH_DASH] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1108),
    [aux_sym__list_destructing_token1] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [anon_sym_self] = ACTIONS(1110),
    [anon_sym_parent] = ACTIONS(1110),
    [aux_sym__argument_name_token1] = ACTIONS(1110),
    [aux_sym__argument_name_token2] = ACTIONS(1110),
    [anon_sym_POUND_LBRACK] = ACTIONS(1108),
    [aux_sym_encapsed_string_token1] = ACTIONS(1108),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [aux_sym_string_token1] = ACTIONS(1108),
    [anon_sym_SQUOTE] = ACTIONS(1108),
    [anon_sym_LT_LT_LT] = ACTIONS(1108),
    [anon_sym_BQUOTE] = ACTIONS(1108),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [aux_sym_yield_expression_token1] = ACTIONS(1110),
    [aux_sym_include_expression_token1] = ACTIONS(1110),
    [aux_sym_include_once_expression_token1] = ACTIONS(1110),
    [aux_sym_require_expression_token1] = ACTIONS(1110),
    [aux_sym_require_once_expression_token1] = ACTIONS(1110),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1112),
  },
  [448] = {
    [sym_text_interpolation] = STATE(448),
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_name] = ACTIONS(1116),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1118),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1116),
    [aux_sym_global_declaration_token1] = ACTIONS(1116),
    [aux_sym_namespace_definition_token1] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1116),
    [anon_sym_BSLASH] = ACTIONS(1114),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [aux_sym_trait_declaration_token1] = ACTIONS(1116),
    [aux_sym_interface_declaration_token1] = ACTIONS(1116),
    [aux_sym_enum_declaration_token1] = ACTIONS(1116),
    [aux_sym_enum_case_token1] = ACTIONS(1116),
    [aux_sym_class_declaration_token1] = ACTIONS(1116),
    [aux_sym_final_modifier_token1] = ACTIONS(1116),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1116),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1116),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [aux_sym_cast_type_token1] = ACTIONS(1116),
    [aux_sym_echo_statement_token1] = ACTIONS(1116),
    [anon_sym_unset] = ACTIONS(1116),
    [aux_sym_declare_statement_token1] = ACTIONS(1116),
    [aux_sym_declare_statement_token2] = ACTIONS(1116),
    [sym_float] = ACTIONS(1116),
    [aux_sym_try_statement_token1] = ACTIONS(1116),
    [aux_sym_goto_statement_token1] = ACTIONS(1116),
    [aux_sym_continue_statement_token1] = ACTIONS(1116),
    [aux_sym_break_statement_token1] = ACTIONS(1116),
    [sym_integer] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1116),
    [aux_sym_throw_expression_token1] = ACTIONS(1116),
    [aux_sym_while_statement_token1] = ACTIONS(1116),
    [aux_sym_while_statement_token2] = ACTIONS(1116),
    [aux_sym_do_statement_token1] = ACTIONS(1116),
    [aux_sym_for_statement_token1] = ACTIONS(1116),
    [aux_sym_for_statement_token2] = ACTIONS(1116),
    [aux_sym_foreach_statement_token1] = ACTIONS(1116),
    [aux_sym_foreach_statement_token2] = ACTIONS(1116),
    [aux_sym_if_statement_token1] = ACTIONS(1116),
    [aux_sym_if_statement_token2] = ACTIONS(1116),
    [aux_sym_else_if_clause_token1] = ACTIONS(1116),
    [aux_sym_else_clause_token1] = ACTIONS(1116),
    [aux_sym_match_expression_token1] = ACTIONS(1116),
    [aux_sym_match_default_expression_token1] = ACTIONS(1116),
    [aux_sym_switch_statement_token1] = ACTIONS(1116),
    [aux_sym_switch_block_token1] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_AT] = ACTIONS(1114),
    [aux_sym_clone_expression_token1] = ACTIONS(1116),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1116),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [aux_sym__list_destructing_token1] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_self] = ACTIONS(1116),
    [anon_sym_parent] = ACTIONS(1116),
    [aux_sym__argument_name_token1] = ACTIONS(1116),
    [aux_sym__argument_name_token2] = ACTIONS(1116),
    [anon_sym_POUND_LBRACK] = ACTIONS(1114),
    [aux_sym_encapsed_string_token1] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [aux_sym_string_token1] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_LT_LT_LT] = ACTIONS(1114),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [anon_sym_DOLLAR] = ACTIONS(1114),
    [aux_sym_yield_expression_token1] = ACTIONS(1116),
    [aux_sym_include_expression_token1] = ACTIONS(1116),
    [aux_sym_include_once_expression_token1] = ACTIONS(1116),
    [aux_sym_require_expression_token1] = ACTIONS(1116),
    [aux_sym_require_once_expression_token1] = ACTIONS(1116),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1118),
  },
  [449] = {
    [sym_text_interpolation] = STATE(449),
    [ts_builtin_sym_end] = ACTIONS(1120),
    [sym_name] = ACTIONS(1122),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1124),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1122),
    [aux_sym_global_declaration_token1] = ACTIONS(1122),
    [aux_sym_namespace_definition_token1] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1122),
    [anon_sym_BSLASH] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [aux_sym_trait_declaration_token1] = ACTIONS(1122),
    [aux_sym_interface_declaration_token1] = ACTIONS(1122),
    [aux_sym_enum_declaration_token1] = ACTIONS(1122),
    [aux_sym_enum_case_token1] = ACTIONS(1122),
    [aux_sym_class_declaration_token1] = ACTIONS(1122),
    [aux_sym_final_modifier_token1] = ACTIONS(1122),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1122),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1122),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1122),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [aux_sym_cast_type_token1] = ACTIONS(1122),
    [aux_sym_echo_statement_token1] = ACTIONS(1122),
    [anon_sym_unset] = ACTIONS(1122),
    [aux_sym_declare_statement_token1] = ACTIONS(1122),
    [aux_sym_declare_statement_token2] = ACTIONS(1122),
    [sym_float] = ACTIONS(1122),
    [aux_sym_try_statement_token1] = ACTIONS(1122),
    [aux_sym_goto_statement_token1] = ACTIONS(1122),
    [aux_sym_continue_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1122),
    [sym_integer] = ACTIONS(1122),
    [aux_sym_return_statement_token1] = ACTIONS(1122),
    [aux_sym_throw_expression_token1] = ACTIONS(1122),
    [aux_sym_while_statement_token1] = ACTIONS(1122),
    [aux_sym_while_statement_token2] = ACTIONS(1122),
    [aux_sym_do_statement_token1] = ACTIONS(1122),
    [aux_sym_for_statement_token1] = ACTIONS(1122),
    [aux_sym_for_statement_token2] = ACTIONS(1122),
    [aux_sym_foreach_statement_token1] = ACTIONS(1122),
    [aux_sym_foreach_statement_token2] = ACTIONS(1122),
    [aux_sym_if_statement_token1] = ACTIONS(1122),
    [aux_sym_if_statement_token2] = ACTIONS(1122),
    [aux_sym_else_if_clause_token1] = ACTIONS(1122),
    [aux_sym_else_clause_token1] = ACTIONS(1122),
    [aux_sym_match_expression_token1] = ACTIONS(1122),
    [aux_sym_match_default_expression_token1] = ACTIONS(1122),
    [aux_sym_switch_statement_token1] = ACTIONS(1122),
    [aux_sym_switch_block_token1] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1120),
    [anon_sym_BANG] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1120),
    [aux_sym_clone_expression_token1] = ACTIONS(1122),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1122),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1122),
    [anon_sym_DASH_DASH] = ACTIONS(1120),
    [anon_sym_PLUS_PLUS] = ACTIONS(1120),
    [aux_sym__list_destructing_token1] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [anon_sym_self] = ACTIONS(1122),
    [anon_sym_parent] = ACTIONS(1122),
    [aux_sym__argument_name_token1] = ACTIONS(1122),
    [aux_sym__argument_name_token2] = ACTIONS(1122),
    [anon_sym_POUND_LBRACK] = ACTIONS(1120),
    [aux_sym_encapsed_string_token1] = ACTIONS(1120),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [aux_sym_string_token1] = ACTIONS(1120),
    [anon_sym_SQUOTE] = ACTIONS(1120),
    [anon_sym_LT_LT_LT] = ACTIONS(1120),
    [anon_sym_BQUOTE] = ACTIONS(1120),
    [anon_sym_DOLLAR] = ACTIONS(1120),
    [aux_sym_yield_expression_token1] = ACTIONS(1122),
    [aux_sym_include_expression_token1] = ACTIONS(1122),
    [aux_sym_include_once_expression_token1] = ACTIONS(1122),
    [aux_sym_require_expression_token1] = ACTIONS(1122),
    [aux_sym_require_once_expression_token1] = ACTIONS(1122),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1124),
  },
  [450] = {
    [sym_text_interpolation] = STATE(450),
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_name] = ACTIONS(1128),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1130),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1128),
    [aux_sym_global_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_definition_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1128),
    [anon_sym_BSLASH] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [aux_sym_trait_declaration_token1] = ACTIONS(1128),
    [aux_sym_interface_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_case_token1] = ACTIONS(1128),
    [aux_sym_class_declaration_token1] = ACTIONS(1128),
    [aux_sym_final_modifier_token1] = ACTIONS(1128),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1128),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1128),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [aux_sym_cast_type_token1] = ACTIONS(1128),
    [aux_sym_echo_statement_token1] = ACTIONS(1128),
    [anon_sym_unset] = ACTIONS(1128),
    [aux_sym_declare_statement_token1] = ACTIONS(1128),
    [aux_sym_declare_statement_token2] = ACTIONS(1128),
    [sym_float] = ACTIONS(1128),
    [aux_sym_try_statement_token1] = ACTIONS(1128),
    [aux_sym_goto_statement_token1] = ACTIONS(1128),
    [aux_sym_continue_statement_token1] = ACTIONS(1128),
    [aux_sym_break_statement_token1] = ACTIONS(1128),
    [sym_integer] = ACTIONS(1128),
    [aux_sym_return_statement_token1] = ACTIONS(1128),
    [aux_sym_throw_expression_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token2] = ACTIONS(1128),
    [aux_sym_do_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token2] = ACTIONS(1128),
    [aux_sym_foreach_statement_token1] = ACTIONS(1128),
    [aux_sym_foreach_statement_token2] = ACTIONS(1128),
    [aux_sym_if_statement_token1] = ACTIONS(1128),
    [aux_sym_if_statement_token2] = ACTIONS(1128),
    [aux_sym_else_if_clause_token1] = ACTIONS(1128),
    [aux_sym_else_clause_token1] = ACTIONS(1128),
    [aux_sym_match_expression_token1] = ACTIONS(1128),
    [aux_sym_match_default_expression_token1] = ACTIONS(1128),
    [aux_sym_switch_statement_token1] = ACTIONS(1128),
    [aux_sym_switch_block_token1] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1126),
    [aux_sym_clone_expression_token1] = ACTIONS(1128),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1128),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [aux_sym__list_destructing_token1] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_self] = ACTIONS(1128),
    [anon_sym_parent] = ACTIONS(1128),
    [aux_sym__argument_name_token1] = ACTIONS(1128),
    [aux_sym__argument_name_token2] = ACTIONS(1128),
    [anon_sym_POUND_LBRACK] = ACTIONS(1126),
    [aux_sym_encapsed_string_token1] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [aux_sym_string_token1] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_LT_LT_LT] = ACTIONS(1126),
    [anon_sym_BQUOTE] = ACTIONS(1126),
    [anon_sym_DOLLAR] = ACTIONS(1126),
    [aux_sym_yield_expression_token1] = ACTIONS(1128),
    [aux_sym_include_expression_token1] = ACTIONS(1128),
    [aux_sym_include_once_expression_token1] = ACTIONS(1128),
    [aux_sym_require_expression_token1] = ACTIONS(1128),
    [aux_sym_require_once_expression_token1] = ACTIONS(1128),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1130),
  },
  [451] = {
    [sym_text_interpolation] = STATE(451),
    [ts_builtin_sym_end] = ACTIONS(1132),
    [sym_name] = ACTIONS(1134),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1136),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1134),
    [aux_sym_global_declaration_token1] = ACTIONS(1134),
    [aux_sym_namespace_definition_token1] = ACTIONS(1134),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1134),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1134),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1134),
    [anon_sym_BSLASH] = ACTIONS(1132),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_RBRACE] = ACTIONS(1132),
    [aux_sym_trait_declaration_token1] = ACTIONS(1134),
    [aux_sym_interface_declaration_token1] = ACTIONS(1134),
    [aux_sym_enum_declaration_token1] = ACTIONS(1134),
    [aux_sym_enum_case_token1] = ACTIONS(1134),
    [aux_sym_class_declaration_token1] = ACTIONS(1134),
    [aux_sym_final_modifier_token1] = ACTIONS(1134),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1134),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1134),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1134),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1134),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1134),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [aux_sym_cast_type_token1] = ACTIONS(1134),
    [aux_sym_echo_statement_token1] = ACTIONS(1134),
    [anon_sym_unset] = ACTIONS(1134),
    [aux_sym_declare_statement_token1] = ACTIONS(1134),
    [aux_sym_declare_statement_token2] = ACTIONS(1134),
    [sym_float] = ACTIONS(1134),
    [aux_sym_try_statement_token1] = ACTIONS(1134),
    [aux_sym_goto_statement_token1] = ACTIONS(1134),
    [aux_sym_continue_statement_token1] = ACTIONS(1134),
    [aux_sym_break_statement_token1] = ACTIONS(1134),
    [sym_integer] = ACTIONS(1134),
    [aux_sym_return_statement_token1] = ACTIONS(1134),
    [aux_sym_throw_expression_token1] = ACTIONS(1134),
    [aux_sym_while_statement_token1] = ACTIONS(1134),
    [aux_sym_while_statement_token2] = ACTIONS(1134),
    [aux_sym_do_statement_token1] = ACTIONS(1134),
    [aux_sym_for_statement_token1] = ACTIONS(1134),
    [aux_sym_for_statement_token2] = ACTIONS(1134),
    [aux_sym_foreach_statement_token1] = ACTIONS(1134),
    [aux_sym_foreach_statement_token2] = ACTIONS(1134),
    [aux_sym_if_statement_token1] = ACTIONS(1134),
    [aux_sym_if_statement_token2] = ACTIONS(1134),
    [aux_sym_else_if_clause_token1] = ACTIONS(1134),
    [aux_sym_else_clause_token1] = ACTIONS(1134),
    [aux_sym_match_expression_token1] = ACTIONS(1134),
    [aux_sym_match_default_expression_token1] = ACTIONS(1134),
    [aux_sym_switch_statement_token1] = ACTIONS(1134),
    [aux_sym_switch_block_token1] = ACTIONS(1134),
    [anon_sym_PLUS] = ACTIONS(1134),
    [anon_sym_DASH] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1132),
    [anon_sym_BANG] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1132),
    [aux_sym_clone_expression_token1] = ACTIONS(1134),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1134),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1132),
    [aux_sym__list_destructing_token1] = ACTIONS(1134),
    [anon_sym_LBRACK] = ACTIONS(1132),
    [anon_sym_self] = ACTIONS(1134),
    [anon_sym_parent] = ACTIONS(1134),
    [aux_sym__argument_name_token1] = ACTIONS(1134),
    [aux_sym__argument_name_token2] = ACTIONS(1134),
    [anon_sym_POUND_LBRACK] = ACTIONS(1132),
    [aux_sym_encapsed_string_token1] = ACTIONS(1132),
    [anon_sym_DQUOTE] = ACTIONS(1132),
    [aux_sym_string_token1] = ACTIONS(1132),
    [anon_sym_SQUOTE] = ACTIONS(1132),
    [anon_sym_LT_LT_LT] = ACTIONS(1132),
    [anon_sym_BQUOTE] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(1132),
    [aux_sym_yield_expression_token1] = ACTIONS(1134),
    [aux_sym_include_expression_token1] = ACTIONS(1134),
    [aux_sym_include_once_expression_token1] = ACTIONS(1134),
    [aux_sym_require_expression_token1] = ACTIONS(1134),
    [aux_sym_require_once_expression_token1] = ACTIONS(1134),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1136),
  },
  [452] = {
    [sym_text_interpolation] = STATE(452),
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_name] = ACTIONS(1140),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1142),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1140),
    [aux_sym_global_declaration_token1] = ACTIONS(1140),
    [aux_sym_namespace_definition_token1] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1140),
    [anon_sym_BSLASH] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [aux_sym_trait_declaration_token1] = ACTIONS(1140),
    [aux_sym_interface_declaration_token1] = ACTIONS(1140),
    [aux_sym_enum_declaration_token1] = ACTIONS(1140),
    [aux_sym_enum_case_token1] = ACTIONS(1140),
    [aux_sym_class_declaration_token1] = ACTIONS(1140),
    [aux_sym_final_modifier_token1] = ACTIONS(1140),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1140),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1140),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [aux_sym_cast_type_token1] = ACTIONS(1140),
    [aux_sym_echo_statement_token1] = ACTIONS(1140),
    [anon_sym_unset] = ACTIONS(1140),
    [aux_sym_declare_statement_token1] = ACTIONS(1140),
    [aux_sym_declare_statement_token2] = ACTIONS(1140),
    [sym_float] = ACTIONS(1140),
    [aux_sym_try_statement_token1] = ACTIONS(1140),
    [aux_sym_goto_statement_token1] = ACTIONS(1140),
    [aux_sym_continue_statement_token1] = ACTIONS(1140),
    [aux_sym_break_statement_token1] = ACTIONS(1140),
    [sym_integer] = ACTIONS(1140),
    [aux_sym_return_statement_token1] = ACTIONS(1140),
    [aux_sym_throw_expression_token1] = ACTIONS(1140),
    [aux_sym_while_statement_token1] = ACTIONS(1140),
    [aux_sym_while_statement_token2] = ACTIONS(1140),
    [aux_sym_do_statement_token1] = ACTIONS(1140),
    [aux_sym_for_statement_token1] = ACTIONS(1140),
    [aux_sym_for_statement_token2] = ACTIONS(1140),
    [aux_sym_foreach_statement_token1] = ACTIONS(1140),
    [aux_sym_foreach_statement_token2] = ACTIONS(1140),
    [aux_sym_if_statement_token1] = ACTIONS(1140),
    [aux_sym_if_statement_token2] = ACTIONS(1140),
    [aux_sym_else_if_clause_token1] = ACTIONS(1140),
    [aux_sym_else_clause_token1] = ACTIONS(1140),
    [aux_sym_match_expression_token1] = ACTIONS(1140),
    [aux_sym_match_default_expression_token1] = ACTIONS(1140),
    [aux_sym_switch_statement_token1] = ACTIONS(1140),
    [aux_sym_switch_block_token1] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_BANG] = ACTIONS(1138),
    [anon_sym_AT] = ACTIONS(1138),
    [aux_sym_clone_expression_token1] = ACTIONS(1140),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1140),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1140),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [aux_sym__list_destructing_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_self] = ACTIONS(1140),
    [anon_sym_parent] = ACTIONS(1140),
    [aux_sym__argument_name_token1] = ACTIONS(1140),
    [aux_sym__argument_name_token2] = ACTIONS(1140),
    [anon_sym_POUND_LBRACK] = ACTIONS(1138),
    [aux_sym_encapsed_string_token1] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [aux_sym_string_token1] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [anon_sym_LT_LT_LT] = ACTIONS(1138),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [anon_sym_DOLLAR] = ACTIONS(1138),
    [aux_sym_yield_expression_token1] = ACTIONS(1140),
    [aux_sym_include_expression_token1] = ACTIONS(1140),
    [aux_sym_include_once_expression_token1] = ACTIONS(1140),
    [aux_sym_require_expression_token1] = ACTIONS(1140),
    [aux_sym_require_once_expression_token1] = ACTIONS(1140),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1142),
  },
  [453] = {
    [sym_text_interpolation] = STATE(453),
    [ts_builtin_sym_end] = ACTIONS(1144),
    [sym_name] = ACTIONS(1146),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1148),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1146),
    [aux_sym_global_declaration_token1] = ACTIONS(1146),
    [aux_sym_namespace_definition_token1] = ACTIONS(1146),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1146),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1146),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1146),
    [anon_sym_BSLASH] = ACTIONS(1144),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1144),
    [aux_sym_trait_declaration_token1] = ACTIONS(1146),
    [aux_sym_interface_declaration_token1] = ACTIONS(1146),
    [aux_sym_enum_declaration_token1] = ACTIONS(1146),
    [aux_sym_enum_case_token1] = ACTIONS(1146),
    [aux_sym_class_declaration_token1] = ACTIONS(1146),
    [aux_sym_final_modifier_token1] = ACTIONS(1146),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1146),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1146),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1146),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1146),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1146),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(1144),
    [aux_sym_cast_type_token1] = ACTIONS(1146),
    [aux_sym_echo_statement_token1] = ACTIONS(1146),
    [anon_sym_unset] = ACTIONS(1146),
    [aux_sym_declare_statement_token1] = ACTIONS(1146),
    [aux_sym_declare_statement_token2] = ACTIONS(1146),
    [sym_float] = ACTIONS(1146),
    [aux_sym_try_statement_token1] = ACTIONS(1146),
    [aux_sym_goto_statement_token1] = ACTIONS(1146),
    [aux_sym_continue_statement_token1] = ACTIONS(1146),
    [aux_sym_break_statement_token1] = ACTIONS(1146),
    [sym_integer] = ACTIONS(1146),
    [aux_sym_return_statement_token1] = ACTIONS(1146),
    [aux_sym_throw_expression_token1] = ACTIONS(1146),
    [aux_sym_while_statement_token1] = ACTIONS(1146),
    [aux_sym_while_statement_token2] = ACTIONS(1146),
    [aux_sym_do_statement_token1] = ACTIONS(1146),
    [aux_sym_for_statement_token1] = ACTIONS(1146),
    [aux_sym_for_statement_token2] = ACTIONS(1146),
    [aux_sym_foreach_statement_token1] = ACTIONS(1146),
    [aux_sym_foreach_statement_token2] = ACTIONS(1146),
    [aux_sym_if_statement_token1] = ACTIONS(1146),
    [aux_sym_if_statement_token2] = ACTIONS(1146),
    [aux_sym_else_if_clause_token1] = ACTIONS(1146),
    [aux_sym_else_clause_token1] = ACTIONS(1146),
    [aux_sym_match_expression_token1] = ACTIONS(1146),
    [aux_sym_match_default_expression_token1] = ACTIONS(1146),
    [aux_sym_switch_statement_token1] = ACTIONS(1146),
    [aux_sym_switch_block_token1] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_TILDE] = ACTIONS(1144),
    [anon_sym_BANG] = ACTIONS(1144),
    [anon_sym_AT] = ACTIONS(1144),
    [aux_sym_clone_expression_token1] = ACTIONS(1146),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1146),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1146),
    [anon_sym_DASH_DASH] = ACTIONS(1144),
    [anon_sym_PLUS_PLUS] = ACTIONS(1144),
    [aux_sym__list_destructing_token1] = ACTIONS(1146),
    [anon_sym_LBRACK] = ACTIONS(1144),
    [anon_sym_self] = ACTIONS(1146),
    [anon_sym_parent] = ACTIONS(1146),
    [aux_sym__argument_name_token1] = ACTIONS(1146),
    [aux_sym__argument_name_token2] = ACTIONS(1146),
    [anon_sym_POUND_LBRACK] = ACTIONS(1144),
    [aux_sym_encapsed_string_token1] = ACTIONS(1144),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [aux_sym_string_token1] = ACTIONS(1144),
    [anon_sym_SQUOTE] = ACTIONS(1144),
    [anon_sym_LT_LT_LT] = ACTIONS(1144),
    [anon_sym_BQUOTE] = ACTIONS(1144),
    [anon_sym_DOLLAR] = ACTIONS(1144),
    [aux_sym_yield_expression_token1] = ACTIONS(1146),
    [aux_sym_include_expression_token1] = ACTIONS(1146),
    [aux_sym_include_once_expression_token1] = ACTIONS(1146),
    [aux_sym_require_expression_token1] = ACTIONS(1146),
    [aux_sym_require_once_expression_token1] = ACTIONS(1146),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1148),
  },
  [454] = {
    [sym_text_interpolation] = STATE(454),
    [ts_builtin_sym_end] = ACTIONS(1150),
    [sym_name] = ACTIONS(1152),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1154),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1152),
    [aux_sym_global_declaration_token1] = ACTIONS(1152),
    [aux_sym_namespace_definition_token1] = ACTIONS(1152),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1152),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1152),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1152),
    [anon_sym_BSLASH] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1150),
    [anon_sym_RBRACE] = ACTIONS(1150),
    [aux_sym_trait_declaration_token1] = ACTIONS(1152),
    [aux_sym_interface_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_declaration_token1] = ACTIONS(1152),
    [aux_sym_enum_case_token1] = ACTIONS(1152),
    [aux_sym_class_declaration_token1] = ACTIONS(1152),
    [aux_sym_final_modifier_token1] = ACTIONS(1152),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1152),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1152),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1152),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1152),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1152),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1150),
    [aux_sym_cast_type_token1] = ACTIONS(1152),
    [aux_sym_echo_statement_token1] = ACTIONS(1152),
    [anon_sym_unset] = ACTIONS(1152),
    [aux_sym_declare_statement_token1] = ACTIONS(1152),
    [aux_sym_declare_statement_token2] = ACTIONS(1152),
    [sym_float] = ACTIONS(1152),
    [aux_sym_try_statement_token1] = ACTIONS(1152),
    [aux_sym_goto_statement_token1] = ACTIONS(1152),
    [aux_sym_continue_statement_token1] = ACTIONS(1152),
    [aux_sym_break_statement_token1] = ACTIONS(1152),
    [sym_integer] = ACTIONS(1152),
    [aux_sym_return_statement_token1] = ACTIONS(1152),
    [aux_sym_throw_expression_token1] = ACTIONS(1152),
    [aux_sym_while_statement_token1] = ACTIONS(1152),
    [aux_sym_while_statement_token2] = ACTIONS(1152),
    [aux_sym_do_statement_token1] = ACTIONS(1152),
    [aux_sym_for_statement_token1] = ACTIONS(1152),
    [aux_sym_for_statement_token2] = ACTIONS(1152),
    [aux_sym_foreach_statement_token1] = ACTIONS(1152),
    [aux_sym_foreach_statement_token2] = ACTIONS(1152),
    [aux_sym_if_statement_token1] = ACTIONS(1152),
    [aux_sym_if_statement_token2] = ACTIONS(1152),
    [aux_sym_else_if_clause_token1] = ACTIONS(1152),
    [aux_sym_else_clause_token1] = ACTIONS(1152),
    [aux_sym_match_expression_token1] = ACTIONS(1152),
    [aux_sym_match_default_expression_token1] = ACTIONS(1152),
    [aux_sym_switch_statement_token1] = ACTIONS(1152),
    [aux_sym_switch_block_token1] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1152),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_TILDE] = ACTIONS(1150),
    [anon_sym_BANG] = ACTIONS(1150),
    [anon_sym_AT] = ACTIONS(1150),
    [aux_sym_clone_expression_token1] = ACTIONS(1152),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1152),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1152),
    [anon_sym_DASH_DASH] = ACTIONS(1150),
    [anon_sym_PLUS_PLUS] = ACTIONS(1150),
    [aux_sym__list_destructing_token1] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_self] = ACTIONS(1152),
    [anon_sym_parent] = ACTIONS(1152),
    [aux_sym__argument_name_token1] = ACTIONS(1152),
    [aux_sym__argument_name_token2] = ACTIONS(1152),
    [anon_sym_POUND_LBRACK] = ACTIONS(1150),
    [aux_sym_encapsed_string_token1] = ACTIONS(1150),
    [anon_sym_DQUOTE] = ACTIONS(1150),
    [aux_sym_string_token1] = ACTIONS(1150),
    [anon_sym_SQUOTE] = ACTIONS(1150),
    [anon_sym_LT_LT_LT] = ACTIONS(1150),
    [anon_sym_BQUOTE] = ACTIONS(1150),
    [anon_sym_DOLLAR] = ACTIONS(1150),
    [aux_sym_yield_expression_token1] = ACTIONS(1152),
    [aux_sym_include_expression_token1] = ACTIONS(1152),
    [aux_sym_include_once_expression_token1] = ACTIONS(1152),
    [aux_sym_require_expression_token1] = ACTIONS(1152),
    [aux_sym_require_once_expression_token1] = ACTIONS(1152),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1154),
  },
  [455] = {
    [sym_text_interpolation] = STATE(455),
    [ts_builtin_sym_end] = ACTIONS(1156),
    [sym_name] = ACTIONS(1158),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1160),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1158),
    [aux_sym_global_declaration_token1] = ACTIONS(1158),
    [aux_sym_namespace_definition_token1] = ACTIONS(1158),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1158),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1158),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1158),
    [anon_sym_BSLASH] = ACTIONS(1156),
    [anon_sym_LBRACE] = ACTIONS(1156),
    [anon_sym_RBRACE] = ACTIONS(1156),
    [aux_sym_trait_declaration_token1] = ACTIONS(1158),
    [aux_sym_interface_declaration_token1] = ACTIONS(1158),
    [aux_sym_enum_declaration_token1] = ACTIONS(1158),
    [aux_sym_enum_case_token1] = ACTIONS(1158),
    [aux_sym_class_declaration_token1] = ACTIONS(1158),
    [aux_sym_final_modifier_token1] = ACTIONS(1158),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1158),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1158),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1158),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1158),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1158),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1158),
    [anon_sym_LPAREN] = ACTIONS(1156),
    [aux_sym_cast_type_token1] = ACTIONS(1158),
    [aux_sym_echo_statement_token1] = ACTIONS(1158),
    [anon_sym_unset] = ACTIONS(1158),
    [aux_sym_declare_statement_token1] = ACTIONS(1158),
    [aux_sym_declare_statement_token2] = ACTIONS(1158),
    [sym_float] = ACTIONS(1158),
    [aux_sym_try_statement_token1] = ACTIONS(1158),
    [aux_sym_goto_statement_token1] = ACTIONS(1158),
    [aux_sym_continue_statement_token1] = ACTIONS(1158),
    [aux_sym_break_statement_token1] = ACTIONS(1158),
    [sym_integer] = ACTIONS(1158),
    [aux_sym_return_statement_token1] = ACTIONS(1158),
    [aux_sym_throw_expression_token1] = ACTIONS(1158),
    [aux_sym_while_statement_token1] = ACTIONS(1158),
    [aux_sym_while_statement_token2] = ACTIONS(1158),
    [aux_sym_do_statement_token1] = ACTIONS(1158),
    [aux_sym_for_statement_token1] = ACTIONS(1158),
    [aux_sym_for_statement_token2] = ACTIONS(1158),
    [aux_sym_foreach_statement_token1] = ACTIONS(1158),
    [aux_sym_foreach_statement_token2] = ACTIONS(1158),
    [aux_sym_if_statement_token1] = ACTIONS(1158),
    [aux_sym_if_statement_token2] = ACTIONS(1158),
    [aux_sym_else_if_clause_token1] = ACTIONS(1158),
    [aux_sym_else_clause_token1] = ACTIONS(1158),
    [aux_sym_match_expression_token1] = ACTIONS(1158),
    [aux_sym_match_default_expression_token1] = ACTIONS(1158),
    [aux_sym_switch_statement_token1] = ACTIONS(1158),
    [aux_sym_switch_block_token1] = ACTIONS(1158),
    [anon_sym_PLUS] = ACTIONS(1158),
    [anon_sym_DASH] = ACTIONS(1158),
    [anon_sym_TILDE] = ACTIONS(1156),
    [anon_sym_BANG] = ACTIONS(1156),
    [anon_sym_AT] = ACTIONS(1156),
    [aux_sym_clone_expression_token1] = ACTIONS(1158),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1158),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1158),
    [anon_sym_DASH_DASH] = ACTIONS(1156),
    [anon_sym_PLUS_PLUS] = ACTIONS(1156),
    [aux_sym__list_destructing_token1] = ACTIONS(1158),
    [anon_sym_LBRACK] = ACTIONS(1156),
    [anon_sym_self] = ACTIONS(1158),
    [anon_sym_parent] = ACTIONS(1158),
    [aux_sym__argument_name_token1] = ACTIONS(1158),
    [aux_sym__argument_name_token2] = ACTIONS(1158),
    [anon_sym_POUND_LBRACK] = ACTIONS(1156),
    [aux_sym_encapsed_string_token1] = ACTIONS(1156),
    [anon_sym_DQUOTE] = ACTIONS(1156),
    [aux_sym_string_token1] = ACTIONS(1156),
    [anon_sym_SQUOTE] = ACTIONS(1156),
    [anon_sym_LT_LT_LT] = ACTIONS(1156),
    [anon_sym_BQUOTE] = ACTIONS(1156),
    [anon_sym_DOLLAR] = ACTIONS(1156),
    [aux_sym_yield_expression_token1] = ACTIONS(1158),
    [aux_sym_include_expression_token1] = ACTIONS(1158),
    [aux_sym_include_once_expression_token1] = ACTIONS(1158),
    [aux_sym_require_expression_token1] = ACTIONS(1158),
    [aux_sym_require_once_expression_token1] = ACTIONS(1158),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1160),
  },
  [456] = {
    [sym_text_interpolation] = STATE(456),
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_name] = ACTIONS(1052),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1050),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1052),
    [aux_sym_global_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_definition_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1052),
    [anon_sym_BSLASH] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [aux_sym_trait_declaration_token1] = ACTIONS(1052),
    [aux_sym_interface_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_case_token1] = ACTIONS(1052),
    [aux_sym_class_declaration_token1] = ACTIONS(1052),
    [aux_sym_final_modifier_token1] = ACTIONS(1052),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1052),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1052),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [aux_sym_cast_type_token1] = ACTIONS(1052),
    [aux_sym_echo_statement_token1] = ACTIONS(1052),
    [anon_sym_unset] = ACTIONS(1052),
    [aux_sym_declare_statement_token1] = ACTIONS(1052),
    [aux_sym_declare_statement_token2] = ACTIONS(1052),
    [sym_float] = ACTIONS(1052),
    [aux_sym_try_statement_token1] = ACTIONS(1052),
    [aux_sym_goto_statement_token1] = ACTIONS(1052),
    [aux_sym_continue_statement_token1] = ACTIONS(1052),
    [aux_sym_break_statement_token1] = ACTIONS(1052),
    [sym_integer] = ACTIONS(1052),
    [aux_sym_return_statement_token1] = ACTIONS(1052),
    [aux_sym_throw_expression_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token2] = ACTIONS(1052),
    [aux_sym_do_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token2] = ACTIONS(1052),
    [aux_sym_foreach_statement_token1] = ACTIONS(1052),
    [aux_sym_foreach_statement_token2] = ACTIONS(1052),
    [aux_sym_if_statement_token1] = ACTIONS(1052),
    [aux_sym_if_statement_token2] = ACTIONS(1052),
    [aux_sym_else_if_clause_token1] = ACTIONS(1052),
    [aux_sym_else_clause_token1] = ACTIONS(1052),
    [aux_sym_match_expression_token1] = ACTIONS(1052),
    [aux_sym_match_default_expression_token1] = ACTIONS(1052),
    [aux_sym_switch_statement_token1] = ACTIONS(1052),
    [aux_sym_switch_block_token1] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1050),
    [aux_sym_clone_expression_token1] = ACTIONS(1052),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1052),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [aux_sym__list_destructing_token1] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1050),
    [anon_sym_self] = ACTIONS(1052),
    [anon_sym_parent] = ACTIONS(1052),
    [aux_sym__argument_name_token1] = ACTIONS(1052),
    [aux_sym__argument_name_token2] = ACTIONS(1052),
    [anon_sym_POUND_LBRACK] = ACTIONS(1050),
    [aux_sym_encapsed_string_token1] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [aux_sym_string_token1] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_LT_LT_LT] = ACTIONS(1050),
    [anon_sym_BQUOTE] = ACTIONS(1050),
    [anon_sym_DOLLAR] = ACTIONS(1050),
    [aux_sym_yield_expression_token1] = ACTIONS(1052),
    [aux_sym_include_expression_token1] = ACTIONS(1052),
    [aux_sym_include_once_expression_token1] = ACTIONS(1052),
    [aux_sym_require_expression_token1] = ACTIONS(1052),
    [aux_sym_require_once_expression_token1] = ACTIONS(1052),
    [sym_comment] = ACTIONS(5),
  },
  [457] = {
    [sym_text_interpolation] = STATE(457),
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_name] = ACTIONS(1164),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1162),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1164),
    [aux_sym_global_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_definition_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1164),
    [anon_sym_BSLASH] = ACTIONS(1162),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [aux_sym_trait_declaration_token1] = ACTIONS(1164),
    [aux_sym_interface_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_case_token1] = ACTIONS(1164),
    [aux_sym_class_declaration_token1] = ACTIONS(1164),
    [aux_sym_final_modifier_token1] = ACTIONS(1164),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1164),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1164),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [aux_sym_cast_type_token1] = ACTIONS(1164),
    [aux_sym_echo_statement_token1] = ACTIONS(1164),
    [anon_sym_unset] = ACTIONS(1164),
    [aux_sym_declare_statement_token1] = ACTIONS(1164),
    [aux_sym_declare_statement_token2] = ACTIONS(1164),
    [sym_float] = ACTIONS(1164),
    [aux_sym_try_statement_token1] = ACTIONS(1164),
    [aux_sym_goto_statement_token1] = ACTIONS(1164),
    [aux_sym_continue_statement_token1] = ACTIONS(1164),
    [aux_sym_break_statement_token1] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1164),
    [aux_sym_return_statement_token1] = ACTIONS(1164),
    [aux_sym_throw_expression_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token2] = ACTIONS(1164),
    [aux_sym_do_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token2] = ACTIONS(1164),
    [aux_sym_foreach_statement_token1] = ACTIONS(1164),
    [aux_sym_foreach_statement_token2] = ACTIONS(1164),
    [aux_sym_if_statement_token1] = ACTIONS(1164),
    [aux_sym_if_statement_token2] = ACTIONS(1164),
    [aux_sym_else_if_clause_token1] = ACTIONS(1164),
    [aux_sym_else_clause_token1] = ACTIONS(1164),
    [aux_sym_match_expression_token1] = ACTIONS(1164),
    [aux_sym_match_default_expression_token1] = ACTIONS(1164),
    [aux_sym_switch_statement_token1] = ACTIONS(1164),
    [aux_sym_switch_block_token1] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_BANG] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(1162),
    [aux_sym_clone_expression_token1] = ACTIONS(1164),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1164),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1164),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [aux_sym__list_destructing_token1] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_self] = ACTIONS(1164),
    [anon_sym_parent] = ACTIONS(1164),
    [aux_sym__argument_name_token1] = ACTIONS(1164),
    [aux_sym__argument_name_token2] = ACTIONS(1164),
    [anon_sym_POUND_LBRACK] = ACTIONS(1162),
    [aux_sym_encapsed_string_token1] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [aux_sym_string_token1] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [anon_sym_LT_LT_LT] = ACTIONS(1162),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [anon_sym_DOLLAR] = ACTIONS(1162),
    [aux_sym_yield_expression_token1] = ACTIONS(1164),
    [aux_sym_include_expression_token1] = ACTIONS(1164),
    [aux_sym_include_once_expression_token1] = ACTIONS(1164),
    [aux_sym_require_expression_token1] = ACTIONS(1164),
    [aux_sym_require_once_expression_token1] = ACTIONS(1164),
    [sym_comment] = ACTIONS(5),
  },
  [458] = {
    [sym_text_interpolation] = STATE(458),
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_name] = ACTIONS(1168),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1166),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1168),
    [aux_sym_global_declaration_token1] = ACTIONS(1168),
    [aux_sym_namespace_definition_token1] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1168),
    [anon_sym_BSLASH] = ACTIONS(1166),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [aux_sym_trait_declaration_token1] = ACTIONS(1168),
    [aux_sym_interface_declaration_token1] = ACTIONS(1168),
    [aux_sym_enum_declaration_token1] = ACTIONS(1168),
    [aux_sym_enum_case_token1] = ACTIONS(1168),
    [aux_sym_class_declaration_token1] = ACTIONS(1168),
    [aux_sym_final_modifier_token1] = ACTIONS(1168),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1168),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1168),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [aux_sym_cast_type_token1] = ACTIONS(1168),
    [aux_sym_echo_statement_token1] = ACTIONS(1168),
    [anon_sym_unset] = ACTIONS(1168),
    [aux_sym_declare_statement_token1] = ACTIONS(1168),
    [aux_sym_declare_statement_token2] = ACTIONS(1168),
    [sym_float] = ACTIONS(1168),
    [aux_sym_try_statement_token1] = ACTIONS(1168),
    [aux_sym_goto_statement_token1] = ACTIONS(1168),
    [aux_sym_continue_statement_token1] = ACTIONS(1168),
    [aux_sym_break_statement_token1] = ACTIONS(1168),
    [sym_integer] = ACTIONS(1168),
    [aux_sym_return_statement_token1] = ACTIONS(1168),
    [aux_sym_throw_expression_token1] = ACTIONS(1168),
    [aux_sym_while_statement_token1] = ACTIONS(1168),
    [aux_sym_while_statement_token2] = ACTIONS(1168),
    [aux_sym_do_statement_token1] = ACTIONS(1168),
    [aux_sym_for_statement_token1] = ACTIONS(1168),
    [aux_sym_for_statement_token2] = ACTIONS(1168),
    [aux_sym_foreach_statement_token1] = ACTIONS(1168),
    [aux_sym_foreach_statement_token2] = ACTIONS(1168),
    [aux_sym_if_statement_token1] = ACTIONS(1168),
    [aux_sym_if_statement_token2] = ACTIONS(1168),
    [aux_sym_else_if_clause_token1] = ACTIONS(1168),
    [aux_sym_else_clause_token1] = ACTIONS(1168),
    [aux_sym_match_expression_token1] = ACTIONS(1168),
    [aux_sym_match_default_expression_token1] = ACTIONS(1168),
    [aux_sym_switch_statement_token1] = ACTIONS(1168),
    [aux_sym_switch_block_token1] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_BANG] = ACTIONS(1166),
    [anon_sym_AT] = ACTIONS(1166),
    [aux_sym_clone_expression_token1] = ACTIONS(1168),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1168),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1168),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [aux_sym__list_destructing_token1] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_self] = ACTIONS(1168),
    [anon_sym_parent] = ACTIONS(1168),
    [aux_sym__argument_name_token1] = ACTIONS(1168),
    [aux_sym__argument_name_token2] = ACTIONS(1168),
    [anon_sym_POUND_LBRACK] = ACTIONS(1166),
    [aux_sym_encapsed_string_token1] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [aux_sym_string_token1] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [anon_sym_LT_LT_LT] = ACTIONS(1166),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [anon_sym_DOLLAR] = ACTIONS(1166),
    [aux_sym_yield_expression_token1] = ACTIONS(1168),
    [aux_sym_include_expression_token1] = ACTIONS(1168),
    [aux_sym_include_once_expression_token1] = ACTIONS(1168),
    [aux_sym_require_expression_token1] = ACTIONS(1168),
    [aux_sym_require_once_expression_token1] = ACTIONS(1168),
    [sym_comment] = ACTIONS(5),
  },
  [459] = {
    [sym_text_interpolation] = STATE(459),
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_name] = ACTIONS(1172),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1170),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1172),
    [aux_sym_global_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_definition_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1172),
    [anon_sym_BSLASH] = ACTIONS(1170),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [aux_sym_trait_declaration_token1] = ACTIONS(1172),
    [aux_sym_interface_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_case_token1] = ACTIONS(1172),
    [aux_sym_class_declaration_token1] = ACTIONS(1172),
    [aux_sym_final_modifier_token1] = ACTIONS(1172),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1172),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1172),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [aux_sym_cast_type_token1] = ACTIONS(1172),
    [aux_sym_echo_statement_token1] = ACTIONS(1172),
    [anon_sym_unset] = ACTIONS(1172),
    [aux_sym_declare_statement_token1] = ACTIONS(1172),
    [aux_sym_declare_statement_token2] = ACTIONS(1172),
    [sym_float] = ACTIONS(1172),
    [aux_sym_try_statement_token1] = ACTIONS(1172),
    [aux_sym_goto_statement_token1] = ACTIONS(1172),
    [aux_sym_continue_statement_token1] = ACTIONS(1172),
    [aux_sym_break_statement_token1] = ACTIONS(1172),
    [sym_integer] = ACTIONS(1172),
    [aux_sym_return_statement_token1] = ACTIONS(1172),
    [aux_sym_throw_expression_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token2] = ACTIONS(1172),
    [aux_sym_do_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token2] = ACTIONS(1172),
    [aux_sym_foreach_statement_token1] = ACTIONS(1172),
    [aux_sym_foreach_statement_token2] = ACTIONS(1172),
    [aux_sym_if_statement_token1] = ACTIONS(1172),
    [aux_sym_if_statement_token2] = ACTIONS(1172),
    [aux_sym_else_if_clause_token1] = ACTIONS(1172),
    [aux_sym_else_clause_token1] = ACTIONS(1172),
    [aux_sym_match_expression_token1] = ACTIONS(1172),
    [aux_sym_match_default_expression_token1] = ACTIONS(1172),
    [aux_sym_switch_statement_token1] = ACTIONS(1172),
    [aux_sym_switch_block_token1] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1170),
    [anon_sym_BANG] = ACTIONS(1170),
    [anon_sym_AT] = ACTIONS(1170),
    [aux_sym_clone_expression_token1] = ACTIONS(1172),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1172),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1172),
    [anon_sym_DASH_DASH] = ACTIONS(1170),
    [anon_sym_PLUS_PLUS] = ACTIONS(1170),
    [aux_sym__list_destructing_token1] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_self] = ACTIONS(1172),
    [anon_sym_parent] = ACTIONS(1172),
    [aux_sym__argument_name_token1] = ACTIONS(1172),
    [aux_sym__argument_name_token2] = ACTIONS(1172),
    [anon_sym_POUND_LBRACK] = ACTIONS(1170),
    [aux_sym_encapsed_string_token1] = ACTIONS(1170),
    [anon_sym_DQUOTE] = ACTIONS(1170),
    [aux_sym_string_token1] = ACTIONS(1170),
    [anon_sym_SQUOTE] = ACTIONS(1170),
    [anon_sym_LT_LT_LT] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1170),
    [anon_sym_DOLLAR] = ACTIONS(1170),
    [aux_sym_yield_expression_token1] = ACTIONS(1172),
    [aux_sym_include_expression_token1] = ACTIONS(1172),
    [aux_sym_include_once_expression_token1] = ACTIONS(1172),
    [aux_sym_require_expression_token1] = ACTIONS(1172),
    [aux_sym_require_once_expression_token1] = ACTIONS(1172),
    [sym_comment] = ACTIONS(5),
  },
  [460] = {
    [sym_text_interpolation] = STATE(460),
    [ts_builtin_sym_end] = ACTIONS(1174),
    [sym_name] = ACTIONS(1176),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1174),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1176),
    [aux_sym_global_declaration_token1] = ACTIONS(1176),
    [aux_sym_namespace_definition_token1] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1176),
    [anon_sym_BSLASH] = ACTIONS(1174),
    [anon_sym_LBRACE] = ACTIONS(1174),
    [anon_sym_RBRACE] = ACTIONS(1174),
    [aux_sym_trait_declaration_token1] = ACTIONS(1176),
    [aux_sym_interface_declaration_token1] = ACTIONS(1176),
    [aux_sym_enum_declaration_token1] = ACTIONS(1176),
    [aux_sym_enum_case_token1] = ACTIONS(1176),
    [aux_sym_class_declaration_token1] = ACTIONS(1176),
    [aux_sym_final_modifier_token1] = ACTIONS(1176),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1176),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1176),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [aux_sym_cast_type_token1] = ACTIONS(1176),
    [aux_sym_echo_statement_token1] = ACTIONS(1176),
    [anon_sym_unset] = ACTIONS(1176),
    [aux_sym_declare_statement_token1] = ACTIONS(1176),
    [aux_sym_declare_statement_token2] = ACTIONS(1176),
    [sym_float] = ACTIONS(1176),
    [aux_sym_try_statement_token1] = ACTIONS(1176),
    [aux_sym_goto_statement_token1] = ACTIONS(1176),
    [aux_sym_continue_statement_token1] = ACTIONS(1176),
    [aux_sym_break_statement_token1] = ACTIONS(1176),
    [sym_integer] = ACTIONS(1176),
    [aux_sym_return_statement_token1] = ACTIONS(1176),
    [aux_sym_throw_expression_token1] = ACTIONS(1176),
    [aux_sym_while_statement_token1] = ACTIONS(1176),
    [aux_sym_while_statement_token2] = ACTIONS(1176),
    [aux_sym_do_statement_token1] = ACTIONS(1176),
    [aux_sym_for_statement_token1] = ACTIONS(1176),
    [aux_sym_for_statement_token2] = ACTIONS(1176),
    [aux_sym_foreach_statement_token1] = ACTIONS(1176),
    [aux_sym_foreach_statement_token2] = ACTIONS(1176),
    [aux_sym_if_statement_token1] = ACTIONS(1176),
    [aux_sym_if_statement_token2] = ACTIONS(1176),
    [aux_sym_else_if_clause_token1] = ACTIONS(1176),
    [aux_sym_else_clause_token1] = ACTIONS(1176),
    [aux_sym_match_expression_token1] = ACTIONS(1176),
    [aux_sym_match_default_expression_token1] = ACTIONS(1176),
    [aux_sym_switch_statement_token1] = ACTIONS(1176),
    [aux_sym_switch_block_token1] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1174),
    [anon_sym_BANG] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(1174),
    [aux_sym_clone_expression_token1] = ACTIONS(1176),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1176),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1176),
    [anon_sym_DASH_DASH] = ACTIONS(1174),
    [anon_sym_PLUS_PLUS] = ACTIONS(1174),
    [aux_sym__list_destructing_token1] = ACTIONS(1176),
    [anon_sym_LBRACK] = ACTIONS(1174),
    [anon_sym_self] = ACTIONS(1176),
    [anon_sym_parent] = ACTIONS(1176),
    [aux_sym__argument_name_token1] = ACTIONS(1176),
    [aux_sym__argument_name_token2] = ACTIONS(1176),
    [anon_sym_POUND_LBRACK] = ACTIONS(1174),
    [aux_sym_encapsed_string_token1] = ACTIONS(1174),
    [anon_sym_DQUOTE] = ACTIONS(1174),
    [aux_sym_string_token1] = ACTIONS(1174),
    [anon_sym_SQUOTE] = ACTIONS(1174),
    [anon_sym_LT_LT_LT] = ACTIONS(1174),
    [anon_sym_BQUOTE] = ACTIONS(1174),
    [anon_sym_DOLLAR] = ACTIONS(1174),
    [aux_sym_yield_expression_token1] = ACTIONS(1176),
    [aux_sym_include_expression_token1] = ACTIONS(1176),
    [aux_sym_include_once_expression_token1] = ACTIONS(1176),
    [aux_sym_require_expression_token1] = ACTIONS(1176),
    [aux_sym_require_once_expression_token1] = ACTIONS(1176),
    [sym_comment] = ACTIONS(5),
  },
  [461] = {
    [sym_text_interpolation] = STATE(461),
    [ts_builtin_sym_end] = ACTIONS(1178),
    [sym_name] = ACTIONS(1180),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1178),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1180),
    [aux_sym_global_declaration_token1] = ACTIONS(1180),
    [aux_sym_namespace_definition_token1] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1180),
    [anon_sym_BSLASH] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1178),
    [anon_sym_RBRACE] = ACTIONS(1178),
    [aux_sym_trait_declaration_token1] = ACTIONS(1180),
    [aux_sym_interface_declaration_token1] = ACTIONS(1180),
    [aux_sym_enum_declaration_token1] = ACTIONS(1180),
    [aux_sym_enum_case_token1] = ACTIONS(1180),
    [aux_sym_class_declaration_token1] = ACTIONS(1180),
    [aux_sym_final_modifier_token1] = ACTIONS(1180),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1180),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1180),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1180),
    [anon_sym_LPAREN] = ACTIONS(1178),
    [aux_sym_cast_type_token1] = ACTIONS(1180),
    [aux_sym_echo_statement_token1] = ACTIONS(1180),
    [anon_sym_unset] = ACTIONS(1180),
    [aux_sym_declare_statement_token1] = ACTIONS(1180),
    [aux_sym_declare_statement_token2] = ACTIONS(1180),
    [sym_float] = ACTIONS(1180),
    [aux_sym_try_statement_token1] = ACTIONS(1180),
    [aux_sym_goto_statement_token1] = ACTIONS(1180),
    [aux_sym_continue_statement_token1] = ACTIONS(1180),
    [aux_sym_break_statement_token1] = ACTIONS(1180),
    [sym_integer] = ACTIONS(1180),
    [aux_sym_return_statement_token1] = ACTIONS(1180),
    [aux_sym_throw_expression_token1] = ACTIONS(1180),
    [aux_sym_while_statement_token1] = ACTIONS(1180),
    [aux_sym_while_statement_token2] = ACTIONS(1180),
    [aux_sym_do_statement_token1] = ACTIONS(1180),
    [aux_sym_for_statement_token1] = ACTIONS(1180),
    [aux_sym_for_statement_token2] = ACTIONS(1180),
    [aux_sym_foreach_statement_token1] = ACTIONS(1180),
    [aux_sym_foreach_statement_token2] = ACTIONS(1180),
    [aux_sym_if_statement_token1] = ACTIONS(1180),
    [aux_sym_if_statement_token2] = ACTIONS(1180),
    [aux_sym_else_if_clause_token1] = ACTIONS(1180),
    [aux_sym_else_clause_token1] = ACTIONS(1180),
    [aux_sym_match_expression_token1] = ACTIONS(1180),
    [aux_sym_match_default_expression_token1] = ACTIONS(1180),
    [aux_sym_switch_statement_token1] = ACTIONS(1180),
    [aux_sym_switch_block_token1] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1180),
    [anon_sym_DASH] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1178),
    [anon_sym_BANG] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1178),
    [aux_sym_clone_expression_token1] = ACTIONS(1180),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1180),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1180),
    [anon_sym_DASH_DASH] = ACTIONS(1178),
    [anon_sym_PLUS_PLUS] = ACTIONS(1178),
    [aux_sym__list_destructing_token1] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(1178),
    [anon_sym_self] = ACTIONS(1180),
    [anon_sym_parent] = ACTIONS(1180),
    [aux_sym__argument_name_token1] = ACTIONS(1180),
    [aux_sym__argument_name_token2] = ACTIONS(1180),
    [anon_sym_POUND_LBRACK] = ACTIONS(1178),
    [aux_sym_encapsed_string_token1] = ACTIONS(1178),
    [anon_sym_DQUOTE] = ACTIONS(1178),
    [aux_sym_string_token1] = ACTIONS(1178),
    [anon_sym_SQUOTE] = ACTIONS(1178),
    [anon_sym_LT_LT_LT] = ACTIONS(1178),
    [anon_sym_BQUOTE] = ACTIONS(1178),
    [anon_sym_DOLLAR] = ACTIONS(1178),
    [aux_sym_yield_expression_token1] = ACTIONS(1180),
    [aux_sym_include_expression_token1] = ACTIONS(1180),
    [aux_sym_include_once_expression_token1] = ACTIONS(1180),
    [aux_sym_require_expression_token1] = ACTIONS(1180),
    [aux_sym_require_once_expression_token1] = ACTIONS(1180),
    [sym_comment] = ACTIONS(5),
  },
  [462] = {
    [sym_text_interpolation] = STATE(462),
    [ts_builtin_sym_end] = ACTIONS(1182),
    [sym_name] = ACTIONS(1184),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1182),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1184),
    [aux_sym_global_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_definition_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1184),
    [anon_sym_BSLASH] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_RBRACE] = ACTIONS(1182),
    [aux_sym_trait_declaration_token1] = ACTIONS(1184),
    [aux_sym_interface_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_case_token1] = ACTIONS(1184),
    [aux_sym_class_declaration_token1] = ACTIONS(1184),
    [aux_sym_final_modifier_token1] = ACTIONS(1184),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1184),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1184),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [aux_sym_cast_type_token1] = ACTIONS(1184),
    [aux_sym_echo_statement_token1] = ACTIONS(1184),
    [anon_sym_unset] = ACTIONS(1184),
    [aux_sym_declare_statement_token1] = ACTIONS(1184),
    [aux_sym_declare_statement_token2] = ACTIONS(1184),
    [sym_float] = ACTIONS(1184),
    [aux_sym_try_statement_token1] = ACTIONS(1184),
    [aux_sym_goto_statement_token1] = ACTIONS(1184),
    [aux_sym_continue_statement_token1] = ACTIONS(1184),
    [aux_sym_break_statement_token1] = ACTIONS(1184),
    [sym_integer] = ACTIONS(1184),
    [aux_sym_return_statement_token1] = ACTIONS(1184),
    [aux_sym_throw_expression_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token2] = ACTIONS(1184),
    [aux_sym_do_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token2] = ACTIONS(1184),
    [aux_sym_foreach_statement_token1] = ACTIONS(1184),
    [aux_sym_foreach_statement_token2] = ACTIONS(1184),
    [aux_sym_if_statement_token1] = ACTIONS(1184),
    [aux_sym_if_statement_token2] = ACTIONS(1184),
    [aux_sym_else_if_clause_token1] = ACTIONS(1184),
    [aux_sym_else_clause_token1] = ACTIONS(1184),
    [aux_sym_match_expression_token1] = ACTIONS(1184),
    [aux_sym_match_default_expression_token1] = ACTIONS(1184),
    [aux_sym_switch_statement_token1] = ACTIONS(1184),
    [aux_sym_switch_block_token1] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1182),
    [aux_sym_clone_expression_token1] = ACTIONS(1184),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1184),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1184),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [aux_sym__list_destructing_token1] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1182),
    [anon_sym_self] = ACTIONS(1184),
    [anon_sym_parent] = ACTIONS(1184),
    [aux_sym__argument_name_token1] = ACTIONS(1184),
    [aux_sym__argument_name_token2] = ACTIONS(1184),
    [anon_sym_POUND_LBRACK] = ACTIONS(1182),
    [aux_sym_encapsed_string_token1] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [aux_sym_string_token1] = ACTIONS(1182),
    [anon_sym_SQUOTE] = ACTIONS(1182),
    [anon_sym_LT_LT_LT] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(1182),
    [anon_sym_DOLLAR] = ACTIONS(1182),
    [aux_sym_yield_expression_token1] = ACTIONS(1184),
    [aux_sym_include_expression_token1] = ACTIONS(1184),
    [aux_sym_include_once_expression_token1] = ACTIONS(1184),
    [aux_sym_require_expression_token1] = ACTIONS(1184),
    [aux_sym_require_once_expression_token1] = ACTIONS(1184),
    [sym_comment] = ACTIONS(5),
  },
  [463] = {
    [sym_text_interpolation] = STATE(463),
    [ts_builtin_sym_end] = ACTIONS(1186),
    [sym_name] = ACTIONS(1188),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1186),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1188),
    [aux_sym_global_declaration_token1] = ACTIONS(1188),
    [aux_sym_namespace_definition_token1] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1188),
    [anon_sym_BSLASH] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [aux_sym_trait_declaration_token1] = ACTIONS(1188),
    [aux_sym_interface_declaration_token1] = ACTIONS(1188),
    [aux_sym_enum_declaration_token1] = ACTIONS(1188),
    [aux_sym_enum_case_token1] = ACTIONS(1188),
    [aux_sym_class_declaration_token1] = ACTIONS(1188),
    [aux_sym_final_modifier_token1] = ACTIONS(1188),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1188),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1188),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [aux_sym_cast_type_token1] = ACTIONS(1188),
    [aux_sym_echo_statement_token1] = ACTIONS(1188),
    [anon_sym_unset] = ACTIONS(1188),
    [aux_sym_declare_statement_token1] = ACTIONS(1188),
    [aux_sym_declare_statement_token2] = ACTIONS(1188),
    [sym_float] = ACTIONS(1188),
    [aux_sym_try_statement_token1] = ACTIONS(1188),
    [aux_sym_goto_statement_token1] = ACTIONS(1188),
    [aux_sym_continue_statement_token1] = ACTIONS(1188),
    [aux_sym_break_statement_token1] = ACTIONS(1188),
    [sym_integer] = ACTIONS(1188),
    [aux_sym_return_statement_token1] = ACTIONS(1188),
    [aux_sym_throw_expression_token1] = ACTIONS(1188),
    [aux_sym_while_statement_token1] = ACTIONS(1188),
    [aux_sym_while_statement_token2] = ACTIONS(1188),
    [aux_sym_do_statement_token1] = ACTIONS(1188),
    [aux_sym_for_statement_token1] = ACTIONS(1188),
    [aux_sym_for_statement_token2] = ACTIONS(1188),
    [aux_sym_foreach_statement_token1] = ACTIONS(1188),
    [aux_sym_foreach_statement_token2] = ACTIONS(1188),
    [aux_sym_if_statement_token1] = ACTIONS(1188),
    [aux_sym_if_statement_token2] = ACTIONS(1188),
    [aux_sym_else_if_clause_token1] = ACTIONS(1188),
    [aux_sym_else_clause_token1] = ACTIONS(1188),
    [aux_sym_match_expression_token1] = ACTIONS(1188),
    [aux_sym_match_default_expression_token1] = ACTIONS(1188),
    [aux_sym_switch_statement_token1] = ACTIONS(1188),
    [aux_sym_switch_block_token1] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_AT] = ACTIONS(1186),
    [aux_sym_clone_expression_token1] = ACTIONS(1188),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1188),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1188),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [aux_sym__list_destructing_token1] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_self] = ACTIONS(1188),
    [anon_sym_parent] = ACTIONS(1188),
    [aux_sym__argument_name_token1] = ACTIONS(1188),
    [aux_sym__argument_name_token2] = ACTIONS(1188),
    [anon_sym_POUND_LBRACK] = ACTIONS(1186),
    [aux_sym_encapsed_string_token1] = ACTIONS(1186),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [aux_sym_string_token1] = ACTIONS(1186),
    [anon_sym_SQUOTE] = ACTIONS(1186),
    [anon_sym_LT_LT_LT] = ACTIONS(1186),
    [anon_sym_BQUOTE] = ACTIONS(1186),
    [anon_sym_DOLLAR] = ACTIONS(1186),
    [aux_sym_yield_expression_token1] = ACTIONS(1188),
    [aux_sym_include_expression_token1] = ACTIONS(1188),
    [aux_sym_include_once_expression_token1] = ACTIONS(1188),
    [aux_sym_require_expression_token1] = ACTIONS(1188),
    [aux_sym_require_once_expression_token1] = ACTIONS(1188),
    [sym_comment] = ACTIONS(5),
  },
  [464] = {
    [sym_text_interpolation] = STATE(464),
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_name] = ACTIONS(1192),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1190),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1192),
    [aux_sym_global_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_definition_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1192),
    [anon_sym_BSLASH] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [aux_sym_trait_declaration_token1] = ACTIONS(1192),
    [aux_sym_interface_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_case_token1] = ACTIONS(1192),
    [aux_sym_class_declaration_token1] = ACTIONS(1192),
    [aux_sym_final_modifier_token1] = ACTIONS(1192),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1192),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1192),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [aux_sym_cast_type_token1] = ACTIONS(1192),
    [aux_sym_echo_statement_token1] = ACTIONS(1192),
    [anon_sym_unset] = ACTIONS(1192),
    [aux_sym_declare_statement_token1] = ACTIONS(1192),
    [aux_sym_declare_statement_token2] = ACTIONS(1192),
    [sym_float] = ACTIONS(1192),
    [aux_sym_try_statement_token1] = ACTIONS(1192),
    [aux_sym_goto_statement_token1] = ACTIONS(1192),
    [aux_sym_continue_statement_token1] = ACTIONS(1192),
    [aux_sym_break_statement_token1] = ACTIONS(1192),
    [sym_integer] = ACTIONS(1192),
    [aux_sym_return_statement_token1] = ACTIONS(1192),
    [aux_sym_throw_expression_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token2] = ACTIONS(1192),
    [aux_sym_do_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token2] = ACTIONS(1192),
    [aux_sym_foreach_statement_token1] = ACTIONS(1192),
    [aux_sym_foreach_statement_token2] = ACTIONS(1192),
    [aux_sym_if_statement_token1] = ACTIONS(1192),
    [aux_sym_if_statement_token2] = ACTIONS(1192),
    [aux_sym_else_if_clause_token1] = ACTIONS(1192),
    [aux_sym_else_clause_token1] = ACTIONS(1192),
    [aux_sym_match_expression_token1] = ACTIONS(1192),
    [aux_sym_match_default_expression_token1] = ACTIONS(1192),
    [aux_sym_switch_statement_token1] = ACTIONS(1192),
    [aux_sym_switch_block_token1] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1190),
    [aux_sym_clone_expression_token1] = ACTIONS(1192),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1192),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [aux_sym__list_destructing_token1] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_self] = ACTIONS(1192),
    [anon_sym_parent] = ACTIONS(1192),
    [aux_sym__argument_name_token1] = ACTIONS(1192),
    [aux_sym__argument_name_token2] = ACTIONS(1192),
    [anon_sym_POUND_LBRACK] = ACTIONS(1190),
    [aux_sym_encapsed_string_token1] = ACTIONS(1190),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [aux_sym_string_token1] = ACTIONS(1190),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_LT_LT_LT] = ACTIONS(1190),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [anon_sym_DOLLAR] = ACTIONS(1190),
    [aux_sym_yield_expression_token1] = ACTIONS(1192),
    [aux_sym_include_expression_token1] = ACTIONS(1192),
    [aux_sym_include_once_expression_token1] = ACTIONS(1192),
    [aux_sym_require_expression_token1] = ACTIONS(1192),
    [aux_sym_require_once_expression_token1] = ACTIONS(1192),
    [sym_comment] = ACTIONS(5),
  },
  [465] = {
    [sym_text_interpolation] = STATE(465),
    [ts_builtin_sym_end] = ACTIONS(1194),
    [sym_name] = ACTIONS(1196),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1194),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1196),
    [aux_sym_global_declaration_token1] = ACTIONS(1196),
    [aux_sym_namespace_definition_token1] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1194),
    [anon_sym_LBRACE] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [aux_sym_trait_declaration_token1] = ACTIONS(1196),
    [aux_sym_interface_declaration_token1] = ACTIONS(1196),
    [aux_sym_enum_declaration_token1] = ACTIONS(1196),
    [aux_sym_enum_case_token1] = ACTIONS(1196),
    [aux_sym_class_declaration_token1] = ACTIONS(1196),
    [aux_sym_final_modifier_token1] = ACTIONS(1196),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1196),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1196),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [aux_sym_cast_type_token1] = ACTIONS(1196),
    [aux_sym_echo_statement_token1] = ACTIONS(1196),
    [anon_sym_unset] = ACTIONS(1196),
    [aux_sym_declare_statement_token1] = ACTIONS(1196),
    [aux_sym_declare_statement_token2] = ACTIONS(1196),
    [sym_float] = ACTIONS(1196),
    [aux_sym_try_statement_token1] = ACTIONS(1196),
    [aux_sym_goto_statement_token1] = ACTIONS(1196),
    [aux_sym_continue_statement_token1] = ACTIONS(1196),
    [aux_sym_break_statement_token1] = ACTIONS(1196),
    [sym_integer] = ACTIONS(1196),
    [aux_sym_return_statement_token1] = ACTIONS(1196),
    [aux_sym_throw_expression_token1] = ACTIONS(1196),
    [aux_sym_while_statement_token1] = ACTIONS(1196),
    [aux_sym_while_statement_token2] = ACTIONS(1196),
    [aux_sym_do_statement_token1] = ACTIONS(1196),
    [aux_sym_for_statement_token1] = ACTIONS(1196),
    [aux_sym_for_statement_token2] = ACTIONS(1196),
    [aux_sym_foreach_statement_token1] = ACTIONS(1196),
    [aux_sym_foreach_statement_token2] = ACTIONS(1196),
    [aux_sym_if_statement_token1] = ACTIONS(1196),
    [aux_sym_if_statement_token2] = ACTIONS(1196),
    [aux_sym_else_if_clause_token1] = ACTIONS(1196),
    [aux_sym_else_clause_token1] = ACTIONS(1196),
    [aux_sym_match_expression_token1] = ACTIONS(1196),
    [aux_sym_match_default_expression_token1] = ACTIONS(1196),
    [aux_sym_switch_statement_token1] = ACTIONS(1196),
    [aux_sym_switch_block_token1] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1194),
    [anon_sym_BANG] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1194),
    [aux_sym_clone_expression_token1] = ACTIONS(1196),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1196),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1196),
    [anon_sym_DASH_DASH] = ACTIONS(1194),
    [anon_sym_PLUS_PLUS] = ACTIONS(1194),
    [aux_sym__list_destructing_token1] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_self] = ACTIONS(1196),
    [anon_sym_parent] = ACTIONS(1196),
    [aux_sym__argument_name_token1] = ACTIONS(1196),
    [aux_sym__argument_name_token2] = ACTIONS(1196),
    [anon_sym_POUND_LBRACK] = ACTIONS(1194),
    [aux_sym_encapsed_string_token1] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [aux_sym_string_token1] = ACTIONS(1194),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [anon_sym_LT_LT_LT] = ACTIONS(1194),
    [anon_sym_BQUOTE] = ACTIONS(1194),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [aux_sym_yield_expression_token1] = ACTIONS(1196),
    [aux_sym_include_expression_token1] = ACTIONS(1196),
    [aux_sym_include_once_expression_token1] = ACTIONS(1196),
    [aux_sym_require_expression_token1] = ACTIONS(1196),
    [aux_sym_require_once_expression_token1] = ACTIONS(1196),
    [sym_comment] = ACTIONS(5),
  },
  [466] = {
    [sym_text_interpolation] = STATE(466),
    [ts_builtin_sym_end] = ACTIONS(1198),
    [sym_name] = ACTIONS(1200),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1198),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1200),
    [aux_sym_global_declaration_token1] = ACTIONS(1200),
    [aux_sym_namespace_definition_token1] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1200),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [aux_sym_trait_declaration_token1] = ACTIONS(1200),
    [aux_sym_interface_declaration_token1] = ACTIONS(1200),
    [aux_sym_enum_declaration_token1] = ACTIONS(1200),
    [aux_sym_enum_case_token1] = ACTIONS(1200),
    [aux_sym_class_declaration_token1] = ACTIONS(1200),
    [aux_sym_final_modifier_token1] = ACTIONS(1200),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1200),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1200),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [aux_sym_cast_type_token1] = ACTIONS(1200),
    [aux_sym_echo_statement_token1] = ACTIONS(1200),
    [anon_sym_unset] = ACTIONS(1200),
    [aux_sym_declare_statement_token1] = ACTIONS(1200),
    [aux_sym_declare_statement_token2] = ACTIONS(1200),
    [sym_float] = ACTIONS(1200),
    [aux_sym_try_statement_token1] = ACTIONS(1200),
    [aux_sym_goto_statement_token1] = ACTIONS(1200),
    [aux_sym_continue_statement_token1] = ACTIONS(1200),
    [aux_sym_break_statement_token1] = ACTIONS(1200),
    [sym_integer] = ACTIONS(1200),
    [aux_sym_return_statement_token1] = ACTIONS(1200),
    [aux_sym_throw_expression_token1] = ACTIONS(1200),
    [aux_sym_while_statement_token1] = ACTIONS(1200),
    [aux_sym_while_statement_token2] = ACTIONS(1200),
    [aux_sym_do_statement_token1] = ACTIONS(1200),
    [aux_sym_for_statement_token1] = ACTIONS(1200),
    [aux_sym_for_statement_token2] = ACTIONS(1200),
    [aux_sym_foreach_statement_token1] = ACTIONS(1200),
    [aux_sym_foreach_statement_token2] = ACTIONS(1200),
    [aux_sym_if_statement_token1] = ACTIONS(1200),
    [aux_sym_if_statement_token2] = ACTIONS(1200),
    [aux_sym_else_if_clause_token1] = ACTIONS(1200),
    [aux_sym_else_clause_token1] = ACTIONS(1200),
    [aux_sym_match_expression_token1] = ACTIONS(1200),
    [aux_sym_match_default_expression_token1] = ACTIONS(1200),
    [aux_sym_switch_statement_token1] = ACTIONS(1200),
    [aux_sym_switch_block_token1] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_BANG] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1198),
    [aux_sym_clone_expression_token1] = ACTIONS(1200),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1200),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1200),
    [anon_sym_DASH_DASH] = ACTIONS(1198),
    [anon_sym_PLUS_PLUS] = ACTIONS(1198),
    [aux_sym__list_destructing_token1] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_self] = ACTIONS(1200),
    [anon_sym_parent] = ACTIONS(1200),
    [aux_sym__argument_name_token1] = ACTIONS(1200),
    [aux_sym__argument_name_token2] = ACTIONS(1200),
    [anon_sym_POUND_LBRACK] = ACTIONS(1198),
    [aux_sym_encapsed_string_token1] = ACTIONS(1198),
    [anon_sym_DQUOTE] = ACTIONS(1198),
    [aux_sym_string_token1] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1198),
    [anon_sym_LT_LT_LT] = ACTIONS(1198),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [anon_sym_DOLLAR] = ACTIONS(1198),
    [aux_sym_yield_expression_token1] = ACTIONS(1200),
    [aux_sym_include_expression_token1] = ACTIONS(1200),
    [aux_sym_include_once_expression_token1] = ACTIONS(1200),
    [aux_sym_require_expression_token1] = ACTIONS(1200),
    [aux_sym_require_once_expression_token1] = ACTIONS(1200),
    [sym_comment] = ACTIONS(5),
  },
  [467] = {
    [sym_text_interpolation] = STATE(467),
    [ts_builtin_sym_end] = ACTIONS(1202),
    [sym_name] = ACTIONS(1204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1202),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1204),
    [aux_sym_global_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_definition_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1204),
    [anon_sym_BSLASH] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [aux_sym_trait_declaration_token1] = ACTIONS(1204),
    [aux_sym_interface_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_case_token1] = ACTIONS(1204),
    [aux_sym_class_declaration_token1] = ACTIONS(1204),
    [aux_sym_final_modifier_token1] = ACTIONS(1204),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1204),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1204),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [aux_sym_cast_type_token1] = ACTIONS(1204),
    [aux_sym_echo_statement_token1] = ACTIONS(1204),
    [anon_sym_unset] = ACTIONS(1204),
    [aux_sym_declare_statement_token1] = ACTIONS(1204),
    [aux_sym_declare_statement_token2] = ACTIONS(1204),
    [sym_float] = ACTIONS(1204),
    [aux_sym_try_statement_token1] = ACTIONS(1204),
    [aux_sym_goto_statement_token1] = ACTIONS(1204),
    [aux_sym_continue_statement_token1] = ACTIONS(1204),
    [aux_sym_break_statement_token1] = ACTIONS(1204),
    [sym_integer] = ACTIONS(1204),
    [aux_sym_return_statement_token1] = ACTIONS(1204),
    [aux_sym_throw_expression_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token2] = ACTIONS(1204),
    [aux_sym_do_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token2] = ACTIONS(1204),
    [aux_sym_foreach_statement_token1] = ACTIONS(1204),
    [aux_sym_foreach_statement_token2] = ACTIONS(1204),
    [aux_sym_if_statement_token1] = ACTIONS(1204),
    [aux_sym_if_statement_token2] = ACTIONS(1204),
    [aux_sym_else_if_clause_token1] = ACTIONS(1204),
    [aux_sym_else_clause_token1] = ACTIONS(1204),
    [aux_sym_match_expression_token1] = ACTIONS(1204),
    [aux_sym_match_default_expression_token1] = ACTIONS(1204),
    [aux_sym_switch_statement_token1] = ACTIONS(1204),
    [aux_sym_switch_block_token1] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1202),
    [aux_sym_clone_expression_token1] = ACTIONS(1204),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1204),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1204),
    [anon_sym_DASH_DASH] = ACTIONS(1202),
    [anon_sym_PLUS_PLUS] = ACTIONS(1202),
    [aux_sym__list_destructing_token1] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1202),
    [anon_sym_self] = ACTIONS(1204),
    [anon_sym_parent] = ACTIONS(1204),
    [aux_sym__argument_name_token1] = ACTIONS(1204),
    [aux_sym__argument_name_token2] = ACTIONS(1204),
    [anon_sym_POUND_LBRACK] = ACTIONS(1202),
    [aux_sym_encapsed_string_token1] = ACTIONS(1202),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [aux_sym_string_token1] = ACTIONS(1202),
    [anon_sym_SQUOTE] = ACTIONS(1202),
    [anon_sym_LT_LT_LT] = ACTIONS(1202),
    [anon_sym_BQUOTE] = ACTIONS(1202),
    [anon_sym_DOLLAR] = ACTIONS(1202),
    [aux_sym_yield_expression_token1] = ACTIONS(1204),
    [aux_sym_include_expression_token1] = ACTIONS(1204),
    [aux_sym_include_once_expression_token1] = ACTIONS(1204),
    [aux_sym_require_expression_token1] = ACTIONS(1204),
    [aux_sym_require_once_expression_token1] = ACTIONS(1204),
    [sym_comment] = ACTIONS(5),
  },
  [468] = {
    [sym_text_interpolation] = STATE(468),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_name] = ACTIONS(1208),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1208),
    [aux_sym_global_declaration_token1] = ACTIONS(1208),
    [aux_sym_namespace_definition_token1] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1208),
    [anon_sym_BSLASH] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [aux_sym_trait_declaration_token1] = ACTIONS(1208),
    [aux_sym_interface_declaration_token1] = ACTIONS(1208),
    [aux_sym_enum_declaration_token1] = ACTIONS(1208),
    [aux_sym_enum_case_token1] = ACTIONS(1208),
    [aux_sym_class_declaration_token1] = ACTIONS(1208),
    [aux_sym_final_modifier_token1] = ACTIONS(1208),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1208),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1208),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [aux_sym_cast_type_token1] = ACTIONS(1208),
    [aux_sym_echo_statement_token1] = ACTIONS(1208),
    [anon_sym_unset] = ACTIONS(1208),
    [aux_sym_declare_statement_token1] = ACTIONS(1208),
    [aux_sym_declare_statement_token2] = ACTIONS(1208),
    [sym_float] = ACTIONS(1208),
    [aux_sym_try_statement_token1] = ACTIONS(1208),
    [aux_sym_goto_statement_token1] = ACTIONS(1208),
    [aux_sym_continue_statement_token1] = ACTIONS(1208),
    [aux_sym_break_statement_token1] = ACTIONS(1208),
    [sym_integer] = ACTIONS(1208),
    [aux_sym_return_statement_token1] = ACTIONS(1208),
    [aux_sym_throw_expression_token1] = ACTIONS(1208),
    [aux_sym_while_statement_token1] = ACTIONS(1208),
    [aux_sym_while_statement_token2] = ACTIONS(1208),
    [aux_sym_do_statement_token1] = ACTIONS(1208),
    [aux_sym_for_statement_token1] = ACTIONS(1208),
    [aux_sym_for_statement_token2] = ACTIONS(1208),
    [aux_sym_foreach_statement_token1] = ACTIONS(1208),
    [aux_sym_foreach_statement_token2] = ACTIONS(1208),
    [aux_sym_if_statement_token1] = ACTIONS(1208),
    [aux_sym_if_statement_token2] = ACTIONS(1208),
    [aux_sym_else_if_clause_token1] = ACTIONS(1208),
    [aux_sym_else_clause_token1] = ACTIONS(1208),
    [aux_sym_match_expression_token1] = ACTIONS(1208),
    [aux_sym_match_default_expression_token1] = ACTIONS(1208),
    [aux_sym_switch_statement_token1] = ACTIONS(1208),
    [aux_sym_switch_block_token1] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1206),
    [anon_sym_BANG] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1206),
    [aux_sym_clone_expression_token1] = ACTIONS(1208),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1208),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1208),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [aux_sym__list_destructing_token1] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_self] = ACTIONS(1208),
    [anon_sym_parent] = ACTIONS(1208),
    [aux_sym__argument_name_token1] = ACTIONS(1208),
    [aux_sym__argument_name_token2] = ACTIONS(1208),
    [anon_sym_POUND_LBRACK] = ACTIONS(1206),
    [aux_sym_encapsed_string_token1] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [aux_sym_string_token1] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1206),
    [anon_sym_LT_LT_LT] = ACTIONS(1206),
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [anon_sym_DOLLAR] = ACTIONS(1206),
    [aux_sym_yield_expression_token1] = ACTIONS(1208),
    [aux_sym_include_expression_token1] = ACTIONS(1208),
    [aux_sym_include_once_expression_token1] = ACTIONS(1208),
    [aux_sym_require_expression_token1] = ACTIONS(1208),
    [aux_sym_require_once_expression_token1] = ACTIONS(1208),
    [sym_comment] = ACTIONS(5),
  },
  [469] = {
    [sym_text_interpolation] = STATE(469),
    [ts_builtin_sym_end] = ACTIONS(1210),
    [sym_name] = ACTIONS(1212),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1210),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1212),
    [aux_sym_global_declaration_token1] = ACTIONS(1212),
    [aux_sym_namespace_definition_token1] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1212),
    [anon_sym_BSLASH] = ACTIONS(1210),
    [anon_sym_LBRACE] = ACTIONS(1210),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [aux_sym_trait_declaration_token1] = ACTIONS(1212),
    [aux_sym_interface_declaration_token1] = ACTIONS(1212),
    [aux_sym_enum_declaration_token1] = ACTIONS(1212),
    [aux_sym_enum_case_token1] = ACTIONS(1212),
    [aux_sym_class_declaration_token1] = ACTIONS(1212),
    [aux_sym_final_modifier_token1] = ACTIONS(1212),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1212),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1212),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1210),
    [aux_sym_cast_type_token1] = ACTIONS(1212),
    [aux_sym_echo_statement_token1] = ACTIONS(1212),
    [anon_sym_unset] = ACTIONS(1212),
    [aux_sym_declare_statement_token1] = ACTIONS(1212),
    [aux_sym_declare_statement_token2] = ACTIONS(1212),
    [sym_float] = ACTIONS(1212),
    [aux_sym_try_statement_token1] = ACTIONS(1212),
    [aux_sym_goto_statement_token1] = ACTIONS(1212),
    [aux_sym_continue_statement_token1] = ACTIONS(1212),
    [aux_sym_break_statement_token1] = ACTIONS(1212),
    [sym_integer] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1212),
    [aux_sym_throw_expression_token1] = ACTIONS(1212),
    [aux_sym_while_statement_token1] = ACTIONS(1212),
    [aux_sym_while_statement_token2] = ACTIONS(1212),
    [aux_sym_do_statement_token1] = ACTIONS(1212),
    [aux_sym_for_statement_token1] = ACTIONS(1212),
    [aux_sym_for_statement_token2] = ACTIONS(1212),
    [aux_sym_foreach_statement_token1] = ACTIONS(1212),
    [aux_sym_foreach_statement_token2] = ACTIONS(1212),
    [aux_sym_if_statement_token1] = ACTIONS(1212),
    [aux_sym_if_statement_token2] = ACTIONS(1212),
    [aux_sym_else_if_clause_token1] = ACTIONS(1212),
    [aux_sym_else_clause_token1] = ACTIONS(1212),
    [aux_sym_match_expression_token1] = ACTIONS(1212),
    [aux_sym_match_default_expression_token1] = ACTIONS(1212),
    [aux_sym_switch_statement_token1] = ACTIONS(1212),
    [aux_sym_switch_block_token1] = ACTIONS(1212),
    [anon_sym_PLUS] = ACTIONS(1212),
    [anon_sym_DASH] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1210),
    [anon_sym_AT] = ACTIONS(1210),
    [aux_sym_clone_expression_token1] = ACTIONS(1212),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1212),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1212),
    [anon_sym_DASH_DASH] = ACTIONS(1210),
    [anon_sym_PLUS_PLUS] = ACTIONS(1210),
    [aux_sym__list_destructing_token1] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1210),
    [anon_sym_self] = ACTIONS(1212),
    [anon_sym_parent] = ACTIONS(1212),
    [aux_sym__argument_name_token1] = ACTIONS(1212),
    [aux_sym__argument_name_token2] = ACTIONS(1212),
    [anon_sym_POUND_LBRACK] = ACTIONS(1210),
    [aux_sym_encapsed_string_token1] = ACTIONS(1210),
    [anon_sym_DQUOTE] = ACTIONS(1210),
    [aux_sym_string_token1] = ACTIONS(1210),
    [anon_sym_SQUOTE] = ACTIONS(1210),
    [anon_sym_LT_LT_LT] = ACTIONS(1210),
    [anon_sym_BQUOTE] = ACTIONS(1210),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [aux_sym_yield_expression_token1] = ACTIONS(1212),
    [aux_sym_include_expression_token1] = ACTIONS(1212),
    [aux_sym_include_once_expression_token1] = ACTIONS(1212),
    [aux_sym_require_expression_token1] = ACTIONS(1212),
    [aux_sym_require_once_expression_token1] = ACTIONS(1212),
    [sym_comment] = ACTIONS(5),
  },
  [470] = {
    [sym_text_interpolation] = STATE(470),
    [ts_builtin_sym_end] = ACTIONS(1202),
    [sym_name] = ACTIONS(1204),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1202),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1204),
    [aux_sym_global_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_definition_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1204),
    [anon_sym_BSLASH] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [aux_sym_trait_declaration_token1] = ACTIONS(1204),
    [aux_sym_interface_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_case_token1] = ACTIONS(1204),
    [aux_sym_class_declaration_token1] = ACTIONS(1204),
    [aux_sym_final_modifier_token1] = ACTIONS(1204),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1204),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1204),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [aux_sym_cast_type_token1] = ACTIONS(1204),
    [aux_sym_echo_statement_token1] = ACTIONS(1204),
    [anon_sym_unset] = ACTIONS(1204),
    [aux_sym_declare_statement_token1] = ACTIONS(1204),
    [aux_sym_declare_statement_token2] = ACTIONS(1204),
    [sym_float] = ACTIONS(1204),
    [aux_sym_try_statement_token1] = ACTIONS(1204),
    [aux_sym_goto_statement_token1] = ACTIONS(1204),
    [aux_sym_continue_statement_token1] = ACTIONS(1204),
    [aux_sym_break_statement_token1] = ACTIONS(1204),
    [sym_integer] = ACTIONS(1204),
    [aux_sym_return_statement_token1] = ACTIONS(1204),
    [aux_sym_throw_expression_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token2] = ACTIONS(1204),
    [aux_sym_do_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token2] = ACTIONS(1204),
    [aux_sym_foreach_statement_token1] = ACTIONS(1204),
    [aux_sym_foreach_statement_token2] = ACTIONS(1204),
    [aux_sym_if_statement_token1] = ACTIONS(1204),
    [aux_sym_if_statement_token2] = ACTIONS(1204),
    [aux_sym_else_if_clause_token1] = ACTIONS(1204),
    [aux_sym_else_clause_token1] = ACTIONS(1204),
    [aux_sym_match_expression_token1] = ACTIONS(1204),
    [aux_sym_match_default_expression_token1] = ACTIONS(1204),
    [aux_sym_switch_statement_token1] = ACTIONS(1204),
    [aux_sym_switch_block_token1] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1202),
    [aux_sym_clone_expression_token1] = ACTIONS(1204),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1204),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1204),
    [anon_sym_DASH_DASH] = ACTIONS(1202),
    [anon_sym_PLUS_PLUS] = ACTIONS(1202),
    [aux_sym__list_destructing_token1] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1202),
    [anon_sym_self] = ACTIONS(1204),
    [anon_sym_parent] = ACTIONS(1204),
    [aux_sym__argument_name_token1] = ACTIONS(1204),
    [aux_sym__argument_name_token2] = ACTIONS(1204),
    [anon_sym_POUND_LBRACK] = ACTIONS(1202),
    [aux_sym_encapsed_string_token1] = ACTIONS(1202),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [aux_sym_string_token1] = ACTIONS(1202),
    [anon_sym_SQUOTE] = ACTIONS(1202),
    [anon_sym_LT_LT_LT] = ACTIONS(1202),
    [anon_sym_BQUOTE] = ACTIONS(1202),
    [anon_sym_DOLLAR] = ACTIONS(1202),
    [aux_sym_yield_expression_token1] = ACTIONS(1204),
    [aux_sym_include_expression_token1] = ACTIONS(1204),
    [aux_sym_include_once_expression_token1] = ACTIONS(1204),
    [aux_sym_require_expression_token1] = ACTIONS(1204),
    [aux_sym_require_once_expression_token1] = ACTIONS(1204),
    [sym_comment] = ACTIONS(5),
  },
  [471] = {
    [sym_text_interpolation] = STATE(471),
    [ts_builtin_sym_end] = ACTIONS(1214),
    [sym_name] = ACTIONS(1216),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1214),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1216),
    [aux_sym_global_declaration_token1] = ACTIONS(1216),
    [aux_sym_namespace_definition_token1] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1216),
    [anon_sym_BSLASH] = ACTIONS(1214),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [aux_sym_trait_declaration_token1] = ACTIONS(1216),
    [aux_sym_interface_declaration_token1] = ACTIONS(1216),
    [aux_sym_enum_declaration_token1] = ACTIONS(1216),
    [aux_sym_enum_case_token1] = ACTIONS(1216),
    [aux_sym_class_declaration_token1] = ACTIONS(1216),
    [aux_sym_final_modifier_token1] = ACTIONS(1216),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1216),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1216),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [aux_sym_cast_type_token1] = ACTIONS(1216),
    [aux_sym_echo_statement_token1] = ACTIONS(1216),
    [anon_sym_unset] = ACTIONS(1216),
    [aux_sym_declare_statement_token1] = ACTIONS(1216),
    [aux_sym_declare_statement_token2] = ACTIONS(1216),
    [sym_float] = ACTIONS(1216),
    [aux_sym_try_statement_token1] = ACTIONS(1216),
    [aux_sym_goto_statement_token1] = ACTIONS(1216),
    [aux_sym_continue_statement_token1] = ACTIONS(1216),
    [aux_sym_break_statement_token1] = ACTIONS(1216),
    [sym_integer] = ACTIONS(1216),
    [aux_sym_return_statement_token1] = ACTIONS(1216),
    [aux_sym_throw_expression_token1] = ACTIONS(1216),
    [aux_sym_while_statement_token1] = ACTIONS(1216),
    [aux_sym_while_statement_token2] = ACTIONS(1216),
    [aux_sym_do_statement_token1] = ACTIONS(1216),
    [aux_sym_for_statement_token1] = ACTIONS(1216),
    [aux_sym_for_statement_token2] = ACTIONS(1216),
    [aux_sym_foreach_statement_token1] = ACTIONS(1216),
    [aux_sym_foreach_statement_token2] = ACTIONS(1216),
    [aux_sym_if_statement_token1] = ACTIONS(1216),
    [aux_sym_if_statement_token2] = ACTIONS(1216),
    [aux_sym_else_if_clause_token1] = ACTIONS(1216),
    [aux_sym_else_clause_token1] = ACTIONS(1216),
    [aux_sym_match_expression_token1] = ACTIONS(1216),
    [aux_sym_match_default_expression_token1] = ACTIONS(1216),
    [aux_sym_switch_statement_token1] = ACTIONS(1216),
    [aux_sym_switch_block_token1] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_BANG] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1214),
    [aux_sym_clone_expression_token1] = ACTIONS(1216),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1216),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1216),
    [anon_sym_DASH_DASH] = ACTIONS(1214),
    [anon_sym_PLUS_PLUS] = ACTIONS(1214),
    [aux_sym__list_destructing_token1] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_self] = ACTIONS(1216),
    [anon_sym_parent] = ACTIONS(1216),
    [aux_sym__argument_name_token1] = ACTIONS(1216),
    [aux_sym__argument_name_token2] = ACTIONS(1216),
    [anon_sym_POUND_LBRACK] = ACTIONS(1214),
    [aux_sym_encapsed_string_token1] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [aux_sym_string_token1] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1214),
    [anon_sym_LT_LT_LT] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1214),
    [anon_sym_DOLLAR] = ACTIONS(1214),
    [aux_sym_yield_expression_token1] = ACTIONS(1216),
    [aux_sym_include_expression_token1] = ACTIONS(1216),
    [aux_sym_include_once_expression_token1] = ACTIONS(1216),
    [aux_sym_require_expression_token1] = ACTIONS(1216),
    [aux_sym_require_once_expression_token1] = ACTIONS(1216),
    [sym_comment] = ACTIONS(5),
  },
  [472] = {
    [sym_text_interpolation] = STATE(472),
    [ts_builtin_sym_end] = ACTIONS(1218),
    [sym_name] = ACTIONS(1220),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1218),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1220),
    [aux_sym_global_declaration_token1] = ACTIONS(1220),
    [aux_sym_namespace_definition_token1] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1220),
    [anon_sym_BSLASH] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1218),
    [anon_sym_RBRACE] = ACTIONS(1218),
    [aux_sym_trait_declaration_token1] = ACTIONS(1220),
    [aux_sym_interface_declaration_token1] = ACTIONS(1220),
    [aux_sym_enum_declaration_token1] = ACTIONS(1220),
    [aux_sym_enum_case_token1] = ACTIONS(1220),
    [aux_sym_class_declaration_token1] = ACTIONS(1220),
    [aux_sym_final_modifier_token1] = ACTIONS(1220),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1220),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1218),
    [aux_sym_cast_type_token1] = ACTIONS(1220),
    [aux_sym_echo_statement_token1] = ACTIONS(1220),
    [anon_sym_unset] = ACTIONS(1220),
    [aux_sym_declare_statement_token1] = ACTIONS(1220),
    [aux_sym_declare_statement_token2] = ACTIONS(1220),
    [sym_float] = ACTIONS(1220),
    [aux_sym_try_statement_token1] = ACTIONS(1220),
    [aux_sym_goto_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1220),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [sym_integer] = ACTIONS(1220),
    [aux_sym_return_statement_token1] = ACTIONS(1220),
    [aux_sym_throw_expression_token1] = ACTIONS(1220),
    [aux_sym_while_statement_token1] = ACTIONS(1220),
    [aux_sym_while_statement_token2] = ACTIONS(1220),
    [aux_sym_do_statement_token1] = ACTIONS(1220),
    [aux_sym_for_statement_token1] = ACTIONS(1220),
    [aux_sym_for_statement_token2] = ACTIONS(1220),
    [aux_sym_foreach_statement_token1] = ACTIONS(1220),
    [aux_sym_foreach_statement_token2] = ACTIONS(1220),
    [aux_sym_if_statement_token1] = ACTIONS(1220),
    [aux_sym_if_statement_token2] = ACTIONS(1220),
    [aux_sym_else_if_clause_token1] = ACTIONS(1220),
    [aux_sym_else_clause_token1] = ACTIONS(1220),
    [aux_sym_match_expression_token1] = ACTIONS(1220),
    [aux_sym_match_default_expression_token1] = ACTIONS(1220),
    [aux_sym_switch_statement_token1] = ACTIONS(1220),
    [aux_sym_switch_block_token1] = ACTIONS(1220),
    [anon_sym_PLUS] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1218),
    [aux_sym_clone_expression_token1] = ACTIONS(1220),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1220),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1220),
    [anon_sym_DASH_DASH] = ACTIONS(1218),
    [anon_sym_PLUS_PLUS] = ACTIONS(1218),
    [aux_sym__list_destructing_token1] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_self] = ACTIONS(1220),
    [anon_sym_parent] = ACTIONS(1220),
    [aux_sym__argument_name_token1] = ACTIONS(1220),
    [aux_sym__argument_name_token2] = ACTIONS(1220),
    [anon_sym_POUND_LBRACK] = ACTIONS(1218),
    [aux_sym_encapsed_string_token1] = ACTIONS(1218),
    [anon_sym_DQUOTE] = ACTIONS(1218),
    [aux_sym_string_token1] = ACTIONS(1218),
    [anon_sym_SQUOTE] = ACTIONS(1218),
    [anon_sym_LT_LT_LT] = ACTIONS(1218),
    [anon_sym_BQUOTE] = ACTIONS(1218),
    [anon_sym_DOLLAR] = ACTIONS(1218),
    [aux_sym_yield_expression_token1] = ACTIONS(1220),
    [aux_sym_include_expression_token1] = ACTIONS(1220),
    [aux_sym_include_once_expression_token1] = ACTIONS(1220),
    [aux_sym_require_expression_token1] = ACTIONS(1220),
    [aux_sym_require_once_expression_token1] = ACTIONS(1220),
    [sym_comment] = ACTIONS(5),
  },
  [473] = {
    [sym_text_interpolation] = STATE(473),
    [ts_builtin_sym_end] = ACTIONS(1222),
    [sym_name] = ACTIONS(1224),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1222),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1224),
    [aux_sym_global_declaration_token1] = ACTIONS(1224),
    [aux_sym_namespace_definition_token1] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1224),
    [anon_sym_BSLASH] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [aux_sym_trait_declaration_token1] = ACTIONS(1224),
    [aux_sym_interface_declaration_token1] = ACTIONS(1224),
    [aux_sym_enum_declaration_token1] = ACTIONS(1224),
    [aux_sym_enum_case_token1] = ACTIONS(1224),
    [aux_sym_class_declaration_token1] = ACTIONS(1224),
    [aux_sym_final_modifier_token1] = ACTIONS(1224),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1224),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1224),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1224),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [aux_sym_cast_type_token1] = ACTIONS(1224),
    [aux_sym_echo_statement_token1] = ACTIONS(1224),
    [anon_sym_unset] = ACTIONS(1224),
    [aux_sym_declare_statement_token1] = ACTIONS(1224),
    [aux_sym_declare_statement_token2] = ACTIONS(1224),
    [sym_float] = ACTIONS(1224),
    [aux_sym_try_statement_token1] = ACTIONS(1224),
    [aux_sym_goto_statement_token1] = ACTIONS(1224),
    [aux_sym_continue_statement_token1] = ACTIONS(1224),
    [aux_sym_break_statement_token1] = ACTIONS(1224),
    [sym_integer] = ACTIONS(1224),
    [aux_sym_return_statement_token1] = ACTIONS(1224),
    [aux_sym_throw_expression_token1] = ACTIONS(1224),
    [aux_sym_while_statement_token1] = ACTIONS(1224),
    [aux_sym_while_statement_token2] = ACTIONS(1224),
    [aux_sym_do_statement_token1] = ACTIONS(1224),
    [aux_sym_for_statement_token1] = ACTIONS(1224),
    [aux_sym_for_statement_token2] = ACTIONS(1224),
    [aux_sym_foreach_statement_token1] = ACTIONS(1224),
    [aux_sym_foreach_statement_token2] = ACTIONS(1224),
    [aux_sym_if_statement_token1] = ACTIONS(1224),
    [aux_sym_if_statement_token2] = ACTIONS(1224),
    [aux_sym_else_if_clause_token1] = ACTIONS(1224),
    [aux_sym_else_clause_token1] = ACTIONS(1224),
    [aux_sym_match_expression_token1] = ACTIONS(1224),
    [aux_sym_match_default_expression_token1] = ACTIONS(1224),
    [aux_sym_switch_statement_token1] = ACTIONS(1224),
    [aux_sym_switch_block_token1] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1222),
    [aux_sym_clone_expression_token1] = ACTIONS(1224),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1224),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1224),
    [anon_sym_DASH_DASH] = ACTIONS(1222),
    [anon_sym_PLUS_PLUS] = ACTIONS(1222),
    [aux_sym__list_destructing_token1] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_self] = ACTIONS(1224),
    [anon_sym_parent] = ACTIONS(1224),
    [aux_sym__argument_name_token1] = ACTIONS(1224),
    [aux_sym__argument_name_token2] = ACTIONS(1224),
    [anon_sym_POUND_LBRACK] = ACTIONS(1222),
    [aux_sym_encapsed_string_token1] = ACTIONS(1222),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [aux_sym_string_token1] = ACTIONS(1222),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT_LT_LT] = ACTIONS(1222),
    [anon_sym_BQUOTE] = ACTIONS(1222),
    [anon_sym_DOLLAR] = ACTIONS(1222),
    [aux_sym_yield_expression_token1] = ACTIONS(1224),
    [aux_sym_include_expression_token1] = ACTIONS(1224),
    [aux_sym_include_once_expression_token1] = ACTIONS(1224),
    [aux_sym_require_expression_token1] = ACTIONS(1224),
    [aux_sym_require_once_expression_token1] = ACTIONS(1224),
    [sym_comment] = ACTIONS(5),
  },
  [474] = {
    [sym_text_interpolation] = STATE(474),
    [ts_builtin_sym_end] = ACTIONS(1226),
    [sym_name] = ACTIONS(1228),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1226),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1228),
    [aux_sym_global_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_definition_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1228),
    [anon_sym_BSLASH] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [aux_sym_trait_declaration_token1] = ACTIONS(1228),
    [aux_sym_interface_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_case_token1] = ACTIONS(1228),
    [aux_sym_class_declaration_token1] = ACTIONS(1228),
    [aux_sym_final_modifier_token1] = ACTIONS(1228),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1228),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1228),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [aux_sym_cast_type_token1] = ACTIONS(1228),
    [aux_sym_echo_statement_token1] = ACTIONS(1228),
    [anon_sym_unset] = ACTIONS(1228),
    [aux_sym_declare_statement_token1] = ACTIONS(1228),
    [aux_sym_declare_statement_token2] = ACTIONS(1228),
    [sym_float] = ACTIONS(1228),
    [aux_sym_try_statement_token1] = ACTIONS(1228),
    [aux_sym_goto_statement_token1] = ACTIONS(1228),
    [aux_sym_continue_statement_token1] = ACTIONS(1228),
    [aux_sym_break_statement_token1] = ACTIONS(1228),
    [sym_integer] = ACTIONS(1228),
    [aux_sym_return_statement_token1] = ACTIONS(1228),
    [aux_sym_throw_expression_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token2] = ACTIONS(1228),
    [aux_sym_do_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token2] = ACTIONS(1228),
    [aux_sym_foreach_statement_token1] = ACTIONS(1228),
    [aux_sym_foreach_statement_token2] = ACTIONS(1228),
    [aux_sym_if_statement_token1] = ACTIONS(1228),
    [aux_sym_if_statement_token2] = ACTIONS(1228),
    [aux_sym_else_if_clause_token1] = ACTIONS(1228),
    [aux_sym_else_clause_token1] = ACTIONS(1228),
    [aux_sym_match_expression_token1] = ACTIONS(1228),
    [aux_sym_match_default_expression_token1] = ACTIONS(1228),
    [aux_sym_switch_statement_token1] = ACTIONS(1228),
    [aux_sym_switch_block_token1] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1226),
    [anon_sym_BANG] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1226),
    [aux_sym_clone_expression_token1] = ACTIONS(1228),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1228),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1228),
    [anon_sym_DASH_DASH] = ACTIONS(1226),
    [anon_sym_PLUS_PLUS] = ACTIONS(1226),
    [aux_sym__list_destructing_token1] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_self] = ACTIONS(1228),
    [anon_sym_parent] = ACTIONS(1228),
    [aux_sym__argument_name_token1] = ACTIONS(1228),
    [aux_sym__argument_name_token2] = ACTIONS(1228),
    [anon_sym_POUND_LBRACK] = ACTIONS(1226),
    [aux_sym_encapsed_string_token1] = ACTIONS(1226),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [aux_sym_string_token1] = ACTIONS(1226),
    [anon_sym_SQUOTE] = ACTIONS(1226),
    [anon_sym_LT_LT_LT] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(1226),
    [aux_sym_yield_expression_token1] = ACTIONS(1228),
    [aux_sym_include_expression_token1] = ACTIONS(1228),
    [aux_sym_include_once_expression_token1] = ACTIONS(1228),
    [aux_sym_require_expression_token1] = ACTIONS(1228),
    [aux_sym_require_once_expression_token1] = ACTIONS(1228),
    [sym_comment] = ACTIONS(5),
  },
  [475] = {
    [sym_text_interpolation] = STATE(475),
    [ts_builtin_sym_end] = ACTIONS(1230),
    [sym_name] = ACTIONS(1232),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1230),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1232),
    [aux_sym_global_declaration_token1] = ACTIONS(1232),
    [aux_sym_namespace_definition_token1] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1232),
    [anon_sym_BSLASH] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [aux_sym_trait_declaration_token1] = ACTIONS(1232),
    [aux_sym_interface_declaration_token1] = ACTIONS(1232),
    [aux_sym_enum_declaration_token1] = ACTIONS(1232),
    [aux_sym_enum_case_token1] = ACTIONS(1232),
    [aux_sym_class_declaration_token1] = ACTIONS(1232),
    [aux_sym_final_modifier_token1] = ACTIONS(1232),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1232),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1232),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [aux_sym_cast_type_token1] = ACTIONS(1232),
    [aux_sym_echo_statement_token1] = ACTIONS(1232),
    [anon_sym_unset] = ACTIONS(1232),
    [aux_sym_declare_statement_token1] = ACTIONS(1232),
    [aux_sym_declare_statement_token2] = ACTIONS(1232),
    [sym_float] = ACTIONS(1232),
    [aux_sym_try_statement_token1] = ACTIONS(1232),
    [aux_sym_goto_statement_token1] = ACTIONS(1232),
    [aux_sym_continue_statement_token1] = ACTIONS(1232),
    [aux_sym_break_statement_token1] = ACTIONS(1232),
    [sym_integer] = ACTIONS(1232),
    [aux_sym_return_statement_token1] = ACTIONS(1232),
    [aux_sym_throw_expression_token1] = ACTIONS(1232),
    [aux_sym_while_statement_token1] = ACTIONS(1232),
    [aux_sym_while_statement_token2] = ACTIONS(1232),
    [aux_sym_do_statement_token1] = ACTIONS(1232),
    [aux_sym_for_statement_token1] = ACTIONS(1232),
    [aux_sym_for_statement_token2] = ACTIONS(1232),
    [aux_sym_foreach_statement_token1] = ACTIONS(1232),
    [aux_sym_foreach_statement_token2] = ACTIONS(1232),
    [aux_sym_if_statement_token1] = ACTIONS(1232),
    [aux_sym_if_statement_token2] = ACTIONS(1232),
    [aux_sym_else_if_clause_token1] = ACTIONS(1232),
    [aux_sym_else_clause_token1] = ACTIONS(1232),
    [aux_sym_match_expression_token1] = ACTIONS(1232),
    [aux_sym_match_default_expression_token1] = ACTIONS(1232),
    [aux_sym_switch_statement_token1] = ACTIONS(1232),
    [aux_sym_switch_block_token1] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [aux_sym_clone_expression_token1] = ACTIONS(1232),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1232),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1232),
    [anon_sym_DASH_DASH] = ACTIONS(1230),
    [anon_sym_PLUS_PLUS] = ACTIONS(1230),
    [aux_sym__list_destructing_token1] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1230),
    [anon_sym_self] = ACTIONS(1232),
    [anon_sym_parent] = ACTIONS(1232),
    [aux_sym__argument_name_token1] = ACTIONS(1232),
    [aux_sym__argument_name_token2] = ACTIONS(1232),
    [anon_sym_POUND_LBRACK] = ACTIONS(1230),
    [aux_sym_encapsed_string_token1] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [aux_sym_string_token1] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [anon_sym_LT_LT_LT] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_DOLLAR] = ACTIONS(1230),
    [aux_sym_yield_expression_token1] = ACTIONS(1232),
    [aux_sym_include_expression_token1] = ACTIONS(1232),
    [aux_sym_include_once_expression_token1] = ACTIONS(1232),
    [aux_sym_require_expression_token1] = ACTIONS(1232),
    [aux_sym_require_once_expression_token1] = ACTIONS(1232),
    [sym_comment] = ACTIONS(5),
  },
  [476] = {
    [sym_text_interpolation] = STATE(476),
    [ts_builtin_sym_end] = ACTIONS(1234),
    [sym_name] = ACTIONS(1236),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1234),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1236),
    [aux_sym_global_declaration_token1] = ACTIONS(1236),
    [aux_sym_namespace_definition_token1] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1236),
    [anon_sym_BSLASH] = ACTIONS(1234),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_RBRACE] = ACTIONS(1234),
    [aux_sym_trait_declaration_token1] = ACTIONS(1236),
    [aux_sym_interface_declaration_token1] = ACTIONS(1236),
    [aux_sym_enum_declaration_token1] = ACTIONS(1236),
    [aux_sym_enum_case_token1] = ACTIONS(1236),
    [aux_sym_class_declaration_token1] = ACTIONS(1236),
    [aux_sym_final_modifier_token1] = ACTIONS(1236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1236),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1236),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [aux_sym_cast_type_token1] = ACTIONS(1236),
    [aux_sym_echo_statement_token1] = ACTIONS(1236),
    [anon_sym_unset] = ACTIONS(1236),
    [aux_sym_declare_statement_token1] = ACTIONS(1236),
    [aux_sym_declare_statement_token2] = ACTIONS(1236),
    [sym_float] = ACTIONS(1236),
    [aux_sym_try_statement_token1] = ACTIONS(1236),
    [aux_sym_goto_statement_token1] = ACTIONS(1236),
    [aux_sym_continue_statement_token1] = ACTIONS(1236),
    [aux_sym_break_statement_token1] = ACTIONS(1236),
    [sym_integer] = ACTIONS(1236),
    [aux_sym_return_statement_token1] = ACTIONS(1236),
    [aux_sym_throw_expression_token1] = ACTIONS(1236),
    [aux_sym_while_statement_token1] = ACTIONS(1236),
    [aux_sym_while_statement_token2] = ACTIONS(1236),
    [aux_sym_do_statement_token1] = ACTIONS(1236),
    [aux_sym_for_statement_token1] = ACTIONS(1236),
    [aux_sym_for_statement_token2] = ACTIONS(1236),
    [aux_sym_foreach_statement_token1] = ACTIONS(1236),
    [aux_sym_foreach_statement_token2] = ACTIONS(1236),
    [aux_sym_if_statement_token1] = ACTIONS(1236),
    [aux_sym_if_statement_token2] = ACTIONS(1236),
    [aux_sym_else_if_clause_token1] = ACTIONS(1236),
    [aux_sym_else_clause_token1] = ACTIONS(1236),
    [aux_sym_match_expression_token1] = ACTIONS(1236),
    [aux_sym_match_default_expression_token1] = ACTIONS(1236),
    [aux_sym_switch_statement_token1] = ACTIONS(1236),
    [aux_sym_switch_block_token1] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_TILDE] = ACTIONS(1234),
    [anon_sym_BANG] = ACTIONS(1234),
    [anon_sym_AT] = ACTIONS(1234),
    [aux_sym_clone_expression_token1] = ACTIONS(1236),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1236),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1236),
    [anon_sym_DASH_DASH] = ACTIONS(1234),
    [anon_sym_PLUS_PLUS] = ACTIONS(1234),
    [aux_sym__list_destructing_token1] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1234),
    [anon_sym_self] = ACTIONS(1236),
    [anon_sym_parent] = ACTIONS(1236),
    [aux_sym__argument_name_token1] = ACTIONS(1236),
    [aux_sym__argument_name_token2] = ACTIONS(1236),
    [anon_sym_POUND_LBRACK] = ACTIONS(1234),
    [aux_sym_encapsed_string_token1] = ACTIONS(1234),
    [anon_sym_DQUOTE] = ACTIONS(1234),
    [aux_sym_string_token1] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_LT_LT_LT] = ACTIONS(1234),
    [anon_sym_BQUOTE] = ACTIONS(1234),
    [anon_sym_DOLLAR] = ACTIONS(1234),
    [aux_sym_yield_expression_token1] = ACTIONS(1236),
    [aux_sym_include_expression_token1] = ACTIONS(1236),
    [aux_sym_include_once_expression_token1] = ACTIONS(1236),
    [aux_sym_require_expression_token1] = ACTIONS(1236),
    [aux_sym_require_once_expression_token1] = ACTIONS(1236),
    [sym_comment] = ACTIONS(5),
  },
  [477] = {
    [sym_text_interpolation] = STATE(477),
    [ts_builtin_sym_end] = ACTIONS(1238),
    [sym_name] = ACTIONS(1240),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1238),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1240),
    [aux_sym_global_declaration_token1] = ACTIONS(1240),
    [aux_sym_namespace_definition_token1] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1240),
    [anon_sym_BSLASH] = ACTIONS(1238),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [aux_sym_trait_declaration_token1] = ACTIONS(1240),
    [aux_sym_interface_declaration_token1] = ACTIONS(1240),
    [aux_sym_enum_declaration_token1] = ACTIONS(1240),
    [aux_sym_enum_case_token1] = ACTIONS(1240),
    [aux_sym_class_declaration_token1] = ACTIONS(1240),
    [aux_sym_final_modifier_token1] = ACTIONS(1240),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1240),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1240),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [aux_sym_cast_type_token1] = ACTIONS(1240),
    [aux_sym_echo_statement_token1] = ACTIONS(1240),
    [anon_sym_unset] = ACTIONS(1240),
    [aux_sym_declare_statement_token1] = ACTIONS(1240),
    [aux_sym_declare_statement_token2] = ACTIONS(1240),
    [sym_float] = ACTIONS(1240),
    [aux_sym_try_statement_token1] = ACTIONS(1240),
    [aux_sym_goto_statement_token1] = ACTIONS(1240),
    [aux_sym_continue_statement_token1] = ACTIONS(1240),
    [aux_sym_break_statement_token1] = ACTIONS(1240),
    [sym_integer] = ACTIONS(1240),
    [aux_sym_return_statement_token1] = ACTIONS(1240),
    [aux_sym_throw_expression_token1] = ACTIONS(1240),
    [aux_sym_while_statement_token1] = ACTIONS(1240),
    [aux_sym_while_statement_token2] = ACTIONS(1240),
    [aux_sym_do_statement_token1] = ACTIONS(1240),
    [aux_sym_for_statement_token1] = ACTIONS(1240),
    [aux_sym_for_statement_token2] = ACTIONS(1240),
    [aux_sym_foreach_statement_token1] = ACTIONS(1240),
    [aux_sym_foreach_statement_token2] = ACTIONS(1240),
    [aux_sym_if_statement_token1] = ACTIONS(1240),
    [aux_sym_if_statement_token2] = ACTIONS(1240),
    [aux_sym_else_if_clause_token1] = ACTIONS(1240),
    [aux_sym_else_clause_token1] = ACTIONS(1240),
    [aux_sym_match_expression_token1] = ACTIONS(1240),
    [aux_sym_match_default_expression_token1] = ACTIONS(1240),
    [aux_sym_switch_statement_token1] = ACTIONS(1240),
    [aux_sym_switch_block_token1] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_AT] = ACTIONS(1238),
    [aux_sym_clone_expression_token1] = ACTIONS(1240),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1240),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1240),
    [anon_sym_DASH_DASH] = ACTIONS(1238),
    [anon_sym_PLUS_PLUS] = ACTIONS(1238),
    [aux_sym__list_destructing_token1] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_self] = ACTIONS(1240),
    [anon_sym_parent] = ACTIONS(1240),
    [aux_sym__argument_name_token1] = ACTIONS(1240),
    [aux_sym__argument_name_token2] = ACTIONS(1240),
    [anon_sym_POUND_LBRACK] = ACTIONS(1238),
    [aux_sym_encapsed_string_token1] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [aux_sym_string_token1] = ACTIONS(1238),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT_LT_LT] = ACTIONS(1238),
    [anon_sym_BQUOTE] = ACTIONS(1238),
    [anon_sym_DOLLAR] = ACTIONS(1238),
    [aux_sym_yield_expression_token1] = ACTIONS(1240),
    [aux_sym_include_expression_token1] = ACTIONS(1240),
    [aux_sym_include_once_expression_token1] = ACTIONS(1240),
    [aux_sym_require_expression_token1] = ACTIONS(1240),
    [aux_sym_require_once_expression_token1] = ACTIONS(1240),
    [sym_comment] = ACTIONS(5),
  },
  [478] = {
    [sym_text_interpolation] = STATE(478),
    [ts_builtin_sym_end] = ACTIONS(1242),
    [sym_name] = ACTIONS(1244),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1242),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1244),
    [aux_sym_global_declaration_token1] = ACTIONS(1244),
    [aux_sym_namespace_definition_token1] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1244),
    [anon_sym_BSLASH] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [aux_sym_trait_declaration_token1] = ACTIONS(1244),
    [aux_sym_interface_declaration_token1] = ACTIONS(1244),
    [aux_sym_enum_declaration_token1] = ACTIONS(1244),
    [aux_sym_enum_case_token1] = ACTIONS(1244),
    [aux_sym_class_declaration_token1] = ACTIONS(1244),
    [aux_sym_final_modifier_token1] = ACTIONS(1244),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1244),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1244),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [aux_sym_cast_type_token1] = ACTIONS(1244),
    [aux_sym_echo_statement_token1] = ACTIONS(1244),
    [anon_sym_unset] = ACTIONS(1244),
    [aux_sym_declare_statement_token1] = ACTIONS(1244),
    [aux_sym_declare_statement_token2] = ACTIONS(1244),
    [sym_float] = ACTIONS(1244),
    [aux_sym_try_statement_token1] = ACTIONS(1244),
    [aux_sym_goto_statement_token1] = ACTIONS(1244),
    [aux_sym_continue_statement_token1] = ACTIONS(1244),
    [aux_sym_break_statement_token1] = ACTIONS(1244),
    [sym_integer] = ACTIONS(1244),
    [aux_sym_return_statement_token1] = ACTIONS(1244),
    [aux_sym_throw_expression_token1] = ACTIONS(1244),
    [aux_sym_while_statement_token1] = ACTIONS(1244),
    [aux_sym_while_statement_token2] = ACTIONS(1244),
    [aux_sym_do_statement_token1] = ACTIONS(1244),
    [aux_sym_for_statement_token1] = ACTIONS(1244),
    [aux_sym_for_statement_token2] = ACTIONS(1244),
    [aux_sym_foreach_statement_token1] = ACTIONS(1244),
    [aux_sym_foreach_statement_token2] = ACTIONS(1244),
    [aux_sym_if_statement_token1] = ACTIONS(1244),
    [aux_sym_if_statement_token2] = ACTIONS(1244),
    [aux_sym_else_if_clause_token1] = ACTIONS(1244),
    [aux_sym_else_clause_token1] = ACTIONS(1244),
    [aux_sym_match_expression_token1] = ACTIONS(1244),
    [aux_sym_match_default_expression_token1] = ACTIONS(1244),
    [aux_sym_switch_statement_token1] = ACTIONS(1244),
    [aux_sym_switch_block_token1] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1242),
    [aux_sym_clone_expression_token1] = ACTIONS(1244),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1244),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1244),
    [anon_sym_DASH_DASH] = ACTIONS(1242),
    [anon_sym_PLUS_PLUS] = ACTIONS(1242),
    [aux_sym__list_destructing_token1] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_self] = ACTIONS(1244),
    [anon_sym_parent] = ACTIONS(1244),
    [aux_sym__argument_name_token1] = ACTIONS(1244),
    [aux_sym__argument_name_token2] = ACTIONS(1244),
    [anon_sym_POUND_LBRACK] = ACTIONS(1242),
    [aux_sym_encapsed_string_token1] = ACTIONS(1242),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [aux_sym_string_token1] = ACTIONS(1242),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_LT_LT_LT] = ACTIONS(1242),
    [anon_sym_BQUOTE] = ACTIONS(1242),
    [anon_sym_DOLLAR] = ACTIONS(1242),
    [aux_sym_yield_expression_token1] = ACTIONS(1244),
    [aux_sym_include_expression_token1] = ACTIONS(1244),
    [aux_sym_include_once_expression_token1] = ACTIONS(1244),
    [aux_sym_require_expression_token1] = ACTIONS(1244),
    [aux_sym_require_once_expression_token1] = ACTIONS(1244),
    [sym_comment] = ACTIONS(5),
  },
  [479] = {
    [sym_text_interpolation] = STATE(479),
    [ts_builtin_sym_end] = ACTIONS(1246),
    [sym_name] = ACTIONS(1248),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1246),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1248),
    [aux_sym_global_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_definition_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1248),
    [anon_sym_BSLASH] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [aux_sym_trait_declaration_token1] = ACTIONS(1248),
    [aux_sym_interface_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_case_token1] = ACTIONS(1248),
    [aux_sym_class_declaration_token1] = ACTIONS(1248),
    [aux_sym_final_modifier_token1] = ACTIONS(1248),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1248),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1248),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [aux_sym_cast_type_token1] = ACTIONS(1248),
    [aux_sym_echo_statement_token1] = ACTIONS(1248),
    [anon_sym_unset] = ACTIONS(1248),
    [aux_sym_declare_statement_token1] = ACTIONS(1248),
    [aux_sym_declare_statement_token2] = ACTIONS(1248),
    [sym_float] = ACTIONS(1248),
    [aux_sym_try_statement_token1] = ACTIONS(1248),
    [aux_sym_goto_statement_token1] = ACTIONS(1248),
    [aux_sym_continue_statement_token1] = ACTIONS(1248),
    [aux_sym_break_statement_token1] = ACTIONS(1248),
    [sym_integer] = ACTIONS(1248),
    [aux_sym_return_statement_token1] = ACTIONS(1248),
    [aux_sym_throw_expression_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token2] = ACTIONS(1248),
    [aux_sym_do_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token2] = ACTIONS(1248),
    [aux_sym_foreach_statement_token1] = ACTIONS(1248),
    [aux_sym_foreach_statement_token2] = ACTIONS(1248),
    [aux_sym_if_statement_token1] = ACTIONS(1248),
    [aux_sym_if_statement_token2] = ACTIONS(1248),
    [aux_sym_else_if_clause_token1] = ACTIONS(1248),
    [aux_sym_else_clause_token1] = ACTIONS(1248),
    [aux_sym_match_expression_token1] = ACTIONS(1248),
    [aux_sym_match_default_expression_token1] = ACTIONS(1248),
    [aux_sym_switch_statement_token1] = ACTIONS(1248),
    [aux_sym_switch_block_token1] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1246),
    [aux_sym_clone_expression_token1] = ACTIONS(1248),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1248),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [aux_sym__list_destructing_token1] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_self] = ACTIONS(1248),
    [anon_sym_parent] = ACTIONS(1248),
    [aux_sym__argument_name_token1] = ACTIONS(1248),
    [aux_sym__argument_name_token2] = ACTIONS(1248),
    [anon_sym_POUND_LBRACK] = ACTIONS(1246),
    [aux_sym_encapsed_string_token1] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [aux_sym_string_token1] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_LT_LT_LT] = ACTIONS(1246),
    [anon_sym_BQUOTE] = ACTIONS(1246),
    [anon_sym_DOLLAR] = ACTIONS(1246),
    [aux_sym_yield_expression_token1] = ACTIONS(1248),
    [aux_sym_include_expression_token1] = ACTIONS(1248),
    [aux_sym_include_once_expression_token1] = ACTIONS(1248),
    [aux_sym_require_expression_token1] = ACTIONS(1248),
    [aux_sym_require_once_expression_token1] = ACTIONS(1248),
    [sym_comment] = ACTIONS(5),
  },
  [480] = {
    [sym_text_interpolation] = STATE(480),
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_name] = ACTIONS(1252),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1250),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1252),
    [aux_sym_global_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_definition_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [aux_sym_trait_declaration_token1] = ACTIONS(1252),
    [aux_sym_interface_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_case_token1] = ACTIONS(1252),
    [aux_sym_class_declaration_token1] = ACTIONS(1252),
    [aux_sym_final_modifier_token1] = ACTIONS(1252),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1252),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1252),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [aux_sym_cast_type_token1] = ACTIONS(1252),
    [aux_sym_echo_statement_token1] = ACTIONS(1252),
    [anon_sym_unset] = ACTIONS(1252),
    [aux_sym_declare_statement_token1] = ACTIONS(1252),
    [aux_sym_declare_statement_token2] = ACTIONS(1252),
    [sym_float] = ACTIONS(1252),
    [aux_sym_try_statement_token1] = ACTIONS(1252),
    [aux_sym_goto_statement_token1] = ACTIONS(1252),
    [aux_sym_continue_statement_token1] = ACTIONS(1252),
    [aux_sym_break_statement_token1] = ACTIONS(1252),
    [sym_integer] = ACTIONS(1252),
    [aux_sym_return_statement_token1] = ACTIONS(1252),
    [aux_sym_throw_expression_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token2] = ACTIONS(1252),
    [aux_sym_do_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token2] = ACTIONS(1252),
    [aux_sym_foreach_statement_token1] = ACTIONS(1252),
    [aux_sym_foreach_statement_token2] = ACTIONS(1252),
    [aux_sym_if_statement_token1] = ACTIONS(1252),
    [aux_sym_if_statement_token2] = ACTIONS(1252),
    [aux_sym_else_if_clause_token1] = ACTIONS(1252),
    [aux_sym_else_clause_token1] = ACTIONS(1252),
    [aux_sym_match_expression_token1] = ACTIONS(1252),
    [aux_sym_match_default_expression_token1] = ACTIONS(1252),
    [aux_sym_switch_statement_token1] = ACTIONS(1252),
    [aux_sym_switch_block_token1] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [aux_sym_clone_expression_token1] = ACTIONS(1252),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1252),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1252),
    [anon_sym_DASH_DASH] = ACTIONS(1250),
    [anon_sym_PLUS_PLUS] = ACTIONS(1250),
    [aux_sym__list_destructing_token1] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_self] = ACTIONS(1252),
    [anon_sym_parent] = ACTIONS(1252),
    [aux_sym__argument_name_token1] = ACTIONS(1252),
    [aux_sym__argument_name_token2] = ACTIONS(1252),
    [anon_sym_POUND_LBRACK] = ACTIONS(1250),
    [aux_sym_encapsed_string_token1] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [aux_sym_string_token1] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_LT_LT_LT] = ACTIONS(1250),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1250),
    [aux_sym_yield_expression_token1] = ACTIONS(1252),
    [aux_sym_include_expression_token1] = ACTIONS(1252),
    [aux_sym_include_once_expression_token1] = ACTIONS(1252),
    [aux_sym_require_expression_token1] = ACTIONS(1252),
    [aux_sym_require_once_expression_token1] = ACTIONS(1252),
    [sym_comment] = ACTIONS(5),
  },
  [481] = {
    [sym_text_interpolation] = STATE(481),
    [ts_builtin_sym_end] = ACTIONS(1254),
    [sym_name] = ACTIONS(1256),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1254),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1256),
    [aux_sym_global_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_definition_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1256),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_RBRACE] = ACTIONS(1254),
    [aux_sym_trait_declaration_token1] = ACTIONS(1256),
    [aux_sym_interface_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_case_token1] = ACTIONS(1256),
    [aux_sym_class_declaration_token1] = ACTIONS(1256),
    [aux_sym_final_modifier_token1] = ACTIONS(1256),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1256),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1256),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [aux_sym_cast_type_token1] = ACTIONS(1256),
    [aux_sym_echo_statement_token1] = ACTIONS(1256),
    [anon_sym_unset] = ACTIONS(1256),
    [aux_sym_declare_statement_token1] = ACTIONS(1256),
    [aux_sym_declare_statement_token2] = ACTIONS(1256),
    [sym_float] = ACTIONS(1256),
    [aux_sym_try_statement_token1] = ACTIONS(1256),
    [aux_sym_goto_statement_token1] = ACTIONS(1256),
    [aux_sym_continue_statement_token1] = ACTIONS(1256),
    [aux_sym_break_statement_token1] = ACTIONS(1256),
    [sym_integer] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1256),
    [aux_sym_throw_expression_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token2] = ACTIONS(1256),
    [aux_sym_do_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token2] = ACTIONS(1256),
    [aux_sym_foreach_statement_token1] = ACTIONS(1256),
    [aux_sym_foreach_statement_token2] = ACTIONS(1256),
    [aux_sym_if_statement_token1] = ACTIONS(1256),
    [aux_sym_if_statement_token2] = ACTIONS(1256),
    [aux_sym_else_if_clause_token1] = ACTIONS(1256),
    [aux_sym_else_clause_token1] = ACTIONS(1256),
    [aux_sym_match_expression_token1] = ACTIONS(1256),
    [aux_sym_match_default_expression_token1] = ACTIONS(1256),
    [aux_sym_switch_statement_token1] = ACTIONS(1256),
    [aux_sym_switch_block_token1] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1254),
    [aux_sym_clone_expression_token1] = ACTIONS(1256),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1256),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1256),
    [anon_sym_DASH_DASH] = ACTIONS(1254),
    [anon_sym_PLUS_PLUS] = ACTIONS(1254),
    [aux_sym__list_destructing_token1] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1254),
    [anon_sym_self] = ACTIONS(1256),
    [anon_sym_parent] = ACTIONS(1256),
    [aux_sym__argument_name_token1] = ACTIONS(1256),
    [aux_sym__argument_name_token2] = ACTIONS(1256),
    [anon_sym_POUND_LBRACK] = ACTIONS(1254),
    [aux_sym_encapsed_string_token1] = ACTIONS(1254),
    [anon_sym_DQUOTE] = ACTIONS(1254),
    [aux_sym_string_token1] = ACTIONS(1254),
    [anon_sym_SQUOTE] = ACTIONS(1254),
    [anon_sym_LT_LT_LT] = ACTIONS(1254),
    [anon_sym_BQUOTE] = ACTIONS(1254),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [aux_sym_yield_expression_token1] = ACTIONS(1256),
    [aux_sym_include_expression_token1] = ACTIONS(1256),
    [aux_sym_include_once_expression_token1] = ACTIONS(1256),
    [aux_sym_require_expression_token1] = ACTIONS(1256),
    [aux_sym_require_once_expression_token1] = ACTIONS(1256),
    [sym_comment] = ACTIONS(5),
  },
  [482] = {
    [sym_text_interpolation] = STATE(482),
    [ts_builtin_sym_end] = ACTIONS(1254),
    [sym_name] = ACTIONS(1256),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1254),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1256),
    [aux_sym_global_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_definition_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1256),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_RBRACE] = ACTIONS(1254),
    [aux_sym_trait_declaration_token1] = ACTIONS(1256),
    [aux_sym_interface_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_case_token1] = ACTIONS(1256),
    [aux_sym_class_declaration_token1] = ACTIONS(1256),
    [aux_sym_final_modifier_token1] = ACTIONS(1256),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1256),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1256),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [aux_sym_cast_type_token1] = ACTIONS(1256),
    [aux_sym_echo_statement_token1] = ACTIONS(1256),
    [anon_sym_unset] = ACTIONS(1256),
    [aux_sym_declare_statement_token1] = ACTIONS(1256),
    [aux_sym_declare_statement_token2] = ACTIONS(1256),
    [sym_float] = ACTIONS(1256),
    [aux_sym_try_statement_token1] = ACTIONS(1256),
    [aux_sym_goto_statement_token1] = ACTIONS(1256),
    [aux_sym_continue_statement_token1] = ACTIONS(1256),
    [aux_sym_break_statement_token1] = ACTIONS(1256),
    [sym_integer] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1256),
    [aux_sym_throw_expression_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token2] = ACTIONS(1256),
    [aux_sym_do_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token2] = ACTIONS(1256),
    [aux_sym_foreach_statement_token1] = ACTIONS(1256),
    [aux_sym_foreach_statement_token2] = ACTIONS(1256),
    [aux_sym_if_statement_token1] = ACTIONS(1256),
    [aux_sym_if_statement_token2] = ACTIONS(1256),
    [aux_sym_else_if_clause_token1] = ACTIONS(1256),
    [aux_sym_else_clause_token1] = ACTIONS(1256),
    [aux_sym_match_expression_token1] = ACTIONS(1256),
    [aux_sym_match_default_expression_token1] = ACTIONS(1256),
    [aux_sym_switch_statement_token1] = ACTIONS(1256),
    [aux_sym_switch_block_token1] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1254),
    [aux_sym_clone_expression_token1] = ACTIONS(1256),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1256),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1256),
    [anon_sym_DASH_DASH] = ACTIONS(1254),
    [anon_sym_PLUS_PLUS] = ACTIONS(1254),
    [aux_sym__list_destructing_token1] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1254),
    [anon_sym_self] = ACTIONS(1256),
    [anon_sym_parent] = ACTIONS(1256),
    [aux_sym__argument_name_token1] = ACTIONS(1256),
    [aux_sym__argument_name_token2] = ACTIONS(1256),
    [anon_sym_POUND_LBRACK] = ACTIONS(1254),
    [aux_sym_encapsed_string_token1] = ACTIONS(1254),
    [anon_sym_DQUOTE] = ACTIONS(1254),
    [aux_sym_string_token1] = ACTIONS(1254),
    [anon_sym_SQUOTE] = ACTIONS(1254),
    [anon_sym_LT_LT_LT] = ACTIONS(1254),
    [anon_sym_BQUOTE] = ACTIONS(1254),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [aux_sym_yield_expression_token1] = ACTIONS(1256),
    [aux_sym_include_expression_token1] = ACTIONS(1256),
    [aux_sym_include_once_expression_token1] = ACTIONS(1256),
    [aux_sym_require_expression_token1] = ACTIONS(1256),
    [aux_sym_require_once_expression_token1] = ACTIONS(1256),
    [sym_comment] = ACTIONS(5),
  },
  [483] = {
    [sym_text_interpolation] = STATE(483),
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym_name] = ACTIONS(1260),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1258),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1260),
    [aux_sym_global_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_definition_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1260),
    [anon_sym_BSLASH] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_RBRACE] = ACTIONS(1258),
    [aux_sym_trait_declaration_token1] = ACTIONS(1260),
    [aux_sym_interface_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_case_token1] = ACTIONS(1260),
    [aux_sym_class_declaration_token1] = ACTIONS(1260),
    [aux_sym_final_modifier_token1] = ACTIONS(1260),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1260),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1260),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [aux_sym_cast_type_token1] = ACTIONS(1260),
    [aux_sym_echo_statement_token1] = ACTIONS(1260),
    [anon_sym_unset] = ACTIONS(1260),
    [aux_sym_declare_statement_token1] = ACTIONS(1260),
    [aux_sym_declare_statement_token2] = ACTIONS(1260),
    [sym_float] = ACTIONS(1260),
    [aux_sym_try_statement_token1] = ACTIONS(1260),
    [aux_sym_goto_statement_token1] = ACTIONS(1260),
    [aux_sym_continue_statement_token1] = ACTIONS(1260),
    [aux_sym_break_statement_token1] = ACTIONS(1260),
    [sym_integer] = ACTIONS(1260),
    [aux_sym_return_statement_token1] = ACTIONS(1260),
    [aux_sym_throw_expression_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token2] = ACTIONS(1260),
    [aux_sym_do_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token2] = ACTIONS(1260),
    [aux_sym_foreach_statement_token1] = ACTIONS(1260),
    [aux_sym_foreach_statement_token2] = ACTIONS(1260),
    [aux_sym_if_statement_token1] = ACTIONS(1260),
    [aux_sym_if_statement_token2] = ACTIONS(1260),
    [aux_sym_else_if_clause_token1] = ACTIONS(1260),
    [aux_sym_else_clause_token1] = ACTIONS(1260),
    [aux_sym_match_expression_token1] = ACTIONS(1260),
    [aux_sym_match_default_expression_token1] = ACTIONS(1260),
    [aux_sym_switch_statement_token1] = ACTIONS(1260),
    [aux_sym_switch_block_token1] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1258),
    [aux_sym_clone_expression_token1] = ACTIONS(1260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1260),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1258),
    [anon_sym_PLUS_PLUS] = ACTIONS(1258),
    [aux_sym__list_destructing_token1] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_self] = ACTIONS(1260),
    [anon_sym_parent] = ACTIONS(1260),
    [aux_sym__argument_name_token1] = ACTIONS(1260),
    [aux_sym__argument_name_token2] = ACTIONS(1260),
    [anon_sym_POUND_LBRACK] = ACTIONS(1258),
    [aux_sym_encapsed_string_token1] = ACTIONS(1258),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [aux_sym_string_token1] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1258),
    [anon_sym_LT_LT_LT] = ACTIONS(1258),
    [anon_sym_BQUOTE] = ACTIONS(1258),
    [anon_sym_DOLLAR] = ACTIONS(1258),
    [aux_sym_yield_expression_token1] = ACTIONS(1260),
    [aux_sym_include_expression_token1] = ACTIONS(1260),
    [aux_sym_include_once_expression_token1] = ACTIONS(1260),
    [aux_sym_require_expression_token1] = ACTIONS(1260),
    [aux_sym_require_once_expression_token1] = ACTIONS(1260),
    [sym_comment] = ACTIONS(5),
  },
  [484] = {
    [sym_text_interpolation] = STATE(484),
    [ts_builtin_sym_end] = ACTIONS(1262),
    [sym_name] = ACTIONS(1264),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1262),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1264),
    [aux_sym_global_declaration_token1] = ACTIONS(1264),
    [aux_sym_namespace_definition_token1] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1264),
    [anon_sym_BSLASH] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1262),
    [anon_sym_RBRACE] = ACTIONS(1262),
    [aux_sym_trait_declaration_token1] = ACTIONS(1264),
    [aux_sym_interface_declaration_token1] = ACTIONS(1264),
    [aux_sym_enum_declaration_token1] = ACTIONS(1264),
    [aux_sym_enum_case_token1] = ACTIONS(1264),
    [aux_sym_class_declaration_token1] = ACTIONS(1264),
    [aux_sym_final_modifier_token1] = ACTIONS(1264),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1264),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1264),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [aux_sym_cast_type_token1] = ACTIONS(1264),
    [aux_sym_echo_statement_token1] = ACTIONS(1264),
    [anon_sym_unset] = ACTIONS(1264),
    [aux_sym_declare_statement_token1] = ACTIONS(1264),
    [aux_sym_declare_statement_token2] = ACTIONS(1264),
    [sym_float] = ACTIONS(1264),
    [aux_sym_try_statement_token1] = ACTIONS(1264),
    [aux_sym_goto_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1264),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [sym_integer] = ACTIONS(1264),
    [aux_sym_return_statement_token1] = ACTIONS(1264),
    [aux_sym_throw_expression_token1] = ACTIONS(1264),
    [aux_sym_while_statement_token1] = ACTIONS(1264),
    [aux_sym_while_statement_token2] = ACTIONS(1264),
    [aux_sym_do_statement_token1] = ACTIONS(1264),
    [aux_sym_for_statement_token1] = ACTIONS(1264),
    [aux_sym_for_statement_token2] = ACTIONS(1264),
    [aux_sym_foreach_statement_token1] = ACTIONS(1264),
    [aux_sym_foreach_statement_token2] = ACTIONS(1264),
    [aux_sym_if_statement_token1] = ACTIONS(1264),
    [aux_sym_if_statement_token2] = ACTIONS(1264),
    [aux_sym_else_if_clause_token1] = ACTIONS(1264),
    [aux_sym_else_clause_token1] = ACTIONS(1264),
    [aux_sym_match_expression_token1] = ACTIONS(1264),
    [aux_sym_match_default_expression_token1] = ACTIONS(1264),
    [aux_sym_switch_statement_token1] = ACTIONS(1264),
    [aux_sym_switch_block_token1] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1262),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1262),
    [aux_sym_clone_expression_token1] = ACTIONS(1264),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1264),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1264),
    [anon_sym_DASH_DASH] = ACTIONS(1262),
    [anon_sym_PLUS_PLUS] = ACTIONS(1262),
    [aux_sym__list_destructing_token1] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1262),
    [anon_sym_self] = ACTIONS(1264),
    [anon_sym_parent] = ACTIONS(1264),
    [aux_sym__argument_name_token1] = ACTIONS(1264),
    [aux_sym__argument_name_token2] = ACTIONS(1264),
    [anon_sym_POUND_LBRACK] = ACTIONS(1262),
    [aux_sym_encapsed_string_token1] = ACTIONS(1262),
    [anon_sym_DQUOTE] = ACTIONS(1262),
    [aux_sym_string_token1] = ACTIONS(1262),
    [anon_sym_SQUOTE] = ACTIONS(1262),
    [anon_sym_LT_LT_LT] = ACTIONS(1262),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [anon_sym_DOLLAR] = ACTIONS(1262),
    [aux_sym_yield_expression_token1] = ACTIONS(1264),
    [aux_sym_include_expression_token1] = ACTIONS(1264),
    [aux_sym_include_once_expression_token1] = ACTIONS(1264),
    [aux_sym_require_expression_token1] = ACTIONS(1264),
    [aux_sym_require_once_expression_token1] = ACTIONS(1264),
    [sym_comment] = ACTIONS(5),
  },
  [485] = {
    [sym_text_interpolation] = STATE(485),
    [ts_builtin_sym_end] = ACTIONS(1266),
    [sym_name] = ACTIONS(1268),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1266),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1268),
    [aux_sym_global_declaration_token1] = ACTIONS(1268),
    [aux_sym_namespace_definition_token1] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1268),
    [anon_sym_BSLASH] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1266),
    [anon_sym_RBRACE] = ACTIONS(1266),
    [aux_sym_trait_declaration_token1] = ACTIONS(1268),
    [aux_sym_interface_declaration_token1] = ACTIONS(1268),
    [aux_sym_enum_declaration_token1] = ACTIONS(1268),
    [aux_sym_enum_case_token1] = ACTIONS(1268),
    [aux_sym_class_declaration_token1] = ACTIONS(1268),
    [aux_sym_final_modifier_token1] = ACTIONS(1268),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1268),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1268),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [aux_sym_cast_type_token1] = ACTIONS(1268),
    [aux_sym_echo_statement_token1] = ACTIONS(1268),
    [anon_sym_unset] = ACTIONS(1268),
    [aux_sym_declare_statement_token1] = ACTIONS(1268),
    [aux_sym_declare_statement_token2] = ACTIONS(1268),
    [sym_float] = ACTIONS(1268),
    [aux_sym_try_statement_token1] = ACTIONS(1268),
    [aux_sym_goto_statement_token1] = ACTIONS(1268),
    [aux_sym_continue_statement_token1] = ACTIONS(1268),
    [aux_sym_break_statement_token1] = ACTIONS(1268),
    [sym_integer] = ACTIONS(1268),
    [aux_sym_return_statement_token1] = ACTIONS(1268),
    [aux_sym_throw_expression_token1] = ACTIONS(1268),
    [aux_sym_while_statement_token1] = ACTIONS(1268),
    [aux_sym_while_statement_token2] = ACTIONS(1268),
    [aux_sym_do_statement_token1] = ACTIONS(1268),
    [aux_sym_for_statement_token1] = ACTIONS(1268),
    [aux_sym_for_statement_token2] = ACTIONS(1268),
    [aux_sym_foreach_statement_token1] = ACTIONS(1268),
    [aux_sym_foreach_statement_token2] = ACTIONS(1268),
    [aux_sym_if_statement_token1] = ACTIONS(1268),
    [aux_sym_if_statement_token2] = ACTIONS(1268),
    [aux_sym_else_if_clause_token1] = ACTIONS(1268),
    [aux_sym_else_clause_token1] = ACTIONS(1268),
    [aux_sym_match_expression_token1] = ACTIONS(1268),
    [aux_sym_match_default_expression_token1] = ACTIONS(1268),
    [aux_sym_switch_statement_token1] = ACTIONS(1268),
    [aux_sym_switch_block_token1] = ACTIONS(1268),
    [anon_sym_PLUS] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1266),
    [aux_sym_clone_expression_token1] = ACTIONS(1268),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1268),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1268),
    [anon_sym_DASH_DASH] = ACTIONS(1266),
    [anon_sym_PLUS_PLUS] = ACTIONS(1266),
    [aux_sym__list_destructing_token1] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_self] = ACTIONS(1268),
    [anon_sym_parent] = ACTIONS(1268),
    [aux_sym__argument_name_token1] = ACTIONS(1268),
    [aux_sym__argument_name_token2] = ACTIONS(1268),
    [anon_sym_POUND_LBRACK] = ACTIONS(1266),
    [aux_sym_encapsed_string_token1] = ACTIONS(1266),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [aux_sym_string_token1] = ACTIONS(1266),
    [anon_sym_SQUOTE] = ACTIONS(1266),
    [anon_sym_LT_LT_LT] = ACTIONS(1266),
    [anon_sym_BQUOTE] = ACTIONS(1266),
    [anon_sym_DOLLAR] = ACTIONS(1266),
    [aux_sym_yield_expression_token1] = ACTIONS(1268),
    [aux_sym_include_expression_token1] = ACTIONS(1268),
    [aux_sym_include_once_expression_token1] = ACTIONS(1268),
    [aux_sym_require_expression_token1] = ACTIONS(1268),
    [aux_sym_require_once_expression_token1] = ACTIONS(1268),
    [sym_comment] = ACTIONS(5),
  },
  [486] = {
    [sym_text_interpolation] = STATE(486),
    [ts_builtin_sym_end] = ACTIONS(1182),
    [sym_name] = ACTIONS(1184),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1182),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1184),
    [aux_sym_global_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_definition_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1184),
    [anon_sym_BSLASH] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_RBRACE] = ACTIONS(1182),
    [aux_sym_trait_declaration_token1] = ACTIONS(1184),
    [aux_sym_interface_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_case_token1] = ACTIONS(1184),
    [aux_sym_class_declaration_token1] = ACTIONS(1184),
    [aux_sym_final_modifier_token1] = ACTIONS(1184),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1184),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1184),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [aux_sym_cast_type_token1] = ACTIONS(1184),
    [aux_sym_echo_statement_token1] = ACTIONS(1184),
    [anon_sym_unset] = ACTIONS(1184),
    [aux_sym_declare_statement_token1] = ACTIONS(1184),
    [aux_sym_declare_statement_token2] = ACTIONS(1184),
    [sym_float] = ACTIONS(1184),
    [aux_sym_try_statement_token1] = ACTIONS(1184),
    [aux_sym_goto_statement_token1] = ACTIONS(1184),
    [aux_sym_continue_statement_token1] = ACTIONS(1184),
    [aux_sym_break_statement_token1] = ACTIONS(1184),
    [sym_integer] = ACTIONS(1184),
    [aux_sym_return_statement_token1] = ACTIONS(1184),
    [aux_sym_throw_expression_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token2] = ACTIONS(1184),
    [aux_sym_do_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token2] = ACTIONS(1184),
    [aux_sym_foreach_statement_token1] = ACTIONS(1184),
    [aux_sym_foreach_statement_token2] = ACTIONS(1184),
    [aux_sym_if_statement_token1] = ACTIONS(1184),
    [aux_sym_if_statement_token2] = ACTIONS(1184),
    [aux_sym_else_if_clause_token1] = ACTIONS(1184),
    [aux_sym_else_clause_token1] = ACTIONS(1184),
    [aux_sym_match_expression_token1] = ACTIONS(1184),
    [aux_sym_match_default_expression_token1] = ACTIONS(1184),
    [aux_sym_switch_statement_token1] = ACTIONS(1184),
    [aux_sym_switch_block_token1] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1182),
    [aux_sym_clone_expression_token1] = ACTIONS(1184),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1184),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1184),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [aux_sym__list_destructing_token1] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1182),
    [anon_sym_self] = ACTIONS(1184),
    [anon_sym_parent] = ACTIONS(1184),
    [aux_sym__argument_name_token1] = ACTIONS(1184),
    [aux_sym__argument_name_token2] = ACTIONS(1184),
    [anon_sym_POUND_LBRACK] = ACTIONS(1182),
    [aux_sym_encapsed_string_token1] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [aux_sym_string_token1] = ACTIONS(1182),
    [anon_sym_SQUOTE] = ACTIONS(1182),
    [anon_sym_LT_LT_LT] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(1182),
    [anon_sym_DOLLAR] = ACTIONS(1182),
    [aux_sym_yield_expression_token1] = ACTIONS(1184),
    [aux_sym_include_expression_token1] = ACTIONS(1184),
    [aux_sym_include_once_expression_token1] = ACTIONS(1184),
    [aux_sym_require_expression_token1] = ACTIONS(1184),
    [aux_sym_require_once_expression_token1] = ACTIONS(1184),
    [sym_comment] = ACTIONS(5),
  },
  [487] = {
    [sym_text_interpolation] = STATE(487),
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym_name] = ACTIONS(1272),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1270),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1272),
    [aux_sym_global_declaration_token1] = ACTIONS(1272),
    [aux_sym_namespace_definition_token1] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1272),
    [anon_sym_BSLASH] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [aux_sym_trait_declaration_token1] = ACTIONS(1272),
    [aux_sym_interface_declaration_token1] = ACTIONS(1272),
    [aux_sym_enum_declaration_token1] = ACTIONS(1272),
    [aux_sym_enum_case_token1] = ACTIONS(1272),
    [aux_sym_class_declaration_token1] = ACTIONS(1272),
    [aux_sym_final_modifier_token1] = ACTIONS(1272),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1272),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1272),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [aux_sym_cast_type_token1] = ACTIONS(1272),
    [aux_sym_echo_statement_token1] = ACTIONS(1272),
    [anon_sym_unset] = ACTIONS(1272),
    [aux_sym_declare_statement_token1] = ACTIONS(1272),
    [aux_sym_declare_statement_token2] = ACTIONS(1272),
    [sym_float] = ACTIONS(1272),
    [aux_sym_try_statement_token1] = ACTIONS(1272),
    [aux_sym_goto_statement_token1] = ACTIONS(1272),
    [aux_sym_continue_statement_token1] = ACTIONS(1272),
    [aux_sym_break_statement_token1] = ACTIONS(1272),
    [sym_integer] = ACTIONS(1272),
    [aux_sym_return_statement_token1] = ACTIONS(1272),
    [aux_sym_throw_expression_token1] = ACTIONS(1272),
    [aux_sym_while_statement_token1] = ACTIONS(1272),
    [aux_sym_while_statement_token2] = ACTIONS(1272),
    [aux_sym_do_statement_token1] = ACTIONS(1272),
    [aux_sym_for_statement_token1] = ACTIONS(1272),
    [aux_sym_for_statement_token2] = ACTIONS(1272),
    [aux_sym_foreach_statement_token1] = ACTIONS(1272),
    [aux_sym_foreach_statement_token2] = ACTIONS(1272),
    [aux_sym_if_statement_token1] = ACTIONS(1272),
    [aux_sym_if_statement_token2] = ACTIONS(1272),
    [aux_sym_else_if_clause_token1] = ACTIONS(1272),
    [aux_sym_else_clause_token1] = ACTIONS(1272),
    [aux_sym_match_expression_token1] = ACTIONS(1272),
    [aux_sym_match_default_expression_token1] = ACTIONS(1272),
    [aux_sym_switch_statement_token1] = ACTIONS(1272),
    [aux_sym_switch_block_token1] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_BANG] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1270),
    [aux_sym_clone_expression_token1] = ACTIONS(1272),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1272),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1272),
    [anon_sym_DASH_DASH] = ACTIONS(1270),
    [anon_sym_PLUS_PLUS] = ACTIONS(1270),
    [aux_sym__list_destructing_token1] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_self] = ACTIONS(1272),
    [anon_sym_parent] = ACTIONS(1272),
    [aux_sym__argument_name_token1] = ACTIONS(1272),
    [aux_sym__argument_name_token2] = ACTIONS(1272),
    [anon_sym_POUND_LBRACK] = ACTIONS(1270),
    [aux_sym_encapsed_string_token1] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [aux_sym_string_token1] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1270),
    [anon_sym_LT_LT_LT] = ACTIONS(1270),
    [anon_sym_BQUOTE] = ACTIONS(1270),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [aux_sym_yield_expression_token1] = ACTIONS(1272),
    [aux_sym_include_expression_token1] = ACTIONS(1272),
    [aux_sym_include_once_expression_token1] = ACTIONS(1272),
    [aux_sym_require_expression_token1] = ACTIONS(1272),
    [aux_sym_require_once_expression_token1] = ACTIONS(1272),
    [sym_comment] = ACTIONS(5),
  },
  [488] = {
    [sym_text_interpolation] = STATE(488),
    [ts_builtin_sym_end] = ACTIONS(1274),
    [sym_name] = ACTIONS(1276),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1274),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1276),
    [aux_sym_global_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_definition_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1276),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [aux_sym_trait_declaration_token1] = ACTIONS(1276),
    [aux_sym_interface_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_case_token1] = ACTIONS(1276),
    [aux_sym_class_declaration_token1] = ACTIONS(1276),
    [aux_sym_final_modifier_token1] = ACTIONS(1276),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1276),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1276),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [aux_sym_cast_type_token1] = ACTIONS(1276),
    [aux_sym_echo_statement_token1] = ACTIONS(1276),
    [anon_sym_unset] = ACTIONS(1276),
    [aux_sym_declare_statement_token1] = ACTIONS(1276),
    [aux_sym_declare_statement_token2] = ACTIONS(1276),
    [sym_float] = ACTIONS(1276),
    [aux_sym_try_statement_token1] = ACTIONS(1276),
    [aux_sym_goto_statement_token1] = ACTIONS(1276),
    [aux_sym_continue_statement_token1] = ACTIONS(1276),
    [aux_sym_break_statement_token1] = ACTIONS(1276),
    [sym_integer] = ACTIONS(1276),
    [aux_sym_return_statement_token1] = ACTIONS(1276),
    [aux_sym_throw_expression_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token2] = ACTIONS(1276),
    [aux_sym_do_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token2] = ACTIONS(1276),
    [aux_sym_foreach_statement_token1] = ACTIONS(1276),
    [aux_sym_foreach_statement_token2] = ACTIONS(1276),
    [aux_sym_if_statement_token1] = ACTIONS(1276),
    [aux_sym_if_statement_token2] = ACTIONS(1276),
    [aux_sym_else_if_clause_token1] = ACTIONS(1276),
    [aux_sym_else_clause_token1] = ACTIONS(1276),
    [aux_sym_match_expression_token1] = ACTIONS(1276),
    [aux_sym_match_default_expression_token1] = ACTIONS(1276),
    [aux_sym_switch_statement_token1] = ACTIONS(1276),
    [aux_sym_switch_block_token1] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [aux_sym_clone_expression_token1] = ACTIONS(1276),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1276),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1274),
    [anon_sym_PLUS_PLUS] = ACTIONS(1274),
    [aux_sym__list_destructing_token1] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_self] = ACTIONS(1276),
    [anon_sym_parent] = ACTIONS(1276),
    [aux_sym__argument_name_token1] = ACTIONS(1276),
    [aux_sym__argument_name_token2] = ACTIONS(1276),
    [anon_sym_POUND_LBRACK] = ACTIONS(1274),
    [aux_sym_encapsed_string_token1] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [aux_sym_string_token1] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [anon_sym_LT_LT_LT] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [aux_sym_yield_expression_token1] = ACTIONS(1276),
    [aux_sym_include_expression_token1] = ACTIONS(1276),
    [aux_sym_include_once_expression_token1] = ACTIONS(1276),
    [aux_sym_require_expression_token1] = ACTIONS(1276),
    [aux_sym_require_once_expression_token1] = ACTIONS(1276),
    [sym_comment] = ACTIONS(5),
  },
  [489] = {
    [sym_text_interpolation] = STATE(489),
    [ts_builtin_sym_end] = ACTIONS(1278),
    [sym_name] = ACTIONS(1280),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1278),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1280),
    [aux_sym_global_declaration_token1] = ACTIONS(1280),
    [aux_sym_namespace_definition_token1] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1280),
    [anon_sym_BSLASH] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1278),
    [anon_sym_RBRACE] = ACTIONS(1278),
    [aux_sym_trait_declaration_token1] = ACTIONS(1280),
    [aux_sym_interface_declaration_token1] = ACTIONS(1280),
    [aux_sym_enum_declaration_token1] = ACTIONS(1280),
    [aux_sym_enum_case_token1] = ACTIONS(1280),
    [aux_sym_class_declaration_token1] = ACTIONS(1280),
    [aux_sym_final_modifier_token1] = ACTIONS(1280),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1280),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1280),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [aux_sym_cast_type_token1] = ACTIONS(1280),
    [aux_sym_echo_statement_token1] = ACTIONS(1280),
    [anon_sym_unset] = ACTIONS(1280),
    [aux_sym_declare_statement_token1] = ACTIONS(1280),
    [aux_sym_declare_statement_token2] = ACTIONS(1280),
    [sym_float] = ACTIONS(1280),
    [aux_sym_try_statement_token1] = ACTIONS(1280),
    [aux_sym_goto_statement_token1] = ACTIONS(1280),
    [aux_sym_continue_statement_token1] = ACTIONS(1280),
    [aux_sym_break_statement_token1] = ACTIONS(1280),
    [sym_integer] = ACTIONS(1280),
    [aux_sym_return_statement_token1] = ACTIONS(1280),
    [aux_sym_throw_expression_token1] = ACTIONS(1280),
    [aux_sym_while_statement_token1] = ACTIONS(1280),
    [aux_sym_while_statement_token2] = ACTIONS(1280),
    [aux_sym_do_statement_token1] = ACTIONS(1280),
    [aux_sym_for_statement_token1] = ACTIONS(1280),
    [aux_sym_for_statement_token2] = ACTIONS(1280),
    [aux_sym_foreach_statement_token1] = ACTIONS(1280),
    [aux_sym_foreach_statement_token2] = ACTIONS(1280),
    [aux_sym_if_statement_token1] = ACTIONS(1280),
    [aux_sym_if_statement_token2] = ACTIONS(1280),
    [aux_sym_else_if_clause_token1] = ACTIONS(1280),
    [aux_sym_else_clause_token1] = ACTIONS(1280),
    [aux_sym_match_expression_token1] = ACTIONS(1280),
    [aux_sym_match_default_expression_token1] = ACTIONS(1280),
    [aux_sym_switch_statement_token1] = ACTIONS(1280),
    [aux_sym_switch_block_token1] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1278),
    [aux_sym_clone_expression_token1] = ACTIONS(1280),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1280),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1278),
    [anon_sym_PLUS_PLUS] = ACTIONS(1278),
    [aux_sym__list_destructing_token1] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1278),
    [anon_sym_self] = ACTIONS(1280),
    [anon_sym_parent] = ACTIONS(1280),
    [aux_sym__argument_name_token1] = ACTIONS(1280),
    [aux_sym__argument_name_token2] = ACTIONS(1280),
    [anon_sym_POUND_LBRACK] = ACTIONS(1278),
    [aux_sym_encapsed_string_token1] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(1278),
    [aux_sym_string_token1] = ACTIONS(1278),
    [anon_sym_SQUOTE] = ACTIONS(1278),
    [anon_sym_LT_LT_LT] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1278),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [aux_sym_yield_expression_token1] = ACTIONS(1280),
    [aux_sym_include_expression_token1] = ACTIONS(1280),
    [aux_sym_include_once_expression_token1] = ACTIONS(1280),
    [aux_sym_require_expression_token1] = ACTIONS(1280),
    [aux_sym_require_once_expression_token1] = ACTIONS(1280),
    [sym_comment] = ACTIONS(5),
  },
  [490] = {
    [sym_text_interpolation] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(1274),
    [sym_name] = ACTIONS(1276),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1274),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1276),
    [aux_sym_global_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_definition_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1276),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [aux_sym_trait_declaration_token1] = ACTIONS(1276),
    [aux_sym_interface_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_case_token1] = ACTIONS(1276),
    [aux_sym_class_declaration_token1] = ACTIONS(1276),
    [aux_sym_final_modifier_token1] = ACTIONS(1276),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1276),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1276),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [aux_sym_cast_type_token1] = ACTIONS(1276),
    [aux_sym_echo_statement_token1] = ACTIONS(1276),
    [anon_sym_unset] = ACTIONS(1276),
    [aux_sym_declare_statement_token1] = ACTIONS(1276),
    [aux_sym_declare_statement_token2] = ACTIONS(1276),
    [sym_float] = ACTIONS(1276),
    [aux_sym_try_statement_token1] = ACTIONS(1276),
    [aux_sym_goto_statement_token1] = ACTIONS(1276),
    [aux_sym_continue_statement_token1] = ACTIONS(1276),
    [aux_sym_break_statement_token1] = ACTIONS(1276),
    [sym_integer] = ACTIONS(1276),
    [aux_sym_return_statement_token1] = ACTIONS(1276),
    [aux_sym_throw_expression_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token2] = ACTIONS(1276),
    [aux_sym_do_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token2] = ACTIONS(1276),
    [aux_sym_foreach_statement_token1] = ACTIONS(1276),
    [aux_sym_foreach_statement_token2] = ACTIONS(1276),
    [aux_sym_if_statement_token1] = ACTIONS(1276),
    [aux_sym_if_statement_token2] = ACTIONS(1276),
    [aux_sym_else_if_clause_token1] = ACTIONS(1276),
    [aux_sym_else_clause_token1] = ACTIONS(1276),
    [aux_sym_match_expression_token1] = ACTIONS(1276),
    [aux_sym_match_default_expression_token1] = ACTIONS(1276),
    [aux_sym_switch_statement_token1] = ACTIONS(1276),
    [aux_sym_switch_block_token1] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [aux_sym_clone_expression_token1] = ACTIONS(1276),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1276),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1274),
    [anon_sym_PLUS_PLUS] = ACTIONS(1274),
    [aux_sym__list_destructing_token1] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_self] = ACTIONS(1276),
    [anon_sym_parent] = ACTIONS(1276),
    [aux_sym__argument_name_token1] = ACTIONS(1276),
    [aux_sym__argument_name_token2] = ACTIONS(1276),
    [anon_sym_POUND_LBRACK] = ACTIONS(1274),
    [aux_sym_encapsed_string_token1] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [aux_sym_string_token1] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [anon_sym_LT_LT_LT] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [aux_sym_yield_expression_token1] = ACTIONS(1276),
    [aux_sym_include_expression_token1] = ACTIONS(1276),
    [aux_sym_include_once_expression_token1] = ACTIONS(1276),
    [aux_sym_require_expression_token1] = ACTIONS(1276),
    [aux_sym_require_once_expression_token1] = ACTIONS(1276),
    [sym_comment] = ACTIONS(5),
  },
  [491] = {
    [sym_text_interpolation] = STATE(491),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(906),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(634),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_function_call_expression] = STATE(602),
    [sym_scoped_call_expression] = STATE(602),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(602),
    [sym_nullsafe_member_call_expression] = STATE(602),
    [sym_subscript_expression] = STATE(602),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(602),
    [sym_variable_name] = STATE(602),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(851),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(5),
  },
  [492] = {
    [sym_text_interpolation] = STATE(492),
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_name] = ACTIONS(1286),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1284),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1286),
    [aux_sym_global_declaration_token1] = ACTIONS(1286),
    [aux_sym_namespace_definition_token1] = ACTIONS(1286),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1286),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1286),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1286),
    [anon_sym_BSLASH] = ACTIONS(1284),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [aux_sym_trait_declaration_token1] = ACTIONS(1286),
    [aux_sym_interface_declaration_token1] = ACTIONS(1286),
    [aux_sym_enum_declaration_token1] = ACTIONS(1286),
    [aux_sym_enum_case_token1] = ACTIONS(1286),
    [aux_sym_class_declaration_token1] = ACTIONS(1286),
    [aux_sym_final_modifier_token1] = ACTIONS(1286),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1286),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1286),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1286),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1286),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1286),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [aux_sym_cast_type_token1] = ACTIONS(1286),
    [aux_sym_echo_statement_token1] = ACTIONS(1286),
    [anon_sym_unset] = ACTIONS(1286),
    [aux_sym_declare_statement_token1] = ACTIONS(1286),
    [aux_sym_declare_statement_token2] = ACTIONS(1286),
    [sym_float] = ACTIONS(1286),
    [aux_sym_try_statement_token1] = ACTIONS(1286),
    [aux_sym_goto_statement_token1] = ACTIONS(1286),
    [aux_sym_continue_statement_token1] = ACTIONS(1286),
    [aux_sym_break_statement_token1] = ACTIONS(1286),
    [sym_integer] = ACTIONS(1286),
    [aux_sym_return_statement_token1] = ACTIONS(1286),
    [aux_sym_throw_expression_token1] = ACTIONS(1286),
    [aux_sym_while_statement_token1] = ACTIONS(1286),
    [aux_sym_while_statement_token2] = ACTIONS(1286),
    [aux_sym_do_statement_token1] = ACTIONS(1286),
    [aux_sym_for_statement_token1] = ACTIONS(1286),
    [aux_sym_for_statement_token2] = ACTIONS(1286),
    [aux_sym_foreach_statement_token1] = ACTIONS(1286),
    [aux_sym_foreach_statement_token2] = ACTIONS(1286),
    [aux_sym_if_statement_token1] = ACTIONS(1286),
    [aux_sym_if_statement_token2] = ACTIONS(1286),
    [aux_sym_else_if_clause_token1] = ACTIONS(1286),
    [aux_sym_else_clause_token1] = ACTIONS(1286),
    [aux_sym_match_expression_token1] = ACTIONS(1286),
    [aux_sym_match_default_expression_token1] = ACTIONS(1286),
    [aux_sym_switch_statement_token1] = ACTIONS(1286),
    [aux_sym_switch_block_token1] = ACTIONS(1286),
    [anon_sym_PLUS] = ACTIONS(1286),
    [anon_sym_DASH] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_BANG] = ACTIONS(1284),
    [anon_sym_AT] = ACTIONS(1284),
    [aux_sym_clone_expression_token1] = ACTIONS(1286),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1286),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1286),
    [anon_sym_DASH_DASH] = ACTIONS(1284),
    [anon_sym_PLUS_PLUS] = ACTIONS(1284),
    [aux_sym__list_destructing_token1] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_self] = ACTIONS(1286),
    [anon_sym_parent] = ACTIONS(1286),
    [aux_sym__argument_name_token1] = ACTIONS(1286),
    [aux_sym__argument_name_token2] = ACTIONS(1286),
    [anon_sym_POUND_LBRACK] = ACTIONS(1284),
    [aux_sym_encapsed_string_token1] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1284),
    [aux_sym_string_token1] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1284),
    [anon_sym_LT_LT_LT] = ACTIONS(1284),
    [anon_sym_BQUOTE] = ACTIONS(1284),
    [anon_sym_DOLLAR] = ACTIONS(1284),
    [aux_sym_yield_expression_token1] = ACTIONS(1286),
    [aux_sym_include_expression_token1] = ACTIONS(1286),
    [aux_sym_include_once_expression_token1] = ACTIONS(1286),
    [aux_sym_require_expression_token1] = ACTIONS(1286),
    [aux_sym_require_once_expression_token1] = ACTIONS(1286),
    [sym_comment] = ACTIONS(5),
  },
  [493] = {
    [sym_text_interpolation] = STATE(493),
    [ts_builtin_sym_end] = ACTIONS(1288),
    [sym_name] = ACTIONS(1290),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1288),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1290),
    [aux_sym_global_declaration_token1] = ACTIONS(1290),
    [aux_sym_namespace_definition_token1] = ACTIONS(1290),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1290),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1290),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1290),
    [anon_sym_BSLASH] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_RBRACE] = ACTIONS(1288),
    [aux_sym_trait_declaration_token1] = ACTIONS(1290),
    [aux_sym_interface_declaration_token1] = ACTIONS(1290),
    [aux_sym_enum_declaration_token1] = ACTIONS(1290),
    [aux_sym_enum_case_token1] = ACTIONS(1290),
    [aux_sym_class_declaration_token1] = ACTIONS(1290),
    [aux_sym_final_modifier_token1] = ACTIONS(1290),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1290),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1290),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1290),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1290),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1290),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [aux_sym_cast_type_token1] = ACTIONS(1290),
    [aux_sym_echo_statement_token1] = ACTIONS(1290),
    [anon_sym_unset] = ACTIONS(1290),
    [aux_sym_declare_statement_token1] = ACTIONS(1290),
    [aux_sym_declare_statement_token2] = ACTIONS(1290),
    [sym_float] = ACTIONS(1290),
    [aux_sym_try_statement_token1] = ACTIONS(1290),
    [aux_sym_goto_statement_token1] = ACTIONS(1290),
    [aux_sym_continue_statement_token1] = ACTIONS(1290),
    [aux_sym_break_statement_token1] = ACTIONS(1290),
    [sym_integer] = ACTIONS(1290),
    [aux_sym_return_statement_token1] = ACTIONS(1290),
    [aux_sym_throw_expression_token1] = ACTIONS(1290),
    [aux_sym_while_statement_token1] = ACTIONS(1290),
    [aux_sym_while_statement_token2] = ACTIONS(1290),
    [aux_sym_do_statement_token1] = ACTIONS(1290),
    [aux_sym_for_statement_token1] = ACTIONS(1290),
    [aux_sym_for_statement_token2] = ACTIONS(1290),
    [aux_sym_foreach_statement_token1] = ACTIONS(1290),
    [aux_sym_foreach_statement_token2] = ACTIONS(1290),
    [aux_sym_if_statement_token1] = ACTIONS(1290),
    [aux_sym_if_statement_token2] = ACTIONS(1290),
    [aux_sym_else_if_clause_token1] = ACTIONS(1290),
    [aux_sym_else_clause_token1] = ACTIONS(1290),
    [aux_sym_match_expression_token1] = ACTIONS(1290),
    [aux_sym_match_default_expression_token1] = ACTIONS(1290),
    [aux_sym_switch_statement_token1] = ACTIONS(1290),
    [aux_sym_switch_block_token1] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1290),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_BANG] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [aux_sym_clone_expression_token1] = ACTIONS(1290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1290),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1288),
    [anon_sym_PLUS_PLUS] = ACTIONS(1288),
    [aux_sym__list_destructing_token1] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_self] = ACTIONS(1290),
    [anon_sym_parent] = ACTIONS(1290),
    [aux_sym__argument_name_token1] = ACTIONS(1290),
    [aux_sym__argument_name_token2] = ACTIONS(1290),
    [anon_sym_POUND_LBRACK] = ACTIONS(1288),
    [aux_sym_encapsed_string_token1] = ACTIONS(1288),
    [anon_sym_DQUOTE] = ACTIONS(1288),
    [aux_sym_string_token1] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(1288),
    [anon_sym_LT_LT_LT] = ACTIONS(1288),
    [anon_sym_BQUOTE] = ACTIONS(1288),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [aux_sym_yield_expression_token1] = ACTIONS(1290),
    [aux_sym_include_expression_token1] = ACTIONS(1290),
    [aux_sym_include_once_expression_token1] = ACTIONS(1290),
    [aux_sym_require_expression_token1] = ACTIONS(1290),
    [aux_sym_require_once_expression_token1] = ACTIONS(1290),
    [sym_comment] = ACTIONS(5),
  },
  [494] = {
    [sym_text_interpolation] = STATE(494),
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_name] = ACTIONS(1017),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1015),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1017),
    [aux_sym_global_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_definition_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1017),
    [anon_sym_BSLASH] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [aux_sym_trait_declaration_token1] = ACTIONS(1017),
    [aux_sym_interface_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_case_token1] = ACTIONS(1017),
    [aux_sym_class_declaration_token1] = ACTIONS(1017),
    [aux_sym_final_modifier_token1] = ACTIONS(1017),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1017),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1017),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [aux_sym_cast_type_token1] = ACTIONS(1017),
    [aux_sym_echo_statement_token1] = ACTIONS(1017),
    [anon_sym_unset] = ACTIONS(1017),
    [aux_sym_declare_statement_token1] = ACTIONS(1017),
    [aux_sym_declare_statement_token2] = ACTIONS(1017),
    [sym_float] = ACTIONS(1017),
    [aux_sym_try_statement_token1] = ACTIONS(1017),
    [aux_sym_goto_statement_token1] = ACTIONS(1017),
    [aux_sym_continue_statement_token1] = ACTIONS(1017),
    [aux_sym_break_statement_token1] = ACTIONS(1017),
    [sym_integer] = ACTIONS(1017),
    [aux_sym_return_statement_token1] = ACTIONS(1017),
    [aux_sym_throw_expression_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token2] = ACTIONS(1017),
    [aux_sym_do_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token2] = ACTIONS(1017),
    [aux_sym_foreach_statement_token1] = ACTIONS(1017),
    [aux_sym_foreach_statement_token2] = ACTIONS(1017),
    [aux_sym_if_statement_token1] = ACTIONS(1017),
    [aux_sym_if_statement_token2] = ACTIONS(1017),
    [aux_sym_else_if_clause_token1] = ACTIONS(1017),
    [aux_sym_else_clause_token1] = ACTIONS(1017),
    [aux_sym_match_expression_token1] = ACTIONS(1017),
    [aux_sym_match_default_expression_token1] = ACTIONS(1017),
    [aux_sym_switch_statement_token1] = ACTIONS(1017),
    [aux_sym_switch_block_token1] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1015),
    [aux_sym_clone_expression_token1] = ACTIONS(1017),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1017),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [aux_sym__list_destructing_token1] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_self] = ACTIONS(1017),
    [anon_sym_parent] = ACTIONS(1017),
    [aux_sym__argument_name_token1] = ACTIONS(1017),
    [aux_sym__argument_name_token2] = ACTIONS(1017),
    [anon_sym_POUND_LBRACK] = ACTIONS(1015),
    [aux_sym_encapsed_string_token1] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [aux_sym_string_token1] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1015),
    [aux_sym_yield_expression_token1] = ACTIONS(1017),
    [aux_sym_include_expression_token1] = ACTIONS(1017),
    [aux_sym_include_once_expression_token1] = ACTIONS(1017),
    [aux_sym_require_expression_token1] = ACTIONS(1017),
    [aux_sym_require_once_expression_token1] = ACTIONS(1017),
    [sym_comment] = ACTIONS(5),
  },
  [495] = {
    [sym_text_interpolation] = STATE(495),
    [ts_builtin_sym_end] = ACTIONS(1292),
    [sym_name] = ACTIONS(1294),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1292),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1294),
    [aux_sym_global_declaration_token1] = ACTIONS(1294),
    [aux_sym_namespace_definition_token1] = ACTIONS(1294),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1294),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1294),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1294),
    [anon_sym_BSLASH] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [aux_sym_trait_declaration_token1] = ACTIONS(1294),
    [aux_sym_interface_declaration_token1] = ACTIONS(1294),
    [aux_sym_enum_declaration_token1] = ACTIONS(1294),
    [aux_sym_enum_case_token1] = ACTIONS(1294),
    [aux_sym_class_declaration_token1] = ACTIONS(1294),
    [aux_sym_final_modifier_token1] = ACTIONS(1294),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1294),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1294),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1294),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1294),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1294),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [aux_sym_cast_type_token1] = ACTIONS(1294),
    [aux_sym_echo_statement_token1] = ACTIONS(1294),
    [anon_sym_unset] = ACTIONS(1294),
    [aux_sym_declare_statement_token1] = ACTIONS(1294),
    [aux_sym_declare_statement_token2] = ACTIONS(1294),
    [sym_float] = ACTIONS(1294),
    [aux_sym_try_statement_token1] = ACTIONS(1294),
    [aux_sym_goto_statement_token1] = ACTIONS(1294),
    [aux_sym_continue_statement_token1] = ACTIONS(1294),
    [aux_sym_break_statement_token1] = ACTIONS(1294),
    [sym_integer] = ACTIONS(1294),
    [aux_sym_return_statement_token1] = ACTIONS(1294),
    [aux_sym_throw_expression_token1] = ACTIONS(1294),
    [aux_sym_while_statement_token1] = ACTIONS(1294),
    [aux_sym_while_statement_token2] = ACTIONS(1294),
    [aux_sym_do_statement_token1] = ACTIONS(1294),
    [aux_sym_for_statement_token1] = ACTIONS(1294),
    [aux_sym_for_statement_token2] = ACTIONS(1294),
    [aux_sym_foreach_statement_token1] = ACTIONS(1294),
    [aux_sym_foreach_statement_token2] = ACTIONS(1294),
    [aux_sym_if_statement_token1] = ACTIONS(1294),
    [aux_sym_if_statement_token2] = ACTIONS(1294),
    [aux_sym_else_if_clause_token1] = ACTIONS(1294),
    [aux_sym_else_clause_token1] = ACTIONS(1294),
    [aux_sym_match_expression_token1] = ACTIONS(1294),
    [aux_sym_match_default_expression_token1] = ACTIONS(1294),
    [aux_sym_switch_statement_token1] = ACTIONS(1294),
    [aux_sym_switch_block_token1] = ACTIONS(1294),
    [anon_sym_PLUS] = ACTIONS(1294),
    [anon_sym_DASH] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_AT] = ACTIONS(1292),
    [aux_sym_clone_expression_token1] = ACTIONS(1294),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1294),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1294),
    [anon_sym_DASH_DASH] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1292),
    [aux_sym__list_destructing_token1] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_self] = ACTIONS(1294),
    [anon_sym_parent] = ACTIONS(1294),
    [aux_sym__argument_name_token1] = ACTIONS(1294),
    [aux_sym__argument_name_token2] = ACTIONS(1294),
    [anon_sym_POUND_LBRACK] = ACTIONS(1292),
    [aux_sym_encapsed_string_token1] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1292),
    [aux_sym_string_token1] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1292),
    [anon_sym_LT_LT_LT] = ACTIONS(1292),
    [anon_sym_BQUOTE] = ACTIONS(1292),
    [anon_sym_DOLLAR] = ACTIONS(1292),
    [aux_sym_yield_expression_token1] = ACTIONS(1294),
    [aux_sym_include_expression_token1] = ACTIONS(1294),
    [aux_sym_include_once_expression_token1] = ACTIONS(1294),
    [aux_sym_require_expression_token1] = ACTIONS(1294),
    [aux_sym_require_once_expression_token1] = ACTIONS(1294),
    [sym_comment] = ACTIONS(5),
  },
  [496] = {
    [sym_text_interpolation] = STATE(496),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(906),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(598),
    [sym_member_access_expression] = STATE(598),
    [sym_nullsafe_member_access_expression] = STATE(598),
    [sym_scoped_property_access_expression] = STATE(598),
    [sym_function_call_expression] = STATE(579),
    [sym_scoped_call_expression] = STATE(579),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(579),
    [sym_nullsafe_member_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(579),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(579),
    [sym_variable_name] = STATE(579),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(573),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(587),
    [aux_sym_clone_expression_token1] = ACTIONS(591),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_include_expression_token1] = ACTIONS(619),
    [aux_sym_include_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(5),
  },
  [497] = {
    [sym_text_interpolation] = STATE(497),
    [ts_builtin_sym_end] = ACTIONS(1296),
    [sym_name] = ACTIONS(1298),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1296),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1298),
    [aux_sym_global_declaration_token1] = ACTIONS(1298),
    [aux_sym_namespace_definition_token1] = ACTIONS(1298),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1298),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1298),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1298),
    [anon_sym_BSLASH] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1296),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [aux_sym_trait_declaration_token1] = ACTIONS(1298),
    [aux_sym_interface_declaration_token1] = ACTIONS(1298),
    [aux_sym_enum_declaration_token1] = ACTIONS(1298),
    [aux_sym_enum_case_token1] = ACTIONS(1298),
    [aux_sym_class_declaration_token1] = ACTIONS(1298),
    [aux_sym_final_modifier_token1] = ACTIONS(1298),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1298),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1298),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1298),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1298),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1298),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [aux_sym_cast_type_token1] = ACTIONS(1298),
    [aux_sym_echo_statement_token1] = ACTIONS(1298),
    [anon_sym_unset] = ACTIONS(1298),
    [aux_sym_declare_statement_token1] = ACTIONS(1298),
    [aux_sym_declare_statement_token2] = ACTIONS(1298),
    [sym_float] = ACTIONS(1298),
    [aux_sym_try_statement_token1] = ACTIONS(1298),
    [aux_sym_goto_statement_token1] = ACTIONS(1298),
    [aux_sym_continue_statement_token1] = ACTIONS(1298),
    [aux_sym_break_statement_token1] = ACTIONS(1298),
    [sym_integer] = ACTIONS(1298),
    [aux_sym_return_statement_token1] = ACTIONS(1298),
    [aux_sym_throw_expression_token1] = ACTIONS(1298),
    [aux_sym_while_statement_token1] = ACTIONS(1298),
    [aux_sym_while_statement_token2] = ACTIONS(1298),
    [aux_sym_do_statement_token1] = ACTIONS(1298),
    [aux_sym_for_statement_token1] = ACTIONS(1298),
    [aux_sym_for_statement_token2] = ACTIONS(1298),
    [aux_sym_foreach_statement_token1] = ACTIONS(1298),
    [aux_sym_foreach_statement_token2] = ACTIONS(1298),
    [aux_sym_if_statement_token1] = ACTIONS(1298),
    [aux_sym_if_statement_token2] = ACTIONS(1298),
    [aux_sym_else_if_clause_token1] = ACTIONS(1298),
    [aux_sym_else_clause_token1] = ACTIONS(1298),
    [aux_sym_match_expression_token1] = ACTIONS(1298),
    [aux_sym_match_default_expression_token1] = ACTIONS(1298),
    [aux_sym_switch_statement_token1] = ACTIONS(1298),
    [aux_sym_switch_block_token1] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(1298),
    [anon_sym_DASH] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_BANG] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1296),
    [aux_sym_clone_expression_token1] = ACTIONS(1298),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1298),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1298),
    [anon_sym_DASH_DASH] = ACTIONS(1296),
    [anon_sym_PLUS_PLUS] = ACTIONS(1296),
    [aux_sym__list_destructing_token1] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_self] = ACTIONS(1298),
    [anon_sym_parent] = ACTIONS(1298),
    [aux_sym__argument_name_token1] = ACTIONS(1298),
    [aux_sym__argument_name_token2] = ACTIONS(1298),
    [anon_sym_POUND_LBRACK] = ACTIONS(1296),
    [aux_sym_encapsed_string_token1] = ACTIONS(1296),
    [anon_sym_DQUOTE] = ACTIONS(1296),
    [aux_sym_string_token1] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1296),
    [anon_sym_LT_LT_LT] = ACTIONS(1296),
    [anon_sym_BQUOTE] = ACTIONS(1296),
    [anon_sym_DOLLAR] = ACTIONS(1296),
    [aux_sym_yield_expression_token1] = ACTIONS(1298),
    [aux_sym_include_expression_token1] = ACTIONS(1298),
    [aux_sym_include_once_expression_token1] = ACTIONS(1298),
    [aux_sym_require_expression_token1] = ACTIONS(1298),
    [aux_sym_require_once_expression_token1] = ACTIONS(1298),
    [sym_comment] = ACTIONS(5),
  },
  [498] = {
    [sym_text_interpolation] = STATE(498),
    [ts_builtin_sym_end] = ACTIONS(1300),
    [sym_name] = ACTIONS(1302),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1300),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1302),
    [aux_sym_global_declaration_token1] = ACTIONS(1302),
    [aux_sym_namespace_definition_token1] = ACTIONS(1302),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1302),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1302),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1302),
    [anon_sym_BSLASH] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(1300),
    [anon_sym_RBRACE] = ACTIONS(1300),
    [aux_sym_trait_declaration_token1] = ACTIONS(1302),
    [aux_sym_interface_declaration_token1] = ACTIONS(1302),
    [aux_sym_enum_declaration_token1] = ACTIONS(1302),
    [aux_sym_enum_case_token1] = ACTIONS(1302),
    [aux_sym_class_declaration_token1] = ACTIONS(1302),
    [aux_sym_final_modifier_token1] = ACTIONS(1302),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1302),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1302),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1302),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1302),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1302),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1302),
    [anon_sym_LPAREN] = ACTIONS(1300),
    [aux_sym_cast_type_token1] = ACTIONS(1302),
    [aux_sym_echo_statement_token1] = ACTIONS(1302),
    [anon_sym_unset] = ACTIONS(1302),
    [aux_sym_declare_statement_token1] = ACTIONS(1302),
    [aux_sym_declare_statement_token2] = ACTIONS(1302),
    [sym_float] = ACTIONS(1302),
    [aux_sym_try_statement_token1] = ACTIONS(1302),
    [aux_sym_goto_statement_token1] = ACTIONS(1302),
    [aux_sym_continue_statement_token1] = ACTIONS(1302),
    [aux_sym_break_statement_token1] = ACTIONS(1302),
    [sym_integer] = ACTIONS(1302),
    [aux_sym_return_statement_token1] = ACTIONS(1302),
    [aux_sym_throw_expression_token1] = ACTIONS(1302),
    [aux_sym_while_statement_token1] = ACTIONS(1302),
    [aux_sym_while_statement_token2] = ACTIONS(1302),
    [aux_sym_do_statement_token1] = ACTIONS(1302),
    [aux_sym_for_statement_token1] = ACTIONS(1302),
    [aux_sym_for_statement_token2] = ACTIONS(1302),
    [aux_sym_foreach_statement_token1] = ACTIONS(1302),
    [aux_sym_foreach_statement_token2] = ACTIONS(1302),
    [aux_sym_if_statement_token1] = ACTIONS(1302),
    [aux_sym_if_statement_token2] = ACTIONS(1302),
    [aux_sym_else_if_clause_token1] = ACTIONS(1302),
    [aux_sym_else_clause_token1] = ACTIONS(1302),
    [aux_sym_match_expression_token1] = ACTIONS(1302),
    [aux_sym_match_default_expression_token1] = ACTIONS(1302),
    [aux_sym_switch_statement_token1] = ACTIONS(1302),
    [aux_sym_switch_block_token1] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_TILDE] = ACTIONS(1300),
    [anon_sym_BANG] = ACTIONS(1300),
    [anon_sym_AT] = ACTIONS(1300),
    [aux_sym_clone_expression_token1] = ACTIONS(1302),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1302),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1302),
    [anon_sym_DASH_DASH] = ACTIONS(1300),
    [anon_sym_PLUS_PLUS] = ACTIONS(1300),
    [aux_sym__list_destructing_token1] = ACTIONS(1302),
    [anon_sym_LBRACK] = ACTIONS(1300),
    [anon_sym_self] = ACTIONS(1302),
    [anon_sym_parent] = ACTIONS(1302),
    [aux_sym__argument_name_token1] = ACTIONS(1302),
    [aux_sym__argument_name_token2] = ACTIONS(1302),
    [anon_sym_POUND_LBRACK] = ACTIONS(1300),
    [aux_sym_encapsed_string_token1] = ACTIONS(1300),
    [anon_sym_DQUOTE] = ACTIONS(1300),
    [aux_sym_string_token1] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(1300),
    [anon_sym_LT_LT_LT] = ACTIONS(1300),
    [anon_sym_BQUOTE] = ACTIONS(1300),
    [anon_sym_DOLLAR] = ACTIONS(1300),
    [aux_sym_yield_expression_token1] = ACTIONS(1302),
    [aux_sym_include_expression_token1] = ACTIONS(1302),
    [aux_sym_include_once_expression_token1] = ACTIONS(1302),
    [aux_sym_require_expression_token1] = ACTIONS(1302),
    [aux_sym_require_once_expression_token1] = ACTIONS(1302),
    [sym_comment] = ACTIONS(5),
  },
  [499] = {
    [sym_text_interpolation] = STATE(499),
    [ts_builtin_sym_end] = ACTIONS(1304),
    [sym_name] = ACTIONS(1306),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1304),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1306),
    [aux_sym_global_declaration_token1] = ACTIONS(1306),
    [aux_sym_namespace_definition_token1] = ACTIONS(1306),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1306),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1306),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1306),
    [anon_sym_BSLASH] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_RBRACE] = ACTIONS(1304),
    [aux_sym_trait_declaration_token1] = ACTIONS(1306),
    [aux_sym_interface_declaration_token1] = ACTIONS(1306),
    [aux_sym_enum_declaration_token1] = ACTIONS(1306),
    [aux_sym_enum_case_token1] = ACTIONS(1306),
    [aux_sym_class_declaration_token1] = ACTIONS(1306),
    [aux_sym_final_modifier_token1] = ACTIONS(1306),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1306),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1306),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1306),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1306),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1306),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [aux_sym_cast_type_token1] = ACTIONS(1306),
    [aux_sym_echo_statement_token1] = ACTIONS(1306),
    [anon_sym_unset] = ACTIONS(1306),
    [aux_sym_declare_statement_token1] = ACTIONS(1306),
    [aux_sym_declare_statement_token2] = ACTIONS(1306),
    [sym_float] = ACTIONS(1306),
    [aux_sym_try_statement_token1] = ACTIONS(1306),
    [aux_sym_goto_statement_token1] = ACTIONS(1306),
    [aux_sym_continue_statement_token1] = ACTIONS(1306),
    [aux_sym_break_statement_token1] = ACTIONS(1306),
    [sym_integer] = ACTIONS(1306),
    [aux_sym_return_statement_token1] = ACTIONS(1306),
    [aux_sym_throw_expression_token1] = ACTIONS(1306),
    [aux_sym_while_statement_token1] = ACTIONS(1306),
    [aux_sym_while_statement_token2] = ACTIONS(1306),
    [aux_sym_do_statement_token1] = ACTIONS(1306),
    [aux_sym_for_statement_token1] = ACTIONS(1306),
    [aux_sym_for_statement_token2] = ACTIONS(1306),
    [aux_sym_foreach_statement_token1] = ACTIONS(1306),
    [aux_sym_foreach_statement_token2] = ACTIONS(1306),
    [aux_sym_if_statement_token1] = ACTIONS(1306),
    [aux_sym_if_statement_token2] = ACTIONS(1306),
    [aux_sym_else_if_clause_token1] = ACTIONS(1306),
    [aux_sym_else_clause_token1] = ACTIONS(1306),
    [aux_sym_match_expression_token1] = ACTIONS(1306),
    [aux_sym_match_default_expression_token1] = ACTIONS(1306),
    [aux_sym_switch_statement_token1] = ACTIONS(1306),
    [aux_sym_switch_block_token1] = ACTIONS(1306),
    [anon_sym_PLUS] = ACTIONS(1306),
    [anon_sym_DASH] = ACTIONS(1306),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_AT] = ACTIONS(1304),
    [aux_sym_clone_expression_token1] = ACTIONS(1306),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1306),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1306),
    [anon_sym_DASH_DASH] = ACTIONS(1304),
    [anon_sym_PLUS_PLUS] = ACTIONS(1304),
    [aux_sym__list_destructing_token1] = ACTIONS(1306),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_self] = ACTIONS(1306),
    [anon_sym_parent] = ACTIONS(1306),
    [aux_sym__argument_name_token1] = ACTIONS(1306),
    [aux_sym__argument_name_token2] = ACTIONS(1306),
    [anon_sym_POUND_LBRACK] = ACTIONS(1304),
    [aux_sym_encapsed_string_token1] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [aux_sym_string_token1] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [aux_sym_yield_expression_token1] = ACTIONS(1306),
    [aux_sym_include_expression_token1] = ACTIONS(1306),
    [aux_sym_include_once_expression_token1] = ACTIONS(1306),
    [aux_sym_require_expression_token1] = ACTIONS(1306),
    [aux_sym_require_once_expression_token1] = ACTIONS(1306),
    [sym_comment] = ACTIONS(5),
  },
  [500] = {
    [sym_text_interpolation] = STATE(500),
    [ts_builtin_sym_end] = ACTIONS(1308),
    [sym_name] = ACTIONS(1310),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1308),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1310),
    [aux_sym_global_declaration_token1] = ACTIONS(1310),
    [aux_sym_namespace_definition_token1] = ACTIONS(1310),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1310),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1310),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1310),
    [anon_sym_BSLASH] = ACTIONS(1308),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [aux_sym_trait_declaration_token1] = ACTIONS(1310),
    [aux_sym_interface_declaration_token1] = ACTIONS(1310),
    [aux_sym_enum_declaration_token1] = ACTIONS(1310),
    [aux_sym_enum_case_token1] = ACTIONS(1310),
    [aux_sym_class_declaration_token1] = ACTIONS(1310),
    [aux_sym_final_modifier_token1] = ACTIONS(1310),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1310),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1310),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1310),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1310),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1310),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [aux_sym_cast_type_token1] = ACTIONS(1310),
    [aux_sym_echo_statement_token1] = ACTIONS(1310),
    [anon_sym_unset] = ACTIONS(1310),
    [aux_sym_declare_statement_token1] = ACTIONS(1310),
    [aux_sym_declare_statement_token2] = ACTIONS(1310),
    [sym_float] = ACTIONS(1310),
    [aux_sym_try_statement_token1] = ACTIONS(1310),
    [aux_sym_goto_statement_token1] = ACTIONS(1310),
    [aux_sym_continue_statement_token1] = ACTIONS(1310),
    [aux_sym_break_statement_token1] = ACTIONS(1310),
    [sym_integer] = ACTIONS(1310),
    [aux_sym_return_statement_token1] = ACTIONS(1310),
    [aux_sym_throw_expression_token1] = ACTIONS(1310),
    [aux_sym_while_statement_token1] = ACTIONS(1310),
    [aux_sym_while_statement_token2] = ACTIONS(1310),
    [aux_sym_do_statement_token1] = ACTIONS(1310),
    [aux_sym_for_statement_token1] = ACTIONS(1310),
    [aux_sym_for_statement_token2] = ACTIONS(1310),
    [aux_sym_foreach_statement_token1] = ACTIONS(1310),
    [aux_sym_foreach_statement_token2] = ACTIONS(1310),
    [aux_sym_if_statement_token1] = ACTIONS(1310),
    [aux_sym_if_statement_token2] = ACTIONS(1310),
    [aux_sym_else_if_clause_token1] = ACTIONS(1310),
    [aux_sym_else_clause_token1] = ACTIONS(1310),
    [aux_sym_match_expression_token1] = ACTIONS(1310),
    [aux_sym_match_default_expression_token1] = ACTIONS(1310),
    [aux_sym_switch_statement_token1] = ACTIONS(1310),
    [aux_sym_switch_block_token1] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(1308),
    [aux_sym_clone_expression_token1] = ACTIONS(1310),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1310),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [aux_sym__list_destructing_token1] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_self] = ACTIONS(1310),
    [anon_sym_parent] = ACTIONS(1310),
    [aux_sym__argument_name_token1] = ACTIONS(1310),
    [aux_sym__argument_name_token2] = ACTIONS(1310),
    [anon_sym_POUND_LBRACK] = ACTIONS(1308),
    [aux_sym_encapsed_string_token1] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [aux_sym_string_token1] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_LT_LT_LT] = ACTIONS(1308),
    [anon_sym_BQUOTE] = ACTIONS(1308),
    [anon_sym_DOLLAR] = ACTIONS(1308),
    [aux_sym_yield_expression_token1] = ACTIONS(1310),
    [aux_sym_include_expression_token1] = ACTIONS(1310),
    [aux_sym_include_once_expression_token1] = ACTIONS(1310),
    [aux_sym_require_expression_token1] = ACTIONS(1310),
    [aux_sym_require_once_expression_token1] = ACTIONS(1310),
    [sym_comment] = ACTIONS(5),
  },
  [501] = {
    [sym_text_interpolation] = STATE(501),
    [ts_builtin_sym_end] = ACTIONS(1312),
    [sym_name] = ACTIONS(1314),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1312),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1314),
    [aux_sym_global_declaration_token1] = ACTIONS(1314),
    [aux_sym_namespace_definition_token1] = ACTIONS(1314),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1314),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1314),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1314),
    [anon_sym_BSLASH] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_RBRACE] = ACTIONS(1312),
    [aux_sym_trait_declaration_token1] = ACTIONS(1314),
    [aux_sym_interface_declaration_token1] = ACTIONS(1314),
    [aux_sym_enum_declaration_token1] = ACTIONS(1314),
    [aux_sym_enum_case_token1] = ACTIONS(1314),
    [aux_sym_class_declaration_token1] = ACTIONS(1314),
    [aux_sym_final_modifier_token1] = ACTIONS(1314),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1314),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1314),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1314),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1314),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1314),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [aux_sym_cast_type_token1] = ACTIONS(1314),
    [aux_sym_echo_statement_token1] = ACTIONS(1314),
    [anon_sym_unset] = ACTIONS(1314),
    [aux_sym_declare_statement_token1] = ACTIONS(1314),
    [aux_sym_declare_statement_token2] = ACTIONS(1314),
    [sym_float] = ACTIONS(1314),
    [aux_sym_try_statement_token1] = ACTIONS(1314),
    [aux_sym_goto_statement_token1] = ACTIONS(1314),
    [aux_sym_continue_statement_token1] = ACTIONS(1314),
    [aux_sym_break_statement_token1] = ACTIONS(1314),
    [sym_integer] = ACTIONS(1314),
    [aux_sym_return_statement_token1] = ACTIONS(1314),
    [aux_sym_throw_expression_token1] = ACTIONS(1314),
    [aux_sym_while_statement_token1] = ACTIONS(1314),
    [aux_sym_while_statement_token2] = ACTIONS(1314),
    [aux_sym_do_statement_token1] = ACTIONS(1314),
    [aux_sym_for_statement_token1] = ACTIONS(1314),
    [aux_sym_for_statement_token2] = ACTIONS(1314),
    [aux_sym_foreach_statement_token1] = ACTIONS(1314),
    [aux_sym_foreach_statement_token2] = ACTIONS(1314),
    [aux_sym_if_statement_token1] = ACTIONS(1314),
    [aux_sym_if_statement_token2] = ACTIONS(1314),
    [aux_sym_else_if_clause_token1] = ACTIONS(1314),
    [aux_sym_else_clause_token1] = ACTIONS(1314),
    [aux_sym_match_expression_token1] = ACTIONS(1314),
    [aux_sym_match_default_expression_token1] = ACTIONS(1314),
    [aux_sym_switch_statement_token1] = ACTIONS(1314),
    [aux_sym_switch_block_token1] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1314),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1312),
    [anon_sym_AT] = ACTIONS(1312),
    [aux_sym_clone_expression_token1] = ACTIONS(1314),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1314),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1312),
    [anon_sym_PLUS_PLUS] = ACTIONS(1312),
    [aux_sym__list_destructing_token1] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_self] = ACTIONS(1314),
    [anon_sym_parent] = ACTIONS(1314),
    [aux_sym__argument_name_token1] = ACTIONS(1314),
    [aux_sym__argument_name_token2] = ACTIONS(1314),
    [anon_sym_POUND_LBRACK] = ACTIONS(1312),
    [aux_sym_encapsed_string_token1] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [aux_sym_string_token1] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [anon_sym_LT_LT_LT] = ACTIONS(1312),
    [anon_sym_BQUOTE] = ACTIONS(1312),
    [anon_sym_DOLLAR] = ACTIONS(1312),
    [aux_sym_yield_expression_token1] = ACTIONS(1314),
    [aux_sym_include_expression_token1] = ACTIONS(1314),
    [aux_sym_include_once_expression_token1] = ACTIONS(1314),
    [aux_sym_require_expression_token1] = ACTIONS(1314),
    [aux_sym_require_once_expression_token1] = ACTIONS(1314),
    [sym_comment] = ACTIONS(5),
  },
  [502] = {
    [sym_text_interpolation] = STATE(502),
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_name] = ACTIONS(1318),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1316),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1318),
    [aux_sym_global_declaration_token1] = ACTIONS(1318),
    [aux_sym_namespace_definition_token1] = ACTIONS(1318),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1318),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1318),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1318),
    [anon_sym_BSLASH] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [aux_sym_trait_declaration_token1] = ACTIONS(1318),
    [aux_sym_interface_declaration_token1] = ACTIONS(1318),
    [aux_sym_enum_declaration_token1] = ACTIONS(1318),
    [aux_sym_enum_case_token1] = ACTIONS(1318),
    [aux_sym_class_declaration_token1] = ACTIONS(1318),
    [aux_sym_final_modifier_token1] = ACTIONS(1318),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1318),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1318),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1318),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1318),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1318),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [aux_sym_cast_type_token1] = ACTIONS(1318),
    [aux_sym_echo_statement_token1] = ACTIONS(1318),
    [anon_sym_unset] = ACTIONS(1318),
    [aux_sym_declare_statement_token1] = ACTIONS(1318),
    [aux_sym_declare_statement_token2] = ACTIONS(1318),
    [sym_float] = ACTIONS(1318),
    [aux_sym_try_statement_token1] = ACTIONS(1318),
    [aux_sym_goto_statement_token1] = ACTIONS(1318),
    [aux_sym_continue_statement_token1] = ACTIONS(1318),
    [aux_sym_break_statement_token1] = ACTIONS(1318),
    [sym_integer] = ACTIONS(1318),
    [aux_sym_return_statement_token1] = ACTIONS(1318),
    [aux_sym_throw_expression_token1] = ACTIONS(1318),
    [aux_sym_while_statement_token1] = ACTIONS(1318),
    [aux_sym_while_statement_token2] = ACTIONS(1318),
    [aux_sym_do_statement_token1] = ACTIONS(1318),
    [aux_sym_for_statement_token1] = ACTIONS(1318),
    [aux_sym_for_statement_token2] = ACTIONS(1318),
    [aux_sym_foreach_statement_token1] = ACTIONS(1318),
    [aux_sym_foreach_statement_token2] = ACTIONS(1318),
    [aux_sym_if_statement_token1] = ACTIONS(1318),
    [aux_sym_if_statement_token2] = ACTIONS(1318),
    [aux_sym_else_if_clause_token1] = ACTIONS(1318),
    [aux_sym_else_clause_token1] = ACTIONS(1318),
    [aux_sym_match_expression_token1] = ACTIONS(1318),
    [aux_sym_match_default_expression_token1] = ACTIONS(1318),
    [aux_sym_switch_statement_token1] = ACTIONS(1318),
    [aux_sym_switch_block_token1] = ACTIONS(1318),
    [anon_sym_PLUS] = ACTIONS(1318),
    [anon_sym_DASH] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [aux_sym_clone_expression_token1] = ACTIONS(1318),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1318),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1318),
    [anon_sym_DASH_DASH] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1316),
    [aux_sym__list_destructing_token1] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_self] = ACTIONS(1318),
    [anon_sym_parent] = ACTIONS(1318),
    [aux_sym__argument_name_token1] = ACTIONS(1318),
    [aux_sym__argument_name_token2] = ACTIONS(1318),
    [anon_sym_POUND_LBRACK] = ACTIONS(1316),
    [aux_sym_encapsed_string_token1] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [aux_sym_string_token1] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_LT_LT_LT] = ACTIONS(1316),
    [anon_sym_BQUOTE] = ACTIONS(1316),
    [anon_sym_DOLLAR] = ACTIONS(1316),
    [aux_sym_yield_expression_token1] = ACTIONS(1318),
    [aux_sym_include_expression_token1] = ACTIONS(1318),
    [aux_sym_include_once_expression_token1] = ACTIONS(1318),
    [aux_sym_require_expression_token1] = ACTIONS(1318),
    [aux_sym_require_once_expression_token1] = ACTIONS(1318),
    [sym_comment] = ACTIONS(5),
  },
  [503] = {
    [sym_text_interpolation] = STATE(503),
    [ts_builtin_sym_end] = ACTIONS(1320),
    [sym_name] = ACTIONS(1322),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1320),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1322),
    [aux_sym_global_declaration_token1] = ACTIONS(1322),
    [aux_sym_namespace_definition_token1] = ACTIONS(1322),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1322),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1322),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1322),
    [anon_sym_BSLASH] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [aux_sym_trait_declaration_token1] = ACTIONS(1322),
    [aux_sym_interface_declaration_token1] = ACTIONS(1322),
    [aux_sym_enum_declaration_token1] = ACTIONS(1322),
    [aux_sym_enum_case_token1] = ACTIONS(1322),
    [aux_sym_class_declaration_token1] = ACTIONS(1322),
    [aux_sym_final_modifier_token1] = ACTIONS(1322),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1322),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1322),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1322),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1322),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1322),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1320),
    [aux_sym_cast_type_token1] = ACTIONS(1322),
    [aux_sym_echo_statement_token1] = ACTIONS(1322),
    [anon_sym_unset] = ACTIONS(1322),
    [aux_sym_declare_statement_token1] = ACTIONS(1322),
    [aux_sym_declare_statement_token2] = ACTIONS(1322),
    [sym_float] = ACTIONS(1322),
    [aux_sym_try_statement_token1] = ACTIONS(1322),
    [aux_sym_goto_statement_token1] = ACTIONS(1322),
    [aux_sym_continue_statement_token1] = ACTIONS(1322),
    [aux_sym_break_statement_token1] = ACTIONS(1322),
    [sym_integer] = ACTIONS(1322),
    [aux_sym_return_statement_token1] = ACTIONS(1322),
    [aux_sym_throw_expression_token1] = ACTIONS(1322),
    [aux_sym_while_statement_token1] = ACTIONS(1322),
    [aux_sym_while_statement_token2] = ACTIONS(1322),
    [aux_sym_do_statement_token1] = ACTIONS(1322),
    [aux_sym_for_statement_token1] = ACTIONS(1322),
    [aux_sym_for_statement_token2] = ACTIONS(1322),
    [aux_sym_foreach_statement_token1] = ACTIONS(1322),
    [aux_sym_foreach_statement_token2] = ACTIONS(1322),
    [aux_sym_if_statement_token1] = ACTIONS(1322),
    [aux_sym_if_statement_token2] = ACTIONS(1322),
    [aux_sym_else_if_clause_token1] = ACTIONS(1322),
    [aux_sym_else_clause_token1] = ACTIONS(1322),
    [aux_sym_match_expression_token1] = ACTIONS(1322),
    [aux_sym_match_default_expression_token1] = ACTIONS(1322),
    [aux_sym_switch_statement_token1] = ACTIONS(1322),
    [aux_sym_switch_block_token1] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1320),
    [anon_sym_BANG] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(1320),
    [aux_sym_clone_expression_token1] = ACTIONS(1322),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1322),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1320),
    [aux_sym__list_destructing_token1] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_self] = ACTIONS(1322),
    [anon_sym_parent] = ACTIONS(1322),
    [aux_sym__argument_name_token1] = ACTIONS(1322),
    [aux_sym__argument_name_token2] = ACTIONS(1322),
    [anon_sym_POUND_LBRACK] = ACTIONS(1320),
    [aux_sym_encapsed_string_token1] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1320),
    [aux_sym_string_token1] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(1320),
    [aux_sym_yield_expression_token1] = ACTIONS(1322),
    [aux_sym_include_expression_token1] = ACTIONS(1322),
    [aux_sym_include_once_expression_token1] = ACTIONS(1322),
    [aux_sym_require_expression_token1] = ACTIONS(1322),
    [aux_sym_require_once_expression_token1] = ACTIONS(1322),
    [sym_comment] = ACTIONS(5),
  },
  [504] = {
    [sym_text_interpolation] = STATE(504),
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_name] = ACTIONS(1326),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1324),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1326),
    [aux_sym_global_declaration_token1] = ACTIONS(1326),
    [aux_sym_namespace_definition_token1] = ACTIONS(1326),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1326),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1326),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1326),
    [anon_sym_BSLASH] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_RBRACE] = ACTIONS(1324),
    [aux_sym_trait_declaration_token1] = ACTIONS(1326),
    [aux_sym_interface_declaration_token1] = ACTIONS(1326),
    [aux_sym_enum_declaration_token1] = ACTIONS(1326),
    [aux_sym_enum_case_token1] = ACTIONS(1326),
    [aux_sym_class_declaration_token1] = ACTIONS(1326),
    [aux_sym_final_modifier_token1] = ACTIONS(1326),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1326),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1326),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1326),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1326),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1326),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [aux_sym_cast_type_token1] = ACTIONS(1326),
    [aux_sym_echo_statement_token1] = ACTIONS(1326),
    [anon_sym_unset] = ACTIONS(1326),
    [aux_sym_declare_statement_token1] = ACTIONS(1326),
    [aux_sym_declare_statement_token2] = ACTIONS(1326),
    [sym_float] = ACTIONS(1326),
    [aux_sym_try_statement_token1] = ACTIONS(1326),
    [aux_sym_goto_statement_token1] = ACTIONS(1326),
    [aux_sym_continue_statement_token1] = ACTIONS(1326),
    [aux_sym_break_statement_token1] = ACTIONS(1326),
    [sym_integer] = ACTIONS(1326),
    [aux_sym_return_statement_token1] = ACTIONS(1326),
    [aux_sym_throw_expression_token1] = ACTIONS(1326),
    [aux_sym_while_statement_token1] = ACTIONS(1326),
    [aux_sym_while_statement_token2] = ACTIONS(1326),
    [aux_sym_do_statement_token1] = ACTIONS(1326),
    [aux_sym_for_statement_token1] = ACTIONS(1326),
    [aux_sym_for_statement_token2] = ACTIONS(1326),
    [aux_sym_foreach_statement_token1] = ACTIONS(1326),
    [aux_sym_foreach_statement_token2] = ACTIONS(1326),
    [aux_sym_if_statement_token1] = ACTIONS(1326),
    [aux_sym_if_statement_token2] = ACTIONS(1326),
    [aux_sym_else_if_clause_token1] = ACTIONS(1326),
    [aux_sym_else_clause_token1] = ACTIONS(1326),
    [aux_sym_match_expression_token1] = ACTIONS(1326),
    [aux_sym_match_default_expression_token1] = ACTIONS(1326),
    [aux_sym_switch_statement_token1] = ACTIONS(1326),
    [aux_sym_switch_block_token1] = ACTIONS(1326),
    [anon_sym_PLUS] = ACTIONS(1326),
    [anon_sym_DASH] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_BANG] = ACTIONS(1324),
    [anon_sym_AT] = ACTIONS(1324),
    [aux_sym_clone_expression_token1] = ACTIONS(1326),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1326),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1326),
    [anon_sym_DASH_DASH] = ACTIONS(1324),
    [anon_sym_PLUS_PLUS] = ACTIONS(1324),
    [aux_sym__list_destructing_token1] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_self] = ACTIONS(1326),
    [anon_sym_parent] = ACTIONS(1326),
    [aux_sym__argument_name_token1] = ACTIONS(1326),
    [aux_sym__argument_name_token2] = ACTIONS(1326),
    [anon_sym_POUND_LBRACK] = ACTIONS(1324),
    [aux_sym_encapsed_string_token1] = ACTIONS(1324),
    [anon_sym_DQUOTE] = ACTIONS(1324),
    [aux_sym_string_token1] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1324),
    [anon_sym_LT_LT_LT] = ACTIONS(1324),
    [anon_sym_BQUOTE] = ACTIONS(1324),
    [anon_sym_DOLLAR] = ACTIONS(1324),
    [aux_sym_yield_expression_token1] = ACTIONS(1326),
    [aux_sym_include_expression_token1] = ACTIONS(1326),
    [aux_sym_include_once_expression_token1] = ACTIONS(1326),
    [aux_sym_require_expression_token1] = ACTIONS(1326),
    [aux_sym_require_once_expression_token1] = ACTIONS(1326),
    [sym_comment] = ACTIONS(5),
  },
  [505] = {
    [sym_text_interpolation] = STATE(505),
    [ts_builtin_sym_end] = ACTIONS(1328),
    [sym_name] = ACTIONS(1330),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1328),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1330),
    [aux_sym_global_declaration_token1] = ACTIONS(1330),
    [aux_sym_namespace_definition_token1] = ACTIONS(1330),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1330),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1330),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1330),
    [anon_sym_BSLASH] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_RBRACE] = ACTIONS(1328),
    [aux_sym_trait_declaration_token1] = ACTIONS(1330),
    [aux_sym_interface_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_declaration_token1] = ACTIONS(1330),
    [aux_sym_enum_case_token1] = ACTIONS(1330),
    [aux_sym_class_declaration_token1] = ACTIONS(1330),
    [aux_sym_final_modifier_token1] = ACTIONS(1330),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1330),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1330),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1330),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1330),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1330),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(1328),
    [aux_sym_cast_type_token1] = ACTIONS(1330),
    [aux_sym_echo_statement_token1] = ACTIONS(1330),
    [anon_sym_unset] = ACTIONS(1330),
    [aux_sym_declare_statement_token1] = ACTIONS(1330),
    [aux_sym_declare_statement_token2] = ACTIONS(1330),
    [sym_float] = ACTIONS(1330),
    [aux_sym_try_statement_token1] = ACTIONS(1330),
    [aux_sym_goto_statement_token1] = ACTIONS(1330),
    [aux_sym_continue_statement_token1] = ACTIONS(1330),
    [aux_sym_break_statement_token1] = ACTIONS(1330),
    [sym_integer] = ACTIONS(1330),
    [aux_sym_return_statement_token1] = ACTIONS(1330),
    [aux_sym_throw_expression_token1] = ACTIONS(1330),
    [aux_sym_while_statement_token1] = ACTIONS(1330),
    [aux_sym_while_statement_token2] = ACTIONS(1330),
    [aux_sym_do_statement_token1] = ACTIONS(1330),
    [aux_sym_for_statement_token1] = ACTIONS(1330),
    [aux_sym_for_statement_token2] = ACTIONS(1330),
    [aux_sym_foreach_statement_token1] = ACTIONS(1330),
    [aux_sym_foreach_statement_token2] = ACTIONS(1330),
    [aux_sym_if_statement_token1] = ACTIONS(1330),
    [aux_sym_if_statement_token2] = ACTIONS(1330),
    [aux_sym_else_if_clause_token1] = ACTIONS(1330),
    [aux_sym_else_clause_token1] = ACTIONS(1330),
    [aux_sym_match_expression_token1] = ACTIONS(1330),
    [aux_sym_match_default_expression_token1] = ACTIONS(1330),
    [aux_sym_switch_statement_token1] = ACTIONS(1330),
    [aux_sym_switch_block_token1] = ACTIONS(1330),
    [anon_sym_PLUS] = ACTIONS(1330),
    [anon_sym_DASH] = ACTIONS(1330),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_BANG] = ACTIONS(1328),
    [anon_sym_AT] = ACTIONS(1328),
    [aux_sym_clone_expression_token1] = ACTIONS(1330),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1330),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1330),
    [anon_sym_DASH_DASH] = ACTIONS(1328),
    [anon_sym_PLUS_PLUS] = ACTIONS(1328),
    [aux_sym__list_destructing_token1] = ACTIONS(1330),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_self] = ACTIONS(1330),
    [anon_sym_parent] = ACTIONS(1330),
    [aux_sym__argument_name_token1] = ACTIONS(1330),
    [aux_sym__argument_name_token2] = ACTIONS(1330),
    [anon_sym_POUND_LBRACK] = ACTIONS(1328),
    [aux_sym_encapsed_string_token1] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1328),
    [aux_sym_string_token1] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(1328),
    [anon_sym_LT_LT_LT] = ACTIONS(1328),
    [anon_sym_BQUOTE] = ACTIONS(1328),
    [anon_sym_DOLLAR] = ACTIONS(1328),
    [aux_sym_yield_expression_token1] = ACTIONS(1330),
    [aux_sym_include_expression_token1] = ACTIONS(1330),
    [aux_sym_include_once_expression_token1] = ACTIONS(1330),
    [aux_sym_require_expression_token1] = ACTIONS(1330),
    [aux_sym_require_once_expression_token1] = ACTIONS(1330),
    [sym_comment] = ACTIONS(5),
  },
  [506] = {
    [sym_text_interpolation] = STATE(506),
    [ts_builtin_sym_end] = ACTIONS(1332),
    [sym_name] = ACTIONS(1334),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1332),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1334),
    [aux_sym_global_declaration_token1] = ACTIONS(1334),
    [aux_sym_namespace_definition_token1] = ACTIONS(1334),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1334),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1334),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1334),
    [anon_sym_BSLASH] = ACTIONS(1332),
    [anon_sym_LBRACE] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [aux_sym_trait_declaration_token1] = ACTIONS(1334),
    [aux_sym_interface_declaration_token1] = ACTIONS(1334),
    [aux_sym_enum_declaration_token1] = ACTIONS(1334),
    [aux_sym_enum_case_token1] = ACTIONS(1334),
    [aux_sym_class_declaration_token1] = ACTIONS(1334),
    [aux_sym_final_modifier_token1] = ACTIONS(1334),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1334),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1334),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1334),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1334),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1334),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1334),
    [anon_sym_LPAREN] = ACTIONS(1332),
    [aux_sym_cast_type_token1] = ACTIONS(1334),
    [aux_sym_echo_statement_token1] = ACTIONS(1334),
    [anon_sym_unset] = ACTIONS(1334),
    [aux_sym_declare_statement_token1] = ACTIONS(1334),
    [aux_sym_declare_statement_token2] = ACTIONS(1334),
    [sym_float] = ACTIONS(1334),
    [aux_sym_try_statement_token1] = ACTIONS(1334),
    [aux_sym_goto_statement_token1] = ACTIONS(1334),
    [aux_sym_continue_statement_token1] = ACTIONS(1334),
    [aux_sym_break_statement_token1] = ACTIONS(1334),
    [sym_integer] = ACTIONS(1334),
    [aux_sym_return_statement_token1] = ACTIONS(1334),
    [aux_sym_throw_expression_token1] = ACTIONS(1334),
    [aux_sym_while_statement_token1] = ACTIONS(1334),
    [aux_sym_while_statement_token2] = ACTIONS(1334),
    [aux_sym_do_statement_token1] = ACTIONS(1334),
    [aux_sym_for_statement_token1] = ACTIONS(1334),
    [aux_sym_for_statement_token2] = ACTIONS(1334),
    [aux_sym_foreach_statement_token1] = ACTIONS(1334),
    [aux_sym_foreach_statement_token2] = ACTIONS(1334),
    [aux_sym_if_statement_token1] = ACTIONS(1334),
    [aux_sym_if_statement_token2] = ACTIONS(1334),
    [aux_sym_else_if_clause_token1] = ACTIONS(1334),
    [aux_sym_else_clause_token1] = ACTIONS(1334),
    [aux_sym_match_expression_token1] = ACTIONS(1334),
    [aux_sym_match_default_expression_token1] = ACTIONS(1334),
    [aux_sym_switch_statement_token1] = ACTIONS(1334),
    [aux_sym_switch_block_token1] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_AT] = ACTIONS(1332),
    [aux_sym_clone_expression_token1] = ACTIONS(1334),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1334),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1334),
    [anon_sym_DASH_DASH] = ACTIONS(1332),
    [anon_sym_PLUS_PLUS] = ACTIONS(1332),
    [aux_sym__list_destructing_token1] = ACTIONS(1334),
    [anon_sym_LBRACK] = ACTIONS(1332),
    [anon_sym_self] = ACTIONS(1334),
    [anon_sym_parent] = ACTIONS(1334),
    [aux_sym__argument_name_token1] = ACTIONS(1334),
    [aux_sym__argument_name_token2] = ACTIONS(1334),
    [anon_sym_POUND_LBRACK] = ACTIONS(1332),
    [aux_sym_encapsed_string_token1] = ACTIONS(1332),
    [anon_sym_DQUOTE] = ACTIONS(1332),
    [aux_sym_string_token1] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1332),
    [anon_sym_LT_LT_LT] = ACTIONS(1332),
    [anon_sym_BQUOTE] = ACTIONS(1332),
    [anon_sym_DOLLAR] = ACTIONS(1332),
    [aux_sym_yield_expression_token1] = ACTIONS(1334),
    [aux_sym_include_expression_token1] = ACTIONS(1334),
    [aux_sym_include_once_expression_token1] = ACTIONS(1334),
    [aux_sym_require_expression_token1] = ACTIONS(1334),
    [aux_sym_require_once_expression_token1] = ACTIONS(1334),
    [sym_comment] = ACTIONS(5),
  },
  [507] = {
    [sym_text_interpolation] = STATE(507),
    [ts_builtin_sym_end] = ACTIONS(1336),
    [sym_name] = ACTIONS(1338),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1336),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1338),
    [aux_sym_global_declaration_token1] = ACTIONS(1338),
    [aux_sym_namespace_definition_token1] = ACTIONS(1338),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1338),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1338),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1338),
    [anon_sym_BSLASH] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [aux_sym_trait_declaration_token1] = ACTIONS(1338),
    [aux_sym_interface_declaration_token1] = ACTIONS(1338),
    [aux_sym_enum_declaration_token1] = ACTIONS(1338),
    [aux_sym_enum_case_token1] = ACTIONS(1338),
    [aux_sym_class_declaration_token1] = ACTIONS(1338),
    [aux_sym_final_modifier_token1] = ACTIONS(1338),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1338),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1338),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1338),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1338),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1338),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1338),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [aux_sym_cast_type_token1] = ACTIONS(1338),
    [aux_sym_echo_statement_token1] = ACTIONS(1338),
    [anon_sym_unset] = ACTIONS(1338),
    [aux_sym_declare_statement_token1] = ACTIONS(1338),
    [aux_sym_declare_statement_token2] = ACTIONS(1338),
    [sym_float] = ACTIONS(1338),
    [aux_sym_try_statement_token1] = ACTIONS(1338),
    [aux_sym_goto_statement_token1] = ACTIONS(1338),
    [aux_sym_continue_statement_token1] = ACTIONS(1338),
    [aux_sym_break_statement_token1] = ACTIONS(1338),
    [sym_integer] = ACTIONS(1338),
    [aux_sym_return_statement_token1] = ACTIONS(1338),
    [aux_sym_throw_expression_token1] = ACTIONS(1338),
    [aux_sym_while_statement_token1] = ACTIONS(1338),
    [aux_sym_while_statement_token2] = ACTIONS(1338),
    [aux_sym_do_statement_token1] = ACTIONS(1338),
    [aux_sym_for_statement_token1] = ACTIONS(1338),
    [aux_sym_for_statement_token2] = ACTIONS(1338),
    [aux_sym_foreach_statement_token1] = ACTIONS(1338),
    [aux_sym_foreach_statement_token2] = ACTIONS(1338),
    [aux_sym_if_statement_token1] = ACTIONS(1338),
    [aux_sym_if_statement_token2] = ACTIONS(1338),
    [aux_sym_else_if_clause_token1] = ACTIONS(1338),
    [aux_sym_else_clause_token1] = ACTIONS(1338),
    [aux_sym_match_expression_token1] = ACTIONS(1338),
    [aux_sym_match_default_expression_token1] = ACTIONS(1338),
    [aux_sym_switch_statement_token1] = ACTIONS(1338),
    [aux_sym_switch_block_token1] = ACTIONS(1338),
    [anon_sym_PLUS] = ACTIONS(1338),
    [anon_sym_DASH] = ACTIONS(1338),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1336),
    [anon_sym_AT] = ACTIONS(1336),
    [aux_sym_clone_expression_token1] = ACTIONS(1338),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1338),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [aux_sym__list_destructing_token1] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_self] = ACTIONS(1338),
    [anon_sym_parent] = ACTIONS(1338),
    [aux_sym__argument_name_token1] = ACTIONS(1338),
    [aux_sym__argument_name_token2] = ACTIONS(1338),
    [anon_sym_POUND_LBRACK] = ACTIONS(1336),
    [aux_sym_encapsed_string_token1] = ACTIONS(1336),
    [anon_sym_DQUOTE] = ACTIONS(1336),
    [aux_sym_string_token1] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(1336),
    [anon_sym_LT_LT_LT] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_DOLLAR] = ACTIONS(1336),
    [aux_sym_yield_expression_token1] = ACTIONS(1338),
    [aux_sym_include_expression_token1] = ACTIONS(1338),
    [aux_sym_include_once_expression_token1] = ACTIONS(1338),
    [aux_sym_require_expression_token1] = ACTIONS(1338),
    [aux_sym_require_once_expression_token1] = ACTIONS(1338),
    [sym_comment] = ACTIONS(5),
  },
  [508] = {
    [sym_text_interpolation] = STATE(508),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(906),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(598),
    [sym_member_access_expression] = STATE(598),
    [sym_nullsafe_member_access_expression] = STATE(598),
    [sym_scoped_property_access_expression] = STATE(598),
    [sym_function_call_expression] = STATE(579),
    [sym_scoped_call_expression] = STATE(579),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(579),
    [sym_nullsafe_member_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(579),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(579),
    [sym_variable_name] = STATE(579),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(669),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_BANG] = ACTIONS(677),
    [aux_sym_clone_expression_token1] = ACTIONS(681),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_include_expression_token1] = ACTIONS(691),
    [aux_sym_include_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(5),
  },
  [509] = {
    [sym_text_interpolation] = STATE(509),
    [ts_builtin_sym_end] = ACTIONS(1320),
    [sym_name] = ACTIONS(1322),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1320),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1322),
    [aux_sym_global_declaration_token1] = ACTIONS(1322),
    [aux_sym_namespace_definition_token1] = ACTIONS(1322),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1322),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1322),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1322),
    [anon_sym_BSLASH] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [aux_sym_trait_declaration_token1] = ACTIONS(1322),
    [aux_sym_interface_declaration_token1] = ACTIONS(1322),
    [aux_sym_enum_declaration_token1] = ACTIONS(1322),
    [aux_sym_enum_case_token1] = ACTIONS(1322),
    [aux_sym_class_declaration_token1] = ACTIONS(1322),
    [aux_sym_final_modifier_token1] = ACTIONS(1322),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1322),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1322),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1322),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1322),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1322),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1320),
    [aux_sym_cast_type_token1] = ACTIONS(1322),
    [aux_sym_echo_statement_token1] = ACTIONS(1322),
    [anon_sym_unset] = ACTIONS(1322),
    [aux_sym_declare_statement_token1] = ACTIONS(1322),
    [aux_sym_declare_statement_token2] = ACTIONS(1322),
    [sym_float] = ACTIONS(1322),
    [aux_sym_try_statement_token1] = ACTIONS(1322),
    [aux_sym_goto_statement_token1] = ACTIONS(1322),
    [aux_sym_continue_statement_token1] = ACTIONS(1322),
    [aux_sym_break_statement_token1] = ACTIONS(1322),
    [sym_integer] = ACTIONS(1322),
    [aux_sym_return_statement_token1] = ACTIONS(1322),
    [aux_sym_throw_expression_token1] = ACTIONS(1322),
    [aux_sym_while_statement_token1] = ACTIONS(1322),
    [aux_sym_while_statement_token2] = ACTIONS(1322),
    [aux_sym_do_statement_token1] = ACTIONS(1322),
    [aux_sym_for_statement_token1] = ACTIONS(1322),
    [aux_sym_for_statement_token2] = ACTIONS(1322),
    [aux_sym_foreach_statement_token1] = ACTIONS(1322),
    [aux_sym_foreach_statement_token2] = ACTIONS(1322),
    [aux_sym_if_statement_token1] = ACTIONS(1322),
    [aux_sym_if_statement_token2] = ACTIONS(1322),
    [aux_sym_else_if_clause_token1] = ACTIONS(1322),
    [aux_sym_else_clause_token1] = ACTIONS(1322),
    [aux_sym_match_expression_token1] = ACTIONS(1322),
    [aux_sym_match_default_expression_token1] = ACTIONS(1322),
    [aux_sym_switch_statement_token1] = ACTIONS(1322),
    [aux_sym_switch_block_token1] = ACTIONS(1322),
    [anon_sym_PLUS] = ACTIONS(1322),
    [anon_sym_DASH] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1320),
    [anon_sym_BANG] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(1320),
    [aux_sym_clone_expression_token1] = ACTIONS(1322),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1322),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1322),
    [anon_sym_DASH_DASH] = ACTIONS(1320),
    [anon_sym_PLUS_PLUS] = ACTIONS(1320),
    [aux_sym__list_destructing_token1] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_self] = ACTIONS(1322),
    [anon_sym_parent] = ACTIONS(1322),
    [aux_sym__argument_name_token1] = ACTIONS(1322),
    [aux_sym__argument_name_token2] = ACTIONS(1322),
    [anon_sym_POUND_LBRACK] = ACTIONS(1320),
    [aux_sym_encapsed_string_token1] = ACTIONS(1320),
    [anon_sym_DQUOTE] = ACTIONS(1320),
    [aux_sym_string_token1] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1320),
    [anon_sym_LT_LT_LT] = ACTIONS(1320),
    [anon_sym_BQUOTE] = ACTIONS(1320),
    [anon_sym_DOLLAR] = ACTIONS(1320),
    [aux_sym_yield_expression_token1] = ACTIONS(1322),
    [aux_sym_include_expression_token1] = ACTIONS(1322),
    [aux_sym_include_once_expression_token1] = ACTIONS(1322),
    [aux_sym_require_expression_token1] = ACTIONS(1322),
    [aux_sym_require_once_expression_token1] = ACTIONS(1322),
    [sym_comment] = ACTIONS(5),
  },
  [510] = {
    [sym_text_interpolation] = STATE(510),
    [ts_builtin_sym_end] = ACTIONS(1340),
    [sym_name] = ACTIONS(1342),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1340),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1342),
    [aux_sym_global_declaration_token1] = ACTIONS(1342),
    [aux_sym_namespace_definition_token1] = ACTIONS(1342),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1342),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1342),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1342),
    [anon_sym_BSLASH] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [aux_sym_trait_declaration_token1] = ACTIONS(1342),
    [aux_sym_interface_declaration_token1] = ACTIONS(1342),
    [aux_sym_enum_declaration_token1] = ACTIONS(1342),
    [aux_sym_enum_case_token1] = ACTIONS(1342),
    [aux_sym_class_declaration_token1] = ACTIONS(1342),
    [aux_sym_final_modifier_token1] = ACTIONS(1342),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1342),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1342),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1342),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1342),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1342),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1342),
    [anon_sym_LPAREN] = ACTIONS(1340),
    [aux_sym_cast_type_token1] = ACTIONS(1342),
    [aux_sym_echo_statement_token1] = ACTIONS(1342),
    [anon_sym_unset] = ACTIONS(1342),
    [aux_sym_declare_statement_token1] = ACTIONS(1342),
    [aux_sym_declare_statement_token2] = ACTIONS(1342),
    [sym_float] = ACTIONS(1342),
    [aux_sym_try_statement_token1] = ACTIONS(1342),
    [aux_sym_goto_statement_token1] = ACTIONS(1342),
    [aux_sym_continue_statement_token1] = ACTIONS(1342),
    [aux_sym_break_statement_token1] = ACTIONS(1342),
    [sym_integer] = ACTIONS(1342),
    [aux_sym_return_statement_token1] = ACTIONS(1342),
    [aux_sym_throw_expression_token1] = ACTIONS(1342),
    [aux_sym_while_statement_token1] = ACTIONS(1342),
    [aux_sym_while_statement_token2] = ACTIONS(1342),
    [aux_sym_do_statement_token1] = ACTIONS(1342),
    [aux_sym_for_statement_token1] = ACTIONS(1342),
    [aux_sym_for_statement_token2] = ACTIONS(1342),
    [aux_sym_foreach_statement_token1] = ACTIONS(1342),
    [aux_sym_foreach_statement_token2] = ACTIONS(1342),
    [aux_sym_if_statement_token1] = ACTIONS(1342),
    [aux_sym_if_statement_token2] = ACTIONS(1342),
    [aux_sym_else_if_clause_token1] = ACTIONS(1342),
    [aux_sym_else_clause_token1] = ACTIONS(1342),
    [aux_sym_match_expression_token1] = ACTIONS(1342),
    [aux_sym_match_default_expression_token1] = ACTIONS(1342),
    [aux_sym_switch_statement_token1] = ACTIONS(1342),
    [aux_sym_switch_block_token1] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_TILDE] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_AT] = ACTIONS(1340),
    [aux_sym_clone_expression_token1] = ACTIONS(1342),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1342),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1342),
    [anon_sym_DASH_DASH] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1340),
    [aux_sym__list_destructing_token1] = ACTIONS(1342),
    [anon_sym_LBRACK] = ACTIONS(1340),
    [anon_sym_self] = ACTIONS(1342),
    [anon_sym_parent] = ACTIONS(1342),
    [aux_sym__argument_name_token1] = ACTIONS(1342),
    [aux_sym__argument_name_token2] = ACTIONS(1342),
    [anon_sym_POUND_LBRACK] = ACTIONS(1340),
    [aux_sym_encapsed_string_token1] = ACTIONS(1340),
    [anon_sym_DQUOTE] = ACTIONS(1340),
    [aux_sym_string_token1] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(1340),
    [anon_sym_LT_LT_LT] = ACTIONS(1340),
    [anon_sym_BQUOTE] = ACTIONS(1340),
    [anon_sym_DOLLAR] = ACTIONS(1340),
    [aux_sym_yield_expression_token1] = ACTIONS(1342),
    [aux_sym_include_expression_token1] = ACTIONS(1342),
    [aux_sym_include_once_expression_token1] = ACTIONS(1342),
    [aux_sym_require_expression_token1] = ACTIONS(1342),
    [aux_sym_require_once_expression_token1] = ACTIONS(1342),
    [sym_comment] = ACTIONS(5),
  },
  [511] = {
    [sym_text_interpolation] = STATE(511),
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_name] = ACTIONS(1346),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1344),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1346),
    [aux_sym_global_declaration_token1] = ACTIONS(1346),
    [aux_sym_namespace_definition_token1] = ACTIONS(1346),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1346),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1346),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1346),
    [anon_sym_BSLASH] = ACTIONS(1344),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [aux_sym_trait_declaration_token1] = ACTIONS(1346),
    [aux_sym_interface_declaration_token1] = ACTIONS(1346),
    [aux_sym_enum_declaration_token1] = ACTIONS(1346),
    [aux_sym_enum_case_token1] = ACTIONS(1346),
    [aux_sym_class_declaration_token1] = ACTIONS(1346),
    [aux_sym_final_modifier_token1] = ACTIONS(1346),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1346),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1346),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1346),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1346),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1346),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [aux_sym_cast_type_token1] = ACTIONS(1346),
    [aux_sym_echo_statement_token1] = ACTIONS(1346),
    [anon_sym_unset] = ACTIONS(1346),
    [aux_sym_declare_statement_token1] = ACTIONS(1346),
    [aux_sym_declare_statement_token2] = ACTIONS(1346),
    [sym_float] = ACTIONS(1346),
    [aux_sym_try_statement_token1] = ACTIONS(1346),
    [aux_sym_goto_statement_token1] = ACTIONS(1346),
    [aux_sym_continue_statement_token1] = ACTIONS(1346),
    [aux_sym_break_statement_token1] = ACTIONS(1346),
    [sym_integer] = ACTIONS(1346),
    [aux_sym_return_statement_token1] = ACTIONS(1346),
    [aux_sym_throw_expression_token1] = ACTIONS(1346),
    [aux_sym_while_statement_token1] = ACTIONS(1346),
    [aux_sym_while_statement_token2] = ACTIONS(1346),
    [aux_sym_do_statement_token1] = ACTIONS(1346),
    [aux_sym_for_statement_token1] = ACTIONS(1346),
    [aux_sym_for_statement_token2] = ACTIONS(1346),
    [aux_sym_foreach_statement_token1] = ACTIONS(1346),
    [aux_sym_foreach_statement_token2] = ACTIONS(1346),
    [aux_sym_if_statement_token1] = ACTIONS(1346),
    [aux_sym_if_statement_token2] = ACTIONS(1346),
    [aux_sym_else_if_clause_token1] = ACTIONS(1346),
    [aux_sym_else_clause_token1] = ACTIONS(1346),
    [aux_sym_match_expression_token1] = ACTIONS(1346),
    [aux_sym_match_default_expression_token1] = ACTIONS(1346),
    [aux_sym_switch_statement_token1] = ACTIONS(1346),
    [aux_sym_switch_block_token1] = ACTIONS(1346),
    [anon_sym_PLUS] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_BANG] = ACTIONS(1344),
    [anon_sym_AT] = ACTIONS(1344),
    [aux_sym_clone_expression_token1] = ACTIONS(1346),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1346),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1344),
    [anon_sym_PLUS_PLUS] = ACTIONS(1344),
    [aux_sym__list_destructing_token1] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_self] = ACTIONS(1346),
    [anon_sym_parent] = ACTIONS(1346),
    [aux_sym__argument_name_token1] = ACTIONS(1346),
    [aux_sym__argument_name_token2] = ACTIONS(1346),
    [anon_sym_POUND_LBRACK] = ACTIONS(1344),
    [aux_sym_encapsed_string_token1] = ACTIONS(1344),
    [anon_sym_DQUOTE] = ACTIONS(1344),
    [aux_sym_string_token1] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1344),
    [anon_sym_LT_LT_LT] = ACTIONS(1344),
    [anon_sym_BQUOTE] = ACTIONS(1344),
    [anon_sym_DOLLAR] = ACTIONS(1344),
    [aux_sym_yield_expression_token1] = ACTIONS(1346),
    [aux_sym_include_expression_token1] = ACTIONS(1346),
    [aux_sym_include_once_expression_token1] = ACTIONS(1346),
    [aux_sym_require_expression_token1] = ACTIONS(1346),
    [aux_sym_require_once_expression_token1] = ACTIONS(1346),
    [sym_comment] = ACTIONS(5),
  },
  [512] = {
    [sym_text_interpolation] = STATE(512),
    [ts_builtin_sym_end] = ACTIONS(1348),
    [sym_name] = ACTIONS(1350),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1348),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1350),
    [aux_sym_global_declaration_token1] = ACTIONS(1350),
    [aux_sym_namespace_definition_token1] = ACTIONS(1350),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1350),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1350),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1350),
    [anon_sym_BSLASH] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1348),
    [aux_sym_trait_declaration_token1] = ACTIONS(1350),
    [aux_sym_interface_declaration_token1] = ACTIONS(1350),
    [aux_sym_enum_declaration_token1] = ACTIONS(1350),
    [aux_sym_enum_case_token1] = ACTIONS(1350),
    [aux_sym_class_declaration_token1] = ACTIONS(1350),
    [aux_sym_final_modifier_token1] = ACTIONS(1350),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1350),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1350),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1350),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1350),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1350),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [aux_sym_cast_type_token1] = ACTIONS(1350),
    [aux_sym_echo_statement_token1] = ACTIONS(1350),
    [anon_sym_unset] = ACTIONS(1350),
    [aux_sym_declare_statement_token1] = ACTIONS(1350),
    [aux_sym_declare_statement_token2] = ACTIONS(1350),
    [sym_float] = ACTIONS(1350),
    [aux_sym_try_statement_token1] = ACTIONS(1350),
    [aux_sym_goto_statement_token1] = ACTIONS(1350),
    [aux_sym_continue_statement_token1] = ACTIONS(1350),
    [aux_sym_break_statement_token1] = ACTIONS(1350),
    [sym_integer] = ACTIONS(1350),
    [aux_sym_return_statement_token1] = ACTIONS(1350),
    [aux_sym_throw_expression_token1] = ACTIONS(1350),
    [aux_sym_while_statement_token1] = ACTIONS(1350),
    [aux_sym_while_statement_token2] = ACTIONS(1350),
    [aux_sym_do_statement_token1] = ACTIONS(1350),
    [aux_sym_for_statement_token1] = ACTIONS(1350),
    [aux_sym_for_statement_token2] = ACTIONS(1350),
    [aux_sym_foreach_statement_token1] = ACTIONS(1350),
    [aux_sym_foreach_statement_token2] = ACTIONS(1350),
    [aux_sym_if_statement_token1] = ACTIONS(1350),
    [aux_sym_if_statement_token2] = ACTIONS(1350),
    [aux_sym_else_if_clause_token1] = ACTIONS(1350),
    [aux_sym_else_clause_token1] = ACTIONS(1350),
    [aux_sym_match_expression_token1] = ACTIONS(1350),
    [aux_sym_match_default_expression_token1] = ACTIONS(1350),
    [aux_sym_switch_statement_token1] = ACTIONS(1350),
    [aux_sym_switch_block_token1] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_BANG] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(1348),
    [aux_sym_clone_expression_token1] = ACTIONS(1350),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1350),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1348),
    [aux_sym__list_destructing_token1] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_self] = ACTIONS(1350),
    [anon_sym_parent] = ACTIONS(1350),
    [aux_sym__argument_name_token1] = ACTIONS(1350),
    [aux_sym__argument_name_token2] = ACTIONS(1350),
    [anon_sym_POUND_LBRACK] = ACTIONS(1348),
    [aux_sym_encapsed_string_token1] = ACTIONS(1348),
    [anon_sym_DQUOTE] = ACTIONS(1348),
    [aux_sym_string_token1] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1348),
    [anon_sym_LT_LT_LT] = ACTIONS(1348),
    [anon_sym_BQUOTE] = ACTIONS(1348),
    [anon_sym_DOLLAR] = ACTIONS(1348),
    [aux_sym_yield_expression_token1] = ACTIONS(1350),
    [aux_sym_include_expression_token1] = ACTIONS(1350),
    [aux_sym_include_once_expression_token1] = ACTIONS(1350),
    [aux_sym_require_expression_token1] = ACTIONS(1350),
    [aux_sym_require_once_expression_token1] = ACTIONS(1350),
    [sym_comment] = ACTIONS(5),
  },
  [513] = {
    [sym_text_interpolation] = STATE(513),
    [ts_builtin_sym_end] = ACTIONS(1352),
    [sym_name] = ACTIONS(1354),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1352),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1354),
    [aux_sym_global_declaration_token1] = ACTIONS(1354),
    [aux_sym_namespace_definition_token1] = ACTIONS(1354),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1354),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1354),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1354),
    [anon_sym_BSLASH] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(1352),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [aux_sym_trait_declaration_token1] = ACTIONS(1354),
    [aux_sym_interface_declaration_token1] = ACTIONS(1354),
    [aux_sym_enum_declaration_token1] = ACTIONS(1354),
    [aux_sym_enum_case_token1] = ACTIONS(1354),
    [aux_sym_class_declaration_token1] = ACTIONS(1354),
    [aux_sym_final_modifier_token1] = ACTIONS(1354),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1354),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1354),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1354),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1354),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1354),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1354),
    [anon_sym_LPAREN] = ACTIONS(1352),
    [aux_sym_cast_type_token1] = ACTIONS(1354),
    [aux_sym_echo_statement_token1] = ACTIONS(1354),
    [anon_sym_unset] = ACTIONS(1354),
    [aux_sym_declare_statement_token1] = ACTIONS(1354),
    [aux_sym_declare_statement_token2] = ACTIONS(1354),
    [sym_float] = ACTIONS(1354),
    [aux_sym_try_statement_token1] = ACTIONS(1354),
    [aux_sym_goto_statement_token1] = ACTIONS(1354),
    [aux_sym_continue_statement_token1] = ACTIONS(1354),
    [aux_sym_break_statement_token1] = ACTIONS(1354),
    [sym_integer] = ACTIONS(1354),
    [aux_sym_return_statement_token1] = ACTIONS(1354),
    [aux_sym_throw_expression_token1] = ACTIONS(1354),
    [aux_sym_while_statement_token1] = ACTIONS(1354),
    [aux_sym_while_statement_token2] = ACTIONS(1354),
    [aux_sym_do_statement_token1] = ACTIONS(1354),
    [aux_sym_for_statement_token1] = ACTIONS(1354),
    [aux_sym_for_statement_token2] = ACTIONS(1354),
    [aux_sym_foreach_statement_token1] = ACTIONS(1354),
    [aux_sym_foreach_statement_token2] = ACTIONS(1354),
    [aux_sym_if_statement_token1] = ACTIONS(1354),
    [aux_sym_if_statement_token2] = ACTIONS(1354),
    [aux_sym_else_if_clause_token1] = ACTIONS(1354),
    [aux_sym_else_clause_token1] = ACTIONS(1354),
    [aux_sym_match_expression_token1] = ACTIONS(1354),
    [aux_sym_match_default_expression_token1] = ACTIONS(1354),
    [aux_sym_switch_statement_token1] = ACTIONS(1354),
    [aux_sym_switch_block_token1] = ACTIONS(1354),
    [anon_sym_PLUS] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(1352),
    [anon_sym_BANG] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(1352),
    [aux_sym_clone_expression_token1] = ACTIONS(1354),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1354),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1354),
    [anon_sym_DASH_DASH] = ACTIONS(1352),
    [anon_sym_PLUS_PLUS] = ACTIONS(1352),
    [aux_sym__list_destructing_token1] = ACTIONS(1354),
    [anon_sym_LBRACK] = ACTIONS(1352),
    [anon_sym_self] = ACTIONS(1354),
    [anon_sym_parent] = ACTIONS(1354),
    [aux_sym__argument_name_token1] = ACTIONS(1354),
    [aux_sym__argument_name_token2] = ACTIONS(1354),
    [anon_sym_POUND_LBRACK] = ACTIONS(1352),
    [aux_sym_encapsed_string_token1] = ACTIONS(1352),
    [anon_sym_DQUOTE] = ACTIONS(1352),
    [aux_sym_string_token1] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1352),
    [anon_sym_LT_LT_LT] = ACTIONS(1352),
    [anon_sym_BQUOTE] = ACTIONS(1352),
    [anon_sym_DOLLAR] = ACTIONS(1352),
    [aux_sym_yield_expression_token1] = ACTIONS(1354),
    [aux_sym_include_expression_token1] = ACTIONS(1354),
    [aux_sym_include_once_expression_token1] = ACTIONS(1354),
    [aux_sym_require_expression_token1] = ACTIONS(1354),
    [aux_sym_require_once_expression_token1] = ACTIONS(1354),
    [sym_comment] = ACTIONS(5),
  },
  [514] = {
    [sym_text_interpolation] = STATE(514),
    [ts_builtin_sym_end] = ACTIONS(1356),
    [sym_name] = ACTIONS(1358),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1356),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1358),
    [aux_sym_global_declaration_token1] = ACTIONS(1358),
    [aux_sym_namespace_definition_token1] = ACTIONS(1358),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1358),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1358),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1358),
    [anon_sym_BSLASH] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1356),
    [anon_sym_RBRACE] = ACTIONS(1356),
    [aux_sym_trait_declaration_token1] = ACTIONS(1358),
    [aux_sym_interface_declaration_token1] = ACTIONS(1358),
    [aux_sym_enum_declaration_token1] = ACTIONS(1358),
    [aux_sym_enum_case_token1] = ACTIONS(1358),
    [aux_sym_class_declaration_token1] = ACTIONS(1358),
    [aux_sym_final_modifier_token1] = ACTIONS(1358),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1358),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1358),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1358),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1358),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1358),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1358),
    [anon_sym_LPAREN] = ACTIONS(1356),
    [aux_sym_cast_type_token1] = ACTIONS(1358),
    [aux_sym_echo_statement_token1] = ACTIONS(1358),
    [anon_sym_unset] = ACTIONS(1358),
    [aux_sym_declare_statement_token1] = ACTIONS(1358),
    [aux_sym_declare_statement_token2] = ACTIONS(1358),
    [sym_float] = ACTIONS(1358),
    [aux_sym_try_statement_token1] = ACTIONS(1358),
    [aux_sym_goto_statement_token1] = ACTIONS(1358),
    [aux_sym_continue_statement_token1] = ACTIONS(1358),
    [aux_sym_break_statement_token1] = ACTIONS(1358),
    [sym_integer] = ACTIONS(1358),
    [aux_sym_return_statement_token1] = ACTIONS(1358),
    [aux_sym_throw_expression_token1] = ACTIONS(1358),
    [aux_sym_while_statement_token1] = ACTIONS(1358),
    [aux_sym_while_statement_token2] = ACTIONS(1358),
    [aux_sym_do_statement_token1] = ACTIONS(1358),
    [aux_sym_for_statement_token1] = ACTIONS(1358),
    [aux_sym_for_statement_token2] = ACTIONS(1358),
    [aux_sym_foreach_statement_token1] = ACTIONS(1358),
    [aux_sym_foreach_statement_token2] = ACTIONS(1358),
    [aux_sym_if_statement_token1] = ACTIONS(1358),
    [aux_sym_if_statement_token2] = ACTIONS(1358),
    [aux_sym_else_if_clause_token1] = ACTIONS(1358),
    [aux_sym_else_clause_token1] = ACTIONS(1358),
    [aux_sym_match_expression_token1] = ACTIONS(1358),
    [aux_sym_match_default_expression_token1] = ACTIONS(1358),
    [aux_sym_switch_statement_token1] = ACTIONS(1358),
    [aux_sym_switch_block_token1] = ACTIONS(1358),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1356),
    [anon_sym_BANG] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(1356),
    [aux_sym_clone_expression_token1] = ACTIONS(1358),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1358),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1358),
    [anon_sym_DASH_DASH] = ACTIONS(1356),
    [anon_sym_PLUS_PLUS] = ACTIONS(1356),
    [aux_sym__list_destructing_token1] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1356),
    [anon_sym_self] = ACTIONS(1358),
    [anon_sym_parent] = ACTIONS(1358),
    [aux_sym__argument_name_token1] = ACTIONS(1358),
    [aux_sym__argument_name_token2] = ACTIONS(1358),
    [anon_sym_POUND_LBRACK] = ACTIONS(1356),
    [aux_sym_encapsed_string_token1] = ACTIONS(1356),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [aux_sym_string_token1] = ACTIONS(1356),
    [anon_sym_SQUOTE] = ACTIONS(1356),
    [anon_sym_LT_LT_LT] = ACTIONS(1356),
    [anon_sym_BQUOTE] = ACTIONS(1356),
    [anon_sym_DOLLAR] = ACTIONS(1356),
    [aux_sym_yield_expression_token1] = ACTIONS(1358),
    [aux_sym_include_expression_token1] = ACTIONS(1358),
    [aux_sym_include_once_expression_token1] = ACTIONS(1358),
    [aux_sym_require_expression_token1] = ACTIONS(1358),
    [aux_sym_require_once_expression_token1] = ACTIONS(1358),
    [sym_comment] = ACTIONS(5),
  },
  [515] = {
    [sym_text_interpolation] = STATE(515),
    [ts_builtin_sym_end] = ACTIONS(1360),
    [sym_name] = ACTIONS(1362),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1360),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1362),
    [aux_sym_global_declaration_token1] = ACTIONS(1362),
    [aux_sym_namespace_definition_token1] = ACTIONS(1362),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1362),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1362),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1362),
    [anon_sym_BSLASH] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [aux_sym_trait_declaration_token1] = ACTIONS(1362),
    [aux_sym_interface_declaration_token1] = ACTIONS(1362),
    [aux_sym_enum_declaration_token1] = ACTIONS(1362),
    [aux_sym_enum_case_token1] = ACTIONS(1362),
    [aux_sym_class_declaration_token1] = ACTIONS(1362),
    [aux_sym_final_modifier_token1] = ACTIONS(1362),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1362),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1362),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1362),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1362),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1362),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1362),
    [anon_sym_LPAREN] = ACTIONS(1360),
    [aux_sym_cast_type_token1] = ACTIONS(1362),
    [aux_sym_echo_statement_token1] = ACTIONS(1362),
    [anon_sym_unset] = ACTIONS(1362),
    [aux_sym_declare_statement_token1] = ACTIONS(1362),
    [aux_sym_declare_statement_token2] = ACTIONS(1362),
    [sym_float] = ACTIONS(1362),
    [aux_sym_try_statement_token1] = ACTIONS(1362),
    [aux_sym_goto_statement_token1] = ACTIONS(1362),
    [aux_sym_continue_statement_token1] = ACTIONS(1362),
    [aux_sym_break_statement_token1] = ACTIONS(1362),
    [sym_integer] = ACTIONS(1362),
    [aux_sym_return_statement_token1] = ACTIONS(1362),
    [aux_sym_throw_expression_token1] = ACTIONS(1362),
    [aux_sym_while_statement_token1] = ACTIONS(1362),
    [aux_sym_while_statement_token2] = ACTIONS(1362),
    [aux_sym_do_statement_token1] = ACTIONS(1362),
    [aux_sym_for_statement_token1] = ACTIONS(1362),
    [aux_sym_for_statement_token2] = ACTIONS(1362),
    [aux_sym_foreach_statement_token1] = ACTIONS(1362),
    [aux_sym_foreach_statement_token2] = ACTIONS(1362),
    [aux_sym_if_statement_token1] = ACTIONS(1362),
    [aux_sym_if_statement_token2] = ACTIONS(1362),
    [aux_sym_else_if_clause_token1] = ACTIONS(1362),
    [aux_sym_else_clause_token1] = ACTIONS(1362),
    [aux_sym_match_expression_token1] = ACTIONS(1362),
    [aux_sym_match_default_expression_token1] = ACTIONS(1362),
    [aux_sym_switch_statement_token1] = ACTIONS(1362),
    [aux_sym_switch_block_token1] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(1360),
    [aux_sym_clone_expression_token1] = ACTIONS(1362),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1362),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1362),
    [anon_sym_DASH_DASH] = ACTIONS(1360),
    [anon_sym_PLUS_PLUS] = ACTIONS(1360),
    [aux_sym__list_destructing_token1] = ACTIONS(1362),
    [anon_sym_LBRACK] = ACTIONS(1360),
    [anon_sym_self] = ACTIONS(1362),
    [anon_sym_parent] = ACTIONS(1362),
    [aux_sym__argument_name_token1] = ACTIONS(1362),
    [aux_sym__argument_name_token2] = ACTIONS(1362),
    [anon_sym_POUND_LBRACK] = ACTIONS(1360),
    [aux_sym_encapsed_string_token1] = ACTIONS(1360),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [aux_sym_string_token1] = ACTIONS(1360),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_LT_LT_LT] = ACTIONS(1360),
    [anon_sym_BQUOTE] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [aux_sym_yield_expression_token1] = ACTIONS(1362),
    [aux_sym_include_expression_token1] = ACTIONS(1362),
    [aux_sym_include_once_expression_token1] = ACTIONS(1362),
    [aux_sym_require_expression_token1] = ACTIONS(1362),
    [aux_sym_require_once_expression_token1] = ACTIONS(1362),
    [sym_comment] = ACTIONS(5),
  },
  [516] = {
    [sym_text_interpolation] = STATE(516),
    [ts_builtin_sym_end] = ACTIONS(1364),
    [sym_name] = ACTIONS(1366),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1364),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1366),
    [aux_sym_global_declaration_token1] = ACTIONS(1366),
    [aux_sym_namespace_definition_token1] = ACTIONS(1366),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1366),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1366),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1366),
    [anon_sym_BSLASH] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_RBRACE] = ACTIONS(1364),
    [aux_sym_trait_declaration_token1] = ACTIONS(1366),
    [aux_sym_interface_declaration_token1] = ACTIONS(1366),
    [aux_sym_enum_declaration_token1] = ACTIONS(1366),
    [aux_sym_enum_case_token1] = ACTIONS(1366),
    [aux_sym_class_declaration_token1] = ACTIONS(1366),
    [aux_sym_final_modifier_token1] = ACTIONS(1366),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1366),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1366),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1366),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1366),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1366),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [aux_sym_cast_type_token1] = ACTIONS(1366),
    [aux_sym_echo_statement_token1] = ACTIONS(1366),
    [anon_sym_unset] = ACTIONS(1366),
    [aux_sym_declare_statement_token1] = ACTIONS(1366),
    [aux_sym_declare_statement_token2] = ACTIONS(1366),
    [sym_float] = ACTIONS(1366),
    [aux_sym_try_statement_token1] = ACTIONS(1366),
    [aux_sym_goto_statement_token1] = ACTIONS(1366),
    [aux_sym_continue_statement_token1] = ACTIONS(1366),
    [aux_sym_break_statement_token1] = ACTIONS(1366),
    [sym_integer] = ACTIONS(1366),
    [aux_sym_return_statement_token1] = ACTIONS(1366),
    [aux_sym_throw_expression_token1] = ACTIONS(1366),
    [aux_sym_while_statement_token1] = ACTIONS(1366),
    [aux_sym_while_statement_token2] = ACTIONS(1366),
    [aux_sym_do_statement_token1] = ACTIONS(1366),
    [aux_sym_for_statement_token1] = ACTIONS(1366),
    [aux_sym_for_statement_token2] = ACTIONS(1366),
    [aux_sym_foreach_statement_token1] = ACTIONS(1366),
    [aux_sym_foreach_statement_token2] = ACTIONS(1366),
    [aux_sym_if_statement_token1] = ACTIONS(1366),
    [aux_sym_if_statement_token2] = ACTIONS(1366),
    [aux_sym_else_if_clause_token1] = ACTIONS(1366),
    [aux_sym_else_clause_token1] = ACTIONS(1366),
    [aux_sym_match_expression_token1] = ACTIONS(1366),
    [aux_sym_match_default_expression_token1] = ACTIONS(1366),
    [aux_sym_switch_statement_token1] = ACTIONS(1366),
    [aux_sym_switch_block_token1] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(1366),
    [anon_sym_DASH] = ACTIONS(1366),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_BANG] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [aux_sym_clone_expression_token1] = ACTIONS(1366),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1366),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1366),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [aux_sym__list_destructing_token1] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1364),
    [anon_sym_self] = ACTIONS(1366),
    [anon_sym_parent] = ACTIONS(1366),
    [aux_sym__argument_name_token1] = ACTIONS(1366),
    [aux_sym__argument_name_token2] = ACTIONS(1366),
    [anon_sym_POUND_LBRACK] = ACTIONS(1364),
    [aux_sym_encapsed_string_token1] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1364),
    [aux_sym_string_token1] = ACTIONS(1364),
    [anon_sym_SQUOTE] = ACTIONS(1364),
    [anon_sym_LT_LT_LT] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1364),
    [anon_sym_DOLLAR] = ACTIONS(1364),
    [aux_sym_yield_expression_token1] = ACTIONS(1366),
    [aux_sym_include_expression_token1] = ACTIONS(1366),
    [aux_sym_include_once_expression_token1] = ACTIONS(1366),
    [aux_sym_require_expression_token1] = ACTIONS(1366),
    [aux_sym_require_once_expression_token1] = ACTIONS(1366),
    [sym_comment] = ACTIONS(5),
  },
  [517] = {
    [sym_text_interpolation] = STATE(517),
    [ts_builtin_sym_end] = ACTIONS(1368),
    [sym_name] = ACTIONS(1370),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1368),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1370),
    [aux_sym_global_declaration_token1] = ACTIONS(1370),
    [aux_sym_namespace_definition_token1] = ACTIONS(1370),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1370),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1370),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1370),
    [anon_sym_BSLASH] = ACTIONS(1368),
    [anon_sym_LBRACE] = ACTIONS(1368),
    [anon_sym_RBRACE] = ACTIONS(1368),
    [aux_sym_trait_declaration_token1] = ACTIONS(1370),
    [aux_sym_interface_declaration_token1] = ACTIONS(1370),
    [aux_sym_enum_declaration_token1] = ACTIONS(1370),
    [aux_sym_enum_case_token1] = ACTIONS(1370),
    [aux_sym_class_declaration_token1] = ACTIONS(1370),
    [aux_sym_final_modifier_token1] = ACTIONS(1370),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1370),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1370),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1370),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1370),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1370),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1368),
    [aux_sym_cast_type_token1] = ACTIONS(1370),
    [aux_sym_echo_statement_token1] = ACTIONS(1370),
    [anon_sym_unset] = ACTIONS(1370),
    [aux_sym_declare_statement_token1] = ACTIONS(1370),
    [aux_sym_declare_statement_token2] = ACTIONS(1370),
    [sym_float] = ACTIONS(1370),
    [aux_sym_try_statement_token1] = ACTIONS(1370),
    [aux_sym_goto_statement_token1] = ACTIONS(1370),
    [aux_sym_continue_statement_token1] = ACTIONS(1370),
    [aux_sym_break_statement_token1] = ACTIONS(1370),
    [sym_integer] = ACTIONS(1370),
    [aux_sym_return_statement_token1] = ACTIONS(1370),
    [aux_sym_throw_expression_token1] = ACTIONS(1370),
    [aux_sym_while_statement_token1] = ACTIONS(1370),
    [aux_sym_while_statement_token2] = ACTIONS(1370),
    [aux_sym_do_statement_token1] = ACTIONS(1370),
    [aux_sym_for_statement_token1] = ACTIONS(1370),
    [aux_sym_for_statement_token2] = ACTIONS(1370),
    [aux_sym_foreach_statement_token1] = ACTIONS(1370),
    [aux_sym_foreach_statement_token2] = ACTIONS(1370),
    [aux_sym_if_statement_token1] = ACTIONS(1370),
    [aux_sym_if_statement_token2] = ACTIONS(1370),
    [aux_sym_else_if_clause_token1] = ACTIONS(1370),
    [aux_sym_else_clause_token1] = ACTIONS(1370),
    [aux_sym_match_expression_token1] = ACTIONS(1370),
    [aux_sym_match_default_expression_token1] = ACTIONS(1370),
    [aux_sym_switch_statement_token1] = ACTIONS(1370),
    [aux_sym_switch_block_token1] = ACTIONS(1370),
    [anon_sym_PLUS] = ACTIONS(1370),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(1368),
    [anon_sym_AT] = ACTIONS(1368),
    [aux_sym_clone_expression_token1] = ACTIONS(1370),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1370),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1370),
    [anon_sym_DASH_DASH] = ACTIONS(1368),
    [anon_sym_PLUS_PLUS] = ACTIONS(1368),
    [aux_sym__list_destructing_token1] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1368),
    [anon_sym_self] = ACTIONS(1370),
    [anon_sym_parent] = ACTIONS(1370),
    [aux_sym__argument_name_token1] = ACTIONS(1370),
    [aux_sym__argument_name_token2] = ACTIONS(1370),
    [anon_sym_POUND_LBRACK] = ACTIONS(1368),
    [aux_sym_encapsed_string_token1] = ACTIONS(1368),
    [anon_sym_DQUOTE] = ACTIONS(1368),
    [aux_sym_string_token1] = ACTIONS(1368),
    [anon_sym_SQUOTE] = ACTIONS(1368),
    [anon_sym_LT_LT_LT] = ACTIONS(1368),
    [anon_sym_BQUOTE] = ACTIONS(1368),
    [anon_sym_DOLLAR] = ACTIONS(1368),
    [aux_sym_yield_expression_token1] = ACTIONS(1370),
    [aux_sym_include_expression_token1] = ACTIONS(1370),
    [aux_sym_include_once_expression_token1] = ACTIONS(1370),
    [aux_sym_require_expression_token1] = ACTIONS(1370),
    [aux_sym_require_once_expression_token1] = ACTIONS(1370),
    [sym_comment] = ACTIONS(5),
  },
  [518] = {
    [sym_text_interpolation] = STATE(518),
    [ts_builtin_sym_end] = ACTIONS(1372),
    [sym_name] = ACTIONS(1374),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1372),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1374),
    [aux_sym_global_declaration_token1] = ACTIONS(1374),
    [aux_sym_namespace_definition_token1] = ACTIONS(1374),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1374),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1374),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1374),
    [anon_sym_BSLASH] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_RBRACE] = ACTIONS(1372),
    [aux_sym_trait_declaration_token1] = ACTIONS(1374),
    [aux_sym_interface_declaration_token1] = ACTIONS(1374),
    [aux_sym_enum_declaration_token1] = ACTIONS(1374),
    [aux_sym_enum_case_token1] = ACTIONS(1374),
    [aux_sym_class_declaration_token1] = ACTIONS(1374),
    [aux_sym_final_modifier_token1] = ACTIONS(1374),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1374),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1374),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1374),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1374),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1374),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [aux_sym_cast_type_token1] = ACTIONS(1374),
    [aux_sym_echo_statement_token1] = ACTIONS(1374),
    [anon_sym_unset] = ACTIONS(1374),
    [aux_sym_declare_statement_token1] = ACTIONS(1374),
    [aux_sym_declare_statement_token2] = ACTIONS(1374),
    [sym_float] = ACTIONS(1374),
    [aux_sym_try_statement_token1] = ACTIONS(1374),
    [aux_sym_goto_statement_token1] = ACTIONS(1374),
    [aux_sym_continue_statement_token1] = ACTIONS(1374),
    [aux_sym_break_statement_token1] = ACTIONS(1374),
    [sym_integer] = ACTIONS(1374),
    [aux_sym_return_statement_token1] = ACTIONS(1374),
    [aux_sym_throw_expression_token1] = ACTIONS(1374),
    [aux_sym_while_statement_token1] = ACTIONS(1374),
    [aux_sym_while_statement_token2] = ACTIONS(1374),
    [aux_sym_do_statement_token1] = ACTIONS(1374),
    [aux_sym_for_statement_token1] = ACTIONS(1374),
    [aux_sym_for_statement_token2] = ACTIONS(1374),
    [aux_sym_foreach_statement_token1] = ACTIONS(1374),
    [aux_sym_foreach_statement_token2] = ACTIONS(1374),
    [aux_sym_if_statement_token1] = ACTIONS(1374),
    [aux_sym_if_statement_token2] = ACTIONS(1374),
    [aux_sym_else_if_clause_token1] = ACTIONS(1374),
    [aux_sym_else_clause_token1] = ACTIONS(1374),
    [aux_sym_match_expression_token1] = ACTIONS(1374),
    [aux_sym_match_default_expression_token1] = ACTIONS(1374),
    [aux_sym_switch_statement_token1] = ACTIONS(1374),
    [aux_sym_switch_block_token1] = ACTIONS(1374),
    [anon_sym_PLUS] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1374),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_BANG] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [aux_sym_clone_expression_token1] = ACTIONS(1374),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1374),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1374),
    [anon_sym_DASH_DASH] = ACTIONS(1372),
    [anon_sym_PLUS_PLUS] = ACTIONS(1372),
    [aux_sym__list_destructing_token1] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_self] = ACTIONS(1374),
    [anon_sym_parent] = ACTIONS(1374),
    [aux_sym__argument_name_token1] = ACTIONS(1374),
    [aux_sym__argument_name_token2] = ACTIONS(1374),
    [anon_sym_POUND_LBRACK] = ACTIONS(1372),
    [aux_sym_encapsed_string_token1] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(1372),
    [aux_sym_string_token1] = ACTIONS(1372),
    [anon_sym_SQUOTE] = ACTIONS(1372),
    [anon_sym_LT_LT_LT] = ACTIONS(1372),
    [anon_sym_BQUOTE] = ACTIONS(1372),
    [anon_sym_DOLLAR] = ACTIONS(1372),
    [aux_sym_yield_expression_token1] = ACTIONS(1374),
    [aux_sym_include_expression_token1] = ACTIONS(1374),
    [aux_sym_include_once_expression_token1] = ACTIONS(1374),
    [aux_sym_require_expression_token1] = ACTIONS(1374),
    [aux_sym_require_once_expression_token1] = ACTIONS(1374),
    [sym_comment] = ACTIONS(5),
  },
  [519] = {
    [sym_text_interpolation] = STATE(519),
    [ts_builtin_sym_end] = ACTIONS(1376),
    [sym_name] = ACTIONS(1378),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1376),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1378),
    [aux_sym_global_declaration_token1] = ACTIONS(1378),
    [aux_sym_namespace_definition_token1] = ACTIONS(1378),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1378),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1378),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1378),
    [anon_sym_BSLASH] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_RBRACE] = ACTIONS(1376),
    [aux_sym_trait_declaration_token1] = ACTIONS(1378),
    [aux_sym_interface_declaration_token1] = ACTIONS(1378),
    [aux_sym_enum_declaration_token1] = ACTIONS(1378),
    [aux_sym_enum_case_token1] = ACTIONS(1378),
    [aux_sym_class_declaration_token1] = ACTIONS(1378),
    [aux_sym_final_modifier_token1] = ACTIONS(1378),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1378),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1378),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1378),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1378),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1378),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [aux_sym_cast_type_token1] = ACTIONS(1378),
    [aux_sym_echo_statement_token1] = ACTIONS(1378),
    [anon_sym_unset] = ACTIONS(1378),
    [aux_sym_declare_statement_token1] = ACTIONS(1378),
    [aux_sym_declare_statement_token2] = ACTIONS(1378),
    [sym_float] = ACTIONS(1378),
    [aux_sym_try_statement_token1] = ACTIONS(1378),
    [aux_sym_goto_statement_token1] = ACTIONS(1378),
    [aux_sym_continue_statement_token1] = ACTIONS(1378),
    [aux_sym_break_statement_token1] = ACTIONS(1378),
    [sym_integer] = ACTIONS(1378),
    [aux_sym_return_statement_token1] = ACTIONS(1378),
    [aux_sym_throw_expression_token1] = ACTIONS(1378),
    [aux_sym_while_statement_token1] = ACTIONS(1378),
    [aux_sym_while_statement_token2] = ACTIONS(1378),
    [aux_sym_do_statement_token1] = ACTIONS(1378),
    [aux_sym_for_statement_token1] = ACTIONS(1378),
    [aux_sym_for_statement_token2] = ACTIONS(1378),
    [aux_sym_foreach_statement_token1] = ACTIONS(1378),
    [aux_sym_foreach_statement_token2] = ACTIONS(1378),
    [aux_sym_if_statement_token1] = ACTIONS(1378),
    [aux_sym_if_statement_token2] = ACTIONS(1378),
    [aux_sym_else_if_clause_token1] = ACTIONS(1378),
    [aux_sym_else_clause_token1] = ACTIONS(1378),
    [aux_sym_match_expression_token1] = ACTIONS(1378),
    [aux_sym_match_default_expression_token1] = ACTIONS(1378),
    [aux_sym_switch_statement_token1] = ACTIONS(1378),
    [aux_sym_switch_block_token1] = ACTIONS(1378),
    [anon_sym_PLUS] = ACTIONS(1378),
    [anon_sym_DASH] = ACTIONS(1378),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_BANG] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1376),
    [aux_sym_clone_expression_token1] = ACTIONS(1378),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1378),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1378),
    [anon_sym_DASH_DASH] = ACTIONS(1376),
    [anon_sym_PLUS_PLUS] = ACTIONS(1376),
    [aux_sym__list_destructing_token1] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_self] = ACTIONS(1378),
    [anon_sym_parent] = ACTIONS(1378),
    [aux_sym__argument_name_token1] = ACTIONS(1378),
    [aux_sym__argument_name_token2] = ACTIONS(1378),
    [anon_sym_POUND_LBRACK] = ACTIONS(1376),
    [aux_sym_encapsed_string_token1] = ACTIONS(1376),
    [anon_sym_DQUOTE] = ACTIONS(1376),
    [aux_sym_string_token1] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(1376),
    [anon_sym_LT_LT_LT] = ACTIONS(1376),
    [anon_sym_BQUOTE] = ACTIONS(1376),
    [anon_sym_DOLLAR] = ACTIONS(1376),
    [aux_sym_yield_expression_token1] = ACTIONS(1378),
    [aux_sym_include_expression_token1] = ACTIONS(1378),
    [aux_sym_include_once_expression_token1] = ACTIONS(1378),
    [aux_sym_require_expression_token1] = ACTIONS(1378),
    [aux_sym_require_once_expression_token1] = ACTIONS(1378),
    [sym_comment] = ACTIONS(5),
  },
  [520] = {
    [sym_text_interpolation] = STATE(520),
    [ts_builtin_sym_end] = ACTIONS(1380),
    [sym_name] = ACTIONS(1382),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1380),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1382),
    [aux_sym_global_declaration_token1] = ACTIONS(1382),
    [aux_sym_namespace_definition_token1] = ACTIONS(1382),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1382),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1382),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1382),
    [anon_sym_BSLASH] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_RBRACE] = ACTIONS(1380),
    [aux_sym_trait_declaration_token1] = ACTIONS(1382),
    [aux_sym_interface_declaration_token1] = ACTIONS(1382),
    [aux_sym_enum_declaration_token1] = ACTIONS(1382),
    [aux_sym_enum_case_token1] = ACTIONS(1382),
    [aux_sym_class_declaration_token1] = ACTIONS(1382),
    [aux_sym_final_modifier_token1] = ACTIONS(1382),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1382),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1382),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1382),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1382),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1382),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1382),
    [anon_sym_LPAREN] = ACTIONS(1380),
    [aux_sym_cast_type_token1] = ACTIONS(1382),
    [aux_sym_echo_statement_token1] = ACTIONS(1382),
    [anon_sym_unset] = ACTIONS(1382),
    [aux_sym_declare_statement_token1] = ACTIONS(1382),
    [aux_sym_declare_statement_token2] = ACTIONS(1382),
    [sym_float] = ACTIONS(1382),
    [aux_sym_try_statement_token1] = ACTIONS(1382),
    [aux_sym_goto_statement_token1] = ACTIONS(1382),
    [aux_sym_continue_statement_token1] = ACTIONS(1382),
    [aux_sym_break_statement_token1] = ACTIONS(1382),
    [sym_integer] = ACTIONS(1382),
    [aux_sym_return_statement_token1] = ACTIONS(1382),
    [aux_sym_throw_expression_token1] = ACTIONS(1382),
    [aux_sym_while_statement_token1] = ACTIONS(1382),
    [aux_sym_while_statement_token2] = ACTIONS(1382),
    [aux_sym_do_statement_token1] = ACTIONS(1382),
    [aux_sym_for_statement_token1] = ACTIONS(1382),
    [aux_sym_for_statement_token2] = ACTIONS(1382),
    [aux_sym_foreach_statement_token1] = ACTIONS(1382),
    [aux_sym_foreach_statement_token2] = ACTIONS(1382),
    [aux_sym_if_statement_token1] = ACTIONS(1382),
    [aux_sym_if_statement_token2] = ACTIONS(1382),
    [aux_sym_else_if_clause_token1] = ACTIONS(1382),
    [aux_sym_else_clause_token1] = ACTIONS(1382),
    [aux_sym_match_expression_token1] = ACTIONS(1382),
    [aux_sym_match_default_expression_token1] = ACTIONS(1382),
    [aux_sym_switch_statement_token1] = ACTIONS(1382),
    [aux_sym_switch_block_token1] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_BANG] = ACTIONS(1380),
    [anon_sym_AT] = ACTIONS(1380),
    [aux_sym_clone_expression_token1] = ACTIONS(1382),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1382),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1382),
    [anon_sym_DASH_DASH] = ACTIONS(1380),
    [anon_sym_PLUS_PLUS] = ACTIONS(1380),
    [aux_sym__list_destructing_token1] = ACTIONS(1382),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_self] = ACTIONS(1382),
    [anon_sym_parent] = ACTIONS(1382),
    [aux_sym__argument_name_token1] = ACTIONS(1382),
    [aux_sym__argument_name_token2] = ACTIONS(1382),
    [anon_sym_POUND_LBRACK] = ACTIONS(1380),
    [aux_sym_encapsed_string_token1] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [aux_sym_string_token1] = ACTIONS(1380),
    [anon_sym_SQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [aux_sym_yield_expression_token1] = ACTIONS(1382),
    [aux_sym_include_expression_token1] = ACTIONS(1382),
    [aux_sym_include_once_expression_token1] = ACTIONS(1382),
    [aux_sym_require_expression_token1] = ACTIONS(1382),
    [aux_sym_require_once_expression_token1] = ACTIONS(1382),
    [sym_comment] = ACTIONS(5),
  },
  [521] = {
    [sym_text_interpolation] = STATE(521),
    [ts_builtin_sym_end] = ACTIONS(1384),
    [sym_name] = ACTIONS(1386),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1384),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1386),
    [aux_sym_global_declaration_token1] = ACTIONS(1386),
    [aux_sym_namespace_definition_token1] = ACTIONS(1386),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1386),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1386),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1386),
    [anon_sym_BSLASH] = ACTIONS(1384),
    [anon_sym_LBRACE] = ACTIONS(1384),
    [anon_sym_RBRACE] = ACTIONS(1384),
    [aux_sym_trait_declaration_token1] = ACTIONS(1386),
    [aux_sym_interface_declaration_token1] = ACTIONS(1386),
    [aux_sym_enum_declaration_token1] = ACTIONS(1386),
    [aux_sym_enum_case_token1] = ACTIONS(1386),
    [aux_sym_class_declaration_token1] = ACTIONS(1386),
    [aux_sym_final_modifier_token1] = ACTIONS(1386),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1386),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1386),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1386),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1386),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1386),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1386),
    [anon_sym_LPAREN] = ACTIONS(1384),
    [aux_sym_cast_type_token1] = ACTIONS(1386),
    [aux_sym_echo_statement_token1] = ACTIONS(1386),
    [anon_sym_unset] = ACTIONS(1386),
    [aux_sym_declare_statement_token1] = ACTIONS(1386),
    [aux_sym_declare_statement_token2] = ACTIONS(1386),
    [sym_float] = ACTIONS(1386),
    [aux_sym_try_statement_token1] = ACTIONS(1386),
    [aux_sym_goto_statement_token1] = ACTIONS(1386),
    [aux_sym_continue_statement_token1] = ACTIONS(1386),
    [aux_sym_break_statement_token1] = ACTIONS(1386),
    [sym_integer] = ACTIONS(1386),
    [aux_sym_return_statement_token1] = ACTIONS(1386),
    [aux_sym_throw_expression_token1] = ACTIONS(1386),
    [aux_sym_while_statement_token1] = ACTIONS(1386),
    [aux_sym_while_statement_token2] = ACTIONS(1386),
    [aux_sym_do_statement_token1] = ACTIONS(1386),
    [aux_sym_for_statement_token1] = ACTIONS(1386),
    [aux_sym_for_statement_token2] = ACTIONS(1386),
    [aux_sym_foreach_statement_token1] = ACTIONS(1386),
    [aux_sym_foreach_statement_token2] = ACTIONS(1386),
    [aux_sym_if_statement_token1] = ACTIONS(1386),
    [aux_sym_if_statement_token2] = ACTIONS(1386),
    [aux_sym_else_if_clause_token1] = ACTIONS(1386),
    [aux_sym_else_clause_token1] = ACTIONS(1386),
    [aux_sym_match_expression_token1] = ACTIONS(1386),
    [aux_sym_match_default_expression_token1] = ACTIONS(1386),
    [aux_sym_switch_statement_token1] = ACTIONS(1386),
    [aux_sym_switch_block_token1] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_TILDE] = ACTIONS(1384),
    [anon_sym_BANG] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(1384),
    [aux_sym_clone_expression_token1] = ACTIONS(1386),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1386),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1386),
    [anon_sym_DASH_DASH] = ACTIONS(1384),
    [anon_sym_PLUS_PLUS] = ACTIONS(1384),
    [aux_sym__list_destructing_token1] = ACTIONS(1386),
    [anon_sym_LBRACK] = ACTIONS(1384),
    [anon_sym_self] = ACTIONS(1386),
    [anon_sym_parent] = ACTIONS(1386),
    [aux_sym__argument_name_token1] = ACTIONS(1386),
    [aux_sym__argument_name_token2] = ACTIONS(1386),
    [anon_sym_POUND_LBRACK] = ACTIONS(1384),
    [aux_sym_encapsed_string_token1] = ACTIONS(1384),
    [anon_sym_DQUOTE] = ACTIONS(1384),
    [aux_sym_string_token1] = ACTIONS(1384),
    [anon_sym_SQUOTE] = ACTIONS(1384),
    [anon_sym_LT_LT_LT] = ACTIONS(1384),
    [anon_sym_BQUOTE] = ACTIONS(1384),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [aux_sym_yield_expression_token1] = ACTIONS(1386),
    [aux_sym_include_expression_token1] = ACTIONS(1386),
    [aux_sym_include_once_expression_token1] = ACTIONS(1386),
    [aux_sym_require_expression_token1] = ACTIONS(1386),
    [aux_sym_require_once_expression_token1] = ACTIONS(1386),
    [sym_comment] = ACTIONS(5),
  },
  [522] = {
    [sym_text_interpolation] = STATE(522),
    [ts_builtin_sym_end] = ACTIONS(1388),
    [sym_name] = ACTIONS(1390),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1388),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1390),
    [aux_sym_global_declaration_token1] = ACTIONS(1390),
    [aux_sym_namespace_definition_token1] = ACTIONS(1390),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1390),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1390),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1390),
    [anon_sym_BSLASH] = ACTIONS(1388),
    [anon_sym_LBRACE] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1388),
    [aux_sym_trait_declaration_token1] = ACTIONS(1390),
    [aux_sym_interface_declaration_token1] = ACTIONS(1390),
    [aux_sym_enum_declaration_token1] = ACTIONS(1390),
    [aux_sym_enum_case_token1] = ACTIONS(1390),
    [aux_sym_class_declaration_token1] = ACTIONS(1390),
    [aux_sym_final_modifier_token1] = ACTIONS(1390),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1390),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1390),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1390),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1390),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1390),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1390),
    [anon_sym_LPAREN] = ACTIONS(1388),
    [aux_sym_cast_type_token1] = ACTIONS(1390),
    [aux_sym_echo_statement_token1] = ACTIONS(1390),
    [anon_sym_unset] = ACTIONS(1390),
    [aux_sym_declare_statement_token1] = ACTIONS(1390),
    [aux_sym_declare_statement_token2] = ACTIONS(1390),
    [sym_float] = ACTIONS(1390),
    [aux_sym_try_statement_token1] = ACTIONS(1390),
    [aux_sym_goto_statement_token1] = ACTIONS(1390),
    [aux_sym_continue_statement_token1] = ACTIONS(1390),
    [aux_sym_break_statement_token1] = ACTIONS(1390),
    [sym_integer] = ACTIONS(1390),
    [aux_sym_return_statement_token1] = ACTIONS(1390),
    [aux_sym_throw_expression_token1] = ACTIONS(1390),
    [aux_sym_while_statement_token1] = ACTIONS(1390),
    [aux_sym_while_statement_token2] = ACTIONS(1390),
    [aux_sym_do_statement_token1] = ACTIONS(1390),
    [aux_sym_for_statement_token1] = ACTIONS(1390),
    [aux_sym_for_statement_token2] = ACTIONS(1390),
    [aux_sym_foreach_statement_token1] = ACTIONS(1390),
    [aux_sym_foreach_statement_token2] = ACTIONS(1390),
    [aux_sym_if_statement_token1] = ACTIONS(1390),
    [aux_sym_if_statement_token2] = ACTIONS(1390),
    [aux_sym_else_if_clause_token1] = ACTIONS(1390),
    [aux_sym_else_clause_token1] = ACTIONS(1390),
    [aux_sym_match_expression_token1] = ACTIONS(1390),
    [aux_sym_match_default_expression_token1] = ACTIONS(1390),
    [aux_sym_switch_statement_token1] = ACTIONS(1390),
    [aux_sym_switch_block_token1] = ACTIONS(1390),
    [anon_sym_PLUS] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_TILDE] = ACTIONS(1388),
    [anon_sym_BANG] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1388),
    [aux_sym_clone_expression_token1] = ACTIONS(1390),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1390),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1390),
    [anon_sym_DASH_DASH] = ACTIONS(1388),
    [anon_sym_PLUS_PLUS] = ACTIONS(1388),
    [aux_sym__list_destructing_token1] = ACTIONS(1390),
    [anon_sym_LBRACK] = ACTIONS(1388),
    [anon_sym_self] = ACTIONS(1390),
    [anon_sym_parent] = ACTIONS(1390),
    [aux_sym__argument_name_token1] = ACTIONS(1390),
    [aux_sym__argument_name_token2] = ACTIONS(1390),
    [anon_sym_POUND_LBRACK] = ACTIONS(1388),
    [aux_sym_encapsed_string_token1] = ACTIONS(1388),
    [anon_sym_DQUOTE] = ACTIONS(1388),
    [aux_sym_string_token1] = ACTIONS(1388),
    [anon_sym_SQUOTE] = ACTIONS(1388),
    [anon_sym_LT_LT_LT] = ACTIONS(1388),
    [anon_sym_BQUOTE] = ACTIONS(1388),
    [anon_sym_DOLLAR] = ACTIONS(1388),
    [aux_sym_yield_expression_token1] = ACTIONS(1390),
    [aux_sym_include_expression_token1] = ACTIONS(1390),
    [aux_sym_include_once_expression_token1] = ACTIONS(1390),
    [aux_sym_require_expression_token1] = ACTIONS(1390),
    [aux_sym_require_once_expression_token1] = ACTIONS(1390),
    [sym_comment] = ACTIONS(5),
  },
  [523] = {
    [sym_text_interpolation] = STATE(523),
    [ts_builtin_sym_end] = ACTIONS(1392),
    [sym_name] = ACTIONS(1394),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1392),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1394),
    [aux_sym_global_declaration_token1] = ACTIONS(1394),
    [aux_sym_namespace_definition_token1] = ACTIONS(1394),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1394),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1394),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1394),
    [anon_sym_BSLASH] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1392),
    [anon_sym_RBRACE] = ACTIONS(1392),
    [aux_sym_trait_declaration_token1] = ACTIONS(1394),
    [aux_sym_interface_declaration_token1] = ACTIONS(1394),
    [aux_sym_enum_declaration_token1] = ACTIONS(1394),
    [aux_sym_enum_case_token1] = ACTIONS(1394),
    [aux_sym_class_declaration_token1] = ACTIONS(1394),
    [aux_sym_final_modifier_token1] = ACTIONS(1394),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1394),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1394),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1394),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1394),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1394),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1392),
    [aux_sym_cast_type_token1] = ACTIONS(1394),
    [aux_sym_echo_statement_token1] = ACTIONS(1394),
    [anon_sym_unset] = ACTIONS(1394),
    [aux_sym_declare_statement_token1] = ACTIONS(1394),
    [aux_sym_declare_statement_token2] = ACTIONS(1394),
    [sym_float] = ACTIONS(1394),
    [aux_sym_try_statement_token1] = ACTIONS(1394),
    [aux_sym_goto_statement_token1] = ACTIONS(1394),
    [aux_sym_continue_statement_token1] = ACTIONS(1394),
    [aux_sym_break_statement_token1] = ACTIONS(1394),
    [sym_integer] = ACTIONS(1394),
    [aux_sym_return_statement_token1] = ACTIONS(1394),
    [aux_sym_throw_expression_token1] = ACTIONS(1394),
    [aux_sym_while_statement_token1] = ACTIONS(1394),
    [aux_sym_while_statement_token2] = ACTIONS(1394),
    [aux_sym_do_statement_token1] = ACTIONS(1394),
    [aux_sym_for_statement_token1] = ACTIONS(1394),
    [aux_sym_for_statement_token2] = ACTIONS(1394),
    [aux_sym_foreach_statement_token1] = ACTIONS(1394),
    [aux_sym_foreach_statement_token2] = ACTIONS(1394),
    [aux_sym_if_statement_token1] = ACTIONS(1394),
    [aux_sym_if_statement_token2] = ACTIONS(1394),
    [aux_sym_else_if_clause_token1] = ACTIONS(1394),
    [aux_sym_else_clause_token1] = ACTIONS(1394),
    [aux_sym_match_expression_token1] = ACTIONS(1394),
    [aux_sym_match_default_expression_token1] = ACTIONS(1394),
    [aux_sym_switch_statement_token1] = ACTIONS(1394),
    [aux_sym_switch_block_token1] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_TILDE] = ACTIONS(1392),
    [anon_sym_BANG] = ACTIONS(1392),
    [anon_sym_AT] = ACTIONS(1392),
    [aux_sym_clone_expression_token1] = ACTIONS(1394),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1394),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1394),
    [anon_sym_DASH_DASH] = ACTIONS(1392),
    [anon_sym_PLUS_PLUS] = ACTIONS(1392),
    [aux_sym__list_destructing_token1] = ACTIONS(1394),
    [anon_sym_LBRACK] = ACTIONS(1392),
    [anon_sym_self] = ACTIONS(1394),
    [anon_sym_parent] = ACTIONS(1394),
    [aux_sym__argument_name_token1] = ACTIONS(1394),
    [aux_sym__argument_name_token2] = ACTIONS(1394),
    [anon_sym_POUND_LBRACK] = ACTIONS(1392),
    [aux_sym_encapsed_string_token1] = ACTIONS(1392),
    [anon_sym_DQUOTE] = ACTIONS(1392),
    [aux_sym_string_token1] = ACTIONS(1392),
    [anon_sym_SQUOTE] = ACTIONS(1392),
    [anon_sym_LT_LT_LT] = ACTIONS(1392),
    [anon_sym_BQUOTE] = ACTIONS(1392),
    [anon_sym_DOLLAR] = ACTIONS(1392),
    [aux_sym_yield_expression_token1] = ACTIONS(1394),
    [aux_sym_include_expression_token1] = ACTIONS(1394),
    [aux_sym_include_once_expression_token1] = ACTIONS(1394),
    [aux_sym_require_expression_token1] = ACTIONS(1394),
    [aux_sym_require_once_expression_token1] = ACTIONS(1394),
    [sym_comment] = ACTIONS(5),
  },
  [524] = {
    [sym_text_interpolation] = STATE(524),
    [ts_builtin_sym_end] = ACTIONS(1396),
    [sym_name] = ACTIONS(1398),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1396),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1398),
    [aux_sym_global_declaration_token1] = ACTIONS(1398),
    [aux_sym_namespace_definition_token1] = ACTIONS(1398),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1398),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1398),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1398),
    [anon_sym_BSLASH] = ACTIONS(1396),
    [anon_sym_LBRACE] = ACTIONS(1396),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [aux_sym_trait_declaration_token1] = ACTIONS(1398),
    [aux_sym_interface_declaration_token1] = ACTIONS(1398),
    [aux_sym_enum_declaration_token1] = ACTIONS(1398),
    [aux_sym_enum_case_token1] = ACTIONS(1398),
    [aux_sym_class_declaration_token1] = ACTIONS(1398),
    [aux_sym_final_modifier_token1] = ACTIONS(1398),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1398),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1398),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1398),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1398),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1398),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1398),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [aux_sym_cast_type_token1] = ACTIONS(1398),
    [aux_sym_echo_statement_token1] = ACTIONS(1398),
    [anon_sym_unset] = ACTIONS(1398),
    [aux_sym_declare_statement_token1] = ACTIONS(1398),
    [aux_sym_declare_statement_token2] = ACTIONS(1398),
    [sym_float] = ACTIONS(1398),
    [aux_sym_try_statement_token1] = ACTIONS(1398),
    [aux_sym_goto_statement_token1] = ACTIONS(1398),
    [aux_sym_continue_statement_token1] = ACTIONS(1398),
    [aux_sym_break_statement_token1] = ACTIONS(1398),
    [sym_integer] = ACTIONS(1398),
    [aux_sym_return_statement_token1] = ACTIONS(1398),
    [aux_sym_throw_expression_token1] = ACTIONS(1398),
    [aux_sym_while_statement_token1] = ACTIONS(1398),
    [aux_sym_while_statement_token2] = ACTIONS(1398),
    [aux_sym_do_statement_token1] = ACTIONS(1398),
    [aux_sym_for_statement_token1] = ACTIONS(1398),
    [aux_sym_for_statement_token2] = ACTIONS(1398),
    [aux_sym_foreach_statement_token1] = ACTIONS(1398),
    [aux_sym_foreach_statement_token2] = ACTIONS(1398),
    [aux_sym_if_statement_token1] = ACTIONS(1398),
    [aux_sym_if_statement_token2] = ACTIONS(1398),
    [aux_sym_else_if_clause_token1] = ACTIONS(1398),
    [aux_sym_else_clause_token1] = ACTIONS(1398),
    [aux_sym_match_expression_token1] = ACTIONS(1398),
    [aux_sym_match_default_expression_token1] = ACTIONS(1398),
    [aux_sym_switch_statement_token1] = ACTIONS(1398),
    [aux_sym_switch_block_token1] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_TILDE] = ACTIONS(1396),
    [anon_sym_BANG] = ACTIONS(1396),
    [anon_sym_AT] = ACTIONS(1396),
    [aux_sym_clone_expression_token1] = ACTIONS(1398),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1398),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1398),
    [anon_sym_DASH_DASH] = ACTIONS(1396),
    [anon_sym_PLUS_PLUS] = ACTIONS(1396),
    [aux_sym__list_destructing_token1] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1396),
    [anon_sym_self] = ACTIONS(1398),
    [anon_sym_parent] = ACTIONS(1398),
    [aux_sym__argument_name_token1] = ACTIONS(1398),
    [aux_sym__argument_name_token2] = ACTIONS(1398),
    [anon_sym_POUND_LBRACK] = ACTIONS(1396),
    [aux_sym_encapsed_string_token1] = ACTIONS(1396),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [aux_sym_string_token1] = ACTIONS(1396),
    [anon_sym_SQUOTE] = ACTIONS(1396),
    [anon_sym_LT_LT_LT] = ACTIONS(1396),
    [anon_sym_BQUOTE] = ACTIONS(1396),
    [anon_sym_DOLLAR] = ACTIONS(1396),
    [aux_sym_yield_expression_token1] = ACTIONS(1398),
    [aux_sym_include_expression_token1] = ACTIONS(1398),
    [aux_sym_include_once_expression_token1] = ACTIONS(1398),
    [aux_sym_require_expression_token1] = ACTIONS(1398),
    [aux_sym_require_once_expression_token1] = ACTIONS(1398),
    [sym_comment] = ACTIONS(5),
  },
  [525] = {
    [sym_text_interpolation] = STATE(525),
    [ts_builtin_sym_end] = ACTIONS(1400),
    [sym_name] = ACTIONS(1402),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1400),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1402),
    [aux_sym_global_declaration_token1] = ACTIONS(1402),
    [aux_sym_namespace_definition_token1] = ACTIONS(1402),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1402),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1402),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1402),
    [anon_sym_BSLASH] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_RBRACE] = ACTIONS(1400),
    [aux_sym_trait_declaration_token1] = ACTIONS(1402),
    [aux_sym_interface_declaration_token1] = ACTIONS(1402),
    [aux_sym_enum_declaration_token1] = ACTIONS(1402),
    [aux_sym_enum_case_token1] = ACTIONS(1402),
    [aux_sym_class_declaration_token1] = ACTIONS(1402),
    [aux_sym_final_modifier_token1] = ACTIONS(1402),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1402),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1402),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1402),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1402),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1402),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [aux_sym_cast_type_token1] = ACTIONS(1402),
    [aux_sym_echo_statement_token1] = ACTIONS(1402),
    [anon_sym_unset] = ACTIONS(1402),
    [aux_sym_declare_statement_token1] = ACTIONS(1402),
    [aux_sym_declare_statement_token2] = ACTIONS(1402),
    [sym_float] = ACTIONS(1402),
    [aux_sym_try_statement_token1] = ACTIONS(1402),
    [aux_sym_goto_statement_token1] = ACTIONS(1402),
    [aux_sym_continue_statement_token1] = ACTIONS(1402),
    [aux_sym_break_statement_token1] = ACTIONS(1402),
    [sym_integer] = ACTIONS(1402),
    [aux_sym_return_statement_token1] = ACTIONS(1402),
    [aux_sym_throw_expression_token1] = ACTIONS(1402),
    [aux_sym_while_statement_token1] = ACTIONS(1402),
    [aux_sym_while_statement_token2] = ACTIONS(1402),
    [aux_sym_do_statement_token1] = ACTIONS(1402),
    [aux_sym_for_statement_token1] = ACTIONS(1402),
    [aux_sym_for_statement_token2] = ACTIONS(1402),
    [aux_sym_foreach_statement_token1] = ACTIONS(1402),
    [aux_sym_foreach_statement_token2] = ACTIONS(1402),
    [aux_sym_if_statement_token1] = ACTIONS(1402),
    [aux_sym_if_statement_token2] = ACTIONS(1402),
    [aux_sym_else_if_clause_token1] = ACTIONS(1402),
    [aux_sym_else_clause_token1] = ACTIONS(1402),
    [aux_sym_match_expression_token1] = ACTIONS(1402),
    [aux_sym_match_default_expression_token1] = ACTIONS(1402),
    [aux_sym_switch_statement_token1] = ACTIONS(1402),
    [aux_sym_switch_block_token1] = ACTIONS(1402),
    [anon_sym_PLUS] = ACTIONS(1402),
    [anon_sym_DASH] = ACTIONS(1402),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_BANG] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1400),
    [aux_sym_clone_expression_token1] = ACTIONS(1402),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1402),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1402),
    [anon_sym_DASH_DASH] = ACTIONS(1400),
    [anon_sym_PLUS_PLUS] = ACTIONS(1400),
    [aux_sym__list_destructing_token1] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_self] = ACTIONS(1402),
    [anon_sym_parent] = ACTIONS(1402),
    [aux_sym__argument_name_token1] = ACTIONS(1402),
    [aux_sym__argument_name_token2] = ACTIONS(1402),
    [anon_sym_POUND_LBRACK] = ACTIONS(1400),
    [aux_sym_encapsed_string_token1] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1400),
    [aux_sym_string_token1] = ACTIONS(1400),
    [anon_sym_SQUOTE] = ACTIONS(1400),
    [anon_sym_LT_LT_LT] = ACTIONS(1400),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [aux_sym_yield_expression_token1] = ACTIONS(1402),
    [aux_sym_include_expression_token1] = ACTIONS(1402),
    [aux_sym_include_once_expression_token1] = ACTIONS(1402),
    [aux_sym_require_expression_token1] = ACTIONS(1402),
    [aux_sym_require_once_expression_token1] = ACTIONS(1402),
    [sym_comment] = ACTIONS(5),
  },
  [526] = {
    [sym_text_interpolation] = STATE(526),
    [ts_builtin_sym_end] = ACTIONS(1404),
    [sym_name] = ACTIONS(1406),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1404),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1406),
    [aux_sym_global_declaration_token1] = ACTIONS(1406),
    [aux_sym_namespace_definition_token1] = ACTIONS(1406),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1406),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1406),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1406),
    [anon_sym_BSLASH] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_RBRACE] = ACTIONS(1404),
    [aux_sym_trait_declaration_token1] = ACTIONS(1406),
    [aux_sym_interface_declaration_token1] = ACTIONS(1406),
    [aux_sym_enum_declaration_token1] = ACTIONS(1406),
    [aux_sym_enum_case_token1] = ACTIONS(1406),
    [aux_sym_class_declaration_token1] = ACTIONS(1406),
    [aux_sym_final_modifier_token1] = ACTIONS(1406),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1406),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1406),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1406),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1406),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1406),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1404),
    [aux_sym_cast_type_token1] = ACTIONS(1406),
    [aux_sym_echo_statement_token1] = ACTIONS(1406),
    [anon_sym_unset] = ACTIONS(1406),
    [aux_sym_declare_statement_token1] = ACTIONS(1406),
    [aux_sym_declare_statement_token2] = ACTIONS(1406),
    [sym_float] = ACTIONS(1406),
    [aux_sym_try_statement_token1] = ACTIONS(1406),
    [aux_sym_goto_statement_token1] = ACTIONS(1406),
    [aux_sym_continue_statement_token1] = ACTIONS(1406),
    [aux_sym_break_statement_token1] = ACTIONS(1406),
    [sym_integer] = ACTIONS(1406),
    [aux_sym_return_statement_token1] = ACTIONS(1406),
    [aux_sym_throw_expression_token1] = ACTIONS(1406),
    [aux_sym_while_statement_token1] = ACTIONS(1406),
    [aux_sym_while_statement_token2] = ACTIONS(1406),
    [aux_sym_do_statement_token1] = ACTIONS(1406),
    [aux_sym_for_statement_token1] = ACTIONS(1406),
    [aux_sym_for_statement_token2] = ACTIONS(1406),
    [aux_sym_foreach_statement_token1] = ACTIONS(1406),
    [aux_sym_foreach_statement_token2] = ACTIONS(1406),
    [aux_sym_if_statement_token1] = ACTIONS(1406),
    [aux_sym_if_statement_token2] = ACTIONS(1406),
    [aux_sym_else_if_clause_token1] = ACTIONS(1406),
    [aux_sym_else_clause_token1] = ACTIONS(1406),
    [aux_sym_match_expression_token1] = ACTIONS(1406),
    [aux_sym_match_default_expression_token1] = ACTIONS(1406),
    [aux_sym_switch_statement_token1] = ACTIONS(1406),
    [aux_sym_switch_block_token1] = ACTIONS(1406),
    [anon_sym_PLUS] = ACTIONS(1406),
    [anon_sym_DASH] = ACTIONS(1406),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_BANG] = ACTIONS(1404),
    [anon_sym_AT] = ACTIONS(1404),
    [aux_sym_clone_expression_token1] = ACTIONS(1406),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1406),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1406),
    [anon_sym_DASH_DASH] = ACTIONS(1404),
    [anon_sym_PLUS_PLUS] = ACTIONS(1404),
    [aux_sym__list_destructing_token1] = ACTIONS(1406),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_self] = ACTIONS(1406),
    [anon_sym_parent] = ACTIONS(1406),
    [aux_sym__argument_name_token1] = ACTIONS(1406),
    [aux_sym__argument_name_token2] = ACTIONS(1406),
    [anon_sym_POUND_LBRACK] = ACTIONS(1404),
    [aux_sym_encapsed_string_token1] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1404),
    [aux_sym_string_token1] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(1404),
    [anon_sym_LT_LT_LT] = ACTIONS(1404),
    [anon_sym_BQUOTE] = ACTIONS(1404),
    [anon_sym_DOLLAR] = ACTIONS(1404),
    [aux_sym_yield_expression_token1] = ACTIONS(1406),
    [aux_sym_include_expression_token1] = ACTIONS(1406),
    [aux_sym_include_once_expression_token1] = ACTIONS(1406),
    [aux_sym_require_expression_token1] = ACTIONS(1406),
    [aux_sym_require_once_expression_token1] = ACTIONS(1406),
    [sym_comment] = ACTIONS(5),
  },
  [527] = {
    [sym_text_interpolation] = STATE(527),
    [ts_builtin_sym_end] = ACTIONS(1408),
    [sym_name] = ACTIONS(1410),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1408),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1410),
    [aux_sym_global_declaration_token1] = ACTIONS(1410),
    [aux_sym_namespace_definition_token1] = ACTIONS(1410),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1410),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1410),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1410),
    [anon_sym_BSLASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_RBRACE] = ACTIONS(1408),
    [aux_sym_trait_declaration_token1] = ACTIONS(1410),
    [aux_sym_interface_declaration_token1] = ACTIONS(1410),
    [aux_sym_enum_declaration_token1] = ACTIONS(1410),
    [aux_sym_enum_case_token1] = ACTIONS(1410),
    [aux_sym_class_declaration_token1] = ACTIONS(1410),
    [aux_sym_final_modifier_token1] = ACTIONS(1410),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1410),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1410),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1410),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1410),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1410),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [aux_sym_cast_type_token1] = ACTIONS(1410),
    [aux_sym_echo_statement_token1] = ACTIONS(1410),
    [anon_sym_unset] = ACTIONS(1410),
    [aux_sym_declare_statement_token1] = ACTIONS(1410),
    [aux_sym_declare_statement_token2] = ACTIONS(1410),
    [sym_float] = ACTIONS(1410),
    [aux_sym_try_statement_token1] = ACTIONS(1410),
    [aux_sym_goto_statement_token1] = ACTIONS(1410),
    [aux_sym_continue_statement_token1] = ACTIONS(1410),
    [aux_sym_break_statement_token1] = ACTIONS(1410),
    [sym_integer] = ACTIONS(1410),
    [aux_sym_return_statement_token1] = ACTIONS(1410),
    [aux_sym_throw_expression_token1] = ACTIONS(1410),
    [aux_sym_while_statement_token1] = ACTIONS(1410),
    [aux_sym_while_statement_token2] = ACTIONS(1410),
    [aux_sym_do_statement_token1] = ACTIONS(1410),
    [aux_sym_for_statement_token1] = ACTIONS(1410),
    [aux_sym_for_statement_token2] = ACTIONS(1410),
    [aux_sym_foreach_statement_token1] = ACTIONS(1410),
    [aux_sym_foreach_statement_token2] = ACTIONS(1410),
    [aux_sym_if_statement_token1] = ACTIONS(1410),
    [aux_sym_if_statement_token2] = ACTIONS(1410),
    [aux_sym_else_if_clause_token1] = ACTIONS(1410),
    [aux_sym_else_clause_token1] = ACTIONS(1410),
    [aux_sym_match_expression_token1] = ACTIONS(1410),
    [aux_sym_match_default_expression_token1] = ACTIONS(1410),
    [aux_sym_switch_statement_token1] = ACTIONS(1410),
    [aux_sym_switch_block_token1] = ACTIONS(1410),
    [anon_sym_PLUS] = ACTIONS(1410),
    [anon_sym_DASH] = ACTIONS(1410),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_BANG] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [aux_sym_clone_expression_token1] = ACTIONS(1410),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1410),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1410),
    [anon_sym_DASH_DASH] = ACTIONS(1408),
    [anon_sym_PLUS_PLUS] = ACTIONS(1408),
    [aux_sym__list_destructing_token1] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_self] = ACTIONS(1410),
    [anon_sym_parent] = ACTIONS(1410),
    [aux_sym__argument_name_token1] = ACTIONS(1410),
    [aux_sym__argument_name_token2] = ACTIONS(1410),
    [anon_sym_POUND_LBRACK] = ACTIONS(1408),
    [aux_sym_encapsed_string_token1] = ACTIONS(1408),
    [anon_sym_DQUOTE] = ACTIONS(1408),
    [aux_sym_string_token1] = ACTIONS(1408),
    [anon_sym_SQUOTE] = ACTIONS(1408),
    [anon_sym_LT_LT_LT] = ACTIONS(1408),
    [anon_sym_BQUOTE] = ACTIONS(1408),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [aux_sym_yield_expression_token1] = ACTIONS(1410),
    [aux_sym_include_expression_token1] = ACTIONS(1410),
    [aux_sym_include_once_expression_token1] = ACTIONS(1410),
    [aux_sym_require_expression_token1] = ACTIONS(1410),
    [aux_sym_require_once_expression_token1] = ACTIONS(1410),
    [sym_comment] = ACTIONS(5),
  },
  [528] = {
    [sym_text_interpolation] = STATE(528),
    [ts_builtin_sym_end] = ACTIONS(1412),
    [sym_name] = ACTIONS(1414),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1412),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1414),
    [aux_sym_global_declaration_token1] = ACTIONS(1414),
    [aux_sym_namespace_definition_token1] = ACTIONS(1414),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1414),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1414),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1414),
    [anon_sym_BSLASH] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(1412),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [aux_sym_trait_declaration_token1] = ACTIONS(1414),
    [aux_sym_interface_declaration_token1] = ACTIONS(1414),
    [aux_sym_enum_declaration_token1] = ACTIONS(1414),
    [aux_sym_enum_case_token1] = ACTIONS(1414),
    [aux_sym_class_declaration_token1] = ACTIONS(1414),
    [aux_sym_final_modifier_token1] = ACTIONS(1414),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1414),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1414),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1414),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1414),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1414),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1414),
    [anon_sym_LPAREN] = ACTIONS(1412),
    [aux_sym_cast_type_token1] = ACTIONS(1414),
    [aux_sym_echo_statement_token1] = ACTIONS(1414),
    [anon_sym_unset] = ACTIONS(1414),
    [aux_sym_declare_statement_token1] = ACTIONS(1414),
    [aux_sym_declare_statement_token2] = ACTIONS(1414),
    [sym_float] = ACTIONS(1414),
    [aux_sym_try_statement_token1] = ACTIONS(1414),
    [aux_sym_goto_statement_token1] = ACTIONS(1414),
    [aux_sym_continue_statement_token1] = ACTIONS(1414),
    [aux_sym_break_statement_token1] = ACTIONS(1414),
    [sym_integer] = ACTIONS(1414),
    [aux_sym_return_statement_token1] = ACTIONS(1414),
    [aux_sym_throw_expression_token1] = ACTIONS(1414),
    [aux_sym_while_statement_token1] = ACTIONS(1414),
    [aux_sym_while_statement_token2] = ACTIONS(1414),
    [aux_sym_do_statement_token1] = ACTIONS(1414),
    [aux_sym_for_statement_token1] = ACTIONS(1414),
    [aux_sym_for_statement_token2] = ACTIONS(1414),
    [aux_sym_foreach_statement_token1] = ACTIONS(1414),
    [aux_sym_foreach_statement_token2] = ACTIONS(1414),
    [aux_sym_if_statement_token1] = ACTIONS(1414),
    [aux_sym_if_statement_token2] = ACTIONS(1414),
    [aux_sym_else_if_clause_token1] = ACTIONS(1414),
    [aux_sym_else_clause_token1] = ACTIONS(1414),
    [aux_sym_match_expression_token1] = ACTIONS(1414),
    [aux_sym_match_default_expression_token1] = ACTIONS(1414),
    [aux_sym_switch_statement_token1] = ACTIONS(1414),
    [aux_sym_switch_block_token1] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_TILDE] = ACTIONS(1412),
    [anon_sym_BANG] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(1412),
    [aux_sym_clone_expression_token1] = ACTIONS(1414),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1414),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1414),
    [anon_sym_DASH_DASH] = ACTIONS(1412),
    [anon_sym_PLUS_PLUS] = ACTIONS(1412),
    [aux_sym__list_destructing_token1] = ACTIONS(1414),
    [anon_sym_LBRACK] = ACTIONS(1412),
    [anon_sym_self] = ACTIONS(1414),
    [anon_sym_parent] = ACTIONS(1414),
    [aux_sym__argument_name_token1] = ACTIONS(1414),
    [aux_sym__argument_name_token2] = ACTIONS(1414),
    [anon_sym_POUND_LBRACK] = ACTIONS(1412),
    [aux_sym_encapsed_string_token1] = ACTIONS(1412),
    [anon_sym_DQUOTE] = ACTIONS(1412),
    [aux_sym_string_token1] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(1412),
    [anon_sym_LT_LT_LT] = ACTIONS(1412),
    [anon_sym_BQUOTE] = ACTIONS(1412),
    [anon_sym_DOLLAR] = ACTIONS(1412),
    [aux_sym_yield_expression_token1] = ACTIONS(1414),
    [aux_sym_include_expression_token1] = ACTIONS(1414),
    [aux_sym_include_once_expression_token1] = ACTIONS(1414),
    [aux_sym_require_expression_token1] = ACTIONS(1414),
    [aux_sym_require_once_expression_token1] = ACTIONS(1414),
    [sym_comment] = ACTIONS(5),
  },
  [529] = {
    [sym_text_interpolation] = STATE(529),
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_name] = ACTIONS(1418),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1416),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1418),
    [aux_sym_global_declaration_token1] = ACTIONS(1418),
    [aux_sym_namespace_definition_token1] = ACTIONS(1418),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1418),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1418),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1418),
    [anon_sym_BSLASH] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1416),
    [aux_sym_trait_declaration_token1] = ACTIONS(1418),
    [aux_sym_interface_declaration_token1] = ACTIONS(1418),
    [aux_sym_enum_declaration_token1] = ACTIONS(1418),
    [aux_sym_enum_case_token1] = ACTIONS(1418),
    [aux_sym_class_declaration_token1] = ACTIONS(1418),
    [aux_sym_final_modifier_token1] = ACTIONS(1418),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1418),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1418),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1418),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1418),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1418),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [aux_sym_cast_type_token1] = ACTIONS(1418),
    [aux_sym_echo_statement_token1] = ACTIONS(1418),
    [anon_sym_unset] = ACTIONS(1418),
    [aux_sym_declare_statement_token1] = ACTIONS(1418),
    [aux_sym_declare_statement_token2] = ACTIONS(1418),
    [sym_float] = ACTIONS(1418),
    [aux_sym_try_statement_token1] = ACTIONS(1418),
    [aux_sym_goto_statement_token1] = ACTIONS(1418),
    [aux_sym_continue_statement_token1] = ACTIONS(1418),
    [aux_sym_break_statement_token1] = ACTIONS(1418),
    [sym_integer] = ACTIONS(1418),
    [aux_sym_return_statement_token1] = ACTIONS(1418),
    [aux_sym_throw_expression_token1] = ACTIONS(1418),
    [aux_sym_while_statement_token1] = ACTIONS(1418),
    [aux_sym_while_statement_token2] = ACTIONS(1418),
    [aux_sym_do_statement_token1] = ACTIONS(1418),
    [aux_sym_for_statement_token1] = ACTIONS(1418),
    [aux_sym_for_statement_token2] = ACTIONS(1418),
    [aux_sym_foreach_statement_token1] = ACTIONS(1418),
    [aux_sym_foreach_statement_token2] = ACTIONS(1418),
    [aux_sym_if_statement_token1] = ACTIONS(1418),
    [aux_sym_if_statement_token2] = ACTIONS(1418),
    [aux_sym_else_if_clause_token1] = ACTIONS(1418),
    [aux_sym_else_clause_token1] = ACTIONS(1418),
    [aux_sym_match_expression_token1] = ACTIONS(1418),
    [aux_sym_match_default_expression_token1] = ACTIONS(1418),
    [aux_sym_switch_statement_token1] = ACTIONS(1418),
    [aux_sym_switch_block_token1] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_BANG] = ACTIONS(1416),
    [anon_sym_AT] = ACTIONS(1416),
    [aux_sym_clone_expression_token1] = ACTIONS(1418),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1418),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1418),
    [anon_sym_DASH_DASH] = ACTIONS(1416),
    [anon_sym_PLUS_PLUS] = ACTIONS(1416),
    [aux_sym__list_destructing_token1] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_self] = ACTIONS(1418),
    [anon_sym_parent] = ACTIONS(1418),
    [aux_sym__argument_name_token1] = ACTIONS(1418),
    [aux_sym__argument_name_token2] = ACTIONS(1418),
    [anon_sym_POUND_LBRACK] = ACTIONS(1416),
    [aux_sym_encapsed_string_token1] = ACTIONS(1416),
    [anon_sym_DQUOTE] = ACTIONS(1416),
    [aux_sym_string_token1] = ACTIONS(1416),
    [anon_sym_SQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LT_LT] = ACTIONS(1416),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_DOLLAR] = ACTIONS(1416),
    [aux_sym_yield_expression_token1] = ACTIONS(1418),
    [aux_sym_include_expression_token1] = ACTIONS(1418),
    [aux_sym_include_once_expression_token1] = ACTIONS(1418),
    [aux_sym_require_expression_token1] = ACTIONS(1418),
    [aux_sym_require_once_expression_token1] = ACTIONS(1418),
    [sym_comment] = ACTIONS(5),
  },
  [530] = {
    [sym_text_interpolation] = STATE(530),
    [ts_builtin_sym_end] = ACTIONS(1420),
    [sym_name] = ACTIONS(1422),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1420),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1422),
    [aux_sym_global_declaration_token1] = ACTIONS(1422),
    [aux_sym_namespace_definition_token1] = ACTIONS(1422),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1422),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1422),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1422),
    [anon_sym_BSLASH] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [aux_sym_trait_declaration_token1] = ACTIONS(1422),
    [aux_sym_interface_declaration_token1] = ACTIONS(1422),
    [aux_sym_enum_declaration_token1] = ACTIONS(1422),
    [aux_sym_enum_case_token1] = ACTIONS(1422),
    [aux_sym_class_declaration_token1] = ACTIONS(1422),
    [aux_sym_final_modifier_token1] = ACTIONS(1422),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1422),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1422),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1422),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1422),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1422),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [aux_sym_cast_type_token1] = ACTIONS(1422),
    [aux_sym_echo_statement_token1] = ACTIONS(1422),
    [anon_sym_unset] = ACTIONS(1422),
    [aux_sym_declare_statement_token1] = ACTIONS(1422),
    [aux_sym_declare_statement_token2] = ACTIONS(1422),
    [sym_float] = ACTIONS(1422),
    [aux_sym_try_statement_token1] = ACTIONS(1422),
    [aux_sym_goto_statement_token1] = ACTIONS(1422),
    [aux_sym_continue_statement_token1] = ACTIONS(1422),
    [aux_sym_break_statement_token1] = ACTIONS(1422),
    [sym_integer] = ACTIONS(1422),
    [aux_sym_return_statement_token1] = ACTIONS(1422),
    [aux_sym_throw_expression_token1] = ACTIONS(1422),
    [aux_sym_while_statement_token1] = ACTIONS(1422),
    [aux_sym_while_statement_token2] = ACTIONS(1422),
    [aux_sym_do_statement_token1] = ACTIONS(1422),
    [aux_sym_for_statement_token1] = ACTIONS(1422),
    [aux_sym_for_statement_token2] = ACTIONS(1422),
    [aux_sym_foreach_statement_token1] = ACTIONS(1422),
    [aux_sym_foreach_statement_token2] = ACTIONS(1422),
    [aux_sym_if_statement_token1] = ACTIONS(1422),
    [aux_sym_if_statement_token2] = ACTIONS(1422),
    [aux_sym_else_if_clause_token1] = ACTIONS(1422),
    [aux_sym_else_clause_token1] = ACTIONS(1422),
    [aux_sym_match_expression_token1] = ACTIONS(1422),
    [aux_sym_match_default_expression_token1] = ACTIONS(1422),
    [aux_sym_switch_statement_token1] = ACTIONS(1422),
    [aux_sym_switch_block_token1] = ACTIONS(1422),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_BANG] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(1420),
    [aux_sym_clone_expression_token1] = ACTIONS(1422),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1422),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1422),
    [anon_sym_DASH_DASH] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1420),
    [aux_sym__list_destructing_token1] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_self] = ACTIONS(1422),
    [anon_sym_parent] = ACTIONS(1422),
    [aux_sym__argument_name_token1] = ACTIONS(1422),
    [aux_sym__argument_name_token2] = ACTIONS(1422),
    [anon_sym_POUND_LBRACK] = ACTIONS(1420),
    [aux_sym_encapsed_string_token1] = ACTIONS(1420),
    [anon_sym_DQUOTE] = ACTIONS(1420),
    [aux_sym_string_token1] = ACTIONS(1420),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [anon_sym_LT_LT_LT] = ACTIONS(1420),
    [anon_sym_BQUOTE] = ACTIONS(1420),
    [anon_sym_DOLLAR] = ACTIONS(1420),
    [aux_sym_yield_expression_token1] = ACTIONS(1422),
    [aux_sym_include_expression_token1] = ACTIONS(1422),
    [aux_sym_include_once_expression_token1] = ACTIONS(1422),
    [aux_sym_require_expression_token1] = ACTIONS(1422),
    [aux_sym_require_once_expression_token1] = ACTIONS(1422),
    [sym_comment] = ACTIONS(5),
  },
  [531] = {
    [sym_text_interpolation] = STATE(531),
    [ts_builtin_sym_end] = ACTIONS(1424),
    [sym_name] = ACTIONS(1426),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1424),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1426),
    [aux_sym_global_declaration_token1] = ACTIONS(1426),
    [aux_sym_namespace_definition_token1] = ACTIONS(1426),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1426),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1426),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1426),
    [anon_sym_BSLASH] = ACTIONS(1424),
    [anon_sym_LBRACE] = ACTIONS(1424),
    [anon_sym_RBRACE] = ACTIONS(1424),
    [aux_sym_trait_declaration_token1] = ACTIONS(1426),
    [aux_sym_interface_declaration_token1] = ACTIONS(1426),
    [aux_sym_enum_declaration_token1] = ACTIONS(1426),
    [aux_sym_enum_case_token1] = ACTIONS(1426),
    [aux_sym_class_declaration_token1] = ACTIONS(1426),
    [aux_sym_final_modifier_token1] = ACTIONS(1426),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1426),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1426),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1426),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1426),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1426),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1426),
    [anon_sym_LPAREN] = ACTIONS(1424),
    [aux_sym_cast_type_token1] = ACTIONS(1426),
    [aux_sym_echo_statement_token1] = ACTIONS(1426),
    [anon_sym_unset] = ACTIONS(1426),
    [aux_sym_declare_statement_token1] = ACTIONS(1426),
    [aux_sym_declare_statement_token2] = ACTIONS(1426),
    [sym_float] = ACTIONS(1426),
    [aux_sym_try_statement_token1] = ACTIONS(1426),
    [aux_sym_goto_statement_token1] = ACTIONS(1426),
    [aux_sym_continue_statement_token1] = ACTIONS(1426),
    [aux_sym_break_statement_token1] = ACTIONS(1426),
    [sym_integer] = ACTIONS(1426),
    [aux_sym_return_statement_token1] = ACTIONS(1426),
    [aux_sym_throw_expression_token1] = ACTIONS(1426),
    [aux_sym_while_statement_token1] = ACTIONS(1426),
    [aux_sym_while_statement_token2] = ACTIONS(1426),
    [aux_sym_do_statement_token1] = ACTIONS(1426),
    [aux_sym_for_statement_token1] = ACTIONS(1426),
    [aux_sym_for_statement_token2] = ACTIONS(1426),
    [aux_sym_foreach_statement_token1] = ACTIONS(1426),
    [aux_sym_foreach_statement_token2] = ACTIONS(1426),
    [aux_sym_if_statement_token1] = ACTIONS(1426),
    [aux_sym_if_statement_token2] = ACTIONS(1426),
    [aux_sym_else_if_clause_token1] = ACTIONS(1426),
    [aux_sym_else_clause_token1] = ACTIONS(1426),
    [aux_sym_match_expression_token1] = ACTIONS(1426),
    [aux_sym_match_default_expression_token1] = ACTIONS(1426),
    [aux_sym_switch_statement_token1] = ACTIONS(1426),
    [aux_sym_switch_block_token1] = ACTIONS(1426),
    [anon_sym_PLUS] = ACTIONS(1426),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_TILDE] = ACTIONS(1424),
    [anon_sym_BANG] = ACTIONS(1424),
    [anon_sym_AT] = ACTIONS(1424),
    [aux_sym_clone_expression_token1] = ACTIONS(1426),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1426),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1426),
    [anon_sym_DASH_DASH] = ACTIONS(1424),
    [anon_sym_PLUS_PLUS] = ACTIONS(1424),
    [aux_sym__list_destructing_token1] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1424),
    [anon_sym_self] = ACTIONS(1426),
    [anon_sym_parent] = ACTIONS(1426),
    [aux_sym__argument_name_token1] = ACTIONS(1426),
    [aux_sym__argument_name_token2] = ACTIONS(1426),
    [anon_sym_POUND_LBRACK] = ACTIONS(1424),
    [aux_sym_encapsed_string_token1] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [aux_sym_string_token1] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LT_LT] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [aux_sym_yield_expression_token1] = ACTIONS(1426),
    [aux_sym_include_expression_token1] = ACTIONS(1426),
    [aux_sym_include_once_expression_token1] = ACTIONS(1426),
    [aux_sym_require_expression_token1] = ACTIONS(1426),
    [aux_sym_require_once_expression_token1] = ACTIONS(1426),
    [sym_comment] = ACTIONS(5),
  },
  [532] = {
    [sym_text_interpolation] = STATE(532),
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_name] = ACTIONS(1430),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1428),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1430),
    [aux_sym_global_declaration_token1] = ACTIONS(1430),
    [aux_sym_namespace_definition_token1] = ACTIONS(1430),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1430),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1430),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1430),
    [anon_sym_BSLASH] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [aux_sym_trait_declaration_token1] = ACTIONS(1430),
    [aux_sym_interface_declaration_token1] = ACTIONS(1430),
    [aux_sym_enum_declaration_token1] = ACTIONS(1430),
    [aux_sym_enum_case_token1] = ACTIONS(1430),
    [aux_sym_class_declaration_token1] = ACTIONS(1430),
    [aux_sym_final_modifier_token1] = ACTIONS(1430),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1430),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1430),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1430),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1430),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1430),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [aux_sym_cast_type_token1] = ACTIONS(1430),
    [aux_sym_echo_statement_token1] = ACTIONS(1430),
    [anon_sym_unset] = ACTIONS(1430),
    [aux_sym_declare_statement_token1] = ACTIONS(1430),
    [aux_sym_declare_statement_token2] = ACTIONS(1430),
    [sym_float] = ACTIONS(1430),
    [aux_sym_try_statement_token1] = ACTIONS(1430),
    [aux_sym_goto_statement_token1] = ACTIONS(1430),
    [aux_sym_continue_statement_token1] = ACTIONS(1430),
    [aux_sym_break_statement_token1] = ACTIONS(1430),
    [sym_integer] = ACTIONS(1430),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_throw_expression_token1] = ACTIONS(1430),
    [aux_sym_while_statement_token1] = ACTIONS(1430),
    [aux_sym_while_statement_token2] = ACTIONS(1430),
    [aux_sym_do_statement_token1] = ACTIONS(1430),
    [aux_sym_for_statement_token1] = ACTIONS(1430),
    [aux_sym_for_statement_token2] = ACTIONS(1430),
    [aux_sym_foreach_statement_token1] = ACTIONS(1430),
    [aux_sym_foreach_statement_token2] = ACTIONS(1430),
    [aux_sym_if_statement_token1] = ACTIONS(1430),
    [aux_sym_if_statement_token2] = ACTIONS(1430),
    [aux_sym_else_if_clause_token1] = ACTIONS(1430),
    [aux_sym_else_clause_token1] = ACTIONS(1430),
    [aux_sym_match_expression_token1] = ACTIONS(1430),
    [aux_sym_match_default_expression_token1] = ACTIONS(1430),
    [aux_sym_switch_statement_token1] = ACTIONS(1430),
    [aux_sym_switch_block_token1] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [aux_sym_clone_expression_token1] = ACTIONS(1430),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1430),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [aux_sym__list_destructing_token1] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_self] = ACTIONS(1430),
    [anon_sym_parent] = ACTIONS(1430),
    [aux_sym__argument_name_token1] = ACTIONS(1430),
    [aux_sym__argument_name_token2] = ACTIONS(1430),
    [anon_sym_POUND_LBRACK] = ACTIONS(1428),
    [aux_sym_encapsed_string_token1] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [aux_sym_string_token1] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LT_LT] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [aux_sym_yield_expression_token1] = ACTIONS(1430),
    [aux_sym_include_expression_token1] = ACTIONS(1430),
    [aux_sym_include_once_expression_token1] = ACTIONS(1430),
    [aux_sym_require_expression_token1] = ACTIONS(1430),
    [aux_sym_require_once_expression_token1] = ACTIONS(1430),
    [sym_comment] = ACTIONS(5),
  },
  [533] = {
    [sym_text_interpolation] = STATE(533),
    [ts_builtin_sym_end] = ACTIONS(1432),
    [sym_name] = ACTIONS(1434),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1432),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1434),
    [aux_sym_global_declaration_token1] = ACTIONS(1434),
    [aux_sym_namespace_definition_token1] = ACTIONS(1434),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1434),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1434),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1434),
    [anon_sym_BSLASH] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(1432),
    [anon_sym_RBRACE] = ACTIONS(1432),
    [aux_sym_trait_declaration_token1] = ACTIONS(1434),
    [aux_sym_interface_declaration_token1] = ACTIONS(1434),
    [aux_sym_enum_declaration_token1] = ACTIONS(1434),
    [aux_sym_enum_case_token1] = ACTIONS(1434),
    [aux_sym_class_declaration_token1] = ACTIONS(1434),
    [aux_sym_final_modifier_token1] = ACTIONS(1434),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1434),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1434),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1434),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1434),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1434),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1432),
    [aux_sym_cast_type_token1] = ACTIONS(1434),
    [aux_sym_echo_statement_token1] = ACTIONS(1434),
    [anon_sym_unset] = ACTIONS(1434),
    [aux_sym_declare_statement_token1] = ACTIONS(1434),
    [aux_sym_declare_statement_token2] = ACTIONS(1434),
    [sym_float] = ACTIONS(1434),
    [aux_sym_try_statement_token1] = ACTIONS(1434),
    [aux_sym_goto_statement_token1] = ACTIONS(1434),
    [aux_sym_continue_statement_token1] = ACTIONS(1434),
    [aux_sym_break_statement_token1] = ACTIONS(1434),
    [sym_integer] = ACTIONS(1434),
    [aux_sym_return_statement_token1] = ACTIONS(1434),
    [aux_sym_throw_expression_token1] = ACTIONS(1434),
    [aux_sym_while_statement_token1] = ACTIONS(1434),
    [aux_sym_while_statement_token2] = ACTIONS(1434),
    [aux_sym_do_statement_token1] = ACTIONS(1434),
    [aux_sym_for_statement_token1] = ACTIONS(1434),
    [aux_sym_for_statement_token2] = ACTIONS(1434),
    [aux_sym_foreach_statement_token1] = ACTIONS(1434),
    [aux_sym_foreach_statement_token2] = ACTIONS(1434),
    [aux_sym_if_statement_token1] = ACTIONS(1434),
    [aux_sym_if_statement_token2] = ACTIONS(1434),
    [aux_sym_else_if_clause_token1] = ACTIONS(1434),
    [aux_sym_else_clause_token1] = ACTIONS(1434),
    [aux_sym_match_expression_token1] = ACTIONS(1434),
    [aux_sym_match_default_expression_token1] = ACTIONS(1434),
    [aux_sym_switch_statement_token1] = ACTIONS(1434),
    [aux_sym_switch_block_token1] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1432),
    [anon_sym_BANG] = ACTIONS(1432),
    [anon_sym_AT] = ACTIONS(1432),
    [aux_sym_clone_expression_token1] = ACTIONS(1434),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1434),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1432),
    [aux_sym__list_destructing_token1] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_self] = ACTIONS(1434),
    [anon_sym_parent] = ACTIONS(1434),
    [aux_sym__argument_name_token1] = ACTIONS(1434),
    [aux_sym__argument_name_token2] = ACTIONS(1434),
    [anon_sym_POUND_LBRACK] = ACTIONS(1432),
    [aux_sym_encapsed_string_token1] = ACTIONS(1432),
    [anon_sym_DQUOTE] = ACTIONS(1432),
    [aux_sym_string_token1] = ACTIONS(1432),
    [anon_sym_SQUOTE] = ACTIONS(1432),
    [anon_sym_LT_LT_LT] = ACTIONS(1432),
    [anon_sym_BQUOTE] = ACTIONS(1432),
    [anon_sym_DOLLAR] = ACTIONS(1432),
    [aux_sym_yield_expression_token1] = ACTIONS(1434),
    [aux_sym_include_expression_token1] = ACTIONS(1434),
    [aux_sym_include_once_expression_token1] = ACTIONS(1434),
    [aux_sym_require_expression_token1] = ACTIONS(1434),
    [aux_sym_require_once_expression_token1] = ACTIONS(1434),
    [sym_comment] = ACTIONS(5),
  },
  [534] = {
    [sym_text_interpolation] = STATE(534),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [sym_name] = ACTIONS(1438),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1436),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1438),
    [aux_sym_global_declaration_token1] = ACTIONS(1438),
    [aux_sym_namespace_definition_token1] = ACTIONS(1438),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1438),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1438),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1438),
    [anon_sym_BSLASH] = ACTIONS(1436),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [aux_sym_trait_declaration_token1] = ACTIONS(1438),
    [aux_sym_interface_declaration_token1] = ACTIONS(1438),
    [aux_sym_enum_declaration_token1] = ACTIONS(1438),
    [aux_sym_enum_case_token1] = ACTIONS(1438),
    [aux_sym_class_declaration_token1] = ACTIONS(1438),
    [aux_sym_final_modifier_token1] = ACTIONS(1438),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1438),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1438),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1438),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1438),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1438),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1438),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [aux_sym_cast_type_token1] = ACTIONS(1438),
    [aux_sym_echo_statement_token1] = ACTIONS(1438),
    [anon_sym_unset] = ACTIONS(1438),
    [aux_sym_declare_statement_token1] = ACTIONS(1438),
    [aux_sym_declare_statement_token2] = ACTIONS(1438),
    [sym_float] = ACTIONS(1438),
    [aux_sym_try_statement_token1] = ACTIONS(1438),
    [aux_sym_goto_statement_token1] = ACTIONS(1438),
    [aux_sym_continue_statement_token1] = ACTIONS(1438),
    [aux_sym_break_statement_token1] = ACTIONS(1438),
    [sym_integer] = ACTIONS(1438),
    [aux_sym_return_statement_token1] = ACTIONS(1438),
    [aux_sym_throw_expression_token1] = ACTIONS(1438),
    [aux_sym_while_statement_token1] = ACTIONS(1438),
    [aux_sym_while_statement_token2] = ACTIONS(1438),
    [aux_sym_do_statement_token1] = ACTIONS(1438),
    [aux_sym_for_statement_token1] = ACTIONS(1438),
    [aux_sym_for_statement_token2] = ACTIONS(1438),
    [aux_sym_foreach_statement_token1] = ACTIONS(1438),
    [aux_sym_foreach_statement_token2] = ACTIONS(1438),
    [aux_sym_if_statement_token1] = ACTIONS(1438),
    [aux_sym_if_statement_token2] = ACTIONS(1438),
    [aux_sym_else_if_clause_token1] = ACTIONS(1438),
    [aux_sym_else_clause_token1] = ACTIONS(1438),
    [aux_sym_match_expression_token1] = ACTIONS(1438),
    [aux_sym_match_default_expression_token1] = ACTIONS(1438),
    [aux_sym_switch_statement_token1] = ACTIONS(1438),
    [aux_sym_switch_block_token1] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_AT] = ACTIONS(1436),
    [aux_sym_clone_expression_token1] = ACTIONS(1438),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1438),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1438),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [aux_sym__list_destructing_token1] = ACTIONS(1438),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [anon_sym_self] = ACTIONS(1438),
    [anon_sym_parent] = ACTIONS(1438),
    [aux_sym__argument_name_token1] = ACTIONS(1438),
    [aux_sym__argument_name_token2] = ACTIONS(1438),
    [anon_sym_POUND_LBRACK] = ACTIONS(1436),
    [aux_sym_encapsed_string_token1] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [aux_sym_string_token1] = ACTIONS(1436),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_LT_LT_LT] = ACTIONS(1436),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [anon_sym_DOLLAR] = ACTIONS(1436),
    [aux_sym_yield_expression_token1] = ACTIONS(1438),
    [aux_sym_include_expression_token1] = ACTIONS(1438),
    [aux_sym_include_once_expression_token1] = ACTIONS(1438),
    [aux_sym_require_expression_token1] = ACTIONS(1438),
    [aux_sym_require_once_expression_token1] = ACTIONS(1438),
    [sym_comment] = ACTIONS(5),
  },
  [535] = {
    [sym_text_interpolation] = STATE(535),
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_name] = ACTIONS(1430),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1428),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1430),
    [aux_sym_global_declaration_token1] = ACTIONS(1430),
    [aux_sym_namespace_definition_token1] = ACTIONS(1430),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1430),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1430),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1430),
    [anon_sym_BSLASH] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [aux_sym_trait_declaration_token1] = ACTIONS(1430),
    [aux_sym_interface_declaration_token1] = ACTIONS(1430),
    [aux_sym_enum_declaration_token1] = ACTIONS(1430),
    [aux_sym_enum_case_token1] = ACTIONS(1430),
    [aux_sym_class_declaration_token1] = ACTIONS(1430),
    [aux_sym_final_modifier_token1] = ACTIONS(1430),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1430),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1430),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1430),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1430),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1430),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [aux_sym_cast_type_token1] = ACTIONS(1430),
    [aux_sym_echo_statement_token1] = ACTIONS(1430),
    [anon_sym_unset] = ACTIONS(1430),
    [aux_sym_declare_statement_token1] = ACTIONS(1430),
    [aux_sym_declare_statement_token2] = ACTIONS(1430),
    [sym_float] = ACTIONS(1430),
    [aux_sym_try_statement_token1] = ACTIONS(1430),
    [aux_sym_goto_statement_token1] = ACTIONS(1430),
    [aux_sym_continue_statement_token1] = ACTIONS(1430),
    [aux_sym_break_statement_token1] = ACTIONS(1430),
    [sym_integer] = ACTIONS(1430),
    [aux_sym_return_statement_token1] = ACTIONS(1430),
    [aux_sym_throw_expression_token1] = ACTIONS(1430),
    [aux_sym_while_statement_token1] = ACTIONS(1430),
    [aux_sym_while_statement_token2] = ACTIONS(1430),
    [aux_sym_do_statement_token1] = ACTIONS(1430),
    [aux_sym_for_statement_token1] = ACTIONS(1430),
    [aux_sym_for_statement_token2] = ACTIONS(1430),
    [aux_sym_foreach_statement_token1] = ACTIONS(1430),
    [aux_sym_foreach_statement_token2] = ACTIONS(1430),
    [aux_sym_if_statement_token1] = ACTIONS(1430),
    [aux_sym_if_statement_token2] = ACTIONS(1430),
    [aux_sym_else_if_clause_token1] = ACTIONS(1430),
    [aux_sym_else_clause_token1] = ACTIONS(1430),
    [aux_sym_match_expression_token1] = ACTIONS(1430),
    [aux_sym_match_default_expression_token1] = ACTIONS(1430),
    [aux_sym_switch_statement_token1] = ACTIONS(1430),
    [aux_sym_switch_block_token1] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_BANG] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [aux_sym_clone_expression_token1] = ACTIONS(1430),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1430),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1430),
    [anon_sym_DASH_DASH] = ACTIONS(1428),
    [anon_sym_PLUS_PLUS] = ACTIONS(1428),
    [aux_sym__list_destructing_token1] = ACTIONS(1430),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_self] = ACTIONS(1430),
    [anon_sym_parent] = ACTIONS(1430),
    [aux_sym__argument_name_token1] = ACTIONS(1430),
    [aux_sym__argument_name_token2] = ACTIONS(1430),
    [anon_sym_POUND_LBRACK] = ACTIONS(1428),
    [aux_sym_encapsed_string_token1] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [aux_sym_string_token1] = ACTIONS(1428),
    [anon_sym_SQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LT_LT] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(1428),
    [aux_sym_yield_expression_token1] = ACTIONS(1430),
    [aux_sym_include_expression_token1] = ACTIONS(1430),
    [aux_sym_include_once_expression_token1] = ACTIONS(1430),
    [aux_sym_require_expression_token1] = ACTIONS(1430),
    [aux_sym_require_once_expression_token1] = ACTIONS(1430),
    [sym_comment] = ACTIONS(5),
  },
  [536] = {
    [sym_text_interpolation] = STATE(536),
    [ts_builtin_sym_end] = ACTIONS(1440),
    [sym_name] = ACTIONS(1442),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1440),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1442),
    [aux_sym_global_declaration_token1] = ACTIONS(1442),
    [aux_sym_namespace_definition_token1] = ACTIONS(1442),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1442),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1442),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1442),
    [anon_sym_BSLASH] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [aux_sym_trait_declaration_token1] = ACTIONS(1442),
    [aux_sym_interface_declaration_token1] = ACTIONS(1442),
    [aux_sym_enum_declaration_token1] = ACTIONS(1442),
    [aux_sym_enum_case_token1] = ACTIONS(1442),
    [aux_sym_class_declaration_token1] = ACTIONS(1442),
    [aux_sym_final_modifier_token1] = ACTIONS(1442),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1442),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1442),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1442),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1442),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1442),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [aux_sym_cast_type_token1] = ACTIONS(1442),
    [aux_sym_echo_statement_token1] = ACTIONS(1442),
    [anon_sym_unset] = ACTIONS(1442),
    [aux_sym_declare_statement_token1] = ACTIONS(1442),
    [aux_sym_declare_statement_token2] = ACTIONS(1442),
    [sym_float] = ACTIONS(1442),
    [aux_sym_try_statement_token1] = ACTIONS(1442),
    [aux_sym_goto_statement_token1] = ACTIONS(1442),
    [aux_sym_continue_statement_token1] = ACTIONS(1442),
    [aux_sym_break_statement_token1] = ACTIONS(1442),
    [sym_integer] = ACTIONS(1442),
    [aux_sym_return_statement_token1] = ACTIONS(1442),
    [aux_sym_throw_expression_token1] = ACTIONS(1442),
    [aux_sym_while_statement_token1] = ACTIONS(1442),
    [aux_sym_while_statement_token2] = ACTIONS(1442),
    [aux_sym_do_statement_token1] = ACTIONS(1442),
    [aux_sym_for_statement_token1] = ACTIONS(1442),
    [aux_sym_for_statement_token2] = ACTIONS(1442),
    [aux_sym_foreach_statement_token1] = ACTIONS(1442),
    [aux_sym_foreach_statement_token2] = ACTIONS(1442),
    [aux_sym_if_statement_token1] = ACTIONS(1442),
    [aux_sym_if_statement_token2] = ACTIONS(1442),
    [aux_sym_else_if_clause_token1] = ACTIONS(1442),
    [aux_sym_else_clause_token1] = ACTIONS(1442),
    [aux_sym_match_expression_token1] = ACTIONS(1442),
    [aux_sym_match_default_expression_token1] = ACTIONS(1442),
    [aux_sym_switch_statement_token1] = ACTIONS(1442),
    [aux_sym_switch_block_token1] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1440),
    [aux_sym_clone_expression_token1] = ACTIONS(1442),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1442),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [aux_sym__list_destructing_token1] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1440),
    [anon_sym_self] = ACTIONS(1442),
    [anon_sym_parent] = ACTIONS(1442),
    [aux_sym__argument_name_token1] = ACTIONS(1442),
    [aux_sym__argument_name_token2] = ACTIONS(1442),
    [anon_sym_POUND_LBRACK] = ACTIONS(1440),
    [aux_sym_encapsed_string_token1] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [aux_sym_string_token1] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [aux_sym_yield_expression_token1] = ACTIONS(1442),
    [aux_sym_include_expression_token1] = ACTIONS(1442),
    [aux_sym_include_once_expression_token1] = ACTIONS(1442),
    [aux_sym_require_expression_token1] = ACTIONS(1442),
    [aux_sym_require_once_expression_token1] = ACTIONS(1442),
    [sym_comment] = ACTIONS(5),
  },
  [537] = {
    [sym_text_interpolation] = STATE(537),
    [ts_builtin_sym_end] = ACTIONS(1444),
    [sym_name] = ACTIONS(1446),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1444),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1446),
    [aux_sym_global_declaration_token1] = ACTIONS(1446),
    [aux_sym_namespace_definition_token1] = ACTIONS(1446),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1446),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1446),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1446),
    [anon_sym_BSLASH] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1444),
    [aux_sym_trait_declaration_token1] = ACTIONS(1446),
    [aux_sym_interface_declaration_token1] = ACTIONS(1446),
    [aux_sym_enum_declaration_token1] = ACTIONS(1446),
    [aux_sym_enum_case_token1] = ACTIONS(1446),
    [aux_sym_class_declaration_token1] = ACTIONS(1446),
    [aux_sym_final_modifier_token1] = ACTIONS(1446),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1446),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1446),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1446),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1446),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1446),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1446),
    [anon_sym_LPAREN] = ACTIONS(1444),
    [aux_sym_cast_type_token1] = ACTIONS(1446),
    [aux_sym_echo_statement_token1] = ACTIONS(1446),
    [anon_sym_unset] = ACTIONS(1446),
    [aux_sym_declare_statement_token1] = ACTIONS(1446),
    [aux_sym_declare_statement_token2] = ACTIONS(1446),
    [sym_float] = ACTIONS(1446),
    [aux_sym_try_statement_token1] = ACTIONS(1446),
    [aux_sym_goto_statement_token1] = ACTIONS(1446),
    [aux_sym_continue_statement_token1] = ACTIONS(1446),
    [aux_sym_break_statement_token1] = ACTIONS(1446),
    [sym_integer] = ACTIONS(1446),
    [aux_sym_return_statement_token1] = ACTIONS(1446),
    [aux_sym_throw_expression_token1] = ACTIONS(1446),
    [aux_sym_while_statement_token1] = ACTIONS(1446),
    [aux_sym_while_statement_token2] = ACTIONS(1446),
    [aux_sym_do_statement_token1] = ACTIONS(1446),
    [aux_sym_for_statement_token1] = ACTIONS(1446),
    [aux_sym_for_statement_token2] = ACTIONS(1446),
    [aux_sym_foreach_statement_token1] = ACTIONS(1446),
    [aux_sym_foreach_statement_token2] = ACTIONS(1446),
    [aux_sym_if_statement_token1] = ACTIONS(1446),
    [aux_sym_if_statement_token2] = ACTIONS(1446),
    [aux_sym_else_if_clause_token1] = ACTIONS(1446),
    [aux_sym_else_clause_token1] = ACTIONS(1446),
    [aux_sym_match_expression_token1] = ACTIONS(1446),
    [aux_sym_match_default_expression_token1] = ACTIONS(1446),
    [aux_sym_switch_statement_token1] = ACTIONS(1446),
    [aux_sym_switch_block_token1] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_TILDE] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1444),
    [anon_sym_AT] = ACTIONS(1444),
    [aux_sym_clone_expression_token1] = ACTIONS(1446),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1446),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1446),
    [anon_sym_DASH_DASH] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1444),
    [aux_sym__list_destructing_token1] = ACTIONS(1446),
    [anon_sym_LBRACK] = ACTIONS(1444),
    [anon_sym_self] = ACTIONS(1446),
    [anon_sym_parent] = ACTIONS(1446),
    [aux_sym__argument_name_token1] = ACTIONS(1446),
    [aux_sym__argument_name_token2] = ACTIONS(1446),
    [anon_sym_POUND_LBRACK] = ACTIONS(1444),
    [aux_sym_encapsed_string_token1] = ACTIONS(1444),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [aux_sym_string_token1] = ACTIONS(1444),
    [anon_sym_SQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1444),
    [aux_sym_yield_expression_token1] = ACTIONS(1446),
    [aux_sym_include_expression_token1] = ACTIONS(1446),
    [aux_sym_include_once_expression_token1] = ACTIONS(1446),
    [aux_sym_require_expression_token1] = ACTIONS(1446),
    [aux_sym_require_once_expression_token1] = ACTIONS(1446),
    [sym_comment] = ACTIONS(5),
  },
  [538] = {
    [sym_text_interpolation] = STATE(538),
    [ts_builtin_sym_end] = ACTIONS(1448),
    [sym_name] = ACTIONS(1450),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1448),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1450),
    [aux_sym_global_declaration_token1] = ACTIONS(1450),
    [aux_sym_namespace_definition_token1] = ACTIONS(1450),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1450),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1450),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1450),
    [anon_sym_BSLASH] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1448),
    [anon_sym_RBRACE] = ACTIONS(1448),
    [aux_sym_trait_declaration_token1] = ACTIONS(1450),
    [aux_sym_interface_declaration_token1] = ACTIONS(1450),
    [aux_sym_enum_declaration_token1] = ACTIONS(1450),
    [aux_sym_enum_case_token1] = ACTIONS(1450),
    [aux_sym_class_declaration_token1] = ACTIONS(1450),
    [aux_sym_final_modifier_token1] = ACTIONS(1450),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1450),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1450),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1450),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1450),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1450),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1450),
    [anon_sym_LPAREN] = ACTIONS(1448),
    [aux_sym_cast_type_token1] = ACTIONS(1450),
    [aux_sym_echo_statement_token1] = ACTIONS(1450),
    [anon_sym_unset] = ACTIONS(1450),
    [aux_sym_declare_statement_token1] = ACTIONS(1450),
    [aux_sym_declare_statement_token2] = ACTIONS(1450),
    [sym_float] = ACTIONS(1450),
    [aux_sym_try_statement_token1] = ACTIONS(1450),
    [aux_sym_goto_statement_token1] = ACTIONS(1450),
    [aux_sym_continue_statement_token1] = ACTIONS(1450),
    [aux_sym_break_statement_token1] = ACTIONS(1450),
    [sym_integer] = ACTIONS(1450),
    [aux_sym_return_statement_token1] = ACTIONS(1450),
    [aux_sym_throw_expression_token1] = ACTIONS(1450),
    [aux_sym_while_statement_token1] = ACTIONS(1450),
    [aux_sym_while_statement_token2] = ACTIONS(1450),
    [aux_sym_do_statement_token1] = ACTIONS(1450),
    [aux_sym_for_statement_token1] = ACTIONS(1450),
    [aux_sym_for_statement_token2] = ACTIONS(1450),
    [aux_sym_foreach_statement_token1] = ACTIONS(1450),
    [aux_sym_foreach_statement_token2] = ACTIONS(1450),
    [aux_sym_if_statement_token1] = ACTIONS(1450),
    [aux_sym_if_statement_token2] = ACTIONS(1450),
    [aux_sym_else_if_clause_token1] = ACTIONS(1450),
    [aux_sym_else_clause_token1] = ACTIONS(1450),
    [aux_sym_match_expression_token1] = ACTIONS(1450),
    [aux_sym_match_default_expression_token1] = ACTIONS(1450),
    [aux_sym_switch_statement_token1] = ACTIONS(1450),
    [aux_sym_switch_block_token1] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_TILDE] = ACTIONS(1448),
    [anon_sym_BANG] = ACTIONS(1448),
    [anon_sym_AT] = ACTIONS(1448),
    [aux_sym_clone_expression_token1] = ACTIONS(1450),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1450),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1450),
    [anon_sym_DASH_DASH] = ACTIONS(1448),
    [anon_sym_PLUS_PLUS] = ACTIONS(1448),
    [aux_sym__list_destructing_token1] = ACTIONS(1450),
    [anon_sym_LBRACK] = ACTIONS(1448),
    [anon_sym_self] = ACTIONS(1450),
    [anon_sym_parent] = ACTIONS(1450),
    [aux_sym__argument_name_token1] = ACTIONS(1450),
    [aux_sym__argument_name_token2] = ACTIONS(1450),
    [anon_sym_POUND_LBRACK] = ACTIONS(1448),
    [aux_sym_encapsed_string_token1] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1448),
    [aux_sym_string_token1] = ACTIONS(1448),
    [anon_sym_SQUOTE] = ACTIONS(1448),
    [anon_sym_LT_LT_LT] = ACTIONS(1448),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [anon_sym_DOLLAR] = ACTIONS(1448),
    [aux_sym_yield_expression_token1] = ACTIONS(1450),
    [aux_sym_include_expression_token1] = ACTIONS(1450),
    [aux_sym_include_once_expression_token1] = ACTIONS(1450),
    [aux_sym_require_expression_token1] = ACTIONS(1450),
    [aux_sym_require_once_expression_token1] = ACTIONS(1450),
    [sym_comment] = ACTIONS(5),
  },
  [539] = {
    [sym_text_interpolation] = STATE(539),
    [ts_builtin_sym_end] = ACTIONS(1452),
    [sym_name] = ACTIONS(1454),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1452),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1454),
    [aux_sym_global_declaration_token1] = ACTIONS(1454),
    [aux_sym_namespace_definition_token1] = ACTIONS(1454),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1454),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1454),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1454),
    [anon_sym_BSLASH] = ACTIONS(1452),
    [anon_sym_LBRACE] = ACTIONS(1452),
    [anon_sym_RBRACE] = ACTIONS(1452),
    [aux_sym_trait_declaration_token1] = ACTIONS(1454),
    [aux_sym_interface_declaration_token1] = ACTIONS(1454),
    [aux_sym_enum_declaration_token1] = ACTIONS(1454),
    [aux_sym_enum_case_token1] = ACTIONS(1454),
    [aux_sym_class_declaration_token1] = ACTIONS(1454),
    [aux_sym_final_modifier_token1] = ACTIONS(1454),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1454),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1454),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1454),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1454),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1454),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(1452),
    [aux_sym_cast_type_token1] = ACTIONS(1454),
    [aux_sym_echo_statement_token1] = ACTIONS(1454),
    [anon_sym_unset] = ACTIONS(1454),
    [aux_sym_declare_statement_token1] = ACTIONS(1454),
    [aux_sym_declare_statement_token2] = ACTIONS(1454),
    [sym_float] = ACTIONS(1454),
    [aux_sym_try_statement_token1] = ACTIONS(1454),
    [aux_sym_goto_statement_token1] = ACTIONS(1454),
    [aux_sym_continue_statement_token1] = ACTIONS(1454),
    [aux_sym_break_statement_token1] = ACTIONS(1454),
    [sym_integer] = ACTIONS(1454),
    [aux_sym_return_statement_token1] = ACTIONS(1454),
    [aux_sym_throw_expression_token1] = ACTIONS(1454),
    [aux_sym_while_statement_token1] = ACTIONS(1454),
    [aux_sym_while_statement_token2] = ACTIONS(1454),
    [aux_sym_do_statement_token1] = ACTIONS(1454),
    [aux_sym_for_statement_token1] = ACTIONS(1454),
    [aux_sym_for_statement_token2] = ACTIONS(1454),
    [aux_sym_foreach_statement_token1] = ACTIONS(1454),
    [aux_sym_foreach_statement_token2] = ACTIONS(1454),
    [aux_sym_if_statement_token1] = ACTIONS(1454),
    [aux_sym_if_statement_token2] = ACTIONS(1454),
    [aux_sym_else_if_clause_token1] = ACTIONS(1454),
    [aux_sym_else_clause_token1] = ACTIONS(1454),
    [aux_sym_match_expression_token1] = ACTIONS(1454),
    [aux_sym_match_default_expression_token1] = ACTIONS(1454),
    [aux_sym_switch_statement_token1] = ACTIONS(1454),
    [aux_sym_switch_block_token1] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_TILDE] = ACTIONS(1452),
    [anon_sym_BANG] = ACTIONS(1452),
    [anon_sym_AT] = ACTIONS(1452),
    [aux_sym_clone_expression_token1] = ACTIONS(1454),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1454),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1454),
    [anon_sym_DASH_DASH] = ACTIONS(1452),
    [anon_sym_PLUS_PLUS] = ACTIONS(1452),
    [aux_sym__list_destructing_token1] = ACTIONS(1454),
    [anon_sym_LBRACK] = ACTIONS(1452),
    [anon_sym_self] = ACTIONS(1454),
    [anon_sym_parent] = ACTIONS(1454),
    [aux_sym__argument_name_token1] = ACTIONS(1454),
    [aux_sym__argument_name_token2] = ACTIONS(1454),
    [anon_sym_POUND_LBRACK] = ACTIONS(1452),
    [aux_sym_encapsed_string_token1] = ACTIONS(1452),
    [anon_sym_DQUOTE] = ACTIONS(1452),
    [aux_sym_string_token1] = ACTIONS(1452),
    [anon_sym_SQUOTE] = ACTIONS(1452),
    [anon_sym_LT_LT_LT] = ACTIONS(1452),
    [anon_sym_BQUOTE] = ACTIONS(1452),
    [anon_sym_DOLLAR] = ACTIONS(1452),
    [aux_sym_yield_expression_token1] = ACTIONS(1454),
    [aux_sym_include_expression_token1] = ACTIONS(1454),
    [aux_sym_include_once_expression_token1] = ACTIONS(1454),
    [aux_sym_require_expression_token1] = ACTIONS(1454),
    [aux_sym_require_once_expression_token1] = ACTIONS(1454),
    [sym_comment] = ACTIONS(5),
  },
  [540] = {
    [sym_text_interpolation] = STATE(540),
    [ts_builtin_sym_end] = ACTIONS(1456),
    [sym_name] = ACTIONS(1458),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1456),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1458),
    [aux_sym_global_declaration_token1] = ACTIONS(1458),
    [aux_sym_namespace_definition_token1] = ACTIONS(1458),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1458),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1458),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1458),
    [anon_sym_BSLASH] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(1456),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [aux_sym_trait_declaration_token1] = ACTIONS(1458),
    [aux_sym_interface_declaration_token1] = ACTIONS(1458),
    [aux_sym_enum_declaration_token1] = ACTIONS(1458),
    [aux_sym_enum_case_token1] = ACTIONS(1458),
    [aux_sym_class_declaration_token1] = ACTIONS(1458),
    [aux_sym_final_modifier_token1] = ACTIONS(1458),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1458),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1458),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1458),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1458),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1458),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1458),
    [anon_sym_LPAREN] = ACTIONS(1456),
    [aux_sym_cast_type_token1] = ACTIONS(1458),
    [aux_sym_echo_statement_token1] = ACTIONS(1458),
    [anon_sym_unset] = ACTIONS(1458),
    [aux_sym_declare_statement_token1] = ACTIONS(1458),
    [aux_sym_declare_statement_token2] = ACTIONS(1458),
    [sym_float] = ACTIONS(1458),
    [aux_sym_try_statement_token1] = ACTIONS(1458),
    [aux_sym_goto_statement_token1] = ACTIONS(1458),
    [aux_sym_continue_statement_token1] = ACTIONS(1458),
    [aux_sym_break_statement_token1] = ACTIONS(1458),
    [sym_integer] = ACTIONS(1458),
    [aux_sym_return_statement_token1] = ACTIONS(1458),
    [aux_sym_throw_expression_token1] = ACTIONS(1458),
    [aux_sym_while_statement_token1] = ACTIONS(1458),
    [aux_sym_while_statement_token2] = ACTIONS(1458),
    [aux_sym_do_statement_token1] = ACTIONS(1458),
    [aux_sym_for_statement_token1] = ACTIONS(1458),
    [aux_sym_for_statement_token2] = ACTIONS(1458),
    [aux_sym_foreach_statement_token1] = ACTIONS(1458),
    [aux_sym_foreach_statement_token2] = ACTIONS(1458),
    [aux_sym_if_statement_token1] = ACTIONS(1458),
    [aux_sym_if_statement_token2] = ACTIONS(1458),
    [aux_sym_else_if_clause_token1] = ACTIONS(1458),
    [aux_sym_else_clause_token1] = ACTIONS(1458),
    [aux_sym_match_expression_token1] = ACTIONS(1458),
    [aux_sym_match_default_expression_token1] = ACTIONS(1458),
    [aux_sym_switch_statement_token1] = ACTIONS(1458),
    [aux_sym_switch_block_token1] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_TILDE] = ACTIONS(1456),
    [anon_sym_BANG] = ACTIONS(1456),
    [anon_sym_AT] = ACTIONS(1456),
    [aux_sym_clone_expression_token1] = ACTIONS(1458),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1458),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1458),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [aux_sym__list_destructing_token1] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(1456),
    [anon_sym_self] = ACTIONS(1458),
    [anon_sym_parent] = ACTIONS(1458),
    [aux_sym__argument_name_token1] = ACTIONS(1458),
    [aux_sym__argument_name_token2] = ACTIONS(1458),
    [anon_sym_POUND_LBRACK] = ACTIONS(1456),
    [aux_sym_encapsed_string_token1] = ACTIONS(1456),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [aux_sym_string_token1] = ACTIONS(1456),
    [anon_sym_SQUOTE] = ACTIONS(1456),
    [anon_sym_LT_LT_LT] = ACTIONS(1456),
    [anon_sym_BQUOTE] = ACTIONS(1456),
    [anon_sym_DOLLAR] = ACTIONS(1456),
    [aux_sym_yield_expression_token1] = ACTIONS(1458),
    [aux_sym_include_expression_token1] = ACTIONS(1458),
    [aux_sym_include_once_expression_token1] = ACTIONS(1458),
    [aux_sym_require_expression_token1] = ACTIONS(1458),
    [aux_sym_require_once_expression_token1] = ACTIONS(1458),
    [sym_comment] = ACTIONS(5),
  },
  [541] = {
    [sym_text_interpolation] = STATE(541),
    [ts_builtin_sym_end] = ACTIONS(1460),
    [sym_name] = ACTIONS(1462),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1460),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1462),
    [aux_sym_global_declaration_token1] = ACTIONS(1462),
    [aux_sym_namespace_definition_token1] = ACTIONS(1462),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1462),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1462),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1462),
    [anon_sym_BSLASH] = ACTIONS(1460),
    [anon_sym_LBRACE] = ACTIONS(1460),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [aux_sym_trait_declaration_token1] = ACTIONS(1462),
    [aux_sym_interface_declaration_token1] = ACTIONS(1462),
    [aux_sym_enum_declaration_token1] = ACTIONS(1462),
    [aux_sym_enum_case_token1] = ACTIONS(1462),
    [aux_sym_class_declaration_token1] = ACTIONS(1462),
    [aux_sym_final_modifier_token1] = ACTIONS(1462),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1462),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1462),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1462),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1462),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1462),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1462),
    [anon_sym_LPAREN] = ACTIONS(1460),
    [aux_sym_cast_type_token1] = ACTIONS(1462),
    [aux_sym_echo_statement_token1] = ACTIONS(1462),
    [anon_sym_unset] = ACTIONS(1462),
    [aux_sym_declare_statement_token1] = ACTIONS(1462),
    [aux_sym_declare_statement_token2] = ACTIONS(1462),
    [sym_float] = ACTIONS(1462),
    [aux_sym_try_statement_token1] = ACTIONS(1462),
    [aux_sym_goto_statement_token1] = ACTIONS(1462),
    [aux_sym_continue_statement_token1] = ACTIONS(1462),
    [aux_sym_break_statement_token1] = ACTIONS(1462),
    [sym_integer] = ACTIONS(1462),
    [aux_sym_return_statement_token1] = ACTIONS(1462),
    [aux_sym_throw_expression_token1] = ACTIONS(1462),
    [aux_sym_while_statement_token1] = ACTIONS(1462),
    [aux_sym_while_statement_token2] = ACTIONS(1462),
    [aux_sym_do_statement_token1] = ACTIONS(1462),
    [aux_sym_for_statement_token1] = ACTIONS(1462),
    [aux_sym_for_statement_token2] = ACTIONS(1462),
    [aux_sym_foreach_statement_token1] = ACTIONS(1462),
    [aux_sym_foreach_statement_token2] = ACTIONS(1462),
    [aux_sym_if_statement_token1] = ACTIONS(1462),
    [aux_sym_if_statement_token2] = ACTIONS(1462),
    [aux_sym_else_if_clause_token1] = ACTIONS(1462),
    [aux_sym_else_clause_token1] = ACTIONS(1462),
    [aux_sym_match_expression_token1] = ACTIONS(1462),
    [aux_sym_match_default_expression_token1] = ACTIONS(1462),
    [aux_sym_switch_statement_token1] = ACTIONS(1462),
    [aux_sym_switch_block_token1] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_TILDE] = ACTIONS(1460),
    [anon_sym_BANG] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(1460),
    [aux_sym_clone_expression_token1] = ACTIONS(1462),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1462),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1462),
    [anon_sym_DASH_DASH] = ACTIONS(1460),
    [anon_sym_PLUS_PLUS] = ACTIONS(1460),
    [aux_sym__list_destructing_token1] = ACTIONS(1462),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_self] = ACTIONS(1462),
    [anon_sym_parent] = ACTIONS(1462),
    [aux_sym__argument_name_token1] = ACTIONS(1462),
    [aux_sym__argument_name_token2] = ACTIONS(1462),
    [anon_sym_POUND_LBRACK] = ACTIONS(1460),
    [aux_sym_encapsed_string_token1] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [aux_sym_string_token1] = ACTIONS(1460),
    [anon_sym_SQUOTE] = ACTIONS(1460),
    [anon_sym_LT_LT_LT] = ACTIONS(1460),
    [anon_sym_BQUOTE] = ACTIONS(1460),
    [anon_sym_DOLLAR] = ACTIONS(1460),
    [aux_sym_yield_expression_token1] = ACTIONS(1462),
    [aux_sym_include_expression_token1] = ACTIONS(1462),
    [aux_sym_include_once_expression_token1] = ACTIONS(1462),
    [aux_sym_require_expression_token1] = ACTIONS(1462),
    [aux_sym_require_once_expression_token1] = ACTIONS(1462),
    [sym_comment] = ACTIONS(5),
  },
  [542] = {
    [sym_text_interpolation] = STATE(542),
    [ts_builtin_sym_end] = ACTIONS(1464),
    [sym_name] = ACTIONS(1466),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1464),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1466),
    [aux_sym_global_declaration_token1] = ACTIONS(1466),
    [aux_sym_namespace_definition_token1] = ACTIONS(1466),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1466),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1466),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1466),
    [anon_sym_BSLASH] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [aux_sym_trait_declaration_token1] = ACTIONS(1466),
    [aux_sym_interface_declaration_token1] = ACTIONS(1466),
    [aux_sym_enum_declaration_token1] = ACTIONS(1466),
    [aux_sym_enum_case_token1] = ACTIONS(1466),
    [aux_sym_class_declaration_token1] = ACTIONS(1466),
    [aux_sym_final_modifier_token1] = ACTIONS(1466),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1466),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1466),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1466),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1466),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1466),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1466),
    [anon_sym_LPAREN] = ACTIONS(1464),
    [aux_sym_cast_type_token1] = ACTIONS(1466),
    [aux_sym_echo_statement_token1] = ACTIONS(1466),
    [anon_sym_unset] = ACTIONS(1466),
    [aux_sym_declare_statement_token1] = ACTIONS(1466),
    [aux_sym_declare_statement_token2] = ACTIONS(1466),
    [sym_float] = ACTIONS(1466),
    [aux_sym_try_statement_token1] = ACTIONS(1466),
    [aux_sym_goto_statement_token1] = ACTIONS(1466),
    [aux_sym_continue_statement_token1] = ACTIONS(1466),
    [aux_sym_break_statement_token1] = ACTIONS(1466),
    [sym_integer] = ACTIONS(1466),
    [aux_sym_return_statement_token1] = ACTIONS(1466),
    [aux_sym_throw_expression_token1] = ACTIONS(1466),
    [aux_sym_while_statement_token1] = ACTIONS(1466),
    [aux_sym_while_statement_token2] = ACTIONS(1466),
    [aux_sym_do_statement_token1] = ACTIONS(1466),
    [aux_sym_for_statement_token1] = ACTIONS(1466),
    [aux_sym_for_statement_token2] = ACTIONS(1466),
    [aux_sym_foreach_statement_token1] = ACTIONS(1466),
    [aux_sym_foreach_statement_token2] = ACTIONS(1466),
    [aux_sym_if_statement_token1] = ACTIONS(1466),
    [aux_sym_if_statement_token2] = ACTIONS(1466),
    [aux_sym_else_if_clause_token1] = ACTIONS(1466),
    [aux_sym_else_clause_token1] = ACTIONS(1466),
    [aux_sym_match_expression_token1] = ACTIONS(1466),
    [aux_sym_match_default_expression_token1] = ACTIONS(1466),
    [aux_sym_switch_statement_token1] = ACTIONS(1466),
    [aux_sym_switch_block_token1] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_TILDE] = ACTIONS(1464),
    [anon_sym_BANG] = ACTIONS(1464),
    [anon_sym_AT] = ACTIONS(1464),
    [aux_sym_clone_expression_token1] = ACTIONS(1466),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1466),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1466),
    [anon_sym_DASH_DASH] = ACTIONS(1464),
    [anon_sym_PLUS_PLUS] = ACTIONS(1464),
    [aux_sym__list_destructing_token1] = ACTIONS(1466),
    [anon_sym_LBRACK] = ACTIONS(1464),
    [anon_sym_self] = ACTIONS(1466),
    [anon_sym_parent] = ACTIONS(1466),
    [aux_sym__argument_name_token1] = ACTIONS(1466),
    [aux_sym__argument_name_token2] = ACTIONS(1466),
    [anon_sym_POUND_LBRACK] = ACTIONS(1464),
    [aux_sym_encapsed_string_token1] = ACTIONS(1464),
    [anon_sym_DQUOTE] = ACTIONS(1464),
    [aux_sym_string_token1] = ACTIONS(1464),
    [anon_sym_SQUOTE] = ACTIONS(1464),
    [anon_sym_LT_LT_LT] = ACTIONS(1464),
    [anon_sym_BQUOTE] = ACTIONS(1464),
    [anon_sym_DOLLAR] = ACTIONS(1464),
    [aux_sym_yield_expression_token1] = ACTIONS(1466),
    [aux_sym_include_expression_token1] = ACTIONS(1466),
    [aux_sym_include_once_expression_token1] = ACTIONS(1466),
    [aux_sym_require_expression_token1] = ACTIONS(1466),
    [aux_sym_require_once_expression_token1] = ACTIONS(1466),
    [sym_comment] = ACTIONS(5),
  },
  [543] = {
    [sym_text_interpolation] = STATE(543),
    [ts_builtin_sym_end] = ACTIONS(1468),
    [sym_name] = ACTIONS(1470),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1468),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1470),
    [aux_sym_global_declaration_token1] = ACTIONS(1470),
    [aux_sym_namespace_definition_token1] = ACTIONS(1470),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1470),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1470),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1470),
    [anon_sym_BSLASH] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(1468),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [aux_sym_trait_declaration_token1] = ACTIONS(1470),
    [aux_sym_interface_declaration_token1] = ACTIONS(1470),
    [aux_sym_enum_declaration_token1] = ACTIONS(1470),
    [aux_sym_enum_case_token1] = ACTIONS(1470),
    [aux_sym_class_declaration_token1] = ACTIONS(1470),
    [aux_sym_final_modifier_token1] = ACTIONS(1470),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1470),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1470),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1470),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1470),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1470),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1468),
    [aux_sym_cast_type_token1] = ACTIONS(1470),
    [aux_sym_echo_statement_token1] = ACTIONS(1470),
    [anon_sym_unset] = ACTIONS(1470),
    [aux_sym_declare_statement_token1] = ACTIONS(1470),
    [aux_sym_declare_statement_token2] = ACTIONS(1470),
    [sym_float] = ACTIONS(1470),
    [aux_sym_try_statement_token1] = ACTIONS(1470),
    [aux_sym_goto_statement_token1] = ACTIONS(1470),
    [aux_sym_continue_statement_token1] = ACTIONS(1470),
    [aux_sym_break_statement_token1] = ACTIONS(1470),
    [sym_integer] = ACTIONS(1470),
    [aux_sym_return_statement_token1] = ACTIONS(1470),
    [aux_sym_throw_expression_token1] = ACTIONS(1470),
    [aux_sym_while_statement_token1] = ACTIONS(1470),
    [aux_sym_while_statement_token2] = ACTIONS(1470),
    [aux_sym_do_statement_token1] = ACTIONS(1470),
    [aux_sym_for_statement_token1] = ACTIONS(1470),
    [aux_sym_for_statement_token2] = ACTIONS(1470),
    [aux_sym_foreach_statement_token1] = ACTIONS(1470),
    [aux_sym_foreach_statement_token2] = ACTIONS(1470),
    [aux_sym_if_statement_token1] = ACTIONS(1470),
    [aux_sym_if_statement_token2] = ACTIONS(1470),
    [aux_sym_else_if_clause_token1] = ACTIONS(1470),
    [aux_sym_else_clause_token1] = ACTIONS(1470),
    [aux_sym_match_expression_token1] = ACTIONS(1470),
    [aux_sym_match_default_expression_token1] = ACTIONS(1470),
    [aux_sym_switch_statement_token1] = ACTIONS(1470),
    [aux_sym_switch_block_token1] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_TILDE] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1468),
    [anon_sym_AT] = ACTIONS(1468),
    [aux_sym_clone_expression_token1] = ACTIONS(1470),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1470),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1470),
    [anon_sym_DASH_DASH] = ACTIONS(1468),
    [anon_sym_PLUS_PLUS] = ACTIONS(1468),
    [aux_sym__list_destructing_token1] = ACTIONS(1470),
    [anon_sym_LBRACK] = ACTIONS(1468),
    [anon_sym_self] = ACTIONS(1470),
    [anon_sym_parent] = ACTIONS(1470),
    [aux_sym__argument_name_token1] = ACTIONS(1470),
    [aux_sym__argument_name_token2] = ACTIONS(1470),
    [anon_sym_POUND_LBRACK] = ACTIONS(1468),
    [aux_sym_encapsed_string_token1] = ACTIONS(1468),
    [anon_sym_DQUOTE] = ACTIONS(1468),
    [aux_sym_string_token1] = ACTIONS(1468),
    [anon_sym_SQUOTE] = ACTIONS(1468),
    [anon_sym_LT_LT_LT] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1468),
    [anon_sym_DOLLAR] = ACTIONS(1468),
    [aux_sym_yield_expression_token1] = ACTIONS(1470),
    [aux_sym_include_expression_token1] = ACTIONS(1470),
    [aux_sym_include_once_expression_token1] = ACTIONS(1470),
    [aux_sym_require_expression_token1] = ACTIONS(1470),
    [aux_sym_require_once_expression_token1] = ACTIONS(1470),
    [sym_comment] = ACTIONS(5),
  },
  [544] = {
    [sym_text_interpolation] = STATE(544),
    [ts_builtin_sym_end] = ACTIONS(1472),
    [sym_name] = ACTIONS(1474),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1472),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1474),
    [aux_sym_global_declaration_token1] = ACTIONS(1474),
    [aux_sym_namespace_definition_token1] = ACTIONS(1474),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1474),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1474),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1474),
    [anon_sym_BSLASH] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [anon_sym_RBRACE] = ACTIONS(1472),
    [aux_sym_trait_declaration_token1] = ACTIONS(1474),
    [aux_sym_interface_declaration_token1] = ACTIONS(1474),
    [aux_sym_enum_declaration_token1] = ACTIONS(1474),
    [aux_sym_enum_case_token1] = ACTIONS(1474),
    [aux_sym_class_declaration_token1] = ACTIONS(1474),
    [aux_sym_final_modifier_token1] = ACTIONS(1474),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1474),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1474),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1474),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1474),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1474),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1474),
    [anon_sym_LPAREN] = ACTIONS(1472),
    [aux_sym_cast_type_token1] = ACTIONS(1474),
    [aux_sym_echo_statement_token1] = ACTIONS(1474),
    [anon_sym_unset] = ACTIONS(1474),
    [aux_sym_declare_statement_token1] = ACTIONS(1474),
    [aux_sym_declare_statement_token2] = ACTIONS(1474),
    [sym_float] = ACTIONS(1474),
    [aux_sym_try_statement_token1] = ACTIONS(1474),
    [aux_sym_goto_statement_token1] = ACTIONS(1474),
    [aux_sym_continue_statement_token1] = ACTIONS(1474),
    [aux_sym_break_statement_token1] = ACTIONS(1474),
    [sym_integer] = ACTIONS(1474),
    [aux_sym_return_statement_token1] = ACTIONS(1474),
    [aux_sym_throw_expression_token1] = ACTIONS(1474),
    [aux_sym_while_statement_token1] = ACTIONS(1474),
    [aux_sym_while_statement_token2] = ACTIONS(1474),
    [aux_sym_do_statement_token1] = ACTIONS(1474),
    [aux_sym_for_statement_token1] = ACTIONS(1474),
    [aux_sym_for_statement_token2] = ACTIONS(1474),
    [aux_sym_foreach_statement_token1] = ACTIONS(1474),
    [aux_sym_foreach_statement_token2] = ACTIONS(1474),
    [aux_sym_if_statement_token1] = ACTIONS(1474),
    [aux_sym_if_statement_token2] = ACTIONS(1474),
    [aux_sym_else_if_clause_token1] = ACTIONS(1474),
    [aux_sym_else_clause_token1] = ACTIONS(1474),
    [aux_sym_match_expression_token1] = ACTIONS(1474),
    [aux_sym_match_default_expression_token1] = ACTIONS(1474),
    [aux_sym_switch_statement_token1] = ACTIONS(1474),
    [aux_sym_switch_block_token1] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_TILDE] = ACTIONS(1472),
    [anon_sym_BANG] = ACTIONS(1472),
    [anon_sym_AT] = ACTIONS(1472),
    [aux_sym_clone_expression_token1] = ACTIONS(1474),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1474),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1474),
    [anon_sym_DASH_DASH] = ACTIONS(1472),
    [anon_sym_PLUS_PLUS] = ACTIONS(1472),
    [aux_sym__list_destructing_token1] = ACTIONS(1474),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_self] = ACTIONS(1474),
    [anon_sym_parent] = ACTIONS(1474),
    [aux_sym__argument_name_token1] = ACTIONS(1474),
    [aux_sym__argument_name_token2] = ACTIONS(1474),
    [anon_sym_POUND_LBRACK] = ACTIONS(1472),
    [aux_sym_encapsed_string_token1] = ACTIONS(1472),
    [anon_sym_DQUOTE] = ACTIONS(1472),
    [aux_sym_string_token1] = ACTIONS(1472),
    [anon_sym_SQUOTE] = ACTIONS(1472),
    [anon_sym_LT_LT_LT] = ACTIONS(1472),
    [anon_sym_BQUOTE] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1472),
    [aux_sym_yield_expression_token1] = ACTIONS(1474),
    [aux_sym_include_expression_token1] = ACTIONS(1474),
    [aux_sym_include_once_expression_token1] = ACTIONS(1474),
    [aux_sym_require_expression_token1] = ACTIONS(1474),
    [aux_sym_require_once_expression_token1] = ACTIONS(1474),
    [sym_comment] = ACTIONS(5),
  },
  [545] = {
    [sym_text_interpolation] = STATE(545),
    [ts_builtin_sym_end] = ACTIONS(1476),
    [sym_name] = ACTIONS(1478),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1476),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1478),
    [aux_sym_global_declaration_token1] = ACTIONS(1478),
    [aux_sym_namespace_definition_token1] = ACTIONS(1478),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1478),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1478),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1478),
    [anon_sym_BSLASH] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [aux_sym_trait_declaration_token1] = ACTIONS(1478),
    [aux_sym_interface_declaration_token1] = ACTIONS(1478),
    [aux_sym_enum_declaration_token1] = ACTIONS(1478),
    [aux_sym_enum_case_token1] = ACTIONS(1478),
    [aux_sym_class_declaration_token1] = ACTIONS(1478),
    [aux_sym_final_modifier_token1] = ACTIONS(1478),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1478),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1478),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1478),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1478),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1478),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [aux_sym_cast_type_token1] = ACTIONS(1478),
    [aux_sym_echo_statement_token1] = ACTIONS(1478),
    [anon_sym_unset] = ACTIONS(1478),
    [aux_sym_declare_statement_token1] = ACTIONS(1478),
    [aux_sym_declare_statement_token2] = ACTIONS(1478),
    [sym_float] = ACTIONS(1478),
    [aux_sym_try_statement_token1] = ACTIONS(1478),
    [aux_sym_goto_statement_token1] = ACTIONS(1478),
    [aux_sym_continue_statement_token1] = ACTIONS(1478),
    [aux_sym_break_statement_token1] = ACTIONS(1478),
    [sym_integer] = ACTIONS(1478),
    [aux_sym_return_statement_token1] = ACTIONS(1478),
    [aux_sym_throw_expression_token1] = ACTIONS(1478),
    [aux_sym_while_statement_token1] = ACTIONS(1478),
    [aux_sym_while_statement_token2] = ACTIONS(1478),
    [aux_sym_do_statement_token1] = ACTIONS(1478),
    [aux_sym_for_statement_token1] = ACTIONS(1478),
    [aux_sym_for_statement_token2] = ACTIONS(1478),
    [aux_sym_foreach_statement_token1] = ACTIONS(1478),
    [aux_sym_foreach_statement_token2] = ACTIONS(1478),
    [aux_sym_if_statement_token1] = ACTIONS(1478),
    [aux_sym_if_statement_token2] = ACTIONS(1478),
    [aux_sym_else_if_clause_token1] = ACTIONS(1478),
    [aux_sym_else_clause_token1] = ACTIONS(1478),
    [aux_sym_match_expression_token1] = ACTIONS(1478),
    [aux_sym_match_default_expression_token1] = ACTIONS(1478),
    [aux_sym_switch_statement_token1] = ACTIONS(1478),
    [aux_sym_switch_block_token1] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1476),
    [anon_sym_AT] = ACTIONS(1476),
    [aux_sym_clone_expression_token1] = ACTIONS(1478),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1478),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1478),
    [anon_sym_DASH_DASH] = ACTIONS(1476),
    [anon_sym_PLUS_PLUS] = ACTIONS(1476),
    [aux_sym__list_destructing_token1] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1476),
    [anon_sym_self] = ACTIONS(1478),
    [anon_sym_parent] = ACTIONS(1478),
    [aux_sym__argument_name_token1] = ACTIONS(1478),
    [aux_sym__argument_name_token2] = ACTIONS(1478),
    [anon_sym_POUND_LBRACK] = ACTIONS(1476),
    [aux_sym_encapsed_string_token1] = ACTIONS(1476),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [aux_sym_string_token1] = ACTIONS(1476),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [anon_sym_LT_LT_LT] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [aux_sym_yield_expression_token1] = ACTIONS(1478),
    [aux_sym_include_expression_token1] = ACTIONS(1478),
    [aux_sym_include_once_expression_token1] = ACTIONS(1478),
    [aux_sym_require_expression_token1] = ACTIONS(1478),
    [aux_sym_require_once_expression_token1] = ACTIONS(1478),
    [sym_comment] = ACTIONS(5),
  },
  [546] = {
    [sym_text_interpolation] = STATE(546),
    [ts_builtin_sym_end] = ACTIONS(1480),
    [sym_name] = ACTIONS(1482),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1480),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1482),
    [aux_sym_global_declaration_token1] = ACTIONS(1482),
    [aux_sym_namespace_definition_token1] = ACTIONS(1482),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1482),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1482),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1482),
    [anon_sym_BSLASH] = ACTIONS(1480),
    [anon_sym_LBRACE] = ACTIONS(1480),
    [anon_sym_RBRACE] = ACTIONS(1480),
    [aux_sym_trait_declaration_token1] = ACTIONS(1482),
    [aux_sym_interface_declaration_token1] = ACTIONS(1482),
    [aux_sym_enum_declaration_token1] = ACTIONS(1482),
    [aux_sym_enum_case_token1] = ACTIONS(1482),
    [aux_sym_class_declaration_token1] = ACTIONS(1482),
    [aux_sym_final_modifier_token1] = ACTIONS(1482),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1482),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1482),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1482),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1482),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1482),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1480),
    [aux_sym_cast_type_token1] = ACTIONS(1482),
    [aux_sym_echo_statement_token1] = ACTIONS(1482),
    [anon_sym_unset] = ACTIONS(1482),
    [aux_sym_declare_statement_token1] = ACTIONS(1482),
    [aux_sym_declare_statement_token2] = ACTIONS(1482),
    [sym_float] = ACTIONS(1482),
    [aux_sym_try_statement_token1] = ACTIONS(1482),
    [aux_sym_goto_statement_token1] = ACTIONS(1482),
    [aux_sym_continue_statement_token1] = ACTIONS(1482),
    [aux_sym_break_statement_token1] = ACTIONS(1482),
    [sym_integer] = ACTIONS(1482),
    [aux_sym_return_statement_token1] = ACTIONS(1482),
    [aux_sym_throw_expression_token1] = ACTIONS(1482),
    [aux_sym_while_statement_token1] = ACTIONS(1482),
    [aux_sym_while_statement_token2] = ACTIONS(1482),
    [aux_sym_do_statement_token1] = ACTIONS(1482),
    [aux_sym_for_statement_token1] = ACTIONS(1482),
    [aux_sym_for_statement_token2] = ACTIONS(1482),
    [aux_sym_foreach_statement_token1] = ACTIONS(1482),
    [aux_sym_foreach_statement_token2] = ACTIONS(1482),
    [aux_sym_if_statement_token1] = ACTIONS(1482),
    [aux_sym_if_statement_token2] = ACTIONS(1482),
    [aux_sym_else_if_clause_token1] = ACTIONS(1482),
    [aux_sym_else_clause_token1] = ACTIONS(1482),
    [aux_sym_match_expression_token1] = ACTIONS(1482),
    [aux_sym_match_default_expression_token1] = ACTIONS(1482),
    [aux_sym_switch_statement_token1] = ACTIONS(1482),
    [aux_sym_switch_block_token1] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_TILDE] = ACTIONS(1480),
    [anon_sym_BANG] = ACTIONS(1480),
    [anon_sym_AT] = ACTIONS(1480),
    [aux_sym_clone_expression_token1] = ACTIONS(1482),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1482),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1482),
    [anon_sym_DASH_DASH] = ACTIONS(1480),
    [anon_sym_PLUS_PLUS] = ACTIONS(1480),
    [aux_sym__list_destructing_token1] = ACTIONS(1482),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_self] = ACTIONS(1482),
    [anon_sym_parent] = ACTIONS(1482),
    [aux_sym__argument_name_token1] = ACTIONS(1482),
    [aux_sym__argument_name_token2] = ACTIONS(1482),
    [anon_sym_POUND_LBRACK] = ACTIONS(1480),
    [aux_sym_encapsed_string_token1] = ACTIONS(1480),
    [anon_sym_DQUOTE] = ACTIONS(1480),
    [aux_sym_string_token1] = ACTIONS(1480),
    [anon_sym_SQUOTE] = ACTIONS(1480),
    [anon_sym_LT_LT_LT] = ACTIONS(1480),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [anon_sym_DOLLAR] = ACTIONS(1480),
    [aux_sym_yield_expression_token1] = ACTIONS(1482),
    [aux_sym_include_expression_token1] = ACTIONS(1482),
    [aux_sym_include_once_expression_token1] = ACTIONS(1482),
    [aux_sym_require_expression_token1] = ACTIONS(1482),
    [aux_sym_require_once_expression_token1] = ACTIONS(1482),
    [sym_comment] = ACTIONS(5),
  },
  [547] = {
    [sym_text_interpolation] = STATE(547),
    [ts_builtin_sym_end] = ACTIONS(1484),
    [sym_name] = ACTIONS(1486),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1484),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1486),
    [aux_sym_global_declaration_token1] = ACTIONS(1486),
    [aux_sym_namespace_definition_token1] = ACTIONS(1486),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1486),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1486),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1486),
    [anon_sym_BSLASH] = ACTIONS(1484),
    [anon_sym_LBRACE] = ACTIONS(1484),
    [anon_sym_RBRACE] = ACTIONS(1484),
    [aux_sym_trait_declaration_token1] = ACTIONS(1486),
    [aux_sym_interface_declaration_token1] = ACTIONS(1486),
    [aux_sym_enum_declaration_token1] = ACTIONS(1486),
    [aux_sym_enum_case_token1] = ACTIONS(1486),
    [aux_sym_class_declaration_token1] = ACTIONS(1486),
    [aux_sym_final_modifier_token1] = ACTIONS(1486),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1486),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1486),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1486),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1486),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1486),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1486),
    [anon_sym_LPAREN] = ACTIONS(1484),
    [aux_sym_cast_type_token1] = ACTIONS(1486),
    [aux_sym_echo_statement_token1] = ACTIONS(1486),
    [anon_sym_unset] = ACTIONS(1486),
    [aux_sym_declare_statement_token1] = ACTIONS(1486),
    [aux_sym_declare_statement_token2] = ACTIONS(1486),
    [sym_float] = ACTIONS(1486),
    [aux_sym_try_statement_token1] = ACTIONS(1486),
    [aux_sym_goto_statement_token1] = ACTIONS(1486),
    [aux_sym_continue_statement_token1] = ACTIONS(1486),
    [aux_sym_break_statement_token1] = ACTIONS(1486),
    [sym_integer] = ACTIONS(1486),
    [aux_sym_return_statement_token1] = ACTIONS(1486),
    [aux_sym_throw_expression_token1] = ACTIONS(1486),
    [aux_sym_while_statement_token1] = ACTIONS(1486),
    [aux_sym_while_statement_token2] = ACTIONS(1486),
    [aux_sym_do_statement_token1] = ACTIONS(1486),
    [aux_sym_for_statement_token1] = ACTIONS(1486),
    [aux_sym_for_statement_token2] = ACTIONS(1486),
    [aux_sym_foreach_statement_token1] = ACTIONS(1486),
    [aux_sym_foreach_statement_token2] = ACTIONS(1486),
    [aux_sym_if_statement_token1] = ACTIONS(1486),
    [aux_sym_if_statement_token2] = ACTIONS(1486),
    [aux_sym_else_if_clause_token1] = ACTIONS(1486),
    [aux_sym_else_clause_token1] = ACTIONS(1486),
    [aux_sym_match_expression_token1] = ACTIONS(1486),
    [aux_sym_match_default_expression_token1] = ACTIONS(1486),
    [aux_sym_switch_statement_token1] = ACTIONS(1486),
    [aux_sym_switch_block_token1] = ACTIONS(1486),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_TILDE] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_AT] = ACTIONS(1484),
    [aux_sym_clone_expression_token1] = ACTIONS(1486),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1486),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1486),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [aux_sym__list_destructing_token1] = ACTIONS(1486),
    [anon_sym_LBRACK] = ACTIONS(1484),
    [anon_sym_self] = ACTIONS(1486),
    [anon_sym_parent] = ACTIONS(1486),
    [aux_sym__argument_name_token1] = ACTIONS(1486),
    [aux_sym__argument_name_token2] = ACTIONS(1486),
    [anon_sym_POUND_LBRACK] = ACTIONS(1484),
    [aux_sym_encapsed_string_token1] = ACTIONS(1484),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [aux_sym_string_token1] = ACTIONS(1484),
    [anon_sym_SQUOTE] = ACTIONS(1484),
    [anon_sym_LT_LT_LT] = ACTIONS(1484),
    [anon_sym_BQUOTE] = ACTIONS(1484),
    [anon_sym_DOLLAR] = ACTIONS(1484),
    [aux_sym_yield_expression_token1] = ACTIONS(1486),
    [aux_sym_include_expression_token1] = ACTIONS(1486),
    [aux_sym_include_once_expression_token1] = ACTIONS(1486),
    [aux_sym_require_expression_token1] = ACTIONS(1486),
    [aux_sym_require_once_expression_token1] = ACTIONS(1486),
    [sym_comment] = ACTIONS(5),
  },
  [548] = {
    [sym_text_interpolation] = STATE(548),
    [ts_builtin_sym_end] = ACTIONS(1488),
    [sym_name] = ACTIONS(1490),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1488),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1490),
    [aux_sym_global_declaration_token1] = ACTIONS(1490),
    [aux_sym_namespace_definition_token1] = ACTIONS(1490),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1490),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1490),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1490),
    [anon_sym_BSLASH] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_RBRACE] = ACTIONS(1488),
    [aux_sym_trait_declaration_token1] = ACTIONS(1490),
    [aux_sym_interface_declaration_token1] = ACTIONS(1490),
    [aux_sym_enum_declaration_token1] = ACTIONS(1490),
    [aux_sym_enum_case_token1] = ACTIONS(1490),
    [aux_sym_class_declaration_token1] = ACTIONS(1490),
    [aux_sym_final_modifier_token1] = ACTIONS(1490),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1490),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1490),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1490),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1490),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1490),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [aux_sym_cast_type_token1] = ACTIONS(1490),
    [aux_sym_echo_statement_token1] = ACTIONS(1490),
    [anon_sym_unset] = ACTIONS(1490),
    [aux_sym_declare_statement_token1] = ACTIONS(1490),
    [aux_sym_declare_statement_token2] = ACTIONS(1490),
    [sym_float] = ACTIONS(1490),
    [aux_sym_try_statement_token1] = ACTIONS(1490),
    [aux_sym_goto_statement_token1] = ACTIONS(1490),
    [aux_sym_continue_statement_token1] = ACTIONS(1490),
    [aux_sym_break_statement_token1] = ACTIONS(1490),
    [sym_integer] = ACTIONS(1490),
    [aux_sym_return_statement_token1] = ACTIONS(1490),
    [aux_sym_throw_expression_token1] = ACTIONS(1490),
    [aux_sym_while_statement_token1] = ACTIONS(1490),
    [aux_sym_while_statement_token2] = ACTIONS(1490),
    [aux_sym_do_statement_token1] = ACTIONS(1490),
    [aux_sym_for_statement_token1] = ACTIONS(1490),
    [aux_sym_for_statement_token2] = ACTIONS(1490),
    [aux_sym_foreach_statement_token1] = ACTIONS(1490),
    [aux_sym_foreach_statement_token2] = ACTIONS(1490),
    [aux_sym_if_statement_token1] = ACTIONS(1490),
    [aux_sym_if_statement_token2] = ACTIONS(1490),
    [aux_sym_else_if_clause_token1] = ACTIONS(1490),
    [aux_sym_else_clause_token1] = ACTIONS(1490),
    [aux_sym_match_expression_token1] = ACTIONS(1490),
    [aux_sym_match_default_expression_token1] = ACTIONS(1490),
    [aux_sym_switch_statement_token1] = ACTIONS(1490),
    [aux_sym_switch_block_token1] = ACTIONS(1490),
    [anon_sym_PLUS] = ACTIONS(1490),
    [anon_sym_DASH] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_BANG] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [aux_sym_clone_expression_token1] = ACTIONS(1490),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1490),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1490),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [aux_sym__list_destructing_token1] = ACTIONS(1490),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_self] = ACTIONS(1490),
    [anon_sym_parent] = ACTIONS(1490),
    [aux_sym__argument_name_token1] = ACTIONS(1490),
    [aux_sym__argument_name_token2] = ACTIONS(1490),
    [anon_sym_POUND_LBRACK] = ACTIONS(1488),
    [aux_sym_encapsed_string_token1] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(1488),
    [aux_sym_string_token1] = ACTIONS(1488),
    [anon_sym_SQUOTE] = ACTIONS(1488),
    [anon_sym_LT_LT_LT] = ACTIONS(1488),
    [anon_sym_BQUOTE] = ACTIONS(1488),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [aux_sym_yield_expression_token1] = ACTIONS(1490),
    [aux_sym_include_expression_token1] = ACTIONS(1490),
    [aux_sym_include_once_expression_token1] = ACTIONS(1490),
    [aux_sym_require_expression_token1] = ACTIONS(1490),
    [aux_sym_require_once_expression_token1] = ACTIONS(1490),
    [sym_comment] = ACTIONS(5),
  },
  [549] = {
    [sym_text_interpolation] = STATE(549),
    [sym_qualified_name] = STATE(837),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym__unary_expression] = STATE(1065),
    [sym_unary_op_expression] = STATE(1064),
    [sym_clone_expression] = STATE(1064),
    [sym__primary_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(805),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_expression] = STATE(1064),
    [sym_cast_variable] = STATE(633),
    [sym_member_access_expression] = STATE(633),
    [sym_nullsafe_member_access_expression] = STATE(633),
    [sym_scoped_property_access_expression] = STATE(633),
    [sym_function_call_expression] = STATE(605),
    [sym_scoped_call_expression] = STATE(605),
    [sym__scope_resolution_qualifier] = STATE(2647),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(605),
    [sym_nullsafe_member_call_expression] = STATE(605),
    [sym_subscript_expression] = STATE(605),
    [sym__dereferencable_expression] = STATE(1699),
    [sym_array_creation_expression] = STATE(805),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(805),
    [sym_dynamic_variable_name] = STATE(605),
    [sym_variable_name] = STATE(605),
    [sym_include_expression] = STATE(1065),
    [sym_include_once_expression] = STATE(1065),
    [sym__reserved_identifier] = STATE(1566),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(657),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(246),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [anon_sym_PLUS] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(286),
    [anon_sym_BANG] = ACTIONS(286),
    [aux_sym_clone_expression_token1] = ACTIONS(290),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1492),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [aux_sym_include_expression_token1] = ACTIONS(322),
    [aux_sym_include_once_expression_token1] = ACTIONS(324),
    [sym_comment] = ACTIONS(5),
  },
  [550] = {
    [sym_text_interpolation] = STATE(550),
    [ts_builtin_sym_end] = ACTIONS(1046),
    [sym_name] = ACTIONS(1048),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1046),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1048),
    [aux_sym_global_declaration_token1] = ACTIONS(1048),
    [aux_sym_namespace_definition_token1] = ACTIONS(1048),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1048),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1048),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1048),
    [anon_sym_BSLASH] = ACTIONS(1046),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [aux_sym_trait_declaration_token1] = ACTIONS(1048),
    [aux_sym_interface_declaration_token1] = ACTIONS(1048),
    [aux_sym_enum_declaration_token1] = ACTIONS(1048),
    [aux_sym_enum_case_token1] = ACTIONS(1048),
    [aux_sym_class_declaration_token1] = ACTIONS(1048),
    [aux_sym_final_modifier_token1] = ACTIONS(1048),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1048),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1048),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1048),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1048),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1048),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(1046),
    [aux_sym_cast_type_token1] = ACTIONS(1048),
    [aux_sym_echo_statement_token1] = ACTIONS(1048),
    [anon_sym_unset] = ACTIONS(1048),
    [aux_sym_declare_statement_token1] = ACTIONS(1048),
    [aux_sym_declare_statement_token2] = ACTIONS(1048),
    [sym_float] = ACTIONS(1048),
    [aux_sym_try_statement_token1] = ACTIONS(1048),
    [aux_sym_goto_statement_token1] = ACTIONS(1048),
    [aux_sym_continue_statement_token1] = ACTIONS(1048),
    [aux_sym_break_statement_token1] = ACTIONS(1048),
    [sym_integer] = ACTIONS(1048),
    [aux_sym_return_statement_token1] = ACTIONS(1048),
    [aux_sym_throw_expression_token1] = ACTIONS(1048),
    [aux_sym_while_statement_token1] = ACTIONS(1048),
    [aux_sym_while_statement_token2] = ACTIONS(1048),
    [aux_sym_do_statement_token1] = ACTIONS(1048),
    [aux_sym_for_statement_token1] = ACTIONS(1048),
    [aux_sym_for_statement_token2] = ACTIONS(1048),
    [aux_sym_foreach_statement_token1] = ACTIONS(1048),
    [aux_sym_foreach_statement_token2] = ACTIONS(1048),
    [aux_sym_if_statement_token1] = ACTIONS(1048),
    [aux_sym_if_statement_token2] = ACTIONS(1048),
    [aux_sym_else_if_clause_token1] = ACTIONS(1048),
    [aux_sym_else_clause_token1] = ACTIONS(1048),
    [aux_sym_match_expression_token1] = ACTIONS(1048),
    [aux_sym_match_default_expression_token1] = ACTIONS(1048),
    [aux_sym_switch_statement_token1] = ACTIONS(1048),
    [aux_sym_switch_block_token1] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_TILDE] = ACTIONS(1046),
    [anon_sym_BANG] = ACTIONS(1046),
    [anon_sym_AT] = ACTIONS(1046),
    [aux_sym_clone_expression_token1] = ACTIONS(1048),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1048),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1048),
    [anon_sym_DASH_DASH] = ACTIONS(1046),
    [anon_sym_PLUS_PLUS] = ACTIONS(1046),
    [aux_sym__list_destructing_token1] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(1046),
    [anon_sym_self] = ACTIONS(1048),
    [anon_sym_parent] = ACTIONS(1048),
    [aux_sym__argument_name_token1] = ACTIONS(1048),
    [aux_sym__argument_name_token2] = ACTIONS(1048),
    [anon_sym_POUND_LBRACK] = ACTIONS(1046),
    [aux_sym_encapsed_string_token1] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [aux_sym_string_token1] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LT_LT] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1046),
    [aux_sym_yield_expression_token1] = ACTIONS(1048),
    [aux_sym_include_expression_token1] = ACTIONS(1048),
    [aux_sym_include_once_expression_token1] = ACTIONS(1048),
    [aux_sym_require_expression_token1] = ACTIONS(1048),
    [aux_sym_require_once_expression_token1] = ACTIONS(1048),
    [sym_comment] = ACTIONS(5),
  },
  [551] = {
    [sym_text_interpolation] = STATE(551),
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_name] = ACTIONS(1496),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1494),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1496),
    [aux_sym_global_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_definition_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1496),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [aux_sym_trait_declaration_token1] = ACTIONS(1496),
    [aux_sym_interface_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_case_token1] = ACTIONS(1496),
    [aux_sym_class_declaration_token1] = ACTIONS(1496),
    [aux_sym_final_modifier_token1] = ACTIONS(1496),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1496),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1496),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [aux_sym_cast_type_token1] = ACTIONS(1496),
    [aux_sym_echo_statement_token1] = ACTIONS(1496),
    [anon_sym_unset] = ACTIONS(1496),
    [aux_sym_declare_statement_token1] = ACTIONS(1496),
    [aux_sym_declare_statement_token2] = ACTIONS(1496),
    [sym_float] = ACTIONS(1496),
    [aux_sym_try_statement_token1] = ACTIONS(1496),
    [aux_sym_goto_statement_token1] = ACTIONS(1496),
    [aux_sym_continue_statement_token1] = ACTIONS(1496),
    [aux_sym_break_statement_token1] = ACTIONS(1496),
    [sym_integer] = ACTIONS(1496),
    [aux_sym_return_statement_token1] = ACTIONS(1496),
    [aux_sym_throw_expression_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token2] = ACTIONS(1496),
    [aux_sym_do_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token2] = ACTIONS(1496),
    [aux_sym_foreach_statement_token1] = ACTIONS(1496),
    [aux_sym_foreach_statement_token2] = ACTIONS(1496),
    [aux_sym_if_statement_token1] = ACTIONS(1496),
    [aux_sym_if_statement_token2] = ACTIONS(1496),
    [aux_sym_else_if_clause_token1] = ACTIONS(1496),
    [aux_sym_else_clause_token1] = ACTIONS(1496),
    [aux_sym_match_expression_token1] = ACTIONS(1496),
    [aux_sym_match_default_expression_token1] = ACTIONS(1496),
    [aux_sym_switch_statement_token1] = ACTIONS(1496),
    [aux_sym_switch_block_token1] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [aux_sym_clone_expression_token1] = ACTIONS(1496),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1496),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [aux_sym__list_destructing_token1] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_self] = ACTIONS(1496),
    [anon_sym_parent] = ACTIONS(1496),
    [aux_sym__argument_name_token1] = ACTIONS(1496),
    [aux_sym__argument_name_token2] = ACTIONS(1496),
    [anon_sym_POUND_LBRACK] = ACTIONS(1494),
    [aux_sym_encapsed_string_token1] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [aux_sym_string_token1] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_LT_LT_LT] = ACTIONS(1494),
    [anon_sym_BQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [aux_sym_yield_expression_token1] = ACTIONS(1496),
    [aux_sym_include_expression_token1] = ACTIONS(1496),
    [aux_sym_include_once_expression_token1] = ACTIONS(1496),
    [aux_sym_require_expression_token1] = ACTIONS(1496),
    [aux_sym_require_once_expression_token1] = ACTIONS(1496),
    [sym_comment] = ACTIONS(5),
  },
  [552] = {
    [sym_text_interpolation] = STATE(552),
    [ts_builtin_sym_end] = ACTIONS(1498),
    [sym_name] = ACTIONS(1500),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1498),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1500),
    [aux_sym_global_declaration_token1] = ACTIONS(1500),
    [aux_sym_namespace_definition_token1] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_RBRACE] = ACTIONS(1498),
    [aux_sym_trait_declaration_token1] = ACTIONS(1500),
    [aux_sym_interface_declaration_token1] = ACTIONS(1500),
    [aux_sym_enum_declaration_token1] = ACTIONS(1500),
    [aux_sym_enum_case_token1] = ACTIONS(1500),
    [aux_sym_class_declaration_token1] = ACTIONS(1500),
    [aux_sym_final_modifier_token1] = ACTIONS(1500),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1500),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1500),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1500),
    [anon_sym_LPAREN] = ACTIONS(1498),
    [aux_sym_cast_type_token1] = ACTIONS(1500),
    [aux_sym_echo_statement_token1] = ACTIONS(1500),
    [anon_sym_unset] = ACTIONS(1500),
    [aux_sym_declare_statement_token1] = ACTIONS(1500),
    [aux_sym_declare_statement_token2] = ACTIONS(1500),
    [sym_float] = ACTIONS(1500),
    [aux_sym_try_statement_token1] = ACTIONS(1500),
    [aux_sym_goto_statement_token1] = ACTIONS(1500),
    [aux_sym_continue_statement_token1] = ACTIONS(1500),
    [aux_sym_break_statement_token1] = ACTIONS(1500),
    [sym_integer] = ACTIONS(1500),
    [aux_sym_return_statement_token1] = ACTIONS(1500),
    [aux_sym_throw_expression_token1] = ACTIONS(1500),
    [aux_sym_while_statement_token1] = ACTIONS(1500),
    [aux_sym_while_statement_token2] = ACTIONS(1500),
    [aux_sym_do_statement_token1] = ACTIONS(1500),
    [aux_sym_for_statement_token1] = ACTIONS(1500),
    [aux_sym_for_statement_token2] = ACTIONS(1500),
    [aux_sym_foreach_statement_token1] = ACTIONS(1500),
    [aux_sym_foreach_statement_token2] = ACTIONS(1500),
    [aux_sym_if_statement_token1] = ACTIONS(1500),
    [aux_sym_if_statement_token2] = ACTIONS(1500),
    [aux_sym_else_if_clause_token1] = ACTIONS(1500),
    [aux_sym_else_clause_token1] = ACTIONS(1500),
    [aux_sym_match_expression_token1] = ACTIONS(1500),
    [aux_sym_match_default_expression_token1] = ACTIONS(1500),
    [aux_sym_switch_statement_token1] = ACTIONS(1500),
    [aux_sym_switch_block_token1] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_AT] = ACTIONS(1498),
    [aux_sym_clone_expression_token1] = ACTIONS(1500),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1500),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [aux_sym__list_destructing_token1] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(1498),
    [anon_sym_self] = ACTIONS(1500),
    [anon_sym_parent] = ACTIONS(1500),
    [aux_sym__argument_name_token1] = ACTIONS(1500),
    [aux_sym__argument_name_token2] = ACTIONS(1500),
    [anon_sym_POUND_LBRACK] = ACTIONS(1498),
    [aux_sym_encapsed_string_token1] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [aux_sym_string_token1] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_LT_LT_LT] = ACTIONS(1498),
    [anon_sym_BQUOTE] = ACTIONS(1498),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [aux_sym_yield_expression_token1] = ACTIONS(1500),
    [aux_sym_include_expression_token1] = ACTIONS(1500),
    [aux_sym_include_once_expression_token1] = ACTIONS(1500),
    [aux_sym_require_expression_token1] = ACTIONS(1500),
    [aux_sym_require_once_expression_token1] = ACTIONS(1500),
    [sym_comment] = ACTIONS(5),
  },
  [553] = {
    [sym_text_interpolation] = STATE(553),
    [ts_builtin_sym_end] = ACTIONS(1440),
    [sym_name] = ACTIONS(1442),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1440),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1442),
    [aux_sym_global_declaration_token1] = ACTIONS(1442),
    [aux_sym_namespace_definition_token1] = ACTIONS(1442),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1442),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1442),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1442),
    [anon_sym_BSLASH] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(1440),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [aux_sym_trait_declaration_token1] = ACTIONS(1442),
    [aux_sym_interface_declaration_token1] = ACTIONS(1442),
    [aux_sym_enum_declaration_token1] = ACTIONS(1442),
    [aux_sym_enum_case_token1] = ACTIONS(1442),
    [aux_sym_class_declaration_token1] = ACTIONS(1442),
    [aux_sym_final_modifier_token1] = ACTIONS(1442),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1442),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1442),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1442),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1442),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1442),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1442),
    [anon_sym_LPAREN] = ACTIONS(1440),
    [aux_sym_cast_type_token1] = ACTIONS(1442),
    [aux_sym_echo_statement_token1] = ACTIONS(1442),
    [anon_sym_unset] = ACTIONS(1442),
    [aux_sym_declare_statement_token1] = ACTIONS(1442),
    [aux_sym_declare_statement_token2] = ACTIONS(1442),
    [sym_float] = ACTIONS(1442),
    [aux_sym_try_statement_token1] = ACTIONS(1442),
    [aux_sym_goto_statement_token1] = ACTIONS(1442),
    [aux_sym_continue_statement_token1] = ACTIONS(1442),
    [aux_sym_break_statement_token1] = ACTIONS(1442),
    [sym_integer] = ACTIONS(1442),
    [aux_sym_return_statement_token1] = ACTIONS(1442),
    [aux_sym_throw_expression_token1] = ACTIONS(1442),
    [aux_sym_while_statement_token1] = ACTIONS(1442),
    [aux_sym_while_statement_token2] = ACTIONS(1442),
    [aux_sym_do_statement_token1] = ACTIONS(1442),
    [aux_sym_for_statement_token1] = ACTIONS(1442),
    [aux_sym_for_statement_token2] = ACTIONS(1442),
    [aux_sym_foreach_statement_token1] = ACTIONS(1442),
    [aux_sym_foreach_statement_token2] = ACTIONS(1442),
    [aux_sym_if_statement_token1] = ACTIONS(1442),
    [aux_sym_if_statement_token2] = ACTIONS(1442),
    [aux_sym_else_if_clause_token1] = ACTIONS(1442),
    [aux_sym_else_clause_token1] = ACTIONS(1442),
    [aux_sym_match_expression_token1] = ACTIONS(1442),
    [aux_sym_match_default_expression_token1] = ACTIONS(1442),
    [aux_sym_switch_statement_token1] = ACTIONS(1442),
    [aux_sym_switch_block_token1] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_TILDE] = ACTIONS(1440),
    [anon_sym_BANG] = ACTIONS(1440),
    [anon_sym_AT] = ACTIONS(1440),
    [aux_sym_clone_expression_token1] = ACTIONS(1442),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1442),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1442),
    [anon_sym_DASH_DASH] = ACTIONS(1440),
    [anon_sym_PLUS_PLUS] = ACTIONS(1440),
    [aux_sym__list_destructing_token1] = ACTIONS(1442),
    [anon_sym_LBRACK] = ACTIONS(1440),
    [anon_sym_self] = ACTIONS(1442),
    [anon_sym_parent] = ACTIONS(1442),
    [aux_sym__argument_name_token1] = ACTIONS(1442),
    [aux_sym__argument_name_token2] = ACTIONS(1442),
    [anon_sym_POUND_LBRACK] = ACTIONS(1440),
    [aux_sym_encapsed_string_token1] = ACTIONS(1440),
    [anon_sym_DQUOTE] = ACTIONS(1440),
    [aux_sym_string_token1] = ACTIONS(1440),
    [anon_sym_SQUOTE] = ACTIONS(1440),
    [anon_sym_LT_LT_LT] = ACTIONS(1440),
    [anon_sym_BQUOTE] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1440),
    [aux_sym_yield_expression_token1] = ACTIONS(1442),
    [aux_sym_include_expression_token1] = ACTIONS(1442),
    [aux_sym_include_once_expression_token1] = ACTIONS(1442),
    [aux_sym_require_expression_token1] = ACTIONS(1442),
    [aux_sym_require_once_expression_token1] = ACTIONS(1442),
    [sym_comment] = ACTIONS(5),
  },
  [554] = {
    [sym_text_interpolation] = STATE(554),
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_name] = ACTIONS(1504),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1502),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1504),
    [aux_sym_global_declaration_token1] = ACTIONS(1504),
    [aux_sym_namespace_definition_token1] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [aux_sym_trait_declaration_token1] = ACTIONS(1504),
    [aux_sym_interface_declaration_token1] = ACTIONS(1504),
    [aux_sym_enum_declaration_token1] = ACTIONS(1504),
    [aux_sym_enum_case_token1] = ACTIONS(1504),
    [aux_sym_class_declaration_token1] = ACTIONS(1504),
    [aux_sym_final_modifier_token1] = ACTIONS(1504),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1504),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1504),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [aux_sym_cast_type_token1] = ACTIONS(1504),
    [aux_sym_echo_statement_token1] = ACTIONS(1504),
    [anon_sym_unset] = ACTIONS(1504),
    [aux_sym_declare_statement_token1] = ACTIONS(1504),
    [aux_sym_declare_statement_token2] = ACTIONS(1504),
    [sym_float] = ACTIONS(1504),
    [aux_sym_try_statement_token1] = ACTIONS(1504),
    [aux_sym_goto_statement_token1] = ACTIONS(1504),
    [aux_sym_continue_statement_token1] = ACTIONS(1504),
    [aux_sym_break_statement_token1] = ACTIONS(1504),
    [sym_integer] = ACTIONS(1504),
    [aux_sym_return_statement_token1] = ACTIONS(1504),
    [aux_sym_throw_expression_token1] = ACTIONS(1504),
    [aux_sym_while_statement_token1] = ACTIONS(1504),
    [aux_sym_while_statement_token2] = ACTIONS(1504),
    [aux_sym_do_statement_token1] = ACTIONS(1504),
    [aux_sym_for_statement_token1] = ACTIONS(1504),
    [aux_sym_for_statement_token2] = ACTIONS(1504),
    [aux_sym_foreach_statement_token1] = ACTIONS(1504),
    [aux_sym_foreach_statement_token2] = ACTIONS(1504),
    [aux_sym_if_statement_token1] = ACTIONS(1504),
    [aux_sym_if_statement_token2] = ACTIONS(1504),
    [aux_sym_else_if_clause_token1] = ACTIONS(1504),
    [aux_sym_else_clause_token1] = ACTIONS(1504),
    [aux_sym_match_expression_token1] = ACTIONS(1504),
    [aux_sym_match_default_expression_token1] = ACTIONS(1504),
    [aux_sym_switch_statement_token1] = ACTIONS(1504),
    [aux_sym_switch_block_token1] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [aux_sym_clone_expression_token1] = ACTIONS(1504),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1504),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1504),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [aux_sym__list_destructing_token1] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1502),
    [anon_sym_self] = ACTIONS(1504),
    [anon_sym_parent] = ACTIONS(1504),
    [aux_sym__argument_name_token1] = ACTIONS(1504),
    [aux_sym__argument_name_token2] = ACTIONS(1504),
    [anon_sym_POUND_LBRACK] = ACTIONS(1502),
    [aux_sym_encapsed_string_token1] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [aux_sym_string_token1] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_LT_LT_LT] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1502),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [aux_sym_yield_expression_token1] = ACTIONS(1504),
    [aux_sym_include_expression_token1] = ACTIONS(1504),
    [aux_sym_include_once_expression_token1] = ACTIONS(1504),
    [aux_sym_require_expression_token1] = ACTIONS(1504),
    [aux_sym_require_once_expression_token1] = ACTIONS(1504),
    [sym_comment] = ACTIONS(5),
  },
  [555] = {
    [sym_text_interpolation] = STATE(555),
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_name] = ACTIONS(1508),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1506),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1508),
    [aux_sym_global_declaration_token1] = ACTIONS(1508),
    [aux_sym_namespace_definition_token1] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1506),
    [aux_sym_trait_declaration_token1] = ACTIONS(1508),
    [aux_sym_interface_declaration_token1] = ACTIONS(1508),
    [aux_sym_enum_declaration_token1] = ACTIONS(1508),
    [aux_sym_enum_case_token1] = ACTIONS(1508),
    [aux_sym_class_declaration_token1] = ACTIONS(1508),
    [aux_sym_final_modifier_token1] = ACTIONS(1508),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1508),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1508),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [aux_sym_cast_type_token1] = ACTIONS(1508),
    [aux_sym_echo_statement_token1] = ACTIONS(1508),
    [anon_sym_unset] = ACTIONS(1508),
    [aux_sym_declare_statement_token1] = ACTIONS(1508),
    [aux_sym_declare_statement_token2] = ACTIONS(1508),
    [sym_float] = ACTIONS(1508),
    [aux_sym_try_statement_token1] = ACTIONS(1508),
    [aux_sym_goto_statement_token1] = ACTIONS(1508),
    [aux_sym_continue_statement_token1] = ACTIONS(1508),
    [aux_sym_break_statement_token1] = ACTIONS(1508),
    [sym_integer] = ACTIONS(1508),
    [aux_sym_return_statement_token1] = ACTIONS(1508),
    [aux_sym_throw_expression_token1] = ACTIONS(1508),
    [aux_sym_while_statement_token1] = ACTIONS(1508),
    [aux_sym_while_statement_token2] = ACTIONS(1508),
    [aux_sym_do_statement_token1] = ACTIONS(1508),
    [aux_sym_for_statement_token1] = ACTIONS(1508),
    [aux_sym_for_statement_token2] = ACTIONS(1508),
    [aux_sym_foreach_statement_token1] = ACTIONS(1508),
    [aux_sym_foreach_statement_token2] = ACTIONS(1508),
    [aux_sym_if_statement_token1] = ACTIONS(1508),
    [aux_sym_if_statement_token2] = ACTIONS(1508),
    [aux_sym_else_if_clause_token1] = ACTIONS(1508),
    [aux_sym_else_clause_token1] = ACTIONS(1508),
    [aux_sym_match_expression_token1] = ACTIONS(1508),
    [aux_sym_match_default_expression_token1] = ACTIONS(1508),
    [aux_sym_switch_statement_token1] = ACTIONS(1508),
    [aux_sym_switch_block_token1] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [aux_sym_clone_expression_token1] = ACTIONS(1508),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1508),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1508),
    [anon_sym_DASH_DASH] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1506),
    [aux_sym__list_destructing_token1] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [anon_sym_self] = ACTIONS(1508),
    [anon_sym_parent] = ACTIONS(1508),
    [aux_sym__argument_name_token1] = ACTIONS(1508),
    [aux_sym__argument_name_token2] = ACTIONS(1508),
    [anon_sym_POUND_LBRACK] = ACTIONS(1506),
    [aux_sym_encapsed_string_token1] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [aux_sym_string_token1] = ACTIONS(1506),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LT_LT] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [aux_sym_yield_expression_token1] = ACTIONS(1508),
    [aux_sym_include_expression_token1] = ACTIONS(1508),
    [aux_sym_include_once_expression_token1] = ACTIONS(1508),
    [aux_sym_require_expression_token1] = ACTIONS(1508),
    [aux_sym_require_once_expression_token1] = ACTIONS(1508),
    [sym_comment] = ACTIONS(5),
  },
  [556] = {
    [sym_text_interpolation] = STATE(556),
    [ts_builtin_sym_end] = ACTIONS(1510),
    [sym_name] = ACTIONS(1512),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1510),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1512),
    [aux_sym_global_declaration_token1] = ACTIONS(1512),
    [aux_sym_namespace_definition_token1] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1512),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [aux_sym_trait_declaration_token1] = ACTIONS(1512),
    [aux_sym_interface_declaration_token1] = ACTIONS(1512),
    [aux_sym_enum_declaration_token1] = ACTIONS(1512),
    [aux_sym_enum_case_token1] = ACTIONS(1512),
    [aux_sym_class_declaration_token1] = ACTIONS(1512),
    [aux_sym_final_modifier_token1] = ACTIONS(1512),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1512),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1512),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1512),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [aux_sym_cast_type_token1] = ACTIONS(1512),
    [aux_sym_echo_statement_token1] = ACTIONS(1512),
    [anon_sym_unset] = ACTIONS(1512),
    [aux_sym_declare_statement_token1] = ACTIONS(1512),
    [aux_sym_declare_statement_token2] = ACTIONS(1512),
    [sym_float] = ACTIONS(1512),
    [aux_sym_try_statement_token1] = ACTIONS(1512),
    [aux_sym_goto_statement_token1] = ACTIONS(1512),
    [aux_sym_continue_statement_token1] = ACTIONS(1512),
    [aux_sym_break_statement_token1] = ACTIONS(1512),
    [sym_integer] = ACTIONS(1512),
    [aux_sym_return_statement_token1] = ACTIONS(1512),
    [aux_sym_throw_expression_token1] = ACTIONS(1512),
    [aux_sym_while_statement_token1] = ACTIONS(1512),
    [aux_sym_while_statement_token2] = ACTIONS(1512),
    [aux_sym_do_statement_token1] = ACTIONS(1512),
    [aux_sym_for_statement_token1] = ACTIONS(1512),
    [aux_sym_for_statement_token2] = ACTIONS(1512),
    [aux_sym_foreach_statement_token1] = ACTIONS(1512),
    [aux_sym_foreach_statement_token2] = ACTIONS(1512),
    [aux_sym_if_statement_token1] = ACTIONS(1512),
    [aux_sym_if_statement_token2] = ACTIONS(1512),
    [aux_sym_else_if_clause_token1] = ACTIONS(1512),
    [aux_sym_else_clause_token1] = ACTIONS(1512),
    [aux_sym_match_expression_token1] = ACTIONS(1512),
    [aux_sym_match_default_expression_token1] = ACTIONS(1512),
    [aux_sym_switch_statement_token1] = ACTIONS(1512),
    [aux_sym_switch_block_token1] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [aux_sym_clone_expression_token1] = ACTIONS(1512),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1512),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1512),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [aux_sym__list_destructing_token1] = ACTIONS(1512),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_self] = ACTIONS(1512),
    [anon_sym_parent] = ACTIONS(1512),
    [aux_sym__argument_name_token1] = ACTIONS(1512),
    [aux_sym__argument_name_token2] = ACTIONS(1512),
    [anon_sym_POUND_LBRACK] = ACTIONS(1510),
    [aux_sym_encapsed_string_token1] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [aux_sym_string_token1] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_LT_LT_LT] = ACTIONS(1510),
    [anon_sym_BQUOTE] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [aux_sym_yield_expression_token1] = ACTIONS(1512),
    [aux_sym_include_expression_token1] = ACTIONS(1512),
    [aux_sym_include_once_expression_token1] = ACTIONS(1512),
    [aux_sym_require_expression_token1] = ACTIONS(1512),
    [aux_sym_require_once_expression_token1] = ACTIONS(1512),
    [sym_comment] = ACTIONS(5),
  },
  [557] = {
    [sym_text_interpolation] = STATE(557),
    [ts_builtin_sym_end] = ACTIONS(1514),
    [sym_name] = ACTIONS(1516),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1514),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1516),
    [aux_sym_global_declaration_token1] = ACTIONS(1516),
    [aux_sym_namespace_definition_token1] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1516),
    [anon_sym_BSLASH] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [aux_sym_trait_declaration_token1] = ACTIONS(1516),
    [aux_sym_interface_declaration_token1] = ACTIONS(1516),
    [aux_sym_enum_declaration_token1] = ACTIONS(1516),
    [aux_sym_enum_case_token1] = ACTIONS(1516),
    [aux_sym_class_declaration_token1] = ACTIONS(1516),
    [aux_sym_final_modifier_token1] = ACTIONS(1516),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1516),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1516),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [aux_sym_cast_type_token1] = ACTIONS(1516),
    [aux_sym_echo_statement_token1] = ACTIONS(1516),
    [anon_sym_unset] = ACTIONS(1516),
    [aux_sym_declare_statement_token1] = ACTIONS(1516),
    [aux_sym_declare_statement_token2] = ACTIONS(1516),
    [sym_float] = ACTIONS(1516),
    [aux_sym_try_statement_token1] = ACTIONS(1516),
    [aux_sym_goto_statement_token1] = ACTIONS(1516),
    [aux_sym_continue_statement_token1] = ACTIONS(1516),
    [aux_sym_break_statement_token1] = ACTIONS(1516),
    [sym_integer] = ACTIONS(1516),
    [aux_sym_return_statement_token1] = ACTIONS(1516),
    [aux_sym_throw_expression_token1] = ACTIONS(1516),
    [aux_sym_while_statement_token1] = ACTIONS(1516),
    [aux_sym_while_statement_token2] = ACTIONS(1516),
    [aux_sym_do_statement_token1] = ACTIONS(1516),
    [aux_sym_for_statement_token1] = ACTIONS(1516),
    [aux_sym_for_statement_token2] = ACTIONS(1516),
    [aux_sym_foreach_statement_token1] = ACTIONS(1516),
    [aux_sym_foreach_statement_token2] = ACTIONS(1516),
    [aux_sym_if_statement_token1] = ACTIONS(1516),
    [aux_sym_if_statement_token2] = ACTIONS(1516),
    [aux_sym_else_if_clause_token1] = ACTIONS(1516),
    [aux_sym_else_clause_token1] = ACTIONS(1516),
    [aux_sym_match_expression_token1] = ACTIONS(1516),
    [aux_sym_match_default_expression_token1] = ACTIONS(1516),
    [aux_sym_switch_statement_token1] = ACTIONS(1516),
    [aux_sym_switch_block_token1] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(1514),
    [aux_sym_clone_expression_token1] = ACTIONS(1516),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1516),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1516),
    [anon_sym_DASH_DASH] = ACTIONS(1514),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [aux_sym__list_destructing_token1] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_self] = ACTIONS(1516),
    [anon_sym_parent] = ACTIONS(1516),
    [aux_sym__argument_name_token1] = ACTIONS(1516),
    [aux_sym__argument_name_token2] = ACTIONS(1516),
    [anon_sym_POUND_LBRACK] = ACTIONS(1514),
    [aux_sym_encapsed_string_token1] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(1514),
    [aux_sym_string_token1] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1514),
    [anon_sym_LT_LT_LT] = ACTIONS(1514),
    [anon_sym_BQUOTE] = ACTIONS(1514),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [aux_sym_yield_expression_token1] = ACTIONS(1516),
    [aux_sym_include_expression_token1] = ACTIONS(1516),
    [aux_sym_include_once_expression_token1] = ACTIONS(1516),
    [aux_sym_require_expression_token1] = ACTIONS(1516),
    [aux_sym_require_once_expression_token1] = ACTIONS(1516),
    [sym_comment] = ACTIONS(5),
  },
  [558] = {
    [sym_text_interpolation] = STATE(558),
    [ts_builtin_sym_end] = ACTIONS(1518),
    [sym_name] = ACTIONS(1520),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1518),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1520),
    [aux_sym_global_declaration_token1] = ACTIONS(1520),
    [aux_sym_namespace_definition_token1] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1520),
    [anon_sym_BSLASH] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [aux_sym_trait_declaration_token1] = ACTIONS(1520),
    [aux_sym_interface_declaration_token1] = ACTIONS(1520),
    [aux_sym_enum_declaration_token1] = ACTIONS(1520),
    [aux_sym_enum_case_token1] = ACTIONS(1520),
    [aux_sym_class_declaration_token1] = ACTIONS(1520),
    [aux_sym_final_modifier_token1] = ACTIONS(1520),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1520),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1520),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [aux_sym_cast_type_token1] = ACTIONS(1520),
    [aux_sym_echo_statement_token1] = ACTIONS(1520),
    [anon_sym_unset] = ACTIONS(1520),
    [aux_sym_declare_statement_token1] = ACTIONS(1520),
    [aux_sym_declare_statement_token2] = ACTIONS(1520),
    [sym_float] = ACTIONS(1520),
    [aux_sym_try_statement_token1] = ACTIONS(1520),
    [aux_sym_goto_statement_token1] = ACTIONS(1520),
    [aux_sym_continue_statement_token1] = ACTIONS(1520),
    [aux_sym_break_statement_token1] = ACTIONS(1520),
    [sym_integer] = ACTIONS(1520),
    [aux_sym_return_statement_token1] = ACTIONS(1520),
    [aux_sym_throw_expression_token1] = ACTIONS(1520),
    [aux_sym_while_statement_token1] = ACTIONS(1520),
    [aux_sym_while_statement_token2] = ACTIONS(1520),
    [aux_sym_do_statement_token1] = ACTIONS(1520),
    [aux_sym_for_statement_token1] = ACTIONS(1520),
    [aux_sym_for_statement_token2] = ACTIONS(1520),
    [aux_sym_foreach_statement_token1] = ACTIONS(1520),
    [aux_sym_foreach_statement_token2] = ACTIONS(1520),
    [aux_sym_if_statement_token1] = ACTIONS(1520),
    [aux_sym_if_statement_token2] = ACTIONS(1520),
    [aux_sym_else_if_clause_token1] = ACTIONS(1520),
    [aux_sym_else_clause_token1] = ACTIONS(1520),
    [aux_sym_match_expression_token1] = ACTIONS(1520),
    [aux_sym_match_default_expression_token1] = ACTIONS(1520),
    [aux_sym_switch_statement_token1] = ACTIONS(1520),
    [aux_sym_switch_block_token1] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1518),
    [aux_sym_clone_expression_token1] = ACTIONS(1520),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1520),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1518),
    [anon_sym_PLUS_PLUS] = ACTIONS(1518),
    [aux_sym__list_destructing_token1] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_self] = ACTIONS(1520),
    [anon_sym_parent] = ACTIONS(1520),
    [aux_sym__argument_name_token1] = ACTIONS(1520),
    [aux_sym__argument_name_token2] = ACTIONS(1520),
    [anon_sym_POUND_LBRACK] = ACTIONS(1518),
    [aux_sym_encapsed_string_token1] = ACTIONS(1518),
    [anon_sym_DQUOTE] = ACTIONS(1518),
    [aux_sym_string_token1] = ACTIONS(1518),
    [anon_sym_SQUOTE] = ACTIONS(1518),
    [anon_sym_LT_LT_LT] = ACTIONS(1518),
    [anon_sym_BQUOTE] = ACTIONS(1518),
    [anon_sym_DOLLAR] = ACTIONS(1518),
    [aux_sym_yield_expression_token1] = ACTIONS(1520),
    [aux_sym_include_expression_token1] = ACTIONS(1520),
    [aux_sym_include_once_expression_token1] = ACTIONS(1520),
    [aux_sym_require_expression_token1] = ACTIONS(1520),
    [aux_sym_require_once_expression_token1] = ACTIONS(1520),
    [sym_comment] = ACTIONS(5),
  },
  [559] = {
    [sym_text_interpolation] = STATE(559),
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_name] = ACTIONS(1524),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1522),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1524),
    [aux_sym_global_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_definition_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1524),
    [anon_sym_BSLASH] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [aux_sym_trait_declaration_token1] = ACTIONS(1524),
    [aux_sym_interface_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_case_token1] = ACTIONS(1524),
    [aux_sym_class_declaration_token1] = ACTIONS(1524),
    [aux_sym_final_modifier_token1] = ACTIONS(1524),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1524),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1524),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [aux_sym_cast_type_token1] = ACTIONS(1524),
    [aux_sym_echo_statement_token1] = ACTIONS(1524),
    [anon_sym_unset] = ACTIONS(1524),
    [aux_sym_declare_statement_token1] = ACTIONS(1524),
    [aux_sym_declare_statement_token2] = ACTIONS(1524),
    [sym_float] = ACTIONS(1524),
    [aux_sym_try_statement_token1] = ACTIONS(1524),
    [aux_sym_goto_statement_token1] = ACTIONS(1524),
    [aux_sym_continue_statement_token1] = ACTIONS(1524),
    [aux_sym_break_statement_token1] = ACTIONS(1524),
    [sym_integer] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1524),
    [aux_sym_throw_expression_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token2] = ACTIONS(1524),
    [aux_sym_do_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token2] = ACTIONS(1524),
    [aux_sym_foreach_statement_token1] = ACTIONS(1524),
    [aux_sym_foreach_statement_token2] = ACTIONS(1524),
    [aux_sym_if_statement_token1] = ACTIONS(1524),
    [aux_sym_if_statement_token2] = ACTIONS(1524),
    [aux_sym_else_if_clause_token1] = ACTIONS(1524),
    [aux_sym_else_clause_token1] = ACTIONS(1524),
    [aux_sym_match_expression_token1] = ACTIONS(1524),
    [aux_sym_match_default_expression_token1] = ACTIONS(1524),
    [aux_sym_switch_statement_token1] = ACTIONS(1524),
    [aux_sym_switch_block_token1] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1522),
    [aux_sym_clone_expression_token1] = ACTIONS(1524),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1524),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1524),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [aux_sym__list_destructing_token1] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_self] = ACTIONS(1524),
    [anon_sym_parent] = ACTIONS(1524),
    [aux_sym__argument_name_token1] = ACTIONS(1524),
    [aux_sym__argument_name_token2] = ACTIONS(1524),
    [anon_sym_POUND_LBRACK] = ACTIONS(1522),
    [aux_sym_encapsed_string_token1] = ACTIONS(1522),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [aux_sym_string_token1] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(1522),
    [aux_sym_yield_expression_token1] = ACTIONS(1524),
    [aux_sym_include_expression_token1] = ACTIONS(1524),
    [aux_sym_include_once_expression_token1] = ACTIONS(1524),
    [aux_sym_require_expression_token1] = ACTIONS(1524),
    [aux_sym_require_once_expression_token1] = ACTIONS(1524),
    [sym_comment] = ACTIONS(5),
  },
  [560] = {
    [sym_text_interpolation] = STATE(560),
    [ts_builtin_sym_end] = ACTIONS(1526),
    [sym_name] = ACTIONS(1528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1526),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1528),
    [aux_sym_global_declaration_token1] = ACTIONS(1528),
    [aux_sym_namespace_definition_token1] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1528),
    [anon_sym_BSLASH] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [aux_sym_trait_declaration_token1] = ACTIONS(1528),
    [aux_sym_interface_declaration_token1] = ACTIONS(1528),
    [aux_sym_enum_declaration_token1] = ACTIONS(1528),
    [aux_sym_enum_case_token1] = ACTIONS(1528),
    [aux_sym_class_declaration_token1] = ACTIONS(1528),
    [aux_sym_final_modifier_token1] = ACTIONS(1528),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1528),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1528),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [aux_sym_cast_type_token1] = ACTIONS(1528),
    [aux_sym_echo_statement_token1] = ACTIONS(1528),
    [anon_sym_unset] = ACTIONS(1528),
    [aux_sym_declare_statement_token1] = ACTIONS(1528),
    [aux_sym_declare_statement_token2] = ACTIONS(1528),
    [sym_float] = ACTIONS(1528),
    [aux_sym_try_statement_token1] = ACTIONS(1528),
    [aux_sym_goto_statement_token1] = ACTIONS(1528),
    [aux_sym_continue_statement_token1] = ACTIONS(1528),
    [aux_sym_break_statement_token1] = ACTIONS(1528),
    [sym_integer] = ACTIONS(1528),
    [aux_sym_return_statement_token1] = ACTIONS(1528),
    [aux_sym_throw_expression_token1] = ACTIONS(1528),
    [aux_sym_while_statement_token1] = ACTIONS(1528),
    [aux_sym_while_statement_token2] = ACTIONS(1528),
    [aux_sym_do_statement_token1] = ACTIONS(1528),
    [aux_sym_for_statement_token1] = ACTIONS(1528),
    [aux_sym_for_statement_token2] = ACTIONS(1528),
    [aux_sym_foreach_statement_token1] = ACTIONS(1528),
    [aux_sym_foreach_statement_token2] = ACTIONS(1528),
    [aux_sym_if_statement_token1] = ACTIONS(1528),
    [aux_sym_if_statement_token2] = ACTIONS(1528),
    [aux_sym_else_if_clause_token1] = ACTIONS(1528),
    [aux_sym_else_clause_token1] = ACTIONS(1528),
    [aux_sym_match_expression_token1] = ACTIONS(1528),
    [aux_sym_match_default_expression_token1] = ACTIONS(1528),
    [aux_sym_switch_statement_token1] = ACTIONS(1528),
    [aux_sym_switch_block_token1] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_AT] = ACTIONS(1526),
    [aux_sym_clone_expression_token1] = ACTIONS(1528),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1528),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1528),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [aux_sym__list_destructing_token1] = ACTIONS(1528),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_self] = ACTIONS(1528),
    [anon_sym_parent] = ACTIONS(1528),
    [aux_sym__argument_name_token1] = ACTIONS(1528),
    [aux_sym__argument_name_token2] = ACTIONS(1528),
    [anon_sym_POUND_LBRACK] = ACTIONS(1526),
    [aux_sym_encapsed_string_token1] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [aux_sym_string_token1] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [anon_sym_LT_LT_LT] = ACTIONS(1526),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(1526),
    [aux_sym_yield_expression_token1] = ACTIONS(1528),
    [aux_sym_include_expression_token1] = ACTIONS(1528),
    [aux_sym_include_once_expression_token1] = ACTIONS(1528),
    [aux_sym_require_expression_token1] = ACTIONS(1528),
    [aux_sym_require_once_expression_token1] = ACTIONS(1528),
    [sym_comment] = ACTIONS(5),
  },
  [561] = {
    [sym_text_interpolation] = STATE(561),
    [ts_builtin_sym_end] = ACTIONS(1027),
    [sym_name] = ACTIONS(1029),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1027),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1029),
    [aux_sym_global_declaration_token1] = ACTIONS(1029),
    [aux_sym_namespace_definition_token1] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1029),
    [anon_sym_BSLASH] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [aux_sym_trait_declaration_token1] = ACTIONS(1029),
    [aux_sym_interface_declaration_token1] = ACTIONS(1029),
    [aux_sym_enum_declaration_token1] = ACTIONS(1029),
    [aux_sym_enum_case_token1] = ACTIONS(1029),
    [aux_sym_class_declaration_token1] = ACTIONS(1029),
    [aux_sym_final_modifier_token1] = ACTIONS(1029),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1029),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1029),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [aux_sym_cast_type_token1] = ACTIONS(1029),
    [aux_sym_echo_statement_token1] = ACTIONS(1029),
    [anon_sym_unset] = ACTIONS(1029),
    [aux_sym_declare_statement_token1] = ACTIONS(1029),
    [aux_sym_declare_statement_token2] = ACTIONS(1029),
    [sym_float] = ACTIONS(1029),
    [aux_sym_try_statement_token1] = ACTIONS(1029),
    [aux_sym_goto_statement_token1] = ACTIONS(1029),
    [aux_sym_continue_statement_token1] = ACTIONS(1029),
    [aux_sym_break_statement_token1] = ACTIONS(1029),
    [sym_integer] = ACTIONS(1029),
    [aux_sym_return_statement_token1] = ACTIONS(1029),
    [aux_sym_throw_expression_token1] = ACTIONS(1029),
    [aux_sym_while_statement_token1] = ACTIONS(1029),
    [aux_sym_while_statement_token2] = ACTIONS(1029),
    [aux_sym_do_statement_token1] = ACTIONS(1029),
    [aux_sym_for_statement_token1] = ACTIONS(1029),
    [aux_sym_for_statement_token2] = ACTIONS(1029),
    [aux_sym_foreach_statement_token1] = ACTIONS(1029),
    [aux_sym_foreach_statement_token2] = ACTIONS(1029),
    [aux_sym_if_statement_token1] = ACTIONS(1029),
    [aux_sym_if_statement_token2] = ACTIONS(1029),
    [aux_sym_else_if_clause_token1] = ACTIONS(1029),
    [aux_sym_else_clause_token1] = ACTIONS(1029),
    [aux_sym_match_expression_token1] = ACTIONS(1029),
    [aux_sym_match_default_expression_token1] = ACTIONS(1029),
    [aux_sym_switch_statement_token1] = ACTIONS(1029),
    [aux_sym_switch_block_token1] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(1027),
    [aux_sym_clone_expression_token1] = ACTIONS(1029),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1029),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [aux_sym__list_destructing_token1] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_self] = ACTIONS(1029),
    [anon_sym_parent] = ACTIONS(1029),
    [aux_sym__argument_name_token1] = ACTIONS(1029),
    [aux_sym__argument_name_token2] = ACTIONS(1029),
    [anon_sym_POUND_LBRACK] = ACTIONS(1027),
    [aux_sym_encapsed_string_token1] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [aux_sym_string_token1] = ACTIONS(1027),
    [anon_sym_SQUOTE] = ACTIONS(1027),
    [anon_sym_LT_LT_LT] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1027),
    [aux_sym_yield_expression_token1] = ACTIONS(1029),
    [aux_sym_include_expression_token1] = ACTIONS(1029),
    [aux_sym_include_once_expression_token1] = ACTIONS(1029),
    [aux_sym_require_expression_token1] = ACTIONS(1029),
    [aux_sym_require_once_expression_token1] = ACTIONS(1029),
    [sym_comment] = ACTIONS(5),
  },
  [562] = {
    [sym_text_interpolation] = STATE(562),
    [ts_builtin_sym_end] = ACTIONS(1530),
    [sym_name] = ACTIONS(1532),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1530),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1532),
    [aux_sym_global_declaration_token1] = ACTIONS(1532),
    [aux_sym_namespace_definition_token1] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1532),
    [anon_sym_BSLASH] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [aux_sym_trait_declaration_token1] = ACTIONS(1532),
    [aux_sym_interface_declaration_token1] = ACTIONS(1532),
    [aux_sym_enum_declaration_token1] = ACTIONS(1532),
    [aux_sym_enum_case_token1] = ACTIONS(1532),
    [aux_sym_class_declaration_token1] = ACTIONS(1532),
    [aux_sym_final_modifier_token1] = ACTIONS(1532),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1532),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1532),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [aux_sym_cast_type_token1] = ACTIONS(1532),
    [aux_sym_echo_statement_token1] = ACTIONS(1532),
    [anon_sym_unset] = ACTIONS(1532),
    [aux_sym_declare_statement_token1] = ACTIONS(1532),
    [aux_sym_declare_statement_token2] = ACTIONS(1532),
    [sym_float] = ACTIONS(1532),
    [aux_sym_try_statement_token1] = ACTIONS(1532),
    [aux_sym_goto_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1532),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [sym_integer] = ACTIONS(1532),
    [aux_sym_return_statement_token1] = ACTIONS(1532),
    [aux_sym_throw_expression_token1] = ACTIONS(1532),
    [aux_sym_while_statement_token1] = ACTIONS(1532),
    [aux_sym_while_statement_token2] = ACTIONS(1532),
    [aux_sym_do_statement_token1] = ACTIONS(1532),
    [aux_sym_for_statement_token1] = ACTIONS(1532),
    [aux_sym_for_statement_token2] = ACTIONS(1532),
    [aux_sym_foreach_statement_token1] = ACTIONS(1532),
    [aux_sym_foreach_statement_token2] = ACTIONS(1532),
    [aux_sym_if_statement_token1] = ACTIONS(1532),
    [aux_sym_if_statement_token2] = ACTIONS(1532),
    [aux_sym_else_if_clause_token1] = ACTIONS(1532),
    [aux_sym_else_clause_token1] = ACTIONS(1532),
    [aux_sym_match_expression_token1] = ACTIONS(1532),
    [aux_sym_match_default_expression_token1] = ACTIONS(1532),
    [aux_sym_switch_statement_token1] = ACTIONS(1532),
    [aux_sym_switch_block_token1] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1530),
    [aux_sym_clone_expression_token1] = ACTIONS(1532),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1532),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1530),
    [aux_sym__list_destructing_token1] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1530),
    [anon_sym_self] = ACTIONS(1532),
    [anon_sym_parent] = ACTIONS(1532),
    [aux_sym__argument_name_token1] = ACTIONS(1532),
    [aux_sym__argument_name_token2] = ACTIONS(1532),
    [anon_sym_POUND_LBRACK] = ACTIONS(1530),
    [aux_sym_encapsed_string_token1] = ACTIONS(1530),
    [anon_sym_DQUOTE] = ACTIONS(1530),
    [aux_sym_string_token1] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(1530),
    [anon_sym_LT_LT_LT] = ACTIONS(1530),
    [anon_sym_BQUOTE] = ACTIONS(1530),
    [anon_sym_DOLLAR] = ACTIONS(1530),
    [aux_sym_yield_expression_token1] = ACTIONS(1532),
    [aux_sym_include_expression_token1] = ACTIONS(1532),
    [aux_sym_include_once_expression_token1] = ACTIONS(1532),
    [aux_sym_require_expression_token1] = ACTIONS(1532),
    [aux_sym_require_once_expression_token1] = ACTIONS(1532),
    [sym_comment] = ACTIONS(5),
  },
  [563] = {
    [sym_text_interpolation] = STATE(563),
    [ts_builtin_sym_end] = ACTIONS(1534),
    [sym_name] = ACTIONS(1536),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1534),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1536),
    [aux_sym_global_declaration_token1] = ACTIONS(1536),
    [aux_sym_namespace_definition_token1] = ACTIONS(1536),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1536),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1536),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1536),
    [anon_sym_BSLASH] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_RBRACE] = ACTIONS(1534),
    [aux_sym_trait_declaration_token1] = ACTIONS(1536),
    [aux_sym_interface_declaration_token1] = ACTIONS(1536),
    [aux_sym_enum_declaration_token1] = ACTIONS(1536),
    [aux_sym_enum_case_token1] = ACTIONS(1536),
    [aux_sym_class_declaration_token1] = ACTIONS(1536),
    [aux_sym_final_modifier_token1] = ACTIONS(1536),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1536),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1536),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1536),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1536),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1536),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [aux_sym_cast_type_token1] = ACTIONS(1536),
    [aux_sym_echo_statement_token1] = ACTIONS(1536),
    [anon_sym_unset] = ACTIONS(1536),
    [aux_sym_declare_statement_token1] = ACTIONS(1536),
    [aux_sym_declare_statement_token2] = ACTIONS(1536),
    [sym_float] = ACTIONS(1536),
    [aux_sym_try_statement_token1] = ACTIONS(1536),
    [aux_sym_goto_statement_token1] = ACTIONS(1536),
    [aux_sym_continue_statement_token1] = ACTIONS(1536),
    [aux_sym_break_statement_token1] = ACTIONS(1536),
    [sym_integer] = ACTIONS(1536),
    [aux_sym_return_statement_token1] = ACTIONS(1536),
    [aux_sym_throw_expression_token1] = ACTIONS(1536),
    [aux_sym_while_statement_token1] = ACTIONS(1536),
    [aux_sym_while_statement_token2] = ACTIONS(1536),
    [aux_sym_do_statement_token1] = ACTIONS(1536),
    [aux_sym_for_statement_token1] = ACTIONS(1536),
    [aux_sym_for_statement_token2] = ACTIONS(1536),
    [aux_sym_foreach_statement_token1] = ACTIONS(1536),
    [aux_sym_foreach_statement_token2] = ACTIONS(1536),
    [aux_sym_if_statement_token1] = ACTIONS(1536),
    [aux_sym_if_statement_token2] = ACTIONS(1536),
    [aux_sym_else_if_clause_token1] = ACTIONS(1536),
    [aux_sym_else_clause_token1] = ACTIONS(1536),
    [aux_sym_match_expression_token1] = ACTIONS(1536),
    [aux_sym_match_default_expression_token1] = ACTIONS(1536),
    [aux_sym_switch_statement_token1] = ACTIONS(1536),
    [aux_sym_switch_block_token1] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1536),
    [anon_sym_DASH] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1534),
    [anon_sym_BANG] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(1534),
    [aux_sym_clone_expression_token1] = ACTIONS(1536),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1536),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1536),
    [anon_sym_DASH_DASH] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1534),
    [aux_sym__list_destructing_token1] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(1536),
    [anon_sym_parent] = ACTIONS(1536),
    [aux_sym__argument_name_token1] = ACTIONS(1536),
    [aux_sym__argument_name_token2] = ACTIONS(1536),
    [anon_sym_POUND_LBRACK] = ACTIONS(1534),
    [aux_sym_encapsed_string_token1] = ACTIONS(1534),
    [anon_sym_DQUOTE] = ACTIONS(1534),
    [aux_sym_string_token1] = ACTIONS(1534),
    [anon_sym_SQUOTE] = ACTIONS(1534),
    [anon_sym_LT_LT_LT] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1534),
    [anon_sym_DOLLAR] = ACTIONS(1534),
    [aux_sym_yield_expression_token1] = ACTIONS(1536),
    [aux_sym_include_expression_token1] = ACTIONS(1536),
    [aux_sym_include_once_expression_token1] = ACTIONS(1536),
    [aux_sym_require_expression_token1] = ACTIONS(1536),
    [aux_sym_require_once_expression_token1] = ACTIONS(1536),
    [sym_comment] = ACTIONS(5),
  },
  [564] = {
    [sym_text_interpolation] = STATE(564),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(906),
    [sym_clone_expression] = STATE(906),
    [sym__primary_expression] = STATE(906),
    [sym_parenthesized_expression] = STATE(688),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_expression] = STATE(906),
    [sym_cast_variable] = STATE(598),
    [sym_member_access_expression] = STATE(598),
    [sym_nullsafe_member_access_expression] = STATE(598),
    [sym_scoped_property_access_expression] = STATE(598),
    [sym_function_call_expression] = STATE(579),
    [sym_scoped_call_expression] = STATE(579),
    [sym__scope_resolution_qualifier] = STATE(2630),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(579),
    [sym_nullsafe_member_call_expression] = STATE(579),
    [sym_subscript_expression] = STATE(579),
    [sym__dereferencable_expression] = STATE(1759),
    [sym_array_creation_expression] = STATE(688),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(688),
    [sym_dynamic_variable_name] = STATE(579),
    [sym_variable_name] = STATE(579),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1591),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(559),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(627),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [anon_sym_PLUS] = ACTIONS(633),
    [anon_sym_DASH] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(635),
    [aux_sym_clone_expression_token1] = ACTIONS(639),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [aux_sym_include_expression_token1] = ACTIONS(649),
    [aux_sym_include_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(5),
  },
  [565] = {
    [sym_text_interpolation] = STATE(565),
    [ts_builtin_sym_end] = ACTIONS(1538),
    [sym_name] = ACTIONS(1540),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1538),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1540),
    [aux_sym_global_declaration_token1] = ACTIONS(1540),
    [aux_sym_namespace_definition_token1] = ACTIONS(1540),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1540),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1540),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1540),
    [anon_sym_BSLASH] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [aux_sym_trait_declaration_token1] = ACTIONS(1540),
    [aux_sym_interface_declaration_token1] = ACTIONS(1540),
    [aux_sym_enum_declaration_token1] = ACTIONS(1540),
    [aux_sym_enum_case_token1] = ACTIONS(1540),
    [aux_sym_class_declaration_token1] = ACTIONS(1540),
    [aux_sym_final_modifier_token1] = ACTIONS(1540),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1540),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1540),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1540),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1540),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1540),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [aux_sym_cast_type_token1] = ACTIONS(1540),
    [aux_sym_echo_statement_token1] = ACTIONS(1540),
    [anon_sym_unset] = ACTIONS(1540),
    [aux_sym_declare_statement_token1] = ACTIONS(1540),
    [aux_sym_declare_statement_token2] = ACTIONS(1540),
    [sym_float] = ACTIONS(1540),
    [aux_sym_try_statement_token1] = ACTIONS(1540),
    [aux_sym_goto_statement_token1] = ACTIONS(1540),
    [aux_sym_continue_statement_token1] = ACTIONS(1540),
    [aux_sym_break_statement_token1] = ACTIONS(1540),
    [sym_integer] = ACTIONS(1540),
    [aux_sym_return_statement_token1] = ACTIONS(1540),
    [aux_sym_throw_expression_token1] = ACTIONS(1540),
    [aux_sym_while_statement_token1] = ACTIONS(1540),
    [aux_sym_while_statement_token2] = ACTIONS(1540),
    [aux_sym_do_statement_token1] = ACTIONS(1540),
    [aux_sym_for_statement_token1] = ACTIONS(1540),
    [aux_sym_for_statement_token2] = ACTIONS(1540),
    [aux_sym_foreach_statement_token1] = ACTIONS(1540),
    [aux_sym_foreach_statement_token2] = ACTIONS(1540),
    [aux_sym_if_statement_token1] = ACTIONS(1540),
    [aux_sym_if_statement_token2] = ACTIONS(1540),
    [aux_sym_else_if_clause_token1] = ACTIONS(1540),
    [aux_sym_else_clause_token1] = ACTIONS(1540),
    [aux_sym_match_expression_token1] = ACTIONS(1540),
    [aux_sym_match_default_expression_token1] = ACTIONS(1540),
    [aux_sym_switch_statement_token1] = ACTIONS(1540),
    [aux_sym_switch_block_token1] = ACTIONS(1540),
    [anon_sym_PLUS] = ACTIONS(1540),
    [anon_sym_DASH] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1538),
    [anon_sym_BANG] = ACTIONS(1538),
    [anon_sym_AT] = ACTIONS(1538),
    [aux_sym_clone_expression_token1] = ACTIONS(1540),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1540),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1538),
    [anon_sym_PLUS_PLUS] = ACTIONS(1538),
    [aux_sym__list_destructing_token1] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_self] = ACTIONS(1540),
    [anon_sym_parent] = ACTIONS(1540),
    [aux_sym__argument_name_token1] = ACTIONS(1540),
    [aux_sym__argument_name_token2] = ACTIONS(1540),
    [anon_sym_POUND_LBRACK] = ACTIONS(1538),
    [aux_sym_encapsed_string_token1] = ACTIONS(1538),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [aux_sym_string_token1] = ACTIONS(1538),
    [anon_sym_SQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LT_LT] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(1538),
    [aux_sym_yield_expression_token1] = ACTIONS(1540),
    [aux_sym_include_expression_token1] = ACTIONS(1540),
    [aux_sym_include_once_expression_token1] = ACTIONS(1540),
    [aux_sym_require_expression_token1] = ACTIONS(1540),
    [aux_sym_require_once_expression_token1] = ACTIONS(1540),
    [sym_comment] = ACTIONS(5),
  },
  [566] = {
    [sym_text_interpolation] = STATE(566),
    [ts_builtin_sym_end] = ACTIONS(1542),
    [sym_name] = ACTIONS(1544),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1542),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1544),
    [aux_sym_global_declaration_token1] = ACTIONS(1544),
    [aux_sym_namespace_definition_token1] = ACTIONS(1544),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1544),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1544),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1544),
    [anon_sym_BSLASH] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [aux_sym_trait_declaration_token1] = ACTIONS(1544),
    [aux_sym_interface_declaration_token1] = ACTIONS(1544),
    [aux_sym_enum_declaration_token1] = ACTIONS(1544),
    [aux_sym_enum_case_token1] = ACTIONS(1544),
    [aux_sym_class_declaration_token1] = ACTIONS(1544),
    [aux_sym_final_modifier_token1] = ACTIONS(1544),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1544),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1544),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1544),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1544),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1544),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1544),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [aux_sym_cast_type_token1] = ACTIONS(1544),
    [aux_sym_echo_statement_token1] = ACTIONS(1544),
    [anon_sym_unset] = ACTIONS(1544),
    [aux_sym_declare_statement_token1] = ACTIONS(1544),
    [aux_sym_declare_statement_token2] = ACTIONS(1544),
    [sym_float] = ACTIONS(1544),
    [aux_sym_try_statement_token1] = ACTIONS(1544),
    [aux_sym_goto_statement_token1] = ACTIONS(1544),
    [aux_sym_continue_statement_token1] = ACTIONS(1544),
    [aux_sym_break_statement_token1] = ACTIONS(1544),
    [sym_integer] = ACTIONS(1544),
    [aux_sym_return_statement_token1] = ACTIONS(1544),
    [aux_sym_throw_expression_token1] = ACTIONS(1544),
    [aux_sym_while_statement_token1] = ACTIONS(1544),
    [aux_sym_while_statement_token2] = ACTIONS(1544),
    [aux_sym_do_statement_token1] = ACTIONS(1544),
    [aux_sym_for_statement_token1] = ACTIONS(1544),
    [aux_sym_for_statement_token2] = ACTIONS(1544),
    [aux_sym_foreach_statement_token1] = ACTIONS(1544),
    [aux_sym_foreach_statement_token2] = ACTIONS(1544),
    [aux_sym_if_statement_token1] = ACTIONS(1544),
    [aux_sym_if_statement_token2] = ACTIONS(1544),
    [aux_sym_else_if_clause_token1] = ACTIONS(1544),
    [aux_sym_else_clause_token1] = ACTIONS(1544),
    [aux_sym_match_expression_token1] = ACTIONS(1544),
    [aux_sym_match_default_expression_token1] = ACTIONS(1544),
    [aux_sym_switch_statement_token1] = ACTIONS(1544),
    [aux_sym_switch_block_token1] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1542),
    [anon_sym_AT] = ACTIONS(1542),
    [aux_sym_clone_expression_token1] = ACTIONS(1544),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1544),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1544),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [aux_sym__list_destructing_token1] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_self] = ACTIONS(1544),
    [anon_sym_parent] = ACTIONS(1544),
    [aux_sym__argument_name_token1] = ACTIONS(1544),
    [aux_sym__argument_name_token2] = ACTIONS(1544),
    [anon_sym_POUND_LBRACK] = ACTIONS(1542),
    [aux_sym_encapsed_string_token1] = ACTIONS(1542),
    [anon_sym_DQUOTE] = ACTIONS(1542),
    [aux_sym_string_token1] = ACTIONS(1542),
    [anon_sym_SQUOTE] = ACTIONS(1542),
    [anon_sym_LT_LT_LT] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_DOLLAR] = ACTIONS(1542),
    [aux_sym_yield_expression_token1] = ACTIONS(1544),
    [aux_sym_include_expression_token1] = ACTIONS(1544),
    [aux_sym_include_once_expression_token1] = ACTIONS(1544),
    [aux_sym_require_expression_token1] = ACTIONS(1544),
    [aux_sym_require_once_expression_token1] = ACTIONS(1544),
    [sym_comment] = ACTIONS(5),
  },
  [567] = {
    [sym_text_interpolation] = STATE(567),
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_name] = ACTIONS(1496),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1494),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1496),
    [aux_sym_global_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_definition_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1496),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [aux_sym_trait_declaration_token1] = ACTIONS(1496),
    [aux_sym_interface_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_case_token1] = ACTIONS(1496),
    [aux_sym_class_declaration_token1] = ACTIONS(1496),
    [aux_sym_final_modifier_token1] = ACTIONS(1496),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1496),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1496),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [aux_sym_cast_type_token1] = ACTIONS(1496),
    [aux_sym_echo_statement_token1] = ACTIONS(1496),
    [anon_sym_unset] = ACTIONS(1496),
    [aux_sym_declare_statement_token1] = ACTIONS(1496),
    [aux_sym_declare_statement_token2] = ACTIONS(1496),
    [sym_float] = ACTIONS(1496),
    [aux_sym_try_statement_token1] = ACTIONS(1496),
    [aux_sym_goto_statement_token1] = ACTIONS(1496),
    [aux_sym_continue_statement_token1] = ACTIONS(1496),
    [aux_sym_break_statement_token1] = ACTIONS(1496),
    [sym_integer] = ACTIONS(1496),
    [aux_sym_return_statement_token1] = ACTIONS(1496),
    [aux_sym_throw_expression_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token2] = ACTIONS(1496),
    [aux_sym_do_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token2] = ACTIONS(1496),
    [aux_sym_foreach_statement_token1] = ACTIONS(1496),
    [aux_sym_foreach_statement_token2] = ACTIONS(1496),
    [aux_sym_if_statement_token1] = ACTIONS(1496),
    [aux_sym_if_statement_token2] = ACTIONS(1496),
    [aux_sym_else_if_clause_token1] = ACTIONS(1496),
    [aux_sym_else_clause_token1] = ACTIONS(1496),
    [aux_sym_match_expression_token1] = ACTIONS(1496),
    [aux_sym_match_default_expression_token1] = ACTIONS(1496),
    [aux_sym_switch_statement_token1] = ACTIONS(1496),
    [aux_sym_switch_block_token1] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [aux_sym_clone_expression_token1] = ACTIONS(1496),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1496),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [aux_sym__list_destructing_token1] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_self] = ACTIONS(1496),
    [anon_sym_parent] = ACTIONS(1496),
    [aux_sym__argument_name_token1] = ACTIONS(1496),
    [aux_sym__argument_name_token2] = ACTIONS(1496),
    [anon_sym_POUND_LBRACK] = ACTIONS(1494),
    [aux_sym_encapsed_string_token1] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [aux_sym_string_token1] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_LT_LT_LT] = ACTIONS(1494),
    [anon_sym_BQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [aux_sym_yield_expression_token1] = ACTIONS(1496),
    [aux_sym_include_expression_token1] = ACTIONS(1496),
    [aux_sym_include_once_expression_token1] = ACTIONS(1496),
    [aux_sym_require_expression_token1] = ACTIONS(1496),
    [aux_sym_require_once_expression_token1] = ACTIONS(1496),
    [sym_comment] = ACTIONS(5),
  },
  [568] = {
    [sym_text_interpolation] = STATE(568),
    [ts_builtin_sym_end] = ACTIONS(1546),
    [sym_name] = ACTIONS(1548),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1546),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1548),
    [aux_sym_global_declaration_token1] = ACTIONS(1548),
    [aux_sym_namespace_definition_token1] = ACTIONS(1548),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1548),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1548),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1548),
    [anon_sym_BSLASH] = ACTIONS(1546),
    [anon_sym_LBRACE] = ACTIONS(1546),
    [anon_sym_RBRACE] = ACTIONS(1546),
    [aux_sym_trait_declaration_token1] = ACTIONS(1548),
    [aux_sym_interface_declaration_token1] = ACTIONS(1548),
    [aux_sym_enum_declaration_token1] = ACTIONS(1548),
    [aux_sym_enum_case_token1] = ACTIONS(1548),
    [aux_sym_class_declaration_token1] = ACTIONS(1548),
    [aux_sym_final_modifier_token1] = ACTIONS(1548),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1548),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1548),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1548),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1548),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1548),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1548),
    [anon_sym_LPAREN] = ACTIONS(1546),
    [aux_sym_cast_type_token1] = ACTIONS(1548),
    [aux_sym_echo_statement_token1] = ACTIONS(1548),
    [anon_sym_unset] = ACTIONS(1548),
    [aux_sym_declare_statement_token1] = ACTIONS(1548),
    [aux_sym_declare_statement_token2] = ACTIONS(1548),
    [sym_float] = ACTIONS(1548),
    [aux_sym_try_statement_token1] = ACTIONS(1548),
    [aux_sym_goto_statement_token1] = ACTIONS(1548),
    [aux_sym_continue_statement_token1] = ACTIONS(1548),
    [aux_sym_break_statement_token1] = ACTIONS(1548),
    [sym_integer] = ACTIONS(1548),
    [aux_sym_return_statement_token1] = ACTIONS(1548),
    [aux_sym_throw_expression_token1] = ACTIONS(1548),
    [aux_sym_while_statement_token1] = ACTIONS(1548),
    [aux_sym_while_statement_token2] = ACTIONS(1548),
    [aux_sym_do_statement_token1] = ACTIONS(1548),
    [aux_sym_for_statement_token1] = ACTIONS(1548),
    [aux_sym_for_statement_token2] = ACTIONS(1548),
    [aux_sym_foreach_statement_token1] = ACTIONS(1548),
    [aux_sym_foreach_statement_token2] = ACTIONS(1548),
    [aux_sym_if_statement_token1] = ACTIONS(1548),
    [aux_sym_if_statement_token2] = ACTIONS(1548),
    [aux_sym_else_if_clause_token1] = ACTIONS(1548),
    [aux_sym_else_clause_token1] = ACTIONS(1548),
    [aux_sym_match_expression_token1] = ACTIONS(1548),
    [aux_sym_match_default_expression_token1] = ACTIONS(1548),
    [aux_sym_switch_statement_token1] = ACTIONS(1548),
    [aux_sym_switch_block_token1] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_TILDE] = ACTIONS(1546),
    [anon_sym_BANG] = ACTIONS(1546),
    [anon_sym_AT] = ACTIONS(1546),
    [aux_sym_clone_expression_token1] = ACTIONS(1548),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1548),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1548),
    [anon_sym_DASH_DASH] = ACTIONS(1546),
    [anon_sym_PLUS_PLUS] = ACTIONS(1546),
    [aux_sym__list_destructing_token1] = ACTIONS(1548),
    [anon_sym_LBRACK] = ACTIONS(1546),
    [anon_sym_self] = ACTIONS(1548),
    [anon_sym_parent] = ACTIONS(1548),
    [aux_sym__argument_name_token1] = ACTIONS(1548),
    [aux_sym__argument_name_token2] = ACTIONS(1548),
    [anon_sym_POUND_LBRACK] = ACTIONS(1546),
    [aux_sym_encapsed_string_token1] = ACTIONS(1546),
    [anon_sym_DQUOTE] = ACTIONS(1546),
    [aux_sym_string_token1] = ACTIONS(1546),
    [anon_sym_SQUOTE] = ACTIONS(1546),
    [anon_sym_LT_LT_LT] = ACTIONS(1546),
    [anon_sym_BQUOTE] = ACTIONS(1546),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [aux_sym_yield_expression_token1] = ACTIONS(1548),
    [aux_sym_include_expression_token1] = ACTIONS(1548),
    [aux_sym_include_once_expression_token1] = ACTIONS(1548),
    [aux_sym_require_expression_token1] = ACTIONS(1548),
    [aux_sym_require_once_expression_token1] = ACTIONS(1548),
    [sym_comment] = ACTIONS(5),
  },
  [569] = {
    [sym_text_interpolation] = STATE(569),
    [sym_name] = ACTIONS(1550),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1552),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1550),
    [aux_sym_global_declaration_token1] = ACTIONS(1550),
    [aux_sym_namespace_definition_token1] = ACTIONS(1550),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1550),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1550),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1550),
    [anon_sym_BSLASH] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [aux_sym_trait_declaration_token1] = ACTIONS(1550),
    [aux_sym_interface_declaration_token1] = ACTIONS(1550),
    [aux_sym_enum_declaration_token1] = ACTIONS(1550),
    [anon_sym_COLON] = ACTIONS(1552),
    [aux_sym_class_declaration_token1] = ACTIONS(1550),
    [aux_sym_final_modifier_token1] = ACTIONS(1550),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1550),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1550),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1550),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1550),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1550),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1552),
    [aux_sym_cast_type_token1] = ACTIONS(1550),
    [aux_sym_echo_statement_token1] = ACTIONS(1550),
    [anon_sym_unset] = ACTIONS(1550),
    [aux_sym_declare_statement_token1] = ACTIONS(1550),
    [sym_float] = ACTIONS(1550),
    [aux_sym_try_statement_token1] = ACTIONS(1550),
    [aux_sym_goto_statement_token1] = ACTIONS(1550),
    [aux_sym_continue_statement_token1] = ACTIONS(1550),
    [aux_sym_break_statement_token1] = ACTIONS(1550),
    [sym_integer] = ACTIONS(1550),
    [aux_sym_return_statement_token1] = ACTIONS(1550),
    [aux_sym_throw_expression_token1] = ACTIONS(1550),
    [aux_sym_while_statement_token1] = ACTIONS(1550),
    [aux_sym_do_statement_token1] = ACTIONS(1550),
    [aux_sym_for_statement_token1] = ACTIONS(1550),
    [aux_sym_foreach_statement_token1] = ACTIONS(1550),
    [aux_sym_if_statement_token1] = ACTIONS(1550),
    [aux_sym_match_expression_token1] = ACTIONS(1550),
    [aux_sym_switch_statement_token1] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1550),
    [anon_sym_TILDE] = ACTIONS(1552),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(1552),
    [aux_sym_clone_expression_token1] = ACTIONS(1550),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1550),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1550),
    [anon_sym_DASH_DASH] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1552),
    [aux_sym__list_destructing_token1] = ACTIONS(1550),
    [anon_sym_LBRACK] = ACTIONS(1552),
    [anon_sym_self] = ACTIONS(1550),
    [anon_sym_parent] = ACTIONS(1550),
    [aux_sym__argument_name_token1] = ACTIONS(1550),
    [aux_sym__argument_name_token2] = ACTIONS(1550),
    [anon_sym_POUND_LBRACK] = ACTIONS(1552),
    [aux_sym_encapsed_string_token1] = ACTIONS(1552),
    [anon_sym_DQUOTE] = ACTIONS(1552),
    [aux_sym_string_token1] = ACTIONS(1552),
    [anon_sym_SQUOTE] = ACTIONS(1552),
    [anon_sym_LT_LT_LT] = ACTIONS(1552),
    [anon_sym_BQUOTE] = ACTIONS(1552),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [aux_sym_yield_expression_token1] = ACTIONS(1550),
    [aux_sym_include_expression_token1] = ACTIONS(1550),
    [aux_sym_include_once_expression_token1] = ACTIONS(1550),
    [aux_sym_require_expression_token1] = ACTIONS(1550),
    [aux_sym_require_once_expression_token1] = ACTIONS(1550),
    [sym_comment] = ACTIONS(5),
  },
  [570] = {
    [sym_text_interpolation] = STATE(570),
    [sym_qualified_name] = STATE(702),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2660),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__primary_expression] = STATE(930),
    [sym_parenthesized_expression] = STATE(720),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_variable] = STATE(690),
    [sym_member_access_expression] = STATE(690),
    [sym_nullsafe_member_access_expression] = STATE(690),
    [sym_scoped_property_access_expression] = STATE(690),
    [sym_function_call_expression] = STATE(654),
    [sym_scoped_call_expression] = STATE(654),
    [sym__scope_resolution_qualifier] = STATE(2703),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(654),
    [sym_nullsafe_member_call_expression] = STATE(654),
    [sym_subscript_expression] = STATE(654),
    [sym__dereferencable_expression] = STATE(1741),
    [sym_array_creation_expression] = STATE(720),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(720),
    [sym_dynamic_variable_name] = STATE(654),
    [sym_variable_name] = STATE(654),
    [sym__reserved_identifier] = STATE(1593),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(1554),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(581),
    [aux_sym_print_intrinsic_token1] = ACTIONS(593),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(1558),
    [sym_comment] = ACTIONS(5),
  },
  [571] = {
    [sym_text_interpolation] = STATE(571),
    [sym_qualified_name] = STATE(702),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2491),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__primary_expression] = STATE(930),
    [sym_parenthesized_expression] = STATE(720),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_variable] = STATE(690),
    [sym_member_access_expression] = STATE(690),
    [sym_nullsafe_member_access_expression] = STATE(690),
    [sym_scoped_property_access_expression] = STATE(690),
    [sym_function_call_expression] = STATE(654),
    [sym_scoped_call_expression] = STATE(654),
    [sym__scope_resolution_qualifier] = STATE(2703),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(654),
    [sym_nullsafe_member_call_expression] = STATE(654),
    [sym_subscript_expression] = STATE(654),
    [sym__dereferencable_expression] = STATE(1741),
    [sym_array_creation_expression] = STATE(720),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(720),
    [sym_dynamic_variable_name] = STATE(654),
    [sym_variable_name] = STATE(654),
    [sym__reserved_identifier] = STATE(1593),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(1554),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(631),
    [aux_sym_print_intrinsic_token1] = ACTIONS(641),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(1558),
    [sym_comment] = ACTIONS(5),
  },
  [572] = {
    [sym_text_interpolation] = STATE(572),
    [sym_qualified_name] = STATE(702),
    [sym_namespace_name_as_prefix] = STATE(2691),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2563),
    [sym_arrow_function] = STATE(953),
    [sym_throw_expression] = STATE(953),
    [sym__primary_expression] = STATE(930),
    [sym_parenthesized_expression] = STATE(720),
    [sym_class_constant_access_expression] = STATE(771),
    [sym_print_intrinsic] = STATE(953),
    [sym_anonymous_function_creation_expression] = STATE(953),
    [sym_object_creation_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_cast_variable] = STATE(690),
    [sym_member_access_expression] = STATE(690),
    [sym_nullsafe_member_access_expression] = STATE(690),
    [sym_scoped_property_access_expression] = STATE(690),
    [sym_function_call_expression] = STATE(654),
    [sym_scoped_call_expression] = STATE(654),
    [sym__scope_resolution_qualifier] = STATE(2703),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(654),
    [sym_nullsafe_member_call_expression] = STATE(654),
    [sym_subscript_expression] = STATE(654),
    [sym__dereferencable_expression] = STATE(1741),
    [sym_array_creation_expression] = STATE(720),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1848),
    [sym_encapsed_string] = STATE(730),
    [sym_string] = STATE(730),
    [sym_heredoc] = STATE(730),
    [sym_nowdoc] = STATE(730),
    [sym_shell_command_expression] = STATE(953),
    [sym_boolean] = STATE(953),
    [sym_null] = STATE(953),
    [sym__string] = STATE(720),
    [sym_dynamic_variable_name] = STATE(654),
    [sym_variable_name] = STATE(654),
    [sym__reserved_identifier] = STATE(1593),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(1554),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(565),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(569),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [aux_sym_cast_type_token1] = ACTIONS(577),
    [sym_float] = ACTIONS(579),
    [sym_integer] = ACTIONS(579),
    [aux_sym_throw_expression_token1] = ACTIONS(673),
    [aux_sym_print_intrinsic_token1] = ACTIONS(683),
    [aux_sym_object_creation_expression_token1] = ACTIONS(595),
    [anon_sym_DASH_DASH] = ACTIONS(597),
    [anon_sym_PLUS_PLUS] = ACTIONS(597),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(601),
    [aux_sym__argument_name_token2] = ACTIONS(603),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(605),
    [aux_sym_string_token1] = ACTIONS(607),
    [anon_sym_SQUOTE] = ACTIONS(607),
    [anon_sym_LT_LT_LT] = ACTIONS(609),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(1558),
    [sym_comment] = ACTIONS(5),
  },
  [573] = {
    [sym_text_interpolation] = STATE(573),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2659),
    [sym_namespace_name] = STATE(2656),
    [sym_static_modifier] = STATE(2653),
    [sym__arrow_function_header] = STATE(2650),
    [sym_arrow_function] = STATE(1047),
    [sym_throw_expression] = STATE(1047),
    [sym__primary_expression] = STATE(1082),
    [sym_parenthesized_expression] = STATE(809),
    [sym_class_constant_access_expression] = STATE(903),
    [sym_print_intrinsic] = STATE(1047),
    [sym_anonymous_function_creation_expression] = STATE(1047),
    [sym_object_creation_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_cast_variable] = STATE(820),
    [sym_member_access_expression] = STATE(820),
    [sym_nullsafe_member_access_expression] = STATE(820),
    [sym_scoped_property_access_expression] = STATE(820),
    [sym_function_call_expression] = STATE(776),
    [sym_scoped_call_expression] = STATE(776),
    [sym__scope_resolution_qualifier] = STATE(2604),
    [sym_relative_scope] = STATE(2646),
    [sym_member_call_expression] = STATE(776),
    [sym_nullsafe_member_call_expression] = STATE(776),
    [sym_subscript_expression] = STATE(776),
    [sym__dereferencable_expression] = STATE(1770),
    [sym_array_creation_expression] = STATE(809),
    [sym_attribute_group] = STATE(1363),
    [sym_attribute_list] = STATE(1865),
    [sym_encapsed_string] = STATE(899),
    [sym_string] = STATE(899),
    [sym_heredoc] = STATE(899),
    [sym_nowdoc] = STATE(899),
    [sym_shell_command_expression] = STATE(1047),
    [sym_boolean] = STATE(1047),
    [sym_null] = STATE(1047),
    [sym__string] = STATE(809),
    [sym_dynamic_variable_name] = STATE(776),
    [sym_variable_name] = STATE(776),
    [sym__reserved_identifier] = STATE(1573),
    [aux_sym_attribute_list_repeat1] = STATE(1355),
    [sym_name] = ACTIONS(1560),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_function_static_declaration_token1] = ACTIONS(661),
    [aux_sym_namespace_definition_token1] = ACTIONS(567),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(663),
    [anon_sym_BSLASH] = ACTIONS(220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(244),
    [anon_sym_LPAREN] = ACTIONS(1562),
    [aux_sym_cast_type_token1] = ACTIONS(248),
    [sym_float] = ACTIONS(256),
    [sym_integer] = ACTIONS(256),
    [aux_sym_throw_expression_token1] = ACTIONS(268),
    [aux_sym_print_intrinsic_token1] = ACTIONS(292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(294),
    [anon_sym_DASH_DASH] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1492),
    [anon_sym_self] = ACTIONS(302),
    [anon_sym_parent] = ACTIONS(302),
    [aux_sym__argument_name_token1] = ACTIONS(304),
    [aux_sym__argument_name_token2] = ACTIONS(306),
    [anon_sym_POUND_LBRACK] = ACTIONS(308),
    [aux_sym_encapsed_string_token1] = ACTIONS(310),
    [anon_sym_DQUOTE] = ACTIONS(310),
    [aux_sym_string_token1] = ACTIONS(312),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_LT_LT_LT] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(1564),
    [sym_comment] = ACTIONS(5),
  },
  [574] = {
    [sym_text_interpolation] = STATE(574),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1568),
    [anon_sym_COMMA] = ACTIONS(1566),
    [anon_sym_EQ] = ACTIONS(1568),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(1566),
    [aux_sym_base_clause_token1] = ACTIONS(1566),
    [anon_sym_COLON] = ACTIONS(1568),
    [aux_sym_class_interface_clause_token1] = ACTIONS(1566),
    [anon_sym_EQ_GT] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(1566),
    [anon_sym_QMARK] = ACTIONS(1568),
    [anon_sym_PIPE] = ACTIONS(1568),
    [anon_sym_PLUS] = ACTIONS(1568),
    [anon_sym_DASH] = ACTIONS(1568),
    [anon_sym_COLON_COLON] = ACTIONS(1566),
    [anon_sym_DASH_DASH] = ACTIONS(1566),
    [anon_sym_PLUS_PLUS] = ACTIONS(1566),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1566),
    [anon_sym_STAR_EQ] = ACTIONS(1566),
    [anon_sym_SLASH_EQ] = ACTIONS(1566),
    [anon_sym_PERCENT_EQ] = ACTIONS(1566),
    [anon_sym_PLUS_EQ] = ACTIONS(1566),
    [anon_sym_DASH_EQ] = ACTIONS(1566),
    [anon_sym_DOT_EQ] = ACTIONS(1566),
    [anon_sym_LT_LT_EQ] = ACTIONS(1566),
    [anon_sym_GT_GT_EQ] = ACTIONS(1566),
    [anon_sym_AMP_EQ] = ACTIONS(1566),
    [anon_sym_CARET_EQ] = ACTIONS(1566),
    [anon_sym_PIPE_EQ] = ACTIONS(1566),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1566),
    [anon_sym_DASH_GT] = ACTIONS(1566),
    [anon_sym_QMARK_DASH_GT] = ACTIONS(1566),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_RBRACK] = ACTIONS(1566),
    [aux_sym_binary_expression_token1] = ACTIONS(1566),
    [anon_sym_QMARK_QMARK] = ACTIONS(1568),
    [anon_sym_STAR_STAR] = ACTIONS(1568),
    [aux_sym_binary_expression_token2] = ACTIONS(1566),
    [aux_sym_binary_expression_token3] = ACTIONS(1566),
    [aux_sym_binary_expression_token4] = ACTIONS(1566),
    [anon_sym_PIPE_PIPE] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1566),
    [anon_sym_CARET] = ACTIONS(1568),
    [anon_sym_EQ_EQ] = ACTIONS(1568),
    [anon_sym_BANG_EQ] = ACTIONS(1568),
    [anon_sym_LT_GT] = ACTIONS(1566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1566),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1566),
    [anon_sym_LT] = ACTIONS(1568),
    [anon_sym_GT] = ACTIONS(1568),
    [anon_sym_LT_EQ] = ACTIONS(1568),
    [anon_sym_GT_EQ] = ACTIONS(1566),
    [anon_sym_LT_EQ_GT] = ACTIONS(1566),
    [anon_sym_LT_LT] = ACTIONS(1568),
    [anon_sym_GT_GT] = ACTIONS(1568),
    [anon_sym_DOT] = ACTIONS(1568),
    [anon_sym_STAR] = ACTIONS(1568),
    [anon_sym_SLASH] = ACTIONS(1568),
    [anon_sym_PERCENT] = ACTIONS(1568),
    [sym_comment] = ACTIONS(1570),
  },
  [575] = {
    [sym_text_interpolation] = STATE(575),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1572),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_EQ] = ACTIONS(1574),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(1572),
    [anon_sym_LBRACE] = ACTIONS(1572),
    [anon_sym_RBRACE] = ACTIONS(1572),
    [aux_sym_base_clause_token1] = ACTIONS(1572),
    [anon_sym_COLON] = ACTIONS(1574),
    [aux_sym_class_interface_clause_token1] = ACTIONS(1572),
    [anon_sym_EQ_GT] = ACTIONS(1572),
    [anon_sym_LPAREN] = ACTIONS(1572),
    [anon_sym_RPAREN] = ACTIONS(1572),
    [anon_sym_QMARK] = ACTIONS(1574),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_COLON_COLON] = ACTIONS(1572),
    [anon_sym_DASH_DASH] = ACTIONS(1572),
    [anon_sym_PLUS_PLUS] = ACTIONS(1572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1572),
    [anon_sym_STAR_EQ] = ACTIONS(1572),
    [anon_sym_SLASH_EQ] = ACTIONS(1572),
    [anon_sym_PERCENT_EQ] = ACTIONS(1572),
    [anon_sym_PLUS_EQ] = ACTIONS(1572),
    [anon_sym_DASH_EQ] = ACTIONS(1572),
    [anon_sym_DOT_EQ] = ACTIONS(1572),
    [anon_sym_LT_LT_EQ] = ACTIONS(1572),
    [anon_sym_GT_GT_EQ] = ACTIONS(1572),
    [anon_sym_AMP_EQ] = ACTIONS(1572),
    [anon_sym_CARET_EQ] = ACTIONS(1572),
    [anon_sym_PIPE_EQ] = ACTIONS(1572),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1572),
    [anon_sym_DASH_GT] = ACTIONS(1572),
    [anon_sym_QMARK_DASH_GT] = ACTIONS(1572),
    [anon_sym_LBRACK] = ACTIONS(1572),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [aux_sym_binary_expression_token1] = ACTIONS(1572),
    [anon_sym_QMARK_QMARK] = ACTIONS(1574),
    [anon_sym_STAR_STAR] = ACTIONS(1574),
    [aux_sym_binary_expression_token2] = ACTIONS(1572),
    [aux_sym_binary_expression_token3] = ACTIONS(1572),
    [aux_sym_binary_expression_token4] = ACTIONS(1572),
    [anon_sym_PIPE_PIPE] = ACTIONS(1572),
    [anon_sym_AMP_AMP] = ACTIONS(1572),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_EQ_EQ] = ACTIONS(1574),
    [anon_sym_BANG_EQ] = ACTIONS(1574),
    [anon_sym_LT_GT] = ACTIONS(1572),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1572),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1572),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_LT_EQ] = ACTIONS(1574),
    [anon_sym_GT_EQ] = ACTIONS(1572),
    [anon_sym_LT_EQ_GT] = ACTIONS(1572),
    [anon_sym_LT_LT] = ACTIONS(1574),
    [anon_sym_GT_GT] = ACTIONS(1574),
    [anon_sym_DOT] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1574),
    [anon_sym_PERCENT] = ACTIONS(1574),
    [sym_comment] = ACTIONS(1570),
  },
  [576] = {
    [sym_text_interpolation] = STATE(576),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1578),
    [anon_sym_COMMA] = ACTIONS(1576),
    [anon_sym_EQ] = ACTIONS(1578),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(1576),
    [anon_sym_LBRACE] = ACTIONS(1576),
    [anon_sym_RBRACE] = ACTIONS(1576),
    [aux_sym_base_clause_token1] = ACTIONS(1576),
    [anon_sym_COLON] = ACTIONS(1578),
    [aux_sym_class_interface_clause_token1] = ACTIONS(1576),
    [anon_sym_EQ_GT] = ACTIONS(1576),
    [anon_sym_LPAREN] = ACTIONS(1576),
    [anon_sym_RPAREN] = ACTIONS(1576),
    [anon_sym_QMARK] = ACTIONS(1578),
    [anon_sym_PIPE] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1578),
    [anon_sym_DASH] = ACTIONS(1578),
    [anon_sym_COLON_COLON] = ACTIONS(1576),
    [anon_sym_DASH_DASH] = ACTIONS(1576),
    [anon_sym_PLUS_PLUS] = ACTIONS(1576),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1576),
    [anon_sym_STAR_EQ] = ACTIONS(1576),
    [anon_sym_SLASH_EQ] = ACTIONS(1576),
    [anon_sym_PERCENT_EQ] = ACTIONS(1576),
    [anon_sym_PLUS_EQ] = ACTIONS(1576),
    [anon_sym_DASH_EQ] = ACTIONS(1576),
    [anon_sym_DOT_EQ] = ACTIONS(1576),
    [anon_sym_LT_LT_EQ] = ACTIONS(1576),
    [anon_sym_GT_GT_EQ] = ACTIONS(1576),
    [anon_sym_AMP_EQ] = ACTIONS(1576),
    [anon_sym_CARET_EQ] = ACTIONS(1576),
    [anon_sym_PIPE_EQ] = ACTIONS(1576),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1576),
    [anon_sym_DASH_GT] = ACTIONS(1576),
    [anon_sym_QMARK_DASH_GT] = ACTIONS(1576),
    [anon_sym_LBRACK] = ACTIONS(1576),
    [anon_sym_RBRACK] = ACTIONS(1576),
    [aux_sym_binary_expression_token1] = ACTIONS(1576),
    [anon_sym_QMARK_QMARK] = ACTIONS(1578),
    [anon_sym_STAR_STAR] = ACTIONS(1578),
    [aux_sym_binary_expression_token2] = ACTIONS(1576),
    [aux_sym_binary_expression_token3] = ACTIONS(1576),
    [aux_sym_binary_expression_token4] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1576),
    [anon_sym_AMP_AMP] = ACTIONS(1576),
    [anon_sym_CARET] = ACTIONS(1578),
    [anon_sym_EQ_EQ] = ACTIONS(1578),
    [anon_sym_BANG_EQ] = ACTIONS(1578),
    [anon_sym_LT_GT] = ACTIONS(1576),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1576),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1576),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1578),
    [anon_sym_LT_EQ] = ACTIONS(1578),
    [anon_sym_GT_EQ] = ACTIONS(1576),
    [anon_sym_LT_EQ_GT] = ACTIONS(1576),
    [anon_sym_LT_LT] = ACTIONS(1578),
    [anon_sym_GT_GT] = ACTIONS(1578),
    [anon_sym_DOT] = ACTIONS(1578),
    [anon_sym_STAR] = ACTIONS(1578),
    [anon_sym_SLASH] = ACTIONS(1578),
    [anon_sym_PERCENT] = ACTIONS(1578),
    [sym_comment] = ACTIONS(1570),
  },
  [577] = {
    [sym_text_interpolation] = STATE(577),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1580),
    [anon_sym_AMP] = ACTIONS(1582),
    [anon_sym_COMMA] = ACTIONS(1580),
    [anon_sym_EQ] = ACTIONS(1582),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(1580),
    [anon_sym_LBRACE] = ACTIONS(1580),
    [anon_sym_RBRACE] = ACTIONS(1580),
    [aux_sym_base_clause_token1] = ACTIONS(1580),
    [anon_sym_COLON] = ACTIONS(1582),
    [aux_sym_class_interface_clause_token1] = ACTIONS(1580),
    [anon_sym_EQ_GT] = ACTIONS(1580),
    [anon_sym_LPAREN] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1580),
    [anon_sym_QMARK] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1582),
    [anon_sym_PLUS] = ACTIONS(1582),
    [anon_sym_DASH] = ACTIONS(1582),
    [anon_sym_COLON_COLON] = ACTIONS(1580),
    [anon_sym_DASH_DASH] = ACTIONS(1580),
    [anon_sym_PLUS_PLUS] = ACTIONS(1580),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1580),
    [anon_sym_STAR_EQ] = ACTIONS(1580),
    [anon_sym_SLASH_EQ] = ACTIONS(1580),
    [anon_sym_PERCENT_EQ] = ACTIONS(1580),
    [anon_sym_PLUS_EQ] = ACTIONS(1580),
    [anon_sym_DASH_EQ] = ACTIONS(1580),
    [anon_sym_DOT_EQ] = ACTIONS(1580),
    [anon_sym_LT_LT_EQ] = ACTIONS(1580),
    [anon_sym_GT_GT_EQ] = ACTIONS(1580),
    [anon_sym_AMP_EQ] = ACTIONS(1580),
    [anon_sym_CARET_EQ] = ACTIONS(1580),
    [anon_sym_PIPE_EQ] = ACTIONS(1580),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1580),
    [anon_sym_DASH_GT] = ACTIONS(1580),
    [anon_sym_QMARK_DASH_GT] = ACTIONS(1580),
    [anon_sym_LBRACK] = ACTIONS(1580),
    [anon_sym_RBRACK] = ACTIONS(1580),
    [aux_sym_binary_expression_token1] = ACTIONS(1580),
    [anon_sym_QMARK_QMARK] = ACTIONS(1582),
    [anon_sym_STAR_STAR] = ACTIONS(1582),
    [aux_sym_binary_expression_token2] = ACTIONS(1580),
    [aux_sym_binary_expression_token3] = ACTIONS(1580),
    [aux_sym_binary_expression_token4] = ACTIONS(1580),
    [anon_sym_PIPE_PIPE] = ACTIONS(1580),
    [anon_sym_AMP_AMP] = ACTIONS(1580),
    [anon_sym_CARET] = ACTIONS(1582),
    [anon_sym_EQ_EQ] = ACTIONS(1582),
    [anon_sym_BANG_EQ] = ACTIONS(1582),
    [anon_sym_LT_GT] = ACTIONS(1580),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1580),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1580),
    [anon_sym_LT] = ACTIONS(1582),
    [anon_sym_GT] = ACTIONS(1582),
    [anon_sym_LT_EQ] = ACTIONS(1582),
    [anon_sym_GT_EQ] = ACTIONS(1580),
    [anon_sym_LT_EQ_GT] = ACTIONS(1580),
    [anon_sym_LT_LT] = ACTIONS(1582),
    [anon_sym_GT_GT] = ACTIONS(1582),
    [anon_sym_DOT] = ACTIONS(1582),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(1582),
    [anon_sym_PERCENT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(1570),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(578), 1,
      sym_text_interpolation,
    STATE(587), 1,
      sym_arguments,
    ACTIONS(1586), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1584), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [79] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1594), 1,
      anon_sym_EQ,
    STATE(579), 1,
      sym_text_interpolation,
    STATE(596), 1,
      sym_arguments,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1600), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [166] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(580), 1,
      sym_text_interpolation,
    STATE(589), 1,
      sym_arguments,
    ACTIONS(1604), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1602), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [245] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(581), 1,
      sym_text_interpolation,
    STATE(586), 1,
      sym_arguments,
    ACTIONS(1608), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1606), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [324] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_text_interpolation,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1612), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1610), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [403] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(583), 1,
      sym_text_interpolation,
    STATE(585), 1,
      sym_arguments,
    ACTIONS(1616), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1614), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [482] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(584), 1,
      sym_text_interpolation,
    ACTIONS(1620), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1618), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [556] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(585), 1,
      sym_text_interpolation,
    ACTIONS(1624), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1622), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [630] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(586), 1,
      sym_text_interpolation,
    ACTIONS(1628), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1626), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [704] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(587), 1,
      sym_text_interpolation,
    ACTIONS(1632), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1630), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [778] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(588), 1,
      sym_text_interpolation,
    ACTIONS(1636), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1634), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [852] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(589), 1,
      sym_text_interpolation,
    ACTIONS(1640), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1638), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [926] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(590), 1,
      sym_text_interpolation,
    ACTIONS(1644), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1642), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1000] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(591), 1,
      sym_text_interpolation,
    ACTIONS(1648), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1646), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1074] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(592), 1,
      sym_text_interpolation,
    ACTIONS(1652), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1650), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1148] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(593), 1,
      sym_text_interpolation,
    ACTIONS(1656), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1654), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1222] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(594), 1,
      sym_text_interpolation,
    ACTIONS(1660), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1658), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1296] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(595), 1,
      sym_text_interpolation,
    ACTIONS(1664), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1662), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1370] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(596), 1,
      sym_text_interpolation,
    ACTIONS(1668), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1666), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1444] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(597), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 16,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1529] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1594), 1,
      anon_sym_EQ,
    STATE(598), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1600), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1610] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(599), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1694] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    STATE(600), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 16,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1773] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(601), 1,
      sym_text_interpolation,
    STATE(623), 1,
      sym_arguments,
    ACTIONS(1616), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1614), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1848] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1594), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(602), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1600), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_RBRACK,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1931] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(603), 1,
      sym_text_interpolation,
    STATE(2189), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2020] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(604), 1,
      sym_text_interpolation,
    STATE(624), 1,
      sym_arguments,
    ACTIONS(1586), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1584), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2095] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1594), 1,
      anon_sym_EQ,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(605), 1,
      sym_text_interpolation,
    STATE(613), 1,
      sym_arguments,
    ACTIONS(1682), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1600), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2178] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    ACTIONS(1684), 1,
      anon_sym_EQ,
    STATE(606), 1,
      sym_text_interpolation,
    STATE(613), 1,
      sym_arguments,
    ACTIONS(1682), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1686), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2261] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(607), 1,
      sym_text_interpolation,
    STATE(610), 1,
      sym_arguments,
    ACTIONS(1612), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1610), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2336] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(608), 1,
      sym_text_interpolation,
    STATE(621), 1,
      sym_arguments,
    ACTIONS(1604), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1602), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2411] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(609), 1,
      sym_text_interpolation,
    STATE(626), 1,
      sym_arguments,
    ACTIONS(1608), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1606), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2486] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(610), 1,
      sym_text_interpolation,
    ACTIONS(1636), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1634), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2556] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(611), 1,
      sym_text_interpolation,
    ACTIONS(1644), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1642), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2626] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(612), 1,
      sym_text_interpolation,
    ACTIONS(1648), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1646), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2696] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(613), 1,
      sym_text_interpolation,
    ACTIONS(1668), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1666), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2766] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(614), 1,
      sym_text_interpolation,
    ACTIONS(1620), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1618), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2836] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(615), 1,
      sym_text_interpolation,
    ACTIONS(1574), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1572), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2906] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(616), 1,
      sym_text_interpolation,
    ACTIONS(1652), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1650), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2976] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(617), 1,
      sym_text_interpolation,
    ACTIONS(1568), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1566), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3046] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(618), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1688), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3130] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(619), 1,
      sym_text_interpolation,
    ACTIONS(1664), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1662), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3200] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(620), 1,
      sym_text_interpolation,
    ACTIONS(1656), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1654), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3270] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(621), 1,
      sym_text_interpolation,
    ACTIONS(1640), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1638), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3340] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(622), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1690), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3424] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(623), 1,
      sym_text_interpolation,
    ACTIONS(1624), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1622), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3494] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(624), 1,
      sym_text_interpolation,
    ACTIONS(1632), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1630), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3564] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(625), 1,
      sym_text_interpolation,
    ACTIONS(1578), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1576), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3634] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(626), 1,
      sym_text_interpolation,
    ACTIONS(1628), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1626), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3704] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1693), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(627), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1695), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 14,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3786] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(628), 1,
      sym_text_interpolation,
    ACTIONS(1582), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1580), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3856] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(629), 1,
      sym_text_interpolation,
    ACTIONS(1660), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1658), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3926] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(630), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4004] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(631), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4088] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym_text_interpolation,
    STATE(2189), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4171] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1594), 1,
      anon_sym_EQ,
    STATE(633), 1,
      sym_text_interpolation,
    ACTIONS(1682), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1600), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4248] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1594), 1,
      anon_sym_EQ,
    STATE(634), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1600), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_RBRACK,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4325] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(596), 1,
      sym_arguments,
    STATE(635), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1699), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 11,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4408] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_EQ,
    STATE(636), 1,
      sym_text_interpolation,
    ACTIONS(1682), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1686), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4485] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    STATE(637), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4563] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1693), 1,
      anon_sym_EQ,
    STATE(638), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1695), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1590), 14,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4639] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(639), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1690), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4717] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_EQ,
    STATE(640), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1688), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1672), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4795] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(641), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1699), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1590), 11,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1676), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1592), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4872] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(642), 1,
      sym_text_interpolation,
    ACTIONS(1702), 22,
      anon_sym_AMP,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_COLON,
      aux_sym_class_interface_clause_token1,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_self,
      anon_sym_parent,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      sym_name,
    ACTIONS(1704), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4936] = 30,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(236), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(238), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1708), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(1710), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1714), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(1716), 1,
      sym_var_modifier,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    STATE(643), 1,
      sym_text_interpolation,
    STATE(1037), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1320), 1,
      sym__modifier,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1703), 1,
      sym_variable_name,
    STATE(1911), 1,
      sym__function_definition_header,
    STATE(1912), 1,
      sym_property_element,
    STATE(2051), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(1718), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1321), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5049] = 30,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(236), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(238), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1708), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(1710), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1714), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(1716), 1,
      sym_var_modifier,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    STATE(644), 1,
      sym_text_interpolation,
    STATE(1037), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1320), 1,
      sym__modifier,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1703), 1,
      sym_variable_name,
    STATE(1873), 1,
      sym_property_element,
    STATE(1876), 1,
      sym__function_definition_header,
    STATE(2154), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(1718), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1321), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5162] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(645), 1,
      sym_text_interpolation,
    STATE(660), 1,
      sym_arguments,
    ACTIONS(1604), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5227] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(596), 1,
      sym_arguments,
    STATE(646), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5298] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(647), 1,
      sym_text_interpolation,
    ACTIONS(1656), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_class_interface_clause_token1,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5359] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(648), 1,
      sym_text_interpolation,
    STATE(666), 1,
      sym_arguments,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5430] = 30,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1733), 1,
      anon_sym_COMMA,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1737), 1,
      anon_sym_RPAREN,
    ACTIONS(1739), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(649), 1,
      sym_text_interpolation,
    STATE(945), 1,
      sym_attribute_list,
    STATE(1146), 1,
      sym_visibility_modifier,
    STATE(1323), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1762), 1,
      sym__type,
    STATE(2064), 1,
      sym_reference_modifier,
    STATE(2067), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2065), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5541] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(596), 1,
      sym_arguments,
    STATE(650), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5612] = 30,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1739), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(1751), 1,
      anon_sym_COMMA,
    ACTIONS(1753), 1,
      anon_sym_RPAREN,
    STATE(651), 1,
      sym_text_interpolation,
    STATE(945), 1,
      sym_attribute_list,
    STATE(1146), 1,
      sym_visibility_modifier,
    STATE(1323), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1762), 1,
      sym__type,
    STATE(2064), 1,
      sym_reference_modifier,
    STATE(2067), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2016), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5723] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(652), 1,
      sym_text_interpolation,
    STATE(736), 1,
      sym_arguments,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5794] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(653), 1,
      sym_text_interpolation,
    STATE(666), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5861] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(654), 1,
      sym_text_interpolation,
    STATE(666), 1,
      sym_arguments,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5930] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(655), 1,
      sym_text_interpolation,
    STATE(672), 1,
      sym_arguments,
    ACTIONS(1612), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5995] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(656), 1,
      sym_text_interpolation,
    STATE(673), 1,
      sym_arguments,
    ACTIONS(1586), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6060] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(657), 1,
      sym_text_interpolation,
    STATE(683), 1,
      sym_arguments,
    ACTIONS(1608), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6125] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(658), 1,
      sym_text_interpolation,
    STATE(659), 1,
      sym_arguments,
    ACTIONS(1616), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6190] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(659), 1,
      sym_text_interpolation,
    ACTIONS(1624), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6250] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(660), 1,
      sym_text_interpolation,
    ACTIONS(1640), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6310] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(661), 1,
      sym_text_interpolation,
    ACTIONS(1620), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6370] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(662), 1,
      sym_text_interpolation,
    ACTIONS(1582), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1580), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6430] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(584), 1,
      sym_arguments,
    STATE(663), 1,
      sym_text_interpolation,
    ACTIONS(1763), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1761), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6494] = 29,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1739), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(1765), 1,
      anon_sym_RPAREN,
    STATE(664), 1,
      sym_text_interpolation,
    STATE(945), 1,
      sym_attribute_list,
    STATE(1146), 1,
      sym_visibility_modifier,
    STATE(1323), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1762), 1,
      sym__type,
    STATE(2064), 1,
      sym_reference_modifier,
    STATE(2067), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2269), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [6602] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(665), 1,
      sym_text_interpolation,
    ACTIONS(1664), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1662), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6662] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(666), 1,
      sym_text_interpolation,
    ACTIONS(1668), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6722] = 29,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1739), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(1767), 1,
      anon_sym_RPAREN,
    STATE(667), 1,
      sym_text_interpolation,
    STATE(945), 1,
      sym_attribute_list,
    STATE(1146), 1,
      sym_visibility_modifier,
    STATE(1323), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1762), 1,
      sym__type,
    STATE(2064), 1,
      sym_reference_modifier,
    STATE(2067), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2269), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [6830] = 30,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1769), 1,
      sym_name,
    ACTIONS(1773), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    STATE(668), 1,
      sym_text_interpolation,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1720), 1,
      sym__dereferencable_expression,
    STATE(2535), 1,
      sym__scope_resolution_qualifier,
    STATE(2562), 1,
      sym_attribute_list,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(830), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1743), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(1771), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(851), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(853), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1579), 7,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [6940] = 30,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      sym_name,
    ACTIONS(1781), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    STATE(669), 1,
      sym_text_interpolation,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1738), 1,
      sym__dereferencable_expression,
    STATE(2601), 1,
      sym_attribute_list,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(2696), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(710), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1743), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(689), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(693), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1579), 7,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [7050] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(670), 1,
      sym_text_interpolation,
    ACTIONS(1568), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1566), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7110] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(671), 1,
      sym_text_interpolation,
    ACTIONS(1652), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7170] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(672), 1,
      sym_text_interpolation,
    ACTIONS(1636), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7230] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(673), 1,
      sym_text_interpolation,
    ACTIONS(1632), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7290] = 29,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1739), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(1785), 1,
      anon_sym_RPAREN,
    STATE(674), 1,
      sym_text_interpolation,
    STATE(945), 1,
      sym_attribute_list,
    STATE(1146), 1,
      sym_visibility_modifier,
    STATE(1323), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1762), 1,
      sym__type,
    STATE(2064), 1,
      sym_reference_modifier,
    STATE(2067), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2269), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [7398] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(675), 1,
      sym_text_interpolation,
    ACTIONS(1648), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7458] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(676), 1,
      sym_text_interpolation,
    ACTIONS(1578), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1576), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7518] = 29,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1739), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(1787), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym_text_interpolation,
    STATE(945), 1,
      sym_attribute_list,
    STATE(1146), 1,
      sym_visibility_modifier,
    STATE(1323), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1762), 1,
      sym__type,
    STATE(2064), 1,
      sym_reference_modifier,
    STATE(2067), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2269), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [7626] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(678), 1,
      sym_text_interpolation,
    ACTIONS(1574), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7686] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(679), 1,
      sym_text_interpolation,
    ACTIONS(1644), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7746] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(680), 1,
      sym_text_interpolation,
    ACTIONS(1660), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1658), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7806] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(681), 1,
      sym_text_interpolation,
    ACTIONS(1656), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7866] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(585), 1,
      sym_arguments,
    STATE(682), 1,
      sym_text_interpolation,
    ACTIONS(1791), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1789), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7930] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(683), 1,
      sym_text_interpolation,
    ACTIONS(1628), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7990] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(684), 1,
      sym_text_interpolation,
    STATE(748), 1,
      sym_arguments,
    ACTIONS(1608), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8053] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(659), 1,
      sym_arguments,
    STATE(685), 1,
      sym_text_interpolation,
    ACTIONS(1791), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1789), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8116] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(686), 1,
      sym_text_interpolation,
    STATE(754), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8181] = 29,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(298), 1,
      aux_sym__list_destructing_token1,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(743), 1,
      anon_sym_AMP,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(687), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2110), 1,
      sym_by_ref,
    STATE(2111), 1,
      sym__list_destructing,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1544), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1470), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [8288] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(688), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8353] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1795), 1,
      anon_sym_LPAREN,
    STATE(689), 1,
      sym_text_interpolation,
    STATE(927), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8418] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(690), 1,
      sym_text_interpolation,
    ACTIONS(1598), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8481] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(589), 1,
      sym_arguments,
    STATE(691), 1,
      sym_text_interpolation,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8542] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(692), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8603] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(693), 1,
      sym_text_interpolation,
    STATE(736), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8668] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(694), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8733] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(695), 1,
      sym_text_interpolation,
    STATE(754), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1799), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1797), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8798] = 27,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 1,
      sym_name,
    ACTIONS(1803), 1,
      anon_sym_RBRACE,
    STATE(696), 1,
      sym_text_interpolation,
    STATE(697), 1,
      aux_sym_use_list_repeat1,
    STATE(1598), 1,
      sym_class_constant_access_expression,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2335), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1743), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1579), 10,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [8901] = 27,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 1,
      sym_name,
    ACTIONS(1805), 1,
      anon_sym_RBRACE,
    STATE(697), 1,
      sym_text_interpolation,
    STATE(707), 1,
      aux_sym_use_list_repeat1,
    STATE(1598), 1,
      sym_class_constant_access_expression,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2335), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1743), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1579), 10,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [9004] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(698), 1,
      sym_text_interpolation,
    STATE(754), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1809), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1807), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9069] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(699), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9134] = 29,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(298), 1,
      aux_sym__list_destructing_token1,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(743), 1,
      anon_sym_AMP,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(700), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2262), 1,
      sym_by_ref,
    STATE(2324), 1,
      sym__list_destructing,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1596), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1537), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [9241] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(585), 1,
      sym_arguments,
    STATE(701), 1,
      sym_text_interpolation,
    ACTIONS(1616), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9304] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(666), 1,
      sym_arguments,
    STATE(702), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9369] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym_EQ,
    STATE(703), 1,
      sym_text_interpolation,
    ACTIONS(1815), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1813), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1811), 30,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9432] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(589), 1,
      sym_arguments,
    STATE(704), 1,
      sym_text_interpolation,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9495] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1739), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(705), 1,
      sym_text_interpolation,
    STATE(945), 1,
      sym_attribute_list,
    STATE(1146), 1,
      sym_visibility_modifier,
    STATE(1323), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1762), 1,
      sym__type,
    STATE(2064), 1,
      sym_reference_modifier,
    STATE(2067), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2269), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [9600] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    STATE(706), 1,
      sym_text_interpolation,
    ACTIONS(1608), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9663] = 26,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1820), 1,
      sym_name,
    ACTIONS(1826), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1829), 1,
      anon_sym_BSLASH,
    ACTIONS(1832), 1,
      anon_sym_RBRACE,
    ACTIONS(1834), 1,
      anon_sym_LPAREN,
    ACTIONS(1837), 1,
      aux_sym_cast_type_token1,
    ACTIONS(1840), 1,
      anon_sym_LBRACK,
    ACTIONS(1849), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1852), 1,
      anon_sym_DOLLAR,
    STATE(1598), 1,
      sym_class_constant_access_expression,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(1843), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1846), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(707), 2,
      sym_text_interpolation,
      aux_sym_use_list_repeat1,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2335), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(1823), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1743), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1579), 10,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [9764] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(708), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9829] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(587), 1,
      sym_arguments,
    STATE(709), 1,
      sym_text_interpolation,
    ACTIONS(1586), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9892] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(710), 1,
      sym_text_interpolation,
    STATE(736), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9957] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(586), 1,
      sym_arguments,
    STATE(711), 1,
      sym_text_interpolation,
    ACTIONS(1608), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10018] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(661), 1,
      sym_arguments,
    STATE(712), 1,
      sym_text_interpolation,
    ACTIONS(1763), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1761), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10081] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(713), 1,
      sym_text_interpolation,
    STATE(755), 1,
      sym_arguments,
    ACTIONS(1612), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10144] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_arguments,
    STATE(714), 1,
      sym_text_interpolation,
    ACTIONS(1612), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10207] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(715), 1,
      sym_text_interpolation,
    STATE(762), 1,
      sym_arguments,
    ACTIONS(1586), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10270] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(716), 1,
      sym_text_interpolation,
    STATE(742), 1,
      sym_arguments,
    ACTIONS(1616), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10333] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(717), 1,
      sym_text_interpolation,
    STATE(747), 1,
      sym_arguments,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10396] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(585), 1,
      sym_arguments,
    STATE(718), 1,
      sym_text_interpolation,
    ACTIONS(1616), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10457] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(588), 1,
      sym_arguments,
    STATE(719), 1,
      sym_text_interpolation,
    ACTIONS(1612), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10518] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(666), 1,
      sym_arguments,
    STATE(720), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10583] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(587), 1,
      sym_arguments,
    STATE(721), 1,
      sym_text_interpolation,
    ACTIONS(1586), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10644] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(722), 1,
      sym_text_interpolation,
    ACTIONS(1568), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1566), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10702] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(723), 1,
      sym_text_interpolation,
    ACTIONS(1857), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1855), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10760] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(724), 1,
      sym_text_interpolation,
    ACTIONS(1861), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1859), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10818] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(725), 1,
      sym_text_interpolation,
    ACTIONS(1865), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1863), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10876] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(726), 1,
      sym_text_interpolation,
    ACTIONS(1869), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1867), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10934] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(727), 1,
      sym_text_interpolation,
    ACTIONS(1620), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10992] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(728), 1,
      sym_text_interpolation,
    ACTIONS(1873), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1871), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11050] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(743), 1,
      anon_sym_AMP,
    ACTIONS(853), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(729), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2422), 1,
      sym__array_destructing,
    STATE(2423), 1,
      sym_by_ref,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1589), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1492), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [11154] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(730), 1,
      sym_text_interpolation,
    ACTIONS(1877), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1875), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11212] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(731), 1,
      sym_text_interpolation,
    ACTIONS(1881), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1879), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11270] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(732), 1,
      sym_text_interpolation,
    ACTIONS(1648), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11328] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(733), 1,
      sym_text_interpolation,
    ACTIONS(1885), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1883), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11386] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(734), 1,
      sym_text_interpolation,
    ACTIONS(1889), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1887), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11444] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(735), 1,
      sym_text_interpolation,
    ACTIONS(1893), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1891), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11502] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(736), 1,
      sym_text_interpolation,
    ACTIONS(1666), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1897), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1895), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11562] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    STATE(737), 1,
      sym_text_interpolation,
    ACTIONS(1656), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11622] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(738), 1,
      sym_text_interpolation,
    ACTIONS(1813), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1811), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11680] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(739), 1,
      sym_text_interpolation,
    ACTIONS(1664), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1662), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11738] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(740), 1,
      sym_text_interpolation,
    ACTIONS(1903), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1901), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11796] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(741), 1,
      sym_text_interpolation,
    ACTIONS(1550), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1552), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11854] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(742), 1,
      sym_text_interpolation,
    ACTIONS(1624), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11912] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(743), 1,
      sym_text_interpolation,
    ACTIONS(1652), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11970] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(744), 1,
      sym_text_interpolation,
    ACTIONS(1907), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1905), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12028] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(745), 1,
      sym_text_interpolation,
    ACTIONS(1660), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1658), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12086] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(746), 1,
      sym_text_interpolation,
    ACTIONS(1911), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1909), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12144] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(747), 1,
      sym_text_interpolation,
    ACTIONS(1640), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12202] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(748), 1,
      sym_text_interpolation,
    ACTIONS(1628), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12260] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(749), 1,
      sym_text_interpolation,
    ACTIONS(1578), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1576), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12318] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(750), 1,
      sym_text_interpolation,
    ACTIONS(1644), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12376] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(751), 1,
      sym_text_interpolation,
    ACTIONS(1582), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1580), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12434] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(752), 1,
      sym_text_interpolation,
    ACTIONS(1915), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1913), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12492] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(753), 1,
      sym_text_interpolation,
    ACTIONS(1919), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1917), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12550] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(754), 1,
      sym_text_interpolation,
    ACTIONS(1668), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12608] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(755), 1,
      sym_text_interpolation,
    ACTIONS(1636), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12666] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(756), 1,
      sym_text_interpolation,
    ACTIONS(1923), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1921), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12724] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(757), 1,
      sym_text_interpolation,
    ACTIONS(1927), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1925), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12782] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(758), 1,
      sym_text_interpolation,
    ACTIONS(1931), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1929), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12840] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(759), 1,
      sym_text_interpolation,
    ACTIONS(1935), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1933), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12898] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(760), 1,
      sym_text_interpolation,
    ACTIONS(1939), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1937), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12956] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(761), 1,
      sym_text_interpolation,
    ACTIONS(1574), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13014] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(762), 1,
      sym_text_interpolation,
    ACTIONS(1632), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13072] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(763), 1,
      sym_text_interpolation,
    ACTIONS(1943), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1941), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13130] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(764), 1,
      sym_text_interpolation,
    STATE(801), 1,
      sym_arguments,
    ACTIONS(1586), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13191] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(765), 1,
      sym_text_interpolation,
    STATE(789), 1,
      sym_arguments,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13252] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(766), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1809), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1807), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13311] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(767), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13370] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(768), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1799), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1797), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13429] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(769), 1,
      sym_text_interpolation,
    STATE(802), 1,
      sym_arguments,
    ACTIONS(1612), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13490] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(770), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13549] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(771), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13608] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(772), 1,
      sym_text_interpolation,
    STATE(797), 1,
      sym_arguments,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13675] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(773), 1,
      sym_text_interpolation,
    STATE(788), 1,
      sym_arguments,
    ACTIONS(1608), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13736] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(774), 1,
      sym_text_interpolation,
    ACTIONS(1949), 18,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LBRACK,
      anon_sym_POUND_LBRACK,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
      anon_sym_LT_LT_LT,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(1947), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym__arrow_function_header_token1,
      aux_sym_cast_type_token1,
      sym_float,
      sym_integer,
      aux_sym_throw_expression_token1,
      aux_sym_match_expression_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_clone_expression_token1,
      aux_sym_print_intrinsic_token1,
      aux_sym_object_creation_expression_token1,
      aux_sym__list_destructing_token1,
      anon_sym_self,
      anon_sym_parent,
      aux_sym__argument_name_token1,
      aux_sym__argument_name_token2,
      aux_sym_yield_expression_token1,
      aux_sym_include_expression_token1,
      aux_sym_include_once_expression_token1,
      aux_sym_require_expression_token1,
      aux_sym_require_once_expression_token1,
      sym_name,
  [13793] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(775), 1,
      sym_text_interpolation,
    ACTIONS(1017), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1015), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13850] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(776), 1,
      sym_text_interpolation,
    STATE(797), 1,
      sym_arguments,
    ACTIONS(1682), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13915] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(613), 1,
      sym_arguments,
    STATE(777), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13982] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(778), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_arguments,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14049] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(779), 1,
      sym_text_interpolation,
    STATE(803), 1,
      sym_arguments,
    ACTIONS(1616), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14110] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(780), 1,
      sym_text_interpolation,
    ACTIONS(1029), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1027), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14167] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(781), 1,
      sym_text_interpolation,
    STATE(797), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14230] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(596), 1,
      sym_arguments,
    STATE(782), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14297] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1815), 1,
      anon_sym_RPAREN,
    ACTIONS(1818), 1,
      anon_sym_EQ,
    STATE(783), 1,
      sym_text_interpolation,
    ACTIONS(1813), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1811), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14358] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(784), 1,
      sym_text_interpolation,
    ACTIONS(1582), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1580), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14414] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(785), 1,
      sym_text_interpolation,
    ACTIONS(1664), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1662), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14470] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(786), 1,
      sym_text_interpolation,
    ACTIONS(1620), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14526] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(787), 1,
      sym_text_interpolation,
    ACTIONS(1660), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1658), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14582] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(788), 1,
      sym_text_interpolation,
    ACTIONS(1628), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14638] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(789), 1,
      sym_text_interpolation,
    ACTIONS(1640), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14694] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(790), 1,
      sym_text_interpolation,
    ACTIONS(1568), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1566), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14750] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(791), 1,
      sym_text_interpolation,
    ACTIONS(1574), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14806] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(792), 1,
      sym_text_interpolation,
    ACTIONS(1656), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14862] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(793), 1,
      sym_text_interpolation,
    ACTIONS(1955), 17,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LBRACK,
      anon_sym_POUND_LBRACK,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
      anon_sym_LT_LT_LT,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(1953), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym__arrow_function_header_token1,
      aux_sym_cast_type_token1,
      sym_float,
      sym_integer,
      aux_sym_throw_expression_token1,
      aux_sym_match_expression_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_clone_expression_token1,
      aux_sym_print_intrinsic_token1,
      aux_sym_object_creation_expression_token1,
      aux_sym__list_destructing_token1,
      anon_sym_self,
      anon_sym_parent,
      aux_sym__argument_name_token1,
      aux_sym__argument_name_token2,
      aux_sym_yield_expression_token1,
      aux_sym_include_expression_token1,
      aux_sym_include_once_expression_token1,
      aux_sym_require_expression_token1,
      aux_sym_require_once_expression_token1,
      sym_name,
  [14918] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(794), 1,
      sym_text_interpolation,
    ACTIONS(1578), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1576), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14974] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1957), 1,
      anon_sym_COLON,
    STATE(596), 1,
      sym_arguments,
    STATE(795), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15042] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1959), 1,
      anon_sym_COLON,
    STATE(613), 1,
      sym_arguments,
    STATE(796), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 21,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15110] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(797), 1,
      sym_text_interpolation,
    ACTIONS(1668), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15166] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    STATE(613), 1,
      sym_arguments,
    STATE(798), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 21,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15234] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(799), 1,
      sym_text_interpolation,
    ACTIONS(1652), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15290] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(800), 1,
      sym_text_interpolation,
    ACTIONS(1648), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15346] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(801), 1,
      sym_text_interpolation,
    ACTIONS(1632), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15402] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(802), 1,
      sym_text_interpolation,
    ACTIONS(1636), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15458] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(803), 1,
      sym_text_interpolation,
    ACTIONS(1624), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15514] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(804), 1,
      sym_text_interpolation,
    ACTIONS(1644), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15570] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(613), 1,
      sym_arguments,
    STATE(805), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15631] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(1963), 1,
      sym_name,
    STATE(806), 1,
      sym_text_interpolation,
    STATE(1723), 1,
      sym__dereferencable_expression,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2651), 1,
      sym__scope_resolution_qualifier,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(826), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1743), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(1771), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(825), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(902), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1579), 7,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [15726] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(587), 1,
      sym_arguments,
    STATE(807), 1,
      sym_text_interpolation,
    ACTIONS(1586), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15785] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(623), 1,
      sym_arguments,
    STATE(808), 1,
      sym_text_interpolation,
    ACTIONS(1791), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1789), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15844] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(797), 1,
      sym_arguments,
    STATE(809), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15905] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(797), 1,
      sym_arguments,
    STATE(810), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15966] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1556), 1,
      anon_sym_LPAREN,
    ACTIONS(1558), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1965), 1,
      sym_name,
    STATE(811), 1,
      sym_text_interpolation,
    STATE(1741), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(2703), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1593), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1592), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(692), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(653), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [16061] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_arguments,
    STATE(812), 1,
      sym_text_interpolation,
    ACTIONS(1612), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16120] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(589), 1,
      sym_arguments,
    STATE(813), 1,
      sym_text_interpolation,
    ACTIONS(1604), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16179] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(814), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1555), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1460), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [16274] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(815), 1,
      sym_text_interpolation,
    ACTIONS(1656), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16329] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym_arguments,
    STATE(816), 1,
      sym_text_interpolation,
    ACTIONS(1608), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16388] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(817), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16445] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(1967), 1,
      sym_name,
    ACTIONS(1969), 1,
      anon_sym_LPAREN,
    STATE(818), 1,
      sym_text_interpolation,
    STATE(1735), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2662), 1,
      sym__scope_resolution_qualifier,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1565), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1570), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(768), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(695), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [16540] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(1967), 1,
      sym_name,
    ACTIONS(1969), 1,
      anon_sym_LPAREN,
    STATE(819), 1,
      sym_text_interpolation,
    STATE(1735), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2662), 1,
      sym__scope_resolution_qualifier,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1565), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1570), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(767), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(686), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [16635] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(820), 1,
      sym_text_interpolation,
    ACTIONS(1682), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16694] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(821), 1,
      sym_text_interpolation,
    STATE(878), 1,
      sym_arguments,
    ACTIONS(1608), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16753] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(822), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_arguments,
    ACTIONS(1604), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16812] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(823), 1,
      sym_text_interpolation,
    ACTIONS(1048), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1046), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16867] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(803), 1,
      sym_arguments,
    STATE(824), 1,
      sym_text_interpolation,
    ACTIONS(1791), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1789), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16926] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(825), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16987] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(826), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17048] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(827), 1,
      sym_text_interpolation,
    ACTIONS(1052), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1050), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17103] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(828), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(692), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1462), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [17198] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(829), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1542), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1465), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [17293] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(830), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17354] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(589), 1,
      sym_arguments,
    STATE(831), 1,
      sym_text_interpolation,
    ACTIONS(1604), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17411] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(1971), 1,
      sym_name,
    ACTIONS(1973), 1,
      anon_sym_LPAREN,
    STATE(832), 1,
      sym_text_interpolation,
    STATE(1696), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2641), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1575), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1587), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(905), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(856), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [17506] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(1971), 1,
      sym_name,
    ACTIONS(1973), 1,
      anon_sym_LPAREN,
    STATE(833), 1,
      sym_text_interpolation,
    STATE(1696), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2641), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1575), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1587), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(901), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(849), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [17601] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(834), 1,
      sym_text_interpolation,
    ACTIONS(1702), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1704), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17656] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(786), 1,
      sym_arguments,
    STATE(835), 1,
      sym_text_interpolation,
    ACTIONS(1763), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1761), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17715] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(614), 1,
      sym_arguments,
    STATE(836), 1,
      sym_text_interpolation,
    ACTIONS(1763), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1761), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17774] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(613), 1,
      sym_arguments,
    STATE(837), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17835] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(587), 1,
      sym_arguments,
    STATE(838), 1,
      sym_text_interpolation,
    ACTIONS(1586), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17892] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym_EQ,
    STATE(839), 1,
      sym_text_interpolation,
    ACTIONS(1813), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1811), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17949] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(585), 1,
      sym_arguments,
    STATE(840), 1,
      sym_text_interpolation,
    ACTIONS(1616), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18006] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(841), 1,
      sym_text_interpolation,
    STATE(889), 1,
      sym_arguments,
    ACTIONS(1612), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18065] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(842), 1,
      sym_text_interpolation,
    STATE(890), 1,
      sym_arguments,
    ACTIONS(1586), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1584), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18124] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1564), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1975), 1,
      sym_name,
    ACTIONS(1977), 1,
      anon_sym_LPAREN,
    STATE(843), 1,
      sym_text_interpolation,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(1770), 1,
      sym__dereferencable_expression,
    STATE(2629), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1573), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1569), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(817), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(781), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18219] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(1979), 1,
      sym_name,
    STATE(844), 1,
      sym_text_interpolation,
    STATE(1729), 1,
      sym__dereferencable_expression,
    STATE(2640), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(708), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1743), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(699), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(770), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1579), 7,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [18314] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(845), 1,
      sym_text_interpolation,
    STATE(894), 1,
      sym_arguments,
    ACTIONS(1616), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18373] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(586), 1,
      sym_arguments,
    STATE(846), 1,
      sym_text_interpolation,
    ACTIONS(1608), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18430] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(1971), 1,
      sym_name,
    STATE(847), 1,
      sym_text_interpolation,
    STATE(1696), 1,
      sym__dereferencable_expression,
    STATE(2493), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(904), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1575), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1587), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(1743), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(850), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18525] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(848), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(766), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(1743), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1471), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18620] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(849), 1,
      sym_text_interpolation,
    STATE(865), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1799), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1797), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18681] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(850), 1,
      sym_text_interpolation,
    STATE(865), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1809), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1807), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18742] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(851), 1,
      sym_text_interpolation,
    STATE(875), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18803] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(585), 1,
      sym_arguments,
    STATE(852), 1,
      sym_text_interpolation,
    ACTIONS(1616), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18862] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1981), 1,
      anon_sym_LPAREN,
    STATE(853), 1,
      sym_text_interpolation,
    STATE(1136), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1757), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1755), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18923] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1793), 1,
      sym_name,
    STATE(854), 1,
      sym_text_interpolation,
    STATE(1730), 1,
      sym__dereferencable_expression,
    STATE(1743), 1,
      sym_class_constant_access_expression,
    STATE(2630), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1591), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1579), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(1560), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1521), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19018] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(577), 1,
      aux_sym_cast_type_token1,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1282), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(1967), 1,
      sym_name,
    STATE(855), 1,
      sym_text_interpolation,
    STATE(1735), 1,
      sym__dereferencable_expression,
    STATE(2565), 1,
      sym__scope_resolution_qualifier,
    STATE(2646), 1,
      sym_relative_scope,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(766), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1565), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1570), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(1743), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
    STATE(698), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19113] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(856), 1,
      sym_text_interpolation,
    STATE(865), 1,
      sym_arguments,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19174] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(588), 1,
      sym_arguments,
    STATE(857), 1,
      sym_text_interpolation,
    ACTIONS(1612), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19231] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(858), 1,
      sym_text_interpolation,
    ACTIONS(1873), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1871), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19285] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(859), 1,
      sym_text_interpolation,
    ACTIONS(1582), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1580), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19339] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(860), 1,
      sym_text_interpolation,
    ACTIONS(1889), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1887), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19393] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(861), 1,
      sym_text_interpolation,
    ACTIONS(1907), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1905), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19447] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym_EQ,
    STATE(862), 1,
      sym_text_interpolation,
    ACTIONS(1813), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1811), 28,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19503] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(863), 1,
      sym_text_interpolation,
    ACTIONS(1857), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1855), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19557] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(864), 1,
      sym_text_interpolation,
    ACTIONS(1652), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19611] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(865), 1,
      sym_text_interpolation,
    ACTIONS(1668), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19665] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(866), 1,
      sym_text_interpolation,
    ACTIONS(1885), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1883), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19719] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(867), 1,
      sym_text_interpolation,
    ACTIONS(1574), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19773] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(868), 1,
      sym_text_interpolation,
    ACTIONS(1640), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19827] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(869), 1,
      sym_text_interpolation,
    ACTIONS(1865), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1863), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19881] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(870), 1,
      sym_text_interpolation,
    ACTIONS(1620), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19935] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(871), 1,
      sym_text_interpolation,
    ACTIONS(1578), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1576), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19989] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1818), 1,
      anon_sym_EQ,
    STATE(872), 1,
      sym_text_interpolation,
    ACTIONS(1983), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1813), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1811), 26,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20047] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(873), 1,
      sym_text_interpolation,
    ACTIONS(1931), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1929), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20101] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(874), 1,
      sym_text_interpolation,
    ACTIONS(1935), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1933), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20155] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(875), 1,
      sym_text_interpolation,
    ACTIONS(1666), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1897), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1895), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20211] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(876), 1,
      sym_text_interpolation,
    ACTIONS(1943), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1941), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20265] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(877), 1,
      sym_text_interpolation,
    ACTIONS(1915), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1913), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20319] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(878), 1,
      sym_text_interpolation,
    ACTIONS(1628), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20373] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(879), 1,
      sym_text_interpolation,
    ACTIONS(1893), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1891), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20427] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(880), 1,
      sym_text_interpolation,
    ACTIONS(1861), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1859), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20481] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    STATE(881), 1,
      sym_text_interpolation,
    ACTIONS(1656), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20537] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(882), 1,
      sym_text_interpolation,
    ACTIONS(1660), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1658), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20591] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(883), 1,
      sym_text_interpolation,
    ACTIONS(1881), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1879), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20645] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(884), 1,
      sym_text_interpolation,
    ACTIONS(1644), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20699] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(885), 1,
      sym_text_interpolation,
    ACTIONS(1927), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1925), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20753] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(886), 1,
      sym_text_interpolation,
    ACTIONS(1813), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1811), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20807] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(887), 1,
      sym_text_interpolation,
    ACTIONS(1919), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1917), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20861] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(888), 1,
      sym_text_interpolation,
    ACTIONS(1903), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1901), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20915] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(889), 1,
      sym_text_interpolation,
    ACTIONS(1636), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20969] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(890), 1,
      sym_text_interpolation,
    ACTIONS(1632), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21023] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(891), 1,
      sym_text_interpolation,
    ACTIONS(1550), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1552), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21077] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(892), 1,
      sym_text_interpolation,
    ACTIONS(1648), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21131] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(893), 1,
      sym_text_interpolation,
    ACTIONS(1869), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1867), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21185] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(894), 1,
      sym_text_interpolation,
    ACTIONS(1624), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21239] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(895), 1,
      sym_text_interpolation,
    ACTIONS(1923), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1921), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21293] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(896), 1,
      sym_text_interpolation,
    ACTIONS(1911), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1909), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21347] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(897), 1,
      sym_text_interpolation,
    ACTIONS(1568), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1566), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21401] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(898), 1,
      sym_text_interpolation,
    ACTIONS(1939), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1937), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21455] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(899), 1,
      sym_text_interpolation,
    ACTIONS(1877), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1875), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21509] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(900), 1,
      sym_text_interpolation,
    ACTIONS(1664), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1662), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21563] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(901), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1799), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1797), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21618] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(902), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1749), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21673] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(903), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21728] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(904), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1809), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1807), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21783] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(905), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1594), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1600), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21838] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(906), 1,
      sym_text_interpolation,
    ACTIONS(1987), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1985), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21890] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(907), 1,
      sym_text_interpolation,
    ACTIONS(1991), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1989), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21942] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(908), 1,
      sym_text_interpolation,
    ACTIONS(1574), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21994] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(909), 1,
      sym_text_interpolation,
    ACTIONS(1995), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1993), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22046] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(910), 1,
      sym_text_interpolation,
    ACTIONS(1999), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1997), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22098] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(911), 1,
      sym_text_interpolation,
    ACTIONS(2003), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2001), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22150] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(912), 1,
      sym_text_interpolation,
    ACTIONS(2007), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2005), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22202] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(913), 1,
      sym_text_interpolation,
    ACTIONS(2011), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2009), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22254] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(914), 1,
      sym_text_interpolation,
    ACTIONS(2015), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2013), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22306] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(915), 1,
      sym_text_interpolation,
    ACTIONS(2019), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2017), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22358] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(916), 1,
      sym_text_interpolation,
    ACTIONS(2023), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2021), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22410] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(917), 1,
      sym_text_interpolation,
    ACTIONS(2027), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22462] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(918), 1,
      sym_text_interpolation,
    ACTIONS(2031), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2029), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22514] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(919), 1,
      sym_text_interpolation,
    ACTIONS(2035), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2033), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22566] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(920), 1,
      sym_text_interpolation,
    ACTIONS(2039), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2037), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22618] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(921), 1,
      sym_text_interpolation,
    ACTIONS(2043), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2041), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22670] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(922), 1,
      sym_text_interpolation,
    ACTIONS(1568), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1566), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22722] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(923), 1,
      sym_text_interpolation,
    ACTIONS(2047), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2045), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22774] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(924), 1,
      sym_text_interpolation,
    ACTIONS(2051), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2049), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22826] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(925), 1,
      sym_text_interpolation,
    ACTIONS(1582), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1580), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22878] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(926), 1,
      sym_text_interpolation,
    ACTIONS(2055), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2053), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22930] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(927), 1,
      sym_text_interpolation,
    ACTIONS(1897), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1895), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22982] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(928), 1,
      sym_text_interpolation,
    ACTIONS(2059), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2057), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23034] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(929), 1,
      sym_text_interpolation,
    ACTIONS(2063), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2061), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23086] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(930), 1,
      sym_text_interpolation,
    ACTIONS(2067), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2065), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23138] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(931), 1,
      sym_text_interpolation,
    ACTIONS(2071), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2069), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23190] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(932), 1,
      sym_text_interpolation,
    ACTIONS(2075), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2073), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23242] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(933), 1,
      sym_text_interpolation,
    ACTIONS(2079), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2077), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23294] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(934), 1,
      sym_text_interpolation,
    ACTIONS(2083), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23346] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(935), 1,
      sym_text_interpolation,
    ACTIONS(2087), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2085), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23398] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(936), 1,
      sym_text_interpolation,
    ACTIONS(2091), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2089), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23450] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(937), 1,
      sym_text_interpolation,
    ACTIONS(2095), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2093), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23502] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(938), 1,
      sym_text_interpolation,
    ACTIONS(2099), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2097), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23554] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(939), 1,
      sym_text_interpolation,
    ACTIONS(2103), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2101), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23606] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(940), 1,
      sym_text_interpolation,
    ACTIONS(2107), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2105), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23658] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(941), 1,
      sym_text_interpolation,
    ACTIONS(2111), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2109), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23710] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(942), 1,
      sym_text_interpolation,
    ACTIONS(2115), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2113), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23762] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(943), 1,
      sym_text_interpolation,
    ACTIONS(1578), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1576), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23814] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(944), 1,
      sym_text_interpolation,
    ACTIONS(2119), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2117), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23866] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1735), 1,
      anon_sym_LPAREN,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(2121), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(945), 1,
      sym_text_interpolation,
    STATE(1170), 1,
      sym_visibility_modifier,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1558), 1,
      sym__types,
    STATE(1769), 1,
      sym__type,
    STATE(2139), 1,
      sym_reference_modifier,
    STATE(2141), 1,
      sym_variable_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [23954] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(946), 1,
      sym_text_interpolation,
    ACTIONS(2125), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2123), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24006] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(947), 1,
      sym_text_interpolation,
    ACTIONS(2129), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2127), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24058] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(948), 1,
      sym_text_interpolation,
    ACTIONS(2133), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2131), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24110] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(949), 1,
      sym_text_interpolation,
    ACTIONS(2137), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2135), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24162] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(950), 1,
      sym_text_interpolation,
    ACTIONS(2141), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2139), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24214] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(951), 1,
      sym_text_interpolation,
    ACTIONS(2145), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2143), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24266] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(952), 1,
      sym_text_interpolation,
    ACTIONS(2149), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2147), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24318] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(953), 1,
      sym_text_interpolation,
    ACTIONS(1592), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24370] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(954), 1,
      sym_text_interpolation,
    ACTIONS(2153), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2151), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24422] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(955), 1,
      sym_text_interpolation,
    ACTIONS(2157), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2155), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24474] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(956), 1,
      sym_text_interpolation,
    ACTIONS(2161), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2159), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24526] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(957), 1,
      sym_text_interpolation,
    ACTIONS(2165), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2163), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24578] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(958), 1,
      sym_text_interpolation,
    ACTIONS(2169), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2167), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24630] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(959), 1,
      sym_text_interpolation,
    ACTIONS(2173), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2171), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24682] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(960), 1,
      sym_text_interpolation,
    ACTIONS(2177), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2175), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24734] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(961), 1,
      sym_text_interpolation,
    ACTIONS(2181), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2179), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24786] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(962), 1,
      sym_text_interpolation,
    ACTIONS(2185), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2183), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24838] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2187), 1,
      aux_sym_binary_expression_token1,
    STATE(963), 1,
      sym_text_interpolation,
    ACTIONS(1991), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1989), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24892] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(964), 1,
      sym_text_interpolation,
    ACTIONS(2191), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2189), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24944] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(965), 1,
      sym_text_interpolation,
    ACTIONS(2195), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2193), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [24996] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(966), 1,
      sym_text_interpolation,
    ACTIONS(2199), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2197), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25048] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(967), 1,
      sym_text_interpolation,
    ACTIONS(2203), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2201), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25100] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(968), 1,
      sym_text_interpolation,
    ACTIONS(2207), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2205), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25152] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(969), 1,
      sym_text_interpolation,
    ACTIONS(2211), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2209), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25204] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(970), 1,
      sym_text_interpolation,
    ACTIONS(2215), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2213), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25256] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(971), 1,
      sym_text_interpolation,
    ACTIONS(2219), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2217), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25308] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(972), 1,
      sym_text_interpolation,
    ACTIONS(1048), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1046), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25359] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(973), 1,
      sym_text_interpolation,
    ACTIONS(1052), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1050), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25410] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(974), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2221), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [25498] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    STATE(975), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 25,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25550] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(976), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [25638] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(977), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25720] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(978), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [25808] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(979), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 8,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [25894] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(980), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 9,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25978] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(981), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2267), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [26066] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(982), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26148] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2271), 1,
      anon_sym_EQ_GT,
    STATE(983), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2139), 6,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [26238] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(984), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2273), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [26326] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2277), 1,
      anon_sym_QMARK,
    STATE(985), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2275), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26408] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(986), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2279), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [26496] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2283), 1,
      anon_sym_QMARK,
    STATE(987), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2281), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26578] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(988), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2285), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [26666] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(989), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 19,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [26728] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(990), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2159), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [26816] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(991), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 12,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [26894] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(992), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 13,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [26970] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    STATE(993), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 25,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27022] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(994), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 14,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [27094] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(995), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2287), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27176] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(996), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 14,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [27246] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(997), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2289), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [27334] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(998), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 13,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [27408] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(999), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1749), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1747), 18,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [27474] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(1000), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2291), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [27562] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(1001), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27644] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(1002), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2293), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27726] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(1003), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 22,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [27784] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(1004), 1,
      sym_text_interpolation,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 24,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [27840] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(1005), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 20,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [27900] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    STATE(1006), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [27971] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1007), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2279), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [28058] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1008), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2293), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [28139] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    STATE(1009), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28190] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1010), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [28265] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1011), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [28342] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1012), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [28425] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1013), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [28510] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    STATE(1014), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1749), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1747), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [28575] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    STATE(1015), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [28636] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1016), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [28717] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    STATE(1017), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [28774] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1018), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2289), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [28861] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    STATE(1019), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [28920] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1020), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [29007] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    STATE(1021), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29058] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1022), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2285), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [29145] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    STATE(1023), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [29214] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1024), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2273), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [29301] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1025), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [29382] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_QMARK,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1026), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2281), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [29463] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1027), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [29544] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1028), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2221), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [29631] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1029), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2291), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [29718] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2335), 1,
      anon_sym_EQ_GT,
    STATE(1030), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2139), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [29807] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_QMARK,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1031), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2275), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [29888] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1032), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2267), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [29975] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1033), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [30062] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    STATE(1034), 1,
      sym_text_interpolation,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [30117] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1035), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [30190] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1036), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2159), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [30277] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2339), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2344), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2347), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2350), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2353), 1,
      sym_var_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1037), 2,
      sym_text_interpolation,
      aux_sym_property_declaration_repeat1,
    ACTIONS(2342), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2356), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
    ACTIONS(2337), 17,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [30342] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2287), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [30423] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1039), 1,
      sym_text_interpolation,
    ACTIONS(2195), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2193), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30471] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1040), 1,
      sym_text_interpolation,
    ACTIONS(2177), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2175), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30519] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1041), 1,
      sym_text_interpolation,
    ACTIONS(2111), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2109), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30567] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2359), 1,
      sym_name,
    STATE(1042), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1606), 1,
      sym__type,
    STATE(1859), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [30643] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1043), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [30723] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1044), 1,
      sym_text_interpolation,
    ACTIONS(2161), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2159), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30771] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1045), 1,
      sym_text_interpolation,
    ACTIONS(2115), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2113), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30819] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1046), 1,
      sym_text_interpolation,
    ACTIONS(2019), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2017), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30867] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1047), 1,
      sym_text_interpolation,
    ACTIONS(1592), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30915] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1048), 1,
      sym_text_interpolation,
    ACTIONS(1568), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1566), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30963] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1049), 1,
      sym_text_interpolation,
    ACTIONS(1582), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1580), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31011] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1050), 1,
      sym_text_interpolation,
    ACTIONS(1578), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1576), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31059] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1051), 1,
      sym_text_interpolation,
    ACTIONS(2063), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2061), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31107] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1052), 1,
      sym_text_interpolation,
    ACTIONS(2023), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2021), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31155] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1053), 1,
      sym_text_interpolation,
    ACTIONS(2103), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2101), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31203] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1054), 1,
      sym_text_interpolation,
    ACTIONS(2133), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2131), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31251] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1055), 1,
      sym_text_interpolation,
    ACTIONS(2129), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2127), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31299] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1056), 1,
      sym_text_interpolation,
    ACTIONS(1574), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31347] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2359), 1,
      sym_name,
    STATE(1057), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1636), 1,
      sym__type,
    STATE(1875), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [31423] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1058), 1,
      sym_text_interpolation,
    ACTIONS(2095), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2093), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31471] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1059), 1,
      sym_text_interpolation,
    ACTIONS(2181), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2179), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31519] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1060), 1,
      sym_text_interpolation,
    ACTIONS(1991), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1989), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31567] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1061), 1,
      sym_text_interpolation,
    ACTIONS(2141), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2139), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31615] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1062), 1,
      sym_text_interpolation,
    ACTIONS(1995), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1993), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31663] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2397), 1,
      aux_sym_binary_expression_token1,
    STATE(1063), 1,
      sym_text_interpolation,
    ACTIONS(1991), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1989), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31713] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1064), 1,
      sym_text_interpolation,
    ACTIONS(1987), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1985), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31761] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1065), 1,
      sym_text_interpolation,
    ACTIONS(2185), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2183), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31809] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2359), 1,
      sym_name,
    STATE(1066), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1631), 1,
      sym__type,
    STATE(1943), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [31885] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1067), 1,
      sym_text_interpolation,
    ACTIONS(1017), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1015), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31933] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1068), 1,
      sym_text_interpolation,
    ACTIONS(2059), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2057), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31981] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1069), 1,
      sym_text_interpolation,
    ACTIONS(2087), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2085), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32029] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1070), 1,
      sym_text_interpolation,
    ACTIONS(1999), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1997), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32077] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1071), 1,
      sym_text_interpolation,
    ACTIONS(2039), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2037), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32125] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1072), 1,
      sym_text_interpolation,
    ACTIONS(2027), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32173] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1073), 1,
      sym_text_interpolation,
    ACTIONS(2015), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2013), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32221] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1074), 1,
      sym_text_interpolation,
    ACTIONS(2215), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2213), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32269] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1075), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32355] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1076), 1,
      sym_text_interpolation,
    ACTIONS(2191), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2189), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32403] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1077), 1,
      sym_text_interpolation,
    ACTIONS(1029), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1027), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32451] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1078), 1,
      sym_text_interpolation,
    ACTIONS(2083), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32499] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1079), 1,
      sym_text_interpolation,
    ACTIONS(2071), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2069), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32547] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1080), 1,
      sym_text_interpolation,
    ACTIONS(2099), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2097), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32595] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1081), 1,
      sym_text_interpolation,
    ACTIONS(2075), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2073), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32643] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1082), 1,
      sym_text_interpolation,
    ACTIONS(2067), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2065), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32691] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1083), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2267), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32777] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1084), 1,
      sym_text_interpolation,
    ACTIONS(2031), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2029), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32825] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1085), 1,
      sym_text_interpolation,
    ACTIONS(2003), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2001), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32873] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1086), 1,
      sym_text_interpolation,
    ACTIONS(2007), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2005), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32921] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1087), 1,
      sym_text_interpolation,
    ACTIONS(2051), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2049), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32969] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1088), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2287), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33049] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1089), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2293), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33129] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_QMARK,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1090), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2275), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33209] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    STATE(1091), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33259] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1092), 1,
      sym_text_interpolation,
    ACTIONS(2219), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2217), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33307] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1093), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 18,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [33365] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1094), 1,
      sym_text_interpolation,
    ACTIONS(2207), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2205), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33413] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1095), 1,
      sym_text_interpolation,
    ACTIONS(2203), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2201), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33461] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1096), 1,
      sym_text_interpolation,
    ACTIONS(2199), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2197), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33509] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1097), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 20,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [33565] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1098), 1,
      sym_text_interpolation,
    ACTIONS(2047), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2045), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33613] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1099), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 17,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [33673] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1100), 1,
      sym_text_interpolation,
    ACTIONS(2091), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2089), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33721] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1101), 1,
      sym_text_interpolation,
    ACTIONS(2165), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2163), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33769] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1102), 1,
      sym_text_interpolation,
    ACTIONS(2119), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2117), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33817] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1103), 1,
      sym_text_interpolation,
    ACTIONS(2125), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2123), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33865] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1104), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1749), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1747), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33929] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1105), 1,
      sym_text_interpolation,
    ACTIONS(2137), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2135), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33977] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1106), 1,
      sym_text_interpolation,
    ACTIONS(2157), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2155), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34025] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1107), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [34095] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1108), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [34169] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1109), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2159), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [34255] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1110), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 10,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [34331] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1111), 1,
      sym_text_interpolation,
    ACTIONS(2169), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2167), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34379] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1112), 1,
      sym_text_interpolation,
    ACTIONS(2153), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2151), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34427] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1113), 1,
      sym_text_interpolation,
    ACTIONS(2149), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2147), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34475] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1114), 1,
      sym_text_interpolation,
    ACTIONS(2145), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2143), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34523] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_QMARK,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1115), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2281), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34603] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    STATE(1116), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 7,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34685] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1117), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [34769] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1118), 1,
      sym_text_interpolation,
    ACTIONS(2211), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2209), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34817] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1119), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34897] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    STATE(1120), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34947] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1121), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [35027] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1122), 1,
      sym_text_interpolation,
    ACTIONS(2173), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2171), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [35075] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1123), 1,
      sym_text_interpolation,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [35129] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2405), 1,
      anon_sym_EQ_GT,
    STATE(1124), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2139), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_binary_expression_token1,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35217] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1125), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [35289] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    STATE(1126), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [35357] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1127), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2291), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [35443] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1128), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [35529] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1129), 1,
      sym_text_interpolation,
    ACTIONS(2043), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2041), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [35577] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1130), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2221), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [35663] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1131), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2273), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [35749] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1132), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2289), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [35835] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1133), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2279), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [35921] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1134), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2285), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [36007] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1135), 1,
      sym_text_interpolation,
    ACTIONS(2079), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2077), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [36055] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1136), 1,
      sym_text_interpolation,
    ACTIONS(1897), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1895), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [36103] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2359), 1,
      sym_name,
    STATE(1137), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1617), 1,
      sym__type,
    STATE(1890), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [36179] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1138), 1,
      sym_text_interpolation,
    ACTIONS(2107), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2105), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [36227] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2359), 1,
      sym_name,
    STATE(1139), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1616), 1,
      sym__type,
    STATE(1885), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [36303] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1140), 1,
      sym_text_interpolation,
    ACTIONS(2055), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2053), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [36351] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2359), 1,
      sym_name,
    STATE(1141), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1626), 1,
      sym__type,
    STATE(1799), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [36427] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1142), 1,
      sym_text_interpolation,
    ACTIONS(2011), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2009), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [36475] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1143), 1,
      sym_text_interpolation,
    ACTIONS(2035), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2033), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [36523] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1144), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2287), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [36602] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1145), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 9,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [36677] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(240), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(1146), 1,
      sym_text_interpolation,
    STATE(1201), 1,
      sym_readonly_modifier,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2129), 1,
      sym_variable_name,
    STATE(2386), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [36754] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1147), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2289), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36839] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1148), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2285), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36924] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1149), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2279), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37009] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1150), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2273), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37094] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1151), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2221), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37179] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2447), 1,
      anon_sym_EQ_GT,
    STATE(1152), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2139), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37266] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1153), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2291), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37351] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1154), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 11,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [37418] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1155), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 10,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [37489] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1156), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2267), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37574] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    STATE(1157), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 22,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [37623] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1158), 1,
      sym_text_interpolation,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 21,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [37676] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1159), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [37755] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1160), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2265), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37840] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1161), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2159), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37925] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1162), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2263), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38010] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_COLON,
    STATE(1163), 1,
      sym_text_interpolation,
    ACTIONS(2133), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2131), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [38059] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_COLON,
    STATE(1164), 1,
      sym_text_interpolation,
    ACTIONS(2129), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2127), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [38108] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1165), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 17,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [38165] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1166), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 19,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [38220] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1167), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1747), 16,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [38279] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1168), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1749), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1747), 15,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38342] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1169), 1,
      sym_text_interpolation,
    ACTIONS(1749), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 11,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [38411] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(240), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(1170), 1,
      sym_text_interpolation,
    STATE(1205), 1,
      sym_readonly_modifier,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2172), 1,
      sym_variable_name,
    STATE(2291), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [38488] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_QMARK,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1171), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2281), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [38567] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    STATE(1172), 1,
      sym_text_interpolation,
    ACTIONS(1749), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1747), 22,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [38616] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1173), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [38695] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1174), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 5,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [38778] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1175), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [38857] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_QMARK,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1176), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2275), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [38936] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    STATE(1177), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 6,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [39017] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1178), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2293), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [39096] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_QMARK,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    STATE(1179), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1747), 10,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [39169] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2451), 1,
      anon_sym_EQ_GT,
    STATE(1180), 1,
      sym_text_interpolation,
    ACTIONS(2139), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39255] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2453), 1,
      anon_sym_EQ_GT,
    STATE(1181), 1,
      sym_text_interpolation,
    ACTIONS(2139), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39341] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2455), 1,
      anon_sym_EQ_GT,
    STATE(1182), 1,
      sym_text_interpolation,
    ACTIONS(2139), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39427] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1183), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2457), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39511] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2461), 1,
      anon_sym_COMMA,
    STATE(1184), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2459), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39597] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2461), 1,
      anon_sym_COMMA,
    STATE(1185), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2463), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39683] = 26,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2465), 1,
      anon_sym_COMMA,
    ACTIONS(2467), 1,
      anon_sym_EQ_GT,
    STATE(1186), 1,
      sym_text_interpolation,
    STATE(2116), 1,
      aux_sym_match_condition_list_repeat1,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39771] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1187), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2469), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39855] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1188), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2471), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39939] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1189), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2473), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40022] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2483), 1,
      anon_sym_RBRACE,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1190), 1,
      sym_text_interpolation,
    STATE(1191), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [40113] = 27,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2495), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2498), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2501), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2504), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2507), 1,
      anon_sym_RBRACE,
    ACTIONS(2509), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2512), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2515), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2518), 1,
      sym_var_modifier,
    ACTIONS(2524), 1,
      anon_sym_POUND_LBRACK,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    STATE(1191), 2,
      sym_text_interpolation,
      aux_sym_declaration_list_repeat1,
    ACTIONS(2521), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [40202] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2529), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(1192), 1,
      sym_text_interpolation,
    STATE(1407), 1,
      sym__const_declaration,
    STATE(2657), 1,
      sym_visibility_modifier,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2531), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2527), 22,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [40255] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    ACTIONS(2533), 1,
      anon_sym_RBRACE,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1193), 1,
      sym_text_interpolation,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [40346] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1194), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2535), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40429] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1195), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2537), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40512] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1196), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2539), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40595] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    ACTIONS(2541), 1,
      anon_sym_RBRACE,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1197), 1,
      sym_text_interpolation,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [40686] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1198), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2543), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40769] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1199), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2545), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40852] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    ACTIONS(2547), 1,
      anon_sym_RBRACE,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1193), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1200), 1,
      sym_text_interpolation,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [40943] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(1201), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2187), 1,
      sym_variable_name,
    STATE(2260), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [41014] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2549), 1,
      anon_sym_EQ_GT,
    ACTIONS(2551), 1,
      anon_sym_RPAREN,
    STATE(1202), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41099] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2463), 1,
      anon_sym_SEMI,
    ACTIONS(2553), 1,
      anon_sym_COMMA,
    STATE(1203), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41184] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1204), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2555), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41267] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(1205), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1952), 1,
      sym_variable_name,
    STATE(2221), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [41338] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1206), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41421] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1207), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2559), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41504] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1208), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2561), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41587] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1209), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2563), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41670] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1210), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2565), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41753] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1211), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2567), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41836] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1212), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2569), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41919] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2529), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(1213), 1,
      sym_text_interpolation,
    STATE(1395), 1,
      sym__const_declaration,
    STATE(2657), 1,
      sym_visibility_modifier,
    ACTIONS(242), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2531), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2527), 22,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [41972] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1214), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2571), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42055] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    ACTIONS(2573), 1,
      anon_sym_RBRACE,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1215), 1,
      sym_text_interpolation,
    STATE(1225), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [42146] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1216), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2575), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42229] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1217), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2577), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42312] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2549), 1,
      anon_sym_EQ_GT,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    STATE(1218), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42397] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2459), 1,
      anon_sym_RPAREN,
    ACTIONS(2581), 1,
      anon_sym_COMMA,
    STATE(1219), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42482] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1220), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2583), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42565] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1221), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2585), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42648] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1222), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2587), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42731] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    ACTIONS(2589), 1,
      anon_sym_RBRACE,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1197), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1223), 1,
      sym_text_interpolation,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [42822] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2459), 1,
      anon_sym_SEMI,
    ACTIONS(2553), 1,
      anon_sym_COMMA,
    STATE(1224), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42907] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    ACTIONS(2591), 1,
      anon_sym_RBRACE,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1225), 1,
      sym_text_interpolation,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [42998] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1226), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2593), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43081] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1227), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2595), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43164] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    STATE(1228), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2597), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43247] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1229), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2599), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43330] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2549), 1,
      anon_sym_EQ_GT,
    ACTIONS(2601), 1,
      anon_sym_RPAREN,
    STATE(1230), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43415] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1231), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2603), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43498] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1232), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43581] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2463), 1,
      anon_sym_RPAREN,
    ACTIONS(2581), 1,
      anon_sym_COMMA,
    STATE(1233), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43666] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    STATE(1234), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2607), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43749] = 28,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    ACTIONS(2609), 1,
      anon_sym_RBRACE,
    STATE(644), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1190), 1,
      aux_sym_declaration_list_repeat1,
    STATE(1213), 1,
      sym_final_modifier,
    STATE(1235), 1,
      sym_text_interpolation,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1413), 1,
      sym__const_declaration,
    STATE(1415), 1,
      sym__class_const_declaration,
    STATE(1416), 1,
      sym__member_declaration,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
    STATE(1414), 3,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [43840] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1236), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2611), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43923] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1237), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2613), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44006] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1238), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2615), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44089] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2549), 1,
      anon_sym_EQ_GT,
    ACTIONS(2617), 1,
      anon_sym_RPAREN,
    STATE(1239), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44174] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_AMP,
    ACTIONS(2409), 1,
      anon_sym_QMARK,
    ACTIONS(2411), 1,
      anon_sym_PIPE,
    ACTIONS(2415), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2417), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2421), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2423), 1,
      anon_sym_CARET,
    ACTIONS(2431), 1,
      anon_sym_GT_EQ,
    ACTIONS(2435), 1,
      anon_sym_DOT,
    ACTIONS(2439), 1,
      anon_sym_PERCENT,
    ACTIONS(2441), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2443), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2445), 1,
      aux_sym_binary_expression_token4,
    STATE(1240), 1,
      sym_text_interpolation,
    ACTIONS(2413), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2425), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2433), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2437), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2619), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2429), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2427), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44257] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2363), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_QMARK,
    ACTIONS(2367), 1,
      anon_sym_PIPE,
    ACTIONS(2371), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2373), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2375), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2377), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2379), 1,
      anon_sym_CARET,
    ACTIONS(2387), 1,
      anon_sym_GT_EQ,
    ACTIONS(2391), 1,
      anon_sym_DOT,
    ACTIONS(2395), 1,
      anon_sym_PERCENT,
    ACTIONS(2399), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2401), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2403), 1,
      aux_sym_binary_expression_token4,
    STATE(1241), 1,
      sym_text_interpolation,
    ACTIONS(2369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2389), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2393), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2621), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2385), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2383), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44340] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1720), 1,
      anon_sym_LPAREN,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2623), 1,
      sym_bottom_type,
    STATE(1242), 1,
      sym_text_interpolation,
    STATE(1433), 1,
      sym__types,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2349), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1480), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [44408] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2625), 1,
      anon_sym_RBRACE,
    STATE(1243), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44490] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2627), 1,
      anon_sym_RBRACE,
    STATE(1244), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44572] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2629), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1245), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44654] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2631), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1246), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44736] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1247), 1,
      sym_text_interpolation,
    ACTIONS(2635), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2633), 27,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [44780] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2637), 1,
      anon_sym_RPAREN,
    STATE(1248), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44862] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2639), 1,
      anon_sym_RBRACE,
    STATE(1249), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44944] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2641), 1,
      anon_sym_RBRACE,
    STATE(1250), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45026] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2643), 1,
      anon_sym_RBRACE,
    STATE(1251), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45108] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2643), 1,
      anon_sym_RBRACK,
    STATE(1252), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45190] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym_name,
    ACTIONS(2649), 1,
      anon_sym_LPAREN,
    ACTIONS(2651), 1,
      anon_sym_QMARK,
    ACTIONS(2653), 1,
      sym_bottom_type,
    STATE(1253), 1,
      sym_text_interpolation,
    STATE(1547), 1,
      sym__types,
    STATE(1774), 1,
      sym_qualified_name,
    STATE(1992), 1,
      sym__type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1773), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(2081), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    ACTIONS(2647), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [45258] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2655), 1,
      anon_sym_RPAREN,
    STATE(1254), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45340] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2657), 1,
      anon_sym_RBRACE,
    STATE(1255), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45422] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2659), 1,
      anon_sym_RBRACE,
    STATE(1256), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45504] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2661), 1,
      anon_sym_RBRACE,
    STATE(1257), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45586] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2663), 1,
      anon_sym_RBRACE,
    STATE(1258), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45668] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2665), 1,
      anon_sym_RBRACE,
    STATE(1259), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45750] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2665), 1,
      anon_sym_RBRACK,
    STATE(1260), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45832] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2667), 1,
      anon_sym_RBRACE,
    STATE(1261), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45914] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2669), 1,
      anon_sym_RBRACE,
    STATE(1262), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45996] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2671), 1,
      anon_sym_RBRACE,
    STATE(1263), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46078] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2673), 1,
      anon_sym_RBRACE,
    STATE(1264), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46160] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2675), 1,
      anon_sym_RBRACE,
    STATE(1265), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46242] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2677), 1,
      anon_sym_COLON,
    STATE(1266), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46324] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2679), 1,
      anon_sym_RBRACE,
    STATE(1267), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46406] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2681), 1,
      anon_sym_RBRACE,
    STATE(1268), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46488] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2683), 1,
      anon_sym_RBRACE,
    STATE(1269), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46570] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2685), 1,
      anon_sym_EQ_GT,
    STATE(1270), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46652] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2687), 1,
      anon_sym_EQ_GT,
    STATE(1271), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46734] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2689), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1272), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46816] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2691), 1,
      anon_sym_RPAREN,
    STATE(1273), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46898] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2693), 1,
      anon_sym_COLON,
    STATE(1274), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [46980] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2695), 1,
      anon_sym_RBRACE,
    STATE(1275), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47062] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2697), 1,
      anon_sym_RBRACE,
    STATE(1276), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47144] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2699), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1277), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47226] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2701), 1,
      anon_sym_RBRACE,
    STATE(1278), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47308] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2703), 1,
      anon_sym_RPAREN,
    STATE(1279), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47390] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2705), 1,
      anon_sym_RBRACE,
    STATE(1280), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47472] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2707), 1,
      anon_sym_RBRACE,
    STATE(1281), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47554] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2707), 1,
      anon_sym_RBRACK,
    STATE(1282), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47636] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2709), 1,
      anon_sym_COLON,
    STATE(1283), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47718] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2711), 1,
      anon_sym_RBRACK,
    STATE(1284), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47800] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2713), 1,
      anon_sym_RBRACE,
    STATE(1285), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47882] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2715), 1,
      anon_sym_RBRACE,
    STATE(1286), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [47964] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2717), 1,
      anon_sym_RBRACE,
    STATE(1287), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48046] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2711), 1,
      anon_sym_RBRACE,
    STATE(1288), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48128] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2719), 1,
      anon_sym_RBRACE,
    STATE(1289), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48210] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2721), 1,
      anon_sym_RBRACE,
    STATE(1290), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48292] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2723), 1,
      anon_sym_RBRACE,
    STATE(1291), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48374] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2725), 1,
      anon_sym_RBRACE,
    STATE(1292), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48456] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2727), 1,
      anon_sym_RBRACE,
    STATE(1293), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48538] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2729), 1,
      anon_sym_RBRACE,
    STATE(1294), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48620] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2731), 1,
      anon_sym_RBRACE,
    STATE(1295), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48702] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2733), 1,
      anon_sym_EQ_GT,
    STATE(1296), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48784] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2735), 1,
      anon_sym_COLON,
    STATE(1297), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48866] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2737), 1,
      anon_sym_RBRACE,
    STATE(1298), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [48948] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2739), 1,
      anon_sym_RBRACE,
    STATE(1299), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49030] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2675), 1,
      anon_sym_RBRACK,
    STATE(1300), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49112] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_AMP,
    ACTIONS(2299), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2307), 1,
      anon_sym_GT_EQ,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    ACTIONS(2315), 1,
      anon_sym_PERCENT,
    ACTIONS(2317), 1,
      anon_sym_QMARK,
    ACTIONS(2319), 1,
      anon_sym_PIPE,
    ACTIONS(2321), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2323), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2325), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2327), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2329), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2331), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2333), 1,
      anon_sym_CARET,
    ACTIONS(2737), 1,
      anon_sym_RBRACK,
    STATE(1301), 1,
      sym_text_interpolation,
    ACTIONS(2297), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2301), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2309), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2313), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2305), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2303), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49194] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2741), 1,
      anon_sym_RBRACE,
    STATE(1302), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49276] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2743), 1,
      anon_sym_RBRACE,
    STATE(1303), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49358] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2745), 1,
      anon_sym_RBRACE,
    STATE(1304), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49440] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2747), 1,
      anon_sym_RBRACE,
    STATE(1305), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49522] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2749), 1,
      anon_sym_RBRACE,
    STATE(1306), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49604] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2751), 1,
      anon_sym_RBRACE,
    STATE(1307), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49686] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2753), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49768] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2755), 1,
      anon_sym_RBRACE,
    STATE(1309), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49850] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_AMP,
    ACTIONS(2225), 1,
      anon_sym_QMARK,
    ACTIONS(2227), 1,
      anon_sym_PIPE,
    ACTIONS(2231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2233), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2235), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2237), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2239), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2241), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2243), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2245), 1,
      anon_sym_CARET,
    ACTIONS(2253), 1,
      anon_sym_GT_EQ,
    ACTIONS(2257), 1,
      anon_sym_DOT,
    ACTIONS(2261), 1,
      anon_sym_PERCENT,
    ACTIONS(2757), 1,
      anon_sym_RBRACE,
    STATE(1310), 1,
      sym_text_interpolation,
    ACTIONS(2229), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2247), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2255), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2259), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2251), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2249), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [49932] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2759), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2761), 1,
      anon_sym_RBRACE,
    ACTIONS(2763), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2765), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2767), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2769), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2771), 1,
      sym_var_modifier,
    STATE(1311), 1,
      sym_text_interpolation,
    STATE(1316), 1,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1352), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1356), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1412), 1,
      sym__enum_member_declaration,
    STATE(1487), 1,
      sym__modifier,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2773), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1411), 3,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [50013] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2759), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2763), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2765), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2767), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2769), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2771), 1,
      sym_var_modifier,
    ACTIONS(2775), 1,
      anon_sym_RBRACE,
    STATE(1312), 1,
      sym_text_interpolation,
    STATE(1318), 1,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1352), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1356), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1412), 1,
      sym__enum_member_declaration,
    STATE(1487), 1,
      sym__modifier,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2773), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1411), 3,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [50094] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1313), 1,
      sym_text_interpolation,
    ACTIONS(2779), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2777), 26,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50137] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2781), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(1314), 1,
      sym_text_interpolation,
    ACTIONS(2531), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2527), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50182] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1315), 1,
      sym_text_interpolation,
    ACTIONS(2785), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2783), 26,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50225] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2759), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2763), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2765), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2767), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2769), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2771), 1,
      sym_var_modifier,
    ACTIONS(2787), 1,
      anon_sym_RBRACE,
    STATE(1316), 1,
      sym_text_interpolation,
    STATE(1318), 1,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1352), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1356), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1412), 1,
      sym__enum_member_declaration,
    STATE(1487), 1,
      sym__modifier,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2773), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1411), 3,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [50306] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2477), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2759), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2763), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2765), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2767), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2769), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2771), 1,
      sym_var_modifier,
    ACTIONS(2789), 1,
      anon_sym_RBRACE,
    STATE(1312), 1,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1317), 1,
      sym_text_interpolation,
    STATE(1352), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1356), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1412), 1,
      sym__enum_member_declaration,
    STATE(1487), 1,
      sym__modifier,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2773), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1411), 3,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [50387] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2791), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2794), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2797), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2800), 1,
      anon_sym_RBRACE,
    ACTIONS(2802), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2805), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2808), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2811), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2814), 1,
      sym_var_modifier,
    ACTIONS(2820), 1,
      anon_sym_POUND_LBRACK,
    STATE(1352), 1,
      sym_attribute_list,
    STATE(1355), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1356), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1412), 1,
      sym__enum_member_declaration,
    STATE(1487), 1,
      sym__modifier,
    STATE(1823), 1,
      sym__function_definition_header,
    STATE(1318), 2,
      sym_text_interpolation,
      aux_sym_enum_declaration_list_repeat1,
    ACTIONS(2817), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1411), 3,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [50466] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1319), 1,
      sym_text_interpolation,
    ACTIONS(2825), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2823), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50508] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1320), 1,
      sym_text_interpolation,
    ACTIONS(2829), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2827), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50550] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1321), 1,
      sym_text_interpolation,
    ACTIONS(2531), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2527), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50592] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1322), 1,
      sym_text_interpolation,
    ACTIONS(2833), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2831), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50634] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_POUND_LBRACK,
    STATE(1323), 1,
      sym_text_interpolation,
    STATE(1324), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1325), 1,
      sym_attribute_group,
    ACTIONS(2837), 5,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
    ACTIONS(2835), 19,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50681] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2843), 1,
      anon_sym_POUND_LBRACK,
    STATE(1325), 1,
      sym_attribute_group,
    STATE(1324), 2,
      sym_text_interpolation,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2841), 5,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
    ACTIONS(2839), 19,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50726] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1325), 1,
      sym_text_interpolation,
    ACTIONS(2848), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2846), 19,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50765] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym_name,
    ACTIONS(2651), 1,
      anon_sym_QMARK,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    STATE(1326), 1,
      sym_text_interpolation,
    STATE(1774), 1,
      sym_qualified_name,
    STATE(1926), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1773), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2647), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [50822] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    STATE(1327), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2072), 1,
      sym__types,
    STATE(2599), 1,
      sym_intersection_type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [50879] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    STATE(1328), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2072), 1,
      sym__types,
    STATE(2588), 1,
      sym_intersection_type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [50936] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1329), 1,
      sym_text_interpolation,
    ACTIONS(2854), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2852), 19,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [50975] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    STATE(1330), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2072), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2684), 1,
      sym_intersection_type,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51032] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN,
    STATE(1331), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1472), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51089] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1332), 1,
      sym_text_interpolation,
    ACTIONS(2860), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2858), 19,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [51128] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1333), 1,
      sym_text_interpolation,
    ACTIONS(2864), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2862), 19,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [51167] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN,
    STATE(1334), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1464), 1,
      sym__types,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51224] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    STATE(1335), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2072), 1,
      sym__types,
    STATE(2556), 1,
      sym_intersection_type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51281] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    STATE(1336), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2072), 1,
      sym__types,
    STATE(2496), 1,
      sym_intersection_type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51338] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN,
    STATE(1337), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1464), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51395] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    ACTIONS(2856), 1,
      anon_sym_LPAREN,
    STATE(1338), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1472), 1,
      sym__types,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51452] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym_name,
    ACTIONS(2651), 1,
      anon_sym_QMARK,
    ACTIONS(2850), 1,
      anon_sym_LPAREN,
    STATE(1339), 1,
      sym_text_interpolation,
    STATE(1774), 1,
      sym_qualified_name,
    STATE(1867), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1773), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2647), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51509] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym_name,
    ACTIONS(2651), 1,
      anon_sym_QMARK,
    STATE(1340), 1,
      sym_text_interpolation,
    STATE(1774), 1,
      sym_qualified_name,
    STATE(1894), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1773), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2647), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51563] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    STATE(1341), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1469), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51617] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    STATE(1342), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1469), 1,
      sym__types,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51671] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1722), 1,
      anon_sym_QMARK,
    STATE(1343), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1461), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51725] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    ACTIONS(1741), 1,
      anon_sym_QMARK,
    STATE(1344), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1461), 1,
      sym__types,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(1442), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51779] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym_name,
    ACTIONS(2651), 1,
      anon_sym_QMARK,
    STATE(1345), 1,
      sym_text_interpolation,
    STATE(1774), 1,
      sym_qualified_name,
    STATE(1786), 1,
      sym__types,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1773), 3,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2647), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51833] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    STATE(1346), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2534), 1,
      sym_namespace_name_as_prefix,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(1449), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51880] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    STATE(1347), 1,
      sym_text_interpolation,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1449), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(1712), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [51927] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1348), 1,
      sym_text_interpolation,
    ACTIONS(2785), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2783), 18,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_readonly_modifier_token1,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [51962] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym_name,
    STATE(1349), 1,
      sym_text_interpolation,
    STATE(1774), 1,
      sym_qualified_name,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1753), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(2647), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [52009] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1350), 1,
      sym_text_interpolation,
    ACTIONS(2825), 3,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOLLAR,
    ACTIONS(2823), 17,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      anon_sym_QMARK,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [52043] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2475), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2481), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2489), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2491), 1,
      sym_var_modifier,
    STATE(643), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1192), 1,
      sym_final_modifier,
    STATE(1314), 1,
      sym_visibility_modifier,
    STATE(1320), 1,
      sym__modifier,
    STATE(1351), 1,
      sym_text_interpolation,
    STATE(1399), 1,
      sym__const_declaration,
    STATE(1872), 1,
      sym__function_definition_header,
    ACTIONS(2493), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1321), 3,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
  [52102] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2759), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2765), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2767), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2769), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2771), 1,
      sym_var_modifier,
    ACTIONS(2866), 1,
      aux_sym_enum_case_token1,
    STATE(1352), 1,
      sym_text_interpolation,
    STATE(1354), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1487), 1,
      sym__modifier,
    STATE(1872), 1,
      sym__function_definition_header,
    ACTIONS(2773), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [52154] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2868), 1,
      anon_sym_POUND_LBRACK,
    STATE(1363), 1,
      sym_attribute_group,
    STATE(1353), 2,
      sym_text_interpolation,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2841), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
  [52187] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2759), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2765), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2767), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2769), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2771), 1,
      sym_var_modifier,
    STATE(1354), 1,
      sym_text_interpolation,
    STATE(1359), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1487), 1,
      sym__modifier,
    STATE(1911), 1,
      sym__function_definition_header,
    ACTIONS(2773), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [52236] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(308), 1,
      anon_sym_POUND_LBRACK,
    STATE(1353), 1,
      aux_sym_attribute_list_repeat1,
    STATE(1355), 1,
      sym_text_interpolation,
    STATE(1363), 1,
      sym_attribute_group,
    ACTIONS(2837), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
  [52271] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2479), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2759), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2765), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2767), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2769), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2771), 1,
      sym_var_modifier,
    STATE(1356), 1,
      sym_text_interpolation,
    STATE(1359), 1,
      aux_sym_property_declaration_repeat1,
    STATE(1487), 1,
      sym__modifier,
    STATE(1876), 1,
      sym__function_definition_header,
    ACTIONS(2773), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [52320] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1357), 1,
      sym_text_interpolation,
    ACTIONS(2871), 6,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_cast_type_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(1832), 10,
      anon_sym_BSLASH,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
      anon_sym_LT_LT_LT,
      anon_sym_DOLLAR,
  [52350] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(609), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2873), 1,
      sym_float,
    ACTIONS(2875), 1,
      sym_integer,
    ACTIONS(2877), 1,
      aux_sym__argument_name_token1,
    ACTIONS(2879), 1,
      aux_sym__argument_name_token2,
    STATE(1358), 1,
      sym_text_interpolation,
    ACTIONS(605), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(607), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(2567), 3,
      sym_boolean,
      sym_null,
      sym__string,
    STATE(730), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
  [52394] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2342), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2881), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2884), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2887), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2890), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2893), 1,
      sym_var_modifier,
    STATE(1487), 1,
      sym__modifier,
    STATE(1359), 2,
      sym_text_interpolation,
      aux_sym_property_declaration_repeat1,
    ACTIONS(2896), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1486), 5,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [52438] = 14,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2899), 1,
      anon_sym_LBRACE,
    ACTIONS(2905), 1,
      anon_sym_BSLASHu,
    ACTIONS(2908), 1,
      sym__new_line,
    ACTIONS(2911), 1,
      anon_sym_DOLLAR,
    ACTIONS(2914), 1,
      sym_heredoc_end,
    STATE(1370), 1,
      aux_sym__interpolated_string_body_heredoc,
    STATE(1459), 1,
      sym_variable_name,
    STATE(1597), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2902), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1360), 2,
      sym_text_interpolation,
      aux_sym_heredoc_body_repeat1,
    STATE(1557), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1578), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [52485] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1361), 1,
      sym_text_interpolation,
    ACTIONS(2860), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [52512] = 15,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2916), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      anon_sym_BSLASHu,
    ACTIONS(2922), 1,
      sym__new_line,
    ACTIONS(2925), 1,
      anon_sym_DOLLAR,
    ACTIONS(2927), 1,
      sym_heredoc_end,
    STATE(1360), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1362), 1,
      sym_text_interpolation,
    STATE(1370), 1,
      aux_sym__interpolated_string_body_heredoc,
    STATE(1459), 1,
      sym_variable_name,
    STATE(1597), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2918), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1557), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1578), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [52561] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1363), 1,
      sym_text_interpolation,
    ACTIONS(2848), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [52588] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1364), 1,
      sym_text_interpolation,
    ACTIONS(2854), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [52615] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1365), 1,
      sym_text_interpolation,
    ACTIONS(2864), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [52642] = 13,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2916), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      anon_sym_BSLASHu,
    ACTIONS(2925), 1,
      anon_sym_DOLLAR,
    STATE(1366), 1,
      sym_text_interpolation,
    STATE(1374), 1,
      aux_sym__interpolated_string_body_heredoc,
    STATE(1459), 1,
      sym_variable_name,
    STATE(1597), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2914), 2,
      sym_heredoc_end,
      sym__new_line,
    ACTIONS(2918), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1557), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1578), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [52686] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1367), 1,
      sym_text_interpolation,
    ACTIONS(2929), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52712] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1368), 1,
      sym_text_interpolation,
    ACTIONS(2931), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52738] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1369), 1,
      sym_text_interpolation,
    ACTIONS(2933), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52764] = 13,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2916), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      anon_sym_BSLASHu,
    ACTIONS(2925), 1,
      anon_sym_DOLLAR,
    STATE(1370), 1,
      sym_text_interpolation,
    STATE(1374), 1,
      aux_sym__interpolated_string_body_heredoc,
    STATE(1459), 1,
      sym_variable_name,
    STATE(1597), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2918), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    ACTIONS(2935), 2,
      sym_heredoc_end,
      sym__new_line,
    STATE(1557), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1578), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [52808] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1371), 1,
      sym_text_interpolation,
    ACTIONS(2931), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52834] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1372), 1,
      sym_text_interpolation,
    ACTIONS(2937), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52860] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1373), 1,
      sym_text_interpolation,
    ACTIONS(2929), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52886] = 12,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2939), 1,
      anon_sym_LBRACE,
    ACTIONS(2945), 1,
      anon_sym_BSLASHu,
    ACTIONS(2950), 1,
      anon_sym_DOLLAR,
    STATE(1459), 1,
      sym_variable_name,
    STATE(1597), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2942), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    ACTIONS(2948), 2,
      sym_heredoc_end,
      sym__new_line,
    STATE(1374), 2,
      sym_text_interpolation,
      aux_sym__interpolated_string_body_heredoc,
    STATE(1557), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1578), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [52928] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1375), 1,
      sym_text_interpolation,
    ACTIONS(2953), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52954] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1376), 1,
      sym_text_interpolation,
    ACTIONS(2955), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [52980] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1377), 1,
      sym_text_interpolation,
    ACTIONS(2957), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53006] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1378), 1,
      sym_text_interpolation,
    ACTIONS(2959), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53032] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1379), 1,
      sym_text_interpolation,
    ACTIONS(2955), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53058] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1380), 1,
      sym_text_interpolation,
    ACTIONS(2961), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53084] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1381), 1,
      sym_text_interpolation,
    ACTIONS(2963), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53110] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1382), 1,
      sym_text_interpolation,
    ACTIONS(2965), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53136] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1383), 1,
      sym_text_interpolation,
    ACTIONS(2965), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53162] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1384), 1,
      sym_text_interpolation,
    ACTIONS(2967), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53188] = 14,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2916), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 1,
      anon_sym_BSLASHu,
    ACTIONS(2925), 1,
      anon_sym_DOLLAR,
    ACTIONS(2969), 1,
      sym__new_line,
    STATE(1362), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1370), 1,
      aux_sym__interpolated_string_body_heredoc,
    STATE(1385), 1,
      sym_text_interpolation,
    STATE(1459), 1,
      sym_variable_name,
    STATE(1597), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2918), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1557), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1578), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [53234] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1386), 1,
      sym_text_interpolation,
    ACTIONS(1015), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53260] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1387), 1,
      sym_text_interpolation,
    ACTIONS(1027), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53286] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1388), 1,
      sym_text_interpolation,
    ACTIONS(2971), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53311] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2973), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2975), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2977), 1,
      aux_sym_enum_declaration_token1,
    ACTIONS(2979), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(2981), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2983), 1,
      aux_sym__arrow_function_header_token1,
    STATE(1389), 1,
      sym_text_interpolation,
    STATE(2401), 1,
      sym__function_definition_header,
    STATE(2532), 1,
      sym_static_modifier,
    STATE(2533), 1,
      sym_readonly_modifier,
    STATE(2045), 2,
      sym_final_modifier,
      sym_abstract_modifier,
  [53358] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2485), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2487), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2973), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2975), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2981), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2983), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(2985), 1,
      aux_sym_enum_declaration_token1,
    ACTIONS(2987), 1,
      aux_sym_class_declaration_token1,
    STATE(1390), 1,
      sym_text_interpolation,
    STATE(2380), 1,
      sym__function_definition_header,
    STATE(2532), 1,
      sym_static_modifier,
    STATE(2618), 1,
      sym_readonly_modifier,
    STATE(1989), 2,
      sym_final_modifier,
      sym_abstract_modifier,
  [53405] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(2995), 1,
      anon_sym_BSLASH,
    STATE(1391), 1,
      sym_text_interpolation,
    STATE(1863), 1,
      sym_namespace_use_clause,
    STATE(2600), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2993), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
    STATE(1725), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53446] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1392), 1,
      sym_text_interpolation,
    ACTIONS(1510), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53471] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1393), 1,
      sym_text_interpolation,
    ACTIONS(2997), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53496] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1394), 1,
      sym_text_interpolation,
    ACTIONS(2999), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53521] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1395), 1,
      sym_text_interpolation,
    ACTIONS(3001), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53546] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1396), 1,
      sym_text_interpolation,
    ACTIONS(3003), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53571] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_LBRACE,
    ACTIONS(3009), 1,
      anon_sym_BSLASHu,
    ACTIONS(3011), 1,
      anon_sym_DQUOTE,
    ACTIONS(3013), 1,
      anon_sym_DOLLAR,
    STATE(1397), 1,
      sym_text_interpolation,
    STATE(1429), 1,
      aux_sym__interpolated_string_body,
    STATE(1511), 1,
      sym_variable_name,
    STATE(1610), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3007), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1609), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1611), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [53614] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1398), 1,
      sym_text_interpolation,
    ACTIONS(3015), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53639] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1399), 1,
      sym_text_interpolation,
    ACTIONS(3017), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53664] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LBRACE,
    ACTIONS(3023), 1,
      anon_sym_BSLASHu,
    ACTIONS(3025), 1,
      anon_sym_BQUOTE,
    ACTIONS(3027), 1,
      anon_sym_DOLLAR,
    STATE(1400), 1,
      sym_text_interpolation,
    STATE(1424), 1,
      aux_sym__interpolated_execution_operator_body,
    STATE(1496), 1,
      sym_variable_name,
    STATE(1675), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3021), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1612), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1676), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [53707] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1401), 1,
      sym_text_interpolation,
    ACTIONS(1328), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53732] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1402), 1,
      sym_text_interpolation,
    ACTIONS(1304), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53757] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1403), 1,
      sym_text_interpolation,
    ACTIONS(3029), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53782] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_LBRACE,
    ACTIONS(3009), 1,
      anon_sym_BSLASHu,
    ACTIONS(3013), 1,
      anon_sym_DOLLAR,
    ACTIONS(3031), 1,
      anon_sym_DQUOTE,
    STATE(1404), 1,
      sym_text_interpolation,
    STATE(1427), 1,
      aux_sym__interpolated_string_body,
    STATE(1511), 1,
      sym_variable_name,
    STATE(1610), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3007), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1609), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1611), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [53825] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LBRACE,
    ACTIONS(3023), 1,
      anon_sym_BSLASHu,
    ACTIONS(3027), 1,
      anon_sym_DOLLAR,
    ACTIONS(3033), 1,
      anon_sym_BQUOTE,
    STATE(1405), 1,
      sym_text_interpolation,
    STATE(1418), 1,
      aux_sym__interpolated_execution_operator_body,
    STATE(1496), 1,
      sym_variable_name,
    STATE(1675), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3021), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1612), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1676), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [53868] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1406), 1,
      sym_text_interpolation,
    ACTIONS(3035), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53893] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1407), 1,
      sym_text_interpolation,
    ACTIONS(3037), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53918] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1408), 1,
      sym_text_interpolation,
    ACTIONS(1270), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53943] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1409), 1,
      sym_text_interpolation,
    ACTIONS(3039), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [53968] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(1410), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3041), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3043), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [53999] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1411), 1,
      sym_text_interpolation,
    ACTIONS(3045), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54024] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1412), 1,
      sym_text_interpolation,
    ACTIONS(3047), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54049] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1413), 1,
      sym_text_interpolation,
    ACTIONS(3049), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54074] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1414), 1,
      sym_text_interpolation,
    ACTIONS(3051), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54099] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1415), 1,
      sym_text_interpolation,
    ACTIONS(3053), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54124] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1416), 1,
      sym_text_interpolation,
    ACTIONS(3055), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54149] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(3059), 1,
      anon_sym_BSLASH,
    STATE(1417), 1,
      sym_text_interpolation,
    STATE(1871), 1,
      sym_namespace_use_clause,
    STATE(2608), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(3057), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
    STATE(1725), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54190] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LBRACE,
    ACTIONS(3023), 1,
      anon_sym_BSLASHu,
    ACTIONS(3027), 1,
      anon_sym_DOLLAR,
    ACTIONS(3061), 1,
      anon_sym_BQUOTE,
    STATE(1418), 1,
      sym_text_interpolation,
    STATE(1424), 1,
      aux_sym__interpolated_execution_operator_body,
    STATE(1496), 1,
      sym_variable_name,
    STATE(1675), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3021), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1612), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1676), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [54233] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1419), 1,
      sym_text_interpolation,
    ACTIONS(3063), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54258] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1420), 1,
      sym_text_interpolation,
    ACTIONS(1502), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54283] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1421), 1,
      sym_text_interpolation,
    ACTIONS(3065), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54308] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_LBRACE,
    ACTIONS(3023), 1,
      anon_sym_BSLASHu,
    ACTIONS(3027), 1,
      anon_sym_DOLLAR,
    ACTIONS(3067), 1,
      anon_sym_BQUOTE,
    STATE(1400), 1,
      aux_sym__interpolated_execution_operator_body,
    STATE(1422), 1,
      sym_text_interpolation,
    STATE(1496), 1,
      sym_variable_name,
    STATE(1675), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3021), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1612), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1676), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [54351] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1423), 1,
      sym_text_interpolation,
    ACTIONS(1522), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54376] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_LBRACE,
    ACTIONS(3075), 1,
      anon_sym_BSLASHu,
    ACTIONS(3078), 1,
      anon_sym_BQUOTE,
    ACTIONS(3080), 1,
      anon_sym_DOLLAR,
    STATE(1496), 1,
      sym_variable_name,
    STATE(1675), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3072), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1424), 2,
      sym_text_interpolation,
      aux_sym__interpolated_execution_operator_body,
    STATE(1612), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1676), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [54417] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1425), 1,
      sym_text_interpolation,
    ACTIONS(3083), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54442] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1426), 1,
      sym_text_interpolation,
    ACTIONS(1526), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54467] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_LBRACE,
    ACTIONS(3009), 1,
      anon_sym_BSLASHu,
    ACTIONS(3013), 1,
      anon_sym_DOLLAR,
    ACTIONS(3085), 1,
      anon_sym_DQUOTE,
    STATE(1427), 1,
      sym_text_interpolation,
    STATE(1429), 1,
      aux_sym__interpolated_string_body,
    STATE(1511), 1,
      sym_variable_name,
    STATE(1610), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3007), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1609), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1611), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [54510] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_LBRACE,
    ACTIONS(3009), 1,
      anon_sym_BSLASHu,
    ACTIONS(3013), 1,
      anon_sym_DOLLAR,
    ACTIONS(3087), 1,
      anon_sym_DQUOTE,
    STATE(1397), 1,
      aux_sym__interpolated_string_body,
    STATE(1428), 1,
      sym_text_interpolation,
    STATE(1511), 1,
      sym_variable_name,
    STATE(1610), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3007), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1609), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1611), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [54553] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_LBRACE,
    ACTIONS(3095), 1,
      anon_sym_BSLASHu,
    ACTIONS(3098), 1,
      anon_sym_DQUOTE,
    ACTIONS(3100), 1,
      anon_sym_DOLLAR,
    STATE(1511), 1,
      sym_variable_name,
    STATE(1610), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3092), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1429), 2,
      sym_text_interpolation,
      aux_sym__interpolated_string_body,
    STATE(1609), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1611), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [54594] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1430), 1,
      sym_text_interpolation,
    ACTIONS(3103), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [54619] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_name,
    ACTIONS(3107), 1,
      anon_sym_RBRACK,
    STATE(1431), 1,
      sym_text_interpolation,
    STATE(2245), 1,
      sym_attribute,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54659] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_name,
    ACTIONS(3109), 1,
      anon_sym_RBRACK,
    STATE(1432), 1,
      sym_text_interpolation,
    STATE(2245), 1,
      sym_attribute,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54699] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_PIPE,
    STATE(1433), 1,
      sym_text_interpolation,
    STATE(1453), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1498), 1,
      aux_sym_union_type_repeat1,
    STATE(1501), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3118), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3111), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [54735] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_name,
    ACTIONS(3125), 1,
      anon_sym_RBRACK,
    STATE(1434), 1,
      sym_text_interpolation,
    STATE(2245), 1,
      sym_attribute,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54775] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_BSLASHu,
    ACTIONS(3127), 1,
      anon_sym_LBRACE,
    ACTIONS(3129), 1,
      anon_sym_DOLLAR,
    STATE(1366), 1,
      aux_sym__interpolated_string_body_heredoc,
    STATE(1435), 1,
      sym_text_interpolation,
    STATE(1459), 1,
      sym_variable_name,
    STATE(1597), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2918), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1557), 2,
      sym__complex_string_part,
      sym__simple_string_part,
    STATE(1578), 2,
      sym__simple_string_subscript_expression,
      sym_dynamic_variable_name,
  [54815] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_name,
    ACTIONS(3131), 1,
      anon_sym_RBRACK,
    STATE(1436), 1,
      sym_text_interpolation,
    STATE(2245), 1,
      sym_attribute,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54855] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(3133), 1,
      anon_sym_BSLASH,
    STATE(1437), 1,
      sym_text_interpolation,
    STATE(1832), 1,
      sym_namespace_use_clause,
    STATE(2520), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1725), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54892] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_name,
    STATE(1438), 1,
      sym_text_interpolation,
    STATE(2033), 1,
      sym_attribute,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [54929] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2833), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3135), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1439), 1,
      sym_text_interpolation,
    STATE(1879), 1,
      sym_variable_name,
    STATE(1882), 1,
      sym_static_variable_declaration,
    ACTIONS(1654), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [54964] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_name,
    STATE(1440), 1,
      sym_text_interpolation,
    STATE(2245), 1,
      sym_attribute,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55001] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    STATE(1441), 1,
      sym_text_interpolation,
    STATE(2125), 1,
      sym_namespace_use_clause,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1725), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55038] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1442), 1,
      sym_text_interpolation,
    ACTIONS(3137), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3139), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55063] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1443), 1,
      sym_text_interpolation,
    ACTIONS(3141), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3143), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55088] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(314), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3145), 1,
      sym_integer,
    STATE(1444), 1,
      sym_text_interpolation,
    STATE(2412), 1,
      sym__string,
    ACTIONS(310), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(312), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(899), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
  [55121] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(314), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3147), 1,
      sym_integer,
    STATE(1445), 1,
      sym_text_interpolation,
    STATE(2350), 1,
      sym__string,
    ACTIONS(310), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(312), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(899), 4,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
  [55154] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1446), 1,
      sym_text_interpolation,
    ACTIONS(3041), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3043), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55179] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1957), 1,
      anon_sym_COLON,
    ACTIONS(2833), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3149), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1447), 1,
      sym_text_interpolation,
    ACTIONS(1654), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55210] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2833), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3135), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1448), 1,
      sym_text_interpolation,
    STATE(1868), 1,
      sym_static_variable_declaration,
    STATE(1879), 1,
      sym_variable_name,
    ACTIONS(1654), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55245] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1449), 1,
      sym_text_interpolation,
    ACTIONS(3151), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3153), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55270] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(3155), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(3157), 1,
      aux_sym_use_instead_of_clause_token1,
    STATE(596), 1,
      sym_arguments,
    STATE(1450), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55305] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(3159), 1,
      anon_sym_BSLASH,
    STATE(1451), 1,
      sym_text_interpolation,
    STATE(1920), 1,
      sym_namespace_use_clause,
    STATE(2619), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1725), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55342] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_name,
    STATE(1452), 1,
      sym_text_interpolation,
    STATE(2059), 1,
      sym_attribute,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55379] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_AMP,
    STATE(1453), 1,
      sym_text_interpolation,
    STATE(1455), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3161), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3163), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [55407] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2833), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3149), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1454), 1,
      sym_text_interpolation,
    ACTIONS(1654), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55435] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3167), 1,
      anon_sym_AMP,
    STATE(1455), 2,
      sym_text_interpolation,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3165), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3170), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [55461] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3172), 1,
      sym_name,
    STATE(1456), 1,
      sym_text_interpolation,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1790), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55495] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3174), 1,
      sym_name,
    STATE(1457), 1,
      sym_text_interpolation,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(1826), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55529] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3176), 1,
      sym_name,
    STATE(1458), 1,
      sym_text_interpolation,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(2163), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55563] = 8,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3180), 1,
      anon_sym_DASH_GT,
    ACTIONS(3182), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      sym_encapsed_string_chars_after_variable_heredoc,
    STATE(1459), 1,
      sym_text_interpolation,
    ACTIONS(3178), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3184), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [55593] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(3188), 1,
      anon_sym_COMMA,
    ACTIONS(3190), 1,
      anon_sym_RPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1460), 1,
      sym_text_interpolation,
    STATE(2142), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55625] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1461), 1,
      sym_text_interpolation,
    ACTIONS(3165), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3170), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55649] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1462), 1,
      sym_text_interpolation,
    ACTIONS(1600), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55677] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1463), 1,
      sym_text_interpolation,
    ACTIONS(3192), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3194), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55701] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1464), 1,
      sym_text_interpolation,
    ACTIONS(3196), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3199), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55725] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(3188), 1,
      anon_sym_COMMA,
    ACTIONS(3202), 1,
      anon_sym_RPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1465), 1,
      sym_text_interpolation,
    STATE(2167), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55757] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3204), 1,
      sym_name,
    STATE(1466), 1,
      sym_text_interpolation,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
    STATE(2077), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55791] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3206), 1,
      sym_name,
    STATE(1467), 1,
      sym_text_interpolation,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2659), 1,
      sym_namespace_name_as_prefix,
    STATE(1646), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55825] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1468), 1,
      sym_text_interpolation,
    ACTIONS(1658), 5,
      sym_encapsed_string_chars_heredoc,
      sym_encapsed_string_chars_after_variable_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
    ACTIONS(1660), 5,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
  [55849] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1469), 1,
      sym_text_interpolation,
    ACTIONS(3208), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3210), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55873] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(3212), 1,
      anon_sym_RPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1470), 1,
      sym_text_interpolation,
    STATE(2207), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55905] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1471), 1,
      sym_text_interpolation,
    ACTIONS(1807), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [55933] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1472), 1,
      sym_text_interpolation,
    ACTIONS(3214), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3216), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [55957] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3218), 1,
      sym_name,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    STATE(1473), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(715), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [55986] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3222), 1,
      sym_name,
    ACTIONS(3226), 1,
      anon_sym_LBRACE,
    STATE(1474), 1,
      sym_text_interpolation,
    ACTIONS(3224), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(582), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56015] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_BSLASHu,
    STATE(1475), 1,
      sym_text_interpolation,
    ACTIONS(1658), 8,
      sym_execution_string_chars,
      sym_execution_string_chars_after_variable,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [56038] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      sym_name,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1476), 1,
      sym_text_interpolation,
    STATE(1588), 1,
      sym_reference_modifier,
    STATE(1635), 1,
      sym_formal_parameters,
    STATE(2319), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56071] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(318), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3232), 1,
      sym_name,
    ACTIONS(3236), 1,
      anon_sym_LBRACE,
    STATE(1477), 1,
      sym_text_interpolation,
    ACTIONS(3234), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(607), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56100] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3238), 1,
      sym_name,
    ACTIONS(3240), 1,
      anon_sym_LBRACE,
    STATE(1478), 1,
      sym_text_interpolation,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(812), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56129] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(318), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3242), 1,
      sym_name,
    ACTIONS(3244), 1,
      anon_sym_LBRACE,
    STATE(808), 1,
      sym__reserved_identifier,
    STATE(1479), 1,
      sym_text_interpolation,
    STATE(601), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56160] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1480), 1,
      sym_text_interpolation,
    ACTIONS(3246), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3248), 5,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [56183] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1558), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3250), 1,
      sym_name,
    ACTIONS(3252), 1,
      anon_sym_LBRACE,
    STATE(685), 1,
      sym__reserved_identifier,
    STATE(1481), 1,
      sym_text_interpolation,
    STATE(658), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56214] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      sym_name,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1482), 1,
      sym_text_interpolation,
    STATE(1561), 1,
      sym_reference_modifier,
    STATE(1603), 1,
      sym_formal_parameters,
    STATE(2319), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56247] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(666), 1,
      sym_arguments,
    STATE(1483), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [56276] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1484), 1,
      sym_text_interpolation,
    ACTIONS(2833), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [56297] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3254), 1,
      sym_name,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    STATE(1485), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(721), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56326] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1486), 1,
      sym_text_interpolation,
    ACTIONS(2531), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [56347] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1487), 1,
      sym_text_interpolation,
    ACTIONS(2829), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [56368] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3258), 1,
      sym_name,
    ACTIONS(3260), 1,
      anon_sym_LBRACE,
    STATE(1488), 1,
      sym_text_interpolation,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(807), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56397] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(754), 1,
      sym_arguments,
    STATE(1489), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [56426] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3262), 1,
      sym_name,
    ACTIONS(3264), 1,
      anon_sym_LBRACE,
    STATE(1490), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(719), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56455] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3266), 1,
      sym_name,
    ACTIONS(3268), 1,
      anon_sym_LBRACE,
    STATE(1491), 1,
      sym_text_interpolation,
    STATE(1582), 1,
      sym__reserved_identifier,
    STATE(845), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56486] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1492), 1,
      sym_text_interpolation,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [56513] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3272), 1,
      sym_name,
    ACTIONS(3274), 1,
      anon_sym_LBRACE,
    STATE(1493), 1,
      sym_text_interpolation,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(838), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56542] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3276), 1,
      sym_name,
    ACTIONS(3278), 1,
      anon_sym_LBRACE,
    STATE(682), 1,
      sym__reserved_identifier,
    STATE(1494), 1,
      sym_text_interpolation,
    STATE(583), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56573] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_PIPE,
    STATE(1495), 1,
      sym_text_interpolation,
    STATE(1529), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3282), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3280), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [56600] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3178), 1,
      anon_sym_BSLASHu,
    ACTIONS(3286), 1,
      anon_sym_DASH_GT,
    ACTIONS(3288), 1,
      anon_sym_LBRACK,
    ACTIONS(3290), 1,
      sym_execution_string_chars_after_variable,
    STATE(1496), 1,
      sym_text_interpolation,
    ACTIONS(3184), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [56629] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1497), 1,
      sym_text_interpolation,
    ACTIONS(2603), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [56656] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3296), 1,
      anon_sym_PIPE,
    STATE(1498), 1,
      sym_text_interpolation,
    STATE(1532), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3294), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3292), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [56683] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3298), 1,
      sym_name,
    ACTIONS(3300), 1,
      anon_sym_LBRACE,
    STATE(1499), 1,
      sym_text_interpolation,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(857), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56712] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3276), 1,
      sym_name,
    ACTIONS(3278), 1,
      anon_sym_LBRACE,
    STATE(682), 1,
      sym__reserved_identifier,
    STATE(1500), 1,
      sym_text_interpolation,
    STATE(718), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56743] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_PIPE,
    STATE(1501), 1,
      sym_text_interpolation,
    STATE(1529), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3304), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3302), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [56770] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1502), 1,
      sym_text_interpolation,
    ACTIONS(2613), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [56797] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1558), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3306), 1,
      sym_name,
    ACTIONS(3310), 1,
      anon_sym_LBRACE,
    STATE(1503), 1,
      sym_text_interpolation,
    ACTIONS(3308), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(655), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56826] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3312), 1,
      sym_name,
    ACTIONS(3314), 1,
      anon_sym_LBRACE,
    STATE(1504), 1,
      sym_text_interpolation,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(841), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56855] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3316), 1,
      sym_name,
    ACTIONS(3318), 1,
      anon_sym_LBRACE,
    STATE(1505), 1,
      sym_text_interpolation,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(842), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [56884] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3276), 1,
      sym_name,
    ACTIONS(3278), 1,
      anon_sym_LBRACE,
    STATE(682), 1,
      sym__reserved_identifier,
    STATE(1506), 1,
      sym_text_interpolation,
    STATE(840), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56915] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1507), 1,
      sym_text_interpolation,
    ACTIONS(2575), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [56942] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1564), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    STATE(1508), 1,
      sym_text_interpolation,
    STATE(1568), 1,
      sym__reserved_identifier,
    STATE(779), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [56973] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1509), 1,
      sym_text_interpolation,
    ACTIONS(2635), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [56994] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3276), 1,
      sym_name,
    ACTIONS(3278), 1,
      anon_sym_LBRACE,
    STATE(682), 1,
      sym__reserved_identifier,
    STATE(1510), 1,
      sym_text_interpolation,
    STATE(701), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [57025] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3178), 1,
      anon_sym_BSLASHu,
    ACTIONS(3324), 1,
      anon_sym_DASH_GT,
    ACTIONS(3326), 1,
      anon_sym_LBRACK,
    ACTIONS(3328), 1,
      sym_encapsed_string_chars_after_variable,
    STATE(1511), 1,
      sym_text_interpolation,
    ACTIONS(3184), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [57054] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1564), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3330), 1,
      sym_name,
    ACTIONS(3332), 1,
      anon_sym_LBRACE,
    STATE(824), 1,
      sym__reserved_identifier,
    STATE(1512), 1,
      sym_text_interpolation,
    STATE(779), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [57085] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1513), 1,
      sym_text_interpolation,
    ACTIONS(2779), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [57106] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(797), 1,
      sym_arguments,
    STATE(1514), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57135] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3284), 1,
      anon_sym_PIPE,
    STATE(1495), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1515), 1,
      sym_text_interpolation,
    ACTIONS(3336), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3334), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [57162] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1516), 1,
      sym_text_interpolation,
    ACTIONS(2785), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [57183] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1517), 1,
      sym_text_interpolation,
    ACTIONS(2593), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57210] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(318), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3338), 1,
      sym_name,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    STATE(1518), 1,
      sym_text_interpolation,
    ACTIONS(3234), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(604), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57239] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_BSLASHu,
    STATE(1519), 1,
      sym_text_interpolation,
    ACTIONS(1658), 8,
      sym_encapsed_string_chars,
      sym_encapsed_string_chars_after_variable,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [57262] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3342), 1,
      sym_name,
    ACTIONS(3344), 1,
      anon_sym_LBRACE,
    STATE(1520), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(714), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57291] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1521), 1,
      sym_text_interpolation,
    ACTIONS(3346), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57318] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(3348), 1,
      anon_sym_EQ,
    STATE(1522), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3043), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3041), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [57347] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(865), 1,
      sym_arguments,
    STATE(1523), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57376] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3350), 1,
      sym_name,
    ACTIONS(3352), 1,
      anon_sym_LBRACE,
    STATE(1524), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(709), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57405] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3276), 1,
      sym_name,
    ACTIONS(3278), 1,
      anon_sym_LBRACE,
    STATE(682), 1,
      sym__reserved_identifier,
    STATE(1525), 1,
      sym_text_interpolation,
    STATE(852), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [57436] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1564), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3354), 1,
      sym_name,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    STATE(1526), 1,
      sym_text_interpolation,
    ACTIONS(3356), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(769), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57465] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1564), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3360), 1,
      sym_name,
    ACTIONS(3362), 1,
      anon_sym_LBRACE,
    STATE(1527), 1,
      sym_text_interpolation,
    ACTIONS(3356), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(764), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57494] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3222), 1,
      sym_name,
    ACTIONS(3226), 1,
      anon_sym_LBRACE,
    STATE(1528), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(582), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57523] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_PIPE,
    STATE(1529), 2,
      sym_text_interpolation,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3216), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3214), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [57548] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1530), 1,
      sym_text_interpolation,
    ACTIONS(2825), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [57569] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3367), 1,
      sym_name,
    ACTIONS(3369), 1,
      anon_sym_LBRACE,
    STATE(1531), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(578), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57598] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3371), 1,
      anon_sym_PIPE,
    STATE(1532), 2,
      sym_text_interpolation,
      aux_sym_union_type_repeat1,
    ACTIONS(3210), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3208), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [57623] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1957), 1,
      anon_sym_COLON,
    STATE(1533), 1,
      sym_text_interpolation,
    ACTIONS(1654), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57648] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3374), 1,
      sym_name,
    ACTIONS(3376), 1,
      anon_sym_LBRACE,
    STATE(1534), 1,
      sym_text_interpolation,
    STATE(1600), 1,
      sym__reserved_identifier,
    STATE(716), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [57679] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_name,
    ACTIONS(3268), 1,
      anon_sym_LBRACE,
    STATE(1535), 1,
      sym_text_interpolation,
    STATE(1582), 1,
      sym__reserved_identifier,
    STATE(1586), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [57710] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3374), 1,
      sym_name,
    ACTIONS(3376), 1,
      anon_sym_LBRACE,
    STATE(1536), 1,
      sym_text_interpolation,
    STATE(1600), 1,
      sym__reserved_identifier,
    STATE(1577), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [57741] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1537), 1,
      sym_text_interpolation,
    ACTIONS(3378), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57768] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3367), 1,
      sym_name,
    ACTIONS(3369), 1,
      anon_sym_LBRACE,
    STATE(1538), 1,
      sym_text_interpolation,
    ACTIONS(3224), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(578), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57797] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(596), 1,
      sym_arguments,
    STATE(1539), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57826] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1558), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3380), 1,
      sym_name,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(1540), 1,
      sym_text_interpolation,
    ACTIONS(3308), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(656), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57855] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3384), 1,
      sym_name,
    ACTIONS(3386), 1,
      anon_sym_LBRACE,
    STATE(1541), 1,
      sym_text_interpolation,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(713), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [57884] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_COMMA,
    ACTIONS(3202), 1,
      anon_sym_RPAREN,
    STATE(1542), 1,
      sym_text_interpolation,
    STATE(2167), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57910] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(3390), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    STATE(1377), 1,
      sym_use_list,
    STATE(1543), 1,
      sym_text_interpolation,
    STATE(1666), 1,
      aux_sym_base_clause_repeat1,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57942] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_RPAREN,
    STATE(1544), 1,
      sym_text_interpolation,
    STATE(2207), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [57968] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1545), 1,
      sym_text_interpolation,
    STATE(1889), 1,
      sym_named_type,
    STATE(2135), 1,
      sym_type_list,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
  [58002] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(927), 1,
      sym_declaration_list,
    STATE(1546), 1,
      sym_text_interpolation,
    STATE(1661), 1,
      sym_arguments,
    STATE(1942), 1,
      sym_base_clause,
    STATE(2251), 1,
      sym_class_interface_clause,
  [58036] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3400), 1,
      anon_sym_AMP,
    ACTIONS(3402), 1,
      anon_sym_PIPE,
    STATE(1547), 1,
      sym_text_interpolation,
    STATE(1697), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1750), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1752), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3118), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [58066] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1899), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2833), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3135), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1548), 1,
      sym_text_interpolation,
    ACTIONS(1654), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58092] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(975), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3404), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3407), 1,
      aux_sym_finally_clause_token1,
    ACTIONS(973), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    STATE(1549), 2,
      sym_text_interpolation,
      aux_sym_try_statement_repeat1,
    STATE(1742), 2,
      sym_catch_clause,
      sym_finally_clause,
  [58120] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(985), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3410), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3412), 1,
      aux_sym_finally_clause_token1,
    STATE(1549), 1,
      aux_sym_try_statement_repeat1,
    STATE(1550), 1,
      sym_text_interpolation,
    ACTIONS(983), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    STATE(1742), 2,
      sym_catch_clause,
      sym_finally_clause,
  [58150] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(915), 1,
      sym_declaration_list,
    STATE(1551), 1,
      sym_text_interpolation,
    STATE(1655), 1,
      sym_arguments,
    STATE(1929), 1,
      sym_base_clause,
    STATE(2327), 1,
      sym_class_interface_clause,
  [58184] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1136), 1,
      sym_declaration_list,
    STATE(1552), 1,
      sym_text_interpolation,
    STATE(1622), 1,
      sym_arguments,
    STATE(1791), 1,
      sym_base_clause,
    STATE(2457), 1,
      sym_class_interface_clause,
  [58218] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1553), 1,
      sym_text_interpolation,
    STATE(1889), 1,
      sym_named_type,
    STATE(2131), 1,
      sym_type_list,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
  [58252] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1046), 1,
      sym_declaration_list,
    STATE(1554), 1,
      sym_text_interpolation,
    STATE(1601), 1,
      sym_arguments,
    STATE(1840), 1,
      sym_base_clause,
    STATE(2263), 1,
      sym_class_interface_clause,
  [58286] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_COMMA,
    ACTIONS(3190), 1,
      anon_sym_RPAREN,
    STATE(1555), 1,
      sym_text_interpolation,
    STATE(2142), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58312] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1556), 1,
      sym_text_interpolation,
    ACTIONS(1652), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(1650), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [58333] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1557), 1,
      sym_text_interpolation,
    ACTIONS(3416), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3418), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [58354] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3420), 1,
      anon_sym_AMP,
    ACTIONS(3426), 1,
      anon_sym_PIPE,
    STATE(1558), 1,
      sym_text_interpolation,
    STATE(1713), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1714), 1,
      aux_sym_union_type_repeat1,
    STATE(1841), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3118), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [58383] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1559), 1,
      sym_text_interpolation,
    ACTIONS(1660), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(1658), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [58404] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1560), 1,
      sym_text_interpolation,
    ACTIONS(3346), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58425] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    ACTIONS(3428), 1,
      sym_name,
    STATE(1561), 1,
      sym_text_interpolation,
    STATE(1614), 1,
      sym_formal_parameters,
    STATE(2486), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [58452] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1562), 1,
      sym_text_interpolation,
    ACTIONS(1955), 3,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
    ACTIONS(1953), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [58473] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(3432), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1563), 1,
      sym_text_interpolation,
    STATE(2056), 1,
      sym_namespace_aliasing_clause,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3430), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58500] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1564), 1,
      sym_text_interpolation,
    ACTIONS(1664), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(1662), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [58521] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(754), 1,
      sym_arguments,
    STATE(1565), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58544] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1678), 1,
      anon_sym_LPAREN,
    STATE(613), 1,
      sym_arguments,
    STATE(1566), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58567] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(786), 1,
      sym_arguments,
    STATE(1567), 1,
      sym_text_interpolation,
    ACTIONS(1761), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58590] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(803), 1,
      sym_arguments,
    STATE(1568), 1,
      sym_text_interpolation,
    ACTIONS(1789), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58613] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(797), 1,
      sym_arguments,
    STATE(1569), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58636] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(754), 1,
      sym_arguments,
    STATE(1570), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58659] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3434), 1,
      sym_name,
    STATE(1571), 1,
      sym_text_interpolation,
    STATE(1715), 1,
      sym_reference_modifier,
    STATE(2336), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [58686] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3438), 1,
      anon_sym_DASH,
    STATE(1572), 1,
      sym_text_interpolation,
    STATE(2590), 1,
      sym__simple_string_array_access_argument,
    ACTIONS(3436), 2,
      sym_integer,
      sym_name,
    STATE(2673), 2,
      sym__simple_string_subscript_unary_expression,
      sym_variable_name,
  [58713] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    STATE(797), 1,
      sym_arguments,
    STATE(1573), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58736] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3438), 1,
      anon_sym_DASH,
    STATE(1574), 1,
      sym_text_interpolation,
    STATE(2587), 1,
      sym__simple_string_array_access_argument,
    ACTIONS(3436), 2,
      sym_integer,
      sym_name,
    STATE(2673), 2,
      sym__simple_string_subscript_unary_expression,
      sym_variable_name,
  [58763] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(865), 1,
      sym_arguments,
    STATE(1575), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58786] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1576), 1,
      sym_text_interpolation,
    ACTIONS(3440), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(2948), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [58807] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(742), 1,
      sym_arguments,
    STATE(1577), 1,
      sym_text_interpolation,
    ACTIONS(1614), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58830] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1578), 1,
      sym_text_interpolation,
    ACTIONS(3178), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3184), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [58851] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1579), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58874] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3444), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3447), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3442), 2,
      anon_sym_RBRACE,
      aux_sym_switch_block_token1,
    STATE(1580), 2,
      sym_text_interpolation,
      aux_sym_switch_block_repeat1,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [58899] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3438), 1,
      anon_sym_DASH,
    STATE(1581), 1,
      sym_text_interpolation,
    STATE(2680), 1,
      sym__simple_string_array_access_argument,
    ACTIONS(3436), 2,
      sym_integer,
      sym_name,
    STATE(2673), 2,
      sym__simple_string_subscript_unary_expression,
      sym_variable_name,
  [58926] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(894), 1,
      sym_arguments,
    STATE(1582), 1,
      sym_text_interpolation,
    ACTIONS(1789), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [58949] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1583), 1,
      sym_text_interpolation,
    ACTIONS(3450), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3452), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [58970] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(1584), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3043), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [58993] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1585), 1,
      sym_text_interpolation,
    ACTIONS(3454), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3456), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [59014] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(894), 1,
      sym_arguments,
    STATE(1586), 1,
      sym_text_interpolation,
    ACTIONS(1614), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59037] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(865), 1,
      sym_arguments,
    STATE(1587), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59060] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    ACTIONS(3428), 1,
      sym_name,
    STATE(1588), 1,
      sym_text_interpolation,
    STATE(1644), 1,
      sym_formal_parameters,
    STATE(2486), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [59087] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1589), 1,
      sym_text_interpolation,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59108] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(870), 1,
      sym_arguments,
    STATE(1590), 1,
      sym_text_interpolation,
    ACTIONS(1761), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59131] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(596), 1,
      sym_arguments,
    STATE(1591), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59154] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(666), 1,
      sym_arguments,
    STATE(1592), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59177] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1726), 1,
      anon_sym_LPAREN,
    STATE(666), 1,
      sym_arguments,
    STATE(1593), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59200] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(727), 1,
      sym_arguments,
    STATE(1594), 1,
      sym_text_interpolation,
    ACTIONS(1761), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59223] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(220), 1,
      anon_sym_BSLASH,
    ACTIONS(567), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1706), 1,
      sym_name,
    STATE(1446), 1,
      sym_qualified_name,
    STATE(1595), 1,
      sym_text_interpolation,
    STATE(2148), 1,
      sym_named_type,
    STATE(2656), 1,
      sym_namespace_name,
    STATE(2691), 1,
      sym_namespace_name_as_prefix,
  [59254] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1596), 1,
      sym_text_interpolation,
    ACTIONS(3378), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59275] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1597), 1,
      sym_text_interpolation,
    ACTIONS(3458), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3460), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [59296] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3155), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(3157), 1,
      aux_sym_use_instead_of_clause_token1,
    STATE(1598), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59319] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1599), 1,
      sym_text_interpolation,
    ACTIONS(3462), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3464), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [59340] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    STATE(742), 1,
      sym_arguments,
    STATE(1600), 1,
      sym_text_interpolation,
    ACTIONS(1789), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [59363] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1143), 1,
      sym_declaration_list,
    STATE(1601), 1,
      sym_text_interpolation,
    STATE(1900), 1,
      sym_base_clause,
    STATE(2421), 1,
      sym_class_interface_clause,
  [59391] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3450), 1,
      anon_sym_BSLASHu,
    STATE(1602), 1,
      sym_text_interpolation,
    ACTIONS(3452), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [59411] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1140), 1,
      sym_compound_statement,
    STATE(1603), 1,
      sym_text_interpolation,
    STATE(1827), 1,
      sym_anonymous_function_use_clause,
    STATE(2484), 1,
      sym__return_type,
  [59439] = 9,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3472), 1,
      sym_php_tag,
    ACTIONS(3474), 1,
      aux_sym_text_token1,
    ACTIONS(3476), 1,
      aux_sym_text_token2,
    ACTIONS(3478), 1,
      sym__eof,
    STATE(1604), 1,
      sym_text_interpolation,
    STATE(1783), 1,
      aux_sym_text_repeat1,
    STATE(2224), 1,
      sym_text,
  [59467] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(442), 1,
      sym_declaration_list,
    STATE(1605), 1,
      sym_text_interpolation,
    STATE(1866), 1,
      sym_base_clause,
    STATE(2474), 1,
      sym_class_interface_clause,
  [59495] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_name,
    STATE(1606), 1,
      sym_text_interpolation,
    STATE(1825), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [59519] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(1607), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    STATE(2445), 1,
      sym_arguments,
    ACTIONS(3484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [59545] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_BSLASHu,
    STATE(1608), 1,
      sym_text_interpolation,
    ACTIONS(3464), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [59565] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3488), 1,
      anon_sym_BSLASHu,
    STATE(1609), 1,
      sym_text_interpolation,
    ACTIONS(3486), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [59585] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_BSLASHu,
    STATE(1610), 1,
      sym_text_interpolation,
    ACTIONS(3460), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [59605] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3178), 1,
      anon_sym_BSLASHu,
    STATE(1611), 1,
      sym_text_interpolation,
    ACTIONS(3184), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [59625] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3492), 1,
      anon_sym_BSLASHu,
    STATE(1612), 1,
      sym_text_interpolation,
    ACTIONS(3490), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [59645] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1070), 1,
      sym_compound_statement,
    STATE(1613), 1,
      sym_text_interpolation,
    STATE(1802), 1,
      sym_anonymous_function_use_clause,
    STATE(2410), 1,
      sym__return_type,
  [59673] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1073), 1,
      sym_compound_statement,
    STATE(1614), 1,
      sym_text_interpolation,
    STATE(1814), 1,
      sym_anonymous_function_use_clause,
    STATE(2356), 1,
      sym__return_type,
  [59701] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_name,
    STATE(1615), 1,
      sym_text_interpolation,
    STATE(2158), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [59725] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_name,
    STATE(1616), 1,
      sym_text_interpolation,
    STATE(1880), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [59749] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_name,
    STATE(1617), 1,
      sym_text_interpolation,
    STATE(1888), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [59773] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3494), 1,
      aux_sym_if_statement_token2,
    ACTIONS(3496), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3498), 1,
      aux_sym_else_clause_token1,
    STATE(1618), 1,
      sym_text_interpolation,
    STATE(1637), 1,
      aux_sym_if_statement_repeat2,
    STATE(2173), 1,
      sym_else_if_clause_2,
    STATE(2626), 1,
      sym_else_clause_2,
  [59801] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_RBRACE,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    STATE(1619), 1,
      sym_text_interpolation,
    STATE(1638), 1,
      aux_sym_switch_block_repeat1,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [59827] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3506), 1,
      aux_sym_switch_block_token1,
    STATE(1620), 1,
      sym_text_interpolation,
    STATE(1639), 1,
      aux_sym_switch_block_repeat1,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [59853] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(1621), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3508), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [59875] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1052), 1,
      sym_declaration_list,
    STATE(1622), 1,
      sym_text_interpolation,
    STATE(1839), 1,
      sym_base_clause,
    STATE(2268), 1,
      sym_class_interface_clause,
  [59903] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3510), 1,
      anon_sym_BSLASHu,
    STATE(1623), 1,
      sym_text_interpolation,
    ACTIONS(3098), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [59923] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3512), 1,
      anon_sym_BSLASHu,
    STATE(1624), 1,
      sym_text_interpolation,
    ACTIONS(3078), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [59943] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(445), 1,
      sym_declaration_list,
    STATE(1625), 1,
      sym_text_interpolation,
    STATE(1850), 1,
      sym_base_clause,
    STATE(2226), 1,
      sym_class_interface_clause,
  [59971] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_name,
    STATE(1626), 1,
      sym_text_interpolation,
    STATE(1851), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [59995] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_declaration_list,
    STATE(1627), 1,
      sym_text_interpolation,
    STATE(1857), 1,
      sym_base_clause,
    STATE(2229), 1,
      sym_class_interface_clause,
  [60023] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1051), 1,
      sym_compound_statement,
    STATE(1628), 1,
      sym_text_interpolation,
    STATE(1941), 1,
      sym_anonymous_function_use_clause,
    STATE(2246), 1,
      sym__return_type,
  [60051] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3514), 1,
      aux_sym_switch_block_token1,
    STATE(1580), 1,
      aux_sym_switch_block_repeat1,
    STATE(1629), 1,
      sym_text_interpolation,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [60077] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3496), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3498), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3516), 1,
      aux_sym_if_statement_token2,
    STATE(1630), 1,
      sym_text_interpolation,
    STATE(1693), 1,
      aux_sym_if_statement_repeat2,
    STATE(2173), 1,
      sym_else_if_clause_2,
    STATE(2553), 1,
      sym_else_clause_2,
  [60105] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_name,
    STATE(1631), 1,
      sym_text_interpolation,
    STATE(1925), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [60129] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3518), 1,
      aux_sym_switch_block_token1,
    STATE(1629), 1,
      aux_sym_switch_block_repeat1,
    STATE(1632), 1,
      sym_text_interpolation,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [60155] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3496), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3498), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3520), 1,
      aux_sym_if_statement_token2,
    STATE(1630), 1,
      aux_sym_if_statement_repeat2,
    STATE(1633), 1,
      sym_text_interpolation,
    STATE(2173), 1,
      sym_else_if_clause_2,
    STATE(2568), 1,
      sym_else_clause_2,
  [60183] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    STATE(1634), 1,
      sym_text_interpolation,
    STATE(1883), 1,
      aux_sym_base_clause_repeat1,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3524), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [60209] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1041), 1,
      sym_compound_statement,
    STATE(1635), 1,
      sym_text_interpolation,
    STATE(1856), 1,
      sym_anonymous_function_use_clause,
    STATE(2225), 1,
      sym__return_type,
  [60237] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3482), 1,
      sym_name,
    STATE(1636), 1,
      sym_text_interpolation,
    STATE(1930), 1,
      sym_const_element,
    STATE(2594), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [60261] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3496), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3498), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3526), 1,
      aux_sym_if_statement_token2,
    STATE(1637), 1,
      sym_text_interpolation,
    STATE(1693), 1,
      aux_sym_if_statement_repeat2,
    STATE(2173), 1,
      sym_else_if_clause_2,
    STATE(2525), 1,
      sym_else_clause_2,
  [60289] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3528), 1,
      anon_sym_RBRACE,
    STATE(1580), 1,
      aux_sym_switch_block_repeat1,
    STATE(1638), 1,
      sym_text_interpolation,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [60315] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3530), 1,
      aux_sym_switch_block_token1,
    STATE(1580), 1,
      aux_sym_switch_block_repeat1,
    STATE(1639), 1,
      sym_text_interpolation,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [60341] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3450), 1,
      anon_sym_BSLASHu,
    STATE(1640), 1,
      sym_text_interpolation,
    ACTIONS(3452), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [60361] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_BSLASHu,
    STATE(1641), 1,
      sym_text_interpolation,
    ACTIONS(3456), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [60381] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_declaration_list,
    STATE(1642), 1,
      sym_text_interpolation,
    STATE(1895), 1,
      sym_base_clause,
    STATE(2452), 1,
      sym_class_interface_clause,
  [60409] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1114), 1,
      sym_compound_statement,
    STATE(1643), 1,
      sym_text_interpolation,
    STATE(1908), 1,
      sym_anonymous_function_use_clause,
    STATE(2460), 1,
      sym__return_type,
  [60437] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1113), 1,
      sym_compound_statement,
    STATE(1644), 1,
      sym_text_interpolation,
    STATE(1914), 1,
      sym_anonymous_function_use_clause,
    STATE(2404), 1,
      sym__return_type,
  [60465] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_declaration_list,
    STATE(1645), 1,
      sym_text_interpolation,
    STATE(1923), 1,
      sym_base_clause,
    STATE(2478), 1,
      sym_class_interface_clause,
  [60493] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3390), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    STATE(1377), 1,
      sym_use_list,
    STATE(1646), 1,
      sym_text_interpolation,
    STATE(1666), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [60519] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3462), 1,
      anon_sym_BSLASHu,
    STATE(1647), 1,
      sym_text_interpolation,
    ACTIONS(3464), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [60539] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1648), 1,
      sym_text_interpolation,
    STATE(1733), 1,
      sym_declaration_list,
    STATE(1896), 1,
      sym_base_clause,
    STATE(2469), 1,
      sym_class_interface_clause,
  [60567] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(923), 1,
      sym_compound_statement,
    STATE(1649), 1,
      sym_text_interpolation,
    STATE(1897), 1,
      sym_anonymous_function_use_clause,
    STATE(2480), 1,
      sym__return_type,
  [60595] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1650), 1,
      sym_text_interpolation,
    STATE(1768), 1,
      sym_declaration_list,
    STATE(1901), 1,
      sym_base_clause,
    STATE(2438), 1,
      sym_class_interface_clause,
  [60623] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(952), 1,
      sym_compound_statement,
    STATE(1651), 1,
      sym_text_interpolation,
    STATE(1904), 1,
      sym_anonymous_function_use_clause,
    STATE(2425), 1,
      sym__return_type,
  [60651] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(951), 1,
      sym_compound_statement,
    STATE(1652), 1,
      sym_text_interpolation,
    STATE(1907), 1,
      sym_anonymous_function_use_clause,
    STATE(2414), 1,
      sym__return_type,
  [60679] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1653), 1,
      sym_text_interpolation,
    STATE(1747), 1,
      sym_declaration_list,
    STATE(1910), 1,
      sym_base_clause,
    STATE(2413), 1,
      sym_class_interface_clause,
  [60707] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_declaration_list,
    STATE(1654), 1,
      sym_text_interpolation,
    STATE(1835), 1,
      sym_base_clause,
    STATE(2288), 1,
      sym_class_interface_clause,
  [60735] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(919), 1,
      sym_declaration_list,
    STATE(1655), 1,
      sym_text_interpolation,
    STATE(1913), 1,
      sym_base_clause,
    STATE(2397), 1,
      sym_class_interface_clause,
  [60763] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3532), 1,
      anon_sym_RBRACE,
    STATE(1580), 1,
      aux_sym_switch_block_repeat1,
    STATE(1656), 1,
      sym_text_interpolation,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [60789] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(929), 1,
      sym_compound_statement,
    STATE(1657), 1,
      sym_text_interpolation,
    STATE(1916), 1,
      sym_anonymous_function_use_clause,
    STATE(2368), 1,
      sym__return_type,
  [60817] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1658), 1,
      sym_text_interpolation,
    STATE(1702), 1,
      sym_declaration_list,
    STATE(1917), 1,
      sym_base_clause,
    STATE(2365), 1,
      sym_class_interface_clause,
  [60845] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(941), 1,
      sym_compound_statement,
    STATE(1659), 1,
      sym_text_interpolation,
    STATE(1921), 1,
      sym_anonymous_function_use_clause,
    STATE(2219), 1,
      sym__return_type,
  [60873] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1660), 1,
      sym_text_interpolation,
    STATE(1704), 1,
      sym_declaration_list,
    STATE(1927), 1,
      sym_base_clause,
    STATE(2341), 1,
      sym_class_interface_clause,
  [60901] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(916), 1,
      sym_declaration_list,
    STATE(1661), 1,
      sym_text_interpolation,
    STATE(1933), 1,
      sym_base_clause,
    STATE(2321), 1,
      sym_class_interface_clause,
  [60929] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3504), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3534), 1,
      anon_sym_RBRACE,
    STATE(1656), 1,
      aux_sym_switch_block_repeat1,
    STATE(1662), 1,
      sym_text_interpolation,
    STATE(1838), 2,
      sym_case_statement,
      sym_default_statement,
  [60955] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1098), 1,
      sym_compound_statement,
    STATE(1663), 1,
      sym_text_interpolation,
    STATE(1843), 1,
      sym_anonymous_function_use_clause,
    STATE(2264), 1,
      sym__return_type,
  [60983] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(914), 1,
      sym_compound_statement,
    STATE(1664), 1,
      sym_text_interpolation,
    STATE(1940), 1,
      sym_anonymous_function_use_clause,
    STATE(2270), 1,
      sym__return_type,
  [61011] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(910), 1,
      sym_compound_statement,
    STATE(1665), 1,
      sym_text_interpolation,
    STATE(1946), 1,
      sym_anonymous_function_use_clause,
    STATE(2248), 1,
      sym__return_type,
  [61039] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3390), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_use_list,
    STATE(1666), 1,
      sym_text_interpolation,
    STATE(1781), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3536), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61065] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1667), 1,
      sym_text_interpolation,
    STATE(1744), 1,
      sym_declaration_list,
    STATE(1936), 1,
      sym_base_clause,
    STATE(2283), 1,
      sym_class_interface_clause,
  [61093] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3466), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(926), 1,
      sym_compound_statement,
    STATE(1668), 1,
      sym_text_interpolation,
    STATE(1928), 1,
      sym_anonymous_function_use_clause,
    STATE(2343), 1,
      sym__return_type,
  [61121] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_BSLASHu,
    STATE(1669), 1,
      sym_text_interpolation,
    ACTIONS(1658), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [61141] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1660), 1,
      anon_sym_BSLASHu,
    STATE(1670), 1,
      sym_text_interpolation,
    ACTIONS(1658), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [61161] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_BSLASHu,
    STATE(1671), 1,
      sym_text_interpolation,
    ACTIONS(1662), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [61181] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1652), 1,
      anon_sym_BSLASHu,
    STATE(1672), 1,
      sym_text_interpolation,
    ACTIONS(1650), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [61201] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_BSLASHu,
    STATE(1673), 1,
      sym_text_interpolation,
    ACTIONS(1662), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [61221] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1652), 1,
      anon_sym_BSLASHu,
    STATE(1674), 1,
      sym_text_interpolation,
    ACTIONS(1650), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [61241] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_BSLASHu,
    STATE(1675), 1,
      sym_text_interpolation,
    ACTIONS(3460), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [61261] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3178), 1,
      anon_sym_BSLASHu,
    STATE(1676), 1,
      sym_text_interpolation,
    ACTIONS(3184), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [61281] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1005), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3538), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3541), 1,
      aux_sym_else_clause_token1,
    STATE(1677), 1,
      sym_text_interpolation,
    STATE(1727), 1,
      aux_sym_if_statement_repeat1,
    STATE(1982), 1,
      sym_else_if_clause,
    STATE(1996), 1,
      sym_else_clause,
  [61309] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(991), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3544), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3547), 1,
      aux_sym_else_clause_token1,
    STATE(1677), 1,
      aux_sym_if_statement_repeat1,
    STATE(1678), 1,
      sym_text_interpolation,
    STATE(1981), 1,
      sym_else_clause,
    STATE(1982), 1,
      sym_else_if_clause,
  [61337] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(991), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3550), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3552), 1,
      aux_sym_else_clause_token1,
    STATE(1679), 1,
      sym_text_interpolation,
    STATE(1680), 1,
      aux_sym_if_statement_repeat1,
    STATE(1981), 1,
      sym_else_clause,
    STATE(1982), 1,
      sym_else_if_clause,
  [61365] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1005), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3550), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3552), 1,
      aux_sym_else_clause_token1,
    STATE(1680), 1,
      sym_text_interpolation,
    STATE(1727), 1,
      aux_sym_if_statement_repeat1,
    STATE(1982), 1,
      sym_else_if_clause,
    STATE(1996), 1,
      sym_else_clause,
  [61393] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_BSLASHu,
    STATE(1681), 1,
      sym_text_interpolation,
    ACTIONS(3456), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [61413] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(2449), 1,
      anon_sym_COLON,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1668), 1,
      sym_formal_parameters,
    STATE(1682), 1,
      sym_text_interpolation,
    STATE(2470), 1,
      sym_reference_modifier,
  [61438] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_PIPE,
    STATE(1683), 1,
      sym_text_interpolation,
    STATE(1771), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3282), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [61459] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_COLON,
    STATE(1684), 1,
      sym_text_interpolation,
    STATE(1976), 1,
      sym_enum_declaration_list,
    STATE(2361), 1,
      sym_class_interface_clause,
  [61484] = 8,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(13), 1,
      aux_sym_text_token1,
    ACTIONS(15), 1,
      aux_sym_text_token2,
    ACTIONS(3560), 1,
      ts_builtin_sym_end,
    ACTIONS(3562), 1,
      sym_php_tag,
    STATE(1685), 1,
      sym_text_interpolation,
    STATE(1701), 1,
      aux_sym_text_repeat1,
  [61509] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_BSLASH,
    STATE(1686), 1,
      sym_text_interpolation,
    STATE(1695), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3564), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [61530] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3568), 1,
      sym_name,
    ACTIONS(3570), 1,
      anon_sym_BSLASH,
    STATE(544), 1,
      sym_compound_statement,
    STATE(1687), 1,
      sym_text_interpolation,
    STATE(1712), 1,
      sym_namespace_name,
  [61555] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3572), 1,
      sym_name,
    STATE(1688), 1,
      sym_text_interpolation,
    STATE(1860), 1,
      sym_namespace_name,
    STATE(2311), 1,
      sym_namespace_use_group_clause,
    ACTIONS(3574), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
  [61578] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1062), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1689), 1,
      sym_text_interpolation,
    ACTIONS(1060), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3576), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61599] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3578), 1,
      anon_sym_AMP,
    ACTIONS(3580), 1,
      anon_sym_RPAREN,
    STATE(1690), 1,
      sym_text_interpolation,
    STATE(2332), 2,
      sym_variable_name,
      sym_variable_reference,
  [61622] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(318), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3582), 1,
      sym_name,
    ACTIONS(3584), 1,
      anon_sym_LBRACE,
    STATE(1691), 1,
      sym_text_interpolation,
    STATE(616), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [61645] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1025), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1692), 1,
      sym_text_interpolation,
    ACTIONS(1023), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [61664] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3586), 1,
      aux_sym_if_statement_token2,
    ACTIONS(3588), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3591), 1,
      aux_sym_else_clause_token1,
    STATE(2173), 1,
      sym_else_if_clause_2,
    STATE(1693), 2,
      sym_text_interpolation,
      aux_sym_if_statement_repeat2,
  [61687] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1564), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3593), 1,
      sym_name,
    ACTIONS(3595), 1,
      anon_sym_LBRACE,
    STATE(1694), 1,
      sym_text_interpolation,
    STATE(799), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [61710] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_BSLASH,
    STATE(1695), 1,
      sym_text_interpolation,
    STATE(1777), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3597), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [61731] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_LBRACE,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3603), 1,
      anon_sym_DASH_GT,
    ACTIONS(3605), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3607), 1,
      anon_sym_LBRACK,
    STATE(1696), 1,
      sym_text_interpolation,
  [61756] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3400), 1,
      anon_sym_AMP,
    STATE(1697), 1,
      sym_text_interpolation,
    STATE(1717), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3163), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [61777] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_PIPE,
    STATE(1698), 1,
      sym_text_interpolation,
    STATE(1716), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3282), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [61798] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3611), 1,
      anon_sym_LBRACE,
    ACTIONS(3613), 1,
      anon_sym_DASH_GT,
    ACTIONS(3615), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3617), 1,
      anon_sym_LBRACK,
    STATE(1699), 1,
      sym_text_interpolation,
  [61823] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3410), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3412), 1,
      aux_sym_finally_clause_token1,
    STATE(1550), 1,
      aux_sym_try_statement_repeat1,
    STATE(1700), 1,
      sym_text_interpolation,
    STATE(1742), 2,
      sym_catch_clause,
      sym_finally_clause,
  [61846] = 7,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3619), 1,
      ts_builtin_sym_end,
    ACTIONS(3621), 1,
      sym_php_tag,
    ACTIONS(3623), 1,
      aux_sym_text_token1,
    ACTIONS(3626), 1,
      aux_sym_text_token2,
    STATE(1701), 2,
      sym_text_interpolation,
      aux_sym_text_repeat1,
  [61869] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1128), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1702), 1,
      sym_text_interpolation,
    ACTIONS(1126), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3629), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61890] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3633), 1,
      anon_sym_EQ,
    STATE(1703), 1,
      sym_text_interpolation,
    STATE(1979), 1,
      sym_property_initializer,
    ACTIONS(3631), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [61911] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1098), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1704), 1,
      sym_text_interpolation,
    ACTIONS(1096), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3635), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61932] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    ACTIONS(3637), 1,
      anon_sym_COLON,
    STATE(1705), 1,
      sym_text_interpolation,
    STATE(2024), 1,
      sym_enum_declaration_list,
    STATE(2300), 1,
      sym_class_interface_clause,
  [61957] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1074), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1706), 1,
      sym_text_interpolation,
    ACTIONS(1072), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3639), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61978] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_BSLASH,
    STATE(1707), 1,
      sym_text_interpolation,
    STATE(2043), 1,
      sym_compound_statement,
    ACTIONS(3641), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62001] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1044), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1708), 1,
      sym_text_interpolation,
    ACTIONS(1042), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [62020] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_PIPE,
    STATE(1683), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1709), 1,
      sym_text_interpolation,
    ACTIONS(3336), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [62041] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3645), 1,
      anon_sym_BSLASH,
    STATE(1710), 1,
      sym_text_interpolation,
    STATE(1763), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3564), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62062] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1068), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1711), 1,
      sym_text_interpolation,
    ACTIONS(1066), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3648), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62083] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_BSLASH,
    STATE(528), 1,
      sym_compound_statement,
    STATE(1712), 1,
      sym_text_interpolation,
    ACTIONS(3650), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62106] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3554), 1,
      anon_sym_PIPE,
    STATE(1713), 1,
      sym_text_interpolation,
    STATE(1771), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3304), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [62127] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3652), 1,
      anon_sym_PIPE,
    STATE(1714), 1,
      sym_text_interpolation,
    STATE(1784), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3294), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [62148] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3654), 1,
      sym_name,
    STATE(1715), 1,
      sym_text_interpolation,
    STATE(2345), 1,
      sym__reserved_identifier,
    ACTIONS(2361), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [62169] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3656), 1,
      anon_sym_PIPE,
    STATE(1716), 2,
      sym_text_interpolation,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3216), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62188] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3659), 1,
      anon_sym_AMP,
    STATE(1717), 2,
      sym_text_interpolation,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3170), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62207] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3662), 1,
      anon_sym_PIPE,
    STATE(1718), 2,
      sym_text_interpolation,
      aux_sym_union_type_repeat1,
    ACTIONS(3210), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62226] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1040), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1719), 1,
      sym_text_interpolation,
    ACTIONS(1038), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [62245] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_LBRACE,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3607), 1,
      anon_sym_LBRACK,
    ACTIONS(3665), 1,
      anon_sym_DASH_GT,
    ACTIONS(3667), 1,
      anon_sym_QMARK_DASH_GT,
    STATE(1720), 1,
      sym_text_interpolation,
  [62270] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1777), 1,
      anon_sym_DOLLAR,
    ACTIONS(3669), 1,
      sym_name,
    ACTIONS(3671), 1,
      anon_sym_LBRACE,
    STATE(1721), 1,
      sym_text_interpolation,
    STATE(864), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [62293] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_PIPE,
    STATE(1698), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1722), 1,
      sym_text_interpolation,
    ACTIONS(3336), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62314] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3599), 1,
      anon_sym_LBRACE,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3607), 1,
      anon_sym_LBRACK,
    ACTIONS(3673), 1,
      anon_sym_DASH_GT,
    ACTIONS(3675), 1,
      anon_sym_QMARK_DASH_GT,
    STATE(1723), 1,
      sym_text_interpolation,
  [62339] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_COLON,
    STATE(1724), 1,
      sym_text_interpolation,
    STATE(1971), 1,
      sym__return_type,
    ACTIONS(3677), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62360] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3432), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1725), 1,
      sym_text_interpolation,
    STATE(2056), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3430), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [62381] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1134), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1726), 1,
      sym_text_interpolation,
    ACTIONS(1132), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3681), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62402] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1031), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1033), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3683), 1,
      aux_sym_else_if_clause_token1,
    STATE(1982), 1,
      sym_else_if_clause,
    STATE(1727), 2,
      sym_text_interpolation,
      aux_sym_if_statement_repeat1,
  [62425] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3686), 1,
      sym_name,
    ACTIONS(3688), 1,
      anon_sym_LBRACE,
    ACTIONS(3690), 1,
      anon_sym_DOLLAR,
    STATE(1728), 1,
      sym_text_interpolation,
    STATE(1674), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [62448] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3692), 1,
      anon_sym_LBRACE,
    ACTIONS(3694), 1,
      anon_sym_DASH_GT,
    ACTIONS(3696), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3698), 1,
      anon_sym_LBRACK,
    STATE(1729), 1,
      sym_text_interpolation,
  [62473] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    ACTIONS(3702), 1,
      anon_sym_DASH_GT,
    ACTIONS(3704), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3706), 1,
      anon_sym_LBRACK,
    STATE(1730), 1,
      sym_text_interpolation,
  [62498] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(613), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3708), 1,
      sym_name,
    ACTIONS(3710), 1,
      anon_sym_LBRACE,
    STATE(1731), 1,
      sym_text_interpolation,
    STATE(592), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [62521] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3714), 1,
      anon_sym_BSLASH,
    STATE(1732), 2,
      sym_text_interpolation,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3712), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62540] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1092), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1733), 1,
      sym_text_interpolation,
    ACTIONS(1090), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3717), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62561] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    ACTIONS(3721), 1,
      anon_sym_COLON,
    STATE(563), 1,
      sym_enum_declaration_list,
    STATE(1734), 1,
      sym_text_interpolation,
    STATE(2476), 1,
      sym_class_interface_clause,
  [62586] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3692), 1,
      anon_sym_LBRACE,
    ACTIONS(3698), 1,
      anon_sym_LBRACK,
    ACTIONS(3723), 1,
      anon_sym_DASH_GT,
    ACTIONS(3725), 1,
      anon_sym_QMARK_DASH_GT,
    STATE(1735), 1,
      sym_text_interpolation,
  [62611] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3727), 1,
      sym_name,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(3731), 1,
      anon_sym_DOLLAR,
    STATE(1736), 1,
      sym_text_interpolation,
    STATE(1672), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [62634] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1104), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1737), 1,
      sym_text_interpolation,
    ACTIONS(1102), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3733), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62655] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3692), 1,
      anon_sym_LBRACE,
    ACTIONS(3698), 1,
      anon_sym_LBRACK,
    ACTIONS(3735), 1,
      anon_sym_DASH_GT,
    ACTIONS(3737), 1,
      anon_sym_QMARK_DASH_GT,
    STATE(1738), 1,
      sym_text_interpolation,
  [62680] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1140), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1739), 1,
      sym_text_interpolation,
    ACTIONS(1138), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3739), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62701] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3741), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3743), 1,
      aux_sym_finally_clause_token1,
    STATE(424), 1,
      aux_sym_try_statement_repeat1,
    STATE(1740), 1,
      sym_text_interpolation,
    STATE(430), 2,
      sym_catch_clause,
      sym_finally_clause,
  [62724] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3745), 1,
      anon_sym_LBRACE,
    ACTIONS(3747), 1,
      anon_sym_DASH_GT,
    ACTIONS(3749), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3751), 1,
      anon_sym_LBRACK,
    STATE(1741), 1,
      sym_text_interpolation,
  [62749] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1021), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1742), 1,
      sym_text_interpolation,
    ACTIONS(1019), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [62768] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1743), 1,
      sym_text_interpolation,
    ACTIONS(1596), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [62785] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1080), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1744), 1,
      sym_text_interpolation,
    ACTIONS(1078), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3753), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62806] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1086), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1745), 1,
      sym_text_interpolation,
    ACTIONS(1084), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3755), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62827] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1558), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3757), 1,
      sym_name,
    ACTIONS(3759), 1,
      anon_sym_LBRACE,
    STATE(1746), 1,
      sym_text_interpolation,
    STATE(671), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [62850] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1056), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1747), 1,
      sym_text_interpolation,
    ACTIONS(1054), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3761), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62871] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3568), 1,
      sym_name,
    ACTIONS(3570), 1,
      anon_sym_BSLASH,
    STATE(1707), 1,
      sym_namespace_name,
    STATE(1748), 1,
      sym_text_interpolation,
    STATE(2084), 1,
      sym_compound_statement,
  [62896] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_DOLLAR,
    ACTIONS(3763), 1,
      sym_name,
    ACTIONS(3765), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_text_interpolation,
    STATE(743), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [62919] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_PIPE,
    STATE(1716), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1750), 1,
      sym_text_interpolation,
    ACTIONS(3304), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62940] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3688), 1,
      anon_sym_LBRACE,
    ACTIONS(3690), 1,
      anon_sym_DOLLAR,
    ACTIONS(3767), 1,
      sym_name,
    STATE(1751), 1,
      sym_text_interpolation,
    STATE(1674), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [62963] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_PIPE,
    STATE(1718), 1,
      aux_sym_union_type_repeat1,
    STATE(1752), 1,
      sym_text_interpolation,
    ACTIONS(3294), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62984] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1753), 1,
      sym_text_interpolation,
    ACTIONS(3153), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [63001] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3679), 1,
      anon_sym_COLON,
    STATE(1754), 1,
      sym_text_interpolation,
    STATE(1995), 1,
      sym__return_type,
    ACTIONS(3771), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [63022] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1152), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1755), 1,
      sym_text_interpolation,
    ACTIONS(1150), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3773), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63043] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3729), 1,
      anon_sym_LBRACE,
    ACTIONS(3731), 1,
      anon_sym_DOLLAR,
    ACTIONS(3775), 1,
      sym_name,
    STATE(1756), 1,
      sym_text_interpolation,
    STATE(1672), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [63066] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3777), 1,
      sym_name,
    ACTIONS(3779), 1,
      anon_sym_LBRACE,
    ACTIONS(3781), 1,
      anon_sym_DOLLAR,
    STATE(1757), 1,
      sym_text_interpolation,
    STATE(1556), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [63089] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3779), 1,
      anon_sym_LBRACE,
    ACTIONS(3781), 1,
      anon_sym_DOLLAR,
    ACTIONS(3783), 1,
      sym_name,
    STATE(1758), 1,
      sym_text_interpolation,
    STATE(1556), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [63112] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    ACTIONS(3706), 1,
      anon_sym_LBRACK,
    ACTIONS(3785), 1,
      anon_sym_DASH_GT,
    ACTIONS(3787), 1,
      anon_sym_QMARK_DASH_GT,
    STATE(1759), 1,
      sym_text_interpolation,
  [63137] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    ACTIONS(3789), 1,
      anon_sym_LBRACE,
    STATE(1760), 1,
      sym_text_interpolation,
    STATE(2143), 1,
      aux_sym_base_clause_repeat1,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
  [63162] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1158), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1761), 1,
      sym_text_interpolation,
    ACTIONS(1156), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3791), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63183] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3793), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1762), 1,
      sym_text_interpolation,
    STATE(2132), 1,
      sym_reference_modifier,
    STATE(2134), 1,
      sym_variable_name,
  [63208] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3795), 1,
      anon_sym_BSLASH,
    STATE(1732), 1,
      aux_sym_namespace_name_repeat1,
    STATE(1763), 1,
      sym_text_interpolation,
    ACTIONS(3597), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [63229] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1110), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1764), 1,
      sym_text_interpolation,
    ACTIONS(1108), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3798), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63250] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1122), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1765), 1,
      sym_text_interpolation,
    ACTIONS(1120), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3800), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63271] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3578), 1,
      anon_sym_AMP,
    ACTIONS(3802), 1,
      anon_sym_RPAREN,
    STATE(1766), 1,
      sym_text_interpolation,
    STATE(2332), 2,
      sym_variable_name,
      sym_variable_reference,
  [63294] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(1767), 1,
      sym_text_interpolation,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3508), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [63315] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1146), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1768), 1,
      sym_text_interpolation,
    ACTIONS(1144), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3804), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63336] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3806), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1769), 1,
      sym_text_interpolation,
    STATE(2169), 1,
      sym_variable_name,
    STATE(2170), 1,
      sym_reference_modifier,
  [63361] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3808), 1,
      anon_sym_LBRACE,
    ACTIONS(3810), 1,
      anon_sym_DASH_GT,
    ACTIONS(3812), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3814), 1,
      anon_sym_LBRACK,
    STATE(1770), 1,
      sym_text_interpolation,
  [63386] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3816), 1,
      anon_sym_PIPE,
    STATE(1771), 2,
      sym_text_interpolation,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3216), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [63405] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3819), 1,
      sym_name,
    STATE(1772), 1,
      sym_text_interpolation,
    STATE(2098), 1,
      sym_visibility_modifier,
    ACTIONS(3821), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [63426] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1773), 1,
      sym_text_interpolation,
    ACTIONS(3139), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [63443] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1774), 1,
      sym_text_interpolation,
    ACTIONS(3043), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [63460] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1775), 1,
      sym_text_interpolation,
    ACTIONS(3143), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [63477] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(2449), 1,
      anon_sym_COLON,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1776), 1,
      sym_text_interpolation,
    STATE(2010), 1,
      sym_formal_parameters,
    STATE(2339), 1,
      sym_reference_modifier,
  [63502] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3823), 1,
      anon_sym_BSLASH,
    STATE(1777), 2,
      sym_text_interpolation,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3712), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [63521] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1116), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1778), 1,
      sym_text_interpolation,
    ACTIONS(1114), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3826), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63542] = 7,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3619), 1,
      sym__eof,
    ACTIONS(3621), 1,
      sym_php_tag,
    ACTIONS(3828), 1,
      aux_sym_text_token1,
    ACTIONS(3831), 1,
      aux_sym_text_token2,
    STATE(1779), 2,
      sym_text_interpolation,
      aux_sym_text_repeat1,
  [63565] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3572), 1,
      sym_name,
    STATE(1780), 1,
      sym_text_interpolation,
    STATE(1860), 1,
      sym_namespace_name,
    STATE(2192), 1,
      sym_namespace_use_group_clause,
    ACTIONS(3574), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
  [63588] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3834), 1,
      anon_sym_COMMA,
    STATE(1781), 2,
      sym_text_interpolation,
      aux_sym_base_clause_repeat1,
    ACTIONS(3508), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [63607] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_COLON,
    STATE(514), 1,
      sym_enum_declaration_list,
    STATE(1782), 1,
      sym_text_interpolation,
    STATE(2220), 1,
      sym_class_interface_clause,
  [63632] = 8,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3474), 1,
      aux_sym_text_token1,
    ACTIONS(3476), 1,
      aux_sym_text_token2,
    ACTIONS(3560), 1,
      sym__eof,
    ACTIONS(3562), 1,
      sym_php_tag,
    STATE(1779), 1,
      aux_sym_text_repeat1,
    STATE(1783), 1,
      sym_text_interpolation,
  [63657] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3839), 1,
      anon_sym_PIPE,
    STATE(1784), 2,
      sym_text_interpolation,
      aux_sym_union_type_repeat1,
    ACTIONS(3210), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [63676] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3578), 1,
      anon_sym_AMP,
    STATE(1785), 1,
      sym_text_interpolation,
    STATE(2165), 2,
      sym_variable_name,
      sym_variable_reference,
  [63696] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1786), 1,
      sym_text_interpolation,
    ACTIONS(3170), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
  [63712] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1659), 1,
      sym_formal_parameters,
    STATE(1787), 1,
      sym_text_interpolation,
    STATE(2317), 1,
      sym_reference_modifier,
  [63734] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1788), 1,
      sym_text_interpolation,
    ACTIONS(3842), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [63750] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1789), 1,
      sym_text_interpolation,
    ACTIONS(3194), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [63766] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1790), 1,
      sym_text_interpolation,
    ACTIONS(3508), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [63782] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1052), 1,
      sym_declaration_list,
    STATE(1791), 1,
      sym_text_interpolation,
    STATE(2268), 1,
      sym_class_interface_clause,
  [63804] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3846), 1,
      anon_sym_PIPE,
    ACTIONS(3844), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
    STATE(1792), 2,
      sym_text_interpolation,
      aux_sym_type_list_repeat1,
  [63822] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_EQ,
    ACTIONS(3851), 1,
      anon_sym_RPAREN,
    STATE(1793), 1,
      sym_text_interpolation,
    STATE(2195), 1,
      aux_sym__list_destructing_repeat1,
  [63844] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1794), 1,
      sym_text_interpolation,
    ACTIONS(3853), 2,
      sym_php_tag,
      aux_sym_text_token1,
    ACTIONS(3855), 2,
      sym__eof,
      aux_sym_text_token2,
  [63862] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1795), 1,
      sym_text_interpolation,
    ACTIONS(3857), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [63878] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3859), 1,
      anon_sym_SQUOTE,
    ACTIONS(3861), 1,
      aux_sym_string_token2,
    ACTIONS(3864), 1,
      sym_string_value,
    STATE(1796), 2,
      sym_text_interpolation,
      aux_sym_string_repeat1,
  [63898] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1797), 1,
      sym_text_interpolation,
    ACTIONS(3712), 4,
      anon_sym_COMMA,
      anon_sym_BSLASH,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [63914] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_COLON,
    ACTIONS(3570), 1,
      anon_sym_BSLASH,
    ACTIONS(3867), 1,
      sym_name,
    STATE(1798), 1,
      sym_text_interpolation,
    STATE(2593), 1,
      sym_namespace_name,
  [63936] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1799), 1,
      sym_text_interpolation,
    STATE(1852), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3869), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63956] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1643), 1,
      sym_formal_parameters,
    STATE(1800), 1,
      sym_text_interpolation,
    STATE(2342), 1,
      sym_reference_modifier,
  [63978] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1801), 1,
      sym_text_interpolation,
    STATE(2201), 1,
      sym_formal_parameters,
    STATE(2244), 1,
      sym_reference_modifier,
  [64000] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1062), 1,
      sym_compound_statement,
    STATE(1802), 1,
      sym_text_interpolation,
    STATE(2441), 1,
      sym__return_type,
  [64022] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1803), 1,
      sym_text_interpolation,
    STATE(1813), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3873), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64042] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3879), 1,
      anon_sym_COMMA,
    ACTIONS(3877), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1804), 2,
      sym_text_interpolation,
      aux_sym_function_static_declaration_repeat1,
  [64060] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(3578), 1,
      anon_sym_AMP,
    STATE(1805), 1,
      sym_text_interpolation,
    STATE(2332), 2,
      sym_variable_name,
      sym_variable_reference,
  [64080] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3884), 1,
      anon_sym_COMMA,
    ACTIONS(3882), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1806), 2,
      sym_text_interpolation,
      aux_sym_global_declaration_repeat1,
  [64098] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1807), 1,
      sym_text_interpolation,
    STATE(1808), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3887), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64118] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3893), 1,
      anon_sym_COMMA,
    ACTIONS(3891), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1808), 2,
      sym_text_interpolation,
      aux_sym_namespace_use_declaration_repeat1,
  [64136] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3898), 1,
      sym_nowdoc_string,
    ACTIONS(3896), 2,
      sym_heredoc_end,
      sym__new_line,
    STATE(1809), 2,
      sym_text_interpolation,
      aux_sym_nowdoc_body_repeat1,
  [64154] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1810), 1,
      sym_text_interpolation,
    ACTIONS(3901), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [64170] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3903), 1,
      anon_sym_AMP,
    ACTIONS(3170), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
    STATE(1811), 2,
      sym_text_interpolation,
      aux_sym_intersection_type_repeat1,
  [64188] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1652), 1,
      sym_formal_parameters,
    STATE(1812), 1,
      sym_text_interpolation,
    STATE(2372), 1,
      sym_reference_modifier,
  [64210] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3908), 1,
      anon_sym_COMMA,
    ACTIONS(3906), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1813), 2,
      sym_text_interpolation,
      aux_sym_property_declaration_repeat2,
  [64228] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1085), 1,
      sym_compound_statement,
    STATE(1814), 1,
      sym_text_interpolation,
    STATE(2315), 1,
      sym__return_type,
  [64250] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1808), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(1815), 1,
      sym_text_interpolation,
    ACTIONS(3911), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64270] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1816), 1,
      sym_text_interpolation,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3913), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64290] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1813), 1,
      aux_sym_property_declaration_repeat2,
    STATE(1817), 1,
      sym_text_interpolation,
    ACTIONS(3915), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64310] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(1818), 1,
      sym_text_interpolation,
    ACTIONS(3853), 2,
      sym_php_tag,
      aux_sym_text_token1,
    ACTIONS(3855), 2,
      ts_builtin_sym_end,
      aux_sym_text_token2,
  [64328] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3919), 1,
      anon_sym_COMMA,
    ACTIONS(3917), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(1819), 2,
      sym_text_interpolation,
      aux_sym__const_declaration_repeat1,
  [64346] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1803), 1,
      aux_sym_property_declaration_repeat2,
    STATE(1820), 1,
      sym_text_interpolation,
    ACTIONS(3922), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64366] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1813), 1,
      aux_sym_property_declaration_repeat2,
    STATE(1821), 1,
      sym_text_interpolation,
    ACTIONS(3924), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64386] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1635), 1,
      sym_formal_parameters,
    STATE(1822), 1,
      sym_text_interpolation,
    STATE(2362), 1,
      sym_reference_modifier,
  [64408] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3926), 1,
      anon_sym_SEMI,
    ACTIONS(3928), 1,
      anon_sym_LBRACE,
    ACTIONS(3930), 1,
      sym__automatic_semicolon,
    STATE(1384), 1,
      sym_compound_statement,
    STATE(1823), 1,
      sym_text_interpolation,
  [64430] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1824), 1,
      sym_text_interpolation,
    ACTIONS(3869), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64450] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1816), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1825), 1,
      sym_text_interpolation,
    ACTIONS(3932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64470] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    STATE(1826), 1,
      sym_text_interpolation,
    STATE(1883), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3524), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [64490] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1071), 1,
      sym_compound_statement,
    STATE(1827), 1,
      sym_text_interpolation,
    STATE(2344), 1,
      sym__return_type,
  [64512] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    STATE(489), 1,
      sym_enum_declaration_list,
    STATE(1828), 1,
      sym_text_interpolation,
    STATE(2355), 1,
      sym_class_interface_clause,
  [64534] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1829), 1,
      sym_text_interpolation,
    ACTIONS(3934), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [64550] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1665), 1,
      sym_formal_parameters,
    STATE(1830), 1,
      sym_text_interpolation,
    STATE(2218), 1,
      sym_reference_modifier,
  [64572] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1808), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(1831), 1,
      sym_text_interpolation,
    ACTIONS(3936), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64592] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1807), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(1832), 1,
      sym_text_interpolation,
    ACTIONS(3936), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64612] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(1806), 1,
      aux_sym_global_declaration_repeat1,
    STATE(1833), 1,
      sym_text_interpolation,
    ACTIONS(3938), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64632] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3944), 1,
      anon_sym_COMMA,
    STATE(1804), 1,
      aux_sym_function_static_declaration_repeat1,
    STATE(1834), 1,
      sym_text_interpolation,
    ACTIONS(3942), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64652] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(451), 1,
      sym_declaration_list,
    STATE(1835), 1,
      sym_text_interpolation,
    STATE(2405), 1,
      sym_class_interface_clause,
  [64674] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1836), 1,
      sym_text_interpolation,
    STATE(2115), 1,
      sym_formal_parameters,
    STATE(2416), 1,
      sym_reference_modifier,
  [64696] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1837), 1,
      sym_text_interpolation,
    ACTIONS(3934), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [64712] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1838), 1,
      sym_text_interpolation,
    ACTIONS(3946), 4,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_match_default_expression_token1,
      aux_sym_switch_block_token1,
  [64728] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1092), 1,
      sym_declaration_list,
    STATE(1839), 1,
      sym_text_interpolation,
    STATE(2419), 1,
      sym_class_interface_clause,
  [64750] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1143), 1,
      sym_declaration_list,
    STATE(1840), 1,
      sym_text_interpolation,
    STATE(2421), 1,
      sym_class_interface_clause,
  [64772] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3948), 1,
      anon_sym_AMP,
    STATE(1811), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1841), 1,
      sym_text_interpolation,
    ACTIONS(3163), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [64792] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1842), 1,
      sym_text_interpolation,
    STATE(2105), 1,
      sym_formal_parameters,
    STATE(2424), 1,
      sym_reference_modifier,
  [64814] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1076), 1,
      sym_compound_statement,
    STATE(1843), 1,
      sym_text_interpolation,
    STATE(2402), 1,
      sym__return_type,
  [64836] = 7,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3951), 1,
      anon_sym_SQUOTE,
    ACTIONS(3953), 1,
      aux_sym_string_token2,
    ACTIONS(3955), 1,
      sym_string_value,
    STATE(1796), 1,
      aux_sym_string_repeat1,
    STATE(1844), 1,
      sym_text_interpolation,
  [64858] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1845), 1,
      sym_text_interpolation,
    ACTIONS(3957), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [64874] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    STATE(1846), 1,
      sym_text_interpolation,
    STATE(2445), 1,
      sym_arguments,
    ACTIONS(3484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [64894] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1847), 1,
      sym_text_interpolation,
    STATE(2503), 1,
      sym_declare_directive,
    ACTIONS(3959), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [64912] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2983), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3961), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3963), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1848), 1,
      sym_text_interpolation,
    STATE(2532), 1,
      sym_static_modifier,
  [64934] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3967), 1,
      sym_nowdoc_string,
    STATE(1809), 1,
      aux_sym_nowdoc_body_repeat1,
    STATE(1849), 1,
      sym_text_interpolation,
    ACTIONS(3965), 2,
      sym_heredoc_end,
      sym__new_line,
  [64954] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_declaration_list,
    STATE(1850), 1,
      sym_text_interpolation,
    STATE(2437), 1,
      sym_class_interface_clause,
  [64976] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1851), 1,
      sym_text_interpolation,
    STATE(1899), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3969), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [64996] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1852), 1,
      sym_text_interpolation,
    ACTIONS(3971), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65016] = 7,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3953), 1,
      aux_sym_string_token2,
    ACTIONS(3955), 1,
      sym_string_value,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    STATE(1853), 1,
      sym_text_interpolation,
    STATE(1906), 1,
      aux_sym_string_repeat1,
  [65038] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1668), 1,
      sym_formal_parameters,
    STATE(1854), 1,
      sym_text_interpolation,
    STATE(2470), 1,
      sym_reference_modifier,
  [65060] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1855), 1,
      sym_text_interpolation,
    ACTIONS(3712), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LBRACE,
  [65076] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1111), 1,
      sym_compound_statement,
    STATE(1856), 1,
      sym_text_interpolation,
    STATE(2385), 1,
      sym__return_type,
  [65098] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_declaration_list,
    STATE(1857), 1,
      sym_text_interpolation,
    STATE(2375), 1,
      sym_class_interface_clause,
  [65120] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3975), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_declaration_list,
    STATE(1858), 1,
      sym_text_interpolation,
    STATE(2479), 1,
      sym_base_clause,
  [65142] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1824), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1859), 1,
      sym_text_interpolation,
    ACTIONS(3977), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65162] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3981), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1860), 1,
      sym_text_interpolation,
    STATE(2279), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3979), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [65182] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1861), 1,
      sym_text_interpolation,
    ACTIONS(3983), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [65198] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1862), 1,
      sym_text_interpolation,
    ACTIONS(3901), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [65214] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1831), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(1863), 1,
      sym_text_interpolation,
    ACTIONS(3985), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65234] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1864), 1,
      sym_text_interpolation,
    ACTIONS(3987), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65254] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2973), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2983), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3989), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1865), 1,
      sym_text_interpolation,
    STATE(2532), 1,
      sym_static_modifier,
  [65276] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_declaration_list,
    STATE(1866), 1,
      sym_text_interpolation,
    STATE(2320), 1,
      sym_class_interface_clause,
  [65298] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1867), 1,
      sym_text_interpolation,
    ACTIONS(3199), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [65314] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3944), 1,
      anon_sym_COMMA,
    STATE(1868), 1,
      sym_text_interpolation,
    STATE(1918), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3991), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65334] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(1869), 1,
      sym_text_interpolation,
    STATE(1919), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3993), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65354] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1870), 1,
      sym_text_interpolation,
    STATE(2595), 1,
      sym_declare_directive,
    ACTIONS(3959), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [65372] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1871), 1,
      sym_text_interpolation,
    STATE(1922), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65392] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3928), 1,
      anon_sym_LBRACE,
    ACTIONS(3997), 1,
      anon_sym_SEMI,
    ACTIONS(3999), 1,
      sym__automatic_semicolon,
    STATE(1375), 1,
      sym_compound_statement,
    STATE(1872), 1,
      sym_text_interpolation,
  [65414] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1873), 1,
      sym_text_interpolation,
    STATE(1905), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(4001), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65434] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(1833), 1,
      aux_sym_global_declaration_repeat1,
    STATE(1874), 1,
      sym_text_interpolation,
    ACTIONS(4003), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65454] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1875), 1,
      sym_text_interpolation,
    STATE(1931), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(4005), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65474] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3928), 1,
      anon_sym_LBRACE,
    ACTIONS(4007), 1,
      anon_sym_SEMI,
    ACTIONS(4009), 1,
      sym__automatic_semicolon,
    STATE(1380), 1,
      sym_compound_statement,
    STATE(1876), 1,
      sym_text_interpolation,
  [65496] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1877), 1,
      sym_text_interpolation,
    ACTIONS(4011), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65516] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3396), 1,
      aux_sym_base_clause_token1,
    STATE(1878), 1,
      sym_text_interpolation,
    STATE(2031), 1,
      sym_declaration_list,
    STATE(2326), 1,
      sym_base_clause,
  [65538] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4015), 1,
      anon_sym_EQ,
    STATE(1879), 1,
      sym_text_interpolation,
    ACTIONS(4013), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [65556] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1864), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1880), 1,
      sym_text_interpolation,
    ACTIONS(4017), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65576] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1603), 1,
      sym_formal_parameters,
    STATE(1881), 1,
      sym_text_interpolation,
    STATE(2280), 1,
      sym_reference_modifier,
  [65598] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3944), 1,
      anon_sym_COMMA,
    STATE(1834), 1,
      aux_sym_function_static_declaration_repeat1,
    STATE(1882), 1,
      sym_text_interpolation,
    ACTIONS(4019), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65618] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    STATE(1883), 1,
      sym_text_interpolation,
    STATE(1898), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(4021), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [65638] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1884), 1,
      sym_text_interpolation,
    ACTIONS(4023), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65658] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1877), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1885), 1,
      sym_text_interpolation,
    ACTIONS(4025), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65678] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1886), 1,
      sym_text_interpolation,
    ACTIONS(4025), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65698] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1613), 1,
      sym_formal_parameters,
    STATE(1887), 1,
      sym_text_interpolation,
    STATE(2403), 1,
      sym_reference_modifier,
  [65720] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1884), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1888), 1,
      sym_text_interpolation,
    ACTIONS(4027), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65740] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4031), 1,
      anon_sym_PIPE,
    STATE(1889), 1,
      sym_text_interpolation,
    STATE(1893), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(4029), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [65760] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1886), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1890), 1,
      sym_text_interpolation,
    ACTIONS(4033), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65780] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1891), 1,
      sym_text_interpolation,
    ACTIONS(3983), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [65796] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1892), 1,
      sym_text_interpolation,
    ACTIONS(1704), 4,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [65812] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4031), 1,
      anon_sym_PIPE,
    STATE(1792), 1,
      aux_sym_type_list_repeat1,
    STATE(1893), 1,
      sym_text_interpolation,
    ACTIONS(4035), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [65832] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1894), 1,
      sym_text_interpolation,
    ACTIONS(3210), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [65848] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_declaration_list,
    STATE(1895), 1,
      sym_text_interpolation,
    STATE(2250), 1,
      sym_class_interface_clause,
  [65870] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1726), 1,
      sym_declaration_list,
    STATE(1896), 1,
      sym_text_interpolation,
    STATE(2455), 1,
      sym_class_interface_clause,
  [65892] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(964), 1,
      sym_compound_statement,
    STATE(1897), 1,
      sym_text_interpolation,
    STATE(2456), 1,
      sym__return_type,
  [65914] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    ACTIONS(3508), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
    STATE(1898), 2,
      sym_text_interpolation,
      aux_sym_base_clause_repeat1,
  [65932] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1899), 1,
      sym_text_interpolation,
    ACTIONS(4040), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [65952] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1069), 1,
      sym_declaration_list,
    STATE(1900), 1,
      sym_text_interpolation,
    STATE(2334), 1,
      sym_class_interface_clause,
  [65974] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1737), 1,
      sym_declaration_list,
    STATE(1901), 1,
      sym_text_interpolation,
    STATE(2472), 1,
      sym_class_interface_clause,
  [65996] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1817), 1,
      aux_sym_property_declaration_repeat2,
    STATE(1902), 1,
      sym_text_interpolation,
    ACTIONS(4042), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66016] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    STATE(1903), 1,
      sym_text_interpolation,
    STATE(2178), 1,
      sym_enum_declaration_list,
    STATE(2473), 1,
      sym_class_interface_clause,
  [66038] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(949), 1,
      sym_compound_statement,
    STATE(1904), 1,
      sym_text_interpolation,
    STATE(2475), 1,
      sym__return_type,
  [66060] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1813), 1,
      aux_sym_property_declaration_repeat2,
    STATE(1905), 1,
      sym_text_interpolation,
    ACTIONS(4044), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66080] = 7,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3953), 1,
      aux_sym_string_token2,
    ACTIONS(3955), 1,
      sym_string_value,
    ACTIONS(4046), 1,
      anon_sym_SQUOTE,
    STATE(1796), 1,
      aux_sym_string_repeat1,
    STATE(1906), 1,
      sym_text_interpolation,
  [66102] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(944), 1,
      sym_compound_statement,
    STATE(1907), 1,
      sym_text_interpolation,
    STATE(2454), 1,
      sym__return_type,
  [66124] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1102), 1,
      sym_compound_statement,
    STATE(1908), 1,
      sym_text_interpolation,
    STATE(2266), 1,
      sym__return_type,
  [66146] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1909), 1,
      sym_text_interpolation,
    ACTIONS(4048), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66166] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1761), 1,
      sym_declaration_list,
    STATE(1910), 1,
      sym_text_interpolation,
    STATE(2481), 1,
      sym_class_interface_clause,
  [66188] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3928), 1,
      anon_sym_LBRACE,
    ACTIONS(4050), 1,
      anon_sym_SEMI,
    ACTIONS(4052), 1,
      sym__automatic_semicolon,
    STATE(1378), 1,
      sym_compound_statement,
    STATE(1911), 1,
      sym_text_interpolation,
  [66210] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3875), 1,
      anon_sym_COMMA,
    STATE(1821), 1,
      aux_sym_property_declaration_repeat2,
    STATE(1912), 1,
      sym_text_interpolation,
    ACTIONS(4054), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66230] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(935), 1,
      sym_declaration_list,
    STATE(1913), 1,
      sym_text_interpolation,
    STATE(2483), 1,
      sym_class_interface_clause,
  [66252] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1105), 1,
      sym_compound_statement,
    STATE(1914), 1,
      sym_text_interpolation,
    STATE(2267), 1,
      sym__return_type,
  [66274] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    STATE(479), 1,
      sym_enum_declaration_list,
    STATE(1915), 1,
      sym_text_interpolation,
    STATE(2278), 1,
      sym_class_interface_clause,
  [66296] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(967), 1,
      sym_compound_statement,
    STATE(1916), 1,
      sym_text_interpolation,
    STATE(2439), 1,
      sym__return_type,
  [66318] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1764), 1,
      sym_declaration_list,
    STATE(1917), 1,
      sym_text_interpolation,
    STATE(2435), 1,
      sym_class_interface_clause,
  [66340] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3944), 1,
      anon_sym_COMMA,
    STATE(1804), 1,
      aux_sym_function_static_declaration_repeat1,
    STATE(1918), 1,
      sym_text_interpolation,
    ACTIONS(4056), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66360] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(1806), 1,
      aux_sym_global_declaration_repeat1,
    STATE(1919), 1,
      sym_text_interpolation,
    ACTIONS(4058), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66380] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1815), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(1920), 1,
      sym_text_interpolation,
    ACTIONS(4060), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66400] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(958), 1,
      sym_compound_statement,
    STATE(1921), 1,
      sym_text_interpolation,
    STATE(2426), 1,
      sym__return_type,
  [66422] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3889), 1,
      anon_sym_COMMA,
    STATE(1808), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(1922), 1,
      sym_text_interpolation,
    ACTIONS(4060), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66442] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_declaration_list,
    STATE(1923), 1,
      sym_text_interpolation,
    STATE(2284), 1,
      sym_class_interface_clause,
  [66464] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1924), 1,
      sym_text_interpolation,
    ACTIONS(4062), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66484] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1909), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1925), 1,
      sym_text_interpolation,
    ACTIONS(4064), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66504] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1926), 1,
      sym_text_interpolation,
    ACTIONS(3216), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [66520] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1745), 1,
      sym_declaration_list,
    STATE(1927), 1,
      sym_text_interpolation,
    STATE(2409), 1,
      sym_class_interface_clause,
  [66542] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(920), 1,
      sym_compound_statement,
    STATE(1928), 1,
      sym_text_interpolation,
    STATE(2277), 1,
      sym__return_type,
  [66564] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(919), 1,
      sym_declaration_list,
    STATE(1929), 1,
      sym_text_interpolation,
    STATE(2397), 1,
      sym_class_interface_clause,
  [66586] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1930), 1,
      sym_text_interpolation,
    STATE(1939), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(4066), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66606] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1931), 1,
      sym_text_interpolation,
    ACTIONS(4068), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66626] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1932), 1,
      sym_text_interpolation,
    STATE(2507), 1,
      sym_declare_directive,
    ACTIONS(3959), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [66644] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(971), 1,
      sym_declaration_list,
    STATE(1933), 1,
      sym_text_interpolation,
    STATE(2394), 1,
      sym_class_interface_clause,
  [66666] = 7,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3953), 1,
      aux_sym_string_token2,
    ACTIONS(3955), 1,
      sym_string_value,
    ACTIONS(4070), 1,
      anon_sym_SQUOTE,
    STATE(1844), 1,
      aux_sym_string_repeat1,
    STATE(1934), 1,
      sym_text_interpolation,
  [66688] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3981), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1935), 1,
      sym_text_interpolation,
    STATE(2309), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(4072), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [66708] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1711), 1,
      sym_declaration_list,
    STATE(1936), 1,
      sym_text_interpolation,
    STATE(2281), 1,
      sym_class_interface_clause,
  [66730] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    STATE(1937), 1,
      sym_text_interpolation,
    STATE(1962), 1,
      sym_enum_declaration_list,
    STATE(2378), 1,
      sym_class_interface_clause,
  [66752] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1731), 1,
      anon_sym_AMP,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1938), 1,
      sym_text_interpolation,
    STATE(2010), 1,
      sym_formal_parameters,
    STATE(2339), 1,
      sym_reference_modifier,
  [66774] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1939), 1,
      sym_text_interpolation,
    ACTIONS(4074), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66794] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(911), 1,
      sym_compound_statement,
    STATE(1940), 1,
      sym_text_interpolation,
    STATE(2377), 1,
      sym__return_type,
  [66816] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(1095), 1,
      sym_compound_statement,
    STATE(1941), 1,
      sym_text_interpolation,
    STATE(2312), 1,
      sym__return_type,
  [66838] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    ACTIONS(3398), 1,
      aux_sym_class_interface_clause_token1,
    STATE(916), 1,
      sym_declaration_list,
    STATE(1942), 1,
      sym_text_interpolation,
    STATE(2321), 1,
      sym_class_interface_clause,
  [66860] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3871), 1,
      anon_sym_COMMA,
    STATE(1924), 1,
      aux_sym__const_declaration_repeat1,
    STATE(1943), 1,
      sym_text_interpolation,
    ACTIONS(4068), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [66880] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1944), 1,
      sym_text_interpolation,
    ACTIONS(3842), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [66896] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1945), 1,
      sym_text_interpolation,
    STATE(2623), 1,
      sym_declare_directive,
    ACTIONS(3959), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [66914] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    STATE(909), 1,
      sym_compound_statement,
    STATE(1946), 1,
      sym_text_interpolation,
    STATE(2370), 1,
      sym__return_type,
  [66936] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1947), 1,
      sym_text_interpolation,
    ACTIONS(4076), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [66951] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4078), 1,
      sym__new_line,
    ACTIONS(4080), 1,
      sym_heredoc_end,
    STATE(1948), 1,
      sym_text_interpolation,
    STATE(2429), 1,
      sym_heredoc_body,
  [66970] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1430), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1949), 1,
      sym_text_interpolation,
    ACTIONS(1428), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [66987] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_EQ,
    STATE(1950), 1,
      sym_text_interpolation,
    ACTIONS(4082), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [67004] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(829), 1,
      anon_sym_RBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4086), 1,
      anon_sym_COMMA,
    STATE(1951), 1,
      sym_text_interpolation,
    STATE(2199), 1,
      aux_sym_array_creation_expression_repeat1,
  [67023] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4090), 1,
      anon_sym_EQ,
    STATE(1952), 1,
      sym_text_interpolation,
    ACTIONS(4088), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [67040] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3109), 1,
      anon_sym_RBRACK,
    ACTIONS(4092), 1,
      anon_sym_COMMA,
    STATE(1953), 1,
      sym_text_interpolation,
    STATE(2202), 1,
      aux_sym_attribute_group_repeat1,
  [67059] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1430), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1954), 1,
      sym_text_interpolation,
    ACTIONS(1428), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67076] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(318), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1955), 1,
      sym_text_interpolation,
    STATE(1874), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [67093] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1326), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1956), 1,
      sym_text_interpolation,
    ACTIONS(1324), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67110] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1512), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1957), 1,
      sym_text_interpolation,
    ACTIONS(1510), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67127] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1314), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1958), 1,
      sym_text_interpolation,
    ACTIONS(1312), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67144] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4094), 1,
      anon_sym_COMMA,
    ACTIONS(4096), 1,
      anon_sym_RPAREN,
    STATE(1959), 1,
      sym_text_interpolation,
    STATE(2009), 1,
      aux_sym_arguments_repeat1,
  [67163] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1276), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1960), 1,
      sym_text_interpolation,
    ACTIONS(1274), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67180] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1294), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1961), 1,
      sym_text_interpolation,
    ACTIONS(1292), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67197] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1280), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1962), 1,
      sym_text_interpolation,
    ACTIONS(1278), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67214] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4098), 1,
      anon_sym_DQUOTE,
    ACTIONS(4100), 1,
      anon_sym_SQUOTE,
    ACTIONS(4102), 1,
      sym_heredoc_start,
    STATE(1963), 1,
      sym_text_interpolation,
  [67233] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4106), 1,
      anon_sym_EQ,
    STATE(1964), 1,
      sym_text_interpolation,
    ACTIONS(4104), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [67250] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_COMMA,
    ACTIONS(4110), 1,
      anon_sym_RBRACE,
    STATE(1965), 1,
      sym_text_interpolation,
    STATE(2162), 1,
      aux_sym_namespace_use_group_repeat1,
  [67269] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1220), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1966), 1,
      sym_text_interpolation,
    ACTIONS(1218), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67286] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1516), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1967), 1,
      sym_text_interpolation,
    ACTIONS(1514), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67303] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1212), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1968), 1,
      sym_text_interpolation,
    ACTIONS(1210), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67320] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1196), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1969), 1,
      sym_text_interpolation,
    ACTIONS(1194), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67337] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1264), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1970), 1,
      sym_text_interpolation,
    ACTIONS(1262), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67354] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1971), 1,
      sym_text_interpolation,
    ACTIONS(4112), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [67369] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(775), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4114), 1,
      anon_sym_COMMA,
    STATE(1972), 1,
      sym_text_interpolation,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
  [67388] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2981), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4116), 1,
      aux_sym_class_declaration_token1,
    STATE(1973), 1,
      sym_text_interpolation,
    STATE(2540), 1,
      sym_readonly_modifier,
  [67407] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1450), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1974), 1,
      sym_text_interpolation,
    ACTIONS(1448), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67424] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1785), 1,
      anon_sym_RPAREN,
    ACTIONS(4118), 1,
      anon_sym_COMMA,
    STATE(1975), 1,
      sym_text_interpolation,
    STATE(2183), 1,
      aux_sym_formal_parameters_repeat1,
  [67443] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1358), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1976), 1,
      sym_text_interpolation,
    ACTIONS(1356), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67460] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4120), 1,
      anon_sym_COMMA,
    ACTIONS(4122), 1,
      anon_sym_RPAREN,
    STATE(1977), 1,
      sym_text_interpolation,
    STATE(1985), 1,
      aux_sym_array_creation_expression_repeat1,
  [67479] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4124), 1,
      anon_sym_COMMA,
    ACTIONS(4127), 1,
      anon_sym_RPAREN,
    STATE(1978), 2,
      sym_text_interpolation,
      aux_sym_array_creation_expression_repeat1,
  [67496] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1979), 1,
      sym_text_interpolation,
    ACTIONS(4129), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [67511] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1310), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1980), 1,
      sym_text_interpolation,
    ACTIONS(1308), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67528] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1334), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1981), 1,
      sym_text_interpolation,
    ACTIONS(1332), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67545] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1338), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1982), 1,
      sym_text_interpolation,
    ACTIONS(1336), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67562] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1382), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1983), 1,
      sym_text_interpolation,
    ACTIONS(1380), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67579] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1386), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1984), 1,
      sym_text_interpolation,
    ACTIONS(1384), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67596] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(827), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4131), 1,
      anon_sym_COMMA,
    STATE(1978), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1985), 1,
      sym_text_interpolation,
  [67615] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1454), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1986), 1,
      sym_text_interpolation,
    ACTIONS(1452), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67632] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1458), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1987), 1,
      sym_text_interpolation,
    ACTIONS(1456), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67649] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1504), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1988), 1,
      sym_text_interpolation,
    ACTIONS(1502), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67666] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2981), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4133), 1,
      aux_sym_class_declaration_token1,
    STATE(1989), 1,
      sym_text_interpolation,
    STATE(2627), 1,
      sym_readonly_modifier,
  [67685] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1524), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1990), 1,
      sym_text_interpolation,
    ACTIONS(1522), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67702] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3570), 1,
      anon_sym_BSLASH,
    ACTIONS(3867), 1,
      sym_name,
    STATE(1991), 1,
      sym_text_interpolation,
    STATE(2593), 1,
      sym_namespace_name,
  [67721] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1992), 1,
      sym_text_interpolation,
    ACTIONS(4135), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [67736] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4139), 1,
      anon_sym_RBRACE,
    STATE(1993), 1,
      sym_text_interpolation,
    STATE(2040), 1,
      aux_sym_match_block_repeat1,
  [67755] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2981), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4141), 1,
      aux_sym_class_declaration_token1,
    STATE(1994), 1,
      sym_text_interpolation,
    STATE(2615), 1,
      sym_readonly_modifier,
  [67774] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1995), 1,
      sym_text_interpolation,
    ACTIONS(4143), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [67789] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1164), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1996), 1,
      sym_text_interpolation,
    ACTIONS(1162), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67806] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1446), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1997), 1,
      sym_text_interpolation,
    ACTIONS(1444), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67823] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1438), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1998), 1,
      sym_text_interpolation,
    ACTIONS(1436), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67840] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1422), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1999), 1,
      sym_text_interpolation,
    ACTIONS(1420), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67857] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1406), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2000), 1,
      sym_text_interpolation,
    ACTIONS(1404), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67874] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1168), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2001), 1,
      sym_text_interpolation,
    ACTIONS(1166), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67891] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1298), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2002), 1,
      sym_text_interpolation,
    ACTIONS(1296), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67908] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4145), 1,
      anon_sym_EQ_GT,
    STATE(2003), 1,
      sym_text_interpolation,
    STATE(2625), 1,
      sym__return_type,
  [67927] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1470), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2004), 1,
      sym_text_interpolation,
    ACTIONS(1468), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67944] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1540), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2005), 1,
      sym_text_interpolation,
    ACTIONS(1538), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [67961] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4078), 1,
      sym__new_line,
    ACTIONS(4147), 1,
      sym_heredoc_end,
    STATE(2006), 1,
      sym_text_interpolation,
    STATE(2398), 1,
      sym_heredoc_body,
  [67980] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4149), 1,
      sym__new_line,
    ACTIONS(4151), 1,
      sym_heredoc_end,
    STATE(2007), 1,
      sym_text_interpolation,
    STATE(2400), 1,
      sym_nowdoc_body,
  [67999] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1520), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2008), 1,
      sym_text_interpolation,
    ACTIONS(1518), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68016] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(777), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4153), 1,
      anon_sym_COMMA,
    STATE(2009), 1,
      sym_text_interpolation,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
  [68035] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4155), 1,
      anon_sym_EQ_GT,
    STATE(2010), 1,
      sym_text_interpolation,
    STATE(2499), 1,
      sym__return_type,
  [68054] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1374), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2011), 1,
      sym_text_interpolation,
    ACTIONS(1372), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68071] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1204), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2012), 1,
      sym_text_interpolation,
    ACTIONS(1202), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68088] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1462), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2013), 1,
      sym_text_interpolation,
    ACTIONS(1460), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68105] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1410), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2014), 1,
      sym_text_interpolation,
    ACTIONS(1408), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68122] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1394), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2015), 1,
      sym_text_interpolation,
    ACTIONS(1392), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68139] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4157), 1,
      anon_sym_COMMA,
    ACTIONS(4159), 1,
      anon_sym_RPAREN,
    STATE(1975), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(2016), 1,
      sym_text_interpolation,
  [68158] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1398), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2017), 1,
      sym_text_interpolation,
    ACTIONS(1396), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68175] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1204), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2018), 1,
      sym_text_interpolation,
    ACTIONS(1202), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68192] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1224), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2019), 1,
      sym_text_interpolation,
    ACTIONS(1222), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68209] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1402), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2020), 1,
      sym_text_interpolation,
    ACTIONS(1400), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68226] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1350), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2021), 1,
      sym_text_interpolation,
    ACTIONS(1348), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68243] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1434), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2022), 1,
      sym_text_interpolation,
    ACTIONS(1432), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68260] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4161), 1,
      anon_sym_LBRACE,
    ACTIONS(4163), 1,
      anon_sym_COLON,
    STATE(497), 1,
      sym_switch_block,
    STATE(2023), 1,
      sym_text_interpolation,
  [68279] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1536), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2024), 1,
      sym_text_interpolation,
    ACTIONS(1534), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68296] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1256), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2025), 1,
      sym_text_interpolation,
    ACTIONS(1254), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68313] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_EQ,
    STATE(2026), 1,
      sym_text_interpolation,
    ACTIONS(4165), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [68330] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1496), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2027), 1,
      sym_text_interpolation,
    ACTIONS(1494), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68347] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COMMA,
    ACTIONS(4169), 1,
      anon_sym_RBRACK,
    STATE(2028), 1,
      sym_text_interpolation,
    STATE(2091), 1,
      aux_sym__array_destructing_repeat1,
  [68366] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4171), 1,
      anon_sym_COMMA,
    ACTIONS(4173), 1,
      anon_sym_RBRACK,
    STATE(2029), 1,
      sym_text_interpolation,
    STATE(2092), 1,
      aux_sym_array_creation_expression_repeat1,
  [68385] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COMMA,
    ACTIONS(4169), 1,
      anon_sym_RBRACK,
    STATE(2030), 1,
      sym_text_interpolation,
    STATE(2093), 1,
      aux_sym__array_destructing_repeat1,
  [68404] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1548), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2031), 1,
      sym_text_interpolation,
    ACTIONS(1546), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68421] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1532), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2032), 1,
      sym_text_interpolation,
    ACTIONS(1530), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68438] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4175), 1,
      anon_sym_COMMA,
    ACTIONS(4177), 1,
      anon_sym_RBRACK,
    STATE(2033), 1,
      sym_text_interpolation,
    STATE(2094), 1,
      aux_sym_attribute_group_repeat1,
  [68457] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1346), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2034), 1,
      sym_text_interpolation,
    ACTIONS(1344), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68474] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1180), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2035), 1,
      sym_text_interpolation,
    ACTIONS(1178), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68491] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1330), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2036), 1,
      sym_text_interpolation,
    ACTIONS(1328), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68508] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4181), 1,
      sym_string_value,
    STATE(2037), 1,
      sym_text_interpolation,
    ACTIONS(4179), 2,
      anon_sym_SQUOTE,
      aux_sym_string_token2,
  [68525] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1528), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2038), 1,
      sym_text_interpolation,
    ACTIONS(1526), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68542] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4078), 1,
      sym__new_line,
    ACTIONS(4183), 1,
      sym_heredoc_end,
    STATE(2039), 1,
      sym_text_interpolation,
    STATE(2440), 1,
      sym_heredoc_body,
  [68561] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(867), 1,
      anon_sym_RBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4185), 1,
      anon_sym_COMMA,
    STATE(2040), 1,
      sym_text_interpolation,
    STATE(2156), 1,
      aux_sym_match_block_repeat1,
  [68580] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1306), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2041), 1,
      sym_text_interpolation,
    ACTIONS(1304), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68597] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1418), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2042), 1,
      sym_text_interpolation,
    ACTIONS(1416), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68614] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1414), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2043), 1,
      sym_text_interpolation,
    ACTIONS(1412), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68631] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3580), 1,
      anon_sym_RPAREN,
    ACTIONS(4187), 1,
      anon_sym_COMMA,
    STATE(2044), 1,
      sym_text_interpolation,
    STATE(2160), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [68650] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2981), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4189), 1,
      aux_sym_class_declaration_token1,
    STATE(2045), 1,
      sym_text_interpolation,
    STATE(2528), 1,
      sym_readonly_modifier,
  [68669] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1192), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2046), 1,
      sym_text_interpolation,
    ACTIONS(1190), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68686] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    STATE(1879), 1,
      sym_variable_name,
    STATE(2047), 1,
      sym_text_interpolation,
    STATE(2120), 1,
      sym_static_variable_declaration,
  [68705] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1378), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2048), 1,
      sym_text_interpolation,
    ACTIONS(1376), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68722] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1496), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2049), 1,
      sym_text_interpolation,
    ACTIONS(1494), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68739] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(318), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2050), 1,
      sym_text_interpolation,
    STATE(2121), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [68756] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    STATE(1703), 1,
      sym_variable_name,
    STATE(1820), 1,
      sym_property_element,
    STATE(2051), 1,
      sym_text_interpolation,
  [68775] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1370), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2052), 1,
      sym_text_interpolation,
    ACTIONS(1368), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68792] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1256), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2053), 1,
      sym_text_interpolation,
    ACTIONS(1254), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68809] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1354), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2054), 1,
      sym_text_interpolation,
    ACTIONS(1352), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68826] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    STATE(1703), 1,
      sym_variable_name,
    STATE(2055), 1,
      sym_text_interpolation,
    STATE(2153), 1,
      sym_property_element,
  [68845] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2056), 1,
      sym_text_interpolation,
    ACTIONS(4191), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [68860] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4078), 1,
      sym__new_line,
    ACTIONS(4193), 1,
      sym_heredoc_end,
    STATE(2057), 1,
      sym_text_interpolation,
    STATE(2227), 1,
      sym_heredoc_body,
  [68879] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1240), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2058), 1,
      sym_text_interpolation,
    ACTIONS(1238), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68896] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4195), 1,
      anon_sym_COMMA,
    ACTIONS(4197), 1,
      anon_sym_RBRACK,
    STATE(1953), 1,
      aux_sym_attribute_group_repeat1,
    STATE(2059), 1,
      sym_text_interpolation,
  [68915] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4199), 1,
      sym_name,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    STATE(2060), 1,
      sym_text_interpolation,
    STATE(2393), 1,
      sym_namespace_use_group,
  [68934] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4203), 1,
      anon_sym_COMMA,
    ACTIONS(4205), 1,
      anon_sym_RBRACK,
    STATE(1951), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(2061), 1,
      sym_text_interpolation,
  [68953] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1228), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2062), 1,
      sym_text_interpolation,
    ACTIONS(1226), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68970] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1276), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2063), 1,
      sym_text_interpolation,
    ACTIONS(1274), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [68987] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(4207), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2064), 1,
      sym_text_interpolation,
    STATE(2128), 1,
      sym_variable_name,
  [69006] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_COMMA,
    ACTIONS(4211), 1,
      anon_sym_RPAREN,
    STATE(2065), 1,
      sym_text_interpolation,
    STATE(2130), 1,
      aux_sym_formal_parameters_repeat1,
  [69025] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1188), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2066), 1,
      sym_text_interpolation,
    ACTIONS(1186), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69042] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4215), 1,
      anon_sym_EQ,
    STATE(2067), 1,
      sym_text_interpolation,
    ACTIONS(4213), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69059] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(3771), 1,
      anon_sym_LBRACE,
    STATE(2068), 1,
      sym_text_interpolation,
    STATE(2577), 1,
      sym__return_type,
  [69078] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1176), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2069), 1,
      sym_text_interpolation,
    ACTIONS(1174), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69095] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1268), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2070), 1,
      sym_text_interpolation,
    ACTIONS(1266), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69112] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4219), 1,
      anon_sym_EQ,
    STATE(2071), 1,
      sym_text_interpolation,
    ACTIONS(4217), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [69129] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_AMP,
    ACTIONS(4221), 1,
      anon_sym_RPAREN,
    STATE(1453), 1,
      aux_sym_intersection_type_repeat1,
    STATE(2072), 1,
      sym_text_interpolation,
  [69148] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1490), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2073), 1,
      sym_text_interpolation,
    ACTIONS(1488), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69165] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1232), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2074), 1,
      sym_text_interpolation,
    ACTIONS(1230), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69182] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1500), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2075), 1,
      sym_text_interpolation,
    ACTIONS(1498), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69199] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1290), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2076), 1,
      sym_text_interpolation,
    ACTIONS(1288), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69216] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2077), 1,
      sym_text_interpolation,
    ACTIONS(3508), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [69231] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1508), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2078), 1,
      sym_text_interpolation,
    ACTIONS(1506), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69248] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4223), 1,
      anon_sym_EQ_GT,
    STATE(2079), 1,
      sym_text_interpolation,
    STATE(2602), 1,
      sym__return_type,
  [69267] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1486), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2080), 1,
      sym_text_interpolation,
    ACTIONS(1484), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69284] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2081), 1,
      sym_text_interpolation,
    ACTIONS(3248), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [69299] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4227), 1,
      anon_sym_EQ,
    STATE(2082), 1,
      sym_text_interpolation,
    ACTIONS(4225), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [69316] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4229), 1,
      anon_sym_COMMA,
    ACTIONS(4231), 1,
      anon_sym_RPAREN,
    STATE(2083), 1,
      sym_text_interpolation,
    STATE(2164), 1,
      aux_sym_array_creation_expression_repeat1,
  [69335] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1474), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2084), 1,
      sym_text_interpolation,
    ACTIONS(1472), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69352] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1322), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2085), 1,
      sym_text_interpolation,
    ACTIONS(1320), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69369] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2086), 1,
      sym_text_interpolation,
    ACTIONS(2785), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      sym_name,
  [69384] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1260), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2087), 1,
      sym_text_interpolation,
    ACTIONS(1258), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69401] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1200), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2088), 1,
      sym_text_interpolation,
    ACTIONS(1198), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69418] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1390), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2089), 1,
      sym_text_interpolation,
    ACTIONS(1388), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69435] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
    STATE(2090), 1,
      sym_text_interpolation,
    STATE(2196), 1,
      aux_sym__list_destructing_repeat1,
  [69454] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4167), 1,
      anon_sym_COMMA,
    ACTIONS(4233), 1,
      anon_sym_RBRACK,
    STATE(2091), 1,
      sym_text_interpolation,
    STATE(2093), 1,
      aux_sym__array_destructing_repeat1,
  [69473] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(841), 1,
      anon_sym_RBRACK,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4235), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      sym_text_interpolation,
    STATE(2199), 1,
      aux_sym_array_creation_expression_repeat1,
  [69492] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4237), 1,
      anon_sym_COMMA,
    ACTIONS(4240), 1,
      anon_sym_RBRACK,
    STATE(2093), 2,
      sym_text_interpolation,
      aux_sym__array_destructing_repeat1,
  [69509] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3107), 1,
      anon_sym_RBRACK,
    ACTIONS(4242), 1,
      anon_sym_COMMA,
    STATE(2094), 1,
      sym_text_interpolation,
    STATE(2202), 1,
      aux_sym_attribute_group_repeat1,
  [69528] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1252), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2095), 1,
      sym_text_interpolation,
    ACTIONS(1250), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69545] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1244), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2096), 1,
      sym_text_interpolation,
    ACTIONS(1242), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69562] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1466), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2097), 1,
      sym_text_interpolation,
    ACTIONS(1464), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69579] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4244), 1,
      sym_name,
    STATE(2098), 1,
      sym_text_interpolation,
    ACTIONS(4246), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [69596] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4248), 1,
      anon_sym_COMMA,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    STATE(2099), 2,
      sym_text_interpolation,
      aux_sym_arguments_repeat1,
  [69613] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_COLON,
    ACTIONS(4253), 1,
      anon_sym_LPAREN,
    STATE(2100), 1,
      sym_text_interpolation,
    STATE(2406), 1,
      sym_parenthesized_expression,
  [69632] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4255), 1,
      anon_sym_COMMA,
    ACTIONS(4257), 1,
      anon_sym_RPAREN,
    STATE(2101), 1,
      sym_text_interpolation,
    STATE(2216), 1,
      aux_sym_arguments_repeat1,
  [69651] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3967), 1,
      sym_nowdoc_string,
    ACTIONS(4259), 1,
      anon_sym_,
    STATE(1849), 1,
      aux_sym_nowdoc_body_repeat1,
    STATE(2102), 1,
      sym_text_interpolation,
  [69670] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1216), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2103), 1,
      sym_text_interpolation,
    ACTIONS(1214), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69687] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1236), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2104), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69704] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4261), 1,
      anon_sym_EQ_GT,
    STATE(2105), 1,
      sym_text_interpolation,
    STATE(2708), 1,
      sym__return_type,
  [69723] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1184), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2106), 1,
      sym_text_interpolation,
    ACTIONS(1182), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69740] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1322), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2107), 1,
      sym_text_interpolation,
    ACTIONS(1320), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69757] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2108), 1,
      sym_text_interpolation,
    ACTIONS(4263), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [69772] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2109), 1,
      sym_text_interpolation,
    ACTIONS(4265), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [69787] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3212), 1,
      anon_sym_RPAREN,
    STATE(2110), 1,
      sym_text_interpolation,
    STATE(2207), 1,
      aux_sym__list_destructing_repeat1,
  [69806] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4267), 1,
      anon_sym_RPAREN,
    STATE(2111), 1,
      sym_text_interpolation,
    STATE(2211), 1,
      aux_sym__list_destructing_repeat1,
  [69825] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    ACTIONS(4269), 1,
      sym_name,
    STATE(2112), 1,
      sym_text_interpolation,
    STATE(2289), 1,
      sym_namespace_use_group,
  [69844] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
    STATE(2113), 1,
      sym_text_interpolation,
    STATE(2189), 1,
      aux_sym__list_destructing_repeat1,
  [69863] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1184), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2114), 1,
      sym_text_interpolation,
    ACTIONS(1182), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69880] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4271), 1,
      anon_sym_EQ_GT,
    STATE(2115), 1,
      sym_text_interpolation,
    STATE(2699), 1,
      sym__return_type,
  [69899] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(953), 1,
      anon_sym_EQ_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_COMMA,
    STATE(2116), 1,
      sym_text_interpolation,
    STATE(2159), 1,
      aux_sym_match_condition_list_repeat1,
  [69918] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(869), 1,
      anon_sym_RBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4275), 1,
      anon_sym_COMMA,
    STATE(2117), 1,
      sym_text_interpolation,
    STATE(2156), 1,
      aux_sym_match_block_repeat1,
  [69937] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4277), 1,
      anon_sym_LBRACE,
    ACTIONS(4279), 1,
      anon_sym_COLON,
    STATE(2002), 1,
      sym_switch_block,
    STATE(2118), 1,
      sym_text_interpolation,
  [69956] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1318), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2119), 1,
      sym_text_interpolation,
    ACTIONS(1316), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [69973] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2120), 1,
      sym_text_interpolation,
    ACTIONS(3877), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [69988] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2121), 1,
      sym_text_interpolation,
    ACTIONS(3882), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [70003] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4199), 1,
      sym_name,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    STATE(2122), 1,
      sym_text_interpolation,
    STATE(2255), 1,
      sym_namespace_use_group,
  [70022] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    ACTIONS(4269), 1,
      sym_name,
    STATE(2123), 1,
      sym_text_interpolation,
    STATE(2255), 1,
      sym_namespace_use_group,
  [70041] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2124), 1,
      sym_text_interpolation,
    ACTIONS(4281), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [70056] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2125), 1,
      sym_text_interpolation,
    ACTIONS(3891), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [70071] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2126), 1,
      sym_text_interpolation,
    ACTIONS(4283), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [70086] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2127), 1,
      sym_text_interpolation,
    ACTIONS(4285), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [70101] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4289), 1,
      anon_sym_EQ,
    STATE(2128), 1,
      sym_text_interpolation,
    ACTIONS(4287), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70118] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4293), 1,
      anon_sym_EQ,
    STATE(2129), 1,
      sym_text_interpolation,
    ACTIONS(4291), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70135] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_RPAREN,
    ACTIONS(4295), 1,
      anon_sym_COMMA,
    STATE(2130), 1,
      sym_text_interpolation,
    STATE(2183), 1,
      aux_sym_formal_parameters_repeat1,
  [70154] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(4297), 1,
      anon_sym_RPAREN,
    STATE(2131), 1,
      sym_text_interpolation,
    STATE(2551), 1,
      sym_variable_name,
  [70173] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(4299), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2132), 1,
      sym_text_interpolation,
    STATE(2180), 1,
      sym_variable_name,
  [70192] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    ACTIONS(4269), 1,
      sym_name,
    STATE(2133), 1,
      sym_text_interpolation,
    STATE(2453), 1,
      sym_namespace_use_group,
  [70211] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4303), 1,
      anon_sym_EQ,
    STATE(2134), 1,
      sym_text_interpolation,
    ACTIONS(4301), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70228] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    STATE(2135), 1,
      sym_text_interpolation,
    STATE(2545), 1,
      sym_variable_name,
  [70247] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1342), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2136), 1,
      sym_text_interpolation,
    ACTIONS(1340), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70264] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1442), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2137), 1,
      sym_text_interpolation,
    ACTIONS(1440), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70281] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4309), 1,
      aux_sym_else_clause_token1,
    STATE(2138), 1,
      sym_text_interpolation,
    ACTIONS(4307), 2,
      aux_sym_if_statement_token2,
      aux_sym_else_if_clause_token1,
  [70298] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(4311), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2139), 1,
      sym_text_interpolation,
    STATE(2174), 1,
      sym_variable_name,
  [70317] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3346), 1,
      anon_sym_RPAREN,
    ACTIONS(4313), 1,
      anon_sym_COMMA,
    STATE(2140), 2,
      sym_text_interpolation,
      aux_sym_unset_statement_repeat1,
  [70334] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4318), 1,
      anon_sym_EQ,
    STATE(2141), 1,
      sym_text_interpolation,
    ACTIONS(4316), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70351] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_COMMA,
    ACTIONS(4320), 1,
      anon_sym_RPAREN,
    STATE(2140), 1,
      aux_sym_unset_statement_repeat1,
    STATE(2142), 1,
      sym_text_interpolation,
  [70370] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    ACTIONS(4322), 1,
      anon_sym_LBRACE,
    STATE(1898), 1,
      aux_sym_base_clause_repeat1,
    STATE(2143), 1,
      sym_text_interpolation,
  [70389] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(3677), 1,
      anon_sym_LBRACE,
    STATE(2144), 1,
      sym_text_interpolation,
    STATE(2603), 1,
      sym__return_type,
  [70408] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4324), 1,
      anon_sym_COMMA,
    ACTIONS(4326), 1,
      anon_sym_RPAREN,
    STATE(2145), 1,
      sym_text_interpolation,
    STATE(2155), 1,
      aux_sym_arguments_repeat1,
  [70427] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    ACTIONS(4269), 1,
      sym_name,
    STATE(2146), 1,
      sym_text_interpolation,
    STATE(2371), 1,
      sym_namespace_use_group,
  [70446] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4199), 1,
      sym_name,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    STATE(2147), 1,
      sym_text_interpolation,
    STATE(2371), 1,
      sym_namespace_use_group,
  [70465] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2148), 1,
      sym_text_interpolation,
    ACTIONS(3844), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [70480] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1286), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2149), 1,
      sym_text_interpolation,
    ACTIONS(1284), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70497] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4330), 1,
      anon_sym_EQ,
    STATE(2150), 1,
      sym_text_interpolation,
    ACTIONS(4328), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [70514] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1544), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2151), 1,
      sym_text_interpolation,
    ACTIONS(1542), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70531] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1366), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2152), 1,
      sym_text_interpolation,
    ACTIONS(1364), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70548] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2153), 1,
      sym_text_interpolation,
    ACTIONS(3906), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [70563] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1724), 1,
      anon_sym_DOLLAR,
    STATE(1703), 1,
      sym_variable_name,
    STATE(1902), 1,
      sym_property_element,
    STATE(2154), 1,
      sym_text_interpolation,
  [70582] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(801), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4332), 1,
      anon_sym_COMMA,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
    STATE(2155), 1,
      sym_text_interpolation,
  [70601] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4334), 1,
      anon_sym_COMMA,
    ACTIONS(4337), 1,
      anon_sym_RBRACE,
    STATE(2156), 2,
      sym_text_interpolation,
      aux_sym_match_block_repeat1,
  [70618] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1426), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2157), 1,
      sym_text_interpolation,
    ACTIONS(1424), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70635] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2158), 1,
      sym_text_interpolation,
    ACTIONS(3917), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [70650] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_EQ_GT,
    ACTIONS(4339), 1,
      anon_sym_COMMA,
    STATE(2159), 2,
      sym_text_interpolation,
      aux_sym_match_condition_list_repeat1,
  [70667] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4342), 1,
      anon_sym_COMMA,
    ACTIONS(4345), 1,
      anon_sym_RPAREN,
    STATE(2160), 2,
      sym_text_interpolation,
      aux_sym_anonymous_function_use_clause_repeat1,
  [70684] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4199), 1,
      sym_name,
    ACTIONS(4201), 1,
      anon_sym_LBRACE,
    STATE(2161), 1,
      sym_text_interpolation,
    STATE(2254), 1,
      sym_namespace_use_group,
  [70703] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4347), 1,
      anon_sym_COMMA,
    ACTIONS(4350), 1,
      anon_sym_RBRACE,
    STATE(2162), 2,
      sym_text_interpolation,
      aux_sym_namespace_use_group_repeat1,
  [70720] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    ACTIONS(3789), 1,
      anon_sym_LBRACE,
    STATE(2143), 1,
      aux_sym_base_clause_repeat1,
    STATE(2163), 1,
      sym_text_interpolation,
  [70739] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(839), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4352), 1,
      anon_sym_COMMA,
    STATE(1978), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(2164), 1,
      sym_text_interpolation,
  [70758] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4354), 1,
      anon_sym_COMMA,
    ACTIONS(4356), 1,
      anon_sym_RPAREN,
    STATE(2044), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
    STATE(2165), 1,
      sym_text_interpolation,
  [70777] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1302), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2166), 1,
      sym_text_interpolation,
    ACTIONS(1300), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70794] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_COMMA,
    ACTIONS(4358), 1,
      anon_sym_RPAREN,
    STATE(2140), 1,
      aux_sym_unset_statement_repeat1,
    STATE(2167), 1,
      sym_text_interpolation,
  [70813] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4360), 1,
      anon_sym_DQUOTE,
    ACTIONS(4362), 1,
      anon_sym_SQUOTE,
    ACTIONS(4364), 1,
      sym_heredoc_start,
    STATE(2168), 1,
      sym_text_interpolation,
  [70832] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4368), 1,
      anon_sym_EQ,
    STATE(2169), 1,
      sym_text_interpolation,
    ACTIONS(4366), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70849] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    ACTIONS(4370), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2071), 1,
      sym_variable_name,
    STATE(2170), 1,
      sym_text_interpolation,
  [70868] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(318), 1,
      anon_sym_DOLLAR,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2171), 1,
      sym_text_interpolation,
    STATE(1869), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [70885] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4374), 1,
      anon_sym_EQ,
    STATE(2172), 1,
      sym_text_interpolation,
    ACTIONS(4372), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70902] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4378), 1,
      aux_sym_else_clause_token1,
    STATE(2173), 1,
      sym_text_interpolation,
    ACTIONS(4376), 2,
      aux_sym_if_statement_token2,
      aux_sym_else_if_clause_token1,
  [70919] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4382), 1,
      anon_sym_EQ,
    STATE(2174), 1,
      sym_text_interpolation,
    ACTIONS(4380), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [70936] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1272), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2175), 1,
      sym_text_interpolation,
    ACTIONS(1270), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70953] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4384), 1,
      anon_sym_COMMA,
    ACTIONS(4386), 1,
      anon_sym_RBRACE,
    STATE(2117), 1,
      aux_sym_match_block_repeat1,
    STATE(2176), 1,
      sym_text_interpolation,
  [70972] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1362), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2177), 1,
      sym_text_interpolation,
    ACTIONS(1360), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [70989] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1248), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2178), 1,
      sym_text_interpolation,
    ACTIONS(1246), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [71006] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(821), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4388), 1,
      anon_sym_COMMA,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
    STATE(2179), 1,
      sym_text_interpolation,
  [71025] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_EQ,
    STATE(2180), 1,
      sym_text_interpolation,
    ACTIONS(4390), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71042] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_COMMA,
    ACTIONS(4396), 1,
      anon_sym_RPAREN,
    STATE(2179), 1,
      aux_sym_arguments_repeat1,
    STATE(2181), 1,
      sym_text_interpolation,
  [71061] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1208), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2182), 1,
      sym_text_interpolation,
    ACTIONS(1206), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [71078] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4398), 1,
      anon_sym_COMMA,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    STATE(2183), 2,
      sym_text_interpolation,
      aux_sym_formal_parameters_repeat1,
  [71095] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_EQ,
    STATE(2184), 1,
      sym_text_interpolation,
    ACTIONS(4403), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71112] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2185), 1,
      sym_text_interpolation,
    ACTIONS(4405), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [71127] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4409), 1,
      anon_sym_EQ,
    STATE(2186), 1,
      sym_text_interpolation,
    ACTIONS(4407), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71144] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4413), 1,
      anon_sym_EQ,
    STATE(2187), 1,
      sym_text_interpolation,
    ACTIONS(4411), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71161] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(819), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4415), 1,
      anon_sym_COMMA,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
    STATE(2188), 1,
      sym_text_interpolation,
  [71180] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4417), 1,
      anon_sym_RPAREN,
    STATE(2189), 1,
      sym_text_interpolation,
    STATE(2196), 1,
      aux_sym__list_destructing_repeat1,
  [71199] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_COMMA,
    ACTIONS(4421), 1,
      anon_sym_RPAREN,
    STATE(1972), 1,
      aux_sym_arguments_repeat1,
    STATE(2190), 1,
      sym_text_interpolation,
  [71218] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4423), 1,
      anon_sym_COMMA,
    ACTIONS(4425), 1,
      anon_sym_RPAREN,
    STATE(2188), 1,
      aux_sym_arguments_repeat1,
    STATE(2191), 1,
      sym_text_interpolation,
  [71237] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_COMMA,
    ACTIONS(4427), 1,
      anon_sym_RBRACE,
    STATE(1965), 1,
      aux_sym_namespace_use_group_repeat1,
    STATE(2192), 1,
      sym_text_interpolation,
  [71256] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2193), 1,
      sym_text_interpolation,
    ACTIONS(4429), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [71271] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2194), 1,
      sym_text_interpolation,
    ACTIONS(4431), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [71286] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_RPAREN,
    STATE(2195), 1,
      sym_text_interpolation,
    STATE(2196), 1,
      aux_sym__list_destructing_repeat1,
  [71305] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_RPAREN,
    ACTIONS(4435), 1,
      anon_sym_COMMA,
    STATE(2196), 2,
      sym_text_interpolation,
      aux_sym__list_destructing_repeat1,
  [71322] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_EQ,
    STATE(2197), 1,
      sym_text_interpolation,
    ACTIONS(4438), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [71339] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2198), 1,
      sym_text_interpolation,
    ACTIONS(4127), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [71354] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4127), 1,
      anon_sym_RBRACK,
    ACTIONS(4440), 1,
      anon_sym_COMMA,
    STATE(2199), 2,
      sym_text_interpolation,
      aux_sym_array_creation_expression_repeat1,
  [71371] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(803), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_COMMA,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
    STATE(2200), 1,
      sym_text_interpolation,
  [71390] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4445), 1,
      anon_sym_EQ_GT,
    STATE(2201), 1,
      sym_text_interpolation,
    STATE(2591), 1,
      sym__return_type,
  [71409] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_COMMA,
    ACTIONS(4450), 1,
      anon_sym_RBRACK,
    STATE(2202), 2,
      sym_text_interpolation,
      aux_sym_attribute_group_repeat1,
  [71426] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4452), 1,
      anon_sym_COMMA,
    ACTIONS(4454), 1,
      anon_sym_RPAREN,
    STATE(2200), 1,
      aux_sym_arguments_repeat1,
    STATE(2203), 1,
      sym_text_interpolation,
  [71445] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1478), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2204), 1,
      sym_text_interpolation,
    ACTIONS(1476), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [71462] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4458), 1,
      anon_sym_EQ,
    STATE(2205), 1,
      sym_text_interpolation,
    ACTIONS(4456), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71479] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4460), 1,
      anon_sym_EQ_GT,
    STATE(2206), 1,
      sym_text_interpolation,
    STATE(2579), 1,
      sym__return_type,
  [71498] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_RPAREN,
    STATE(2196), 1,
      aux_sym__list_destructing_repeat1,
    STATE(2207), 1,
      sym_text_interpolation,
  [71517] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1442), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2208), 1,
      sym_text_interpolation,
    ACTIONS(1440), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [71534] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2209), 1,
      sym_text_interpolation,
    ACTIONS(4464), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [71549] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4466), 1,
      anon_sym_COMMA,
    ACTIONS(4468), 1,
      anon_sym_RPAREN,
    STATE(2210), 1,
      sym_text_interpolation,
    STATE(2212), 1,
      aux_sym_arguments_repeat1,
  [71568] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_RPAREN,
    STATE(2196), 1,
      aux_sym__list_destructing_repeat1,
    STATE(2211), 1,
      sym_text_interpolation,
  [71587] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(791), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_COMMA,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
    STATE(2212), 1,
      sym_text_interpolation,
  [71606] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_COLON,
    ACTIONS(4474), 1,
      anon_sym_EQ_GT,
    STATE(2213), 1,
      sym_text_interpolation,
    STATE(2511), 1,
      sym__return_type,
  [71625] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1172), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2214), 1,
      sym_text_interpolation,
    ACTIONS(1170), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [71642] = 4,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(2215), 1,
      sym_text_interpolation,
    ACTIONS(4476), 3,
      sym_heredoc_end,
      sym_nowdoc_string,
      sym__new_line,
  [71657] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(795), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    STATE(2099), 1,
      aux_sym_arguments_repeat1,
    STATE(2216), 1,
      sym_text_interpolation,
  [71676] = 6,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4149), 1,
      sym__new_line,
    ACTIONS(4480), 1,
      sym_heredoc_end,
    STATE(2217), 1,
      sym_text_interpolation,
    STATE(2430), 1,
      sym_nowdoc_body,
  [71695] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1657), 1,
      sym_formal_parameters,
    STATE(2218), 1,
      sym_text_interpolation,
  [71711] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(954), 1,
      sym_compound_statement,
    STATE(2219), 1,
      sym_text_interpolation,
  [71727] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    STATE(464), 1,
      sym_enum_declaration_list,
    STATE(2220), 1,
      sym_text_interpolation,
  [71743] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2205), 1,
      sym_variable_name,
    STATE(2221), 1,
      sym_text_interpolation,
  [71759] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(451), 1,
      ts_builtin_sym_end,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4482), 1,
      sym_php_tag,
    STATE(2222), 1,
      sym_text_interpolation,
  [71775] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2223), 1,
      sym_text_interpolation,
    ACTIONS(4484), 2,
      anon_sym_string,
      anon_sym_int,
  [71789] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2224), 1,
      sym_text_interpolation,
    ACTIONS(4486), 2,
      sym__eof,
      sym_php_tag,
  [71803] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1112), 1,
      sym_compound_statement,
    STATE(2225), 1,
      sym_text_interpolation,
  [71819] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_declaration_list,
    STATE(2226), 1,
      sym_text_interpolation,
  [71835] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4488), 1,
      sym__new_line,
    ACTIONS(4490), 1,
      sym_heredoc_end,
    STATE(2227), 1,
      sym_text_interpolation,
  [71851] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2228), 1,
      sym_text_interpolation,
    ACTIONS(2603), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71865] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_declaration_list,
    STATE(2229), 1,
      sym_text_interpolation,
  [71881] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2230), 1,
      sym_text_interpolation,
    ACTIONS(2613), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71895] = 4,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    STATE(2231), 1,
      sym_text_interpolation,
    ACTIONS(3965), 2,
      sym_heredoc_end,
      sym__new_line,
  [71909] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2232), 1,
      sym_text_interpolation,
    ACTIONS(4492), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71923] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4494), 1,
      sym_name,
    STATE(2233), 1,
      sym_text_interpolation,
    STATE(2593), 1,
      sym_namespace_name,
  [71939] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4494), 1,
      sym_name,
    STATE(2234), 1,
      sym_text_interpolation,
    STATE(2628), 1,
      sym_namespace_name,
  [71955] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4494), 1,
      sym_name,
    STATE(2235), 1,
      sym_text_interpolation,
    STATE(2620), 1,
      sym_namespace_name,
  [71971] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2236), 1,
      sym_text_interpolation,
    ACTIONS(4497), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71985] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1740), 1,
      sym_compound_statement,
    STATE(2237), 1,
      sym_text_interpolation,
  [72001] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(37), 1,
      sym_parenthesized_expression,
    STATE(2238), 1,
      sym_text_interpolation,
  [72017] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(77), 1,
      sym_parenthesized_expression,
    STATE(2239), 1,
      sym_text_interpolation,
  [72033] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_LPAREN,
    STATE(2240), 1,
      sym_text_interpolation,
    STATE(2364), 1,
      sym_parenthesized_expression,
  [72049] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
    STATE(2241), 1,
      sym_text_interpolation,
  [72065] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(46), 1,
      sym_parenthesized_expression,
    STATE(2242), 1,
      sym_text_interpolation,
  [72081] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_LPAREN,
    STATE(2023), 1,
      sym_parenthesized_expression,
    STATE(2243), 1,
      sym_text_interpolation,
  [72097] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(2003), 1,
      sym_formal_parameters,
    STATE(2244), 1,
      sym_text_interpolation,
  [72113] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2245), 1,
      sym_text_interpolation,
    ACTIONS(4450), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [72127] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1096), 1,
      sym_compound_statement,
    STATE(2246), 1,
      sym_text_interpolation,
  [72143] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2247), 1,
      sym_text_interpolation,
    ACTIONS(4501), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72157] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(939), 1,
      sym_compound_statement,
    STATE(2248), 1,
      sym_text_interpolation,
  [72173] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2249), 1,
      sym_text_interpolation,
    ACTIONS(4503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [72187] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(439), 1,
      sym_declaration_list,
    STATE(2250), 1,
      sym_text_interpolation,
  [72203] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(916), 1,
      sym_declaration_list,
    STATE(2251), 1,
      sym_text_interpolation,
  [72219] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2252), 1,
      sym_text_interpolation,
    ACTIONS(4506), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72233] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1708), 1,
      sym_compound_statement,
    STATE(2253), 1,
      sym_text_interpolation,
  [72249] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2254), 1,
      sym_text_interpolation,
    ACTIONS(3911), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72263] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2255), 1,
      sym_text_interpolation,
    ACTIONS(4508), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72277] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2256), 1,
      sym_text_interpolation,
    ACTIONS(4510), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72291] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4512), 1,
      sym_name,
    STATE(1935), 1,
      sym_namespace_name,
    STATE(2257), 1,
      sym_text_interpolation,
  [72307] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2258), 1,
      sym_text_interpolation,
    ACTIONS(4514), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72321] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(474), 1,
      sym_compound_statement,
    STATE(2259), 1,
      sym_text_interpolation,
  [72337] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(1964), 1,
      sym_variable_name,
    STATE(2260), 1,
      sym_text_interpolation,
  [72353] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2261), 1,
      sym_text_interpolation,
    ACTIONS(1688), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72367] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2262), 1,
      sym_text_interpolation,
    ACTIONS(3378), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72381] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1143), 1,
      sym_declaration_list,
    STATE(2263), 1,
      sym_text_interpolation,
  [72397] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1084), 1,
      sym_compound_statement,
    STATE(2264), 1,
      sym_text_interpolation,
  [72413] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2265), 1,
      sym_text_interpolation,
    ACTIONS(3849), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [72427] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1039), 1,
      sym_compound_statement,
    STATE(2266), 1,
      sym_text_interpolation,
  [72443] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1074), 1,
      sym_compound_statement,
    STATE(2267), 1,
      sym_text_interpolation,
  [72459] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1092), 1,
      sym_declaration_list,
    STATE(2268), 1,
      sym_text_interpolation,
  [72475] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2269), 1,
      sym_text_interpolation,
    ACTIONS(4401), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72489] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(938), 1,
      sym_compound_statement,
    STATE(2270), 1,
      sym_text_interpolation,
  [72505] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2271), 1,
      sym_text_interpolation,
    ACTIONS(4516), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72519] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2272), 1,
      sym_text_interpolation,
    ACTIONS(3528), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72533] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2236), 1,
      sym_variable_name,
    STATE(2273), 1,
      sym_text_interpolation,
  [72549] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2274), 1,
      sym_text_interpolation,
    ACTIONS(4518), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [72563] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    ACTIONS(4520), 1,
      anon_sym_EQ,
    STATE(2275), 1,
      sym_text_interpolation,
  [72579] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2276), 1,
      sym_text_interpolation,
    ACTIONS(4522), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [72593] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(912), 1,
      sym_compound_statement,
    STATE(2277), 1,
      sym_text_interpolation,
  [72609] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    STATE(465), 1,
      sym_enum_declaration_list,
    STATE(2278), 1,
      sym_text_interpolation,
  [72625] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2279), 1,
      sym_text_interpolation,
    ACTIONS(4072), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [72639] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1614), 1,
      sym_formal_parameters,
    STATE(2280), 1,
      sym_text_interpolation,
  [72655] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1706), 1,
      sym_declaration_list,
    STATE(2281), 1,
      sym_text_interpolation,
  [72671] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2282), 1,
      sym_text_interpolation,
    ACTIONS(2463), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [72685] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1711), 1,
      sym_declaration_list,
    STATE(2283), 1,
      sym_text_interpolation,
  [72701] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(454), 1,
      sym_declaration_list,
    STATE(2284), 1,
      sym_text_interpolation,
  [72717] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4524), 1,
      sym_name,
    STATE(2285), 1,
      sym_text_interpolation,
    STATE(2524), 1,
      sym_namespace_name,
  [72733] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2286), 1,
      sym_text_interpolation,
    ACTIONS(4527), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72747] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2232), 1,
      sym_variable_name,
    STATE(2287), 1,
      sym_text_interpolation,
  [72763] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(451), 1,
      sym_declaration_list,
    STATE(2288), 1,
      sym_text_interpolation,
  [72779] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2289), 1,
      sym_text_interpolation,
    ACTIONS(4529), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72793] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(373), 1,
      anon_sym_COLON,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2290), 1,
      sym_text_interpolation,
    STATE(2548), 1,
      sym_colon_block,
  [72809] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(1950), 1,
      sym_variable_name,
    STATE(2291), 1,
      sym_text_interpolation,
  [72825] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_LPAREN,
    STATE(2292), 1,
      sym_text_interpolation,
    STATE(2383), 1,
      sym_parenthesized_expression,
  [72841] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2293), 1,
      sym_text_interpolation,
    ACTIONS(4531), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72855] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2294), 1,
      sym_text_interpolation,
    ACTIONS(4533), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72869] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2295), 1,
      sym_text_interpolation,
    ACTIONS(4535), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72883] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(84), 1,
      sym_parenthesized_expression,
    STATE(2296), 1,
      sym_text_interpolation,
  [72899] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2833), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(4537), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(2297), 1,
      sym_text_interpolation,
  [72915] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(83), 1,
      sym_parenthesized_expression,
    STATE(2298), 1,
      sym_text_interpolation,
  [72931] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2299), 1,
      sym_text_interpolation,
    ACTIONS(4539), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72945] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    STATE(1984), 1,
      sym_enum_declaration_list,
    STATE(2300), 1,
      sym_text_interpolation,
  [72961] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1700), 1,
      sym_compound_statement,
    STATE(2301), 1,
      sym_text_interpolation,
  [72977] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2302), 1,
      sym_text_interpolation,
    ACTIONS(3532), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [72991] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(27), 1,
      sym_parenthesized_expression,
    STATE(2303), 1,
      sym_text_interpolation,
  [73007] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_LPAREN,
    STATE(2304), 1,
      sym_text_interpolation,
    STATE(2406), 1,
      sym_parenthesized_expression,
  [73023] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_LPAREN,
    STATE(2118), 1,
      sym_parenthesized_expression,
    STATE(2305), 1,
      sym_text_interpolation,
  [73039] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
    STATE(2306), 1,
      sym_text_interpolation,
  [73055] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2307), 1,
      sym_text_interpolation,
    STATE(2347), 1,
      sym_variable_name,
  [73071] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4494), 1,
      sym_name,
    STATE(2308), 1,
      sym_text_interpolation,
    STATE(2519), 1,
      sym_namespace_name,
  [73087] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2309), 1,
      sym_text_interpolation,
    ACTIONS(4541), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [73101] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2310), 1,
      sym_text_interpolation,
    ACTIONS(4543), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73115] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2311), 1,
      sym_text_interpolation,
    ACTIONS(4350), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [73129] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1118), 1,
      sym_compound_statement,
    STATE(2312), 1,
      sym_text_interpolation,
  [73145] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2313), 1,
      sym_text_interpolation,
    ACTIONS(4545), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73159] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2314), 1,
      sym_text_interpolation,
    ACTIONS(2463), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73173] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1079), 1,
      sym_compound_statement,
    STATE(2315), 1,
      sym_text_interpolation,
  [73189] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2316), 1,
      sym_text_interpolation,
    STATE(2323), 1,
      sym_variable_name,
  [73205] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1651), 1,
      sym_formal_parameters,
    STATE(2317), 1,
      sym_text_interpolation,
  [73221] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2318), 1,
      sym_text_interpolation,
    ACTIONS(4281), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [73235] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(2068), 1,
      sym_formal_parameters,
    STATE(2319), 1,
      sym_text_interpolation,
  [73251] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(441), 1,
      sym_declaration_list,
    STATE(2320), 1,
      sym_text_interpolation,
  [73267] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(971), 1,
      sym_declaration_list,
    STATE(2321), 1,
      sym_text_interpolation,
  [73283] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2322), 1,
      sym_text_interpolation,
    ACTIONS(4547), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73297] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2323), 1,
      sym_text_interpolation,
    ACTIONS(4549), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [73311] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2324), 1,
      sym_text_interpolation,
    ACTIONS(4551), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [73325] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4553), 1,
      anon_sym_LBRACE,
    STATE(431), 1,
      sym_compound_statement,
    STATE(2325), 1,
      sym_text_interpolation,
  [73341] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1987), 1,
      sym_declaration_list,
    STATE(2326), 1,
      sym_text_interpolation,
  [73357] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(919), 1,
      sym_declaration_list,
    STATE(2327), 1,
      sym_text_interpolation,
  [73373] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2328), 1,
      sym_text_interpolation,
    ACTIONS(4555), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [73387] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2328), 1,
      sym_variable_name,
    STATE(2329), 1,
      sym_text_interpolation,
  [73403] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2330), 1,
      sym_text_interpolation,
    ACTIONS(483), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73417] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2331), 1,
      sym_text_interpolation,
    ACTIONS(4557), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [73431] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2332), 1,
      sym_text_interpolation,
    ACTIONS(4345), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [73445] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2333), 1,
      sym_text_interpolation,
    ACTIONS(4559), 2,
      anon_sym_string,
      anon_sym_int,
  [73459] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1040), 1,
      sym_declaration_list,
    STATE(2334), 1,
      sym_text_interpolation,
  [73475] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2335), 1,
      sym_text_interpolation,
    ACTIONS(4561), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73489] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4563), 1,
      anon_sym_LPAREN,
    STATE(1754), 1,
      sym_formal_parameters,
    STATE(2336), 1,
      sym_text_interpolation,
  [73505] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3975), 1,
      anon_sym_LBRACE,
    STATE(562), 1,
      sym_declaration_list,
    STATE(2337), 1,
      sym_text_interpolation,
  [73521] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(2032), 1,
      sym_declaration_list,
    STATE(2338), 1,
      sym_text_interpolation,
  [73537] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(2079), 1,
      sym_formal_parameters,
    STATE(2339), 1,
      sym_text_interpolation,
  [73553] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4565), 1,
      anon_sym_LPAREN,
    STATE(2295), 1,
      sym_parenthesized_expression,
    STATE(2340), 1,
      sym_text_interpolation,
  [73569] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1745), 1,
      sym_declaration_list,
    STATE(2341), 1,
      sym_text_interpolation,
  [73585] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1663), 1,
      sym_formal_parameters,
    STATE(2342), 1,
      sym_text_interpolation,
  [73601] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(917), 1,
      sym_compound_statement,
    STATE(2343), 1,
      sym_text_interpolation,
  [73617] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1086), 1,
      sym_compound_statement,
    STATE(2344), 1,
      sym_text_interpolation,
  [73633] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4563), 1,
      anon_sym_LPAREN,
    STATE(1724), 1,
      sym_formal_parameters,
    STATE(2345), 1,
      sym_text_interpolation,
  [73649] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4567), 1,
      anon_sym_LPAREN,
    ACTIONS(4569), 1,
      anon_sym_RPAREN,
    STATE(2346), 1,
      sym_text_interpolation,
  [73665] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2347), 1,
      sym_text_interpolation,
    ACTIONS(4571), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [73679] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2348), 1,
      sym_text_interpolation,
    ACTIONS(4337), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [73693] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2349), 1,
      sym_text_interpolation,
    ACTIONS(4135), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [73707] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2350), 1,
      sym_text_interpolation,
    ACTIONS(4573), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73721] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2351), 1,
      sym_text_interpolation,
    ACTIONS(4575), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73735] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4577), 1,
      anon_sym_SEMI,
    ACTIONS(4579), 1,
      sym__automatic_semicolon,
    STATE(2352), 1,
      sym_text_interpolation,
  [73751] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2062), 1,
      sym_compound_statement,
    STATE(2353), 1,
      sym_text_interpolation,
  [73767] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2354), 1,
      sym_text_interpolation,
    ACTIONS(4581), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73781] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    STATE(480), 1,
      sym_enum_declaration_list,
    STATE(2355), 1,
      sym_text_interpolation,
  [73797] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1080), 1,
      sym_compound_statement,
    STATE(2356), 1,
      sym_text_interpolation,
  [73813] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2357), 1,
      sym_text_interpolation,
    ACTIONS(4583), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73827] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2358), 1,
      sym_text_interpolation,
    ACTIONS(4585), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73841] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2359), 1,
      sym_text_interpolation,
    ACTIONS(531), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73855] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2360), 1,
      sym_text_interpolation,
    ACTIONS(2459), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73869] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    STATE(2046), 1,
      sym_enum_declaration_list,
    STATE(2361), 1,
      sym_text_interpolation,
  [73885] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1644), 1,
      sym_formal_parameters,
    STATE(2362), 1,
      sym_text_interpolation,
  [73901] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2363), 1,
      sym_text_interpolation,
    ACTIONS(4587), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73915] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4589), 1,
      anon_sym_LBRACE,
    STATE(1087), 1,
      sym_match_block,
    STATE(2364), 1,
      sym_text_interpolation,
  [73931] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1764), 1,
      sym_declaration_list,
    STATE(2365), 1,
      sym_text_interpolation,
  [73947] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2366), 1,
      sym_text_interpolation,
    ACTIONS(4591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [73961] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2274), 1,
      sym_variable_name,
    STATE(2367), 1,
      sym_text_interpolation,
  [73977] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(966), 1,
      sym_compound_statement,
    STATE(2368), 1,
      sym_text_interpolation,
  [73993] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2369), 1,
      sym_text_interpolation,
    ACTIONS(4593), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74007] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(968), 1,
      sym_compound_statement,
    STATE(2370), 1,
      sym_text_interpolation,
  [74023] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2371), 1,
      sym_text_interpolation,
    ACTIONS(4595), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74037] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1649), 1,
      sym_formal_parameters,
    STATE(2372), 1,
      sym_text_interpolation,
  [74053] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2373), 1,
      sym_text_interpolation,
    ACTIONS(4597), 2,
      anon_sym_string,
      anon_sym_int,
  [74067] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2374), 1,
      sym_text_interpolation,
    ACTIONS(4599), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [74081] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_declaration_list,
    STATE(2375), 1,
      sym_text_interpolation,
  [74097] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_RPAREN,
    ACTIONS(4520), 1,
      anon_sym_EQ,
    STATE(2376), 1,
      sym_text_interpolation,
  [74113] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(931), 1,
      sym_compound_statement,
    STATE(2377), 1,
      sym_text_interpolation,
  [74129] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    STATE(2095), 1,
      sym_enum_declaration_list,
    STATE(2378), 1,
      sym_text_interpolation,
  [74145] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2271), 1,
      sym_variable_name,
    STATE(2379), 1,
      sym_text_interpolation,
  [74161] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2000), 1,
      sym_compound_statement,
    STATE(2380), 1,
      sym_text_interpolation,
  [74177] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_RPAREN,
    ACTIONS(4520), 1,
      anon_sym_EQ,
    STATE(2381), 1,
      sym_text_interpolation,
  [74193] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2382), 1,
      sym_text_interpolation,
    ACTIONS(4602), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74207] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(469), 1,
      anon_sym_COLON,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2138), 1,
      sym_colon_block,
    STATE(2383), 1,
      sym_text_interpolation,
  [74223] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_RPAREN,
    ACTIONS(4520), 1,
      anon_sym_EQ,
    STATE(2384), 1,
      sym_text_interpolation,
  [74239] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1106), 1,
      sym_compound_statement,
    STATE(2385), 1,
      sym_text_interpolation,
  [74255] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2186), 1,
      sym_variable_name,
    STATE(2386), 1,
      sym_text_interpolation,
  [74271] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2387), 1,
      sym_text_interpolation,
    ACTIONS(4604), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74285] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4606), 1,
      anon_sym_SEMI,
    ACTIONS(4608), 1,
      sym__automatic_semicolon,
    STATE(2388), 1,
      sym_text_interpolation,
  [74301] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2258), 1,
      sym_variable_name,
    STATE(2389), 1,
      sym_text_interpolation,
  [74317] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2390), 1,
      sym_text_interpolation,
    ACTIONS(4610), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [74331] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2391), 1,
      sym_text_interpolation,
    ACTIONS(4612), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [74345] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2392), 1,
      sym_text_interpolation,
    ACTIONS(4614), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74359] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2393), 1,
      sym_text_interpolation,
    ACTIONS(3887), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74373] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(928), 1,
      sym_declaration_list,
    STATE(2394), 1,
      sym_text_interpolation,
  [74389] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4616), 1,
      anon_sym_BSLASH,
    STATE(1777), 1,
      aux_sym_namespace_name_repeat1,
    STATE(2395), 1,
      sym_text_interpolation,
  [74405] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2396), 1,
      sym_text_interpolation,
    ACTIONS(4619), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74419] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(935), 1,
      sym_declaration_list,
    STATE(2397), 1,
      sym_text_interpolation,
  [74435] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4621), 1,
      sym__new_line,
    ACTIONS(4623), 1,
      sym_heredoc_end,
    STATE(2398), 1,
      sym_text_interpolation,
  [74451] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4553), 1,
      anon_sym_LBRACE,
    STATE(434), 1,
      sym_compound_statement,
    STATE(2399), 1,
      sym_text_interpolation,
  [74467] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4625), 1,
      sym__new_line,
    ACTIONS(4627), 1,
      sym_heredoc_end,
    STATE(2400), 1,
      sym_text_interpolation,
  [74483] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(222), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(526), 1,
      sym_compound_statement,
    STATE(2401), 1,
      sym_text_interpolation,
  [74499] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1045), 1,
      sym_compound_statement,
    STATE(2402), 1,
      sym_text_interpolation,
  [74515] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1628), 1,
      sym_formal_parameters,
    STATE(2403), 1,
      sym_text_interpolation,
  [74531] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1103), 1,
      sym_compound_statement,
    STATE(2404), 1,
      sym_text_interpolation,
  [74547] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(448), 1,
      sym_declaration_list,
    STATE(2405), 1,
      sym_text_interpolation,
  [74563] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4629), 1,
      anon_sym_LBRACE,
    STATE(924), 1,
      sym_match_block,
    STATE(2406), 1,
      sym_text_interpolation,
  [74579] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2407), 1,
      sym_text_interpolation,
    ACTIONS(4631), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [74593] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_SEMI,
    ACTIONS(4635), 1,
      sym__automatic_semicolon,
    STATE(2408), 1,
      sym_text_interpolation,
  [74609] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_declaration_list,
    STATE(2409), 1,
      sym_text_interpolation,
  [74625] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym_compound_statement,
    STATE(2410), 1,
      sym_text_interpolation,
  [74641] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(65), 1,
      sym_parenthesized_expression,
    STATE(2411), 1,
      sym_text_interpolation,
  [74657] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2412), 1,
      sym_text_interpolation,
    ACTIONS(4637), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74671] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1761), 1,
      sym_declaration_list,
    STATE(2413), 1,
      sym_text_interpolation,
  [74687] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(936), 1,
      sym_compound_statement,
    STATE(2414), 1,
      sym_text_interpolation,
  [74703] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4494), 1,
      sym_name,
    STATE(2415), 1,
      sym_text_interpolation,
    STATE(2531), 1,
      sym_namespace_name,
  [74719] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(2206), 1,
      sym_formal_parameters,
    STATE(2416), 1,
      sym_text_interpolation,
  [74735] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2417), 1,
      sym_text_interpolation,
    ACTIONS(4639), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74749] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2418), 1,
      sym_text_interpolation,
    ACTIONS(541), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74763] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1068), 1,
      sym_declaration_list,
    STATE(2419), 1,
      sym_text_interpolation,
  [74779] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2420), 1,
      sym_text_interpolation,
    ACTIONS(4641), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74793] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1069), 1,
      sym_declaration_list,
    STATE(2421), 1,
      sym_text_interpolation,
  [74809] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2422), 1,
      sym_text_interpolation,
    ACTIONS(4438), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [74823] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2423), 1,
      sym_text_interpolation,
    ACTIONS(3270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [74837] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(2213), 1,
      sym_formal_parameters,
    STATE(2424), 1,
      sym_text_interpolation,
  [74853] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(946), 1,
      sym_compound_statement,
    STATE(2425), 1,
      sym_text_interpolation,
  [74869] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(955), 1,
      sym_compound_statement,
    STATE(2426), 1,
      sym_text_interpolation,
  [74885] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2427), 1,
      sym_text_interpolation,
    ACTIONS(4246), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [74899] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2428), 1,
      sym_text_interpolation,
    ACTIONS(2593), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [74913] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4643), 1,
      sym__new_line,
    ACTIONS(4645), 1,
      sym_heredoc_end,
    STATE(2429), 1,
      sym_text_interpolation,
  [74929] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4647), 1,
      sym__new_line,
    ACTIONS(4649), 1,
      sym_heredoc_end,
    STATE(2430), 1,
      sym_text_interpolation,
  [74945] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_COLON,
    ACTIONS(4567), 1,
      anon_sym_LPAREN,
    STATE(2431), 1,
      sym_text_interpolation,
  [74961] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2432), 1,
      sym_text_interpolation,
    ACTIONS(4251), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [74975] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2433), 1,
      sym_text_interpolation,
    ACTIONS(2575), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [74989] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2434), 1,
      sym_text_interpolation,
    ACTIONS(4651), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75003] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1739), 1,
      sym_declaration_list,
    STATE(2435), 1,
      sym_text_interpolation,
  [75019] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2436), 1,
      sym_text_interpolation,
    ACTIONS(4653), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75033] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(449), 1,
      sym_declaration_list,
    STATE(2437), 1,
      sym_text_interpolation,
  [75049] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1737), 1,
      sym_declaration_list,
    STATE(2438), 1,
      sym_text_interpolation,
  [75065] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(969), 1,
      sym_compound_statement,
    STATE(2439), 1,
      sym_text_interpolation,
  [75081] = 5,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4655), 1,
      sym__new_line,
    ACTIONS(4657), 1,
      sym_heredoc_end,
    STATE(2440), 1,
      sym_text_interpolation,
  [75097] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1094), 1,
      sym_compound_statement,
    STATE(2441), 1,
      sym_text_interpolation,
  [75113] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1745), 1,
      anon_sym_DOLLAR,
    STATE(2390), 1,
      sym_variable_name,
    STATE(2442), 1,
      sym_text_interpolation,
  [75129] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2443), 1,
      sym_text_interpolation,
    ACTIONS(4659), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75143] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2444), 1,
      sym_text_interpolation,
    ACTIONS(4661), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75157] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2445), 1,
      sym_text_interpolation,
    ACTIONS(4663), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [75171] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2446), 1,
      sym_text_interpolation,
    ACTIONS(4665), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75185] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2447), 1,
      sym_text_interpolation,
    ACTIONS(4667), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75199] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2448), 1,
      sym_text_interpolation,
    ACTIONS(4669), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75213] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2449), 1,
      sym_text_interpolation,
    ACTIONS(4671), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75227] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2450), 1,
      sym_text_interpolation,
    ACTIONS(1697), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [75241] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2451), 1,
      sym_text_interpolation,
    ACTIONS(4240), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [75255] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_declaration_list,
    STATE(2452), 1,
      sym_text_interpolation,
  [75271] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2453), 1,
      sym_text_interpolation,
    ACTIONS(4673), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75285] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(965), 1,
      sym_compound_statement,
    STATE(2454), 1,
      sym_text_interpolation,
  [75301] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1778), 1,
      sym_declaration_list,
    STATE(2455), 1,
      sym_text_interpolation,
  [75317] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(942), 1,
      sym_compound_statement,
    STATE(2456), 1,
      sym_text_interpolation,
  [75333] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1052), 1,
      sym_declaration_list,
    STATE(2457), 1,
      sym_text_interpolation,
  [75349] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2458), 1,
      sym_text_interpolation,
    ACTIONS(4675), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75363] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1719), 1,
      sym_compound_statement,
    STATE(2459), 1,
      sym_text_interpolation,
  [75379] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1100), 1,
      sym_compound_statement,
    STATE(2460), 1,
      sym_text_interpolation,
  [75395] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_BSLASH,
    STATE(2395), 1,
      aux_sym_namespace_name_repeat1,
    STATE(2461), 1,
      sym_text_interpolation,
  [75411] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2462), 1,
      sym_text_interpolation,
    ACTIONS(489), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75425] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(1692), 1,
      sym_compound_statement,
    STATE(2463), 1,
      sym_text_interpolation,
  [75441] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2833), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(4677), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(2464), 1,
      sym_text_interpolation,
  [75457] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4565), 1,
      anon_sym_LPAREN,
    STATE(2247), 1,
      sym_parenthesized_expression,
    STATE(2465), 1,
      sym_text_interpolation,
  [75473] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4553), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_compound_statement,
    STATE(2466), 1,
      sym_text_interpolation,
  [75489] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4499), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
    STATE(2467), 1,
      sym_text_interpolation,
  [75505] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2468), 1,
      sym_text_interpolation,
    ACTIONS(4679), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [75519] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1726), 1,
      sym_declaration_list,
    STATE(2469), 1,
      sym_text_interpolation,
  [75535] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(1664), 1,
      sym_formal_parameters,
    STATE(2470), 1,
      sym_text_interpolation,
  [75551] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2471), 1,
      sym_text_interpolation,
    ACTIONS(2459), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [75565] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_declaration_list,
    STATE(2472), 1,
      sym_text_interpolation,
  [75581] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3556), 1,
      anon_sym_LBRACE,
    STATE(1969), 1,
      sym_enum_declaration_list,
    STATE(2473), 1,
      sym_text_interpolation,
  [75597] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_declaration_list,
    STATE(2474), 1,
      sym_text_interpolation,
  [75613] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(970), 1,
      sym_compound_statement,
    STATE(2475), 1,
      sym_text_interpolation,
  [75629] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3719), 1,
      anon_sym_LBRACE,
    STATE(521), 1,
      sym_enum_declaration_list,
    STATE(2476), 1,
      sym_text_interpolation,
  [75645] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2477), 1,
      sym_text_interpolation,
    ACTIONS(4681), 2,
      anon_sym_string,
      anon_sym_int,
  [75659] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_declaration_list,
    STATE(2478), 1,
      sym_text_interpolation,
  [75675] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3975), 1,
      anon_sym_LBRACE,
    STATE(540), 1,
      sym_declaration_list,
    STATE(2479), 1,
      sym_text_interpolation,
  [75691] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(918), 1,
      sym_compound_statement,
    STATE(2480), 1,
      sym_text_interpolation,
  [75707] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3414), 1,
      anon_sym_LBRACE,
    STATE(1689), 1,
      sym_declaration_list,
    STATE(2481), 1,
      sym_text_interpolation,
  [75723] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_RPAREN,
    ACTIONS(4520), 1,
      anon_sym_EQ,
    STATE(2482), 1,
      sym_text_interpolation,
  [75739] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(960), 1,
      sym_declaration_list,
    STATE(2483), 1,
      sym_text_interpolation,
  [75755] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3468), 1,
      anon_sym_LBRACE,
    STATE(1072), 1,
      sym_compound_statement,
    STATE(2484), 1,
      sym_text_interpolation,
  [75771] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4683), 1,
      anon_sym_SEMI,
    ACTIONS(4685), 1,
      sym__automatic_semicolon,
    STATE(2485), 1,
      sym_text_interpolation,
  [75787] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3230), 1,
      anon_sym_LPAREN,
    STATE(2144), 1,
      sym_formal_parameters,
    STATE(2486), 1,
      sym_text_interpolation,
  [75803] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4687), 1,
      anon_sym_RPAREN,
    STATE(2487), 1,
      sym_text_interpolation,
  [75816] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4689), 1,
      sym_name,
    STATE(2488), 1,
      sym_text_interpolation,
  [75829] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4231), 1,
      anon_sym_RPAREN,
    STATE(2489), 1,
      sym_text_interpolation,
  [75842] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4691), 1,
      aux_sym_while_statement_token2,
    STATE(2490), 1,
      sym_text_interpolation,
  [75855] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4693), 1,
      anon_sym_EQ_GT,
    STATE(2491), 1,
      sym_text_interpolation,
  [75868] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4695), 1,
      anon_sym_EQ,
    STATE(2492), 1,
      sym_text_interpolation,
  [75881] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4697), 1,
      anon_sym_COLON_COLON,
    STATE(2493), 1,
      sym_text_interpolation,
  [75894] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4699), 1,
      sym_heredoc_end,
    STATE(2494), 1,
      sym_text_interpolation,
  [75907] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(905), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2495), 1,
      sym_text_interpolation,
  [75920] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4701), 1,
      anon_sym_RPAREN,
    STATE(2496), 1,
      sym_text_interpolation,
  [75933] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_RPAREN,
    STATE(2497), 1,
      sym_text_interpolation,
  [75946] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4703), 1,
      sym_heredoc_end,
    STATE(2498), 1,
      sym_text_interpolation,
  [75959] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4705), 1,
      anon_sym_EQ_GT,
    STATE(2499), 1,
      sym_text_interpolation,
  [75972] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(901), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2500), 1,
      sym_text_interpolation,
  [75985] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4707), 1,
      anon_sym_RPAREN,
    STATE(2501), 1,
      sym_text_interpolation,
  [75998] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4709), 1,
      anon_sym_RPAREN,
    STATE(2502), 1,
      sym_text_interpolation,
  [76011] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4711), 1,
      anon_sym_RPAREN,
    STATE(2503), 1,
      sym_text_interpolation,
  [76024] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4713), 1,
      anon_sym_LPAREN,
    STATE(2504), 1,
      sym_text_interpolation,
  [76037] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4715), 1,
      anon_sym_EQ,
    STATE(2505), 1,
      sym_text_interpolation,
  [76050] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4717), 1,
      anon_sym_LPAREN,
    STATE(2506), 1,
      sym_text_interpolation,
  [76063] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4719), 1,
      anon_sym_RPAREN,
    STATE(2507), 1,
      sym_text_interpolation,
  [76076] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4721), 1,
      sym_name,
    STATE(2508), 1,
      sym_text_interpolation,
  [76089] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4723), 1,
      anon_sym_RPAREN,
    STATE(2509), 1,
      sym_text_interpolation,
  [76102] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4173), 1,
      anon_sym_RBRACK,
    STATE(2510), 1,
      sym_text_interpolation,
  [76115] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4725), 1,
      anon_sym_EQ_GT,
    STATE(2511), 1,
      sym_text_interpolation,
  [76128] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4727), 1,
      anon_sym_SEMI,
    STATE(2512), 1,
      sym_text_interpolation,
  [76141] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4729), 1,
      sym_name,
    STATE(2513), 1,
      sym_text_interpolation,
  [76154] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4211), 1,
      anon_sym_RPAREN,
    STATE(2514), 1,
      sym_text_interpolation,
  [76167] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4731), 1,
      anon_sym_DQUOTE2,
    STATE(2515), 1,
      sym_text_interpolation,
  [76180] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4733), 1,
      anon_sym_SQUOTE2,
    STATE(2516), 1,
      sym_text_interpolation,
  [76193] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_RPAREN,
    STATE(2517), 1,
      sym_text_interpolation,
  [76206] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4735), 1,
      sym_name,
    STATE(2518), 1,
      sym_text_interpolation,
  [76219] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_BSLASH,
    STATE(2519), 1,
      sym_text_interpolation,
  [76232] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4739), 1,
      anon_sym_BSLASH,
    STATE(2520), 1,
      sym_text_interpolation,
  [76245] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4741), 1,
      anon_sym_RBRACK,
    STATE(2521), 1,
      sym_text_interpolation,
  [76258] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4743), 1,
      sym_name,
    STATE(2522), 1,
      sym_text_interpolation,
  [76271] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4269), 1,
      sym_name,
    STATE(2523), 1,
      sym_text_interpolation,
  [76284] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4745), 1,
      anon_sym_BSLASH,
    STATE(2524), 1,
      sym_text_interpolation,
  [76297] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4747), 1,
      aux_sym_if_statement_token2,
    STATE(2525), 1,
      sym_text_interpolation,
  [76310] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4749), 1,
      sym_name,
    STATE(2526), 1,
      sym_text_interpolation,
  [76323] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4751), 1,
      sym_name,
    STATE(2527), 1,
      sym_text_interpolation,
  [76336] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4753), 1,
      aux_sym_class_declaration_token1,
    STATE(2528), 1,
      sym_text_interpolation,
  [76349] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4755), 1,
      sym_name,
    STATE(2529), 1,
      sym_text_interpolation,
  [76362] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4757), 1,
      sym_name,
    STATE(2530), 1,
      sym_text_interpolation,
  [76375] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4759), 1,
      anon_sym_BSLASH,
    STATE(2531), 1,
      sym_text_interpolation,
  [76388] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4761), 1,
      aux_sym__arrow_function_header_token1,
    STATE(2532), 1,
      sym_text_interpolation,
  [76401] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4189), 1,
      aux_sym_class_declaration_token1,
    STATE(2533), 1,
      sym_text_interpolation,
  [76414] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym_name,
    STATE(2534), 1,
      sym_text_interpolation,
  [76427] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4765), 1,
      anon_sym_COLON_COLON,
    STATE(2535), 1,
      sym_text_interpolation,
  [76440] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4767), 1,
      sym_name,
    STATE(2536), 1,
      sym_text_interpolation,
  [76453] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4769), 1,
      sym_name,
    STATE(2537), 1,
      sym_text_interpolation,
  [76466] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4569), 1,
      anon_sym_RPAREN,
    STATE(2538), 1,
      sym_text_interpolation,
  [76479] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4771), 1,
      aux_sym_foreach_statement_token2,
    STATE(2539), 1,
      sym_text_interpolation,
  [76492] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4773), 1,
      aux_sym_class_declaration_token1,
    STATE(2540), 1,
      sym_text_interpolation,
  [76505] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4775), 1,
      sym_name,
    STATE(2541), 1,
      sym_text_interpolation,
  [76518] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4199), 1,
      sym_name,
    STATE(2542), 1,
      sym_text_interpolation,
  [76531] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4777), 1,
      anon_sym_RPAREN,
    STATE(2543), 1,
      sym_text_interpolation,
  [76544] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4779), 1,
      sym_name,
    STATE(2544), 1,
      sym_text_interpolation,
  [76557] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4781), 1,
      anon_sym_RPAREN,
    STATE(2545), 1,
      sym_text_interpolation,
  [76570] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4783), 1,
      sym_heredoc_start,
    STATE(2546), 1,
      sym_text_interpolation,
  [76583] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4785), 1,
      sym_heredoc_start,
    STATE(2547), 1,
      sym_text_interpolation,
  [76596] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4787), 1,
      aux_sym_if_statement_token2,
    STATE(2548), 1,
      sym_text_interpolation,
  [76609] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_RPAREN,
    STATE(2549), 1,
      sym_text_interpolation,
  [76622] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(891), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2550), 1,
      sym_text_interpolation,
  [76635] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4789), 1,
      anon_sym_RPAREN,
    STATE(2551), 1,
      sym_text_interpolation,
  [76648] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4791), 1,
      anon_sym_RPAREN,
    STATE(2552), 1,
      sym_text_interpolation,
  [76661] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4793), 1,
      aux_sym_if_statement_token2,
    STATE(2553), 1,
      sym_text_interpolation,
  [76674] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_RPAREN,
    STATE(2554), 1,
      sym_text_interpolation,
  [76687] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(885), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2555), 1,
      sym_text_interpolation,
  [76700] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4795), 1,
      anon_sym_RPAREN,
    STATE(2556), 1,
      sym_text_interpolation,
  [76713] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_RPAREN,
    STATE(2557), 1,
      sym_text_interpolation,
  [76726] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4797), 1,
      anon_sym_SEMI,
    STATE(2558), 1,
      sym_text_interpolation,
  [76739] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2559), 1,
      sym_text_interpolation,
  [76752] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4799), 1,
      sym_name,
    STATE(2560), 1,
      sym_text_interpolation,
  [76765] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(915), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2561), 1,
      sym_text_interpolation,
  [76778] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4801), 1,
      aux_sym_class_declaration_token1,
    STATE(2562), 1,
      sym_text_interpolation,
  [76791] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4803), 1,
      anon_sym_EQ_GT,
    STATE(2563), 1,
      sym_text_interpolation,
  [76804] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4805), 1,
      anon_sym_EQ,
    STATE(2564), 1,
      sym_text_interpolation,
  [76817] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_COLON_COLON,
    STATE(2565), 1,
      sym_text_interpolation,
  [76830] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4809), 1,
      anon_sym_RPAREN,
    STATE(2566), 1,
      sym_text_interpolation,
  [76843] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4811), 1,
      anon_sym_RPAREN,
    STATE(2567), 1,
      sym_text_interpolation,
  [76856] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4813), 1,
      aux_sym_if_statement_token2,
    STATE(2568), 1,
      sym_text_interpolation,
  [76869] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4815), 1,
      aux_sym_foreach_statement_token2,
    STATE(2569), 1,
      sym_text_interpolation,
  [76882] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4817), 1,
      sym_name,
    STATE(2570), 1,
      sym_text_interpolation,
  [76895] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4819), 1,
      aux_sym_while_statement_token1,
    STATE(2571), 1,
      sym_text_interpolation,
  [76908] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4821), 1,
      sym_name,
    STATE(2572), 1,
      sym_text_interpolation,
  [76921] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4823), 1,
      anon_sym_RPAREN,
    STATE(2573), 1,
      sym_text_interpolation,
  [76934] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4326), 1,
      anon_sym_RPAREN,
    STATE(2574), 1,
      sym_text_interpolation,
  [76947] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4159), 1,
      anon_sym_RPAREN,
    STATE(2575), 1,
      sym_text_interpolation,
  [76960] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4825), 1,
      anon_sym_RPAREN,
    STATE(2576), 1,
      sym_text_interpolation,
  [76973] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4143), 1,
      anon_sym_LBRACE,
    STATE(2577), 1,
      sym_text_interpolation,
  [76986] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4827), 1,
      sym_name,
    STATE(2578), 1,
      sym_text_interpolation,
  [76999] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ_GT,
    STATE(2579), 1,
      sym_text_interpolation,
  [77012] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4831), 1,
      anon_sym_RPAREN,
    STATE(2580), 1,
      sym_text_interpolation,
  [77025] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4833), 1,
      anon_sym_RPAREN,
    STATE(2581), 1,
      sym_text_interpolation,
  [77038] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4835), 1,
      sym_heredoc_end,
    STATE(2582), 1,
      sym_text_interpolation,
  [77051] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4837), 1,
      sym_name,
    STATE(2583), 1,
      sym_text_interpolation,
  [77064] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4839), 1,
      anon_sym_SQUOTE2,
    STATE(2584), 1,
      sym_text_interpolation,
  [77077] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4841), 1,
      anon_sym_DQUOTE2,
    STATE(2585), 1,
      sym_text_interpolation,
  [77090] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4843), 1,
      anon_sym_RPAREN,
    STATE(2586), 1,
      sym_text_interpolation,
  [77103] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4845), 1,
      anon_sym_RBRACK,
    STATE(2587), 1,
      sym_text_interpolation,
  [77116] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym_RPAREN,
    STATE(2588), 1,
      sym_text_interpolation,
  [77129] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4849), 1,
      sym_heredoc_end,
    STATE(2589), 1,
      sym_text_interpolation,
  [77142] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_RBRACK,
    STATE(2590), 1,
      sym_text_interpolation,
  [77155] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_EQ_GT,
    STATE(2591), 1,
      sym_text_interpolation,
  [77168] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4855), 1,
      aux_sym_while_statement_token2,
    STATE(2592), 1,
      sym_text_interpolation,
  [77181] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3643), 1,
      anon_sym_BSLASH,
    STATE(2593), 1,
      sym_text_interpolation,
  [77194] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3348), 1,
      anon_sym_EQ,
    STATE(2594), 1,
      sym_text_interpolation,
  [77207] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_RPAREN,
    STATE(2595), 1,
      sym_text_interpolation,
  [77220] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4859), 1,
      sym_name,
    STATE(2596), 1,
      sym_text_interpolation,
  [77233] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4861), 1,
      sym_name,
    STATE(2597), 1,
      sym_text_interpolation,
  [77246] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4863), 1,
      anon_sym_RPAREN,
    STATE(2598), 1,
      sym_text_interpolation,
  [77259] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4865), 1,
      anon_sym_RPAREN,
    STATE(2599), 1,
      sym_text_interpolation,
  [77272] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_BSLASH,
    STATE(2600), 1,
      sym_text_interpolation,
  [77285] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4869), 1,
      aux_sym_class_declaration_token1,
    STATE(2601), 1,
      sym_text_interpolation,
  [77298] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_EQ_GT,
    STATE(2602), 1,
      sym_text_interpolation,
  [77311] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4112), 1,
      anon_sym_LBRACE,
    STATE(2603), 1,
      sym_text_interpolation,
  [77324] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4873), 1,
      anon_sym_COLON_COLON,
    STATE(2604), 1,
      sym_text_interpolation,
  [77337] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4875), 1,
      sym_name,
    STATE(2605), 1,
      sym_text_interpolation,
  [77350] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4141), 1,
      aux_sym_class_declaration_token1,
    STATE(2606), 1,
      sym_text_interpolation,
  [77363] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4877), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(2607), 1,
      sym_text_interpolation,
  [77376] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4879), 1,
      anon_sym_BSLASH,
    STATE(2608), 1,
      sym_text_interpolation,
  [77389] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4881), 1,
      sym_name,
    STATE(2609), 1,
      sym_text_interpolation,
  [77402] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4139), 1,
      anon_sym_RBRACE,
    STATE(2610), 1,
      sym_text_interpolation,
  [77415] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(907), 1,
      anon_sym_SEMI,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2611), 1,
      sym_text_interpolation,
  [77428] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4883), 1,
      aux_sym_while_statement_token1,
    STATE(2612), 1,
      sym_text_interpolation,
  [77441] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4885), 1,
      sym_heredoc_start,
    STATE(2613), 1,
      sym_text_interpolation,
  [77454] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4887), 1,
      sym_heredoc_start,
    STATE(2614), 1,
      sym_text_interpolation,
  [77467] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4889), 1,
      aux_sym_class_declaration_token1,
    STATE(2615), 1,
      sym_text_interpolation,
  [77480] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4567), 1,
      anon_sym_LPAREN,
    STATE(2616), 1,
      sym_text_interpolation,
  [77493] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4891), 1,
      sym_name,
    STATE(2617), 1,
      sym_text_interpolation,
  [77506] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4133), 1,
      aux_sym_class_declaration_token1,
    STATE(2618), 1,
      sym_text_interpolation,
  [77519] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4893), 1,
      anon_sym_BSLASH,
    STATE(2619), 1,
      sym_text_interpolation,
  [77532] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_BSLASH,
    STATE(2620), 1,
      sym_text_interpolation,
  [77545] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4897), 1,
      sym_name,
    STATE(2621), 1,
      sym_text_interpolation,
  [77558] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4899), 1,
      sym_name,
    STATE(2622), 1,
      sym_text_interpolation,
  [77571] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_RPAREN,
    STATE(2623), 1,
      sym_text_interpolation,
  [77584] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4903), 1,
      sym_name,
    STATE(2624), 1,
      sym_text_interpolation,
  [77597] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4905), 1,
      anon_sym_EQ_GT,
    STATE(2625), 1,
      sym_text_interpolation,
  [77610] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4907), 1,
      aux_sym_if_statement_token2,
    STATE(2626), 1,
      sym_text_interpolation,
  [77623] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4909), 1,
      aux_sym_class_declaration_token1,
    STATE(2627), 1,
      sym_text_interpolation,
  [77636] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4911), 1,
      anon_sym_BSLASH,
    STATE(2628), 1,
      sym_text_interpolation,
  [77649] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4913), 1,
      anon_sym_COLON_COLON,
    STATE(2629), 1,
      sym_text_interpolation,
  [77662] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4915), 1,
      anon_sym_COLON_COLON,
    STATE(2630), 1,
      sym_text_interpolation,
  [77675] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4386), 1,
      anon_sym_RBRACE,
    STATE(2631), 1,
      sym_text_interpolation,
  [77688] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(889), 1,
      anon_sym_SEMI,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2632), 1,
      sym_text_interpolation,
  [77701] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4917), 1,
      anon_sym_EQ_GT,
    STATE(2633), 1,
      sym_text_interpolation,
  [77714] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3582), 1,
      sym_name,
    STATE(2634), 1,
      sym_text_interpolation,
  [77727] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4919), 1,
      anon_sym_EQ_GT,
    STATE(2635), 1,
      sym_text_interpolation,
  [77740] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4122), 1,
      anon_sym_RPAREN,
    STATE(2636), 1,
      sym_text_interpolation,
  [77753] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(895), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2637), 1,
      sym_text_interpolation,
  [77766] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4921), 1,
      anon_sym_SEMI,
    STATE(2638), 1,
      sym_text_interpolation,
  [77779] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    STATE(2639), 1,
      sym_text_interpolation,
  [77792] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4923), 1,
      anon_sym_COLON_COLON,
    STATE(2640), 1,
      sym_text_interpolation,
  [77805] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4925), 1,
      anon_sym_COLON_COLON,
    STATE(2641), 1,
      sym_text_interpolation,
  [77818] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(897), 1,
      anon_sym_RPAREN,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2642), 1,
      sym_text_interpolation,
  [77831] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4927), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym_text_interpolation,
  [77844] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4520), 1,
      anon_sym_EQ,
    STATE(2644), 1,
      sym_text_interpolation,
  [77857] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4929), 1,
      anon_sym_RPAREN,
    STATE(2645), 1,
      sym_text_interpolation,
  [77870] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COLON_COLON,
    STATE(2646), 1,
      sym_text_interpolation,
  [77883] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4931), 1,
      anon_sym_COLON_COLON,
    STATE(2647), 1,
      sym_text_interpolation,
  [77896] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4396), 1,
      anon_sym_RPAREN,
    STATE(2648), 1,
      sym_text_interpolation,
  [77909] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4933), 1,
      anon_sym_EQ,
    STATE(2649), 1,
      sym_text_interpolation,
  [77922] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4935), 1,
      anon_sym_EQ_GT,
    STATE(2650), 1,
      sym_text_interpolation,
  [77935] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4937), 1,
      anon_sym_COLON_COLON,
    STATE(2651), 1,
      sym_text_interpolation,
  [77948] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4939), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(2652), 1,
      sym_text_interpolation,
  [77961] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4941), 1,
      aux_sym__arrow_function_header_token1,
    STATE(2653), 1,
      sym_text_interpolation,
  [77974] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4116), 1,
      aux_sym_class_declaration_token1,
    STATE(2654), 1,
      sym_text_interpolation,
  [77987] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_RPAREN,
    STATE(2655), 1,
      sym_text_interpolation,
  [78000] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4943), 1,
      anon_sym_BSLASH,
    STATE(2656), 1,
      sym_text_interpolation,
  [78013] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4945), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(2657), 1,
      sym_text_interpolation,
  [78026] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4425), 1,
      anon_sym_RPAREN,
    STATE(2658), 1,
      sym_text_interpolation,
  [78039] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4947), 1,
      sym_name,
    STATE(2659), 1,
      sym_text_interpolation,
  [78052] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4949), 1,
      anon_sym_EQ_GT,
    STATE(2660), 1,
      sym_text_interpolation,
  [78065] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(877), 1,
      anon_sym_SEMI,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2661), 1,
      sym_text_interpolation,
  [78078] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4951), 1,
      anon_sym_COLON_COLON,
    STATE(2662), 1,
      sym_text_interpolation,
  [78091] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4205), 1,
      anon_sym_RBRACK,
    STATE(2663), 1,
      sym_text_interpolation,
  [78104] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_LPAREN,
    STATE(2664), 1,
      sym_text_interpolation,
  [78117] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4955), 1,
      anon_sym_SEMI,
    STATE(2665), 1,
      sym_text_interpolation,
  [78130] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4957), 1,
      sym_heredoc_end,
    STATE(2666), 1,
      sym_text_interpolation,
  [78143] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4959), 1,
      sym_name,
    STATE(2667), 1,
      sym_text_interpolation,
  [78156] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(3708), 1,
      sym_name,
    STATE(2668), 1,
      sym_text_interpolation,
  [78169] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4961), 1,
      anon_sym_LPAREN,
    STATE(2669), 1,
      sym_text_interpolation,
  [78182] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4963), 1,
      anon_sym_LPAREN,
    STATE(2670), 1,
      sym_text_interpolation,
  [78195] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4454), 1,
      anon_sym_RPAREN,
    STATE(2671), 1,
      sym_text_interpolation,
  [78208] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4965), 1,
      sym_name,
    STATE(2672), 1,
      sym_text_interpolation,
  [78221] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4967), 1,
      anon_sym_RBRACK,
    STATE(2673), 1,
      sym_text_interpolation,
  [78234] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4969), 1,
      anon_sym_LPAREN,
    STATE(2674), 1,
      sym_text_interpolation,
  [78247] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4971), 1,
      anon_sym_LPAREN,
    STATE(2675), 1,
      sym_text_interpolation,
  [78260] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    STATE(2676), 1,
      sym_text_interpolation,
  [78273] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4975), 1,
      anon_sym_LPAREN,
    STATE(2677), 1,
      sym_text_interpolation,
  [78286] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4977), 1,
      anon_sym_LPAREN,
    STATE(2678), 1,
      sym_text_interpolation,
  [78299] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4979), 1,
      sym_integer,
    STATE(2679), 1,
      sym_text_interpolation,
  [78312] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4981), 1,
      anon_sym_RBRACK,
    STATE(2680), 1,
      sym_text_interpolation,
  [78325] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4096), 1,
      anon_sym_RPAREN,
    STATE(2681), 1,
      sym_text_interpolation,
  [78338] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4983), 1,
      sym_name,
    STATE(2682), 1,
      sym_text_interpolation,
  [78351] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4985), 1,
      sym_heredoc_end,
    STATE(2683), 1,
      sym_text_interpolation,
  [78364] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4987), 1,
      anon_sym_RPAREN,
    STATE(2684), 1,
      sym_text_interpolation,
  [78377] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4989), 1,
      anon_sym_LPAREN,
    STATE(2685), 1,
      sym_text_interpolation,
  [78390] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4991), 1,
      sym_name,
    STATE(2686), 1,
      sym_text_interpolation,
  [78403] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4993), 1,
      anon_sym_SEMI,
    STATE(2687), 1,
      sym_text_interpolation,
  [78416] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4995), 1,
      sym_name,
    STATE(2688), 1,
      sym_text_interpolation,
  [78429] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(893), 1,
      anon_sym_SEMI,
    ACTIONS(1570), 1,
      sym_comment,
    STATE(2689), 1,
      sym_text_interpolation,
  [78442] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4997), 1,
      sym_name,
    STATE(2690), 1,
      sym_text_interpolation,
  [78455] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4999), 1,
      sym_name,
    STATE(2691), 1,
      sym_text_interpolation,
  [78468] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5001), 1,
      anon_sym_SEMI,
    STATE(2692), 1,
      sym_text_interpolation,
  [78481] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5003), 1,
      anon_sym_LPAREN,
    STATE(2693), 1,
      sym_text_interpolation,
  [78494] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(4468), 1,
      anon_sym_RPAREN,
    STATE(2694), 1,
      sym_text_interpolation,
  [78507] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5005), 1,
      anon_sym_SEMI,
    STATE(2695), 1,
      sym_text_interpolation,
  [78520] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5007), 1,
      anon_sym_COLON_COLON,
    STATE(2696), 1,
      sym_text_interpolation,
  [78533] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5009), 1,
      anon_sym_LPAREN,
    STATE(2697), 1,
      sym_text_interpolation,
  [78546] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5011), 1,
      anon_sym_LPAREN,
    STATE(2698), 1,
      sym_text_interpolation,
  [78559] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5013), 1,
      anon_sym_EQ_GT,
    STATE(2699), 1,
      sym_text_interpolation,
  [78572] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5015), 1,
      anon_sym_LPAREN,
    STATE(2700), 1,
      sym_text_interpolation,
  [78585] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5017), 1,
      sym_name,
    STATE(2701), 1,
      sym_text_interpolation,
  [78598] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5019), 1,
      anon_sym_SEMI,
    STATE(2702), 1,
      sym_text_interpolation,
  [78611] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5021), 1,
      anon_sym_COLON_COLON,
    STATE(2703), 1,
      sym_text_interpolation,
  [78624] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    STATE(2704), 1,
      sym_text_interpolation,
  [78637] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5025), 1,
      ts_builtin_sym_end,
    STATE(2705), 1,
      sym_text_interpolation,
  [78650] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5027), 1,
      anon_sym_LPAREN,
    STATE(2706), 1,
      sym_text_interpolation,
  [78663] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LPAREN,
    STATE(2707), 1,
      sym_text_interpolation,
  [78676] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(1570), 1,
      sym_comment,
    ACTIONS(5031), 1,
      anon_sym_EQ_GT,
    STATE(2708), 1,
      sym_text_interpolation,
  [78689] = 1,
    ACTIONS(5033), 1,
      ts_builtin_sym_end,
  [78693] = 1,
    ACTIONS(5035), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(578)] = 0,
  [SMALL_STATE(579)] = 79,
  [SMALL_STATE(580)] = 166,
  [SMALL_STATE(581)] = 245,
  [SMALL_STATE(582)] = 324,
  [SMALL_STATE(583)] = 403,
  [SMALL_STATE(584)] = 482,
  [SMALL_STATE(585)] = 556,
  [SMALL_STATE(586)] = 630,
  [SMALL_STATE(587)] = 704,
  [SMALL_STATE(588)] = 778,
  [SMALL_STATE(589)] = 852,
  [SMALL_STATE(590)] = 926,
  [SMALL_STATE(591)] = 1000,
  [SMALL_STATE(592)] = 1074,
  [SMALL_STATE(593)] = 1148,
  [SMALL_STATE(594)] = 1222,
  [SMALL_STATE(595)] = 1296,
  [SMALL_STATE(596)] = 1370,
  [SMALL_STATE(597)] = 1444,
  [SMALL_STATE(598)] = 1529,
  [SMALL_STATE(599)] = 1610,
  [SMALL_STATE(600)] = 1694,
  [SMALL_STATE(601)] = 1773,
  [SMALL_STATE(602)] = 1848,
  [SMALL_STATE(603)] = 1931,
  [SMALL_STATE(604)] = 2020,
  [SMALL_STATE(605)] = 2095,
  [SMALL_STATE(606)] = 2178,
  [SMALL_STATE(607)] = 2261,
  [SMALL_STATE(608)] = 2336,
  [SMALL_STATE(609)] = 2411,
  [SMALL_STATE(610)] = 2486,
  [SMALL_STATE(611)] = 2556,
  [SMALL_STATE(612)] = 2626,
  [SMALL_STATE(613)] = 2696,
  [SMALL_STATE(614)] = 2766,
  [SMALL_STATE(615)] = 2836,
  [SMALL_STATE(616)] = 2906,
  [SMALL_STATE(617)] = 2976,
  [SMALL_STATE(618)] = 3046,
  [SMALL_STATE(619)] = 3130,
  [SMALL_STATE(620)] = 3200,
  [SMALL_STATE(621)] = 3270,
  [SMALL_STATE(622)] = 3340,
  [SMALL_STATE(623)] = 3424,
  [SMALL_STATE(624)] = 3494,
  [SMALL_STATE(625)] = 3564,
  [SMALL_STATE(626)] = 3634,
  [SMALL_STATE(627)] = 3704,
  [SMALL_STATE(628)] = 3786,
  [SMALL_STATE(629)] = 3856,
  [SMALL_STATE(630)] = 3926,
  [SMALL_STATE(631)] = 4004,
  [SMALL_STATE(632)] = 4088,
  [SMALL_STATE(633)] = 4171,
  [SMALL_STATE(634)] = 4248,
  [SMALL_STATE(635)] = 4325,
  [SMALL_STATE(636)] = 4408,
  [SMALL_STATE(637)] = 4485,
  [SMALL_STATE(638)] = 4563,
  [SMALL_STATE(639)] = 4639,
  [SMALL_STATE(640)] = 4717,
  [SMALL_STATE(641)] = 4795,
  [SMALL_STATE(642)] = 4872,
  [SMALL_STATE(643)] = 4936,
  [SMALL_STATE(644)] = 5049,
  [SMALL_STATE(645)] = 5162,
  [SMALL_STATE(646)] = 5227,
  [SMALL_STATE(647)] = 5298,
  [SMALL_STATE(648)] = 5359,
  [SMALL_STATE(649)] = 5430,
  [SMALL_STATE(650)] = 5541,
  [SMALL_STATE(651)] = 5612,
  [SMALL_STATE(652)] = 5723,
  [SMALL_STATE(653)] = 5794,
  [SMALL_STATE(654)] = 5861,
  [SMALL_STATE(655)] = 5930,
  [SMALL_STATE(656)] = 5995,
  [SMALL_STATE(657)] = 6060,
  [SMALL_STATE(658)] = 6125,
  [SMALL_STATE(659)] = 6190,
  [SMALL_STATE(660)] = 6250,
  [SMALL_STATE(661)] = 6310,
  [SMALL_STATE(662)] = 6370,
  [SMALL_STATE(663)] = 6430,
  [SMALL_STATE(664)] = 6494,
  [SMALL_STATE(665)] = 6602,
  [SMALL_STATE(666)] = 6662,
  [SMALL_STATE(667)] = 6722,
  [SMALL_STATE(668)] = 6830,
  [SMALL_STATE(669)] = 6940,
  [SMALL_STATE(670)] = 7050,
  [SMALL_STATE(671)] = 7110,
  [SMALL_STATE(672)] = 7170,
  [SMALL_STATE(673)] = 7230,
  [SMALL_STATE(674)] = 7290,
  [SMALL_STATE(675)] = 7398,
  [SMALL_STATE(676)] = 7458,
  [SMALL_STATE(677)] = 7518,
  [SMALL_STATE(678)] = 7626,
  [SMALL_STATE(679)] = 7686,
  [SMALL_STATE(680)] = 7746,
  [SMALL_STATE(681)] = 7806,
  [SMALL_STATE(682)] = 7866,
  [SMALL_STATE(683)] = 7930,
  [SMALL_STATE(684)] = 7990,
  [SMALL_STATE(685)] = 8053,
  [SMALL_STATE(686)] = 8116,
  [SMALL_STATE(687)] = 8181,
  [SMALL_STATE(688)] = 8288,
  [SMALL_STATE(689)] = 8353,
  [SMALL_STATE(690)] = 8418,
  [SMALL_STATE(691)] = 8481,
  [SMALL_STATE(692)] = 8542,
  [SMALL_STATE(693)] = 8603,
  [SMALL_STATE(694)] = 8668,
  [SMALL_STATE(695)] = 8733,
  [SMALL_STATE(696)] = 8798,
  [SMALL_STATE(697)] = 8901,
  [SMALL_STATE(698)] = 9004,
  [SMALL_STATE(699)] = 9069,
  [SMALL_STATE(700)] = 9134,
  [SMALL_STATE(701)] = 9241,
  [SMALL_STATE(702)] = 9304,
  [SMALL_STATE(703)] = 9369,
  [SMALL_STATE(704)] = 9432,
  [SMALL_STATE(705)] = 9495,
  [SMALL_STATE(706)] = 9600,
  [SMALL_STATE(707)] = 9663,
  [SMALL_STATE(708)] = 9764,
  [SMALL_STATE(709)] = 9829,
  [SMALL_STATE(710)] = 9892,
  [SMALL_STATE(711)] = 9957,
  [SMALL_STATE(712)] = 10018,
  [SMALL_STATE(713)] = 10081,
  [SMALL_STATE(714)] = 10144,
  [SMALL_STATE(715)] = 10207,
  [SMALL_STATE(716)] = 10270,
  [SMALL_STATE(717)] = 10333,
  [SMALL_STATE(718)] = 10396,
  [SMALL_STATE(719)] = 10457,
  [SMALL_STATE(720)] = 10518,
  [SMALL_STATE(721)] = 10583,
  [SMALL_STATE(722)] = 10644,
  [SMALL_STATE(723)] = 10702,
  [SMALL_STATE(724)] = 10760,
  [SMALL_STATE(725)] = 10818,
  [SMALL_STATE(726)] = 10876,
  [SMALL_STATE(727)] = 10934,
  [SMALL_STATE(728)] = 10992,
  [SMALL_STATE(729)] = 11050,
  [SMALL_STATE(730)] = 11154,
  [SMALL_STATE(731)] = 11212,
  [SMALL_STATE(732)] = 11270,
  [SMALL_STATE(733)] = 11328,
  [SMALL_STATE(734)] = 11386,
  [SMALL_STATE(735)] = 11444,
  [SMALL_STATE(736)] = 11502,
  [SMALL_STATE(737)] = 11562,
  [SMALL_STATE(738)] = 11622,
  [SMALL_STATE(739)] = 11680,
  [SMALL_STATE(740)] = 11738,
  [SMALL_STATE(741)] = 11796,
  [SMALL_STATE(742)] = 11854,
  [SMALL_STATE(743)] = 11912,
  [SMALL_STATE(744)] = 11970,
  [SMALL_STATE(745)] = 12028,
  [SMALL_STATE(746)] = 12086,
  [SMALL_STATE(747)] = 12144,
  [SMALL_STATE(748)] = 12202,
  [SMALL_STATE(749)] = 12260,
  [SMALL_STATE(750)] = 12318,
  [SMALL_STATE(751)] = 12376,
  [SMALL_STATE(752)] = 12434,
  [SMALL_STATE(753)] = 12492,
  [SMALL_STATE(754)] = 12550,
  [SMALL_STATE(755)] = 12608,
  [SMALL_STATE(756)] = 12666,
  [SMALL_STATE(757)] = 12724,
  [SMALL_STATE(758)] = 12782,
  [SMALL_STATE(759)] = 12840,
  [SMALL_STATE(760)] = 12898,
  [SMALL_STATE(761)] = 12956,
  [SMALL_STATE(762)] = 13014,
  [SMALL_STATE(763)] = 13072,
  [SMALL_STATE(764)] = 13130,
  [SMALL_STATE(765)] = 13191,
  [SMALL_STATE(766)] = 13252,
  [SMALL_STATE(767)] = 13311,
  [SMALL_STATE(768)] = 13370,
  [SMALL_STATE(769)] = 13429,
  [SMALL_STATE(770)] = 13490,
  [SMALL_STATE(771)] = 13549,
  [SMALL_STATE(772)] = 13608,
  [SMALL_STATE(773)] = 13675,
  [SMALL_STATE(774)] = 13736,
  [SMALL_STATE(775)] = 13793,
  [SMALL_STATE(776)] = 13850,
  [SMALL_STATE(777)] = 13915,
  [SMALL_STATE(778)] = 13982,
  [SMALL_STATE(779)] = 14049,
  [SMALL_STATE(780)] = 14110,
  [SMALL_STATE(781)] = 14167,
  [SMALL_STATE(782)] = 14230,
  [SMALL_STATE(783)] = 14297,
  [SMALL_STATE(784)] = 14358,
  [SMALL_STATE(785)] = 14414,
  [SMALL_STATE(786)] = 14470,
  [SMALL_STATE(787)] = 14526,
  [SMALL_STATE(788)] = 14582,
  [SMALL_STATE(789)] = 14638,
  [SMALL_STATE(790)] = 14694,
  [SMALL_STATE(791)] = 14750,
  [SMALL_STATE(792)] = 14806,
  [SMALL_STATE(793)] = 14862,
  [SMALL_STATE(794)] = 14918,
  [SMALL_STATE(795)] = 14974,
  [SMALL_STATE(796)] = 15042,
  [SMALL_STATE(797)] = 15110,
  [SMALL_STATE(798)] = 15166,
  [SMALL_STATE(799)] = 15234,
  [SMALL_STATE(800)] = 15290,
  [SMALL_STATE(801)] = 15346,
  [SMALL_STATE(802)] = 15402,
  [SMALL_STATE(803)] = 15458,
  [SMALL_STATE(804)] = 15514,
  [SMALL_STATE(805)] = 15570,
  [SMALL_STATE(806)] = 15631,
  [SMALL_STATE(807)] = 15726,
  [SMALL_STATE(808)] = 15785,
  [SMALL_STATE(809)] = 15844,
  [SMALL_STATE(810)] = 15905,
  [SMALL_STATE(811)] = 15966,
  [SMALL_STATE(812)] = 16061,
  [SMALL_STATE(813)] = 16120,
  [SMALL_STATE(814)] = 16179,
  [SMALL_STATE(815)] = 16274,
  [SMALL_STATE(816)] = 16329,
  [SMALL_STATE(817)] = 16388,
  [SMALL_STATE(818)] = 16445,
  [SMALL_STATE(819)] = 16540,
  [SMALL_STATE(820)] = 16635,
  [SMALL_STATE(821)] = 16694,
  [SMALL_STATE(822)] = 16753,
  [SMALL_STATE(823)] = 16812,
  [SMALL_STATE(824)] = 16867,
  [SMALL_STATE(825)] = 16926,
  [SMALL_STATE(826)] = 16987,
  [SMALL_STATE(827)] = 17048,
  [SMALL_STATE(828)] = 17103,
  [SMALL_STATE(829)] = 17198,
  [SMALL_STATE(830)] = 17293,
  [SMALL_STATE(831)] = 17354,
  [SMALL_STATE(832)] = 17411,
  [SMALL_STATE(833)] = 17506,
  [SMALL_STATE(834)] = 17601,
  [SMALL_STATE(835)] = 17656,
  [SMALL_STATE(836)] = 17715,
  [SMALL_STATE(837)] = 17774,
  [SMALL_STATE(838)] = 17835,
  [SMALL_STATE(839)] = 17892,
  [SMALL_STATE(840)] = 17949,
  [SMALL_STATE(841)] = 18006,
  [SMALL_STATE(842)] = 18065,
  [SMALL_STATE(843)] = 18124,
  [SMALL_STATE(844)] = 18219,
  [SMALL_STATE(845)] = 18314,
  [SMALL_STATE(846)] = 18373,
  [SMALL_STATE(847)] = 18430,
  [SMALL_STATE(848)] = 18525,
  [SMALL_STATE(849)] = 18620,
  [SMALL_STATE(850)] = 18681,
  [SMALL_STATE(851)] = 18742,
  [SMALL_STATE(852)] = 18803,
  [SMALL_STATE(853)] = 18862,
  [SMALL_STATE(854)] = 18923,
  [SMALL_STATE(855)] = 19018,
  [SMALL_STATE(856)] = 19113,
  [SMALL_STATE(857)] = 19174,
  [SMALL_STATE(858)] = 19231,
  [SMALL_STATE(859)] = 19285,
  [SMALL_STATE(860)] = 19339,
  [SMALL_STATE(861)] = 19393,
  [SMALL_STATE(862)] = 19447,
  [SMALL_STATE(863)] = 19503,
  [SMALL_STATE(864)] = 19557,
  [SMALL_STATE(865)] = 19611,
  [SMALL_STATE(866)] = 19665,
  [SMALL_STATE(867)] = 19719,
  [SMALL_STATE(868)] = 19773,
  [SMALL_STATE(869)] = 19827,
  [SMALL_STATE(870)] = 19881,
  [SMALL_STATE(871)] = 19935,
  [SMALL_STATE(872)] = 19989,
  [SMALL_STATE(873)] = 20047,
  [SMALL_STATE(874)] = 20101,
  [SMALL_STATE(875)] = 20155,
  [SMALL_STATE(876)] = 20211,
  [SMALL_STATE(877)] = 20265,
  [SMALL_STATE(878)] = 20319,
  [SMALL_STATE(879)] = 20373,
  [SMALL_STATE(880)] = 20427,
  [SMALL_STATE(881)] = 20481,
  [SMALL_STATE(882)] = 20537,
  [SMALL_STATE(883)] = 20591,
  [SMALL_STATE(884)] = 20645,
  [SMALL_STATE(885)] = 20699,
  [SMALL_STATE(886)] = 20753,
  [SMALL_STATE(887)] = 20807,
  [SMALL_STATE(888)] = 20861,
  [SMALL_STATE(889)] = 20915,
  [SMALL_STATE(890)] = 20969,
  [SMALL_STATE(891)] = 21023,
  [SMALL_STATE(892)] = 21077,
  [SMALL_STATE(893)] = 21131,
  [SMALL_STATE(894)] = 21185,
  [SMALL_STATE(895)] = 21239,
  [SMALL_STATE(896)] = 21293,
  [SMALL_STATE(897)] = 21347,
  [SMALL_STATE(898)] = 21401,
  [SMALL_STATE(899)] = 21455,
  [SMALL_STATE(900)] = 21509,
  [SMALL_STATE(901)] = 21563,
  [SMALL_STATE(902)] = 21618,
  [SMALL_STATE(903)] = 21673,
  [SMALL_STATE(904)] = 21728,
  [SMALL_STATE(905)] = 21783,
  [SMALL_STATE(906)] = 21838,
  [SMALL_STATE(907)] = 21890,
  [SMALL_STATE(908)] = 21942,
  [SMALL_STATE(909)] = 21994,
  [SMALL_STATE(910)] = 22046,
  [SMALL_STATE(911)] = 22098,
  [SMALL_STATE(912)] = 22150,
  [SMALL_STATE(913)] = 22202,
  [SMALL_STATE(914)] = 22254,
  [SMALL_STATE(915)] = 22306,
  [SMALL_STATE(916)] = 22358,
  [SMALL_STATE(917)] = 22410,
  [SMALL_STATE(918)] = 22462,
  [SMALL_STATE(919)] = 22514,
  [SMALL_STATE(920)] = 22566,
  [SMALL_STATE(921)] = 22618,
  [SMALL_STATE(922)] = 22670,
  [SMALL_STATE(923)] = 22722,
  [SMALL_STATE(924)] = 22774,
  [SMALL_STATE(925)] = 22826,
  [SMALL_STATE(926)] = 22878,
  [SMALL_STATE(927)] = 22930,
  [SMALL_STATE(928)] = 22982,
  [SMALL_STATE(929)] = 23034,
  [SMALL_STATE(930)] = 23086,
  [SMALL_STATE(931)] = 23138,
  [SMALL_STATE(932)] = 23190,
  [SMALL_STATE(933)] = 23242,
  [SMALL_STATE(934)] = 23294,
  [SMALL_STATE(935)] = 23346,
  [SMALL_STATE(936)] = 23398,
  [SMALL_STATE(937)] = 23450,
  [SMALL_STATE(938)] = 23502,
  [SMALL_STATE(939)] = 23554,
  [SMALL_STATE(940)] = 23606,
  [SMALL_STATE(941)] = 23658,
  [SMALL_STATE(942)] = 23710,
  [SMALL_STATE(943)] = 23762,
  [SMALL_STATE(944)] = 23814,
  [SMALL_STATE(945)] = 23866,
  [SMALL_STATE(946)] = 23954,
  [SMALL_STATE(947)] = 24006,
  [SMALL_STATE(948)] = 24058,
  [SMALL_STATE(949)] = 24110,
  [SMALL_STATE(950)] = 24162,
  [SMALL_STATE(951)] = 24214,
  [SMALL_STATE(952)] = 24266,
  [SMALL_STATE(953)] = 24318,
  [SMALL_STATE(954)] = 24370,
  [SMALL_STATE(955)] = 24422,
  [SMALL_STATE(956)] = 24474,
  [SMALL_STATE(957)] = 24526,
  [SMALL_STATE(958)] = 24578,
  [SMALL_STATE(959)] = 24630,
  [SMALL_STATE(960)] = 24682,
  [SMALL_STATE(961)] = 24734,
  [SMALL_STATE(962)] = 24786,
  [SMALL_STATE(963)] = 24838,
  [SMALL_STATE(964)] = 24892,
  [SMALL_STATE(965)] = 24944,
  [SMALL_STATE(966)] = 24996,
  [SMALL_STATE(967)] = 25048,
  [SMALL_STATE(968)] = 25100,
  [SMALL_STATE(969)] = 25152,
  [SMALL_STATE(970)] = 25204,
  [SMALL_STATE(971)] = 25256,
  [SMALL_STATE(972)] = 25308,
  [SMALL_STATE(973)] = 25359,
  [SMALL_STATE(974)] = 25410,
  [SMALL_STATE(975)] = 25498,
  [SMALL_STATE(976)] = 25550,
  [SMALL_STATE(977)] = 25638,
  [SMALL_STATE(978)] = 25720,
  [SMALL_STATE(979)] = 25808,
  [SMALL_STATE(980)] = 25894,
  [SMALL_STATE(981)] = 25978,
  [SMALL_STATE(982)] = 26066,
  [SMALL_STATE(983)] = 26148,
  [SMALL_STATE(984)] = 26238,
  [SMALL_STATE(985)] = 26326,
  [SMALL_STATE(986)] = 26408,
  [SMALL_STATE(987)] = 26496,
  [SMALL_STATE(988)] = 26578,
  [SMALL_STATE(989)] = 26666,
  [SMALL_STATE(990)] = 26728,
  [SMALL_STATE(991)] = 26816,
  [SMALL_STATE(992)] = 26894,
  [SMALL_STATE(993)] = 26970,
  [SMALL_STATE(994)] = 27022,
  [SMALL_STATE(995)] = 27094,
  [SMALL_STATE(996)] = 27176,
  [SMALL_STATE(997)] = 27246,
  [SMALL_STATE(998)] = 27334,
  [SMALL_STATE(999)] = 27408,
  [SMALL_STATE(1000)] = 27474,
  [SMALL_STATE(1001)] = 27562,
  [SMALL_STATE(1002)] = 27644,
  [SMALL_STATE(1003)] = 27726,
  [SMALL_STATE(1004)] = 27784,
  [SMALL_STATE(1005)] = 27840,
  [SMALL_STATE(1006)] = 27900,
  [SMALL_STATE(1007)] = 27971,
  [SMALL_STATE(1008)] = 28058,
  [SMALL_STATE(1009)] = 28139,
  [SMALL_STATE(1010)] = 28190,
  [SMALL_STATE(1011)] = 28265,
  [SMALL_STATE(1012)] = 28342,
  [SMALL_STATE(1013)] = 28425,
  [SMALL_STATE(1014)] = 28510,
  [SMALL_STATE(1015)] = 28575,
  [SMALL_STATE(1016)] = 28636,
  [SMALL_STATE(1017)] = 28717,
  [SMALL_STATE(1018)] = 28774,
  [SMALL_STATE(1019)] = 28861,
  [SMALL_STATE(1020)] = 28920,
  [SMALL_STATE(1021)] = 29007,
  [SMALL_STATE(1022)] = 29058,
  [SMALL_STATE(1023)] = 29145,
  [SMALL_STATE(1024)] = 29214,
  [SMALL_STATE(1025)] = 29301,
  [SMALL_STATE(1026)] = 29382,
  [SMALL_STATE(1027)] = 29463,
  [SMALL_STATE(1028)] = 29544,
  [SMALL_STATE(1029)] = 29631,
  [SMALL_STATE(1030)] = 29718,
  [SMALL_STATE(1031)] = 29807,
  [SMALL_STATE(1032)] = 29888,
  [SMALL_STATE(1033)] = 29975,
  [SMALL_STATE(1034)] = 30062,
  [SMALL_STATE(1035)] = 30117,
  [SMALL_STATE(1036)] = 30190,
  [SMALL_STATE(1037)] = 30277,
  [SMALL_STATE(1038)] = 30342,
  [SMALL_STATE(1039)] = 30423,
  [SMALL_STATE(1040)] = 30471,
  [SMALL_STATE(1041)] = 30519,
  [SMALL_STATE(1042)] = 30567,
  [SMALL_STATE(1043)] = 30643,
  [SMALL_STATE(1044)] = 30723,
  [SMALL_STATE(1045)] = 30771,
  [SMALL_STATE(1046)] = 30819,
  [SMALL_STATE(1047)] = 30867,
  [SMALL_STATE(1048)] = 30915,
  [SMALL_STATE(1049)] = 30963,
  [SMALL_STATE(1050)] = 31011,
  [SMALL_STATE(1051)] = 31059,
  [SMALL_STATE(1052)] = 31107,
  [SMALL_STATE(1053)] = 31155,
  [SMALL_STATE(1054)] = 31203,
  [SMALL_STATE(1055)] = 31251,
  [SMALL_STATE(1056)] = 31299,
  [SMALL_STATE(1057)] = 31347,
  [SMALL_STATE(1058)] = 31423,
  [SMALL_STATE(1059)] = 31471,
  [SMALL_STATE(1060)] = 31519,
  [SMALL_STATE(1061)] = 31567,
  [SMALL_STATE(1062)] = 31615,
  [SMALL_STATE(1063)] = 31663,
  [SMALL_STATE(1064)] = 31713,
  [SMALL_STATE(1065)] = 31761,
  [SMALL_STATE(1066)] = 31809,
  [SMALL_STATE(1067)] = 31885,
  [SMALL_STATE(1068)] = 31933,
  [SMALL_STATE(1069)] = 31981,
  [SMALL_STATE(1070)] = 32029,
  [SMALL_STATE(1071)] = 32077,
  [SMALL_STATE(1072)] = 32125,
  [SMALL_STATE(1073)] = 32173,
  [SMALL_STATE(1074)] = 32221,
  [SMALL_STATE(1075)] = 32269,
  [SMALL_STATE(1076)] = 32355,
  [SMALL_STATE(1077)] = 32403,
  [SMALL_STATE(1078)] = 32451,
  [SMALL_STATE(1079)] = 32499,
  [SMALL_STATE(1080)] = 32547,
  [SMALL_STATE(1081)] = 32595,
  [SMALL_STATE(1082)] = 32643,
  [SMALL_STATE(1083)] = 32691,
  [SMALL_STATE(1084)] = 32777,
  [SMALL_STATE(1085)] = 32825,
  [SMALL_STATE(1086)] = 32873,
  [SMALL_STATE(1087)] = 32921,
  [SMALL_STATE(1088)] = 32969,
  [SMALL_STATE(1089)] = 33049,
  [SMALL_STATE(1090)] = 33129,
  [SMALL_STATE(1091)] = 33209,
  [SMALL_STATE(1092)] = 33259,
  [SMALL_STATE(1093)] = 33307,
  [SMALL_STATE(1094)] = 33365,
  [SMALL_STATE(1095)] = 33413,
  [SMALL_STATE(1096)] = 33461,
  [SMALL_STATE(1097)] = 33509,
  [SMALL_STATE(1098)] = 33565,
  [SMALL_STATE(1099)] = 33613,
  [SMALL_STATE(1100)] = 33673,
  [SMALL_STATE(1101)] = 33721,
  [SMALL_STATE(1102)] = 33769,
  [SMALL_STATE(1103)] = 33817,
  [SMALL_STATE(1104)] = 33865,
  [SMALL_STATE(1105)] = 33929,
  [SMALL_STATE(1106)] = 33977,
  [SMALL_STATE(1107)] = 34025,
  [SMALL_STATE(1108)] = 34095,
  [SMALL_STATE(1109)] = 34169,
  [SMALL_STATE(1110)] = 34255,
  [SMALL_STATE(1111)] = 34331,
  [SMALL_STATE(1112)] = 34379,
  [SMALL_STATE(1113)] = 34427,
  [SMALL_STATE(1114)] = 34475,
  [SMALL_STATE(1115)] = 34523,
  [SMALL_STATE(1116)] = 34603,
  [SMALL_STATE(1117)] = 34685,
  [SMALL_STATE(1118)] = 34769,
  [SMALL_STATE(1119)] = 34817,
  [SMALL_STATE(1120)] = 34897,
  [SMALL_STATE(1121)] = 34947,
  [SMALL_STATE(1122)] = 35027,
  [SMALL_STATE(1123)] = 35075,
  [SMALL_STATE(1124)] = 35129,
  [SMALL_STATE(1125)] = 35217,
  [SMALL_STATE(1126)] = 35289,
  [SMALL_STATE(1127)] = 35357,
  [SMALL_STATE(1128)] = 35443,
  [SMALL_STATE(1129)] = 35529,
  [SMALL_STATE(1130)] = 35577,
  [SMALL_STATE(1131)] = 35663,
  [SMALL_STATE(1132)] = 35749,
  [SMALL_STATE(1133)] = 35835,
  [SMALL_STATE(1134)] = 35921,
  [SMALL_STATE(1135)] = 36007,
  [SMALL_STATE(1136)] = 36055,
  [SMALL_STATE(1137)] = 36103,
  [SMALL_STATE(1138)] = 36179,
  [SMALL_STATE(1139)] = 36227,
  [SMALL_STATE(1140)] = 36303,
  [SMALL_STATE(1141)] = 36351,
  [SMALL_STATE(1142)] = 36427,
  [SMALL_STATE(1143)] = 36475,
  [SMALL_STATE(1144)] = 36523,
  [SMALL_STATE(1145)] = 36602,
  [SMALL_STATE(1146)] = 36677,
  [SMALL_STATE(1147)] = 36754,
  [SMALL_STATE(1148)] = 36839,
  [SMALL_STATE(1149)] = 36924,
  [SMALL_STATE(1150)] = 37009,
  [SMALL_STATE(1151)] = 37094,
  [SMALL_STATE(1152)] = 37179,
  [SMALL_STATE(1153)] = 37266,
  [SMALL_STATE(1154)] = 37351,
  [SMALL_STATE(1155)] = 37418,
  [SMALL_STATE(1156)] = 37489,
  [SMALL_STATE(1157)] = 37574,
  [SMALL_STATE(1158)] = 37623,
  [SMALL_STATE(1159)] = 37676,
  [SMALL_STATE(1160)] = 37755,
  [SMALL_STATE(1161)] = 37840,
  [SMALL_STATE(1162)] = 37925,
  [SMALL_STATE(1163)] = 38010,
  [SMALL_STATE(1164)] = 38059,
  [SMALL_STATE(1165)] = 38108,
  [SMALL_STATE(1166)] = 38165,
  [SMALL_STATE(1167)] = 38220,
  [SMALL_STATE(1168)] = 38279,
  [SMALL_STATE(1169)] = 38342,
  [SMALL_STATE(1170)] = 38411,
  [SMALL_STATE(1171)] = 38488,
  [SMALL_STATE(1172)] = 38567,
  [SMALL_STATE(1173)] = 38616,
  [SMALL_STATE(1174)] = 38695,
  [SMALL_STATE(1175)] = 38778,
  [SMALL_STATE(1176)] = 38857,
  [SMALL_STATE(1177)] = 38936,
  [SMALL_STATE(1178)] = 39017,
  [SMALL_STATE(1179)] = 39096,
  [SMALL_STATE(1180)] = 39169,
  [SMALL_STATE(1181)] = 39255,
  [SMALL_STATE(1182)] = 39341,
  [SMALL_STATE(1183)] = 39427,
  [SMALL_STATE(1184)] = 39511,
  [SMALL_STATE(1185)] = 39597,
  [SMALL_STATE(1186)] = 39683,
  [SMALL_STATE(1187)] = 39771,
  [SMALL_STATE(1188)] = 39855,
  [SMALL_STATE(1189)] = 39939,
  [SMALL_STATE(1190)] = 40022,
  [SMALL_STATE(1191)] = 40113,
  [SMALL_STATE(1192)] = 40202,
  [SMALL_STATE(1193)] = 40255,
  [SMALL_STATE(1194)] = 40346,
  [SMALL_STATE(1195)] = 40429,
  [SMALL_STATE(1196)] = 40512,
  [SMALL_STATE(1197)] = 40595,
  [SMALL_STATE(1198)] = 40686,
  [SMALL_STATE(1199)] = 40769,
  [SMALL_STATE(1200)] = 40852,
  [SMALL_STATE(1201)] = 40943,
  [SMALL_STATE(1202)] = 41014,
  [SMALL_STATE(1203)] = 41099,
  [SMALL_STATE(1204)] = 41184,
  [SMALL_STATE(1205)] = 41267,
  [SMALL_STATE(1206)] = 41338,
  [SMALL_STATE(1207)] = 41421,
  [SMALL_STATE(1208)] = 41504,
  [SMALL_STATE(1209)] = 41587,
  [SMALL_STATE(1210)] = 41670,
  [SMALL_STATE(1211)] = 41753,
  [SMALL_STATE(1212)] = 41836,
  [SMALL_STATE(1213)] = 41919,
  [SMALL_STATE(1214)] = 41972,
  [SMALL_STATE(1215)] = 42055,
  [SMALL_STATE(1216)] = 42146,
  [SMALL_STATE(1217)] = 42229,
  [SMALL_STATE(1218)] = 42312,
  [SMALL_STATE(1219)] = 42397,
  [SMALL_STATE(1220)] = 42482,
  [SMALL_STATE(1221)] = 42565,
  [SMALL_STATE(1222)] = 42648,
  [SMALL_STATE(1223)] = 42731,
  [SMALL_STATE(1224)] = 42822,
  [SMALL_STATE(1225)] = 42907,
  [SMALL_STATE(1226)] = 42998,
  [SMALL_STATE(1227)] = 43081,
  [SMALL_STATE(1228)] = 43164,
  [SMALL_STATE(1229)] = 43247,
  [SMALL_STATE(1230)] = 43330,
  [SMALL_STATE(1231)] = 43415,
  [SMALL_STATE(1232)] = 43498,
  [SMALL_STATE(1233)] = 43581,
  [SMALL_STATE(1234)] = 43666,
  [SMALL_STATE(1235)] = 43749,
  [SMALL_STATE(1236)] = 43840,
  [SMALL_STATE(1237)] = 43923,
  [SMALL_STATE(1238)] = 44006,
  [SMALL_STATE(1239)] = 44089,
  [SMALL_STATE(1240)] = 44174,
  [SMALL_STATE(1241)] = 44257,
  [SMALL_STATE(1242)] = 44340,
  [SMALL_STATE(1243)] = 44408,
  [SMALL_STATE(1244)] = 44490,
  [SMALL_STATE(1245)] = 44572,
  [SMALL_STATE(1246)] = 44654,
  [SMALL_STATE(1247)] = 44736,
  [SMALL_STATE(1248)] = 44780,
  [SMALL_STATE(1249)] = 44862,
  [SMALL_STATE(1250)] = 44944,
  [SMALL_STATE(1251)] = 45026,
  [SMALL_STATE(1252)] = 45108,
  [SMALL_STATE(1253)] = 45190,
  [SMALL_STATE(1254)] = 45258,
  [SMALL_STATE(1255)] = 45340,
  [SMALL_STATE(1256)] = 45422,
  [SMALL_STATE(1257)] = 45504,
  [SMALL_STATE(1258)] = 45586,
  [SMALL_STATE(1259)] = 45668,
  [SMALL_STATE(1260)] = 45750,
  [SMALL_STATE(1261)] = 45832,
  [SMALL_STATE(1262)] = 45914,
  [SMALL_STATE(1263)] = 45996,
  [SMALL_STATE(1264)] = 46078,
  [SMALL_STATE(1265)] = 46160,
  [SMALL_STATE(1266)] = 46242,
  [SMALL_STATE(1267)] = 46324,
  [SMALL_STATE(1268)] = 46406,
  [SMALL_STATE(1269)] = 46488,
  [SMALL_STATE(1270)] = 46570,
  [SMALL_STATE(1271)] = 46652,
  [SMALL_STATE(1272)] = 46734,
  [SMALL_STATE(1273)] = 46816,
  [SMALL_STATE(1274)] = 46898,
  [SMALL_STATE(1275)] = 46980,
  [SMALL_STATE(1276)] = 47062,
  [SMALL_STATE(1277)] = 47144,
  [SMALL_STATE(1278)] = 47226,
  [SMALL_STATE(1279)] = 47308,
  [SMALL_STATE(1280)] = 47390,
  [SMALL_STATE(1281)] = 47472,
  [SMALL_STATE(1282)] = 47554,
  [SMALL_STATE(1283)] = 47636,
  [SMALL_STATE(1284)] = 47718,
  [SMALL_STATE(1285)] = 47800,
  [SMALL_STATE(1286)] = 47882,
  [SMALL_STATE(1287)] = 47964,
  [SMALL_STATE(1288)] = 48046,
  [SMALL_STATE(1289)] = 48128,
  [SMALL_STATE(1290)] = 48210,
  [SMALL_STATE(1291)] = 48292,
  [SMALL_STATE(1292)] = 48374,
  [SMALL_STATE(1293)] = 48456,
  [SMALL_STATE(1294)] = 48538,
  [SMALL_STATE(1295)] = 48620,
  [SMALL_STATE(1296)] = 48702,
  [SMALL_STATE(1297)] = 48784,
  [SMALL_STATE(1298)] = 48866,
  [SMALL_STATE(1299)] = 48948,
  [SMALL_STATE(1300)] = 49030,
  [SMALL_STATE(1301)] = 49112,
  [SMALL_STATE(1302)] = 49194,
  [SMALL_STATE(1303)] = 49276,
  [SMALL_STATE(1304)] = 49358,
  [SMALL_STATE(1305)] = 49440,
  [SMALL_STATE(1306)] = 49522,
  [SMALL_STATE(1307)] = 49604,
  [SMALL_STATE(1308)] = 49686,
  [SMALL_STATE(1309)] = 49768,
  [SMALL_STATE(1310)] = 49850,
  [SMALL_STATE(1311)] = 49932,
  [SMALL_STATE(1312)] = 50013,
  [SMALL_STATE(1313)] = 50094,
  [SMALL_STATE(1314)] = 50137,
  [SMALL_STATE(1315)] = 50182,
  [SMALL_STATE(1316)] = 50225,
  [SMALL_STATE(1317)] = 50306,
  [SMALL_STATE(1318)] = 50387,
  [SMALL_STATE(1319)] = 50466,
  [SMALL_STATE(1320)] = 50508,
  [SMALL_STATE(1321)] = 50550,
  [SMALL_STATE(1322)] = 50592,
  [SMALL_STATE(1323)] = 50634,
  [SMALL_STATE(1324)] = 50681,
  [SMALL_STATE(1325)] = 50726,
  [SMALL_STATE(1326)] = 50765,
  [SMALL_STATE(1327)] = 50822,
  [SMALL_STATE(1328)] = 50879,
  [SMALL_STATE(1329)] = 50936,
  [SMALL_STATE(1330)] = 50975,
  [SMALL_STATE(1331)] = 51032,
  [SMALL_STATE(1332)] = 51089,
  [SMALL_STATE(1333)] = 51128,
  [SMALL_STATE(1334)] = 51167,
  [SMALL_STATE(1335)] = 51224,
  [SMALL_STATE(1336)] = 51281,
  [SMALL_STATE(1337)] = 51338,
  [SMALL_STATE(1338)] = 51395,
  [SMALL_STATE(1339)] = 51452,
  [SMALL_STATE(1340)] = 51509,
  [SMALL_STATE(1341)] = 51563,
  [SMALL_STATE(1342)] = 51617,
  [SMALL_STATE(1343)] = 51671,
  [SMALL_STATE(1344)] = 51725,
  [SMALL_STATE(1345)] = 51779,
  [SMALL_STATE(1346)] = 51833,
  [SMALL_STATE(1347)] = 51880,
  [SMALL_STATE(1348)] = 51927,
  [SMALL_STATE(1349)] = 51962,
  [SMALL_STATE(1350)] = 52009,
  [SMALL_STATE(1351)] = 52043,
  [SMALL_STATE(1352)] = 52102,
  [SMALL_STATE(1353)] = 52154,
  [SMALL_STATE(1354)] = 52187,
  [SMALL_STATE(1355)] = 52236,
  [SMALL_STATE(1356)] = 52271,
  [SMALL_STATE(1357)] = 52320,
  [SMALL_STATE(1358)] = 52350,
  [SMALL_STATE(1359)] = 52394,
  [SMALL_STATE(1360)] = 52438,
  [SMALL_STATE(1361)] = 52485,
  [SMALL_STATE(1362)] = 52512,
  [SMALL_STATE(1363)] = 52561,
  [SMALL_STATE(1364)] = 52588,
  [SMALL_STATE(1365)] = 52615,
  [SMALL_STATE(1366)] = 52642,
  [SMALL_STATE(1367)] = 52686,
  [SMALL_STATE(1368)] = 52712,
  [SMALL_STATE(1369)] = 52738,
  [SMALL_STATE(1370)] = 52764,
  [SMALL_STATE(1371)] = 52808,
  [SMALL_STATE(1372)] = 52834,
  [SMALL_STATE(1373)] = 52860,
  [SMALL_STATE(1374)] = 52886,
  [SMALL_STATE(1375)] = 52928,
  [SMALL_STATE(1376)] = 52954,
  [SMALL_STATE(1377)] = 52980,
  [SMALL_STATE(1378)] = 53006,
  [SMALL_STATE(1379)] = 53032,
  [SMALL_STATE(1380)] = 53058,
  [SMALL_STATE(1381)] = 53084,
  [SMALL_STATE(1382)] = 53110,
  [SMALL_STATE(1383)] = 53136,
  [SMALL_STATE(1384)] = 53162,
  [SMALL_STATE(1385)] = 53188,
  [SMALL_STATE(1386)] = 53234,
  [SMALL_STATE(1387)] = 53260,
  [SMALL_STATE(1388)] = 53286,
  [SMALL_STATE(1389)] = 53311,
  [SMALL_STATE(1390)] = 53358,
  [SMALL_STATE(1391)] = 53405,
  [SMALL_STATE(1392)] = 53446,
  [SMALL_STATE(1393)] = 53471,
  [SMALL_STATE(1394)] = 53496,
  [SMALL_STATE(1395)] = 53521,
  [SMALL_STATE(1396)] = 53546,
  [SMALL_STATE(1397)] = 53571,
  [SMALL_STATE(1398)] = 53614,
  [SMALL_STATE(1399)] = 53639,
  [SMALL_STATE(1400)] = 53664,
  [SMALL_STATE(1401)] = 53707,
  [SMALL_STATE(1402)] = 53732,
  [SMALL_STATE(1403)] = 53757,
  [SMALL_STATE(1404)] = 53782,
  [SMALL_STATE(1405)] = 53825,
  [SMALL_STATE(1406)] = 53868,
  [SMALL_STATE(1407)] = 53893,
  [SMALL_STATE(1408)] = 53918,
  [SMALL_STATE(1409)] = 53943,
  [SMALL_STATE(1410)] = 53968,
  [SMALL_STATE(1411)] = 53999,
  [SMALL_STATE(1412)] = 54024,
  [SMALL_STATE(1413)] = 54049,
  [SMALL_STATE(1414)] = 54074,
  [SMALL_STATE(1415)] = 54099,
  [SMALL_STATE(1416)] = 54124,
  [SMALL_STATE(1417)] = 54149,
  [SMALL_STATE(1418)] = 54190,
  [SMALL_STATE(1419)] = 54233,
  [SMALL_STATE(1420)] = 54258,
  [SMALL_STATE(1421)] = 54283,
  [SMALL_STATE(1422)] = 54308,
  [SMALL_STATE(1423)] = 54351,
  [SMALL_STATE(1424)] = 54376,
  [SMALL_STATE(1425)] = 54417,
  [SMALL_STATE(1426)] = 54442,
  [SMALL_STATE(1427)] = 54467,
  [SMALL_STATE(1428)] = 54510,
  [SMALL_STATE(1429)] = 54553,
  [SMALL_STATE(1430)] = 54594,
  [SMALL_STATE(1431)] = 54619,
  [SMALL_STATE(1432)] = 54659,
  [SMALL_STATE(1433)] = 54699,
  [SMALL_STATE(1434)] = 54735,
  [SMALL_STATE(1435)] = 54775,
  [SMALL_STATE(1436)] = 54815,
  [SMALL_STATE(1437)] = 54855,
  [SMALL_STATE(1438)] = 54892,
  [SMALL_STATE(1439)] = 54929,
  [SMALL_STATE(1440)] = 54964,
  [SMALL_STATE(1441)] = 55001,
  [SMALL_STATE(1442)] = 55038,
  [SMALL_STATE(1443)] = 55063,
  [SMALL_STATE(1444)] = 55088,
  [SMALL_STATE(1445)] = 55121,
  [SMALL_STATE(1446)] = 55154,
  [SMALL_STATE(1447)] = 55179,
  [SMALL_STATE(1448)] = 55210,
  [SMALL_STATE(1449)] = 55245,
  [SMALL_STATE(1450)] = 55270,
  [SMALL_STATE(1451)] = 55305,
  [SMALL_STATE(1452)] = 55342,
  [SMALL_STATE(1453)] = 55379,
  [SMALL_STATE(1454)] = 55407,
  [SMALL_STATE(1455)] = 55435,
  [SMALL_STATE(1456)] = 55461,
  [SMALL_STATE(1457)] = 55495,
  [SMALL_STATE(1458)] = 55529,
  [SMALL_STATE(1459)] = 55563,
  [SMALL_STATE(1460)] = 55593,
  [SMALL_STATE(1461)] = 55625,
  [SMALL_STATE(1462)] = 55649,
  [SMALL_STATE(1463)] = 55677,
  [SMALL_STATE(1464)] = 55701,
  [SMALL_STATE(1465)] = 55725,
  [SMALL_STATE(1466)] = 55757,
  [SMALL_STATE(1467)] = 55791,
  [SMALL_STATE(1468)] = 55825,
  [SMALL_STATE(1469)] = 55849,
  [SMALL_STATE(1470)] = 55873,
  [SMALL_STATE(1471)] = 55905,
  [SMALL_STATE(1472)] = 55933,
  [SMALL_STATE(1473)] = 55957,
  [SMALL_STATE(1474)] = 55986,
  [SMALL_STATE(1475)] = 56015,
  [SMALL_STATE(1476)] = 56038,
  [SMALL_STATE(1477)] = 56071,
  [SMALL_STATE(1478)] = 56100,
  [SMALL_STATE(1479)] = 56129,
  [SMALL_STATE(1480)] = 56160,
  [SMALL_STATE(1481)] = 56183,
  [SMALL_STATE(1482)] = 56214,
  [SMALL_STATE(1483)] = 56247,
  [SMALL_STATE(1484)] = 56276,
  [SMALL_STATE(1485)] = 56297,
  [SMALL_STATE(1486)] = 56326,
  [SMALL_STATE(1487)] = 56347,
  [SMALL_STATE(1488)] = 56368,
  [SMALL_STATE(1489)] = 56397,
  [SMALL_STATE(1490)] = 56426,
  [SMALL_STATE(1491)] = 56455,
  [SMALL_STATE(1492)] = 56486,
  [SMALL_STATE(1493)] = 56513,
  [SMALL_STATE(1494)] = 56542,
  [SMALL_STATE(1495)] = 56573,
  [SMALL_STATE(1496)] = 56600,
  [SMALL_STATE(1497)] = 56629,
  [SMALL_STATE(1498)] = 56656,
  [SMALL_STATE(1499)] = 56683,
  [SMALL_STATE(1500)] = 56712,
  [SMALL_STATE(1501)] = 56743,
  [SMALL_STATE(1502)] = 56770,
  [SMALL_STATE(1503)] = 56797,
  [SMALL_STATE(1504)] = 56826,
  [SMALL_STATE(1505)] = 56855,
  [SMALL_STATE(1506)] = 56884,
  [SMALL_STATE(1507)] = 56915,
  [SMALL_STATE(1508)] = 56942,
  [SMALL_STATE(1509)] = 56973,
  [SMALL_STATE(1510)] = 56994,
  [SMALL_STATE(1511)] = 57025,
  [SMALL_STATE(1512)] = 57054,
  [SMALL_STATE(1513)] = 57085,
  [SMALL_STATE(1514)] = 57106,
  [SMALL_STATE(1515)] = 57135,
  [SMALL_STATE(1516)] = 57162,
  [SMALL_STATE(1517)] = 57183,
  [SMALL_STATE(1518)] = 57210,
  [SMALL_STATE(1519)] = 57239,
  [SMALL_STATE(1520)] = 57262,
  [SMALL_STATE(1521)] = 57291,
  [SMALL_STATE(1522)] = 57318,
  [SMALL_STATE(1523)] = 57347,
  [SMALL_STATE(1524)] = 57376,
  [SMALL_STATE(1525)] = 57405,
  [SMALL_STATE(1526)] = 57436,
  [SMALL_STATE(1527)] = 57465,
  [SMALL_STATE(1528)] = 57494,
  [SMALL_STATE(1529)] = 57523,
  [SMALL_STATE(1530)] = 57548,
  [SMALL_STATE(1531)] = 57569,
  [SMALL_STATE(1532)] = 57598,
  [SMALL_STATE(1533)] = 57623,
  [SMALL_STATE(1534)] = 57648,
  [SMALL_STATE(1535)] = 57679,
  [SMALL_STATE(1536)] = 57710,
  [SMALL_STATE(1537)] = 57741,
  [SMALL_STATE(1538)] = 57768,
  [SMALL_STATE(1539)] = 57797,
  [SMALL_STATE(1540)] = 57826,
  [SMALL_STATE(1541)] = 57855,
  [SMALL_STATE(1542)] = 57884,
  [SMALL_STATE(1543)] = 57910,
  [SMALL_STATE(1544)] = 57942,
  [SMALL_STATE(1545)] = 57968,
  [SMALL_STATE(1546)] = 58002,
  [SMALL_STATE(1547)] = 58036,
  [SMALL_STATE(1548)] = 58066,
  [SMALL_STATE(1549)] = 58092,
  [SMALL_STATE(1550)] = 58120,
  [SMALL_STATE(1551)] = 58150,
  [SMALL_STATE(1552)] = 58184,
  [SMALL_STATE(1553)] = 58218,
  [SMALL_STATE(1554)] = 58252,
  [SMALL_STATE(1555)] = 58286,
  [SMALL_STATE(1556)] = 58312,
  [SMALL_STATE(1557)] = 58333,
  [SMALL_STATE(1558)] = 58354,
  [SMALL_STATE(1559)] = 58383,
  [SMALL_STATE(1560)] = 58404,
  [SMALL_STATE(1561)] = 58425,
  [SMALL_STATE(1562)] = 58452,
  [SMALL_STATE(1563)] = 58473,
  [SMALL_STATE(1564)] = 58500,
  [SMALL_STATE(1565)] = 58521,
  [SMALL_STATE(1566)] = 58544,
  [SMALL_STATE(1567)] = 58567,
  [SMALL_STATE(1568)] = 58590,
  [SMALL_STATE(1569)] = 58613,
  [SMALL_STATE(1570)] = 58636,
  [SMALL_STATE(1571)] = 58659,
  [SMALL_STATE(1572)] = 58686,
  [SMALL_STATE(1573)] = 58713,
  [SMALL_STATE(1574)] = 58736,
  [SMALL_STATE(1575)] = 58763,
  [SMALL_STATE(1576)] = 58786,
  [SMALL_STATE(1577)] = 58807,
  [SMALL_STATE(1578)] = 58830,
  [SMALL_STATE(1579)] = 58851,
  [SMALL_STATE(1580)] = 58874,
  [SMALL_STATE(1581)] = 58899,
  [SMALL_STATE(1582)] = 58926,
  [SMALL_STATE(1583)] = 58949,
  [SMALL_STATE(1584)] = 58970,
  [SMALL_STATE(1585)] = 58993,
  [SMALL_STATE(1586)] = 59014,
  [SMALL_STATE(1587)] = 59037,
  [SMALL_STATE(1588)] = 59060,
  [SMALL_STATE(1589)] = 59087,
  [SMALL_STATE(1590)] = 59108,
  [SMALL_STATE(1591)] = 59131,
  [SMALL_STATE(1592)] = 59154,
  [SMALL_STATE(1593)] = 59177,
  [SMALL_STATE(1594)] = 59200,
  [SMALL_STATE(1595)] = 59223,
  [SMALL_STATE(1596)] = 59254,
  [SMALL_STATE(1597)] = 59275,
  [SMALL_STATE(1598)] = 59296,
  [SMALL_STATE(1599)] = 59319,
  [SMALL_STATE(1600)] = 59340,
  [SMALL_STATE(1601)] = 59363,
  [SMALL_STATE(1602)] = 59391,
  [SMALL_STATE(1603)] = 59411,
  [SMALL_STATE(1604)] = 59439,
  [SMALL_STATE(1605)] = 59467,
  [SMALL_STATE(1606)] = 59495,
  [SMALL_STATE(1607)] = 59519,
  [SMALL_STATE(1608)] = 59545,
  [SMALL_STATE(1609)] = 59565,
  [SMALL_STATE(1610)] = 59585,
  [SMALL_STATE(1611)] = 59605,
  [SMALL_STATE(1612)] = 59625,
  [SMALL_STATE(1613)] = 59645,
  [SMALL_STATE(1614)] = 59673,
  [SMALL_STATE(1615)] = 59701,
  [SMALL_STATE(1616)] = 59725,
  [SMALL_STATE(1617)] = 59749,
  [SMALL_STATE(1618)] = 59773,
  [SMALL_STATE(1619)] = 59801,
  [SMALL_STATE(1620)] = 59827,
  [SMALL_STATE(1621)] = 59853,
  [SMALL_STATE(1622)] = 59875,
  [SMALL_STATE(1623)] = 59903,
  [SMALL_STATE(1624)] = 59923,
  [SMALL_STATE(1625)] = 59943,
  [SMALL_STATE(1626)] = 59971,
  [SMALL_STATE(1627)] = 59995,
  [SMALL_STATE(1628)] = 60023,
  [SMALL_STATE(1629)] = 60051,
  [SMALL_STATE(1630)] = 60077,
  [SMALL_STATE(1631)] = 60105,
  [SMALL_STATE(1632)] = 60129,
  [SMALL_STATE(1633)] = 60155,
  [SMALL_STATE(1634)] = 60183,
  [SMALL_STATE(1635)] = 60209,
  [SMALL_STATE(1636)] = 60237,
  [SMALL_STATE(1637)] = 60261,
  [SMALL_STATE(1638)] = 60289,
  [SMALL_STATE(1639)] = 60315,
  [SMALL_STATE(1640)] = 60341,
  [SMALL_STATE(1641)] = 60361,
  [SMALL_STATE(1642)] = 60381,
  [SMALL_STATE(1643)] = 60409,
  [SMALL_STATE(1644)] = 60437,
  [SMALL_STATE(1645)] = 60465,
  [SMALL_STATE(1646)] = 60493,
  [SMALL_STATE(1647)] = 60519,
  [SMALL_STATE(1648)] = 60539,
  [SMALL_STATE(1649)] = 60567,
  [SMALL_STATE(1650)] = 60595,
  [SMALL_STATE(1651)] = 60623,
  [SMALL_STATE(1652)] = 60651,
  [SMALL_STATE(1653)] = 60679,
  [SMALL_STATE(1654)] = 60707,
  [SMALL_STATE(1655)] = 60735,
  [SMALL_STATE(1656)] = 60763,
  [SMALL_STATE(1657)] = 60789,
  [SMALL_STATE(1658)] = 60817,
  [SMALL_STATE(1659)] = 60845,
  [SMALL_STATE(1660)] = 60873,
  [SMALL_STATE(1661)] = 60901,
  [SMALL_STATE(1662)] = 60929,
  [SMALL_STATE(1663)] = 60955,
  [SMALL_STATE(1664)] = 60983,
  [SMALL_STATE(1665)] = 61011,
  [SMALL_STATE(1666)] = 61039,
  [SMALL_STATE(1667)] = 61065,
  [SMALL_STATE(1668)] = 61093,
  [SMALL_STATE(1669)] = 61121,
  [SMALL_STATE(1670)] = 61141,
  [SMALL_STATE(1671)] = 61161,
  [SMALL_STATE(1672)] = 61181,
  [SMALL_STATE(1673)] = 61201,
  [SMALL_STATE(1674)] = 61221,
  [SMALL_STATE(1675)] = 61241,
  [SMALL_STATE(1676)] = 61261,
  [SMALL_STATE(1677)] = 61281,
  [SMALL_STATE(1678)] = 61309,
  [SMALL_STATE(1679)] = 61337,
  [SMALL_STATE(1680)] = 61365,
  [SMALL_STATE(1681)] = 61393,
  [SMALL_STATE(1682)] = 61413,
  [SMALL_STATE(1683)] = 61438,
  [SMALL_STATE(1684)] = 61459,
  [SMALL_STATE(1685)] = 61484,
  [SMALL_STATE(1686)] = 61509,
  [SMALL_STATE(1687)] = 61530,
  [SMALL_STATE(1688)] = 61555,
  [SMALL_STATE(1689)] = 61578,
  [SMALL_STATE(1690)] = 61599,
  [SMALL_STATE(1691)] = 61622,
  [SMALL_STATE(1692)] = 61645,
  [SMALL_STATE(1693)] = 61664,
  [SMALL_STATE(1694)] = 61687,
  [SMALL_STATE(1695)] = 61710,
  [SMALL_STATE(1696)] = 61731,
  [SMALL_STATE(1697)] = 61756,
  [SMALL_STATE(1698)] = 61777,
  [SMALL_STATE(1699)] = 61798,
  [SMALL_STATE(1700)] = 61823,
  [SMALL_STATE(1701)] = 61846,
  [SMALL_STATE(1702)] = 61869,
  [SMALL_STATE(1703)] = 61890,
  [SMALL_STATE(1704)] = 61911,
  [SMALL_STATE(1705)] = 61932,
  [SMALL_STATE(1706)] = 61957,
  [SMALL_STATE(1707)] = 61978,
  [SMALL_STATE(1708)] = 62001,
  [SMALL_STATE(1709)] = 62020,
  [SMALL_STATE(1710)] = 62041,
  [SMALL_STATE(1711)] = 62062,
  [SMALL_STATE(1712)] = 62083,
  [SMALL_STATE(1713)] = 62106,
  [SMALL_STATE(1714)] = 62127,
  [SMALL_STATE(1715)] = 62148,
  [SMALL_STATE(1716)] = 62169,
  [SMALL_STATE(1717)] = 62188,
  [SMALL_STATE(1718)] = 62207,
  [SMALL_STATE(1719)] = 62226,
  [SMALL_STATE(1720)] = 62245,
  [SMALL_STATE(1721)] = 62270,
  [SMALL_STATE(1722)] = 62293,
  [SMALL_STATE(1723)] = 62314,
  [SMALL_STATE(1724)] = 62339,
  [SMALL_STATE(1725)] = 62360,
  [SMALL_STATE(1726)] = 62381,
  [SMALL_STATE(1727)] = 62402,
  [SMALL_STATE(1728)] = 62425,
  [SMALL_STATE(1729)] = 62448,
  [SMALL_STATE(1730)] = 62473,
  [SMALL_STATE(1731)] = 62498,
  [SMALL_STATE(1732)] = 62521,
  [SMALL_STATE(1733)] = 62540,
  [SMALL_STATE(1734)] = 62561,
  [SMALL_STATE(1735)] = 62586,
  [SMALL_STATE(1736)] = 62611,
  [SMALL_STATE(1737)] = 62634,
  [SMALL_STATE(1738)] = 62655,
  [SMALL_STATE(1739)] = 62680,
  [SMALL_STATE(1740)] = 62701,
  [SMALL_STATE(1741)] = 62724,
  [SMALL_STATE(1742)] = 62749,
  [SMALL_STATE(1743)] = 62768,
  [SMALL_STATE(1744)] = 62785,
  [SMALL_STATE(1745)] = 62806,
  [SMALL_STATE(1746)] = 62827,
  [SMALL_STATE(1747)] = 62850,
  [SMALL_STATE(1748)] = 62871,
  [SMALL_STATE(1749)] = 62896,
  [SMALL_STATE(1750)] = 62919,
  [SMALL_STATE(1751)] = 62940,
  [SMALL_STATE(1752)] = 62963,
  [SMALL_STATE(1753)] = 62984,
  [SMALL_STATE(1754)] = 63001,
  [SMALL_STATE(1755)] = 63022,
  [SMALL_STATE(1756)] = 63043,
  [SMALL_STATE(1757)] = 63066,
  [SMALL_STATE(1758)] = 63089,
  [SMALL_STATE(1759)] = 63112,
  [SMALL_STATE(1760)] = 63137,
  [SMALL_STATE(1761)] = 63162,
  [SMALL_STATE(1762)] = 63183,
  [SMALL_STATE(1763)] = 63208,
  [SMALL_STATE(1764)] = 63229,
  [SMALL_STATE(1765)] = 63250,
  [SMALL_STATE(1766)] = 63271,
  [SMALL_STATE(1767)] = 63294,
  [SMALL_STATE(1768)] = 63315,
  [SMALL_STATE(1769)] = 63336,
  [SMALL_STATE(1770)] = 63361,
  [SMALL_STATE(1771)] = 63386,
  [SMALL_STATE(1772)] = 63405,
  [SMALL_STATE(1773)] = 63426,
  [SMALL_STATE(1774)] = 63443,
  [SMALL_STATE(1775)] = 63460,
  [SMALL_STATE(1776)] = 63477,
  [SMALL_STATE(1777)] = 63502,
  [SMALL_STATE(1778)] = 63521,
  [SMALL_STATE(1779)] = 63542,
  [SMALL_STATE(1780)] = 63565,
  [SMALL_STATE(1781)] = 63588,
  [SMALL_STATE(1782)] = 63607,
  [SMALL_STATE(1783)] = 63632,
  [SMALL_STATE(1784)] = 63657,
  [SMALL_STATE(1785)] = 63676,
  [SMALL_STATE(1786)] = 63696,
  [SMALL_STATE(1787)] = 63712,
  [SMALL_STATE(1788)] = 63734,
  [SMALL_STATE(1789)] = 63750,
  [SMALL_STATE(1790)] = 63766,
  [SMALL_STATE(1791)] = 63782,
  [SMALL_STATE(1792)] = 63804,
  [SMALL_STATE(1793)] = 63822,
  [SMALL_STATE(1794)] = 63844,
  [SMALL_STATE(1795)] = 63862,
  [SMALL_STATE(1796)] = 63878,
  [SMALL_STATE(1797)] = 63898,
  [SMALL_STATE(1798)] = 63914,
  [SMALL_STATE(1799)] = 63936,
  [SMALL_STATE(1800)] = 63956,
  [SMALL_STATE(1801)] = 63978,
  [SMALL_STATE(1802)] = 64000,
  [SMALL_STATE(1803)] = 64022,
  [SMALL_STATE(1804)] = 64042,
  [SMALL_STATE(1805)] = 64060,
  [SMALL_STATE(1806)] = 64080,
  [SMALL_STATE(1807)] = 64098,
  [SMALL_STATE(1808)] = 64118,
  [SMALL_STATE(1809)] = 64136,
  [SMALL_STATE(1810)] = 64154,
  [SMALL_STATE(1811)] = 64170,
  [SMALL_STATE(1812)] = 64188,
  [SMALL_STATE(1813)] = 64210,
  [SMALL_STATE(1814)] = 64228,
  [SMALL_STATE(1815)] = 64250,
  [SMALL_STATE(1816)] = 64270,
  [SMALL_STATE(1817)] = 64290,
  [SMALL_STATE(1818)] = 64310,
  [SMALL_STATE(1819)] = 64328,
  [SMALL_STATE(1820)] = 64346,
  [SMALL_STATE(1821)] = 64366,
  [SMALL_STATE(1822)] = 64386,
  [SMALL_STATE(1823)] = 64408,
  [SMALL_STATE(1824)] = 64430,
  [SMALL_STATE(1825)] = 64450,
  [SMALL_STATE(1826)] = 64470,
  [SMALL_STATE(1827)] = 64490,
  [SMALL_STATE(1828)] = 64512,
  [SMALL_STATE(1829)] = 64534,
  [SMALL_STATE(1830)] = 64550,
  [SMALL_STATE(1831)] = 64572,
  [SMALL_STATE(1832)] = 64592,
  [SMALL_STATE(1833)] = 64612,
  [SMALL_STATE(1834)] = 64632,
  [SMALL_STATE(1835)] = 64652,
  [SMALL_STATE(1836)] = 64674,
  [SMALL_STATE(1837)] = 64696,
  [SMALL_STATE(1838)] = 64712,
  [SMALL_STATE(1839)] = 64728,
  [SMALL_STATE(1840)] = 64750,
  [SMALL_STATE(1841)] = 64772,
  [SMALL_STATE(1842)] = 64792,
  [SMALL_STATE(1843)] = 64814,
  [SMALL_STATE(1844)] = 64836,
  [SMALL_STATE(1845)] = 64858,
  [SMALL_STATE(1846)] = 64874,
  [SMALL_STATE(1847)] = 64894,
  [SMALL_STATE(1848)] = 64912,
  [SMALL_STATE(1849)] = 64934,
  [SMALL_STATE(1850)] = 64954,
  [SMALL_STATE(1851)] = 64976,
  [SMALL_STATE(1852)] = 64996,
  [SMALL_STATE(1853)] = 65016,
  [SMALL_STATE(1854)] = 65038,
  [SMALL_STATE(1855)] = 65060,
  [SMALL_STATE(1856)] = 65076,
  [SMALL_STATE(1857)] = 65098,
  [SMALL_STATE(1858)] = 65120,
  [SMALL_STATE(1859)] = 65142,
  [SMALL_STATE(1860)] = 65162,
  [SMALL_STATE(1861)] = 65182,
  [SMALL_STATE(1862)] = 65198,
  [SMALL_STATE(1863)] = 65214,
  [SMALL_STATE(1864)] = 65234,
  [SMALL_STATE(1865)] = 65254,
  [SMALL_STATE(1866)] = 65276,
  [SMALL_STATE(1867)] = 65298,
  [SMALL_STATE(1868)] = 65314,
  [SMALL_STATE(1869)] = 65334,
  [SMALL_STATE(1870)] = 65354,
  [SMALL_STATE(1871)] = 65372,
  [SMALL_STATE(1872)] = 65392,
  [SMALL_STATE(1873)] = 65414,
  [SMALL_STATE(1874)] = 65434,
  [SMALL_STATE(1875)] = 65454,
  [SMALL_STATE(1876)] = 65474,
  [SMALL_STATE(1877)] = 65496,
  [SMALL_STATE(1878)] = 65516,
  [SMALL_STATE(1879)] = 65538,
  [SMALL_STATE(1880)] = 65556,
  [SMALL_STATE(1881)] = 65576,
  [SMALL_STATE(1882)] = 65598,
  [SMALL_STATE(1883)] = 65618,
  [SMALL_STATE(1884)] = 65638,
  [SMALL_STATE(1885)] = 65658,
  [SMALL_STATE(1886)] = 65678,
  [SMALL_STATE(1887)] = 65698,
  [SMALL_STATE(1888)] = 65720,
  [SMALL_STATE(1889)] = 65740,
  [SMALL_STATE(1890)] = 65760,
  [SMALL_STATE(1891)] = 65780,
  [SMALL_STATE(1892)] = 65796,
  [SMALL_STATE(1893)] = 65812,
  [SMALL_STATE(1894)] = 65832,
  [SMALL_STATE(1895)] = 65848,
  [SMALL_STATE(1896)] = 65870,
  [SMALL_STATE(1897)] = 65892,
  [SMALL_STATE(1898)] = 65914,
  [SMALL_STATE(1899)] = 65932,
  [SMALL_STATE(1900)] = 65952,
  [SMALL_STATE(1901)] = 65974,
  [SMALL_STATE(1902)] = 65996,
  [SMALL_STATE(1903)] = 66016,
  [SMALL_STATE(1904)] = 66038,
  [SMALL_STATE(1905)] = 66060,
  [SMALL_STATE(1906)] = 66080,
  [SMALL_STATE(1907)] = 66102,
  [SMALL_STATE(1908)] = 66124,
  [SMALL_STATE(1909)] = 66146,
  [SMALL_STATE(1910)] = 66166,
  [SMALL_STATE(1911)] = 66188,
  [SMALL_STATE(1912)] = 66210,
  [SMALL_STATE(1913)] = 66230,
  [SMALL_STATE(1914)] = 66252,
  [SMALL_STATE(1915)] = 66274,
  [SMALL_STATE(1916)] = 66296,
  [SMALL_STATE(1917)] = 66318,
  [SMALL_STATE(1918)] = 66340,
  [SMALL_STATE(1919)] = 66360,
  [SMALL_STATE(1920)] = 66380,
  [SMALL_STATE(1921)] = 66400,
  [SMALL_STATE(1922)] = 66422,
  [SMALL_STATE(1923)] = 66442,
  [SMALL_STATE(1924)] = 66464,
  [SMALL_STATE(1925)] = 66484,
  [SMALL_STATE(1926)] = 66504,
  [SMALL_STATE(1927)] = 66520,
  [SMALL_STATE(1928)] = 66542,
  [SMALL_STATE(1929)] = 66564,
  [SMALL_STATE(1930)] = 66586,
  [SMALL_STATE(1931)] = 66606,
  [SMALL_STATE(1932)] = 66626,
  [SMALL_STATE(1933)] = 66644,
  [SMALL_STATE(1934)] = 66666,
  [SMALL_STATE(1935)] = 66688,
  [SMALL_STATE(1936)] = 66708,
  [SMALL_STATE(1937)] = 66730,
  [SMALL_STATE(1938)] = 66752,
  [SMALL_STATE(1939)] = 66774,
  [SMALL_STATE(1940)] = 66794,
  [SMALL_STATE(1941)] = 66816,
  [SMALL_STATE(1942)] = 66838,
  [SMALL_STATE(1943)] = 66860,
  [SMALL_STATE(1944)] = 66880,
  [SMALL_STATE(1945)] = 66896,
  [SMALL_STATE(1946)] = 66914,
  [SMALL_STATE(1947)] = 66936,
  [SMALL_STATE(1948)] = 66951,
  [SMALL_STATE(1949)] = 66970,
  [SMALL_STATE(1950)] = 66987,
  [SMALL_STATE(1951)] = 67004,
  [SMALL_STATE(1952)] = 67023,
  [SMALL_STATE(1953)] = 67040,
  [SMALL_STATE(1954)] = 67059,
  [SMALL_STATE(1955)] = 67076,
  [SMALL_STATE(1956)] = 67093,
  [SMALL_STATE(1957)] = 67110,
  [SMALL_STATE(1958)] = 67127,
  [SMALL_STATE(1959)] = 67144,
  [SMALL_STATE(1960)] = 67163,
  [SMALL_STATE(1961)] = 67180,
  [SMALL_STATE(1962)] = 67197,
  [SMALL_STATE(1963)] = 67214,
  [SMALL_STATE(1964)] = 67233,
  [SMALL_STATE(1965)] = 67250,
  [SMALL_STATE(1966)] = 67269,
  [SMALL_STATE(1967)] = 67286,
  [SMALL_STATE(1968)] = 67303,
  [SMALL_STATE(1969)] = 67320,
  [SMALL_STATE(1970)] = 67337,
  [SMALL_STATE(1971)] = 67354,
  [SMALL_STATE(1972)] = 67369,
  [SMALL_STATE(1973)] = 67388,
  [SMALL_STATE(1974)] = 67407,
  [SMALL_STATE(1975)] = 67424,
  [SMALL_STATE(1976)] = 67443,
  [SMALL_STATE(1977)] = 67460,
  [SMALL_STATE(1978)] = 67479,
  [SMALL_STATE(1979)] = 67496,
  [SMALL_STATE(1980)] = 67511,
  [SMALL_STATE(1981)] = 67528,
  [SMALL_STATE(1982)] = 67545,
  [SMALL_STATE(1983)] = 67562,
  [SMALL_STATE(1984)] = 67579,
  [SMALL_STATE(1985)] = 67596,
  [SMALL_STATE(1986)] = 67615,
  [SMALL_STATE(1987)] = 67632,
  [SMALL_STATE(1988)] = 67649,
  [SMALL_STATE(1989)] = 67666,
  [SMALL_STATE(1990)] = 67685,
  [SMALL_STATE(1991)] = 67702,
  [SMALL_STATE(1992)] = 67721,
  [SMALL_STATE(1993)] = 67736,
  [SMALL_STATE(1994)] = 67755,
  [SMALL_STATE(1995)] = 67774,
  [SMALL_STATE(1996)] = 67789,
  [SMALL_STATE(1997)] = 67806,
  [SMALL_STATE(1998)] = 67823,
  [SMALL_STATE(1999)] = 67840,
  [SMALL_STATE(2000)] = 67857,
  [SMALL_STATE(2001)] = 67874,
  [SMALL_STATE(2002)] = 67891,
  [SMALL_STATE(2003)] = 67908,
  [SMALL_STATE(2004)] = 67927,
  [SMALL_STATE(2005)] = 67944,
  [SMALL_STATE(2006)] = 67961,
  [SMALL_STATE(2007)] = 67980,
  [SMALL_STATE(2008)] = 67999,
  [SMALL_STATE(2009)] = 68016,
  [SMALL_STATE(2010)] = 68035,
  [SMALL_STATE(2011)] = 68054,
  [SMALL_STATE(2012)] = 68071,
  [SMALL_STATE(2013)] = 68088,
  [SMALL_STATE(2014)] = 68105,
  [SMALL_STATE(2015)] = 68122,
  [SMALL_STATE(2016)] = 68139,
  [SMALL_STATE(2017)] = 68158,
  [SMALL_STATE(2018)] = 68175,
  [SMALL_STATE(2019)] = 68192,
  [SMALL_STATE(2020)] = 68209,
  [SMALL_STATE(2021)] = 68226,
  [SMALL_STATE(2022)] = 68243,
  [SMALL_STATE(2023)] = 68260,
  [SMALL_STATE(2024)] = 68279,
  [SMALL_STATE(2025)] = 68296,
  [SMALL_STATE(2026)] = 68313,
  [SMALL_STATE(2027)] = 68330,
  [SMALL_STATE(2028)] = 68347,
  [SMALL_STATE(2029)] = 68366,
  [SMALL_STATE(2030)] = 68385,
  [SMALL_STATE(2031)] = 68404,
  [SMALL_STATE(2032)] = 68421,
  [SMALL_STATE(2033)] = 68438,
  [SMALL_STATE(2034)] = 68457,
  [SMALL_STATE(2035)] = 68474,
  [SMALL_STATE(2036)] = 68491,
  [SMALL_STATE(2037)] = 68508,
  [SMALL_STATE(2038)] = 68525,
  [SMALL_STATE(2039)] = 68542,
  [SMALL_STATE(2040)] = 68561,
  [SMALL_STATE(2041)] = 68580,
  [SMALL_STATE(2042)] = 68597,
  [SMALL_STATE(2043)] = 68614,
  [SMALL_STATE(2044)] = 68631,
  [SMALL_STATE(2045)] = 68650,
  [SMALL_STATE(2046)] = 68669,
  [SMALL_STATE(2047)] = 68686,
  [SMALL_STATE(2048)] = 68705,
  [SMALL_STATE(2049)] = 68722,
  [SMALL_STATE(2050)] = 68739,
  [SMALL_STATE(2051)] = 68756,
  [SMALL_STATE(2052)] = 68775,
  [SMALL_STATE(2053)] = 68792,
  [SMALL_STATE(2054)] = 68809,
  [SMALL_STATE(2055)] = 68826,
  [SMALL_STATE(2056)] = 68845,
  [SMALL_STATE(2057)] = 68860,
  [SMALL_STATE(2058)] = 68879,
  [SMALL_STATE(2059)] = 68896,
  [SMALL_STATE(2060)] = 68915,
  [SMALL_STATE(2061)] = 68934,
  [SMALL_STATE(2062)] = 68953,
  [SMALL_STATE(2063)] = 68970,
  [SMALL_STATE(2064)] = 68987,
  [SMALL_STATE(2065)] = 69006,
  [SMALL_STATE(2066)] = 69025,
  [SMALL_STATE(2067)] = 69042,
  [SMALL_STATE(2068)] = 69059,
  [SMALL_STATE(2069)] = 69078,
  [SMALL_STATE(2070)] = 69095,
  [SMALL_STATE(2071)] = 69112,
  [SMALL_STATE(2072)] = 69129,
  [SMALL_STATE(2073)] = 69148,
  [SMALL_STATE(2074)] = 69165,
  [SMALL_STATE(2075)] = 69182,
  [SMALL_STATE(2076)] = 69199,
  [SMALL_STATE(2077)] = 69216,
  [SMALL_STATE(2078)] = 69231,
  [SMALL_STATE(2079)] = 69248,
  [SMALL_STATE(2080)] = 69267,
  [SMALL_STATE(2081)] = 69284,
  [SMALL_STATE(2082)] = 69299,
  [SMALL_STATE(2083)] = 69316,
  [SMALL_STATE(2084)] = 69335,
  [SMALL_STATE(2085)] = 69352,
  [SMALL_STATE(2086)] = 69369,
  [SMALL_STATE(2087)] = 69384,
  [SMALL_STATE(2088)] = 69401,
  [SMALL_STATE(2089)] = 69418,
  [SMALL_STATE(2090)] = 69435,
  [SMALL_STATE(2091)] = 69454,
  [SMALL_STATE(2092)] = 69473,
  [SMALL_STATE(2093)] = 69492,
  [SMALL_STATE(2094)] = 69509,
  [SMALL_STATE(2095)] = 69528,
  [SMALL_STATE(2096)] = 69545,
  [SMALL_STATE(2097)] = 69562,
  [SMALL_STATE(2098)] = 69579,
  [SMALL_STATE(2099)] = 69596,
  [SMALL_STATE(2100)] = 69613,
  [SMALL_STATE(2101)] = 69632,
  [SMALL_STATE(2102)] = 69651,
  [SMALL_STATE(2103)] = 69670,
  [SMALL_STATE(2104)] = 69687,
  [SMALL_STATE(2105)] = 69704,
  [SMALL_STATE(2106)] = 69723,
  [SMALL_STATE(2107)] = 69740,
  [SMALL_STATE(2108)] = 69757,
  [SMALL_STATE(2109)] = 69772,
  [SMALL_STATE(2110)] = 69787,
  [SMALL_STATE(2111)] = 69806,
  [SMALL_STATE(2112)] = 69825,
  [SMALL_STATE(2113)] = 69844,
  [SMALL_STATE(2114)] = 69863,
  [SMALL_STATE(2115)] = 69880,
  [SMALL_STATE(2116)] = 69899,
  [SMALL_STATE(2117)] = 69918,
  [SMALL_STATE(2118)] = 69937,
  [SMALL_STATE(2119)] = 69956,
  [SMALL_STATE(2120)] = 69973,
  [SMALL_STATE(2121)] = 69988,
  [SMALL_STATE(2122)] = 70003,
  [SMALL_STATE(2123)] = 70022,
  [SMALL_STATE(2124)] = 70041,
  [SMALL_STATE(2125)] = 70056,
  [SMALL_STATE(2126)] = 70071,
  [SMALL_STATE(2127)] = 70086,
  [SMALL_STATE(2128)] = 70101,
  [SMALL_STATE(2129)] = 70118,
  [SMALL_STATE(2130)] = 70135,
  [SMALL_STATE(2131)] = 70154,
  [SMALL_STATE(2132)] = 70173,
  [SMALL_STATE(2133)] = 70192,
  [SMALL_STATE(2134)] = 70211,
  [SMALL_STATE(2135)] = 70228,
  [SMALL_STATE(2136)] = 70247,
  [SMALL_STATE(2137)] = 70264,
  [SMALL_STATE(2138)] = 70281,
  [SMALL_STATE(2139)] = 70298,
  [SMALL_STATE(2140)] = 70317,
  [SMALL_STATE(2141)] = 70334,
  [SMALL_STATE(2142)] = 70351,
  [SMALL_STATE(2143)] = 70370,
  [SMALL_STATE(2144)] = 70389,
  [SMALL_STATE(2145)] = 70408,
  [SMALL_STATE(2146)] = 70427,
  [SMALL_STATE(2147)] = 70446,
  [SMALL_STATE(2148)] = 70465,
  [SMALL_STATE(2149)] = 70480,
  [SMALL_STATE(2150)] = 70497,
  [SMALL_STATE(2151)] = 70514,
  [SMALL_STATE(2152)] = 70531,
  [SMALL_STATE(2153)] = 70548,
  [SMALL_STATE(2154)] = 70563,
  [SMALL_STATE(2155)] = 70582,
  [SMALL_STATE(2156)] = 70601,
  [SMALL_STATE(2157)] = 70618,
  [SMALL_STATE(2158)] = 70635,
  [SMALL_STATE(2159)] = 70650,
  [SMALL_STATE(2160)] = 70667,
  [SMALL_STATE(2161)] = 70684,
  [SMALL_STATE(2162)] = 70703,
  [SMALL_STATE(2163)] = 70720,
  [SMALL_STATE(2164)] = 70739,
  [SMALL_STATE(2165)] = 70758,
  [SMALL_STATE(2166)] = 70777,
  [SMALL_STATE(2167)] = 70794,
  [SMALL_STATE(2168)] = 70813,
  [SMALL_STATE(2169)] = 70832,
  [SMALL_STATE(2170)] = 70849,
  [SMALL_STATE(2171)] = 70868,
  [SMALL_STATE(2172)] = 70885,
  [SMALL_STATE(2173)] = 70902,
  [SMALL_STATE(2174)] = 70919,
  [SMALL_STATE(2175)] = 70936,
  [SMALL_STATE(2176)] = 70953,
  [SMALL_STATE(2177)] = 70972,
  [SMALL_STATE(2178)] = 70989,
  [SMALL_STATE(2179)] = 71006,
  [SMALL_STATE(2180)] = 71025,
  [SMALL_STATE(2181)] = 71042,
  [SMALL_STATE(2182)] = 71061,
  [SMALL_STATE(2183)] = 71078,
  [SMALL_STATE(2184)] = 71095,
  [SMALL_STATE(2185)] = 71112,
  [SMALL_STATE(2186)] = 71127,
  [SMALL_STATE(2187)] = 71144,
  [SMALL_STATE(2188)] = 71161,
  [SMALL_STATE(2189)] = 71180,
  [SMALL_STATE(2190)] = 71199,
  [SMALL_STATE(2191)] = 71218,
  [SMALL_STATE(2192)] = 71237,
  [SMALL_STATE(2193)] = 71256,
  [SMALL_STATE(2194)] = 71271,
  [SMALL_STATE(2195)] = 71286,
  [SMALL_STATE(2196)] = 71305,
  [SMALL_STATE(2197)] = 71322,
  [SMALL_STATE(2198)] = 71339,
  [SMALL_STATE(2199)] = 71354,
  [SMALL_STATE(2200)] = 71371,
  [SMALL_STATE(2201)] = 71390,
  [SMALL_STATE(2202)] = 71409,
  [SMALL_STATE(2203)] = 71426,
  [SMALL_STATE(2204)] = 71445,
  [SMALL_STATE(2205)] = 71462,
  [SMALL_STATE(2206)] = 71479,
  [SMALL_STATE(2207)] = 71498,
  [SMALL_STATE(2208)] = 71517,
  [SMALL_STATE(2209)] = 71534,
  [SMALL_STATE(2210)] = 71549,
  [SMALL_STATE(2211)] = 71568,
  [SMALL_STATE(2212)] = 71587,
  [SMALL_STATE(2213)] = 71606,
  [SMALL_STATE(2214)] = 71625,
  [SMALL_STATE(2215)] = 71642,
  [SMALL_STATE(2216)] = 71657,
  [SMALL_STATE(2217)] = 71676,
  [SMALL_STATE(2218)] = 71695,
  [SMALL_STATE(2219)] = 71711,
  [SMALL_STATE(2220)] = 71727,
  [SMALL_STATE(2221)] = 71743,
  [SMALL_STATE(2222)] = 71759,
  [SMALL_STATE(2223)] = 71775,
  [SMALL_STATE(2224)] = 71789,
  [SMALL_STATE(2225)] = 71803,
  [SMALL_STATE(2226)] = 71819,
  [SMALL_STATE(2227)] = 71835,
  [SMALL_STATE(2228)] = 71851,
  [SMALL_STATE(2229)] = 71865,
  [SMALL_STATE(2230)] = 71881,
  [SMALL_STATE(2231)] = 71895,
  [SMALL_STATE(2232)] = 71909,
  [SMALL_STATE(2233)] = 71923,
  [SMALL_STATE(2234)] = 71939,
  [SMALL_STATE(2235)] = 71955,
  [SMALL_STATE(2236)] = 71971,
  [SMALL_STATE(2237)] = 71985,
  [SMALL_STATE(2238)] = 72001,
  [SMALL_STATE(2239)] = 72017,
  [SMALL_STATE(2240)] = 72033,
  [SMALL_STATE(2241)] = 72049,
  [SMALL_STATE(2242)] = 72065,
  [SMALL_STATE(2243)] = 72081,
  [SMALL_STATE(2244)] = 72097,
  [SMALL_STATE(2245)] = 72113,
  [SMALL_STATE(2246)] = 72127,
  [SMALL_STATE(2247)] = 72143,
  [SMALL_STATE(2248)] = 72157,
  [SMALL_STATE(2249)] = 72173,
  [SMALL_STATE(2250)] = 72187,
  [SMALL_STATE(2251)] = 72203,
  [SMALL_STATE(2252)] = 72219,
  [SMALL_STATE(2253)] = 72233,
  [SMALL_STATE(2254)] = 72249,
  [SMALL_STATE(2255)] = 72263,
  [SMALL_STATE(2256)] = 72277,
  [SMALL_STATE(2257)] = 72291,
  [SMALL_STATE(2258)] = 72307,
  [SMALL_STATE(2259)] = 72321,
  [SMALL_STATE(2260)] = 72337,
  [SMALL_STATE(2261)] = 72353,
  [SMALL_STATE(2262)] = 72367,
  [SMALL_STATE(2263)] = 72381,
  [SMALL_STATE(2264)] = 72397,
  [SMALL_STATE(2265)] = 72413,
  [SMALL_STATE(2266)] = 72427,
  [SMALL_STATE(2267)] = 72443,
  [SMALL_STATE(2268)] = 72459,
  [SMALL_STATE(2269)] = 72475,
  [SMALL_STATE(2270)] = 72489,
  [SMALL_STATE(2271)] = 72505,
  [SMALL_STATE(2272)] = 72519,
  [SMALL_STATE(2273)] = 72533,
  [SMALL_STATE(2274)] = 72549,
  [SMALL_STATE(2275)] = 72563,
  [SMALL_STATE(2276)] = 72579,
  [SMALL_STATE(2277)] = 72593,
  [SMALL_STATE(2278)] = 72609,
  [SMALL_STATE(2279)] = 72625,
  [SMALL_STATE(2280)] = 72639,
  [SMALL_STATE(2281)] = 72655,
  [SMALL_STATE(2282)] = 72671,
  [SMALL_STATE(2283)] = 72685,
  [SMALL_STATE(2284)] = 72701,
  [SMALL_STATE(2285)] = 72717,
  [SMALL_STATE(2286)] = 72733,
  [SMALL_STATE(2287)] = 72747,
  [SMALL_STATE(2288)] = 72763,
  [SMALL_STATE(2289)] = 72779,
  [SMALL_STATE(2290)] = 72793,
  [SMALL_STATE(2291)] = 72809,
  [SMALL_STATE(2292)] = 72825,
  [SMALL_STATE(2293)] = 72841,
  [SMALL_STATE(2294)] = 72855,
  [SMALL_STATE(2295)] = 72869,
  [SMALL_STATE(2296)] = 72883,
  [SMALL_STATE(2297)] = 72899,
  [SMALL_STATE(2298)] = 72915,
  [SMALL_STATE(2299)] = 72931,
  [SMALL_STATE(2300)] = 72945,
  [SMALL_STATE(2301)] = 72961,
  [SMALL_STATE(2302)] = 72977,
  [SMALL_STATE(2303)] = 72991,
  [SMALL_STATE(2304)] = 73007,
  [SMALL_STATE(2305)] = 73023,
  [SMALL_STATE(2306)] = 73039,
  [SMALL_STATE(2307)] = 73055,
  [SMALL_STATE(2308)] = 73071,
  [SMALL_STATE(2309)] = 73087,
  [SMALL_STATE(2310)] = 73101,
  [SMALL_STATE(2311)] = 73115,
  [SMALL_STATE(2312)] = 73129,
  [SMALL_STATE(2313)] = 73145,
  [SMALL_STATE(2314)] = 73159,
  [SMALL_STATE(2315)] = 73173,
  [SMALL_STATE(2316)] = 73189,
  [SMALL_STATE(2317)] = 73205,
  [SMALL_STATE(2318)] = 73221,
  [SMALL_STATE(2319)] = 73235,
  [SMALL_STATE(2320)] = 73251,
  [SMALL_STATE(2321)] = 73267,
  [SMALL_STATE(2322)] = 73283,
  [SMALL_STATE(2323)] = 73297,
  [SMALL_STATE(2324)] = 73311,
  [SMALL_STATE(2325)] = 73325,
  [SMALL_STATE(2326)] = 73341,
  [SMALL_STATE(2327)] = 73357,
  [SMALL_STATE(2328)] = 73373,
  [SMALL_STATE(2329)] = 73387,
  [SMALL_STATE(2330)] = 73403,
  [SMALL_STATE(2331)] = 73417,
  [SMALL_STATE(2332)] = 73431,
  [SMALL_STATE(2333)] = 73445,
  [SMALL_STATE(2334)] = 73459,
  [SMALL_STATE(2335)] = 73475,
  [SMALL_STATE(2336)] = 73489,
  [SMALL_STATE(2337)] = 73505,
  [SMALL_STATE(2338)] = 73521,
  [SMALL_STATE(2339)] = 73537,
  [SMALL_STATE(2340)] = 73553,
  [SMALL_STATE(2341)] = 73569,
  [SMALL_STATE(2342)] = 73585,
  [SMALL_STATE(2343)] = 73601,
  [SMALL_STATE(2344)] = 73617,
  [SMALL_STATE(2345)] = 73633,
  [SMALL_STATE(2346)] = 73649,
  [SMALL_STATE(2347)] = 73665,
  [SMALL_STATE(2348)] = 73679,
  [SMALL_STATE(2349)] = 73693,
  [SMALL_STATE(2350)] = 73707,
  [SMALL_STATE(2351)] = 73721,
  [SMALL_STATE(2352)] = 73735,
  [SMALL_STATE(2353)] = 73751,
  [SMALL_STATE(2354)] = 73767,
  [SMALL_STATE(2355)] = 73781,
  [SMALL_STATE(2356)] = 73797,
  [SMALL_STATE(2357)] = 73813,
  [SMALL_STATE(2358)] = 73827,
  [SMALL_STATE(2359)] = 73841,
  [SMALL_STATE(2360)] = 73855,
  [SMALL_STATE(2361)] = 73869,
  [SMALL_STATE(2362)] = 73885,
  [SMALL_STATE(2363)] = 73901,
  [SMALL_STATE(2364)] = 73915,
  [SMALL_STATE(2365)] = 73931,
  [SMALL_STATE(2366)] = 73947,
  [SMALL_STATE(2367)] = 73961,
  [SMALL_STATE(2368)] = 73977,
  [SMALL_STATE(2369)] = 73993,
  [SMALL_STATE(2370)] = 74007,
  [SMALL_STATE(2371)] = 74023,
  [SMALL_STATE(2372)] = 74037,
  [SMALL_STATE(2373)] = 74053,
  [SMALL_STATE(2374)] = 74067,
  [SMALL_STATE(2375)] = 74081,
  [SMALL_STATE(2376)] = 74097,
  [SMALL_STATE(2377)] = 74113,
  [SMALL_STATE(2378)] = 74129,
  [SMALL_STATE(2379)] = 74145,
  [SMALL_STATE(2380)] = 74161,
  [SMALL_STATE(2381)] = 74177,
  [SMALL_STATE(2382)] = 74193,
  [SMALL_STATE(2383)] = 74207,
  [SMALL_STATE(2384)] = 74223,
  [SMALL_STATE(2385)] = 74239,
  [SMALL_STATE(2386)] = 74255,
  [SMALL_STATE(2387)] = 74271,
  [SMALL_STATE(2388)] = 74285,
  [SMALL_STATE(2389)] = 74301,
  [SMALL_STATE(2390)] = 74317,
  [SMALL_STATE(2391)] = 74331,
  [SMALL_STATE(2392)] = 74345,
  [SMALL_STATE(2393)] = 74359,
  [SMALL_STATE(2394)] = 74373,
  [SMALL_STATE(2395)] = 74389,
  [SMALL_STATE(2396)] = 74405,
  [SMALL_STATE(2397)] = 74419,
  [SMALL_STATE(2398)] = 74435,
  [SMALL_STATE(2399)] = 74451,
  [SMALL_STATE(2400)] = 74467,
  [SMALL_STATE(2401)] = 74483,
  [SMALL_STATE(2402)] = 74499,
  [SMALL_STATE(2403)] = 74515,
  [SMALL_STATE(2404)] = 74531,
  [SMALL_STATE(2405)] = 74547,
  [SMALL_STATE(2406)] = 74563,
  [SMALL_STATE(2407)] = 74579,
  [SMALL_STATE(2408)] = 74593,
  [SMALL_STATE(2409)] = 74609,
  [SMALL_STATE(2410)] = 74625,
  [SMALL_STATE(2411)] = 74641,
  [SMALL_STATE(2412)] = 74657,
  [SMALL_STATE(2413)] = 74671,
  [SMALL_STATE(2414)] = 74687,
  [SMALL_STATE(2415)] = 74703,
  [SMALL_STATE(2416)] = 74719,
  [SMALL_STATE(2417)] = 74735,
  [SMALL_STATE(2418)] = 74749,
  [SMALL_STATE(2419)] = 74763,
  [SMALL_STATE(2420)] = 74779,
  [SMALL_STATE(2421)] = 74793,
  [SMALL_STATE(2422)] = 74809,
  [SMALL_STATE(2423)] = 74823,
  [SMALL_STATE(2424)] = 74837,
  [SMALL_STATE(2425)] = 74853,
  [SMALL_STATE(2426)] = 74869,
  [SMALL_STATE(2427)] = 74885,
  [SMALL_STATE(2428)] = 74899,
  [SMALL_STATE(2429)] = 74913,
  [SMALL_STATE(2430)] = 74929,
  [SMALL_STATE(2431)] = 74945,
  [SMALL_STATE(2432)] = 74961,
  [SMALL_STATE(2433)] = 74975,
  [SMALL_STATE(2434)] = 74989,
  [SMALL_STATE(2435)] = 75003,
  [SMALL_STATE(2436)] = 75019,
  [SMALL_STATE(2437)] = 75033,
  [SMALL_STATE(2438)] = 75049,
  [SMALL_STATE(2439)] = 75065,
  [SMALL_STATE(2440)] = 75081,
  [SMALL_STATE(2441)] = 75097,
  [SMALL_STATE(2442)] = 75113,
  [SMALL_STATE(2443)] = 75129,
  [SMALL_STATE(2444)] = 75143,
  [SMALL_STATE(2445)] = 75157,
  [SMALL_STATE(2446)] = 75171,
  [SMALL_STATE(2447)] = 75185,
  [SMALL_STATE(2448)] = 75199,
  [SMALL_STATE(2449)] = 75213,
  [SMALL_STATE(2450)] = 75227,
  [SMALL_STATE(2451)] = 75241,
  [SMALL_STATE(2452)] = 75255,
  [SMALL_STATE(2453)] = 75271,
  [SMALL_STATE(2454)] = 75285,
  [SMALL_STATE(2455)] = 75301,
  [SMALL_STATE(2456)] = 75317,
  [SMALL_STATE(2457)] = 75333,
  [SMALL_STATE(2458)] = 75349,
  [SMALL_STATE(2459)] = 75363,
  [SMALL_STATE(2460)] = 75379,
  [SMALL_STATE(2461)] = 75395,
  [SMALL_STATE(2462)] = 75411,
  [SMALL_STATE(2463)] = 75425,
  [SMALL_STATE(2464)] = 75441,
  [SMALL_STATE(2465)] = 75457,
  [SMALL_STATE(2466)] = 75473,
  [SMALL_STATE(2467)] = 75489,
  [SMALL_STATE(2468)] = 75505,
  [SMALL_STATE(2469)] = 75519,
  [SMALL_STATE(2470)] = 75535,
  [SMALL_STATE(2471)] = 75551,
  [SMALL_STATE(2472)] = 75565,
  [SMALL_STATE(2473)] = 75581,
  [SMALL_STATE(2474)] = 75597,
  [SMALL_STATE(2475)] = 75613,
  [SMALL_STATE(2476)] = 75629,
  [SMALL_STATE(2477)] = 75645,
  [SMALL_STATE(2478)] = 75659,
  [SMALL_STATE(2479)] = 75675,
  [SMALL_STATE(2480)] = 75691,
  [SMALL_STATE(2481)] = 75707,
  [SMALL_STATE(2482)] = 75723,
  [SMALL_STATE(2483)] = 75739,
  [SMALL_STATE(2484)] = 75755,
  [SMALL_STATE(2485)] = 75771,
  [SMALL_STATE(2486)] = 75787,
  [SMALL_STATE(2487)] = 75803,
  [SMALL_STATE(2488)] = 75816,
  [SMALL_STATE(2489)] = 75829,
  [SMALL_STATE(2490)] = 75842,
  [SMALL_STATE(2491)] = 75855,
  [SMALL_STATE(2492)] = 75868,
  [SMALL_STATE(2493)] = 75881,
  [SMALL_STATE(2494)] = 75894,
  [SMALL_STATE(2495)] = 75907,
  [SMALL_STATE(2496)] = 75920,
  [SMALL_STATE(2497)] = 75933,
  [SMALL_STATE(2498)] = 75946,
  [SMALL_STATE(2499)] = 75959,
  [SMALL_STATE(2500)] = 75972,
  [SMALL_STATE(2501)] = 75985,
  [SMALL_STATE(2502)] = 75998,
  [SMALL_STATE(2503)] = 76011,
  [SMALL_STATE(2504)] = 76024,
  [SMALL_STATE(2505)] = 76037,
  [SMALL_STATE(2506)] = 76050,
  [SMALL_STATE(2507)] = 76063,
  [SMALL_STATE(2508)] = 76076,
  [SMALL_STATE(2509)] = 76089,
  [SMALL_STATE(2510)] = 76102,
  [SMALL_STATE(2511)] = 76115,
  [SMALL_STATE(2512)] = 76128,
  [SMALL_STATE(2513)] = 76141,
  [SMALL_STATE(2514)] = 76154,
  [SMALL_STATE(2515)] = 76167,
  [SMALL_STATE(2516)] = 76180,
  [SMALL_STATE(2517)] = 76193,
  [SMALL_STATE(2518)] = 76206,
  [SMALL_STATE(2519)] = 76219,
  [SMALL_STATE(2520)] = 76232,
  [SMALL_STATE(2521)] = 76245,
  [SMALL_STATE(2522)] = 76258,
  [SMALL_STATE(2523)] = 76271,
  [SMALL_STATE(2524)] = 76284,
  [SMALL_STATE(2525)] = 76297,
  [SMALL_STATE(2526)] = 76310,
  [SMALL_STATE(2527)] = 76323,
  [SMALL_STATE(2528)] = 76336,
  [SMALL_STATE(2529)] = 76349,
  [SMALL_STATE(2530)] = 76362,
  [SMALL_STATE(2531)] = 76375,
  [SMALL_STATE(2532)] = 76388,
  [SMALL_STATE(2533)] = 76401,
  [SMALL_STATE(2534)] = 76414,
  [SMALL_STATE(2535)] = 76427,
  [SMALL_STATE(2536)] = 76440,
  [SMALL_STATE(2537)] = 76453,
  [SMALL_STATE(2538)] = 76466,
  [SMALL_STATE(2539)] = 76479,
  [SMALL_STATE(2540)] = 76492,
  [SMALL_STATE(2541)] = 76505,
  [SMALL_STATE(2542)] = 76518,
  [SMALL_STATE(2543)] = 76531,
  [SMALL_STATE(2544)] = 76544,
  [SMALL_STATE(2545)] = 76557,
  [SMALL_STATE(2546)] = 76570,
  [SMALL_STATE(2547)] = 76583,
  [SMALL_STATE(2548)] = 76596,
  [SMALL_STATE(2549)] = 76609,
  [SMALL_STATE(2550)] = 76622,
  [SMALL_STATE(2551)] = 76635,
  [SMALL_STATE(2552)] = 76648,
  [SMALL_STATE(2553)] = 76661,
  [SMALL_STATE(2554)] = 76674,
  [SMALL_STATE(2555)] = 76687,
  [SMALL_STATE(2556)] = 76700,
  [SMALL_STATE(2557)] = 76713,
  [SMALL_STATE(2558)] = 76726,
  [SMALL_STATE(2559)] = 76739,
  [SMALL_STATE(2560)] = 76752,
  [SMALL_STATE(2561)] = 76765,
  [SMALL_STATE(2562)] = 76778,
  [SMALL_STATE(2563)] = 76791,
  [SMALL_STATE(2564)] = 76804,
  [SMALL_STATE(2565)] = 76817,
  [SMALL_STATE(2566)] = 76830,
  [SMALL_STATE(2567)] = 76843,
  [SMALL_STATE(2568)] = 76856,
  [SMALL_STATE(2569)] = 76869,
  [SMALL_STATE(2570)] = 76882,
  [SMALL_STATE(2571)] = 76895,
  [SMALL_STATE(2572)] = 76908,
  [SMALL_STATE(2573)] = 76921,
  [SMALL_STATE(2574)] = 76934,
  [SMALL_STATE(2575)] = 76947,
  [SMALL_STATE(2576)] = 76960,
  [SMALL_STATE(2577)] = 76973,
  [SMALL_STATE(2578)] = 76986,
  [SMALL_STATE(2579)] = 76999,
  [SMALL_STATE(2580)] = 77012,
  [SMALL_STATE(2581)] = 77025,
  [SMALL_STATE(2582)] = 77038,
  [SMALL_STATE(2583)] = 77051,
  [SMALL_STATE(2584)] = 77064,
  [SMALL_STATE(2585)] = 77077,
  [SMALL_STATE(2586)] = 77090,
  [SMALL_STATE(2587)] = 77103,
  [SMALL_STATE(2588)] = 77116,
  [SMALL_STATE(2589)] = 77129,
  [SMALL_STATE(2590)] = 77142,
  [SMALL_STATE(2591)] = 77155,
  [SMALL_STATE(2592)] = 77168,
  [SMALL_STATE(2593)] = 77181,
  [SMALL_STATE(2594)] = 77194,
  [SMALL_STATE(2595)] = 77207,
  [SMALL_STATE(2596)] = 77220,
  [SMALL_STATE(2597)] = 77233,
  [SMALL_STATE(2598)] = 77246,
  [SMALL_STATE(2599)] = 77259,
  [SMALL_STATE(2600)] = 77272,
  [SMALL_STATE(2601)] = 77285,
  [SMALL_STATE(2602)] = 77298,
  [SMALL_STATE(2603)] = 77311,
  [SMALL_STATE(2604)] = 77324,
  [SMALL_STATE(2605)] = 77337,
  [SMALL_STATE(2606)] = 77350,
  [SMALL_STATE(2607)] = 77363,
  [SMALL_STATE(2608)] = 77376,
  [SMALL_STATE(2609)] = 77389,
  [SMALL_STATE(2610)] = 77402,
  [SMALL_STATE(2611)] = 77415,
  [SMALL_STATE(2612)] = 77428,
  [SMALL_STATE(2613)] = 77441,
  [SMALL_STATE(2614)] = 77454,
  [SMALL_STATE(2615)] = 77467,
  [SMALL_STATE(2616)] = 77480,
  [SMALL_STATE(2617)] = 77493,
  [SMALL_STATE(2618)] = 77506,
  [SMALL_STATE(2619)] = 77519,
  [SMALL_STATE(2620)] = 77532,
  [SMALL_STATE(2621)] = 77545,
  [SMALL_STATE(2622)] = 77558,
  [SMALL_STATE(2623)] = 77571,
  [SMALL_STATE(2624)] = 77584,
  [SMALL_STATE(2625)] = 77597,
  [SMALL_STATE(2626)] = 77610,
  [SMALL_STATE(2627)] = 77623,
  [SMALL_STATE(2628)] = 77636,
  [SMALL_STATE(2629)] = 77649,
  [SMALL_STATE(2630)] = 77662,
  [SMALL_STATE(2631)] = 77675,
  [SMALL_STATE(2632)] = 77688,
  [SMALL_STATE(2633)] = 77701,
  [SMALL_STATE(2634)] = 77714,
  [SMALL_STATE(2635)] = 77727,
  [SMALL_STATE(2636)] = 77740,
  [SMALL_STATE(2637)] = 77753,
  [SMALL_STATE(2638)] = 77766,
  [SMALL_STATE(2639)] = 77779,
  [SMALL_STATE(2640)] = 77792,
  [SMALL_STATE(2641)] = 77805,
  [SMALL_STATE(2642)] = 77818,
  [SMALL_STATE(2643)] = 77831,
  [SMALL_STATE(2644)] = 77844,
  [SMALL_STATE(2645)] = 77857,
  [SMALL_STATE(2646)] = 77870,
  [SMALL_STATE(2647)] = 77883,
  [SMALL_STATE(2648)] = 77896,
  [SMALL_STATE(2649)] = 77909,
  [SMALL_STATE(2650)] = 77922,
  [SMALL_STATE(2651)] = 77935,
  [SMALL_STATE(2652)] = 77948,
  [SMALL_STATE(2653)] = 77961,
  [SMALL_STATE(2654)] = 77974,
  [SMALL_STATE(2655)] = 77987,
  [SMALL_STATE(2656)] = 78000,
  [SMALL_STATE(2657)] = 78013,
  [SMALL_STATE(2658)] = 78026,
  [SMALL_STATE(2659)] = 78039,
  [SMALL_STATE(2660)] = 78052,
  [SMALL_STATE(2661)] = 78065,
  [SMALL_STATE(2662)] = 78078,
  [SMALL_STATE(2663)] = 78091,
  [SMALL_STATE(2664)] = 78104,
  [SMALL_STATE(2665)] = 78117,
  [SMALL_STATE(2666)] = 78130,
  [SMALL_STATE(2667)] = 78143,
  [SMALL_STATE(2668)] = 78156,
  [SMALL_STATE(2669)] = 78169,
  [SMALL_STATE(2670)] = 78182,
  [SMALL_STATE(2671)] = 78195,
  [SMALL_STATE(2672)] = 78208,
  [SMALL_STATE(2673)] = 78221,
  [SMALL_STATE(2674)] = 78234,
  [SMALL_STATE(2675)] = 78247,
  [SMALL_STATE(2676)] = 78260,
  [SMALL_STATE(2677)] = 78273,
  [SMALL_STATE(2678)] = 78286,
  [SMALL_STATE(2679)] = 78299,
  [SMALL_STATE(2680)] = 78312,
  [SMALL_STATE(2681)] = 78325,
  [SMALL_STATE(2682)] = 78338,
  [SMALL_STATE(2683)] = 78351,
  [SMALL_STATE(2684)] = 78364,
  [SMALL_STATE(2685)] = 78377,
  [SMALL_STATE(2686)] = 78390,
  [SMALL_STATE(2687)] = 78403,
  [SMALL_STATE(2688)] = 78416,
  [SMALL_STATE(2689)] = 78429,
  [SMALL_STATE(2690)] = 78442,
  [SMALL_STATE(2691)] = 78455,
  [SMALL_STATE(2692)] = 78468,
  [SMALL_STATE(2693)] = 78481,
  [SMALL_STATE(2694)] = 78494,
  [SMALL_STATE(2695)] = 78507,
  [SMALL_STATE(2696)] = 78520,
  [SMALL_STATE(2697)] = 78533,
  [SMALL_STATE(2698)] = 78546,
  [SMALL_STATE(2699)] = 78559,
  [SMALL_STATE(2700)] = 78572,
  [SMALL_STATE(2701)] = 78585,
  [SMALL_STATE(2702)] = 78598,
  [SMALL_STATE(2703)] = 78611,
  [SMALL_STATE(2704)] = 78624,
  [SMALL_STATE(2705)] = 78637,
  [SMALL_STATE(2706)] = 78650,
  [SMALL_STATE(2707)] = 78663,
  [SMALL_STATE(2708)] = 78676,
  [SMALL_STATE(2709)] = 78689,
  [SMALL_STATE(2710)] = 78693,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [19] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(796),
  [22] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(483),
  [25] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1439),
  [28] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1955),
  [31] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1687),
  [34] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1391),
  [37] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1482),
  [40] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1042),
  [43] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2233),
  [46] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [49] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2690),
  [52] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2688),
  [55] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2686),
  [58] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [60] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2682),
  [63] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1247),
  [66] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1313),
  [69] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1350),
  [72] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1348),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1938),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(94),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2676),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(203),
  [87] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2675),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2674),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1047),
  [96] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2237),
  [99] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2672),
  [102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(198),
  [105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(187),
  [108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(186),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(365),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2238),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(85),
  [120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2670),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2669),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2239),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2240),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2243),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(402),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(402),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(404),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(573),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(418),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(668),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(833),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2664),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(109),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(737),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1054),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1055),
  [171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1438),
  [174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1404),
  [177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1934),
  [180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1963),
  [183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1405),
  [186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1691),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(88),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(410),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(396),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(230),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(369),
  [204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 134),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 134),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2682),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2675),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2674),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 2),
  [332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 2),
  [334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 3),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 3),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 134),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 134),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 1),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 2),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2697),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2306),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2706),
  [365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2643),
  [368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2303),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2677),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2418),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2538),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1), SHIFT(728),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1), SHIFT(858),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 1),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_placeholder, 1),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 3),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 2),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2506),
  [980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2466),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 3),
  [985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 3),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 18),
  [993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18),
  [995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(2298),
  [998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(82),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 47),
  [1007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47),
  [1009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(2298),
  [1012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(82),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [1017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 184),
  [1025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 184),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [1029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91),
  [1035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91), SHIFT_REPEAT(2298),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 170),
  [1062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 170),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 42),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 42),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 88),
  [1074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 88),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 12),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 12),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 96),
  [1086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 96),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [1098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 107),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 107),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 186),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 186),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 139),
  [1122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 139),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 63),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 63),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [1134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 109),
  [1146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 109),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 176),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 176),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [1158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 90),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 90),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 140),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 140),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 109),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 109),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_label_statement, 2),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_label_statement, 2),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 107),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 107),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, .production_id = 175),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, .production_id = 175),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 12),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 12),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 90),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 90),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 107),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 107),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 6),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 6),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 151),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 151),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, .production_id = 167),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, .production_id = 167),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, .production_id = 9),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, .production_id = 9),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 63),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 63),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 7),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 7),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 88),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 88),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 149),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 149),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 131),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 131),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration_list, 3),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration_list, 3),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, .production_id = 186),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, .production_id = 186),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 6, .production_id = 99),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 6, .production_id = 99),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 87),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 87),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 6),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 6),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 9, .production_id = 167),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 9, .production_id = 167),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 152),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 152),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 18),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 18),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 97),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 97),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [1310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 42),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 42),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 3, .production_id = 18),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause, 3, .production_id = 18),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 5),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 5),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5, .production_id = 99),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5, .production_id = 99),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 46),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 46),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 45),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 45),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 46),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 46),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 55),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 55),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 177),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 177),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 3),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 3),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 63),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 63),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 176),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 176),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 96),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 96),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 3),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 3),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 18),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 18),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 11),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 11),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 12),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 12),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 42),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 42),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [1394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 27),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 27),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 12),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 12),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 3),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 3),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 4),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 4),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 170),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 170),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 5),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 5),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_echo_statement, 3),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_echo_statement, 3),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 4),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 4),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 47),
  [1442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 47),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 4),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 4),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 5),
  [1450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 5),
  [1452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration_list, 2),
  [1454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration_list, 2),
  [1456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 42),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 42),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 18),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 18),
  [1464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 89),
  [1466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 89),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 1, .production_id = 1),
  [1470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 1, .production_id = 1),
  [1472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, .production_id = 3),
  [1474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, .production_id = 3),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 7),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 7),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1),
  [1482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1),
  [1484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, .production_id = 3),
  [1486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, .production_id = 3),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 4),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 4),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5, .production_id = 40),
  [1512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5, .production_id = 40),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 8),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 8),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 139),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 139),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 4, .production_id = 40),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 4, .production_id = 40),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 3),
  [1528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 3),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_declaration, 3, .production_id = 12),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_declaration, 3, .production_id = 12),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 12),
  [1536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 12),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 18),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 18),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 4),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 4),
  [1546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 12),
  [1548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 12),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [1576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [1578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [1580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [1582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, .production_id = 25),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, .production_id = 25),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_variable, 4, .production_id = 44),
  [1596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dereferencable_expression, 1),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_variable, 4, .production_id = 44),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 5, .production_id = 102),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 5, .production_id = 102),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_access_expression, 5, .production_id = 102),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_access_expression, 5, .production_id = 102),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_access_expression, 3, .production_id = 25),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_access_expression, 3, .production_id = 25),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 24),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 24),
  [1618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 141),
  [1620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 141),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 60),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 60),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_call_expression, 6, .production_id = 142),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_call_expression, 6, .production_id = 142),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 4, .production_id = 61),
  [1632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 4, .production_id = 61),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_call_expression, 4, .production_id = 61),
  [1636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_call_expression, 4, .production_id = 61),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 6, .production_id = 142),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 6, .production_id = 142),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 3),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 3),
  [1646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 2),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 2),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1),
  [1656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__reserved_identifier, 1),
  [1658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_name, 2),
  [1660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_name, 2),
  [1662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 4),
  [1664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 4),
  [1666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_expression, 2, .production_id = 8),
  [1668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call_expression, 2, .production_id = 8),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2),
  [1690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__array_destructing_element, 1),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 1),
  [1699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__array_destructing_element, 3),
  [1702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 2),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 2),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [1718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(2544),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 22),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 22),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [1755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2),
  [1757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_constant_access_expression, 5, .production_id = 101),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_constant_access_expression, 5, .production_id = 101),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_constant_access_expression, 3),
  [1791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_constant_access_expression, 3),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_by_ref, 2),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_by_ref, 2),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 2),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 2),
  [1815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing, 2), REDUCE(sym_array_creation_expression, 2),
  [1818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_destructing, 2),
  [1820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1450),
  [1823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(737),
  [1826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1991),
  [1829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2233),
  [1832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [1834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(98),
  [1837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2616),
  [1840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(118),
  [1843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1428),
  [1846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1853),
  [1849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2168),
  [1852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1731),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 17),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 17),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_encapsed_string, 3),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_encapsed_string, 3),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 17),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 17),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 7, .production_id = 168),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 7, .production_id = 168),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3),
  [1873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3),
  [1875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 6, .production_id = 17),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 6, .production_id = 17),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 5, .production_id = 93),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 5, .production_id = 93),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 5, .production_id = 94),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 5, .production_id = 94),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_scope, 1),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 5, .production_id = 92),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 5, .production_id = 92),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 7, .production_id = 169),
  [1911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 7, .production_id = 169),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 6, .production_id = 138),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 6, .production_id = 138),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 6, .production_id = 137),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 6, .production_id = 137),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 4, .production_id = 51),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 4, .production_id = 51),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 3, .production_id = 19),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 3, .production_id = 19),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_encapsed_string, 2),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_encapsed_string, 2),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_name, 2, .production_id = 52),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_name, 2, .production_id = 52),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_modifier, 1),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_modifier, 1),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 2),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_expression, 1),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_expression, 1),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 69),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 69),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 28),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 28),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 82),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 82),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 83),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 83),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 10),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 10),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 36),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 36),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4, .production_id = 48),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4, .production_id = 48),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 38),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 38),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 171),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 171),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 5, .production_id = 48),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 5, .production_id = 48),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 39),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 39),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 143),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 143),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, .production_id = 18),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, .production_id = 18),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 14),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 14),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 6),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 6),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 67),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 67),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_clone_expression, 2),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_clone_expression, 2),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 126),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 126),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_suppression_expression, 2),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_suppression_expression, 2),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_command_expression, 3),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_command_expression, 3),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_op_expression, 2, .production_id = 5),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_op_expression, 2, .production_id = 5),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 6, .production_id = 48),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 6, .production_id = 48),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 144),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 144),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 81),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 81),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 68),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 68),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 62),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 62),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 8, .production_id = 185),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 8, .production_id = 185),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 145),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 145),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 146),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 146),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 147),
  [2137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 147),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 1),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_initializer, 1),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 103),
  [2145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 103),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 104),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 104),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 105),
  [2153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 105),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 148),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 148),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 3),
  [2161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_initializer, 3),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 5),
  [2165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 5),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 106),
  [2169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 106),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_command_expression, 2),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_command_expression, 2),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 7, .production_id = 48),
  [2177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 7, .production_id = 48),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [2185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 172),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 172),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 173),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 173),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 112),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 112),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 113),
  [2203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 113),
  [2205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 114),
  [2207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 114),
  [2209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 154),
  [2211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 154),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 174),
  [2215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 174),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 5),
  [2219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 5),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_expression, 2),
  [2223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_unpacking, 2),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_intrinsic, 2),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_assignment_expression, 4, .production_id = 59),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_once_expression, 2),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, .production_id = 58),
  [2277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, .production_id = 58),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_expression, 2),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 100),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 100),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_once_expression, 2),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 22),
  [2289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 21),
  [2293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [2339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1322),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [2344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1247),
  [2347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1313),
  [2350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1319),
  [2353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1321),
  [2356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1315),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_element, 3),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expressions, 1),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 1),
  [2469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_initializer, 2),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 3, .production_id = 29),
  [2473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 156),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1322),
  [2498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1467),
  [2501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1571),
  [2504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1137),
  [2507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [2509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1247),
  [2512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1313),
  [2515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1319),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1321),
  [2521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1315),
  [2524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1438),
  [2527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__modifier, 1),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modifier, 1),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 117),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 119),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 125),
  [2545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 79),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 178),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 155),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 179),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 180),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 6, .production_id = 181),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, .production_id = 95),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 157),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_condition_list_repeat1, 2),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 158),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_conditional_expression, 3, .production_id = 133),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_default_expression, 3, .production_id = 132),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 160),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, .production_id = 54),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 162),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [2613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, .production_id = 53),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 115),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 7, .production_id = 187),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_final_modifier, 1),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_final_modifier, 1),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_pair, 3),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_modifier, 1),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_modifier, 1),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 1),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [2791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1484),
  [2794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1467),
  [2797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1571),
  [2800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2),
  [2802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(2605),
  [2805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1509),
  [2808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1513),
  [2811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1530),
  [2814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1486),
  [2817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1516),
  [2820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1438),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_modifier, 1),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_modifier, 1),
  [2827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 1),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 1),
  [2831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_modifier, 1),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_modifier, 1),
  [2835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 1),
  [2837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 1),
  [2839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [2841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [2843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(1452),
  [2846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_list_repeat1, 1),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 1),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [2852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 4),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 4),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [2858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 5),
  [2860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 5),
  [2862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 3),
  [2864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 3),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [2868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(1438),
  [2871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1484),
  [2884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1509),
  [2887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1513),
  [2890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1530),
  [2893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1486),
  [2896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1516),
  [2899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(358),
  [2902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1557),
  [2905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1557),
  [2908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1435),
  [2911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1757),
  [2914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [2922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_heredoc_body, 2), SHIFT(1435),
  [2925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 2),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 164),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 128),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 1),
  [2937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2),
  [2939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(358),
  [2942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1557),
  [2945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1557),
  [2948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2),
  [2950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1757),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 27),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 129),
  [2957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 165),
  [2961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 130),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 85),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 9),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 163),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [2993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 3, .production_id = 11),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 182),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 2, .production_id = 84),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 6, .production_id = 188),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 2, .production_id = 86),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 163),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 182),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 3, .production_id = 127),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 4, .production_id = 75),
  [3041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_type, 1),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_type, 1),
  [3045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_member_declaration, 1),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 1),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 1, .production_id = 1),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_declaration, 1),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_declaration, 1, .production_id = 41),
  [3055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 40),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [3069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(310),
  [3072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1612),
  [3075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1612),
  [3078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2),
  [3080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1736),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 40),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [3089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(333),
  [3092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1609),
  [3095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1609),
  [3098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2),
  [3100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1728),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 5, .production_id = 183),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [3111] = {.entry = {.count = 4, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [3118] = {.entry = {.count = 4, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [3137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__types, 1),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__types, 1),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [3151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_type, 2),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [3161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_intersection_type_repeat1, 2),
  [3167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1343),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_part, 1),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [3184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_part, 1),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [3192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 4),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 4),
  [3196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_type_repeat1, 2), REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [3208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_union_type_repeat1, 2),
  [3210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [3214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 3),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 4, .dynamic_precedence = -1),
  [3282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 4, .dynamic_precedence = -1),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 2, .dynamic_precedence = -1),
  [3304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 2, .dynamic_precedence = -1),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 3, .dynamic_precedence = -1),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 3, .dynamic_precedence = -1),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [3354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1331),
  [3367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1341),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 4),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [3404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2685),
  [3407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2253),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 1),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 1),
  [3420] = {.entry = {.count = 5, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1), SHIFT(1344),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [3428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 1),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [3434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [3440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [3444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(279),
  [3447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2276),
  [3450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__complex_string_part, 3),
  [3452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__complex_string_part, 3),
  [3454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_member_access_expression, 3, .production_id = 25),
  [3456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_member_access_expression, 3, .production_id = 25),
  [3458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_part, 1, .production_id = 7),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_part, 1, .production_id = 7),
  [3462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_subscript_expression, 4),
  [3464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_subscript_expression, 4),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [3482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 1),
  [3488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 1),
  [3490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 1),
  [3492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_execution_operator_body, 1),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [3508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2),
  [3510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 2),
  [3512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_clause, 2),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [3538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(2296),
  [3541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(78),
  [3544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(2296),
  [3547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(78),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [3552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text, 1),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_text, 1),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 1),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [3574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 91),
  [3588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 91), SHIFT_REPEAT(2292),
  [3591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 91),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 2),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution_qualifier, 1),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2),
  [3623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(1818),
  [3626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(1818),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 1),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [3645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(2526),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [3656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1326),
  [3659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1345),
  [3662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1340),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 35),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [3683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91), SHIFT_REPEAT(2296),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2),
  [3714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(2526),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 3, .production_id = 13),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 2),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [3795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(2526),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [3816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1338),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [3823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(2544),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [3828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(1794),
  [3831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(1794),
  [3834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2), SHIFT_REPEAT(1456),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [3839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1342),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [3844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [3846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(1595),
  [3849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 1),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [3853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 1),
  [3855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 1),
  [3857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 3),
  [3859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [3861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2037),
  [3864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2037),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [3877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2),
  [3879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2), SHIFT_REPEAT(2047),
  [3882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2),
  [3884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2), SHIFT_REPEAT(2050),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [3891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2),
  [3893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2), SHIFT_REPEAT(1441),
  [3896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_nowdoc_body_repeat1, 2),
  [3898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_nowdoc_body_repeat1, 2), SHIFT_REPEAT(2215),
  [3901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [3903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1344),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2),
  [3908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2), SHIFT_REPEAT(2055),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [3917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__const_declaration_repeat1, 2),
  [3919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__const_declaration_repeat1, 2), SHIFT_REPEAT(1615),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [3934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [3946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 1),
  [3948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_intersection_type, 2), SHIFT(1344),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [3953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [3957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 4),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [3965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc_body, 2),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [3973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [3979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 1),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [3983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [4013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 1, .production_id = 2),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_clause, 3),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [4029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 1),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [4035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 2),
  [4037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2), SHIFT_REPEAT(1466),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [4072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 2),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [4076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 3),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 122),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 121),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [4104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 116),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [4112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 5, .production_id = 80),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(152),
  [4127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [4129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 2),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [4135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_type, 2, .production_id = 37),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [4143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 34),
  [4145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 110),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 2, .production_id = 4),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 1, .production_id = 6),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1),
  [4181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [4191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 2),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [4199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 2),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [4213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 1, .production_id = 2),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 124),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 1),
  [4223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 15),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [4237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 2), SHIFT_REPEAT(148),
  [4240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 2),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3),
  [4248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(137),
  [4251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [4261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 20),
  [4263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 5, .production_id = 50),
  [4265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 5),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [4269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 3),
  [4271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 26),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [4281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_aliasing_clause, 2),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 7, .production_id = 136),
  [4285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 7),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 30),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 2, .production_id = 31),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [4301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 32),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [4307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 18),
  [4309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 18),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [4313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2), SHIFT_REPEAT(854),
  [4316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 33),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 3),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [4334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(155),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2),
  [4339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_condition_list_repeat1, 2), SHIFT_REPEAT(243),
  [4342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2), SHIFT_REPEAT(1805),
  [4345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2),
  [4347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2), SHIFT_REPEAT(1688),
  [4350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [4366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 78),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [4372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 77),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 45),
  [4378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 45),
  [4380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 76),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 74),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [4398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(705),
  [4401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2, .production_id = 49),
  [4405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 4),
  [4407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 72),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 71),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [4429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 6),
  [4431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 4, .production_id = 50),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [4435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2), SHIFT_REPEAT(156),
  [4438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 3, .production_id = 50),
  [4440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(145),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 66),
  [4447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_group_repeat1, 2), SHIFT_REPEAT(1440),
  [4450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_group_repeat1, 2),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 159),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [4460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 64),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 6, .production_id = 136),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [4474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 56),
  [4476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_nowdoc_body_repeat1, 1),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 120),
  [4494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 1), SHIFT(2461),
  [4497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 118),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [4503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing_element, 3), REDUCE(sym_array_element_initializer, 3),
  [4506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 4),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 3),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 70),
  [4516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 73),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 75),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [4524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 2), SHIFT(2461),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [4529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [4533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [4541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 3),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [4547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 4),
  [4549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_reference, 2),
  [4551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 4, .production_id = 135),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [4555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 5, .production_id = 161),
  [4557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 5),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_type, 1),
  [4571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 123),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [4599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing_element, 1), REDUCE(sym_array_element_initializer, 1),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [4610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 2, .production_id = 11),
  [4612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 4),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [4616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(2544),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 6),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [4651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_instead_of_clause, 3),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [4663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 4),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 16),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 98),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [4741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_subscript_unary_expression, 2),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [4757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 4),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [4787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause_2, 2, .production_id = 3),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_directive, 3),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [4829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 108),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 111),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [4871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 43),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [4905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 6, .production_id = 153),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [4967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_array_access_argument, 1),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [5013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 65),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [5025] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [5031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 57),
  [5033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text_interpolation, 2),
  [5035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text_interpolation, 3),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token_encapsed_string_chars = 1,
  ts_external_token_encapsed_string_chars_after_variable = 2,
  ts_external_token_execution_string_chars = 3,
  ts_external_token_execution_string_chars_after_variable = 4,
  ts_external_token_encapsed_string_chars_heredoc = 5,
  ts_external_token_encapsed_string_chars_after_variable_heredoc = 6,
  ts_external_token__eof = 7,
  ts_external_token_heredoc_start = 8,
  ts_external_token_heredoc_end = 9,
  ts_external_token_nowdoc_string = 10,
  ts_external_token_sentinel_error = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token_encapsed_string_chars] = sym_encapsed_string_chars,
  [ts_external_token_encapsed_string_chars_after_variable] = sym_encapsed_string_chars_after_variable,
  [ts_external_token_execution_string_chars] = sym_execution_string_chars,
  [ts_external_token_execution_string_chars_after_variable] = sym_execution_string_chars_after_variable,
  [ts_external_token_encapsed_string_chars_heredoc] = sym_encapsed_string_chars_heredoc,
  [ts_external_token_encapsed_string_chars_after_variable_heredoc] = sym_encapsed_string_chars_after_variable_heredoc,
  [ts_external_token__eof] = sym__eof,
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_nowdoc_string] = sym_nowdoc_string,
  [ts_external_token_sentinel_error] = sym_sentinel_error,
};

static const bool ts_external_scanner_states[15][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_encapsed_string_chars] = true,
    [ts_external_token_encapsed_string_chars_after_variable] = true,
    [ts_external_token_execution_string_chars] = true,
    [ts_external_token_execution_string_chars_after_variable] = true,
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_encapsed_string_chars_after_variable_heredoc] = true,
    [ts_external_token__eof] = true,
    [ts_external_token_heredoc_start] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_nowdoc_string] = true,
    [ts_external_token_sentinel_error] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [4] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
  },
  [5] = {
    [ts_external_token_encapsed_string_chars] = true,
  },
  [6] = {
    [ts_external_token_execution_string_chars] = true,
  },
  [7] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_encapsed_string_chars_after_variable_heredoc] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [8] = {
    [ts_external_token_execution_string_chars] = true,
    [ts_external_token_execution_string_chars_after_variable] = true,
  },
  [9] = {
    [ts_external_token_encapsed_string_chars] = true,
    [ts_external_token_encapsed_string_chars_after_variable] = true,
  },
  [10] = {
    [ts_external_token__eof] = true,
  },
  [11] = {
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_nowdoc_string] = true,
  },
  [12] = {
    [ts_external_token_heredoc_end] = true,
  },
  [13] = {
    [ts_external_token_heredoc_start] = true,
  },
  [14] = {
    [ts_external_token_nowdoc_string] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_php_external_scanner_create(void);
void tree_sitter_php_external_scanner_destroy(void *);
bool tree_sitter_php_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_php_external_scanner_serialize(void *, char *);
void tree_sitter_php_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_php(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_name,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_php_external_scanner_create,
      tree_sitter_php_external_scanner_destroy,
      tree_sitter_php_external_scanner_scan,
      tree_sitter_php_external_scanner_serialize,
      tree_sitter_php_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
