#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2668
#define LARGE_STATE_COUNT 571
#define SYMBOL_COUNT 402
#define ALIAS_COUNT 0
#define TOKEN_COUNT 193
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 26
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 189

enum ts_symbol_identifiers {
  sym_name = 1,
  anon_sym_QMARK_GT = 2,
  sym_php_tag = 3,
  aux_sym_text_token1 = 4,
  anon_sym_SEMI = 5,
  anon_sym_AMP = 6,
  aux_sym_function_static_declaration_token1 = 7,
  anon_sym_COMMA = 8,
  anon_sym_EQ = 9,
  aux_sym_global_declaration_token1 = 10,
  aux_sym_namespace_definition_token1 = 11,
  aux_sym_namespace_use_declaration_token1 = 12,
  aux_sym_namespace_use_declaration_token2 = 13,
  aux_sym_namespace_use_declaration_token3 = 14,
  anon_sym_BSLASH = 15,
  aux_sym_namespace_aliasing_clause_token1 = 16,
  anon_sym_LBRACE = 17,
  anon_sym_RBRACE = 18,
  aux_sym_trait_declaration_token1 = 19,
  aux_sym_interface_declaration_token1 = 20,
  aux_sym_base_clause_token1 = 21,
  aux_sym_enum_declaration_token1 = 22,
  anon_sym_COLON = 23,
  anon_sym_string = 24,
  anon_sym_int = 25,
  aux_sym_enum_case_token1 = 26,
  aux_sym_class_declaration_token1 = 27,
  aux_sym_final_modifier_token1 = 28,
  aux_sym_abstract_modifier_token1 = 29,
  aux_sym_readonly_modifier_token1 = 30,
  aux_sym_class_interface_clause_token1 = 31,
  sym_var_modifier = 32,
  aux_sym_use_instead_of_clause_token1 = 33,
  aux_sym_visibility_modifier_token1 = 34,
  aux_sym_visibility_modifier_token2 = 35,
  aux_sym_visibility_modifier_token3 = 36,
  aux_sym__arrow_function_header_token1 = 37,
  anon_sym_EQ_GT = 38,
  anon_sym_LPAREN = 39,
  anon_sym_RPAREN = 40,
  anon_sym_DOT_DOT_DOT = 41,
  anon_sym_QMARK = 42,
  sym_bottom_type = 43,
  anon_sym_PIPE = 44,
  anon_sym_array = 45,
  aux_sym_primitive_type_token1 = 46,
  anon_sym_iterable = 47,
  anon_sym_bool = 48,
  anon_sym_float = 49,
  anon_sym_void = 50,
  anon_sym_mixed = 51,
  anon_sym_static = 52,
  anon_sym_false = 53,
  anon_sym_null = 54,
  anon_sym_true = 55,
  aux_sym_cast_type_token1 = 56,
  aux_sym_cast_type_token2 = 57,
  aux_sym_cast_type_token3 = 58,
  aux_sym_cast_type_token4 = 59,
  aux_sym_cast_type_token5 = 60,
  aux_sym_cast_type_token6 = 61,
  aux_sym_cast_type_token7 = 62,
  aux_sym_cast_type_token8 = 63,
  aux_sym_cast_type_token9 = 64,
  aux_sym_cast_type_token10 = 65,
  aux_sym_cast_type_token11 = 66,
  aux_sym_cast_type_token12 = 67,
  aux_sym_echo_statement_token1 = 68,
  anon_sym_unset = 69,
  aux_sym_declare_statement_token1 = 70,
  aux_sym_declare_statement_token2 = 71,
  anon_sym_ticks = 72,
  anon_sym_encoding = 73,
  anon_sym_strict_types = 74,
  sym_float = 75,
  aux_sym_try_statement_token1 = 76,
  aux_sym_catch_clause_token1 = 77,
  aux_sym_finally_clause_token1 = 78,
  aux_sym_goto_statement_token1 = 79,
  aux_sym_continue_statement_token1 = 80,
  aux_sym_break_statement_token1 = 81,
  sym_integer = 82,
  aux_sym_return_statement_token1 = 83,
  aux_sym_throw_expression_token1 = 84,
  aux_sym_while_statement_token1 = 85,
  aux_sym_while_statement_token2 = 86,
  aux_sym_do_statement_token1 = 87,
  aux_sym_for_statement_token1 = 88,
  aux_sym_for_statement_token2 = 89,
  aux_sym_foreach_statement_token1 = 90,
  aux_sym_foreach_statement_token2 = 91,
  aux_sym_if_statement_token1 = 92,
  aux_sym_if_statement_token2 = 93,
  aux_sym_else_if_clause_token1 = 94,
  aux_sym_else_clause_token1 = 95,
  aux_sym_match_expression_token1 = 96,
  aux_sym_match_default_expression_token1 = 97,
  aux_sym_switch_statement_token1 = 98,
  aux_sym_switch_block_token1 = 99,
  anon_sym_PLUS = 100,
  anon_sym_DASH = 101,
  anon_sym_TILDE = 102,
  anon_sym_BANG = 103,
  anon_sym_AT = 104,
  aux_sym_clone_expression_token1 = 105,
  anon_sym_COLON_COLON = 106,
  aux_sym_print_intrinsic_token1 = 107,
  aux_sym_object_creation_expression_token1 = 108,
  anon_sym_DASH_DASH = 109,
  anon_sym_PLUS_PLUS = 110,
  anon_sym_STAR_STAR_EQ = 111,
  anon_sym_STAR_EQ = 112,
  anon_sym_SLASH_EQ = 113,
  anon_sym_PERCENT_EQ = 114,
  anon_sym_PLUS_EQ = 115,
  anon_sym_DASH_EQ = 116,
  anon_sym_DOT_EQ = 117,
  anon_sym_LT_LT_EQ = 118,
  anon_sym_GT_GT_EQ = 119,
  anon_sym_AMP_EQ = 120,
  anon_sym_CARET_EQ = 121,
  anon_sym_PIPE_EQ = 122,
  anon_sym_QMARK_QMARK_EQ = 123,
  anon_sym_DASH_GT = 124,
  anon_sym_QMARK_DASH_GT = 125,
  aux_sym__list_destructing_token1 = 126,
  anon_sym_LBRACK = 127,
  anon_sym_RBRACK = 128,
  anon_sym_self = 129,
  anon_sym_parent = 130,
  aux_sym__argument_name_token1 = 131,
  aux_sym__argument_name_token2 = 132,
  anon_sym_POUND_LBRACK = 133,
  sym_escape_sequence = 134,
  anon_sym_BSLASHu = 135,
  aux_sym_encapsed_string_token1 = 136,
  anon_sym_DQUOTE = 137,
  aux_sym_string_token1 = 138,
  anon_sym_SQUOTE = 139,
  aux_sym_string_token2 = 140,
  sym_string_value = 141,
  anon_sym_LT_LT_LT = 142,
  anon_sym_DQUOTE2 = 143,
  sym__new_line = 144,
  anon_sym_ = 145,
  anon_sym_SQUOTE2 = 146,
  anon_sym_BQUOTE = 147,
  anon_sym_DOLLAR = 148,
  aux_sym_yield_expression_token1 = 149,
  aux_sym_yield_expression_token2 = 150,
  aux_sym_binary_expression_token1 = 151,
  anon_sym_QMARK_QMARK = 152,
  anon_sym_STAR_STAR = 153,
  aux_sym_binary_expression_token2 = 154,
  aux_sym_binary_expression_token3 = 155,
  aux_sym_binary_expression_token4 = 156,
  anon_sym_PIPE_PIPE = 157,
  anon_sym_AMP_AMP = 158,
  anon_sym_CARET = 159,
  anon_sym_EQ_EQ = 160,
  anon_sym_BANG_EQ = 161,
  anon_sym_LT_GT = 162,
  anon_sym_EQ_EQ_EQ = 163,
  anon_sym_BANG_EQ_EQ = 164,
  anon_sym_LT = 165,
  anon_sym_GT = 166,
  anon_sym_LT_EQ = 167,
  anon_sym_GT_EQ = 168,
  anon_sym_LT_EQ_GT = 169,
  anon_sym_LT_LT = 170,
  anon_sym_GT_GT = 171,
  anon_sym_DOT = 172,
  anon_sym_STAR = 173,
  anon_sym_SLASH = 174,
  anon_sym_PERCENT = 175,
  aux_sym_include_expression_token1 = 176,
  aux_sym_include_once_expression_token1 = 177,
  aux_sym_require_expression_token1 = 178,
  aux_sym_require_once_expression_token1 = 179,
  sym_comment = 180,
  sym__automatic_semicolon = 181,
  sym_encapsed_string_chars = 182,
  sym_encapsed_string_chars_after_variable = 183,
  sym_execution_string_chars = 184,
  sym_execution_string_chars_after_variable = 185,
  sym_encapsed_string_chars_heredoc = 186,
  sym_encapsed_string_chars_after_variable_heredoc = 187,
  sym__eof = 188,
  sym_heredoc_start = 189,
  sym_heredoc_end = 190,
  sym_nowdoc_string = 191,
  sym_sentinel_error = 192,
  sym_program = 193,
  sym_empty_statement = 194,
  sym_reference_modifier = 195,
  sym_function_static_declaration = 196,
  sym_static_variable_declaration = 197,
  sym_global_declaration = 198,
  sym_namespace_definition = 199,
  sym_namespace_use_declaration = 200,
  sym_namespace_use_clause = 201,
  sym_qualified_name = 202,
  sym_namespace_name_as_prefix = 203,
  sym_namespace_name = 204,
  sym_namespace_aliasing_clause = 205,
  sym_namespace_use_group = 206,
  sym_namespace_use_group_clause = 207,
  sym_trait_declaration = 208,
  sym_interface_declaration = 209,
  sym_base_clause = 210,
  sym_enum_declaration = 211,
  sym_enum_declaration_list = 212,
  sym__enum_member_declaration = 213,
  sym_enum_case = 214,
  sym_class_declaration = 215,
  sym_declaration_list = 216,
  sym_final_modifier = 217,
  sym_abstract_modifier = 218,
  sym_readonly_modifier = 219,
  sym_class_interface_clause = 220,
  sym__member_declaration = 221,
  sym_const_declaration = 222,
  sym__class_const_declaration = 223,
  sym__const_declaration = 224,
  sym_property_declaration = 225,
  sym__modifier = 226,
  sym_property_element = 227,
  sym_property_initializer = 228,
  sym_method_declaration = 229,
  sym_static_modifier = 230,
  sym_use_declaration = 231,
  sym_use_list = 232,
  sym_use_instead_of_clause = 233,
  sym_use_as_clause = 234,
  sym_visibility_modifier = 235,
  sym_function_definition = 236,
  sym__function_definition_header = 237,
  sym__arrow_function_header = 238,
  sym_arrow_function = 239,
  sym_formal_parameters = 240,
  sym_property_promotion_parameter = 241,
  sym_simple_parameter = 242,
  sym_variadic_parameter = 243,
  sym__type = 244,
  sym__types = 245,
  sym_named_type = 246,
  sym_optional_type = 247,
  sym_union_type = 248,
  sym_intersection_type = 249,
  sym_disjunctive_normal_form_type = 250,
  sym_primitive_type = 251,
  sym_cast_type = 252,
  sym__return_type = 253,
  sym_const_element = 254,
  sym_echo_statement = 255,
  sym_unset_statement = 256,
  sym_declare_statement = 257,
  sym_declare_directive = 258,
  sym_try_statement = 259,
  sym_catch_clause = 260,
  sym_type_list = 261,
  sym_finally_clause = 262,
  sym_goto_statement = 263,
  sym_continue_statement = 264,
  sym_break_statement = 265,
  sym_return_statement = 266,
  sym_throw_expression = 267,
  sym_while_statement = 268,
  sym_do_statement = 269,
  sym_for_statement = 270,
  sym__expressions = 271,
  sym_sequence_expression = 272,
  sym_foreach_statement = 273,
  sym_foreach_pair = 274,
  sym_if_statement = 275,
  sym_colon_block = 276,
  sym_else_if_clause = 277,
  sym_else_clause = 278,
  sym_else_if_clause_2 = 279,
  sym_else_clause_2 = 280,
  sym_match_expression = 281,
  sym_match_block = 282,
  sym_match_condition_list = 283,
  sym_match_conditional_expression = 284,
  sym_match_default_expression = 285,
  sym_switch_statement = 286,
  sym_switch_block = 287,
  sym_case_statement = 288,
  sym_default_statement = 289,
  sym_compound_statement = 290,
  sym_named_label_statement = 291,
  sym_expression_statement = 292,
  sym__expression = 293,
  sym__unary_expression = 294,
  sym_unary_op_expression = 295,
  sym_error_suppression_expression = 296,
  sym_clone_expression = 297,
  sym__primary_expression = 298,
  sym_parenthesized_expression = 299,
  sym_class_constant_access_expression = 300,
  sym_print_intrinsic = 301,
  sym_anonymous_function_creation_expression = 302,
  sym_anonymous_function_use_clause = 303,
  sym_object_creation_expression = 304,
  sym_update_expression = 305,
  sym_cast_expression = 306,
  sym_cast_variable = 307,
  sym_assignment_expression = 308,
  sym_reference_assignment_expression = 309,
  sym_conditional_expression = 310,
  sym_augmented_assignment_expression = 311,
  sym_member_access_expression = 312,
  sym_nullsafe_member_access_expression = 313,
  sym_scoped_property_access_expression = 314,
  sym_list_literal = 315,
  sym__list_destructing = 316,
  sym__array_destructing = 317,
  sym__array_destructing_element = 318,
  sym_function_call_expression = 319,
  sym_scoped_call_expression = 320,
  sym__scope_resolution_qualifier = 321,
  sym_relative_scope = 322,
  sym_variadic_placeholder = 323,
  sym_arguments = 324,
  sym_argument = 325,
  sym__argument_name = 326,
  sym_member_call_expression = 327,
  sym_nullsafe_member_call_expression = 328,
  sym_variadic_unpacking = 329,
  sym_subscript_expression = 330,
  sym__dereferencable_expression = 331,
  sym_array_creation_expression = 332,
  sym_attribute_group = 333,
  sym_attribute_list = 334,
  sym_attribute = 335,
  sym__complex_string_part = 336,
  sym__simple_string_member_access_expression = 337,
  sym__simple_string_subscript_unary_expression = 338,
  sym__simple_string_array_access_argument = 339,
  sym__simple_string_subscript_expression = 340,
  sym__simple_string_part = 341,
  aux_sym__interpolated_string_body = 342,
  aux_sym__interpolated_string_body_heredoc = 343,
  sym_encapsed_string = 344,
  sym_string = 345,
  sym_heredoc_body = 346,
  sym_heredoc = 347,
  sym_nowdoc_body = 348,
  sym_nowdoc = 349,
  aux_sym__interpolated_execution_operator_body = 350,
  sym_shell_command_expression = 351,
  sym_boolean = 352,
  sym_null = 353,
  sym__string = 354,
  sym_dynamic_variable_name = 355,
  sym_variable_name = 356,
  sym_variable_reference = 357,
  sym_by_ref = 358,
  sym_yield_expression = 359,
  sym_array_element_initializer = 360,
  sym_binary_expression = 361,
  sym_include_expression = 362,
  sym_include_once_expression = 363,
  sym_require_expression = 364,
  sym_require_once_expression = 365,
  sym__reserved_identifier = 366,
  aux_sym_program_repeat1 = 367,
  aux_sym_function_static_declaration_repeat1 = 368,
  aux_sym_global_declaration_repeat1 = 369,
  aux_sym_namespace_use_declaration_repeat1 = 370,
  aux_sym_namespace_name_repeat1 = 371,
  aux_sym_namespace_use_group_repeat1 = 372,
  aux_sym_base_clause_repeat1 = 373,
  aux_sym_enum_declaration_list_repeat1 = 374,
  aux_sym_declaration_list_repeat1 = 375,
  aux_sym__const_declaration_repeat1 = 376,
  aux_sym_property_declaration_repeat1 = 377,
  aux_sym_property_declaration_repeat2 = 378,
  aux_sym_use_list_repeat1 = 379,
  aux_sym_formal_parameters_repeat1 = 380,
  aux_sym_union_type_repeat1 = 381,
  aux_sym_intersection_type_repeat1 = 382,
  aux_sym_disjunctive_normal_form_type_repeat1 = 383,
  aux_sym_unset_statement_repeat1 = 384,
  aux_sym_try_statement_repeat1 = 385,
  aux_sym_type_list_repeat1 = 386,
  aux_sym_if_statement_repeat1 = 387,
  aux_sym_if_statement_repeat2 = 388,
  aux_sym_match_block_repeat1 = 389,
  aux_sym_match_condition_list_repeat1 = 390,
  aux_sym_switch_block_repeat1 = 391,
  aux_sym_anonymous_function_use_clause_repeat1 = 392,
  aux_sym__list_destructing_repeat1 = 393,
  aux_sym__array_destructing_repeat1 = 394,
  aux_sym_arguments_repeat1 = 395,
  aux_sym_array_creation_expression_repeat1 = 396,
  aux_sym_attribute_group_repeat1 = 397,
  aux_sym_attribute_list_repeat1 = 398,
  aux_sym_string_repeat1 = 399,
  aux_sym_heredoc_body_repeat1 = 400,
  aux_sym_nowdoc_body_repeat1 = 401,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_name] = "name",
  [anon_sym_QMARK_GT] = "\?>",
  [sym_php_tag] = "php_tag",
  [aux_sym_text_token1] = "text_token1",
  [anon_sym_SEMI] = ";",
  [anon_sym_AMP] = "&",
  [aux_sym_function_static_declaration_token1] = "static",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [aux_sym_global_declaration_token1] = "global",
  [aux_sym_namespace_definition_token1] = "namespace",
  [aux_sym_namespace_use_declaration_token1] = "use",
  [aux_sym_namespace_use_declaration_token2] = "function",
  [aux_sym_namespace_use_declaration_token3] = "const",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_namespace_aliasing_clause_token1] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym_trait_declaration_token1] = "trait",
  [aux_sym_interface_declaration_token1] = "interface",
  [aux_sym_base_clause_token1] = "extends",
  [aux_sym_enum_declaration_token1] = "enum",
  [anon_sym_COLON] = ":",
  [anon_sym_string] = "string",
  [anon_sym_int] = "int",
  [aux_sym_enum_case_token1] = "case",
  [aux_sym_class_declaration_token1] = "class",
  [aux_sym_final_modifier_token1] = "final",
  [aux_sym_abstract_modifier_token1] = "abstract",
  [aux_sym_readonly_modifier_token1] = "readonly",
  [aux_sym_class_interface_clause_token1] = "implements",
  [sym_var_modifier] = "var_modifier",
  [aux_sym_use_instead_of_clause_token1] = "insteadof",
  [aux_sym_visibility_modifier_token1] = "public",
  [aux_sym_visibility_modifier_token2] = "protected",
  [aux_sym_visibility_modifier_token3] = "private",
  [aux_sym__arrow_function_header_token1] = "fn",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [sym_bottom_type] = "bottom_type",
  [anon_sym_PIPE] = "|",
  [anon_sym_array] = "array",
  [aux_sym_primitive_type_token1] = "callable",
  [anon_sym_iterable] = "iterable",
  [anon_sym_bool] = "bool",
  [anon_sym_float] = "float",
  [anon_sym_void] = "void",
  [anon_sym_mixed] = "mixed",
  [anon_sym_static] = "static",
  [anon_sym_false] = "false",
  [anon_sym_null] = "null",
  [anon_sym_true] = "true",
  [aux_sym_cast_type_token1] = "cast_type_token1",
  [aux_sym_cast_type_token2] = "cast_type_token2",
  [aux_sym_cast_type_token3] = "cast_type_token3",
  [aux_sym_cast_type_token4] = "cast_type_token4",
  [aux_sym_cast_type_token5] = "cast_type_token5",
  [aux_sym_cast_type_token6] = "cast_type_token6",
  [aux_sym_cast_type_token7] = "cast_type_token7",
  [aux_sym_cast_type_token8] = "cast_type_token8",
  [aux_sym_cast_type_token9] = "cast_type_token9",
  [aux_sym_cast_type_token10] = "cast_type_token10",
  [aux_sym_cast_type_token11] = "cast_type_token11",
  [aux_sym_cast_type_token12] = "cast_type_token12",
  [aux_sym_echo_statement_token1] = "echo",
  [anon_sym_unset] = "unset",
  [aux_sym_declare_statement_token1] = "declare",
  [aux_sym_declare_statement_token2] = "enddeclare",
  [anon_sym_ticks] = "ticks",
  [anon_sym_encoding] = "encoding",
  [anon_sym_strict_types] = "strict_types",
  [sym_float] = "float",
  [aux_sym_try_statement_token1] = "try",
  [aux_sym_catch_clause_token1] = "catch",
  [aux_sym_finally_clause_token1] = "finally",
  [aux_sym_goto_statement_token1] = "goto",
  [aux_sym_continue_statement_token1] = "continue",
  [aux_sym_break_statement_token1] = "break",
  [sym_integer] = "integer",
  [aux_sym_return_statement_token1] = "return",
  [aux_sym_throw_expression_token1] = "throw",
  [aux_sym_while_statement_token1] = "while",
  [aux_sym_while_statement_token2] = "endwhile",
  [aux_sym_do_statement_token1] = "do",
  [aux_sym_for_statement_token1] = "for",
  [aux_sym_for_statement_token2] = "endfor",
  [aux_sym_foreach_statement_token1] = "foreach",
  [aux_sym_foreach_statement_token2] = "endforeach",
  [aux_sym_if_statement_token1] = "if",
  [aux_sym_if_statement_token2] = "endif",
  [aux_sym_else_if_clause_token1] = "elseif",
  [aux_sym_else_clause_token1] = "else",
  [aux_sym_match_expression_token1] = "match",
  [aux_sym_match_default_expression_token1] = "default",
  [aux_sym_switch_statement_token1] = "switch",
  [aux_sym_switch_block_token1] = "endswitch",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_AT] = "@",
  [aux_sym_clone_expression_token1] = "clone",
  [anon_sym_COLON_COLON] = "::",
  [aux_sym_print_intrinsic_token1] = "print",
  [aux_sym_object_creation_expression_token1] = "new",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_QMARK_DASH_GT] = "\?->",
  [aux_sym__list_destructing_token1] = "list",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_self] = "self",
  [anon_sym_parent] = "parent",
  [aux_sym__argument_name_token1] = "_argument_name_token1",
  [aux_sym__argument_name_token2] = "_argument_name_token2",
  [anon_sym_POUND_LBRACK] = "#[",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_BSLASHu] = "string_value",
  [aux_sym_encapsed_string_token1] = "encapsed_string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "escape_sequence",
  [sym_string_value] = "string_value",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_DQUOTE2] = "\"",
  [sym__new_line] = "_new_line",
  [anon_sym_] = "nowdoc_string",
  [anon_sym_SQUOTE2] = "'",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_yield_expression_token1] = "yield",
  [aux_sym_yield_expression_token2] = "from",
  [aux_sym_binary_expression_token1] = "instanceof",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_STAR_STAR] = "**",
  [aux_sym_binary_expression_token2] = "and",
  [aux_sym_binary_expression_token3] = "or",
  [aux_sym_binary_expression_token4] = "xor",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_CARET] = "^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [aux_sym_include_expression_token1] = "include",
  [aux_sym_include_once_expression_token1] = "include_once",
  [aux_sym_require_expression_token1] = "require",
  [aux_sym_require_once_expression_token1] = "require_once",
  [sym_comment] = "comment",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym_encapsed_string_chars] = "string_value",
  [sym_encapsed_string_chars_after_variable] = "string_value",
  [sym_execution_string_chars] = "string_value",
  [sym_execution_string_chars_after_variable] = "string_value",
  [sym_encapsed_string_chars_heredoc] = "string_value",
  [sym_encapsed_string_chars_after_variable_heredoc] = "string_value",
  [sym__eof] = "_eof",
  [sym_heredoc_start] = "heredoc_start",
  [sym_heredoc_end] = "heredoc_end",
  [sym_nowdoc_string] = "nowdoc_string",
  [sym_sentinel_error] = "sentinel_error",
  [sym_program] = "program",
  [sym_empty_statement] = "empty_statement",
  [sym_reference_modifier] = "reference_modifier",
  [sym_function_static_declaration] = "function_static_declaration",
  [sym_static_variable_declaration] = "static_variable_declaration",
  [sym_global_declaration] = "global_declaration",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_use_declaration] = "namespace_use_declaration",
  [sym_namespace_use_clause] = "namespace_use_clause",
  [sym_qualified_name] = "qualified_name",
  [sym_namespace_name_as_prefix] = "namespace_name_as_prefix",
  [sym_namespace_name] = "namespace_name",
  [sym_namespace_aliasing_clause] = "namespace_aliasing_clause",
  [sym_namespace_use_group] = "namespace_use_group",
  [sym_namespace_use_group_clause] = "namespace_use_group_clause",
  [sym_trait_declaration] = "trait_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_base_clause] = "base_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_declaration_list] = "enum_declaration_list",
  [sym__enum_member_declaration] = "_enum_member_declaration",
  [sym_enum_case] = "enum_case",
  [sym_class_declaration] = "class_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_final_modifier] = "final_modifier",
  [sym_abstract_modifier] = "abstract_modifier",
  [sym_readonly_modifier] = "readonly_modifier",
  [sym_class_interface_clause] = "class_interface_clause",
  [sym__member_declaration] = "_member_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym__class_const_declaration] = "const_declaration",
  [sym__const_declaration] = "_const_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym__modifier] = "_modifier",
  [sym_property_element] = "property_element",
  [sym_property_initializer] = "property_initializer",
  [sym_method_declaration] = "method_declaration",
  [sym_static_modifier] = "static_modifier",
  [sym_use_declaration] = "use_declaration",
  [sym_use_list] = "use_list",
  [sym_use_instead_of_clause] = "use_instead_of_clause",
  [sym_use_as_clause] = "use_as_clause",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym_function_definition] = "function_definition",
  [sym__function_definition_header] = "_function_definition_header",
  [sym__arrow_function_header] = "_arrow_function_header",
  [sym_arrow_function] = "arrow_function",
  [sym_formal_parameters] = "formal_parameters",
  [sym_property_promotion_parameter] = "property_promotion_parameter",
  [sym_simple_parameter] = "simple_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym__type] = "_type",
  [sym__types] = "_types",
  [sym_named_type] = "named_type",
  [sym_optional_type] = "optional_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_disjunctive_normal_form_type] = "disjunctive_normal_form_type",
  [sym_primitive_type] = "primitive_type",
  [sym_cast_type] = "cast_type",
  [sym__return_type] = "_return_type",
  [sym_const_element] = "const_element",
  [sym_echo_statement] = "echo_statement",
  [sym_unset_statement] = "unset_statement",
  [sym_declare_statement] = "declare_statement",
  [sym_declare_directive] = "declare_directive",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_type_list] = "type_list",
  [sym_finally_clause] = "finally_clause",
  [sym_goto_statement] = "goto_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_expression] = "throw_expression",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__expressions] = "_expressions",
  [sym_sequence_expression] = "sequence_expression",
  [sym_foreach_statement] = "foreach_statement",
  [sym_foreach_pair] = "pair",
  [sym_if_statement] = "if_statement",
  [sym_colon_block] = "colon_block",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_else_if_clause_2] = "else_if_clause",
  [sym_else_clause_2] = "else_clause",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_condition_list] = "match_condition_list",
  [sym_match_conditional_expression] = "match_conditional_expression",
  [sym_match_default_expression] = "match_default_expression",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_block] = "switch_block",
  [sym_case_statement] = "case_statement",
  [sym_default_statement] = "default_statement",
  [sym_compound_statement] = "compound_statement",
  [sym_named_label_statement] = "named_label_statement",
  [sym_expression_statement] = "expression_statement",
  [sym__expression] = "_expression",
  [sym__unary_expression] = "_unary_expression",
  [sym_unary_op_expression] = "unary_op_expression",
  [sym_error_suppression_expression] = "error_suppression_expression",
  [sym_clone_expression] = "clone_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_constant_access_expression] = "class_constant_access_expression",
  [sym_print_intrinsic] = "print_intrinsic",
  [sym_anonymous_function_creation_expression] = "anonymous_function_creation_expression",
  [sym_anonymous_function_use_clause] = "anonymous_function_use_clause",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_cast_variable] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_reference_assignment_expression] = "reference_assignment_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_member_access_expression] = "member_access_expression",
  [sym_nullsafe_member_access_expression] = "nullsafe_member_access_expression",
  [sym_scoped_property_access_expression] = "scoped_property_access_expression",
  [sym_list_literal] = "list_literal",
  [sym__list_destructing] = "_list_destructing",
  [sym__array_destructing] = "_array_destructing",
  [sym__array_destructing_element] = "_array_destructing_element",
  [sym_function_call_expression] = "function_call_expression",
  [sym_scoped_call_expression] = "scoped_call_expression",
  [sym__scope_resolution_qualifier] = "_scope_resolution_qualifier",
  [sym_relative_scope] = "relative_scope",
  [sym_variadic_placeholder] = "variadic_placeholder",
  [sym_arguments] = "arguments",
  [sym_argument] = "argument",
  [sym__argument_name] = "_argument_name",
  [sym_member_call_expression] = "member_call_expression",
  [sym_nullsafe_member_call_expression] = "nullsafe_member_call_expression",
  [sym_variadic_unpacking] = "variadic_unpacking",
  [sym_subscript_expression] = "subscript_expression",
  [sym__dereferencable_expression] = "_dereferencable_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_attribute_group] = "attribute_group",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute] = "attribute",
  [sym__complex_string_part] = "_complex_string_part",
  [sym__simple_string_member_access_expression] = "member_access_expression",
  [sym__simple_string_subscript_unary_expression] = "unary_op_expression",
  [sym__simple_string_array_access_argument] = "_simple_string_array_access_argument",
  [sym__simple_string_subscript_expression] = "subscript_expression",
  [sym__simple_string_part] = "_simple_string_part",
  [aux_sym__interpolated_string_body] = "_interpolated_string_body",
  [aux_sym__interpolated_string_body_heredoc] = "_interpolated_string_body_heredoc",
  [sym_encapsed_string] = "encapsed_string",
  [sym_string] = "string",
  [sym_heredoc_body] = "heredoc_body",
  [sym_heredoc] = "heredoc",
  [sym_nowdoc_body] = "nowdoc_body",
  [sym_nowdoc] = "nowdoc",
  [aux_sym__interpolated_execution_operator_body] = "_interpolated_execution_operator_body",
  [sym_shell_command_expression] = "shell_command_expression",
  [sym_boolean] = "boolean",
  [sym_null] = "null",
  [sym__string] = "_string",
  [sym_dynamic_variable_name] = "dynamic_variable_name",
  [sym_variable_name] = "variable_name",
  [sym_variable_reference] = "by_ref",
  [sym_by_ref] = "by_ref",
  [sym_yield_expression] = "yield_expression",
  [sym_array_element_initializer] = "array_element_initializer",
  [sym_binary_expression] = "binary_expression",
  [sym_include_expression] = "include_expression",
  [sym_include_once_expression] = "include_once_expression",
  [sym_require_expression] = "require_expression",
  [sym_require_once_expression] = "require_once_expression",
  [sym__reserved_identifier] = "name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_function_static_declaration_repeat1] = "function_static_declaration_repeat1",
  [aux_sym_global_declaration_repeat1] = "global_declaration_repeat1",
  [aux_sym_namespace_use_declaration_repeat1] = "namespace_use_declaration_repeat1",
  [aux_sym_namespace_name_repeat1] = "namespace_name_repeat1",
  [aux_sym_namespace_use_group_repeat1] = "namespace_use_group_repeat1",
  [aux_sym_base_clause_repeat1] = "base_clause_repeat1",
  [aux_sym_enum_declaration_list_repeat1] = "enum_declaration_list_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym__const_declaration_repeat1] = "_const_declaration_repeat1",
  [aux_sym_property_declaration_repeat1] = "property_declaration_repeat1",
  [aux_sym_property_declaration_repeat2] = "property_declaration_repeat2",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_union_type_repeat1] = "union_type_repeat1",
  [aux_sym_intersection_type_repeat1] = "intersection_type_repeat1",
  [aux_sym_disjunctive_normal_form_type_repeat1] = "disjunctive_normal_form_type_repeat1",
  [aux_sym_unset_statement_repeat1] = "unset_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_if_statement_repeat2] = "if_statement_repeat2",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_match_condition_list_repeat1] = "match_condition_list_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_anonymous_function_use_clause_repeat1] = "anonymous_function_use_clause_repeat1",
  [aux_sym__list_destructing_repeat1] = "_list_destructing_repeat1",
  [aux_sym__array_destructing_repeat1] = "_array_destructing_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [aux_sym_attribute_group_repeat1] = "attribute_group_repeat1",
  [aux_sym_attribute_list_repeat1] = "attribute_list_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym_nowdoc_body_repeat1] = "nowdoc_body_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_name] = sym_name,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [sym_php_tag] = sym_php_tag,
  [aux_sym_text_token1] = aux_sym_text_token1,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_AMP] = anon_sym_AMP,
  [aux_sym_function_static_declaration_token1] = anon_sym_static,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym_global_declaration_token1] = aux_sym_global_declaration_token1,
  [aux_sym_namespace_definition_token1] = aux_sym_namespace_definition_token1,
  [aux_sym_namespace_use_declaration_token1] = aux_sym_namespace_use_declaration_token1,
  [aux_sym_namespace_use_declaration_token2] = aux_sym_namespace_use_declaration_token2,
  [aux_sym_namespace_use_declaration_token3] = aux_sym_namespace_use_declaration_token3,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym_namespace_aliasing_clause_token1] = aux_sym_namespace_aliasing_clause_token1,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym_trait_declaration_token1] = aux_sym_trait_declaration_token1,
  [aux_sym_interface_declaration_token1] = aux_sym_interface_declaration_token1,
  [aux_sym_base_clause_token1] = aux_sym_base_clause_token1,
  [aux_sym_enum_declaration_token1] = aux_sym_enum_declaration_token1,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_int] = anon_sym_int,
  [aux_sym_enum_case_token1] = aux_sym_enum_case_token1,
  [aux_sym_class_declaration_token1] = aux_sym_class_declaration_token1,
  [aux_sym_final_modifier_token1] = aux_sym_final_modifier_token1,
  [aux_sym_abstract_modifier_token1] = aux_sym_abstract_modifier_token1,
  [aux_sym_readonly_modifier_token1] = aux_sym_readonly_modifier_token1,
  [aux_sym_class_interface_clause_token1] = aux_sym_class_interface_clause_token1,
  [sym_var_modifier] = sym_var_modifier,
  [aux_sym_use_instead_of_clause_token1] = aux_sym_use_instead_of_clause_token1,
  [aux_sym_visibility_modifier_token1] = aux_sym_visibility_modifier_token1,
  [aux_sym_visibility_modifier_token2] = aux_sym_visibility_modifier_token2,
  [aux_sym_visibility_modifier_token3] = aux_sym_visibility_modifier_token3,
  [aux_sym__arrow_function_header_token1] = aux_sym__arrow_function_header_token1,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym_bottom_type] = sym_bottom_type,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_array] = anon_sym_array,
  [aux_sym_primitive_type_token1] = aux_sym_primitive_type_token1,
  [anon_sym_iterable] = anon_sym_iterable,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_mixed] = anon_sym_mixed,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_true] = anon_sym_true,
  [aux_sym_cast_type_token1] = aux_sym_cast_type_token1,
  [aux_sym_cast_type_token2] = aux_sym_cast_type_token2,
  [aux_sym_cast_type_token3] = aux_sym_cast_type_token3,
  [aux_sym_cast_type_token4] = aux_sym_cast_type_token4,
  [aux_sym_cast_type_token5] = aux_sym_cast_type_token5,
  [aux_sym_cast_type_token6] = aux_sym_cast_type_token6,
  [aux_sym_cast_type_token7] = aux_sym_cast_type_token7,
  [aux_sym_cast_type_token8] = aux_sym_cast_type_token8,
  [aux_sym_cast_type_token9] = aux_sym_cast_type_token9,
  [aux_sym_cast_type_token10] = aux_sym_cast_type_token10,
  [aux_sym_cast_type_token11] = aux_sym_cast_type_token11,
  [aux_sym_cast_type_token12] = aux_sym_cast_type_token12,
  [aux_sym_echo_statement_token1] = aux_sym_echo_statement_token1,
  [anon_sym_unset] = anon_sym_unset,
  [aux_sym_declare_statement_token1] = aux_sym_declare_statement_token1,
  [aux_sym_declare_statement_token2] = aux_sym_declare_statement_token2,
  [anon_sym_ticks] = anon_sym_ticks,
  [anon_sym_encoding] = anon_sym_encoding,
  [anon_sym_strict_types] = anon_sym_strict_types,
  [sym_float] = sym_float,
  [aux_sym_try_statement_token1] = aux_sym_try_statement_token1,
  [aux_sym_catch_clause_token1] = aux_sym_catch_clause_token1,
  [aux_sym_finally_clause_token1] = aux_sym_finally_clause_token1,
  [aux_sym_goto_statement_token1] = aux_sym_goto_statement_token1,
  [aux_sym_continue_statement_token1] = aux_sym_continue_statement_token1,
  [aux_sym_break_statement_token1] = aux_sym_break_statement_token1,
  [sym_integer] = sym_integer,
  [aux_sym_return_statement_token1] = aux_sym_return_statement_token1,
  [aux_sym_throw_expression_token1] = aux_sym_throw_expression_token1,
  [aux_sym_while_statement_token1] = aux_sym_while_statement_token1,
  [aux_sym_while_statement_token2] = aux_sym_while_statement_token2,
  [aux_sym_do_statement_token1] = aux_sym_do_statement_token1,
  [aux_sym_for_statement_token1] = aux_sym_for_statement_token1,
  [aux_sym_for_statement_token2] = aux_sym_for_statement_token2,
  [aux_sym_foreach_statement_token1] = aux_sym_foreach_statement_token1,
  [aux_sym_foreach_statement_token2] = aux_sym_foreach_statement_token2,
  [aux_sym_if_statement_token1] = aux_sym_if_statement_token1,
  [aux_sym_if_statement_token2] = aux_sym_if_statement_token2,
  [aux_sym_else_if_clause_token1] = aux_sym_else_if_clause_token1,
  [aux_sym_else_clause_token1] = aux_sym_else_clause_token1,
  [aux_sym_match_expression_token1] = aux_sym_match_expression_token1,
  [aux_sym_match_default_expression_token1] = aux_sym_match_default_expression_token1,
  [aux_sym_switch_statement_token1] = aux_sym_switch_statement_token1,
  [aux_sym_switch_block_token1] = aux_sym_switch_block_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_AT] = anon_sym_AT,
  [aux_sym_clone_expression_token1] = aux_sym_clone_expression_token1,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [aux_sym_print_intrinsic_token1] = aux_sym_print_intrinsic_token1,
  [aux_sym_object_creation_expression_token1] = aux_sym_object_creation_expression_token1,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_QMARK_DASH_GT] = anon_sym_QMARK_DASH_GT,
  [aux_sym__list_destructing_token1] = aux_sym__list_destructing_token1,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_self] = anon_sym_self,
  [anon_sym_parent] = anon_sym_parent,
  [aux_sym__argument_name_token1] = aux_sym__argument_name_token1,
  [aux_sym__argument_name_token2] = aux_sym__argument_name_token2,
  [anon_sym_POUND_LBRACK] = anon_sym_POUND_LBRACK,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_BSLASHu] = sym_string_value,
  [aux_sym_encapsed_string_token1] = aux_sym_encapsed_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = sym_escape_sequence,
  [sym_string_value] = sym_string_value,
  [anon_sym_LT_LT_LT] = anon_sym_LT_LT_LT,
  [anon_sym_DQUOTE2] = anon_sym_DQUOTE,
  [sym__new_line] = sym__new_line,
  [anon_sym_] = sym_nowdoc_string,
  [anon_sym_SQUOTE2] = anon_sym_SQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_yield_expression_token1] = aux_sym_yield_expression_token1,
  [aux_sym_yield_expression_token2] = aux_sym_yield_expression_token2,
  [aux_sym_binary_expression_token1] = aux_sym_binary_expression_token1,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [aux_sym_binary_expression_token2] = aux_sym_binary_expression_token2,
  [aux_sym_binary_expression_token3] = aux_sym_binary_expression_token3,
  [aux_sym_binary_expression_token4] = aux_sym_binary_expression_token4,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym_include_expression_token1] = aux_sym_include_expression_token1,
  [aux_sym_include_once_expression_token1] = aux_sym_include_once_expression_token1,
  [aux_sym_require_expression_token1] = aux_sym_require_expression_token1,
  [aux_sym_require_once_expression_token1] = aux_sym_require_once_expression_token1,
  [sym_comment] = sym_comment,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym_encapsed_string_chars] = sym_string_value,
  [sym_encapsed_string_chars_after_variable] = sym_string_value,
  [sym_execution_string_chars] = sym_string_value,
  [sym_execution_string_chars_after_variable] = sym_string_value,
  [sym_encapsed_string_chars_heredoc] = sym_string_value,
  [sym_encapsed_string_chars_after_variable_heredoc] = sym_string_value,
  [sym__eof] = sym__eof,
  [sym_heredoc_start] = sym_heredoc_start,
  [sym_heredoc_end] = sym_heredoc_end,
  [sym_nowdoc_string] = sym_nowdoc_string,
  [sym_sentinel_error] = sym_sentinel_error,
  [sym_program] = sym_program,
  [sym_empty_statement] = sym_empty_statement,
  [sym_reference_modifier] = sym_reference_modifier,
  [sym_function_static_declaration] = sym_function_static_declaration,
  [sym_static_variable_declaration] = sym_static_variable_declaration,
  [sym_global_declaration] = sym_global_declaration,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_use_declaration] = sym_namespace_use_declaration,
  [sym_namespace_use_clause] = sym_namespace_use_clause,
  [sym_qualified_name] = sym_qualified_name,
  [sym_namespace_name_as_prefix] = sym_namespace_name_as_prefix,
  [sym_namespace_name] = sym_namespace_name,
  [sym_namespace_aliasing_clause] = sym_namespace_aliasing_clause,
  [sym_namespace_use_group] = sym_namespace_use_group,
  [sym_namespace_use_group_clause] = sym_namespace_use_group_clause,
  [sym_trait_declaration] = sym_trait_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_base_clause] = sym_base_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_declaration_list] = sym_enum_declaration_list,
  [sym__enum_member_declaration] = sym__enum_member_declaration,
  [sym_enum_case] = sym_enum_case,
  [sym_class_declaration] = sym_class_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_final_modifier] = sym_final_modifier,
  [sym_abstract_modifier] = sym_abstract_modifier,
  [sym_readonly_modifier] = sym_readonly_modifier,
  [sym_class_interface_clause] = sym_class_interface_clause,
  [sym__member_declaration] = sym__member_declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym__class_const_declaration] = sym_const_declaration,
  [sym__const_declaration] = sym__const_declaration,
  [sym_property_declaration] = sym_property_declaration,
  [sym__modifier] = sym__modifier,
  [sym_property_element] = sym_property_element,
  [sym_property_initializer] = sym_property_initializer,
  [sym_method_declaration] = sym_method_declaration,
  [sym_static_modifier] = sym_static_modifier,
  [sym_use_declaration] = sym_use_declaration,
  [sym_use_list] = sym_use_list,
  [sym_use_instead_of_clause] = sym_use_instead_of_clause,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym_function_definition] = sym_function_definition,
  [sym__function_definition_header] = sym__function_definition_header,
  [sym__arrow_function_header] = sym__arrow_function_header,
  [sym_arrow_function] = sym_arrow_function,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_property_promotion_parameter] = sym_property_promotion_parameter,
  [sym_simple_parameter] = sym_simple_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym__type] = sym__type,
  [sym__types] = sym__types,
  [sym_named_type] = sym_named_type,
  [sym_optional_type] = sym_optional_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_disjunctive_normal_form_type] = sym_disjunctive_normal_form_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_cast_type] = sym_cast_type,
  [sym__return_type] = sym__return_type,
  [sym_const_element] = sym_const_element,
  [sym_echo_statement] = sym_echo_statement,
  [sym_unset_statement] = sym_unset_statement,
  [sym_declare_statement] = sym_declare_statement,
  [sym_declare_directive] = sym_declare_directive,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_type_list] = sym_type_list,
  [sym_finally_clause] = sym_finally_clause,
  [sym_goto_statement] = sym_goto_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_expression] = sym_throw_expression,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__expressions] = sym__expressions,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_foreach_pair] = sym_foreach_pair,
  [sym_if_statement] = sym_if_statement,
  [sym_colon_block] = sym_colon_block,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_else_if_clause_2] = sym_else_if_clause,
  [sym_else_clause_2] = sym_else_clause,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_condition_list] = sym_match_condition_list,
  [sym_match_conditional_expression] = sym_match_conditional_expression,
  [sym_match_default_expression] = sym_match_default_expression,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_block] = sym_switch_block,
  [sym_case_statement] = sym_case_statement,
  [sym_default_statement] = sym_default_statement,
  [sym_compound_statement] = sym_compound_statement,
  [sym_named_label_statement] = sym_named_label_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym__expression] = sym__expression,
  [sym__unary_expression] = sym__unary_expression,
  [sym_unary_op_expression] = sym_unary_op_expression,
  [sym_error_suppression_expression] = sym_error_suppression_expression,
  [sym_clone_expression] = sym_clone_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_constant_access_expression] = sym_class_constant_access_expression,
  [sym_print_intrinsic] = sym_print_intrinsic,
  [sym_anonymous_function_creation_expression] = sym_anonymous_function_creation_expression,
  [sym_anonymous_function_use_clause] = sym_anonymous_function_use_clause,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_cast_variable] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_reference_assignment_expression] = sym_reference_assignment_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_nullsafe_member_access_expression] = sym_nullsafe_member_access_expression,
  [sym_scoped_property_access_expression] = sym_scoped_property_access_expression,
  [sym_list_literal] = sym_list_literal,
  [sym__list_destructing] = sym__list_destructing,
  [sym__array_destructing] = sym__array_destructing,
  [sym__array_destructing_element] = sym__array_destructing_element,
  [sym_function_call_expression] = sym_function_call_expression,
  [sym_scoped_call_expression] = sym_scoped_call_expression,
  [sym__scope_resolution_qualifier] = sym__scope_resolution_qualifier,
  [sym_relative_scope] = sym_relative_scope,
  [sym_variadic_placeholder] = sym_variadic_placeholder,
  [sym_arguments] = sym_arguments,
  [sym_argument] = sym_argument,
  [sym__argument_name] = sym__argument_name,
  [sym_member_call_expression] = sym_member_call_expression,
  [sym_nullsafe_member_call_expression] = sym_nullsafe_member_call_expression,
  [sym_variadic_unpacking] = sym_variadic_unpacking,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym__dereferencable_expression] = sym__dereferencable_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_attribute_group] = sym_attribute_group,
  [sym_attribute_list] = sym_attribute_list,
  [sym_attribute] = sym_attribute,
  [sym__complex_string_part] = sym__complex_string_part,
  [sym__simple_string_member_access_expression] = sym_member_access_expression,
  [sym__simple_string_subscript_unary_expression] = sym_unary_op_expression,
  [sym__simple_string_array_access_argument] = sym__simple_string_array_access_argument,
  [sym__simple_string_subscript_expression] = sym_subscript_expression,
  [sym__simple_string_part] = sym__simple_string_part,
  [aux_sym__interpolated_string_body] = aux_sym__interpolated_string_body,
  [aux_sym__interpolated_string_body_heredoc] = aux_sym__interpolated_string_body_heredoc,
  [sym_encapsed_string] = sym_encapsed_string,
  [sym_string] = sym_string,
  [sym_heredoc_body] = sym_heredoc_body,
  [sym_heredoc] = sym_heredoc,
  [sym_nowdoc_body] = sym_nowdoc_body,
  [sym_nowdoc] = sym_nowdoc,
  [aux_sym__interpolated_execution_operator_body] = aux_sym__interpolated_execution_operator_body,
  [sym_shell_command_expression] = sym_shell_command_expression,
  [sym_boolean] = sym_boolean,
  [sym_null] = sym_null,
  [sym__string] = sym__string,
  [sym_dynamic_variable_name] = sym_dynamic_variable_name,
  [sym_variable_name] = sym_variable_name,
  [sym_variable_reference] = sym_by_ref,
  [sym_by_ref] = sym_by_ref,
  [sym_yield_expression] = sym_yield_expression,
  [sym_array_element_initializer] = sym_array_element_initializer,
  [sym_binary_expression] = sym_binary_expression,
  [sym_include_expression] = sym_include_expression,
  [sym_include_once_expression] = sym_include_once_expression,
  [sym_require_expression] = sym_require_expression,
  [sym_require_once_expression] = sym_require_once_expression,
  [sym__reserved_identifier] = sym_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_function_static_declaration_repeat1] = aux_sym_function_static_declaration_repeat1,
  [aux_sym_global_declaration_repeat1] = aux_sym_global_declaration_repeat1,
  [aux_sym_namespace_use_declaration_repeat1] = aux_sym_namespace_use_declaration_repeat1,
  [aux_sym_namespace_name_repeat1] = aux_sym_namespace_name_repeat1,
  [aux_sym_namespace_use_group_repeat1] = aux_sym_namespace_use_group_repeat1,
  [aux_sym_base_clause_repeat1] = aux_sym_base_clause_repeat1,
  [aux_sym_enum_declaration_list_repeat1] = aux_sym_enum_declaration_list_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym__const_declaration_repeat1] = aux_sym__const_declaration_repeat1,
  [aux_sym_property_declaration_repeat1] = aux_sym_property_declaration_repeat1,
  [aux_sym_property_declaration_repeat2] = aux_sym_property_declaration_repeat2,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_union_type_repeat1] = aux_sym_union_type_repeat1,
  [aux_sym_intersection_type_repeat1] = aux_sym_intersection_type_repeat1,
  [aux_sym_disjunctive_normal_form_type_repeat1] = aux_sym_disjunctive_normal_form_type_repeat1,
  [aux_sym_unset_statement_repeat1] = aux_sym_unset_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_if_statement_repeat2] = aux_sym_if_statement_repeat2,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_match_condition_list_repeat1] = aux_sym_match_condition_list_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_anonymous_function_use_clause_repeat1] = aux_sym_anonymous_function_use_clause_repeat1,
  [aux_sym__list_destructing_repeat1] = aux_sym__list_destructing_repeat1,
  [aux_sym__array_destructing_repeat1] = aux_sym__array_destructing_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [aux_sym_attribute_group_repeat1] = aux_sym_attribute_group_repeat1,
  [aux_sym_attribute_list_repeat1] = aux_sym_attribute_list_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_heredoc_body_repeat1] = aux_sym_heredoc_body_repeat1,
  [aux_sym_nowdoc_body_repeat1] = aux_sym_nowdoc_body_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_php_tag] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_text_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_function_static_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_global_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_definition_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_namespace_aliasing_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_trait_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interface_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_base_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_enum_case_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_declaration_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_final_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_abstract_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_readonly_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_interface_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_var_modifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_use_instead_of_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_visibility_modifier_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__arrow_function_header_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym_bottom_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_array] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_primitive_type_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iterable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_cast_type_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token6] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token7] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token8] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token9] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token10] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token11] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_type_token12] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_echo_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_declare_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_declare_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ticks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_encoding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strict_types] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_try_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_catch_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_finally_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_goto_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_continue_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_break_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_return_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_throw_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_do_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_for_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_foreach_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_foreach_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_statement_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_else_if_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_else_clause_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_match_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_match_default_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_switch_statement_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_switch_block_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_clone_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_print_intrinsic_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_object_creation_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__list_destructing_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_self] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__argument_name_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_name_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_POUND_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHu] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_encapsed_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = true,
    .named = true,
  },
  [sym_string_value] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [sym__new_line] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_yield_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_yield_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_include_once_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_require_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_require_once_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_encapsed_string_chars] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_after_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_execution_string_chars] = {
    .visible = true,
    .named = true,
  },
  [sym_execution_string_chars_after_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_encapsed_string_chars_after_variable_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_end] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc_string] = {
    .visible = true,
    .named = true,
  },
  [sym_sentinel_error] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_static_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name_as_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_aliasing_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_base_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_case] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_final_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_interface_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__class_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__const_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__modifier] = {
    .visible = false,
    .named = true,
  },
  [sym_property_element] = {
    .visible = true,
    .named = true,
  },
  [sym_property_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_instead_of_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_definition_header] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow_function_header] = {
    .visible = false,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_property_promotion_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__types] = {
    .visible = false,
    .named = true,
  },
  [sym_named_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunctive_normal_form_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_type] = {
    .visible = true,
    .named = true,
  },
  [sym__return_type] = {
    .visible = false,
    .named = true,
  },
  [sym_const_element] = {
    .visible = true,
    .named = true,
  },
  [sym_echo_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expressions] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_colon_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_condition_list] = {
    .visible = true,
    .named = true,
  },
  [sym_match_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_default_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_default_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_op_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_error_suppression_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_clone_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_constant_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_print_intrinsic] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_nullsafe_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_property_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__list_destructing] = {
    .visible = false,
    .named = true,
  },
  [sym__array_destructing] = {
    .visible = false,
    .named = true,
  },
  [sym__array_destructing_element] = {
    .visible = false,
    .named = true,
  },
  [sym_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution_qualifier] = {
    .visible = false,
    .named = true,
  },
  [sym_relative_scope] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_placeholder] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_name] = {
    .visible = false,
    .named = true,
  },
  [sym_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_nullsafe_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_unpacking] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__dereferencable_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_group] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__complex_string_part] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_string_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_subscript_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_array_access_argument] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_string_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_string_part] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__interpolated_string_body] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpolated_string_body_heredoc] = {
    .visible = false,
    .named = false,
  },
  [sym_encapsed_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_nowdoc] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpolated_execution_operator_body] = {
    .visible = false,
    .named = false,
  },
  [sym_shell_command_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_dynamic_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_by_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_element_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_static_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_intersection_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_disjunctive_normal_form_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_condition_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_function_use_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__list_destructing_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__array_destructing_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_nowdoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_attributes = 4,
  field_body = 5,
  field_condition = 6,
  field_conditional_expressions = 7,
  field_default_value = 8,
  field_end_tag = 9,
  field_function = 10,
  field_identifier = 11,
  field_left = 12,
  field_modifier = 13,
  field_name = 14,
  field_object = 15,
  field_operator = 16,
  field_parameters = 17,
  field_readonly = 18,
  field_reference_modifier = 19,
  field_return_expression = 20,
  field_return_type = 21,
  field_right = 22,
  field_scope = 23,
  field_type = 24,
  field_value = 25,
  field_visibility = 26,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attributes] = "attributes",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_conditional_expressions] = "conditional_expressions",
  [field_default_value] = "default_value",
  [field_end_tag] = "end_tag",
  [field_function] = "function",
  [field_identifier] = "identifier",
  [field_left] = "left",
  [field_modifier] = "modifier",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_readonly] = "readonly",
  [field_reference_modifier] = "reference_modifier",
  [field_return_expression] = "return_expression",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_type] = "type",
  [field_value] = "value",
  [field_visibility] = "visibility",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 2},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 5},
  [10] = {.index = 15, .length = 2},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 2},
  [13] = {.index = 20, .length = 2},
  [14] = {.index = 22, .length = 2},
  [15] = {.index = 24, .length = 2},
  [16] = {.index = 26, .length = 2},
  [18] = {.index = 28, .length = 2},
  [19] = {.index = 30, .length = 2},
  [20] = {.index = 32, .length = 1},
  [21] = {.index = 33, .length = 5},
  [22] = {.index = 38, .length = 3},
  [23] = {.index = 41, .length = 2},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 2},
  [26] = {.index = 47, .length = 2},
  [27] = {.index = 49, .length = 6},
  [28] = {.index = 55, .length = 2},
  [29] = {.index = 57, .length = 2},
  [30] = {.index = 59, .length = 2},
  [31] = {.index = 61, .length = 2},
  [32] = {.index = 63, .length = 2},
  [33] = {.index = 65, .length = 2},
  [34] = {.index = 67, .length = 3},
  [35] = {.index = 70, .length = 3},
  [36] = {.index = 73, .length = 3},
  [37] = {.index = 76, .length = 1},
  [38] = {.index = 77, .length = 3},
  [39] = {.index = 80, .length = 2},
  [40] = {.index = 82, .length = 1},
  [41] = {.index = 83, .length = 3},
  [42] = {.index = 86, .length = 2},
  [43] = {.index = 88, .length = 3},
  [44] = {.index = 91, .length = 2},
  [45] = {.index = 93, .length = 1},
  [46] = {.index = 94, .length = 3},
  [47] = {.index = 97, .length = 3},
  [48] = {.index = 100, .length = 1},
  [51] = {.index = 101, .length = 3},
  [52] = {.index = 1, .length = 1},
  [53] = {.index = 104, .length = 1},
  [54] = {.index = 105, .length = 1},
  [55] = {.index = 106, .length = 3},
  [56] = {.index = 109, .length = 2},
  [57] = {.index = 111, .length = 2},
  [58] = {.index = 113, .length = 2},
  [59] = {.index = 115, .length = 2},
  [60] = {.index = 117, .length = 3},
  [61] = {.index = 120, .length = 3},
  [62] = {.index = 123, .length = 3},
  [63] = {.index = 126, .length = 3},
  [64] = {.index = 129, .length = 3},
  [65] = {.index = 132, .length = 3},
  [66] = {.index = 135, .length = 2},
  [67] = {.index = 137, .length = 3},
  [68] = {.index = 140, .length = 3},
  [69] = {.index = 143, .length = 2},
  [70] = {.index = 145, .length = 2},
  [71] = {.index = 147, .length = 3},
  [72] = {.index = 150, .length = 3},
  [73] = {.index = 153, .length = 2},
  [74] = {.index = 155, .length = 3},
  [75] = {.index = 158, .length = 2},
  [76] = {.index = 160, .length = 3},
  [77] = {.index = 163, .length = 3},
  [78] = {.index = 166, .length = 3},
  [79] = {.index = 169, .length = 2},
  [80] = {.index = 171, .length = 4},
  [81] = {.index = 175, .length = 4},
  [82] = {.index = 179, .length = 3},
  [83] = {.index = 182, .length = 3},
  [84] = {.index = 185, .length = 2},
  [85] = {.index = 187, .length = 4},
  [86] = {.index = 191, .length = 2},
  [87] = {.index = 193, .length = 2},
  [88] = {.index = 193, .length = 2},
  [89] = {.index = 195, .length = 2},
  [90] = {.index = 197, .length = 4},
  [91] = {.index = 201, .length = 2},
  [92] = {.index = 203, .length = 3},
  [93] = {.index = 206, .length = 4},
  [94] = {.index = 210, .length = 2},
  [95] = {.index = 212, .length = 2},
  [96] = {.index = 214, .length = 3},
  [97] = {.index = 217, .length = 4},
  [98] = {.index = 221, .length = 3},
  [99] = {.index = 224, .length = 1},
  [100] = {.index = 225, .length = 3},
  [102] = {.index = 228, .length = 2},
  [103] = {.index = 230, .length = 3},
  [104] = {.index = 233, .length = 4},
  [105] = {.index = 237, .length = 4},
  [106] = {.index = 241, .length = 3},
  [107] = {.index = 244, .length = 3},
  [108] = {.index = 247, .length = 4},
  [109] = {.index = 251, .length = 4},
  [110] = {.index = 255, .length = 3},
  [111] = {.index = 258, .length = 3},
  [112] = {.index = 261, .length = 4},
  [113] = {.index = 265, .length = 3},
  [114] = {.index = 268, .length = 3},
  [115] = {.index = 271, .length = 3},
  [116] = {.index = 274, .length = 4},
  [117] = {.index = 278, .length = 3},
  [118] = {.index = 281, .length = 3},
  [119] = {.index = 284, .length = 3},
  [120] = {.index = 287, .length = 3},
  [121] = {.index = 290, .length = 4},
  [122] = {.index = 294, .length = 4},
  [123] = {.index = 298, .length = 3},
  [124] = {.index = 301, .length = 4},
  [125] = {.index = 305, .length = 3},
  [126] = {.index = 308, .length = 4},
  [127] = {.index = 312, .length = 3},
  [128] = {.index = 315, .length = 5},
  [129] = {.index = 320, .length = 4},
  [130] = {.index = 324, .length = 5},
  [131] = {.index = 329, .length = 2},
  [132] = {.index = 331, .length = 1},
  [133] = {.index = 332, .length = 2},
  [134] = {.index = 334, .length = 1},
  [137] = {.index = 335, .length = 5},
  [138] = {.index = 340, .length = 3},
  [139] = {.index = 343, .length = 3},
  [140] = {.index = 346, .length = 4},
  [141] = {.index = 350, .length = 3},
  [142] = {.index = 353, .length = 3},
  [143] = {.index = 356, .length = 4},
  [144] = {.index = 360, .length = 4},
  [145] = {.index = 364, .length = 3},
  [146] = {.index = 367, .length = 5},
  [147] = {.index = 372, .length = 4},
  [148] = {.index = 376, .length = 4},
  [149] = {.index = 380, .length = 3},
  [150] = {.index = 380, .length = 3},
  [151] = {.index = 383, .length = 4},
  [152] = {.index = 387, .length = 5},
  [153] = {.index = 392, .length = 4},
  [154] = {.index = 396, .length = 4},
  [155] = {.index = 400, .length = 4},
  [156] = {.index = 404, .length = 4},
  [157] = {.index = 408, .length = 4},
  [158] = {.index = 412, .length = 4},
  [159] = {.index = 416, .length = 5},
  [160] = {.index = 421, .length = 4},
  [161] = {.index = 425, .length = 4},
  [162] = {.index = 429, .length = 4},
  [163] = {.index = 433, .length = 1},
  [164] = {.index = 434, .length = 5},
  [165] = {.index = 439, .length = 6},
  [166] = {.index = 445, .length = 2},
  [167] = {.index = 447, .length = 1},
  [168] = {.index = 448, .length = 5},
  [169] = {.index = 453, .length = 3},
  [170] = {.index = 456, .length = 4},
  [171] = {.index = 460, .length = 5},
  [172] = {.index = 465, .length = 4},
  [173] = {.index = 469, .length = 4},
  [174] = {.index = 473, .length = 5},
  [175] = {.index = 478, .length = 3},
  [176] = {.index = 481, .length = 4},
  [177] = {.index = 485, .length = 5},
  [178] = {.index = 490, .length = 5},
  [179] = {.index = 495, .length = 5},
  [180] = {.index = 500, .length = 5},
  [181] = {.index = 505, .length = 5},
  [182] = {.index = 510, .length = 2},
  [183] = {.index = 512, .length = 2},
  [184] = {.index = 514, .length = 3},
  [185] = {.index = 517, .length = 5},
  [186] = {.index = 522, .length = 5},
  [187] = {.index = 527, .length = 6},
  [188] = {.index = 533, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_body, 1},
  [3] =
    {field_parameters, 1},
  [4] =
    {field_argument, 1},
    {field_operator, 0},
  [6] =
    {field_name, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [8] =
    {field_arguments, 1},
    {field_function, 0},
  [10] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [15] =
    {field_argument, 0},
    {field_operator, 1},
  [17] =
    {field_name, 1},
  [18] =
    {field_body, 2},
    {field_name, 1},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_body, 2},
    {field_parameters, 1},
  [24] =
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [26] =
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [28] =
    {field_body, 2},
    {field_condition, 1},
  [30] =
    {field_end_tag, 2},
    {field_identifier, 1},
  [32] =
    {field_parameters, 2},
  [33] =
    {field_attributes, 0, .inherited = true},
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [38] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [41] =
    {field_left, 0},
    {field_right, 2},
  [43] =
    {field_name, 2},
    {field_scope, 0},
  [45] =
    {field_name, 2},
    {field_object, 0},
  [47] =
    {field_attributes, 0},
    {field_parameters, 2},
  [49] =
    {field_attributes, 0},
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [55] =
    {field_body, 3},
    {field_parameters, 2},
  [57] =
    {field_name, 0},
    {field_value, 2},
  [59] =
    {field_name, 1},
    {field_reference_modifier, 0},
  [61] =
    {field_name, 1},
    {field_visibility, 0},
  [63] =
    {field_name, 1},
    {field_type, 0},
  [65] =
    {field_attributes, 0},
    {field_name, 1},
  [67] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [70] =
    {field_name, 2},
    {field_parameters, 3},
    {field_reference_modifier, 1},
  [73] =
    {field_body, 3},
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [76] =
    {field_return_type, 1},
  [77] =
    {field_body, 3},
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [80] =
    {field_body, 3},
    {field_parameters, 1},
  [82] =
    {field_type, 1},
  [83] =
    {field_attributes, 0, .inherited = true},
    {field_modifier, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [86] =
    {field_body, 3},
    {field_name, 1},
  [88] =
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 3, .inherited = true},
  [91] =
    {field_type, 1},
    {field_value, 3},
  [93] =
    {field_alternative, 0},
  [94] =
    {field_alternative, 3},
    {field_body, 2},
    {field_condition, 1},
  [97] =
    {field_alternative, 3, .inherited = true},
    {field_body, 2},
    {field_condition, 1},
  [100] =
    {field_attributes, 1},
  [101] =
    {field_end_tag, 3},
    {field_identifier, 1},
    {field_value, 2},
  [104] =
    {field_reference_modifier, 0},
  [105] =
    {field_name, 0, .inherited = true},
  [106] =
    {field_body, 3},
    {field_modifier, 0},
    {field_name, 2},
  [109] =
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [111] =
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [113] =
    {field_alternative, 3},
    {field_condition, 0},
  [115] =
    {field_left, 0},
    {field_right, 3},
  [117] =
    {field_arguments, 3},
    {field_name, 2},
    {field_scope, 0},
  [120] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [123] =
    {field_attributes, 0},
    {field_body, 3},
    {field_parameters, 2},
  [126] =
    {field_attributes, 0},
    {field_body, 3},
    {field_name, 2},
  [129] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [132] =
    {field_attributes, 0},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [135] =
    {field_attributes, 0},
    {field_parameters, 3},
  [137] =
    {field_body, 4},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [140] =
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [143] =
    {field_body, 4},
    {field_parameters, 2},
  [145] =
    {field_name, 2},
    {field_reference_modifier, 0},
  [147] =
    {field_name, 2},
    {field_readonly, 1},
    {field_visibility, 0},
  [150] =
    {field_name, 2},
    {field_type, 1},
    {field_visibility, 0},
  [153] =
    {field_name, 2},
    {field_type, 0},
  [155] =
    {field_name, 2},
    {field_reference_modifier, 1},
    {field_type, 0},
  [158] =
    {field_attributes, 0},
    {field_name, 2},
  [160] =
    {field_attributes, 0},
    {field_name, 2},
    {field_reference_modifier, 1},
  [163] =
    {field_attributes, 0},
    {field_name, 2},
    {field_visibility, 1},
  [166] =
    {field_attributes, 0},
    {field_name, 2},
    {field_type, 1},
  [169] =
    {field_default_value, 2},
    {field_name, 0},
  [171] =
    {field_name, 2},
    {field_parameters, 3},
    {field_reference_modifier, 1},
    {field_return_type, 4, .inherited = true},
  [175] =
    {field_body, 4},
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 3, .inherited = true},
  [179] =
    {field_body, 4},
    {field_parameters, 2},
    {field_reference_modifier, 1},
  [182] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3, .inherited = true},
  [185] =
    {field_modifier, 0},
    {field_type, 1, .inherited = true},
  [187] =
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_reference_modifier, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [191] =
    {field_attributes, 0},
    {field_type, 1, .inherited = true},
  [193] =
    {field_body, 4},
    {field_name, 1},
  [195] =
    {field_body, 1},
    {field_condition, 3},
  [197] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 1},
  [201] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [203] =
    {field_end_tag, 4},
    {field_identifier, 1},
    {field_value, 2},
  [206] =
    {field_end_tag, 4},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
  [210] =
    {field_end_tag, 4},
    {field_identifier, 2},
  [212] =
    {field_name, 0, .inherited = true},
    {field_reference_modifier, 1},
  [214] =
    {field_body, 4},
    {field_modifier, 0},
    {field_name, 2},
  [217] =
    {field_body, 4},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [221] =
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [224] =
    {field_type, 2},
  [225] =
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 0},
  [228] =
    {field_name, 3},
    {field_object, 0},
  [230] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 3},
  [233] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [237] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [241] =
    {field_attributes, 0},
    {field_body, 4},
    {field_parameters, 2},
  [244] =
    {field_attributes, 0},
    {field_body, 4},
    {field_name, 2},
  [247] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [251] =
    {field_attributes, 0},
    {field_body, 4},
    {field_modifier, 1},
    {field_name, 3},
  [255] =
    {field_attributes, 0},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [258] =
    {field_attributes, 0},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [261] =
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [265] =
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [268] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [271] =
    {field_default_value, 3},
    {field_name, 1},
    {field_reference_modifier, 0},
  [274] =
    {field_name, 3},
    {field_readonly, 1},
    {field_type, 2},
    {field_visibility, 0},
  [278] =
    {field_default_value, 3},
    {field_name, 1},
    {field_visibility, 0},
  [281] =
    {field_name, 3},
    {field_reference_modifier, 1},
    {field_type, 0},
  [284] =
    {field_default_value, 3},
    {field_name, 1},
    {field_type, 0},
  [287] =
    {field_attributes, 0},
    {field_name, 3},
    {field_reference_modifier, 1},
  [290] =
    {field_attributes, 0},
    {field_name, 3},
    {field_readonly, 2},
    {field_visibility, 1},
  [294] =
    {field_attributes, 0},
    {field_name, 3},
    {field_type, 2},
    {field_visibility, 1},
  [298] =
    {field_attributes, 0},
    {field_name, 3},
    {field_type, 1},
  [301] =
    {field_attributes, 0},
    {field_name, 3},
    {field_reference_modifier, 2},
    {field_type, 1},
  [305] =
    {field_attributes, 0},
    {field_default_value, 3},
    {field_name, 1},
  [308] =
    {field_body, 5},
    {field_parameters, 2},
    {field_reference_modifier, 1},
    {field_return_type, 4, .inherited = true},
  [312] =
    {field_attributes, 0},
    {field_modifier, 1},
    {field_type, 2, .inherited = true},
  [315] =
    {field_attributes, 0},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [320] =
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [324] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_reference_modifier, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [329] =
    {field_body, 5},
    {field_name, 1},
  [331] =
    {field_return_expression, 2},
  [332] =
    {field_conditional_expressions, 0},
    {field_return_expression, 2},
  [334] =
    {field_value, 1},
  [335] =
    {field_end_tag, 5},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
    {field_value, 4},
  [340] =
    {field_end_tag, 5},
    {field_identifier, 2},
    {field_value, 4},
  [343] =
    {field_body, 5},
    {field_modifier, 0},
    {field_name, 2},
  [346] =
    {field_body, 5},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [350] =
    {field_arguments, 5},
    {field_name, 3},
    {field_scope, 0},
  [353] =
    {field_arguments, 5},
    {field_name, 3},
    {field_object, 0},
  [356] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [360] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [364] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
  [367] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 4, .inherited = true},
  [372] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 3},
    {field_reference_modifier, 2},
  [376] =
    {field_attributes, 0},
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [380] =
    {field_attributes, 0},
    {field_body, 5},
    {field_name, 2},
  [383] =
    {field_attributes, 0},
    {field_body, 5},
    {field_modifier, 1},
    {field_name, 3},
  [387] =
    {field_attributes, 0},
    {field_body, 5},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [392] =
    {field_attributes, 0},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 5, .inherited = true},
  [396] =
    {field_body, 6},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 5, .inherited = true},
  [400] =
    {field_default_value, 4},
    {field_name, 2},
    {field_readonly, 1},
    {field_visibility, 0},
  [404] =
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 1},
    {field_visibility, 0},
  [408] =
    {field_default_value, 4},
    {field_name, 2},
    {field_reference_modifier, 1},
    {field_type, 0},
  [412] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_reference_modifier, 1},
  [416] =
    {field_attributes, 0},
    {field_name, 4},
    {field_readonly, 2},
    {field_type, 3},
    {field_visibility, 1},
  [421] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_visibility, 1},
  [425] =
    {field_attributes, 0},
    {field_name, 4},
    {field_reference_modifier, 2},
    {field_type, 1},
  [429] =
    {field_attributes, 0},
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 1},
  [433] =
    {field_attributes, 0},
  [434] =
    {field_attributes, 0},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_reference_modifier, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
  [439] =
    {field_attributes, 0},
    {field_body, 3},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_reference_modifier, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
  [445] =
    {field_body, 4},
    {field_type, 2},
  [447] =
    {field_body, 6},
  [448] =
    {field_end_tag, 6},
    {field_identifier, 1},
    {field_identifier, 2},
    {field_identifier, 3},
    {field_value, 4},
  [453] =
    {field_end_tag, 6},
    {field_identifier, 2},
    {field_value, 4},
  [456] =
    {field_body, 6},
    {field_modifier, 0},
    {field_modifier, 1},
    {field_name, 3},
  [460] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 5, .inherited = true},
  [465] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 4},
    {field_reference_modifier, 3},
  [469] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 3},
    {field_return_type, 5, .inherited = true},
  [473] =
    {field_attributes, 0},
    {field_body, 6},
    {field_parameters, 3},
    {field_reference_modifier, 2},
    {field_return_type, 5, .inherited = true},
  [478] =
    {field_attributes, 0},
    {field_body, 6},
    {field_name, 2},
  [481] =
    {field_attributes, 0},
    {field_body, 6},
    {field_modifier, 1},
    {field_name, 3},
  [485] =
    {field_attributes, 0},
    {field_body, 6},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [490] =
    {field_default_value, 5},
    {field_name, 3},
    {field_readonly, 1},
    {field_type, 2},
    {field_visibility, 0},
  [495] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_readonly, 2},
    {field_visibility, 1},
  [500] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_type, 2},
    {field_visibility, 1},
  [505] =
    {field_attributes, 0},
    {field_default_value, 5},
    {field_name, 3},
    {field_reference_modifier, 2},
    {field_type, 1},
  [510] =
    {field_attributes, 0},
    {field_type, 2},
  [512] =
    {field_name, 1},
    {field_value, 3},
  [514] =
    {field_body, 5},
    {field_name, 3},
    {field_type, 2},
  [517] =
    {field_attributes, 0},
    {field_body, 7},
    {field_parameters, 4},
    {field_reference_modifier, 3},
    {field_return_type, 6, .inherited = true},
  [522] =
    {field_attributes, 0},
    {field_body, 7},
    {field_modifier, 1},
    {field_modifier, 2},
    {field_name, 4},
  [527] =
    {field_attributes, 0},
    {field_default_value, 6},
    {field_name, 4},
    {field_readonly, 2},
    {field_type, 3},
    {field_visibility, 1},
  [533] =
    {field_attributes, 0},
    {field_name, 2},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [6] = {
    [0] = sym_list_literal,
  },
  [17] = {
    [0] = anon_sym_array,
  },
  [49] = {
    [1] = sym_list_literal,
  },
  [50] = {
    [2] = sym_list_literal,
  },
  [52] = {
    [0] = sym_name,
  },
  [87] = {
    [3] = sym_primitive_type,
  },
  [101] = {
    [3] = sym_name,
  },
  [131] = {
    [3] = sym_primitive_type,
  },
  [135] = {
    [3] = sym_list_literal,
  },
  [136] = {
    [4] = sym_list_literal,
  },
  [149] = {
    [4] = sym_primitive_type,
  },
  [175] = {
    [4] = sym_primitive_type,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__expression, 2,
    sym__expression,
    sym_name,
  sym__list_destructing, 2,
    sym__list_destructing,
    sym_list_literal,
  sym__array_destructing, 2,
    sym__array_destructing,
    sym_list_literal,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 2,
  [9] = 9,
  [10] = 7,
  [11] = 9,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 12,
  [17] = 12,
  [18] = 12,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 23,
  [28] = 28,
  [29] = 28,
  [30] = 30,
  [31] = 31,
  [32] = 23,
  [33] = 20,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 24,
  [38] = 38,
  [39] = 36,
  [40] = 40,
  [41] = 26,
  [42] = 25,
  [43] = 22,
  [44] = 38,
  [45] = 34,
  [46] = 23,
  [47] = 40,
  [48] = 48,
  [49] = 49,
  [50] = 20,
  [51] = 21,
  [52] = 35,
  [53] = 28,
  [54] = 19,
  [55] = 55,
  [56] = 19,
  [57] = 55,
  [58] = 55,
  [59] = 19,
  [60] = 26,
  [61] = 55,
  [62] = 31,
  [63] = 28,
  [64] = 24,
  [65] = 40,
  [66] = 40,
  [67] = 24,
  [68] = 26,
  [69] = 36,
  [70] = 49,
  [71] = 48,
  [72] = 20,
  [73] = 36,
  [74] = 30,
  [75] = 55,
  [76] = 26,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 77,
  [81] = 78,
  [82] = 79,
  [83] = 77,
  [84] = 77,
  [85] = 85,
  [86] = 85,
  [87] = 85,
  [88] = 85,
  [89] = 89,
  [90] = 89,
  [91] = 91,
  [92] = 89,
  [93] = 89,
  [94] = 91,
  [95] = 91,
  [96] = 89,
  [97] = 91,
  [98] = 91,
  [99] = 89,
  [100] = 100,
  [101] = 101,
  [102] = 100,
  [103] = 101,
  [104] = 100,
  [105] = 100,
  [106] = 100,
  [107] = 100,
  [108] = 101,
  [109] = 100,
  [110] = 101,
  [111] = 101,
  [112] = 100,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 115,
  [117] = 113,
  [118] = 113,
  [119] = 113,
  [120] = 120,
  [121] = 115,
  [122] = 113,
  [123] = 120,
  [124] = 115,
  [125] = 113,
  [126] = 115,
  [127] = 115,
  [128] = 113,
  [129] = 115,
  [130] = 114,
  [131] = 115,
  [132] = 113,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 134,
  [139] = 136,
  [140] = 140,
  [141] = 135,
  [142] = 133,
  [143] = 140,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 148,
  [150] = 146,
  [151] = 147,
  [152] = 152,
  [153] = 144,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 157,
  [159] = 159,
  [160] = 160,
  [161] = 157,
  [162] = 162,
  [163] = 163,
  [164] = 162,
  [165] = 165,
  [166] = 166,
  [167] = 166,
  [168] = 157,
  [169] = 165,
  [170] = 165,
  [171] = 163,
  [172] = 163,
  [173] = 160,
  [174] = 165,
  [175] = 166,
  [176] = 159,
  [177] = 159,
  [178] = 159,
  [179] = 162,
  [180] = 160,
  [181] = 160,
  [182] = 166,
  [183] = 162,
  [184] = 163,
  [185] = 185,
  [186] = 185,
  [187] = 187,
  [188] = 188,
  [189] = 187,
  [190] = 190,
  [191] = 185,
  [192] = 185,
  [193] = 190,
  [194] = 188,
  [195] = 195,
  [196] = 195,
  [197] = 185,
  [198] = 198,
  [199] = 199,
  [200] = 185,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 204,
  [206] = 204,
  [207] = 207,
  [208] = 208,
  [209] = 204,
  [210] = 207,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 212,
  [215] = 208,
  [216] = 208,
  [217] = 208,
  [218] = 212,
  [219] = 207,
  [220] = 212,
  [221] = 208,
  [222] = 208,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 226,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 226,
  [238] = 233,
  [239] = 235,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 223,
  [247] = 247,
  [248] = 248,
  [249] = 242,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 224,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 234,
  [266] = 266,
  [267] = 226,
  [268] = 268,
  [269] = 234,
  [270] = 233,
  [271] = 235,
  [272] = 226,
  [273] = 233,
  [274] = 274,
  [275] = 235,
  [276] = 274,
  [277] = 248,
  [278] = 264,
  [279] = 264,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 226,
  [284] = 244,
  [285] = 226,
  [286] = 286,
  [287] = 233,
  [288] = 264,
  [289] = 235,
  [290] = 290,
  [291] = 274,
  [292] = 264,
  [293] = 226,
  [294] = 294,
  [295] = 282,
  [296] = 274,
  [297] = 297,
  [298] = 233,
  [299] = 235,
  [300] = 235,
  [301] = 274,
  [302] = 233,
  [303] = 264,
  [304] = 274,
  [305] = 235,
  [306] = 226,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 233,
  [311] = 311,
  [312] = 282,
  [313] = 282,
  [314] = 297,
  [315] = 307,
  [316] = 297,
  [317] = 317,
  [318] = 318,
  [319] = 307,
  [320] = 311,
  [321] = 230,
  [322] = 311,
  [323] = 236,
  [324] = 241,
  [325] = 325,
  [326] = 228,
  [327] = 228,
  [328] = 328,
  [329] = 329,
  [330] = 230,
  [331] = 240,
  [332] = 332,
  [333] = 236,
  [334] = 334,
  [335] = 280,
  [336] = 243,
  [337] = 286,
  [338] = 245,
  [339] = 339,
  [340] = 241,
  [341] = 280,
  [342] = 224,
  [343] = 247,
  [344] = 248,
  [345] = 242,
  [346] = 346,
  [347] = 225,
  [348] = 228,
  [349] = 311,
  [350] = 225,
  [351] = 225,
  [352] = 224,
  [353] = 233,
  [354] = 235,
  [355] = 268,
  [356] = 262,
  [357] = 357,
  [358] = 247,
  [359] = 274,
  [360] = 360,
  [361] = 280,
  [362] = 260,
  [363] = 250,
  [364] = 364,
  [365] = 243,
  [366] = 234,
  [367] = 245,
  [368] = 259,
  [369] = 257,
  [370] = 258,
  [371] = 257,
  [372] = 251,
  [373] = 223,
  [374] = 258,
  [375] = 252,
  [376] = 240,
  [377] = 235,
  [378] = 256,
  [379] = 255,
  [380] = 247,
  [381] = 248,
  [382] = 242,
  [383] = 253,
  [384] = 254,
  [385] = 233,
  [386] = 259,
  [387] = 255,
  [388] = 250,
  [389] = 307,
  [390] = 251,
  [391] = 259,
  [392] = 286,
  [393] = 254,
  [394] = 268,
  [395] = 256,
  [396] = 252,
  [397] = 253,
  [398] = 257,
  [399] = 253,
  [400] = 260,
  [401] = 244,
  [402] = 230,
  [403] = 252,
  [404] = 251,
  [405] = 250,
  [406] = 262,
  [407] = 236,
  [408] = 408,
  [409] = 297,
  [410] = 262,
  [411] = 240,
  [412] = 243,
  [413] = 241,
  [414] = 286,
  [415] = 258,
  [416] = 254,
  [417] = 255,
  [418] = 256,
  [419] = 245,
  [420] = 223,
  [421] = 260,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 424,
  [426] = 426,
  [427] = 426,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 429,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 428,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 451,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 440,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 561,
  [563] = 561,
  [564] = 561,
  [565] = 561,
  [566] = 566,
  [567] = 567,
  [568] = 567,
  [569] = 567,
  [570] = 567,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 594,
  [597] = 578,
  [598] = 598,
  [599] = 576,
  [600] = 576,
  [601] = 575,
  [602] = 580,
  [603] = 577,
  [604] = 604,
  [605] = 579,
  [606] = 594,
  [607] = 581,
  [608] = 608,
  [609] = 593,
  [610] = 608,
  [611] = 573,
  [612] = 571,
  [613] = 574,
  [614] = 614,
  [615] = 585,
  [616] = 583,
  [617] = 592,
  [618] = 591,
  [619] = 604,
  [620] = 588,
  [621] = 584,
  [622] = 590,
  [623] = 589,
  [624] = 572,
  [625] = 586,
  [626] = 587,
  [627] = 594,
  [628] = 582,
  [629] = 629,
  [630] = 595,
  [631] = 631,
  [632] = 604,
  [633] = 595,
  [634] = 604,
  [635] = 635,
  [636] = 636,
  [637] = 635,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 579,
  [644] = 581,
  [645] = 645,
  [646] = 577,
  [647] = 578,
  [648] = 575,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 580,
  [653] = 649,
  [654] = 654,
  [655] = 654,
  [656] = 656,
  [657] = 657,
  [658] = 574,
  [659] = 586,
  [660] = 588,
  [661] = 584,
  [662] = 589,
  [663] = 587,
  [664] = 590,
  [665] = 591,
  [666] = 666,
  [667] = 582,
  [668] = 592,
  [669] = 583,
  [670] = 593,
  [671] = 581,
  [672] = 672,
  [673] = 585,
  [674] = 666,
  [675] = 675,
  [676] = 571,
  [677] = 573,
  [678] = 675,
  [679] = 672,
  [680] = 572,
  [681] = 580,
  [682] = 682,
  [683] = 580,
  [684] = 579,
  [685] = 685,
  [686] = 686,
  [687] = 575,
  [688] = 688,
  [689] = 579,
  [690] = 578,
  [691] = 580,
  [692] = 577,
  [693] = 577,
  [694] = 682,
  [695] = 695,
  [696] = 695,
  [697] = 697,
  [698] = 575,
  [699] = 578,
  [700] = 700,
  [701] = 701,
  [702] = 575,
  [703] = 645,
  [704] = 704,
  [705] = 579,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 656,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 578,
  [716] = 577,
  [717] = 657,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 573,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 571,
  [726] = 584,
  [727] = 588,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 583,
  [732] = 732,
  [733] = 733,
  [734] = 593,
  [735] = 735,
  [736] = 592,
  [737] = 737,
  [738] = 591,
  [739] = 572,
  [740] = 582,
  [741] = 587,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 585,
  [754] = 754,
  [755] = 589,
  [756] = 574,
  [757] = 566,
  [758] = 590,
  [759] = 586,
  [760] = 760,
  [761] = 761,
  [762] = 654,
  [763] = 429,
  [764] = 642,
  [765] = 580,
  [766] = 578,
  [767] = 575,
  [768] = 579,
  [769] = 577,
  [770] = 701,
  [771] = 651,
  [772] = 713,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 428,
  [777] = 650,
  [778] = 654,
  [779] = 645,
  [780] = 585,
  [781] = 586,
  [782] = 587,
  [783] = 783,
  [784] = 573,
  [785] = 783,
  [786] = 588,
  [787] = 584,
  [788] = 572,
  [789] = 589,
  [790] = 590,
  [791] = 581,
  [792] = 593,
  [793] = 592,
  [794] = 591,
  [795] = 582,
  [796] = 574,
  [797] = 583,
  [798] = 798,
  [799] = 571,
  [800] = 800,
  [801] = 579,
  [802] = 579,
  [803] = 803,
  [804] = 577,
  [805] = 805,
  [806] = 645,
  [807] = 704,
  [808] = 808,
  [809] = 714,
  [810] = 682,
  [811] = 811,
  [812] = 803,
  [813] = 656,
  [814] = 695,
  [815] = 657,
  [816] = 688,
  [817] = 578,
  [818] = 577,
  [819] = 580,
  [820] = 657,
  [821] = 695,
  [822] = 682,
  [823] = 575,
  [824] = 824,
  [825] = 578,
  [826] = 808,
  [827] = 581,
  [828] = 440,
  [829] = 451,
  [830] = 580,
  [831] = 579,
  [832] = 575,
  [833] = 805,
  [834] = 834,
  [835] = 580,
  [836] = 639,
  [837] = 811,
  [838] = 577,
  [839] = 575,
  [840] = 803,
  [841] = 656,
  [842] = 834,
  [843] = 706,
  [844] = 701,
  [845] = 803,
  [846] = 708,
  [847] = 709,
  [848] = 710,
  [849] = 578,
  [850] = 712,
  [851] = 805,
  [852] = 803,
  [853] = 713,
  [854] = 591,
  [855] = 566,
  [856] = 745,
  [857] = 735,
  [858] = 743,
  [859] = 732,
  [860] = 720,
  [861] = 719,
  [862] = 730,
  [863] = 729,
  [864] = 583,
  [865] = 728,
  [866] = 724,
  [867] = 722,
  [868] = 748,
  [869] = 749,
  [870] = 733,
  [871] = 585,
  [872] = 744,
  [873] = 713,
  [874] = 586,
  [875] = 573,
  [876] = 587,
  [877] = 742,
  [878] = 713,
  [879] = 593,
  [880] = 592,
  [881] = 752,
  [882] = 582,
  [883] = 746,
  [884] = 574,
  [885] = 754,
  [886] = 571,
  [887] = 572,
  [888] = 747,
  [889] = 590,
  [890] = 589,
  [891] = 751,
  [892] = 750,
  [893] = 584,
  [894] = 737,
  [895] = 588,
  [896] = 774,
  [897] = 775,
  [898] = 761,
  [899] = 760,
  [900] = 701,
  [901] = 901,
  [902] = 902,
  [903] = 903,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 572,
  [914] = 574,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 918,
  [919] = 919,
  [920] = 920,
  [921] = 921,
  [922] = 922,
  [923] = 923,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 929,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 935,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 573,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 571,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 451,
  [967] = 440,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 992,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 989,
  [1001] = 987,
  [1002] = 969,
  [1003] = 984,
  [1004] = 983,
  [1005] = 982,
  [1006] = 980,
  [1007] = 979,
  [1008] = 978,
  [1009] = 990,
  [1010] = 977,
  [1011] = 995,
  [1012] = 988,
  [1013] = 976,
  [1014] = 973,
  [1015] = 974,
  [1016] = 975,
  [1017] = 970,
  [1018] = 997,
  [1019] = 994,
  [1020] = 981,
  [1021] = 972,
  [1022] = 985,
  [1023] = 993,
  [1024] = 971,
  [1025] = 998,
  [1026] = 996,
  [1027] = 968,
  [1028] = 991,
  [1029] = 1029,
  [1030] = 992,
  [1031] = 986,
  [1032] = 999,
  [1033] = 902,
  [1034] = 949,
  [1035] = 1035,
  [1036] = 999,
  [1037] = 959,
  [1038] = 925,
  [1039] = 950,
  [1040] = 988,
  [1041] = 916,
  [1042] = 946,
  [1043] = 929,
  [1044] = 927,
  [1045] = 969,
  [1046] = 945,
  [1047] = 944,
  [1048] = 951,
  [1049] = 942,
  [1050] = 952,
  [1051] = 926,
  [1052] = 995,
  [1053] = 930,
  [1054] = 931,
  [1055] = 981,
  [1056] = 924,
  [1057] = 911,
  [1058] = 918,
  [1059] = 1035,
  [1060] = 962,
  [1061] = 923,
  [1062] = 941,
  [1063] = 920,
  [1064] = 934,
  [1065] = 572,
  [1066] = 1066,
  [1067] = 954,
  [1068] = 904,
  [1069] = 940,
  [1070] = 932,
  [1071] = 933,
  [1072] = 943,
  [1073] = 935,
  [1074] = 936,
  [1075] = 937,
  [1076] = 938,
  [1077] = 907,
  [1078] = 928,
  [1079] = 909,
  [1080] = 986,
  [1081] = 919,
  [1082] = 998,
  [1083] = 996,
  [1084] = 985,
  [1085] = 571,
  [1086] = 1035,
  [1087] = 922,
  [1088] = 939,
  [1089] = 958,
  [1090] = 573,
  [1091] = 992,
  [1092] = 906,
  [1093] = 990,
  [1094] = 429,
  [1095] = 1066,
  [1096] = 574,
  [1097] = 948,
  [1098] = 915,
  [1099] = 1066,
  [1100] = 910,
  [1101] = 991,
  [1102] = 968,
  [1103] = 993,
  [1104] = 994,
  [1105] = 917,
  [1106] = 955,
  [1107] = 961,
  [1108] = 972,
  [1109] = 997,
  [1110] = 957,
  [1111] = 963,
  [1112] = 903,
  [1113] = 964,
  [1114] = 975,
  [1115] = 947,
  [1116] = 901,
  [1117] = 989,
  [1118] = 987,
  [1119] = 971,
  [1120] = 953,
  [1121] = 965,
  [1122] = 428,
  [1123] = 973,
  [1124] = 976,
  [1125] = 977,
  [1126] = 970,
  [1127] = 984,
  [1128] = 978,
  [1129] = 979,
  [1130] = 912,
  [1131] = 908,
  [1132] = 905,
  [1133] = 974,
  [1134] = 980,
  [1135] = 983,
  [1136] = 982,
  [1137] = 986,
  [1138] = 994,
  [1139] = 1139,
  [1140] = 979,
  [1141] = 1141,
  [1142] = 980,
  [1143] = 976,
  [1144] = 982,
  [1145] = 1145,
  [1146] = 975,
  [1147] = 973,
  [1148] = 977,
  [1149] = 991,
  [1150] = 969,
  [1151] = 983,
  [1152] = 999,
  [1153] = 981,
  [1154] = 995,
  [1155] = 972,
  [1156] = 971,
  [1157] = 985,
  [1158] = 968,
  [1159] = 984,
  [1160] = 978,
  [1161] = 1161,
  [1162] = 988,
  [1163] = 974,
  [1164] = 998,
  [1165] = 996,
  [1166] = 992,
  [1167] = 990,
  [1168] = 970,
  [1169] = 997,
  [1170] = 989,
  [1171] = 987,
  [1172] = 993,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 997,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 997,
  [1182] = 1182,
  [1183] = 1183,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1175,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1175,
  [1198] = 1198,
  [1199] = 1193,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1187,
  [1203] = 1193,
  [1204] = 1204,
  [1205] = 1192,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1193,
  [1213] = 1173,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1208,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1192,
  [1221] = 1221,
  [1222] = 1192,
  [1223] = 1173,
  [1224] = 1187,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1209,
  [1228] = 1187,
  [1229] = 1229,
  [1230] = 1211,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1216,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1236,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1235,
  [1242] = 1235,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1240,
  [1249] = 1244,
  [1250] = 1246,
  [1251] = 1235,
  [1252] = 1243,
  [1253] = 1237,
  [1254] = 1254,
  [1255] = 1237,
  [1256] = 1245,
  [1257] = 1243,
  [1258] = 1245,
  [1259] = 1245,
  [1260] = 1243,
  [1261] = 1240,
  [1262] = 1262,
  [1263] = 1236,
  [1264] = 1243,
  [1265] = 1265,
  [1266] = 1245,
  [1267] = 1254,
  [1268] = 1236,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1236,
  [1272] = 1272,
  [1273] = 1243,
  [1274] = 1245,
  [1275] = 1243,
  [1276] = 1245,
  [1277] = 1237,
  [1278] = 1247,
  [1279] = 1237,
  [1280] = 1254,
  [1281] = 1239,
  [1282] = 1243,
  [1283] = 1245,
  [1284] = 1236,
  [1285] = 1243,
  [1286] = 1254,
  [1287] = 1247,
  [1288] = 1247,
  [1289] = 1247,
  [1290] = 1237,
  [1291] = 1236,
  [1292] = 1235,
  [1293] = 1245,
  [1294] = 1240,
  [1295] = 1235,
  [1296] = 1247,
  [1297] = 1239,
  [1298] = 1236,
  [1299] = 1237,
  [1300] = 1236,
  [1301] = 1245,
  [1302] = 1244,
  [1303] = 1243,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1306,
  [1309] = 1304,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1317,
  [1319] = 1319,
  [1320] = 1319,
  [1321] = 1317,
  [1322] = 1316,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1326,
  [1328] = 1326,
  [1329] = 1319,
  [1330] = 1330,
  [1331] = 1330,
  [1332] = 1330,
  [1333] = 1333,
  [1334] = 1333,
  [1335] = 1333,
  [1336] = 1307,
  [1337] = 1337,
  [1338] = 1337,
  [1339] = 1337,
  [1340] = 1312,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1314,
  [1345] = 1345,
  [1346] = 1315,
  [1347] = 1029,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1323,
  [1352] = 1352,
  [1353] = 1325,
  [1354] = 1324,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 428,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 429,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1386,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1379,
  [1394] = 1394,
  [1395] = 520,
  [1396] = 1396,
  [1397] = 1394,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 504,
  [1401] = 488,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1381,
  [1405] = 1405,
  [1406] = 556,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 459,
  [1410] = 1402,
  [1411] = 1391,
  [1412] = 541,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 528,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1416,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1417,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1425,
  [1427] = 1424,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1431,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 688,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1444,
  [1452] = 1437,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 586,
  [1456] = 645,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1458,
  [1461] = 1461,
  [1462] = 1312,
  [1463] = 1463,
  [1464] = 1457,
  [1465] = 1465,
  [1466] = 1461,
  [1467] = 1458,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1461,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1463,
  [1474] = 1474,
  [1475] = 1461,
  [1476] = 1463,
  [1477] = 1458,
  [1478] = 1478,
  [1479] = 1458,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 586,
  [1483] = 1457,
  [1484] = 1313,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1458,
  [1488] = 1488,
  [1489] = 1461,
  [1490] = 1463,
  [1491] = 1491,
  [1492] = 1463,
  [1493] = 1458,
  [1494] = 1458,
  [1495] = 1461,
  [1496] = 1458,
  [1497] = 1463,
  [1498] = 1463,
  [1499] = 1461,
  [1500] = 1463,
  [1501] = 1463,
  [1502] = 1461,
  [1503] = 1458,
  [1504] = 1461,
  [1505] = 1505,
  [1506] = 1307,
  [1507] = 1457,
  [1508] = 1463,
  [1509] = 1509,
  [1510] = 1458,
  [1511] = 1310,
  [1512] = 1463,
  [1513] = 1265,
  [1514] = 586,
  [1515] = 1515,
  [1516] = 1463,
  [1517] = 1461,
  [1518] = 1463,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1457,
  [1522] = 1522,
  [1523] = 1461,
  [1524] = 422,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1526,
  [1530] = 423,
  [1531] = 1441,
  [1532] = 1420,
  [1533] = 1527,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1535,
  [1537] = 1534,
  [1538] = 1538,
  [1539] = 1384,
  [1540] = 1540,
  [1541] = 1538,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 657,
  [1547] = 800,
  [1548] = 587,
  [1549] = 585,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 657,
  [1553] = 575,
  [1554] = 586,
  [1555] = 1555,
  [1556] = 656,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1542,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1542,
  [1563] = 657,
  [1564] = 1542,
  [1565] = 575,
  [1566] = 656,
  [1567] = 1538,
  [1568] = 1542,
  [1569] = 1542,
  [1570] = 1420,
  [1571] = 1571,
  [1572] = 1544,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1544,
  [1577] = 1544,
  [1578] = 1544,
  [1579] = 1579,
  [1580] = 656,
  [1581] = 1581,
  [1582] = 1581,
  [1583] = 587,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 424,
  [1591] = 1591,
  [1592] = 1586,
  [1593] = 1588,
  [1594] = 585,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 587,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1585,
  [1602] = 585,
  [1603] = 1555,
  [1604] = 1557,
  [1605] = 1560,
  [1606] = 1606,
  [1607] = 1550,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1560,
  [1612] = 1612,
  [1613] = 1589,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 426,
  [1617] = 426,
  [1618] = 1550,
  [1619] = 1619,
  [1620] = 1596,
  [1621] = 424,
  [1622] = 1608,
  [1623] = 1599,
  [1624] = 1555,
  [1625] = 1557,
  [1626] = 1626,
  [1627] = 1614,
  [1628] = 1584,
  [1629] = 1619,
  [1630] = 1630,
  [1631] = 1615,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 1632,
  [1635] = 1591,
  [1636] = 1609,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1630,
  [1640] = 586,
  [1641] = 1641,
  [1642] = 1586,
  [1643] = 1606,
  [1644] = 1644,
  [1645] = 586,
  [1646] = 1644,
  [1647] = 1638,
  [1648] = 1608,
  [1649] = 1649,
  [1650] = 1626,
  [1651] = 1651,
  [1652] = 1633,
  [1653] = 1595,
  [1654] = 1654,
  [1655] = 1587,
  [1656] = 1637,
  [1657] = 1657,
  [1658] = 450,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1442,
  [1663] = 1478,
  [1664] = 1664,
  [1665] = 1486,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1439,
  [1669] = 1669,
  [1670] = 1481,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1468,
  [1675] = 438,
  [1676] = 1664,
  [1677] = 1677,
  [1678] = 1664,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 437,
  [1682] = 1664,
  [1683] = 431,
  [1684] = 1667,
  [1685] = 1486,
  [1686] = 1686,
  [1687] = 1478,
  [1688] = 1688,
  [1689] = 453,
  [1690] = 1660,
  [1691] = 1680,
  [1692] = 434,
  [1693] = 1673,
  [1694] = 1671,
  [1695] = 430,
  [1696] = 1696,
  [1697] = 452,
  [1698] = 448,
  [1699] = 435,
  [1700] = 1651,
  [1701] = 1671,
  [1702] = 1664,
  [1703] = 1671,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 1664,
  [1707] = 1664,
  [1708] = 1708,
  [1709] = 1664,
  [1710] = 1664,
  [1711] = 1711,
  [1712] = 1664,
  [1713] = 1664,
  [1714] = 432,
  [1715] = 433,
  [1716] = 1716,
  [1717] = 1666,
  [1718] = 439,
  [1719] = 446,
  [1720] = 1671,
  [1721] = 1721,
  [1722] = 442,
  [1723] = 1474,
  [1724] = 1474,
  [1725] = 443,
  [1726] = 1726,
  [1727] = 1520,
  [1728] = 1433,
  [1729] = 1671,
  [1730] = 1671,
  [1731] = 441,
  [1732] = 1671,
  [1733] = 1733,
  [1734] = 1436,
  [1735] = 1468,
  [1736] = 1664,
  [1737] = 1669,
  [1738] = 1671,
  [1739] = 1739,
  [1740] = 1671,
  [1741] = 1741,
  [1742] = 449,
  [1743] = 447,
  [1744] = 444,
  [1745] = 1657,
  [1746] = 1696,
  [1747] = 445,
  [1748] = 1481,
  [1749] = 436,
  [1750] = 1520,
  [1751] = 1423,
  [1752] = 1671,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1446,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1758,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1775,
  [1778] = 1772,
  [1779] = 1439,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1759,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1786,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1442,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1449,
  [1802] = 1447,
  [1803] = 1756,
  [1804] = 1804,
  [1805] = 1796,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 639,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1771,
  [1815] = 1812,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1796,
  [1821] = 1798,
  [1822] = 1792,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 1813,
  [1826] = 1807,
  [1827] = 1827,
  [1828] = 1800,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1788,
  [1832] = 1782,
  [1833] = 1833,
  [1834] = 1757,
  [1835] = 1781,
  [1836] = 1758,
  [1837] = 1837,
  [1838] = 1780,
  [1839] = 1775,
  [1840] = 1761,
  [1841] = 1841,
  [1842] = 1765,
  [1843] = 1767,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1705,
  [1847] = 1847,
  [1848] = 1768,
  [1849] = 1849,
  [1850] = 1810,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1797,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1775,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1856,
  [1863] = 1773,
  [1864] = 1864,
  [1865] = 1784,
  [1866] = 1787,
  [1867] = 1857,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 1829,
  [1872] = 1754,
  [1873] = 1873,
  [1874] = 1868,
  [1875] = 1764,
  [1876] = 1763,
  [1877] = 1762,
  [1878] = 1827,
  [1879] = 1760,
  [1880] = 1880,
  [1881] = 1784,
  [1882] = 1861,
  [1883] = 1824,
  [1884] = 1884,
  [1885] = 1753,
  [1886] = 1886,
  [1887] = 1754,
  [1888] = 1787,
  [1889] = 1889,
  [1890] = 1837,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1789,
  [1894] = 1445,
  [1895] = 1895,
  [1896] = 1873,
  [1897] = 1897,
  [1898] = 1898,
  [1899] = 1443,
  [1900] = 1791,
  [1901] = 1783,
  [1902] = 1886,
  [1903] = 1903,
  [1904] = 1851,
  [1905] = 1905,
  [1906] = 1906,
  [1907] = 1852,
  [1908] = 1830,
  [1909] = 1812,
  [1910] = 1798,
  [1911] = 1782,
  [1912] = 1912,
  [1913] = 1913,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1924,
  [1925] = 1925,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1918,
  [1934] = 1929,
  [1935] = 1935,
  [1936] = 1936,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1939,
  [1940] = 1940,
  [1941] = 1937,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1716,
  [1945] = 1945,
  [1946] = 1946,
  [1947] = 1923,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1950,
  [1951] = 1931,
  [1952] = 1952,
  [1953] = 1930,
  [1954] = 1917,
  [1955] = 1927,
  [1956] = 1924,
  [1957] = 1957,
  [1958] = 1919,
  [1959] = 1959,
  [1960] = 1916,
  [1961] = 1961,
  [1962] = 1962,
  [1963] = 1963,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1967,
  [1968] = 1968,
  [1969] = 1969,
  [1970] = 1970,
  [1971] = 1971,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1932,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 546,
  [1979] = 1979,
  [1980] = 479,
  [1981] = 1981,
  [1982] = 462,
  [1983] = 1677,
  [1984] = 485,
  [1985] = 1985,
  [1986] = 1986,
  [1987] = 480,
  [1988] = 1942,
  [1989] = 1989,
  [1990] = 1990,
  [1991] = 455,
  [1992] = 1950,
  [1993] = 512,
  [1994] = 1994,
  [1995] = 1995,
  [1996] = 511,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 540,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 526,
  [2005] = 1922,
  [2006] = 503,
  [2007] = 2007,
  [2008] = 521,
  [2009] = 473,
  [2010] = 522,
  [2011] = 1963,
  [2012] = 494,
  [2013] = 1964,
  [2014] = 470,
  [2015] = 1966,
  [2016] = 472,
  [2017] = 2017,
  [2018] = 474,
  [2019] = 2019,
  [2020] = 476,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 499,
  [2026] = 529,
  [2027] = 2027,
  [2028] = 533,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 477,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 481,
  [2040] = 2040,
  [2041] = 2022,
  [2042] = 2042,
  [2043] = 2038,
  [2044] = 493,
  [2045] = 1989,
  [2046] = 1997,
  [2047] = 1970,
  [2048] = 559,
  [2049] = 1969,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 557,
  [2054] = 508,
  [2055] = 551,
  [2056] = 542,
  [2057] = 536,
  [2058] = 535,
  [2059] = 528,
  [2060] = 525,
  [2061] = 518,
  [2062] = 501,
  [2063] = 458,
  [2064] = 468,
  [2065] = 469,
  [2066] = 496,
  [2067] = 538,
  [2068] = 532,
  [2069] = 463,
  [2070] = 464,
  [2071] = 465,
  [2072] = 547,
  [2073] = 553,
  [2074] = 505,
  [2075] = 504,
  [2076] = 488,
  [2077] = 2077,
  [2078] = 475,
  [2079] = 534,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 498,
  [2083] = 497,
  [2084] = 495,
  [2085] = 460,
  [2086] = 1939,
  [2087] = 457,
  [2088] = 555,
  [2089] = 489,
  [2090] = 492,
  [2091] = 531,
  [2092] = 490,
  [2093] = 466,
  [2094] = 459,
  [2095] = 2095,
  [2096] = 506,
  [2097] = 537,
  [2098] = 544,
  [2099] = 2099,
  [2100] = 554,
  [2101] = 2101,
  [2102] = 1916,
  [2103] = 552,
  [2104] = 1915,
  [2105] = 491,
  [2106] = 502,
  [2107] = 523,
  [2108] = 524,
  [2109] = 541,
  [2110] = 2110,
  [2111] = 556,
  [2112] = 1966,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 517,
  [2117] = 513,
  [2118] = 509,
  [2119] = 456,
  [2120] = 530,
  [2121] = 519,
  [2122] = 483,
  [2123] = 484,
  [2124] = 486,
  [2125] = 487,
  [2126] = 500,
  [2127] = 510,
  [2128] = 514,
  [2129] = 515,
  [2130] = 520,
  [2131] = 543,
  [2132] = 549,
  [2133] = 550,
  [2134] = 1914,
  [2135] = 558,
  [2136] = 454,
  [2137] = 467,
  [2138] = 461,
  [2139] = 2139,
  [2140] = 560,
  [2141] = 478,
  [2142] = 545,
  [2143] = 1485,
  [2144] = 471,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 1916,
  [2148] = 548,
  [2149] = 1307,
  [2150] = 482,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 1966,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 1898,
  [2159] = 2159,
  [2160] = 1966,
  [2161] = 1916,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 1966,
  [2167] = 2167,
  [2168] = 1916,
  [2169] = 2169,
  [2170] = 1916,
  [2171] = 2171,
  [2172] = 1966,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2176,
  [2177] = 1916,
  [2178] = 1966,
  [2179] = 2179,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2182,
  [2183] = 2183,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2213,
  [2214] = 2214,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2221,
  [2222] = 2197,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2193,
  [2228] = 2228,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 1667,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 1971,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2189,
  [2259] = 2259,
  [2260] = 2204,
  [2261] = 2206,
  [2262] = 2208,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2193,
  [2277] = 1673,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2188,
  [2286] = 2182,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2196,
  [2293] = 2293,
  [2294] = 2265,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2284,
  [2300] = 2300,
  [2301] = 2204,
  [2302] = 2302,
  [2303] = 2289,
  [2304] = 2271,
  [2305] = 2240,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2237,
  [2310] = 2310,
  [2311] = 2235,
  [2312] = 2232,
  [2313] = 2231,
  [2314] = 2259,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2290,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2219,
  [2321] = 2236,
  [2322] = 2256,
  [2323] = 2252,
  [2324] = 2324,
  [2325] = 2251,
  [2326] = 2218,
  [2327] = 2327,
  [2328] = 2210,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2209,
  [2332] = 2316,
  [2333] = 2333,
  [2334] = 2201,
  [2335] = 2194,
  [2336] = 2336,
  [2337] = 2297,
  [2338] = 2211,
  [2339] = 2339,
  [2340] = 2195,
  [2341] = 2236,
  [2342] = 2342,
  [2343] = 2198,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2199,
  [2347] = 2347,
  [2348] = 2250,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2200,
  [2352] = 2202,
  [2353] = 2353,
  [2354] = 2244,
  [2355] = 2288,
  [2356] = 2344,
  [2357] = 2357,
  [2358] = 2203,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2242,
  [2365] = 2365,
  [2366] = 2217,
  [2367] = 2216,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2226,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2229,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2266,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2267,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2330,
  [2384] = 2384,
  [2385] = 2329,
  [2386] = 2386,
  [2387] = 2270,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2272,
  [2391] = 2391,
  [2392] = 2273,
  [2393] = 2274,
  [2394] = 2253,
  [2395] = 2225,
  [2396] = 2388,
  [2397] = 2275,
  [2398] = 2398,
  [2399] = 2278,
  [2400] = 2279,
  [2401] = 2401,
  [2402] = 2181,
  [2403] = 2291,
  [2404] = 2306,
  [2405] = 2307,
  [2406] = 2308,
  [2407] = 2407,
  [2408] = 2315,
  [2409] = 2345,
  [2410] = 2339,
  [2411] = 2224,
  [2412] = 2412,
  [2413] = 2264,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2213,
  [2417] = 2417,
  [2418] = 2333,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2327,
  [2422] = 2324,
  [2423] = 2204,
  [2424] = 2310,
  [2425] = 2302,
  [2426] = 2193,
  [2427] = 2236,
  [2428] = 2428,
  [2429] = 2384,
  [2430] = 2382,
  [2431] = 2336,
  [2432] = 2300,
  [2433] = 2269,
  [2434] = 2434,
  [2435] = 2319,
  [2436] = 2381,
  [2437] = 2296,
  [2438] = 2349,
  [2439] = 2375,
  [2440] = 2372,
  [2441] = 2283,
  [2442] = 2113,
  [2443] = 2268,
  [2444] = 2374,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2114,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2461,
  [2462] = 2462,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 2465,
  [2466] = 2456,
  [2467] = 2455,
  [2468] = 2453,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2451,
  [2478] = 2478,
  [2479] = 2474,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2473,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2459,
  [2492] = 2095,
  [2493] = 2457,
  [2494] = 2494,
  [2495] = 2450,
  [2496] = 2496,
  [2497] = 2454,
  [2498] = 2462,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2452,
  [2505] = 2505,
  [2506] = 2482,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2461,
  [2513] = 2513,
  [2514] = 2452,
  [2515] = 2515,
  [2516] = 2454,
  [2517] = 2517,
  [2518] = 2496,
  [2519] = 2519,
  [2520] = 2456,
  [2521] = 2455,
  [2522] = 2453,
  [2523] = 2451,
  [2524] = 2476,
  [2525] = 2481,
  [2526] = 2526,
  [2527] = 2487,
  [2528] = 2488,
  [2529] = 2446,
  [2530] = 2502,
  [2531] = 2502,
  [2532] = 2460,
  [2533] = 2453,
  [2534] = 2465,
  [2535] = 2505,
  [2536] = 2536,
  [2537] = 2536,
  [2538] = 2502,
  [2539] = 2508,
  [2540] = 2540,
  [2541] = 2502,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2501,
  [2545] = 2451,
  [2546] = 2490,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2551,
  [2552] = 2548,
  [2553] = 2551,
  [2554] = 2554,
  [2555] = 2555,
  [2556] = 2508,
  [2557] = 2557,
  [2558] = 2558,
  [2559] = 2554,
  [2560] = 2560,
  [2561] = 2561,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2519,
  [2569] = 2569,
  [2570] = 2566,
  [2571] = 2560,
  [2572] = 2445,
  [2573] = 2453,
  [2574] = 2473,
  [2575] = 2550,
  [2576] = 2540,
  [2577] = 2499,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 2508,
  [2581] = 2581,
  [2582] = 2582,
  [2583] = 2583,
  [2584] = 2475,
  [2585] = 2470,
  [2586] = 2561,
  [2587] = 2587,
  [2588] = 2453,
  [2589] = 2458,
  [2590] = 2569,
  [2591] = 2486,
  [2592] = 2453,
  [2593] = 2511,
  [2594] = 2452,
  [2595] = 2451,
  [2596] = 2515,
  [2597] = 2454,
  [2598] = 2598,
  [2599] = 2453,
  [2600] = 2457,
  [2601] = 2601,
  [2602] = 2459,
  [2603] = 2486,
  [2604] = 2604,
  [2605] = 2494,
  [2606] = 2606,
  [2607] = 2607,
  [2608] = 2457,
  [2609] = 2565,
  [2610] = 2453,
  [2611] = 2490,
  [2612] = 2453,
  [2613] = 2469,
  [2614] = 2564,
  [2615] = 2615,
  [2616] = 2453,
  [2617] = 2617,
  [2618] = 2458,
  [2619] = 2455,
  [2620] = 2456,
  [2621] = 2486,
  [2622] = 2515,
  [2623] = 2564,
  [2624] = 2624,
  [2625] = 2563,
  [2626] = 2486,
  [2627] = 2627,
  [2628] = 2460,
  [2629] = 2629,
  [2630] = 2459,
  [2631] = 2631,
  [2632] = 2453,
  [2633] = 2484,
  [2634] = 2634,
  [2635] = 2635,
  [2636] = 2557,
  [2637] = 2489,
  [2638] = 2638,
  [2639] = 2639,
  [2640] = 2486,
  [2641] = 2519,
  [2642] = 2507,
  [2643] = 2643,
  [2644] = 2503,
  [2645] = 2578,
  [2646] = 2458,
  [2647] = 2453,
  [2648] = 2635,
  [2649] = 2515,
  [2650] = 2635,
  [2651] = 2634,
  [2652] = 2503,
  [2653] = 2579,
  [2654] = 2635,
  [2655] = 2639,
  [2656] = 2581,
  [2657] = 2582,
  [2658] = 2583,
  [2659] = 2503,
  [2660] = 2587,
  [2661] = 2639,
  [2662] = 2486,
  [2663] = 2639,
  [2664] = 2638,
  [2665] = 2486,
  [2666] = 2638,
  [2667] = 2638,
};

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < 'e'
    ? (c < '\\'
      ? (c < '$'
        ? c == '"'
        : c <= '$')
      : (c <= '\\' || c == '`'))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static inline bool sym_name_character_set_1(int32_t c) {
  return (c < 161
    ? (c < '_'
      ? (c < 'A'
        ? (c >= '0' && c <= '9')
        : c <= 'Z')
      : (c <= '_' || (c < 128
        ? (c >= 'a' && c <= 'z')
        : c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static inline bool sym_name_character_set_2(int32_t c) {
  return (c < 161
    ? (c < 'a'
      ? (c < '_'
        ? (c >= 'A' && c <= 'Z')
        : c <= '_')
      : (c <= 'z' || (c >= 128 && c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static inline bool sym_name_character_set_3(int32_t c) {
  return (c < 161
    ? (c < '_'
      ? (c < 'B'
        ? (c >= '0' && c <= '9')
        : c <= 'Z')
      : (c <= '_' || (c < 128
        ? (c >= 'b' && c <= 'z')
        : c <= 159)))
    : (c <= 8202 || (c < 57344
      ? (c < 8289
        ? (c >= 8204 && c <= 8287)
        : c <= 55295)
      : (c <= 65278 || (c >= 65280 && c <= 65535)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(128);
      if (lookahead == '"') ADVANCE(176);
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(179);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(212);
      if (lookahead == '+') ADVANCE(120);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(210);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(110);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(195);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(199);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '@') ADVANCE(129);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(189);
      if (lookahead == '_') ADVANCE(257);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(98);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == '~') ADVANCE(126);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(218);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(222);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(240);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(255);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(248);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(244);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(238);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(67)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(260);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(260);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(261);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(177);
      if (lookahead == '\r') ADVANCE(177);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '{') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(177);
      if (lookahead == '\r') ADVANCE(177);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(39);
      if (lookahead == '{') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(128);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(216);
      if (lookahead == '&') ADVANCE(76);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(213);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(210);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == '0') ADVANCE(110);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(196);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(200);
      if (lookahead == '?') ADVANCE(96);
      if (lookahead == '@') ADVANCE(129);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(188);
      if (lookahead == '_') ADVANCE(257);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == '~') ADVANCE(126);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(219);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(223);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(255);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(5)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(127);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(75);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(106);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(110);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '@') ADVANCE(129);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '_') ADVANCE(257);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '~') ADVANCE(126);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(219);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(223);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(255);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(127);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(110);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '@') ADVANCE(129);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == '_') ADVANCE(257);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '~') ADVANCE(126);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(218);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(222);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(240);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(255);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(248);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(244);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(238);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(216);
      if (lookahead == '&') ADVANCE(76);
      if (lookahead == '\'') ADVANCE(179);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(213);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(125);
      if (lookahead == '.') ADVANCE(209);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(198);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(200);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(188);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('A' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(216);
      if (lookahead == '&') ADVANCE(76);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(213);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(125);
      if (lookahead == '.') ADVANCE(209);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(198);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(200);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(39);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(188);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('A' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(216);
      if (lookahead == '&') ADVANCE(76);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(213);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(125);
      if (lookahead == '.') ADVANCE(209);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == '0') ADVANCE(115);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(198);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(200);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(188);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(85);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(216);
      if (lookahead == '&') ADVANCE(76);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(213);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(209);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(198);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(200);
      if (lookahead == '?') ADVANCE(96);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(188);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(85);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '%') ADVANCE(216);
      if (lookahead == '&') ADVANCE(76);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(213);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(124);
      if (lookahead == '.') ADVANCE(209);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(198);
      if (lookahead == '=') ADVANCE(34);
      if (lookahead == '>') ADVANCE(200);
      if (lookahead == '?') ADVANCE(95);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(188);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(99);
      if (lookahead == '}') ADVANCE(85);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(176);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(75);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == '?') ADVANCE(92);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(163);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(219);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(75);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(115);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(219);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(110);
      if (lookahead == '<') ADVANCE(30);
      if (lookahead == '_') ADVANCE(60);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(14);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(43);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(53);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(50);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(75);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '?') ADVANCE(92);
      if (lookahead == '\\') ADVANCE(82);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(18)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 19:
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 20:
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(75);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == '?') ADVANCE(92);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(75);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '?') ADVANCE(92);
      if (lookahead == '\\') ADVANCE(82);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(173);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead == '\\') ADVANCE(41);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(168);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(261);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(260);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(25);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(29);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '_') ADVANCE(60);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(91);
      END_STATE();
    case 30:
      if (lookahead == '<') ADVANCE(32);
      END_STATE();
    case 31:
      if (lookahead == '<') ADVANCE(32);
      if (lookahead == '?') ADVANCE(73);
      END_STATE();
    case 32:
      if (lookahead == '<') ADVANCE(175);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 34:
      if (lookahead == '=') ADVANCE(190);
      if (lookahead == '>') ADVANCE(88);
      END_STATE();
    case 35:
      if (lookahead == '>') ADVANCE(146);
      END_STATE();
    case 36:
      if (lookahead == '>') ADVANCE(88);
      END_STATE();
    case 37:
      if (lookahead == '>') ADVANCE(71);
      END_STATE();
    case 38:
      if (lookahead == '>') ADVANCE(147);
      END_STATE();
    case 39:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(165);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 42:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 43:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(46);
      END_STATE();
    case 44:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 45:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(49);
      END_STATE();
    case 46:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(51);
      END_STATE();
    case 47:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 48:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(47);
      END_STATE();
    case 49:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(72);
      END_STATE();
    case 50:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(52);
      END_STATE();
    case 51:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(44);
      END_STATE();
    case 52:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(44);
      END_STATE();
    case 53:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 54:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(113);
      END_STATE();
    case 55:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(111);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(116);
      END_STATE();
    case 57:
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(155);
      if (lookahead == 'u') ADVANCE(160);
      if (lookahead == 'x') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(157);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(112);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(28);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(117);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(114);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(158);
      END_STATE();
    case 65:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 66:
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 67:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(128);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(212);
      if (lookahead == '+') ADVANCE(120);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(210);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(110);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(195);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(199);
      if (lookahead == '?') ADVANCE(93);
      if (lookahead == '@') ADVANCE(129);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(189);
      if (lookahead == '_') ADVANCE(257);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(98);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == '~') ADVANCE(126);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(218);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(222);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(240);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(255);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(248);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(244);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(238);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(67)
      if (('C' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 68:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(127);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(263);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '&') ADVANCE(75);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(110);
      if (lookahead == ':') ADVANCE(86);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(31);
      if (lookahead == '=') ADVANCE(36);
      if (lookahead == '?') ADVANCE(37);
      if (lookahead == '@') ADVANCE(129);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '_') ADVANCE(257);
      if (lookahead == '`') ADVANCE(180);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '}') ADVANCE(85);
      if (lookahead == '~') ADVANCE(126);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(219);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(221);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(223);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(255);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(253);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(112);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(68)
      if (('C' <= lookahead && lookahead <= 'Z') ||
          ('c' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 69:
      if (eof) ADVANCE(70);
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '"') ADVANCE(162);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '$') ADVANCE(181);
      if (lookahead == '%') ADVANCE(217);
      if (lookahead == '&') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(164);
      if (lookahead == '(') ADVANCE(89);
      if (lookahead == ')') ADVANCE(90);
      if (lookahead == '*') ADVANCE(212);
      if (lookahead == '+') ADVANCE(120);
      if (lookahead == ',') ADVANCE(79);
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(211);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '0') ADVANCE(115);
      if (lookahead == ':') ADVANCE(87);
      if (lookahead == ';') ADVANCE(74);
      if (lookahead == '<') ADVANCE(197);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(199);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '[') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(82);
      if (lookahead == ']') ADVANCE(149);
      if (lookahead == '^') ADVANCE(189);
      if (lookahead == '{') ADVANCE(84);
      if (lookahead == '|') ADVANCE(98);
      if (lookahead == '}') ADVANCE(85);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(69)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_php_tag);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_php_tag);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(45);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(187);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(187);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_function_static_declaration_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(190);
      if (lookahead == '>') ADVANCE(88);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(88);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(165);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(130);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(38);
      if (lookahead == '>') ADVANCE(71);
      if (lookahead == '?') ADVANCE(183);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(38);
      if (lookahead == '?') ADVANCE(183);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '-') ADVANCE(38);
      if (lookahead == '?') ADVANCE(182);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(182);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(144);
      if (lookahead == '|') ADVANCE(186);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(186);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym_cast_type_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_cast_type_token3);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(aux_sym_cast_type_token6);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(aux_sym_cast_type_token8);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_cast_type_token11);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(aux_sym_cast_type_token12);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '_') ADVANCE(59);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(59);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(258);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(108);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 159) ||
          (161 <= lookahead && lookahead <= 8202) ||
          (8204 <= lookahead && lookahead <= 8287) ||
          (8289 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65278) ||
          (65280 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(116);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(63);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '_') ADVANCE(58);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(112);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(113);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(114);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(56);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(54);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(116);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(132);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(132);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(131);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(146);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '>') ADVANCE(146);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(146);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(191);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_QMARK_DASH_GT);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym__argument_name_token1);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym__argument_name_token1);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym__argument_name_token2);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__argument_name_token2);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACK);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(155);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(156);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(155);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      if (lookahead == '{') ADVANCE(65);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_encapsed_string_token1);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\n') ADVANCE(174);
      if (lookahead == '\r') ADVANCE(167);
      if (lookahead == '>') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(262);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(172);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\n') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(174);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '#') ADVANCE(173);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead == '\\') ADVANCE(41);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(174);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(174);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '/') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(171);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '*') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '?') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(262);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\\') ADVANCE(262);
      if (lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == '?' ||
          lookahead == '[') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(172);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_string_value);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_DQUOTE2);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym__new_line);
      if (lookahead == '\n') ADVANCE(177);
      if (lookahead == '\r') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_SQUOTE2);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(193);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(194);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(201);
      if (lookahead == '>') ADVANCE(192);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '=') ADVANCE(201);
      if (lookahead == '>') ADVANCE(192);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(201);
      if (lookahead == '>') ADVANCE(192);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(202);
      if (lookahead == '>') ADVANCE(208);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(202);
      if (lookahead == '>') ADVANCE(207);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(203);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '<') ADVANCE(175);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '_') ADVANCE(59);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(185);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(184);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(261);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(261);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(242);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '\'') ADVANCE(163);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '.') ADVANCE(107);
      if (lookahead == '_') ADVANCE(257);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(220);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (128 <= lookahead && lookahead <= 159) ||
          (161 <= lookahead && lookahead <= 8202) ||
          (8204 <= lookahead && lookahead <= 8287) ||
          (8289 <= lookahead && lookahead <= 55295) ||
          (57344 <= lookahead && lookahead <= 65278) ||
          (65280 <= lookahead && lookahead <= 65535)) ADVANCE(259);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(108);
      if (sym_name_character_set_2(lookahead)) ADVANCE(259);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(237);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(241);
      if (sym_name_character_set_3(lookahead)) ADVANCE(259);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(237);
      if (sym_name_character_set_3(lookahead)) ADVANCE(259);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(256);
      if (sym_name_character_set_3(lookahead)) ADVANCE(259);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(252);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(233);
      if (sym_name_character_set_3(lookahead)) ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(252);
      if (sym_name_character_set_3(lookahead)) ADVANCE(259);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(250);
      if (sym_name_character_set_3(lookahead)) ADVANCE(259);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(78);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(153);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(251);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(104);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(228);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(239);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(101);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(151);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(235);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(246);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(247);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(231);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(249);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(227);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(234);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(224);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(254);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(243);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(229);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(230);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(225);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(102);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(103);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(105);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(232);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(226);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(229);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(236);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(100);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(220);
      if (sym_name_character_set_2(lookahead)) ADVANCE(259);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(108);
      if (sym_name_character_set_2(lookahead)) ADVANCE(259);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_name);
      if (sym_name_character_set_1(lookahead)) ADVANCE(259);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(261);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(166);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(174);
      if (lookahead == '\'' ||
          lookahead == '\\') ADVANCE(261);
      if (lookahead != 0) ADVANCE(172);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '[') ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '?') ADVANCE(261);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '?' &&
          lookahead != '[') ADVANCE(261);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'B') ADVANCE(2);
      if (lookahead == 'E') ADVANCE(3);
      if (lookahead == 'F') ADVANCE(4);
      if (lookahead == 'I') ADVANCE(5);
      if (lookahead == 'M') ADVANCE(6);
      if (lookahead == 'N') ADVANCE(7);
      if (lookahead == 'P') ADVANCE(8);
      if (lookahead == 'S') ADVANCE(9);
      if (lookahead == 'T') ADVANCE(10);
      if (lookahead == 'U') ADVANCE(11);
      if (lookahead == 'V') ADVANCE(12);
      if (lookahead == 'a') ADVANCE(13);
      if (lookahead == 'b') ADVANCE(14);
      if (lookahead == 'e') ADVANCE(15);
      if (lookahead == 'f') ADVANCE(16);
      if (lookahead == 'i') ADVANCE(17);
      if (lookahead == 'm') ADVANCE(18);
      if (lookahead == 'n') ADVANCE(19);
      if (lookahead == 'p') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(25);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(26);
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(28);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(29);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(30);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(31);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(32);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(33);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(34);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(35);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(36);
      END_STATE();
    case 2:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(37);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(38);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 3:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(41);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(42);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(43);
      END_STATE();
    case 4:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(44);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(47);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 5:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(50);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 6:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 7:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 8:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(55);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 9:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 10:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(58);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(59);
      END_STATE();
    case 11:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(60);
      END_STATE();
    case 12:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 13:
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(34);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(35);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(36);
      END_STATE();
    case 14:
      if (lookahead == 'O') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(63);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(37);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(39);
      END_STATE();
    case 15:
      if (lookahead == 'N') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(64);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(40);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(41);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(43);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'l') ADVANCE(66);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(44);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(46);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(47);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 17:
      if (lookahead == 'N') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(67);
      if (lookahead == 't') ADVANCE(68);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(49);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(50);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(69);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 19:
      if (lookahead == 'E') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(70);
      if (lookahead == 'u') ADVANCE(71);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(72);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(55);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(56);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 22:
      if (lookahead == 'R') ADVANCE(59);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(58);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(77);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(60);
      END_STATE();
    case 24:
      if (lookahead == 'o') ADVANCE(78);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 25:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(80);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 26:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(82);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 27:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(84);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(85);
      END_STATE();
    case 28:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 29:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(87);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 31:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(90);
      END_STATE();
    case 32:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(91);
      END_STATE();
    case 33:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 34:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(93);
      END_STATE();
    case 35:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(94);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(aux_sym_namespace_aliasing_clause_token1);
      END_STATE();
    case 37:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(95);
      END_STATE();
    case 38:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 39:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 40:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(98);
      END_STATE();
    case 41:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(99);
      END_STATE();
    case 42:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(100);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 43:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(102);
      END_STATE();
    case 44:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym__arrow_function_header_token1);
      END_STATE();
    case 46:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 47:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 48:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(106);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_if_statement_token1);
      END_STATE();
    case 50:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 51:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(108);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(109);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(110);
      END_STATE();
    case 52:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(111);
      END_STATE();
    case 53:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 54:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 55:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(114);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(115);
      END_STATE();
    case 56:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(116);
      END_STATE();
    case 57:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 58:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(118);
      END_STATE();
    case 59:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(119);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(120);
      END_STATE();
    case 60:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 61:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 63:
      if (lookahead == 'O') ADVANCE(96);
      if (lookahead == 'o') ADVANCE(124);
      END_STATE();
    case 64:
      if (lookahead == 'c') ADVANCE(125);
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(100);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(101);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(126);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 67:
      if (lookahead == 'T') ADVANCE(110);
      if (lookahead == 't') ADVANCE(128);
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(108);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(109);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 69:
      if (lookahead == 'x') ADVANCE(130);
      END_STATE();
    case 70:
      if (lookahead == 'v') ADVANCE(131);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(113);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 73:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(135);
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 75:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 76:
      if (lookahead == 'u') ADVANCE(138);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(119);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(120);
      END_STATE();
    case 77:
      if (lookahead == 's') ADVANCE(139);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(140);
      END_STATE();
    case 79:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(141);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(142);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(143);
      END_STATE();
    case 80:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(144);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(145);
      END_STATE();
    case 81:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(146);
      END_STATE();
    case 82:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(147);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym_do_statement_token1);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 84:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 85:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(151);
      END_STATE();
    case 86:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(152);
      END_STATE();
    case 87:
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(153);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_binary_expression_token3);
      END_STATE();
    case 89:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(154);
      if (lookahead == 'Q' ||
          lookahead == 'q') ADVANCE(155);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(156);
      END_STATE();
    case 90:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(157);
      END_STATE();
    case 91:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(158);
      END_STATE();
    case 92:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 93:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(160);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_binary_expression_token2);
      END_STATE();
    case 95:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 96:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 97:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 98:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 99:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 100:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(166);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(167);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(168);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(169);
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(170);
      END_STATE();
    case 101:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(171);
      END_STATE();
    case 102:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 103:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(173);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(aux_sym_for_statement_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(174);
      END_STATE();
    case 105:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(175);
      END_STATE();
    case 106:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(176);
      END_STATE();
    case 107:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 108:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(178);
      END_STATE();
    case 109:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(179);
      END_STATE();
    case 110:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 111:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(181);
      END_STATE();
    case 112:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(182);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(aux_sym_object_creation_expression_token1);
      END_STATE();
    case 114:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(183);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(184);
      END_STATE();
    case 115:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(185);
      END_STATE();
    case 116:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 117:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(187);
      END_STATE();
    case 118:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(188);
      END_STATE();
    case 119:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_try_statement_token1);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token1);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_var_modifier);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 124:
      if (lookahead == 'L') ADVANCE(162);
      if (lookahead == 'l') ADVANCE(191);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(192);
      END_STATE();
    case 126:
      if (lookahead == 's') ADVANCE(193);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 134:
      if (lookahead == 'f') ADVANCE(200);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 136:
      if (lookahead == 'i') ADVANCE(202);
      END_STATE();
    case 137:
      if (lookahead == 'k') ADVANCE(203);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 140:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 141:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 142:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 143:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(209);
      END_STATE();
    case 144:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(210);
      END_STATE();
    case 145:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 146:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(212);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(213);
      END_STATE();
    case 147:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 148:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 149:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(216);
      END_STATE();
    case 150:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(217);
      END_STATE();
    case 151:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 152:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(219);
      END_STATE();
    case 153:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 154:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(221);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(222);
      END_STATE();
    case 155:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(223);
      END_STATE();
    case 156:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(224);
      END_STATE();
    case 157:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_binary_expression_token4);
      END_STATE();
    case 159:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(226);
      END_STATE();
    case 160:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 161:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 162:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 163:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(230);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_echo_statement_token1);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_else_clause_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 166:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 167:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 168:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(234);
      END_STATE();
    case 169:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(235);
      END_STATE();
    case 170:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(236);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_enum_declaration_token1);
      END_STATE();
    case 172:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 173:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 174:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_yield_expression_token2);
      END_STATE();
    case 176:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(240);
      END_STATE();
    case 177:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 178:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(242);
      END_STATE();
    case 179:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(243);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 180:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(245);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 181:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(247);
      END_STATE();
    case 182:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(248);
      END_STATE();
    case 183:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(249);
      END_STATE();
    case 184:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 185:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 186:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(252);
      END_STATE();
    case 187:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 188:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(254);
      END_STATE();
    case 189:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(255);
      END_STATE();
    case 190:
      if (lookahead == 'y') ADVANCE(256);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_bool);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(229);
      END_STATE();
    case 192:
      if (lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(258);
      END_STATE();
    case 194:
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 195:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 196:
      if (lookahead == 'd') ADVANCE(261);
      END_STATE();
    case 197:
      if (lookahead == 'r') ADVANCE(262);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 199:
      if (lookahead == 'n') ADVANCE(263);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_self);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(264);
      END_STATE();
    case 202:
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 'n') ADVANCE(266);
      END_STATE();
    case 203:
      if (lookahead == 's') ADVANCE(267);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 207:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_enum_case_token1);
      END_STATE();
    case 209:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(270);
      END_STATE();
    case 210:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(271);
      END_STATE();
    case 211:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 212:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(273);
      END_STATE();
    case 213:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(274);
      END_STATE();
    case 214:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(275);
      END_STATE();
    case 215:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(276);
      END_STATE();
    case 216:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(277);
      END_STATE();
    case 217:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(278);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_goto_statement_token1);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym__list_destructing_token1);
      END_STATE();
    case 220:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(279);
      END_STATE();
    case 221:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(280);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_cast_type_token10);
      END_STATE();
    case 223:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 224:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(282);
      END_STATE();
    case 225:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 226:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(284);
      END_STATE();
    case 227:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(285);
      END_STATE();
    case 228:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(286);
      END_STATE();
    case 229:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(aux_sym_break_statement_token1);
      END_STATE();
    case 231:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(288);
      END_STATE();
    case 232:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(289);
      END_STATE();
    case 233:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym_if_statement_token2);
      END_STATE();
    case 235:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 236:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(292);
      END_STATE();
    case 237:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_final_modifier_token1);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(294);
      END_STATE();
    case 239:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(295);
      END_STATE();
    case 240:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(296);
      END_STATE();
    case 241:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(297);
      END_STATE();
    case 242:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(298);
      END_STATE();
    case 243:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(299);
      END_STATE();
    case 244:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(300);
      END_STATE();
    case 245:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(301);
      END_STATE();
    case 246:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(302);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(aux_sym_match_expression_token1);
      END_STATE();
    case 248:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(303);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_print_intrinsic_token1);
      END_STATE();
    case 250:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(304);
      END_STATE();
    case 251:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(305);
      END_STATE();
    case 252:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(306);
      END_STATE();
    case 253:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(307);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_throw_expression_token1);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_trait_declaration_token1);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_array);
      END_STATE();
    case 257:
      if (lookahead == 'i') ADVANCE(308);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 260:
      if (lookahead == 'b') ADVANCE(309);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_mixed);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_bottom_type);
      END_STATE();
    case 263:
      if (lookahead == 't') ADVANCE(310);
      END_STATE();
    case 264:
      if (lookahead == 'c') ADVANCE(311);
      END_STATE();
    case 265:
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 266:
      if (lookahead == 'g') ADVANCE(313);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_ticks);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_unset);
      END_STATE();
    case 269:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(314);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_catch_clause_token1);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_class_declaration_token1);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_clone_expression_token1);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token3);
      END_STATE();
    case 274:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(315);
      END_STATE();
    case 275:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(316);
      END_STATE();
    case 276:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(317);
      END_STATE();
    case 277:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 278:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(319);
      END_STATE();
    case 279:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(320);
      END_STATE();
    case 280:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(321);
      END_STATE();
    case 281:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(322);
      END_STATE();
    case 282:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(323);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_while_statement_token1);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_yield_expression_token1);
      END_STATE();
    case 285:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(324);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_cast_type_token2);
      END_STATE();
    case 287:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_else_if_clause_token1);
      END_STATE();
    case 289:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(326);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_for_statement_token2);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 291:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(328);
      END_STATE();
    case 292:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(329);
      END_STATE();
    case 293:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(330);
      END_STATE();
    case 294:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(331);
      END_STATE();
    case 295:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(332);
      END_STATE();
    case 296:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 297:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(334);
      END_STATE();
    case 298:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 299:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 300:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(337);
      END_STATE();
    case 301:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(338);
      END_STATE();
    case 302:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(339);
      END_STATE();
    case 303:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(340);
      END_STATE();
    case 304:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 305:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(342);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token1);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_switch_statement_token1);
      END_STATE();
    case 308:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 309:
      if (lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 312:
      if (lookahead == '_') ADVANCE(345);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 314:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(346);
      END_STATE();
    case 315:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(347);
      END_STATE();
    case 316:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(348);
      END_STATE();
    case 317:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(349);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_cast_type_token5);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_global_declaration_token1);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_cast_type_token9);
      END_STATE();
    case 321:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(350);
      END_STATE();
    case 322:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_return_statement_token1);
      END_STATE();
    case 324:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(352);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_cast_type_token4);
      END_STATE();
    case 326:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(353);
      END_STATE();
    case 327:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(354);
      END_STATE();
    case 328:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(355);
      END_STATE();
    case 329:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_base_clause_token1);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(aux_sym_finally_clause_token1);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_foreach_statement_token1);
      END_STATE();
    case 333:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(357);
      END_STATE();
    case 334:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(358);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(aux_sym_include_expression_token1);
      if (lookahead == '_') ADVANCE(359);
      END_STATE();
    case 336:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 337:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(361);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_cast_type_token7);
      END_STATE();
    case 339:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(362);
      END_STATE();
    case 340:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(363);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token3);
      END_STATE();
    case 342:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 343:
      if (lookahead == 'g') ADVANCE(365);
      END_STATE();
    case 344:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 345:
      if (lookahead == 't') ADVANCE(367);
      END_STATE();
    case 346:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 347:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(369);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_declare_statement_token1);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_match_default_expression_token1);
      END_STATE();
    case 350:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(370);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_require_expression_token1);
      if (lookahead == '_') ADVANCE(371);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_abstract_modifier_token1);
      END_STATE();
    case 353:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(372);
      END_STATE();
    case 354:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(373);
      END_STATE();
    case 355:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(374);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_while_statement_token2);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_namespace_use_declaration_token2);
      END_STATE();
    case 358:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(375);
      END_STATE();
    case 359:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(376);
      END_STATE();
    case 360:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(377);
      END_STATE();
    case 361:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(378);
      END_STATE();
    case 362:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(379);
      END_STATE();
    case 363:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(380);
      END_STATE();
    case 364:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(381);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_encoding);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_iterable);
      END_STATE();
    case 367:
      if (lookahead == 'y') ADVANCE(382);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_primitive_type_token1);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_continue_statement_token1);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(aux_sym_readonly_modifier_token1);
      END_STATE();
    case 371:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(383);
      END_STATE();
    case 372:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(384);
      END_STATE();
    case 373:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(385);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(aux_sym_switch_block_token1);
      END_STATE();
    case 375:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(386);
      END_STATE();
    case 376:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(387);
      END_STATE();
    case 377:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(388);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(aux_sym_use_instead_of_clause_token1);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(aux_sym_interface_declaration_token1);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(aux_sym_namespace_definition_token1);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(aux_sym_visibility_modifier_token2);
      END_STATE();
    case 382:
      if (lookahead == 'p') ADVANCE(389);
      END_STATE();
    case 383:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(390);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(aux_sym_declare_statement_token2);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(aux_sym_foreach_statement_token2);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(aux_sym_class_interface_clause_token1);
      END_STATE();
    case 387:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(391);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_binary_expression_token1);
      END_STATE();
    case 389:
      if (lookahead == 'e') ADVANCE(392);
      END_STATE();
    case 390:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(393);
      END_STATE();
    case 391:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(394);
      END_STATE();
    case 392:
      if (lookahead == 's') ADVANCE(395);
      END_STATE();
    case 393:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym_include_once_expression_token1);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_strict_types);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_require_once_expression_token1);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 68},
  [2] = {.lex_state = 68},
  [3] = {.lex_state = 68},
  [4] = {.lex_state = 68},
  [5] = {.lex_state = 68},
  [6] = {.lex_state = 68},
  [7] = {.lex_state = 68},
  [8] = {.lex_state = 68},
  [9] = {.lex_state = 68},
  [10] = {.lex_state = 68},
  [11] = {.lex_state = 68},
  [12] = {.lex_state = 68, .external_lex_state = 2},
  [13] = {.lex_state = 68},
  [14] = {.lex_state = 68},
  [15] = {.lex_state = 68},
  [16] = {.lex_state = 68, .external_lex_state = 2},
  [17] = {.lex_state = 68, .external_lex_state = 2},
  [18] = {.lex_state = 68, .external_lex_state = 2},
  [19] = {.lex_state = 68, .external_lex_state = 2},
  [20] = {.lex_state = 68, .external_lex_state = 2},
  [21] = {.lex_state = 68},
  [22] = {.lex_state = 68},
  [23] = {.lex_state = 68},
  [24] = {.lex_state = 68, .external_lex_state = 2},
  [25] = {.lex_state = 68},
  [26] = {.lex_state = 68},
  [27] = {.lex_state = 68},
  [28] = {.lex_state = 68},
  [29] = {.lex_state = 68},
  [30] = {.lex_state = 68},
  [31] = {.lex_state = 68},
  [32] = {.lex_state = 68},
  [33] = {.lex_state = 68, .external_lex_state = 2},
  [34] = {.lex_state = 68},
  [35] = {.lex_state = 68},
  [36] = {.lex_state = 68, .external_lex_state = 2},
  [37] = {.lex_state = 68, .external_lex_state = 2},
  [38] = {.lex_state = 68},
  [39] = {.lex_state = 68, .external_lex_state = 2},
  [40] = {.lex_state = 68, .external_lex_state = 2},
  [41] = {.lex_state = 68},
  [42] = {.lex_state = 68},
  [43] = {.lex_state = 68},
  [44] = {.lex_state = 68},
  [45] = {.lex_state = 68},
  [46] = {.lex_state = 68},
  [47] = {.lex_state = 68, .external_lex_state = 2},
  [48] = {.lex_state = 68},
  [49] = {.lex_state = 68},
  [50] = {.lex_state = 68, .external_lex_state = 2},
  [51] = {.lex_state = 68},
  [52] = {.lex_state = 68},
  [53] = {.lex_state = 68},
  [54] = {.lex_state = 68, .external_lex_state = 2},
  [55] = {.lex_state = 68},
  [56] = {.lex_state = 68, .external_lex_state = 2},
  [57] = {.lex_state = 68},
  [58] = {.lex_state = 68},
  [59] = {.lex_state = 68, .external_lex_state = 2},
  [60] = {.lex_state = 68},
  [61] = {.lex_state = 68},
  [62] = {.lex_state = 68},
  [63] = {.lex_state = 68},
  [64] = {.lex_state = 68, .external_lex_state = 2},
  [65] = {.lex_state = 68, .external_lex_state = 2},
  [66] = {.lex_state = 68, .external_lex_state = 2},
  [67] = {.lex_state = 68, .external_lex_state = 2},
  [68] = {.lex_state = 68},
  [69] = {.lex_state = 68, .external_lex_state = 2},
  [70] = {.lex_state = 68},
  [71] = {.lex_state = 68},
  [72] = {.lex_state = 68, .external_lex_state = 2},
  [73] = {.lex_state = 68, .external_lex_state = 2},
  [74] = {.lex_state = 68},
  [75] = {.lex_state = 68},
  [76] = {.lex_state = 68},
  [77] = {.lex_state = 68},
  [78] = {.lex_state = 68},
  [79] = {.lex_state = 68},
  [80] = {.lex_state = 68},
  [81] = {.lex_state = 68},
  [82] = {.lex_state = 68},
  [83] = {.lex_state = 68},
  [84] = {.lex_state = 68},
  [85] = {.lex_state = 5},
  [86] = {.lex_state = 5},
  [87] = {.lex_state = 5, .external_lex_state = 2},
  [88] = {.lex_state = 5},
  [89] = {.lex_state = 7},
  [90] = {.lex_state = 7},
  [91] = {.lex_state = 7},
  [92] = {.lex_state = 7},
  [93] = {.lex_state = 7},
  [94] = {.lex_state = 7},
  [95] = {.lex_state = 7},
  [96] = {.lex_state = 7},
  [97] = {.lex_state = 7},
  [98] = {.lex_state = 7},
  [99] = {.lex_state = 7},
  [100] = {.lex_state = 6},
  [101] = {.lex_state = 6},
  [102] = {.lex_state = 6},
  [103] = {.lex_state = 6},
  [104] = {.lex_state = 6},
  [105] = {.lex_state = 6},
  [106] = {.lex_state = 6},
  [107] = {.lex_state = 6},
  [108] = {.lex_state = 6},
  [109] = {.lex_state = 6},
  [110] = {.lex_state = 6},
  [111] = {.lex_state = 6},
  [112] = {.lex_state = 6},
  [113] = {.lex_state = 6},
  [114] = {.lex_state = 6},
  [115] = {.lex_state = 6},
  [116] = {.lex_state = 6},
  [117] = {.lex_state = 6},
  [118] = {.lex_state = 6},
  [119] = {.lex_state = 6},
  [120] = {.lex_state = 6},
  [121] = {.lex_state = 6},
  [122] = {.lex_state = 6},
  [123] = {.lex_state = 6},
  [124] = {.lex_state = 6},
  [125] = {.lex_state = 6},
  [126] = {.lex_state = 6},
  [127] = {.lex_state = 6},
  [128] = {.lex_state = 6},
  [129] = {.lex_state = 6},
  [130] = {.lex_state = 6},
  [131] = {.lex_state = 6},
  [132] = {.lex_state = 6},
  [133] = {.lex_state = 68},
  [134] = {.lex_state = 6},
  [135] = {.lex_state = 6},
  [136] = {.lex_state = 6},
  [137] = {.lex_state = 6},
  [138] = {.lex_state = 6},
  [139] = {.lex_state = 6},
  [140] = {.lex_state = 6},
  [141] = {.lex_state = 6},
  [142] = {.lex_state = 68},
  [143] = {.lex_state = 6},
  [144] = {.lex_state = 68},
  [145] = {.lex_state = 68},
  [146] = {.lex_state = 68},
  [147] = {.lex_state = 68},
  [148] = {.lex_state = 6},
  [149] = {.lex_state = 6},
  [150] = {.lex_state = 68},
  [151] = {.lex_state = 68},
  [152] = {.lex_state = 68},
  [153] = {.lex_state = 68},
  [154] = {.lex_state = 68},
  [155] = {.lex_state = 68},
  [156] = {.lex_state = 6},
  [157] = {.lex_state = 68},
  [158] = {.lex_state = 68},
  [159] = {.lex_state = 68},
  [160] = {.lex_state = 68},
  [161] = {.lex_state = 68},
  [162] = {.lex_state = 68},
  [163] = {.lex_state = 68},
  [164] = {.lex_state = 68},
  [165] = {.lex_state = 68},
  [166] = {.lex_state = 68},
  [167] = {.lex_state = 68},
  [168] = {.lex_state = 68},
  [169] = {.lex_state = 68},
  [170] = {.lex_state = 68},
  [171] = {.lex_state = 68},
  [172] = {.lex_state = 68},
  [173] = {.lex_state = 68},
  [174] = {.lex_state = 68},
  [175] = {.lex_state = 68},
  [176] = {.lex_state = 68},
  [177] = {.lex_state = 68},
  [178] = {.lex_state = 68},
  [179] = {.lex_state = 68},
  [180] = {.lex_state = 68},
  [181] = {.lex_state = 68},
  [182] = {.lex_state = 68},
  [183] = {.lex_state = 68},
  [184] = {.lex_state = 68},
  [185] = {.lex_state = 68},
  [186] = {.lex_state = 68},
  [187] = {.lex_state = 68, .external_lex_state = 2},
  [188] = {.lex_state = 68, .external_lex_state = 2},
  [189] = {.lex_state = 68, .external_lex_state = 2},
  [190] = {.lex_state = 68, .external_lex_state = 2},
  [191] = {.lex_state = 68},
  [192] = {.lex_state = 68},
  [193] = {.lex_state = 68, .external_lex_state = 2},
  [194] = {.lex_state = 68, .external_lex_state = 2},
  [195] = {.lex_state = 68},
  [196] = {.lex_state = 68},
  [197] = {.lex_state = 68},
  [198] = {.lex_state = 68},
  [199] = {.lex_state = 68},
  [200] = {.lex_state = 68},
  [201] = {.lex_state = 6},
  [202] = {.lex_state = 6},
  [203] = {.lex_state = 68},
  [204] = {.lex_state = 68},
  [205] = {.lex_state = 68},
  [206] = {.lex_state = 68},
  [207] = {.lex_state = 68},
  [208] = {.lex_state = 68},
  [209] = {.lex_state = 68},
  [210] = {.lex_state = 68},
  [211] = {.lex_state = 68},
  [212] = {.lex_state = 68},
  [213] = {.lex_state = 68},
  [214] = {.lex_state = 68},
  [215] = {.lex_state = 68},
  [216] = {.lex_state = 68},
  [217] = {.lex_state = 68},
  [218] = {.lex_state = 68},
  [219] = {.lex_state = 68},
  [220] = {.lex_state = 68},
  [221] = {.lex_state = 68},
  [222] = {.lex_state = 68},
  [223] = {.lex_state = 68},
  [224] = {.lex_state = 68},
  [225] = {.lex_state = 68},
  [226] = {.lex_state = 68},
  [227] = {.lex_state = 68},
  [228] = {.lex_state = 68},
  [229] = {.lex_state = 68},
  [230] = {.lex_state = 68},
  [231] = {.lex_state = 68},
  [232] = {.lex_state = 68},
  [233] = {.lex_state = 68},
  [234] = {.lex_state = 68},
  [235] = {.lex_state = 68},
  [236] = {.lex_state = 68},
  [237] = {.lex_state = 68},
  [238] = {.lex_state = 68},
  [239] = {.lex_state = 68},
  [240] = {.lex_state = 68},
  [241] = {.lex_state = 68},
  [242] = {.lex_state = 68},
  [243] = {.lex_state = 68},
  [244] = {.lex_state = 68},
  [245] = {.lex_state = 68},
  [246] = {.lex_state = 68},
  [247] = {.lex_state = 68},
  [248] = {.lex_state = 68},
  [249] = {.lex_state = 68},
  [250] = {.lex_state = 68},
  [251] = {.lex_state = 68},
  [252] = {.lex_state = 68},
  [253] = {.lex_state = 68},
  [254] = {.lex_state = 68},
  [255] = {.lex_state = 68},
  [256] = {.lex_state = 68},
  [257] = {.lex_state = 68},
  [258] = {.lex_state = 68},
  [259] = {.lex_state = 68},
  [260] = {.lex_state = 68},
  [261] = {.lex_state = 68},
  [262] = {.lex_state = 68},
  [263] = {.lex_state = 68},
  [264] = {.lex_state = 68},
  [265] = {.lex_state = 68},
  [266] = {.lex_state = 68},
  [267] = {.lex_state = 68},
  [268] = {.lex_state = 68},
  [269] = {.lex_state = 68},
  [270] = {.lex_state = 68},
  [271] = {.lex_state = 68},
  [272] = {.lex_state = 68},
  [273] = {.lex_state = 68},
  [274] = {.lex_state = 68},
  [275] = {.lex_state = 68},
  [276] = {.lex_state = 68},
  [277] = {.lex_state = 68},
  [278] = {.lex_state = 68},
  [279] = {.lex_state = 68},
  [280] = {.lex_state = 68},
  [281] = {.lex_state = 68},
  [282] = {.lex_state = 68},
  [283] = {.lex_state = 68},
  [284] = {.lex_state = 68},
  [285] = {.lex_state = 68},
  [286] = {.lex_state = 68},
  [287] = {.lex_state = 68},
  [288] = {.lex_state = 68},
  [289] = {.lex_state = 68},
  [290] = {.lex_state = 68},
  [291] = {.lex_state = 68},
  [292] = {.lex_state = 68},
  [293] = {.lex_state = 68},
  [294] = {.lex_state = 68},
  [295] = {.lex_state = 68},
  [296] = {.lex_state = 68},
  [297] = {.lex_state = 68},
  [298] = {.lex_state = 68},
  [299] = {.lex_state = 68},
  [300] = {.lex_state = 68},
  [301] = {.lex_state = 68},
  [302] = {.lex_state = 68},
  [303] = {.lex_state = 68},
  [304] = {.lex_state = 68},
  [305] = {.lex_state = 68},
  [306] = {.lex_state = 68},
  [307] = {.lex_state = 68},
  [308] = {.lex_state = 68},
  [309] = {.lex_state = 68},
  [310] = {.lex_state = 68},
  [311] = {.lex_state = 68},
  [312] = {.lex_state = 68},
  [313] = {.lex_state = 68},
  [314] = {.lex_state = 68},
  [315] = {.lex_state = 68},
  [316] = {.lex_state = 68},
  [317] = {.lex_state = 68},
  [318] = {.lex_state = 68},
  [319] = {.lex_state = 68},
  [320] = {.lex_state = 68},
  [321] = {.lex_state = 68},
  [322] = {.lex_state = 68},
  [323] = {.lex_state = 68},
  [324] = {.lex_state = 68},
  [325] = {.lex_state = 68},
  [326] = {.lex_state = 68},
  [327] = {.lex_state = 68},
  [328] = {.lex_state = 68},
  [329] = {.lex_state = 68},
  [330] = {.lex_state = 68},
  [331] = {.lex_state = 68},
  [332] = {.lex_state = 68},
  [333] = {.lex_state = 68},
  [334] = {.lex_state = 68},
  [335] = {.lex_state = 68},
  [336] = {.lex_state = 68},
  [337] = {.lex_state = 68},
  [338] = {.lex_state = 68},
  [339] = {.lex_state = 68},
  [340] = {.lex_state = 68},
  [341] = {.lex_state = 68},
  [342] = {.lex_state = 68},
  [343] = {.lex_state = 68},
  [344] = {.lex_state = 68},
  [345] = {.lex_state = 68},
  [346] = {.lex_state = 68},
  [347] = {.lex_state = 68},
  [348] = {.lex_state = 68},
  [349] = {.lex_state = 68},
  [350] = {.lex_state = 68},
  [351] = {.lex_state = 68},
  [352] = {.lex_state = 68},
  [353] = {.lex_state = 68},
  [354] = {.lex_state = 68},
  [355] = {.lex_state = 68},
  [356] = {.lex_state = 68},
  [357] = {.lex_state = 68},
  [358] = {.lex_state = 68},
  [359] = {.lex_state = 68},
  [360] = {.lex_state = 68},
  [361] = {.lex_state = 68},
  [362] = {.lex_state = 68},
  [363] = {.lex_state = 68},
  [364] = {.lex_state = 68},
  [365] = {.lex_state = 68},
  [366] = {.lex_state = 68},
  [367] = {.lex_state = 68},
  [368] = {.lex_state = 68},
  [369] = {.lex_state = 68},
  [370] = {.lex_state = 68},
  [371] = {.lex_state = 68},
  [372] = {.lex_state = 68},
  [373] = {.lex_state = 68},
  [374] = {.lex_state = 68},
  [375] = {.lex_state = 68},
  [376] = {.lex_state = 68},
  [377] = {.lex_state = 68},
  [378] = {.lex_state = 68},
  [379] = {.lex_state = 68},
  [380] = {.lex_state = 68},
  [381] = {.lex_state = 68},
  [382] = {.lex_state = 68},
  [383] = {.lex_state = 68},
  [384] = {.lex_state = 68},
  [385] = {.lex_state = 68},
  [386] = {.lex_state = 68},
  [387] = {.lex_state = 68},
  [388] = {.lex_state = 68},
  [389] = {.lex_state = 68},
  [390] = {.lex_state = 68},
  [391] = {.lex_state = 68},
  [392] = {.lex_state = 68},
  [393] = {.lex_state = 68},
  [394] = {.lex_state = 68},
  [395] = {.lex_state = 68},
  [396] = {.lex_state = 68},
  [397] = {.lex_state = 68},
  [398] = {.lex_state = 68},
  [399] = {.lex_state = 68},
  [400] = {.lex_state = 68},
  [401] = {.lex_state = 68},
  [402] = {.lex_state = 68},
  [403] = {.lex_state = 68},
  [404] = {.lex_state = 68},
  [405] = {.lex_state = 68},
  [406] = {.lex_state = 68},
  [407] = {.lex_state = 68},
  [408] = {.lex_state = 68},
  [409] = {.lex_state = 68},
  [410] = {.lex_state = 68},
  [411] = {.lex_state = 68},
  [412] = {.lex_state = 68},
  [413] = {.lex_state = 68},
  [414] = {.lex_state = 68},
  [415] = {.lex_state = 68},
  [416] = {.lex_state = 68},
  [417] = {.lex_state = 68},
  [418] = {.lex_state = 68},
  [419] = {.lex_state = 68},
  [420] = {.lex_state = 68},
  [421] = {.lex_state = 68},
  [422] = {.lex_state = 68},
  [423] = {.lex_state = 68},
  [424] = {.lex_state = 68},
  [425] = {.lex_state = 68},
  [426] = {.lex_state = 68},
  [427] = {.lex_state = 68},
  [428] = {.lex_state = 68},
  [429] = {.lex_state = 68},
  [430] = {.lex_state = 68},
  [431] = {.lex_state = 68},
  [432] = {.lex_state = 68},
  [433] = {.lex_state = 68},
  [434] = {.lex_state = 68, .external_lex_state = 2},
  [435] = {.lex_state = 68, .external_lex_state = 2},
  [436] = {.lex_state = 68, .external_lex_state = 2},
  [437] = {.lex_state = 68, .external_lex_state = 2},
  [438] = {.lex_state = 68, .external_lex_state = 2},
  [439] = {.lex_state = 68, .external_lex_state = 2},
  [440] = {.lex_state = 68, .external_lex_state = 2},
  [441] = {.lex_state = 68, .external_lex_state = 2},
  [442] = {.lex_state = 68, .external_lex_state = 2},
  [443] = {.lex_state = 68, .external_lex_state = 2},
  [444] = {.lex_state = 68, .external_lex_state = 2},
  [445] = {.lex_state = 68, .external_lex_state = 2},
  [446] = {.lex_state = 68, .external_lex_state = 2},
  [447] = {.lex_state = 68, .external_lex_state = 2},
  [448] = {.lex_state = 68, .external_lex_state = 2},
  [449] = {.lex_state = 68, .external_lex_state = 2},
  [450] = {.lex_state = 68, .external_lex_state = 2},
  [451] = {.lex_state = 68, .external_lex_state = 2},
  [452] = {.lex_state = 68, .external_lex_state = 2},
  [453] = {.lex_state = 68, .external_lex_state = 2},
  [454] = {.lex_state = 68},
  [455] = {.lex_state = 68},
  [456] = {.lex_state = 68},
  [457] = {.lex_state = 68},
  [458] = {.lex_state = 68},
  [459] = {.lex_state = 68},
  [460] = {.lex_state = 68},
  [461] = {.lex_state = 68},
  [462] = {.lex_state = 68},
  [463] = {.lex_state = 68},
  [464] = {.lex_state = 68},
  [465] = {.lex_state = 68},
  [466] = {.lex_state = 68},
  [467] = {.lex_state = 68},
  [468] = {.lex_state = 68},
  [469] = {.lex_state = 68},
  [470] = {.lex_state = 68},
  [471] = {.lex_state = 68},
  [472] = {.lex_state = 68},
  [473] = {.lex_state = 68},
  [474] = {.lex_state = 68},
  [475] = {.lex_state = 68},
  [476] = {.lex_state = 68},
  [477] = {.lex_state = 68},
  [478] = {.lex_state = 68},
  [479] = {.lex_state = 68},
  [480] = {.lex_state = 68},
  [481] = {.lex_state = 68},
  [482] = {.lex_state = 68},
  [483] = {.lex_state = 68},
  [484] = {.lex_state = 68},
  [485] = {.lex_state = 68},
  [486] = {.lex_state = 68},
  [487] = {.lex_state = 68},
  [488] = {.lex_state = 68},
  [489] = {.lex_state = 68},
  [490] = {.lex_state = 68},
  [491] = {.lex_state = 68},
  [492] = {.lex_state = 68},
  [493] = {.lex_state = 68},
  [494] = {.lex_state = 68},
  [495] = {.lex_state = 68},
  [496] = {.lex_state = 68},
  [497] = {.lex_state = 68},
  [498] = {.lex_state = 68},
  [499] = {.lex_state = 68},
  [500] = {.lex_state = 68},
  [501] = {.lex_state = 68},
  [502] = {.lex_state = 68},
  [503] = {.lex_state = 68},
  [504] = {.lex_state = 68},
  [505] = {.lex_state = 68},
  [506] = {.lex_state = 68},
  [507] = {.lex_state = 68},
  [508] = {.lex_state = 68},
  [509] = {.lex_state = 68},
  [510] = {.lex_state = 68},
  [511] = {.lex_state = 68},
  [512] = {.lex_state = 68},
  [513] = {.lex_state = 68},
  [514] = {.lex_state = 68},
  [515] = {.lex_state = 68},
  [516] = {.lex_state = 68},
  [517] = {.lex_state = 68},
  [518] = {.lex_state = 68},
  [519] = {.lex_state = 68},
  [520] = {.lex_state = 68},
  [521] = {.lex_state = 68},
  [522] = {.lex_state = 68},
  [523] = {.lex_state = 68},
  [524] = {.lex_state = 68},
  [525] = {.lex_state = 68},
  [526] = {.lex_state = 68},
  [527] = {.lex_state = 68},
  [528] = {.lex_state = 68},
  [529] = {.lex_state = 68},
  [530] = {.lex_state = 68},
  [531] = {.lex_state = 68},
  [532] = {.lex_state = 68},
  [533] = {.lex_state = 68},
  [534] = {.lex_state = 68},
  [535] = {.lex_state = 68},
  [536] = {.lex_state = 68},
  [537] = {.lex_state = 68},
  [538] = {.lex_state = 68},
  [539] = {.lex_state = 68},
  [540] = {.lex_state = 68},
  [541] = {.lex_state = 68},
  [542] = {.lex_state = 68},
  [543] = {.lex_state = 68},
  [544] = {.lex_state = 68},
  [545] = {.lex_state = 68},
  [546] = {.lex_state = 68},
  [547] = {.lex_state = 68},
  [548] = {.lex_state = 68},
  [549] = {.lex_state = 68},
  [550] = {.lex_state = 68},
  [551] = {.lex_state = 68},
  [552] = {.lex_state = 68},
  [553] = {.lex_state = 68},
  [554] = {.lex_state = 68},
  [555] = {.lex_state = 68},
  [556] = {.lex_state = 68},
  [557] = {.lex_state = 68},
  [558] = {.lex_state = 68},
  [559] = {.lex_state = 68},
  [560] = {.lex_state = 68},
  [561] = {.lex_state = 68},
  [562] = {.lex_state = 68},
  [563] = {.lex_state = 68},
  [564] = {.lex_state = 68},
  [565] = {.lex_state = 68},
  [566] = {.lex_state = 68},
  [567] = {.lex_state = 68},
  [568] = {.lex_state = 68},
  [569] = {.lex_state = 68},
  [570] = {.lex_state = 68},
  [571] = {.lex_state = 69},
  [572] = {.lex_state = 69},
  [573] = {.lex_state = 69},
  [574] = {.lex_state = 69},
  [575] = {.lex_state = 69},
  [576] = {.lex_state = 69},
  [577] = {.lex_state = 69},
  [578] = {.lex_state = 69},
  [579] = {.lex_state = 69},
  [580] = {.lex_state = 69},
  [581] = {.lex_state = 69},
  [582] = {.lex_state = 69},
  [583] = {.lex_state = 69},
  [584] = {.lex_state = 69},
  [585] = {.lex_state = 69},
  [586] = {.lex_state = 69},
  [587] = {.lex_state = 69},
  [588] = {.lex_state = 69},
  [589] = {.lex_state = 69},
  [590] = {.lex_state = 69},
  [591] = {.lex_state = 69},
  [592] = {.lex_state = 69},
  [593] = {.lex_state = 69},
  [594] = {.lex_state = 69},
  [595] = {.lex_state = 69},
  [596] = {.lex_state = 69},
  [597] = {.lex_state = 69, .external_lex_state = 2},
  [598] = {.lex_state = 69},
  [599] = {.lex_state = 69, .external_lex_state = 2},
  [600] = {.lex_state = 69},
  [601] = {.lex_state = 69, .external_lex_state = 2},
  [602] = {.lex_state = 69, .external_lex_state = 2},
  [603] = {.lex_state = 69, .external_lex_state = 2},
  [604] = {.lex_state = 69},
  [605] = {.lex_state = 69, .external_lex_state = 2},
  [606] = {.lex_state = 69, .external_lex_state = 2},
  [607] = {.lex_state = 69, .external_lex_state = 2},
  [608] = {.lex_state = 69},
  [609] = {.lex_state = 69, .external_lex_state = 2},
  [610] = {.lex_state = 69},
  [611] = {.lex_state = 69, .external_lex_state = 2},
  [612] = {.lex_state = 69, .external_lex_state = 2},
  [613] = {.lex_state = 69, .external_lex_state = 2},
  [614] = {.lex_state = 69},
  [615] = {.lex_state = 69, .external_lex_state = 2},
  [616] = {.lex_state = 69, .external_lex_state = 2},
  [617] = {.lex_state = 69, .external_lex_state = 2},
  [618] = {.lex_state = 69, .external_lex_state = 2},
  [619] = {.lex_state = 69},
  [620] = {.lex_state = 69, .external_lex_state = 2},
  [621] = {.lex_state = 69, .external_lex_state = 2},
  [622] = {.lex_state = 69, .external_lex_state = 2},
  [623] = {.lex_state = 69, .external_lex_state = 2},
  [624] = {.lex_state = 69, .external_lex_state = 2},
  [625] = {.lex_state = 69, .external_lex_state = 2},
  [626] = {.lex_state = 69, .external_lex_state = 2},
  [627] = {.lex_state = 69},
  [628] = {.lex_state = 69, .external_lex_state = 2},
  [629] = {.lex_state = 69},
  [630] = {.lex_state = 69},
  [631] = {.lex_state = 69},
  [632] = {.lex_state = 69, .external_lex_state = 2},
  [633] = {.lex_state = 69, .external_lex_state = 2},
  [634] = {.lex_state = 69},
  [635] = {.lex_state = 69},
  [636] = {.lex_state = 69},
  [637] = {.lex_state = 69},
  [638] = {.lex_state = 69},
  [639] = {.lex_state = 8},
  [640] = {.lex_state = 13},
  [641] = {.lex_state = 13},
  [642] = {.lex_state = 10},
  [643] = {.lex_state = 12},
  [644] = {.lex_state = 10},
  [645] = {.lex_state = 12},
  [646] = {.lex_state = 12},
  [647] = {.lex_state = 12},
  [648] = {.lex_state = 12},
  [649] = {.lex_state = 18},
  [650] = {.lex_state = 12},
  [651] = {.lex_state = 10},
  [652] = {.lex_state = 12},
  [653] = {.lex_state = 18},
  [654] = {.lex_state = 10},
  [655] = {.lex_state = 10},
  [656] = {.lex_state = 10},
  [657] = {.lex_state = 10},
  [658] = {.lex_state = 12},
  [659] = {.lex_state = 12},
  [660] = {.lex_state = 12},
  [661] = {.lex_state = 12},
  [662] = {.lex_state = 12},
  [663] = {.lex_state = 12},
  [664] = {.lex_state = 12},
  [665] = {.lex_state = 12},
  [666] = {.lex_state = 18},
  [667] = {.lex_state = 12},
  [668] = {.lex_state = 12},
  [669] = {.lex_state = 12},
  [670] = {.lex_state = 12},
  [671] = {.lex_state = 12},
  [672] = {.lex_state = 15},
  [673] = {.lex_state = 12},
  [674] = {.lex_state = 18},
  [675] = {.lex_state = 18},
  [676] = {.lex_state = 12},
  [677] = {.lex_state = 12},
  [678] = {.lex_state = 18},
  [679] = {.lex_state = 15},
  [680] = {.lex_state = 12},
  [681] = {.lex_state = 10},
  [682] = {.lex_state = 10},
  [683] = {.lex_state = 10},
  [684] = {.lex_state = 10},
  [685] = {.lex_state = 16},
  [686] = {.lex_state = 16},
  [687] = {.lex_state = 10},
  [688] = {.lex_state = 10},
  [689] = {.lex_state = 10},
  [690] = {.lex_state = 10},
  [691] = {.lex_state = 10},
  [692] = {.lex_state = 10},
  [693] = {.lex_state = 10},
  [694] = {.lex_state = 10},
  [695] = {.lex_state = 10},
  [696] = {.lex_state = 10},
  [697] = {.lex_state = 16},
  [698] = {.lex_state = 10},
  [699] = {.lex_state = 10},
  [700] = {.lex_state = 16},
  [701] = {.lex_state = 12},
  [702] = {.lex_state = 10},
  [703] = {.lex_state = 10},
  [704] = {.lex_state = 10},
  [705] = {.lex_state = 10},
  [706] = {.lex_state = 12},
  [707] = {.lex_state = 16},
  [708] = {.lex_state = 10},
  [709] = {.lex_state = 10},
  [710] = {.lex_state = 10},
  [711] = {.lex_state = 10},
  [712] = {.lex_state = 10},
  [713] = {.lex_state = 10},
  [714] = {.lex_state = 10},
  [715] = {.lex_state = 10},
  [716] = {.lex_state = 10},
  [717] = {.lex_state = 10},
  [718] = {.lex_state = 18},
  [719] = {.lex_state = 10},
  [720] = {.lex_state = 10},
  [721] = {.lex_state = 10},
  [722] = {.lex_state = 10},
  [723] = {.lex_state = 16},
  [724] = {.lex_state = 10},
  [725] = {.lex_state = 10},
  [726] = {.lex_state = 10},
  [727] = {.lex_state = 10},
  [728] = {.lex_state = 10},
  [729] = {.lex_state = 10},
  [730] = {.lex_state = 10},
  [731] = {.lex_state = 10},
  [732] = {.lex_state = 10},
  [733] = {.lex_state = 10},
  [734] = {.lex_state = 10},
  [735] = {.lex_state = 10},
  [736] = {.lex_state = 10},
  [737] = {.lex_state = 10},
  [738] = {.lex_state = 10},
  [739] = {.lex_state = 10},
  [740] = {.lex_state = 10},
  [741] = {.lex_state = 10},
  [742] = {.lex_state = 10},
  [743] = {.lex_state = 10},
  [744] = {.lex_state = 10},
  [745] = {.lex_state = 10},
  [746] = {.lex_state = 10},
  [747] = {.lex_state = 10},
  [748] = {.lex_state = 10},
  [749] = {.lex_state = 10},
  [750] = {.lex_state = 10},
  [751] = {.lex_state = 10},
  [752] = {.lex_state = 10},
  [753] = {.lex_state = 10},
  [754] = {.lex_state = 10},
  [755] = {.lex_state = 10},
  [756] = {.lex_state = 10},
  [757] = {.lex_state = 10},
  [758] = {.lex_state = 10},
  [759] = {.lex_state = 10},
  [760] = {.lex_state = 10},
  [761] = {.lex_state = 10},
  [762] = {.lex_state = 10, .external_lex_state = 2},
  [763] = {.lex_state = 11},
  [764] = {.lex_state = 10, .external_lex_state = 2},
  [765] = {.lex_state = 12, .external_lex_state = 2},
  [766] = {.lex_state = 12, .external_lex_state = 2},
  [767] = {.lex_state = 12, .external_lex_state = 2},
  [768] = {.lex_state = 12, .external_lex_state = 2},
  [769] = {.lex_state = 12, .external_lex_state = 2},
  [770] = {.lex_state = 10},
  [771] = {.lex_state = 10, .external_lex_state = 2},
  [772] = {.lex_state = 10},
  [773] = {.lex_state = 6},
  [774] = {.lex_state = 10},
  [775] = {.lex_state = 10},
  [776] = {.lex_state = 11},
  [777] = {.lex_state = 12, .external_lex_state = 2},
  [778] = {.lex_state = 10, .external_lex_state = 2},
  [779] = {.lex_state = 12, .external_lex_state = 2},
  [780] = {.lex_state = 12, .external_lex_state = 2},
  [781] = {.lex_state = 12, .external_lex_state = 2},
  [782] = {.lex_state = 12, .external_lex_state = 2},
  [783] = {.lex_state = 10, .external_lex_state = 2},
  [784] = {.lex_state = 12, .external_lex_state = 2},
  [785] = {.lex_state = 10, .external_lex_state = 2},
  [786] = {.lex_state = 12, .external_lex_state = 2},
  [787] = {.lex_state = 12, .external_lex_state = 2},
  [788] = {.lex_state = 12, .external_lex_state = 2},
  [789] = {.lex_state = 12, .external_lex_state = 2},
  [790] = {.lex_state = 12, .external_lex_state = 2},
  [791] = {.lex_state = 12, .external_lex_state = 2},
  [792] = {.lex_state = 12, .external_lex_state = 2},
  [793] = {.lex_state = 12, .external_lex_state = 2},
  [794] = {.lex_state = 12, .external_lex_state = 2},
  [795] = {.lex_state = 12, .external_lex_state = 2},
  [796] = {.lex_state = 12, .external_lex_state = 2},
  [797] = {.lex_state = 12, .external_lex_state = 2},
  [798] = {.lex_state = 10},
  [799] = {.lex_state = 12, .external_lex_state = 2},
  [800] = {.lex_state = 6},
  [801] = {.lex_state = 10, .external_lex_state = 2},
  [802] = {.lex_state = 10, .external_lex_state = 2},
  [803] = {.lex_state = 16},
  [804] = {.lex_state = 10, .external_lex_state = 2},
  [805] = {.lex_state = 16},
  [806] = {.lex_state = 10, .external_lex_state = 2},
  [807] = {.lex_state = 10, .external_lex_state = 2},
  [808] = {.lex_state = 16},
  [809] = {.lex_state = 10, .external_lex_state = 2},
  [810] = {.lex_state = 10, .external_lex_state = 2},
  [811] = {.lex_state = 16},
  [812] = {.lex_state = 16},
  [813] = {.lex_state = 10, .external_lex_state = 2},
  [814] = {.lex_state = 10, .external_lex_state = 2},
  [815] = {.lex_state = 10, .external_lex_state = 2},
  [816] = {.lex_state = 10, .external_lex_state = 2},
  [817] = {.lex_state = 10, .external_lex_state = 2},
  [818] = {.lex_state = 10, .external_lex_state = 2},
  [819] = {.lex_state = 10, .external_lex_state = 2},
  [820] = {.lex_state = 10, .external_lex_state = 2},
  [821] = {.lex_state = 10, .external_lex_state = 2},
  [822] = {.lex_state = 10, .external_lex_state = 2},
  [823] = {.lex_state = 10, .external_lex_state = 2},
  [824] = {.lex_state = 16},
  [825] = {.lex_state = 10, .external_lex_state = 2},
  [826] = {.lex_state = 16},
  [827] = {.lex_state = 10, .external_lex_state = 2},
  [828] = {.lex_state = 11},
  [829] = {.lex_state = 11},
  [830] = {.lex_state = 10, .external_lex_state = 2},
  [831] = {.lex_state = 10, .external_lex_state = 2},
  [832] = {.lex_state = 10, .external_lex_state = 2},
  [833] = {.lex_state = 16},
  [834] = {.lex_state = 16},
  [835] = {.lex_state = 10, .external_lex_state = 2},
  [836] = {.lex_state = 10, .external_lex_state = 2},
  [837] = {.lex_state = 16},
  [838] = {.lex_state = 10, .external_lex_state = 2},
  [839] = {.lex_state = 10, .external_lex_state = 2},
  [840] = {.lex_state = 16},
  [841] = {.lex_state = 10, .external_lex_state = 2},
  [842] = {.lex_state = 16},
  [843] = {.lex_state = 12, .external_lex_state = 2},
  [844] = {.lex_state = 12, .external_lex_state = 2},
  [845] = {.lex_state = 16},
  [846] = {.lex_state = 10, .external_lex_state = 2},
  [847] = {.lex_state = 10, .external_lex_state = 2},
  [848] = {.lex_state = 10, .external_lex_state = 2},
  [849] = {.lex_state = 10, .external_lex_state = 2},
  [850] = {.lex_state = 10, .external_lex_state = 2},
  [851] = {.lex_state = 16},
  [852] = {.lex_state = 16},
  [853] = {.lex_state = 10, .external_lex_state = 2},
  [854] = {.lex_state = 10, .external_lex_state = 2},
  [855] = {.lex_state = 10, .external_lex_state = 2},
  [856] = {.lex_state = 10, .external_lex_state = 2},
  [857] = {.lex_state = 10, .external_lex_state = 2},
  [858] = {.lex_state = 10, .external_lex_state = 2},
  [859] = {.lex_state = 10, .external_lex_state = 2},
  [860] = {.lex_state = 10, .external_lex_state = 2},
  [861] = {.lex_state = 10, .external_lex_state = 2},
  [862] = {.lex_state = 10, .external_lex_state = 2},
  [863] = {.lex_state = 10, .external_lex_state = 2},
  [864] = {.lex_state = 10, .external_lex_state = 2},
  [865] = {.lex_state = 10, .external_lex_state = 2},
  [866] = {.lex_state = 10, .external_lex_state = 2},
  [867] = {.lex_state = 10, .external_lex_state = 2},
  [868] = {.lex_state = 10, .external_lex_state = 2},
  [869] = {.lex_state = 10, .external_lex_state = 2},
  [870] = {.lex_state = 10, .external_lex_state = 2},
  [871] = {.lex_state = 10, .external_lex_state = 2},
  [872] = {.lex_state = 10, .external_lex_state = 2},
  [873] = {.lex_state = 10},
  [874] = {.lex_state = 10, .external_lex_state = 2},
  [875] = {.lex_state = 10, .external_lex_state = 2},
  [876] = {.lex_state = 10, .external_lex_state = 2},
  [877] = {.lex_state = 10, .external_lex_state = 2},
  [878] = {.lex_state = 10},
  [879] = {.lex_state = 10, .external_lex_state = 2},
  [880] = {.lex_state = 10, .external_lex_state = 2},
  [881] = {.lex_state = 10, .external_lex_state = 2},
  [882] = {.lex_state = 10, .external_lex_state = 2},
  [883] = {.lex_state = 10, .external_lex_state = 2},
  [884] = {.lex_state = 10, .external_lex_state = 2},
  [885] = {.lex_state = 10, .external_lex_state = 2},
  [886] = {.lex_state = 10, .external_lex_state = 2},
  [887] = {.lex_state = 10, .external_lex_state = 2},
  [888] = {.lex_state = 10, .external_lex_state = 2},
  [889] = {.lex_state = 10, .external_lex_state = 2},
  [890] = {.lex_state = 10, .external_lex_state = 2},
  [891] = {.lex_state = 10, .external_lex_state = 2},
  [892] = {.lex_state = 10, .external_lex_state = 2},
  [893] = {.lex_state = 10, .external_lex_state = 2},
  [894] = {.lex_state = 10, .external_lex_state = 2},
  [895] = {.lex_state = 10, .external_lex_state = 2},
  [896] = {.lex_state = 10, .external_lex_state = 2},
  [897] = {.lex_state = 10, .external_lex_state = 2},
  [898] = {.lex_state = 10, .external_lex_state = 2},
  [899] = {.lex_state = 10, .external_lex_state = 2},
  [900] = {.lex_state = 10, .external_lex_state = 2},
  [901] = {.lex_state = 11},
  [902] = {.lex_state = 11},
  [903] = {.lex_state = 11},
  [904] = {.lex_state = 11},
  [905] = {.lex_state = 11},
  [906] = {.lex_state = 11},
  [907] = {.lex_state = 11},
  [908] = {.lex_state = 11},
  [909] = {.lex_state = 11},
  [910] = {.lex_state = 11},
  [911] = {.lex_state = 11},
  [912] = {.lex_state = 11},
  [913] = {.lex_state = 11},
  [914] = {.lex_state = 11},
  [915] = {.lex_state = 11},
  [916] = {.lex_state = 11},
  [917] = {.lex_state = 11},
  [918] = {.lex_state = 11},
  [919] = {.lex_state = 11},
  [920] = {.lex_state = 11},
  [921] = {.lex_state = 21},
  [922] = {.lex_state = 11},
  [923] = {.lex_state = 11},
  [924] = {.lex_state = 11},
  [925] = {.lex_state = 11},
  [926] = {.lex_state = 11},
  [927] = {.lex_state = 11},
  [928] = {.lex_state = 11},
  [929] = {.lex_state = 11},
  [930] = {.lex_state = 11},
  [931] = {.lex_state = 11},
  [932] = {.lex_state = 11},
  [933] = {.lex_state = 11},
  [934] = {.lex_state = 11},
  [935] = {.lex_state = 11},
  [936] = {.lex_state = 11},
  [937] = {.lex_state = 11},
  [938] = {.lex_state = 11},
  [939] = {.lex_state = 11},
  [940] = {.lex_state = 11},
  [941] = {.lex_state = 11},
  [942] = {.lex_state = 11},
  [943] = {.lex_state = 11},
  [944] = {.lex_state = 11},
  [945] = {.lex_state = 11},
  [946] = {.lex_state = 11},
  [947] = {.lex_state = 11},
  [948] = {.lex_state = 11},
  [949] = {.lex_state = 11},
  [950] = {.lex_state = 11},
  [951] = {.lex_state = 11},
  [952] = {.lex_state = 11},
  [953] = {.lex_state = 11},
  [954] = {.lex_state = 11},
  [955] = {.lex_state = 11},
  [956] = {.lex_state = 11},
  [957] = {.lex_state = 11},
  [958] = {.lex_state = 11},
  [959] = {.lex_state = 11},
  [960] = {.lex_state = 11},
  [961] = {.lex_state = 11},
  [962] = {.lex_state = 11},
  [963] = {.lex_state = 11},
  [964] = {.lex_state = 11},
  [965] = {.lex_state = 11},
  [966] = {.lex_state = 11, .external_lex_state = 2},
  [967] = {.lex_state = 11, .external_lex_state = 2},
  [968] = {.lex_state = 11},
  [969] = {.lex_state = 11},
  [970] = {.lex_state = 11},
  [971] = {.lex_state = 11},
  [972] = {.lex_state = 11},
  [973] = {.lex_state = 11},
  [974] = {.lex_state = 11},
  [975] = {.lex_state = 11},
  [976] = {.lex_state = 11},
  [977] = {.lex_state = 11},
  [978] = {.lex_state = 11},
  [979] = {.lex_state = 11},
  [980] = {.lex_state = 11},
  [981] = {.lex_state = 11},
  [982] = {.lex_state = 11},
  [983] = {.lex_state = 11},
  [984] = {.lex_state = 11},
  [985] = {.lex_state = 11},
  [986] = {.lex_state = 11},
  [987] = {.lex_state = 11},
  [988] = {.lex_state = 11},
  [989] = {.lex_state = 11},
  [990] = {.lex_state = 11},
  [991] = {.lex_state = 11},
  [992] = {.lex_state = 11},
  [993] = {.lex_state = 11},
  [994] = {.lex_state = 11},
  [995] = {.lex_state = 11},
  [996] = {.lex_state = 11},
  [997] = {.lex_state = 11},
  [998] = {.lex_state = 11},
  [999] = {.lex_state = 11},
  [1000] = {.lex_state = 11},
  [1001] = {.lex_state = 11},
  [1002] = {.lex_state = 11},
  [1003] = {.lex_state = 11},
  [1004] = {.lex_state = 11},
  [1005] = {.lex_state = 11},
  [1006] = {.lex_state = 11},
  [1007] = {.lex_state = 11},
  [1008] = {.lex_state = 11},
  [1009] = {.lex_state = 11},
  [1010] = {.lex_state = 11},
  [1011] = {.lex_state = 11},
  [1012] = {.lex_state = 11},
  [1013] = {.lex_state = 11},
  [1014] = {.lex_state = 11},
  [1015] = {.lex_state = 11},
  [1016] = {.lex_state = 11},
  [1017] = {.lex_state = 11},
  [1018] = {.lex_state = 11},
  [1019] = {.lex_state = 11},
  [1020] = {.lex_state = 11},
  [1021] = {.lex_state = 11},
  [1022] = {.lex_state = 11},
  [1023] = {.lex_state = 11},
  [1024] = {.lex_state = 11},
  [1025] = {.lex_state = 11},
  [1026] = {.lex_state = 11},
  [1027] = {.lex_state = 11},
  [1028] = {.lex_state = 11},
  [1029] = {.lex_state = 13},
  [1030] = {.lex_state = 11},
  [1031] = {.lex_state = 11},
  [1032] = {.lex_state = 11},
  [1033] = {.lex_state = 11, .external_lex_state = 2},
  [1034] = {.lex_state = 11, .external_lex_state = 2},
  [1035] = {.lex_state = 13},
  [1036] = {.lex_state = 11, .external_lex_state = 2},
  [1037] = {.lex_state = 11, .external_lex_state = 2},
  [1038] = {.lex_state = 11, .external_lex_state = 2},
  [1039] = {.lex_state = 11, .external_lex_state = 2},
  [1040] = {.lex_state = 11, .external_lex_state = 2},
  [1041] = {.lex_state = 11, .external_lex_state = 2},
  [1042] = {.lex_state = 11, .external_lex_state = 2},
  [1043] = {.lex_state = 11, .external_lex_state = 2},
  [1044] = {.lex_state = 11, .external_lex_state = 2},
  [1045] = {.lex_state = 11, .external_lex_state = 2},
  [1046] = {.lex_state = 11, .external_lex_state = 2},
  [1047] = {.lex_state = 11, .external_lex_state = 2},
  [1048] = {.lex_state = 11, .external_lex_state = 2},
  [1049] = {.lex_state = 11, .external_lex_state = 2},
  [1050] = {.lex_state = 11, .external_lex_state = 2},
  [1051] = {.lex_state = 11, .external_lex_state = 2},
  [1052] = {.lex_state = 11, .external_lex_state = 2},
  [1053] = {.lex_state = 11, .external_lex_state = 2},
  [1054] = {.lex_state = 11, .external_lex_state = 2},
  [1055] = {.lex_state = 11, .external_lex_state = 2},
  [1056] = {.lex_state = 11, .external_lex_state = 2},
  [1057] = {.lex_state = 11, .external_lex_state = 2},
  [1058] = {.lex_state = 11, .external_lex_state = 2},
  [1059] = {.lex_state = 13},
  [1060] = {.lex_state = 11, .external_lex_state = 2},
  [1061] = {.lex_state = 11, .external_lex_state = 2},
  [1062] = {.lex_state = 11, .external_lex_state = 2},
  [1063] = {.lex_state = 11, .external_lex_state = 2},
  [1064] = {.lex_state = 11, .external_lex_state = 2},
  [1065] = {.lex_state = 11, .external_lex_state = 2},
  [1066] = {.lex_state = 13},
  [1067] = {.lex_state = 11, .external_lex_state = 2},
  [1068] = {.lex_state = 11, .external_lex_state = 2},
  [1069] = {.lex_state = 11, .external_lex_state = 2},
  [1070] = {.lex_state = 11, .external_lex_state = 2},
  [1071] = {.lex_state = 11, .external_lex_state = 2},
  [1072] = {.lex_state = 11, .external_lex_state = 2},
  [1073] = {.lex_state = 11, .external_lex_state = 2},
  [1074] = {.lex_state = 11, .external_lex_state = 2},
  [1075] = {.lex_state = 11, .external_lex_state = 2},
  [1076] = {.lex_state = 11, .external_lex_state = 2},
  [1077] = {.lex_state = 11, .external_lex_state = 2},
  [1078] = {.lex_state = 11, .external_lex_state = 2},
  [1079] = {.lex_state = 11, .external_lex_state = 2},
  [1080] = {.lex_state = 11, .external_lex_state = 2},
  [1081] = {.lex_state = 11, .external_lex_state = 2},
  [1082] = {.lex_state = 11, .external_lex_state = 2},
  [1083] = {.lex_state = 11, .external_lex_state = 2},
  [1084] = {.lex_state = 11, .external_lex_state = 2},
  [1085] = {.lex_state = 11, .external_lex_state = 2},
  [1086] = {.lex_state = 13},
  [1087] = {.lex_state = 11, .external_lex_state = 2},
  [1088] = {.lex_state = 11, .external_lex_state = 2},
  [1089] = {.lex_state = 11, .external_lex_state = 2},
  [1090] = {.lex_state = 11, .external_lex_state = 2},
  [1091] = {.lex_state = 11, .external_lex_state = 2},
  [1092] = {.lex_state = 11, .external_lex_state = 2},
  [1093] = {.lex_state = 11, .external_lex_state = 2},
  [1094] = {.lex_state = 11, .external_lex_state = 2},
  [1095] = {.lex_state = 13},
  [1096] = {.lex_state = 11, .external_lex_state = 2},
  [1097] = {.lex_state = 11, .external_lex_state = 2},
  [1098] = {.lex_state = 11, .external_lex_state = 2},
  [1099] = {.lex_state = 13},
  [1100] = {.lex_state = 11, .external_lex_state = 2},
  [1101] = {.lex_state = 11, .external_lex_state = 2},
  [1102] = {.lex_state = 11, .external_lex_state = 2},
  [1103] = {.lex_state = 11, .external_lex_state = 2},
  [1104] = {.lex_state = 11, .external_lex_state = 2},
  [1105] = {.lex_state = 11, .external_lex_state = 2},
  [1106] = {.lex_state = 11, .external_lex_state = 2},
  [1107] = {.lex_state = 11, .external_lex_state = 2},
  [1108] = {.lex_state = 11, .external_lex_state = 2},
  [1109] = {.lex_state = 11, .external_lex_state = 2},
  [1110] = {.lex_state = 11, .external_lex_state = 2},
  [1111] = {.lex_state = 11, .external_lex_state = 2},
  [1112] = {.lex_state = 11, .external_lex_state = 2},
  [1113] = {.lex_state = 11, .external_lex_state = 2},
  [1114] = {.lex_state = 11, .external_lex_state = 2},
  [1115] = {.lex_state = 11, .external_lex_state = 2},
  [1116] = {.lex_state = 11, .external_lex_state = 2},
  [1117] = {.lex_state = 11, .external_lex_state = 2},
  [1118] = {.lex_state = 11, .external_lex_state = 2},
  [1119] = {.lex_state = 11, .external_lex_state = 2},
  [1120] = {.lex_state = 11, .external_lex_state = 2},
  [1121] = {.lex_state = 11, .external_lex_state = 2},
  [1122] = {.lex_state = 11, .external_lex_state = 2},
  [1123] = {.lex_state = 11, .external_lex_state = 2},
  [1124] = {.lex_state = 11, .external_lex_state = 2},
  [1125] = {.lex_state = 11, .external_lex_state = 2},
  [1126] = {.lex_state = 11, .external_lex_state = 2},
  [1127] = {.lex_state = 11, .external_lex_state = 2},
  [1128] = {.lex_state = 11, .external_lex_state = 2},
  [1129] = {.lex_state = 11, .external_lex_state = 2},
  [1130] = {.lex_state = 11, .external_lex_state = 2},
  [1131] = {.lex_state = 11, .external_lex_state = 2},
  [1132] = {.lex_state = 11, .external_lex_state = 2},
  [1133] = {.lex_state = 11, .external_lex_state = 2},
  [1134] = {.lex_state = 11, .external_lex_state = 2},
  [1135] = {.lex_state = 11, .external_lex_state = 2},
  [1136] = {.lex_state = 11, .external_lex_state = 2},
  [1137] = {.lex_state = 11},
  [1138] = {.lex_state = 11},
  [1139] = {.lex_state = 11},
  [1140] = {.lex_state = 11},
  [1141] = {.lex_state = 11},
  [1142] = {.lex_state = 11},
  [1143] = {.lex_state = 11},
  [1144] = {.lex_state = 11},
  [1145] = {.lex_state = 11},
  [1146] = {.lex_state = 11},
  [1147] = {.lex_state = 11},
  [1148] = {.lex_state = 11},
  [1149] = {.lex_state = 11},
  [1150] = {.lex_state = 11},
  [1151] = {.lex_state = 11},
  [1152] = {.lex_state = 11},
  [1153] = {.lex_state = 11},
  [1154] = {.lex_state = 11},
  [1155] = {.lex_state = 11},
  [1156] = {.lex_state = 11},
  [1157] = {.lex_state = 11},
  [1158] = {.lex_state = 11},
  [1159] = {.lex_state = 11},
  [1160] = {.lex_state = 11},
  [1161] = {.lex_state = 11},
  [1162] = {.lex_state = 11},
  [1163] = {.lex_state = 11},
  [1164] = {.lex_state = 11},
  [1165] = {.lex_state = 11},
  [1166] = {.lex_state = 11},
  [1167] = {.lex_state = 11},
  [1168] = {.lex_state = 11},
  [1169] = {.lex_state = 11},
  [1170] = {.lex_state = 11},
  [1171] = {.lex_state = 11},
  [1172] = {.lex_state = 11},
  [1173] = {.lex_state = 11, .external_lex_state = 2},
  [1174] = {.lex_state = 11, .external_lex_state = 2},
  [1175] = {.lex_state = 11, .external_lex_state = 2},
  [1176] = {.lex_state = 11},
  [1177] = {.lex_state = 11},
  [1178] = {.lex_state = 11, .external_lex_state = 2},
  [1179] = {.lex_state = 11, .external_lex_state = 2},
  [1180] = {.lex_state = 11},
  [1181] = {.lex_state = 11},
  [1182] = {.lex_state = 11},
  [1183] = {.lex_state = 11},
  [1184] = {.lex_state = 11},
  [1185] = {.lex_state = 11},
  [1186] = {.lex_state = 11},
  [1187] = {.lex_state = 19},
  [1188] = {.lex_state = 13},
  [1189] = {.lex_state = 11},
  [1190] = {.lex_state = 13},
  [1191] = {.lex_state = 19},
  [1192] = {.lex_state = 19},
  [1193] = {.lex_state = 11},
  [1194] = {.lex_state = 11},
  [1195] = {.lex_state = 11},
  [1196] = {.lex_state = 11},
  [1197] = {.lex_state = 11},
  [1198] = {.lex_state = 11},
  [1199] = {.lex_state = 11},
  [1200] = {.lex_state = 11},
  [1201] = {.lex_state = 11},
  [1202] = {.lex_state = 19},
  [1203] = {.lex_state = 11},
  [1204] = {.lex_state = 11},
  [1205] = {.lex_state = 19},
  [1206] = {.lex_state = 11},
  [1207] = {.lex_state = 11},
  [1208] = {.lex_state = 11, .external_lex_state = 2},
  [1209] = {.lex_state = 11, .external_lex_state = 2},
  [1210] = {.lex_state = 11},
  [1211] = {.lex_state = 11, .external_lex_state = 2},
  [1212] = {.lex_state = 11},
  [1213] = {.lex_state = 11},
  [1214] = {.lex_state = 11},
  [1215] = {.lex_state = 11},
  [1216] = {.lex_state = 11, .external_lex_state = 2},
  [1217] = {.lex_state = 11, .external_lex_state = 2},
  [1218] = {.lex_state = 11},
  [1219] = {.lex_state = 11},
  [1220] = {.lex_state = 19},
  [1221] = {.lex_state = 11},
  [1222] = {.lex_state = 19},
  [1223] = {.lex_state = 11},
  [1224] = {.lex_state = 19},
  [1225] = {.lex_state = 11},
  [1226] = {.lex_state = 11},
  [1227] = {.lex_state = 11, .external_lex_state = 2},
  [1228] = {.lex_state = 19},
  [1229] = {.lex_state = 11},
  [1230] = {.lex_state = 11, .external_lex_state = 2},
  [1231] = {.lex_state = 11},
  [1232] = {.lex_state = 11},
  [1233] = {.lex_state = 11, .external_lex_state = 2},
  [1234] = {.lex_state = 11},
  [1235] = {.lex_state = 11},
  [1236] = {.lex_state = 11},
  [1237] = {.lex_state = 11},
  [1238] = {.lex_state = 11},
  [1239] = {.lex_state = 11},
  [1240] = {.lex_state = 11},
  [1241] = {.lex_state = 11},
  [1242] = {.lex_state = 11},
  [1243] = {.lex_state = 11},
  [1244] = {.lex_state = 11},
  [1245] = {.lex_state = 11},
  [1246] = {.lex_state = 11},
  [1247] = {.lex_state = 11},
  [1248] = {.lex_state = 11},
  [1249] = {.lex_state = 11},
  [1250] = {.lex_state = 11},
  [1251] = {.lex_state = 11},
  [1252] = {.lex_state = 11},
  [1253] = {.lex_state = 11},
  [1254] = {.lex_state = 11},
  [1255] = {.lex_state = 11},
  [1256] = {.lex_state = 11},
  [1257] = {.lex_state = 11},
  [1258] = {.lex_state = 11},
  [1259] = {.lex_state = 11},
  [1260] = {.lex_state = 11},
  [1261] = {.lex_state = 11},
  [1262] = {.lex_state = 11},
  [1263] = {.lex_state = 11},
  [1264] = {.lex_state = 11},
  [1265] = {.lex_state = 13},
  [1266] = {.lex_state = 11},
  [1267] = {.lex_state = 11},
  [1268] = {.lex_state = 11},
  [1269] = {.lex_state = 11},
  [1270] = {.lex_state = 11},
  [1271] = {.lex_state = 11},
  [1272] = {.lex_state = 11},
  [1273] = {.lex_state = 11},
  [1274] = {.lex_state = 11},
  [1275] = {.lex_state = 11},
  [1276] = {.lex_state = 11},
  [1277] = {.lex_state = 11},
  [1278] = {.lex_state = 11},
  [1279] = {.lex_state = 11},
  [1280] = {.lex_state = 11},
  [1281] = {.lex_state = 11},
  [1282] = {.lex_state = 11},
  [1283] = {.lex_state = 11},
  [1284] = {.lex_state = 11},
  [1285] = {.lex_state = 11},
  [1286] = {.lex_state = 11},
  [1287] = {.lex_state = 11},
  [1288] = {.lex_state = 11},
  [1289] = {.lex_state = 11},
  [1290] = {.lex_state = 11},
  [1291] = {.lex_state = 11},
  [1292] = {.lex_state = 11},
  [1293] = {.lex_state = 11},
  [1294] = {.lex_state = 11},
  [1295] = {.lex_state = 11},
  [1296] = {.lex_state = 11},
  [1297] = {.lex_state = 11},
  [1298] = {.lex_state = 11},
  [1299] = {.lex_state = 11},
  [1300] = {.lex_state = 11},
  [1301] = {.lex_state = 11},
  [1302] = {.lex_state = 11},
  [1303] = {.lex_state = 11},
  [1304] = {.lex_state = 19},
  [1305] = {.lex_state = 19},
  [1306] = {.lex_state = 19},
  [1307] = {.lex_state = 13},
  [1308] = {.lex_state = 19},
  [1309] = {.lex_state = 19},
  [1310] = {.lex_state = 13},
  [1311] = {.lex_state = 13},
  [1312] = {.lex_state = 13},
  [1313] = {.lex_state = 13},
  [1314] = {.lex_state = 18},
  [1315] = {.lex_state = 18},
  [1316] = {.lex_state = 11},
  [1317] = {.lex_state = 11},
  [1318] = {.lex_state = 11},
  [1319] = {.lex_state = 11},
  [1320] = {.lex_state = 11},
  [1321] = {.lex_state = 11},
  [1322] = {.lex_state = 11},
  [1323] = {.lex_state = 18},
  [1324] = {.lex_state = 18},
  [1325] = {.lex_state = 18},
  [1326] = {.lex_state = 11},
  [1327] = {.lex_state = 11},
  [1328] = {.lex_state = 11},
  [1329] = {.lex_state = 11},
  [1330] = {.lex_state = 11},
  [1331] = {.lex_state = 11},
  [1332] = {.lex_state = 11},
  [1333] = {.lex_state = 11},
  [1334] = {.lex_state = 11},
  [1335] = {.lex_state = 11},
  [1336] = {.lex_state = 11},
  [1337] = {.lex_state = 69},
  [1338] = {.lex_state = 69},
  [1339] = {.lex_state = 69},
  [1340] = {.lex_state = 11},
  [1341] = {.lex_state = 8},
  [1342] = {.lex_state = 8},
  [1343] = {.lex_state = 8},
  [1344] = {.lex_state = 19},
  [1345] = {.lex_state = 8},
  [1346] = {.lex_state = 19},
  [1347] = {.lex_state = 8},
  [1348] = {.lex_state = 16},
  [1349] = {.lex_state = 17},
  [1350] = {.lex_state = 3, .external_lex_state = 3},
  [1351] = {.lex_state = 19},
  [1352] = {.lex_state = 3, .external_lex_state = 3},
  [1353] = {.lex_state = 19},
  [1354] = {.lex_state = 19},
  [1355] = {.lex_state = 19},
  [1356] = {.lex_state = 3, .external_lex_state = 3},
  [1357] = {.lex_state = 19},
  [1358] = {.lex_state = 19},
  [1359] = {.lex_state = 19},
  [1360] = {.lex_state = 19},
  [1361] = {.lex_state = 19},
  [1362] = {.lex_state = 19},
  [1363] = {.lex_state = 19},
  [1364] = {.lex_state = 19},
  [1365] = {.lex_state = 19},
  [1366] = {.lex_state = 3, .external_lex_state = 3},
  [1367] = {.lex_state = 3, .external_lex_state = 3},
  [1368] = {.lex_state = 19},
  [1369] = {.lex_state = 19},
  [1370] = {.lex_state = 19},
  [1371] = {.lex_state = 3, .external_lex_state = 4},
  [1372] = {.lex_state = 19},
  [1373] = {.lex_state = 19},
  [1374] = {.lex_state = 19},
  [1375] = {.lex_state = 19},
  [1376] = {.lex_state = 19},
  [1377] = {.lex_state = 19},
  [1378] = {.lex_state = 19},
  [1379] = {.lex_state = 8, .external_lex_state = 5},
  [1380] = {.lex_state = 19},
  [1381] = {.lex_state = 8, .external_lex_state = 6},
  [1382] = {.lex_state = 19},
  [1383] = {.lex_state = 19},
  [1384] = {.lex_state = 13},
  [1385] = {.lex_state = 19},
  [1386] = {.lex_state = 13},
  [1387] = {.lex_state = 19},
  [1388] = {.lex_state = 13},
  [1389] = {.lex_state = 19},
  [1390] = {.lex_state = 19},
  [1391] = {.lex_state = 8, .external_lex_state = 6},
  [1392] = {.lex_state = 19},
  [1393] = {.lex_state = 8, .external_lex_state = 5},
  [1394] = {.lex_state = 8, .external_lex_state = 5},
  [1395] = {.lex_state = 19},
  [1396] = {.lex_state = 19},
  [1397] = {.lex_state = 8, .external_lex_state = 5},
  [1398] = {.lex_state = 19},
  [1399] = {.lex_state = 8, .external_lex_state = 5},
  [1400] = {.lex_state = 19},
  [1401] = {.lex_state = 19},
  [1402] = {.lex_state = 8},
  [1403] = {.lex_state = 19},
  [1404] = {.lex_state = 8, .external_lex_state = 6},
  [1405] = {.lex_state = 19},
  [1406] = {.lex_state = 19},
  [1407] = {.lex_state = 19},
  [1408] = {.lex_state = 19},
  [1409] = {.lex_state = 19},
  [1410] = {.lex_state = 8},
  [1411] = {.lex_state = 8, .external_lex_state = 6},
  [1412] = {.lex_state = 19},
  [1413] = {.lex_state = 8, .external_lex_state = 6},
  [1414] = {.lex_state = 19},
  [1415] = {.lex_state = 19},
  [1416] = {.lex_state = 13},
  [1417] = {.lex_state = 13},
  [1418] = {.lex_state = 13},
  [1419] = {.lex_state = 8, .external_lex_state = 4},
  [1420] = {.lex_state = 8},
  [1421] = {.lex_state = 13},
  [1422] = {.lex_state = 16},
  [1423] = {.lex_state = 13},
  [1424] = {.lex_state = 69},
  [1425] = {.lex_state = 13},
  [1426] = {.lex_state = 13},
  [1427] = {.lex_state = 69},
  [1428] = {.lex_state = 13},
  [1429] = {.lex_state = 69},
  [1430] = {.lex_state = 16},
  [1431] = {.lex_state = 13},
  [1432] = {.lex_state = 13},
  [1433] = {.lex_state = 13},
  [1434] = {.lex_state = 69},
  [1435] = {.lex_state = 13},
  [1436] = {.lex_state = 13},
  [1437] = {.lex_state = 69},
  [1438] = {.lex_state = 13},
  [1439] = {.lex_state = 8},
  [1440] = {.lex_state = 69},
  [1441] = {.lex_state = 69},
  [1442] = {.lex_state = 8},
  [1443] = {.lex_state = 13},
  [1444] = {.lex_state = 13},
  [1445] = {.lex_state = 13},
  [1446] = {.lex_state = 13},
  [1447] = {.lex_state = 13},
  [1448] = {.lex_state = 3, .external_lex_state = 7},
  [1449] = {.lex_state = 13},
  [1450] = {.lex_state = 13},
  [1451] = {.lex_state = 13},
  [1452] = {.lex_state = 69},
  [1453] = {.lex_state = 69},
  [1454] = {.lex_state = 13},
  [1455] = {.lex_state = 3, .external_lex_state = 7},
  [1456] = {.lex_state = 69},
  [1457] = {.lex_state = 69},
  [1458] = {.lex_state = 8},
  [1459] = {.lex_state = 69},
  [1460] = {.lex_state = 8},
  [1461] = {.lex_state = 8},
  [1462] = {.lex_state = 8},
  [1463] = {.lex_state = 8},
  [1464] = {.lex_state = 69},
  [1465] = {.lex_state = 8},
  [1466] = {.lex_state = 8},
  [1467] = {.lex_state = 8},
  [1468] = {.lex_state = 8},
  [1469] = {.lex_state = 13},
  [1470] = {.lex_state = 8},
  [1471] = {.lex_state = 69},
  [1472] = {.lex_state = 69},
  [1473] = {.lex_state = 8},
  [1474] = {.lex_state = 8},
  [1475] = {.lex_state = 8},
  [1476] = {.lex_state = 8},
  [1477] = {.lex_state = 8},
  [1478] = {.lex_state = 8},
  [1479] = {.lex_state = 8},
  [1480] = {.lex_state = 69},
  [1481] = {.lex_state = 8},
  [1482] = {.lex_state = 8, .external_lex_state = 8},
  [1483] = {.lex_state = 69},
  [1484] = {.lex_state = 8},
  [1485] = {.lex_state = 13},
  [1486] = {.lex_state = 8},
  [1487] = {.lex_state = 8},
  [1488] = {.lex_state = 69},
  [1489] = {.lex_state = 8},
  [1490] = {.lex_state = 8},
  [1491] = {.lex_state = 69},
  [1492] = {.lex_state = 8},
  [1493] = {.lex_state = 8},
  [1494] = {.lex_state = 8},
  [1495] = {.lex_state = 8},
  [1496] = {.lex_state = 8},
  [1497] = {.lex_state = 8},
  [1498] = {.lex_state = 8},
  [1499] = {.lex_state = 8},
  [1500] = {.lex_state = 8},
  [1501] = {.lex_state = 8},
  [1502] = {.lex_state = 8},
  [1503] = {.lex_state = 8},
  [1504] = {.lex_state = 8},
  [1505] = {.lex_state = 8},
  [1506] = {.lex_state = 8},
  [1507] = {.lex_state = 69},
  [1508] = {.lex_state = 8},
  [1509] = {.lex_state = 8, .external_lex_state = 9},
  [1510] = {.lex_state = 8},
  [1511] = {.lex_state = 8},
  [1512] = {.lex_state = 8},
  [1513] = {.lex_state = 8},
  [1514] = {.lex_state = 8, .external_lex_state = 9},
  [1515] = {.lex_state = 8, .external_lex_state = 8},
  [1516] = {.lex_state = 8},
  [1517] = {.lex_state = 8},
  [1518] = {.lex_state = 8},
  [1519] = {.lex_state = 69},
  [1520] = {.lex_state = 8},
  [1521] = {.lex_state = 69},
  [1522] = {.lex_state = 69},
  [1523] = {.lex_state = 8},
  [1524] = {.lex_state = 69},
  [1525] = {.lex_state = 69},
  [1526] = {.lex_state = 69},
  [1527] = {.lex_state = 69},
  [1528] = {.lex_state = 69, .external_lex_state = 2},
  [1529] = {.lex_state = 69},
  [1530] = {.lex_state = 69},
  [1531] = {.lex_state = 69},
  [1532] = {.lex_state = 69, .external_lex_state = 2},
  [1533] = {.lex_state = 69},
  [1534] = {.lex_state = 69},
  [1535] = {.lex_state = 69},
  [1536] = {.lex_state = 69},
  [1537] = {.lex_state = 69},
  [1538] = {.lex_state = 10},
  [1539] = {.lex_state = 69, .external_lex_state = 2},
  [1540] = {.lex_state = 69},
  [1541] = {.lex_state = 10},
  [1542] = {.lex_state = 69},
  [1543] = {.lex_state = 69},
  [1544] = {.lex_state = 69},
  [1545] = {.lex_state = 8},
  [1546] = {.lex_state = 69},
  [1547] = {.lex_state = 13},
  [1548] = {.lex_state = 3, .external_lex_state = 3},
  [1549] = {.lex_state = 3, .external_lex_state = 3},
  [1550] = {.lex_state = 3, .external_lex_state = 3},
  [1551] = {.lex_state = 69},
  [1552] = {.lex_state = 69},
  [1553] = {.lex_state = 69},
  [1554] = {.lex_state = 3, .external_lex_state = 3},
  [1555] = {.lex_state = 3, .external_lex_state = 3},
  [1556] = {.lex_state = 69},
  [1557] = {.lex_state = 3, .external_lex_state = 3},
  [1558] = {.lex_state = 69, .external_lex_state = 2},
  [1559] = {.lex_state = 69},
  [1560] = {.lex_state = 3, .external_lex_state = 3},
  [1561] = {.lex_state = 3, .external_lex_state = 3},
  [1562] = {.lex_state = 69},
  [1563] = {.lex_state = 69},
  [1564] = {.lex_state = 69},
  [1565] = {.lex_state = 69},
  [1566] = {.lex_state = 69},
  [1567] = {.lex_state = 10},
  [1568] = {.lex_state = 69},
  [1569] = {.lex_state = 69},
  [1570] = {.lex_state = 13},
  [1571] = {.lex_state = 8},
  [1572] = {.lex_state = 69},
  [1573] = {.lex_state = 69},
  [1574] = {.lex_state = 69},
  [1575] = {.lex_state = 69},
  [1576] = {.lex_state = 69},
  [1577] = {.lex_state = 69},
  [1578] = {.lex_state = 69},
  [1579] = {.lex_state = 8},
  [1580] = {.lex_state = 69},
  [1581] = {.lex_state = 69},
  [1582] = {.lex_state = 69},
  [1583] = {.lex_state = 8, .external_lex_state = 5},
  [1584] = {.lex_state = 69},
  [1585] = {.lex_state = 69},
  [1586] = {.lex_state = 8},
  [1587] = {.lex_state = 69},
  [1588] = {.lex_state = 69},
  [1589] = {.lex_state = 69},
  [1590] = {.lex_state = 69},
  [1591] = {.lex_state = 69},
  [1592] = {.lex_state = 8},
  [1593] = {.lex_state = 69},
  [1594] = {.lex_state = 8, .external_lex_state = 6},
  [1595] = {.lex_state = 69},
  [1596] = {.lex_state = 69},
  [1597] = {.lex_state = 69, .external_lex_state = 2},
  [1598] = {.lex_state = 8, .external_lex_state = 6},
  [1599] = {.lex_state = 69},
  [1600] = {.lex_state = 69},
  [1601] = {.lex_state = 69},
  [1602] = {.lex_state = 8, .external_lex_state = 5},
  [1603] = {.lex_state = 8, .external_lex_state = 5},
  [1604] = {.lex_state = 8, .external_lex_state = 5},
  [1605] = {.lex_state = 8, .external_lex_state = 6},
  [1606] = {.lex_state = 69},
  [1607] = {.lex_state = 8, .external_lex_state = 6},
  [1608] = {.lex_state = 8},
  [1609] = {.lex_state = 69},
  [1610] = {.lex_state = 69},
  [1611] = {.lex_state = 8, .external_lex_state = 5},
  [1612] = {.lex_state = 8},
  [1613] = {.lex_state = 69},
  [1614] = {.lex_state = 69},
  [1615] = {.lex_state = 69},
  [1616] = {.lex_state = 69},
  [1617] = {.lex_state = 69},
  [1618] = {.lex_state = 8, .external_lex_state = 5},
  [1619] = {.lex_state = 69},
  [1620] = {.lex_state = 69},
  [1621] = {.lex_state = 69},
  [1622] = {.lex_state = 8},
  [1623] = {.lex_state = 69},
  [1624] = {.lex_state = 8, .external_lex_state = 6},
  [1625] = {.lex_state = 8, .external_lex_state = 6},
  [1626] = {.lex_state = 69},
  [1627] = {.lex_state = 69},
  [1628] = {.lex_state = 69},
  [1629] = {.lex_state = 69},
  [1630] = {.lex_state = 69},
  [1631] = {.lex_state = 69},
  [1632] = {.lex_state = 69},
  [1633] = {.lex_state = 69},
  [1634] = {.lex_state = 69},
  [1635] = {.lex_state = 69},
  [1636] = {.lex_state = 69},
  [1637] = {.lex_state = 69},
  [1638] = {.lex_state = 69},
  [1639] = {.lex_state = 69},
  [1640] = {.lex_state = 8, .external_lex_state = 6},
  [1641] = {.lex_state = 69, .external_lex_state = 2},
  [1642] = {.lex_state = 8},
  [1643] = {.lex_state = 69},
  [1644] = {.lex_state = 69},
  [1645] = {.lex_state = 8, .external_lex_state = 5},
  [1646] = {.lex_state = 69},
  [1647] = {.lex_state = 69},
  [1648] = {.lex_state = 8},
  [1649] = {.lex_state = 8, .external_lex_state = 6},
  [1650] = {.lex_state = 69},
  [1651] = {.lex_state = 69, .external_lex_state = 2},
  [1652] = {.lex_state = 69},
  [1653] = {.lex_state = 69},
  [1654] = {.lex_state = 8, .external_lex_state = 5},
  [1655] = {.lex_state = 69},
  [1656] = {.lex_state = 69},
  [1657] = {.lex_state = 69},
  [1658] = {.lex_state = 69, .external_lex_state = 2},
  [1659] = {.lex_state = 69},
  [1660] = {.lex_state = 69, .external_lex_state = 2},
  [1661] = {.lex_state = 69},
  [1662] = {.lex_state = 69, .external_lex_state = 2},
  [1663] = {.lex_state = 69, .external_lex_state = 2},
  [1664] = {.lex_state = 69},
  [1665] = {.lex_state = 69, .external_lex_state = 2},
  [1666] = {.lex_state = 69},
  [1667] = {.lex_state = 69, .external_lex_state = 2},
  [1668] = {.lex_state = 69, .external_lex_state = 2},
  [1669] = {.lex_state = 69},
  [1670] = {.lex_state = 13},
  [1671] = {.lex_state = 69},
  [1672] = {.lex_state = 69},
  [1673] = {.lex_state = 69},
  [1674] = {.lex_state = 69, .external_lex_state = 2},
  [1675] = {.lex_state = 69, .external_lex_state = 2},
  [1676] = {.lex_state = 69},
  [1677] = {.lex_state = 69, .external_lex_state = 2},
  [1678] = {.lex_state = 69},
  [1679] = {.lex_state = 69, .external_lex_state = 2},
  [1680] = {.lex_state = 69},
  [1681] = {.lex_state = 69, .external_lex_state = 2},
  [1682] = {.lex_state = 69},
  [1683] = {.lex_state = 69},
  [1684] = {.lex_state = 69},
  [1685] = {.lex_state = 13},
  [1686] = {.lex_state = 69, .external_lex_state = 2},
  [1687] = {.lex_state = 13},
  [1688] = {.lex_state = 69},
  [1689] = {.lex_state = 69, .external_lex_state = 2},
  [1690] = {.lex_state = 69, .external_lex_state = 2},
  [1691] = {.lex_state = 69},
  [1692] = {.lex_state = 69, .external_lex_state = 2},
  [1693] = {.lex_state = 69, .external_lex_state = 2},
  [1694] = {.lex_state = 69},
  [1695] = {.lex_state = 69},
  [1696] = {.lex_state = 69},
  [1697] = {.lex_state = 69, .external_lex_state = 2},
  [1698] = {.lex_state = 69, .external_lex_state = 2},
  [1699] = {.lex_state = 69, .external_lex_state = 2},
  [1700] = {.lex_state = 69},
  [1701] = {.lex_state = 69},
  [1702] = {.lex_state = 69},
  [1703] = {.lex_state = 69},
  [1704] = {.lex_state = 69},
  [1705] = {.lex_state = 69, .external_lex_state = 2},
  [1706] = {.lex_state = 69},
  [1707] = {.lex_state = 69},
  [1708] = {.lex_state = 69},
  [1709] = {.lex_state = 69},
  [1710] = {.lex_state = 69},
  [1711] = {.lex_state = 13},
  [1712] = {.lex_state = 69},
  [1713] = {.lex_state = 69},
  [1714] = {.lex_state = 69},
  [1715] = {.lex_state = 69},
  [1716] = {.lex_state = 69, .external_lex_state = 2},
  [1717] = {.lex_state = 69, .external_lex_state = 2},
  [1718] = {.lex_state = 69, .external_lex_state = 2},
  [1719] = {.lex_state = 69, .external_lex_state = 2},
  [1720] = {.lex_state = 69},
  [1721] = {.lex_state = 13},
  [1722] = {.lex_state = 69, .external_lex_state = 2},
  [1723] = {.lex_state = 69, .external_lex_state = 2},
  [1724] = {.lex_state = 13},
  [1725] = {.lex_state = 69, .external_lex_state = 2},
  [1726] = {.lex_state = 8},
  [1727] = {.lex_state = 13},
  [1728] = {.lex_state = 69, .external_lex_state = 2},
  [1729] = {.lex_state = 69},
  [1730] = {.lex_state = 69},
  [1731] = {.lex_state = 69, .external_lex_state = 2},
  [1732] = {.lex_state = 69},
  [1733] = {.lex_state = 69},
  [1734] = {.lex_state = 69, .external_lex_state = 2},
  [1735] = {.lex_state = 13},
  [1736] = {.lex_state = 69},
  [1737] = {.lex_state = 69},
  [1738] = {.lex_state = 69},
  [1739] = {.lex_state = 69},
  [1740] = {.lex_state = 69},
  [1741] = {.lex_state = 69},
  [1742] = {.lex_state = 69, .external_lex_state = 2},
  [1743] = {.lex_state = 69, .external_lex_state = 2},
  [1744] = {.lex_state = 69, .external_lex_state = 2},
  [1745] = {.lex_state = 69},
  [1746] = {.lex_state = 69},
  [1747] = {.lex_state = 69, .external_lex_state = 2},
  [1748] = {.lex_state = 69, .external_lex_state = 2},
  [1749] = {.lex_state = 69, .external_lex_state = 2},
  [1750] = {.lex_state = 69, .external_lex_state = 2},
  [1751] = {.lex_state = 69, .external_lex_state = 2},
  [1752] = {.lex_state = 69},
  [1753] = {.lex_state = 69},
  [1754] = {.lex_state = 69, .external_lex_state = 2},
  [1755] = {.lex_state = 69, .external_lex_state = 2},
  [1756] = {.lex_state = 69, .external_lex_state = 2},
  [1757] = {.lex_state = 69},
  [1758] = {.lex_state = 69, .external_lex_state = 2},
  [1759] = {.lex_state = 69},
  [1760] = {.lex_state = 69, .external_lex_state = 2},
  [1761] = {.lex_state = 69},
  [1762] = {.lex_state = 69, .external_lex_state = 2},
  [1763] = {.lex_state = 69, .external_lex_state = 2},
  [1764] = {.lex_state = 69, .external_lex_state = 2},
  [1765] = {.lex_state = 69},
  [1766] = {.lex_state = 69},
  [1767] = {.lex_state = 69},
  [1768] = {.lex_state = 69},
  [1769] = {.lex_state = 69},
  [1770] = {.lex_state = 69, .external_lex_state = 2},
  [1771] = {.lex_state = 69},
  [1772] = {.lex_state = 8},
  [1773] = {.lex_state = 22},
  [1774] = {.lex_state = 69},
  [1775] = {.lex_state = 69},
  [1776] = {.lex_state = 69},
  [1777] = {.lex_state = 69},
  [1778] = {.lex_state = 8},
  [1779] = {.lex_state = 13},
  [1780] = {.lex_state = 69},
  [1781] = {.lex_state = 69},
  [1782] = {.lex_state = 69, .external_lex_state = 2},
  [1783] = {.lex_state = 69},
  [1784] = {.lex_state = 69, .external_lex_state = 2},
  [1785] = {.lex_state = 69, .external_lex_state = 2},
  [1786] = {.lex_state = 69},
  [1787] = {.lex_state = 69, .external_lex_state = 2},
  [1788] = {.lex_state = 69},
  [1789] = {.lex_state = 69},
  [1790] = {.lex_state = 69},
  [1791] = {.lex_state = 69},
  [1792] = {.lex_state = 69},
  [1793] = {.lex_state = 13},
  [1794] = {.lex_state = 69},
  [1795] = {.lex_state = 69},
  [1796] = {.lex_state = 69, .external_lex_state = 2},
  [1797] = {.lex_state = 69, .external_lex_state = 2},
  [1798] = {.lex_state = 69, .external_lex_state = 2},
  [1799] = {.lex_state = 22},
  [1800] = {.lex_state = 69, .external_lex_state = 2},
  [1801] = {.lex_state = 69, .external_lex_state = 2},
  [1802] = {.lex_state = 69, .external_lex_state = 2},
  [1803] = {.lex_state = 69},
  [1804] = {.lex_state = 69},
  [1805] = {.lex_state = 69, .external_lex_state = 2},
  [1806] = {.lex_state = 69},
  [1807] = {.lex_state = 69, .external_lex_state = 2},
  [1808] = {.lex_state = 69, .external_lex_state = 2},
  [1809] = {.lex_state = 69},
  [1810] = {.lex_state = 22},
  [1811] = {.lex_state = 13},
  [1812] = {.lex_state = 69, .external_lex_state = 2},
  [1813] = {.lex_state = 69, .external_lex_state = 2},
  [1814] = {.lex_state = 69},
  [1815] = {.lex_state = 69, .external_lex_state = 2},
  [1816] = {.lex_state = 69, .external_lex_state = 2},
  [1817] = {.lex_state = 69, .external_lex_state = 2},
  [1818] = {.lex_state = 69},
  [1819] = {.lex_state = 69, .external_lex_state = 2},
  [1820] = {.lex_state = 69, .external_lex_state = 2},
  [1821] = {.lex_state = 69, .external_lex_state = 2},
  [1822] = {.lex_state = 69},
  [1823] = {.lex_state = 69, .external_lex_state = 2},
  [1824] = {.lex_state = 69},
  [1825] = {.lex_state = 69, .external_lex_state = 2},
  [1826] = {.lex_state = 69, .external_lex_state = 2},
  [1827] = {.lex_state = 69},
  [1828] = {.lex_state = 69, .external_lex_state = 2},
  [1829] = {.lex_state = 69},
  [1830] = {.lex_state = 69},
  [1831] = {.lex_state = 69},
  [1832] = {.lex_state = 69, .external_lex_state = 2},
  [1833] = {.lex_state = 69},
  [1834] = {.lex_state = 69},
  [1835] = {.lex_state = 69},
  [1836] = {.lex_state = 69, .external_lex_state = 2},
  [1837] = {.lex_state = 69},
  [1838] = {.lex_state = 69},
  [1839] = {.lex_state = 69},
  [1840] = {.lex_state = 69},
  [1841] = {.lex_state = 69, .external_lex_state = 2},
  [1842] = {.lex_state = 69},
  [1843] = {.lex_state = 69},
  [1844] = {.lex_state = 69, .external_lex_state = 2},
  [1845] = {.lex_state = 69, .external_lex_state = 2},
  [1846] = {.lex_state = 69},
  [1847] = {.lex_state = 69, .external_lex_state = 2},
  [1848] = {.lex_state = 69},
  [1849] = {.lex_state = 69},
  [1850] = {.lex_state = 22},
  [1851] = {.lex_state = 69},
  [1852] = {.lex_state = 69},
  [1853] = {.lex_state = 69},
  [1854] = {.lex_state = 69, .external_lex_state = 2},
  [1855] = {.lex_state = 69, .external_lex_state = 2},
  [1856] = {.lex_state = 69},
  [1857] = {.lex_state = 69},
  [1858] = {.lex_state = 69},
  [1859] = {.lex_state = 3, .external_lex_state = 10},
  [1860] = {.lex_state = 69},
  [1861] = {.lex_state = 69},
  [1862] = {.lex_state = 69},
  [1863] = {.lex_state = 22},
  [1864] = {.lex_state = 69},
  [1865] = {.lex_state = 69, .external_lex_state = 2},
  [1866] = {.lex_state = 69, .external_lex_state = 2},
  [1867] = {.lex_state = 69},
  [1868] = {.lex_state = 69},
  [1869] = {.lex_state = 69},
  [1870] = {.lex_state = 69, .external_lex_state = 2},
  [1871] = {.lex_state = 69},
  [1872] = {.lex_state = 69, .external_lex_state = 2},
  [1873] = {.lex_state = 69},
  [1874] = {.lex_state = 69, .external_lex_state = 2},
  [1875] = {.lex_state = 69, .external_lex_state = 2},
  [1876] = {.lex_state = 69, .external_lex_state = 2},
  [1877] = {.lex_state = 69, .external_lex_state = 2},
  [1878] = {.lex_state = 69},
  [1879] = {.lex_state = 69, .external_lex_state = 2},
  [1880] = {.lex_state = 69, .external_lex_state = 2},
  [1881] = {.lex_state = 69, .external_lex_state = 2},
  [1882] = {.lex_state = 69},
  [1883] = {.lex_state = 69},
  [1884] = {.lex_state = 69, .external_lex_state = 2},
  [1885] = {.lex_state = 69},
  [1886] = {.lex_state = 69, .external_lex_state = 2},
  [1887] = {.lex_state = 69, .external_lex_state = 2},
  [1888] = {.lex_state = 69, .external_lex_state = 2},
  [1889] = {.lex_state = 69, .external_lex_state = 2},
  [1890] = {.lex_state = 69},
  [1891] = {.lex_state = 69, .external_lex_state = 2},
  [1892] = {.lex_state = 69, .external_lex_state = 2},
  [1893] = {.lex_state = 69},
  [1894] = {.lex_state = 69, .external_lex_state = 2},
  [1895] = {.lex_state = 69},
  [1896] = {.lex_state = 69},
  [1897] = {.lex_state = 69},
  [1898] = {.lex_state = 69, .external_lex_state = 2},
  [1899] = {.lex_state = 69, .external_lex_state = 2},
  [1900] = {.lex_state = 69},
  [1901] = {.lex_state = 69, .external_lex_state = 2},
  [1902] = {.lex_state = 69, .external_lex_state = 2},
  [1903] = {.lex_state = 3, .external_lex_state = 10},
  [1904] = {.lex_state = 69},
  [1905] = {.lex_state = 69, .external_lex_state = 2},
  [1906] = {.lex_state = 69},
  [1907] = {.lex_state = 69},
  [1908] = {.lex_state = 69},
  [1909] = {.lex_state = 69, .external_lex_state = 2},
  [1910] = {.lex_state = 69, .external_lex_state = 2},
  [1911] = {.lex_state = 69, .external_lex_state = 2},
  [1912] = {.lex_state = 69},
  [1913] = {.lex_state = 69},
  [1914] = {.lex_state = 69},
  [1915] = {.lex_state = 69, .external_lex_state = 11},
  [1916] = {.lex_state = 69},
  [1917] = {.lex_state = 69},
  [1918] = {.lex_state = 69},
  [1919] = {.lex_state = 69},
  [1920] = {.lex_state = 69},
  [1921] = {.lex_state = 69},
  [1922] = {.lex_state = 69},
  [1923] = {.lex_state = 69},
  [1924] = {.lex_state = 69},
  [1925] = {.lex_state = 69},
  [1926] = {.lex_state = 69},
  [1927] = {.lex_state = 69},
  [1928] = {.lex_state = 69},
  [1929] = {.lex_state = 69},
  [1930] = {.lex_state = 69},
  [1931] = {.lex_state = 3, .external_lex_state = 12},
  [1932] = {.lex_state = 69},
  [1933] = {.lex_state = 69},
  [1934] = {.lex_state = 69},
  [1935] = {.lex_state = 69},
  [1936] = {.lex_state = 69},
  [1937] = {.lex_state = 69},
  [1938] = {.lex_state = 69, .external_lex_state = 2},
  [1939] = {.lex_state = 69},
  [1940] = {.lex_state = 13},
  [1941] = {.lex_state = 69},
  [1942] = {.lex_state = 69},
  [1943] = {.lex_state = 69},
  [1944] = {.lex_state = 69},
  [1945] = {.lex_state = 69},
  [1946] = {.lex_state = 69},
  [1947] = {.lex_state = 69},
  [1948] = {.lex_state = 69},
  [1949] = {.lex_state = 69},
  [1950] = {.lex_state = 69},
  [1951] = {.lex_state = 3, .external_lex_state = 12},
  [1952] = {.lex_state = 69},
  [1953] = {.lex_state = 69},
  [1954] = {.lex_state = 69},
  [1955] = {.lex_state = 69},
  [1956] = {.lex_state = 69},
  [1957] = {.lex_state = 69},
  [1958] = {.lex_state = 69},
  [1959] = {.lex_state = 69},
  [1960] = {.lex_state = 69},
  [1961] = {.lex_state = 69},
  [1962] = {.lex_state = 69},
  [1963] = {.lex_state = 3, .external_lex_state = 12},
  [1964] = {.lex_state = 3, .external_lex_state = 12},
  [1965] = {.lex_state = 69, .external_lex_state = 2},
  [1966] = {.lex_state = 69},
  [1967] = {.lex_state = 69, .external_lex_state = 2},
  [1968] = {.lex_state = 69},
  [1969] = {.lex_state = 69},
  [1970] = {.lex_state = 69},
  [1971] = {.lex_state = 69, .external_lex_state = 2},
  [1972] = {.lex_state = 69, .external_lex_state = 2},
  [1973] = {.lex_state = 69},
  [1974] = {.lex_state = 69},
  [1975] = {.lex_state = 69},
  [1976] = {.lex_state = 13},
  [1977] = {.lex_state = 69},
  [1978] = {.lex_state = 69},
  [1979] = {.lex_state = 13},
  [1980] = {.lex_state = 69},
  [1981] = {.lex_state = 69},
  [1982] = {.lex_state = 69},
  [1983] = {.lex_state = 69},
  [1984] = {.lex_state = 69},
  [1985] = {.lex_state = 69, .external_lex_state = 2},
  [1986] = {.lex_state = 69},
  [1987] = {.lex_state = 69},
  [1988] = {.lex_state = 69},
  [1989] = {.lex_state = 69},
  [1990] = {.lex_state = 69},
  [1991] = {.lex_state = 69},
  [1992] = {.lex_state = 69},
  [1993] = {.lex_state = 69},
  [1994] = {.lex_state = 69},
  [1995] = {.lex_state = 69},
  [1996] = {.lex_state = 69},
  [1997] = {.lex_state = 69},
  [1998] = {.lex_state = 69},
  [1999] = {.lex_state = 69},
  [2000] = {.lex_state = 69},
  [2001] = {.lex_state = 69},
  [2002] = {.lex_state = 69},
  [2003] = {.lex_state = 69},
  [2004] = {.lex_state = 69},
  [2005] = {.lex_state = 69},
  [2006] = {.lex_state = 69},
  [2007] = {.lex_state = 69},
  [2008] = {.lex_state = 69},
  [2009] = {.lex_state = 69},
  [2010] = {.lex_state = 69},
  [2011] = {.lex_state = 3, .external_lex_state = 12},
  [2012] = {.lex_state = 69},
  [2013] = {.lex_state = 3, .external_lex_state = 12},
  [2014] = {.lex_state = 69},
  [2015] = {.lex_state = 69},
  [2016] = {.lex_state = 69},
  [2017] = {.lex_state = 69},
  [2018] = {.lex_state = 69},
  [2019] = {.lex_state = 69},
  [2020] = {.lex_state = 69},
  [2021] = {.lex_state = 69},
  [2022] = {.lex_state = 69},
  [2023] = {.lex_state = 69},
  [2024] = {.lex_state = 69},
  [2025] = {.lex_state = 69},
  [2026] = {.lex_state = 69},
  [2027] = {.lex_state = 69},
  [2028] = {.lex_state = 69},
  [2029] = {.lex_state = 69},
  [2030] = {.lex_state = 69},
  [2031] = {.lex_state = 69},
  [2032] = {.lex_state = 13},
  [2033] = {.lex_state = 69},
  [2034] = {.lex_state = 69},
  [2035] = {.lex_state = 69},
  [2036] = {.lex_state = 69},
  [2037] = {.lex_state = 69, .external_lex_state = 2},
  [2038] = {.lex_state = 69},
  [2039] = {.lex_state = 69},
  [2040] = {.lex_state = 69},
  [2041] = {.lex_state = 69},
  [2042] = {.lex_state = 69},
  [2043] = {.lex_state = 69},
  [2044] = {.lex_state = 69},
  [2045] = {.lex_state = 69},
  [2046] = {.lex_state = 69},
  [2047] = {.lex_state = 69},
  [2048] = {.lex_state = 69},
  [2049] = {.lex_state = 69},
  [2050] = {.lex_state = 69},
  [2051] = {.lex_state = 69},
  [2052] = {.lex_state = 69},
  [2053] = {.lex_state = 69},
  [2054] = {.lex_state = 69},
  [2055] = {.lex_state = 69},
  [2056] = {.lex_state = 69},
  [2057] = {.lex_state = 69},
  [2058] = {.lex_state = 69},
  [2059] = {.lex_state = 69},
  [2060] = {.lex_state = 69},
  [2061] = {.lex_state = 69},
  [2062] = {.lex_state = 69},
  [2063] = {.lex_state = 69},
  [2064] = {.lex_state = 69},
  [2065] = {.lex_state = 69},
  [2066] = {.lex_state = 69},
  [2067] = {.lex_state = 69},
  [2068] = {.lex_state = 69},
  [2069] = {.lex_state = 69},
  [2070] = {.lex_state = 69},
  [2071] = {.lex_state = 69},
  [2072] = {.lex_state = 69},
  [2073] = {.lex_state = 69},
  [2074] = {.lex_state = 69},
  [2075] = {.lex_state = 69},
  [2076] = {.lex_state = 69},
  [2077] = {.lex_state = 69},
  [2078] = {.lex_state = 69},
  [2079] = {.lex_state = 69},
  [2080] = {.lex_state = 69},
  [2081] = {.lex_state = 178, .external_lex_state = 13},
  [2082] = {.lex_state = 69},
  [2083] = {.lex_state = 69},
  [2084] = {.lex_state = 69},
  [2085] = {.lex_state = 69},
  [2086] = {.lex_state = 69},
  [2087] = {.lex_state = 69},
  [2088] = {.lex_state = 69},
  [2089] = {.lex_state = 69},
  [2090] = {.lex_state = 69},
  [2091] = {.lex_state = 69},
  [2092] = {.lex_state = 69},
  [2093] = {.lex_state = 69},
  [2094] = {.lex_state = 69},
  [2095] = {.lex_state = 69, .external_lex_state = 2},
  [2096] = {.lex_state = 69},
  [2097] = {.lex_state = 69},
  [2098] = {.lex_state = 69},
  [2099] = {.lex_state = 69},
  [2100] = {.lex_state = 69},
  [2101] = {.lex_state = 69},
  [2102] = {.lex_state = 69},
  [2103] = {.lex_state = 69},
  [2104] = {.lex_state = 69, .external_lex_state = 11},
  [2105] = {.lex_state = 69},
  [2106] = {.lex_state = 69},
  [2107] = {.lex_state = 69},
  [2108] = {.lex_state = 69},
  [2109] = {.lex_state = 69},
  [2110] = {.lex_state = 69},
  [2111] = {.lex_state = 69},
  [2112] = {.lex_state = 69},
  [2113] = {.lex_state = 69, .external_lex_state = 2},
  [2114] = {.lex_state = 69, .external_lex_state = 2},
  [2115] = {.lex_state = 69},
  [2116] = {.lex_state = 69},
  [2117] = {.lex_state = 69},
  [2118] = {.lex_state = 69},
  [2119] = {.lex_state = 69},
  [2120] = {.lex_state = 69},
  [2121] = {.lex_state = 69},
  [2122] = {.lex_state = 69},
  [2123] = {.lex_state = 69},
  [2124] = {.lex_state = 69},
  [2125] = {.lex_state = 69},
  [2126] = {.lex_state = 69},
  [2127] = {.lex_state = 69},
  [2128] = {.lex_state = 69},
  [2129] = {.lex_state = 69},
  [2130] = {.lex_state = 69},
  [2131] = {.lex_state = 69},
  [2132] = {.lex_state = 69},
  [2133] = {.lex_state = 69},
  [2134] = {.lex_state = 69},
  [2135] = {.lex_state = 69},
  [2136] = {.lex_state = 69},
  [2137] = {.lex_state = 69},
  [2138] = {.lex_state = 69},
  [2139] = {.lex_state = 69},
  [2140] = {.lex_state = 69},
  [2141] = {.lex_state = 69},
  [2142] = {.lex_state = 69},
  [2143] = {.lex_state = 69, .external_lex_state = 2},
  [2144] = {.lex_state = 69},
  [2145] = {.lex_state = 69},
  [2146] = {.lex_state = 69},
  [2147] = {.lex_state = 69},
  [2148] = {.lex_state = 69},
  [2149] = {.lex_state = 69, .external_lex_state = 2},
  [2150] = {.lex_state = 69},
  [2151] = {.lex_state = 69},
  [2152] = {.lex_state = 69},
  [2153] = {.lex_state = 69},
  [2154] = {.lex_state = 69},
  [2155] = {.lex_state = 69},
  [2156] = {.lex_state = 69, .external_lex_state = 2},
  [2157] = {.lex_state = 69, .external_lex_state = 2},
  [2158] = {.lex_state = 69},
  [2159] = {.lex_state = 69, .external_lex_state = 2},
  [2160] = {.lex_state = 69},
  [2161] = {.lex_state = 69},
  [2162] = {.lex_state = 69},
  [2163] = {.lex_state = 69},
  [2164] = {.lex_state = 69},
  [2165] = {.lex_state = 69},
  [2166] = {.lex_state = 69},
  [2167] = {.lex_state = 69},
  [2168] = {.lex_state = 69},
  [2169] = {.lex_state = 69},
  [2170] = {.lex_state = 69},
  [2171] = {.lex_state = 69},
  [2172] = {.lex_state = 69},
  [2173] = {.lex_state = 69, .external_lex_state = 2},
  [2174] = {.lex_state = 69},
  [2175] = {.lex_state = 69},
  [2176] = {.lex_state = 69},
  [2177] = {.lex_state = 69},
  [2178] = {.lex_state = 69},
  [2179] = {.lex_state = 69},
  [2180] = {.lex_state = 69},
  [2181] = {.lex_state = 3, .external_lex_state = 12},
  [2182] = {.lex_state = 69},
  [2183] = {.lex_state = 69},
  [2184] = {.lex_state = 69},
  [2185] = {.lex_state = 69},
  [2186] = {.lex_state = 69},
  [2187] = {.lex_state = 69},
  [2188] = {.lex_state = 69},
  [2189] = {.lex_state = 69},
  [2190] = {.lex_state = 69, .external_lex_state = 2},
  [2191] = {.lex_state = 69},
  [2192] = {.lex_state = 69},
  [2193] = {.lex_state = 69},
  [2194] = {.lex_state = 69},
  [2195] = {.lex_state = 69},
  [2196] = {.lex_state = 69},
  [2197] = {.lex_state = 69},
  [2198] = {.lex_state = 69},
  [2199] = {.lex_state = 69},
  [2200] = {.lex_state = 69},
  [2201] = {.lex_state = 69, .external_lex_state = 2},
  [2202] = {.lex_state = 69},
  [2203] = {.lex_state = 69},
  [2204] = {.lex_state = 69},
  [2205] = {.lex_state = 3, .external_lex_state = 12},
  [2206] = {.lex_state = 69},
  [2207] = {.lex_state = 69, .external_lex_state = 2},
  [2208] = {.lex_state = 69},
  [2209] = {.lex_state = 69},
  [2210] = {.lex_state = 69, .external_lex_state = 2},
  [2211] = {.lex_state = 69},
  [2212] = {.lex_state = 69},
  [2213] = {.lex_state = 69},
  [2214] = {.lex_state = 69},
  [2215] = {.lex_state = 69},
  [2216] = {.lex_state = 69, .external_lex_state = 2},
  [2217] = {.lex_state = 69},
  [2218] = {.lex_state = 69},
  [2219] = {.lex_state = 69},
  [2220] = {.lex_state = 69},
  [2221] = {.lex_state = 69},
  [2222] = {.lex_state = 69},
  [2223] = {.lex_state = 69},
  [2224] = {.lex_state = 69},
  [2225] = {.lex_state = 69},
  [2226] = {.lex_state = 69},
  [2227] = {.lex_state = 69},
  [2228] = {.lex_state = 69},
  [2229] = {.lex_state = 69, .external_lex_state = 2},
  [2230] = {.lex_state = 69, .external_lex_state = 2},
  [2231] = {.lex_state = 69, .external_lex_state = 2},
  [2232] = {.lex_state = 69, .external_lex_state = 2},
  [2233] = {.lex_state = 69, .external_lex_state = 2},
  [2234] = {.lex_state = 69, .external_lex_state = 2},
  [2235] = {.lex_state = 69, .external_lex_state = 2},
  [2236] = {.lex_state = 69},
  [2237] = {.lex_state = 69, .external_lex_state = 2},
  [2238] = {.lex_state = 69},
  [2239] = {.lex_state = 69},
  [2240] = {.lex_state = 69, .external_lex_state = 2},
  [2241] = {.lex_state = 69},
  [2242] = {.lex_state = 69, .external_lex_state = 2},
  [2243] = {.lex_state = 69},
  [2244] = {.lex_state = 69, .external_lex_state = 2},
  [2245] = {.lex_state = 69},
  [2246] = {.lex_state = 69},
  [2247] = {.lex_state = 69},
  [2248] = {.lex_state = 69, .external_lex_state = 2},
  [2249] = {.lex_state = 69},
  [2250] = {.lex_state = 69},
  [2251] = {.lex_state = 69},
  [2252] = {.lex_state = 69},
  [2253] = {.lex_state = 69},
  [2254] = {.lex_state = 69},
  [2255] = {.lex_state = 69},
  [2256] = {.lex_state = 69},
  [2257] = {.lex_state = 69, .external_lex_state = 2},
  [2258] = {.lex_state = 69},
  [2259] = {.lex_state = 69},
  [2260] = {.lex_state = 69},
  [2261] = {.lex_state = 69},
  [2262] = {.lex_state = 69},
  [2263] = {.lex_state = 69},
  [2264] = {.lex_state = 69, .external_lex_state = 2},
  [2265] = {.lex_state = 69},
  [2266] = {.lex_state = 69, .external_lex_state = 2},
  [2267] = {.lex_state = 69},
  [2268] = {.lex_state = 69},
  [2269] = {.lex_state = 69},
  [2270] = {.lex_state = 69},
  [2271] = {.lex_state = 69},
  [2272] = {.lex_state = 69},
  [2273] = {.lex_state = 69},
  [2274] = {.lex_state = 69},
  [2275] = {.lex_state = 69},
  [2276] = {.lex_state = 69},
  [2277] = {.lex_state = 69},
  [2278] = {.lex_state = 69},
  [2279] = {.lex_state = 69},
  [2280] = {.lex_state = 69},
  [2281] = {.lex_state = 69},
  [2282] = {.lex_state = 69},
  [2283] = {.lex_state = 69},
  [2284] = {.lex_state = 69},
  [2285] = {.lex_state = 69},
  [2286] = {.lex_state = 69},
  [2287] = {.lex_state = 69, .external_lex_state = 2},
  [2288] = {.lex_state = 3, .external_lex_state = 12},
  [2289] = {.lex_state = 69},
  [2290] = {.lex_state = 69},
  [2291] = {.lex_state = 3, .external_lex_state = 12},
  [2292] = {.lex_state = 69},
  [2293] = {.lex_state = 69},
  [2294] = {.lex_state = 69},
  [2295] = {.lex_state = 69},
  [2296] = {.lex_state = 69},
  [2297] = {.lex_state = 69},
  [2298] = {.lex_state = 69},
  [2299] = {.lex_state = 69},
  [2300] = {.lex_state = 69, .external_lex_state = 2},
  [2301] = {.lex_state = 69},
  [2302] = {.lex_state = 69, .external_lex_state = 2},
  [2303] = {.lex_state = 69},
  [2304] = {.lex_state = 69},
  [2305] = {.lex_state = 69, .external_lex_state = 2},
  [2306] = {.lex_state = 69},
  [2307] = {.lex_state = 69},
  [2308] = {.lex_state = 69, .external_lex_state = 2},
  [2309] = {.lex_state = 69, .external_lex_state = 2},
  [2310] = {.lex_state = 69, .external_lex_state = 2},
  [2311] = {.lex_state = 69, .external_lex_state = 2},
  [2312] = {.lex_state = 69, .external_lex_state = 2},
  [2313] = {.lex_state = 69, .external_lex_state = 2},
  [2314] = {.lex_state = 69},
  [2315] = {.lex_state = 69, .external_lex_state = 2},
  [2316] = {.lex_state = 69, .external_lex_state = 2},
  [2317] = {.lex_state = 69},
  [2318] = {.lex_state = 69},
  [2319] = {.lex_state = 69},
  [2320] = {.lex_state = 69},
  [2321] = {.lex_state = 69},
  [2322] = {.lex_state = 69},
  [2323] = {.lex_state = 69},
  [2324] = {.lex_state = 69},
  [2325] = {.lex_state = 69},
  [2326] = {.lex_state = 69},
  [2327] = {.lex_state = 69, .external_lex_state = 2},
  [2328] = {.lex_state = 69, .external_lex_state = 2},
  [2329] = {.lex_state = 69},
  [2330] = {.lex_state = 69},
  [2331] = {.lex_state = 69},
  [2332] = {.lex_state = 69, .external_lex_state = 2},
  [2333] = {.lex_state = 69, .external_lex_state = 2},
  [2334] = {.lex_state = 69, .external_lex_state = 2},
  [2335] = {.lex_state = 69},
  [2336] = {.lex_state = 69},
  [2337] = {.lex_state = 69},
  [2338] = {.lex_state = 69},
  [2339] = {.lex_state = 69, .external_lex_state = 2},
  [2340] = {.lex_state = 69},
  [2341] = {.lex_state = 69},
  [2342] = {.lex_state = 69},
  [2343] = {.lex_state = 69},
  [2344] = {.lex_state = 69},
  [2345] = {.lex_state = 69},
  [2346] = {.lex_state = 69},
  [2347] = {.lex_state = 69},
  [2348] = {.lex_state = 69},
  [2349] = {.lex_state = 69},
  [2350] = {.lex_state = 69},
  [2351] = {.lex_state = 69},
  [2352] = {.lex_state = 69},
  [2353] = {.lex_state = 69},
  [2354] = {.lex_state = 69, .external_lex_state = 2},
  [2355] = {.lex_state = 3, .external_lex_state = 12},
  [2356] = {.lex_state = 69},
  [2357] = {.lex_state = 69},
  [2358] = {.lex_state = 69},
  [2359] = {.lex_state = 69},
  [2360] = {.lex_state = 69},
  [2361] = {.lex_state = 69},
  [2362] = {.lex_state = 69},
  [2363] = {.lex_state = 69},
  [2364] = {.lex_state = 69, .external_lex_state = 2},
  [2365] = {.lex_state = 69},
  [2366] = {.lex_state = 69},
  [2367] = {.lex_state = 69, .external_lex_state = 2},
  [2368] = {.lex_state = 69},
  [2369] = {.lex_state = 69},
  [2370] = {.lex_state = 69},
  [2371] = {.lex_state = 69},
  [2372] = {.lex_state = 69, .external_lex_state = 2},
  [2373] = {.lex_state = 69, .external_lex_state = 2},
  [2374] = {.lex_state = 69},
  [2375] = {.lex_state = 69},
  [2376] = {.lex_state = 69, .external_lex_state = 2},
  [2377] = {.lex_state = 69},
  [2378] = {.lex_state = 69},
  [2379] = {.lex_state = 69},
  [2380] = {.lex_state = 69},
  [2381] = {.lex_state = 69},
  [2382] = {.lex_state = 69},
  [2383] = {.lex_state = 69},
  [2384] = {.lex_state = 69},
  [2385] = {.lex_state = 69},
  [2386] = {.lex_state = 69},
  [2387] = {.lex_state = 69},
  [2388] = {.lex_state = 69},
  [2389] = {.lex_state = 69},
  [2390] = {.lex_state = 69},
  [2391] = {.lex_state = 69},
  [2392] = {.lex_state = 69},
  [2393] = {.lex_state = 69},
  [2394] = {.lex_state = 69},
  [2395] = {.lex_state = 69},
  [2396] = {.lex_state = 69},
  [2397] = {.lex_state = 69},
  [2398] = {.lex_state = 69},
  [2399] = {.lex_state = 69},
  [2400] = {.lex_state = 69},
  [2401] = {.lex_state = 69},
  [2402] = {.lex_state = 3, .external_lex_state = 12},
  [2403] = {.lex_state = 3, .external_lex_state = 12},
  [2404] = {.lex_state = 69},
  [2405] = {.lex_state = 69},
  [2406] = {.lex_state = 69, .external_lex_state = 2},
  [2407] = {.lex_state = 69},
  [2408] = {.lex_state = 69, .external_lex_state = 2},
  [2409] = {.lex_state = 69},
  [2410] = {.lex_state = 69, .external_lex_state = 2},
  [2411] = {.lex_state = 69},
  [2412] = {.lex_state = 69},
  [2413] = {.lex_state = 69, .external_lex_state = 2},
  [2414] = {.lex_state = 69},
  [2415] = {.lex_state = 69},
  [2416] = {.lex_state = 69},
  [2417] = {.lex_state = 69},
  [2418] = {.lex_state = 69, .external_lex_state = 2},
  [2419] = {.lex_state = 69},
  [2420] = {.lex_state = 69},
  [2421] = {.lex_state = 69, .external_lex_state = 2},
  [2422] = {.lex_state = 69},
  [2423] = {.lex_state = 69},
  [2424] = {.lex_state = 69, .external_lex_state = 2},
  [2425] = {.lex_state = 69, .external_lex_state = 2},
  [2426] = {.lex_state = 69},
  [2427] = {.lex_state = 69},
  [2428] = {.lex_state = 69},
  [2429] = {.lex_state = 69},
  [2430] = {.lex_state = 69},
  [2431] = {.lex_state = 69},
  [2432] = {.lex_state = 69, .external_lex_state = 2},
  [2433] = {.lex_state = 69, .external_lex_state = 2},
  [2434] = {.lex_state = 69},
  [2435] = {.lex_state = 69},
  [2436] = {.lex_state = 69},
  [2437] = {.lex_state = 69},
  [2438] = {.lex_state = 69},
  [2439] = {.lex_state = 69},
  [2440] = {.lex_state = 69, .external_lex_state = 2},
  [2441] = {.lex_state = 69},
  [2442] = {.lex_state = 69},
  [2443] = {.lex_state = 69},
  [2444] = {.lex_state = 69},
  [2445] = {.lex_state = 69},
  [2446] = {.lex_state = 69},
  [2447] = {.lex_state = 69},
  [2448] = {.lex_state = 69},
  [2449] = {.lex_state = 69},
  [2450] = {.lex_state = 69},
  [2451] = {.lex_state = 69},
  [2452] = {.lex_state = 69},
  [2453] = {.lex_state = 69},
  [2454] = {.lex_state = 69},
  [2455] = {.lex_state = 69},
  [2456] = {.lex_state = 69},
  [2457] = {.lex_state = 69},
  [2458] = {.lex_state = 69},
  [2459] = {.lex_state = 69},
  [2460] = {.lex_state = 69},
  [2461] = {.lex_state = 69},
  [2462] = {.lex_state = 69},
  [2463] = {.lex_state = 69},
  [2464] = {.lex_state = 69},
  [2465] = {.lex_state = 69},
  [2466] = {.lex_state = 69},
  [2467] = {.lex_state = 69},
  [2468] = {.lex_state = 69},
  [2469] = {.lex_state = 69},
  [2470] = {.lex_state = 69},
  [2471] = {.lex_state = 69},
  [2472] = {.lex_state = 69},
  [2473] = {.lex_state = 69},
  [2474] = {.lex_state = 69, .external_lex_state = 12},
  [2475] = {.lex_state = 69},
  [2476] = {.lex_state = 69},
  [2477] = {.lex_state = 69},
  [2478] = {.lex_state = 69},
  [2479] = {.lex_state = 69, .external_lex_state = 12},
  [2480] = {.lex_state = 69},
  [2481] = {.lex_state = 69},
  [2482] = {.lex_state = 69},
  [2483] = {.lex_state = 69},
  [2484] = {.lex_state = 69, .external_lex_state = 12},
  [2485] = {.lex_state = 69},
  [2486] = {.lex_state = 69},
  [2487] = {.lex_state = 8},
  [2488] = {.lex_state = 13},
  [2489] = {.lex_state = 69},
  [2490] = {.lex_state = 69},
  [2491] = {.lex_state = 69},
  [2492] = {.lex_state = 69},
  [2493] = {.lex_state = 69},
  [2494] = {.lex_state = 69},
  [2495] = {.lex_state = 69},
  [2496] = {.lex_state = 69},
  [2497] = {.lex_state = 69},
  [2498] = {.lex_state = 69},
  [2499] = {.lex_state = 69},
  [2500] = {.lex_state = 69},
  [2501] = {.lex_state = 69},
  [2502] = {.lex_state = 69},
  [2503] = {.lex_state = 69},
  [2504] = {.lex_state = 69},
  [2505] = {.lex_state = 69},
  [2506] = {.lex_state = 69},
  [2507] = {.lex_state = 69},
  [2508] = {.lex_state = 69},
  [2509] = {.lex_state = 69},
  [2510] = {.lex_state = 69},
  [2511] = {.lex_state = 69},
  [2512] = {.lex_state = 69},
  [2513] = {.lex_state = 69},
  [2514] = {.lex_state = 69},
  [2515] = {.lex_state = 69},
  [2516] = {.lex_state = 69},
  [2517] = {.lex_state = 69},
  [2518] = {.lex_state = 69},
  [2519] = {.lex_state = 69},
  [2520] = {.lex_state = 69},
  [2521] = {.lex_state = 69},
  [2522] = {.lex_state = 69},
  [2523] = {.lex_state = 69},
  [2524] = {.lex_state = 69},
  [2525] = {.lex_state = 69},
  [2526] = {.lex_state = 69},
  [2527] = {.lex_state = 8},
  [2528] = {.lex_state = 13},
  [2529] = {.lex_state = 69},
  [2530] = {.lex_state = 69},
  [2531] = {.lex_state = 69},
  [2532] = {.lex_state = 69},
  [2533] = {.lex_state = 69},
  [2534] = {.lex_state = 69},
  [2535] = {.lex_state = 69},
  [2536] = {.lex_state = 69},
  [2537] = {.lex_state = 69},
  [2538] = {.lex_state = 69},
  [2539] = {.lex_state = 69},
  [2540] = {.lex_state = 69},
  [2541] = {.lex_state = 69},
  [2542] = {.lex_state = 69},
  [2543] = {.lex_state = 69},
  [2544] = {.lex_state = 69},
  [2545] = {.lex_state = 69},
  [2546] = {.lex_state = 69},
  [2547] = {.lex_state = 69},
  [2548] = {.lex_state = 69},
  [2549] = {.lex_state = 69},
  [2550] = {.lex_state = 69},
  [2551] = {.lex_state = 69},
  [2552] = {.lex_state = 69},
  [2553] = {.lex_state = 69},
  [2554] = {.lex_state = 69},
  [2555] = {.lex_state = 69},
  [2556] = {.lex_state = 69},
  [2557] = {.lex_state = 69, .external_lex_state = 12},
  [2558] = {.lex_state = 69},
  [2559] = {.lex_state = 69},
  [2560] = {.lex_state = 69, .external_lex_state = 11},
  [2561] = {.lex_state = 69},
  [2562] = {.lex_state = 69},
  [2563] = {.lex_state = 69},
  [2564] = {.lex_state = 69},
  [2565] = {.lex_state = 69},
  [2566] = {.lex_state = 69, .external_lex_state = 11},
  [2567] = {.lex_state = 69},
  [2568] = {.lex_state = 69},
  [2569] = {.lex_state = 69},
  [2570] = {.lex_state = 69, .external_lex_state = 11},
  [2571] = {.lex_state = 69, .external_lex_state = 11},
  [2572] = {.lex_state = 69},
  [2573] = {.lex_state = 69},
  [2574] = {.lex_state = 69},
  [2575] = {.lex_state = 69},
  [2576] = {.lex_state = 69},
  [2577] = {.lex_state = 69},
  [2578] = {.lex_state = 69},
  [2579] = {.lex_state = 69},
  [2580] = {.lex_state = 69},
  [2581] = {.lex_state = 69},
  [2582] = {.lex_state = 69},
  [2583] = {.lex_state = 69},
  [2584] = {.lex_state = 69},
  [2585] = {.lex_state = 69},
  [2586] = {.lex_state = 69},
  [2587] = {.lex_state = 69},
  [2588] = {.lex_state = 69},
  [2589] = {.lex_state = 69},
  [2590] = {.lex_state = 69},
  [2591] = {.lex_state = 69},
  [2592] = {.lex_state = 69},
  [2593] = {.lex_state = 69},
  [2594] = {.lex_state = 69},
  [2595] = {.lex_state = 69},
  [2596] = {.lex_state = 69},
  [2597] = {.lex_state = 69},
  [2598] = {.lex_state = 69},
  [2599] = {.lex_state = 69},
  [2600] = {.lex_state = 69},
  [2601] = {.lex_state = 69},
  [2602] = {.lex_state = 69},
  [2603] = {.lex_state = 69},
  [2604] = {.lex_state = 69},
  [2605] = {.lex_state = 69},
  [2606] = {.lex_state = 69},
  [2607] = {.lex_state = 69},
  [2608] = {.lex_state = 69},
  [2609] = {.lex_state = 69},
  [2610] = {.lex_state = 69},
  [2611] = {.lex_state = 69},
  [2612] = {.lex_state = 69},
  [2613] = {.lex_state = 69},
  [2614] = {.lex_state = 69},
  [2615] = {.lex_state = 69},
  [2616] = {.lex_state = 69},
  [2617] = {.lex_state = 69},
  [2618] = {.lex_state = 69},
  [2619] = {.lex_state = 69},
  [2620] = {.lex_state = 69},
  [2621] = {.lex_state = 69},
  [2622] = {.lex_state = 69},
  [2623] = {.lex_state = 69},
  [2624] = {.lex_state = 69},
  [2625] = {.lex_state = 69},
  [2626] = {.lex_state = 69},
  [2627] = {.lex_state = 69},
  [2628] = {.lex_state = 69},
  [2629] = {.lex_state = 69},
  [2630] = {.lex_state = 69},
  [2631] = {.lex_state = 69},
  [2632] = {.lex_state = 69},
  [2633] = {.lex_state = 69, .external_lex_state = 12},
  [2634] = {.lex_state = 69},
  [2635] = {.lex_state = 69},
  [2636] = {.lex_state = 69, .external_lex_state = 12},
  [2637] = {.lex_state = 69},
  [2638] = {.lex_state = 69},
  [2639] = {.lex_state = 69},
  [2640] = {.lex_state = 69},
  [2641] = {.lex_state = 69},
  [2642] = {.lex_state = 69},
  [2643] = {.lex_state = 69},
  [2644] = {.lex_state = 69},
  [2645] = {.lex_state = 69},
  [2646] = {.lex_state = 69},
  [2647] = {.lex_state = 69},
  [2648] = {.lex_state = 69},
  [2649] = {.lex_state = 69},
  [2650] = {.lex_state = 69},
  [2651] = {.lex_state = 69},
  [2652] = {.lex_state = 69},
  [2653] = {.lex_state = 69},
  [2654] = {.lex_state = 69},
  [2655] = {.lex_state = 69},
  [2656] = {.lex_state = 69},
  [2657] = {.lex_state = 69},
  [2658] = {.lex_state = 69},
  [2659] = {.lex_state = 69},
  [2660] = {.lex_state = 69},
  [2661] = {.lex_state = 69},
  [2662] = {.lex_state = 69},
  [2663] = {.lex_state = 69},
  [2664] = {.lex_state = 69},
  [2665] = {.lex_state = 69},
  [2666] = {.lex_state = 69},
  [2667] = {.lex_state = 69},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_name] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(1),
    [aux_sym_text_token1] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [aux_sym_global_declaration_token1] = ACTIONS(1),
    [aux_sym_namespace_definition_token1] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [aux_sym_trait_declaration_token1] = ACTIONS(1),
    [aux_sym_interface_declaration_token1] = ACTIONS(1),
    [aux_sym_base_clause_token1] = ACTIONS(1),
    [aux_sym_enum_declaration_token1] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [aux_sym_enum_case_token1] = ACTIONS(1),
    [aux_sym_class_declaration_token1] = ACTIONS(1),
    [aux_sym_final_modifier_token1] = ACTIONS(1),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1),
    [aux_sym_class_interface_clause_token1] = ACTIONS(1),
    [sym_var_modifier] = ACTIONS(1),
    [aux_sym_use_instead_of_clause_token1] = ACTIONS(1),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym_bottom_type] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_array] = ACTIONS(1),
    [aux_sym_primitive_type_token1] = ACTIONS(1),
    [anon_sym_iterable] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_mixed] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [aux_sym_cast_type_token1] = ACTIONS(1),
    [aux_sym_cast_type_token2] = ACTIONS(1),
    [aux_sym_cast_type_token3] = ACTIONS(1),
    [aux_sym_cast_type_token4] = ACTIONS(1),
    [aux_sym_cast_type_token5] = ACTIONS(1),
    [aux_sym_cast_type_token6] = ACTIONS(1),
    [aux_sym_cast_type_token7] = ACTIONS(1),
    [aux_sym_cast_type_token8] = ACTIONS(1),
    [aux_sym_cast_type_token9] = ACTIONS(1),
    [aux_sym_cast_type_token10] = ACTIONS(1),
    [aux_sym_cast_type_token11] = ACTIONS(1),
    [aux_sym_cast_type_token12] = ACTIONS(1),
    [aux_sym_echo_statement_token1] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [aux_sym_declare_statement_token1] = ACTIONS(1),
    [aux_sym_declare_statement_token2] = ACTIONS(1),
    [anon_sym_ticks] = ACTIONS(1),
    [anon_sym_encoding] = ACTIONS(1),
    [anon_sym_strict_types] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [aux_sym_try_statement_token1] = ACTIONS(1),
    [aux_sym_catch_clause_token1] = ACTIONS(1),
    [aux_sym_finally_clause_token1] = ACTIONS(1),
    [aux_sym_goto_statement_token1] = ACTIONS(1),
    [aux_sym_continue_statement_token1] = ACTIONS(1),
    [aux_sym_break_statement_token1] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [aux_sym_return_statement_token1] = ACTIONS(1),
    [aux_sym_throw_expression_token1] = ACTIONS(1),
    [aux_sym_while_statement_token1] = ACTIONS(1),
    [aux_sym_while_statement_token2] = ACTIONS(1),
    [aux_sym_do_statement_token1] = ACTIONS(1),
    [aux_sym_for_statement_token1] = ACTIONS(1),
    [aux_sym_for_statement_token2] = ACTIONS(1),
    [aux_sym_foreach_statement_token1] = ACTIONS(1),
    [aux_sym_foreach_statement_token2] = ACTIONS(1),
    [aux_sym_if_statement_token1] = ACTIONS(1),
    [aux_sym_if_statement_token2] = ACTIONS(1),
    [aux_sym_else_if_clause_token1] = ACTIONS(1),
    [aux_sym_else_clause_token1] = ACTIONS(1),
    [aux_sym_match_expression_token1] = ACTIONS(1),
    [aux_sym_match_default_expression_token1] = ACTIONS(1),
    [aux_sym_switch_statement_token1] = ACTIONS(1),
    [aux_sym_switch_block_token1] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [aux_sym_clone_expression_token1] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_QMARK_DASH_GT] = ACTIONS(1),
    [aux_sym__list_destructing_token1] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_self] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [aux_sym__argument_name_token1] = ACTIONS(1),
    [aux_sym__argument_name_token2] = ACTIONS(1),
    [anon_sym_POUND_LBRACK] = ACTIONS(1),
    [aux_sym_encapsed_string_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [aux_sym_string_token1] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym_string_token2] = ACTIONS(1),
    [anon_sym_DQUOTE2] = ACTIONS(1),
    [anon_sym_SQUOTE2] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [aux_sym_yield_expression_token1] = ACTIONS(1),
    [aux_sym_yield_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token1] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [aux_sym_binary_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token3] = ACTIONS(1),
    [aux_sym_binary_expression_token4] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [aux_sym_include_expression_token1] = ACTIONS(1),
    [aux_sym_include_once_expression_token1] = ACTIONS(1),
    [aux_sym_require_expression_token1] = ACTIONS(1),
    [aux_sym_require_once_expression_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym_encapsed_string_chars] = ACTIONS(1),
    [sym_encapsed_string_chars_after_variable] = ACTIONS(1),
    [sym_execution_string_chars] = ACTIONS(1),
    [sym_execution_string_chars_after_variable] = ACTIONS(1),
    [sym_encapsed_string_chars_heredoc] = ACTIONS(1),
    [sym_encapsed_string_chars_after_variable_heredoc] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
    [sym_heredoc_start] = ACTIONS(1),
    [sym_heredoc_end] = ACTIONS(1),
    [sym_nowdoc_string] = ACTIONS(1),
    [sym_sentinel_error] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2629),
    [sym_empty_statement] = STATE(15),
    [sym_function_static_declaration] = STATE(15),
    [sym_global_declaration] = STATE(15),
    [sym_namespace_definition] = STATE(15),
    [sym_namespace_use_declaration] = STATE(15),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_class_declaration] = STATE(15),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(15),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(15),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(15),
    [sym_unset_statement] = STATE(15),
    [sym_declare_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_goto_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_foreach_statement] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(15),
    [sym_compound_statement] = STATE(15),
    [sym_named_label_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(9),
    [sym_php_tag] = ACTIONS(11),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_name] = ACTIONS(135),
    [anon_sym_QMARK_GT] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(138),
    [aux_sym_function_static_declaration_token1] = ACTIONS(141),
    [aux_sym_global_declaration_token1] = ACTIONS(144),
    [aux_sym_namespace_definition_token1] = ACTIONS(147),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(150),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(153),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(156),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(162),
    [anon_sym_RBRACE] = ACTIONS(133),
    [aux_sym_trait_declaration_token1] = ACTIONS(165),
    [aux_sym_interface_declaration_token1] = ACTIONS(168),
    [aux_sym_enum_declaration_token1] = ACTIONS(171),
    [aux_sym_enum_case_token1] = ACTIONS(174),
    [aux_sym_class_declaration_token1] = ACTIONS(176),
    [aux_sym_final_modifier_token1] = ACTIONS(179),
    [aux_sym_abstract_modifier_token1] = ACTIONS(182),
    [aux_sym_readonly_modifier_token1] = ACTIONS(185),
    [aux_sym_visibility_modifier_token1] = ACTIONS(188),
    [aux_sym_visibility_modifier_token2] = ACTIONS(188),
    [aux_sym_visibility_modifier_token3] = ACTIONS(188),
    [aux_sym__arrow_function_header_token1] = ACTIONS(191),
    [anon_sym_LPAREN] = ACTIONS(194),
    [aux_sym_cast_type_token1] = ACTIONS(197),
    [aux_sym_echo_statement_token1] = ACTIONS(200),
    [anon_sym_unset] = ACTIONS(203),
    [aux_sym_declare_statement_token1] = ACTIONS(206),
    [aux_sym_declare_statement_token2] = ACTIONS(174),
    [sym_float] = ACTIONS(209),
    [aux_sym_try_statement_token1] = ACTIONS(212),
    [aux_sym_goto_statement_token1] = ACTIONS(215),
    [aux_sym_continue_statement_token1] = ACTIONS(218),
    [aux_sym_break_statement_token1] = ACTIONS(221),
    [sym_integer] = ACTIONS(209),
    [aux_sym_return_statement_token1] = ACTIONS(224),
    [aux_sym_throw_expression_token1] = ACTIONS(227),
    [aux_sym_while_statement_token1] = ACTIONS(230),
    [aux_sym_while_statement_token2] = ACTIONS(174),
    [aux_sym_do_statement_token1] = ACTIONS(233),
    [aux_sym_for_statement_token1] = ACTIONS(236),
    [aux_sym_for_statement_token2] = ACTIONS(174),
    [aux_sym_foreach_statement_token1] = ACTIONS(239),
    [aux_sym_foreach_statement_token2] = ACTIONS(174),
    [aux_sym_if_statement_token1] = ACTIONS(242),
    [aux_sym_if_statement_token2] = ACTIONS(174),
    [aux_sym_match_expression_token1] = ACTIONS(245),
    [aux_sym_match_default_expression_token1] = ACTIONS(174),
    [aux_sym_switch_statement_token1] = ACTIONS(248),
    [aux_sym_switch_block_token1] = ACTIONS(174),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_TILDE] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_AT] = ACTIONS(257),
    [aux_sym_clone_expression_token1] = ACTIONS(260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(263),
    [aux_sym_object_creation_expression_token1] = ACTIONS(266),
    [anon_sym_DASH_DASH] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(269),
    [aux_sym__list_destructing_token1] = ACTIONS(272),
    [anon_sym_LBRACK] = ACTIONS(275),
    [anon_sym_self] = ACTIONS(278),
    [anon_sym_parent] = ACTIONS(278),
    [aux_sym__argument_name_token1] = ACTIONS(281),
    [aux_sym__argument_name_token2] = ACTIONS(284),
    [anon_sym_POUND_LBRACK] = ACTIONS(287),
    [aux_sym_encapsed_string_token1] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [aux_sym_string_token1] = ACTIONS(293),
    [anon_sym_SQUOTE] = ACTIONS(293),
    [anon_sym_LT_LT_LT] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(302),
    [aux_sym_yield_expression_token1] = ACTIONS(305),
    [aux_sym_include_expression_token1] = ACTIONS(308),
    [aux_sym_include_once_expression_token1] = ACTIONS(311),
    [aux_sym_require_expression_token1] = ACTIONS(314),
    [aux_sym_require_once_expression_token1] = ACTIONS(317),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(320),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(322),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(322),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_empty_statement] = STATE(5),
    [sym_function_static_declaration] = STATE(5),
    [sym_global_declaration] = STATE(5),
    [sym_namespace_definition] = STATE(5),
    [sym_namespace_use_declaration] = STATE(5),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(5),
    [sym_interface_declaration] = STATE(5),
    [sym_enum_declaration] = STATE(5),
    [sym_class_declaration] = STATE(5),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(5),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(5),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(5),
    [sym_unset_statement] = STATE(5),
    [sym_declare_statement] = STATE(5),
    [sym_try_statement] = STATE(5),
    [sym_goto_statement] = STATE(5),
    [sym_continue_statement] = STATE(5),
    [sym_break_statement] = STATE(5),
    [sym_return_statement] = STATE(5),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(5),
    [sym_do_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_foreach_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(5),
    [sym_compound_statement] = STATE(5),
    [sym_named_label_statement] = STATE(5),
    [sym_expression_statement] = STATE(5),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(324),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(326),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(326),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(326),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(328),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(330),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(330),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(330),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_empty_statement] = STATE(3),
    [sym_function_static_declaration] = STATE(3),
    [sym_global_declaration] = STATE(3),
    [sym_namespace_definition] = STATE(3),
    [sym_namespace_use_declaration] = STATE(3),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(3),
    [sym_interface_declaration] = STATE(3),
    [sym_enum_declaration] = STATE(3),
    [sym_class_declaration] = STATE(3),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(3),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(3),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(3),
    [sym_unset_statement] = STATE(3),
    [sym_declare_statement] = STATE(3),
    [sym_try_statement] = STATE(3),
    [sym_goto_statement] = STATE(3),
    [sym_continue_statement] = STATE(3),
    [sym_break_statement] = STATE(3),
    [sym_return_statement] = STATE(3),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(3),
    [sym_do_statement] = STATE(3),
    [sym_for_statement] = STATE(3),
    [sym_foreach_statement] = STATE(3),
    [sym_if_statement] = STATE(3),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(3),
    [sym_compound_statement] = STATE(3),
    [sym_named_label_statement] = STATE(3),
    [sym_expression_statement] = STATE(3),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(3),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(332),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_enum_case_token1] = ACTIONS(334),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_match_default_expression_token1] = ACTIONS(334),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [aux_sym_switch_block_token1] = ACTIONS(334),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_while_statement_token2] = ACTIONS(336),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_foreach_statement_token2] = ACTIONS(336),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_if_statement_token2] = ACTIONS(336),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_empty_statement] = STATE(8),
    [sym_function_static_declaration] = STATE(8),
    [sym_global_declaration] = STATE(8),
    [sym_namespace_definition] = STATE(8),
    [sym_namespace_use_declaration] = STATE(8),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(8),
    [sym_interface_declaration] = STATE(8),
    [sym_enum_declaration] = STATE(8),
    [sym_class_declaration] = STATE(8),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(8),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(8),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(8),
    [sym_unset_statement] = STATE(8),
    [sym_declare_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_goto_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_foreach_statement] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(8),
    [sym_compound_statement] = STATE(8),
    [sym_named_label_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(138),
    [aux_sym_function_static_declaration_token1] = ACTIONS(141),
    [aux_sym_global_declaration_token1] = ACTIONS(144),
    [aux_sym_namespace_definition_token1] = ACTIONS(147),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(150),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(153),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(156),
    [anon_sym_BSLASH] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(162),
    [aux_sym_trait_declaration_token1] = ACTIONS(165),
    [aux_sym_interface_declaration_token1] = ACTIONS(168),
    [aux_sym_enum_declaration_token1] = ACTIONS(171),
    [aux_sym_class_declaration_token1] = ACTIONS(176),
    [aux_sym_final_modifier_token1] = ACTIONS(179),
    [aux_sym_abstract_modifier_token1] = ACTIONS(182),
    [aux_sym_readonly_modifier_token1] = ACTIONS(185),
    [aux_sym_visibility_modifier_token1] = ACTIONS(188),
    [aux_sym_visibility_modifier_token2] = ACTIONS(188),
    [aux_sym_visibility_modifier_token3] = ACTIONS(188),
    [aux_sym__arrow_function_header_token1] = ACTIONS(191),
    [anon_sym_LPAREN] = ACTIONS(194),
    [aux_sym_cast_type_token1] = ACTIONS(197),
    [aux_sym_echo_statement_token1] = ACTIONS(200),
    [anon_sym_unset] = ACTIONS(203),
    [aux_sym_declare_statement_token1] = ACTIONS(338),
    [sym_float] = ACTIONS(209),
    [aux_sym_try_statement_token1] = ACTIONS(212),
    [aux_sym_goto_statement_token1] = ACTIONS(215),
    [aux_sym_continue_statement_token1] = ACTIONS(218),
    [aux_sym_break_statement_token1] = ACTIONS(221),
    [sym_integer] = ACTIONS(209),
    [aux_sym_return_statement_token1] = ACTIONS(224),
    [aux_sym_throw_expression_token1] = ACTIONS(227),
    [aux_sym_while_statement_token1] = ACTIONS(341),
    [aux_sym_do_statement_token1] = ACTIONS(233),
    [aux_sym_for_statement_token1] = ACTIONS(344),
    [aux_sym_foreach_statement_token1] = ACTIONS(347),
    [aux_sym_if_statement_token1] = ACTIONS(350),
    [aux_sym_if_statement_token2] = ACTIONS(174),
    [aux_sym_else_if_clause_token1] = ACTIONS(174),
    [aux_sym_else_clause_token1] = ACTIONS(174),
    [aux_sym_match_expression_token1] = ACTIONS(245),
    [aux_sym_switch_statement_token1] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(251),
    [anon_sym_DASH] = ACTIONS(251),
    [anon_sym_TILDE] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_AT] = ACTIONS(257),
    [aux_sym_clone_expression_token1] = ACTIONS(260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(263),
    [aux_sym_object_creation_expression_token1] = ACTIONS(266),
    [anon_sym_DASH_DASH] = ACTIONS(269),
    [anon_sym_PLUS_PLUS] = ACTIONS(269),
    [aux_sym__list_destructing_token1] = ACTIONS(272),
    [anon_sym_LBRACK] = ACTIONS(275),
    [anon_sym_self] = ACTIONS(278),
    [anon_sym_parent] = ACTIONS(278),
    [aux_sym__argument_name_token1] = ACTIONS(281),
    [aux_sym__argument_name_token2] = ACTIONS(284),
    [anon_sym_POUND_LBRACK] = ACTIONS(287),
    [aux_sym_encapsed_string_token1] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [aux_sym_string_token1] = ACTIONS(293),
    [anon_sym_SQUOTE] = ACTIONS(293),
    [anon_sym_LT_LT_LT] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(302),
    [aux_sym_yield_expression_token1] = ACTIONS(305),
    [aux_sym_include_expression_token1] = ACTIONS(308),
    [aux_sym_include_once_expression_token1] = ACTIONS(311),
    [aux_sym_require_expression_token1] = ACTIONS(314),
    [aux_sym_require_once_expression_token1] = ACTIONS(317),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_empty_statement] = STATE(10),
    [sym_function_static_declaration] = STATE(10),
    [sym_global_declaration] = STATE(10),
    [sym_namespace_definition] = STATE(10),
    [sym_namespace_use_declaration] = STATE(10),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(10),
    [sym_interface_declaration] = STATE(10),
    [sym_enum_declaration] = STATE(10),
    [sym_class_declaration] = STATE(10),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(10),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(10),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(10),
    [sym_unset_statement] = STATE(10),
    [sym_declare_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_goto_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_foreach_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(10),
    [sym_compound_statement] = STATE(10),
    [sym_named_label_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token2] = ACTIONS(363),
    [aux_sym_else_if_clause_token1] = ACTIONS(363),
    [aux_sym_else_clause_token1] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_empty_statement] = STATE(8),
    [sym_function_static_declaration] = STATE(8),
    [sym_global_declaration] = STATE(8),
    [sym_namespace_definition] = STATE(8),
    [sym_namespace_use_declaration] = STATE(8),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(8),
    [sym_interface_declaration] = STATE(8),
    [sym_enum_declaration] = STATE(8),
    [sym_class_declaration] = STATE(8),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(8),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(8),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(8),
    [sym_unset_statement] = STATE(8),
    [sym_declare_statement] = STATE(8),
    [sym_try_statement] = STATE(8),
    [sym_goto_statement] = STATE(8),
    [sym_continue_statement] = STATE(8),
    [sym_break_statement] = STATE(8),
    [sym_return_statement] = STATE(8),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(8),
    [sym_do_statement] = STATE(8),
    [sym_for_statement] = STATE(8),
    [sym_foreach_statement] = STATE(8),
    [sym_if_statement] = STATE(8),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(8),
    [sym_compound_statement] = STATE(8),
    [sym_named_label_statement] = STATE(8),
    [sym_expression_statement] = STATE(8),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_if_statement_token2] = ACTIONS(336),
    [aux_sym_else_if_clause_token1] = ACTIONS(336),
    [aux_sym_else_clause_token1] = ACTIONS(336),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_empty_statement] = STATE(7),
    [sym_function_static_declaration] = STATE(7),
    [sym_global_declaration] = STATE(7),
    [sym_namespace_definition] = STATE(7),
    [sym_namespace_use_declaration] = STATE(7),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_class_declaration] = STATE(7),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(7),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(7),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(7),
    [sym_unset_statement] = STATE(7),
    [sym_declare_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_goto_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_foreach_statement] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(7),
    [sym_compound_statement] = STATE(7),
    [sym_named_label_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_while_statement_token2] = ACTIONS(363),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_foreach_statement_token2] = ACTIONS(363),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_if_statement_token2] = ACTIONS(363),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_empty_statement] = STATE(477),
    [sym_function_static_declaration] = STATE(477),
    [sym_global_declaration] = STATE(477),
    [sym_namespace_definition] = STATE(477),
    [sym_namespace_use_declaration] = STATE(477),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(477),
    [sym_interface_declaration] = STATE(477),
    [sym_enum_declaration] = STATE(477),
    [sym_class_declaration] = STATE(477),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(477),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(477),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(477),
    [sym_unset_statement] = STATE(477),
    [sym_declare_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_foreach_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_colon_block] = STATE(2637),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(477),
    [sym_compound_statement] = STATE(477),
    [sym_named_label_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(365),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(369),
  },
  [13] = {
    [sym_empty_statement] = STATE(14),
    [sym_function_static_declaration] = STATE(14),
    [sym_global_declaration] = STATE(14),
    [sym_namespace_definition] = STATE(14),
    [sym_namespace_use_declaration] = STATE(14),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_class_declaration] = STATE(14),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(14),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(14),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(14),
    [sym_unset_statement] = STATE(14),
    [sym_declare_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_goto_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_foreach_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(14),
    [sym_compound_statement] = STATE(14),
    [sym_named_label_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(373),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [ts_builtin_sym_end] = ACTIONS(375),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_name] = ACTIONS(7),
    [anon_sym_QMARK_GT] = ACTIONS(373),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_empty_statement] = STATE(2034),
    [sym_function_static_declaration] = STATE(2034),
    [sym_global_declaration] = STATE(2034),
    [sym_namespace_definition] = STATE(2034),
    [sym_namespace_use_declaration] = STATE(2034),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2034),
    [sym_interface_declaration] = STATE(2034),
    [sym_enum_declaration] = STATE(2034),
    [sym_class_declaration] = STATE(2034),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2034),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2034),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2034),
    [sym_unset_statement] = STATE(2034),
    [sym_declare_statement] = STATE(2034),
    [sym_try_statement] = STATE(2034),
    [sym_goto_statement] = STATE(2034),
    [sym_continue_statement] = STATE(2034),
    [sym_break_statement] = STATE(2034),
    [sym_return_statement] = STATE(2034),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2034),
    [sym_do_statement] = STATE(2034),
    [sym_for_statement] = STATE(2034),
    [sym_foreach_statement] = STATE(2034),
    [sym_if_statement] = STATE(2034),
    [sym_colon_block] = STATE(2489),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2034),
    [sym_compound_statement] = STATE(2034),
    [sym_named_label_statement] = STATE(2034),
    [sym_expression_statement] = STATE(2034),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(431),
  },
  [17] = {
    [sym_empty_statement] = STATE(2034),
    [sym_function_static_declaration] = STATE(2034),
    [sym_global_declaration] = STATE(2034),
    [sym_namespace_definition] = STATE(2034),
    [sym_namespace_use_declaration] = STATE(2034),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2034),
    [sym_interface_declaration] = STATE(2034),
    [sym_enum_declaration] = STATE(2034),
    [sym_class_declaration] = STATE(2034),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2034),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2034),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2034),
    [sym_unset_statement] = STATE(2034),
    [sym_declare_statement] = STATE(2034),
    [sym_try_statement] = STATE(2034),
    [sym_goto_statement] = STATE(2034),
    [sym_continue_statement] = STATE(2034),
    [sym_break_statement] = STATE(2034),
    [sym_return_statement] = STATE(2034),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2034),
    [sym_do_statement] = STATE(2034),
    [sym_for_statement] = STATE(2034),
    [sym_foreach_statement] = STATE(2034),
    [sym_if_statement] = STATE(2034),
    [sym_colon_block] = STATE(2489),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2034),
    [sym_compound_statement] = STATE(2034),
    [sym_named_label_statement] = STATE(2034),
    [sym_expression_statement] = STATE(2034),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(381),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(431),
  },
  [18] = {
    [sym_empty_statement] = STATE(477),
    [sym_function_static_declaration] = STATE(477),
    [sym_global_declaration] = STATE(477),
    [sym_namespace_definition] = STATE(477),
    [sym_namespace_use_declaration] = STATE(477),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(477),
    [sym_interface_declaration] = STATE(477),
    [sym_enum_declaration] = STATE(477),
    [sym_class_declaration] = STATE(477),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(477),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(477),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(477),
    [sym_unset_statement] = STATE(477),
    [sym_declare_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_foreach_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_colon_block] = STATE(2637),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(477),
    [sym_compound_statement] = STATE(477),
    [sym_named_label_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(365),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(369),
  },
  [19] = {
    [sym_empty_statement] = STATE(2068),
    [sym_function_static_declaration] = STATE(2068),
    [sym_global_declaration] = STATE(2068),
    [sym_namespace_definition] = STATE(2068),
    [sym_namespace_use_declaration] = STATE(2068),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2068),
    [sym_interface_declaration] = STATE(2068),
    [sym_enum_declaration] = STATE(2068),
    [sym_class_declaration] = STATE(2068),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2068),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2068),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2068),
    [sym_unset_statement] = STATE(2068),
    [sym_declare_statement] = STATE(2068),
    [sym_try_statement] = STATE(2068),
    [sym_goto_statement] = STATE(2068),
    [sym_continue_statement] = STATE(2068),
    [sym_break_statement] = STATE(2068),
    [sym_return_statement] = STATE(2068),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2068),
    [sym_do_statement] = STATE(2068),
    [sym_for_statement] = STATE(2068),
    [sym_foreach_statement] = STATE(2068),
    [sym_if_statement] = STATE(2068),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2068),
    [sym_compound_statement] = STATE(2068),
    [sym_named_label_statement] = STATE(2068),
    [sym_expression_statement] = STATE(2068),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(443),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(445),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(447),
  },
  [20] = {
    [sym_empty_statement] = STATE(2009),
    [sym_function_static_declaration] = STATE(2009),
    [sym_global_declaration] = STATE(2009),
    [sym_namespace_definition] = STATE(2009),
    [sym_namespace_use_declaration] = STATE(2009),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2009),
    [sym_interface_declaration] = STATE(2009),
    [sym_enum_declaration] = STATE(2009),
    [sym_class_declaration] = STATE(2009),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2009),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2009),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2009),
    [sym_unset_statement] = STATE(2009),
    [sym_declare_statement] = STATE(2009),
    [sym_try_statement] = STATE(2009),
    [sym_goto_statement] = STATE(2009),
    [sym_continue_statement] = STATE(2009),
    [sym_break_statement] = STATE(2009),
    [sym_return_statement] = STATE(2009),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2009),
    [sym_do_statement] = STATE(2009),
    [sym_for_statement] = STATE(2009),
    [sym_foreach_statement] = STATE(2009),
    [sym_if_statement] = STATE(2009),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2009),
    [sym_compound_statement] = STATE(2009),
    [sym_named_label_statement] = STATE(2009),
    [sym_expression_statement] = STATE(2009),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(449),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(451),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [21] = {
    [sym_empty_statement] = STATE(70),
    [sym_function_static_declaration] = STATE(70),
    [sym_global_declaration] = STATE(70),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_use_declaration] = STATE(70),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(70),
    [sym_interface_declaration] = STATE(70),
    [sym_enum_declaration] = STATE(70),
    [sym_class_declaration] = STATE(70),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(70),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(70),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(70),
    [sym_unset_statement] = STATE(70),
    [sym_declare_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_goto_statement] = STATE(70),
    [sym_continue_statement] = STATE(70),
    [sym_break_statement] = STATE(70),
    [sym_return_statement] = STATE(70),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(70),
    [sym_do_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_foreach_statement] = STATE(70),
    [sym_if_statement] = STATE(70),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(70),
    [sym_compound_statement] = STATE(70),
    [sym_named_label_statement] = STATE(70),
    [sym_expression_statement] = STATE(70),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(70),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(455),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_empty_statement] = STATE(38),
    [sym_function_static_declaration] = STATE(38),
    [sym_global_declaration] = STATE(38),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_use_declaration] = STATE(38),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(38),
    [sym_interface_declaration] = STATE(38),
    [sym_enum_declaration] = STATE(38),
    [sym_class_declaration] = STATE(38),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(38),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(38),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(38),
    [sym_unset_statement] = STATE(38),
    [sym_declare_statement] = STATE(38),
    [sym_try_statement] = STATE(38),
    [sym_goto_statement] = STATE(38),
    [sym_continue_statement] = STATE(38),
    [sym_break_statement] = STATE(38),
    [sym_return_statement] = STATE(38),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(38),
    [sym_do_statement] = STATE(38),
    [sym_for_statement] = STATE(38),
    [sym_foreach_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(38),
    [sym_compound_statement] = STATE(38),
    [sym_named_label_statement] = STATE(38),
    [sym_expression_statement] = STATE(38),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(38),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(457),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_empty_statement] = STATE(2121),
    [sym_function_static_declaration] = STATE(2121),
    [sym_global_declaration] = STATE(2121),
    [sym_namespace_definition] = STATE(2121),
    [sym_namespace_use_declaration] = STATE(2121),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2121),
    [sym_interface_declaration] = STATE(2121),
    [sym_enum_declaration] = STATE(2121),
    [sym_class_declaration] = STATE(2121),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2121),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2121),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2121),
    [sym_unset_statement] = STATE(2121),
    [sym_declare_statement] = STATE(2121),
    [sym_try_statement] = STATE(2121),
    [sym_goto_statement] = STATE(2121),
    [sym_continue_statement] = STATE(2121),
    [sym_break_statement] = STATE(2121),
    [sym_return_statement] = STATE(2121),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2121),
    [sym_do_statement] = STATE(2121),
    [sym_for_statement] = STATE(2121),
    [sym_foreach_statement] = STATE(2121),
    [sym_if_statement] = STATE(2121),
    [sym_colon_block] = STATE(2535),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2121),
    [sym_compound_statement] = STATE(2121),
    [sym_named_label_statement] = STATE(2121),
    [sym_expression_statement] = STATE(2121),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_empty_statement] = STATE(2089),
    [sym_function_static_declaration] = STATE(2089),
    [sym_global_declaration] = STATE(2089),
    [sym_namespace_definition] = STATE(2089),
    [sym_namespace_use_declaration] = STATE(2089),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2089),
    [sym_interface_declaration] = STATE(2089),
    [sym_enum_declaration] = STATE(2089),
    [sym_class_declaration] = STATE(2089),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2089),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2089),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2089),
    [sym_unset_statement] = STATE(2089),
    [sym_declare_statement] = STATE(2089),
    [sym_try_statement] = STATE(2089),
    [sym_goto_statement] = STATE(2089),
    [sym_continue_statement] = STATE(2089),
    [sym_break_statement] = STATE(2089),
    [sym_return_statement] = STATE(2089),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2089),
    [sym_do_statement] = STATE(2089),
    [sym_for_statement] = STATE(2089),
    [sym_foreach_statement] = STATE(2089),
    [sym_if_statement] = STATE(2089),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2089),
    [sym_compound_statement] = STATE(2089),
    [sym_named_label_statement] = STATE(2089),
    [sym_expression_statement] = STATE(2089),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(461),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(463),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(465),
  },
  [25] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(457),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_empty_statement] = STATE(58),
    [sym_function_static_declaration] = STATE(58),
    [sym_global_declaration] = STATE(58),
    [sym_namespace_definition] = STATE(58),
    [sym_namespace_use_declaration] = STATE(58),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(58),
    [sym_interface_declaration] = STATE(58),
    [sym_enum_declaration] = STATE(58),
    [sym_class_declaration] = STATE(58),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(58),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(58),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(58),
    [sym_unset_statement] = STATE(58),
    [sym_declare_statement] = STATE(58),
    [sym_try_statement] = STATE(58),
    [sym_goto_statement] = STATE(58),
    [sym_continue_statement] = STATE(58),
    [sym_break_statement] = STATE(58),
    [sym_return_statement] = STATE(58),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(58),
    [sym_do_statement] = STATE(58),
    [sym_for_statement] = STATE(58),
    [sym_foreach_statement] = STATE(58),
    [sym_if_statement] = STATE(58),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(58),
    [sym_compound_statement] = STATE(58),
    [sym_named_label_statement] = STATE(58),
    [sym_expression_statement] = STATE(58),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(58),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(467),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_empty_statement] = STATE(519),
    [sym_function_static_declaration] = STATE(519),
    [sym_global_declaration] = STATE(519),
    [sym_namespace_definition] = STATE(519),
    [sym_namespace_use_declaration] = STATE(519),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(519),
    [sym_interface_declaration] = STATE(519),
    [sym_enum_declaration] = STATE(519),
    [sym_class_declaration] = STATE(519),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(519),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(519),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(519),
    [sym_unset_statement] = STATE(519),
    [sym_declare_statement] = STATE(519),
    [sym_try_statement] = STATE(519),
    [sym_goto_statement] = STATE(519),
    [sym_continue_statement] = STATE(519),
    [sym_break_statement] = STATE(519),
    [sym_return_statement] = STATE(519),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(519),
    [sym_do_statement] = STATE(519),
    [sym_for_statement] = STATE(519),
    [sym_foreach_statement] = STATE(519),
    [sym_if_statement] = STATE(519),
    [sym_colon_block] = STATE(2505),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(519),
    [sym_compound_statement] = STATE(519),
    [sym_named_label_statement] = STATE(519),
    [sym_expression_statement] = STATE(519),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_empty_statement] = STATE(1590),
    [sym_function_static_declaration] = STATE(1590),
    [sym_global_declaration] = STATE(1590),
    [sym_namespace_definition] = STATE(1590),
    [sym_namespace_use_declaration] = STATE(1590),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(1590),
    [sym_interface_declaration] = STATE(1590),
    [sym_enum_declaration] = STATE(1590),
    [sym_class_declaration] = STATE(1590),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(1590),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(1590),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(1590),
    [sym_unset_statement] = STATE(1590),
    [sym_declare_statement] = STATE(1590),
    [sym_try_statement] = STATE(1590),
    [sym_goto_statement] = STATE(1590),
    [sym_continue_statement] = STATE(1590),
    [sym_break_statement] = STATE(1590),
    [sym_return_statement] = STATE(1590),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(1590),
    [sym_do_statement] = STATE(1590),
    [sym_for_statement] = STATE(1590),
    [sym_foreach_statement] = STATE(1590),
    [sym_if_statement] = STATE(1590),
    [sym_colon_block] = STATE(1582),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(1590),
    [sym_compound_statement] = STATE(1590),
    [sym_named_label_statement] = STATE(1590),
    [sym_expression_statement] = STATE(1590),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_empty_statement] = STATE(425),
    [sym_function_static_declaration] = STATE(425),
    [sym_global_declaration] = STATE(425),
    [sym_namespace_definition] = STATE(425),
    [sym_namespace_use_declaration] = STATE(425),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(425),
    [sym_interface_declaration] = STATE(425),
    [sym_enum_declaration] = STATE(425),
    [sym_class_declaration] = STATE(425),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(425),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(425),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(425),
    [sym_unset_statement] = STATE(425),
    [sym_declare_statement] = STATE(425),
    [sym_try_statement] = STATE(425),
    [sym_goto_statement] = STATE(425),
    [sym_continue_statement] = STATE(425),
    [sym_break_statement] = STATE(425),
    [sym_return_statement] = STATE(425),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(425),
    [sym_do_statement] = STATE(425),
    [sym_for_statement] = STATE(425),
    [sym_foreach_statement] = STATE(425),
    [sym_if_statement] = STATE(425),
    [sym_colon_block] = STATE(1581),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(425),
    [sym_compound_statement] = STATE(425),
    [sym_named_label_statement] = STATE(425),
    [sym_expression_statement] = STATE(425),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(471),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_empty_statement] = STATE(34),
    [sym_function_static_declaration] = STATE(34),
    [sym_global_declaration] = STATE(34),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_use_declaration] = STATE(34),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(34),
    [sym_interface_declaration] = STATE(34),
    [sym_enum_declaration] = STATE(34),
    [sym_class_declaration] = STATE(34),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(34),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(34),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(34),
    [sym_unset_statement] = STATE(34),
    [sym_declare_statement] = STATE(34),
    [sym_try_statement] = STATE(34),
    [sym_goto_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(34),
    [sym_do_statement] = STATE(34),
    [sym_for_statement] = STATE(34),
    [sym_foreach_statement] = STATE(34),
    [sym_if_statement] = STATE(34),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(34),
    [sym_compound_statement] = STATE(34),
    [sym_named_label_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(34),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(471),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_empty_statement] = STATE(519),
    [sym_function_static_declaration] = STATE(519),
    [sym_global_declaration] = STATE(519),
    [sym_namespace_definition] = STATE(519),
    [sym_namespace_use_declaration] = STATE(519),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(519),
    [sym_interface_declaration] = STATE(519),
    [sym_enum_declaration] = STATE(519),
    [sym_class_declaration] = STATE(519),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(519),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(519),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(519),
    [sym_unset_statement] = STATE(519),
    [sym_declare_statement] = STATE(519),
    [sym_try_statement] = STATE(519),
    [sym_goto_statement] = STATE(519),
    [sym_continue_statement] = STATE(519),
    [sym_break_statement] = STATE(519),
    [sym_return_statement] = STATE(519),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(519),
    [sym_do_statement] = STATE(519),
    [sym_for_statement] = STATE(519),
    [sym_foreach_statement] = STATE(519),
    [sym_if_statement] = STATE(519),
    [sym_colon_block] = STATE(2505),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(519),
    [sym_compound_statement] = STATE(519),
    [sym_named_label_statement] = STATE(519),
    [sym_expression_statement] = STATE(519),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_empty_statement] = STATE(473),
    [sym_function_static_declaration] = STATE(473),
    [sym_global_declaration] = STATE(473),
    [sym_namespace_definition] = STATE(473),
    [sym_namespace_use_declaration] = STATE(473),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(473),
    [sym_interface_declaration] = STATE(473),
    [sym_enum_declaration] = STATE(473),
    [sym_class_declaration] = STATE(473),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(473),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(473),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(473),
    [sym_unset_statement] = STATE(473),
    [sym_declare_statement] = STATE(473),
    [sym_try_statement] = STATE(473),
    [sym_goto_statement] = STATE(473),
    [sym_continue_statement] = STATE(473),
    [sym_break_statement] = STATE(473),
    [sym_return_statement] = STATE(473),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(473),
    [sym_do_statement] = STATE(473),
    [sym_for_statement] = STATE(473),
    [sym_foreach_statement] = STATE(473),
    [sym_if_statement] = STATE(473),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(473),
    [sym_compound_statement] = STATE(473),
    [sym_named_label_statement] = STATE(473),
    [sym_expression_statement] = STATE(473),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(473),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(475),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(477),
  },
  [34] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(479),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_empty_statement] = STATE(42),
    [sym_function_static_declaration] = STATE(42),
    [sym_global_declaration] = STATE(42),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_use_declaration] = STATE(42),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(42),
    [sym_interface_declaration] = STATE(42),
    [sym_enum_declaration] = STATE(42),
    [sym_class_declaration] = STATE(42),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(42),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(42),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(42),
    [sym_unset_statement] = STATE(42),
    [sym_declare_statement] = STATE(42),
    [sym_try_statement] = STATE(42),
    [sym_goto_statement] = STATE(42),
    [sym_continue_statement] = STATE(42),
    [sym_break_statement] = STATE(42),
    [sym_return_statement] = STATE(42),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(42),
    [sym_do_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_foreach_statement] = STATE(42),
    [sym_if_statement] = STATE(42),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(42),
    [sym_compound_statement] = STATE(42),
    [sym_named_label_statement] = STATE(42),
    [sym_expression_statement] = STATE(42),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(42),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(479),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_empty_statement] = STATE(511),
    [sym_function_static_declaration] = STATE(511),
    [sym_global_declaration] = STATE(511),
    [sym_namespace_definition] = STATE(511),
    [sym_namespace_use_declaration] = STATE(511),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(511),
    [sym_interface_declaration] = STATE(511),
    [sym_enum_declaration] = STATE(511),
    [sym_class_declaration] = STATE(511),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(511),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(511),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(511),
    [sym_unset_statement] = STATE(511),
    [sym_declare_statement] = STATE(511),
    [sym_try_statement] = STATE(511),
    [sym_goto_statement] = STATE(511),
    [sym_continue_statement] = STATE(511),
    [sym_break_statement] = STATE(511),
    [sym_return_statement] = STATE(511),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(511),
    [sym_do_statement] = STATE(511),
    [sym_for_statement] = STATE(511),
    [sym_foreach_statement] = STATE(511),
    [sym_if_statement] = STATE(511),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(511),
    [sym_compound_statement] = STATE(511),
    [sym_named_label_statement] = STATE(511),
    [sym_expression_statement] = STATE(511),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(481),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(483),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(485),
  },
  [37] = {
    [sym_empty_statement] = STATE(489),
    [sym_function_static_declaration] = STATE(489),
    [sym_global_declaration] = STATE(489),
    [sym_namespace_definition] = STATE(489),
    [sym_namespace_use_declaration] = STATE(489),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(489),
    [sym_interface_declaration] = STATE(489),
    [sym_enum_declaration] = STATE(489),
    [sym_class_declaration] = STATE(489),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(489),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(489),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(489),
    [sym_unset_statement] = STATE(489),
    [sym_declare_statement] = STATE(489),
    [sym_try_statement] = STATE(489),
    [sym_goto_statement] = STATE(489),
    [sym_continue_statement] = STATE(489),
    [sym_break_statement] = STATE(489),
    [sym_return_statement] = STATE(489),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(489),
    [sym_do_statement] = STATE(489),
    [sym_for_statement] = STATE(489),
    [sym_foreach_statement] = STATE(489),
    [sym_if_statement] = STATE(489),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(489),
    [sym_compound_statement] = STATE(489),
    [sym_named_label_statement] = STATE(489),
    [sym_expression_statement] = STATE(489),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(487),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(489),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(491),
  },
  [38] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(493),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_empty_statement] = STATE(511),
    [sym_function_static_declaration] = STATE(511),
    [sym_global_declaration] = STATE(511),
    [sym_namespace_definition] = STATE(511),
    [sym_namespace_use_declaration] = STATE(511),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(511),
    [sym_interface_declaration] = STATE(511),
    [sym_enum_declaration] = STATE(511),
    [sym_class_declaration] = STATE(511),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(511),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(511),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(511),
    [sym_unset_statement] = STATE(511),
    [sym_declare_statement] = STATE(511),
    [sym_try_statement] = STATE(511),
    [sym_goto_statement] = STATE(511),
    [sym_continue_statement] = STATE(511),
    [sym_break_statement] = STATE(511),
    [sym_return_statement] = STATE(511),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(511),
    [sym_do_statement] = STATE(511),
    [sym_for_statement] = STATE(511),
    [sym_foreach_statement] = STATE(511),
    [sym_if_statement] = STATE(511),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(511),
    [sym_compound_statement] = STATE(511),
    [sym_named_label_statement] = STATE(511),
    [sym_expression_statement] = STATE(511),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(481),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(483),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(485),
  },
  [40] = {
    [sym_empty_statement] = STATE(2053),
    [sym_function_static_declaration] = STATE(2053),
    [sym_global_declaration] = STATE(2053),
    [sym_namespace_definition] = STATE(2053),
    [sym_namespace_use_declaration] = STATE(2053),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2053),
    [sym_interface_declaration] = STATE(2053),
    [sym_enum_declaration] = STATE(2053),
    [sym_class_declaration] = STATE(2053),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2053),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2053),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2053),
    [sym_unset_statement] = STATE(2053),
    [sym_declare_statement] = STATE(2053),
    [sym_try_statement] = STATE(2053),
    [sym_goto_statement] = STATE(2053),
    [sym_continue_statement] = STATE(2053),
    [sym_break_statement] = STATE(2053),
    [sym_return_statement] = STATE(2053),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2053),
    [sym_do_statement] = STATE(2053),
    [sym_for_statement] = STATE(2053),
    [sym_foreach_statement] = STATE(2053),
    [sym_if_statement] = STATE(2053),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2053),
    [sym_compound_statement] = STATE(2053),
    [sym_named_label_statement] = STATE(2053),
    [sym_expression_statement] = STATE(2053),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(495),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(497),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [41] = {
    [sym_empty_statement] = STATE(75),
    [sym_function_static_declaration] = STATE(75),
    [sym_global_declaration] = STATE(75),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_use_declaration] = STATE(75),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(75),
    [sym_interface_declaration] = STATE(75),
    [sym_enum_declaration] = STATE(75),
    [sym_class_declaration] = STATE(75),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(75),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(75),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(75),
    [sym_unset_statement] = STATE(75),
    [sym_declare_statement] = STATE(75),
    [sym_try_statement] = STATE(75),
    [sym_goto_statement] = STATE(75),
    [sym_continue_statement] = STATE(75),
    [sym_break_statement] = STATE(75),
    [sym_return_statement] = STATE(75),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(75),
    [sym_do_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_foreach_statement] = STATE(75),
    [sym_if_statement] = STATE(75),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(75),
    [sym_compound_statement] = STATE(75),
    [sym_named_label_statement] = STATE(75),
    [sym_expression_statement] = STATE(75),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(75),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(501),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(503),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_empty_statement] = STATE(44),
    [sym_function_static_declaration] = STATE(44),
    [sym_global_declaration] = STATE(44),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_use_declaration] = STATE(44),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(44),
    [sym_interface_declaration] = STATE(44),
    [sym_enum_declaration] = STATE(44),
    [sym_class_declaration] = STATE(44),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(44),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(44),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(44),
    [sym_unset_statement] = STATE(44),
    [sym_declare_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_foreach_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(44),
    [sym_compound_statement] = STATE(44),
    [sym_named_label_statement] = STATE(44),
    [sym_expression_statement] = STATE(44),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(44),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(503),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(505),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(507),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_empty_statement] = STATE(2121),
    [sym_function_static_declaration] = STATE(2121),
    [sym_global_declaration] = STATE(2121),
    [sym_namespace_definition] = STATE(2121),
    [sym_namespace_use_declaration] = STATE(2121),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2121),
    [sym_interface_declaration] = STATE(2121),
    [sym_enum_declaration] = STATE(2121),
    [sym_class_declaration] = STATE(2121),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2121),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2121),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2121),
    [sym_unset_statement] = STATE(2121),
    [sym_declare_statement] = STATE(2121),
    [sym_try_statement] = STATE(2121),
    [sym_goto_statement] = STATE(2121),
    [sym_continue_statement] = STATE(2121),
    [sym_break_statement] = STATE(2121),
    [sym_return_statement] = STATE(2121),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2121),
    [sym_do_statement] = STATE(2121),
    [sym_for_statement] = STATE(2121),
    [sym_foreach_statement] = STATE(2121),
    [sym_if_statement] = STATE(2121),
    [sym_colon_block] = STATE(2535),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2121),
    [sym_compound_statement] = STATE(2121),
    [sym_named_label_statement] = STATE(2121),
    [sym_expression_statement] = STATE(2121),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(367),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_empty_statement] = STATE(557),
    [sym_function_static_declaration] = STATE(557),
    [sym_global_declaration] = STATE(557),
    [sym_namespace_definition] = STATE(557),
    [sym_namespace_use_declaration] = STATE(557),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(557),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(557),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(557),
    [sym_unset_statement] = STATE(557),
    [sym_declare_statement] = STATE(557),
    [sym_try_statement] = STATE(557),
    [sym_goto_statement] = STATE(557),
    [sym_continue_statement] = STATE(557),
    [sym_break_statement] = STATE(557),
    [sym_return_statement] = STATE(557),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(557),
    [sym_do_statement] = STATE(557),
    [sym_for_statement] = STATE(557),
    [sym_foreach_statement] = STATE(557),
    [sym_if_statement] = STATE(557),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(557),
    [sym_compound_statement] = STATE(557),
    [sym_named_label_statement] = STATE(557),
    [sym_expression_statement] = STATE(557),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(509),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(511),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(513),
  },
  [48] = {
    [sym_empty_statement] = STATE(74),
    [sym_function_static_declaration] = STATE(74),
    [sym_global_declaration] = STATE(74),
    [sym_namespace_definition] = STATE(74),
    [sym_namespace_use_declaration] = STATE(74),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(74),
    [sym_interface_declaration] = STATE(74),
    [sym_enum_declaration] = STATE(74),
    [sym_class_declaration] = STATE(74),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(74),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(74),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(74),
    [sym_unset_statement] = STATE(74),
    [sym_declare_statement] = STATE(74),
    [sym_try_statement] = STATE(74),
    [sym_goto_statement] = STATE(74),
    [sym_continue_statement] = STATE(74),
    [sym_break_statement] = STATE(74),
    [sym_return_statement] = STATE(74),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(74),
    [sym_do_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_foreach_statement] = STATE(74),
    [sym_if_statement] = STATE(74),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(74),
    [sym_compound_statement] = STATE(74),
    [sym_named_label_statement] = STATE(74),
    [sym_expression_statement] = STATE(74),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(74),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(515),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(517),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_empty_statement] = STATE(473),
    [sym_function_static_declaration] = STATE(473),
    [sym_global_declaration] = STATE(473),
    [sym_namespace_definition] = STATE(473),
    [sym_namespace_use_declaration] = STATE(473),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(473),
    [sym_interface_declaration] = STATE(473),
    [sym_enum_declaration] = STATE(473),
    [sym_class_declaration] = STATE(473),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(473),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(473),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(473),
    [sym_unset_statement] = STATE(473),
    [sym_declare_statement] = STATE(473),
    [sym_try_statement] = STATE(473),
    [sym_goto_statement] = STATE(473),
    [sym_continue_statement] = STATE(473),
    [sym_break_statement] = STATE(473),
    [sym_return_statement] = STATE(473),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(473),
    [sym_do_statement] = STATE(473),
    [sym_for_statement] = STATE(473),
    [sym_foreach_statement] = STATE(473),
    [sym_if_statement] = STATE(473),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(473),
    [sym_compound_statement] = STATE(473),
    [sym_named_label_statement] = STATE(473),
    [sym_expression_statement] = STATE(473),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(473),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(475),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(477),
  },
  [51] = {
    [sym_empty_statement] = STATE(49),
    [sym_function_static_declaration] = STATE(49),
    [sym_global_declaration] = STATE(49),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_use_declaration] = STATE(49),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(49),
    [sym_interface_declaration] = STATE(49),
    [sym_enum_declaration] = STATE(49),
    [sym_class_declaration] = STATE(49),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(49),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(49),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(49),
    [sym_unset_statement] = STATE(49),
    [sym_declare_statement] = STATE(49),
    [sym_try_statement] = STATE(49),
    [sym_goto_statement] = STATE(49),
    [sym_continue_statement] = STATE(49),
    [sym_break_statement] = STATE(49),
    [sym_return_statement] = STATE(49),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(49),
    [sym_do_statement] = STATE(49),
    [sym_for_statement] = STATE(49),
    [sym_foreach_statement] = STATE(49),
    [sym_if_statement] = STATE(49),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(49),
    [sym_compound_statement] = STATE(49),
    [sym_named_label_statement] = STATE(49),
    [sym_expression_statement] = STATE(49),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(49),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(519),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_empty_statement] = STATE(25),
    [sym_function_static_declaration] = STATE(25),
    [sym_global_declaration] = STATE(25),
    [sym_namespace_definition] = STATE(25),
    [sym_namespace_use_declaration] = STATE(25),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_class_declaration] = STATE(25),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(25),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(25),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(25),
    [sym_unset_statement] = STATE(25),
    [sym_declare_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_goto_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_foreach_statement] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(25),
    [sym_compound_statement] = STATE(25),
    [sym_named_label_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(507),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_empty_statement] = STATE(424),
    [sym_function_static_declaration] = STATE(424),
    [sym_global_declaration] = STATE(424),
    [sym_namespace_definition] = STATE(424),
    [sym_namespace_use_declaration] = STATE(424),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(424),
    [sym_interface_declaration] = STATE(424),
    [sym_enum_declaration] = STATE(424),
    [sym_class_declaration] = STATE(424),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(424),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(424),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(424),
    [sym_unset_statement] = STATE(424),
    [sym_declare_statement] = STATE(424),
    [sym_try_statement] = STATE(424),
    [sym_goto_statement] = STATE(424),
    [sym_continue_statement] = STATE(424),
    [sym_break_statement] = STATE(424),
    [sym_return_statement] = STATE(424),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(424),
    [sym_do_statement] = STATE(424),
    [sym_for_statement] = STATE(424),
    [sym_foreach_statement] = STATE(424),
    [sym_if_statement] = STATE(424),
    [sym_colon_block] = STATE(1581),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(424),
    [sym_compound_statement] = STATE(424),
    [sym_named_label_statement] = STATE(424),
    [sym_expression_statement] = STATE(424),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_empty_statement] = STATE(532),
    [sym_function_static_declaration] = STATE(532),
    [sym_global_declaration] = STATE(532),
    [sym_namespace_definition] = STATE(532),
    [sym_namespace_use_declaration] = STATE(532),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(532),
    [sym_interface_declaration] = STATE(532),
    [sym_enum_declaration] = STATE(532),
    [sym_class_declaration] = STATE(532),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(532),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(532),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(532),
    [sym_unset_statement] = STATE(532),
    [sym_declare_statement] = STATE(532),
    [sym_try_statement] = STATE(532),
    [sym_goto_statement] = STATE(532),
    [sym_continue_statement] = STATE(532),
    [sym_break_statement] = STATE(532),
    [sym_return_statement] = STATE(532),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(532),
    [sym_do_statement] = STATE(532),
    [sym_for_statement] = STATE(532),
    [sym_foreach_statement] = STATE(532),
    [sym_if_statement] = STATE(532),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(532),
    [sym_compound_statement] = STATE(532),
    [sym_named_label_statement] = STATE(532),
    [sym_expression_statement] = STATE(532),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(521),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(523),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(525),
  },
  [55] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(527),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_empty_statement] = STATE(2068),
    [sym_function_static_declaration] = STATE(2068),
    [sym_global_declaration] = STATE(2068),
    [sym_namespace_definition] = STATE(2068),
    [sym_namespace_use_declaration] = STATE(2068),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2068),
    [sym_interface_declaration] = STATE(2068),
    [sym_enum_declaration] = STATE(2068),
    [sym_class_declaration] = STATE(2068),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2068),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2068),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2068),
    [sym_unset_statement] = STATE(2068),
    [sym_declare_statement] = STATE(2068),
    [sym_try_statement] = STATE(2068),
    [sym_goto_statement] = STATE(2068),
    [sym_continue_statement] = STATE(2068),
    [sym_break_statement] = STATE(2068),
    [sym_return_statement] = STATE(2068),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2068),
    [sym_do_statement] = STATE(2068),
    [sym_for_statement] = STATE(2068),
    [sym_foreach_statement] = STATE(2068),
    [sym_if_statement] = STATE(2068),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2068),
    [sym_compound_statement] = STATE(2068),
    [sym_named_label_statement] = STATE(2068),
    [sym_expression_statement] = STATE(2068),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(443),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(445),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(447),
  },
  [57] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(529),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(531),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_empty_statement] = STATE(532),
    [sym_function_static_declaration] = STATE(532),
    [sym_global_declaration] = STATE(532),
    [sym_namespace_definition] = STATE(532),
    [sym_namespace_use_declaration] = STATE(532),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(532),
    [sym_interface_declaration] = STATE(532),
    [sym_enum_declaration] = STATE(532),
    [sym_class_declaration] = STATE(532),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(532),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(532),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(532),
    [sym_unset_statement] = STATE(532),
    [sym_declare_statement] = STATE(532),
    [sym_try_statement] = STATE(532),
    [sym_goto_statement] = STATE(532),
    [sym_continue_statement] = STATE(532),
    [sym_break_statement] = STATE(532),
    [sym_return_statement] = STATE(532),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(532),
    [sym_do_statement] = STATE(532),
    [sym_for_statement] = STATE(532),
    [sym_foreach_statement] = STATE(532),
    [sym_if_statement] = STATE(532),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(532),
    [sym_compound_statement] = STATE(532),
    [sym_named_label_statement] = STATE(532),
    [sym_expression_statement] = STATE(532),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(521),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(523),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(525),
  },
  [60] = {
    [sym_empty_statement] = STATE(55),
    [sym_function_static_declaration] = STATE(55),
    [sym_global_declaration] = STATE(55),
    [sym_namespace_definition] = STATE(55),
    [sym_namespace_use_declaration] = STATE(55),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(55),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(55),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(55),
    [sym_unset_statement] = STATE(55),
    [sym_declare_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym_foreach_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(55),
    [sym_compound_statement] = STATE(55),
    [sym_named_label_statement] = STATE(55),
    [sym_expression_statement] = STATE(55),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(55),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(533),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(535),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_empty_statement] = STATE(45),
    [sym_function_static_declaration] = STATE(45),
    [sym_global_declaration] = STATE(45),
    [sym_namespace_definition] = STATE(45),
    [sym_namespace_use_declaration] = STATE(45),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(45),
    [sym_interface_declaration] = STATE(45),
    [sym_enum_declaration] = STATE(45),
    [sym_class_declaration] = STATE(45),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(45),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(45),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(45),
    [sym_unset_statement] = STATE(45),
    [sym_declare_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_goto_statement] = STATE(45),
    [sym_continue_statement] = STATE(45),
    [sym_break_statement] = STATE(45),
    [sym_return_statement] = STATE(45),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(45),
    [sym_do_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_foreach_statement] = STATE(45),
    [sym_if_statement] = STATE(45),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(45),
    [sym_compound_statement] = STATE(45),
    [sym_named_label_statement] = STATE(45),
    [sym_expression_statement] = STATE(45),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(45),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(537),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_empty_statement] = STATE(1621),
    [sym_function_static_declaration] = STATE(1621),
    [sym_global_declaration] = STATE(1621),
    [sym_namespace_definition] = STATE(1621),
    [sym_namespace_use_declaration] = STATE(1621),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(1621),
    [sym_interface_declaration] = STATE(1621),
    [sym_enum_declaration] = STATE(1621),
    [sym_class_declaration] = STATE(1621),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(1621),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(1621),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(1621),
    [sym_unset_statement] = STATE(1621),
    [sym_declare_statement] = STATE(1621),
    [sym_try_statement] = STATE(1621),
    [sym_goto_statement] = STATE(1621),
    [sym_continue_statement] = STATE(1621),
    [sym_break_statement] = STATE(1621),
    [sym_return_statement] = STATE(1621),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(1621),
    [sym_do_statement] = STATE(1621),
    [sym_for_statement] = STATE(1621),
    [sym_foreach_statement] = STATE(1621),
    [sym_if_statement] = STATE(1621),
    [sym_colon_block] = STATE(1582),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(1621),
    [sym_compound_statement] = STATE(1621),
    [sym_named_label_statement] = STATE(1621),
    [sym_expression_statement] = STATE(1621),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(469),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_empty_statement] = STATE(2089),
    [sym_function_static_declaration] = STATE(2089),
    [sym_global_declaration] = STATE(2089),
    [sym_namespace_definition] = STATE(2089),
    [sym_namespace_use_declaration] = STATE(2089),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2089),
    [sym_interface_declaration] = STATE(2089),
    [sym_enum_declaration] = STATE(2089),
    [sym_class_declaration] = STATE(2089),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2089),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2089),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2089),
    [sym_unset_statement] = STATE(2089),
    [sym_declare_statement] = STATE(2089),
    [sym_try_statement] = STATE(2089),
    [sym_goto_statement] = STATE(2089),
    [sym_continue_statement] = STATE(2089),
    [sym_break_statement] = STATE(2089),
    [sym_return_statement] = STATE(2089),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2089),
    [sym_do_statement] = STATE(2089),
    [sym_for_statement] = STATE(2089),
    [sym_foreach_statement] = STATE(2089),
    [sym_if_statement] = STATE(2089),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2089),
    [sym_compound_statement] = STATE(2089),
    [sym_named_label_statement] = STATE(2089),
    [sym_expression_statement] = STATE(2089),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(461),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(463),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(465),
  },
  [65] = {
    [sym_empty_statement] = STATE(2053),
    [sym_function_static_declaration] = STATE(2053),
    [sym_global_declaration] = STATE(2053),
    [sym_namespace_definition] = STATE(2053),
    [sym_namespace_use_declaration] = STATE(2053),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2053),
    [sym_interface_declaration] = STATE(2053),
    [sym_enum_declaration] = STATE(2053),
    [sym_class_declaration] = STATE(2053),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2053),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2053),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2053),
    [sym_unset_statement] = STATE(2053),
    [sym_declare_statement] = STATE(2053),
    [sym_try_statement] = STATE(2053),
    [sym_goto_statement] = STATE(2053),
    [sym_continue_statement] = STATE(2053),
    [sym_break_statement] = STATE(2053),
    [sym_return_statement] = STATE(2053),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2053),
    [sym_do_statement] = STATE(2053),
    [sym_for_statement] = STATE(2053),
    [sym_foreach_statement] = STATE(2053),
    [sym_if_statement] = STATE(2053),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2053),
    [sym_compound_statement] = STATE(2053),
    [sym_named_label_statement] = STATE(2053),
    [sym_expression_statement] = STATE(2053),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(495),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(497),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [66] = {
    [sym_empty_statement] = STATE(557),
    [sym_function_static_declaration] = STATE(557),
    [sym_global_declaration] = STATE(557),
    [sym_namespace_definition] = STATE(557),
    [sym_namespace_use_declaration] = STATE(557),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(557),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(557),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(557),
    [sym_unset_statement] = STATE(557),
    [sym_declare_statement] = STATE(557),
    [sym_try_statement] = STATE(557),
    [sym_goto_statement] = STATE(557),
    [sym_continue_statement] = STATE(557),
    [sym_break_statement] = STATE(557),
    [sym_return_statement] = STATE(557),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(557),
    [sym_do_statement] = STATE(557),
    [sym_for_statement] = STATE(557),
    [sym_foreach_statement] = STATE(557),
    [sym_if_statement] = STATE(557),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(557),
    [sym_compound_statement] = STATE(557),
    [sym_named_label_statement] = STATE(557),
    [sym_expression_statement] = STATE(557),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(509),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(511),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(513),
  },
  [67] = {
    [sym_empty_statement] = STATE(489),
    [sym_function_static_declaration] = STATE(489),
    [sym_global_declaration] = STATE(489),
    [sym_namespace_definition] = STATE(489),
    [sym_namespace_use_declaration] = STATE(489),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(489),
    [sym_interface_declaration] = STATE(489),
    [sym_enum_declaration] = STATE(489),
    [sym_class_declaration] = STATE(489),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(489),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(489),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(489),
    [sym_unset_statement] = STATE(489),
    [sym_declare_statement] = STATE(489),
    [sym_try_statement] = STATE(489),
    [sym_goto_statement] = STATE(489),
    [sym_continue_statement] = STATE(489),
    [sym_break_statement] = STATE(489),
    [sym_return_statement] = STATE(489),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(489),
    [sym_do_statement] = STATE(489),
    [sym_for_statement] = STATE(489),
    [sym_foreach_statement] = STATE(489),
    [sym_if_statement] = STATE(489),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(489),
    [sym_compound_statement] = STATE(489),
    [sym_named_label_statement] = STATE(489),
    [sym_expression_statement] = STATE(489),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(487),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [anon_sym_COLON] = ACTIONS(489),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(491),
  },
  [68] = {
    [sym_empty_statement] = STATE(61),
    [sym_function_static_declaration] = STATE(61),
    [sym_global_declaration] = STATE(61),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_use_declaration] = STATE(61),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(61),
    [sym_interface_declaration] = STATE(61),
    [sym_enum_declaration] = STATE(61),
    [sym_class_declaration] = STATE(61),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(61),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(61),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(61),
    [sym_unset_statement] = STATE(61),
    [sym_declare_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_foreach_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(61),
    [sym_compound_statement] = STATE(61),
    [sym_named_label_statement] = STATE(61),
    [sym_expression_statement] = STATE(61),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(61),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(539),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_empty_statement] = STATE(1996),
    [sym_function_static_declaration] = STATE(1996),
    [sym_global_declaration] = STATE(1996),
    [sym_namespace_definition] = STATE(1996),
    [sym_namespace_use_declaration] = STATE(1996),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(1996),
    [sym_interface_declaration] = STATE(1996),
    [sym_enum_declaration] = STATE(1996),
    [sym_class_declaration] = STATE(1996),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(1996),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(1996),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(1996),
    [sym_unset_statement] = STATE(1996),
    [sym_declare_statement] = STATE(1996),
    [sym_try_statement] = STATE(1996),
    [sym_goto_statement] = STATE(1996),
    [sym_continue_statement] = STATE(1996),
    [sym_break_statement] = STATE(1996),
    [sym_return_statement] = STATE(1996),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(1996),
    [sym_do_statement] = STATE(1996),
    [sym_for_statement] = STATE(1996),
    [sym_foreach_statement] = STATE(1996),
    [sym_if_statement] = STATE(1996),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(1996),
    [sym_compound_statement] = STATE(1996),
    [sym_named_label_statement] = STATE(1996),
    [sym_expression_statement] = STATE(1996),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(541),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(543),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(545),
  },
  [70] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [aux_sym_declare_statement_token2] = ACTIONS(547),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_empty_statement] = STATE(30),
    [sym_function_static_declaration] = STATE(30),
    [sym_global_declaration] = STATE(30),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_use_declaration] = STATE(30),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(30),
    [sym_interface_declaration] = STATE(30),
    [sym_enum_declaration] = STATE(30),
    [sym_class_declaration] = STATE(30),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(30),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(30),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(30),
    [sym_unset_statement] = STATE(30),
    [sym_declare_statement] = STATE(30),
    [sym_try_statement] = STATE(30),
    [sym_goto_statement] = STATE(30),
    [sym_continue_statement] = STATE(30),
    [sym_break_statement] = STATE(30),
    [sym_return_statement] = STATE(30),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(30),
    [sym_do_statement] = STATE(30),
    [sym_for_statement] = STATE(30),
    [sym_foreach_statement] = STATE(30),
    [sym_if_statement] = STATE(30),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(30),
    [sym_compound_statement] = STATE(30),
    [sym_named_label_statement] = STATE(30),
    [sym_expression_statement] = STATE(30),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(30),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(549),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_empty_statement] = STATE(2009),
    [sym_function_static_declaration] = STATE(2009),
    [sym_global_declaration] = STATE(2009),
    [sym_namespace_definition] = STATE(2009),
    [sym_namespace_use_declaration] = STATE(2009),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2009),
    [sym_interface_declaration] = STATE(2009),
    [sym_enum_declaration] = STATE(2009),
    [sym_class_declaration] = STATE(2009),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2009),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2009),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2009),
    [sym_unset_statement] = STATE(2009),
    [sym_declare_statement] = STATE(2009),
    [sym_try_statement] = STATE(2009),
    [sym_goto_statement] = STATE(2009),
    [sym_continue_statement] = STATE(2009),
    [sym_break_statement] = STATE(2009),
    [sym_return_statement] = STATE(2009),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2009),
    [sym_do_statement] = STATE(2009),
    [sym_for_statement] = STATE(2009),
    [sym_foreach_statement] = STATE(2009),
    [sym_if_statement] = STATE(2009),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2009),
    [sym_compound_statement] = STATE(2009),
    [sym_named_label_statement] = STATE(2009),
    [sym_expression_statement] = STATE(2009),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(449),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(451),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [73] = {
    [sym_empty_statement] = STATE(1996),
    [sym_function_static_declaration] = STATE(1996),
    [sym_global_declaration] = STATE(1996),
    [sym_namespace_definition] = STATE(1996),
    [sym_namespace_use_declaration] = STATE(1996),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(1996),
    [sym_interface_declaration] = STATE(1996),
    [sym_enum_declaration] = STATE(1996),
    [sym_class_declaration] = STATE(1996),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(1996),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(1996),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(1996),
    [sym_unset_statement] = STATE(1996),
    [sym_declare_statement] = STATE(1996),
    [sym_try_statement] = STATE(1996),
    [sym_goto_statement] = STATE(1996),
    [sym_continue_statement] = STATE(1996),
    [sym_break_statement] = STATE(1996),
    [sym_return_statement] = STATE(1996),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(1996),
    [sym_do_statement] = STATE(1996),
    [sym_for_statement] = STATE(1996),
    [sym_foreach_statement] = STATE(1996),
    [sym_if_statement] = STATE(1996),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(1996),
    [sym_compound_statement] = STATE(1996),
    [sym_named_label_statement] = STATE(1996),
    [sym_expression_statement] = STATE(1996),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(541),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [anon_sym_COLON] = ACTIONS(543),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(545),
  },
  [74] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_for_statement_token2] = ACTIONS(537),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_empty_statement] = STATE(2),
    [sym_function_static_declaration] = STATE(2),
    [sym_global_declaration] = STATE(2),
    [sym_namespace_definition] = STATE(2),
    [sym_namespace_use_declaration] = STATE(2),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2),
    [sym_interface_declaration] = STATE(2),
    [sym_enum_declaration] = STATE(2),
    [sym_class_declaration] = STATE(2),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(2),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(2),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2),
    [sym_unset_statement] = STATE(2),
    [sym_declare_statement] = STATE(2),
    [sym_try_statement] = STATE(2),
    [sym_goto_statement] = STATE(2),
    [sym_continue_statement] = STATE(2),
    [sym_break_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2),
    [sym_do_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_foreach_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2),
    [sym_compound_statement] = STATE(2),
    [sym_named_label_statement] = STATE(2),
    [sym_expression_statement] = STATE(2),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(2),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(551),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_empty_statement] = STATE(57),
    [sym_function_static_declaration] = STATE(57),
    [sym_global_declaration] = STATE(57),
    [sym_namespace_definition] = STATE(57),
    [sym_namespace_use_declaration] = STATE(57),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(57),
    [sym_interface_declaration] = STATE(57),
    [sym_enum_declaration] = STATE(57),
    [sym_class_declaration] = STATE(57),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(57),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(57),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(57),
    [sym_unset_statement] = STATE(57),
    [sym_declare_statement] = STATE(57),
    [sym_try_statement] = STATE(57),
    [sym_goto_statement] = STATE(57),
    [sym_continue_statement] = STATE(57),
    [sym_break_statement] = STATE(57),
    [sym_return_statement] = STATE(57),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(57),
    [sym_do_statement] = STATE(57),
    [sym_for_statement] = STATE(57),
    [sym_foreach_statement] = STATE(57),
    [sym_if_statement] = STATE(57),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(57),
    [sym_compound_statement] = STATE(57),
    [sym_named_label_statement] = STATE(57),
    [sym_expression_statement] = STATE(57),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_program_repeat1] = STATE(57),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(553),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_empty_statement] = STATE(495),
    [sym_function_static_declaration] = STATE(495),
    [sym_global_declaration] = STATE(495),
    [sym_namespace_definition] = STATE(495),
    [sym_namespace_use_declaration] = STATE(495),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(495),
    [sym_interface_declaration] = STATE(495),
    [sym_enum_declaration] = STATE(495),
    [sym_class_declaration] = STATE(495),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(495),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(495),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(495),
    [sym_unset_statement] = STATE(495),
    [sym_declare_statement] = STATE(495),
    [sym_try_statement] = STATE(495),
    [sym_goto_statement] = STATE(495),
    [sym_continue_statement] = STATE(495),
    [sym_break_statement] = STATE(495),
    [sym_return_statement] = STATE(495),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(495),
    [sym_do_statement] = STATE(495),
    [sym_for_statement] = STATE(495),
    [sym_foreach_statement] = STATE(495),
    [sym_if_statement] = STATE(495),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(495),
    [sym_compound_statement] = STATE(495),
    [sym_named_label_statement] = STATE(495),
    [sym_expression_statement] = STATE(495),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_empty_statement] = STATE(2590),
    [sym_function_static_declaration] = STATE(2590),
    [sym_global_declaration] = STATE(2590),
    [sym_namespace_definition] = STATE(2590),
    [sym_namespace_use_declaration] = STATE(2590),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2590),
    [sym_interface_declaration] = STATE(2590),
    [sym_enum_declaration] = STATE(2590),
    [sym_class_declaration] = STATE(2590),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2590),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2590),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2590),
    [sym_unset_statement] = STATE(2590),
    [sym_declare_statement] = STATE(2590),
    [sym_try_statement] = STATE(2590),
    [sym_goto_statement] = STATE(2590),
    [sym_continue_statement] = STATE(2590),
    [sym_break_statement] = STATE(2590),
    [sym_return_statement] = STATE(2590),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2590),
    [sym_do_statement] = STATE(2590),
    [sym_for_statement] = STATE(2590),
    [sym_foreach_statement] = STATE(2590),
    [sym_if_statement] = STATE(2590),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2590),
    [sym_compound_statement] = STATE(2590),
    [sym_named_label_statement] = STATE(2590),
    [sym_expression_statement] = STATE(2590),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_empty_statement] = STATE(496),
    [sym_function_static_declaration] = STATE(496),
    [sym_global_declaration] = STATE(496),
    [sym_namespace_definition] = STATE(496),
    [sym_namespace_use_declaration] = STATE(496),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(496),
    [sym_interface_declaration] = STATE(496),
    [sym_enum_declaration] = STATE(496),
    [sym_class_declaration] = STATE(496),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(496),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(496),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(496),
    [sym_unset_statement] = STATE(496),
    [sym_declare_statement] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym_foreach_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(496),
    [sym_compound_statement] = STATE(496),
    [sym_named_label_statement] = STATE(496),
    [sym_expression_statement] = STATE(496),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(353),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(355),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(357),
    [aux_sym_foreach_statement_token1] = ACTIONS(359),
    [aux_sym_if_statement_token1] = ACTIONS(361),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_empty_statement] = STATE(2084),
    [sym_function_static_declaration] = STATE(2084),
    [sym_global_declaration] = STATE(2084),
    [sym_namespace_definition] = STATE(2084),
    [sym_namespace_use_declaration] = STATE(2084),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2084),
    [sym_interface_declaration] = STATE(2084),
    [sym_enum_declaration] = STATE(2084),
    [sym_class_declaration] = STATE(2084),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2084),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2084),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2084),
    [sym_unset_statement] = STATE(2084),
    [sym_declare_statement] = STATE(2084),
    [sym_try_statement] = STATE(2084),
    [sym_goto_statement] = STATE(2084),
    [sym_continue_statement] = STATE(2084),
    [sym_break_statement] = STATE(2084),
    [sym_return_statement] = STATE(2084),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2084),
    [sym_do_statement] = STATE(2084),
    [sym_for_statement] = STATE(2084),
    [sym_foreach_statement] = STATE(2084),
    [sym_if_statement] = STATE(2084),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2084),
    [sym_compound_statement] = STATE(2084),
    [sym_named_label_statement] = STATE(2084),
    [sym_expression_statement] = STATE(2084),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_empty_statement] = STATE(2569),
    [sym_function_static_declaration] = STATE(2569),
    [sym_global_declaration] = STATE(2569),
    [sym_namespace_definition] = STATE(2569),
    [sym_namespace_use_declaration] = STATE(2569),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2569),
    [sym_interface_declaration] = STATE(2569),
    [sym_enum_declaration] = STATE(2569),
    [sym_class_declaration] = STATE(2569),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2569),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2569),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2569),
    [sym_unset_statement] = STATE(2569),
    [sym_declare_statement] = STATE(2569),
    [sym_try_statement] = STATE(2569),
    [sym_goto_statement] = STATE(2569),
    [sym_continue_statement] = STATE(2569),
    [sym_break_statement] = STATE(2569),
    [sym_return_statement] = STATE(2569),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2569),
    [sym_do_statement] = STATE(2569),
    [sym_for_statement] = STATE(2569),
    [sym_foreach_statement] = STATE(2569),
    [sym_if_statement] = STATE(2569),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2569),
    [sym_compound_statement] = STATE(2569),
    [sym_named_label_statement] = STATE(2569),
    [sym_expression_statement] = STATE(2569),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(433),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(435),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(437),
    [aux_sym_foreach_statement_token1] = ACTIONS(439),
    [aux_sym_if_statement_token1] = ACTIONS(441),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_empty_statement] = STATE(2066),
    [sym_function_static_declaration] = STATE(2066),
    [sym_global_declaration] = STATE(2066),
    [sym_namespace_definition] = STATE(2066),
    [sym_namespace_use_declaration] = STATE(2066),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2066),
    [sym_interface_declaration] = STATE(2066),
    [sym_enum_declaration] = STATE(2066),
    [sym_class_declaration] = STATE(2066),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2066),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2066),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2066),
    [sym_unset_statement] = STATE(2066),
    [sym_declare_statement] = STATE(2066),
    [sym_try_statement] = STATE(2066),
    [sym_goto_statement] = STATE(2066),
    [sym_continue_statement] = STATE(2066),
    [sym_break_statement] = STATE(2066),
    [sym_return_statement] = STATE(2066),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2066),
    [sym_do_statement] = STATE(2066),
    [sym_for_statement] = STATE(2066),
    [sym_foreach_statement] = STATE(2066),
    [sym_if_statement] = STATE(2066),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2066),
    [sym_compound_statement] = STATE(2066),
    [sym_named_label_statement] = STATE(2066),
    [sym_expression_statement] = STATE(2066),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_empty_statement] = STATE(495),
    [sym_function_static_declaration] = STATE(495),
    [sym_global_declaration] = STATE(495),
    [sym_namespace_definition] = STATE(495),
    [sym_namespace_use_declaration] = STATE(495),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(495),
    [sym_interface_declaration] = STATE(495),
    [sym_enum_declaration] = STATE(495),
    [sym_class_declaration] = STATE(495),
    [sym_final_modifier] = STATE(1918),
    [sym_abstract_modifier] = STATE(1918),
    [sym_readonly_modifier] = STATE(2625),
    [sym_const_declaration] = STATE(495),
    [sym__const_declaration] = STATE(548),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2623),
    [sym_function_definition] = STATE(495),
    [sym__function_definition_header] = STATE(2213),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(495),
    [sym_unset_statement] = STATE(495),
    [sym_declare_statement] = STATE(495),
    [sym_try_statement] = STATE(495),
    [sym_goto_statement] = STATE(495),
    [sym_continue_statement] = STATE(495),
    [sym_break_statement] = STATE(495),
    [sym_return_statement] = STATE(495),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(495),
    [sym_do_statement] = STATE(495),
    [sym_for_statement] = STATE(495),
    [sym_foreach_statement] = STATE(495),
    [sym_if_statement] = STATE(495),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(495),
    [sym_compound_statement] = STATE(495),
    [sym_named_label_statement] = STATE(495),
    [sym_expression_statement] = STATE(495),
    [sym__expression] = STATE(1216),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1410),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(13),
    [aux_sym_function_static_declaration_token1] = ACTIONS(15),
    [aux_sym_global_declaration_token1] = ACTIONS(17),
    [aux_sym_namespace_definition_token1] = ACTIONS(19),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(21),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(25),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [aux_sym_trait_declaration_token1] = ACTIONS(31),
    [aux_sym_interface_declaration_token1] = ACTIONS(33),
    [aux_sym_enum_declaration_token1] = ACTIONS(35),
    [aux_sym_class_declaration_token1] = ACTIONS(37),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(53),
    [anon_sym_unset] = ACTIONS(55),
    [aux_sym_declare_statement_token1] = ACTIONS(57),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(61),
    [aux_sym_goto_statement_token1] = ACTIONS(63),
    [aux_sym_continue_statement_token1] = ACTIONS(65),
    [aux_sym_break_statement_token1] = ACTIONS(67),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(69),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(73),
    [aux_sym_do_statement_token1] = ACTIONS(75),
    [aux_sym_for_statement_token1] = ACTIONS(77),
    [aux_sym_foreach_statement_token1] = ACTIONS(79),
    [aux_sym_if_statement_token1] = ACTIONS(81),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_empty_statement] = STATE(2084),
    [sym_function_static_declaration] = STATE(2084),
    [sym_global_declaration] = STATE(2084),
    [sym_namespace_definition] = STATE(2084),
    [sym_namespace_use_declaration] = STATE(2084),
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_trait_declaration] = STATE(2084),
    [sym_interface_declaration] = STATE(2084),
    [sym_enum_declaration] = STATE(2084),
    [sym_class_declaration] = STATE(2084),
    [sym_final_modifier] = STATE(1933),
    [sym_abstract_modifier] = STATE(1933),
    [sym_readonly_modifier] = STATE(2563),
    [sym_const_declaration] = STATE(2084),
    [sym__const_declaration] = STATE(2148),
    [sym_static_modifier] = STATE(2624),
    [sym_visibility_modifier] = STATE(2564),
    [sym_function_definition] = STATE(2084),
    [sym__function_definition_header] = STATE(2416),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_echo_statement] = STATE(2084),
    [sym_unset_statement] = STATE(2084),
    [sym_declare_statement] = STATE(2084),
    [sym_try_statement] = STATE(2084),
    [sym_goto_statement] = STATE(2084),
    [sym_continue_statement] = STATE(2084),
    [sym_break_statement] = STATE(2084),
    [sym_return_statement] = STATE(2084),
    [sym_throw_expression] = STATE(1037),
    [sym_while_statement] = STATE(2084),
    [sym_do_statement] = STATE(2084),
    [sym_for_statement] = STATE(2084),
    [sym_foreach_statement] = STATE(2084),
    [sym_if_statement] = STATE(2084),
    [sym_match_expression] = STATE(1056),
    [sym_switch_statement] = STATE(2084),
    [sym_compound_statement] = STATE(2084),
    [sym_named_label_statement] = STATE(2084),
    [sym_expression_statement] = STATE(2084),
    [sym__expression] = STATE(1233),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1402),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(459),
    [aux_sym_function_static_declaration_token1] = ACTIONS(383),
    [aux_sym_global_declaration_token1] = ACTIONS(385),
    [aux_sym_namespace_definition_token1] = ACTIONS(387),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(389),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(23),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(391),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(393),
    [aux_sym_trait_declaration_token1] = ACTIONS(395),
    [aux_sym_interface_declaration_token1] = ACTIONS(397),
    [aux_sym_enum_declaration_token1] = ACTIONS(399),
    [aux_sym_class_declaration_token1] = ACTIONS(401),
    [aux_sym_final_modifier_token1] = ACTIONS(39),
    [aux_sym_abstract_modifier_token1] = ACTIONS(41),
    [aux_sym_readonly_modifier_token1] = ACTIONS(43),
    [aux_sym_visibility_modifier_token1] = ACTIONS(45),
    [aux_sym_visibility_modifier_token2] = ACTIONS(45),
    [aux_sym_visibility_modifier_token3] = ACTIONS(45),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [aux_sym_echo_statement_token1] = ACTIONS(403),
    [anon_sym_unset] = ACTIONS(405),
    [aux_sym_declare_statement_token1] = ACTIONS(407),
    [sym_float] = ACTIONS(59),
    [aux_sym_try_statement_token1] = ACTIONS(409),
    [aux_sym_goto_statement_token1] = ACTIONS(411),
    [aux_sym_continue_statement_token1] = ACTIONS(413),
    [aux_sym_break_statement_token1] = ACTIONS(415),
    [sym_integer] = ACTIONS(59),
    [aux_sym_return_statement_token1] = ACTIONS(417),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_while_statement_token1] = ACTIONS(419),
    [aux_sym_do_statement_token1] = ACTIONS(421),
    [aux_sym_for_statement_token1] = ACTIONS(423),
    [aux_sym_foreach_statement_token1] = ACTIONS(425),
    [aux_sym_if_statement_token1] = ACTIONS(427),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [aux_sym_switch_statement_token1] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(997),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_AMP] = ACTIONS(559),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym_namespace_aliasing_clause_token1] = ACTIONS(567),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_COLON] = ACTIONS(557),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_yield_expression_token2] = ACTIONS(613),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1018),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_AMP] = ACTIONS(559),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(557),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(557),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(557),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_yield_expression_token2] = ACTIONS(643),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1109),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_variadic_unpacking] = STATE(1089),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_by_ref] = STATE(1089),
    [sym_yield_expression] = STATE(1056),
    [sym_array_element_initializer] = STATE(1106),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_AMP] = ACTIONS(655),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [anon_sym_COMMA] = ACTIONS(557),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(87),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_yield_expression_token2] = ACTIONS(663),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(557),
  },
  [88] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1169),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(559),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(557),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [anon_sym_QMARK] = ACTIONS(567),
    [anon_sym_PIPE] = ACTIONS(567),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_yield_expression_token2] = ACTIONS(685),
    [aux_sym_binary_expression_token1] = ACTIONS(567),
    [anon_sym_QMARK_QMARK] = ACTIONS(557),
    [anon_sym_STAR_STAR] = ACTIONS(557),
    [aux_sym_binary_expression_token2] = ACTIONS(567),
    [aux_sym_binary_expression_token3] = ACTIONS(567),
    [aux_sym_binary_expression_token4] = ACTIONS(567),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_CARET] = ACTIONS(557),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(567),
    [anon_sym_LT_GT] = ACTIONS(557),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(557),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ_GT] = ACTIONS(557),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_STAR] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(557),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2531),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2541),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2545),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2530),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2538),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2523),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2477),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2502),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2595),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1244),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2451),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_cast_type] = STATE(2502),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1244),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(695),
    [aux_sym_cast_type_token2] = ACTIONS(697),
    [aux_sym_cast_type_token3] = ACTIONS(697),
    [aux_sym_cast_type_token4] = ACTIONS(697),
    [aux_sym_cast_type_token5] = ACTIONS(697),
    [aux_sym_cast_type_token6] = ACTIONS(697),
    [aux_sym_cast_type_token7] = ACTIONS(697),
    [aux_sym_cast_type_token8] = ACTIONS(697),
    [aux_sym_cast_type_token9] = ACTIONS(697),
    [aux_sym_cast_type_token10] = ACTIONS(697),
    [aux_sym_cast_type_token11] = ACTIONS(697),
    [aux_sym_cast_type_token12] = ACTIONS(697),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2662),
    [sym_argument] = STATE(2170),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(705),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(1926),
    [sym_function_call_expression] = STATE(610),
    [sym_scoped_call_expression] = STATE(610),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(610),
    [sym_nullsafe_member_call_expression] = STATE(610),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(610),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(610),
    [sym_variable_name] = STATE(610),
    [sym_by_ref] = STATE(2254),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym__array_destructing_repeat1] = STATE(1928),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(729),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(731),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2486),
    [sym_argument] = STATE(1960),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(733),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(1926),
    [sym_function_call_expression] = STATE(610),
    [sym_scoped_call_expression] = STATE(610),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(610),
    [sym_nullsafe_member_call_expression] = STATE(610),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(610),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(610),
    [sym_variable_name] = STATE(610),
    [sym_by_ref] = STATE(2254),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym__array_destructing_repeat1] = STATE(1928),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(729),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2640),
    [sym_argument] = STATE(2177),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(739),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2665),
    [sym_argument] = STATE(1916),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(743),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2591),
    [sym_argument] = STATE(2147),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(747),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2621),
    [sym_argument] = STATE(2168),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(751),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(1926),
    [sym_function_call_expression] = STATE(610),
    [sym_scoped_call_expression] = STATE(610),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(610),
    [sym_nullsafe_member_call_expression] = STATE(610),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(610),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(610),
    [sym_variable_name] = STATE(610),
    [sym_by_ref] = STATE(2254),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym__array_destructing_repeat1] = STATE(1928),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(729),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(755),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2603),
    [sym_argument] = STATE(2161),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(757),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(1926),
    [sym_function_call_expression] = STATE(610),
    [sym_scoped_call_expression] = STATE(610),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(610),
    [sym_nullsafe_member_call_expression] = STATE(610),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(610),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(610),
    [sym_variable_name] = STATE(610),
    [sym_by_ref] = STATE(2254),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1927),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym__array_destructing_repeat1] = STATE(1928),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(761),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1180),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(637),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(637),
    [sym_nullsafe_member_access_expression] = STATE(637),
    [sym_scoped_property_access_expression] = STATE(637),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(1926),
    [sym_function_call_expression] = STATE(610),
    [sym_scoped_call_expression] = STATE(610),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(610),
    [sym_nullsafe_member_call_expression] = STATE(610),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(610),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(610),
    [sym_variable_name] = STATE(610),
    [sym_by_ref] = STATE(2254),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym__array_destructing_repeat1] = STATE(1928),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(729),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_RBRACK] = ACTIONS(765),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_variadic_placeholder] = STATE(2626),
    [sym_argument] = STATE(2102),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [anon_sym_COMMA] = ACTIONS(767),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(769),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(715),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1947),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(773),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1927),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(787),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(789),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1955),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(795),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(797),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(1923),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(811),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym_match_condition_list] = STATE(2464),
    [sym_match_conditional_expression] = STATE(1992),
    [sym_match_default_expression] = STATE(1992),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(819),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(821),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(829),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_reference_modifier] = STATE(201),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1195),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_argument] = STATE(2282),
    [sym__argument_name] = STATE(156),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2378),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1480),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(699),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(703),
    [aux_sym_namespace_definition_token1] = ACTIONS(707),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(709),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(717),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [aux_sym__argument_name_token1] = ACTIONS(723),
    [aux_sym__argument_name_token2] = ACTIONS(725),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(833),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(835),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym_match_condition_list] = STATE(2464),
    [sym_match_conditional_expression] = STATE(1950),
    [sym_match_default_expression] = STATE(1950),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(839),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(841),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1272),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(2342),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(2342),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(845),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(847),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_RBRACK] = ACTIONS(851),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1270),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(631),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(631),
    [sym_nullsafe_member_access_expression] = STATE(631),
    [sym_scoped_property_access_expression] = STATE(631),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(1806),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(598),
    [sym_scoped_call_expression] = STATE(598),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(598),
    [sym_nullsafe_member_call_expression] = STATE(598),
    [sym_subscript_expression] = STATE(598),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(598),
    [sym_variable_name] = STATE(598),
    [sym_by_ref] = STATE(1948),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym__list_destructing_repeat1] = STATE(1949),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(854),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(856),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym_match_condition_list] = STATE(2464),
    [sym_match_conditional_expression] = STATE(2220),
    [sym_match_default_expression] = STATE(2220),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(858),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym_match_condition_list] = STATE(2464),
    [sym_match_conditional_expression] = STATE(2220),
    [sym_match_default_expression] = STATE(2220),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(860),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1177),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1181),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_variadic_unpacking] = STATE(958),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(958),
    [sym_yield_expression] = STATE(924),
    [sym_array_element_initializer] = STATE(2003),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(625),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym_match_condition_list] = STATE(2464),
    [sym_match_conditional_expression] = STATE(2220),
    [sym_match_default_expression] = STATE(2220),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(862),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym_match_condition_list] = STATE(2464),
    [sym_match_conditional_expression] = STATE(2220),
    [sym_match_default_expression] = STATE(2220),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(864),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1272),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(2342),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(2342),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(845),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(847),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1272),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(635),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(635),
    [sym_nullsafe_member_access_expression] = STATE(635),
    [sym_scoped_property_access_expression] = STATE(635),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1925),
    [sym__array_destructing_element] = STATE(2342),
    [sym_function_call_expression] = STATE(608),
    [sym_scoped_call_expression] = STATE(608),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(608),
    [sym_nullsafe_member_call_expression] = STATE(608),
    [sym_subscript_expression] = STATE(608),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(608),
    [sym_variable_name] = STATE(608),
    [sym_by_ref] = STATE(2342),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(845),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(847),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(849),
    [anon_sym_RBRACK] = ACTIONS(866),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym_match_condition_list] = STATE(2464),
    [sym_match_conditional_expression] = STATE(2220),
    [sym_match_default_expression] = STATE(2220),
    [sym__expression] = STATE(1176),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [aux_sym_match_default_expression_token1] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1262),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(636),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(636),
    [sym_nullsafe_member_access_expression] = STATE(636),
    [sym_scoped_property_access_expression] = STATE(636),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(1994),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(614),
    [sym_scoped_call_expression] = STATE(614),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(614),
    [sym_nullsafe_member_call_expression] = STATE(614),
    [sym_subscript_expression] = STATE(614),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(614),
    [sym_variable_name] = STATE(614),
    [sym_by_ref] = STATE(2407),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(869),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(869),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_reference_modifier] = STATE(202),
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1185),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2389),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1519),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(701),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2630),
    [sym_sequence_expression] = STATE(2630),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(871),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2459),
    [sym_sequence_expression] = STATE(2459),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(873),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2646),
    [sym_sequence_expression] = STATE(2646),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(875),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2649),
    [sym_sequence_expression] = STATE(2649),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(877),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2602),
    [sym_sequence_expression] = STATE(2602),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(879),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_foreach_pair] = STATE(2516),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1203),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2321),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_by_ref] = STATE(2516),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2457),
    [sym_sequence_expression] = STATE(2457),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(881),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_foreach_pair] = STATE(2597),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1212),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2236),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_by_ref] = STATE(2597),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2652),
    [sym_sequence_expression] = STATE(2652),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(883),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2452),
    [sym_sequence_expression] = STATE(2452),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(885),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2594),
    [sym_sequence_expression] = STATE(2594),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(887),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2491),
    [sym_sequence_expression] = STATE(2491),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(889),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2644),
    [sym_sequence_expression] = STATE(2644),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(891),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2503),
    [sym_sequence_expression] = STATE(2503),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(893),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2493),
    [sym_sequence_expression] = STATE(2493),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(895),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2608),
    [sym_sequence_expression] = STATE(2608),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(897),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2515),
    [sym_sequence_expression] = STATE(2515),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(899),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2659),
    [sym_sequence_expression] = STATE(2659),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(901),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2504),
    [sym_sequence_expression] = STATE(2504),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(903),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2458),
    [sym_sequence_expression] = STATE(2458),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(905),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2589),
    [sym_sequence_expression] = STATE(2589),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(907),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2618),
    [sym_sequence_expression] = STATE(2618),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(909),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_foreach_pair] = STATE(2454),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1193),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2427),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_by_ref] = STATE(2454),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2622),
    [sym_sequence_expression] = STATE(2622),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(911),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2596),
    [sym_sequence_expression] = STATE(2596),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1223),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(913),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2514),
    [sym_sequence_expression] = STATE(2514),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(915),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_foreach_pair] = STATE(2497),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1199),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2341),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_by_ref] = STATE(2497),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__expressions] = STATE(2600),
    [sym_sequence_expression] = STATE(2600),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1213),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(917),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1012),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(953),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1040),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_by_ref] = STATE(1120),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(919),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1217),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(921),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(921),
  },
  [188] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1227),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(923),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(923),
  },
  [189] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1208),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(925),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(925),
  },
  [190] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1230),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(927),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(927),
  },
  [191] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1162),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(953),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(988),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_by_ref] = STATE(953),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(929),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1211),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(931),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(931),
  },
  [194] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1209),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(933),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(933),
  },
  [195] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym__expressions] = STATE(2364),
    [sym_sequence_expression] = STATE(2364),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1173),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym__expressions] = STATE(2242),
    [sym_sequence_expression] = STATE(2242),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1173),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1012),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_by_ref] = STATE(953),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(929),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1269),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2187),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_by_ref] = STATE(2617),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1012),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(638),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(638),
    [sym_nullsafe_member_access_expression] = STATE(638),
    [sym_scoped_property_access_expression] = STATE(638),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(1912),
    [sym_function_call_expression] = STATE(629),
    [sym_scoped_call_expression] = STATE(629),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(629),
    [sym_nullsafe_member_call_expression] = STATE(629),
    [sym_subscript_expression] = STATE(629),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(629),
    [sym_variable_name] = STATE(629),
    [sym_by_ref] = STATE(2401),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(727),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1162),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_by_ref] = STATE(953),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(929),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1184),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2391),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1522),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1219),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_variadic_unpacking] = STATE(2281),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1472),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(667),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1154),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_RPAREN] = ACTIONS(935),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1080),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [anon_sym_AMP] = ACTIONS(937),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1137),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(939),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1031),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(941),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_sequence_expression] = STATE(2269),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1186),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1296),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(943),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(986),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [anon_sym_AMP] = ACTIONS(945),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_sequence_expression] = STATE(2433),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1175),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1218),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1261),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(949),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1218),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_EQ_GT] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1294),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(953),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1288),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(955),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1287),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(957),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1247),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(959),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1248),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(961),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_sequence_expression] = STATE(2269),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1197),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1240),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [anon_sym_COLON] = ACTIONS(963),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1289),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(965),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1278),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1148),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1149),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1280),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1300),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1238),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1114),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1201),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(994),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1200),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1198),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1264),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1011),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1266),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(993),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1236),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1303),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1301),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1020),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(968),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(980),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1123),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1239),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1124),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1125),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1128),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1129),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1134),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1136),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1135),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1127),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1118),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1117),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1093),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1091),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1083),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1082),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1045),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1036),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(991),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1084),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1196),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1292),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(995),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1215),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1298),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1302),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1154),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1282),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1293),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1291),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1285),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1299),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1283),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1290),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(979),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1241),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1235),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1021),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1179),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(974),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1271),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1281),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1284),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(971),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1260),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1295),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1258),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1206),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1255),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1242),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1268),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1204),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1133),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1279),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1132),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1243),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1274),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1245),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1237),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1273),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1251),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1277),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1276),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1263),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1131),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1214),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1218),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1275),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1126),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1015),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1163),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(905),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(908),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(905),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1178),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1182),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(908),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1168),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1138),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1017),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1172),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1158),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1221),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(975),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1146),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1207),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1225),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [330] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1019),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1153),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1183),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1023),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1234),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(972),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1147),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1024),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1143),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1232),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1027),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1155),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1028),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1160),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1140),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1142),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1210),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1267),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1016),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(970),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1254),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1286),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1101),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1257),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1256),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1249),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(985),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1231),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(978),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [359] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1253),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1229),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1108),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(999),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(982),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1174),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1014),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1052),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1013),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(969),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1165),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1164),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [371] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1026),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(983),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1010),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [374] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1025),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(984),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(981),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [377] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1259),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1166),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [379] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1167),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [380] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1008),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [381] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1007),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1006),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [383] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(987),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(989),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [385] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1252),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1002),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(990),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1005),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(908),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1004),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1150),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1156),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1170),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1244),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(992),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [396] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1003),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1171),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(996),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [399] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1001),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1032),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1297),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1104),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1159),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1151),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1144),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1022),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1103),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1226),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(905),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1157),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1055),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [412] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(973),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [413] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1102),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [414] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym_match_expression] = STATE(1056),
    [sym__expression] = STATE(1119),
    [sym__unary_expression] = STATE(1061),
    [sym_unary_op_expression] = STATE(1061),
    [sym_error_suppression_expression] = STATE(1056),
    [sym_clone_expression] = STATE(1061),
    [sym__primary_expression] = STATE(1061),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1061),
    [sym_cast_variable] = STATE(632),
    [sym_assignment_expression] = STATE(1056),
    [sym_reference_assignment_expression] = STATE(1056),
    [sym_conditional_expression] = STATE(1056),
    [sym_augmented_assignment_expression] = STATE(1056),
    [sym_member_access_expression] = STATE(632),
    [sym_nullsafe_member_access_expression] = STATE(632),
    [sym_scoped_property_access_expression] = STATE(632),
    [sym_list_literal] = STATE(2619),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(606),
    [sym_scoped_call_expression] = STATE(606),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(606),
    [sym_nullsafe_member_call_expression] = STATE(606),
    [sym_subscript_expression] = STATE(606),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(606),
    [sym_variable_name] = STATE(606),
    [sym_yield_expression] = STATE(1056),
    [sym_binary_expression] = STATE(1056),
    [sym_include_expression] = STATE(1056),
    [sym_include_once_expression] = STATE(1056),
    [sym_require_expression] = STATE(1056),
    [sym_require_once_expression] = STATE(1056),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_match_expression_token1] = ACTIONS(83),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(91),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_yield_expression_token1] = ACTIONS(123),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [aux_sym_require_expression_token1] = ACTIONS(129),
    [aux_sym_require_once_expression_token1] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(998),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [416] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1000),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1009),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1030),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(619),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(619),
    [sym_nullsafe_member_access_expression] = STATE(619),
    [sym_scoped_property_access_expression] = STATE(619),
    [sym_list_literal] = STATE(2455),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(596),
    [sym_scoped_call_expression] = STATE(596),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(596),
    [sym_nullsafe_member_call_expression] = STATE(596),
    [sym_subscript_expression] = STATE(596),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(596),
    [sym_variable_name] = STATE(596),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(633),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(639),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(641),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [aux_sym_require_expression_token1] = ACTIONS(649),
    [aux_sym_require_once_expression_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(976),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [420] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(977),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(604),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(604),
    [sym_nullsafe_member_access_expression] = STATE(604),
    [sym_scoped_property_access_expression] = STATE(604),
    [sym_list_literal] = STATE(2467),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(594),
    [sym_scoped_call_expression] = STATE(594),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(594),
    [sym_nullsafe_member_call_expression] = STATE(594),
    [sym_subscript_expression] = STATE(594),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(594),
    [sym_variable_name] = STATE(594),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(595),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(611),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [aux_sym_require_expression_token1] = ACTIONS(619),
    [aux_sym_require_once_expression_token1] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym_match_expression] = STATE(924),
    [sym__expression] = STATE(1152),
    [sym__unary_expression] = STATE(923),
    [sym_unary_op_expression] = STATE(923),
    [sym_error_suppression_expression] = STATE(924),
    [sym_clone_expression] = STATE(923),
    [sym__primary_expression] = STATE(923),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(923),
    [sym_cast_variable] = STATE(634),
    [sym_assignment_expression] = STATE(924),
    [sym_reference_assignment_expression] = STATE(924),
    [sym_conditional_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_member_access_expression] = STATE(634),
    [sym_nullsafe_member_access_expression] = STATE(634),
    [sym_scoped_property_access_expression] = STATE(634),
    [sym_list_literal] = STATE(2521),
    [sym__list_destructing] = STATE(2214),
    [sym__array_destructing] = STATE(2214),
    [sym_function_call_expression] = STATE(627),
    [sym_scoped_call_expression] = STATE(627),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(627),
    [sym_nullsafe_member_call_expression] = STATE(627),
    [sym_subscript_expression] = STATE(627),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(627),
    [sym_variable_name] = STATE(627),
    [sym_yield_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_include_expression] = STATE(924),
    [sym_include_once_expression] = STATE(924),
    [sym_require_expression] = STATE(924),
    [sym_require_once_expression] = STATE(924),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_match_expression_token1] = ACTIONS(579),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_AT] = ACTIONS(675),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [aux_sym__list_destructing_token1] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(681),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_yield_expression_token1] = ACTIONS(683),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [aux_sym_require_expression_token1] = ACTIONS(691),
    [aux_sym_require_once_expression_token1] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_catch_clause] = STATE(423),
    [sym_finally_clause] = STATE(423),
    [aux_sym_try_statement_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(969),
    [sym_name] = ACTIONS(971),
    [anon_sym_QMARK_GT] = ACTIONS(969),
    [anon_sym_SEMI] = ACTIONS(969),
    [aux_sym_function_static_declaration_token1] = ACTIONS(971),
    [aux_sym_global_declaration_token1] = ACTIONS(971),
    [aux_sym_namespace_definition_token1] = ACTIONS(971),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(971),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(971),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(971),
    [anon_sym_BSLASH] = ACTIONS(969),
    [anon_sym_LBRACE] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(969),
    [aux_sym_trait_declaration_token1] = ACTIONS(971),
    [aux_sym_interface_declaration_token1] = ACTIONS(971),
    [aux_sym_enum_declaration_token1] = ACTIONS(971),
    [aux_sym_enum_case_token1] = ACTIONS(971),
    [aux_sym_class_declaration_token1] = ACTIONS(971),
    [aux_sym_final_modifier_token1] = ACTIONS(971),
    [aux_sym_abstract_modifier_token1] = ACTIONS(971),
    [aux_sym_readonly_modifier_token1] = ACTIONS(971),
    [aux_sym_visibility_modifier_token1] = ACTIONS(971),
    [aux_sym_visibility_modifier_token2] = ACTIONS(971),
    [aux_sym_visibility_modifier_token3] = ACTIONS(971),
    [aux_sym__arrow_function_header_token1] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(969),
    [aux_sym_cast_type_token1] = ACTIONS(971),
    [aux_sym_echo_statement_token1] = ACTIONS(971),
    [anon_sym_unset] = ACTIONS(971),
    [aux_sym_declare_statement_token1] = ACTIONS(971),
    [aux_sym_declare_statement_token2] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [aux_sym_try_statement_token1] = ACTIONS(971),
    [aux_sym_catch_clause_token1] = ACTIONS(973),
    [aux_sym_finally_clause_token1] = ACTIONS(975),
    [aux_sym_goto_statement_token1] = ACTIONS(971),
    [aux_sym_continue_statement_token1] = ACTIONS(971),
    [aux_sym_break_statement_token1] = ACTIONS(971),
    [sym_integer] = ACTIONS(971),
    [aux_sym_return_statement_token1] = ACTIONS(971),
    [aux_sym_throw_expression_token1] = ACTIONS(971),
    [aux_sym_while_statement_token1] = ACTIONS(971),
    [aux_sym_while_statement_token2] = ACTIONS(971),
    [aux_sym_do_statement_token1] = ACTIONS(971),
    [aux_sym_for_statement_token1] = ACTIONS(971),
    [aux_sym_for_statement_token2] = ACTIONS(971),
    [aux_sym_foreach_statement_token1] = ACTIONS(971),
    [aux_sym_foreach_statement_token2] = ACTIONS(971),
    [aux_sym_if_statement_token1] = ACTIONS(971),
    [aux_sym_if_statement_token2] = ACTIONS(971),
    [aux_sym_else_if_clause_token1] = ACTIONS(971),
    [aux_sym_else_clause_token1] = ACTIONS(971),
    [aux_sym_match_expression_token1] = ACTIONS(971),
    [aux_sym_match_default_expression_token1] = ACTIONS(971),
    [aux_sym_switch_statement_token1] = ACTIONS(971),
    [aux_sym_switch_block_token1] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_AT] = ACTIONS(969),
    [aux_sym_clone_expression_token1] = ACTIONS(971),
    [aux_sym_print_intrinsic_token1] = ACTIONS(971),
    [aux_sym_object_creation_expression_token1] = ACTIONS(971),
    [anon_sym_DASH_DASH] = ACTIONS(969),
    [anon_sym_PLUS_PLUS] = ACTIONS(969),
    [aux_sym__list_destructing_token1] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(969),
    [anon_sym_self] = ACTIONS(971),
    [anon_sym_parent] = ACTIONS(971),
    [aux_sym__argument_name_token1] = ACTIONS(971),
    [aux_sym__argument_name_token2] = ACTIONS(971),
    [anon_sym_POUND_LBRACK] = ACTIONS(969),
    [aux_sym_encapsed_string_token1] = ACTIONS(969),
    [anon_sym_DQUOTE] = ACTIONS(969),
    [aux_sym_string_token1] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(969),
    [anon_sym_LT_LT_LT] = ACTIONS(969),
    [anon_sym_BQUOTE] = ACTIONS(969),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [aux_sym_yield_expression_token1] = ACTIONS(971),
    [aux_sym_include_expression_token1] = ACTIONS(971),
    [aux_sym_include_once_expression_token1] = ACTIONS(971),
    [aux_sym_require_expression_token1] = ACTIONS(971),
    [aux_sym_require_once_expression_token1] = ACTIONS(971),
    [sym_comment] = ACTIONS(3),
  },
  [423] = {
    [sym_catch_clause] = STATE(423),
    [sym_finally_clause] = STATE(423),
    [aux_sym_try_statement_repeat1] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(977),
    [sym_name] = ACTIONS(979),
    [anon_sym_QMARK_GT] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(977),
    [aux_sym_function_static_declaration_token1] = ACTIONS(979),
    [aux_sym_global_declaration_token1] = ACTIONS(979),
    [aux_sym_namespace_definition_token1] = ACTIONS(979),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(979),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(979),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(979),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [aux_sym_trait_declaration_token1] = ACTIONS(979),
    [aux_sym_interface_declaration_token1] = ACTIONS(979),
    [aux_sym_enum_declaration_token1] = ACTIONS(979),
    [aux_sym_enum_case_token1] = ACTIONS(979),
    [aux_sym_class_declaration_token1] = ACTIONS(979),
    [aux_sym_final_modifier_token1] = ACTIONS(979),
    [aux_sym_abstract_modifier_token1] = ACTIONS(979),
    [aux_sym_readonly_modifier_token1] = ACTIONS(979),
    [aux_sym_visibility_modifier_token1] = ACTIONS(979),
    [aux_sym_visibility_modifier_token2] = ACTIONS(979),
    [aux_sym_visibility_modifier_token3] = ACTIONS(979),
    [aux_sym__arrow_function_header_token1] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(977),
    [aux_sym_cast_type_token1] = ACTIONS(979),
    [aux_sym_echo_statement_token1] = ACTIONS(979),
    [anon_sym_unset] = ACTIONS(979),
    [aux_sym_declare_statement_token1] = ACTIONS(979),
    [aux_sym_declare_statement_token2] = ACTIONS(979),
    [sym_float] = ACTIONS(979),
    [aux_sym_try_statement_token1] = ACTIONS(979),
    [aux_sym_catch_clause_token1] = ACTIONS(981),
    [aux_sym_finally_clause_token1] = ACTIONS(984),
    [aux_sym_goto_statement_token1] = ACTIONS(979),
    [aux_sym_continue_statement_token1] = ACTIONS(979),
    [aux_sym_break_statement_token1] = ACTIONS(979),
    [sym_integer] = ACTIONS(979),
    [aux_sym_return_statement_token1] = ACTIONS(979),
    [aux_sym_throw_expression_token1] = ACTIONS(979),
    [aux_sym_while_statement_token1] = ACTIONS(979),
    [aux_sym_while_statement_token2] = ACTIONS(979),
    [aux_sym_do_statement_token1] = ACTIONS(979),
    [aux_sym_for_statement_token1] = ACTIONS(979),
    [aux_sym_for_statement_token2] = ACTIONS(979),
    [aux_sym_foreach_statement_token1] = ACTIONS(979),
    [aux_sym_foreach_statement_token2] = ACTIONS(979),
    [aux_sym_if_statement_token1] = ACTIONS(979),
    [aux_sym_if_statement_token2] = ACTIONS(979),
    [aux_sym_else_if_clause_token1] = ACTIONS(979),
    [aux_sym_else_clause_token1] = ACTIONS(979),
    [aux_sym_match_expression_token1] = ACTIONS(979),
    [aux_sym_match_default_expression_token1] = ACTIONS(979),
    [aux_sym_switch_statement_token1] = ACTIONS(979),
    [aux_sym_switch_block_token1] = ACTIONS(979),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(977),
    [aux_sym_clone_expression_token1] = ACTIONS(979),
    [aux_sym_print_intrinsic_token1] = ACTIONS(979),
    [aux_sym_object_creation_expression_token1] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(977),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [aux_sym__list_destructing_token1] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_self] = ACTIONS(979),
    [anon_sym_parent] = ACTIONS(979),
    [aux_sym__argument_name_token1] = ACTIONS(979),
    [aux_sym__argument_name_token2] = ACTIONS(979),
    [anon_sym_POUND_LBRACK] = ACTIONS(977),
    [aux_sym_encapsed_string_token1] = ACTIONS(977),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [aux_sym_string_token1] = ACTIONS(977),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(977),
    [aux_sym_yield_expression_token1] = ACTIONS(979),
    [aux_sym_include_expression_token1] = ACTIONS(979),
    [aux_sym_include_once_expression_token1] = ACTIONS(979),
    [aux_sym_require_expression_token1] = ACTIONS(979),
    [aux_sym_require_once_expression_token1] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_else_if_clause] = STATE(552),
    [sym_else_clause] = STATE(554),
    [aux_sym_if_statement_repeat1] = STATE(426),
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_name] = ACTIONS(989),
    [anon_sym_QMARK_GT] = ACTIONS(987),
    [anon_sym_SEMI] = ACTIONS(987),
    [aux_sym_function_static_declaration_token1] = ACTIONS(989),
    [aux_sym_global_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_definition_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [aux_sym_trait_declaration_token1] = ACTIONS(989),
    [aux_sym_interface_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_case_token1] = ACTIONS(989),
    [aux_sym_class_declaration_token1] = ACTIONS(989),
    [aux_sym_final_modifier_token1] = ACTIONS(989),
    [aux_sym_abstract_modifier_token1] = ACTIONS(989),
    [aux_sym_readonly_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token2] = ACTIONS(989),
    [aux_sym_visibility_modifier_token3] = ACTIONS(989),
    [aux_sym__arrow_function_header_token1] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [aux_sym_cast_type_token1] = ACTIONS(989),
    [aux_sym_echo_statement_token1] = ACTIONS(989),
    [anon_sym_unset] = ACTIONS(989),
    [aux_sym_declare_statement_token1] = ACTIONS(989),
    [aux_sym_declare_statement_token2] = ACTIONS(989),
    [sym_float] = ACTIONS(989),
    [aux_sym_try_statement_token1] = ACTIONS(989),
    [aux_sym_goto_statement_token1] = ACTIONS(989),
    [aux_sym_continue_statement_token1] = ACTIONS(989),
    [aux_sym_break_statement_token1] = ACTIONS(989),
    [sym_integer] = ACTIONS(989),
    [aux_sym_return_statement_token1] = ACTIONS(989),
    [aux_sym_throw_expression_token1] = ACTIONS(989),
    [aux_sym_while_statement_token1] = ACTIONS(989),
    [aux_sym_while_statement_token2] = ACTIONS(989),
    [aux_sym_do_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token2] = ACTIONS(989),
    [aux_sym_foreach_statement_token1] = ACTIONS(989),
    [aux_sym_foreach_statement_token2] = ACTIONS(989),
    [aux_sym_if_statement_token1] = ACTIONS(989),
    [aux_sym_if_statement_token2] = ACTIONS(989),
    [aux_sym_else_if_clause_token1] = ACTIONS(991),
    [aux_sym_else_clause_token1] = ACTIONS(994),
    [aux_sym_match_expression_token1] = ACTIONS(989),
    [aux_sym_match_default_expression_token1] = ACTIONS(989),
    [aux_sym_switch_statement_token1] = ACTIONS(989),
    [aux_sym_switch_block_token1] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(987),
    [aux_sym_clone_expression_token1] = ACTIONS(989),
    [aux_sym_print_intrinsic_token1] = ACTIONS(989),
    [aux_sym_object_creation_expression_token1] = ACTIONS(989),
    [anon_sym_DASH_DASH] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(987),
    [aux_sym__list_destructing_token1] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_self] = ACTIONS(989),
    [anon_sym_parent] = ACTIONS(989),
    [aux_sym__argument_name_token1] = ACTIONS(989),
    [aux_sym__argument_name_token2] = ACTIONS(989),
    [anon_sym_POUND_LBRACK] = ACTIONS(987),
    [aux_sym_encapsed_string_token1] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_string_token1] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [aux_sym_yield_expression_token1] = ACTIONS(989),
    [aux_sym_include_expression_token1] = ACTIONS(989),
    [aux_sym_include_once_expression_token1] = ACTIONS(989),
    [aux_sym_require_expression_token1] = ACTIONS(989),
    [aux_sym_require_once_expression_token1] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym_else_if_clause] = STATE(552),
    [sym_else_clause] = STATE(554),
    [aux_sym_if_statement_repeat1] = STATE(427),
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_name] = ACTIONS(989),
    [anon_sym_QMARK_GT] = ACTIONS(987),
    [anon_sym_SEMI] = ACTIONS(987),
    [aux_sym_function_static_declaration_token1] = ACTIONS(989),
    [aux_sym_global_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_definition_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(989),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(989),
    [anon_sym_BSLASH] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [aux_sym_trait_declaration_token1] = ACTIONS(989),
    [aux_sym_interface_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_declaration_token1] = ACTIONS(989),
    [aux_sym_enum_case_token1] = ACTIONS(989),
    [aux_sym_class_declaration_token1] = ACTIONS(989),
    [aux_sym_final_modifier_token1] = ACTIONS(989),
    [aux_sym_abstract_modifier_token1] = ACTIONS(989),
    [aux_sym_readonly_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token1] = ACTIONS(989),
    [aux_sym_visibility_modifier_token2] = ACTIONS(989),
    [aux_sym_visibility_modifier_token3] = ACTIONS(989),
    [aux_sym__arrow_function_header_token1] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(987),
    [aux_sym_cast_type_token1] = ACTIONS(989),
    [aux_sym_echo_statement_token1] = ACTIONS(989),
    [anon_sym_unset] = ACTIONS(989),
    [aux_sym_declare_statement_token1] = ACTIONS(989),
    [aux_sym_declare_statement_token2] = ACTIONS(989),
    [sym_float] = ACTIONS(989),
    [aux_sym_try_statement_token1] = ACTIONS(989),
    [aux_sym_goto_statement_token1] = ACTIONS(989),
    [aux_sym_continue_statement_token1] = ACTIONS(989),
    [aux_sym_break_statement_token1] = ACTIONS(989),
    [sym_integer] = ACTIONS(989),
    [aux_sym_return_statement_token1] = ACTIONS(989),
    [aux_sym_throw_expression_token1] = ACTIONS(989),
    [aux_sym_while_statement_token1] = ACTIONS(989),
    [aux_sym_while_statement_token2] = ACTIONS(989),
    [aux_sym_do_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token1] = ACTIONS(989),
    [aux_sym_for_statement_token2] = ACTIONS(989),
    [aux_sym_foreach_statement_token1] = ACTIONS(989),
    [aux_sym_foreach_statement_token2] = ACTIONS(989),
    [aux_sym_if_statement_token1] = ACTIONS(989),
    [aux_sym_if_statement_token2] = ACTIONS(989),
    [aux_sym_else_if_clause_token1] = ACTIONS(997),
    [aux_sym_else_clause_token1] = ACTIONS(999),
    [aux_sym_match_expression_token1] = ACTIONS(989),
    [aux_sym_match_default_expression_token1] = ACTIONS(989),
    [aux_sym_switch_statement_token1] = ACTIONS(989),
    [aux_sym_switch_block_token1] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(987),
    [aux_sym_clone_expression_token1] = ACTIONS(989),
    [aux_sym_print_intrinsic_token1] = ACTIONS(989),
    [aux_sym_object_creation_expression_token1] = ACTIONS(989),
    [anon_sym_DASH_DASH] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(987),
    [aux_sym__list_destructing_token1] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_self] = ACTIONS(989),
    [anon_sym_parent] = ACTIONS(989),
    [aux_sym__argument_name_token1] = ACTIONS(989),
    [aux_sym__argument_name_token2] = ACTIONS(989),
    [anon_sym_POUND_LBRACK] = ACTIONS(987),
    [aux_sym_encapsed_string_token1] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [aux_sym_string_token1] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(987),
    [anon_sym_LT_LT_LT] = ACTIONS(987),
    [anon_sym_BQUOTE] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [aux_sym_yield_expression_token1] = ACTIONS(989),
    [aux_sym_include_expression_token1] = ACTIONS(989),
    [aux_sym_include_once_expression_token1] = ACTIONS(989),
    [aux_sym_require_expression_token1] = ACTIONS(989),
    [aux_sym_require_once_expression_token1] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_else_if_clause] = STATE(552),
    [sym_else_clause] = STATE(497),
    [aux_sym_if_statement_repeat1] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(1001),
    [sym_name] = ACTIONS(1003),
    [anon_sym_QMARK_GT] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1003),
    [aux_sym_global_declaration_token1] = ACTIONS(1003),
    [aux_sym_namespace_definition_token1] = ACTIONS(1003),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1003),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1003),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1003),
    [anon_sym_BSLASH] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(1001),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [aux_sym_trait_declaration_token1] = ACTIONS(1003),
    [aux_sym_interface_declaration_token1] = ACTIONS(1003),
    [aux_sym_enum_declaration_token1] = ACTIONS(1003),
    [aux_sym_enum_case_token1] = ACTIONS(1003),
    [aux_sym_class_declaration_token1] = ACTIONS(1003),
    [aux_sym_final_modifier_token1] = ACTIONS(1003),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1003),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1003),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1003),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1003),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1003),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1001),
    [aux_sym_cast_type_token1] = ACTIONS(1003),
    [aux_sym_echo_statement_token1] = ACTIONS(1003),
    [anon_sym_unset] = ACTIONS(1003),
    [aux_sym_declare_statement_token1] = ACTIONS(1003),
    [aux_sym_declare_statement_token2] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [aux_sym_try_statement_token1] = ACTIONS(1003),
    [aux_sym_goto_statement_token1] = ACTIONS(1003),
    [aux_sym_continue_statement_token1] = ACTIONS(1003),
    [aux_sym_break_statement_token1] = ACTIONS(1003),
    [sym_integer] = ACTIONS(1003),
    [aux_sym_return_statement_token1] = ACTIONS(1003),
    [aux_sym_throw_expression_token1] = ACTIONS(1003),
    [aux_sym_while_statement_token1] = ACTIONS(1003),
    [aux_sym_while_statement_token2] = ACTIONS(1003),
    [aux_sym_do_statement_token1] = ACTIONS(1003),
    [aux_sym_for_statement_token1] = ACTIONS(1003),
    [aux_sym_for_statement_token2] = ACTIONS(1003),
    [aux_sym_foreach_statement_token1] = ACTIONS(1003),
    [aux_sym_foreach_statement_token2] = ACTIONS(1003),
    [aux_sym_if_statement_token1] = ACTIONS(1003),
    [aux_sym_if_statement_token2] = ACTIONS(1003),
    [aux_sym_else_if_clause_token1] = ACTIONS(1005),
    [aux_sym_else_clause_token1] = ACTIONS(1008),
    [aux_sym_match_expression_token1] = ACTIONS(1003),
    [aux_sym_match_default_expression_token1] = ACTIONS(1003),
    [aux_sym_switch_statement_token1] = ACTIONS(1003),
    [aux_sym_switch_block_token1] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(1001),
    [aux_sym_clone_expression_token1] = ACTIONS(1003),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1003),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1003),
    [anon_sym_DASH_DASH] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1001),
    [aux_sym__list_destructing_token1] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_self] = ACTIONS(1003),
    [anon_sym_parent] = ACTIONS(1003),
    [aux_sym__argument_name_token1] = ACTIONS(1003),
    [aux_sym__argument_name_token2] = ACTIONS(1003),
    [anon_sym_POUND_LBRACK] = ACTIONS(1001),
    [aux_sym_encapsed_string_token1] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1001),
    [aux_sym_string_token1] = ACTIONS(1001),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_LT_LT_LT] = ACTIONS(1001),
    [anon_sym_BQUOTE] = ACTIONS(1001),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [aux_sym_yield_expression_token1] = ACTIONS(1003),
    [aux_sym_include_expression_token1] = ACTIONS(1003),
    [aux_sym_include_once_expression_token1] = ACTIONS(1003),
    [aux_sym_require_expression_token1] = ACTIONS(1003),
    [aux_sym_require_once_expression_token1] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_else_if_clause] = STATE(552),
    [sym_else_clause] = STATE(497),
    [aux_sym_if_statement_repeat1] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(1001),
    [sym_name] = ACTIONS(1003),
    [anon_sym_QMARK_GT] = ACTIONS(1001),
    [anon_sym_SEMI] = ACTIONS(1001),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1003),
    [aux_sym_global_declaration_token1] = ACTIONS(1003),
    [aux_sym_namespace_definition_token1] = ACTIONS(1003),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1003),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1003),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1003),
    [anon_sym_BSLASH] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(1001),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [aux_sym_trait_declaration_token1] = ACTIONS(1003),
    [aux_sym_interface_declaration_token1] = ACTIONS(1003),
    [aux_sym_enum_declaration_token1] = ACTIONS(1003),
    [aux_sym_enum_case_token1] = ACTIONS(1003),
    [aux_sym_class_declaration_token1] = ACTIONS(1003),
    [aux_sym_final_modifier_token1] = ACTIONS(1003),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1003),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1003),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1003),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1003),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1003),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1001),
    [aux_sym_cast_type_token1] = ACTIONS(1003),
    [aux_sym_echo_statement_token1] = ACTIONS(1003),
    [anon_sym_unset] = ACTIONS(1003),
    [aux_sym_declare_statement_token1] = ACTIONS(1003),
    [aux_sym_declare_statement_token2] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [aux_sym_try_statement_token1] = ACTIONS(1003),
    [aux_sym_goto_statement_token1] = ACTIONS(1003),
    [aux_sym_continue_statement_token1] = ACTIONS(1003),
    [aux_sym_break_statement_token1] = ACTIONS(1003),
    [sym_integer] = ACTIONS(1003),
    [aux_sym_return_statement_token1] = ACTIONS(1003),
    [aux_sym_throw_expression_token1] = ACTIONS(1003),
    [aux_sym_while_statement_token1] = ACTIONS(1003),
    [aux_sym_while_statement_token2] = ACTIONS(1003),
    [aux_sym_do_statement_token1] = ACTIONS(1003),
    [aux_sym_for_statement_token1] = ACTIONS(1003),
    [aux_sym_for_statement_token2] = ACTIONS(1003),
    [aux_sym_foreach_statement_token1] = ACTIONS(1003),
    [aux_sym_foreach_statement_token2] = ACTIONS(1003),
    [aux_sym_if_statement_token1] = ACTIONS(1003),
    [aux_sym_if_statement_token2] = ACTIONS(1003),
    [aux_sym_else_if_clause_token1] = ACTIONS(997),
    [aux_sym_else_clause_token1] = ACTIONS(999),
    [aux_sym_match_expression_token1] = ACTIONS(1003),
    [aux_sym_match_default_expression_token1] = ACTIONS(1003),
    [aux_sym_switch_statement_token1] = ACTIONS(1003),
    [aux_sym_switch_block_token1] = ACTIONS(1003),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(1001),
    [aux_sym_clone_expression_token1] = ACTIONS(1003),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1003),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1003),
    [anon_sym_DASH_DASH] = ACTIONS(1001),
    [anon_sym_PLUS_PLUS] = ACTIONS(1001),
    [aux_sym__list_destructing_token1] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_self] = ACTIONS(1003),
    [anon_sym_parent] = ACTIONS(1003),
    [aux_sym__argument_name_token1] = ACTIONS(1003),
    [aux_sym__argument_name_token2] = ACTIONS(1003),
    [anon_sym_POUND_LBRACK] = ACTIONS(1001),
    [aux_sym_encapsed_string_token1] = ACTIONS(1001),
    [anon_sym_DQUOTE] = ACTIONS(1001),
    [aux_sym_string_token1] = ACTIONS(1001),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [anon_sym_LT_LT_LT] = ACTIONS(1001),
    [anon_sym_BQUOTE] = ACTIONS(1001),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [aux_sym_yield_expression_token1] = ACTIONS(1003),
    [aux_sym_include_expression_token1] = ACTIONS(1003),
    [aux_sym_include_once_expression_token1] = ACTIONS(1003),
    [aux_sym_require_expression_token1] = ACTIONS(1003),
    [aux_sym_require_once_expression_token1] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1011),
    [sym_name] = ACTIONS(1013),
    [anon_sym_QMARK_GT] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1013),
    [aux_sym_global_declaration_token1] = ACTIONS(1013),
    [aux_sym_namespace_definition_token1] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1013),
    [anon_sym_BSLASH] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [aux_sym_trait_declaration_token1] = ACTIONS(1013),
    [aux_sym_interface_declaration_token1] = ACTIONS(1013),
    [aux_sym_enum_declaration_token1] = ACTIONS(1013),
    [aux_sym_enum_case_token1] = ACTIONS(1013),
    [aux_sym_class_declaration_token1] = ACTIONS(1013),
    [aux_sym_final_modifier_token1] = ACTIONS(1013),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1013),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1013),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [aux_sym_cast_type_token1] = ACTIONS(1013),
    [aux_sym_echo_statement_token1] = ACTIONS(1013),
    [anon_sym_unset] = ACTIONS(1013),
    [aux_sym_declare_statement_token1] = ACTIONS(1013),
    [aux_sym_declare_statement_token2] = ACTIONS(1013),
    [sym_float] = ACTIONS(1013),
    [aux_sym_try_statement_token1] = ACTIONS(1013),
    [aux_sym_catch_clause_token1] = ACTIONS(1013),
    [aux_sym_finally_clause_token1] = ACTIONS(1013),
    [aux_sym_goto_statement_token1] = ACTIONS(1013),
    [aux_sym_continue_statement_token1] = ACTIONS(1013),
    [aux_sym_break_statement_token1] = ACTIONS(1013),
    [sym_integer] = ACTIONS(1013),
    [aux_sym_return_statement_token1] = ACTIONS(1013),
    [aux_sym_throw_expression_token1] = ACTIONS(1013),
    [aux_sym_while_statement_token1] = ACTIONS(1013),
    [aux_sym_while_statement_token2] = ACTIONS(1013),
    [aux_sym_do_statement_token1] = ACTIONS(1013),
    [aux_sym_for_statement_token1] = ACTIONS(1013),
    [aux_sym_for_statement_token2] = ACTIONS(1013),
    [aux_sym_foreach_statement_token1] = ACTIONS(1013),
    [aux_sym_foreach_statement_token2] = ACTIONS(1013),
    [aux_sym_if_statement_token1] = ACTIONS(1013),
    [aux_sym_if_statement_token2] = ACTIONS(1013),
    [aux_sym_else_if_clause_token1] = ACTIONS(1013),
    [aux_sym_else_clause_token1] = ACTIONS(1013),
    [aux_sym_match_expression_token1] = ACTIONS(1013),
    [aux_sym_match_default_expression_token1] = ACTIONS(1013),
    [aux_sym_switch_statement_token1] = ACTIONS(1013),
    [aux_sym_switch_block_token1] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1011),
    [aux_sym_clone_expression_token1] = ACTIONS(1013),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1013),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1011),
    [aux_sym__list_destructing_token1] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_self] = ACTIONS(1013),
    [anon_sym_parent] = ACTIONS(1013),
    [aux_sym__argument_name_token1] = ACTIONS(1013),
    [aux_sym__argument_name_token2] = ACTIONS(1013),
    [anon_sym_POUND_LBRACK] = ACTIONS(1011),
    [aux_sym_encapsed_string_token1] = ACTIONS(1011),
    [anon_sym_DQUOTE] = ACTIONS(1011),
    [aux_sym_string_token1] = ACTIONS(1011),
    [anon_sym_SQUOTE] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_BQUOTE] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(1011),
    [aux_sym_yield_expression_token1] = ACTIONS(1013),
    [aux_sym_include_expression_token1] = ACTIONS(1013),
    [aux_sym_include_once_expression_token1] = ACTIONS(1013),
    [aux_sym_require_expression_token1] = ACTIONS(1013),
    [aux_sym_require_once_expression_token1] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_name] = ACTIONS(1017),
    [anon_sym_QMARK_GT] = ACTIONS(1015),
    [anon_sym_SEMI] = ACTIONS(1015),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1017),
    [aux_sym_global_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_definition_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1017),
    [anon_sym_BSLASH] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [aux_sym_trait_declaration_token1] = ACTIONS(1017),
    [aux_sym_interface_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_case_token1] = ACTIONS(1017),
    [aux_sym_class_declaration_token1] = ACTIONS(1017),
    [aux_sym_final_modifier_token1] = ACTIONS(1017),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1017),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1017),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [aux_sym_cast_type_token1] = ACTIONS(1017),
    [aux_sym_echo_statement_token1] = ACTIONS(1017),
    [anon_sym_unset] = ACTIONS(1017),
    [aux_sym_declare_statement_token1] = ACTIONS(1017),
    [aux_sym_declare_statement_token2] = ACTIONS(1017),
    [sym_float] = ACTIONS(1017),
    [aux_sym_try_statement_token1] = ACTIONS(1017),
    [aux_sym_catch_clause_token1] = ACTIONS(1017),
    [aux_sym_finally_clause_token1] = ACTIONS(1017),
    [aux_sym_goto_statement_token1] = ACTIONS(1017),
    [aux_sym_continue_statement_token1] = ACTIONS(1017),
    [aux_sym_break_statement_token1] = ACTIONS(1017),
    [sym_integer] = ACTIONS(1017),
    [aux_sym_return_statement_token1] = ACTIONS(1017),
    [aux_sym_throw_expression_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token2] = ACTIONS(1017),
    [aux_sym_do_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token2] = ACTIONS(1017),
    [aux_sym_foreach_statement_token1] = ACTIONS(1017),
    [aux_sym_foreach_statement_token2] = ACTIONS(1017),
    [aux_sym_if_statement_token1] = ACTIONS(1017),
    [aux_sym_if_statement_token2] = ACTIONS(1017),
    [aux_sym_else_if_clause_token1] = ACTIONS(1017),
    [aux_sym_else_clause_token1] = ACTIONS(1017),
    [aux_sym_match_expression_token1] = ACTIONS(1017),
    [aux_sym_match_default_expression_token1] = ACTIONS(1017),
    [aux_sym_switch_statement_token1] = ACTIONS(1017),
    [aux_sym_switch_block_token1] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1015),
    [aux_sym_clone_expression_token1] = ACTIONS(1017),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1017),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [aux_sym__list_destructing_token1] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_self] = ACTIONS(1017),
    [anon_sym_parent] = ACTIONS(1017),
    [aux_sym__argument_name_token1] = ACTIONS(1017),
    [aux_sym__argument_name_token2] = ACTIONS(1017),
    [anon_sym_POUND_LBRACK] = ACTIONS(1015),
    [aux_sym_encapsed_string_token1] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [aux_sym_string_token1] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1015),
    [aux_sym_yield_expression_token1] = ACTIONS(1017),
    [aux_sym_include_expression_token1] = ACTIONS(1017),
    [aux_sym_include_once_expression_token1] = ACTIONS(1017),
    [aux_sym_require_expression_token1] = ACTIONS(1017),
    [aux_sym_require_once_expression_token1] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym_name] = ACTIONS(1021),
    [anon_sym_QMARK_GT] = ACTIONS(1019),
    [anon_sym_SEMI] = ACTIONS(1019),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1021),
    [aux_sym_global_declaration_token1] = ACTIONS(1021),
    [aux_sym_namespace_definition_token1] = ACTIONS(1021),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1021),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1021),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1021),
    [anon_sym_BSLASH] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [aux_sym_trait_declaration_token1] = ACTIONS(1021),
    [aux_sym_interface_declaration_token1] = ACTIONS(1021),
    [aux_sym_enum_declaration_token1] = ACTIONS(1021),
    [aux_sym_enum_case_token1] = ACTIONS(1021),
    [aux_sym_class_declaration_token1] = ACTIONS(1021),
    [aux_sym_final_modifier_token1] = ACTIONS(1021),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1021),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1021),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1021),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1021),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1021),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [aux_sym_cast_type_token1] = ACTIONS(1021),
    [aux_sym_echo_statement_token1] = ACTIONS(1021),
    [anon_sym_unset] = ACTIONS(1021),
    [aux_sym_declare_statement_token1] = ACTIONS(1021),
    [aux_sym_declare_statement_token2] = ACTIONS(1021),
    [sym_float] = ACTIONS(1021),
    [aux_sym_try_statement_token1] = ACTIONS(1021),
    [aux_sym_catch_clause_token1] = ACTIONS(1021),
    [aux_sym_finally_clause_token1] = ACTIONS(1021),
    [aux_sym_goto_statement_token1] = ACTIONS(1021),
    [aux_sym_continue_statement_token1] = ACTIONS(1021),
    [aux_sym_break_statement_token1] = ACTIONS(1021),
    [sym_integer] = ACTIONS(1021),
    [aux_sym_return_statement_token1] = ACTIONS(1021),
    [aux_sym_throw_expression_token1] = ACTIONS(1021),
    [aux_sym_while_statement_token1] = ACTIONS(1021),
    [aux_sym_while_statement_token2] = ACTIONS(1021),
    [aux_sym_do_statement_token1] = ACTIONS(1021),
    [aux_sym_for_statement_token1] = ACTIONS(1021),
    [aux_sym_for_statement_token2] = ACTIONS(1021),
    [aux_sym_foreach_statement_token1] = ACTIONS(1021),
    [aux_sym_foreach_statement_token2] = ACTIONS(1021),
    [aux_sym_if_statement_token1] = ACTIONS(1021),
    [aux_sym_if_statement_token2] = ACTIONS(1021),
    [aux_sym_else_if_clause_token1] = ACTIONS(1021),
    [aux_sym_else_clause_token1] = ACTIONS(1021),
    [aux_sym_match_expression_token1] = ACTIONS(1021),
    [aux_sym_match_default_expression_token1] = ACTIONS(1021),
    [aux_sym_switch_statement_token1] = ACTIONS(1021),
    [aux_sym_switch_block_token1] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1021),
    [anon_sym_DASH] = ACTIONS(1021),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_BANG] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(1019),
    [aux_sym_clone_expression_token1] = ACTIONS(1021),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1021),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1021),
    [anon_sym_DASH_DASH] = ACTIONS(1019),
    [anon_sym_PLUS_PLUS] = ACTIONS(1019),
    [aux_sym__list_destructing_token1] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [anon_sym_self] = ACTIONS(1021),
    [anon_sym_parent] = ACTIONS(1021),
    [aux_sym__argument_name_token1] = ACTIONS(1021),
    [aux_sym__argument_name_token2] = ACTIONS(1021),
    [anon_sym_POUND_LBRACK] = ACTIONS(1019),
    [aux_sym_encapsed_string_token1] = ACTIONS(1019),
    [anon_sym_DQUOTE] = ACTIONS(1019),
    [aux_sym_string_token1] = ACTIONS(1019),
    [anon_sym_SQUOTE] = ACTIONS(1019),
    [anon_sym_LT_LT_LT] = ACTIONS(1019),
    [anon_sym_BQUOTE] = ACTIONS(1019),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [aux_sym_yield_expression_token1] = ACTIONS(1021),
    [aux_sym_include_expression_token1] = ACTIONS(1021),
    [aux_sym_include_once_expression_token1] = ACTIONS(1021),
    [aux_sym_require_expression_token1] = ACTIONS(1021),
    [aux_sym_require_once_expression_token1] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1023),
    [sym_name] = ACTIONS(1025),
    [anon_sym_QMARK_GT] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1023),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1025),
    [aux_sym_global_declaration_token1] = ACTIONS(1025),
    [aux_sym_namespace_definition_token1] = ACTIONS(1025),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1025),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1025),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1025),
    [anon_sym_BSLASH] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [aux_sym_trait_declaration_token1] = ACTIONS(1025),
    [aux_sym_interface_declaration_token1] = ACTIONS(1025),
    [aux_sym_enum_declaration_token1] = ACTIONS(1025),
    [aux_sym_enum_case_token1] = ACTIONS(1025),
    [aux_sym_class_declaration_token1] = ACTIONS(1025),
    [aux_sym_final_modifier_token1] = ACTIONS(1025),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1025),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1025),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1025),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1025),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1025),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [aux_sym_cast_type_token1] = ACTIONS(1025),
    [aux_sym_echo_statement_token1] = ACTIONS(1025),
    [anon_sym_unset] = ACTIONS(1025),
    [aux_sym_declare_statement_token1] = ACTIONS(1025),
    [aux_sym_declare_statement_token2] = ACTIONS(1025),
    [sym_float] = ACTIONS(1025),
    [aux_sym_try_statement_token1] = ACTIONS(1025),
    [aux_sym_catch_clause_token1] = ACTIONS(1025),
    [aux_sym_finally_clause_token1] = ACTIONS(1025),
    [aux_sym_goto_statement_token1] = ACTIONS(1025),
    [aux_sym_continue_statement_token1] = ACTIONS(1025),
    [aux_sym_break_statement_token1] = ACTIONS(1025),
    [sym_integer] = ACTIONS(1025),
    [aux_sym_return_statement_token1] = ACTIONS(1025),
    [aux_sym_throw_expression_token1] = ACTIONS(1025),
    [aux_sym_while_statement_token1] = ACTIONS(1025),
    [aux_sym_while_statement_token2] = ACTIONS(1025),
    [aux_sym_do_statement_token1] = ACTIONS(1025),
    [aux_sym_for_statement_token1] = ACTIONS(1025),
    [aux_sym_for_statement_token2] = ACTIONS(1025),
    [aux_sym_foreach_statement_token1] = ACTIONS(1025),
    [aux_sym_foreach_statement_token2] = ACTIONS(1025),
    [aux_sym_if_statement_token1] = ACTIONS(1025),
    [aux_sym_if_statement_token2] = ACTIONS(1025),
    [aux_sym_else_if_clause_token1] = ACTIONS(1025),
    [aux_sym_else_clause_token1] = ACTIONS(1025),
    [aux_sym_match_expression_token1] = ACTIONS(1025),
    [aux_sym_match_default_expression_token1] = ACTIONS(1025),
    [aux_sym_switch_statement_token1] = ACTIONS(1025),
    [aux_sym_switch_block_token1] = ACTIONS(1025),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_DASH] = ACTIONS(1025),
    [anon_sym_TILDE] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1023),
    [aux_sym_clone_expression_token1] = ACTIONS(1025),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1025),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1023),
    [anon_sym_PLUS_PLUS] = ACTIONS(1023),
    [aux_sym__list_destructing_token1] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [anon_sym_self] = ACTIONS(1025),
    [anon_sym_parent] = ACTIONS(1025),
    [aux_sym__argument_name_token1] = ACTIONS(1025),
    [aux_sym__argument_name_token2] = ACTIONS(1025),
    [anon_sym_POUND_LBRACK] = ACTIONS(1023),
    [aux_sym_encapsed_string_token1] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [aux_sym_string_token1] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LT_LT] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [aux_sym_yield_expression_token1] = ACTIONS(1025),
    [aux_sym_include_expression_token1] = ACTIONS(1025),
    [aux_sym_include_once_expression_token1] = ACTIONS(1025),
    [aux_sym_require_expression_token1] = ACTIONS(1025),
    [aux_sym_require_once_expression_token1] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(1027),
    [sym_name] = ACTIONS(1029),
    [anon_sym_QMARK_GT] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1027),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1029),
    [aux_sym_global_declaration_token1] = ACTIONS(1029),
    [aux_sym_namespace_definition_token1] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1029),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1029),
    [anon_sym_BSLASH] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [aux_sym_trait_declaration_token1] = ACTIONS(1029),
    [aux_sym_interface_declaration_token1] = ACTIONS(1029),
    [aux_sym_enum_declaration_token1] = ACTIONS(1029),
    [aux_sym_enum_case_token1] = ACTIONS(1029),
    [aux_sym_class_declaration_token1] = ACTIONS(1029),
    [aux_sym_final_modifier_token1] = ACTIONS(1029),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1029),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1029),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1029),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [aux_sym_cast_type_token1] = ACTIONS(1029),
    [aux_sym_echo_statement_token1] = ACTIONS(1029),
    [anon_sym_unset] = ACTIONS(1029),
    [aux_sym_declare_statement_token1] = ACTIONS(1029),
    [aux_sym_declare_statement_token2] = ACTIONS(1029),
    [sym_float] = ACTIONS(1029),
    [aux_sym_try_statement_token1] = ACTIONS(1029),
    [aux_sym_catch_clause_token1] = ACTIONS(1029),
    [aux_sym_finally_clause_token1] = ACTIONS(1029),
    [aux_sym_goto_statement_token1] = ACTIONS(1029),
    [aux_sym_continue_statement_token1] = ACTIONS(1029),
    [aux_sym_break_statement_token1] = ACTIONS(1029),
    [sym_integer] = ACTIONS(1029),
    [aux_sym_return_statement_token1] = ACTIONS(1029),
    [aux_sym_throw_expression_token1] = ACTIONS(1029),
    [aux_sym_while_statement_token1] = ACTIONS(1029),
    [aux_sym_while_statement_token2] = ACTIONS(1029),
    [aux_sym_do_statement_token1] = ACTIONS(1029),
    [aux_sym_for_statement_token1] = ACTIONS(1029),
    [aux_sym_for_statement_token2] = ACTIONS(1029),
    [aux_sym_foreach_statement_token1] = ACTIONS(1029),
    [aux_sym_foreach_statement_token2] = ACTIONS(1029),
    [aux_sym_if_statement_token1] = ACTIONS(1029),
    [aux_sym_if_statement_token2] = ACTIONS(1029),
    [aux_sym_else_if_clause_token1] = ACTIONS(1029),
    [aux_sym_else_clause_token1] = ACTIONS(1029),
    [aux_sym_match_expression_token1] = ACTIONS(1029),
    [aux_sym_match_default_expression_token1] = ACTIONS(1029),
    [aux_sym_switch_statement_token1] = ACTIONS(1029),
    [aux_sym_switch_block_token1] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(1027),
    [aux_sym_clone_expression_token1] = ACTIONS(1029),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1029),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [aux_sym__list_destructing_token1] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_self] = ACTIONS(1029),
    [anon_sym_parent] = ACTIONS(1029),
    [aux_sym__argument_name_token1] = ACTIONS(1029),
    [aux_sym__argument_name_token2] = ACTIONS(1029),
    [anon_sym_POUND_LBRACK] = ACTIONS(1027),
    [aux_sym_encapsed_string_token1] = ACTIONS(1027),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [aux_sym_string_token1] = ACTIONS(1027),
    [anon_sym_SQUOTE] = ACTIONS(1027),
    [anon_sym_LT_LT_LT] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1027),
    [aux_sym_yield_expression_token1] = ACTIONS(1029),
    [aux_sym_include_expression_token1] = ACTIONS(1029),
    [aux_sym_include_once_expression_token1] = ACTIONS(1029),
    [aux_sym_require_expression_token1] = ACTIONS(1029),
    [aux_sym_require_once_expression_token1] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_else_if_clause] = STATE(552),
    [aux_sym_if_statement_repeat1] = STATE(433),
    [ts_builtin_sym_end] = ACTIONS(1031),
    [sym_name] = ACTIONS(1033),
    [anon_sym_QMARK_GT] = ACTIONS(1031),
    [anon_sym_SEMI] = ACTIONS(1031),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1033),
    [aux_sym_global_declaration_token1] = ACTIONS(1033),
    [aux_sym_namespace_definition_token1] = ACTIONS(1033),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1033),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1033),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1033),
    [anon_sym_BSLASH] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [aux_sym_trait_declaration_token1] = ACTIONS(1033),
    [aux_sym_interface_declaration_token1] = ACTIONS(1033),
    [aux_sym_enum_declaration_token1] = ACTIONS(1033),
    [aux_sym_enum_case_token1] = ACTIONS(1033),
    [aux_sym_class_declaration_token1] = ACTIONS(1033),
    [aux_sym_final_modifier_token1] = ACTIONS(1033),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1033),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1033),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1033),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1033),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1033),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [aux_sym_cast_type_token1] = ACTIONS(1033),
    [aux_sym_echo_statement_token1] = ACTIONS(1033),
    [anon_sym_unset] = ACTIONS(1033),
    [aux_sym_declare_statement_token1] = ACTIONS(1033),
    [aux_sym_declare_statement_token2] = ACTIONS(1033),
    [sym_float] = ACTIONS(1033),
    [aux_sym_try_statement_token1] = ACTIONS(1033),
    [aux_sym_goto_statement_token1] = ACTIONS(1033),
    [aux_sym_continue_statement_token1] = ACTIONS(1033),
    [aux_sym_break_statement_token1] = ACTIONS(1033),
    [sym_integer] = ACTIONS(1033),
    [aux_sym_return_statement_token1] = ACTIONS(1033),
    [aux_sym_throw_expression_token1] = ACTIONS(1033),
    [aux_sym_while_statement_token1] = ACTIONS(1033),
    [aux_sym_while_statement_token2] = ACTIONS(1033),
    [aux_sym_do_statement_token1] = ACTIONS(1033),
    [aux_sym_for_statement_token1] = ACTIONS(1033),
    [aux_sym_for_statement_token2] = ACTIONS(1033),
    [aux_sym_foreach_statement_token1] = ACTIONS(1033),
    [aux_sym_foreach_statement_token2] = ACTIONS(1033),
    [aux_sym_if_statement_token1] = ACTIONS(1033),
    [aux_sym_if_statement_token2] = ACTIONS(1033),
    [aux_sym_else_if_clause_token1] = ACTIONS(1035),
    [aux_sym_else_clause_token1] = ACTIONS(1033),
    [aux_sym_match_expression_token1] = ACTIONS(1033),
    [aux_sym_match_default_expression_token1] = ACTIONS(1033),
    [aux_sym_switch_statement_token1] = ACTIONS(1033),
    [aux_sym_switch_block_token1] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1033),
    [anon_sym_TILDE] = ACTIONS(1031),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1031),
    [aux_sym_clone_expression_token1] = ACTIONS(1033),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1033),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1031),
    [aux_sym__list_destructing_token1] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [anon_sym_self] = ACTIONS(1033),
    [anon_sym_parent] = ACTIONS(1033),
    [aux_sym__argument_name_token1] = ACTIONS(1033),
    [aux_sym__argument_name_token2] = ACTIONS(1033),
    [anon_sym_POUND_LBRACK] = ACTIONS(1031),
    [aux_sym_encapsed_string_token1] = ACTIONS(1031),
    [anon_sym_DQUOTE] = ACTIONS(1031),
    [aux_sym_string_token1] = ACTIONS(1031),
    [anon_sym_SQUOTE] = ACTIONS(1031),
    [anon_sym_LT_LT_LT] = ACTIONS(1031),
    [anon_sym_BQUOTE] = ACTIONS(1031),
    [anon_sym_DOLLAR] = ACTIONS(1031),
    [aux_sym_yield_expression_token1] = ACTIONS(1033),
    [aux_sym_include_expression_token1] = ACTIONS(1033),
    [aux_sym_include_once_expression_token1] = ACTIONS(1033),
    [aux_sym_require_expression_token1] = ACTIONS(1033),
    [aux_sym_require_once_expression_token1] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(1038),
    [sym_name] = ACTIONS(1040),
    [anon_sym_QMARK_GT] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1042),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1040),
    [aux_sym_global_declaration_token1] = ACTIONS(1040),
    [aux_sym_namespace_definition_token1] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1040),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1040),
    [anon_sym_BSLASH] = ACTIONS(1038),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [aux_sym_trait_declaration_token1] = ACTIONS(1040),
    [aux_sym_interface_declaration_token1] = ACTIONS(1040),
    [aux_sym_enum_declaration_token1] = ACTIONS(1040),
    [aux_sym_enum_case_token1] = ACTIONS(1040),
    [aux_sym_class_declaration_token1] = ACTIONS(1040),
    [aux_sym_final_modifier_token1] = ACTIONS(1040),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1040),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1040),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1040),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1040),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [aux_sym_cast_type_token1] = ACTIONS(1040),
    [aux_sym_echo_statement_token1] = ACTIONS(1040),
    [anon_sym_unset] = ACTIONS(1040),
    [aux_sym_declare_statement_token1] = ACTIONS(1040),
    [aux_sym_declare_statement_token2] = ACTIONS(1040),
    [sym_float] = ACTIONS(1040),
    [aux_sym_try_statement_token1] = ACTIONS(1040),
    [aux_sym_goto_statement_token1] = ACTIONS(1040),
    [aux_sym_continue_statement_token1] = ACTIONS(1040),
    [aux_sym_break_statement_token1] = ACTIONS(1040),
    [sym_integer] = ACTIONS(1040),
    [aux_sym_return_statement_token1] = ACTIONS(1040),
    [aux_sym_throw_expression_token1] = ACTIONS(1040),
    [aux_sym_while_statement_token1] = ACTIONS(1040),
    [aux_sym_while_statement_token2] = ACTIONS(1040),
    [aux_sym_do_statement_token1] = ACTIONS(1040),
    [aux_sym_for_statement_token1] = ACTIONS(1040),
    [aux_sym_for_statement_token2] = ACTIONS(1040),
    [aux_sym_foreach_statement_token1] = ACTIONS(1040),
    [aux_sym_foreach_statement_token2] = ACTIONS(1040),
    [aux_sym_if_statement_token1] = ACTIONS(1040),
    [aux_sym_if_statement_token2] = ACTIONS(1040),
    [aux_sym_else_if_clause_token1] = ACTIONS(1040),
    [aux_sym_else_clause_token1] = ACTIONS(1040),
    [aux_sym_match_expression_token1] = ACTIONS(1040),
    [aux_sym_match_default_expression_token1] = ACTIONS(1040),
    [aux_sym_switch_statement_token1] = ACTIONS(1040),
    [aux_sym_switch_block_token1] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_TILDE] = ACTIONS(1038),
    [anon_sym_BANG] = ACTIONS(1038),
    [anon_sym_AT] = ACTIONS(1038),
    [aux_sym_clone_expression_token1] = ACTIONS(1040),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1040),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1040),
    [anon_sym_DASH_DASH] = ACTIONS(1038),
    [anon_sym_PLUS_PLUS] = ACTIONS(1038),
    [aux_sym__list_destructing_token1] = ACTIONS(1040),
    [anon_sym_LBRACK] = ACTIONS(1038),
    [anon_sym_self] = ACTIONS(1040),
    [anon_sym_parent] = ACTIONS(1040),
    [aux_sym__argument_name_token1] = ACTIONS(1040),
    [aux_sym__argument_name_token2] = ACTIONS(1040),
    [anon_sym_POUND_LBRACK] = ACTIONS(1038),
    [aux_sym_encapsed_string_token1] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [aux_sym_string_token1] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [aux_sym_yield_expression_token1] = ACTIONS(1040),
    [aux_sym_include_expression_token1] = ACTIONS(1040),
    [aux_sym_include_once_expression_token1] = ACTIONS(1040),
    [aux_sym_require_expression_token1] = ACTIONS(1040),
    [aux_sym_require_once_expression_token1] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1042),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1044),
    [sym_name] = ACTIONS(1046),
    [anon_sym_QMARK_GT] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1048),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1046),
    [aux_sym_global_declaration_token1] = ACTIONS(1046),
    [aux_sym_namespace_definition_token1] = ACTIONS(1046),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1046),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1046),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1046),
    [anon_sym_BSLASH] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1044),
    [anon_sym_RBRACE] = ACTIONS(1044),
    [aux_sym_trait_declaration_token1] = ACTIONS(1046),
    [aux_sym_interface_declaration_token1] = ACTIONS(1046),
    [aux_sym_enum_declaration_token1] = ACTIONS(1046),
    [aux_sym_enum_case_token1] = ACTIONS(1046),
    [aux_sym_class_declaration_token1] = ACTIONS(1046),
    [aux_sym_final_modifier_token1] = ACTIONS(1046),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1046),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1046),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1046),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1046),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1046),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1046),
    [anon_sym_LPAREN] = ACTIONS(1044),
    [aux_sym_cast_type_token1] = ACTIONS(1046),
    [aux_sym_echo_statement_token1] = ACTIONS(1046),
    [anon_sym_unset] = ACTIONS(1046),
    [aux_sym_declare_statement_token1] = ACTIONS(1046),
    [aux_sym_declare_statement_token2] = ACTIONS(1046),
    [sym_float] = ACTIONS(1046),
    [aux_sym_try_statement_token1] = ACTIONS(1046),
    [aux_sym_goto_statement_token1] = ACTIONS(1046),
    [aux_sym_continue_statement_token1] = ACTIONS(1046),
    [aux_sym_break_statement_token1] = ACTIONS(1046),
    [sym_integer] = ACTIONS(1046),
    [aux_sym_return_statement_token1] = ACTIONS(1046),
    [aux_sym_throw_expression_token1] = ACTIONS(1046),
    [aux_sym_while_statement_token1] = ACTIONS(1046),
    [aux_sym_while_statement_token2] = ACTIONS(1046),
    [aux_sym_do_statement_token1] = ACTIONS(1046),
    [aux_sym_for_statement_token1] = ACTIONS(1046),
    [aux_sym_for_statement_token2] = ACTIONS(1046),
    [aux_sym_foreach_statement_token1] = ACTIONS(1046),
    [aux_sym_foreach_statement_token2] = ACTIONS(1046),
    [aux_sym_if_statement_token1] = ACTIONS(1046),
    [aux_sym_if_statement_token2] = ACTIONS(1046),
    [aux_sym_else_if_clause_token1] = ACTIONS(1046),
    [aux_sym_else_clause_token1] = ACTIONS(1046),
    [aux_sym_match_expression_token1] = ACTIONS(1046),
    [aux_sym_match_default_expression_token1] = ACTIONS(1046),
    [aux_sym_switch_statement_token1] = ACTIONS(1046),
    [aux_sym_switch_block_token1] = ACTIONS(1046),
    [anon_sym_PLUS] = ACTIONS(1046),
    [anon_sym_DASH] = ACTIONS(1046),
    [anon_sym_TILDE] = ACTIONS(1044),
    [anon_sym_BANG] = ACTIONS(1044),
    [anon_sym_AT] = ACTIONS(1044),
    [aux_sym_clone_expression_token1] = ACTIONS(1046),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1046),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1046),
    [anon_sym_DASH_DASH] = ACTIONS(1044),
    [anon_sym_PLUS_PLUS] = ACTIONS(1044),
    [aux_sym__list_destructing_token1] = ACTIONS(1046),
    [anon_sym_LBRACK] = ACTIONS(1044),
    [anon_sym_self] = ACTIONS(1046),
    [anon_sym_parent] = ACTIONS(1046),
    [aux_sym__argument_name_token1] = ACTIONS(1046),
    [aux_sym__argument_name_token2] = ACTIONS(1046),
    [anon_sym_POUND_LBRACK] = ACTIONS(1044),
    [aux_sym_encapsed_string_token1] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1044),
    [aux_sym_string_token1] = ACTIONS(1044),
    [anon_sym_SQUOTE] = ACTIONS(1044),
    [anon_sym_LT_LT_LT] = ACTIONS(1044),
    [anon_sym_BQUOTE] = ACTIONS(1044),
    [anon_sym_DOLLAR] = ACTIONS(1044),
    [aux_sym_yield_expression_token1] = ACTIONS(1046),
    [aux_sym_include_expression_token1] = ACTIONS(1046),
    [aux_sym_include_once_expression_token1] = ACTIONS(1046),
    [aux_sym_require_expression_token1] = ACTIONS(1046),
    [aux_sym_require_once_expression_token1] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1048),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(1050),
    [sym_name] = ACTIONS(1052),
    [anon_sym_QMARK_GT] = ACTIONS(1050),
    [anon_sym_SEMI] = ACTIONS(1054),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1052),
    [aux_sym_global_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_definition_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1052),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1052),
    [anon_sym_BSLASH] = ACTIONS(1050),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [aux_sym_trait_declaration_token1] = ACTIONS(1052),
    [aux_sym_interface_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_declaration_token1] = ACTIONS(1052),
    [aux_sym_enum_case_token1] = ACTIONS(1052),
    [aux_sym_class_declaration_token1] = ACTIONS(1052),
    [aux_sym_final_modifier_token1] = ACTIONS(1052),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1052),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1052),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1052),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1052),
    [anon_sym_LPAREN] = ACTIONS(1050),
    [aux_sym_cast_type_token1] = ACTIONS(1052),
    [aux_sym_echo_statement_token1] = ACTIONS(1052),
    [anon_sym_unset] = ACTIONS(1052),
    [aux_sym_declare_statement_token1] = ACTIONS(1052),
    [aux_sym_declare_statement_token2] = ACTIONS(1052),
    [sym_float] = ACTIONS(1052),
    [aux_sym_try_statement_token1] = ACTIONS(1052),
    [aux_sym_goto_statement_token1] = ACTIONS(1052),
    [aux_sym_continue_statement_token1] = ACTIONS(1052),
    [aux_sym_break_statement_token1] = ACTIONS(1052),
    [sym_integer] = ACTIONS(1052),
    [aux_sym_return_statement_token1] = ACTIONS(1052),
    [aux_sym_throw_expression_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token1] = ACTIONS(1052),
    [aux_sym_while_statement_token2] = ACTIONS(1052),
    [aux_sym_do_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token1] = ACTIONS(1052),
    [aux_sym_for_statement_token2] = ACTIONS(1052),
    [aux_sym_foreach_statement_token1] = ACTIONS(1052),
    [aux_sym_foreach_statement_token2] = ACTIONS(1052),
    [aux_sym_if_statement_token1] = ACTIONS(1052),
    [aux_sym_if_statement_token2] = ACTIONS(1052),
    [aux_sym_else_if_clause_token1] = ACTIONS(1052),
    [aux_sym_else_clause_token1] = ACTIONS(1052),
    [aux_sym_match_expression_token1] = ACTIONS(1052),
    [aux_sym_match_default_expression_token1] = ACTIONS(1052),
    [aux_sym_switch_statement_token1] = ACTIONS(1052),
    [aux_sym_switch_block_token1] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_TILDE] = ACTIONS(1050),
    [anon_sym_BANG] = ACTIONS(1050),
    [anon_sym_AT] = ACTIONS(1050),
    [aux_sym_clone_expression_token1] = ACTIONS(1052),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1052),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1052),
    [anon_sym_DASH_DASH] = ACTIONS(1050),
    [anon_sym_PLUS_PLUS] = ACTIONS(1050),
    [aux_sym__list_destructing_token1] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1050),
    [anon_sym_self] = ACTIONS(1052),
    [anon_sym_parent] = ACTIONS(1052),
    [aux_sym__argument_name_token1] = ACTIONS(1052),
    [aux_sym__argument_name_token2] = ACTIONS(1052),
    [anon_sym_POUND_LBRACK] = ACTIONS(1050),
    [aux_sym_encapsed_string_token1] = ACTIONS(1050),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [aux_sym_string_token1] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [anon_sym_LT_LT_LT] = ACTIONS(1050),
    [anon_sym_BQUOTE] = ACTIONS(1050),
    [anon_sym_DOLLAR] = ACTIONS(1050),
    [aux_sym_yield_expression_token1] = ACTIONS(1052),
    [aux_sym_include_expression_token1] = ACTIONS(1052),
    [aux_sym_include_once_expression_token1] = ACTIONS(1052),
    [aux_sym_require_expression_token1] = ACTIONS(1052),
    [aux_sym_require_once_expression_token1] = ACTIONS(1052),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1054),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1056),
    [sym_name] = ACTIONS(1058),
    [anon_sym_QMARK_GT] = ACTIONS(1056),
    [anon_sym_SEMI] = ACTIONS(1060),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1058),
    [aux_sym_global_declaration_token1] = ACTIONS(1058),
    [aux_sym_namespace_definition_token1] = ACTIONS(1058),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1058),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1058),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1058),
    [anon_sym_BSLASH] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1056),
    [anon_sym_RBRACE] = ACTIONS(1056),
    [aux_sym_trait_declaration_token1] = ACTIONS(1058),
    [aux_sym_interface_declaration_token1] = ACTIONS(1058),
    [aux_sym_enum_declaration_token1] = ACTIONS(1058),
    [aux_sym_enum_case_token1] = ACTIONS(1058),
    [aux_sym_class_declaration_token1] = ACTIONS(1058),
    [aux_sym_final_modifier_token1] = ACTIONS(1058),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1058),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1058),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1058),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1058),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1058),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1058),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [aux_sym_cast_type_token1] = ACTIONS(1058),
    [aux_sym_echo_statement_token1] = ACTIONS(1058),
    [anon_sym_unset] = ACTIONS(1058),
    [aux_sym_declare_statement_token1] = ACTIONS(1058),
    [aux_sym_declare_statement_token2] = ACTIONS(1058),
    [sym_float] = ACTIONS(1058),
    [aux_sym_try_statement_token1] = ACTIONS(1058),
    [aux_sym_goto_statement_token1] = ACTIONS(1058),
    [aux_sym_continue_statement_token1] = ACTIONS(1058),
    [aux_sym_break_statement_token1] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1058),
    [aux_sym_return_statement_token1] = ACTIONS(1058),
    [aux_sym_throw_expression_token1] = ACTIONS(1058),
    [aux_sym_while_statement_token1] = ACTIONS(1058),
    [aux_sym_while_statement_token2] = ACTIONS(1058),
    [aux_sym_do_statement_token1] = ACTIONS(1058),
    [aux_sym_for_statement_token1] = ACTIONS(1058),
    [aux_sym_for_statement_token2] = ACTIONS(1058),
    [aux_sym_foreach_statement_token1] = ACTIONS(1058),
    [aux_sym_foreach_statement_token2] = ACTIONS(1058),
    [aux_sym_if_statement_token1] = ACTIONS(1058),
    [aux_sym_if_statement_token2] = ACTIONS(1058),
    [aux_sym_else_if_clause_token1] = ACTIONS(1058),
    [aux_sym_else_clause_token1] = ACTIONS(1058),
    [aux_sym_match_expression_token1] = ACTIONS(1058),
    [aux_sym_match_default_expression_token1] = ACTIONS(1058),
    [aux_sym_switch_statement_token1] = ACTIONS(1058),
    [aux_sym_switch_block_token1] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_TILDE] = ACTIONS(1056),
    [anon_sym_BANG] = ACTIONS(1056),
    [anon_sym_AT] = ACTIONS(1056),
    [aux_sym_clone_expression_token1] = ACTIONS(1058),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1058),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1058),
    [anon_sym_DASH_DASH] = ACTIONS(1056),
    [anon_sym_PLUS_PLUS] = ACTIONS(1056),
    [aux_sym__list_destructing_token1] = ACTIONS(1058),
    [anon_sym_LBRACK] = ACTIONS(1056),
    [anon_sym_self] = ACTIONS(1058),
    [anon_sym_parent] = ACTIONS(1058),
    [aux_sym__argument_name_token1] = ACTIONS(1058),
    [aux_sym__argument_name_token2] = ACTIONS(1058),
    [anon_sym_POUND_LBRACK] = ACTIONS(1056),
    [aux_sym_encapsed_string_token1] = ACTIONS(1056),
    [anon_sym_DQUOTE] = ACTIONS(1056),
    [aux_sym_string_token1] = ACTIONS(1056),
    [anon_sym_SQUOTE] = ACTIONS(1056),
    [anon_sym_LT_LT_LT] = ACTIONS(1056),
    [anon_sym_BQUOTE] = ACTIONS(1056),
    [anon_sym_DOLLAR] = ACTIONS(1056),
    [aux_sym_yield_expression_token1] = ACTIONS(1058),
    [aux_sym_include_expression_token1] = ACTIONS(1058),
    [aux_sym_include_once_expression_token1] = ACTIONS(1058),
    [aux_sym_require_expression_token1] = ACTIONS(1058),
    [aux_sym_require_once_expression_token1] = ACTIONS(1058),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1060),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_name] = ACTIONS(1064),
    [anon_sym_QMARK_GT] = ACTIONS(1062),
    [anon_sym_SEMI] = ACTIONS(1066),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1064),
    [aux_sym_global_declaration_token1] = ACTIONS(1064),
    [aux_sym_namespace_definition_token1] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1064),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1064),
    [anon_sym_BSLASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [aux_sym_trait_declaration_token1] = ACTIONS(1064),
    [aux_sym_interface_declaration_token1] = ACTIONS(1064),
    [aux_sym_enum_declaration_token1] = ACTIONS(1064),
    [aux_sym_enum_case_token1] = ACTIONS(1064),
    [aux_sym_class_declaration_token1] = ACTIONS(1064),
    [aux_sym_final_modifier_token1] = ACTIONS(1064),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1064),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1064),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1064),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [aux_sym_cast_type_token1] = ACTIONS(1064),
    [aux_sym_echo_statement_token1] = ACTIONS(1064),
    [anon_sym_unset] = ACTIONS(1064),
    [aux_sym_declare_statement_token1] = ACTIONS(1064),
    [aux_sym_declare_statement_token2] = ACTIONS(1064),
    [sym_float] = ACTIONS(1064),
    [aux_sym_try_statement_token1] = ACTIONS(1064),
    [aux_sym_goto_statement_token1] = ACTIONS(1064),
    [aux_sym_continue_statement_token1] = ACTIONS(1064),
    [aux_sym_break_statement_token1] = ACTIONS(1064),
    [sym_integer] = ACTIONS(1064),
    [aux_sym_return_statement_token1] = ACTIONS(1064),
    [aux_sym_throw_expression_token1] = ACTIONS(1064),
    [aux_sym_while_statement_token1] = ACTIONS(1064),
    [aux_sym_while_statement_token2] = ACTIONS(1064),
    [aux_sym_do_statement_token1] = ACTIONS(1064),
    [aux_sym_for_statement_token1] = ACTIONS(1064),
    [aux_sym_for_statement_token2] = ACTIONS(1064),
    [aux_sym_foreach_statement_token1] = ACTIONS(1064),
    [aux_sym_foreach_statement_token2] = ACTIONS(1064),
    [aux_sym_if_statement_token1] = ACTIONS(1064),
    [aux_sym_if_statement_token2] = ACTIONS(1064),
    [aux_sym_else_if_clause_token1] = ACTIONS(1064),
    [aux_sym_else_clause_token1] = ACTIONS(1064),
    [aux_sym_match_expression_token1] = ACTIONS(1064),
    [aux_sym_match_default_expression_token1] = ACTIONS(1064),
    [aux_sym_switch_statement_token1] = ACTIONS(1064),
    [aux_sym_switch_block_token1] = ACTIONS(1064),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_BANG] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [aux_sym_clone_expression_token1] = ACTIONS(1064),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1064),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1064),
    [anon_sym_DASH_DASH] = ACTIONS(1062),
    [anon_sym_PLUS_PLUS] = ACTIONS(1062),
    [aux_sym__list_destructing_token1] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_self] = ACTIONS(1064),
    [anon_sym_parent] = ACTIONS(1064),
    [aux_sym__argument_name_token1] = ACTIONS(1064),
    [aux_sym__argument_name_token2] = ACTIONS(1064),
    [anon_sym_POUND_LBRACK] = ACTIONS(1062),
    [aux_sym_encapsed_string_token1] = ACTIONS(1062),
    [anon_sym_DQUOTE] = ACTIONS(1062),
    [aux_sym_string_token1] = ACTIONS(1062),
    [anon_sym_SQUOTE] = ACTIONS(1062),
    [anon_sym_LT_LT_LT] = ACTIONS(1062),
    [anon_sym_BQUOTE] = ACTIONS(1062),
    [anon_sym_DOLLAR] = ACTIONS(1062),
    [aux_sym_yield_expression_token1] = ACTIONS(1064),
    [aux_sym_include_expression_token1] = ACTIONS(1064),
    [aux_sym_include_once_expression_token1] = ACTIONS(1064),
    [aux_sym_require_expression_token1] = ACTIONS(1064),
    [aux_sym_require_once_expression_token1] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1066),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1068),
    [sym_name] = ACTIONS(1070),
    [anon_sym_QMARK_GT] = ACTIONS(1068),
    [anon_sym_SEMI] = ACTIONS(1072),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1070),
    [aux_sym_global_declaration_token1] = ACTIONS(1070),
    [aux_sym_namespace_definition_token1] = ACTIONS(1070),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1070),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1070),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1070),
    [anon_sym_BSLASH] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1068),
    [anon_sym_RBRACE] = ACTIONS(1068),
    [aux_sym_trait_declaration_token1] = ACTIONS(1070),
    [aux_sym_interface_declaration_token1] = ACTIONS(1070),
    [aux_sym_enum_declaration_token1] = ACTIONS(1070),
    [aux_sym_enum_case_token1] = ACTIONS(1070),
    [aux_sym_class_declaration_token1] = ACTIONS(1070),
    [aux_sym_final_modifier_token1] = ACTIONS(1070),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1070),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1070),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1070),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1070),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1070),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1070),
    [anon_sym_LPAREN] = ACTIONS(1068),
    [aux_sym_cast_type_token1] = ACTIONS(1070),
    [aux_sym_echo_statement_token1] = ACTIONS(1070),
    [anon_sym_unset] = ACTIONS(1070),
    [aux_sym_declare_statement_token1] = ACTIONS(1070),
    [aux_sym_declare_statement_token2] = ACTIONS(1070),
    [sym_float] = ACTIONS(1070),
    [aux_sym_try_statement_token1] = ACTIONS(1070),
    [aux_sym_goto_statement_token1] = ACTIONS(1070),
    [aux_sym_continue_statement_token1] = ACTIONS(1070),
    [aux_sym_break_statement_token1] = ACTIONS(1070),
    [sym_integer] = ACTIONS(1070),
    [aux_sym_return_statement_token1] = ACTIONS(1070),
    [aux_sym_throw_expression_token1] = ACTIONS(1070),
    [aux_sym_while_statement_token1] = ACTIONS(1070),
    [aux_sym_while_statement_token2] = ACTIONS(1070),
    [aux_sym_do_statement_token1] = ACTIONS(1070),
    [aux_sym_for_statement_token1] = ACTIONS(1070),
    [aux_sym_for_statement_token2] = ACTIONS(1070),
    [aux_sym_foreach_statement_token1] = ACTIONS(1070),
    [aux_sym_foreach_statement_token2] = ACTIONS(1070),
    [aux_sym_if_statement_token1] = ACTIONS(1070),
    [aux_sym_if_statement_token2] = ACTIONS(1070),
    [aux_sym_else_if_clause_token1] = ACTIONS(1070),
    [aux_sym_else_clause_token1] = ACTIONS(1070),
    [aux_sym_match_expression_token1] = ACTIONS(1070),
    [aux_sym_match_default_expression_token1] = ACTIONS(1070),
    [aux_sym_switch_statement_token1] = ACTIONS(1070),
    [aux_sym_switch_block_token1] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_TILDE] = ACTIONS(1068),
    [anon_sym_BANG] = ACTIONS(1068),
    [anon_sym_AT] = ACTIONS(1068),
    [aux_sym_clone_expression_token1] = ACTIONS(1070),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1070),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1070),
    [anon_sym_DASH_DASH] = ACTIONS(1068),
    [anon_sym_PLUS_PLUS] = ACTIONS(1068),
    [aux_sym__list_destructing_token1] = ACTIONS(1070),
    [anon_sym_LBRACK] = ACTIONS(1068),
    [anon_sym_self] = ACTIONS(1070),
    [anon_sym_parent] = ACTIONS(1070),
    [aux_sym__argument_name_token1] = ACTIONS(1070),
    [aux_sym__argument_name_token2] = ACTIONS(1070),
    [anon_sym_POUND_LBRACK] = ACTIONS(1068),
    [aux_sym_encapsed_string_token1] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1068),
    [aux_sym_string_token1] = ACTIONS(1068),
    [anon_sym_SQUOTE] = ACTIONS(1068),
    [anon_sym_LT_LT_LT] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1068),
    [anon_sym_DOLLAR] = ACTIONS(1068),
    [aux_sym_yield_expression_token1] = ACTIONS(1070),
    [aux_sym_include_expression_token1] = ACTIONS(1070),
    [aux_sym_include_once_expression_token1] = ACTIONS(1070),
    [aux_sym_require_expression_token1] = ACTIONS(1070),
    [aux_sym_require_once_expression_token1] = ACTIONS(1070),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1072),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(1074),
    [sym_name] = ACTIONS(1076),
    [anon_sym_QMARK_GT] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1076),
    [aux_sym_global_declaration_token1] = ACTIONS(1076),
    [aux_sym_namespace_definition_token1] = ACTIONS(1076),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1076),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1076),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1076),
    [anon_sym_BSLASH] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1074),
    [aux_sym_trait_declaration_token1] = ACTIONS(1076),
    [aux_sym_interface_declaration_token1] = ACTIONS(1076),
    [aux_sym_enum_declaration_token1] = ACTIONS(1076),
    [aux_sym_enum_case_token1] = ACTIONS(1076),
    [aux_sym_class_declaration_token1] = ACTIONS(1076),
    [aux_sym_final_modifier_token1] = ACTIONS(1076),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1076),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1076),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1076),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1076),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1076),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1076),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [aux_sym_cast_type_token1] = ACTIONS(1076),
    [aux_sym_echo_statement_token1] = ACTIONS(1076),
    [anon_sym_unset] = ACTIONS(1076),
    [aux_sym_declare_statement_token1] = ACTIONS(1076),
    [aux_sym_declare_statement_token2] = ACTIONS(1076),
    [sym_float] = ACTIONS(1076),
    [aux_sym_try_statement_token1] = ACTIONS(1076),
    [aux_sym_goto_statement_token1] = ACTIONS(1076),
    [aux_sym_continue_statement_token1] = ACTIONS(1076),
    [aux_sym_break_statement_token1] = ACTIONS(1076),
    [sym_integer] = ACTIONS(1076),
    [aux_sym_return_statement_token1] = ACTIONS(1076),
    [aux_sym_throw_expression_token1] = ACTIONS(1076),
    [aux_sym_while_statement_token1] = ACTIONS(1076),
    [aux_sym_while_statement_token2] = ACTIONS(1076),
    [aux_sym_do_statement_token1] = ACTIONS(1076),
    [aux_sym_for_statement_token1] = ACTIONS(1076),
    [aux_sym_for_statement_token2] = ACTIONS(1076),
    [aux_sym_foreach_statement_token1] = ACTIONS(1076),
    [aux_sym_foreach_statement_token2] = ACTIONS(1076),
    [aux_sym_if_statement_token1] = ACTIONS(1076),
    [aux_sym_if_statement_token2] = ACTIONS(1076),
    [aux_sym_else_if_clause_token1] = ACTIONS(1076),
    [aux_sym_else_clause_token1] = ACTIONS(1076),
    [aux_sym_match_expression_token1] = ACTIONS(1076),
    [aux_sym_match_default_expression_token1] = ACTIONS(1076),
    [aux_sym_switch_statement_token1] = ACTIONS(1076),
    [aux_sym_switch_block_token1] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1074),
    [aux_sym_clone_expression_token1] = ACTIONS(1076),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1076),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [aux_sym__list_destructing_token1] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_self] = ACTIONS(1076),
    [anon_sym_parent] = ACTIONS(1076),
    [aux_sym__argument_name_token1] = ACTIONS(1076),
    [aux_sym__argument_name_token2] = ACTIONS(1076),
    [anon_sym_POUND_LBRACK] = ACTIONS(1074),
    [aux_sym_encapsed_string_token1] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [aux_sym_string_token1] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LT_LT] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [aux_sym_yield_expression_token1] = ACTIONS(1076),
    [aux_sym_include_expression_token1] = ACTIONS(1076),
    [aux_sym_include_once_expression_token1] = ACTIONS(1076),
    [aux_sym_require_expression_token1] = ACTIONS(1076),
    [aux_sym_require_once_expression_token1] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1074),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(1078),
    [sym_name] = ACTIONS(1080),
    [anon_sym_QMARK_GT] = ACTIONS(1078),
    [anon_sym_SEMI] = ACTIONS(1082),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1080),
    [aux_sym_global_declaration_token1] = ACTIONS(1080),
    [aux_sym_namespace_definition_token1] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1080),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1080),
    [anon_sym_BSLASH] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1078),
    [anon_sym_RBRACE] = ACTIONS(1078),
    [aux_sym_trait_declaration_token1] = ACTIONS(1080),
    [aux_sym_interface_declaration_token1] = ACTIONS(1080),
    [aux_sym_enum_declaration_token1] = ACTIONS(1080),
    [aux_sym_enum_case_token1] = ACTIONS(1080),
    [aux_sym_class_declaration_token1] = ACTIONS(1080),
    [aux_sym_final_modifier_token1] = ACTIONS(1080),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1080),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1080),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1080),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1080),
    [anon_sym_LPAREN] = ACTIONS(1078),
    [aux_sym_cast_type_token1] = ACTIONS(1080),
    [aux_sym_echo_statement_token1] = ACTIONS(1080),
    [anon_sym_unset] = ACTIONS(1080),
    [aux_sym_declare_statement_token1] = ACTIONS(1080),
    [aux_sym_declare_statement_token2] = ACTIONS(1080),
    [sym_float] = ACTIONS(1080),
    [aux_sym_try_statement_token1] = ACTIONS(1080),
    [aux_sym_goto_statement_token1] = ACTIONS(1080),
    [aux_sym_continue_statement_token1] = ACTIONS(1080),
    [aux_sym_break_statement_token1] = ACTIONS(1080),
    [sym_integer] = ACTIONS(1080),
    [aux_sym_return_statement_token1] = ACTIONS(1080),
    [aux_sym_throw_expression_token1] = ACTIONS(1080),
    [aux_sym_while_statement_token1] = ACTIONS(1080),
    [aux_sym_while_statement_token2] = ACTIONS(1080),
    [aux_sym_do_statement_token1] = ACTIONS(1080),
    [aux_sym_for_statement_token1] = ACTIONS(1080),
    [aux_sym_for_statement_token2] = ACTIONS(1080),
    [aux_sym_foreach_statement_token1] = ACTIONS(1080),
    [aux_sym_foreach_statement_token2] = ACTIONS(1080),
    [aux_sym_if_statement_token1] = ACTIONS(1080),
    [aux_sym_if_statement_token2] = ACTIONS(1080),
    [aux_sym_else_if_clause_token1] = ACTIONS(1080),
    [aux_sym_else_clause_token1] = ACTIONS(1080),
    [aux_sym_match_expression_token1] = ACTIONS(1080),
    [aux_sym_match_default_expression_token1] = ACTIONS(1080),
    [aux_sym_switch_statement_token1] = ACTIONS(1080),
    [aux_sym_switch_block_token1] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_TILDE] = ACTIONS(1078),
    [anon_sym_BANG] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1078),
    [aux_sym_clone_expression_token1] = ACTIONS(1080),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1080),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1080),
    [anon_sym_DASH_DASH] = ACTIONS(1078),
    [anon_sym_PLUS_PLUS] = ACTIONS(1078),
    [aux_sym__list_destructing_token1] = ACTIONS(1080),
    [anon_sym_LBRACK] = ACTIONS(1078),
    [anon_sym_self] = ACTIONS(1080),
    [anon_sym_parent] = ACTIONS(1080),
    [aux_sym__argument_name_token1] = ACTIONS(1080),
    [aux_sym__argument_name_token2] = ACTIONS(1080),
    [anon_sym_POUND_LBRACK] = ACTIONS(1078),
    [aux_sym_encapsed_string_token1] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1078),
    [aux_sym_string_token1] = ACTIONS(1078),
    [anon_sym_SQUOTE] = ACTIONS(1078),
    [anon_sym_LT_LT_LT] = ACTIONS(1078),
    [anon_sym_BQUOTE] = ACTIONS(1078),
    [anon_sym_DOLLAR] = ACTIONS(1078),
    [aux_sym_yield_expression_token1] = ACTIONS(1080),
    [aux_sym_include_expression_token1] = ACTIONS(1080),
    [aux_sym_include_once_expression_token1] = ACTIONS(1080),
    [aux_sym_require_expression_token1] = ACTIONS(1080),
    [aux_sym_require_once_expression_token1] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1082),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_name] = ACTIONS(1086),
    [anon_sym_QMARK_GT] = ACTIONS(1084),
    [anon_sym_SEMI] = ACTIONS(1088),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1086),
    [aux_sym_global_declaration_token1] = ACTIONS(1086),
    [aux_sym_namespace_definition_token1] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1086),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1086),
    [anon_sym_BSLASH] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [aux_sym_trait_declaration_token1] = ACTIONS(1086),
    [aux_sym_interface_declaration_token1] = ACTIONS(1086),
    [aux_sym_enum_declaration_token1] = ACTIONS(1086),
    [aux_sym_enum_case_token1] = ACTIONS(1086),
    [aux_sym_class_declaration_token1] = ACTIONS(1086),
    [aux_sym_final_modifier_token1] = ACTIONS(1086),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1086),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1086),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1086),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [aux_sym_cast_type_token1] = ACTIONS(1086),
    [aux_sym_echo_statement_token1] = ACTIONS(1086),
    [anon_sym_unset] = ACTIONS(1086),
    [aux_sym_declare_statement_token1] = ACTIONS(1086),
    [aux_sym_declare_statement_token2] = ACTIONS(1086),
    [sym_float] = ACTIONS(1086),
    [aux_sym_try_statement_token1] = ACTIONS(1086),
    [aux_sym_goto_statement_token1] = ACTIONS(1086),
    [aux_sym_continue_statement_token1] = ACTIONS(1086),
    [aux_sym_break_statement_token1] = ACTIONS(1086),
    [sym_integer] = ACTIONS(1086),
    [aux_sym_return_statement_token1] = ACTIONS(1086),
    [aux_sym_throw_expression_token1] = ACTIONS(1086),
    [aux_sym_while_statement_token1] = ACTIONS(1086),
    [aux_sym_while_statement_token2] = ACTIONS(1086),
    [aux_sym_do_statement_token1] = ACTIONS(1086),
    [aux_sym_for_statement_token1] = ACTIONS(1086),
    [aux_sym_for_statement_token2] = ACTIONS(1086),
    [aux_sym_foreach_statement_token1] = ACTIONS(1086),
    [aux_sym_foreach_statement_token2] = ACTIONS(1086),
    [aux_sym_if_statement_token1] = ACTIONS(1086),
    [aux_sym_if_statement_token2] = ACTIONS(1086),
    [aux_sym_else_if_clause_token1] = ACTIONS(1086),
    [aux_sym_else_clause_token1] = ACTIONS(1086),
    [aux_sym_match_expression_token1] = ACTIONS(1086),
    [aux_sym_match_default_expression_token1] = ACTIONS(1086),
    [aux_sym_switch_statement_token1] = ACTIONS(1086),
    [aux_sym_switch_block_token1] = ACTIONS(1086),
    [anon_sym_PLUS] = ACTIONS(1086),
    [anon_sym_DASH] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_BANG] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1084),
    [aux_sym_clone_expression_token1] = ACTIONS(1086),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1086),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1086),
    [anon_sym_DASH_DASH] = ACTIONS(1084),
    [anon_sym_PLUS_PLUS] = ACTIONS(1084),
    [aux_sym__list_destructing_token1] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_self] = ACTIONS(1086),
    [anon_sym_parent] = ACTIONS(1086),
    [aux_sym__argument_name_token1] = ACTIONS(1086),
    [aux_sym__argument_name_token2] = ACTIONS(1086),
    [anon_sym_POUND_LBRACK] = ACTIONS(1084),
    [aux_sym_encapsed_string_token1] = ACTIONS(1084),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [aux_sym_string_token1] = ACTIONS(1084),
    [anon_sym_SQUOTE] = ACTIONS(1084),
    [anon_sym_LT_LT_LT] = ACTIONS(1084),
    [anon_sym_BQUOTE] = ACTIONS(1084),
    [anon_sym_DOLLAR] = ACTIONS(1084),
    [aux_sym_yield_expression_token1] = ACTIONS(1086),
    [aux_sym_include_expression_token1] = ACTIONS(1086),
    [aux_sym_include_once_expression_token1] = ACTIONS(1086),
    [aux_sym_require_expression_token1] = ACTIONS(1086),
    [aux_sym_require_once_expression_token1] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1088),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(1090),
    [sym_name] = ACTIONS(1092),
    [anon_sym_QMARK_GT] = ACTIONS(1090),
    [anon_sym_SEMI] = ACTIONS(1094),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1092),
    [aux_sym_global_declaration_token1] = ACTIONS(1092),
    [aux_sym_namespace_definition_token1] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1092),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1092),
    [anon_sym_BSLASH] = ACTIONS(1090),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [aux_sym_trait_declaration_token1] = ACTIONS(1092),
    [aux_sym_interface_declaration_token1] = ACTIONS(1092),
    [aux_sym_enum_declaration_token1] = ACTIONS(1092),
    [aux_sym_enum_case_token1] = ACTIONS(1092),
    [aux_sym_class_declaration_token1] = ACTIONS(1092),
    [aux_sym_final_modifier_token1] = ACTIONS(1092),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1092),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1092),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1092),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1092),
    [anon_sym_LPAREN] = ACTIONS(1090),
    [aux_sym_cast_type_token1] = ACTIONS(1092),
    [aux_sym_echo_statement_token1] = ACTIONS(1092),
    [anon_sym_unset] = ACTIONS(1092),
    [aux_sym_declare_statement_token1] = ACTIONS(1092),
    [aux_sym_declare_statement_token2] = ACTIONS(1092),
    [sym_float] = ACTIONS(1092),
    [aux_sym_try_statement_token1] = ACTIONS(1092),
    [aux_sym_goto_statement_token1] = ACTIONS(1092),
    [aux_sym_continue_statement_token1] = ACTIONS(1092),
    [aux_sym_break_statement_token1] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1092),
    [aux_sym_return_statement_token1] = ACTIONS(1092),
    [aux_sym_throw_expression_token1] = ACTIONS(1092),
    [aux_sym_while_statement_token1] = ACTIONS(1092),
    [aux_sym_while_statement_token2] = ACTIONS(1092),
    [aux_sym_do_statement_token1] = ACTIONS(1092),
    [aux_sym_for_statement_token1] = ACTIONS(1092),
    [aux_sym_for_statement_token2] = ACTIONS(1092),
    [aux_sym_foreach_statement_token1] = ACTIONS(1092),
    [aux_sym_foreach_statement_token2] = ACTIONS(1092),
    [aux_sym_if_statement_token1] = ACTIONS(1092),
    [aux_sym_if_statement_token2] = ACTIONS(1092),
    [aux_sym_else_if_clause_token1] = ACTIONS(1092),
    [aux_sym_else_clause_token1] = ACTIONS(1092),
    [aux_sym_match_expression_token1] = ACTIONS(1092),
    [aux_sym_match_default_expression_token1] = ACTIONS(1092),
    [aux_sym_switch_statement_token1] = ACTIONS(1092),
    [aux_sym_switch_block_token1] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_TILDE] = ACTIONS(1090),
    [anon_sym_BANG] = ACTIONS(1090),
    [anon_sym_AT] = ACTIONS(1090),
    [aux_sym_clone_expression_token1] = ACTIONS(1092),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1092),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1092),
    [anon_sym_DASH_DASH] = ACTIONS(1090),
    [anon_sym_PLUS_PLUS] = ACTIONS(1090),
    [aux_sym__list_destructing_token1] = ACTIONS(1092),
    [anon_sym_LBRACK] = ACTIONS(1090),
    [anon_sym_self] = ACTIONS(1092),
    [anon_sym_parent] = ACTIONS(1092),
    [aux_sym__argument_name_token1] = ACTIONS(1092),
    [aux_sym__argument_name_token2] = ACTIONS(1092),
    [anon_sym_POUND_LBRACK] = ACTIONS(1090),
    [aux_sym_encapsed_string_token1] = ACTIONS(1090),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [aux_sym_string_token1] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [anon_sym_LT_LT_LT] = ACTIONS(1090),
    [anon_sym_BQUOTE] = ACTIONS(1090),
    [anon_sym_DOLLAR] = ACTIONS(1090),
    [aux_sym_yield_expression_token1] = ACTIONS(1092),
    [aux_sym_include_expression_token1] = ACTIONS(1092),
    [aux_sym_include_once_expression_token1] = ACTIONS(1092),
    [aux_sym_require_expression_token1] = ACTIONS(1092),
    [aux_sym_require_once_expression_token1] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1094),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1096),
    [sym_name] = ACTIONS(1098),
    [anon_sym_QMARK_GT] = ACTIONS(1096),
    [anon_sym_SEMI] = ACTIONS(1100),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1098),
    [aux_sym_global_declaration_token1] = ACTIONS(1098),
    [aux_sym_namespace_definition_token1] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1098),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1098),
    [anon_sym_BSLASH] = ACTIONS(1096),
    [anon_sym_LBRACE] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1096),
    [aux_sym_trait_declaration_token1] = ACTIONS(1098),
    [aux_sym_interface_declaration_token1] = ACTIONS(1098),
    [aux_sym_enum_declaration_token1] = ACTIONS(1098),
    [aux_sym_enum_case_token1] = ACTIONS(1098),
    [aux_sym_class_declaration_token1] = ACTIONS(1098),
    [aux_sym_final_modifier_token1] = ACTIONS(1098),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1098),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1098),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1098),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1096),
    [aux_sym_cast_type_token1] = ACTIONS(1098),
    [aux_sym_echo_statement_token1] = ACTIONS(1098),
    [anon_sym_unset] = ACTIONS(1098),
    [aux_sym_declare_statement_token1] = ACTIONS(1098),
    [aux_sym_declare_statement_token2] = ACTIONS(1098),
    [sym_float] = ACTIONS(1098),
    [aux_sym_try_statement_token1] = ACTIONS(1098),
    [aux_sym_goto_statement_token1] = ACTIONS(1098),
    [aux_sym_continue_statement_token1] = ACTIONS(1098),
    [aux_sym_break_statement_token1] = ACTIONS(1098),
    [sym_integer] = ACTIONS(1098),
    [aux_sym_return_statement_token1] = ACTIONS(1098),
    [aux_sym_throw_expression_token1] = ACTIONS(1098),
    [aux_sym_while_statement_token1] = ACTIONS(1098),
    [aux_sym_while_statement_token2] = ACTIONS(1098),
    [aux_sym_do_statement_token1] = ACTIONS(1098),
    [aux_sym_for_statement_token1] = ACTIONS(1098),
    [aux_sym_for_statement_token2] = ACTIONS(1098),
    [aux_sym_foreach_statement_token1] = ACTIONS(1098),
    [aux_sym_foreach_statement_token2] = ACTIONS(1098),
    [aux_sym_if_statement_token1] = ACTIONS(1098),
    [aux_sym_if_statement_token2] = ACTIONS(1098),
    [aux_sym_else_if_clause_token1] = ACTIONS(1098),
    [aux_sym_else_clause_token1] = ACTIONS(1098),
    [aux_sym_match_expression_token1] = ACTIONS(1098),
    [aux_sym_match_default_expression_token1] = ACTIONS(1098),
    [aux_sym_switch_statement_token1] = ACTIONS(1098),
    [aux_sym_switch_block_token1] = ACTIONS(1098),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1096),
    [anon_sym_BANG] = ACTIONS(1096),
    [anon_sym_AT] = ACTIONS(1096),
    [aux_sym_clone_expression_token1] = ACTIONS(1098),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1098),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1098),
    [anon_sym_DASH_DASH] = ACTIONS(1096),
    [anon_sym_PLUS_PLUS] = ACTIONS(1096),
    [aux_sym__list_destructing_token1] = ACTIONS(1098),
    [anon_sym_LBRACK] = ACTIONS(1096),
    [anon_sym_self] = ACTIONS(1098),
    [anon_sym_parent] = ACTIONS(1098),
    [aux_sym__argument_name_token1] = ACTIONS(1098),
    [aux_sym__argument_name_token2] = ACTIONS(1098),
    [anon_sym_POUND_LBRACK] = ACTIONS(1096),
    [aux_sym_encapsed_string_token1] = ACTIONS(1096),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [aux_sym_string_token1] = ACTIONS(1096),
    [anon_sym_SQUOTE] = ACTIONS(1096),
    [anon_sym_LT_LT_LT] = ACTIONS(1096),
    [anon_sym_BQUOTE] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(1096),
    [aux_sym_yield_expression_token1] = ACTIONS(1098),
    [aux_sym_include_expression_token1] = ACTIONS(1098),
    [aux_sym_include_once_expression_token1] = ACTIONS(1098),
    [aux_sym_require_expression_token1] = ACTIONS(1098),
    [aux_sym_require_once_expression_token1] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1100),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_name] = ACTIONS(1104),
    [anon_sym_QMARK_GT] = ACTIONS(1102),
    [anon_sym_SEMI] = ACTIONS(1106),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1104),
    [aux_sym_global_declaration_token1] = ACTIONS(1104),
    [aux_sym_namespace_definition_token1] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1104),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1104),
    [anon_sym_BSLASH] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_RBRACE] = ACTIONS(1102),
    [aux_sym_trait_declaration_token1] = ACTIONS(1104),
    [aux_sym_interface_declaration_token1] = ACTIONS(1104),
    [aux_sym_enum_declaration_token1] = ACTIONS(1104),
    [aux_sym_enum_case_token1] = ACTIONS(1104),
    [aux_sym_class_declaration_token1] = ACTIONS(1104),
    [aux_sym_final_modifier_token1] = ACTIONS(1104),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1104),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1104),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1104),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [aux_sym_cast_type_token1] = ACTIONS(1104),
    [aux_sym_echo_statement_token1] = ACTIONS(1104),
    [anon_sym_unset] = ACTIONS(1104),
    [aux_sym_declare_statement_token1] = ACTIONS(1104),
    [aux_sym_declare_statement_token2] = ACTIONS(1104),
    [sym_float] = ACTIONS(1104),
    [aux_sym_try_statement_token1] = ACTIONS(1104),
    [aux_sym_goto_statement_token1] = ACTIONS(1104),
    [aux_sym_continue_statement_token1] = ACTIONS(1104),
    [aux_sym_break_statement_token1] = ACTIONS(1104),
    [sym_integer] = ACTIONS(1104),
    [aux_sym_return_statement_token1] = ACTIONS(1104),
    [aux_sym_throw_expression_token1] = ACTIONS(1104),
    [aux_sym_while_statement_token1] = ACTIONS(1104),
    [aux_sym_while_statement_token2] = ACTIONS(1104),
    [aux_sym_do_statement_token1] = ACTIONS(1104),
    [aux_sym_for_statement_token1] = ACTIONS(1104),
    [aux_sym_for_statement_token2] = ACTIONS(1104),
    [aux_sym_foreach_statement_token1] = ACTIONS(1104),
    [aux_sym_foreach_statement_token2] = ACTIONS(1104),
    [aux_sym_if_statement_token1] = ACTIONS(1104),
    [aux_sym_if_statement_token2] = ACTIONS(1104),
    [aux_sym_else_if_clause_token1] = ACTIONS(1104),
    [aux_sym_else_clause_token1] = ACTIONS(1104),
    [aux_sym_match_expression_token1] = ACTIONS(1104),
    [aux_sym_match_default_expression_token1] = ACTIONS(1104),
    [aux_sym_switch_statement_token1] = ACTIONS(1104),
    [aux_sym_switch_block_token1] = ACTIONS(1104),
    [anon_sym_PLUS] = ACTIONS(1104),
    [anon_sym_DASH] = ACTIONS(1104),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_BANG] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [aux_sym_clone_expression_token1] = ACTIONS(1104),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1104),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1104),
    [anon_sym_DASH_DASH] = ACTIONS(1102),
    [anon_sym_PLUS_PLUS] = ACTIONS(1102),
    [aux_sym__list_destructing_token1] = ACTIONS(1104),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_self] = ACTIONS(1104),
    [anon_sym_parent] = ACTIONS(1104),
    [aux_sym__argument_name_token1] = ACTIONS(1104),
    [aux_sym__argument_name_token2] = ACTIONS(1104),
    [anon_sym_POUND_LBRACK] = ACTIONS(1102),
    [aux_sym_encapsed_string_token1] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1102),
    [aux_sym_string_token1] = ACTIONS(1102),
    [anon_sym_SQUOTE] = ACTIONS(1102),
    [anon_sym_LT_LT_LT] = ACTIONS(1102),
    [anon_sym_BQUOTE] = ACTIONS(1102),
    [anon_sym_DOLLAR] = ACTIONS(1102),
    [aux_sym_yield_expression_token1] = ACTIONS(1104),
    [aux_sym_include_expression_token1] = ACTIONS(1104),
    [aux_sym_include_once_expression_token1] = ACTIONS(1104),
    [aux_sym_require_expression_token1] = ACTIONS(1104),
    [aux_sym_require_once_expression_token1] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1106),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1108),
    [sym_name] = ACTIONS(1110),
    [anon_sym_QMARK_GT] = ACTIONS(1108),
    [anon_sym_SEMI] = ACTIONS(1112),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1110),
    [aux_sym_global_declaration_token1] = ACTIONS(1110),
    [aux_sym_namespace_definition_token1] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1110),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1110),
    [anon_sym_BSLASH] = ACTIONS(1108),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1108),
    [aux_sym_trait_declaration_token1] = ACTIONS(1110),
    [aux_sym_interface_declaration_token1] = ACTIONS(1110),
    [aux_sym_enum_declaration_token1] = ACTIONS(1110),
    [aux_sym_enum_case_token1] = ACTIONS(1110),
    [aux_sym_class_declaration_token1] = ACTIONS(1110),
    [aux_sym_final_modifier_token1] = ACTIONS(1110),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1110),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1110),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1110),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1110),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [aux_sym_cast_type_token1] = ACTIONS(1110),
    [aux_sym_echo_statement_token1] = ACTIONS(1110),
    [anon_sym_unset] = ACTIONS(1110),
    [aux_sym_declare_statement_token1] = ACTIONS(1110),
    [aux_sym_declare_statement_token2] = ACTIONS(1110),
    [sym_float] = ACTIONS(1110),
    [aux_sym_try_statement_token1] = ACTIONS(1110),
    [aux_sym_goto_statement_token1] = ACTIONS(1110),
    [aux_sym_continue_statement_token1] = ACTIONS(1110),
    [aux_sym_break_statement_token1] = ACTIONS(1110),
    [sym_integer] = ACTIONS(1110),
    [aux_sym_return_statement_token1] = ACTIONS(1110),
    [aux_sym_throw_expression_token1] = ACTIONS(1110),
    [aux_sym_while_statement_token1] = ACTIONS(1110),
    [aux_sym_while_statement_token2] = ACTIONS(1110),
    [aux_sym_do_statement_token1] = ACTIONS(1110),
    [aux_sym_for_statement_token1] = ACTIONS(1110),
    [aux_sym_for_statement_token2] = ACTIONS(1110),
    [aux_sym_foreach_statement_token1] = ACTIONS(1110),
    [aux_sym_foreach_statement_token2] = ACTIONS(1110),
    [aux_sym_if_statement_token1] = ACTIONS(1110),
    [aux_sym_if_statement_token2] = ACTIONS(1110),
    [aux_sym_else_if_clause_token1] = ACTIONS(1110),
    [aux_sym_else_clause_token1] = ACTIONS(1110),
    [aux_sym_match_expression_token1] = ACTIONS(1110),
    [aux_sym_match_default_expression_token1] = ACTIONS(1110),
    [aux_sym_switch_statement_token1] = ACTIONS(1110),
    [aux_sym_switch_block_token1] = ACTIONS(1110),
    [anon_sym_PLUS] = ACTIONS(1110),
    [anon_sym_DASH] = ACTIONS(1110),
    [anon_sym_TILDE] = ACTIONS(1108),
    [anon_sym_BANG] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1108),
    [aux_sym_clone_expression_token1] = ACTIONS(1110),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1110),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1110),
    [anon_sym_DASH_DASH] = ACTIONS(1108),
    [anon_sym_PLUS_PLUS] = ACTIONS(1108),
    [aux_sym__list_destructing_token1] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1108),
    [anon_sym_self] = ACTIONS(1110),
    [anon_sym_parent] = ACTIONS(1110),
    [aux_sym__argument_name_token1] = ACTIONS(1110),
    [aux_sym__argument_name_token2] = ACTIONS(1110),
    [anon_sym_POUND_LBRACK] = ACTIONS(1108),
    [aux_sym_encapsed_string_token1] = ACTIONS(1108),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [aux_sym_string_token1] = ACTIONS(1108),
    [anon_sym_SQUOTE] = ACTIONS(1108),
    [anon_sym_LT_LT_LT] = ACTIONS(1108),
    [anon_sym_BQUOTE] = ACTIONS(1108),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [aux_sym_yield_expression_token1] = ACTIONS(1110),
    [aux_sym_include_expression_token1] = ACTIONS(1110),
    [aux_sym_include_once_expression_token1] = ACTIONS(1110),
    [aux_sym_require_expression_token1] = ACTIONS(1110),
    [aux_sym_require_once_expression_token1] = ACTIONS(1110),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1112),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1114),
    [sym_name] = ACTIONS(1116),
    [anon_sym_QMARK_GT] = ACTIONS(1114),
    [anon_sym_SEMI] = ACTIONS(1118),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1116),
    [aux_sym_global_declaration_token1] = ACTIONS(1116),
    [aux_sym_namespace_definition_token1] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1116),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1116),
    [anon_sym_BSLASH] = ACTIONS(1114),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_RBRACE] = ACTIONS(1114),
    [aux_sym_trait_declaration_token1] = ACTIONS(1116),
    [aux_sym_interface_declaration_token1] = ACTIONS(1116),
    [aux_sym_enum_declaration_token1] = ACTIONS(1116),
    [aux_sym_enum_case_token1] = ACTIONS(1116),
    [aux_sym_class_declaration_token1] = ACTIONS(1116),
    [aux_sym_final_modifier_token1] = ACTIONS(1116),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1116),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1116),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1116),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1116),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [aux_sym_cast_type_token1] = ACTIONS(1116),
    [aux_sym_echo_statement_token1] = ACTIONS(1116),
    [anon_sym_unset] = ACTIONS(1116),
    [aux_sym_declare_statement_token1] = ACTIONS(1116),
    [aux_sym_declare_statement_token2] = ACTIONS(1116),
    [sym_float] = ACTIONS(1116),
    [aux_sym_try_statement_token1] = ACTIONS(1116),
    [aux_sym_goto_statement_token1] = ACTIONS(1116),
    [aux_sym_continue_statement_token1] = ACTIONS(1116),
    [aux_sym_break_statement_token1] = ACTIONS(1116),
    [sym_integer] = ACTIONS(1116),
    [aux_sym_return_statement_token1] = ACTIONS(1116),
    [aux_sym_throw_expression_token1] = ACTIONS(1116),
    [aux_sym_while_statement_token1] = ACTIONS(1116),
    [aux_sym_while_statement_token2] = ACTIONS(1116),
    [aux_sym_do_statement_token1] = ACTIONS(1116),
    [aux_sym_for_statement_token1] = ACTIONS(1116),
    [aux_sym_for_statement_token2] = ACTIONS(1116),
    [aux_sym_foreach_statement_token1] = ACTIONS(1116),
    [aux_sym_foreach_statement_token2] = ACTIONS(1116),
    [aux_sym_if_statement_token1] = ACTIONS(1116),
    [aux_sym_if_statement_token2] = ACTIONS(1116),
    [aux_sym_else_if_clause_token1] = ACTIONS(1116),
    [aux_sym_else_clause_token1] = ACTIONS(1116),
    [aux_sym_match_expression_token1] = ACTIONS(1116),
    [aux_sym_match_default_expression_token1] = ACTIONS(1116),
    [aux_sym_switch_statement_token1] = ACTIONS(1116),
    [aux_sym_switch_block_token1] = ACTIONS(1116),
    [anon_sym_PLUS] = ACTIONS(1116),
    [anon_sym_DASH] = ACTIONS(1116),
    [anon_sym_TILDE] = ACTIONS(1114),
    [anon_sym_BANG] = ACTIONS(1114),
    [anon_sym_AT] = ACTIONS(1114),
    [aux_sym_clone_expression_token1] = ACTIONS(1116),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1116),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1116),
    [anon_sym_DASH_DASH] = ACTIONS(1114),
    [anon_sym_PLUS_PLUS] = ACTIONS(1114),
    [aux_sym__list_destructing_token1] = ACTIONS(1116),
    [anon_sym_LBRACK] = ACTIONS(1114),
    [anon_sym_self] = ACTIONS(1116),
    [anon_sym_parent] = ACTIONS(1116),
    [aux_sym__argument_name_token1] = ACTIONS(1116),
    [aux_sym__argument_name_token2] = ACTIONS(1116),
    [anon_sym_POUND_LBRACK] = ACTIONS(1114),
    [aux_sym_encapsed_string_token1] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1114),
    [aux_sym_string_token1] = ACTIONS(1114),
    [anon_sym_SQUOTE] = ACTIONS(1114),
    [anon_sym_LT_LT_LT] = ACTIONS(1114),
    [anon_sym_BQUOTE] = ACTIONS(1114),
    [anon_sym_DOLLAR] = ACTIONS(1114),
    [aux_sym_yield_expression_token1] = ACTIONS(1116),
    [aux_sym_include_expression_token1] = ACTIONS(1116),
    [aux_sym_include_once_expression_token1] = ACTIONS(1116),
    [aux_sym_require_expression_token1] = ACTIONS(1116),
    [aux_sym_require_once_expression_token1] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1118),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(1120),
    [sym_name] = ACTIONS(1122),
    [anon_sym_QMARK_GT] = ACTIONS(1120),
    [anon_sym_SEMI] = ACTIONS(1124),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1122),
    [aux_sym_global_declaration_token1] = ACTIONS(1122),
    [aux_sym_namespace_definition_token1] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1122),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1122),
    [anon_sym_BSLASH] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [aux_sym_trait_declaration_token1] = ACTIONS(1122),
    [aux_sym_interface_declaration_token1] = ACTIONS(1122),
    [aux_sym_enum_declaration_token1] = ACTIONS(1122),
    [aux_sym_enum_case_token1] = ACTIONS(1122),
    [aux_sym_class_declaration_token1] = ACTIONS(1122),
    [aux_sym_final_modifier_token1] = ACTIONS(1122),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1122),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1122),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1122),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1122),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [aux_sym_cast_type_token1] = ACTIONS(1122),
    [aux_sym_echo_statement_token1] = ACTIONS(1122),
    [anon_sym_unset] = ACTIONS(1122),
    [aux_sym_declare_statement_token1] = ACTIONS(1122),
    [aux_sym_declare_statement_token2] = ACTIONS(1122),
    [sym_float] = ACTIONS(1122),
    [aux_sym_try_statement_token1] = ACTIONS(1122),
    [aux_sym_goto_statement_token1] = ACTIONS(1122),
    [aux_sym_continue_statement_token1] = ACTIONS(1122),
    [aux_sym_break_statement_token1] = ACTIONS(1122),
    [sym_integer] = ACTIONS(1122),
    [aux_sym_return_statement_token1] = ACTIONS(1122),
    [aux_sym_throw_expression_token1] = ACTIONS(1122),
    [aux_sym_while_statement_token1] = ACTIONS(1122),
    [aux_sym_while_statement_token2] = ACTIONS(1122),
    [aux_sym_do_statement_token1] = ACTIONS(1122),
    [aux_sym_for_statement_token1] = ACTIONS(1122),
    [aux_sym_for_statement_token2] = ACTIONS(1122),
    [aux_sym_foreach_statement_token1] = ACTIONS(1122),
    [aux_sym_foreach_statement_token2] = ACTIONS(1122),
    [aux_sym_if_statement_token1] = ACTIONS(1122),
    [aux_sym_if_statement_token2] = ACTIONS(1122),
    [aux_sym_else_if_clause_token1] = ACTIONS(1122),
    [aux_sym_else_clause_token1] = ACTIONS(1122),
    [aux_sym_match_expression_token1] = ACTIONS(1122),
    [aux_sym_match_default_expression_token1] = ACTIONS(1122),
    [aux_sym_switch_statement_token1] = ACTIONS(1122),
    [aux_sym_switch_block_token1] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1122),
    [anon_sym_TILDE] = ACTIONS(1120),
    [anon_sym_BANG] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1120),
    [aux_sym_clone_expression_token1] = ACTIONS(1122),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1122),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1122),
    [anon_sym_DASH_DASH] = ACTIONS(1120),
    [anon_sym_PLUS_PLUS] = ACTIONS(1120),
    [aux_sym__list_destructing_token1] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1120),
    [anon_sym_self] = ACTIONS(1122),
    [anon_sym_parent] = ACTIONS(1122),
    [aux_sym__argument_name_token1] = ACTIONS(1122),
    [aux_sym__argument_name_token2] = ACTIONS(1122),
    [anon_sym_POUND_LBRACK] = ACTIONS(1120),
    [aux_sym_encapsed_string_token1] = ACTIONS(1120),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [aux_sym_string_token1] = ACTIONS(1120),
    [anon_sym_SQUOTE] = ACTIONS(1120),
    [anon_sym_LT_LT_LT] = ACTIONS(1120),
    [anon_sym_BQUOTE] = ACTIONS(1120),
    [anon_sym_DOLLAR] = ACTIONS(1120),
    [aux_sym_yield_expression_token1] = ACTIONS(1122),
    [aux_sym_include_expression_token1] = ACTIONS(1122),
    [aux_sym_include_once_expression_token1] = ACTIONS(1122),
    [aux_sym_require_expression_token1] = ACTIONS(1122),
    [aux_sym_require_once_expression_token1] = ACTIONS(1122),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1124),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_name] = ACTIONS(1128),
    [anon_sym_QMARK_GT] = ACTIONS(1126),
    [anon_sym_SEMI] = ACTIONS(1130),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1128),
    [aux_sym_global_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_definition_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1128),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1128),
    [anon_sym_BSLASH] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_RBRACE] = ACTIONS(1126),
    [aux_sym_trait_declaration_token1] = ACTIONS(1128),
    [aux_sym_interface_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_declaration_token1] = ACTIONS(1128),
    [aux_sym_enum_case_token1] = ACTIONS(1128),
    [aux_sym_class_declaration_token1] = ACTIONS(1128),
    [aux_sym_final_modifier_token1] = ACTIONS(1128),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1128),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1128),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1128),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [aux_sym_cast_type_token1] = ACTIONS(1128),
    [aux_sym_echo_statement_token1] = ACTIONS(1128),
    [anon_sym_unset] = ACTIONS(1128),
    [aux_sym_declare_statement_token1] = ACTIONS(1128),
    [aux_sym_declare_statement_token2] = ACTIONS(1128),
    [sym_float] = ACTIONS(1128),
    [aux_sym_try_statement_token1] = ACTIONS(1128),
    [aux_sym_goto_statement_token1] = ACTIONS(1128),
    [aux_sym_continue_statement_token1] = ACTIONS(1128),
    [aux_sym_break_statement_token1] = ACTIONS(1128),
    [sym_integer] = ACTIONS(1128),
    [aux_sym_return_statement_token1] = ACTIONS(1128),
    [aux_sym_throw_expression_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token1] = ACTIONS(1128),
    [aux_sym_while_statement_token2] = ACTIONS(1128),
    [aux_sym_do_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token1] = ACTIONS(1128),
    [aux_sym_for_statement_token2] = ACTIONS(1128),
    [aux_sym_foreach_statement_token1] = ACTIONS(1128),
    [aux_sym_foreach_statement_token2] = ACTIONS(1128),
    [aux_sym_if_statement_token1] = ACTIONS(1128),
    [aux_sym_if_statement_token2] = ACTIONS(1128),
    [aux_sym_else_if_clause_token1] = ACTIONS(1128),
    [aux_sym_else_clause_token1] = ACTIONS(1128),
    [aux_sym_match_expression_token1] = ACTIONS(1128),
    [aux_sym_match_default_expression_token1] = ACTIONS(1128),
    [aux_sym_switch_statement_token1] = ACTIONS(1128),
    [aux_sym_switch_block_token1] = ACTIONS(1128),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_BANG] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1126),
    [aux_sym_clone_expression_token1] = ACTIONS(1128),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1128),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1128),
    [anon_sym_DASH_DASH] = ACTIONS(1126),
    [anon_sym_PLUS_PLUS] = ACTIONS(1126),
    [aux_sym__list_destructing_token1] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_self] = ACTIONS(1128),
    [anon_sym_parent] = ACTIONS(1128),
    [aux_sym__argument_name_token1] = ACTIONS(1128),
    [aux_sym__argument_name_token2] = ACTIONS(1128),
    [anon_sym_POUND_LBRACK] = ACTIONS(1126),
    [aux_sym_encapsed_string_token1] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1126),
    [aux_sym_string_token1] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1126),
    [anon_sym_LT_LT_LT] = ACTIONS(1126),
    [anon_sym_BQUOTE] = ACTIONS(1126),
    [anon_sym_DOLLAR] = ACTIONS(1126),
    [aux_sym_yield_expression_token1] = ACTIONS(1128),
    [aux_sym_include_expression_token1] = ACTIONS(1128),
    [aux_sym_include_once_expression_token1] = ACTIONS(1128),
    [aux_sym_require_expression_token1] = ACTIONS(1128),
    [aux_sym_require_once_expression_token1] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1130),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(1132),
    [sym_name] = ACTIONS(1134),
    [anon_sym_QMARK_GT] = ACTIONS(1132),
    [anon_sym_SEMI] = ACTIONS(1136),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1134),
    [aux_sym_global_declaration_token1] = ACTIONS(1134),
    [aux_sym_namespace_definition_token1] = ACTIONS(1134),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1134),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1134),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1134),
    [anon_sym_BSLASH] = ACTIONS(1132),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_RBRACE] = ACTIONS(1132),
    [aux_sym_trait_declaration_token1] = ACTIONS(1134),
    [aux_sym_interface_declaration_token1] = ACTIONS(1134),
    [aux_sym_enum_declaration_token1] = ACTIONS(1134),
    [aux_sym_enum_case_token1] = ACTIONS(1134),
    [aux_sym_class_declaration_token1] = ACTIONS(1134),
    [aux_sym_final_modifier_token1] = ACTIONS(1134),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1134),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1134),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1134),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1134),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1134),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [aux_sym_cast_type_token1] = ACTIONS(1134),
    [aux_sym_echo_statement_token1] = ACTIONS(1134),
    [anon_sym_unset] = ACTIONS(1134),
    [aux_sym_declare_statement_token1] = ACTIONS(1134),
    [aux_sym_declare_statement_token2] = ACTIONS(1134),
    [sym_float] = ACTIONS(1134),
    [aux_sym_try_statement_token1] = ACTIONS(1134),
    [aux_sym_goto_statement_token1] = ACTIONS(1134),
    [aux_sym_continue_statement_token1] = ACTIONS(1134),
    [aux_sym_break_statement_token1] = ACTIONS(1134),
    [sym_integer] = ACTIONS(1134),
    [aux_sym_return_statement_token1] = ACTIONS(1134),
    [aux_sym_throw_expression_token1] = ACTIONS(1134),
    [aux_sym_while_statement_token1] = ACTIONS(1134),
    [aux_sym_while_statement_token2] = ACTIONS(1134),
    [aux_sym_do_statement_token1] = ACTIONS(1134),
    [aux_sym_for_statement_token1] = ACTIONS(1134),
    [aux_sym_for_statement_token2] = ACTIONS(1134),
    [aux_sym_foreach_statement_token1] = ACTIONS(1134),
    [aux_sym_foreach_statement_token2] = ACTIONS(1134),
    [aux_sym_if_statement_token1] = ACTIONS(1134),
    [aux_sym_if_statement_token2] = ACTIONS(1134),
    [aux_sym_else_if_clause_token1] = ACTIONS(1134),
    [aux_sym_else_clause_token1] = ACTIONS(1134),
    [aux_sym_match_expression_token1] = ACTIONS(1134),
    [aux_sym_match_default_expression_token1] = ACTIONS(1134),
    [aux_sym_switch_statement_token1] = ACTIONS(1134),
    [aux_sym_switch_block_token1] = ACTIONS(1134),
    [anon_sym_PLUS] = ACTIONS(1134),
    [anon_sym_DASH] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1132),
    [anon_sym_BANG] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1132),
    [aux_sym_clone_expression_token1] = ACTIONS(1134),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1134),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1132),
    [aux_sym__list_destructing_token1] = ACTIONS(1134),
    [anon_sym_LBRACK] = ACTIONS(1132),
    [anon_sym_self] = ACTIONS(1134),
    [anon_sym_parent] = ACTIONS(1134),
    [aux_sym__argument_name_token1] = ACTIONS(1134),
    [aux_sym__argument_name_token2] = ACTIONS(1134),
    [anon_sym_POUND_LBRACK] = ACTIONS(1132),
    [aux_sym_encapsed_string_token1] = ACTIONS(1132),
    [anon_sym_DQUOTE] = ACTIONS(1132),
    [aux_sym_string_token1] = ACTIONS(1132),
    [anon_sym_SQUOTE] = ACTIONS(1132),
    [anon_sym_LT_LT_LT] = ACTIONS(1132),
    [anon_sym_BQUOTE] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(1132),
    [aux_sym_yield_expression_token1] = ACTIONS(1134),
    [aux_sym_include_expression_token1] = ACTIONS(1134),
    [aux_sym_include_once_expression_token1] = ACTIONS(1134),
    [aux_sym_require_expression_token1] = ACTIONS(1134),
    [aux_sym_require_once_expression_token1] = ACTIONS(1134),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1136),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_name] = ACTIONS(1140),
    [anon_sym_QMARK_GT] = ACTIONS(1138),
    [anon_sym_SEMI] = ACTIONS(1138),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1140),
    [aux_sym_global_declaration_token1] = ACTIONS(1140),
    [aux_sym_namespace_definition_token1] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1140),
    [anon_sym_BSLASH] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [aux_sym_trait_declaration_token1] = ACTIONS(1140),
    [aux_sym_interface_declaration_token1] = ACTIONS(1140),
    [aux_sym_enum_declaration_token1] = ACTIONS(1140),
    [aux_sym_enum_case_token1] = ACTIONS(1140),
    [aux_sym_class_declaration_token1] = ACTIONS(1140),
    [aux_sym_final_modifier_token1] = ACTIONS(1140),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1140),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1140),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [aux_sym_cast_type_token1] = ACTIONS(1140),
    [aux_sym_echo_statement_token1] = ACTIONS(1140),
    [anon_sym_unset] = ACTIONS(1140),
    [aux_sym_declare_statement_token1] = ACTIONS(1140),
    [aux_sym_declare_statement_token2] = ACTIONS(1140),
    [sym_float] = ACTIONS(1140),
    [aux_sym_try_statement_token1] = ACTIONS(1140),
    [aux_sym_goto_statement_token1] = ACTIONS(1140),
    [aux_sym_continue_statement_token1] = ACTIONS(1140),
    [aux_sym_break_statement_token1] = ACTIONS(1140),
    [sym_integer] = ACTIONS(1140),
    [aux_sym_return_statement_token1] = ACTIONS(1140),
    [aux_sym_throw_expression_token1] = ACTIONS(1140),
    [aux_sym_while_statement_token1] = ACTIONS(1140),
    [aux_sym_while_statement_token2] = ACTIONS(1140),
    [aux_sym_do_statement_token1] = ACTIONS(1140),
    [aux_sym_for_statement_token1] = ACTIONS(1140),
    [aux_sym_for_statement_token2] = ACTIONS(1140),
    [aux_sym_foreach_statement_token1] = ACTIONS(1140),
    [aux_sym_foreach_statement_token2] = ACTIONS(1140),
    [aux_sym_if_statement_token1] = ACTIONS(1140),
    [aux_sym_if_statement_token2] = ACTIONS(1140),
    [aux_sym_else_if_clause_token1] = ACTIONS(1140),
    [aux_sym_else_clause_token1] = ACTIONS(1140),
    [aux_sym_match_expression_token1] = ACTIONS(1140),
    [aux_sym_match_default_expression_token1] = ACTIONS(1140),
    [aux_sym_switch_statement_token1] = ACTIONS(1140),
    [aux_sym_switch_block_token1] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_BANG] = ACTIONS(1138),
    [anon_sym_AT] = ACTIONS(1138),
    [aux_sym_clone_expression_token1] = ACTIONS(1140),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1140),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1140),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [aux_sym__list_destructing_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_self] = ACTIONS(1140),
    [anon_sym_parent] = ACTIONS(1140),
    [aux_sym__argument_name_token1] = ACTIONS(1140),
    [aux_sym__argument_name_token2] = ACTIONS(1140),
    [anon_sym_POUND_LBRACK] = ACTIONS(1138),
    [aux_sym_encapsed_string_token1] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [aux_sym_string_token1] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [anon_sym_LT_LT_LT] = ACTIONS(1138),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [anon_sym_DOLLAR] = ACTIONS(1138),
    [aux_sym_yield_expression_token1] = ACTIONS(1140),
    [aux_sym_include_expression_token1] = ACTIONS(1140),
    [aux_sym_include_once_expression_token1] = ACTIONS(1140),
    [aux_sym_require_expression_token1] = ACTIONS(1140),
    [aux_sym_require_once_expression_token1] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1138),
  },
  [452] = {
    [ts_builtin_sym_end] = ACTIONS(1142),
    [sym_name] = ACTIONS(1144),
    [anon_sym_QMARK_GT] = ACTIONS(1142),
    [anon_sym_SEMI] = ACTIONS(1146),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1144),
    [aux_sym_global_declaration_token1] = ACTIONS(1144),
    [aux_sym_namespace_definition_token1] = ACTIONS(1144),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1144),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1144),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1144),
    [anon_sym_BSLASH] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1142),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [aux_sym_trait_declaration_token1] = ACTIONS(1144),
    [aux_sym_interface_declaration_token1] = ACTIONS(1144),
    [aux_sym_enum_declaration_token1] = ACTIONS(1144),
    [aux_sym_enum_case_token1] = ACTIONS(1144),
    [aux_sym_class_declaration_token1] = ACTIONS(1144),
    [aux_sym_final_modifier_token1] = ACTIONS(1144),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1144),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1144),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1144),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1144),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1144),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [aux_sym_cast_type_token1] = ACTIONS(1144),
    [aux_sym_echo_statement_token1] = ACTIONS(1144),
    [anon_sym_unset] = ACTIONS(1144),
    [aux_sym_declare_statement_token1] = ACTIONS(1144),
    [aux_sym_declare_statement_token2] = ACTIONS(1144),
    [sym_float] = ACTIONS(1144),
    [aux_sym_try_statement_token1] = ACTIONS(1144),
    [aux_sym_goto_statement_token1] = ACTIONS(1144),
    [aux_sym_continue_statement_token1] = ACTIONS(1144),
    [aux_sym_break_statement_token1] = ACTIONS(1144),
    [sym_integer] = ACTIONS(1144),
    [aux_sym_return_statement_token1] = ACTIONS(1144),
    [aux_sym_throw_expression_token1] = ACTIONS(1144),
    [aux_sym_while_statement_token1] = ACTIONS(1144),
    [aux_sym_while_statement_token2] = ACTIONS(1144),
    [aux_sym_do_statement_token1] = ACTIONS(1144),
    [aux_sym_for_statement_token1] = ACTIONS(1144),
    [aux_sym_for_statement_token2] = ACTIONS(1144),
    [aux_sym_foreach_statement_token1] = ACTIONS(1144),
    [aux_sym_foreach_statement_token2] = ACTIONS(1144),
    [aux_sym_if_statement_token1] = ACTIONS(1144),
    [aux_sym_if_statement_token2] = ACTIONS(1144),
    [aux_sym_else_if_clause_token1] = ACTIONS(1144),
    [aux_sym_else_clause_token1] = ACTIONS(1144),
    [aux_sym_match_expression_token1] = ACTIONS(1144),
    [aux_sym_match_default_expression_token1] = ACTIONS(1144),
    [aux_sym_switch_statement_token1] = ACTIONS(1144),
    [aux_sym_switch_block_token1] = ACTIONS(1144),
    [anon_sym_PLUS] = ACTIONS(1144),
    [anon_sym_DASH] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1142),
    [anon_sym_BANG] = ACTIONS(1142),
    [anon_sym_AT] = ACTIONS(1142),
    [aux_sym_clone_expression_token1] = ACTIONS(1144),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1144),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1144),
    [anon_sym_DASH_DASH] = ACTIONS(1142),
    [anon_sym_PLUS_PLUS] = ACTIONS(1142),
    [aux_sym__list_destructing_token1] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_self] = ACTIONS(1144),
    [anon_sym_parent] = ACTIONS(1144),
    [aux_sym__argument_name_token1] = ACTIONS(1144),
    [aux_sym__argument_name_token2] = ACTIONS(1144),
    [anon_sym_POUND_LBRACK] = ACTIONS(1142),
    [aux_sym_encapsed_string_token1] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1142),
    [aux_sym_string_token1] = ACTIONS(1142),
    [anon_sym_SQUOTE] = ACTIONS(1142),
    [anon_sym_LT_LT_LT] = ACTIONS(1142),
    [anon_sym_BQUOTE] = ACTIONS(1142),
    [anon_sym_DOLLAR] = ACTIONS(1142),
    [aux_sym_yield_expression_token1] = ACTIONS(1144),
    [aux_sym_include_expression_token1] = ACTIONS(1144),
    [aux_sym_include_once_expression_token1] = ACTIONS(1144),
    [aux_sym_require_expression_token1] = ACTIONS(1144),
    [aux_sym_require_once_expression_token1] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1146),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(1148),
    [sym_name] = ACTIONS(1150),
    [anon_sym_QMARK_GT] = ACTIONS(1148),
    [anon_sym_SEMI] = ACTIONS(1152),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1150),
    [aux_sym_global_declaration_token1] = ACTIONS(1150),
    [aux_sym_namespace_definition_token1] = ACTIONS(1150),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1150),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1150),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1150),
    [anon_sym_BSLASH] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(1148),
    [anon_sym_RBRACE] = ACTIONS(1148),
    [aux_sym_trait_declaration_token1] = ACTIONS(1150),
    [aux_sym_interface_declaration_token1] = ACTIONS(1150),
    [aux_sym_enum_declaration_token1] = ACTIONS(1150),
    [aux_sym_enum_case_token1] = ACTIONS(1150),
    [aux_sym_class_declaration_token1] = ACTIONS(1150),
    [aux_sym_final_modifier_token1] = ACTIONS(1150),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1150),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1150),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1150),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1150),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1150),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(1148),
    [aux_sym_cast_type_token1] = ACTIONS(1150),
    [aux_sym_echo_statement_token1] = ACTIONS(1150),
    [anon_sym_unset] = ACTIONS(1150),
    [aux_sym_declare_statement_token1] = ACTIONS(1150),
    [aux_sym_declare_statement_token2] = ACTIONS(1150),
    [sym_float] = ACTIONS(1150),
    [aux_sym_try_statement_token1] = ACTIONS(1150),
    [aux_sym_goto_statement_token1] = ACTIONS(1150),
    [aux_sym_continue_statement_token1] = ACTIONS(1150),
    [aux_sym_break_statement_token1] = ACTIONS(1150),
    [sym_integer] = ACTIONS(1150),
    [aux_sym_return_statement_token1] = ACTIONS(1150),
    [aux_sym_throw_expression_token1] = ACTIONS(1150),
    [aux_sym_while_statement_token1] = ACTIONS(1150),
    [aux_sym_while_statement_token2] = ACTIONS(1150),
    [aux_sym_do_statement_token1] = ACTIONS(1150),
    [aux_sym_for_statement_token1] = ACTIONS(1150),
    [aux_sym_for_statement_token2] = ACTIONS(1150),
    [aux_sym_foreach_statement_token1] = ACTIONS(1150),
    [aux_sym_foreach_statement_token2] = ACTIONS(1150),
    [aux_sym_if_statement_token1] = ACTIONS(1150),
    [aux_sym_if_statement_token2] = ACTIONS(1150),
    [aux_sym_else_if_clause_token1] = ACTIONS(1150),
    [aux_sym_else_clause_token1] = ACTIONS(1150),
    [aux_sym_match_expression_token1] = ACTIONS(1150),
    [aux_sym_match_default_expression_token1] = ACTIONS(1150),
    [aux_sym_switch_statement_token1] = ACTIONS(1150),
    [aux_sym_switch_block_token1] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_TILDE] = ACTIONS(1148),
    [anon_sym_BANG] = ACTIONS(1148),
    [anon_sym_AT] = ACTIONS(1148),
    [aux_sym_clone_expression_token1] = ACTIONS(1150),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1150),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1150),
    [anon_sym_DASH_DASH] = ACTIONS(1148),
    [anon_sym_PLUS_PLUS] = ACTIONS(1148),
    [aux_sym__list_destructing_token1] = ACTIONS(1150),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_self] = ACTIONS(1150),
    [anon_sym_parent] = ACTIONS(1150),
    [aux_sym__argument_name_token1] = ACTIONS(1150),
    [aux_sym__argument_name_token2] = ACTIONS(1150),
    [anon_sym_POUND_LBRACK] = ACTIONS(1148),
    [aux_sym_encapsed_string_token1] = ACTIONS(1148),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [aux_sym_string_token1] = ACTIONS(1148),
    [anon_sym_SQUOTE] = ACTIONS(1148),
    [anon_sym_LT_LT_LT] = ACTIONS(1148),
    [anon_sym_BQUOTE] = ACTIONS(1148),
    [anon_sym_DOLLAR] = ACTIONS(1148),
    [aux_sym_yield_expression_token1] = ACTIONS(1150),
    [aux_sym_include_expression_token1] = ACTIONS(1150),
    [aux_sym_include_once_expression_token1] = ACTIONS(1150),
    [aux_sym_require_expression_token1] = ACTIONS(1150),
    [aux_sym_require_once_expression_token1] = ACTIONS(1150),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1152),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(1154),
    [sym_name] = ACTIONS(1156),
    [anon_sym_QMARK_GT] = ACTIONS(1154),
    [anon_sym_SEMI] = ACTIONS(1154),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1156),
    [aux_sym_global_declaration_token1] = ACTIONS(1156),
    [aux_sym_namespace_definition_token1] = ACTIONS(1156),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1156),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1156),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1156),
    [anon_sym_BSLASH] = ACTIONS(1154),
    [anon_sym_LBRACE] = ACTIONS(1154),
    [anon_sym_RBRACE] = ACTIONS(1154),
    [aux_sym_trait_declaration_token1] = ACTIONS(1156),
    [aux_sym_interface_declaration_token1] = ACTIONS(1156),
    [aux_sym_enum_declaration_token1] = ACTIONS(1156),
    [aux_sym_enum_case_token1] = ACTIONS(1156),
    [aux_sym_class_declaration_token1] = ACTIONS(1156),
    [aux_sym_final_modifier_token1] = ACTIONS(1156),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1156),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1156),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1156),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1156),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1156),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1156),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [aux_sym_cast_type_token1] = ACTIONS(1156),
    [aux_sym_echo_statement_token1] = ACTIONS(1156),
    [anon_sym_unset] = ACTIONS(1156),
    [aux_sym_declare_statement_token1] = ACTIONS(1156),
    [aux_sym_declare_statement_token2] = ACTIONS(1156),
    [sym_float] = ACTIONS(1156),
    [aux_sym_try_statement_token1] = ACTIONS(1156),
    [aux_sym_goto_statement_token1] = ACTIONS(1156),
    [aux_sym_continue_statement_token1] = ACTIONS(1156),
    [aux_sym_break_statement_token1] = ACTIONS(1156),
    [sym_integer] = ACTIONS(1156),
    [aux_sym_return_statement_token1] = ACTIONS(1156),
    [aux_sym_throw_expression_token1] = ACTIONS(1156),
    [aux_sym_while_statement_token1] = ACTIONS(1156),
    [aux_sym_while_statement_token2] = ACTIONS(1156),
    [aux_sym_do_statement_token1] = ACTIONS(1156),
    [aux_sym_for_statement_token1] = ACTIONS(1156),
    [aux_sym_for_statement_token2] = ACTIONS(1156),
    [aux_sym_foreach_statement_token1] = ACTIONS(1156),
    [aux_sym_foreach_statement_token2] = ACTIONS(1156),
    [aux_sym_if_statement_token1] = ACTIONS(1156),
    [aux_sym_if_statement_token2] = ACTIONS(1156),
    [aux_sym_else_if_clause_token1] = ACTIONS(1156),
    [aux_sym_else_clause_token1] = ACTIONS(1156),
    [aux_sym_match_expression_token1] = ACTIONS(1156),
    [aux_sym_match_default_expression_token1] = ACTIONS(1156),
    [aux_sym_switch_statement_token1] = ACTIONS(1156),
    [aux_sym_switch_block_token1] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(1156),
    [anon_sym_DASH] = ACTIONS(1156),
    [anon_sym_TILDE] = ACTIONS(1154),
    [anon_sym_BANG] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(1154),
    [aux_sym_clone_expression_token1] = ACTIONS(1156),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1156),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1156),
    [anon_sym_DASH_DASH] = ACTIONS(1154),
    [anon_sym_PLUS_PLUS] = ACTIONS(1154),
    [aux_sym__list_destructing_token1] = ACTIONS(1156),
    [anon_sym_LBRACK] = ACTIONS(1154),
    [anon_sym_self] = ACTIONS(1156),
    [anon_sym_parent] = ACTIONS(1156),
    [aux_sym__argument_name_token1] = ACTIONS(1156),
    [aux_sym__argument_name_token2] = ACTIONS(1156),
    [anon_sym_POUND_LBRACK] = ACTIONS(1154),
    [aux_sym_encapsed_string_token1] = ACTIONS(1154),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [aux_sym_string_token1] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1154),
    [anon_sym_LT_LT_LT] = ACTIONS(1154),
    [anon_sym_BQUOTE] = ACTIONS(1154),
    [anon_sym_DOLLAR] = ACTIONS(1154),
    [aux_sym_yield_expression_token1] = ACTIONS(1156),
    [aux_sym_include_expression_token1] = ACTIONS(1156),
    [aux_sym_include_once_expression_token1] = ACTIONS(1156),
    [aux_sym_require_expression_token1] = ACTIONS(1156),
    [aux_sym_require_once_expression_token1] = ACTIONS(1156),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(1158),
    [sym_name] = ACTIONS(1160),
    [anon_sym_QMARK_GT] = ACTIONS(1158),
    [anon_sym_SEMI] = ACTIONS(1158),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1160),
    [aux_sym_global_declaration_token1] = ACTIONS(1160),
    [aux_sym_namespace_definition_token1] = ACTIONS(1160),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1160),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1160),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1160),
    [anon_sym_BSLASH] = ACTIONS(1158),
    [anon_sym_LBRACE] = ACTIONS(1158),
    [anon_sym_RBRACE] = ACTIONS(1158),
    [aux_sym_trait_declaration_token1] = ACTIONS(1160),
    [aux_sym_interface_declaration_token1] = ACTIONS(1160),
    [aux_sym_enum_declaration_token1] = ACTIONS(1160),
    [aux_sym_enum_case_token1] = ACTIONS(1160),
    [aux_sym_class_declaration_token1] = ACTIONS(1160),
    [aux_sym_final_modifier_token1] = ACTIONS(1160),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1160),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1160),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1160),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1160),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1160),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1160),
    [anon_sym_LPAREN] = ACTIONS(1158),
    [aux_sym_cast_type_token1] = ACTIONS(1160),
    [aux_sym_echo_statement_token1] = ACTIONS(1160),
    [anon_sym_unset] = ACTIONS(1160),
    [aux_sym_declare_statement_token1] = ACTIONS(1160),
    [aux_sym_declare_statement_token2] = ACTIONS(1160),
    [sym_float] = ACTIONS(1160),
    [aux_sym_try_statement_token1] = ACTIONS(1160),
    [aux_sym_goto_statement_token1] = ACTIONS(1160),
    [aux_sym_continue_statement_token1] = ACTIONS(1160),
    [aux_sym_break_statement_token1] = ACTIONS(1160),
    [sym_integer] = ACTIONS(1160),
    [aux_sym_return_statement_token1] = ACTIONS(1160),
    [aux_sym_throw_expression_token1] = ACTIONS(1160),
    [aux_sym_while_statement_token1] = ACTIONS(1160),
    [aux_sym_while_statement_token2] = ACTIONS(1160),
    [aux_sym_do_statement_token1] = ACTIONS(1160),
    [aux_sym_for_statement_token1] = ACTIONS(1160),
    [aux_sym_for_statement_token2] = ACTIONS(1160),
    [aux_sym_foreach_statement_token1] = ACTIONS(1160),
    [aux_sym_foreach_statement_token2] = ACTIONS(1160),
    [aux_sym_if_statement_token1] = ACTIONS(1160),
    [aux_sym_if_statement_token2] = ACTIONS(1160),
    [aux_sym_else_if_clause_token1] = ACTIONS(1160),
    [aux_sym_else_clause_token1] = ACTIONS(1160),
    [aux_sym_match_expression_token1] = ACTIONS(1160),
    [aux_sym_match_default_expression_token1] = ACTIONS(1160),
    [aux_sym_switch_statement_token1] = ACTIONS(1160),
    [aux_sym_switch_block_token1] = ACTIONS(1160),
    [anon_sym_PLUS] = ACTIONS(1160),
    [anon_sym_DASH] = ACTIONS(1160),
    [anon_sym_TILDE] = ACTIONS(1158),
    [anon_sym_BANG] = ACTIONS(1158),
    [anon_sym_AT] = ACTIONS(1158),
    [aux_sym_clone_expression_token1] = ACTIONS(1160),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1160),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1160),
    [anon_sym_DASH_DASH] = ACTIONS(1158),
    [anon_sym_PLUS_PLUS] = ACTIONS(1158),
    [aux_sym__list_destructing_token1] = ACTIONS(1160),
    [anon_sym_LBRACK] = ACTIONS(1158),
    [anon_sym_self] = ACTIONS(1160),
    [anon_sym_parent] = ACTIONS(1160),
    [aux_sym__argument_name_token1] = ACTIONS(1160),
    [aux_sym__argument_name_token2] = ACTIONS(1160),
    [anon_sym_POUND_LBRACK] = ACTIONS(1158),
    [aux_sym_encapsed_string_token1] = ACTIONS(1158),
    [anon_sym_DQUOTE] = ACTIONS(1158),
    [aux_sym_string_token1] = ACTIONS(1158),
    [anon_sym_SQUOTE] = ACTIONS(1158),
    [anon_sym_LT_LT_LT] = ACTIONS(1158),
    [anon_sym_BQUOTE] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1158),
    [aux_sym_yield_expression_token1] = ACTIONS(1160),
    [aux_sym_include_expression_token1] = ACTIONS(1160),
    [aux_sym_include_once_expression_token1] = ACTIONS(1160),
    [aux_sym_require_expression_token1] = ACTIONS(1160),
    [aux_sym_require_once_expression_token1] = ACTIONS(1160),
    [sym_comment] = ACTIONS(3),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(1162),
    [sym_name] = ACTIONS(1164),
    [anon_sym_QMARK_GT] = ACTIONS(1162),
    [anon_sym_SEMI] = ACTIONS(1162),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1164),
    [aux_sym_global_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_definition_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1164),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1164),
    [anon_sym_BSLASH] = ACTIONS(1162),
    [anon_sym_LBRACE] = ACTIONS(1162),
    [anon_sym_RBRACE] = ACTIONS(1162),
    [aux_sym_trait_declaration_token1] = ACTIONS(1164),
    [aux_sym_interface_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_declaration_token1] = ACTIONS(1164),
    [aux_sym_enum_case_token1] = ACTIONS(1164),
    [aux_sym_class_declaration_token1] = ACTIONS(1164),
    [aux_sym_final_modifier_token1] = ACTIONS(1164),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1164),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1164),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1164),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1164),
    [anon_sym_LPAREN] = ACTIONS(1162),
    [aux_sym_cast_type_token1] = ACTIONS(1164),
    [aux_sym_echo_statement_token1] = ACTIONS(1164),
    [anon_sym_unset] = ACTIONS(1164),
    [aux_sym_declare_statement_token1] = ACTIONS(1164),
    [aux_sym_declare_statement_token2] = ACTIONS(1164),
    [sym_float] = ACTIONS(1164),
    [aux_sym_try_statement_token1] = ACTIONS(1164),
    [aux_sym_goto_statement_token1] = ACTIONS(1164),
    [aux_sym_continue_statement_token1] = ACTIONS(1164),
    [aux_sym_break_statement_token1] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1164),
    [aux_sym_return_statement_token1] = ACTIONS(1164),
    [aux_sym_throw_expression_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token1] = ACTIONS(1164),
    [aux_sym_while_statement_token2] = ACTIONS(1164),
    [aux_sym_do_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token1] = ACTIONS(1164),
    [aux_sym_for_statement_token2] = ACTIONS(1164),
    [aux_sym_foreach_statement_token1] = ACTIONS(1164),
    [aux_sym_foreach_statement_token2] = ACTIONS(1164),
    [aux_sym_if_statement_token1] = ACTIONS(1164),
    [aux_sym_if_statement_token2] = ACTIONS(1164),
    [aux_sym_else_if_clause_token1] = ACTIONS(1164),
    [aux_sym_else_clause_token1] = ACTIONS(1164),
    [aux_sym_match_expression_token1] = ACTIONS(1164),
    [aux_sym_match_default_expression_token1] = ACTIONS(1164),
    [aux_sym_switch_statement_token1] = ACTIONS(1164),
    [aux_sym_switch_block_token1] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_TILDE] = ACTIONS(1162),
    [anon_sym_BANG] = ACTIONS(1162),
    [anon_sym_AT] = ACTIONS(1162),
    [aux_sym_clone_expression_token1] = ACTIONS(1164),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1164),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1164),
    [anon_sym_DASH_DASH] = ACTIONS(1162),
    [anon_sym_PLUS_PLUS] = ACTIONS(1162),
    [aux_sym__list_destructing_token1] = ACTIONS(1164),
    [anon_sym_LBRACK] = ACTIONS(1162),
    [anon_sym_self] = ACTIONS(1164),
    [anon_sym_parent] = ACTIONS(1164),
    [aux_sym__argument_name_token1] = ACTIONS(1164),
    [aux_sym__argument_name_token2] = ACTIONS(1164),
    [anon_sym_POUND_LBRACK] = ACTIONS(1162),
    [aux_sym_encapsed_string_token1] = ACTIONS(1162),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [aux_sym_string_token1] = ACTIONS(1162),
    [anon_sym_SQUOTE] = ACTIONS(1162),
    [anon_sym_LT_LT_LT] = ACTIONS(1162),
    [anon_sym_BQUOTE] = ACTIONS(1162),
    [anon_sym_DOLLAR] = ACTIONS(1162),
    [aux_sym_yield_expression_token1] = ACTIONS(1164),
    [aux_sym_include_expression_token1] = ACTIONS(1164),
    [aux_sym_include_once_expression_token1] = ACTIONS(1164),
    [aux_sym_require_expression_token1] = ACTIONS(1164),
    [aux_sym_require_once_expression_token1] = ACTIONS(1164),
    [sym_comment] = ACTIONS(3),
  },
  [457] = {
    [ts_builtin_sym_end] = ACTIONS(1166),
    [sym_name] = ACTIONS(1168),
    [anon_sym_QMARK_GT] = ACTIONS(1166),
    [anon_sym_SEMI] = ACTIONS(1166),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1168),
    [aux_sym_global_declaration_token1] = ACTIONS(1168),
    [aux_sym_namespace_definition_token1] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1168),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1168),
    [anon_sym_BSLASH] = ACTIONS(1166),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [aux_sym_trait_declaration_token1] = ACTIONS(1168),
    [aux_sym_interface_declaration_token1] = ACTIONS(1168),
    [aux_sym_enum_declaration_token1] = ACTIONS(1168),
    [aux_sym_enum_case_token1] = ACTIONS(1168),
    [aux_sym_class_declaration_token1] = ACTIONS(1168),
    [aux_sym_final_modifier_token1] = ACTIONS(1168),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1168),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1168),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1168),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1168),
    [anon_sym_LPAREN] = ACTIONS(1166),
    [aux_sym_cast_type_token1] = ACTIONS(1168),
    [aux_sym_echo_statement_token1] = ACTIONS(1168),
    [anon_sym_unset] = ACTIONS(1168),
    [aux_sym_declare_statement_token1] = ACTIONS(1168),
    [aux_sym_declare_statement_token2] = ACTIONS(1168),
    [sym_float] = ACTIONS(1168),
    [aux_sym_try_statement_token1] = ACTIONS(1168),
    [aux_sym_goto_statement_token1] = ACTIONS(1168),
    [aux_sym_continue_statement_token1] = ACTIONS(1168),
    [aux_sym_break_statement_token1] = ACTIONS(1168),
    [sym_integer] = ACTIONS(1168),
    [aux_sym_return_statement_token1] = ACTIONS(1168),
    [aux_sym_throw_expression_token1] = ACTIONS(1168),
    [aux_sym_while_statement_token1] = ACTIONS(1168),
    [aux_sym_while_statement_token2] = ACTIONS(1168),
    [aux_sym_do_statement_token1] = ACTIONS(1168),
    [aux_sym_for_statement_token1] = ACTIONS(1168),
    [aux_sym_for_statement_token2] = ACTIONS(1168),
    [aux_sym_foreach_statement_token1] = ACTIONS(1168),
    [aux_sym_foreach_statement_token2] = ACTIONS(1168),
    [aux_sym_if_statement_token1] = ACTIONS(1168),
    [aux_sym_if_statement_token2] = ACTIONS(1168),
    [aux_sym_else_if_clause_token1] = ACTIONS(1168),
    [aux_sym_else_clause_token1] = ACTIONS(1168),
    [aux_sym_match_expression_token1] = ACTIONS(1168),
    [aux_sym_match_default_expression_token1] = ACTIONS(1168),
    [aux_sym_switch_statement_token1] = ACTIONS(1168),
    [aux_sym_switch_block_token1] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(1168),
    [anon_sym_DASH] = ACTIONS(1168),
    [anon_sym_TILDE] = ACTIONS(1166),
    [anon_sym_BANG] = ACTIONS(1166),
    [anon_sym_AT] = ACTIONS(1166),
    [aux_sym_clone_expression_token1] = ACTIONS(1168),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1168),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1168),
    [anon_sym_DASH_DASH] = ACTIONS(1166),
    [anon_sym_PLUS_PLUS] = ACTIONS(1166),
    [aux_sym__list_destructing_token1] = ACTIONS(1168),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_self] = ACTIONS(1168),
    [anon_sym_parent] = ACTIONS(1168),
    [aux_sym__argument_name_token1] = ACTIONS(1168),
    [aux_sym__argument_name_token2] = ACTIONS(1168),
    [anon_sym_POUND_LBRACK] = ACTIONS(1166),
    [aux_sym_encapsed_string_token1] = ACTIONS(1166),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [aux_sym_string_token1] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [anon_sym_LT_LT_LT] = ACTIONS(1166),
    [anon_sym_BQUOTE] = ACTIONS(1166),
    [anon_sym_DOLLAR] = ACTIONS(1166),
    [aux_sym_yield_expression_token1] = ACTIONS(1168),
    [aux_sym_include_expression_token1] = ACTIONS(1168),
    [aux_sym_include_once_expression_token1] = ACTIONS(1168),
    [aux_sym_require_expression_token1] = ACTIONS(1168),
    [aux_sym_require_once_expression_token1] = ACTIONS(1168),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_name] = ACTIONS(1172),
    [anon_sym_QMARK_GT] = ACTIONS(1170),
    [anon_sym_SEMI] = ACTIONS(1170),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1172),
    [aux_sym_global_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_definition_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1172),
    [anon_sym_BSLASH] = ACTIONS(1170),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [aux_sym_trait_declaration_token1] = ACTIONS(1172),
    [aux_sym_interface_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_case_token1] = ACTIONS(1172),
    [aux_sym_class_declaration_token1] = ACTIONS(1172),
    [aux_sym_final_modifier_token1] = ACTIONS(1172),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1172),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1172),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [aux_sym_cast_type_token1] = ACTIONS(1172),
    [aux_sym_echo_statement_token1] = ACTIONS(1172),
    [anon_sym_unset] = ACTIONS(1172),
    [aux_sym_declare_statement_token1] = ACTIONS(1172),
    [aux_sym_declare_statement_token2] = ACTIONS(1172),
    [sym_float] = ACTIONS(1172),
    [aux_sym_try_statement_token1] = ACTIONS(1172),
    [aux_sym_goto_statement_token1] = ACTIONS(1172),
    [aux_sym_continue_statement_token1] = ACTIONS(1172),
    [aux_sym_break_statement_token1] = ACTIONS(1172),
    [sym_integer] = ACTIONS(1172),
    [aux_sym_return_statement_token1] = ACTIONS(1172),
    [aux_sym_throw_expression_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token2] = ACTIONS(1172),
    [aux_sym_do_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token2] = ACTIONS(1172),
    [aux_sym_foreach_statement_token1] = ACTIONS(1172),
    [aux_sym_foreach_statement_token2] = ACTIONS(1172),
    [aux_sym_if_statement_token1] = ACTIONS(1172),
    [aux_sym_if_statement_token2] = ACTIONS(1172),
    [aux_sym_else_if_clause_token1] = ACTIONS(1172),
    [aux_sym_else_clause_token1] = ACTIONS(1172),
    [aux_sym_match_expression_token1] = ACTIONS(1172),
    [aux_sym_match_default_expression_token1] = ACTIONS(1172),
    [aux_sym_switch_statement_token1] = ACTIONS(1172),
    [aux_sym_switch_block_token1] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1170),
    [anon_sym_BANG] = ACTIONS(1170),
    [anon_sym_AT] = ACTIONS(1170),
    [aux_sym_clone_expression_token1] = ACTIONS(1172),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1172),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1172),
    [anon_sym_DASH_DASH] = ACTIONS(1170),
    [anon_sym_PLUS_PLUS] = ACTIONS(1170),
    [aux_sym__list_destructing_token1] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_self] = ACTIONS(1172),
    [anon_sym_parent] = ACTIONS(1172),
    [aux_sym__argument_name_token1] = ACTIONS(1172),
    [aux_sym__argument_name_token2] = ACTIONS(1172),
    [anon_sym_POUND_LBRACK] = ACTIONS(1170),
    [aux_sym_encapsed_string_token1] = ACTIONS(1170),
    [anon_sym_DQUOTE] = ACTIONS(1170),
    [aux_sym_string_token1] = ACTIONS(1170),
    [anon_sym_SQUOTE] = ACTIONS(1170),
    [anon_sym_LT_LT_LT] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1170),
    [anon_sym_DOLLAR] = ACTIONS(1170),
    [aux_sym_yield_expression_token1] = ACTIONS(1172),
    [aux_sym_include_expression_token1] = ACTIONS(1172),
    [aux_sym_include_once_expression_token1] = ACTIONS(1172),
    [aux_sym_require_expression_token1] = ACTIONS(1172),
    [aux_sym_require_once_expression_token1] = ACTIONS(1172),
    [sym_comment] = ACTIONS(3),
  },
  [459] = {
    [ts_builtin_sym_end] = ACTIONS(1174),
    [sym_name] = ACTIONS(1176),
    [anon_sym_QMARK_GT] = ACTIONS(1174),
    [anon_sym_SEMI] = ACTIONS(1174),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1176),
    [aux_sym_global_declaration_token1] = ACTIONS(1176),
    [aux_sym_namespace_definition_token1] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1176),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1176),
    [anon_sym_BSLASH] = ACTIONS(1174),
    [anon_sym_LBRACE] = ACTIONS(1174),
    [anon_sym_RBRACE] = ACTIONS(1174),
    [aux_sym_trait_declaration_token1] = ACTIONS(1176),
    [aux_sym_interface_declaration_token1] = ACTIONS(1176),
    [aux_sym_enum_declaration_token1] = ACTIONS(1176),
    [aux_sym_enum_case_token1] = ACTIONS(1176),
    [aux_sym_class_declaration_token1] = ACTIONS(1176),
    [aux_sym_final_modifier_token1] = ACTIONS(1176),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1176),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1176),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1176),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [aux_sym_cast_type_token1] = ACTIONS(1176),
    [aux_sym_echo_statement_token1] = ACTIONS(1176),
    [anon_sym_unset] = ACTIONS(1176),
    [aux_sym_declare_statement_token1] = ACTIONS(1176),
    [aux_sym_declare_statement_token2] = ACTIONS(1176),
    [sym_float] = ACTIONS(1176),
    [aux_sym_try_statement_token1] = ACTIONS(1176),
    [aux_sym_goto_statement_token1] = ACTIONS(1176),
    [aux_sym_continue_statement_token1] = ACTIONS(1176),
    [aux_sym_break_statement_token1] = ACTIONS(1176),
    [sym_integer] = ACTIONS(1176),
    [aux_sym_return_statement_token1] = ACTIONS(1176),
    [aux_sym_throw_expression_token1] = ACTIONS(1176),
    [aux_sym_while_statement_token1] = ACTIONS(1176),
    [aux_sym_while_statement_token2] = ACTIONS(1176),
    [aux_sym_do_statement_token1] = ACTIONS(1176),
    [aux_sym_for_statement_token1] = ACTIONS(1176),
    [aux_sym_for_statement_token2] = ACTIONS(1176),
    [aux_sym_foreach_statement_token1] = ACTIONS(1176),
    [aux_sym_foreach_statement_token2] = ACTIONS(1176),
    [aux_sym_if_statement_token1] = ACTIONS(1176),
    [aux_sym_if_statement_token2] = ACTIONS(1176),
    [aux_sym_else_if_clause_token1] = ACTIONS(1176),
    [aux_sym_else_clause_token1] = ACTIONS(1176),
    [aux_sym_match_expression_token1] = ACTIONS(1176),
    [aux_sym_match_default_expression_token1] = ACTIONS(1176),
    [aux_sym_switch_statement_token1] = ACTIONS(1176),
    [aux_sym_switch_block_token1] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(1174),
    [anon_sym_BANG] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(1174),
    [aux_sym_clone_expression_token1] = ACTIONS(1176),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1176),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1176),
    [anon_sym_DASH_DASH] = ACTIONS(1174),
    [anon_sym_PLUS_PLUS] = ACTIONS(1174),
    [aux_sym__list_destructing_token1] = ACTIONS(1176),
    [anon_sym_LBRACK] = ACTIONS(1174),
    [anon_sym_self] = ACTIONS(1176),
    [anon_sym_parent] = ACTIONS(1176),
    [aux_sym__argument_name_token1] = ACTIONS(1176),
    [aux_sym__argument_name_token2] = ACTIONS(1176),
    [anon_sym_POUND_LBRACK] = ACTIONS(1174),
    [aux_sym_encapsed_string_token1] = ACTIONS(1174),
    [anon_sym_DQUOTE] = ACTIONS(1174),
    [aux_sym_string_token1] = ACTIONS(1174),
    [anon_sym_SQUOTE] = ACTIONS(1174),
    [anon_sym_LT_LT_LT] = ACTIONS(1174),
    [anon_sym_BQUOTE] = ACTIONS(1174),
    [anon_sym_DOLLAR] = ACTIONS(1174),
    [aux_sym_yield_expression_token1] = ACTIONS(1176),
    [aux_sym_include_expression_token1] = ACTIONS(1176),
    [aux_sym_include_once_expression_token1] = ACTIONS(1176),
    [aux_sym_require_expression_token1] = ACTIONS(1176),
    [aux_sym_require_once_expression_token1] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1178),
    [sym_name] = ACTIONS(1180),
    [anon_sym_QMARK_GT] = ACTIONS(1178),
    [anon_sym_SEMI] = ACTIONS(1178),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1180),
    [aux_sym_global_declaration_token1] = ACTIONS(1180),
    [aux_sym_namespace_definition_token1] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1180),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1180),
    [anon_sym_BSLASH] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1178),
    [anon_sym_RBRACE] = ACTIONS(1178),
    [aux_sym_trait_declaration_token1] = ACTIONS(1180),
    [aux_sym_interface_declaration_token1] = ACTIONS(1180),
    [aux_sym_enum_declaration_token1] = ACTIONS(1180),
    [aux_sym_enum_case_token1] = ACTIONS(1180),
    [aux_sym_class_declaration_token1] = ACTIONS(1180),
    [aux_sym_final_modifier_token1] = ACTIONS(1180),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1180),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1180),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1180),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1180),
    [anon_sym_LPAREN] = ACTIONS(1178),
    [aux_sym_cast_type_token1] = ACTIONS(1180),
    [aux_sym_echo_statement_token1] = ACTIONS(1180),
    [anon_sym_unset] = ACTIONS(1180),
    [aux_sym_declare_statement_token1] = ACTIONS(1180),
    [aux_sym_declare_statement_token2] = ACTIONS(1180),
    [sym_float] = ACTIONS(1180),
    [aux_sym_try_statement_token1] = ACTIONS(1180),
    [aux_sym_goto_statement_token1] = ACTIONS(1180),
    [aux_sym_continue_statement_token1] = ACTIONS(1180),
    [aux_sym_break_statement_token1] = ACTIONS(1180),
    [sym_integer] = ACTIONS(1180),
    [aux_sym_return_statement_token1] = ACTIONS(1180),
    [aux_sym_throw_expression_token1] = ACTIONS(1180),
    [aux_sym_while_statement_token1] = ACTIONS(1180),
    [aux_sym_while_statement_token2] = ACTIONS(1180),
    [aux_sym_do_statement_token1] = ACTIONS(1180),
    [aux_sym_for_statement_token1] = ACTIONS(1180),
    [aux_sym_for_statement_token2] = ACTIONS(1180),
    [aux_sym_foreach_statement_token1] = ACTIONS(1180),
    [aux_sym_foreach_statement_token2] = ACTIONS(1180),
    [aux_sym_if_statement_token1] = ACTIONS(1180),
    [aux_sym_if_statement_token2] = ACTIONS(1180),
    [aux_sym_else_if_clause_token1] = ACTIONS(1180),
    [aux_sym_else_clause_token1] = ACTIONS(1180),
    [aux_sym_match_expression_token1] = ACTIONS(1180),
    [aux_sym_match_default_expression_token1] = ACTIONS(1180),
    [aux_sym_switch_statement_token1] = ACTIONS(1180),
    [aux_sym_switch_block_token1] = ACTIONS(1180),
    [anon_sym_PLUS] = ACTIONS(1180),
    [anon_sym_DASH] = ACTIONS(1180),
    [anon_sym_TILDE] = ACTIONS(1178),
    [anon_sym_BANG] = ACTIONS(1178),
    [anon_sym_AT] = ACTIONS(1178),
    [aux_sym_clone_expression_token1] = ACTIONS(1180),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1180),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1180),
    [anon_sym_DASH_DASH] = ACTIONS(1178),
    [anon_sym_PLUS_PLUS] = ACTIONS(1178),
    [aux_sym__list_destructing_token1] = ACTIONS(1180),
    [anon_sym_LBRACK] = ACTIONS(1178),
    [anon_sym_self] = ACTIONS(1180),
    [anon_sym_parent] = ACTIONS(1180),
    [aux_sym__argument_name_token1] = ACTIONS(1180),
    [aux_sym__argument_name_token2] = ACTIONS(1180),
    [anon_sym_POUND_LBRACK] = ACTIONS(1178),
    [aux_sym_encapsed_string_token1] = ACTIONS(1178),
    [anon_sym_DQUOTE] = ACTIONS(1178),
    [aux_sym_string_token1] = ACTIONS(1178),
    [anon_sym_SQUOTE] = ACTIONS(1178),
    [anon_sym_LT_LT_LT] = ACTIONS(1178),
    [anon_sym_BQUOTE] = ACTIONS(1178),
    [anon_sym_DOLLAR] = ACTIONS(1178),
    [aux_sym_yield_expression_token1] = ACTIONS(1180),
    [aux_sym_include_expression_token1] = ACTIONS(1180),
    [aux_sym_include_once_expression_token1] = ACTIONS(1180),
    [aux_sym_require_expression_token1] = ACTIONS(1180),
    [aux_sym_require_once_expression_token1] = ACTIONS(1180),
    [sym_comment] = ACTIONS(3),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(1182),
    [sym_name] = ACTIONS(1184),
    [anon_sym_QMARK_GT] = ACTIONS(1182),
    [anon_sym_SEMI] = ACTIONS(1182),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1184),
    [aux_sym_global_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_definition_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1184),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1184),
    [anon_sym_BSLASH] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1182),
    [anon_sym_RBRACE] = ACTIONS(1182),
    [aux_sym_trait_declaration_token1] = ACTIONS(1184),
    [aux_sym_interface_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_declaration_token1] = ACTIONS(1184),
    [aux_sym_enum_case_token1] = ACTIONS(1184),
    [aux_sym_class_declaration_token1] = ACTIONS(1184),
    [aux_sym_final_modifier_token1] = ACTIONS(1184),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1184),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1184),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1184),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1184),
    [anon_sym_LPAREN] = ACTIONS(1182),
    [aux_sym_cast_type_token1] = ACTIONS(1184),
    [aux_sym_echo_statement_token1] = ACTIONS(1184),
    [anon_sym_unset] = ACTIONS(1184),
    [aux_sym_declare_statement_token1] = ACTIONS(1184),
    [aux_sym_declare_statement_token2] = ACTIONS(1184),
    [sym_float] = ACTIONS(1184),
    [aux_sym_try_statement_token1] = ACTIONS(1184),
    [aux_sym_goto_statement_token1] = ACTIONS(1184),
    [aux_sym_continue_statement_token1] = ACTIONS(1184),
    [aux_sym_break_statement_token1] = ACTIONS(1184),
    [sym_integer] = ACTIONS(1184),
    [aux_sym_return_statement_token1] = ACTIONS(1184),
    [aux_sym_throw_expression_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token1] = ACTIONS(1184),
    [aux_sym_while_statement_token2] = ACTIONS(1184),
    [aux_sym_do_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token1] = ACTIONS(1184),
    [aux_sym_for_statement_token2] = ACTIONS(1184),
    [aux_sym_foreach_statement_token1] = ACTIONS(1184),
    [aux_sym_foreach_statement_token2] = ACTIONS(1184),
    [aux_sym_if_statement_token1] = ACTIONS(1184),
    [aux_sym_if_statement_token2] = ACTIONS(1184),
    [aux_sym_else_if_clause_token1] = ACTIONS(1184),
    [aux_sym_else_clause_token1] = ACTIONS(1184),
    [aux_sym_match_expression_token1] = ACTIONS(1184),
    [aux_sym_match_default_expression_token1] = ACTIONS(1184),
    [aux_sym_switch_statement_token1] = ACTIONS(1184),
    [aux_sym_switch_block_token1] = ACTIONS(1184),
    [anon_sym_PLUS] = ACTIONS(1184),
    [anon_sym_DASH] = ACTIONS(1184),
    [anon_sym_TILDE] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1182),
    [anon_sym_AT] = ACTIONS(1182),
    [aux_sym_clone_expression_token1] = ACTIONS(1184),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1184),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1184),
    [anon_sym_DASH_DASH] = ACTIONS(1182),
    [anon_sym_PLUS_PLUS] = ACTIONS(1182),
    [aux_sym__list_destructing_token1] = ACTIONS(1184),
    [anon_sym_LBRACK] = ACTIONS(1182),
    [anon_sym_self] = ACTIONS(1184),
    [anon_sym_parent] = ACTIONS(1184),
    [aux_sym__argument_name_token1] = ACTIONS(1184),
    [aux_sym__argument_name_token2] = ACTIONS(1184),
    [anon_sym_POUND_LBRACK] = ACTIONS(1182),
    [aux_sym_encapsed_string_token1] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1182),
    [aux_sym_string_token1] = ACTIONS(1182),
    [anon_sym_SQUOTE] = ACTIONS(1182),
    [anon_sym_LT_LT_LT] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(1182),
    [anon_sym_DOLLAR] = ACTIONS(1182),
    [aux_sym_yield_expression_token1] = ACTIONS(1184),
    [aux_sym_include_expression_token1] = ACTIONS(1184),
    [aux_sym_include_once_expression_token1] = ACTIONS(1184),
    [aux_sym_require_expression_token1] = ACTIONS(1184),
    [aux_sym_require_once_expression_token1] = ACTIONS(1184),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1186),
    [sym_name] = ACTIONS(1188),
    [anon_sym_QMARK_GT] = ACTIONS(1186),
    [anon_sym_SEMI] = ACTIONS(1186),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1188),
    [aux_sym_global_declaration_token1] = ACTIONS(1188),
    [aux_sym_namespace_definition_token1] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1188),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1188),
    [anon_sym_BSLASH] = ACTIONS(1186),
    [anon_sym_LBRACE] = ACTIONS(1186),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [aux_sym_trait_declaration_token1] = ACTIONS(1188),
    [aux_sym_interface_declaration_token1] = ACTIONS(1188),
    [aux_sym_enum_declaration_token1] = ACTIONS(1188),
    [aux_sym_enum_case_token1] = ACTIONS(1188),
    [aux_sym_class_declaration_token1] = ACTIONS(1188),
    [aux_sym_final_modifier_token1] = ACTIONS(1188),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1188),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1188),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1188),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1186),
    [aux_sym_cast_type_token1] = ACTIONS(1188),
    [aux_sym_echo_statement_token1] = ACTIONS(1188),
    [anon_sym_unset] = ACTIONS(1188),
    [aux_sym_declare_statement_token1] = ACTIONS(1188),
    [aux_sym_declare_statement_token2] = ACTIONS(1188),
    [sym_float] = ACTIONS(1188),
    [aux_sym_try_statement_token1] = ACTIONS(1188),
    [aux_sym_goto_statement_token1] = ACTIONS(1188),
    [aux_sym_continue_statement_token1] = ACTIONS(1188),
    [aux_sym_break_statement_token1] = ACTIONS(1188),
    [sym_integer] = ACTIONS(1188),
    [aux_sym_return_statement_token1] = ACTIONS(1188),
    [aux_sym_throw_expression_token1] = ACTIONS(1188),
    [aux_sym_while_statement_token1] = ACTIONS(1188),
    [aux_sym_while_statement_token2] = ACTIONS(1188),
    [aux_sym_do_statement_token1] = ACTIONS(1188),
    [aux_sym_for_statement_token1] = ACTIONS(1188),
    [aux_sym_for_statement_token2] = ACTIONS(1188),
    [aux_sym_foreach_statement_token1] = ACTIONS(1188),
    [aux_sym_foreach_statement_token2] = ACTIONS(1188),
    [aux_sym_if_statement_token1] = ACTIONS(1188),
    [aux_sym_if_statement_token2] = ACTIONS(1188),
    [aux_sym_else_if_clause_token1] = ACTIONS(1188),
    [aux_sym_else_clause_token1] = ACTIONS(1188),
    [aux_sym_match_expression_token1] = ACTIONS(1188),
    [aux_sym_match_default_expression_token1] = ACTIONS(1188),
    [aux_sym_switch_statement_token1] = ACTIONS(1188),
    [aux_sym_switch_block_token1] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1186),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_AT] = ACTIONS(1186),
    [aux_sym_clone_expression_token1] = ACTIONS(1188),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1188),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1188),
    [anon_sym_DASH_DASH] = ACTIONS(1186),
    [anon_sym_PLUS_PLUS] = ACTIONS(1186),
    [aux_sym__list_destructing_token1] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1186),
    [anon_sym_self] = ACTIONS(1188),
    [anon_sym_parent] = ACTIONS(1188),
    [aux_sym__argument_name_token1] = ACTIONS(1188),
    [aux_sym__argument_name_token2] = ACTIONS(1188),
    [anon_sym_POUND_LBRACK] = ACTIONS(1186),
    [aux_sym_encapsed_string_token1] = ACTIONS(1186),
    [anon_sym_DQUOTE] = ACTIONS(1186),
    [aux_sym_string_token1] = ACTIONS(1186),
    [anon_sym_SQUOTE] = ACTIONS(1186),
    [anon_sym_LT_LT_LT] = ACTIONS(1186),
    [anon_sym_BQUOTE] = ACTIONS(1186),
    [anon_sym_DOLLAR] = ACTIONS(1186),
    [aux_sym_yield_expression_token1] = ACTIONS(1188),
    [aux_sym_include_expression_token1] = ACTIONS(1188),
    [aux_sym_include_once_expression_token1] = ACTIONS(1188),
    [aux_sym_require_expression_token1] = ACTIONS(1188),
    [aux_sym_require_once_expression_token1] = ACTIONS(1188),
    [sym_comment] = ACTIONS(3),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_name] = ACTIONS(1192),
    [anon_sym_QMARK_GT] = ACTIONS(1190),
    [anon_sym_SEMI] = ACTIONS(1190),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1192),
    [aux_sym_global_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_definition_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1192),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1192),
    [anon_sym_BSLASH] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [aux_sym_trait_declaration_token1] = ACTIONS(1192),
    [aux_sym_interface_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_declaration_token1] = ACTIONS(1192),
    [aux_sym_enum_case_token1] = ACTIONS(1192),
    [aux_sym_class_declaration_token1] = ACTIONS(1192),
    [aux_sym_final_modifier_token1] = ACTIONS(1192),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1192),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1192),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1192),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [aux_sym_cast_type_token1] = ACTIONS(1192),
    [aux_sym_echo_statement_token1] = ACTIONS(1192),
    [anon_sym_unset] = ACTIONS(1192),
    [aux_sym_declare_statement_token1] = ACTIONS(1192),
    [aux_sym_declare_statement_token2] = ACTIONS(1192),
    [sym_float] = ACTIONS(1192),
    [aux_sym_try_statement_token1] = ACTIONS(1192),
    [aux_sym_goto_statement_token1] = ACTIONS(1192),
    [aux_sym_continue_statement_token1] = ACTIONS(1192),
    [aux_sym_break_statement_token1] = ACTIONS(1192),
    [sym_integer] = ACTIONS(1192),
    [aux_sym_return_statement_token1] = ACTIONS(1192),
    [aux_sym_throw_expression_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token1] = ACTIONS(1192),
    [aux_sym_while_statement_token2] = ACTIONS(1192),
    [aux_sym_do_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token1] = ACTIONS(1192),
    [aux_sym_for_statement_token2] = ACTIONS(1192),
    [aux_sym_foreach_statement_token1] = ACTIONS(1192),
    [aux_sym_foreach_statement_token2] = ACTIONS(1192),
    [aux_sym_if_statement_token1] = ACTIONS(1192),
    [aux_sym_if_statement_token2] = ACTIONS(1192),
    [aux_sym_else_if_clause_token1] = ACTIONS(1192),
    [aux_sym_else_clause_token1] = ACTIONS(1192),
    [aux_sym_match_expression_token1] = ACTIONS(1192),
    [aux_sym_match_default_expression_token1] = ACTIONS(1192),
    [aux_sym_switch_statement_token1] = ACTIONS(1192),
    [aux_sym_switch_block_token1] = ACTIONS(1192),
    [anon_sym_PLUS] = ACTIONS(1192),
    [anon_sym_DASH] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1190),
    [aux_sym_clone_expression_token1] = ACTIONS(1192),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1192),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1192),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [aux_sym__list_destructing_token1] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_self] = ACTIONS(1192),
    [anon_sym_parent] = ACTIONS(1192),
    [aux_sym__argument_name_token1] = ACTIONS(1192),
    [aux_sym__argument_name_token2] = ACTIONS(1192),
    [anon_sym_POUND_LBRACK] = ACTIONS(1190),
    [aux_sym_encapsed_string_token1] = ACTIONS(1190),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [aux_sym_string_token1] = ACTIONS(1190),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_LT_LT_LT] = ACTIONS(1190),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [anon_sym_DOLLAR] = ACTIONS(1190),
    [aux_sym_yield_expression_token1] = ACTIONS(1192),
    [aux_sym_include_expression_token1] = ACTIONS(1192),
    [aux_sym_include_once_expression_token1] = ACTIONS(1192),
    [aux_sym_require_expression_token1] = ACTIONS(1192),
    [aux_sym_require_once_expression_token1] = ACTIONS(1192),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(1194),
    [sym_name] = ACTIONS(1196),
    [anon_sym_QMARK_GT] = ACTIONS(1194),
    [anon_sym_SEMI] = ACTIONS(1194),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1196),
    [aux_sym_global_declaration_token1] = ACTIONS(1196),
    [aux_sym_namespace_definition_token1] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1196),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1194),
    [anon_sym_LBRACE] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [aux_sym_trait_declaration_token1] = ACTIONS(1196),
    [aux_sym_interface_declaration_token1] = ACTIONS(1196),
    [aux_sym_enum_declaration_token1] = ACTIONS(1196),
    [aux_sym_enum_case_token1] = ACTIONS(1196),
    [aux_sym_class_declaration_token1] = ACTIONS(1196),
    [aux_sym_final_modifier_token1] = ACTIONS(1196),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1196),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1196),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1196),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1196),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [aux_sym_cast_type_token1] = ACTIONS(1196),
    [aux_sym_echo_statement_token1] = ACTIONS(1196),
    [anon_sym_unset] = ACTIONS(1196),
    [aux_sym_declare_statement_token1] = ACTIONS(1196),
    [aux_sym_declare_statement_token2] = ACTIONS(1196),
    [sym_float] = ACTIONS(1196),
    [aux_sym_try_statement_token1] = ACTIONS(1196),
    [aux_sym_goto_statement_token1] = ACTIONS(1196),
    [aux_sym_continue_statement_token1] = ACTIONS(1196),
    [aux_sym_break_statement_token1] = ACTIONS(1196),
    [sym_integer] = ACTIONS(1196),
    [aux_sym_return_statement_token1] = ACTIONS(1196),
    [aux_sym_throw_expression_token1] = ACTIONS(1196),
    [aux_sym_while_statement_token1] = ACTIONS(1196),
    [aux_sym_while_statement_token2] = ACTIONS(1196),
    [aux_sym_do_statement_token1] = ACTIONS(1196),
    [aux_sym_for_statement_token1] = ACTIONS(1196),
    [aux_sym_for_statement_token2] = ACTIONS(1196),
    [aux_sym_foreach_statement_token1] = ACTIONS(1196),
    [aux_sym_foreach_statement_token2] = ACTIONS(1196),
    [aux_sym_if_statement_token1] = ACTIONS(1196),
    [aux_sym_if_statement_token2] = ACTIONS(1196),
    [aux_sym_else_if_clause_token1] = ACTIONS(1196),
    [aux_sym_else_clause_token1] = ACTIONS(1196),
    [aux_sym_match_expression_token1] = ACTIONS(1196),
    [aux_sym_match_default_expression_token1] = ACTIONS(1196),
    [aux_sym_switch_statement_token1] = ACTIONS(1196),
    [aux_sym_switch_block_token1] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_TILDE] = ACTIONS(1194),
    [anon_sym_BANG] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1194),
    [aux_sym_clone_expression_token1] = ACTIONS(1196),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1196),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1196),
    [anon_sym_DASH_DASH] = ACTIONS(1194),
    [anon_sym_PLUS_PLUS] = ACTIONS(1194),
    [aux_sym__list_destructing_token1] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1194),
    [anon_sym_self] = ACTIONS(1196),
    [anon_sym_parent] = ACTIONS(1196),
    [aux_sym__argument_name_token1] = ACTIONS(1196),
    [aux_sym__argument_name_token2] = ACTIONS(1196),
    [anon_sym_POUND_LBRACK] = ACTIONS(1194),
    [aux_sym_encapsed_string_token1] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [aux_sym_string_token1] = ACTIONS(1194),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [anon_sym_LT_LT_LT] = ACTIONS(1194),
    [anon_sym_BQUOTE] = ACTIONS(1194),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [aux_sym_yield_expression_token1] = ACTIONS(1196),
    [aux_sym_include_expression_token1] = ACTIONS(1196),
    [aux_sym_include_once_expression_token1] = ACTIONS(1196),
    [aux_sym_require_expression_token1] = ACTIONS(1196),
    [aux_sym_require_once_expression_token1] = ACTIONS(1196),
    [sym_comment] = ACTIONS(3),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(1198),
    [sym_name] = ACTIONS(1200),
    [anon_sym_QMARK_GT] = ACTIONS(1198),
    [anon_sym_SEMI] = ACTIONS(1198),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1200),
    [aux_sym_global_declaration_token1] = ACTIONS(1200),
    [aux_sym_namespace_definition_token1] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1200),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1200),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [aux_sym_trait_declaration_token1] = ACTIONS(1200),
    [aux_sym_interface_declaration_token1] = ACTIONS(1200),
    [aux_sym_enum_declaration_token1] = ACTIONS(1200),
    [aux_sym_enum_case_token1] = ACTIONS(1200),
    [aux_sym_class_declaration_token1] = ACTIONS(1200),
    [aux_sym_final_modifier_token1] = ACTIONS(1200),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1200),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1200),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1200),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [aux_sym_cast_type_token1] = ACTIONS(1200),
    [aux_sym_echo_statement_token1] = ACTIONS(1200),
    [anon_sym_unset] = ACTIONS(1200),
    [aux_sym_declare_statement_token1] = ACTIONS(1200),
    [aux_sym_declare_statement_token2] = ACTIONS(1200),
    [sym_float] = ACTIONS(1200),
    [aux_sym_try_statement_token1] = ACTIONS(1200),
    [aux_sym_goto_statement_token1] = ACTIONS(1200),
    [aux_sym_continue_statement_token1] = ACTIONS(1200),
    [aux_sym_break_statement_token1] = ACTIONS(1200),
    [sym_integer] = ACTIONS(1200),
    [aux_sym_return_statement_token1] = ACTIONS(1200),
    [aux_sym_throw_expression_token1] = ACTIONS(1200),
    [aux_sym_while_statement_token1] = ACTIONS(1200),
    [aux_sym_while_statement_token2] = ACTIONS(1200),
    [aux_sym_do_statement_token1] = ACTIONS(1200),
    [aux_sym_for_statement_token1] = ACTIONS(1200),
    [aux_sym_for_statement_token2] = ACTIONS(1200),
    [aux_sym_foreach_statement_token1] = ACTIONS(1200),
    [aux_sym_foreach_statement_token2] = ACTIONS(1200),
    [aux_sym_if_statement_token1] = ACTIONS(1200),
    [aux_sym_if_statement_token2] = ACTIONS(1200),
    [aux_sym_else_if_clause_token1] = ACTIONS(1200),
    [aux_sym_else_clause_token1] = ACTIONS(1200),
    [aux_sym_match_expression_token1] = ACTIONS(1200),
    [aux_sym_match_default_expression_token1] = ACTIONS(1200),
    [aux_sym_switch_statement_token1] = ACTIONS(1200),
    [aux_sym_switch_block_token1] = ACTIONS(1200),
    [anon_sym_PLUS] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_BANG] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1198),
    [aux_sym_clone_expression_token1] = ACTIONS(1200),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1200),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1200),
    [anon_sym_DASH_DASH] = ACTIONS(1198),
    [anon_sym_PLUS_PLUS] = ACTIONS(1198),
    [aux_sym__list_destructing_token1] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_self] = ACTIONS(1200),
    [anon_sym_parent] = ACTIONS(1200),
    [aux_sym__argument_name_token1] = ACTIONS(1200),
    [aux_sym__argument_name_token2] = ACTIONS(1200),
    [anon_sym_POUND_LBRACK] = ACTIONS(1198),
    [aux_sym_encapsed_string_token1] = ACTIONS(1198),
    [anon_sym_DQUOTE] = ACTIONS(1198),
    [aux_sym_string_token1] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1198),
    [anon_sym_LT_LT_LT] = ACTIONS(1198),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [anon_sym_DOLLAR] = ACTIONS(1198),
    [aux_sym_yield_expression_token1] = ACTIONS(1200),
    [aux_sym_include_expression_token1] = ACTIONS(1200),
    [aux_sym_include_once_expression_token1] = ACTIONS(1200),
    [aux_sym_require_expression_token1] = ACTIONS(1200),
    [aux_sym_require_once_expression_token1] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1202),
    [sym_name] = ACTIONS(1204),
    [anon_sym_QMARK_GT] = ACTIONS(1202),
    [anon_sym_SEMI] = ACTIONS(1202),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1204),
    [aux_sym_global_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_definition_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1204),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1204),
    [anon_sym_BSLASH] = ACTIONS(1202),
    [anon_sym_LBRACE] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [aux_sym_trait_declaration_token1] = ACTIONS(1204),
    [aux_sym_interface_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_declaration_token1] = ACTIONS(1204),
    [aux_sym_enum_case_token1] = ACTIONS(1204),
    [aux_sym_class_declaration_token1] = ACTIONS(1204),
    [aux_sym_final_modifier_token1] = ACTIONS(1204),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1204),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1204),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1204),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1202),
    [aux_sym_cast_type_token1] = ACTIONS(1204),
    [aux_sym_echo_statement_token1] = ACTIONS(1204),
    [anon_sym_unset] = ACTIONS(1204),
    [aux_sym_declare_statement_token1] = ACTIONS(1204),
    [aux_sym_declare_statement_token2] = ACTIONS(1204),
    [sym_float] = ACTIONS(1204),
    [aux_sym_try_statement_token1] = ACTIONS(1204),
    [aux_sym_goto_statement_token1] = ACTIONS(1204),
    [aux_sym_continue_statement_token1] = ACTIONS(1204),
    [aux_sym_break_statement_token1] = ACTIONS(1204),
    [sym_integer] = ACTIONS(1204),
    [aux_sym_return_statement_token1] = ACTIONS(1204),
    [aux_sym_throw_expression_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token1] = ACTIONS(1204),
    [aux_sym_while_statement_token2] = ACTIONS(1204),
    [aux_sym_do_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token1] = ACTIONS(1204),
    [aux_sym_for_statement_token2] = ACTIONS(1204),
    [aux_sym_foreach_statement_token1] = ACTIONS(1204),
    [aux_sym_foreach_statement_token2] = ACTIONS(1204),
    [aux_sym_if_statement_token1] = ACTIONS(1204),
    [aux_sym_if_statement_token2] = ACTIONS(1204),
    [aux_sym_else_if_clause_token1] = ACTIONS(1204),
    [aux_sym_else_clause_token1] = ACTIONS(1204),
    [aux_sym_match_expression_token1] = ACTIONS(1204),
    [aux_sym_match_default_expression_token1] = ACTIONS(1204),
    [aux_sym_switch_statement_token1] = ACTIONS(1204),
    [aux_sym_switch_block_token1] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1202),
    [anon_sym_BANG] = ACTIONS(1202),
    [anon_sym_AT] = ACTIONS(1202),
    [aux_sym_clone_expression_token1] = ACTIONS(1204),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1204),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1204),
    [anon_sym_DASH_DASH] = ACTIONS(1202),
    [anon_sym_PLUS_PLUS] = ACTIONS(1202),
    [aux_sym__list_destructing_token1] = ACTIONS(1204),
    [anon_sym_LBRACK] = ACTIONS(1202),
    [anon_sym_self] = ACTIONS(1204),
    [anon_sym_parent] = ACTIONS(1204),
    [aux_sym__argument_name_token1] = ACTIONS(1204),
    [aux_sym__argument_name_token2] = ACTIONS(1204),
    [anon_sym_POUND_LBRACK] = ACTIONS(1202),
    [aux_sym_encapsed_string_token1] = ACTIONS(1202),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [aux_sym_string_token1] = ACTIONS(1202),
    [anon_sym_SQUOTE] = ACTIONS(1202),
    [anon_sym_LT_LT_LT] = ACTIONS(1202),
    [anon_sym_BQUOTE] = ACTIONS(1202),
    [anon_sym_DOLLAR] = ACTIONS(1202),
    [aux_sym_yield_expression_token1] = ACTIONS(1204),
    [aux_sym_include_expression_token1] = ACTIONS(1204),
    [aux_sym_include_once_expression_token1] = ACTIONS(1204),
    [aux_sym_require_expression_token1] = ACTIONS(1204),
    [aux_sym_require_once_expression_token1] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(1206),
    [sym_name] = ACTIONS(1208),
    [anon_sym_QMARK_GT] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1206),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1208),
    [aux_sym_global_declaration_token1] = ACTIONS(1208),
    [aux_sym_namespace_definition_token1] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1208),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1208),
    [anon_sym_BSLASH] = ACTIONS(1206),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [aux_sym_trait_declaration_token1] = ACTIONS(1208),
    [aux_sym_interface_declaration_token1] = ACTIONS(1208),
    [aux_sym_enum_declaration_token1] = ACTIONS(1208),
    [aux_sym_enum_case_token1] = ACTIONS(1208),
    [aux_sym_class_declaration_token1] = ACTIONS(1208),
    [aux_sym_final_modifier_token1] = ACTIONS(1208),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1208),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1208),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1208),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1208),
    [anon_sym_LPAREN] = ACTIONS(1206),
    [aux_sym_cast_type_token1] = ACTIONS(1208),
    [aux_sym_echo_statement_token1] = ACTIONS(1208),
    [anon_sym_unset] = ACTIONS(1208),
    [aux_sym_declare_statement_token1] = ACTIONS(1208),
    [aux_sym_declare_statement_token2] = ACTIONS(1208),
    [sym_float] = ACTIONS(1208),
    [aux_sym_try_statement_token1] = ACTIONS(1208),
    [aux_sym_goto_statement_token1] = ACTIONS(1208),
    [aux_sym_continue_statement_token1] = ACTIONS(1208),
    [aux_sym_break_statement_token1] = ACTIONS(1208),
    [sym_integer] = ACTIONS(1208),
    [aux_sym_return_statement_token1] = ACTIONS(1208),
    [aux_sym_throw_expression_token1] = ACTIONS(1208),
    [aux_sym_while_statement_token1] = ACTIONS(1208),
    [aux_sym_while_statement_token2] = ACTIONS(1208),
    [aux_sym_do_statement_token1] = ACTIONS(1208),
    [aux_sym_for_statement_token1] = ACTIONS(1208),
    [aux_sym_for_statement_token2] = ACTIONS(1208),
    [aux_sym_foreach_statement_token1] = ACTIONS(1208),
    [aux_sym_foreach_statement_token2] = ACTIONS(1208),
    [aux_sym_if_statement_token1] = ACTIONS(1208),
    [aux_sym_if_statement_token2] = ACTIONS(1208),
    [aux_sym_else_if_clause_token1] = ACTIONS(1208),
    [aux_sym_else_clause_token1] = ACTIONS(1208),
    [aux_sym_match_expression_token1] = ACTIONS(1208),
    [aux_sym_match_default_expression_token1] = ACTIONS(1208),
    [aux_sym_switch_statement_token1] = ACTIONS(1208),
    [aux_sym_switch_block_token1] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_TILDE] = ACTIONS(1206),
    [anon_sym_BANG] = ACTIONS(1206),
    [anon_sym_AT] = ACTIONS(1206),
    [aux_sym_clone_expression_token1] = ACTIONS(1208),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1208),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1208),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [aux_sym__list_destructing_token1] = ACTIONS(1208),
    [anon_sym_LBRACK] = ACTIONS(1206),
    [anon_sym_self] = ACTIONS(1208),
    [anon_sym_parent] = ACTIONS(1208),
    [aux_sym__argument_name_token1] = ACTIONS(1208),
    [aux_sym__argument_name_token2] = ACTIONS(1208),
    [anon_sym_POUND_LBRACK] = ACTIONS(1206),
    [aux_sym_encapsed_string_token1] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [aux_sym_string_token1] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1206),
    [anon_sym_LT_LT_LT] = ACTIONS(1206),
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [anon_sym_DOLLAR] = ACTIONS(1206),
    [aux_sym_yield_expression_token1] = ACTIONS(1208),
    [aux_sym_include_expression_token1] = ACTIONS(1208),
    [aux_sym_include_once_expression_token1] = ACTIONS(1208),
    [aux_sym_require_expression_token1] = ACTIONS(1208),
    [aux_sym_require_once_expression_token1] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1170),
    [sym_name] = ACTIONS(1172),
    [anon_sym_QMARK_GT] = ACTIONS(1170),
    [anon_sym_SEMI] = ACTIONS(1170),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1172),
    [aux_sym_global_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_definition_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1172),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1172),
    [anon_sym_BSLASH] = ACTIONS(1170),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [aux_sym_trait_declaration_token1] = ACTIONS(1172),
    [aux_sym_interface_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_declaration_token1] = ACTIONS(1172),
    [aux_sym_enum_case_token1] = ACTIONS(1172),
    [aux_sym_class_declaration_token1] = ACTIONS(1172),
    [aux_sym_final_modifier_token1] = ACTIONS(1172),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1172),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1172),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1172),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(1170),
    [aux_sym_cast_type_token1] = ACTIONS(1172),
    [aux_sym_echo_statement_token1] = ACTIONS(1172),
    [anon_sym_unset] = ACTIONS(1172),
    [aux_sym_declare_statement_token1] = ACTIONS(1172),
    [aux_sym_declare_statement_token2] = ACTIONS(1172),
    [sym_float] = ACTIONS(1172),
    [aux_sym_try_statement_token1] = ACTIONS(1172),
    [aux_sym_goto_statement_token1] = ACTIONS(1172),
    [aux_sym_continue_statement_token1] = ACTIONS(1172),
    [aux_sym_break_statement_token1] = ACTIONS(1172),
    [sym_integer] = ACTIONS(1172),
    [aux_sym_return_statement_token1] = ACTIONS(1172),
    [aux_sym_throw_expression_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token1] = ACTIONS(1172),
    [aux_sym_while_statement_token2] = ACTIONS(1172),
    [aux_sym_do_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token1] = ACTIONS(1172),
    [aux_sym_for_statement_token2] = ACTIONS(1172),
    [aux_sym_foreach_statement_token1] = ACTIONS(1172),
    [aux_sym_foreach_statement_token2] = ACTIONS(1172),
    [aux_sym_if_statement_token1] = ACTIONS(1172),
    [aux_sym_if_statement_token2] = ACTIONS(1172),
    [aux_sym_else_if_clause_token1] = ACTIONS(1172),
    [aux_sym_else_clause_token1] = ACTIONS(1172),
    [aux_sym_match_expression_token1] = ACTIONS(1172),
    [aux_sym_match_default_expression_token1] = ACTIONS(1172),
    [aux_sym_switch_statement_token1] = ACTIONS(1172),
    [aux_sym_switch_block_token1] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_TILDE] = ACTIONS(1170),
    [anon_sym_BANG] = ACTIONS(1170),
    [anon_sym_AT] = ACTIONS(1170),
    [aux_sym_clone_expression_token1] = ACTIONS(1172),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1172),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1172),
    [anon_sym_DASH_DASH] = ACTIONS(1170),
    [anon_sym_PLUS_PLUS] = ACTIONS(1170),
    [aux_sym__list_destructing_token1] = ACTIONS(1172),
    [anon_sym_LBRACK] = ACTIONS(1170),
    [anon_sym_self] = ACTIONS(1172),
    [anon_sym_parent] = ACTIONS(1172),
    [aux_sym__argument_name_token1] = ACTIONS(1172),
    [aux_sym__argument_name_token2] = ACTIONS(1172),
    [anon_sym_POUND_LBRACK] = ACTIONS(1170),
    [aux_sym_encapsed_string_token1] = ACTIONS(1170),
    [anon_sym_DQUOTE] = ACTIONS(1170),
    [aux_sym_string_token1] = ACTIONS(1170),
    [anon_sym_SQUOTE] = ACTIONS(1170),
    [anon_sym_LT_LT_LT] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1170),
    [anon_sym_DOLLAR] = ACTIONS(1170),
    [aux_sym_yield_expression_token1] = ACTIONS(1172),
    [aux_sym_include_expression_token1] = ACTIONS(1172),
    [aux_sym_include_once_expression_token1] = ACTIONS(1172),
    [aux_sym_require_expression_token1] = ACTIONS(1172),
    [aux_sym_require_once_expression_token1] = ACTIONS(1172),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(1210),
    [sym_name] = ACTIONS(1212),
    [anon_sym_QMARK_GT] = ACTIONS(1210),
    [anon_sym_SEMI] = ACTIONS(1210),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1212),
    [aux_sym_global_declaration_token1] = ACTIONS(1212),
    [aux_sym_namespace_definition_token1] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1212),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1212),
    [anon_sym_BSLASH] = ACTIONS(1210),
    [anon_sym_LBRACE] = ACTIONS(1210),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [aux_sym_trait_declaration_token1] = ACTIONS(1212),
    [aux_sym_interface_declaration_token1] = ACTIONS(1212),
    [aux_sym_enum_declaration_token1] = ACTIONS(1212),
    [aux_sym_enum_case_token1] = ACTIONS(1212),
    [aux_sym_class_declaration_token1] = ACTIONS(1212),
    [aux_sym_final_modifier_token1] = ACTIONS(1212),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1212),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1212),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1212),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1210),
    [aux_sym_cast_type_token1] = ACTIONS(1212),
    [aux_sym_echo_statement_token1] = ACTIONS(1212),
    [anon_sym_unset] = ACTIONS(1212),
    [aux_sym_declare_statement_token1] = ACTIONS(1212),
    [aux_sym_declare_statement_token2] = ACTIONS(1212),
    [sym_float] = ACTIONS(1212),
    [aux_sym_try_statement_token1] = ACTIONS(1212),
    [aux_sym_goto_statement_token1] = ACTIONS(1212),
    [aux_sym_continue_statement_token1] = ACTIONS(1212),
    [aux_sym_break_statement_token1] = ACTIONS(1212),
    [sym_integer] = ACTIONS(1212),
    [aux_sym_return_statement_token1] = ACTIONS(1212),
    [aux_sym_throw_expression_token1] = ACTIONS(1212),
    [aux_sym_while_statement_token1] = ACTIONS(1212),
    [aux_sym_while_statement_token2] = ACTIONS(1212),
    [aux_sym_do_statement_token1] = ACTIONS(1212),
    [aux_sym_for_statement_token1] = ACTIONS(1212),
    [aux_sym_for_statement_token2] = ACTIONS(1212),
    [aux_sym_foreach_statement_token1] = ACTIONS(1212),
    [aux_sym_foreach_statement_token2] = ACTIONS(1212),
    [aux_sym_if_statement_token1] = ACTIONS(1212),
    [aux_sym_if_statement_token2] = ACTIONS(1212),
    [aux_sym_else_if_clause_token1] = ACTIONS(1212),
    [aux_sym_else_clause_token1] = ACTIONS(1212),
    [aux_sym_match_expression_token1] = ACTIONS(1212),
    [aux_sym_match_default_expression_token1] = ACTIONS(1212),
    [aux_sym_switch_statement_token1] = ACTIONS(1212),
    [aux_sym_switch_block_token1] = ACTIONS(1212),
    [anon_sym_PLUS] = ACTIONS(1212),
    [anon_sym_DASH] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1210),
    [anon_sym_BANG] = ACTIONS(1210),
    [anon_sym_AT] = ACTIONS(1210),
    [aux_sym_clone_expression_token1] = ACTIONS(1212),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1212),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1212),
    [anon_sym_DASH_DASH] = ACTIONS(1210),
    [anon_sym_PLUS_PLUS] = ACTIONS(1210),
    [aux_sym__list_destructing_token1] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1210),
    [anon_sym_self] = ACTIONS(1212),
    [anon_sym_parent] = ACTIONS(1212),
    [aux_sym__argument_name_token1] = ACTIONS(1212),
    [aux_sym__argument_name_token2] = ACTIONS(1212),
    [anon_sym_POUND_LBRACK] = ACTIONS(1210),
    [aux_sym_encapsed_string_token1] = ACTIONS(1210),
    [anon_sym_DQUOTE] = ACTIONS(1210),
    [aux_sym_string_token1] = ACTIONS(1210),
    [anon_sym_SQUOTE] = ACTIONS(1210),
    [anon_sym_LT_LT_LT] = ACTIONS(1210),
    [anon_sym_BQUOTE] = ACTIONS(1210),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [aux_sym_yield_expression_token1] = ACTIONS(1212),
    [aux_sym_include_expression_token1] = ACTIONS(1212),
    [aux_sym_include_once_expression_token1] = ACTIONS(1212),
    [aux_sym_require_expression_token1] = ACTIONS(1212),
    [aux_sym_require_once_expression_token1] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1214),
    [sym_name] = ACTIONS(1216),
    [anon_sym_QMARK_GT] = ACTIONS(1214),
    [anon_sym_SEMI] = ACTIONS(1214),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1216),
    [aux_sym_global_declaration_token1] = ACTIONS(1216),
    [aux_sym_namespace_definition_token1] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1216),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1216),
    [anon_sym_BSLASH] = ACTIONS(1214),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_RBRACE] = ACTIONS(1214),
    [aux_sym_trait_declaration_token1] = ACTIONS(1216),
    [aux_sym_interface_declaration_token1] = ACTIONS(1216),
    [aux_sym_enum_declaration_token1] = ACTIONS(1216),
    [aux_sym_enum_case_token1] = ACTIONS(1216),
    [aux_sym_class_declaration_token1] = ACTIONS(1216),
    [aux_sym_final_modifier_token1] = ACTIONS(1216),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1216),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1216),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1216),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [aux_sym_cast_type_token1] = ACTIONS(1216),
    [aux_sym_echo_statement_token1] = ACTIONS(1216),
    [anon_sym_unset] = ACTIONS(1216),
    [aux_sym_declare_statement_token1] = ACTIONS(1216),
    [aux_sym_declare_statement_token2] = ACTIONS(1216),
    [sym_float] = ACTIONS(1216),
    [aux_sym_try_statement_token1] = ACTIONS(1216),
    [aux_sym_goto_statement_token1] = ACTIONS(1216),
    [aux_sym_continue_statement_token1] = ACTIONS(1216),
    [aux_sym_break_statement_token1] = ACTIONS(1216),
    [sym_integer] = ACTIONS(1216),
    [aux_sym_return_statement_token1] = ACTIONS(1216),
    [aux_sym_throw_expression_token1] = ACTIONS(1216),
    [aux_sym_while_statement_token1] = ACTIONS(1216),
    [aux_sym_while_statement_token2] = ACTIONS(1216),
    [aux_sym_do_statement_token1] = ACTIONS(1216),
    [aux_sym_for_statement_token1] = ACTIONS(1216),
    [aux_sym_for_statement_token2] = ACTIONS(1216),
    [aux_sym_foreach_statement_token1] = ACTIONS(1216),
    [aux_sym_foreach_statement_token2] = ACTIONS(1216),
    [aux_sym_if_statement_token1] = ACTIONS(1216),
    [aux_sym_if_statement_token2] = ACTIONS(1216),
    [aux_sym_else_if_clause_token1] = ACTIONS(1216),
    [aux_sym_else_clause_token1] = ACTIONS(1216),
    [aux_sym_match_expression_token1] = ACTIONS(1216),
    [aux_sym_match_default_expression_token1] = ACTIONS(1216),
    [aux_sym_switch_statement_token1] = ACTIONS(1216),
    [aux_sym_switch_block_token1] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_BANG] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1214),
    [aux_sym_clone_expression_token1] = ACTIONS(1216),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1216),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1216),
    [anon_sym_DASH_DASH] = ACTIONS(1214),
    [anon_sym_PLUS_PLUS] = ACTIONS(1214),
    [aux_sym__list_destructing_token1] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_self] = ACTIONS(1216),
    [anon_sym_parent] = ACTIONS(1216),
    [aux_sym__argument_name_token1] = ACTIONS(1216),
    [aux_sym__argument_name_token2] = ACTIONS(1216),
    [anon_sym_POUND_LBRACK] = ACTIONS(1214),
    [aux_sym_encapsed_string_token1] = ACTIONS(1214),
    [anon_sym_DQUOTE] = ACTIONS(1214),
    [aux_sym_string_token1] = ACTIONS(1214),
    [anon_sym_SQUOTE] = ACTIONS(1214),
    [anon_sym_LT_LT_LT] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1214),
    [anon_sym_DOLLAR] = ACTIONS(1214),
    [aux_sym_yield_expression_token1] = ACTIONS(1216),
    [aux_sym_include_expression_token1] = ACTIONS(1216),
    [aux_sym_include_once_expression_token1] = ACTIONS(1216),
    [aux_sym_require_expression_token1] = ACTIONS(1216),
    [aux_sym_require_once_expression_token1] = ACTIONS(1216),
    [sym_comment] = ACTIONS(3),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(1218),
    [sym_name] = ACTIONS(1220),
    [anon_sym_QMARK_GT] = ACTIONS(1218),
    [anon_sym_SEMI] = ACTIONS(1218),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1220),
    [aux_sym_global_declaration_token1] = ACTIONS(1220),
    [aux_sym_namespace_definition_token1] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1220),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1220),
    [anon_sym_BSLASH] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1218),
    [anon_sym_RBRACE] = ACTIONS(1218),
    [aux_sym_trait_declaration_token1] = ACTIONS(1220),
    [aux_sym_interface_declaration_token1] = ACTIONS(1220),
    [aux_sym_enum_declaration_token1] = ACTIONS(1220),
    [aux_sym_enum_case_token1] = ACTIONS(1220),
    [aux_sym_class_declaration_token1] = ACTIONS(1220),
    [aux_sym_final_modifier_token1] = ACTIONS(1220),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1220),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1220),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1220),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1218),
    [aux_sym_cast_type_token1] = ACTIONS(1220),
    [aux_sym_echo_statement_token1] = ACTIONS(1220),
    [anon_sym_unset] = ACTIONS(1220),
    [aux_sym_declare_statement_token1] = ACTIONS(1220),
    [aux_sym_declare_statement_token2] = ACTIONS(1220),
    [sym_float] = ACTIONS(1220),
    [aux_sym_try_statement_token1] = ACTIONS(1220),
    [aux_sym_goto_statement_token1] = ACTIONS(1220),
    [aux_sym_continue_statement_token1] = ACTIONS(1220),
    [aux_sym_break_statement_token1] = ACTIONS(1220),
    [sym_integer] = ACTIONS(1220),
    [aux_sym_return_statement_token1] = ACTIONS(1220),
    [aux_sym_throw_expression_token1] = ACTIONS(1220),
    [aux_sym_while_statement_token1] = ACTIONS(1220),
    [aux_sym_while_statement_token2] = ACTIONS(1220),
    [aux_sym_do_statement_token1] = ACTIONS(1220),
    [aux_sym_for_statement_token1] = ACTIONS(1220),
    [aux_sym_for_statement_token2] = ACTIONS(1220),
    [aux_sym_foreach_statement_token1] = ACTIONS(1220),
    [aux_sym_foreach_statement_token2] = ACTIONS(1220),
    [aux_sym_if_statement_token1] = ACTIONS(1220),
    [aux_sym_if_statement_token2] = ACTIONS(1220),
    [aux_sym_else_if_clause_token1] = ACTIONS(1220),
    [aux_sym_else_clause_token1] = ACTIONS(1220),
    [aux_sym_match_expression_token1] = ACTIONS(1220),
    [aux_sym_match_default_expression_token1] = ACTIONS(1220),
    [aux_sym_switch_statement_token1] = ACTIONS(1220),
    [aux_sym_switch_block_token1] = ACTIONS(1220),
    [anon_sym_PLUS] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1218),
    [aux_sym_clone_expression_token1] = ACTIONS(1220),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1220),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1220),
    [anon_sym_DASH_DASH] = ACTIONS(1218),
    [anon_sym_PLUS_PLUS] = ACTIONS(1218),
    [aux_sym__list_destructing_token1] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1218),
    [anon_sym_self] = ACTIONS(1220),
    [anon_sym_parent] = ACTIONS(1220),
    [aux_sym__argument_name_token1] = ACTIONS(1220),
    [aux_sym__argument_name_token2] = ACTIONS(1220),
    [anon_sym_POUND_LBRACK] = ACTIONS(1218),
    [aux_sym_encapsed_string_token1] = ACTIONS(1218),
    [anon_sym_DQUOTE] = ACTIONS(1218),
    [aux_sym_string_token1] = ACTIONS(1218),
    [anon_sym_SQUOTE] = ACTIONS(1218),
    [anon_sym_LT_LT_LT] = ACTIONS(1218),
    [anon_sym_BQUOTE] = ACTIONS(1218),
    [anon_sym_DOLLAR] = ACTIONS(1218),
    [aux_sym_yield_expression_token1] = ACTIONS(1220),
    [aux_sym_include_expression_token1] = ACTIONS(1220),
    [aux_sym_include_once_expression_token1] = ACTIONS(1220),
    [aux_sym_require_expression_token1] = ACTIONS(1220),
    [aux_sym_require_once_expression_token1] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1222),
    [sym_name] = ACTIONS(1224),
    [anon_sym_QMARK_GT] = ACTIONS(1222),
    [anon_sym_SEMI] = ACTIONS(1222),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1224),
    [aux_sym_global_declaration_token1] = ACTIONS(1224),
    [aux_sym_namespace_definition_token1] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1224),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1224),
    [anon_sym_BSLASH] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [aux_sym_trait_declaration_token1] = ACTIONS(1224),
    [aux_sym_interface_declaration_token1] = ACTIONS(1224),
    [aux_sym_enum_declaration_token1] = ACTIONS(1224),
    [aux_sym_enum_case_token1] = ACTIONS(1224),
    [aux_sym_class_declaration_token1] = ACTIONS(1224),
    [aux_sym_final_modifier_token1] = ACTIONS(1224),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1224),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1224),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1224),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1224),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [aux_sym_cast_type_token1] = ACTIONS(1224),
    [aux_sym_echo_statement_token1] = ACTIONS(1224),
    [anon_sym_unset] = ACTIONS(1224),
    [aux_sym_declare_statement_token1] = ACTIONS(1224),
    [aux_sym_declare_statement_token2] = ACTIONS(1224),
    [sym_float] = ACTIONS(1224),
    [aux_sym_try_statement_token1] = ACTIONS(1224),
    [aux_sym_goto_statement_token1] = ACTIONS(1224),
    [aux_sym_continue_statement_token1] = ACTIONS(1224),
    [aux_sym_break_statement_token1] = ACTIONS(1224),
    [sym_integer] = ACTIONS(1224),
    [aux_sym_return_statement_token1] = ACTIONS(1224),
    [aux_sym_throw_expression_token1] = ACTIONS(1224),
    [aux_sym_while_statement_token1] = ACTIONS(1224),
    [aux_sym_while_statement_token2] = ACTIONS(1224),
    [aux_sym_do_statement_token1] = ACTIONS(1224),
    [aux_sym_for_statement_token1] = ACTIONS(1224),
    [aux_sym_for_statement_token2] = ACTIONS(1224),
    [aux_sym_foreach_statement_token1] = ACTIONS(1224),
    [aux_sym_foreach_statement_token2] = ACTIONS(1224),
    [aux_sym_if_statement_token1] = ACTIONS(1224),
    [aux_sym_if_statement_token2] = ACTIONS(1224),
    [aux_sym_else_if_clause_token1] = ACTIONS(1224),
    [aux_sym_else_clause_token1] = ACTIONS(1224),
    [aux_sym_match_expression_token1] = ACTIONS(1224),
    [aux_sym_match_default_expression_token1] = ACTIONS(1224),
    [aux_sym_switch_statement_token1] = ACTIONS(1224),
    [aux_sym_switch_block_token1] = ACTIONS(1224),
    [anon_sym_PLUS] = ACTIONS(1224),
    [anon_sym_DASH] = ACTIONS(1224),
    [anon_sym_TILDE] = ACTIONS(1222),
    [anon_sym_BANG] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1222),
    [aux_sym_clone_expression_token1] = ACTIONS(1224),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1224),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1224),
    [anon_sym_DASH_DASH] = ACTIONS(1222),
    [anon_sym_PLUS_PLUS] = ACTIONS(1222),
    [aux_sym__list_destructing_token1] = ACTIONS(1224),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_self] = ACTIONS(1224),
    [anon_sym_parent] = ACTIONS(1224),
    [aux_sym__argument_name_token1] = ACTIONS(1224),
    [aux_sym__argument_name_token2] = ACTIONS(1224),
    [anon_sym_POUND_LBRACK] = ACTIONS(1222),
    [aux_sym_encapsed_string_token1] = ACTIONS(1222),
    [anon_sym_DQUOTE] = ACTIONS(1222),
    [aux_sym_string_token1] = ACTIONS(1222),
    [anon_sym_SQUOTE] = ACTIONS(1222),
    [anon_sym_LT_LT_LT] = ACTIONS(1222),
    [anon_sym_BQUOTE] = ACTIONS(1222),
    [anon_sym_DOLLAR] = ACTIONS(1222),
    [aux_sym_yield_expression_token1] = ACTIONS(1224),
    [aux_sym_include_expression_token1] = ACTIONS(1224),
    [aux_sym_include_once_expression_token1] = ACTIONS(1224),
    [aux_sym_require_expression_token1] = ACTIONS(1224),
    [aux_sym_require_once_expression_token1] = ACTIONS(1224),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(1226),
    [sym_name] = ACTIONS(1228),
    [anon_sym_QMARK_GT] = ACTIONS(1226),
    [anon_sym_SEMI] = ACTIONS(1226),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1228),
    [aux_sym_global_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_definition_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1228),
    [anon_sym_BSLASH] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [aux_sym_trait_declaration_token1] = ACTIONS(1228),
    [aux_sym_interface_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_case_token1] = ACTIONS(1228),
    [aux_sym_class_declaration_token1] = ACTIONS(1228),
    [aux_sym_final_modifier_token1] = ACTIONS(1228),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1228),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1228),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [aux_sym_cast_type_token1] = ACTIONS(1228),
    [aux_sym_echo_statement_token1] = ACTIONS(1228),
    [anon_sym_unset] = ACTIONS(1228),
    [aux_sym_declare_statement_token1] = ACTIONS(1228),
    [aux_sym_declare_statement_token2] = ACTIONS(1228),
    [sym_float] = ACTIONS(1228),
    [aux_sym_try_statement_token1] = ACTIONS(1228),
    [aux_sym_goto_statement_token1] = ACTIONS(1228),
    [aux_sym_continue_statement_token1] = ACTIONS(1228),
    [aux_sym_break_statement_token1] = ACTIONS(1228),
    [sym_integer] = ACTIONS(1228),
    [aux_sym_return_statement_token1] = ACTIONS(1228),
    [aux_sym_throw_expression_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token2] = ACTIONS(1228),
    [aux_sym_do_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token2] = ACTIONS(1228),
    [aux_sym_foreach_statement_token1] = ACTIONS(1228),
    [aux_sym_foreach_statement_token2] = ACTIONS(1228),
    [aux_sym_if_statement_token1] = ACTIONS(1228),
    [aux_sym_if_statement_token2] = ACTIONS(1228),
    [aux_sym_else_if_clause_token1] = ACTIONS(1228),
    [aux_sym_else_clause_token1] = ACTIONS(1228),
    [aux_sym_match_expression_token1] = ACTIONS(1228),
    [aux_sym_match_default_expression_token1] = ACTIONS(1228),
    [aux_sym_switch_statement_token1] = ACTIONS(1228),
    [aux_sym_switch_block_token1] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1226),
    [anon_sym_BANG] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1226),
    [aux_sym_clone_expression_token1] = ACTIONS(1228),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1228),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1228),
    [anon_sym_DASH_DASH] = ACTIONS(1226),
    [anon_sym_PLUS_PLUS] = ACTIONS(1226),
    [aux_sym__list_destructing_token1] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_self] = ACTIONS(1228),
    [anon_sym_parent] = ACTIONS(1228),
    [aux_sym__argument_name_token1] = ACTIONS(1228),
    [aux_sym__argument_name_token2] = ACTIONS(1228),
    [anon_sym_POUND_LBRACK] = ACTIONS(1226),
    [aux_sym_encapsed_string_token1] = ACTIONS(1226),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [aux_sym_string_token1] = ACTIONS(1226),
    [anon_sym_SQUOTE] = ACTIONS(1226),
    [anon_sym_LT_LT_LT] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(1226),
    [aux_sym_yield_expression_token1] = ACTIONS(1228),
    [aux_sym_include_expression_token1] = ACTIONS(1228),
    [aux_sym_include_once_expression_token1] = ACTIONS(1228),
    [aux_sym_require_expression_token1] = ACTIONS(1228),
    [aux_sym_require_once_expression_token1] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1230),
    [sym_name] = ACTIONS(1232),
    [anon_sym_QMARK_GT] = ACTIONS(1230),
    [anon_sym_SEMI] = ACTIONS(1230),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1232),
    [aux_sym_global_declaration_token1] = ACTIONS(1232),
    [aux_sym_namespace_definition_token1] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1232),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1232),
    [anon_sym_BSLASH] = ACTIONS(1230),
    [anon_sym_LBRACE] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1230),
    [aux_sym_trait_declaration_token1] = ACTIONS(1232),
    [aux_sym_interface_declaration_token1] = ACTIONS(1232),
    [aux_sym_enum_declaration_token1] = ACTIONS(1232),
    [aux_sym_enum_case_token1] = ACTIONS(1232),
    [aux_sym_class_declaration_token1] = ACTIONS(1232),
    [aux_sym_final_modifier_token1] = ACTIONS(1232),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1232),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1232),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1232),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1232),
    [anon_sym_LPAREN] = ACTIONS(1230),
    [aux_sym_cast_type_token1] = ACTIONS(1232),
    [aux_sym_echo_statement_token1] = ACTIONS(1232),
    [anon_sym_unset] = ACTIONS(1232),
    [aux_sym_declare_statement_token1] = ACTIONS(1232),
    [aux_sym_declare_statement_token2] = ACTIONS(1232),
    [sym_float] = ACTIONS(1232),
    [aux_sym_try_statement_token1] = ACTIONS(1232),
    [aux_sym_goto_statement_token1] = ACTIONS(1232),
    [aux_sym_continue_statement_token1] = ACTIONS(1232),
    [aux_sym_break_statement_token1] = ACTIONS(1232),
    [sym_integer] = ACTIONS(1232),
    [aux_sym_return_statement_token1] = ACTIONS(1232),
    [aux_sym_throw_expression_token1] = ACTIONS(1232),
    [aux_sym_while_statement_token1] = ACTIONS(1232),
    [aux_sym_while_statement_token2] = ACTIONS(1232),
    [aux_sym_do_statement_token1] = ACTIONS(1232),
    [aux_sym_for_statement_token1] = ACTIONS(1232),
    [aux_sym_for_statement_token2] = ACTIONS(1232),
    [aux_sym_foreach_statement_token1] = ACTIONS(1232),
    [aux_sym_foreach_statement_token2] = ACTIONS(1232),
    [aux_sym_if_statement_token1] = ACTIONS(1232),
    [aux_sym_if_statement_token2] = ACTIONS(1232),
    [aux_sym_else_if_clause_token1] = ACTIONS(1232),
    [aux_sym_else_clause_token1] = ACTIONS(1232),
    [aux_sym_match_expression_token1] = ACTIONS(1232),
    [aux_sym_match_default_expression_token1] = ACTIONS(1232),
    [aux_sym_switch_statement_token1] = ACTIONS(1232),
    [aux_sym_switch_block_token1] = ACTIONS(1232),
    [anon_sym_PLUS] = ACTIONS(1232),
    [anon_sym_DASH] = ACTIONS(1232),
    [anon_sym_TILDE] = ACTIONS(1230),
    [anon_sym_BANG] = ACTIONS(1230),
    [anon_sym_AT] = ACTIONS(1230),
    [aux_sym_clone_expression_token1] = ACTIONS(1232),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1232),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1232),
    [anon_sym_DASH_DASH] = ACTIONS(1230),
    [anon_sym_PLUS_PLUS] = ACTIONS(1230),
    [aux_sym__list_destructing_token1] = ACTIONS(1232),
    [anon_sym_LBRACK] = ACTIONS(1230),
    [anon_sym_self] = ACTIONS(1232),
    [anon_sym_parent] = ACTIONS(1232),
    [aux_sym__argument_name_token1] = ACTIONS(1232),
    [aux_sym__argument_name_token2] = ACTIONS(1232),
    [anon_sym_POUND_LBRACK] = ACTIONS(1230),
    [aux_sym_encapsed_string_token1] = ACTIONS(1230),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [aux_sym_string_token1] = ACTIONS(1230),
    [anon_sym_SQUOTE] = ACTIONS(1230),
    [anon_sym_LT_LT_LT] = ACTIONS(1230),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_DOLLAR] = ACTIONS(1230),
    [aux_sym_yield_expression_token1] = ACTIONS(1232),
    [aux_sym_include_expression_token1] = ACTIONS(1232),
    [aux_sym_include_once_expression_token1] = ACTIONS(1232),
    [aux_sym_require_expression_token1] = ACTIONS(1232),
    [aux_sym_require_once_expression_token1] = ACTIONS(1232),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(1234),
    [sym_name] = ACTIONS(1236),
    [anon_sym_QMARK_GT] = ACTIONS(1234),
    [anon_sym_SEMI] = ACTIONS(1234),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1236),
    [aux_sym_global_declaration_token1] = ACTIONS(1236),
    [aux_sym_namespace_definition_token1] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1236),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1236),
    [anon_sym_BSLASH] = ACTIONS(1234),
    [anon_sym_LBRACE] = ACTIONS(1234),
    [anon_sym_RBRACE] = ACTIONS(1234),
    [aux_sym_trait_declaration_token1] = ACTIONS(1236),
    [aux_sym_interface_declaration_token1] = ACTIONS(1236),
    [aux_sym_enum_declaration_token1] = ACTIONS(1236),
    [aux_sym_enum_case_token1] = ACTIONS(1236),
    [aux_sym_class_declaration_token1] = ACTIONS(1236),
    [aux_sym_final_modifier_token1] = ACTIONS(1236),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1236),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1236),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1236),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1234),
    [aux_sym_cast_type_token1] = ACTIONS(1236),
    [aux_sym_echo_statement_token1] = ACTIONS(1236),
    [anon_sym_unset] = ACTIONS(1236),
    [aux_sym_declare_statement_token1] = ACTIONS(1236),
    [aux_sym_declare_statement_token2] = ACTIONS(1236),
    [sym_float] = ACTIONS(1236),
    [aux_sym_try_statement_token1] = ACTIONS(1236),
    [aux_sym_goto_statement_token1] = ACTIONS(1236),
    [aux_sym_continue_statement_token1] = ACTIONS(1236),
    [aux_sym_break_statement_token1] = ACTIONS(1236),
    [sym_integer] = ACTIONS(1236),
    [aux_sym_return_statement_token1] = ACTIONS(1236),
    [aux_sym_throw_expression_token1] = ACTIONS(1236),
    [aux_sym_while_statement_token1] = ACTIONS(1236),
    [aux_sym_while_statement_token2] = ACTIONS(1236),
    [aux_sym_do_statement_token1] = ACTIONS(1236),
    [aux_sym_for_statement_token1] = ACTIONS(1236),
    [aux_sym_for_statement_token2] = ACTIONS(1236),
    [aux_sym_foreach_statement_token1] = ACTIONS(1236),
    [aux_sym_foreach_statement_token2] = ACTIONS(1236),
    [aux_sym_if_statement_token1] = ACTIONS(1236),
    [aux_sym_if_statement_token2] = ACTIONS(1236),
    [aux_sym_else_if_clause_token1] = ACTIONS(1236),
    [aux_sym_else_clause_token1] = ACTIONS(1236),
    [aux_sym_match_expression_token1] = ACTIONS(1236),
    [aux_sym_match_default_expression_token1] = ACTIONS(1236),
    [aux_sym_switch_statement_token1] = ACTIONS(1236),
    [aux_sym_switch_block_token1] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_TILDE] = ACTIONS(1234),
    [anon_sym_BANG] = ACTIONS(1234),
    [anon_sym_AT] = ACTIONS(1234),
    [aux_sym_clone_expression_token1] = ACTIONS(1236),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1236),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1236),
    [anon_sym_DASH_DASH] = ACTIONS(1234),
    [anon_sym_PLUS_PLUS] = ACTIONS(1234),
    [aux_sym__list_destructing_token1] = ACTIONS(1236),
    [anon_sym_LBRACK] = ACTIONS(1234),
    [anon_sym_self] = ACTIONS(1236),
    [anon_sym_parent] = ACTIONS(1236),
    [aux_sym__argument_name_token1] = ACTIONS(1236),
    [aux_sym__argument_name_token2] = ACTIONS(1236),
    [anon_sym_POUND_LBRACK] = ACTIONS(1234),
    [aux_sym_encapsed_string_token1] = ACTIONS(1234),
    [anon_sym_DQUOTE] = ACTIONS(1234),
    [aux_sym_string_token1] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [anon_sym_LT_LT_LT] = ACTIONS(1234),
    [anon_sym_BQUOTE] = ACTIONS(1234),
    [anon_sym_DOLLAR] = ACTIONS(1234),
    [aux_sym_yield_expression_token1] = ACTIONS(1236),
    [aux_sym_include_expression_token1] = ACTIONS(1236),
    [aux_sym_include_once_expression_token1] = ACTIONS(1236),
    [aux_sym_require_expression_token1] = ACTIONS(1236),
    [aux_sym_require_once_expression_token1] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(1238),
    [sym_name] = ACTIONS(1240),
    [anon_sym_QMARK_GT] = ACTIONS(1238),
    [anon_sym_SEMI] = ACTIONS(1238),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1240),
    [aux_sym_global_declaration_token1] = ACTIONS(1240),
    [aux_sym_namespace_definition_token1] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1240),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1240),
    [anon_sym_BSLASH] = ACTIONS(1238),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [aux_sym_trait_declaration_token1] = ACTIONS(1240),
    [aux_sym_interface_declaration_token1] = ACTIONS(1240),
    [aux_sym_enum_declaration_token1] = ACTIONS(1240),
    [aux_sym_enum_case_token1] = ACTIONS(1240),
    [aux_sym_class_declaration_token1] = ACTIONS(1240),
    [aux_sym_final_modifier_token1] = ACTIONS(1240),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1240),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1240),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1240),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [aux_sym_cast_type_token1] = ACTIONS(1240),
    [aux_sym_echo_statement_token1] = ACTIONS(1240),
    [anon_sym_unset] = ACTIONS(1240),
    [aux_sym_declare_statement_token1] = ACTIONS(1240),
    [aux_sym_declare_statement_token2] = ACTIONS(1240),
    [sym_float] = ACTIONS(1240),
    [aux_sym_try_statement_token1] = ACTIONS(1240),
    [aux_sym_goto_statement_token1] = ACTIONS(1240),
    [aux_sym_continue_statement_token1] = ACTIONS(1240),
    [aux_sym_break_statement_token1] = ACTIONS(1240),
    [sym_integer] = ACTIONS(1240),
    [aux_sym_return_statement_token1] = ACTIONS(1240),
    [aux_sym_throw_expression_token1] = ACTIONS(1240),
    [aux_sym_while_statement_token1] = ACTIONS(1240),
    [aux_sym_while_statement_token2] = ACTIONS(1240),
    [aux_sym_do_statement_token1] = ACTIONS(1240),
    [aux_sym_for_statement_token1] = ACTIONS(1240),
    [aux_sym_for_statement_token2] = ACTIONS(1240),
    [aux_sym_foreach_statement_token1] = ACTIONS(1240),
    [aux_sym_foreach_statement_token2] = ACTIONS(1240),
    [aux_sym_if_statement_token1] = ACTIONS(1240),
    [aux_sym_if_statement_token2] = ACTIONS(1240),
    [aux_sym_else_if_clause_token1] = ACTIONS(1240),
    [aux_sym_else_clause_token1] = ACTIONS(1240),
    [aux_sym_match_expression_token1] = ACTIONS(1240),
    [aux_sym_match_default_expression_token1] = ACTIONS(1240),
    [aux_sym_switch_statement_token1] = ACTIONS(1240),
    [aux_sym_switch_block_token1] = ACTIONS(1240),
    [anon_sym_PLUS] = ACTIONS(1240),
    [anon_sym_DASH] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1238),
    [anon_sym_BANG] = ACTIONS(1238),
    [anon_sym_AT] = ACTIONS(1238),
    [aux_sym_clone_expression_token1] = ACTIONS(1240),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1240),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1240),
    [anon_sym_DASH_DASH] = ACTIONS(1238),
    [anon_sym_PLUS_PLUS] = ACTIONS(1238),
    [aux_sym__list_destructing_token1] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_self] = ACTIONS(1240),
    [anon_sym_parent] = ACTIONS(1240),
    [aux_sym__argument_name_token1] = ACTIONS(1240),
    [aux_sym__argument_name_token2] = ACTIONS(1240),
    [anon_sym_POUND_LBRACK] = ACTIONS(1238),
    [aux_sym_encapsed_string_token1] = ACTIONS(1238),
    [anon_sym_DQUOTE] = ACTIONS(1238),
    [aux_sym_string_token1] = ACTIONS(1238),
    [anon_sym_SQUOTE] = ACTIONS(1238),
    [anon_sym_LT_LT_LT] = ACTIONS(1238),
    [anon_sym_BQUOTE] = ACTIONS(1238),
    [anon_sym_DOLLAR] = ACTIONS(1238),
    [aux_sym_yield_expression_token1] = ACTIONS(1240),
    [aux_sym_include_expression_token1] = ACTIONS(1240),
    [aux_sym_include_once_expression_token1] = ACTIONS(1240),
    [aux_sym_require_expression_token1] = ACTIONS(1240),
    [aux_sym_require_once_expression_token1] = ACTIONS(1240),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(1242),
    [sym_name] = ACTIONS(1244),
    [anon_sym_QMARK_GT] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1242),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1244),
    [aux_sym_global_declaration_token1] = ACTIONS(1244),
    [aux_sym_namespace_definition_token1] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1244),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1244),
    [anon_sym_BSLASH] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [aux_sym_trait_declaration_token1] = ACTIONS(1244),
    [aux_sym_interface_declaration_token1] = ACTIONS(1244),
    [aux_sym_enum_declaration_token1] = ACTIONS(1244),
    [aux_sym_enum_case_token1] = ACTIONS(1244),
    [aux_sym_class_declaration_token1] = ACTIONS(1244),
    [aux_sym_final_modifier_token1] = ACTIONS(1244),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1244),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1244),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1244),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [aux_sym_cast_type_token1] = ACTIONS(1244),
    [aux_sym_echo_statement_token1] = ACTIONS(1244),
    [anon_sym_unset] = ACTIONS(1244),
    [aux_sym_declare_statement_token1] = ACTIONS(1244),
    [aux_sym_declare_statement_token2] = ACTIONS(1244),
    [sym_float] = ACTIONS(1244),
    [aux_sym_try_statement_token1] = ACTIONS(1244),
    [aux_sym_goto_statement_token1] = ACTIONS(1244),
    [aux_sym_continue_statement_token1] = ACTIONS(1244),
    [aux_sym_break_statement_token1] = ACTIONS(1244),
    [sym_integer] = ACTIONS(1244),
    [aux_sym_return_statement_token1] = ACTIONS(1244),
    [aux_sym_throw_expression_token1] = ACTIONS(1244),
    [aux_sym_while_statement_token1] = ACTIONS(1244),
    [aux_sym_while_statement_token2] = ACTIONS(1244),
    [aux_sym_do_statement_token1] = ACTIONS(1244),
    [aux_sym_for_statement_token1] = ACTIONS(1244),
    [aux_sym_for_statement_token2] = ACTIONS(1244),
    [aux_sym_foreach_statement_token1] = ACTIONS(1244),
    [aux_sym_foreach_statement_token2] = ACTIONS(1244),
    [aux_sym_if_statement_token1] = ACTIONS(1244),
    [aux_sym_if_statement_token2] = ACTIONS(1244),
    [aux_sym_else_if_clause_token1] = ACTIONS(1244),
    [aux_sym_else_clause_token1] = ACTIONS(1244),
    [aux_sym_match_expression_token1] = ACTIONS(1244),
    [aux_sym_match_default_expression_token1] = ACTIONS(1244),
    [aux_sym_switch_statement_token1] = ACTIONS(1244),
    [aux_sym_switch_block_token1] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1242),
    [aux_sym_clone_expression_token1] = ACTIONS(1244),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1244),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1244),
    [anon_sym_DASH_DASH] = ACTIONS(1242),
    [anon_sym_PLUS_PLUS] = ACTIONS(1242),
    [aux_sym__list_destructing_token1] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_self] = ACTIONS(1244),
    [anon_sym_parent] = ACTIONS(1244),
    [aux_sym__argument_name_token1] = ACTIONS(1244),
    [aux_sym__argument_name_token2] = ACTIONS(1244),
    [anon_sym_POUND_LBRACK] = ACTIONS(1242),
    [aux_sym_encapsed_string_token1] = ACTIONS(1242),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [aux_sym_string_token1] = ACTIONS(1242),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_LT_LT_LT] = ACTIONS(1242),
    [anon_sym_BQUOTE] = ACTIONS(1242),
    [anon_sym_DOLLAR] = ACTIONS(1242),
    [aux_sym_yield_expression_token1] = ACTIONS(1244),
    [aux_sym_include_expression_token1] = ACTIONS(1244),
    [aux_sym_include_once_expression_token1] = ACTIONS(1244),
    [aux_sym_require_expression_token1] = ACTIONS(1244),
    [aux_sym_require_once_expression_token1] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(1246),
    [sym_name] = ACTIONS(1248),
    [anon_sym_QMARK_GT] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1246),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1248),
    [aux_sym_global_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_definition_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1248),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1248),
    [anon_sym_BSLASH] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1246),
    [aux_sym_trait_declaration_token1] = ACTIONS(1248),
    [aux_sym_interface_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_declaration_token1] = ACTIONS(1248),
    [aux_sym_enum_case_token1] = ACTIONS(1248),
    [aux_sym_class_declaration_token1] = ACTIONS(1248),
    [aux_sym_final_modifier_token1] = ACTIONS(1248),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1248),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1248),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1248),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [aux_sym_cast_type_token1] = ACTIONS(1248),
    [aux_sym_echo_statement_token1] = ACTIONS(1248),
    [anon_sym_unset] = ACTIONS(1248),
    [aux_sym_declare_statement_token1] = ACTIONS(1248),
    [aux_sym_declare_statement_token2] = ACTIONS(1248),
    [sym_float] = ACTIONS(1248),
    [aux_sym_try_statement_token1] = ACTIONS(1248),
    [aux_sym_goto_statement_token1] = ACTIONS(1248),
    [aux_sym_continue_statement_token1] = ACTIONS(1248),
    [aux_sym_break_statement_token1] = ACTIONS(1248),
    [sym_integer] = ACTIONS(1248),
    [aux_sym_return_statement_token1] = ACTIONS(1248),
    [aux_sym_throw_expression_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token1] = ACTIONS(1248),
    [aux_sym_while_statement_token2] = ACTIONS(1248),
    [aux_sym_do_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token1] = ACTIONS(1248),
    [aux_sym_for_statement_token2] = ACTIONS(1248),
    [aux_sym_foreach_statement_token1] = ACTIONS(1248),
    [aux_sym_foreach_statement_token2] = ACTIONS(1248),
    [aux_sym_if_statement_token1] = ACTIONS(1248),
    [aux_sym_if_statement_token2] = ACTIONS(1248),
    [aux_sym_else_if_clause_token1] = ACTIONS(1248),
    [aux_sym_else_clause_token1] = ACTIONS(1248),
    [aux_sym_match_expression_token1] = ACTIONS(1248),
    [aux_sym_match_default_expression_token1] = ACTIONS(1248),
    [aux_sym_switch_statement_token1] = ACTIONS(1248),
    [aux_sym_switch_block_token1] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1246),
    [aux_sym_clone_expression_token1] = ACTIONS(1248),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1248),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1246),
    [aux_sym__list_destructing_token1] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_self] = ACTIONS(1248),
    [anon_sym_parent] = ACTIONS(1248),
    [aux_sym__argument_name_token1] = ACTIONS(1248),
    [aux_sym__argument_name_token2] = ACTIONS(1248),
    [anon_sym_POUND_LBRACK] = ACTIONS(1246),
    [aux_sym_encapsed_string_token1] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1246),
    [aux_sym_string_token1] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1246),
    [anon_sym_LT_LT_LT] = ACTIONS(1246),
    [anon_sym_BQUOTE] = ACTIONS(1246),
    [anon_sym_DOLLAR] = ACTIONS(1246),
    [aux_sym_yield_expression_token1] = ACTIONS(1248),
    [aux_sym_include_expression_token1] = ACTIONS(1248),
    [aux_sym_include_once_expression_token1] = ACTIONS(1248),
    [aux_sym_require_expression_token1] = ACTIONS(1248),
    [aux_sym_require_once_expression_token1] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_name] = ACTIONS(1252),
    [anon_sym_QMARK_GT] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1250),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1252),
    [aux_sym_global_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_definition_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1252),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [aux_sym_trait_declaration_token1] = ACTIONS(1252),
    [aux_sym_interface_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_declaration_token1] = ACTIONS(1252),
    [aux_sym_enum_case_token1] = ACTIONS(1252),
    [aux_sym_class_declaration_token1] = ACTIONS(1252),
    [aux_sym_final_modifier_token1] = ACTIONS(1252),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1252),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1252),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1252),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [aux_sym_cast_type_token1] = ACTIONS(1252),
    [aux_sym_echo_statement_token1] = ACTIONS(1252),
    [anon_sym_unset] = ACTIONS(1252),
    [aux_sym_declare_statement_token1] = ACTIONS(1252),
    [aux_sym_declare_statement_token2] = ACTIONS(1252),
    [sym_float] = ACTIONS(1252),
    [aux_sym_try_statement_token1] = ACTIONS(1252),
    [aux_sym_goto_statement_token1] = ACTIONS(1252),
    [aux_sym_continue_statement_token1] = ACTIONS(1252),
    [aux_sym_break_statement_token1] = ACTIONS(1252),
    [sym_integer] = ACTIONS(1252),
    [aux_sym_return_statement_token1] = ACTIONS(1252),
    [aux_sym_throw_expression_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token1] = ACTIONS(1252),
    [aux_sym_while_statement_token2] = ACTIONS(1252),
    [aux_sym_do_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token1] = ACTIONS(1252),
    [aux_sym_for_statement_token2] = ACTIONS(1252),
    [aux_sym_foreach_statement_token1] = ACTIONS(1252),
    [aux_sym_foreach_statement_token2] = ACTIONS(1252),
    [aux_sym_if_statement_token1] = ACTIONS(1252),
    [aux_sym_if_statement_token2] = ACTIONS(1252),
    [aux_sym_else_if_clause_token1] = ACTIONS(1252),
    [aux_sym_else_clause_token1] = ACTIONS(1252),
    [aux_sym_match_expression_token1] = ACTIONS(1252),
    [aux_sym_match_default_expression_token1] = ACTIONS(1252),
    [aux_sym_switch_statement_token1] = ACTIONS(1252),
    [aux_sym_switch_block_token1] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [aux_sym_clone_expression_token1] = ACTIONS(1252),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1252),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1252),
    [anon_sym_DASH_DASH] = ACTIONS(1250),
    [anon_sym_PLUS_PLUS] = ACTIONS(1250),
    [aux_sym__list_destructing_token1] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_self] = ACTIONS(1252),
    [anon_sym_parent] = ACTIONS(1252),
    [aux_sym__argument_name_token1] = ACTIONS(1252),
    [aux_sym__argument_name_token2] = ACTIONS(1252),
    [anon_sym_POUND_LBRACK] = ACTIONS(1250),
    [aux_sym_encapsed_string_token1] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1250),
    [aux_sym_string_token1] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1250),
    [anon_sym_LT_LT_LT] = ACTIONS(1250),
    [anon_sym_BQUOTE] = ACTIONS(1250),
    [anon_sym_DOLLAR] = ACTIONS(1250),
    [aux_sym_yield_expression_token1] = ACTIONS(1252),
    [aux_sym_include_expression_token1] = ACTIONS(1252),
    [aux_sym_include_once_expression_token1] = ACTIONS(1252),
    [aux_sym_require_expression_token1] = ACTIONS(1252),
    [aux_sym_require_once_expression_token1] = ACTIONS(1252),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1254),
    [sym_name] = ACTIONS(1256),
    [anon_sym_QMARK_GT] = ACTIONS(1254),
    [anon_sym_SEMI] = ACTIONS(1254),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1256),
    [aux_sym_global_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_definition_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1256),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1256),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_RBRACE] = ACTIONS(1254),
    [aux_sym_trait_declaration_token1] = ACTIONS(1256),
    [aux_sym_interface_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_declaration_token1] = ACTIONS(1256),
    [aux_sym_enum_case_token1] = ACTIONS(1256),
    [aux_sym_class_declaration_token1] = ACTIONS(1256),
    [aux_sym_final_modifier_token1] = ACTIONS(1256),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1256),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1256),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1256),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [aux_sym_cast_type_token1] = ACTIONS(1256),
    [aux_sym_echo_statement_token1] = ACTIONS(1256),
    [anon_sym_unset] = ACTIONS(1256),
    [aux_sym_declare_statement_token1] = ACTIONS(1256),
    [aux_sym_declare_statement_token2] = ACTIONS(1256),
    [sym_float] = ACTIONS(1256),
    [aux_sym_try_statement_token1] = ACTIONS(1256),
    [aux_sym_goto_statement_token1] = ACTIONS(1256),
    [aux_sym_continue_statement_token1] = ACTIONS(1256),
    [aux_sym_break_statement_token1] = ACTIONS(1256),
    [sym_integer] = ACTIONS(1256),
    [aux_sym_return_statement_token1] = ACTIONS(1256),
    [aux_sym_throw_expression_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token1] = ACTIONS(1256),
    [aux_sym_while_statement_token2] = ACTIONS(1256),
    [aux_sym_do_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token1] = ACTIONS(1256),
    [aux_sym_for_statement_token2] = ACTIONS(1256),
    [aux_sym_foreach_statement_token1] = ACTIONS(1256),
    [aux_sym_foreach_statement_token2] = ACTIONS(1256),
    [aux_sym_if_statement_token1] = ACTIONS(1256),
    [aux_sym_if_statement_token2] = ACTIONS(1256),
    [aux_sym_else_if_clause_token1] = ACTIONS(1256),
    [aux_sym_else_clause_token1] = ACTIONS(1256),
    [aux_sym_match_expression_token1] = ACTIONS(1256),
    [aux_sym_match_default_expression_token1] = ACTIONS(1256),
    [aux_sym_switch_statement_token1] = ACTIONS(1256),
    [aux_sym_switch_block_token1] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_TILDE] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1254),
    [aux_sym_clone_expression_token1] = ACTIONS(1256),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1256),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1256),
    [anon_sym_DASH_DASH] = ACTIONS(1254),
    [anon_sym_PLUS_PLUS] = ACTIONS(1254),
    [aux_sym__list_destructing_token1] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1254),
    [anon_sym_self] = ACTIONS(1256),
    [anon_sym_parent] = ACTIONS(1256),
    [aux_sym__argument_name_token1] = ACTIONS(1256),
    [aux_sym__argument_name_token2] = ACTIONS(1256),
    [anon_sym_POUND_LBRACK] = ACTIONS(1254),
    [aux_sym_encapsed_string_token1] = ACTIONS(1254),
    [anon_sym_DQUOTE] = ACTIONS(1254),
    [aux_sym_string_token1] = ACTIONS(1254),
    [anon_sym_SQUOTE] = ACTIONS(1254),
    [anon_sym_LT_LT_LT] = ACTIONS(1254),
    [anon_sym_BQUOTE] = ACTIONS(1254),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [aux_sym_yield_expression_token1] = ACTIONS(1256),
    [aux_sym_include_expression_token1] = ACTIONS(1256),
    [aux_sym_include_once_expression_token1] = ACTIONS(1256),
    [aux_sym_require_expression_token1] = ACTIONS(1256),
    [aux_sym_require_once_expression_token1] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym_name] = ACTIONS(1260),
    [anon_sym_QMARK_GT] = ACTIONS(1258),
    [anon_sym_SEMI] = ACTIONS(1258),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1260),
    [aux_sym_global_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_definition_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1260),
    [anon_sym_BSLASH] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_RBRACE] = ACTIONS(1258),
    [aux_sym_trait_declaration_token1] = ACTIONS(1260),
    [aux_sym_interface_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_case_token1] = ACTIONS(1260),
    [aux_sym_class_declaration_token1] = ACTIONS(1260),
    [aux_sym_final_modifier_token1] = ACTIONS(1260),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1260),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1260),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [aux_sym_cast_type_token1] = ACTIONS(1260),
    [aux_sym_echo_statement_token1] = ACTIONS(1260),
    [anon_sym_unset] = ACTIONS(1260),
    [aux_sym_declare_statement_token1] = ACTIONS(1260),
    [aux_sym_declare_statement_token2] = ACTIONS(1260),
    [sym_float] = ACTIONS(1260),
    [aux_sym_try_statement_token1] = ACTIONS(1260),
    [aux_sym_goto_statement_token1] = ACTIONS(1260),
    [aux_sym_continue_statement_token1] = ACTIONS(1260),
    [aux_sym_break_statement_token1] = ACTIONS(1260),
    [sym_integer] = ACTIONS(1260),
    [aux_sym_return_statement_token1] = ACTIONS(1260),
    [aux_sym_throw_expression_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token2] = ACTIONS(1260),
    [aux_sym_do_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token2] = ACTIONS(1260),
    [aux_sym_foreach_statement_token1] = ACTIONS(1260),
    [aux_sym_foreach_statement_token2] = ACTIONS(1260),
    [aux_sym_if_statement_token1] = ACTIONS(1260),
    [aux_sym_if_statement_token2] = ACTIONS(1260),
    [aux_sym_else_if_clause_token1] = ACTIONS(1260),
    [aux_sym_else_clause_token1] = ACTIONS(1260),
    [aux_sym_match_expression_token1] = ACTIONS(1260),
    [aux_sym_match_default_expression_token1] = ACTIONS(1260),
    [aux_sym_switch_statement_token1] = ACTIONS(1260),
    [aux_sym_switch_block_token1] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1258),
    [aux_sym_clone_expression_token1] = ACTIONS(1260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1260),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1258),
    [anon_sym_PLUS_PLUS] = ACTIONS(1258),
    [aux_sym__list_destructing_token1] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_self] = ACTIONS(1260),
    [anon_sym_parent] = ACTIONS(1260),
    [aux_sym__argument_name_token1] = ACTIONS(1260),
    [aux_sym__argument_name_token2] = ACTIONS(1260),
    [anon_sym_POUND_LBRACK] = ACTIONS(1258),
    [aux_sym_encapsed_string_token1] = ACTIONS(1258),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [aux_sym_string_token1] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1258),
    [anon_sym_LT_LT_LT] = ACTIONS(1258),
    [anon_sym_BQUOTE] = ACTIONS(1258),
    [anon_sym_DOLLAR] = ACTIONS(1258),
    [aux_sym_yield_expression_token1] = ACTIONS(1260),
    [aux_sym_include_expression_token1] = ACTIONS(1260),
    [aux_sym_include_once_expression_token1] = ACTIONS(1260),
    [aux_sym_require_expression_token1] = ACTIONS(1260),
    [aux_sym_require_once_expression_token1] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(1262),
    [sym_name] = ACTIONS(1264),
    [anon_sym_QMARK_GT] = ACTIONS(1262),
    [anon_sym_SEMI] = ACTIONS(1262),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1264),
    [aux_sym_global_declaration_token1] = ACTIONS(1264),
    [aux_sym_namespace_definition_token1] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1264),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1264),
    [anon_sym_BSLASH] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1262),
    [anon_sym_RBRACE] = ACTIONS(1262),
    [aux_sym_trait_declaration_token1] = ACTIONS(1264),
    [aux_sym_interface_declaration_token1] = ACTIONS(1264),
    [aux_sym_enum_declaration_token1] = ACTIONS(1264),
    [aux_sym_enum_case_token1] = ACTIONS(1264),
    [aux_sym_class_declaration_token1] = ACTIONS(1264),
    [aux_sym_final_modifier_token1] = ACTIONS(1264),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1264),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1264),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1264),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1262),
    [aux_sym_cast_type_token1] = ACTIONS(1264),
    [aux_sym_echo_statement_token1] = ACTIONS(1264),
    [anon_sym_unset] = ACTIONS(1264),
    [aux_sym_declare_statement_token1] = ACTIONS(1264),
    [aux_sym_declare_statement_token2] = ACTIONS(1264),
    [sym_float] = ACTIONS(1264),
    [aux_sym_try_statement_token1] = ACTIONS(1264),
    [aux_sym_goto_statement_token1] = ACTIONS(1264),
    [aux_sym_continue_statement_token1] = ACTIONS(1264),
    [aux_sym_break_statement_token1] = ACTIONS(1264),
    [sym_integer] = ACTIONS(1264),
    [aux_sym_return_statement_token1] = ACTIONS(1264),
    [aux_sym_throw_expression_token1] = ACTIONS(1264),
    [aux_sym_while_statement_token1] = ACTIONS(1264),
    [aux_sym_while_statement_token2] = ACTIONS(1264),
    [aux_sym_do_statement_token1] = ACTIONS(1264),
    [aux_sym_for_statement_token1] = ACTIONS(1264),
    [aux_sym_for_statement_token2] = ACTIONS(1264),
    [aux_sym_foreach_statement_token1] = ACTIONS(1264),
    [aux_sym_foreach_statement_token2] = ACTIONS(1264),
    [aux_sym_if_statement_token1] = ACTIONS(1264),
    [aux_sym_if_statement_token2] = ACTIONS(1264),
    [aux_sym_else_if_clause_token1] = ACTIONS(1264),
    [aux_sym_else_clause_token1] = ACTIONS(1264),
    [aux_sym_match_expression_token1] = ACTIONS(1264),
    [aux_sym_match_default_expression_token1] = ACTIONS(1264),
    [aux_sym_switch_statement_token1] = ACTIONS(1264),
    [aux_sym_switch_block_token1] = ACTIONS(1264),
    [anon_sym_PLUS] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1262),
    [anon_sym_BANG] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(1262),
    [aux_sym_clone_expression_token1] = ACTIONS(1264),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1264),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1264),
    [anon_sym_DASH_DASH] = ACTIONS(1262),
    [anon_sym_PLUS_PLUS] = ACTIONS(1262),
    [aux_sym__list_destructing_token1] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1262),
    [anon_sym_self] = ACTIONS(1264),
    [anon_sym_parent] = ACTIONS(1264),
    [aux_sym__argument_name_token1] = ACTIONS(1264),
    [aux_sym__argument_name_token2] = ACTIONS(1264),
    [anon_sym_POUND_LBRACK] = ACTIONS(1262),
    [aux_sym_encapsed_string_token1] = ACTIONS(1262),
    [anon_sym_DQUOTE] = ACTIONS(1262),
    [aux_sym_string_token1] = ACTIONS(1262),
    [anon_sym_SQUOTE] = ACTIONS(1262),
    [anon_sym_LT_LT_LT] = ACTIONS(1262),
    [anon_sym_BQUOTE] = ACTIONS(1262),
    [anon_sym_DOLLAR] = ACTIONS(1262),
    [aux_sym_yield_expression_token1] = ACTIONS(1264),
    [aux_sym_include_expression_token1] = ACTIONS(1264),
    [aux_sym_include_once_expression_token1] = ACTIONS(1264),
    [aux_sym_require_expression_token1] = ACTIONS(1264),
    [aux_sym_require_once_expression_token1] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(1266),
    [sym_name] = ACTIONS(1268),
    [anon_sym_QMARK_GT] = ACTIONS(1266),
    [anon_sym_SEMI] = ACTIONS(1266),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1268),
    [aux_sym_global_declaration_token1] = ACTIONS(1268),
    [aux_sym_namespace_definition_token1] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1268),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1268),
    [anon_sym_BSLASH] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1266),
    [anon_sym_RBRACE] = ACTIONS(1266),
    [aux_sym_trait_declaration_token1] = ACTIONS(1268),
    [aux_sym_interface_declaration_token1] = ACTIONS(1268),
    [aux_sym_enum_declaration_token1] = ACTIONS(1268),
    [aux_sym_enum_case_token1] = ACTIONS(1268),
    [aux_sym_class_declaration_token1] = ACTIONS(1268),
    [aux_sym_final_modifier_token1] = ACTIONS(1268),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1268),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1268),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1268),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [aux_sym_cast_type_token1] = ACTIONS(1268),
    [aux_sym_echo_statement_token1] = ACTIONS(1268),
    [anon_sym_unset] = ACTIONS(1268),
    [aux_sym_declare_statement_token1] = ACTIONS(1268),
    [aux_sym_declare_statement_token2] = ACTIONS(1268),
    [sym_float] = ACTIONS(1268),
    [aux_sym_try_statement_token1] = ACTIONS(1268),
    [aux_sym_goto_statement_token1] = ACTIONS(1268),
    [aux_sym_continue_statement_token1] = ACTIONS(1268),
    [aux_sym_break_statement_token1] = ACTIONS(1268),
    [sym_integer] = ACTIONS(1268),
    [aux_sym_return_statement_token1] = ACTIONS(1268),
    [aux_sym_throw_expression_token1] = ACTIONS(1268),
    [aux_sym_while_statement_token1] = ACTIONS(1268),
    [aux_sym_while_statement_token2] = ACTIONS(1268),
    [aux_sym_do_statement_token1] = ACTIONS(1268),
    [aux_sym_for_statement_token1] = ACTIONS(1268),
    [aux_sym_for_statement_token2] = ACTIONS(1268),
    [aux_sym_foreach_statement_token1] = ACTIONS(1268),
    [aux_sym_foreach_statement_token2] = ACTIONS(1268),
    [aux_sym_if_statement_token1] = ACTIONS(1268),
    [aux_sym_if_statement_token2] = ACTIONS(1268),
    [aux_sym_else_if_clause_token1] = ACTIONS(1268),
    [aux_sym_else_clause_token1] = ACTIONS(1268),
    [aux_sym_match_expression_token1] = ACTIONS(1268),
    [aux_sym_match_default_expression_token1] = ACTIONS(1268),
    [aux_sym_switch_statement_token1] = ACTIONS(1268),
    [aux_sym_switch_block_token1] = ACTIONS(1268),
    [anon_sym_PLUS] = ACTIONS(1268),
    [anon_sym_DASH] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_BANG] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1266),
    [aux_sym_clone_expression_token1] = ACTIONS(1268),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1268),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1268),
    [anon_sym_DASH_DASH] = ACTIONS(1266),
    [anon_sym_PLUS_PLUS] = ACTIONS(1266),
    [aux_sym__list_destructing_token1] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_self] = ACTIONS(1268),
    [anon_sym_parent] = ACTIONS(1268),
    [aux_sym__argument_name_token1] = ACTIONS(1268),
    [aux_sym__argument_name_token2] = ACTIONS(1268),
    [anon_sym_POUND_LBRACK] = ACTIONS(1266),
    [aux_sym_encapsed_string_token1] = ACTIONS(1266),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [aux_sym_string_token1] = ACTIONS(1266),
    [anon_sym_SQUOTE] = ACTIONS(1266),
    [anon_sym_LT_LT_LT] = ACTIONS(1266),
    [anon_sym_BQUOTE] = ACTIONS(1266),
    [anon_sym_DOLLAR] = ACTIONS(1266),
    [aux_sym_yield_expression_token1] = ACTIONS(1268),
    [aux_sym_include_expression_token1] = ACTIONS(1268),
    [aux_sym_include_once_expression_token1] = ACTIONS(1268),
    [aux_sym_require_expression_token1] = ACTIONS(1268),
    [aux_sym_require_once_expression_token1] = ACTIONS(1268),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym_name] = ACTIONS(1272),
    [anon_sym_QMARK_GT] = ACTIONS(1270),
    [anon_sym_SEMI] = ACTIONS(1270),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1272),
    [aux_sym_global_declaration_token1] = ACTIONS(1272),
    [aux_sym_namespace_definition_token1] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1272),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1272),
    [anon_sym_BSLASH] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1270),
    [aux_sym_trait_declaration_token1] = ACTIONS(1272),
    [aux_sym_interface_declaration_token1] = ACTIONS(1272),
    [aux_sym_enum_declaration_token1] = ACTIONS(1272),
    [aux_sym_enum_case_token1] = ACTIONS(1272),
    [aux_sym_class_declaration_token1] = ACTIONS(1272),
    [aux_sym_final_modifier_token1] = ACTIONS(1272),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1272),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1272),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1272),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [aux_sym_cast_type_token1] = ACTIONS(1272),
    [aux_sym_echo_statement_token1] = ACTIONS(1272),
    [anon_sym_unset] = ACTIONS(1272),
    [aux_sym_declare_statement_token1] = ACTIONS(1272),
    [aux_sym_declare_statement_token2] = ACTIONS(1272),
    [sym_float] = ACTIONS(1272),
    [aux_sym_try_statement_token1] = ACTIONS(1272),
    [aux_sym_goto_statement_token1] = ACTIONS(1272),
    [aux_sym_continue_statement_token1] = ACTIONS(1272),
    [aux_sym_break_statement_token1] = ACTIONS(1272),
    [sym_integer] = ACTIONS(1272),
    [aux_sym_return_statement_token1] = ACTIONS(1272),
    [aux_sym_throw_expression_token1] = ACTIONS(1272),
    [aux_sym_while_statement_token1] = ACTIONS(1272),
    [aux_sym_while_statement_token2] = ACTIONS(1272),
    [aux_sym_do_statement_token1] = ACTIONS(1272),
    [aux_sym_for_statement_token1] = ACTIONS(1272),
    [aux_sym_for_statement_token2] = ACTIONS(1272),
    [aux_sym_foreach_statement_token1] = ACTIONS(1272),
    [aux_sym_foreach_statement_token2] = ACTIONS(1272),
    [aux_sym_if_statement_token1] = ACTIONS(1272),
    [aux_sym_if_statement_token2] = ACTIONS(1272),
    [aux_sym_else_if_clause_token1] = ACTIONS(1272),
    [aux_sym_else_clause_token1] = ACTIONS(1272),
    [aux_sym_match_expression_token1] = ACTIONS(1272),
    [aux_sym_match_default_expression_token1] = ACTIONS(1272),
    [aux_sym_switch_statement_token1] = ACTIONS(1272),
    [aux_sym_switch_block_token1] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_BANG] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1270),
    [aux_sym_clone_expression_token1] = ACTIONS(1272),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1272),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1272),
    [anon_sym_DASH_DASH] = ACTIONS(1270),
    [anon_sym_PLUS_PLUS] = ACTIONS(1270),
    [aux_sym__list_destructing_token1] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_self] = ACTIONS(1272),
    [anon_sym_parent] = ACTIONS(1272),
    [aux_sym__argument_name_token1] = ACTIONS(1272),
    [aux_sym__argument_name_token2] = ACTIONS(1272),
    [anon_sym_POUND_LBRACK] = ACTIONS(1270),
    [aux_sym_encapsed_string_token1] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(1270),
    [aux_sym_string_token1] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1270),
    [anon_sym_LT_LT_LT] = ACTIONS(1270),
    [anon_sym_BQUOTE] = ACTIONS(1270),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [aux_sym_yield_expression_token1] = ACTIONS(1272),
    [aux_sym_include_expression_token1] = ACTIONS(1272),
    [aux_sym_include_once_expression_token1] = ACTIONS(1272),
    [aux_sym_require_expression_token1] = ACTIONS(1272),
    [aux_sym_require_once_expression_token1] = ACTIONS(1272),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(1274),
    [sym_name] = ACTIONS(1276),
    [anon_sym_QMARK_GT] = ACTIONS(1274),
    [anon_sym_SEMI] = ACTIONS(1274),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1276),
    [aux_sym_global_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_definition_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1276),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1276),
    [anon_sym_BSLASH] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [aux_sym_trait_declaration_token1] = ACTIONS(1276),
    [aux_sym_interface_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_declaration_token1] = ACTIONS(1276),
    [aux_sym_enum_case_token1] = ACTIONS(1276),
    [aux_sym_class_declaration_token1] = ACTIONS(1276),
    [aux_sym_final_modifier_token1] = ACTIONS(1276),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1276),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1276),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1276),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [aux_sym_cast_type_token1] = ACTIONS(1276),
    [aux_sym_echo_statement_token1] = ACTIONS(1276),
    [anon_sym_unset] = ACTIONS(1276),
    [aux_sym_declare_statement_token1] = ACTIONS(1276),
    [aux_sym_declare_statement_token2] = ACTIONS(1276),
    [sym_float] = ACTIONS(1276),
    [aux_sym_try_statement_token1] = ACTIONS(1276),
    [aux_sym_goto_statement_token1] = ACTIONS(1276),
    [aux_sym_continue_statement_token1] = ACTIONS(1276),
    [aux_sym_break_statement_token1] = ACTIONS(1276),
    [sym_integer] = ACTIONS(1276),
    [aux_sym_return_statement_token1] = ACTIONS(1276),
    [aux_sym_throw_expression_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token1] = ACTIONS(1276),
    [aux_sym_while_statement_token2] = ACTIONS(1276),
    [aux_sym_do_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token1] = ACTIONS(1276),
    [aux_sym_for_statement_token2] = ACTIONS(1276),
    [aux_sym_foreach_statement_token1] = ACTIONS(1276),
    [aux_sym_foreach_statement_token2] = ACTIONS(1276),
    [aux_sym_if_statement_token1] = ACTIONS(1276),
    [aux_sym_if_statement_token2] = ACTIONS(1276),
    [aux_sym_else_if_clause_token1] = ACTIONS(1276),
    [aux_sym_else_clause_token1] = ACTIONS(1276),
    [aux_sym_match_expression_token1] = ACTIONS(1276),
    [aux_sym_match_default_expression_token1] = ACTIONS(1276),
    [aux_sym_switch_statement_token1] = ACTIONS(1276),
    [aux_sym_switch_block_token1] = ACTIONS(1276),
    [anon_sym_PLUS] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_BANG] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [aux_sym_clone_expression_token1] = ACTIONS(1276),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1276),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1276),
    [anon_sym_DASH_DASH] = ACTIONS(1274),
    [anon_sym_PLUS_PLUS] = ACTIONS(1274),
    [aux_sym__list_destructing_token1] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_self] = ACTIONS(1276),
    [anon_sym_parent] = ACTIONS(1276),
    [aux_sym__argument_name_token1] = ACTIONS(1276),
    [aux_sym__argument_name_token2] = ACTIONS(1276),
    [anon_sym_POUND_LBRACK] = ACTIONS(1274),
    [aux_sym_encapsed_string_token1] = ACTIONS(1274),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [aux_sym_string_token1] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(1274),
    [anon_sym_LT_LT_LT] = ACTIONS(1274),
    [anon_sym_BQUOTE] = ACTIONS(1274),
    [anon_sym_DOLLAR] = ACTIONS(1274),
    [aux_sym_yield_expression_token1] = ACTIONS(1276),
    [aux_sym_include_expression_token1] = ACTIONS(1276),
    [aux_sym_include_once_expression_token1] = ACTIONS(1276),
    [aux_sym_require_expression_token1] = ACTIONS(1276),
    [aux_sym_require_once_expression_token1] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(1278),
    [sym_name] = ACTIONS(1280),
    [anon_sym_QMARK_GT] = ACTIONS(1278),
    [anon_sym_SEMI] = ACTIONS(1278),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1280),
    [aux_sym_global_declaration_token1] = ACTIONS(1280),
    [aux_sym_namespace_definition_token1] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1280),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1280),
    [anon_sym_BSLASH] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1278),
    [anon_sym_RBRACE] = ACTIONS(1278),
    [aux_sym_trait_declaration_token1] = ACTIONS(1280),
    [aux_sym_interface_declaration_token1] = ACTIONS(1280),
    [aux_sym_enum_declaration_token1] = ACTIONS(1280),
    [aux_sym_enum_case_token1] = ACTIONS(1280),
    [aux_sym_class_declaration_token1] = ACTIONS(1280),
    [aux_sym_final_modifier_token1] = ACTIONS(1280),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1280),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1280),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1280),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [aux_sym_cast_type_token1] = ACTIONS(1280),
    [aux_sym_echo_statement_token1] = ACTIONS(1280),
    [anon_sym_unset] = ACTIONS(1280),
    [aux_sym_declare_statement_token1] = ACTIONS(1280),
    [aux_sym_declare_statement_token2] = ACTIONS(1280),
    [sym_float] = ACTIONS(1280),
    [aux_sym_try_statement_token1] = ACTIONS(1280),
    [aux_sym_goto_statement_token1] = ACTIONS(1280),
    [aux_sym_continue_statement_token1] = ACTIONS(1280),
    [aux_sym_break_statement_token1] = ACTIONS(1280),
    [sym_integer] = ACTIONS(1280),
    [aux_sym_return_statement_token1] = ACTIONS(1280),
    [aux_sym_throw_expression_token1] = ACTIONS(1280),
    [aux_sym_while_statement_token1] = ACTIONS(1280),
    [aux_sym_while_statement_token2] = ACTIONS(1280),
    [aux_sym_do_statement_token1] = ACTIONS(1280),
    [aux_sym_for_statement_token1] = ACTIONS(1280),
    [aux_sym_for_statement_token2] = ACTIONS(1280),
    [aux_sym_foreach_statement_token1] = ACTIONS(1280),
    [aux_sym_foreach_statement_token2] = ACTIONS(1280),
    [aux_sym_if_statement_token1] = ACTIONS(1280),
    [aux_sym_if_statement_token2] = ACTIONS(1280),
    [aux_sym_else_if_clause_token1] = ACTIONS(1280),
    [aux_sym_else_clause_token1] = ACTIONS(1280),
    [aux_sym_match_expression_token1] = ACTIONS(1280),
    [aux_sym_match_default_expression_token1] = ACTIONS(1280),
    [aux_sym_switch_statement_token1] = ACTIONS(1280),
    [aux_sym_switch_block_token1] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1280),
    [anon_sym_TILDE] = ACTIONS(1278),
    [anon_sym_BANG] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1278),
    [aux_sym_clone_expression_token1] = ACTIONS(1280),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1280),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1278),
    [anon_sym_PLUS_PLUS] = ACTIONS(1278),
    [aux_sym__list_destructing_token1] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1278),
    [anon_sym_self] = ACTIONS(1280),
    [anon_sym_parent] = ACTIONS(1280),
    [aux_sym__argument_name_token1] = ACTIONS(1280),
    [aux_sym__argument_name_token2] = ACTIONS(1280),
    [anon_sym_POUND_LBRACK] = ACTIONS(1278),
    [aux_sym_encapsed_string_token1] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(1278),
    [aux_sym_string_token1] = ACTIONS(1278),
    [anon_sym_SQUOTE] = ACTIONS(1278),
    [anon_sym_LT_LT_LT] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1278),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [aux_sym_yield_expression_token1] = ACTIONS(1280),
    [aux_sym_include_expression_token1] = ACTIONS(1280),
    [aux_sym_include_once_expression_token1] = ACTIONS(1280),
    [aux_sym_require_expression_token1] = ACTIONS(1280),
    [aux_sym_require_once_expression_token1] = ACTIONS(1280),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(1282),
    [sym_name] = ACTIONS(1284),
    [anon_sym_QMARK_GT] = ACTIONS(1282),
    [anon_sym_SEMI] = ACTIONS(1282),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1284),
    [aux_sym_global_declaration_token1] = ACTIONS(1284),
    [aux_sym_namespace_definition_token1] = ACTIONS(1284),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1284),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1284),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1284),
    [anon_sym_BSLASH] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1282),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [aux_sym_trait_declaration_token1] = ACTIONS(1284),
    [aux_sym_interface_declaration_token1] = ACTIONS(1284),
    [aux_sym_enum_declaration_token1] = ACTIONS(1284),
    [aux_sym_enum_case_token1] = ACTIONS(1284),
    [aux_sym_class_declaration_token1] = ACTIONS(1284),
    [aux_sym_final_modifier_token1] = ACTIONS(1284),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1284),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1284),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1284),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1284),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1284),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [aux_sym_cast_type_token1] = ACTIONS(1284),
    [aux_sym_echo_statement_token1] = ACTIONS(1284),
    [anon_sym_unset] = ACTIONS(1284),
    [aux_sym_declare_statement_token1] = ACTIONS(1284),
    [aux_sym_declare_statement_token2] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [aux_sym_try_statement_token1] = ACTIONS(1284),
    [aux_sym_goto_statement_token1] = ACTIONS(1284),
    [aux_sym_continue_statement_token1] = ACTIONS(1284),
    [aux_sym_break_statement_token1] = ACTIONS(1284),
    [sym_integer] = ACTIONS(1284),
    [aux_sym_return_statement_token1] = ACTIONS(1284),
    [aux_sym_throw_expression_token1] = ACTIONS(1284),
    [aux_sym_while_statement_token1] = ACTIONS(1284),
    [aux_sym_while_statement_token2] = ACTIONS(1284),
    [aux_sym_do_statement_token1] = ACTIONS(1284),
    [aux_sym_for_statement_token1] = ACTIONS(1284),
    [aux_sym_for_statement_token2] = ACTIONS(1284),
    [aux_sym_foreach_statement_token1] = ACTIONS(1284),
    [aux_sym_foreach_statement_token2] = ACTIONS(1284),
    [aux_sym_if_statement_token1] = ACTIONS(1284),
    [aux_sym_if_statement_token2] = ACTIONS(1284),
    [aux_sym_else_if_clause_token1] = ACTIONS(1284),
    [aux_sym_else_clause_token1] = ACTIONS(1284),
    [aux_sym_match_expression_token1] = ACTIONS(1284),
    [aux_sym_match_default_expression_token1] = ACTIONS(1284),
    [aux_sym_switch_statement_token1] = ACTIONS(1284),
    [aux_sym_switch_block_token1] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(1282),
    [anon_sym_BANG] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(1282),
    [aux_sym_clone_expression_token1] = ACTIONS(1284),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1284),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1282),
    [anon_sym_PLUS_PLUS] = ACTIONS(1282),
    [aux_sym__list_destructing_token1] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_self] = ACTIONS(1284),
    [anon_sym_parent] = ACTIONS(1284),
    [aux_sym__argument_name_token1] = ACTIONS(1284),
    [aux_sym__argument_name_token2] = ACTIONS(1284),
    [anon_sym_POUND_LBRACK] = ACTIONS(1282),
    [aux_sym_encapsed_string_token1] = ACTIONS(1282),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [aux_sym_string_token1] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1282),
    [anon_sym_LT_LT_LT] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_DOLLAR] = ACTIONS(1282),
    [aux_sym_yield_expression_token1] = ACTIONS(1284),
    [aux_sym_include_expression_token1] = ACTIONS(1284),
    [aux_sym_include_once_expression_token1] = ACTIONS(1284),
    [aux_sym_require_expression_token1] = ACTIONS(1284),
    [aux_sym_require_once_expression_token1] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1286),
    [sym_name] = ACTIONS(1288),
    [anon_sym_QMARK_GT] = ACTIONS(1286),
    [anon_sym_SEMI] = ACTIONS(1286),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1288),
    [aux_sym_global_declaration_token1] = ACTIONS(1288),
    [aux_sym_namespace_definition_token1] = ACTIONS(1288),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1288),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1288),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1288),
    [anon_sym_BSLASH] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(1286),
    [anon_sym_RBRACE] = ACTIONS(1286),
    [aux_sym_trait_declaration_token1] = ACTIONS(1288),
    [aux_sym_interface_declaration_token1] = ACTIONS(1288),
    [aux_sym_enum_declaration_token1] = ACTIONS(1288),
    [aux_sym_enum_case_token1] = ACTIONS(1288),
    [aux_sym_class_declaration_token1] = ACTIONS(1288),
    [aux_sym_final_modifier_token1] = ACTIONS(1288),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1288),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1288),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1288),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1288),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1288),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(1286),
    [aux_sym_cast_type_token1] = ACTIONS(1288),
    [aux_sym_echo_statement_token1] = ACTIONS(1288),
    [anon_sym_unset] = ACTIONS(1288),
    [aux_sym_declare_statement_token1] = ACTIONS(1288),
    [aux_sym_declare_statement_token2] = ACTIONS(1288),
    [sym_float] = ACTIONS(1288),
    [aux_sym_try_statement_token1] = ACTIONS(1288),
    [aux_sym_goto_statement_token1] = ACTIONS(1288),
    [aux_sym_continue_statement_token1] = ACTIONS(1288),
    [aux_sym_break_statement_token1] = ACTIONS(1288),
    [sym_integer] = ACTIONS(1288),
    [aux_sym_return_statement_token1] = ACTIONS(1288),
    [aux_sym_throw_expression_token1] = ACTIONS(1288),
    [aux_sym_while_statement_token1] = ACTIONS(1288),
    [aux_sym_while_statement_token2] = ACTIONS(1288),
    [aux_sym_do_statement_token1] = ACTIONS(1288),
    [aux_sym_for_statement_token1] = ACTIONS(1288),
    [aux_sym_for_statement_token2] = ACTIONS(1288),
    [aux_sym_foreach_statement_token1] = ACTIONS(1288),
    [aux_sym_foreach_statement_token2] = ACTIONS(1288),
    [aux_sym_if_statement_token1] = ACTIONS(1288),
    [aux_sym_if_statement_token2] = ACTIONS(1288),
    [aux_sym_else_if_clause_token1] = ACTIONS(1288),
    [aux_sym_else_clause_token1] = ACTIONS(1288),
    [aux_sym_match_expression_token1] = ACTIONS(1288),
    [aux_sym_match_default_expression_token1] = ACTIONS(1288),
    [aux_sym_switch_statement_token1] = ACTIONS(1288),
    [aux_sym_switch_block_token1] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_TILDE] = ACTIONS(1286),
    [anon_sym_BANG] = ACTIONS(1286),
    [anon_sym_AT] = ACTIONS(1286),
    [aux_sym_clone_expression_token1] = ACTIONS(1288),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1288),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1288),
    [anon_sym_DASH_DASH] = ACTIONS(1286),
    [anon_sym_PLUS_PLUS] = ACTIONS(1286),
    [aux_sym__list_destructing_token1] = ACTIONS(1288),
    [anon_sym_LBRACK] = ACTIONS(1286),
    [anon_sym_self] = ACTIONS(1288),
    [anon_sym_parent] = ACTIONS(1288),
    [aux_sym__argument_name_token1] = ACTIONS(1288),
    [aux_sym__argument_name_token2] = ACTIONS(1288),
    [anon_sym_POUND_LBRACK] = ACTIONS(1286),
    [aux_sym_encapsed_string_token1] = ACTIONS(1286),
    [anon_sym_DQUOTE] = ACTIONS(1286),
    [aux_sym_string_token1] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(1286),
    [anon_sym_LT_LT_LT] = ACTIONS(1286),
    [anon_sym_BQUOTE] = ACTIONS(1286),
    [anon_sym_DOLLAR] = ACTIONS(1286),
    [aux_sym_yield_expression_token1] = ACTIONS(1288),
    [aux_sym_include_expression_token1] = ACTIONS(1288),
    [aux_sym_include_once_expression_token1] = ACTIONS(1288),
    [aux_sym_require_expression_token1] = ACTIONS(1288),
    [aux_sym_require_once_expression_token1] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(1290),
    [sym_name] = ACTIONS(1292),
    [anon_sym_QMARK_GT] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1292),
    [aux_sym_global_declaration_token1] = ACTIONS(1292),
    [aux_sym_namespace_definition_token1] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1292),
    [anon_sym_BSLASH] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [aux_sym_trait_declaration_token1] = ACTIONS(1292),
    [aux_sym_interface_declaration_token1] = ACTIONS(1292),
    [aux_sym_enum_declaration_token1] = ACTIONS(1292),
    [aux_sym_enum_case_token1] = ACTIONS(1292),
    [aux_sym_class_declaration_token1] = ACTIONS(1292),
    [aux_sym_final_modifier_token1] = ACTIONS(1292),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1292),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1292),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [aux_sym_cast_type_token1] = ACTIONS(1292),
    [aux_sym_echo_statement_token1] = ACTIONS(1292),
    [anon_sym_unset] = ACTIONS(1292),
    [aux_sym_declare_statement_token1] = ACTIONS(1292),
    [aux_sym_declare_statement_token2] = ACTIONS(1292),
    [sym_float] = ACTIONS(1292),
    [aux_sym_try_statement_token1] = ACTIONS(1292),
    [aux_sym_goto_statement_token1] = ACTIONS(1292),
    [aux_sym_continue_statement_token1] = ACTIONS(1292),
    [aux_sym_break_statement_token1] = ACTIONS(1292),
    [sym_integer] = ACTIONS(1292),
    [aux_sym_return_statement_token1] = ACTIONS(1292),
    [aux_sym_throw_expression_token1] = ACTIONS(1292),
    [aux_sym_while_statement_token1] = ACTIONS(1292),
    [aux_sym_while_statement_token2] = ACTIONS(1292),
    [aux_sym_do_statement_token1] = ACTIONS(1292),
    [aux_sym_for_statement_token1] = ACTIONS(1292),
    [aux_sym_for_statement_token2] = ACTIONS(1292),
    [aux_sym_foreach_statement_token1] = ACTIONS(1292),
    [aux_sym_foreach_statement_token2] = ACTIONS(1292),
    [aux_sym_if_statement_token1] = ACTIONS(1292),
    [aux_sym_if_statement_token2] = ACTIONS(1292),
    [aux_sym_else_if_clause_token1] = ACTIONS(1292),
    [aux_sym_else_clause_token1] = ACTIONS(1292),
    [aux_sym_match_expression_token1] = ACTIONS(1292),
    [aux_sym_match_default_expression_token1] = ACTIONS(1292),
    [aux_sym_switch_statement_token1] = ACTIONS(1292),
    [aux_sym_switch_block_token1] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(1290),
    [aux_sym_clone_expression_token1] = ACTIONS(1292),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [aux_sym__list_destructing_token1] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_self] = ACTIONS(1292),
    [anon_sym_parent] = ACTIONS(1292),
    [aux_sym__argument_name_token1] = ACTIONS(1292),
    [aux_sym__argument_name_token2] = ACTIONS(1292),
    [anon_sym_POUND_LBRACK] = ACTIONS(1290),
    [aux_sym_encapsed_string_token1] = ACTIONS(1290),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [aux_sym_string_token1] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1290),
    [anon_sym_LT_LT_LT] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_DOLLAR] = ACTIONS(1290),
    [aux_sym_yield_expression_token1] = ACTIONS(1292),
    [aux_sym_include_expression_token1] = ACTIONS(1292),
    [aux_sym_include_once_expression_token1] = ACTIONS(1292),
    [aux_sym_require_expression_token1] = ACTIONS(1292),
    [aux_sym_require_once_expression_token1] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(1294),
    [sym_name] = ACTIONS(1296),
    [anon_sym_QMARK_GT] = ACTIONS(1294),
    [anon_sym_SEMI] = ACTIONS(1294),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1296),
    [aux_sym_global_declaration_token1] = ACTIONS(1296),
    [aux_sym_namespace_definition_token1] = ACTIONS(1296),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1296),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1296),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1296),
    [anon_sym_BSLASH] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(1294),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [aux_sym_trait_declaration_token1] = ACTIONS(1296),
    [aux_sym_interface_declaration_token1] = ACTIONS(1296),
    [aux_sym_enum_declaration_token1] = ACTIONS(1296),
    [aux_sym_enum_case_token1] = ACTIONS(1296),
    [aux_sym_class_declaration_token1] = ACTIONS(1296),
    [aux_sym_final_modifier_token1] = ACTIONS(1296),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1296),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1296),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1296),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1296),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1296),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(1294),
    [aux_sym_cast_type_token1] = ACTIONS(1296),
    [aux_sym_echo_statement_token1] = ACTIONS(1296),
    [anon_sym_unset] = ACTIONS(1296),
    [aux_sym_declare_statement_token1] = ACTIONS(1296),
    [aux_sym_declare_statement_token2] = ACTIONS(1296),
    [sym_float] = ACTIONS(1296),
    [aux_sym_try_statement_token1] = ACTIONS(1296),
    [aux_sym_goto_statement_token1] = ACTIONS(1296),
    [aux_sym_continue_statement_token1] = ACTIONS(1296),
    [aux_sym_break_statement_token1] = ACTIONS(1296),
    [sym_integer] = ACTIONS(1296),
    [aux_sym_return_statement_token1] = ACTIONS(1296),
    [aux_sym_throw_expression_token1] = ACTIONS(1296),
    [aux_sym_while_statement_token1] = ACTIONS(1296),
    [aux_sym_while_statement_token2] = ACTIONS(1296),
    [aux_sym_do_statement_token1] = ACTIONS(1296),
    [aux_sym_for_statement_token1] = ACTIONS(1296),
    [aux_sym_for_statement_token2] = ACTIONS(1296),
    [aux_sym_foreach_statement_token1] = ACTIONS(1296),
    [aux_sym_foreach_statement_token2] = ACTIONS(1296),
    [aux_sym_if_statement_token1] = ACTIONS(1296),
    [aux_sym_if_statement_token2] = ACTIONS(1296),
    [aux_sym_else_if_clause_token1] = ACTIONS(1296),
    [aux_sym_else_clause_token1] = ACTIONS(1296),
    [aux_sym_match_expression_token1] = ACTIONS(1296),
    [aux_sym_match_default_expression_token1] = ACTIONS(1296),
    [aux_sym_switch_statement_token1] = ACTIONS(1296),
    [aux_sym_switch_block_token1] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_TILDE] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(1294),
    [anon_sym_AT] = ACTIONS(1294),
    [aux_sym_clone_expression_token1] = ACTIONS(1296),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1296),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1296),
    [anon_sym_DASH_DASH] = ACTIONS(1294),
    [anon_sym_PLUS_PLUS] = ACTIONS(1294),
    [aux_sym__list_destructing_token1] = ACTIONS(1296),
    [anon_sym_LBRACK] = ACTIONS(1294),
    [anon_sym_self] = ACTIONS(1296),
    [anon_sym_parent] = ACTIONS(1296),
    [aux_sym__argument_name_token1] = ACTIONS(1296),
    [aux_sym__argument_name_token2] = ACTIONS(1296),
    [anon_sym_POUND_LBRACK] = ACTIONS(1294),
    [aux_sym_encapsed_string_token1] = ACTIONS(1294),
    [anon_sym_DQUOTE] = ACTIONS(1294),
    [aux_sym_string_token1] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(1294),
    [anon_sym_LT_LT_LT] = ACTIONS(1294),
    [anon_sym_BQUOTE] = ACTIONS(1294),
    [anon_sym_DOLLAR] = ACTIONS(1294),
    [aux_sym_yield_expression_token1] = ACTIONS(1296),
    [aux_sym_include_expression_token1] = ACTIONS(1296),
    [aux_sym_include_once_expression_token1] = ACTIONS(1296),
    [aux_sym_require_expression_token1] = ACTIONS(1296),
    [aux_sym_require_once_expression_token1] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(1298),
    [sym_name] = ACTIONS(1300),
    [anon_sym_QMARK_GT] = ACTIONS(1298),
    [anon_sym_SEMI] = ACTIONS(1298),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1300),
    [aux_sym_global_declaration_token1] = ACTIONS(1300),
    [aux_sym_namespace_definition_token1] = ACTIONS(1300),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1300),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1300),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1300),
    [anon_sym_BSLASH] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_RBRACE] = ACTIONS(1298),
    [aux_sym_trait_declaration_token1] = ACTIONS(1300),
    [aux_sym_interface_declaration_token1] = ACTIONS(1300),
    [aux_sym_enum_declaration_token1] = ACTIONS(1300),
    [aux_sym_enum_case_token1] = ACTIONS(1300),
    [aux_sym_class_declaration_token1] = ACTIONS(1300),
    [aux_sym_final_modifier_token1] = ACTIONS(1300),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1300),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1300),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1300),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1300),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1300),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1298),
    [aux_sym_cast_type_token1] = ACTIONS(1300),
    [aux_sym_echo_statement_token1] = ACTIONS(1300),
    [anon_sym_unset] = ACTIONS(1300),
    [aux_sym_declare_statement_token1] = ACTIONS(1300),
    [aux_sym_declare_statement_token2] = ACTIONS(1300),
    [sym_float] = ACTIONS(1300),
    [aux_sym_try_statement_token1] = ACTIONS(1300),
    [aux_sym_goto_statement_token1] = ACTIONS(1300),
    [aux_sym_continue_statement_token1] = ACTIONS(1300),
    [aux_sym_break_statement_token1] = ACTIONS(1300),
    [sym_integer] = ACTIONS(1300),
    [aux_sym_return_statement_token1] = ACTIONS(1300),
    [aux_sym_throw_expression_token1] = ACTIONS(1300),
    [aux_sym_while_statement_token1] = ACTIONS(1300),
    [aux_sym_while_statement_token2] = ACTIONS(1300),
    [aux_sym_do_statement_token1] = ACTIONS(1300),
    [aux_sym_for_statement_token1] = ACTIONS(1300),
    [aux_sym_for_statement_token2] = ACTIONS(1300),
    [aux_sym_foreach_statement_token1] = ACTIONS(1300),
    [aux_sym_foreach_statement_token2] = ACTIONS(1300),
    [aux_sym_if_statement_token1] = ACTIONS(1300),
    [aux_sym_if_statement_token2] = ACTIONS(1300),
    [aux_sym_else_if_clause_token1] = ACTIONS(1300),
    [aux_sym_else_clause_token1] = ACTIONS(1300),
    [aux_sym_match_expression_token1] = ACTIONS(1300),
    [aux_sym_match_default_expression_token1] = ACTIONS(1300),
    [aux_sym_switch_statement_token1] = ACTIONS(1300),
    [aux_sym_switch_block_token1] = ACTIONS(1300),
    [anon_sym_PLUS] = ACTIONS(1300),
    [anon_sym_DASH] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1298),
    [anon_sym_BANG] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(1298),
    [aux_sym_clone_expression_token1] = ACTIONS(1300),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1300),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1300),
    [anon_sym_DASH_DASH] = ACTIONS(1298),
    [anon_sym_PLUS_PLUS] = ACTIONS(1298),
    [aux_sym__list_destructing_token1] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1298),
    [anon_sym_self] = ACTIONS(1300),
    [anon_sym_parent] = ACTIONS(1300),
    [aux_sym__argument_name_token1] = ACTIONS(1300),
    [aux_sym__argument_name_token2] = ACTIONS(1300),
    [anon_sym_POUND_LBRACK] = ACTIONS(1298),
    [aux_sym_encapsed_string_token1] = ACTIONS(1298),
    [anon_sym_DQUOTE] = ACTIONS(1298),
    [aux_sym_string_token1] = ACTIONS(1298),
    [anon_sym_SQUOTE] = ACTIONS(1298),
    [anon_sym_LT_LT_LT] = ACTIONS(1298),
    [anon_sym_BQUOTE] = ACTIONS(1298),
    [anon_sym_DOLLAR] = ACTIONS(1298),
    [aux_sym_yield_expression_token1] = ACTIONS(1300),
    [aux_sym_include_expression_token1] = ACTIONS(1300),
    [aux_sym_include_once_expression_token1] = ACTIONS(1300),
    [aux_sym_require_expression_token1] = ACTIONS(1300),
    [aux_sym_require_once_expression_token1] = ACTIONS(1300),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(1302),
    [sym_name] = ACTIONS(1304),
    [anon_sym_QMARK_GT] = ACTIONS(1302),
    [anon_sym_SEMI] = ACTIONS(1302),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1304),
    [aux_sym_global_declaration_token1] = ACTIONS(1304),
    [aux_sym_namespace_definition_token1] = ACTIONS(1304),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1304),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1304),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1304),
    [anon_sym_BSLASH] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [aux_sym_trait_declaration_token1] = ACTIONS(1304),
    [aux_sym_interface_declaration_token1] = ACTIONS(1304),
    [aux_sym_enum_declaration_token1] = ACTIONS(1304),
    [aux_sym_enum_case_token1] = ACTIONS(1304),
    [aux_sym_class_declaration_token1] = ACTIONS(1304),
    [aux_sym_final_modifier_token1] = ACTIONS(1304),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1304),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1304),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1304),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1304),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1304),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [aux_sym_cast_type_token1] = ACTIONS(1304),
    [aux_sym_echo_statement_token1] = ACTIONS(1304),
    [anon_sym_unset] = ACTIONS(1304),
    [aux_sym_declare_statement_token1] = ACTIONS(1304),
    [aux_sym_declare_statement_token2] = ACTIONS(1304),
    [sym_float] = ACTIONS(1304),
    [aux_sym_try_statement_token1] = ACTIONS(1304),
    [aux_sym_goto_statement_token1] = ACTIONS(1304),
    [aux_sym_continue_statement_token1] = ACTIONS(1304),
    [aux_sym_break_statement_token1] = ACTIONS(1304),
    [sym_integer] = ACTIONS(1304),
    [aux_sym_return_statement_token1] = ACTIONS(1304),
    [aux_sym_throw_expression_token1] = ACTIONS(1304),
    [aux_sym_while_statement_token1] = ACTIONS(1304),
    [aux_sym_while_statement_token2] = ACTIONS(1304),
    [aux_sym_do_statement_token1] = ACTIONS(1304),
    [aux_sym_for_statement_token1] = ACTIONS(1304),
    [aux_sym_for_statement_token2] = ACTIONS(1304),
    [aux_sym_foreach_statement_token1] = ACTIONS(1304),
    [aux_sym_foreach_statement_token2] = ACTIONS(1304),
    [aux_sym_if_statement_token1] = ACTIONS(1304),
    [aux_sym_if_statement_token2] = ACTIONS(1304),
    [aux_sym_else_if_clause_token1] = ACTIONS(1304),
    [aux_sym_else_clause_token1] = ACTIONS(1304),
    [aux_sym_match_expression_token1] = ACTIONS(1304),
    [aux_sym_match_default_expression_token1] = ACTIONS(1304),
    [aux_sym_switch_statement_token1] = ACTIONS(1304),
    [aux_sym_switch_block_token1] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_TILDE] = ACTIONS(1302),
    [anon_sym_BANG] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1302),
    [aux_sym_clone_expression_token1] = ACTIONS(1304),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1304),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1304),
    [anon_sym_DASH_DASH] = ACTIONS(1302),
    [anon_sym_PLUS_PLUS] = ACTIONS(1302),
    [aux_sym__list_destructing_token1] = ACTIONS(1304),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [anon_sym_self] = ACTIONS(1304),
    [anon_sym_parent] = ACTIONS(1304),
    [aux_sym__argument_name_token1] = ACTIONS(1304),
    [aux_sym__argument_name_token2] = ACTIONS(1304),
    [anon_sym_POUND_LBRACK] = ACTIONS(1302),
    [aux_sym_encapsed_string_token1] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [aux_sym_string_token1] = ACTIONS(1302),
    [anon_sym_SQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(1302),
    [aux_sym_yield_expression_token1] = ACTIONS(1304),
    [aux_sym_include_expression_token1] = ACTIONS(1304),
    [aux_sym_include_once_expression_token1] = ACTIONS(1304),
    [aux_sym_require_expression_token1] = ACTIONS(1304),
    [aux_sym_require_once_expression_token1] = ACTIONS(1304),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(1258),
    [sym_name] = ACTIONS(1260),
    [anon_sym_QMARK_GT] = ACTIONS(1258),
    [anon_sym_SEMI] = ACTIONS(1258),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1260),
    [aux_sym_global_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_definition_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1260),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1260),
    [anon_sym_BSLASH] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_RBRACE] = ACTIONS(1258),
    [aux_sym_trait_declaration_token1] = ACTIONS(1260),
    [aux_sym_interface_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_declaration_token1] = ACTIONS(1260),
    [aux_sym_enum_case_token1] = ACTIONS(1260),
    [aux_sym_class_declaration_token1] = ACTIONS(1260),
    [aux_sym_final_modifier_token1] = ACTIONS(1260),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1260),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1260),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1260),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [aux_sym_cast_type_token1] = ACTIONS(1260),
    [aux_sym_echo_statement_token1] = ACTIONS(1260),
    [anon_sym_unset] = ACTIONS(1260),
    [aux_sym_declare_statement_token1] = ACTIONS(1260),
    [aux_sym_declare_statement_token2] = ACTIONS(1260),
    [sym_float] = ACTIONS(1260),
    [aux_sym_try_statement_token1] = ACTIONS(1260),
    [aux_sym_goto_statement_token1] = ACTIONS(1260),
    [aux_sym_continue_statement_token1] = ACTIONS(1260),
    [aux_sym_break_statement_token1] = ACTIONS(1260),
    [sym_integer] = ACTIONS(1260),
    [aux_sym_return_statement_token1] = ACTIONS(1260),
    [aux_sym_throw_expression_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token1] = ACTIONS(1260),
    [aux_sym_while_statement_token2] = ACTIONS(1260),
    [aux_sym_do_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token1] = ACTIONS(1260),
    [aux_sym_for_statement_token2] = ACTIONS(1260),
    [aux_sym_foreach_statement_token1] = ACTIONS(1260),
    [aux_sym_foreach_statement_token2] = ACTIONS(1260),
    [aux_sym_if_statement_token1] = ACTIONS(1260),
    [aux_sym_if_statement_token2] = ACTIONS(1260),
    [aux_sym_else_if_clause_token1] = ACTIONS(1260),
    [aux_sym_else_clause_token1] = ACTIONS(1260),
    [aux_sym_match_expression_token1] = ACTIONS(1260),
    [aux_sym_match_default_expression_token1] = ACTIONS(1260),
    [aux_sym_switch_statement_token1] = ACTIONS(1260),
    [aux_sym_switch_block_token1] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_TILDE] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1258),
    [aux_sym_clone_expression_token1] = ACTIONS(1260),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1260),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1258),
    [anon_sym_PLUS_PLUS] = ACTIONS(1258),
    [aux_sym__list_destructing_token1] = ACTIONS(1260),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_self] = ACTIONS(1260),
    [anon_sym_parent] = ACTIONS(1260),
    [aux_sym__argument_name_token1] = ACTIONS(1260),
    [aux_sym__argument_name_token2] = ACTIONS(1260),
    [anon_sym_POUND_LBRACK] = ACTIONS(1258),
    [aux_sym_encapsed_string_token1] = ACTIONS(1258),
    [anon_sym_DQUOTE] = ACTIONS(1258),
    [aux_sym_string_token1] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1258),
    [anon_sym_LT_LT_LT] = ACTIONS(1258),
    [anon_sym_BQUOTE] = ACTIONS(1258),
    [anon_sym_DOLLAR] = ACTIONS(1258),
    [aux_sym_yield_expression_token1] = ACTIONS(1260),
    [aux_sym_include_expression_token1] = ACTIONS(1260),
    [aux_sym_include_once_expression_token1] = ACTIONS(1260),
    [aux_sym_require_expression_token1] = ACTIONS(1260),
    [aux_sym_require_once_expression_token1] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(1306),
    [sym_name] = ACTIONS(1308),
    [anon_sym_QMARK_GT] = ACTIONS(1306),
    [anon_sym_SEMI] = ACTIONS(1306),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1308),
    [aux_sym_global_declaration_token1] = ACTIONS(1308),
    [aux_sym_namespace_definition_token1] = ACTIONS(1308),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1308),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1308),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1308),
    [anon_sym_BSLASH] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1306),
    [anon_sym_RBRACE] = ACTIONS(1306),
    [aux_sym_trait_declaration_token1] = ACTIONS(1308),
    [aux_sym_interface_declaration_token1] = ACTIONS(1308),
    [aux_sym_enum_declaration_token1] = ACTIONS(1308),
    [aux_sym_enum_case_token1] = ACTIONS(1308),
    [aux_sym_class_declaration_token1] = ACTIONS(1308),
    [aux_sym_final_modifier_token1] = ACTIONS(1308),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1308),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1308),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1308),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1308),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1308),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1306),
    [aux_sym_cast_type_token1] = ACTIONS(1308),
    [aux_sym_echo_statement_token1] = ACTIONS(1308),
    [anon_sym_unset] = ACTIONS(1308),
    [aux_sym_declare_statement_token1] = ACTIONS(1308),
    [aux_sym_declare_statement_token2] = ACTIONS(1308),
    [sym_float] = ACTIONS(1308),
    [aux_sym_try_statement_token1] = ACTIONS(1308),
    [aux_sym_goto_statement_token1] = ACTIONS(1308),
    [aux_sym_continue_statement_token1] = ACTIONS(1308),
    [aux_sym_break_statement_token1] = ACTIONS(1308),
    [sym_integer] = ACTIONS(1308),
    [aux_sym_return_statement_token1] = ACTIONS(1308),
    [aux_sym_throw_expression_token1] = ACTIONS(1308),
    [aux_sym_while_statement_token1] = ACTIONS(1308),
    [aux_sym_while_statement_token2] = ACTIONS(1308),
    [aux_sym_do_statement_token1] = ACTIONS(1308),
    [aux_sym_for_statement_token1] = ACTIONS(1308),
    [aux_sym_for_statement_token2] = ACTIONS(1308),
    [aux_sym_foreach_statement_token1] = ACTIONS(1308),
    [aux_sym_foreach_statement_token2] = ACTIONS(1308),
    [aux_sym_if_statement_token1] = ACTIONS(1308),
    [aux_sym_if_statement_token2] = ACTIONS(1308),
    [aux_sym_else_if_clause_token1] = ACTIONS(1308),
    [aux_sym_else_clause_token1] = ACTIONS(1308),
    [aux_sym_match_expression_token1] = ACTIONS(1308),
    [aux_sym_match_default_expression_token1] = ACTIONS(1308),
    [aux_sym_switch_statement_token1] = ACTIONS(1308),
    [aux_sym_switch_block_token1] = ACTIONS(1308),
    [anon_sym_PLUS] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1308),
    [anon_sym_TILDE] = ACTIONS(1306),
    [anon_sym_BANG] = ACTIONS(1306),
    [anon_sym_AT] = ACTIONS(1306),
    [aux_sym_clone_expression_token1] = ACTIONS(1308),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1308),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1308),
    [anon_sym_DASH_DASH] = ACTIONS(1306),
    [anon_sym_PLUS_PLUS] = ACTIONS(1306),
    [aux_sym__list_destructing_token1] = ACTIONS(1308),
    [anon_sym_LBRACK] = ACTIONS(1306),
    [anon_sym_self] = ACTIONS(1308),
    [anon_sym_parent] = ACTIONS(1308),
    [aux_sym__argument_name_token1] = ACTIONS(1308),
    [aux_sym__argument_name_token2] = ACTIONS(1308),
    [anon_sym_POUND_LBRACK] = ACTIONS(1306),
    [aux_sym_encapsed_string_token1] = ACTIONS(1306),
    [anon_sym_DQUOTE] = ACTIONS(1306),
    [aux_sym_string_token1] = ACTIONS(1306),
    [anon_sym_SQUOTE] = ACTIONS(1306),
    [anon_sym_LT_LT_LT] = ACTIONS(1306),
    [anon_sym_BQUOTE] = ACTIONS(1306),
    [anon_sym_DOLLAR] = ACTIONS(1306),
    [aux_sym_yield_expression_token1] = ACTIONS(1308),
    [aux_sym_include_expression_token1] = ACTIONS(1308),
    [aux_sym_include_once_expression_token1] = ACTIONS(1308),
    [aux_sym_require_expression_token1] = ACTIONS(1308),
    [aux_sym_require_once_expression_token1] = ACTIONS(1308),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(1310),
    [sym_name] = ACTIONS(1312),
    [anon_sym_QMARK_GT] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1310),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1312),
    [aux_sym_global_declaration_token1] = ACTIONS(1312),
    [aux_sym_namespace_definition_token1] = ACTIONS(1312),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1312),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1312),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1312),
    [anon_sym_BSLASH] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [aux_sym_trait_declaration_token1] = ACTIONS(1312),
    [aux_sym_interface_declaration_token1] = ACTIONS(1312),
    [aux_sym_enum_declaration_token1] = ACTIONS(1312),
    [aux_sym_enum_case_token1] = ACTIONS(1312),
    [aux_sym_class_declaration_token1] = ACTIONS(1312),
    [aux_sym_final_modifier_token1] = ACTIONS(1312),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1312),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1312),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1312),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1312),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1312),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [aux_sym_cast_type_token1] = ACTIONS(1312),
    [aux_sym_echo_statement_token1] = ACTIONS(1312),
    [anon_sym_unset] = ACTIONS(1312),
    [aux_sym_declare_statement_token1] = ACTIONS(1312),
    [aux_sym_declare_statement_token2] = ACTIONS(1312),
    [sym_float] = ACTIONS(1312),
    [aux_sym_try_statement_token1] = ACTIONS(1312),
    [aux_sym_goto_statement_token1] = ACTIONS(1312),
    [aux_sym_continue_statement_token1] = ACTIONS(1312),
    [aux_sym_break_statement_token1] = ACTIONS(1312),
    [sym_integer] = ACTIONS(1312),
    [aux_sym_return_statement_token1] = ACTIONS(1312),
    [aux_sym_throw_expression_token1] = ACTIONS(1312),
    [aux_sym_while_statement_token1] = ACTIONS(1312),
    [aux_sym_while_statement_token2] = ACTIONS(1312),
    [aux_sym_do_statement_token1] = ACTIONS(1312),
    [aux_sym_for_statement_token1] = ACTIONS(1312),
    [aux_sym_for_statement_token2] = ACTIONS(1312),
    [aux_sym_foreach_statement_token1] = ACTIONS(1312),
    [aux_sym_foreach_statement_token2] = ACTIONS(1312),
    [aux_sym_if_statement_token1] = ACTIONS(1312),
    [aux_sym_if_statement_token2] = ACTIONS(1312),
    [aux_sym_else_if_clause_token1] = ACTIONS(1312),
    [aux_sym_else_clause_token1] = ACTIONS(1312),
    [aux_sym_match_expression_token1] = ACTIONS(1312),
    [aux_sym_match_default_expression_token1] = ACTIONS(1312),
    [aux_sym_switch_statement_token1] = ACTIONS(1312),
    [aux_sym_switch_block_token1] = ACTIONS(1312),
    [anon_sym_PLUS] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1312),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1310),
    [aux_sym_clone_expression_token1] = ACTIONS(1312),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1312),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1312),
    [anon_sym_DASH_DASH] = ACTIONS(1310),
    [anon_sym_PLUS_PLUS] = ACTIONS(1310),
    [aux_sym__list_destructing_token1] = ACTIONS(1312),
    [anon_sym_LBRACK] = ACTIONS(1310),
    [anon_sym_self] = ACTIONS(1312),
    [anon_sym_parent] = ACTIONS(1312),
    [aux_sym__argument_name_token1] = ACTIONS(1312),
    [aux_sym__argument_name_token2] = ACTIONS(1312),
    [anon_sym_POUND_LBRACK] = ACTIONS(1310),
    [aux_sym_encapsed_string_token1] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(1310),
    [aux_sym_string_token1] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1310),
    [anon_sym_LT_LT_LT] = ACTIONS(1310),
    [anon_sym_BQUOTE] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(1310),
    [aux_sym_yield_expression_token1] = ACTIONS(1312),
    [aux_sym_include_expression_token1] = ACTIONS(1312),
    [aux_sym_include_once_expression_token1] = ACTIONS(1312),
    [aux_sym_require_expression_token1] = ACTIONS(1312),
    [aux_sym_require_once_expression_token1] = ACTIONS(1312),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1314),
    [sym_name] = ACTIONS(1316),
    [anon_sym_QMARK_GT] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1314),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1316),
    [aux_sym_global_declaration_token1] = ACTIONS(1316),
    [aux_sym_namespace_definition_token1] = ACTIONS(1316),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1316),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1316),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1316),
    [anon_sym_BSLASH] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [aux_sym_trait_declaration_token1] = ACTIONS(1316),
    [aux_sym_interface_declaration_token1] = ACTIONS(1316),
    [aux_sym_enum_declaration_token1] = ACTIONS(1316),
    [aux_sym_enum_case_token1] = ACTIONS(1316),
    [aux_sym_class_declaration_token1] = ACTIONS(1316),
    [aux_sym_final_modifier_token1] = ACTIONS(1316),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1316),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1316),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1316),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1316),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1316),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [aux_sym_cast_type_token1] = ACTIONS(1316),
    [aux_sym_echo_statement_token1] = ACTIONS(1316),
    [anon_sym_unset] = ACTIONS(1316),
    [aux_sym_declare_statement_token1] = ACTIONS(1316),
    [aux_sym_declare_statement_token2] = ACTIONS(1316),
    [sym_float] = ACTIONS(1316),
    [aux_sym_try_statement_token1] = ACTIONS(1316),
    [aux_sym_goto_statement_token1] = ACTIONS(1316),
    [aux_sym_continue_statement_token1] = ACTIONS(1316),
    [aux_sym_break_statement_token1] = ACTIONS(1316),
    [sym_integer] = ACTIONS(1316),
    [aux_sym_return_statement_token1] = ACTIONS(1316),
    [aux_sym_throw_expression_token1] = ACTIONS(1316),
    [aux_sym_while_statement_token1] = ACTIONS(1316),
    [aux_sym_while_statement_token2] = ACTIONS(1316),
    [aux_sym_do_statement_token1] = ACTIONS(1316),
    [aux_sym_for_statement_token1] = ACTIONS(1316),
    [aux_sym_for_statement_token2] = ACTIONS(1316),
    [aux_sym_foreach_statement_token1] = ACTIONS(1316),
    [aux_sym_foreach_statement_token2] = ACTIONS(1316),
    [aux_sym_if_statement_token1] = ACTIONS(1316),
    [aux_sym_if_statement_token2] = ACTIONS(1316),
    [aux_sym_else_if_clause_token1] = ACTIONS(1316),
    [aux_sym_else_clause_token1] = ACTIONS(1316),
    [aux_sym_match_expression_token1] = ACTIONS(1316),
    [aux_sym_match_default_expression_token1] = ACTIONS(1316),
    [aux_sym_switch_statement_token1] = ACTIONS(1316),
    [aux_sym_switch_block_token1] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1314),
    [anon_sym_AT] = ACTIONS(1314),
    [aux_sym_clone_expression_token1] = ACTIONS(1316),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1316),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1314),
    [aux_sym__list_destructing_token1] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_self] = ACTIONS(1316),
    [anon_sym_parent] = ACTIONS(1316),
    [aux_sym__argument_name_token1] = ACTIONS(1316),
    [aux_sym__argument_name_token2] = ACTIONS(1316),
    [anon_sym_POUND_LBRACK] = ACTIONS(1314),
    [aux_sym_encapsed_string_token1] = ACTIONS(1314),
    [anon_sym_DQUOTE] = ACTIONS(1314),
    [aux_sym_string_token1] = ACTIONS(1314),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_LT_LT_LT] = ACTIONS(1314),
    [anon_sym_BQUOTE] = ACTIONS(1314),
    [anon_sym_DOLLAR] = ACTIONS(1314),
    [aux_sym_yield_expression_token1] = ACTIONS(1316),
    [aux_sym_include_expression_token1] = ACTIONS(1316),
    [aux_sym_include_once_expression_token1] = ACTIONS(1316),
    [aux_sym_require_expression_token1] = ACTIONS(1316),
    [aux_sym_require_once_expression_token1] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(1318),
    [sym_name] = ACTIONS(1320),
    [anon_sym_QMARK_GT] = ACTIONS(1318),
    [anon_sym_SEMI] = ACTIONS(1318),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1320),
    [aux_sym_global_declaration_token1] = ACTIONS(1320),
    [aux_sym_namespace_definition_token1] = ACTIONS(1320),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1320),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1320),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1320),
    [anon_sym_BSLASH] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [aux_sym_trait_declaration_token1] = ACTIONS(1320),
    [aux_sym_interface_declaration_token1] = ACTIONS(1320),
    [aux_sym_enum_declaration_token1] = ACTIONS(1320),
    [aux_sym_enum_case_token1] = ACTIONS(1320),
    [aux_sym_class_declaration_token1] = ACTIONS(1320),
    [aux_sym_final_modifier_token1] = ACTIONS(1320),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1320),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1320),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1320),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1320),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1320),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1320),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [aux_sym_cast_type_token1] = ACTIONS(1320),
    [aux_sym_echo_statement_token1] = ACTIONS(1320),
    [anon_sym_unset] = ACTIONS(1320),
    [aux_sym_declare_statement_token1] = ACTIONS(1320),
    [aux_sym_declare_statement_token2] = ACTIONS(1320),
    [sym_float] = ACTIONS(1320),
    [aux_sym_try_statement_token1] = ACTIONS(1320),
    [aux_sym_goto_statement_token1] = ACTIONS(1320),
    [aux_sym_continue_statement_token1] = ACTIONS(1320),
    [aux_sym_break_statement_token1] = ACTIONS(1320),
    [sym_integer] = ACTIONS(1320),
    [aux_sym_return_statement_token1] = ACTIONS(1320),
    [aux_sym_throw_expression_token1] = ACTIONS(1320),
    [aux_sym_while_statement_token1] = ACTIONS(1320),
    [aux_sym_while_statement_token2] = ACTIONS(1320),
    [aux_sym_do_statement_token1] = ACTIONS(1320),
    [aux_sym_for_statement_token1] = ACTIONS(1320),
    [aux_sym_for_statement_token2] = ACTIONS(1320),
    [aux_sym_foreach_statement_token1] = ACTIONS(1320),
    [aux_sym_foreach_statement_token2] = ACTIONS(1320),
    [aux_sym_if_statement_token1] = ACTIONS(1320),
    [aux_sym_if_statement_token2] = ACTIONS(1320),
    [aux_sym_else_if_clause_token1] = ACTIONS(1320),
    [aux_sym_else_clause_token1] = ACTIONS(1320),
    [aux_sym_match_expression_token1] = ACTIONS(1320),
    [aux_sym_match_default_expression_token1] = ACTIONS(1320),
    [aux_sym_switch_statement_token1] = ACTIONS(1320),
    [aux_sym_switch_block_token1] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_AT] = ACTIONS(1318),
    [aux_sym_clone_expression_token1] = ACTIONS(1320),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1320),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1320),
    [anon_sym_DASH_DASH] = ACTIONS(1318),
    [anon_sym_PLUS_PLUS] = ACTIONS(1318),
    [aux_sym__list_destructing_token1] = ACTIONS(1320),
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_self] = ACTIONS(1320),
    [anon_sym_parent] = ACTIONS(1320),
    [aux_sym__argument_name_token1] = ACTIONS(1320),
    [aux_sym__argument_name_token2] = ACTIONS(1320),
    [anon_sym_POUND_LBRACK] = ACTIONS(1318),
    [aux_sym_encapsed_string_token1] = ACTIONS(1318),
    [anon_sym_DQUOTE] = ACTIONS(1318),
    [aux_sym_string_token1] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(1318),
    [anon_sym_LT_LT_LT] = ACTIONS(1318),
    [anon_sym_BQUOTE] = ACTIONS(1318),
    [anon_sym_DOLLAR] = ACTIONS(1318),
    [aux_sym_yield_expression_token1] = ACTIONS(1320),
    [aux_sym_include_expression_token1] = ACTIONS(1320),
    [aux_sym_include_once_expression_token1] = ACTIONS(1320),
    [aux_sym_require_expression_token1] = ACTIONS(1320),
    [aux_sym_require_once_expression_token1] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(1322),
    [sym_name] = ACTIONS(1324),
    [anon_sym_QMARK_GT] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1322),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1324),
    [aux_sym_global_declaration_token1] = ACTIONS(1324),
    [aux_sym_namespace_definition_token1] = ACTIONS(1324),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1324),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1324),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1324),
    [anon_sym_BSLASH] = ACTIONS(1322),
    [anon_sym_LBRACE] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [aux_sym_trait_declaration_token1] = ACTIONS(1324),
    [aux_sym_interface_declaration_token1] = ACTIONS(1324),
    [aux_sym_enum_declaration_token1] = ACTIONS(1324),
    [aux_sym_enum_case_token1] = ACTIONS(1324),
    [aux_sym_class_declaration_token1] = ACTIONS(1324),
    [aux_sym_final_modifier_token1] = ACTIONS(1324),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1324),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1324),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1324),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1324),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1324),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1324),
    [anon_sym_LPAREN] = ACTIONS(1322),
    [aux_sym_cast_type_token1] = ACTIONS(1324),
    [aux_sym_echo_statement_token1] = ACTIONS(1324),
    [anon_sym_unset] = ACTIONS(1324),
    [aux_sym_declare_statement_token1] = ACTIONS(1324),
    [aux_sym_declare_statement_token2] = ACTIONS(1324),
    [sym_float] = ACTIONS(1324),
    [aux_sym_try_statement_token1] = ACTIONS(1324),
    [aux_sym_goto_statement_token1] = ACTIONS(1324),
    [aux_sym_continue_statement_token1] = ACTIONS(1324),
    [aux_sym_break_statement_token1] = ACTIONS(1324),
    [sym_integer] = ACTIONS(1324),
    [aux_sym_return_statement_token1] = ACTIONS(1324),
    [aux_sym_throw_expression_token1] = ACTIONS(1324),
    [aux_sym_while_statement_token1] = ACTIONS(1324),
    [aux_sym_while_statement_token2] = ACTIONS(1324),
    [aux_sym_do_statement_token1] = ACTIONS(1324),
    [aux_sym_for_statement_token1] = ACTIONS(1324),
    [aux_sym_for_statement_token2] = ACTIONS(1324),
    [aux_sym_foreach_statement_token1] = ACTIONS(1324),
    [aux_sym_foreach_statement_token2] = ACTIONS(1324),
    [aux_sym_if_statement_token1] = ACTIONS(1324),
    [aux_sym_if_statement_token2] = ACTIONS(1324),
    [aux_sym_else_if_clause_token1] = ACTIONS(1324),
    [aux_sym_else_clause_token1] = ACTIONS(1324),
    [aux_sym_match_expression_token1] = ACTIONS(1324),
    [aux_sym_match_default_expression_token1] = ACTIONS(1324),
    [aux_sym_switch_statement_token1] = ACTIONS(1324),
    [aux_sym_switch_block_token1] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_TILDE] = ACTIONS(1322),
    [anon_sym_BANG] = ACTIONS(1322),
    [anon_sym_AT] = ACTIONS(1322),
    [aux_sym_clone_expression_token1] = ACTIONS(1324),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1324),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1324),
    [anon_sym_DASH_DASH] = ACTIONS(1322),
    [anon_sym_PLUS_PLUS] = ACTIONS(1322),
    [aux_sym__list_destructing_token1] = ACTIONS(1324),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [anon_sym_self] = ACTIONS(1324),
    [anon_sym_parent] = ACTIONS(1324),
    [aux_sym__argument_name_token1] = ACTIONS(1324),
    [aux_sym__argument_name_token2] = ACTIONS(1324),
    [anon_sym_POUND_LBRACK] = ACTIONS(1322),
    [aux_sym_encapsed_string_token1] = ACTIONS(1322),
    [anon_sym_DQUOTE] = ACTIONS(1322),
    [aux_sym_string_token1] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(1322),
    [anon_sym_LT_LT_LT] = ACTIONS(1322),
    [anon_sym_BQUOTE] = ACTIONS(1322),
    [anon_sym_DOLLAR] = ACTIONS(1322),
    [aux_sym_yield_expression_token1] = ACTIONS(1324),
    [aux_sym_include_expression_token1] = ACTIONS(1324),
    [aux_sym_include_once_expression_token1] = ACTIONS(1324),
    [aux_sym_require_expression_token1] = ACTIONS(1324),
    [aux_sym_require_once_expression_token1] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1326),
    [sym_name] = ACTIONS(1328),
    [anon_sym_QMARK_GT] = ACTIONS(1326),
    [anon_sym_SEMI] = ACTIONS(1326),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1328),
    [aux_sym_global_declaration_token1] = ACTIONS(1328),
    [aux_sym_namespace_definition_token1] = ACTIONS(1328),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1328),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1328),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1328),
    [anon_sym_BSLASH] = ACTIONS(1326),
    [anon_sym_LBRACE] = ACTIONS(1326),
    [anon_sym_RBRACE] = ACTIONS(1326),
    [aux_sym_trait_declaration_token1] = ACTIONS(1328),
    [aux_sym_interface_declaration_token1] = ACTIONS(1328),
    [aux_sym_enum_declaration_token1] = ACTIONS(1328),
    [aux_sym_enum_case_token1] = ACTIONS(1328),
    [aux_sym_class_declaration_token1] = ACTIONS(1328),
    [aux_sym_final_modifier_token1] = ACTIONS(1328),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1328),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1328),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1328),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1328),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1328),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1328),
    [anon_sym_LPAREN] = ACTIONS(1326),
    [aux_sym_cast_type_token1] = ACTIONS(1328),
    [aux_sym_echo_statement_token1] = ACTIONS(1328),
    [anon_sym_unset] = ACTIONS(1328),
    [aux_sym_declare_statement_token1] = ACTIONS(1328),
    [aux_sym_declare_statement_token2] = ACTIONS(1328),
    [sym_float] = ACTIONS(1328),
    [aux_sym_try_statement_token1] = ACTIONS(1328),
    [aux_sym_goto_statement_token1] = ACTIONS(1328),
    [aux_sym_continue_statement_token1] = ACTIONS(1328),
    [aux_sym_break_statement_token1] = ACTIONS(1328),
    [sym_integer] = ACTIONS(1328),
    [aux_sym_return_statement_token1] = ACTIONS(1328),
    [aux_sym_throw_expression_token1] = ACTIONS(1328),
    [aux_sym_while_statement_token1] = ACTIONS(1328),
    [aux_sym_while_statement_token2] = ACTIONS(1328),
    [aux_sym_do_statement_token1] = ACTIONS(1328),
    [aux_sym_for_statement_token1] = ACTIONS(1328),
    [aux_sym_for_statement_token2] = ACTIONS(1328),
    [aux_sym_foreach_statement_token1] = ACTIONS(1328),
    [aux_sym_foreach_statement_token2] = ACTIONS(1328),
    [aux_sym_if_statement_token1] = ACTIONS(1328),
    [aux_sym_if_statement_token2] = ACTIONS(1328),
    [aux_sym_else_if_clause_token1] = ACTIONS(1328),
    [aux_sym_else_clause_token1] = ACTIONS(1328),
    [aux_sym_match_expression_token1] = ACTIONS(1328),
    [aux_sym_match_default_expression_token1] = ACTIONS(1328),
    [aux_sym_switch_statement_token1] = ACTIONS(1328),
    [aux_sym_switch_block_token1] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1328),
    [anon_sym_TILDE] = ACTIONS(1326),
    [anon_sym_BANG] = ACTIONS(1326),
    [anon_sym_AT] = ACTIONS(1326),
    [aux_sym_clone_expression_token1] = ACTIONS(1328),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1328),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1328),
    [anon_sym_DASH_DASH] = ACTIONS(1326),
    [anon_sym_PLUS_PLUS] = ACTIONS(1326),
    [aux_sym__list_destructing_token1] = ACTIONS(1328),
    [anon_sym_LBRACK] = ACTIONS(1326),
    [anon_sym_self] = ACTIONS(1328),
    [anon_sym_parent] = ACTIONS(1328),
    [aux_sym__argument_name_token1] = ACTIONS(1328),
    [aux_sym__argument_name_token2] = ACTIONS(1328),
    [anon_sym_POUND_LBRACK] = ACTIONS(1326),
    [aux_sym_encapsed_string_token1] = ACTIONS(1326),
    [anon_sym_DQUOTE] = ACTIONS(1326),
    [aux_sym_string_token1] = ACTIONS(1326),
    [anon_sym_SQUOTE] = ACTIONS(1326),
    [anon_sym_LT_LT_LT] = ACTIONS(1326),
    [anon_sym_BQUOTE] = ACTIONS(1326),
    [anon_sym_DOLLAR] = ACTIONS(1326),
    [aux_sym_yield_expression_token1] = ACTIONS(1328),
    [aux_sym_include_expression_token1] = ACTIONS(1328),
    [aux_sym_include_once_expression_token1] = ACTIONS(1328),
    [aux_sym_require_expression_token1] = ACTIONS(1328),
    [aux_sym_require_once_expression_token1] = ACTIONS(1328),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(1330),
    [sym_name] = ACTIONS(1332),
    [anon_sym_QMARK_GT] = ACTIONS(1330),
    [anon_sym_SEMI] = ACTIONS(1330),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1332),
    [aux_sym_global_declaration_token1] = ACTIONS(1332),
    [aux_sym_namespace_definition_token1] = ACTIONS(1332),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1332),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1332),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1332),
    [anon_sym_BSLASH] = ACTIONS(1330),
    [anon_sym_LBRACE] = ACTIONS(1330),
    [anon_sym_RBRACE] = ACTIONS(1330),
    [aux_sym_trait_declaration_token1] = ACTIONS(1332),
    [aux_sym_interface_declaration_token1] = ACTIONS(1332),
    [aux_sym_enum_declaration_token1] = ACTIONS(1332),
    [aux_sym_enum_case_token1] = ACTIONS(1332),
    [aux_sym_class_declaration_token1] = ACTIONS(1332),
    [aux_sym_final_modifier_token1] = ACTIONS(1332),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1332),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1332),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1332),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1332),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1332),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1330),
    [aux_sym_cast_type_token1] = ACTIONS(1332),
    [aux_sym_echo_statement_token1] = ACTIONS(1332),
    [anon_sym_unset] = ACTIONS(1332),
    [aux_sym_declare_statement_token1] = ACTIONS(1332),
    [aux_sym_declare_statement_token2] = ACTIONS(1332),
    [sym_float] = ACTIONS(1332),
    [aux_sym_try_statement_token1] = ACTIONS(1332),
    [aux_sym_goto_statement_token1] = ACTIONS(1332),
    [aux_sym_continue_statement_token1] = ACTIONS(1332),
    [aux_sym_break_statement_token1] = ACTIONS(1332),
    [sym_integer] = ACTIONS(1332),
    [aux_sym_return_statement_token1] = ACTIONS(1332),
    [aux_sym_throw_expression_token1] = ACTIONS(1332),
    [aux_sym_while_statement_token1] = ACTIONS(1332),
    [aux_sym_while_statement_token2] = ACTIONS(1332),
    [aux_sym_do_statement_token1] = ACTIONS(1332),
    [aux_sym_for_statement_token1] = ACTIONS(1332),
    [aux_sym_for_statement_token2] = ACTIONS(1332),
    [aux_sym_foreach_statement_token1] = ACTIONS(1332),
    [aux_sym_foreach_statement_token2] = ACTIONS(1332),
    [aux_sym_if_statement_token1] = ACTIONS(1332),
    [aux_sym_if_statement_token2] = ACTIONS(1332),
    [aux_sym_else_if_clause_token1] = ACTIONS(1332),
    [aux_sym_else_clause_token1] = ACTIONS(1332),
    [aux_sym_match_expression_token1] = ACTIONS(1332),
    [aux_sym_match_default_expression_token1] = ACTIONS(1332),
    [aux_sym_switch_statement_token1] = ACTIONS(1332),
    [aux_sym_switch_block_token1] = ACTIONS(1332),
    [anon_sym_PLUS] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1330),
    [anon_sym_BANG] = ACTIONS(1330),
    [anon_sym_AT] = ACTIONS(1330),
    [aux_sym_clone_expression_token1] = ACTIONS(1332),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1332),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1332),
    [anon_sym_DASH_DASH] = ACTIONS(1330),
    [anon_sym_PLUS_PLUS] = ACTIONS(1330),
    [aux_sym__list_destructing_token1] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1330),
    [anon_sym_self] = ACTIONS(1332),
    [anon_sym_parent] = ACTIONS(1332),
    [aux_sym__argument_name_token1] = ACTIONS(1332),
    [aux_sym__argument_name_token2] = ACTIONS(1332),
    [anon_sym_POUND_LBRACK] = ACTIONS(1330),
    [aux_sym_encapsed_string_token1] = ACTIONS(1330),
    [anon_sym_DQUOTE] = ACTIONS(1330),
    [aux_sym_string_token1] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1330),
    [anon_sym_LT_LT_LT] = ACTIONS(1330),
    [anon_sym_BQUOTE] = ACTIONS(1330),
    [anon_sym_DOLLAR] = ACTIONS(1330),
    [aux_sym_yield_expression_token1] = ACTIONS(1332),
    [aux_sym_include_expression_token1] = ACTIONS(1332),
    [aux_sym_include_once_expression_token1] = ACTIONS(1332),
    [aux_sym_require_expression_token1] = ACTIONS(1332),
    [aux_sym_require_once_expression_token1] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [sym_name] = ACTIONS(1336),
    [anon_sym_QMARK_GT] = ACTIONS(1334),
    [anon_sym_SEMI] = ACTIONS(1334),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1336),
    [aux_sym_global_declaration_token1] = ACTIONS(1336),
    [aux_sym_namespace_definition_token1] = ACTIONS(1336),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1336),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1336),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1336),
    [anon_sym_BSLASH] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [aux_sym_trait_declaration_token1] = ACTIONS(1336),
    [aux_sym_interface_declaration_token1] = ACTIONS(1336),
    [aux_sym_enum_declaration_token1] = ACTIONS(1336),
    [aux_sym_enum_case_token1] = ACTIONS(1336),
    [aux_sym_class_declaration_token1] = ACTIONS(1336),
    [aux_sym_final_modifier_token1] = ACTIONS(1336),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1336),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1336),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1336),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1336),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1336),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [aux_sym_cast_type_token1] = ACTIONS(1336),
    [aux_sym_echo_statement_token1] = ACTIONS(1336),
    [anon_sym_unset] = ACTIONS(1336),
    [aux_sym_declare_statement_token1] = ACTIONS(1336),
    [aux_sym_declare_statement_token2] = ACTIONS(1336),
    [sym_float] = ACTIONS(1336),
    [aux_sym_try_statement_token1] = ACTIONS(1336),
    [aux_sym_goto_statement_token1] = ACTIONS(1336),
    [aux_sym_continue_statement_token1] = ACTIONS(1336),
    [aux_sym_break_statement_token1] = ACTIONS(1336),
    [sym_integer] = ACTIONS(1336),
    [aux_sym_return_statement_token1] = ACTIONS(1336),
    [aux_sym_throw_expression_token1] = ACTIONS(1336),
    [aux_sym_while_statement_token1] = ACTIONS(1336),
    [aux_sym_while_statement_token2] = ACTIONS(1336),
    [aux_sym_do_statement_token1] = ACTIONS(1336),
    [aux_sym_for_statement_token1] = ACTIONS(1336),
    [aux_sym_for_statement_token2] = ACTIONS(1336),
    [aux_sym_foreach_statement_token1] = ACTIONS(1336),
    [aux_sym_foreach_statement_token2] = ACTIONS(1336),
    [aux_sym_if_statement_token1] = ACTIONS(1336),
    [aux_sym_if_statement_token2] = ACTIONS(1336),
    [aux_sym_else_if_clause_token1] = ACTIONS(1336),
    [aux_sym_else_clause_token1] = ACTIONS(1336),
    [aux_sym_match_expression_token1] = ACTIONS(1336),
    [aux_sym_match_default_expression_token1] = ACTIONS(1336),
    [aux_sym_switch_statement_token1] = ACTIONS(1336),
    [aux_sym_switch_block_token1] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1336),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_BANG] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [aux_sym_clone_expression_token1] = ACTIONS(1336),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1336),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1334),
    [anon_sym_PLUS_PLUS] = ACTIONS(1334),
    [aux_sym__list_destructing_token1] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_self] = ACTIONS(1336),
    [anon_sym_parent] = ACTIONS(1336),
    [aux_sym__argument_name_token1] = ACTIONS(1336),
    [aux_sym__argument_name_token2] = ACTIONS(1336),
    [anon_sym_POUND_LBRACK] = ACTIONS(1334),
    [aux_sym_encapsed_string_token1] = ACTIONS(1334),
    [anon_sym_DQUOTE] = ACTIONS(1334),
    [aux_sym_string_token1] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1334),
    [anon_sym_LT_LT_LT] = ACTIONS(1334),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [aux_sym_yield_expression_token1] = ACTIONS(1336),
    [aux_sym_include_expression_token1] = ACTIONS(1336),
    [aux_sym_include_once_expression_token1] = ACTIONS(1336),
    [aux_sym_require_expression_token1] = ACTIONS(1336),
    [aux_sym_require_once_expression_token1] = ACTIONS(1336),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1338),
    [sym_name] = ACTIONS(1340),
    [anon_sym_QMARK_GT] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1338),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1340),
    [aux_sym_global_declaration_token1] = ACTIONS(1340),
    [aux_sym_namespace_definition_token1] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1340),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1340),
    [anon_sym_BSLASH] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [aux_sym_trait_declaration_token1] = ACTIONS(1340),
    [aux_sym_interface_declaration_token1] = ACTIONS(1340),
    [aux_sym_enum_declaration_token1] = ACTIONS(1340),
    [aux_sym_enum_case_token1] = ACTIONS(1340),
    [aux_sym_class_declaration_token1] = ACTIONS(1340),
    [aux_sym_final_modifier_token1] = ACTIONS(1340),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1340),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1340),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1340),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1338),
    [aux_sym_cast_type_token1] = ACTIONS(1340),
    [aux_sym_echo_statement_token1] = ACTIONS(1340),
    [anon_sym_unset] = ACTIONS(1340),
    [aux_sym_declare_statement_token1] = ACTIONS(1340),
    [aux_sym_declare_statement_token2] = ACTIONS(1340),
    [sym_float] = ACTIONS(1340),
    [aux_sym_try_statement_token1] = ACTIONS(1340),
    [aux_sym_goto_statement_token1] = ACTIONS(1340),
    [aux_sym_continue_statement_token1] = ACTIONS(1340),
    [aux_sym_break_statement_token1] = ACTIONS(1340),
    [sym_integer] = ACTIONS(1340),
    [aux_sym_return_statement_token1] = ACTIONS(1340),
    [aux_sym_throw_expression_token1] = ACTIONS(1340),
    [aux_sym_while_statement_token1] = ACTIONS(1340),
    [aux_sym_while_statement_token2] = ACTIONS(1340),
    [aux_sym_do_statement_token1] = ACTIONS(1340),
    [aux_sym_for_statement_token1] = ACTIONS(1340),
    [aux_sym_for_statement_token2] = ACTIONS(1340),
    [aux_sym_foreach_statement_token1] = ACTIONS(1340),
    [aux_sym_foreach_statement_token2] = ACTIONS(1340),
    [aux_sym_if_statement_token1] = ACTIONS(1340),
    [aux_sym_if_statement_token2] = ACTIONS(1340),
    [aux_sym_else_if_clause_token1] = ACTIONS(1340),
    [aux_sym_else_clause_token1] = ACTIONS(1340),
    [aux_sym_match_expression_token1] = ACTIONS(1340),
    [aux_sym_match_default_expression_token1] = ACTIONS(1340),
    [aux_sym_switch_statement_token1] = ACTIONS(1340),
    [aux_sym_switch_block_token1] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1338),
    [anon_sym_BANG] = ACTIONS(1338),
    [anon_sym_AT] = ACTIONS(1338),
    [aux_sym_clone_expression_token1] = ACTIONS(1340),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1340),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1340),
    [anon_sym_DASH_DASH] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1338),
    [aux_sym__list_destructing_token1] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1338),
    [anon_sym_self] = ACTIONS(1340),
    [anon_sym_parent] = ACTIONS(1340),
    [aux_sym__argument_name_token1] = ACTIONS(1340),
    [aux_sym__argument_name_token2] = ACTIONS(1340),
    [anon_sym_POUND_LBRACK] = ACTIONS(1338),
    [aux_sym_encapsed_string_token1] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(1338),
    [aux_sym_string_token1] = ACTIONS(1338),
    [anon_sym_SQUOTE] = ACTIONS(1338),
    [anon_sym_LT_LT_LT] = ACTIONS(1338),
    [anon_sym_BQUOTE] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(1338),
    [aux_sym_yield_expression_token1] = ACTIONS(1340),
    [aux_sym_include_expression_token1] = ACTIONS(1340),
    [aux_sym_include_once_expression_token1] = ACTIONS(1340),
    [aux_sym_require_expression_token1] = ACTIONS(1340),
    [aux_sym_require_once_expression_token1] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1342),
    [sym_name] = ACTIONS(1344),
    [anon_sym_QMARK_GT] = ACTIONS(1342),
    [anon_sym_SEMI] = ACTIONS(1342),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1344),
    [aux_sym_global_declaration_token1] = ACTIONS(1344),
    [aux_sym_namespace_definition_token1] = ACTIONS(1344),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1344),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1344),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1344),
    [anon_sym_BSLASH] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1342),
    [aux_sym_trait_declaration_token1] = ACTIONS(1344),
    [aux_sym_interface_declaration_token1] = ACTIONS(1344),
    [aux_sym_enum_declaration_token1] = ACTIONS(1344),
    [aux_sym_enum_case_token1] = ACTIONS(1344),
    [aux_sym_class_declaration_token1] = ACTIONS(1344),
    [aux_sym_final_modifier_token1] = ACTIONS(1344),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1344),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1344),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1344),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1344),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1344),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1344),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [aux_sym_cast_type_token1] = ACTIONS(1344),
    [aux_sym_echo_statement_token1] = ACTIONS(1344),
    [anon_sym_unset] = ACTIONS(1344),
    [aux_sym_declare_statement_token1] = ACTIONS(1344),
    [aux_sym_declare_statement_token2] = ACTIONS(1344),
    [sym_float] = ACTIONS(1344),
    [aux_sym_try_statement_token1] = ACTIONS(1344),
    [aux_sym_goto_statement_token1] = ACTIONS(1344),
    [aux_sym_continue_statement_token1] = ACTIONS(1344),
    [aux_sym_break_statement_token1] = ACTIONS(1344),
    [sym_integer] = ACTIONS(1344),
    [aux_sym_return_statement_token1] = ACTIONS(1344),
    [aux_sym_throw_expression_token1] = ACTIONS(1344),
    [aux_sym_while_statement_token1] = ACTIONS(1344),
    [aux_sym_while_statement_token2] = ACTIONS(1344),
    [aux_sym_do_statement_token1] = ACTIONS(1344),
    [aux_sym_for_statement_token1] = ACTIONS(1344),
    [aux_sym_for_statement_token2] = ACTIONS(1344),
    [aux_sym_foreach_statement_token1] = ACTIONS(1344),
    [aux_sym_foreach_statement_token2] = ACTIONS(1344),
    [aux_sym_if_statement_token1] = ACTIONS(1344),
    [aux_sym_if_statement_token2] = ACTIONS(1344),
    [aux_sym_else_if_clause_token1] = ACTIONS(1344),
    [aux_sym_else_clause_token1] = ACTIONS(1344),
    [aux_sym_match_expression_token1] = ACTIONS(1344),
    [aux_sym_match_default_expression_token1] = ACTIONS(1344),
    [aux_sym_switch_statement_token1] = ACTIONS(1344),
    [aux_sym_switch_block_token1] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1344),
    [anon_sym_TILDE] = ACTIONS(1342),
    [anon_sym_BANG] = ACTIONS(1342),
    [anon_sym_AT] = ACTIONS(1342),
    [aux_sym_clone_expression_token1] = ACTIONS(1344),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1344),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1344),
    [anon_sym_DASH_DASH] = ACTIONS(1342),
    [anon_sym_PLUS_PLUS] = ACTIONS(1342),
    [aux_sym__list_destructing_token1] = ACTIONS(1344),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_self] = ACTIONS(1344),
    [anon_sym_parent] = ACTIONS(1344),
    [aux_sym__argument_name_token1] = ACTIONS(1344),
    [aux_sym__argument_name_token2] = ACTIONS(1344),
    [anon_sym_POUND_LBRACK] = ACTIONS(1342),
    [aux_sym_encapsed_string_token1] = ACTIONS(1342),
    [anon_sym_DQUOTE] = ACTIONS(1342),
    [aux_sym_string_token1] = ACTIONS(1342),
    [anon_sym_SQUOTE] = ACTIONS(1342),
    [anon_sym_LT_LT_LT] = ACTIONS(1342),
    [anon_sym_BQUOTE] = ACTIONS(1342),
    [anon_sym_DOLLAR] = ACTIONS(1342),
    [aux_sym_yield_expression_token1] = ACTIONS(1344),
    [aux_sym_include_expression_token1] = ACTIONS(1344),
    [aux_sym_include_once_expression_token1] = ACTIONS(1344),
    [aux_sym_require_expression_token1] = ACTIONS(1344),
    [aux_sym_require_once_expression_token1] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1346),
    [sym_name] = ACTIONS(1348),
    [anon_sym_QMARK_GT] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1348),
    [aux_sym_global_declaration_token1] = ACTIONS(1348),
    [aux_sym_namespace_definition_token1] = ACTIONS(1348),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1348),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1348),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1348),
    [anon_sym_BSLASH] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [aux_sym_trait_declaration_token1] = ACTIONS(1348),
    [aux_sym_interface_declaration_token1] = ACTIONS(1348),
    [aux_sym_enum_declaration_token1] = ACTIONS(1348),
    [aux_sym_enum_case_token1] = ACTIONS(1348),
    [aux_sym_class_declaration_token1] = ACTIONS(1348),
    [aux_sym_final_modifier_token1] = ACTIONS(1348),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1348),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1348),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1348),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1348),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1348),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1348),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [aux_sym_cast_type_token1] = ACTIONS(1348),
    [aux_sym_echo_statement_token1] = ACTIONS(1348),
    [anon_sym_unset] = ACTIONS(1348),
    [aux_sym_declare_statement_token1] = ACTIONS(1348),
    [aux_sym_declare_statement_token2] = ACTIONS(1348),
    [sym_float] = ACTIONS(1348),
    [aux_sym_try_statement_token1] = ACTIONS(1348),
    [aux_sym_goto_statement_token1] = ACTIONS(1348),
    [aux_sym_continue_statement_token1] = ACTIONS(1348),
    [aux_sym_break_statement_token1] = ACTIONS(1348),
    [sym_integer] = ACTIONS(1348),
    [aux_sym_return_statement_token1] = ACTIONS(1348),
    [aux_sym_throw_expression_token1] = ACTIONS(1348),
    [aux_sym_while_statement_token1] = ACTIONS(1348),
    [aux_sym_while_statement_token2] = ACTIONS(1348),
    [aux_sym_do_statement_token1] = ACTIONS(1348),
    [aux_sym_for_statement_token1] = ACTIONS(1348),
    [aux_sym_for_statement_token2] = ACTIONS(1348),
    [aux_sym_foreach_statement_token1] = ACTIONS(1348),
    [aux_sym_foreach_statement_token2] = ACTIONS(1348),
    [aux_sym_if_statement_token1] = ACTIONS(1348),
    [aux_sym_if_statement_token2] = ACTIONS(1348),
    [aux_sym_else_if_clause_token1] = ACTIONS(1348),
    [aux_sym_else_clause_token1] = ACTIONS(1348),
    [aux_sym_match_expression_token1] = ACTIONS(1348),
    [aux_sym_match_default_expression_token1] = ACTIONS(1348),
    [aux_sym_switch_statement_token1] = ACTIONS(1348),
    [aux_sym_switch_block_token1] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_TILDE] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1346),
    [aux_sym_clone_expression_token1] = ACTIONS(1348),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1348),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [aux_sym__list_destructing_token1] = ACTIONS(1348),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_self] = ACTIONS(1348),
    [anon_sym_parent] = ACTIONS(1348),
    [aux_sym__argument_name_token1] = ACTIONS(1348),
    [aux_sym__argument_name_token2] = ACTIONS(1348),
    [anon_sym_POUND_LBRACK] = ACTIONS(1346),
    [aux_sym_encapsed_string_token1] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(1346),
    [aux_sym_string_token1] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(1346),
    [anon_sym_LT_LT_LT] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_DOLLAR] = ACTIONS(1346),
    [aux_sym_yield_expression_token1] = ACTIONS(1348),
    [aux_sym_include_expression_token1] = ACTIONS(1348),
    [aux_sym_include_once_expression_token1] = ACTIONS(1348),
    [aux_sym_require_expression_token1] = ACTIONS(1348),
    [aux_sym_require_once_expression_token1] = ACTIONS(1348),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(1350),
    [sym_name] = ACTIONS(1352),
    [anon_sym_QMARK_GT] = ACTIONS(1350),
    [anon_sym_SEMI] = ACTIONS(1350),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1352),
    [aux_sym_global_declaration_token1] = ACTIONS(1352),
    [aux_sym_namespace_definition_token1] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1352),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1352),
    [anon_sym_BSLASH] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_RBRACE] = ACTIONS(1350),
    [aux_sym_trait_declaration_token1] = ACTIONS(1352),
    [aux_sym_interface_declaration_token1] = ACTIONS(1352),
    [aux_sym_enum_declaration_token1] = ACTIONS(1352),
    [aux_sym_enum_case_token1] = ACTIONS(1352),
    [aux_sym_class_declaration_token1] = ACTIONS(1352),
    [aux_sym_final_modifier_token1] = ACTIONS(1352),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1352),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1352),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1352),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [aux_sym_cast_type_token1] = ACTIONS(1352),
    [aux_sym_echo_statement_token1] = ACTIONS(1352),
    [anon_sym_unset] = ACTIONS(1352),
    [aux_sym_declare_statement_token1] = ACTIONS(1352),
    [aux_sym_declare_statement_token2] = ACTIONS(1352),
    [sym_float] = ACTIONS(1352),
    [aux_sym_try_statement_token1] = ACTIONS(1352),
    [aux_sym_goto_statement_token1] = ACTIONS(1352),
    [aux_sym_continue_statement_token1] = ACTIONS(1352),
    [aux_sym_break_statement_token1] = ACTIONS(1352),
    [sym_integer] = ACTIONS(1352),
    [aux_sym_return_statement_token1] = ACTIONS(1352),
    [aux_sym_throw_expression_token1] = ACTIONS(1352),
    [aux_sym_while_statement_token1] = ACTIONS(1352),
    [aux_sym_while_statement_token2] = ACTIONS(1352),
    [aux_sym_do_statement_token1] = ACTIONS(1352),
    [aux_sym_for_statement_token1] = ACTIONS(1352),
    [aux_sym_for_statement_token2] = ACTIONS(1352),
    [aux_sym_foreach_statement_token1] = ACTIONS(1352),
    [aux_sym_foreach_statement_token2] = ACTIONS(1352),
    [aux_sym_if_statement_token1] = ACTIONS(1352),
    [aux_sym_if_statement_token2] = ACTIONS(1352),
    [aux_sym_else_if_clause_token1] = ACTIONS(1352),
    [aux_sym_else_clause_token1] = ACTIONS(1352),
    [aux_sym_match_expression_token1] = ACTIONS(1352),
    [aux_sym_match_default_expression_token1] = ACTIONS(1352),
    [aux_sym_switch_statement_token1] = ACTIONS(1352),
    [aux_sym_switch_block_token1] = ACTIONS(1352),
    [anon_sym_PLUS] = ACTIONS(1352),
    [anon_sym_DASH] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_AT] = ACTIONS(1350),
    [aux_sym_clone_expression_token1] = ACTIONS(1352),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1352),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1352),
    [anon_sym_DASH_DASH] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1350),
    [aux_sym__list_destructing_token1] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1350),
    [anon_sym_self] = ACTIONS(1352),
    [anon_sym_parent] = ACTIONS(1352),
    [aux_sym__argument_name_token1] = ACTIONS(1352),
    [aux_sym__argument_name_token2] = ACTIONS(1352),
    [anon_sym_POUND_LBRACK] = ACTIONS(1350),
    [aux_sym_encapsed_string_token1] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(1350),
    [aux_sym_string_token1] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(1350),
    [anon_sym_LT_LT_LT] = ACTIONS(1350),
    [anon_sym_BQUOTE] = ACTIONS(1350),
    [anon_sym_DOLLAR] = ACTIONS(1350),
    [aux_sym_yield_expression_token1] = ACTIONS(1352),
    [aux_sym_include_expression_token1] = ACTIONS(1352),
    [aux_sym_include_once_expression_token1] = ACTIONS(1352),
    [aux_sym_require_expression_token1] = ACTIONS(1352),
    [aux_sym_require_once_expression_token1] = ACTIONS(1352),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_name] = ACTIONS(1356),
    [anon_sym_QMARK_GT] = ACTIONS(1354),
    [anon_sym_SEMI] = ACTIONS(1354),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1356),
    [aux_sym_global_declaration_token1] = ACTIONS(1356),
    [aux_sym_namespace_definition_token1] = ACTIONS(1356),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1356),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1356),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1356),
    [anon_sym_BSLASH] = ACTIONS(1354),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1354),
    [aux_sym_trait_declaration_token1] = ACTIONS(1356),
    [aux_sym_interface_declaration_token1] = ACTIONS(1356),
    [aux_sym_enum_declaration_token1] = ACTIONS(1356),
    [aux_sym_enum_case_token1] = ACTIONS(1356),
    [aux_sym_class_declaration_token1] = ACTIONS(1356),
    [aux_sym_final_modifier_token1] = ACTIONS(1356),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1356),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1356),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1356),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1356),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1356),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1356),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [aux_sym_cast_type_token1] = ACTIONS(1356),
    [aux_sym_echo_statement_token1] = ACTIONS(1356),
    [anon_sym_unset] = ACTIONS(1356),
    [aux_sym_declare_statement_token1] = ACTIONS(1356),
    [aux_sym_declare_statement_token2] = ACTIONS(1356),
    [sym_float] = ACTIONS(1356),
    [aux_sym_try_statement_token1] = ACTIONS(1356),
    [aux_sym_goto_statement_token1] = ACTIONS(1356),
    [aux_sym_continue_statement_token1] = ACTIONS(1356),
    [aux_sym_break_statement_token1] = ACTIONS(1356),
    [sym_integer] = ACTIONS(1356),
    [aux_sym_return_statement_token1] = ACTIONS(1356),
    [aux_sym_throw_expression_token1] = ACTIONS(1356),
    [aux_sym_while_statement_token1] = ACTIONS(1356),
    [aux_sym_while_statement_token2] = ACTIONS(1356),
    [aux_sym_do_statement_token1] = ACTIONS(1356),
    [aux_sym_for_statement_token1] = ACTIONS(1356),
    [aux_sym_for_statement_token2] = ACTIONS(1356),
    [aux_sym_foreach_statement_token1] = ACTIONS(1356),
    [aux_sym_foreach_statement_token2] = ACTIONS(1356),
    [aux_sym_if_statement_token1] = ACTIONS(1356),
    [aux_sym_if_statement_token2] = ACTIONS(1356),
    [aux_sym_else_if_clause_token1] = ACTIONS(1356),
    [aux_sym_else_clause_token1] = ACTIONS(1356),
    [aux_sym_match_expression_token1] = ACTIONS(1356),
    [aux_sym_match_default_expression_token1] = ACTIONS(1356),
    [aux_sym_switch_statement_token1] = ACTIONS(1356),
    [aux_sym_switch_block_token1] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_BANG] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(1354),
    [aux_sym_clone_expression_token1] = ACTIONS(1356),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1356),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1356),
    [anon_sym_DASH_DASH] = ACTIONS(1354),
    [anon_sym_PLUS_PLUS] = ACTIONS(1354),
    [aux_sym__list_destructing_token1] = ACTIONS(1356),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_self] = ACTIONS(1356),
    [anon_sym_parent] = ACTIONS(1356),
    [aux_sym__argument_name_token1] = ACTIONS(1356),
    [aux_sym__argument_name_token2] = ACTIONS(1356),
    [anon_sym_POUND_LBRACK] = ACTIONS(1354),
    [aux_sym_encapsed_string_token1] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1354),
    [aux_sym_string_token1] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(1354),
    [anon_sym_LT_LT_LT] = ACTIONS(1354),
    [anon_sym_BQUOTE] = ACTIONS(1354),
    [anon_sym_DOLLAR] = ACTIONS(1354),
    [aux_sym_yield_expression_token1] = ACTIONS(1356),
    [aux_sym_include_expression_token1] = ACTIONS(1356),
    [aux_sym_include_once_expression_token1] = ACTIONS(1356),
    [aux_sym_require_expression_token1] = ACTIONS(1356),
    [aux_sym_require_once_expression_token1] = ACTIONS(1356),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_name] = ACTIONS(1017),
    [anon_sym_QMARK_GT] = ACTIONS(1015),
    [anon_sym_SEMI] = ACTIONS(1015),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1017),
    [aux_sym_global_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_definition_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1017),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1017),
    [anon_sym_BSLASH] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [aux_sym_trait_declaration_token1] = ACTIONS(1017),
    [aux_sym_interface_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_declaration_token1] = ACTIONS(1017),
    [aux_sym_enum_case_token1] = ACTIONS(1017),
    [aux_sym_class_declaration_token1] = ACTIONS(1017),
    [aux_sym_final_modifier_token1] = ACTIONS(1017),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1017),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1017),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1017),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [aux_sym_cast_type_token1] = ACTIONS(1017),
    [aux_sym_echo_statement_token1] = ACTIONS(1017),
    [anon_sym_unset] = ACTIONS(1017),
    [aux_sym_declare_statement_token1] = ACTIONS(1017),
    [aux_sym_declare_statement_token2] = ACTIONS(1017),
    [sym_float] = ACTIONS(1017),
    [aux_sym_try_statement_token1] = ACTIONS(1017),
    [aux_sym_goto_statement_token1] = ACTIONS(1017),
    [aux_sym_continue_statement_token1] = ACTIONS(1017),
    [aux_sym_break_statement_token1] = ACTIONS(1017),
    [sym_integer] = ACTIONS(1017),
    [aux_sym_return_statement_token1] = ACTIONS(1017),
    [aux_sym_throw_expression_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token1] = ACTIONS(1017),
    [aux_sym_while_statement_token2] = ACTIONS(1017),
    [aux_sym_do_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token1] = ACTIONS(1017),
    [aux_sym_for_statement_token2] = ACTIONS(1017),
    [aux_sym_foreach_statement_token1] = ACTIONS(1017),
    [aux_sym_foreach_statement_token2] = ACTIONS(1017),
    [aux_sym_if_statement_token1] = ACTIONS(1017),
    [aux_sym_if_statement_token2] = ACTIONS(1017),
    [aux_sym_else_if_clause_token1] = ACTIONS(1017),
    [aux_sym_else_clause_token1] = ACTIONS(1017),
    [aux_sym_match_expression_token1] = ACTIONS(1017),
    [aux_sym_match_default_expression_token1] = ACTIONS(1017),
    [aux_sym_switch_statement_token1] = ACTIONS(1017),
    [aux_sym_switch_block_token1] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1017),
    [anon_sym_DASH] = ACTIONS(1017),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1015),
    [aux_sym_clone_expression_token1] = ACTIONS(1017),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1017),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1015),
    [aux_sym__list_destructing_token1] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [anon_sym_self] = ACTIONS(1017),
    [anon_sym_parent] = ACTIONS(1017),
    [aux_sym__argument_name_token1] = ACTIONS(1017),
    [aux_sym__argument_name_token2] = ACTIONS(1017),
    [anon_sym_POUND_LBRACK] = ACTIONS(1015),
    [aux_sym_encapsed_string_token1] = ACTIONS(1015),
    [anon_sym_DQUOTE] = ACTIONS(1015),
    [aux_sym_string_token1] = ACTIONS(1015),
    [anon_sym_SQUOTE] = ACTIONS(1015),
    [anon_sym_LT_LT_LT] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1015),
    [aux_sym_yield_expression_token1] = ACTIONS(1017),
    [aux_sym_include_expression_token1] = ACTIONS(1017),
    [aux_sym_include_once_expression_token1] = ACTIONS(1017),
    [aux_sym_require_expression_token1] = ACTIONS(1017),
    [aux_sym_require_once_expression_token1] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1358),
    [sym_name] = ACTIONS(1360),
    [anon_sym_QMARK_GT] = ACTIONS(1358),
    [anon_sym_SEMI] = ACTIONS(1358),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1360),
    [aux_sym_global_declaration_token1] = ACTIONS(1360),
    [aux_sym_namespace_definition_token1] = ACTIONS(1360),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1360),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1360),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1360),
    [anon_sym_BSLASH] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1358),
    [anon_sym_RBRACE] = ACTIONS(1358),
    [aux_sym_trait_declaration_token1] = ACTIONS(1360),
    [aux_sym_interface_declaration_token1] = ACTIONS(1360),
    [aux_sym_enum_declaration_token1] = ACTIONS(1360),
    [aux_sym_enum_case_token1] = ACTIONS(1360),
    [aux_sym_class_declaration_token1] = ACTIONS(1360),
    [aux_sym_final_modifier_token1] = ACTIONS(1360),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1360),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1360),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1360),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1360),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1360),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1358),
    [aux_sym_cast_type_token1] = ACTIONS(1360),
    [aux_sym_echo_statement_token1] = ACTIONS(1360),
    [anon_sym_unset] = ACTIONS(1360),
    [aux_sym_declare_statement_token1] = ACTIONS(1360),
    [aux_sym_declare_statement_token2] = ACTIONS(1360),
    [sym_float] = ACTIONS(1360),
    [aux_sym_try_statement_token1] = ACTIONS(1360),
    [aux_sym_goto_statement_token1] = ACTIONS(1360),
    [aux_sym_continue_statement_token1] = ACTIONS(1360),
    [aux_sym_break_statement_token1] = ACTIONS(1360),
    [sym_integer] = ACTIONS(1360),
    [aux_sym_return_statement_token1] = ACTIONS(1360),
    [aux_sym_throw_expression_token1] = ACTIONS(1360),
    [aux_sym_while_statement_token1] = ACTIONS(1360),
    [aux_sym_while_statement_token2] = ACTIONS(1360),
    [aux_sym_do_statement_token1] = ACTIONS(1360),
    [aux_sym_for_statement_token1] = ACTIONS(1360),
    [aux_sym_for_statement_token2] = ACTIONS(1360),
    [aux_sym_foreach_statement_token1] = ACTIONS(1360),
    [aux_sym_foreach_statement_token2] = ACTIONS(1360),
    [aux_sym_if_statement_token1] = ACTIONS(1360),
    [aux_sym_if_statement_token2] = ACTIONS(1360),
    [aux_sym_else_if_clause_token1] = ACTIONS(1360),
    [aux_sym_else_clause_token1] = ACTIONS(1360),
    [aux_sym_match_expression_token1] = ACTIONS(1360),
    [aux_sym_match_default_expression_token1] = ACTIONS(1360),
    [aux_sym_switch_statement_token1] = ACTIONS(1360),
    [aux_sym_switch_block_token1] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1358),
    [aux_sym_clone_expression_token1] = ACTIONS(1360),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1360),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1360),
    [anon_sym_DASH_DASH] = ACTIONS(1358),
    [anon_sym_PLUS_PLUS] = ACTIONS(1358),
    [aux_sym__list_destructing_token1] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_self] = ACTIONS(1360),
    [anon_sym_parent] = ACTIONS(1360),
    [aux_sym__argument_name_token1] = ACTIONS(1360),
    [aux_sym__argument_name_token2] = ACTIONS(1360),
    [anon_sym_POUND_LBRACK] = ACTIONS(1358),
    [aux_sym_encapsed_string_token1] = ACTIONS(1358),
    [anon_sym_DQUOTE] = ACTIONS(1358),
    [aux_sym_string_token1] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1358),
    [anon_sym_LT_LT_LT] = ACTIONS(1358),
    [anon_sym_BQUOTE] = ACTIONS(1358),
    [anon_sym_DOLLAR] = ACTIONS(1358),
    [aux_sym_yield_expression_token1] = ACTIONS(1360),
    [aux_sym_include_expression_token1] = ACTIONS(1360),
    [aux_sym_include_once_expression_token1] = ACTIONS(1360),
    [aux_sym_require_expression_token1] = ACTIONS(1360),
    [aux_sym_require_once_expression_token1] = ACTIONS(1360),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_name] = ACTIONS(1364),
    [anon_sym_QMARK_GT] = ACTIONS(1362),
    [anon_sym_SEMI] = ACTIONS(1362),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1364),
    [aux_sym_global_declaration_token1] = ACTIONS(1364),
    [aux_sym_namespace_definition_token1] = ACTIONS(1364),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1364),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1364),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1364),
    [anon_sym_BSLASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_RBRACE] = ACTIONS(1362),
    [aux_sym_trait_declaration_token1] = ACTIONS(1364),
    [aux_sym_interface_declaration_token1] = ACTIONS(1364),
    [aux_sym_enum_declaration_token1] = ACTIONS(1364),
    [aux_sym_enum_case_token1] = ACTIONS(1364),
    [aux_sym_class_declaration_token1] = ACTIONS(1364),
    [aux_sym_final_modifier_token1] = ACTIONS(1364),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1364),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1364),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1364),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1364),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1364),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [aux_sym_cast_type_token1] = ACTIONS(1364),
    [aux_sym_echo_statement_token1] = ACTIONS(1364),
    [anon_sym_unset] = ACTIONS(1364),
    [aux_sym_declare_statement_token1] = ACTIONS(1364),
    [aux_sym_declare_statement_token2] = ACTIONS(1364),
    [sym_float] = ACTIONS(1364),
    [aux_sym_try_statement_token1] = ACTIONS(1364),
    [aux_sym_goto_statement_token1] = ACTIONS(1364),
    [aux_sym_continue_statement_token1] = ACTIONS(1364),
    [aux_sym_break_statement_token1] = ACTIONS(1364),
    [sym_integer] = ACTIONS(1364),
    [aux_sym_return_statement_token1] = ACTIONS(1364),
    [aux_sym_throw_expression_token1] = ACTIONS(1364),
    [aux_sym_while_statement_token1] = ACTIONS(1364),
    [aux_sym_while_statement_token2] = ACTIONS(1364),
    [aux_sym_do_statement_token1] = ACTIONS(1364),
    [aux_sym_for_statement_token1] = ACTIONS(1364),
    [aux_sym_for_statement_token2] = ACTIONS(1364),
    [aux_sym_foreach_statement_token1] = ACTIONS(1364),
    [aux_sym_foreach_statement_token2] = ACTIONS(1364),
    [aux_sym_if_statement_token1] = ACTIONS(1364),
    [aux_sym_if_statement_token2] = ACTIONS(1364),
    [aux_sym_else_if_clause_token1] = ACTIONS(1364),
    [aux_sym_else_clause_token1] = ACTIONS(1364),
    [aux_sym_match_expression_token1] = ACTIONS(1364),
    [aux_sym_match_default_expression_token1] = ACTIONS(1364),
    [aux_sym_switch_statement_token1] = ACTIONS(1364),
    [aux_sym_switch_block_token1] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_BANG] = ACTIONS(1362),
    [anon_sym_AT] = ACTIONS(1362),
    [aux_sym_clone_expression_token1] = ACTIONS(1364),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1364),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1364),
    [anon_sym_DASH_DASH] = ACTIONS(1362),
    [anon_sym_PLUS_PLUS] = ACTIONS(1362),
    [aux_sym__list_destructing_token1] = ACTIONS(1364),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_self] = ACTIONS(1364),
    [anon_sym_parent] = ACTIONS(1364),
    [aux_sym__argument_name_token1] = ACTIONS(1364),
    [aux_sym__argument_name_token2] = ACTIONS(1364),
    [anon_sym_POUND_LBRACK] = ACTIONS(1362),
    [aux_sym_encapsed_string_token1] = ACTIONS(1362),
    [anon_sym_DQUOTE] = ACTIONS(1362),
    [aux_sym_string_token1] = ACTIONS(1362),
    [anon_sym_SQUOTE] = ACTIONS(1362),
    [anon_sym_LT_LT_LT] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(1362),
    [anon_sym_DOLLAR] = ACTIONS(1362),
    [aux_sym_yield_expression_token1] = ACTIONS(1364),
    [aux_sym_include_expression_token1] = ACTIONS(1364),
    [aux_sym_include_once_expression_token1] = ACTIONS(1364),
    [aux_sym_require_expression_token1] = ACTIONS(1364),
    [aux_sym_require_once_expression_token1] = ACTIONS(1364),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1366),
    [sym_name] = ACTIONS(1368),
    [anon_sym_QMARK_GT] = ACTIONS(1366),
    [anon_sym_SEMI] = ACTIONS(1366),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1368),
    [aux_sym_global_declaration_token1] = ACTIONS(1368),
    [aux_sym_namespace_definition_token1] = ACTIONS(1368),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1368),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1368),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1368),
    [anon_sym_BSLASH] = ACTIONS(1366),
    [anon_sym_LBRACE] = ACTIONS(1366),
    [anon_sym_RBRACE] = ACTIONS(1366),
    [aux_sym_trait_declaration_token1] = ACTIONS(1368),
    [aux_sym_interface_declaration_token1] = ACTIONS(1368),
    [aux_sym_enum_declaration_token1] = ACTIONS(1368),
    [aux_sym_enum_case_token1] = ACTIONS(1368),
    [aux_sym_class_declaration_token1] = ACTIONS(1368),
    [aux_sym_final_modifier_token1] = ACTIONS(1368),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1368),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1368),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1368),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1368),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1368),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1368),
    [anon_sym_LPAREN] = ACTIONS(1366),
    [aux_sym_cast_type_token1] = ACTIONS(1368),
    [aux_sym_echo_statement_token1] = ACTIONS(1368),
    [anon_sym_unset] = ACTIONS(1368),
    [aux_sym_declare_statement_token1] = ACTIONS(1368),
    [aux_sym_declare_statement_token2] = ACTIONS(1368),
    [sym_float] = ACTIONS(1368),
    [aux_sym_try_statement_token1] = ACTIONS(1368),
    [aux_sym_goto_statement_token1] = ACTIONS(1368),
    [aux_sym_continue_statement_token1] = ACTIONS(1368),
    [aux_sym_break_statement_token1] = ACTIONS(1368),
    [sym_integer] = ACTIONS(1368),
    [aux_sym_return_statement_token1] = ACTIONS(1368),
    [aux_sym_throw_expression_token1] = ACTIONS(1368),
    [aux_sym_while_statement_token1] = ACTIONS(1368),
    [aux_sym_while_statement_token2] = ACTIONS(1368),
    [aux_sym_do_statement_token1] = ACTIONS(1368),
    [aux_sym_for_statement_token1] = ACTIONS(1368),
    [aux_sym_for_statement_token2] = ACTIONS(1368),
    [aux_sym_foreach_statement_token1] = ACTIONS(1368),
    [aux_sym_foreach_statement_token2] = ACTIONS(1368),
    [aux_sym_if_statement_token1] = ACTIONS(1368),
    [aux_sym_if_statement_token2] = ACTIONS(1368),
    [aux_sym_else_if_clause_token1] = ACTIONS(1368),
    [aux_sym_else_clause_token1] = ACTIONS(1368),
    [aux_sym_match_expression_token1] = ACTIONS(1368),
    [aux_sym_match_default_expression_token1] = ACTIONS(1368),
    [aux_sym_switch_statement_token1] = ACTIONS(1368),
    [aux_sym_switch_block_token1] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(1368),
    [anon_sym_DASH] = ACTIONS(1368),
    [anon_sym_TILDE] = ACTIONS(1366),
    [anon_sym_BANG] = ACTIONS(1366),
    [anon_sym_AT] = ACTIONS(1366),
    [aux_sym_clone_expression_token1] = ACTIONS(1368),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1368),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1368),
    [anon_sym_DASH_DASH] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1366),
    [aux_sym__list_destructing_token1] = ACTIONS(1368),
    [anon_sym_LBRACK] = ACTIONS(1366),
    [anon_sym_self] = ACTIONS(1368),
    [anon_sym_parent] = ACTIONS(1368),
    [aux_sym__argument_name_token1] = ACTIONS(1368),
    [aux_sym__argument_name_token2] = ACTIONS(1368),
    [anon_sym_POUND_LBRACK] = ACTIONS(1366),
    [aux_sym_encapsed_string_token1] = ACTIONS(1366),
    [anon_sym_DQUOTE] = ACTIONS(1366),
    [aux_sym_string_token1] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LT_LT] = ACTIONS(1366),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_DOLLAR] = ACTIONS(1366),
    [aux_sym_yield_expression_token1] = ACTIONS(1368),
    [aux_sym_include_expression_token1] = ACTIONS(1368),
    [aux_sym_include_once_expression_token1] = ACTIONS(1368),
    [aux_sym_require_expression_token1] = ACTIONS(1368),
    [aux_sym_require_once_expression_token1] = ACTIONS(1368),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_name] = ACTIONS(1372),
    [anon_sym_QMARK_GT] = ACTIONS(1370),
    [anon_sym_SEMI] = ACTIONS(1370),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1372),
    [aux_sym_global_declaration_token1] = ACTIONS(1372),
    [aux_sym_namespace_definition_token1] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1372),
    [anon_sym_BSLASH] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [aux_sym_trait_declaration_token1] = ACTIONS(1372),
    [aux_sym_interface_declaration_token1] = ACTIONS(1372),
    [aux_sym_enum_declaration_token1] = ACTIONS(1372),
    [aux_sym_enum_case_token1] = ACTIONS(1372),
    [aux_sym_class_declaration_token1] = ACTIONS(1372),
    [aux_sym_final_modifier_token1] = ACTIONS(1372),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1372),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1372),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [aux_sym_cast_type_token1] = ACTIONS(1372),
    [aux_sym_echo_statement_token1] = ACTIONS(1372),
    [anon_sym_unset] = ACTIONS(1372),
    [aux_sym_declare_statement_token1] = ACTIONS(1372),
    [aux_sym_declare_statement_token2] = ACTIONS(1372),
    [sym_float] = ACTIONS(1372),
    [aux_sym_try_statement_token1] = ACTIONS(1372),
    [aux_sym_goto_statement_token1] = ACTIONS(1372),
    [aux_sym_continue_statement_token1] = ACTIONS(1372),
    [aux_sym_break_statement_token1] = ACTIONS(1372),
    [sym_integer] = ACTIONS(1372),
    [aux_sym_return_statement_token1] = ACTIONS(1372),
    [aux_sym_throw_expression_token1] = ACTIONS(1372),
    [aux_sym_while_statement_token1] = ACTIONS(1372),
    [aux_sym_while_statement_token2] = ACTIONS(1372),
    [aux_sym_do_statement_token1] = ACTIONS(1372),
    [aux_sym_for_statement_token1] = ACTIONS(1372),
    [aux_sym_for_statement_token2] = ACTIONS(1372),
    [aux_sym_foreach_statement_token1] = ACTIONS(1372),
    [aux_sym_foreach_statement_token2] = ACTIONS(1372),
    [aux_sym_if_statement_token1] = ACTIONS(1372),
    [aux_sym_if_statement_token2] = ACTIONS(1372),
    [aux_sym_else_if_clause_token1] = ACTIONS(1372),
    [aux_sym_else_clause_token1] = ACTIONS(1372),
    [aux_sym_match_expression_token1] = ACTIONS(1372),
    [aux_sym_match_default_expression_token1] = ACTIONS(1372),
    [aux_sym_switch_statement_token1] = ACTIONS(1372),
    [aux_sym_switch_block_token1] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_AT] = ACTIONS(1370),
    [aux_sym_clone_expression_token1] = ACTIONS(1372),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1372),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [aux_sym__list_destructing_token1] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_self] = ACTIONS(1372),
    [anon_sym_parent] = ACTIONS(1372),
    [aux_sym__argument_name_token1] = ACTIONS(1372),
    [aux_sym__argument_name_token2] = ACTIONS(1372),
    [anon_sym_POUND_LBRACK] = ACTIONS(1370),
    [aux_sym_encapsed_string_token1] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [aux_sym_string_token1] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_LT_LT_LT] = ACTIONS(1370),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR] = ACTIONS(1370),
    [aux_sym_yield_expression_token1] = ACTIONS(1372),
    [aux_sym_include_expression_token1] = ACTIONS(1372),
    [aux_sym_include_once_expression_token1] = ACTIONS(1372),
    [aux_sym_require_expression_token1] = ACTIONS(1372),
    [aux_sym_require_once_expression_token1] = ACTIONS(1372),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1370),
    [sym_name] = ACTIONS(1372),
    [anon_sym_QMARK_GT] = ACTIONS(1370),
    [anon_sym_SEMI] = ACTIONS(1370),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1372),
    [aux_sym_global_declaration_token1] = ACTIONS(1372),
    [aux_sym_namespace_definition_token1] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1372),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1372),
    [anon_sym_BSLASH] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1370),
    [anon_sym_RBRACE] = ACTIONS(1370),
    [aux_sym_trait_declaration_token1] = ACTIONS(1372),
    [aux_sym_interface_declaration_token1] = ACTIONS(1372),
    [aux_sym_enum_declaration_token1] = ACTIONS(1372),
    [aux_sym_enum_case_token1] = ACTIONS(1372),
    [aux_sym_class_declaration_token1] = ACTIONS(1372),
    [aux_sym_final_modifier_token1] = ACTIONS(1372),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1372),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1372),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1372),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1372),
    [anon_sym_LPAREN] = ACTIONS(1370),
    [aux_sym_cast_type_token1] = ACTIONS(1372),
    [aux_sym_echo_statement_token1] = ACTIONS(1372),
    [anon_sym_unset] = ACTIONS(1372),
    [aux_sym_declare_statement_token1] = ACTIONS(1372),
    [aux_sym_declare_statement_token2] = ACTIONS(1372),
    [sym_float] = ACTIONS(1372),
    [aux_sym_try_statement_token1] = ACTIONS(1372),
    [aux_sym_goto_statement_token1] = ACTIONS(1372),
    [aux_sym_continue_statement_token1] = ACTIONS(1372),
    [aux_sym_break_statement_token1] = ACTIONS(1372),
    [sym_integer] = ACTIONS(1372),
    [aux_sym_return_statement_token1] = ACTIONS(1372),
    [aux_sym_throw_expression_token1] = ACTIONS(1372),
    [aux_sym_while_statement_token1] = ACTIONS(1372),
    [aux_sym_while_statement_token2] = ACTIONS(1372),
    [aux_sym_do_statement_token1] = ACTIONS(1372),
    [aux_sym_for_statement_token1] = ACTIONS(1372),
    [aux_sym_for_statement_token2] = ACTIONS(1372),
    [aux_sym_foreach_statement_token1] = ACTIONS(1372),
    [aux_sym_foreach_statement_token2] = ACTIONS(1372),
    [aux_sym_if_statement_token1] = ACTIONS(1372),
    [aux_sym_if_statement_token2] = ACTIONS(1372),
    [aux_sym_else_if_clause_token1] = ACTIONS(1372),
    [aux_sym_else_clause_token1] = ACTIONS(1372),
    [aux_sym_match_expression_token1] = ACTIONS(1372),
    [aux_sym_match_default_expression_token1] = ACTIONS(1372),
    [aux_sym_switch_statement_token1] = ACTIONS(1372),
    [aux_sym_switch_block_token1] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_TILDE] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(1370),
    [anon_sym_AT] = ACTIONS(1370),
    [aux_sym_clone_expression_token1] = ACTIONS(1372),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1372),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1372),
    [anon_sym_DASH_DASH] = ACTIONS(1370),
    [anon_sym_PLUS_PLUS] = ACTIONS(1370),
    [aux_sym__list_destructing_token1] = ACTIONS(1372),
    [anon_sym_LBRACK] = ACTIONS(1370),
    [anon_sym_self] = ACTIONS(1372),
    [anon_sym_parent] = ACTIONS(1372),
    [aux_sym__argument_name_token1] = ACTIONS(1372),
    [aux_sym__argument_name_token2] = ACTIONS(1372),
    [anon_sym_POUND_LBRACK] = ACTIONS(1370),
    [aux_sym_encapsed_string_token1] = ACTIONS(1370),
    [anon_sym_DQUOTE] = ACTIONS(1370),
    [aux_sym_string_token1] = ACTIONS(1370),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [anon_sym_LT_LT_LT] = ACTIONS(1370),
    [anon_sym_BQUOTE] = ACTIONS(1370),
    [anon_sym_DOLLAR] = ACTIONS(1370),
    [aux_sym_yield_expression_token1] = ACTIONS(1372),
    [aux_sym_include_expression_token1] = ACTIONS(1372),
    [aux_sym_include_once_expression_token1] = ACTIONS(1372),
    [aux_sym_require_expression_token1] = ACTIONS(1372),
    [aux_sym_require_once_expression_token1] = ACTIONS(1372),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1374),
    [sym_name] = ACTIONS(1376),
    [anon_sym_QMARK_GT] = ACTIONS(1374),
    [anon_sym_SEMI] = ACTIONS(1374),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1376),
    [aux_sym_global_declaration_token1] = ACTIONS(1376),
    [aux_sym_namespace_definition_token1] = ACTIONS(1376),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1376),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1376),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1376),
    [anon_sym_BSLASH] = ACTIONS(1374),
    [anon_sym_LBRACE] = ACTIONS(1374),
    [anon_sym_RBRACE] = ACTIONS(1374),
    [aux_sym_trait_declaration_token1] = ACTIONS(1376),
    [aux_sym_interface_declaration_token1] = ACTIONS(1376),
    [aux_sym_enum_declaration_token1] = ACTIONS(1376),
    [aux_sym_enum_case_token1] = ACTIONS(1376),
    [aux_sym_class_declaration_token1] = ACTIONS(1376),
    [aux_sym_final_modifier_token1] = ACTIONS(1376),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1376),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1376),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1376),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1376),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1376),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1376),
    [anon_sym_LPAREN] = ACTIONS(1374),
    [aux_sym_cast_type_token1] = ACTIONS(1376),
    [aux_sym_echo_statement_token1] = ACTIONS(1376),
    [anon_sym_unset] = ACTIONS(1376),
    [aux_sym_declare_statement_token1] = ACTIONS(1376),
    [aux_sym_declare_statement_token2] = ACTIONS(1376),
    [sym_float] = ACTIONS(1376),
    [aux_sym_try_statement_token1] = ACTIONS(1376),
    [aux_sym_goto_statement_token1] = ACTIONS(1376),
    [aux_sym_continue_statement_token1] = ACTIONS(1376),
    [aux_sym_break_statement_token1] = ACTIONS(1376),
    [sym_integer] = ACTIONS(1376),
    [aux_sym_return_statement_token1] = ACTIONS(1376),
    [aux_sym_throw_expression_token1] = ACTIONS(1376),
    [aux_sym_while_statement_token1] = ACTIONS(1376),
    [aux_sym_while_statement_token2] = ACTIONS(1376),
    [aux_sym_do_statement_token1] = ACTIONS(1376),
    [aux_sym_for_statement_token1] = ACTIONS(1376),
    [aux_sym_for_statement_token2] = ACTIONS(1376),
    [aux_sym_foreach_statement_token1] = ACTIONS(1376),
    [aux_sym_foreach_statement_token2] = ACTIONS(1376),
    [aux_sym_if_statement_token1] = ACTIONS(1376),
    [aux_sym_if_statement_token2] = ACTIONS(1376),
    [aux_sym_else_if_clause_token1] = ACTIONS(1376),
    [aux_sym_else_clause_token1] = ACTIONS(1376),
    [aux_sym_match_expression_token1] = ACTIONS(1376),
    [aux_sym_match_default_expression_token1] = ACTIONS(1376),
    [aux_sym_switch_statement_token1] = ACTIONS(1376),
    [aux_sym_switch_block_token1] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_TILDE] = ACTIONS(1374),
    [anon_sym_BANG] = ACTIONS(1374),
    [anon_sym_AT] = ACTIONS(1374),
    [aux_sym_clone_expression_token1] = ACTIONS(1376),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1376),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1376),
    [anon_sym_DASH_DASH] = ACTIONS(1374),
    [anon_sym_PLUS_PLUS] = ACTIONS(1374),
    [aux_sym__list_destructing_token1] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1374),
    [anon_sym_self] = ACTIONS(1376),
    [anon_sym_parent] = ACTIONS(1376),
    [aux_sym__argument_name_token1] = ACTIONS(1376),
    [aux_sym__argument_name_token2] = ACTIONS(1376),
    [anon_sym_POUND_LBRACK] = ACTIONS(1374),
    [aux_sym_encapsed_string_token1] = ACTIONS(1374),
    [anon_sym_DQUOTE] = ACTIONS(1374),
    [aux_sym_string_token1] = ACTIONS(1374),
    [anon_sym_SQUOTE] = ACTIONS(1374),
    [anon_sym_LT_LT_LT] = ACTIONS(1374),
    [anon_sym_BQUOTE] = ACTIONS(1374),
    [anon_sym_DOLLAR] = ACTIONS(1374),
    [aux_sym_yield_expression_token1] = ACTIONS(1376),
    [aux_sym_include_expression_token1] = ACTIONS(1376),
    [aux_sym_include_once_expression_token1] = ACTIONS(1376),
    [aux_sym_require_expression_token1] = ACTIONS(1376),
    [aux_sym_require_once_expression_token1] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1378),
    [sym_name] = ACTIONS(1380),
    [anon_sym_QMARK_GT] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1378),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1380),
    [aux_sym_global_declaration_token1] = ACTIONS(1380),
    [aux_sym_namespace_definition_token1] = ACTIONS(1380),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1380),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1380),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1380),
    [anon_sym_BSLASH] = ACTIONS(1378),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [aux_sym_trait_declaration_token1] = ACTIONS(1380),
    [aux_sym_interface_declaration_token1] = ACTIONS(1380),
    [aux_sym_enum_declaration_token1] = ACTIONS(1380),
    [aux_sym_enum_case_token1] = ACTIONS(1380),
    [aux_sym_class_declaration_token1] = ACTIONS(1380),
    [aux_sym_final_modifier_token1] = ACTIONS(1380),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1380),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1380),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1380),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1380),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1380),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1380),
    [anon_sym_LPAREN] = ACTIONS(1378),
    [aux_sym_cast_type_token1] = ACTIONS(1380),
    [aux_sym_echo_statement_token1] = ACTIONS(1380),
    [anon_sym_unset] = ACTIONS(1380),
    [aux_sym_declare_statement_token1] = ACTIONS(1380),
    [aux_sym_declare_statement_token2] = ACTIONS(1380),
    [sym_float] = ACTIONS(1380),
    [aux_sym_try_statement_token1] = ACTIONS(1380),
    [aux_sym_goto_statement_token1] = ACTIONS(1380),
    [aux_sym_continue_statement_token1] = ACTIONS(1380),
    [aux_sym_break_statement_token1] = ACTIONS(1380),
    [sym_integer] = ACTIONS(1380),
    [aux_sym_return_statement_token1] = ACTIONS(1380),
    [aux_sym_throw_expression_token1] = ACTIONS(1380),
    [aux_sym_while_statement_token1] = ACTIONS(1380),
    [aux_sym_while_statement_token2] = ACTIONS(1380),
    [aux_sym_do_statement_token1] = ACTIONS(1380),
    [aux_sym_for_statement_token1] = ACTIONS(1380),
    [aux_sym_for_statement_token2] = ACTIONS(1380),
    [aux_sym_foreach_statement_token1] = ACTIONS(1380),
    [aux_sym_foreach_statement_token2] = ACTIONS(1380),
    [aux_sym_if_statement_token1] = ACTIONS(1380),
    [aux_sym_if_statement_token2] = ACTIONS(1380),
    [aux_sym_else_if_clause_token1] = ACTIONS(1380),
    [aux_sym_else_clause_token1] = ACTIONS(1380),
    [aux_sym_match_expression_token1] = ACTIONS(1380),
    [aux_sym_match_default_expression_token1] = ACTIONS(1380),
    [aux_sym_switch_statement_token1] = ACTIONS(1380),
    [aux_sym_switch_block_token1] = ACTIONS(1380),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_TILDE] = ACTIONS(1378),
    [anon_sym_BANG] = ACTIONS(1378),
    [anon_sym_AT] = ACTIONS(1378),
    [aux_sym_clone_expression_token1] = ACTIONS(1380),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1380),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1380),
    [anon_sym_DASH_DASH] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(1378),
    [aux_sym__list_destructing_token1] = ACTIONS(1380),
    [anon_sym_LBRACK] = ACTIONS(1378),
    [anon_sym_self] = ACTIONS(1380),
    [anon_sym_parent] = ACTIONS(1380),
    [aux_sym__argument_name_token1] = ACTIONS(1380),
    [aux_sym__argument_name_token2] = ACTIONS(1380),
    [anon_sym_POUND_LBRACK] = ACTIONS(1378),
    [aux_sym_encapsed_string_token1] = ACTIONS(1378),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [aux_sym_string_token1] = ACTIONS(1378),
    [anon_sym_SQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(1378),
    [aux_sym_yield_expression_token1] = ACTIONS(1380),
    [aux_sym_include_expression_token1] = ACTIONS(1380),
    [aux_sym_include_once_expression_token1] = ACTIONS(1380),
    [aux_sym_require_expression_token1] = ACTIONS(1380),
    [aux_sym_require_once_expression_token1] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(1382),
    [sym_name] = ACTIONS(1384),
    [anon_sym_QMARK_GT] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1382),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1384),
    [aux_sym_global_declaration_token1] = ACTIONS(1384),
    [aux_sym_namespace_definition_token1] = ACTIONS(1384),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1384),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1384),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1384),
    [anon_sym_BSLASH] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1382),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [aux_sym_trait_declaration_token1] = ACTIONS(1384),
    [aux_sym_interface_declaration_token1] = ACTIONS(1384),
    [aux_sym_enum_declaration_token1] = ACTIONS(1384),
    [aux_sym_enum_case_token1] = ACTIONS(1384),
    [aux_sym_class_declaration_token1] = ACTIONS(1384),
    [aux_sym_final_modifier_token1] = ACTIONS(1384),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1384),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1384),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1384),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1384),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1384),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1382),
    [aux_sym_cast_type_token1] = ACTIONS(1384),
    [aux_sym_echo_statement_token1] = ACTIONS(1384),
    [anon_sym_unset] = ACTIONS(1384),
    [aux_sym_declare_statement_token1] = ACTIONS(1384),
    [aux_sym_declare_statement_token2] = ACTIONS(1384),
    [sym_float] = ACTIONS(1384),
    [aux_sym_try_statement_token1] = ACTIONS(1384),
    [aux_sym_goto_statement_token1] = ACTIONS(1384),
    [aux_sym_continue_statement_token1] = ACTIONS(1384),
    [aux_sym_break_statement_token1] = ACTIONS(1384),
    [sym_integer] = ACTIONS(1384),
    [aux_sym_return_statement_token1] = ACTIONS(1384),
    [aux_sym_throw_expression_token1] = ACTIONS(1384),
    [aux_sym_while_statement_token1] = ACTIONS(1384),
    [aux_sym_while_statement_token2] = ACTIONS(1384),
    [aux_sym_do_statement_token1] = ACTIONS(1384),
    [aux_sym_for_statement_token1] = ACTIONS(1384),
    [aux_sym_for_statement_token2] = ACTIONS(1384),
    [aux_sym_foreach_statement_token1] = ACTIONS(1384),
    [aux_sym_foreach_statement_token2] = ACTIONS(1384),
    [aux_sym_if_statement_token1] = ACTIONS(1384),
    [aux_sym_if_statement_token2] = ACTIONS(1384),
    [aux_sym_else_if_clause_token1] = ACTIONS(1384),
    [aux_sym_else_clause_token1] = ACTIONS(1384),
    [aux_sym_match_expression_token1] = ACTIONS(1384),
    [aux_sym_match_default_expression_token1] = ACTIONS(1384),
    [aux_sym_switch_statement_token1] = ACTIONS(1384),
    [aux_sym_switch_block_token1] = ACTIONS(1384),
    [anon_sym_PLUS] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1382),
    [anon_sym_BANG] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1382),
    [aux_sym_clone_expression_token1] = ACTIONS(1384),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1384),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1384),
    [anon_sym_DASH_DASH] = ACTIONS(1382),
    [anon_sym_PLUS_PLUS] = ACTIONS(1382),
    [aux_sym__list_destructing_token1] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_self] = ACTIONS(1384),
    [anon_sym_parent] = ACTIONS(1384),
    [aux_sym__argument_name_token1] = ACTIONS(1384),
    [aux_sym__argument_name_token2] = ACTIONS(1384),
    [anon_sym_POUND_LBRACK] = ACTIONS(1382),
    [aux_sym_encapsed_string_token1] = ACTIONS(1382),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [aux_sym_string_token1] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1382),
    [aux_sym_yield_expression_token1] = ACTIONS(1384),
    [aux_sym_include_expression_token1] = ACTIONS(1384),
    [aux_sym_include_once_expression_token1] = ACTIONS(1384),
    [aux_sym_require_expression_token1] = ACTIONS(1384),
    [aux_sym_require_once_expression_token1] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(1011),
    [sym_name] = ACTIONS(1013),
    [anon_sym_QMARK_GT] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1011),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1013),
    [aux_sym_global_declaration_token1] = ACTIONS(1013),
    [aux_sym_namespace_definition_token1] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1013),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1013),
    [anon_sym_BSLASH] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [aux_sym_trait_declaration_token1] = ACTIONS(1013),
    [aux_sym_interface_declaration_token1] = ACTIONS(1013),
    [aux_sym_enum_declaration_token1] = ACTIONS(1013),
    [aux_sym_enum_case_token1] = ACTIONS(1013),
    [aux_sym_class_declaration_token1] = ACTIONS(1013),
    [aux_sym_final_modifier_token1] = ACTIONS(1013),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1013),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1013),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1013),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [aux_sym_cast_type_token1] = ACTIONS(1013),
    [aux_sym_echo_statement_token1] = ACTIONS(1013),
    [anon_sym_unset] = ACTIONS(1013),
    [aux_sym_declare_statement_token1] = ACTIONS(1013),
    [aux_sym_declare_statement_token2] = ACTIONS(1013),
    [sym_float] = ACTIONS(1013),
    [aux_sym_try_statement_token1] = ACTIONS(1013),
    [aux_sym_goto_statement_token1] = ACTIONS(1013),
    [aux_sym_continue_statement_token1] = ACTIONS(1013),
    [aux_sym_break_statement_token1] = ACTIONS(1013),
    [sym_integer] = ACTIONS(1013),
    [aux_sym_return_statement_token1] = ACTIONS(1013),
    [aux_sym_throw_expression_token1] = ACTIONS(1013),
    [aux_sym_while_statement_token1] = ACTIONS(1013),
    [aux_sym_while_statement_token2] = ACTIONS(1013),
    [aux_sym_do_statement_token1] = ACTIONS(1013),
    [aux_sym_for_statement_token1] = ACTIONS(1013),
    [aux_sym_for_statement_token2] = ACTIONS(1013),
    [aux_sym_foreach_statement_token1] = ACTIONS(1013),
    [aux_sym_foreach_statement_token2] = ACTIONS(1013),
    [aux_sym_if_statement_token1] = ACTIONS(1013),
    [aux_sym_if_statement_token2] = ACTIONS(1013),
    [aux_sym_else_if_clause_token1] = ACTIONS(1013),
    [aux_sym_else_clause_token1] = ACTIONS(1013),
    [aux_sym_match_expression_token1] = ACTIONS(1013),
    [aux_sym_match_default_expression_token1] = ACTIONS(1013),
    [aux_sym_switch_statement_token1] = ACTIONS(1013),
    [aux_sym_switch_block_token1] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1013),
    [anon_sym_DASH] = ACTIONS(1013),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1011),
    [aux_sym_clone_expression_token1] = ACTIONS(1013),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1013),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1011),
    [aux_sym__list_destructing_token1] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_self] = ACTIONS(1013),
    [anon_sym_parent] = ACTIONS(1013),
    [aux_sym__argument_name_token1] = ACTIONS(1013),
    [aux_sym__argument_name_token2] = ACTIONS(1013),
    [anon_sym_POUND_LBRACK] = ACTIONS(1011),
    [aux_sym_encapsed_string_token1] = ACTIONS(1011),
    [anon_sym_DQUOTE] = ACTIONS(1011),
    [aux_sym_string_token1] = ACTIONS(1011),
    [anon_sym_SQUOTE] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [anon_sym_BQUOTE] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(1011),
    [aux_sym_yield_expression_token1] = ACTIONS(1013),
    [aux_sym_include_expression_token1] = ACTIONS(1013),
    [aux_sym_include_once_expression_token1] = ACTIONS(1013),
    [aux_sym_require_expression_token1] = ACTIONS(1013),
    [aux_sym_require_once_expression_token1] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1386),
    [sym_name] = ACTIONS(1388),
    [anon_sym_QMARK_GT] = ACTIONS(1386),
    [anon_sym_SEMI] = ACTIONS(1386),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1388),
    [aux_sym_global_declaration_token1] = ACTIONS(1388),
    [aux_sym_namespace_definition_token1] = ACTIONS(1388),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1388),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1388),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1388),
    [anon_sym_BSLASH] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1386),
    [anon_sym_RBRACE] = ACTIONS(1386),
    [aux_sym_trait_declaration_token1] = ACTIONS(1388),
    [aux_sym_interface_declaration_token1] = ACTIONS(1388),
    [aux_sym_enum_declaration_token1] = ACTIONS(1388),
    [aux_sym_enum_case_token1] = ACTIONS(1388),
    [aux_sym_class_declaration_token1] = ACTIONS(1388),
    [aux_sym_final_modifier_token1] = ACTIONS(1388),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1388),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1388),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1388),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1388),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1388),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1386),
    [aux_sym_cast_type_token1] = ACTIONS(1388),
    [aux_sym_echo_statement_token1] = ACTIONS(1388),
    [anon_sym_unset] = ACTIONS(1388),
    [aux_sym_declare_statement_token1] = ACTIONS(1388),
    [aux_sym_declare_statement_token2] = ACTIONS(1388),
    [sym_float] = ACTIONS(1388),
    [aux_sym_try_statement_token1] = ACTIONS(1388),
    [aux_sym_goto_statement_token1] = ACTIONS(1388),
    [aux_sym_continue_statement_token1] = ACTIONS(1388),
    [aux_sym_break_statement_token1] = ACTIONS(1388),
    [sym_integer] = ACTIONS(1388),
    [aux_sym_return_statement_token1] = ACTIONS(1388),
    [aux_sym_throw_expression_token1] = ACTIONS(1388),
    [aux_sym_while_statement_token1] = ACTIONS(1388),
    [aux_sym_while_statement_token2] = ACTIONS(1388),
    [aux_sym_do_statement_token1] = ACTIONS(1388),
    [aux_sym_for_statement_token1] = ACTIONS(1388),
    [aux_sym_for_statement_token2] = ACTIONS(1388),
    [aux_sym_foreach_statement_token1] = ACTIONS(1388),
    [aux_sym_foreach_statement_token2] = ACTIONS(1388),
    [aux_sym_if_statement_token1] = ACTIONS(1388),
    [aux_sym_if_statement_token2] = ACTIONS(1388),
    [aux_sym_else_if_clause_token1] = ACTIONS(1388),
    [aux_sym_else_clause_token1] = ACTIONS(1388),
    [aux_sym_match_expression_token1] = ACTIONS(1388),
    [aux_sym_match_default_expression_token1] = ACTIONS(1388),
    [aux_sym_switch_statement_token1] = ACTIONS(1388),
    [aux_sym_switch_block_token1] = ACTIONS(1388),
    [anon_sym_PLUS] = ACTIONS(1388),
    [anon_sym_DASH] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_BANG] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1386),
    [aux_sym_clone_expression_token1] = ACTIONS(1388),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1388),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(1386),
    [anon_sym_PLUS_PLUS] = ACTIONS(1386),
    [aux_sym__list_destructing_token1] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [anon_sym_self] = ACTIONS(1388),
    [anon_sym_parent] = ACTIONS(1388),
    [aux_sym__argument_name_token1] = ACTIONS(1388),
    [aux_sym__argument_name_token2] = ACTIONS(1388),
    [anon_sym_POUND_LBRACK] = ACTIONS(1386),
    [aux_sym_encapsed_string_token1] = ACTIONS(1386),
    [anon_sym_DQUOTE] = ACTIONS(1386),
    [aux_sym_string_token1] = ACTIONS(1386),
    [anon_sym_SQUOTE] = ACTIONS(1386),
    [anon_sym_LT_LT_LT] = ACTIONS(1386),
    [anon_sym_BQUOTE] = ACTIONS(1386),
    [anon_sym_DOLLAR] = ACTIONS(1386),
    [aux_sym_yield_expression_token1] = ACTIONS(1388),
    [aux_sym_include_expression_token1] = ACTIONS(1388),
    [aux_sym_include_once_expression_token1] = ACTIONS(1388),
    [aux_sym_require_expression_token1] = ACTIONS(1388),
    [aux_sym_require_once_expression_token1] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(1390),
    [sym_name] = ACTIONS(1392),
    [anon_sym_QMARK_GT] = ACTIONS(1390),
    [anon_sym_SEMI] = ACTIONS(1390),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1392),
    [aux_sym_global_declaration_token1] = ACTIONS(1392),
    [aux_sym_namespace_definition_token1] = ACTIONS(1392),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1392),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1392),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1392),
    [anon_sym_BSLASH] = ACTIONS(1390),
    [anon_sym_LBRACE] = ACTIONS(1390),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [aux_sym_trait_declaration_token1] = ACTIONS(1392),
    [aux_sym_interface_declaration_token1] = ACTIONS(1392),
    [aux_sym_enum_declaration_token1] = ACTIONS(1392),
    [aux_sym_enum_case_token1] = ACTIONS(1392),
    [aux_sym_class_declaration_token1] = ACTIONS(1392),
    [aux_sym_final_modifier_token1] = ACTIONS(1392),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1392),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1392),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1392),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1392),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1392),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1390),
    [aux_sym_cast_type_token1] = ACTIONS(1392),
    [aux_sym_echo_statement_token1] = ACTIONS(1392),
    [anon_sym_unset] = ACTIONS(1392),
    [aux_sym_declare_statement_token1] = ACTIONS(1392),
    [aux_sym_declare_statement_token2] = ACTIONS(1392),
    [sym_float] = ACTIONS(1392),
    [aux_sym_try_statement_token1] = ACTIONS(1392),
    [aux_sym_goto_statement_token1] = ACTIONS(1392),
    [aux_sym_continue_statement_token1] = ACTIONS(1392),
    [aux_sym_break_statement_token1] = ACTIONS(1392),
    [sym_integer] = ACTIONS(1392),
    [aux_sym_return_statement_token1] = ACTIONS(1392),
    [aux_sym_throw_expression_token1] = ACTIONS(1392),
    [aux_sym_while_statement_token1] = ACTIONS(1392),
    [aux_sym_while_statement_token2] = ACTIONS(1392),
    [aux_sym_do_statement_token1] = ACTIONS(1392),
    [aux_sym_for_statement_token1] = ACTIONS(1392),
    [aux_sym_for_statement_token2] = ACTIONS(1392),
    [aux_sym_foreach_statement_token1] = ACTIONS(1392),
    [aux_sym_foreach_statement_token2] = ACTIONS(1392),
    [aux_sym_if_statement_token1] = ACTIONS(1392),
    [aux_sym_if_statement_token2] = ACTIONS(1392),
    [aux_sym_else_if_clause_token1] = ACTIONS(1392),
    [aux_sym_else_clause_token1] = ACTIONS(1392),
    [aux_sym_match_expression_token1] = ACTIONS(1392),
    [aux_sym_match_default_expression_token1] = ACTIONS(1392),
    [aux_sym_switch_statement_token1] = ACTIONS(1392),
    [aux_sym_switch_block_token1] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1390),
    [aux_sym_clone_expression_token1] = ACTIONS(1392),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1392),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1392),
    [anon_sym_DASH_DASH] = ACTIONS(1390),
    [anon_sym_PLUS_PLUS] = ACTIONS(1390),
    [aux_sym__list_destructing_token1] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1390),
    [anon_sym_self] = ACTIONS(1392),
    [anon_sym_parent] = ACTIONS(1392),
    [aux_sym__argument_name_token1] = ACTIONS(1392),
    [aux_sym__argument_name_token2] = ACTIONS(1392),
    [anon_sym_POUND_LBRACK] = ACTIONS(1390),
    [aux_sym_encapsed_string_token1] = ACTIONS(1390),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [aux_sym_string_token1] = ACTIONS(1390),
    [anon_sym_SQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LT_LT] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [aux_sym_yield_expression_token1] = ACTIONS(1392),
    [aux_sym_include_expression_token1] = ACTIONS(1392),
    [aux_sym_include_once_expression_token1] = ACTIONS(1392),
    [aux_sym_require_expression_token1] = ACTIONS(1392),
    [aux_sym_require_once_expression_token1] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1394),
    [sym_name] = ACTIONS(1396),
    [anon_sym_QMARK_GT] = ACTIONS(1394),
    [anon_sym_SEMI] = ACTIONS(1394),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1396),
    [aux_sym_global_declaration_token1] = ACTIONS(1396),
    [aux_sym_namespace_definition_token1] = ACTIONS(1396),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1396),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1396),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1396),
    [anon_sym_BSLASH] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [aux_sym_trait_declaration_token1] = ACTIONS(1396),
    [aux_sym_interface_declaration_token1] = ACTIONS(1396),
    [aux_sym_enum_declaration_token1] = ACTIONS(1396),
    [aux_sym_enum_case_token1] = ACTIONS(1396),
    [aux_sym_class_declaration_token1] = ACTIONS(1396),
    [aux_sym_final_modifier_token1] = ACTIONS(1396),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1396),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1396),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1396),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1396),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1396),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [aux_sym_cast_type_token1] = ACTIONS(1396),
    [aux_sym_echo_statement_token1] = ACTIONS(1396),
    [anon_sym_unset] = ACTIONS(1396),
    [aux_sym_declare_statement_token1] = ACTIONS(1396),
    [aux_sym_declare_statement_token2] = ACTIONS(1396),
    [sym_float] = ACTIONS(1396),
    [aux_sym_try_statement_token1] = ACTIONS(1396),
    [aux_sym_goto_statement_token1] = ACTIONS(1396),
    [aux_sym_continue_statement_token1] = ACTIONS(1396),
    [aux_sym_break_statement_token1] = ACTIONS(1396),
    [sym_integer] = ACTIONS(1396),
    [aux_sym_return_statement_token1] = ACTIONS(1396),
    [aux_sym_throw_expression_token1] = ACTIONS(1396),
    [aux_sym_while_statement_token1] = ACTIONS(1396),
    [aux_sym_while_statement_token2] = ACTIONS(1396),
    [aux_sym_do_statement_token1] = ACTIONS(1396),
    [aux_sym_for_statement_token1] = ACTIONS(1396),
    [aux_sym_for_statement_token2] = ACTIONS(1396),
    [aux_sym_foreach_statement_token1] = ACTIONS(1396),
    [aux_sym_foreach_statement_token2] = ACTIONS(1396),
    [aux_sym_if_statement_token1] = ACTIONS(1396),
    [aux_sym_if_statement_token2] = ACTIONS(1396),
    [aux_sym_else_if_clause_token1] = ACTIONS(1396),
    [aux_sym_else_clause_token1] = ACTIONS(1396),
    [aux_sym_match_expression_token1] = ACTIONS(1396),
    [aux_sym_match_default_expression_token1] = ACTIONS(1396),
    [aux_sym_switch_statement_token1] = ACTIONS(1396),
    [aux_sym_switch_block_token1] = ACTIONS(1396),
    [anon_sym_PLUS] = ACTIONS(1396),
    [anon_sym_DASH] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1394),
    [anon_sym_BANG] = ACTIONS(1394),
    [anon_sym_AT] = ACTIONS(1394),
    [aux_sym_clone_expression_token1] = ACTIONS(1396),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1396),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1396),
    [anon_sym_DASH_DASH] = ACTIONS(1394),
    [anon_sym_PLUS_PLUS] = ACTIONS(1394),
    [aux_sym__list_destructing_token1] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_self] = ACTIONS(1396),
    [anon_sym_parent] = ACTIONS(1396),
    [aux_sym__argument_name_token1] = ACTIONS(1396),
    [aux_sym__argument_name_token2] = ACTIONS(1396),
    [anon_sym_POUND_LBRACK] = ACTIONS(1394),
    [aux_sym_encapsed_string_token1] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1394),
    [aux_sym_string_token1] = ACTIONS(1394),
    [anon_sym_SQUOTE] = ACTIONS(1394),
    [anon_sym_LT_LT_LT] = ACTIONS(1394),
    [anon_sym_BQUOTE] = ACTIONS(1394),
    [anon_sym_DOLLAR] = ACTIONS(1394),
    [aux_sym_yield_expression_token1] = ACTIONS(1396),
    [aux_sym_include_expression_token1] = ACTIONS(1396),
    [aux_sym_include_once_expression_token1] = ACTIONS(1396),
    [aux_sym_require_expression_token1] = ACTIONS(1396),
    [aux_sym_require_once_expression_token1] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_name] = ACTIONS(1400),
    [anon_sym_QMARK_GT] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1398),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1400),
    [aux_sym_global_declaration_token1] = ACTIONS(1400),
    [aux_sym_namespace_definition_token1] = ACTIONS(1400),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1400),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1400),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1400),
    [anon_sym_BSLASH] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [aux_sym_trait_declaration_token1] = ACTIONS(1400),
    [aux_sym_interface_declaration_token1] = ACTIONS(1400),
    [aux_sym_enum_declaration_token1] = ACTIONS(1400),
    [aux_sym_enum_case_token1] = ACTIONS(1400),
    [aux_sym_class_declaration_token1] = ACTIONS(1400),
    [aux_sym_final_modifier_token1] = ACTIONS(1400),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1400),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1400),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1400),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1400),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1400),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1400),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [aux_sym_cast_type_token1] = ACTIONS(1400),
    [aux_sym_echo_statement_token1] = ACTIONS(1400),
    [anon_sym_unset] = ACTIONS(1400),
    [aux_sym_declare_statement_token1] = ACTIONS(1400),
    [aux_sym_declare_statement_token2] = ACTIONS(1400),
    [sym_float] = ACTIONS(1400),
    [aux_sym_try_statement_token1] = ACTIONS(1400),
    [aux_sym_goto_statement_token1] = ACTIONS(1400),
    [aux_sym_continue_statement_token1] = ACTIONS(1400),
    [aux_sym_break_statement_token1] = ACTIONS(1400),
    [sym_integer] = ACTIONS(1400),
    [aux_sym_return_statement_token1] = ACTIONS(1400),
    [aux_sym_throw_expression_token1] = ACTIONS(1400),
    [aux_sym_while_statement_token1] = ACTIONS(1400),
    [aux_sym_while_statement_token2] = ACTIONS(1400),
    [aux_sym_do_statement_token1] = ACTIONS(1400),
    [aux_sym_for_statement_token1] = ACTIONS(1400),
    [aux_sym_for_statement_token2] = ACTIONS(1400),
    [aux_sym_foreach_statement_token1] = ACTIONS(1400),
    [aux_sym_foreach_statement_token2] = ACTIONS(1400),
    [aux_sym_if_statement_token1] = ACTIONS(1400),
    [aux_sym_if_statement_token2] = ACTIONS(1400),
    [aux_sym_else_if_clause_token1] = ACTIONS(1400),
    [aux_sym_else_clause_token1] = ACTIONS(1400),
    [aux_sym_match_expression_token1] = ACTIONS(1400),
    [aux_sym_match_default_expression_token1] = ACTIONS(1400),
    [aux_sym_switch_statement_token1] = ACTIONS(1400),
    [aux_sym_switch_block_token1] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_BANG] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1398),
    [aux_sym_clone_expression_token1] = ACTIONS(1400),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1400),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1400),
    [anon_sym_DASH_DASH] = ACTIONS(1398),
    [anon_sym_PLUS_PLUS] = ACTIONS(1398),
    [aux_sym__list_destructing_token1] = ACTIONS(1400),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_self] = ACTIONS(1400),
    [anon_sym_parent] = ACTIONS(1400),
    [aux_sym__argument_name_token1] = ACTIONS(1400),
    [aux_sym__argument_name_token2] = ACTIONS(1400),
    [anon_sym_POUND_LBRACK] = ACTIONS(1398),
    [aux_sym_encapsed_string_token1] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [aux_sym_string_token1] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1398),
    [aux_sym_yield_expression_token1] = ACTIONS(1400),
    [aux_sym_include_expression_token1] = ACTIONS(1400),
    [aux_sym_include_once_expression_token1] = ACTIONS(1400),
    [aux_sym_require_expression_token1] = ACTIONS(1400),
    [aux_sym_require_once_expression_token1] = ACTIONS(1400),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1226),
    [sym_name] = ACTIONS(1228),
    [anon_sym_QMARK_GT] = ACTIONS(1226),
    [anon_sym_SEMI] = ACTIONS(1226),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1228),
    [aux_sym_global_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_definition_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1228),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1228),
    [anon_sym_BSLASH] = ACTIONS(1226),
    [anon_sym_LBRACE] = ACTIONS(1226),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [aux_sym_trait_declaration_token1] = ACTIONS(1228),
    [aux_sym_interface_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_declaration_token1] = ACTIONS(1228),
    [aux_sym_enum_case_token1] = ACTIONS(1228),
    [aux_sym_class_declaration_token1] = ACTIONS(1228),
    [aux_sym_final_modifier_token1] = ACTIONS(1228),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1228),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1228),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1228),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1228),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [aux_sym_cast_type_token1] = ACTIONS(1228),
    [aux_sym_echo_statement_token1] = ACTIONS(1228),
    [anon_sym_unset] = ACTIONS(1228),
    [aux_sym_declare_statement_token1] = ACTIONS(1228),
    [aux_sym_declare_statement_token2] = ACTIONS(1228),
    [sym_float] = ACTIONS(1228),
    [aux_sym_try_statement_token1] = ACTIONS(1228),
    [aux_sym_goto_statement_token1] = ACTIONS(1228),
    [aux_sym_continue_statement_token1] = ACTIONS(1228),
    [aux_sym_break_statement_token1] = ACTIONS(1228),
    [sym_integer] = ACTIONS(1228),
    [aux_sym_return_statement_token1] = ACTIONS(1228),
    [aux_sym_throw_expression_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token1] = ACTIONS(1228),
    [aux_sym_while_statement_token2] = ACTIONS(1228),
    [aux_sym_do_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token1] = ACTIONS(1228),
    [aux_sym_for_statement_token2] = ACTIONS(1228),
    [aux_sym_foreach_statement_token1] = ACTIONS(1228),
    [aux_sym_foreach_statement_token2] = ACTIONS(1228),
    [aux_sym_if_statement_token1] = ACTIONS(1228),
    [aux_sym_if_statement_token2] = ACTIONS(1228),
    [aux_sym_else_if_clause_token1] = ACTIONS(1228),
    [aux_sym_else_clause_token1] = ACTIONS(1228),
    [aux_sym_match_expression_token1] = ACTIONS(1228),
    [aux_sym_match_default_expression_token1] = ACTIONS(1228),
    [aux_sym_switch_statement_token1] = ACTIONS(1228),
    [aux_sym_switch_block_token1] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(1228),
    [anon_sym_DASH] = ACTIONS(1228),
    [anon_sym_TILDE] = ACTIONS(1226),
    [anon_sym_BANG] = ACTIONS(1226),
    [anon_sym_AT] = ACTIONS(1226),
    [aux_sym_clone_expression_token1] = ACTIONS(1228),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1228),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1228),
    [anon_sym_DASH_DASH] = ACTIONS(1226),
    [anon_sym_PLUS_PLUS] = ACTIONS(1226),
    [aux_sym__list_destructing_token1] = ACTIONS(1228),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_self] = ACTIONS(1228),
    [anon_sym_parent] = ACTIONS(1228),
    [aux_sym__argument_name_token1] = ACTIONS(1228),
    [aux_sym__argument_name_token2] = ACTIONS(1228),
    [anon_sym_POUND_LBRACK] = ACTIONS(1226),
    [aux_sym_encapsed_string_token1] = ACTIONS(1226),
    [anon_sym_DQUOTE] = ACTIONS(1226),
    [aux_sym_string_token1] = ACTIONS(1226),
    [anon_sym_SQUOTE] = ACTIONS(1226),
    [anon_sym_LT_LT_LT] = ACTIONS(1226),
    [anon_sym_BQUOTE] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(1226),
    [aux_sym_yield_expression_token1] = ACTIONS(1228),
    [aux_sym_include_expression_token1] = ACTIONS(1228),
    [aux_sym_include_once_expression_token1] = ACTIONS(1228),
    [aux_sym_require_expression_token1] = ACTIONS(1228),
    [aux_sym_require_once_expression_token1] = ACTIONS(1228),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1402),
    [sym_name] = ACTIONS(1404),
    [anon_sym_QMARK_GT] = ACTIONS(1402),
    [anon_sym_SEMI] = ACTIONS(1402),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1404),
    [aux_sym_global_declaration_token1] = ACTIONS(1404),
    [aux_sym_namespace_definition_token1] = ACTIONS(1404),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1404),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1404),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1404),
    [anon_sym_BSLASH] = ACTIONS(1402),
    [anon_sym_LBRACE] = ACTIONS(1402),
    [anon_sym_RBRACE] = ACTIONS(1402),
    [aux_sym_trait_declaration_token1] = ACTIONS(1404),
    [aux_sym_interface_declaration_token1] = ACTIONS(1404),
    [aux_sym_enum_declaration_token1] = ACTIONS(1404),
    [aux_sym_enum_case_token1] = ACTIONS(1404),
    [aux_sym_class_declaration_token1] = ACTIONS(1404),
    [aux_sym_final_modifier_token1] = ACTIONS(1404),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1404),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1404),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1404),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1404),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1404),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1404),
    [anon_sym_LPAREN] = ACTIONS(1402),
    [aux_sym_cast_type_token1] = ACTIONS(1404),
    [aux_sym_echo_statement_token1] = ACTIONS(1404),
    [anon_sym_unset] = ACTIONS(1404),
    [aux_sym_declare_statement_token1] = ACTIONS(1404),
    [aux_sym_declare_statement_token2] = ACTIONS(1404),
    [sym_float] = ACTIONS(1404),
    [aux_sym_try_statement_token1] = ACTIONS(1404),
    [aux_sym_goto_statement_token1] = ACTIONS(1404),
    [aux_sym_continue_statement_token1] = ACTIONS(1404),
    [aux_sym_break_statement_token1] = ACTIONS(1404),
    [sym_integer] = ACTIONS(1404),
    [aux_sym_return_statement_token1] = ACTIONS(1404),
    [aux_sym_throw_expression_token1] = ACTIONS(1404),
    [aux_sym_while_statement_token1] = ACTIONS(1404),
    [aux_sym_while_statement_token2] = ACTIONS(1404),
    [aux_sym_do_statement_token1] = ACTIONS(1404),
    [aux_sym_for_statement_token1] = ACTIONS(1404),
    [aux_sym_for_statement_token2] = ACTIONS(1404),
    [aux_sym_foreach_statement_token1] = ACTIONS(1404),
    [aux_sym_foreach_statement_token2] = ACTIONS(1404),
    [aux_sym_if_statement_token1] = ACTIONS(1404),
    [aux_sym_if_statement_token2] = ACTIONS(1404),
    [aux_sym_else_if_clause_token1] = ACTIONS(1404),
    [aux_sym_else_clause_token1] = ACTIONS(1404),
    [aux_sym_match_expression_token1] = ACTIONS(1404),
    [aux_sym_match_default_expression_token1] = ACTIONS(1404),
    [aux_sym_switch_statement_token1] = ACTIONS(1404),
    [aux_sym_switch_block_token1] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_TILDE] = ACTIONS(1402),
    [anon_sym_BANG] = ACTIONS(1402),
    [anon_sym_AT] = ACTIONS(1402),
    [aux_sym_clone_expression_token1] = ACTIONS(1404),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1404),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1404),
    [anon_sym_DASH_DASH] = ACTIONS(1402),
    [anon_sym_PLUS_PLUS] = ACTIONS(1402),
    [aux_sym__list_destructing_token1] = ACTIONS(1404),
    [anon_sym_LBRACK] = ACTIONS(1402),
    [anon_sym_self] = ACTIONS(1404),
    [anon_sym_parent] = ACTIONS(1404),
    [aux_sym__argument_name_token1] = ACTIONS(1404),
    [aux_sym__argument_name_token2] = ACTIONS(1404),
    [anon_sym_POUND_LBRACK] = ACTIONS(1402),
    [aux_sym_encapsed_string_token1] = ACTIONS(1402),
    [anon_sym_DQUOTE] = ACTIONS(1402),
    [aux_sym_string_token1] = ACTIONS(1402),
    [anon_sym_SQUOTE] = ACTIONS(1402),
    [anon_sym_LT_LT_LT] = ACTIONS(1402),
    [anon_sym_BQUOTE] = ACTIONS(1402),
    [anon_sym_DOLLAR] = ACTIONS(1402),
    [aux_sym_yield_expression_token1] = ACTIONS(1404),
    [aux_sym_include_expression_token1] = ACTIONS(1404),
    [aux_sym_include_once_expression_token1] = ACTIONS(1404),
    [aux_sym_require_expression_token1] = ACTIONS(1404),
    [aux_sym_require_once_expression_token1] = ACTIONS(1404),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1406),
    [sym_name] = ACTIONS(1408),
    [anon_sym_QMARK_GT] = ACTIONS(1406),
    [anon_sym_SEMI] = ACTIONS(1406),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1408),
    [aux_sym_global_declaration_token1] = ACTIONS(1408),
    [aux_sym_namespace_definition_token1] = ACTIONS(1408),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1408),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1408),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1408),
    [anon_sym_BSLASH] = ACTIONS(1406),
    [anon_sym_LBRACE] = ACTIONS(1406),
    [anon_sym_RBRACE] = ACTIONS(1406),
    [aux_sym_trait_declaration_token1] = ACTIONS(1408),
    [aux_sym_interface_declaration_token1] = ACTIONS(1408),
    [aux_sym_enum_declaration_token1] = ACTIONS(1408),
    [aux_sym_enum_case_token1] = ACTIONS(1408),
    [aux_sym_class_declaration_token1] = ACTIONS(1408),
    [aux_sym_final_modifier_token1] = ACTIONS(1408),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1408),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1408),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1408),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1408),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1408),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1408),
    [anon_sym_LPAREN] = ACTIONS(1406),
    [aux_sym_cast_type_token1] = ACTIONS(1408),
    [aux_sym_echo_statement_token1] = ACTIONS(1408),
    [anon_sym_unset] = ACTIONS(1408),
    [aux_sym_declare_statement_token1] = ACTIONS(1408),
    [aux_sym_declare_statement_token2] = ACTIONS(1408),
    [sym_float] = ACTIONS(1408),
    [aux_sym_try_statement_token1] = ACTIONS(1408),
    [aux_sym_goto_statement_token1] = ACTIONS(1408),
    [aux_sym_continue_statement_token1] = ACTIONS(1408),
    [aux_sym_break_statement_token1] = ACTIONS(1408),
    [sym_integer] = ACTIONS(1408),
    [aux_sym_return_statement_token1] = ACTIONS(1408),
    [aux_sym_throw_expression_token1] = ACTIONS(1408),
    [aux_sym_while_statement_token1] = ACTIONS(1408),
    [aux_sym_while_statement_token2] = ACTIONS(1408),
    [aux_sym_do_statement_token1] = ACTIONS(1408),
    [aux_sym_for_statement_token1] = ACTIONS(1408),
    [aux_sym_for_statement_token2] = ACTIONS(1408),
    [aux_sym_foreach_statement_token1] = ACTIONS(1408),
    [aux_sym_foreach_statement_token2] = ACTIONS(1408),
    [aux_sym_if_statement_token1] = ACTIONS(1408),
    [aux_sym_if_statement_token2] = ACTIONS(1408),
    [aux_sym_else_if_clause_token1] = ACTIONS(1408),
    [aux_sym_else_clause_token1] = ACTIONS(1408),
    [aux_sym_match_expression_token1] = ACTIONS(1408),
    [aux_sym_match_default_expression_token1] = ACTIONS(1408),
    [aux_sym_switch_statement_token1] = ACTIONS(1408),
    [aux_sym_switch_block_token1] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(1406),
    [anon_sym_AT] = ACTIONS(1406),
    [aux_sym_clone_expression_token1] = ACTIONS(1408),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1408),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1408),
    [anon_sym_DASH_DASH] = ACTIONS(1406),
    [anon_sym_PLUS_PLUS] = ACTIONS(1406),
    [aux_sym__list_destructing_token1] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1406),
    [anon_sym_self] = ACTIONS(1408),
    [anon_sym_parent] = ACTIONS(1408),
    [aux_sym__argument_name_token1] = ACTIONS(1408),
    [aux_sym__argument_name_token2] = ACTIONS(1408),
    [anon_sym_POUND_LBRACK] = ACTIONS(1406),
    [aux_sym_encapsed_string_token1] = ACTIONS(1406),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [aux_sym_string_token1] = ACTIONS(1406),
    [anon_sym_SQUOTE] = ACTIONS(1406),
    [anon_sym_LT_LT_LT] = ACTIONS(1406),
    [anon_sym_BQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [aux_sym_yield_expression_token1] = ACTIONS(1408),
    [aux_sym_include_expression_token1] = ACTIONS(1408),
    [aux_sym_include_once_expression_token1] = ACTIONS(1408),
    [aux_sym_require_expression_token1] = ACTIONS(1408),
    [aux_sym_require_once_expression_token1] = ACTIONS(1408),
    [sym_comment] = ACTIONS(3),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1410),
    [sym_name] = ACTIONS(1412),
    [anon_sym_QMARK_GT] = ACTIONS(1410),
    [anon_sym_SEMI] = ACTIONS(1410),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1412),
    [aux_sym_global_declaration_token1] = ACTIONS(1412),
    [aux_sym_namespace_definition_token1] = ACTIONS(1412),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1412),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1412),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1412),
    [anon_sym_BSLASH] = ACTIONS(1410),
    [anon_sym_LBRACE] = ACTIONS(1410),
    [anon_sym_RBRACE] = ACTIONS(1410),
    [aux_sym_trait_declaration_token1] = ACTIONS(1412),
    [aux_sym_interface_declaration_token1] = ACTIONS(1412),
    [aux_sym_enum_declaration_token1] = ACTIONS(1412),
    [aux_sym_enum_case_token1] = ACTIONS(1412),
    [aux_sym_class_declaration_token1] = ACTIONS(1412),
    [aux_sym_final_modifier_token1] = ACTIONS(1412),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1412),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1412),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1412),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1412),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1412),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1410),
    [aux_sym_cast_type_token1] = ACTIONS(1412),
    [aux_sym_echo_statement_token1] = ACTIONS(1412),
    [anon_sym_unset] = ACTIONS(1412),
    [aux_sym_declare_statement_token1] = ACTIONS(1412),
    [aux_sym_declare_statement_token2] = ACTIONS(1412),
    [sym_float] = ACTIONS(1412),
    [aux_sym_try_statement_token1] = ACTIONS(1412),
    [aux_sym_goto_statement_token1] = ACTIONS(1412),
    [aux_sym_continue_statement_token1] = ACTIONS(1412),
    [aux_sym_break_statement_token1] = ACTIONS(1412),
    [sym_integer] = ACTIONS(1412),
    [aux_sym_return_statement_token1] = ACTIONS(1412),
    [aux_sym_throw_expression_token1] = ACTIONS(1412),
    [aux_sym_while_statement_token1] = ACTIONS(1412),
    [aux_sym_while_statement_token2] = ACTIONS(1412),
    [aux_sym_do_statement_token1] = ACTIONS(1412),
    [aux_sym_for_statement_token1] = ACTIONS(1412),
    [aux_sym_for_statement_token2] = ACTIONS(1412),
    [aux_sym_foreach_statement_token1] = ACTIONS(1412),
    [aux_sym_foreach_statement_token2] = ACTIONS(1412),
    [aux_sym_if_statement_token1] = ACTIONS(1412),
    [aux_sym_if_statement_token2] = ACTIONS(1412),
    [aux_sym_else_if_clause_token1] = ACTIONS(1412),
    [aux_sym_else_clause_token1] = ACTIONS(1412),
    [aux_sym_match_expression_token1] = ACTIONS(1412),
    [aux_sym_match_default_expression_token1] = ACTIONS(1412),
    [aux_sym_switch_statement_token1] = ACTIONS(1412),
    [aux_sym_switch_block_token1] = ACTIONS(1412),
    [anon_sym_PLUS] = ACTIONS(1412),
    [anon_sym_DASH] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1410),
    [anon_sym_BANG] = ACTIONS(1410),
    [anon_sym_AT] = ACTIONS(1410),
    [aux_sym_clone_expression_token1] = ACTIONS(1412),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1412),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1410),
    [anon_sym_PLUS_PLUS] = ACTIONS(1410),
    [aux_sym__list_destructing_token1] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_self] = ACTIONS(1412),
    [anon_sym_parent] = ACTIONS(1412),
    [aux_sym__argument_name_token1] = ACTIONS(1412),
    [aux_sym__argument_name_token2] = ACTIONS(1412),
    [anon_sym_POUND_LBRACK] = ACTIONS(1410),
    [aux_sym_encapsed_string_token1] = ACTIONS(1410),
    [anon_sym_DQUOTE] = ACTIONS(1410),
    [aux_sym_string_token1] = ACTIONS(1410),
    [anon_sym_SQUOTE] = ACTIONS(1410),
    [anon_sym_LT_LT_LT] = ACTIONS(1410),
    [anon_sym_BQUOTE] = ACTIONS(1410),
    [anon_sym_DOLLAR] = ACTIONS(1410),
    [aux_sym_yield_expression_token1] = ACTIONS(1412),
    [aux_sym_include_expression_token1] = ACTIONS(1412),
    [aux_sym_include_once_expression_token1] = ACTIONS(1412),
    [aux_sym_require_expression_token1] = ACTIONS(1412),
    [aux_sym_require_once_expression_token1] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1414),
    [sym_name] = ACTIONS(1416),
    [anon_sym_QMARK_GT] = ACTIONS(1414),
    [anon_sym_SEMI] = ACTIONS(1414),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1416),
    [aux_sym_global_declaration_token1] = ACTIONS(1416),
    [aux_sym_namespace_definition_token1] = ACTIONS(1416),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1416),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1416),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1416),
    [anon_sym_BSLASH] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [aux_sym_trait_declaration_token1] = ACTIONS(1416),
    [aux_sym_interface_declaration_token1] = ACTIONS(1416),
    [aux_sym_enum_declaration_token1] = ACTIONS(1416),
    [aux_sym_enum_case_token1] = ACTIONS(1416),
    [aux_sym_class_declaration_token1] = ACTIONS(1416),
    [aux_sym_final_modifier_token1] = ACTIONS(1416),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1416),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1416),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1416),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1416),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1416),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1416),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [aux_sym_cast_type_token1] = ACTIONS(1416),
    [aux_sym_echo_statement_token1] = ACTIONS(1416),
    [anon_sym_unset] = ACTIONS(1416),
    [aux_sym_declare_statement_token1] = ACTIONS(1416),
    [aux_sym_declare_statement_token2] = ACTIONS(1416),
    [sym_float] = ACTIONS(1416),
    [aux_sym_try_statement_token1] = ACTIONS(1416),
    [aux_sym_goto_statement_token1] = ACTIONS(1416),
    [aux_sym_continue_statement_token1] = ACTIONS(1416),
    [aux_sym_break_statement_token1] = ACTIONS(1416),
    [sym_integer] = ACTIONS(1416),
    [aux_sym_return_statement_token1] = ACTIONS(1416),
    [aux_sym_throw_expression_token1] = ACTIONS(1416),
    [aux_sym_while_statement_token1] = ACTIONS(1416),
    [aux_sym_while_statement_token2] = ACTIONS(1416),
    [aux_sym_do_statement_token1] = ACTIONS(1416),
    [aux_sym_for_statement_token1] = ACTIONS(1416),
    [aux_sym_for_statement_token2] = ACTIONS(1416),
    [aux_sym_foreach_statement_token1] = ACTIONS(1416),
    [aux_sym_foreach_statement_token2] = ACTIONS(1416),
    [aux_sym_if_statement_token1] = ACTIONS(1416),
    [aux_sym_if_statement_token2] = ACTIONS(1416),
    [aux_sym_else_if_clause_token1] = ACTIONS(1416),
    [aux_sym_else_clause_token1] = ACTIONS(1416),
    [aux_sym_match_expression_token1] = ACTIONS(1416),
    [aux_sym_match_default_expression_token1] = ACTIONS(1416),
    [aux_sym_switch_statement_token1] = ACTIONS(1416),
    [aux_sym_switch_block_token1] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_TILDE] = ACTIONS(1414),
    [anon_sym_BANG] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(1414),
    [aux_sym_clone_expression_token1] = ACTIONS(1416),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1416),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1416),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [aux_sym__list_destructing_token1] = ACTIONS(1416),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_self] = ACTIONS(1416),
    [anon_sym_parent] = ACTIONS(1416),
    [aux_sym__argument_name_token1] = ACTIONS(1416),
    [aux_sym__argument_name_token2] = ACTIONS(1416),
    [anon_sym_POUND_LBRACK] = ACTIONS(1414),
    [aux_sym_encapsed_string_token1] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(1414),
    [aux_sym_string_token1] = ACTIONS(1414),
    [anon_sym_SQUOTE] = ACTIONS(1414),
    [anon_sym_LT_LT_LT] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1414),
    [anon_sym_DOLLAR] = ACTIONS(1414),
    [aux_sym_yield_expression_token1] = ACTIONS(1416),
    [aux_sym_include_expression_token1] = ACTIONS(1416),
    [aux_sym_include_once_expression_token1] = ACTIONS(1416),
    [aux_sym_require_expression_token1] = ACTIONS(1416),
    [aux_sym_require_once_expression_token1] = ACTIONS(1416),
    [sym_comment] = ACTIONS(3),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(1418),
    [sym_name] = ACTIONS(1420),
    [anon_sym_QMARK_GT] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1418),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1420),
    [aux_sym_global_declaration_token1] = ACTIONS(1420),
    [aux_sym_namespace_definition_token1] = ACTIONS(1420),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1420),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1420),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1420),
    [anon_sym_BSLASH] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [aux_sym_trait_declaration_token1] = ACTIONS(1420),
    [aux_sym_interface_declaration_token1] = ACTIONS(1420),
    [aux_sym_enum_declaration_token1] = ACTIONS(1420),
    [aux_sym_enum_case_token1] = ACTIONS(1420),
    [aux_sym_class_declaration_token1] = ACTIONS(1420),
    [aux_sym_final_modifier_token1] = ACTIONS(1420),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1420),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1420),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1420),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1420),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1420),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [aux_sym_cast_type_token1] = ACTIONS(1420),
    [aux_sym_echo_statement_token1] = ACTIONS(1420),
    [anon_sym_unset] = ACTIONS(1420),
    [aux_sym_declare_statement_token1] = ACTIONS(1420),
    [aux_sym_declare_statement_token2] = ACTIONS(1420),
    [sym_float] = ACTIONS(1420),
    [aux_sym_try_statement_token1] = ACTIONS(1420),
    [aux_sym_goto_statement_token1] = ACTIONS(1420),
    [aux_sym_continue_statement_token1] = ACTIONS(1420),
    [aux_sym_break_statement_token1] = ACTIONS(1420),
    [sym_integer] = ACTIONS(1420),
    [aux_sym_return_statement_token1] = ACTIONS(1420),
    [aux_sym_throw_expression_token1] = ACTIONS(1420),
    [aux_sym_while_statement_token1] = ACTIONS(1420),
    [aux_sym_while_statement_token2] = ACTIONS(1420),
    [aux_sym_do_statement_token1] = ACTIONS(1420),
    [aux_sym_for_statement_token1] = ACTIONS(1420),
    [aux_sym_for_statement_token2] = ACTIONS(1420),
    [aux_sym_foreach_statement_token1] = ACTIONS(1420),
    [aux_sym_foreach_statement_token2] = ACTIONS(1420),
    [aux_sym_if_statement_token1] = ACTIONS(1420),
    [aux_sym_if_statement_token2] = ACTIONS(1420),
    [aux_sym_else_if_clause_token1] = ACTIONS(1420),
    [aux_sym_else_clause_token1] = ACTIONS(1420),
    [aux_sym_match_expression_token1] = ACTIONS(1420),
    [aux_sym_match_default_expression_token1] = ACTIONS(1420),
    [aux_sym_switch_statement_token1] = ACTIONS(1420),
    [aux_sym_switch_block_token1] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(1418),
    [aux_sym_clone_expression_token1] = ACTIONS(1420),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1420),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1420),
    [anon_sym_DASH_DASH] = ACTIONS(1418),
    [anon_sym_PLUS_PLUS] = ACTIONS(1418),
    [aux_sym__list_destructing_token1] = ACTIONS(1420),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_self] = ACTIONS(1420),
    [anon_sym_parent] = ACTIONS(1420),
    [aux_sym__argument_name_token1] = ACTIONS(1420),
    [aux_sym__argument_name_token2] = ACTIONS(1420),
    [anon_sym_POUND_LBRACK] = ACTIONS(1418),
    [aux_sym_encapsed_string_token1] = ACTIONS(1418),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [aux_sym_string_token1] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [anon_sym_LT_LT_LT] = ACTIONS(1418),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_DOLLAR] = ACTIONS(1418),
    [aux_sym_yield_expression_token1] = ACTIONS(1420),
    [aux_sym_include_expression_token1] = ACTIONS(1420),
    [aux_sym_include_once_expression_token1] = ACTIONS(1420),
    [aux_sym_require_expression_token1] = ACTIONS(1420),
    [aux_sym_require_once_expression_token1] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1138),
    [sym_name] = ACTIONS(1140),
    [anon_sym_QMARK_GT] = ACTIONS(1138),
    [anon_sym_SEMI] = ACTIONS(1138),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1140),
    [aux_sym_global_declaration_token1] = ACTIONS(1140),
    [aux_sym_namespace_definition_token1] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1140),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1140),
    [anon_sym_BSLASH] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [aux_sym_trait_declaration_token1] = ACTIONS(1140),
    [aux_sym_interface_declaration_token1] = ACTIONS(1140),
    [aux_sym_enum_declaration_token1] = ACTIONS(1140),
    [aux_sym_enum_case_token1] = ACTIONS(1140),
    [aux_sym_class_declaration_token1] = ACTIONS(1140),
    [aux_sym_final_modifier_token1] = ACTIONS(1140),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1140),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1140),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1140),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1140),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [aux_sym_cast_type_token1] = ACTIONS(1140),
    [aux_sym_echo_statement_token1] = ACTIONS(1140),
    [anon_sym_unset] = ACTIONS(1140),
    [aux_sym_declare_statement_token1] = ACTIONS(1140),
    [aux_sym_declare_statement_token2] = ACTIONS(1140),
    [sym_float] = ACTIONS(1140),
    [aux_sym_try_statement_token1] = ACTIONS(1140),
    [aux_sym_goto_statement_token1] = ACTIONS(1140),
    [aux_sym_continue_statement_token1] = ACTIONS(1140),
    [aux_sym_break_statement_token1] = ACTIONS(1140),
    [sym_integer] = ACTIONS(1140),
    [aux_sym_return_statement_token1] = ACTIONS(1140),
    [aux_sym_throw_expression_token1] = ACTIONS(1140),
    [aux_sym_while_statement_token1] = ACTIONS(1140),
    [aux_sym_while_statement_token2] = ACTIONS(1140),
    [aux_sym_do_statement_token1] = ACTIONS(1140),
    [aux_sym_for_statement_token1] = ACTIONS(1140),
    [aux_sym_for_statement_token2] = ACTIONS(1140),
    [aux_sym_foreach_statement_token1] = ACTIONS(1140),
    [aux_sym_foreach_statement_token2] = ACTIONS(1140),
    [aux_sym_if_statement_token1] = ACTIONS(1140),
    [aux_sym_if_statement_token2] = ACTIONS(1140),
    [aux_sym_else_if_clause_token1] = ACTIONS(1140),
    [aux_sym_else_clause_token1] = ACTIONS(1140),
    [aux_sym_match_expression_token1] = ACTIONS(1140),
    [aux_sym_match_default_expression_token1] = ACTIONS(1140),
    [aux_sym_switch_statement_token1] = ACTIONS(1140),
    [aux_sym_switch_block_token1] = ACTIONS(1140),
    [anon_sym_PLUS] = ACTIONS(1140),
    [anon_sym_DASH] = ACTIONS(1140),
    [anon_sym_TILDE] = ACTIONS(1138),
    [anon_sym_BANG] = ACTIONS(1138),
    [anon_sym_AT] = ACTIONS(1138),
    [aux_sym_clone_expression_token1] = ACTIONS(1140),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1140),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1140),
    [anon_sym_DASH_DASH] = ACTIONS(1138),
    [anon_sym_PLUS_PLUS] = ACTIONS(1138),
    [aux_sym__list_destructing_token1] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1138),
    [anon_sym_self] = ACTIONS(1140),
    [anon_sym_parent] = ACTIONS(1140),
    [aux_sym__argument_name_token1] = ACTIONS(1140),
    [aux_sym__argument_name_token2] = ACTIONS(1140),
    [anon_sym_POUND_LBRACK] = ACTIONS(1138),
    [aux_sym_encapsed_string_token1] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [aux_sym_string_token1] = ACTIONS(1138),
    [anon_sym_SQUOTE] = ACTIONS(1138),
    [anon_sym_LT_LT_LT] = ACTIONS(1138),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [anon_sym_DOLLAR] = ACTIONS(1138),
    [aux_sym_yield_expression_token1] = ACTIONS(1140),
    [aux_sym_include_expression_token1] = ACTIONS(1140),
    [aux_sym_include_once_expression_token1] = ACTIONS(1140),
    [aux_sym_require_expression_token1] = ACTIONS(1140),
    [aux_sym_require_once_expression_token1] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(1422),
    [sym_name] = ACTIONS(1424),
    [anon_sym_QMARK_GT] = ACTIONS(1422),
    [anon_sym_SEMI] = ACTIONS(1422),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1424),
    [aux_sym_global_declaration_token1] = ACTIONS(1424),
    [aux_sym_namespace_definition_token1] = ACTIONS(1424),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1424),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1424),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1424),
    [anon_sym_BSLASH] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [aux_sym_trait_declaration_token1] = ACTIONS(1424),
    [aux_sym_interface_declaration_token1] = ACTIONS(1424),
    [aux_sym_enum_declaration_token1] = ACTIONS(1424),
    [aux_sym_enum_case_token1] = ACTIONS(1424),
    [aux_sym_class_declaration_token1] = ACTIONS(1424),
    [aux_sym_final_modifier_token1] = ACTIONS(1424),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1424),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1424),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1424),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1424),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1424),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1424),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [aux_sym_cast_type_token1] = ACTIONS(1424),
    [aux_sym_echo_statement_token1] = ACTIONS(1424),
    [anon_sym_unset] = ACTIONS(1424),
    [aux_sym_declare_statement_token1] = ACTIONS(1424),
    [aux_sym_declare_statement_token2] = ACTIONS(1424),
    [sym_float] = ACTIONS(1424),
    [aux_sym_try_statement_token1] = ACTIONS(1424),
    [aux_sym_goto_statement_token1] = ACTIONS(1424),
    [aux_sym_continue_statement_token1] = ACTIONS(1424),
    [aux_sym_break_statement_token1] = ACTIONS(1424),
    [sym_integer] = ACTIONS(1424),
    [aux_sym_return_statement_token1] = ACTIONS(1424),
    [aux_sym_throw_expression_token1] = ACTIONS(1424),
    [aux_sym_while_statement_token1] = ACTIONS(1424),
    [aux_sym_while_statement_token2] = ACTIONS(1424),
    [aux_sym_do_statement_token1] = ACTIONS(1424),
    [aux_sym_for_statement_token1] = ACTIONS(1424),
    [aux_sym_for_statement_token2] = ACTIONS(1424),
    [aux_sym_foreach_statement_token1] = ACTIONS(1424),
    [aux_sym_foreach_statement_token2] = ACTIONS(1424),
    [aux_sym_if_statement_token1] = ACTIONS(1424),
    [aux_sym_if_statement_token2] = ACTIONS(1424),
    [aux_sym_else_if_clause_token1] = ACTIONS(1424),
    [aux_sym_else_clause_token1] = ACTIONS(1424),
    [aux_sym_match_expression_token1] = ACTIONS(1424),
    [aux_sym_match_default_expression_token1] = ACTIONS(1424),
    [aux_sym_switch_statement_token1] = ACTIONS(1424),
    [aux_sym_switch_block_token1] = ACTIONS(1424),
    [anon_sym_PLUS] = ACTIONS(1424),
    [anon_sym_DASH] = ACTIONS(1424),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_AT] = ACTIONS(1422),
    [aux_sym_clone_expression_token1] = ACTIONS(1424),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1424),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1424),
    [anon_sym_DASH_DASH] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1422),
    [aux_sym__list_destructing_token1] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(1422),
    [anon_sym_self] = ACTIONS(1424),
    [anon_sym_parent] = ACTIONS(1424),
    [aux_sym__argument_name_token1] = ACTIONS(1424),
    [aux_sym__argument_name_token2] = ACTIONS(1424),
    [anon_sym_POUND_LBRACK] = ACTIONS(1422),
    [aux_sym_encapsed_string_token1] = ACTIONS(1422),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [aux_sym_string_token1] = ACTIONS(1422),
    [anon_sym_SQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LT_LT] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(1422),
    [aux_sym_yield_expression_token1] = ACTIONS(1424),
    [aux_sym_include_expression_token1] = ACTIONS(1424),
    [aux_sym_include_once_expression_token1] = ACTIONS(1424),
    [aux_sym_require_expression_token1] = ACTIONS(1424),
    [aux_sym_require_once_expression_token1] = ACTIONS(1424),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1426),
    [sym_name] = ACTIONS(1428),
    [anon_sym_QMARK_GT] = ACTIONS(1426),
    [anon_sym_SEMI] = ACTIONS(1426),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1428),
    [aux_sym_global_declaration_token1] = ACTIONS(1428),
    [aux_sym_namespace_definition_token1] = ACTIONS(1428),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1428),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1428),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1428),
    [anon_sym_BSLASH] = ACTIONS(1426),
    [anon_sym_LBRACE] = ACTIONS(1426),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [aux_sym_trait_declaration_token1] = ACTIONS(1428),
    [aux_sym_interface_declaration_token1] = ACTIONS(1428),
    [aux_sym_enum_declaration_token1] = ACTIONS(1428),
    [aux_sym_enum_case_token1] = ACTIONS(1428),
    [aux_sym_class_declaration_token1] = ACTIONS(1428),
    [aux_sym_final_modifier_token1] = ACTIONS(1428),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1428),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1428),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1428),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1428),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1428),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1428),
    [anon_sym_LPAREN] = ACTIONS(1426),
    [aux_sym_cast_type_token1] = ACTIONS(1428),
    [aux_sym_echo_statement_token1] = ACTIONS(1428),
    [anon_sym_unset] = ACTIONS(1428),
    [aux_sym_declare_statement_token1] = ACTIONS(1428),
    [aux_sym_declare_statement_token2] = ACTIONS(1428),
    [sym_float] = ACTIONS(1428),
    [aux_sym_try_statement_token1] = ACTIONS(1428),
    [aux_sym_goto_statement_token1] = ACTIONS(1428),
    [aux_sym_continue_statement_token1] = ACTIONS(1428),
    [aux_sym_break_statement_token1] = ACTIONS(1428),
    [sym_integer] = ACTIONS(1428),
    [aux_sym_return_statement_token1] = ACTIONS(1428),
    [aux_sym_throw_expression_token1] = ACTIONS(1428),
    [aux_sym_while_statement_token1] = ACTIONS(1428),
    [aux_sym_while_statement_token2] = ACTIONS(1428),
    [aux_sym_do_statement_token1] = ACTIONS(1428),
    [aux_sym_for_statement_token1] = ACTIONS(1428),
    [aux_sym_for_statement_token2] = ACTIONS(1428),
    [aux_sym_foreach_statement_token1] = ACTIONS(1428),
    [aux_sym_foreach_statement_token2] = ACTIONS(1428),
    [aux_sym_if_statement_token1] = ACTIONS(1428),
    [aux_sym_if_statement_token2] = ACTIONS(1428),
    [aux_sym_else_if_clause_token1] = ACTIONS(1428),
    [aux_sym_else_clause_token1] = ACTIONS(1428),
    [aux_sym_match_expression_token1] = ACTIONS(1428),
    [aux_sym_match_default_expression_token1] = ACTIONS(1428),
    [aux_sym_switch_statement_token1] = ACTIONS(1428),
    [aux_sym_switch_block_token1] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_TILDE] = ACTIONS(1426),
    [anon_sym_BANG] = ACTIONS(1426),
    [anon_sym_AT] = ACTIONS(1426),
    [aux_sym_clone_expression_token1] = ACTIONS(1428),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1428),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1428),
    [anon_sym_DASH_DASH] = ACTIONS(1426),
    [anon_sym_PLUS_PLUS] = ACTIONS(1426),
    [aux_sym__list_destructing_token1] = ACTIONS(1428),
    [anon_sym_LBRACK] = ACTIONS(1426),
    [anon_sym_self] = ACTIONS(1428),
    [anon_sym_parent] = ACTIONS(1428),
    [aux_sym__argument_name_token1] = ACTIONS(1428),
    [aux_sym__argument_name_token2] = ACTIONS(1428),
    [anon_sym_POUND_LBRACK] = ACTIONS(1426),
    [aux_sym_encapsed_string_token1] = ACTIONS(1426),
    [anon_sym_DQUOTE] = ACTIONS(1426),
    [aux_sym_string_token1] = ACTIONS(1426),
    [anon_sym_SQUOTE] = ACTIONS(1426),
    [anon_sym_LT_LT_LT] = ACTIONS(1426),
    [anon_sym_BQUOTE] = ACTIONS(1426),
    [anon_sym_DOLLAR] = ACTIONS(1426),
    [aux_sym_yield_expression_token1] = ACTIONS(1428),
    [aux_sym_include_expression_token1] = ACTIONS(1428),
    [aux_sym_include_once_expression_token1] = ACTIONS(1428),
    [aux_sym_require_expression_token1] = ACTIONS(1428),
    [aux_sym_require_once_expression_token1] = ACTIONS(1428),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(1430),
    [sym_name] = ACTIONS(1432),
    [anon_sym_QMARK_GT] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1432),
    [aux_sym_global_declaration_token1] = ACTIONS(1432),
    [aux_sym_namespace_definition_token1] = ACTIONS(1432),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1432),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1432),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1432),
    [anon_sym_BSLASH] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_RBRACE] = ACTIONS(1430),
    [aux_sym_trait_declaration_token1] = ACTIONS(1432),
    [aux_sym_interface_declaration_token1] = ACTIONS(1432),
    [aux_sym_enum_declaration_token1] = ACTIONS(1432),
    [aux_sym_enum_case_token1] = ACTIONS(1432),
    [aux_sym_class_declaration_token1] = ACTIONS(1432),
    [aux_sym_final_modifier_token1] = ACTIONS(1432),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1432),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1432),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1432),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1432),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1432),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [aux_sym_cast_type_token1] = ACTIONS(1432),
    [aux_sym_echo_statement_token1] = ACTIONS(1432),
    [anon_sym_unset] = ACTIONS(1432),
    [aux_sym_declare_statement_token1] = ACTIONS(1432),
    [aux_sym_declare_statement_token2] = ACTIONS(1432),
    [sym_float] = ACTIONS(1432),
    [aux_sym_try_statement_token1] = ACTIONS(1432),
    [aux_sym_goto_statement_token1] = ACTIONS(1432),
    [aux_sym_continue_statement_token1] = ACTIONS(1432),
    [aux_sym_break_statement_token1] = ACTIONS(1432),
    [sym_integer] = ACTIONS(1432),
    [aux_sym_return_statement_token1] = ACTIONS(1432),
    [aux_sym_throw_expression_token1] = ACTIONS(1432),
    [aux_sym_while_statement_token1] = ACTIONS(1432),
    [aux_sym_while_statement_token2] = ACTIONS(1432),
    [aux_sym_do_statement_token1] = ACTIONS(1432),
    [aux_sym_for_statement_token1] = ACTIONS(1432),
    [aux_sym_for_statement_token2] = ACTIONS(1432),
    [aux_sym_foreach_statement_token1] = ACTIONS(1432),
    [aux_sym_foreach_statement_token2] = ACTIONS(1432),
    [aux_sym_if_statement_token1] = ACTIONS(1432),
    [aux_sym_if_statement_token2] = ACTIONS(1432),
    [aux_sym_else_if_clause_token1] = ACTIONS(1432),
    [aux_sym_else_clause_token1] = ACTIONS(1432),
    [aux_sym_match_expression_token1] = ACTIONS(1432),
    [aux_sym_match_default_expression_token1] = ACTIONS(1432),
    [aux_sym_switch_statement_token1] = ACTIONS(1432),
    [aux_sym_switch_block_token1] = ACTIONS(1432),
    [anon_sym_PLUS] = ACTIONS(1432),
    [anon_sym_DASH] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1430),
    [anon_sym_BANG] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1430),
    [aux_sym_clone_expression_token1] = ACTIONS(1432),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1432),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1432),
    [anon_sym_DASH_DASH] = ACTIONS(1430),
    [anon_sym_PLUS_PLUS] = ACTIONS(1430),
    [aux_sym__list_destructing_token1] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_self] = ACTIONS(1432),
    [anon_sym_parent] = ACTIONS(1432),
    [aux_sym__argument_name_token1] = ACTIONS(1432),
    [aux_sym__argument_name_token2] = ACTIONS(1432),
    [anon_sym_POUND_LBRACK] = ACTIONS(1430),
    [aux_sym_encapsed_string_token1] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [aux_sym_string_token1] = ACTIONS(1430),
    [anon_sym_SQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LT_LT] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [aux_sym_yield_expression_token1] = ACTIONS(1432),
    [aux_sym_include_expression_token1] = ACTIONS(1432),
    [aux_sym_include_once_expression_token1] = ACTIONS(1432),
    [aux_sym_require_expression_token1] = ACTIONS(1432),
    [aux_sym_require_once_expression_token1] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(1434),
    [sym_name] = ACTIONS(1436),
    [anon_sym_QMARK_GT] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1434),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1436),
    [aux_sym_global_declaration_token1] = ACTIONS(1436),
    [aux_sym_namespace_definition_token1] = ACTIONS(1436),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1436),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1436),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1436),
    [anon_sym_BSLASH] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1434),
    [aux_sym_trait_declaration_token1] = ACTIONS(1436),
    [aux_sym_interface_declaration_token1] = ACTIONS(1436),
    [aux_sym_enum_declaration_token1] = ACTIONS(1436),
    [aux_sym_enum_case_token1] = ACTIONS(1436),
    [aux_sym_class_declaration_token1] = ACTIONS(1436),
    [aux_sym_final_modifier_token1] = ACTIONS(1436),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1436),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1436),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1436),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1436),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1436),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [aux_sym_cast_type_token1] = ACTIONS(1436),
    [aux_sym_echo_statement_token1] = ACTIONS(1436),
    [anon_sym_unset] = ACTIONS(1436),
    [aux_sym_declare_statement_token1] = ACTIONS(1436),
    [aux_sym_declare_statement_token2] = ACTIONS(1436),
    [sym_float] = ACTIONS(1436),
    [aux_sym_try_statement_token1] = ACTIONS(1436),
    [aux_sym_goto_statement_token1] = ACTIONS(1436),
    [aux_sym_continue_statement_token1] = ACTIONS(1436),
    [aux_sym_break_statement_token1] = ACTIONS(1436),
    [sym_integer] = ACTIONS(1436),
    [aux_sym_return_statement_token1] = ACTIONS(1436),
    [aux_sym_throw_expression_token1] = ACTIONS(1436),
    [aux_sym_while_statement_token1] = ACTIONS(1436),
    [aux_sym_while_statement_token2] = ACTIONS(1436),
    [aux_sym_do_statement_token1] = ACTIONS(1436),
    [aux_sym_for_statement_token1] = ACTIONS(1436),
    [aux_sym_for_statement_token2] = ACTIONS(1436),
    [aux_sym_foreach_statement_token1] = ACTIONS(1436),
    [aux_sym_foreach_statement_token2] = ACTIONS(1436),
    [aux_sym_if_statement_token1] = ACTIONS(1436),
    [aux_sym_if_statement_token2] = ACTIONS(1436),
    [aux_sym_else_if_clause_token1] = ACTIONS(1436),
    [aux_sym_else_clause_token1] = ACTIONS(1436),
    [aux_sym_match_expression_token1] = ACTIONS(1436),
    [aux_sym_match_default_expression_token1] = ACTIONS(1436),
    [aux_sym_switch_statement_token1] = ACTIONS(1436),
    [aux_sym_switch_block_token1] = ACTIONS(1436),
    [anon_sym_PLUS] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [aux_sym_clone_expression_token1] = ACTIONS(1436),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1436),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1436),
    [anon_sym_DASH_DASH] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1434),
    [aux_sym__list_destructing_token1] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_self] = ACTIONS(1436),
    [anon_sym_parent] = ACTIONS(1436),
    [aux_sym__argument_name_token1] = ACTIONS(1436),
    [aux_sym__argument_name_token2] = ACTIONS(1436),
    [anon_sym_POUND_LBRACK] = ACTIONS(1434),
    [aux_sym_encapsed_string_token1] = ACTIONS(1434),
    [anon_sym_DQUOTE] = ACTIONS(1434),
    [aux_sym_string_token1] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1434),
    [anon_sym_LT_LT_LT] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1434),
    [anon_sym_DOLLAR] = ACTIONS(1434),
    [aux_sym_yield_expression_token1] = ACTIONS(1436),
    [aux_sym_include_expression_token1] = ACTIONS(1436),
    [aux_sym_include_once_expression_token1] = ACTIONS(1436),
    [aux_sym_require_expression_token1] = ACTIONS(1436),
    [aux_sym_require_once_expression_token1] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1438),
    [sym_name] = ACTIONS(1440),
    [anon_sym_QMARK_GT] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1440),
    [aux_sym_global_declaration_token1] = ACTIONS(1440),
    [aux_sym_namespace_definition_token1] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1440),
    [anon_sym_BSLASH] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [aux_sym_trait_declaration_token1] = ACTIONS(1440),
    [aux_sym_interface_declaration_token1] = ACTIONS(1440),
    [aux_sym_enum_declaration_token1] = ACTIONS(1440),
    [aux_sym_enum_case_token1] = ACTIONS(1440),
    [aux_sym_class_declaration_token1] = ACTIONS(1440),
    [aux_sym_final_modifier_token1] = ACTIONS(1440),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1440),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1440),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [aux_sym_cast_type_token1] = ACTIONS(1440),
    [aux_sym_echo_statement_token1] = ACTIONS(1440),
    [anon_sym_unset] = ACTIONS(1440),
    [aux_sym_declare_statement_token1] = ACTIONS(1440),
    [aux_sym_declare_statement_token2] = ACTIONS(1440),
    [sym_float] = ACTIONS(1440),
    [aux_sym_try_statement_token1] = ACTIONS(1440),
    [aux_sym_goto_statement_token1] = ACTIONS(1440),
    [aux_sym_continue_statement_token1] = ACTIONS(1440),
    [aux_sym_break_statement_token1] = ACTIONS(1440),
    [sym_integer] = ACTIONS(1440),
    [aux_sym_return_statement_token1] = ACTIONS(1440),
    [aux_sym_throw_expression_token1] = ACTIONS(1440),
    [aux_sym_while_statement_token1] = ACTIONS(1440),
    [aux_sym_while_statement_token2] = ACTIONS(1440),
    [aux_sym_do_statement_token1] = ACTIONS(1440),
    [aux_sym_for_statement_token1] = ACTIONS(1440),
    [aux_sym_for_statement_token2] = ACTIONS(1440),
    [aux_sym_foreach_statement_token1] = ACTIONS(1440),
    [aux_sym_foreach_statement_token2] = ACTIONS(1440),
    [aux_sym_if_statement_token1] = ACTIONS(1440),
    [aux_sym_if_statement_token2] = ACTIONS(1440),
    [aux_sym_else_if_clause_token1] = ACTIONS(1440),
    [aux_sym_else_clause_token1] = ACTIONS(1440),
    [aux_sym_match_expression_token1] = ACTIONS(1440),
    [aux_sym_match_default_expression_token1] = ACTIONS(1440),
    [aux_sym_switch_statement_token1] = ACTIONS(1440),
    [aux_sym_switch_block_token1] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_BANG] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1438),
    [aux_sym_clone_expression_token1] = ACTIONS(1440),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1440),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [aux_sym__list_destructing_token1] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_self] = ACTIONS(1440),
    [anon_sym_parent] = ACTIONS(1440),
    [aux_sym__argument_name_token1] = ACTIONS(1440),
    [aux_sym__argument_name_token2] = ACTIONS(1440),
    [anon_sym_POUND_LBRACK] = ACTIONS(1438),
    [aux_sym_encapsed_string_token1] = ACTIONS(1438),
    [anon_sym_DQUOTE] = ACTIONS(1438),
    [aux_sym_string_token1] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(1438),
    [anon_sym_LT_LT_LT] = ACTIONS(1438),
    [anon_sym_BQUOTE] = ACTIONS(1438),
    [anon_sym_DOLLAR] = ACTIONS(1438),
    [aux_sym_yield_expression_token1] = ACTIONS(1440),
    [aux_sym_include_expression_token1] = ACTIONS(1440),
    [aux_sym_include_once_expression_token1] = ACTIONS(1440),
    [aux_sym_require_expression_token1] = ACTIONS(1440),
    [aux_sym_require_once_expression_token1] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_name] = ACTIONS(1444),
    [anon_sym_QMARK_GT] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1444),
    [aux_sym_global_declaration_token1] = ACTIONS(1444),
    [aux_sym_namespace_definition_token1] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1444),
    [anon_sym_BSLASH] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [aux_sym_trait_declaration_token1] = ACTIONS(1444),
    [aux_sym_interface_declaration_token1] = ACTIONS(1444),
    [aux_sym_enum_declaration_token1] = ACTIONS(1444),
    [aux_sym_enum_case_token1] = ACTIONS(1444),
    [aux_sym_class_declaration_token1] = ACTIONS(1444),
    [aux_sym_final_modifier_token1] = ACTIONS(1444),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1444),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1444),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [aux_sym_cast_type_token1] = ACTIONS(1444),
    [aux_sym_echo_statement_token1] = ACTIONS(1444),
    [anon_sym_unset] = ACTIONS(1444),
    [aux_sym_declare_statement_token1] = ACTIONS(1444),
    [aux_sym_declare_statement_token2] = ACTIONS(1444),
    [sym_float] = ACTIONS(1444),
    [aux_sym_try_statement_token1] = ACTIONS(1444),
    [aux_sym_goto_statement_token1] = ACTIONS(1444),
    [aux_sym_continue_statement_token1] = ACTIONS(1444),
    [aux_sym_break_statement_token1] = ACTIONS(1444),
    [sym_integer] = ACTIONS(1444),
    [aux_sym_return_statement_token1] = ACTIONS(1444),
    [aux_sym_throw_expression_token1] = ACTIONS(1444),
    [aux_sym_while_statement_token1] = ACTIONS(1444),
    [aux_sym_while_statement_token2] = ACTIONS(1444),
    [aux_sym_do_statement_token1] = ACTIONS(1444),
    [aux_sym_for_statement_token1] = ACTIONS(1444),
    [aux_sym_for_statement_token2] = ACTIONS(1444),
    [aux_sym_foreach_statement_token1] = ACTIONS(1444),
    [aux_sym_foreach_statement_token2] = ACTIONS(1444),
    [aux_sym_if_statement_token1] = ACTIONS(1444),
    [aux_sym_if_statement_token2] = ACTIONS(1444),
    [aux_sym_else_if_clause_token1] = ACTIONS(1444),
    [aux_sym_else_clause_token1] = ACTIONS(1444),
    [aux_sym_match_expression_token1] = ACTIONS(1444),
    [aux_sym_match_default_expression_token1] = ACTIONS(1444),
    [aux_sym_switch_statement_token1] = ACTIONS(1444),
    [aux_sym_switch_block_token1] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1442),
    [aux_sym_clone_expression_token1] = ACTIONS(1444),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1444),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [aux_sym__list_destructing_token1] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_self] = ACTIONS(1444),
    [anon_sym_parent] = ACTIONS(1444),
    [aux_sym__argument_name_token1] = ACTIONS(1444),
    [aux_sym__argument_name_token2] = ACTIONS(1444),
    [anon_sym_POUND_LBRACK] = ACTIONS(1442),
    [aux_sym_encapsed_string_token1] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [aux_sym_string_token1] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [anon_sym_LT_LT_LT] = ACTIONS(1442),
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [anon_sym_DOLLAR] = ACTIONS(1442),
    [aux_sym_yield_expression_token1] = ACTIONS(1444),
    [aux_sym_include_expression_token1] = ACTIONS(1444),
    [aux_sym_include_once_expression_token1] = ACTIONS(1444),
    [aux_sym_require_expression_token1] = ACTIONS(1444),
    [aux_sym_require_once_expression_token1] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_name] = ACTIONS(1448),
    [anon_sym_QMARK_GT] = ACTIONS(1446),
    [anon_sym_SEMI] = ACTIONS(1446),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1448),
    [aux_sym_global_declaration_token1] = ACTIONS(1448),
    [aux_sym_namespace_definition_token1] = ACTIONS(1448),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1448),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1448),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1448),
    [anon_sym_BSLASH] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [aux_sym_trait_declaration_token1] = ACTIONS(1448),
    [aux_sym_interface_declaration_token1] = ACTIONS(1448),
    [aux_sym_enum_declaration_token1] = ACTIONS(1448),
    [aux_sym_enum_case_token1] = ACTIONS(1448),
    [aux_sym_class_declaration_token1] = ACTIONS(1448),
    [aux_sym_final_modifier_token1] = ACTIONS(1448),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1448),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1448),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1448),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1448),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1448),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [aux_sym_cast_type_token1] = ACTIONS(1448),
    [aux_sym_echo_statement_token1] = ACTIONS(1448),
    [anon_sym_unset] = ACTIONS(1448),
    [aux_sym_declare_statement_token1] = ACTIONS(1448),
    [aux_sym_declare_statement_token2] = ACTIONS(1448),
    [sym_float] = ACTIONS(1448),
    [aux_sym_try_statement_token1] = ACTIONS(1448),
    [aux_sym_goto_statement_token1] = ACTIONS(1448),
    [aux_sym_continue_statement_token1] = ACTIONS(1448),
    [aux_sym_break_statement_token1] = ACTIONS(1448),
    [sym_integer] = ACTIONS(1448),
    [aux_sym_return_statement_token1] = ACTIONS(1448),
    [aux_sym_throw_expression_token1] = ACTIONS(1448),
    [aux_sym_while_statement_token1] = ACTIONS(1448),
    [aux_sym_while_statement_token2] = ACTIONS(1448),
    [aux_sym_do_statement_token1] = ACTIONS(1448),
    [aux_sym_for_statement_token1] = ACTIONS(1448),
    [aux_sym_for_statement_token2] = ACTIONS(1448),
    [aux_sym_foreach_statement_token1] = ACTIONS(1448),
    [aux_sym_foreach_statement_token2] = ACTIONS(1448),
    [aux_sym_if_statement_token1] = ACTIONS(1448),
    [aux_sym_if_statement_token2] = ACTIONS(1448),
    [aux_sym_else_if_clause_token1] = ACTIONS(1448),
    [aux_sym_else_clause_token1] = ACTIONS(1448),
    [aux_sym_match_expression_token1] = ACTIONS(1448),
    [aux_sym_match_default_expression_token1] = ACTIONS(1448),
    [aux_sym_switch_statement_token1] = ACTIONS(1448),
    [aux_sym_switch_block_token1] = ACTIONS(1448),
    [anon_sym_PLUS] = ACTIONS(1448),
    [anon_sym_DASH] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_AT] = ACTIONS(1446),
    [aux_sym_clone_expression_token1] = ACTIONS(1448),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1448),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1448),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [aux_sym__list_destructing_token1] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_self] = ACTIONS(1448),
    [anon_sym_parent] = ACTIONS(1448),
    [aux_sym__argument_name_token1] = ACTIONS(1448),
    [aux_sym__argument_name_token2] = ACTIONS(1448),
    [anon_sym_POUND_LBRACK] = ACTIONS(1446),
    [aux_sym_encapsed_string_token1] = ACTIONS(1446),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [aux_sym_string_token1] = ACTIONS(1446),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [anon_sym_LT_LT_LT] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [aux_sym_yield_expression_token1] = ACTIONS(1448),
    [aux_sym_include_expression_token1] = ACTIONS(1448),
    [aux_sym_include_once_expression_token1] = ACTIONS(1448),
    [aux_sym_require_expression_token1] = ACTIONS(1448),
    [aux_sym_require_once_expression_token1] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_name] = ACTIONS(1452),
    [anon_sym_QMARK_GT] = ACTIONS(1450),
    [anon_sym_SEMI] = ACTIONS(1450),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1452),
    [aux_sym_global_declaration_token1] = ACTIONS(1452),
    [aux_sym_namespace_definition_token1] = ACTIONS(1452),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1452),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1452),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1452),
    [anon_sym_BSLASH] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_RBRACE] = ACTIONS(1450),
    [aux_sym_trait_declaration_token1] = ACTIONS(1452),
    [aux_sym_interface_declaration_token1] = ACTIONS(1452),
    [aux_sym_enum_declaration_token1] = ACTIONS(1452),
    [aux_sym_enum_case_token1] = ACTIONS(1452),
    [aux_sym_class_declaration_token1] = ACTIONS(1452),
    [aux_sym_final_modifier_token1] = ACTIONS(1452),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1452),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1452),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1452),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1452),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1452),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [aux_sym_cast_type_token1] = ACTIONS(1452),
    [aux_sym_echo_statement_token1] = ACTIONS(1452),
    [anon_sym_unset] = ACTIONS(1452),
    [aux_sym_declare_statement_token1] = ACTIONS(1452),
    [aux_sym_declare_statement_token2] = ACTIONS(1452),
    [sym_float] = ACTIONS(1452),
    [aux_sym_try_statement_token1] = ACTIONS(1452),
    [aux_sym_goto_statement_token1] = ACTIONS(1452),
    [aux_sym_continue_statement_token1] = ACTIONS(1452),
    [aux_sym_break_statement_token1] = ACTIONS(1452),
    [sym_integer] = ACTIONS(1452),
    [aux_sym_return_statement_token1] = ACTIONS(1452),
    [aux_sym_throw_expression_token1] = ACTIONS(1452),
    [aux_sym_while_statement_token1] = ACTIONS(1452),
    [aux_sym_while_statement_token2] = ACTIONS(1452),
    [aux_sym_do_statement_token1] = ACTIONS(1452),
    [aux_sym_for_statement_token1] = ACTIONS(1452),
    [aux_sym_for_statement_token2] = ACTIONS(1452),
    [aux_sym_foreach_statement_token1] = ACTIONS(1452),
    [aux_sym_foreach_statement_token2] = ACTIONS(1452),
    [aux_sym_if_statement_token1] = ACTIONS(1452),
    [aux_sym_if_statement_token2] = ACTIONS(1452),
    [aux_sym_else_if_clause_token1] = ACTIONS(1452),
    [aux_sym_else_clause_token1] = ACTIONS(1452),
    [aux_sym_match_expression_token1] = ACTIONS(1452),
    [aux_sym_match_default_expression_token1] = ACTIONS(1452),
    [aux_sym_switch_statement_token1] = ACTIONS(1452),
    [aux_sym_switch_block_token1] = ACTIONS(1452),
    [anon_sym_PLUS] = ACTIONS(1452),
    [anon_sym_DASH] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_BANG] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(1450),
    [aux_sym_clone_expression_token1] = ACTIONS(1452),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1452),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1452),
    [anon_sym_DASH_DASH] = ACTIONS(1450),
    [anon_sym_PLUS_PLUS] = ACTIONS(1450),
    [aux_sym__list_destructing_token1] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_self] = ACTIONS(1452),
    [anon_sym_parent] = ACTIONS(1452),
    [aux_sym__argument_name_token1] = ACTIONS(1452),
    [aux_sym__argument_name_token2] = ACTIONS(1452),
    [anon_sym_POUND_LBRACK] = ACTIONS(1450),
    [aux_sym_encapsed_string_token1] = ACTIONS(1450),
    [anon_sym_DQUOTE] = ACTIONS(1450),
    [aux_sym_string_token1] = ACTIONS(1450),
    [anon_sym_SQUOTE] = ACTIONS(1450),
    [anon_sym_LT_LT_LT] = ACTIONS(1450),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [anon_sym_DOLLAR] = ACTIONS(1450),
    [aux_sym_yield_expression_token1] = ACTIONS(1452),
    [aux_sym_include_expression_token1] = ACTIONS(1452),
    [aux_sym_include_once_expression_token1] = ACTIONS(1452),
    [aux_sym_require_expression_token1] = ACTIONS(1452),
    [aux_sym_require_once_expression_token1] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1454),
    [sym_name] = ACTIONS(1456),
    [anon_sym_QMARK_GT] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1454),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1456),
    [aux_sym_global_declaration_token1] = ACTIONS(1456),
    [aux_sym_namespace_definition_token1] = ACTIONS(1456),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1456),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1456),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1456),
    [anon_sym_BSLASH] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_RBRACE] = ACTIONS(1454),
    [aux_sym_trait_declaration_token1] = ACTIONS(1456),
    [aux_sym_interface_declaration_token1] = ACTIONS(1456),
    [aux_sym_enum_declaration_token1] = ACTIONS(1456),
    [aux_sym_enum_case_token1] = ACTIONS(1456),
    [aux_sym_class_declaration_token1] = ACTIONS(1456),
    [aux_sym_final_modifier_token1] = ACTIONS(1456),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1456),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1456),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1456),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1456),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1456),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [aux_sym_cast_type_token1] = ACTIONS(1456),
    [aux_sym_echo_statement_token1] = ACTIONS(1456),
    [anon_sym_unset] = ACTIONS(1456),
    [aux_sym_declare_statement_token1] = ACTIONS(1456),
    [aux_sym_declare_statement_token2] = ACTIONS(1456),
    [sym_float] = ACTIONS(1456),
    [aux_sym_try_statement_token1] = ACTIONS(1456),
    [aux_sym_goto_statement_token1] = ACTIONS(1456),
    [aux_sym_continue_statement_token1] = ACTIONS(1456),
    [aux_sym_break_statement_token1] = ACTIONS(1456),
    [sym_integer] = ACTIONS(1456),
    [aux_sym_return_statement_token1] = ACTIONS(1456),
    [aux_sym_throw_expression_token1] = ACTIONS(1456),
    [aux_sym_while_statement_token1] = ACTIONS(1456),
    [aux_sym_while_statement_token2] = ACTIONS(1456),
    [aux_sym_do_statement_token1] = ACTIONS(1456),
    [aux_sym_for_statement_token1] = ACTIONS(1456),
    [aux_sym_for_statement_token2] = ACTIONS(1456),
    [aux_sym_foreach_statement_token1] = ACTIONS(1456),
    [aux_sym_foreach_statement_token2] = ACTIONS(1456),
    [aux_sym_if_statement_token1] = ACTIONS(1456),
    [aux_sym_if_statement_token2] = ACTIONS(1456),
    [aux_sym_else_if_clause_token1] = ACTIONS(1456),
    [aux_sym_else_clause_token1] = ACTIONS(1456),
    [aux_sym_match_expression_token1] = ACTIONS(1456),
    [aux_sym_match_default_expression_token1] = ACTIONS(1456),
    [aux_sym_switch_statement_token1] = ACTIONS(1456),
    [aux_sym_switch_block_token1] = ACTIONS(1456),
    [anon_sym_PLUS] = ACTIONS(1456),
    [anon_sym_DASH] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1454),
    [anon_sym_BANG] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1454),
    [aux_sym_clone_expression_token1] = ACTIONS(1456),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1456),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1456),
    [anon_sym_DASH_DASH] = ACTIONS(1454),
    [anon_sym_PLUS_PLUS] = ACTIONS(1454),
    [aux_sym__list_destructing_token1] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_self] = ACTIONS(1456),
    [anon_sym_parent] = ACTIONS(1456),
    [aux_sym__argument_name_token1] = ACTIONS(1456),
    [aux_sym__argument_name_token2] = ACTIONS(1456),
    [anon_sym_POUND_LBRACK] = ACTIONS(1454),
    [aux_sym_encapsed_string_token1] = ACTIONS(1454),
    [anon_sym_DQUOTE] = ACTIONS(1454),
    [aux_sym_string_token1] = ACTIONS(1454),
    [anon_sym_SQUOTE] = ACTIONS(1454),
    [anon_sym_LT_LT_LT] = ACTIONS(1454),
    [anon_sym_BQUOTE] = ACTIONS(1454),
    [anon_sym_DOLLAR] = ACTIONS(1454),
    [aux_sym_yield_expression_token1] = ACTIONS(1456),
    [aux_sym_include_expression_token1] = ACTIONS(1456),
    [aux_sym_include_once_expression_token1] = ACTIONS(1456),
    [aux_sym_require_expression_token1] = ACTIONS(1456),
    [aux_sym_require_once_expression_token1] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1458),
    [sym_name] = ACTIONS(1460),
    [anon_sym_QMARK_GT] = ACTIONS(1458),
    [anon_sym_SEMI] = ACTIONS(1458),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1460),
    [aux_sym_global_declaration_token1] = ACTIONS(1460),
    [aux_sym_namespace_definition_token1] = ACTIONS(1460),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1460),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1460),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1460),
    [anon_sym_BSLASH] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [aux_sym_trait_declaration_token1] = ACTIONS(1460),
    [aux_sym_interface_declaration_token1] = ACTIONS(1460),
    [aux_sym_enum_declaration_token1] = ACTIONS(1460),
    [aux_sym_enum_case_token1] = ACTIONS(1460),
    [aux_sym_class_declaration_token1] = ACTIONS(1460),
    [aux_sym_final_modifier_token1] = ACTIONS(1460),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1460),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1460),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1460),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1460),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1460),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1460),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [aux_sym_cast_type_token1] = ACTIONS(1460),
    [aux_sym_echo_statement_token1] = ACTIONS(1460),
    [anon_sym_unset] = ACTIONS(1460),
    [aux_sym_declare_statement_token1] = ACTIONS(1460),
    [aux_sym_declare_statement_token2] = ACTIONS(1460),
    [sym_float] = ACTIONS(1460),
    [aux_sym_try_statement_token1] = ACTIONS(1460),
    [aux_sym_goto_statement_token1] = ACTIONS(1460),
    [aux_sym_continue_statement_token1] = ACTIONS(1460),
    [aux_sym_break_statement_token1] = ACTIONS(1460),
    [sym_integer] = ACTIONS(1460),
    [aux_sym_return_statement_token1] = ACTIONS(1460),
    [aux_sym_throw_expression_token1] = ACTIONS(1460),
    [aux_sym_while_statement_token1] = ACTIONS(1460),
    [aux_sym_while_statement_token2] = ACTIONS(1460),
    [aux_sym_do_statement_token1] = ACTIONS(1460),
    [aux_sym_for_statement_token1] = ACTIONS(1460),
    [aux_sym_for_statement_token2] = ACTIONS(1460),
    [aux_sym_foreach_statement_token1] = ACTIONS(1460),
    [aux_sym_foreach_statement_token2] = ACTIONS(1460),
    [aux_sym_if_statement_token1] = ACTIONS(1460),
    [aux_sym_if_statement_token2] = ACTIONS(1460),
    [aux_sym_else_if_clause_token1] = ACTIONS(1460),
    [aux_sym_else_clause_token1] = ACTIONS(1460),
    [aux_sym_match_expression_token1] = ACTIONS(1460),
    [aux_sym_match_default_expression_token1] = ACTIONS(1460),
    [aux_sym_switch_statement_token1] = ACTIONS(1460),
    [aux_sym_switch_block_token1] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1460),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1458),
    [anon_sym_BANG] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1458),
    [aux_sym_clone_expression_token1] = ACTIONS(1460),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1460),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1460),
    [anon_sym_DASH_DASH] = ACTIONS(1458),
    [anon_sym_PLUS_PLUS] = ACTIONS(1458),
    [aux_sym__list_destructing_token1] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [anon_sym_self] = ACTIONS(1460),
    [anon_sym_parent] = ACTIONS(1460),
    [aux_sym__argument_name_token1] = ACTIONS(1460),
    [aux_sym__argument_name_token2] = ACTIONS(1460),
    [anon_sym_POUND_LBRACK] = ACTIONS(1458),
    [aux_sym_encapsed_string_token1] = ACTIONS(1458),
    [anon_sym_DQUOTE] = ACTIONS(1458),
    [aux_sym_string_token1] = ACTIONS(1458),
    [anon_sym_SQUOTE] = ACTIONS(1458),
    [anon_sym_LT_LT_LT] = ACTIONS(1458),
    [anon_sym_BQUOTE] = ACTIONS(1458),
    [anon_sym_DOLLAR] = ACTIONS(1458),
    [aux_sym_yield_expression_token1] = ACTIONS(1460),
    [aux_sym_include_expression_token1] = ACTIONS(1460),
    [aux_sym_include_once_expression_token1] = ACTIONS(1460),
    [aux_sym_require_expression_token1] = ACTIONS(1460),
    [aux_sym_require_once_expression_token1] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(1438),
    [sym_name] = ACTIONS(1440),
    [anon_sym_QMARK_GT] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1440),
    [aux_sym_global_declaration_token1] = ACTIONS(1440),
    [aux_sym_namespace_definition_token1] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1440),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1440),
    [anon_sym_BSLASH] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_RBRACE] = ACTIONS(1438),
    [aux_sym_trait_declaration_token1] = ACTIONS(1440),
    [aux_sym_interface_declaration_token1] = ACTIONS(1440),
    [aux_sym_enum_declaration_token1] = ACTIONS(1440),
    [aux_sym_enum_case_token1] = ACTIONS(1440),
    [aux_sym_class_declaration_token1] = ACTIONS(1440),
    [aux_sym_final_modifier_token1] = ACTIONS(1440),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1440),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1440),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1440),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [aux_sym_cast_type_token1] = ACTIONS(1440),
    [aux_sym_echo_statement_token1] = ACTIONS(1440),
    [anon_sym_unset] = ACTIONS(1440),
    [aux_sym_declare_statement_token1] = ACTIONS(1440),
    [aux_sym_declare_statement_token2] = ACTIONS(1440),
    [sym_float] = ACTIONS(1440),
    [aux_sym_try_statement_token1] = ACTIONS(1440),
    [aux_sym_goto_statement_token1] = ACTIONS(1440),
    [aux_sym_continue_statement_token1] = ACTIONS(1440),
    [aux_sym_break_statement_token1] = ACTIONS(1440),
    [sym_integer] = ACTIONS(1440),
    [aux_sym_return_statement_token1] = ACTIONS(1440),
    [aux_sym_throw_expression_token1] = ACTIONS(1440),
    [aux_sym_while_statement_token1] = ACTIONS(1440),
    [aux_sym_while_statement_token2] = ACTIONS(1440),
    [aux_sym_do_statement_token1] = ACTIONS(1440),
    [aux_sym_for_statement_token1] = ACTIONS(1440),
    [aux_sym_for_statement_token2] = ACTIONS(1440),
    [aux_sym_foreach_statement_token1] = ACTIONS(1440),
    [aux_sym_foreach_statement_token2] = ACTIONS(1440),
    [aux_sym_if_statement_token1] = ACTIONS(1440),
    [aux_sym_if_statement_token2] = ACTIONS(1440),
    [aux_sym_else_if_clause_token1] = ACTIONS(1440),
    [aux_sym_else_clause_token1] = ACTIONS(1440),
    [aux_sym_match_expression_token1] = ACTIONS(1440),
    [aux_sym_match_default_expression_token1] = ACTIONS(1440),
    [aux_sym_switch_statement_token1] = ACTIONS(1440),
    [aux_sym_switch_block_token1] = ACTIONS(1440),
    [anon_sym_PLUS] = ACTIONS(1440),
    [anon_sym_DASH] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_BANG] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1438),
    [aux_sym_clone_expression_token1] = ACTIONS(1440),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1440),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1440),
    [anon_sym_DASH_DASH] = ACTIONS(1438),
    [anon_sym_PLUS_PLUS] = ACTIONS(1438),
    [aux_sym__list_destructing_token1] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_self] = ACTIONS(1440),
    [anon_sym_parent] = ACTIONS(1440),
    [aux_sym__argument_name_token1] = ACTIONS(1440),
    [aux_sym__argument_name_token2] = ACTIONS(1440),
    [anon_sym_POUND_LBRACK] = ACTIONS(1438),
    [aux_sym_encapsed_string_token1] = ACTIONS(1438),
    [anon_sym_DQUOTE] = ACTIONS(1438),
    [aux_sym_string_token1] = ACTIONS(1438),
    [anon_sym_SQUOTE] = ACTIONS(1438),
    [anon_sym_LT_LT_LT] = ACTIONS(1438),
    [anon_sym_BQUOTE] = ACTIONS(1438),
    [anon_sym_DOLLAR] = ACTIONS(1438),
    [aux_sym_yield_expression_token1] = ACTIONS(1440),
    [aux_sym_include_expression_token1] = ACTIONS(1440),
    [aux_sym_include_once_expression_token1] = ACTIONS(1440),
    [aux_sym_require_expression_token1] = ACTIONS(1440),
    [aux_sym_require_once_expression_token1] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1074),
    [sym_name] = ACTIONS(1076),
    [anon_sym_QMARK_GT] = ACTIONS(1074),
    [anon_sym_SEMI] = ACTIONS(1074),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1076),
    [aux_sym_global_declaration_token1] = ACTIONS(1076),
    [aux_sym_namespace_definition_token1] = ACTIONS(1076),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1076),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1076),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1076),
    [anon_sym_BSLASH] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1074),
    [aux_sym_trait_declaration_token1] = ACTIONS(1076),
    [aux_sym_interface_declaration_token1] = ACTIONS(1076),
    [aux_sym_enum_declaration_token1] = ACTIONS(1076),
    [aux_sym_enum_case_token1] = ACTIONS(1076),
    [aux_sym_class_declaration_token1] = ACTIONS(1076),
    [aux_sym_final_modifier_token1] = ACTIONS(1076),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1076),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1076),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1076),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1076),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1076),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1076),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [aux_sym_cast_type_token1] = ACTIONS(1076),
    [aux_sym_echo_statement_token1] = ACTIONS(1076),
    [anon_sym_unset] = ACTIONS(1076),
    [aux_sym_declare_statement_token1] = ACTIONS(1076),
    [aux_sym_declare_statement_token2] = ACTIONS(1076),
    [sym_float] = ACTIONS(1076),
    [aux_sym_try_statement_token1] = ACTIONS(1076),
    [aux_sym_goto_statement_token1] = ACTIONS(1076),
    [aux_sym_continue_statement_token1] = ACTIONS(1076),
    [aux_sym_break_statement_token1] = ACTIONS(1076),
    [sym_integer] = ACTIONS(1076),
    [aux_sym_return_statement_token1] = ACTIONS(1076),
    [aux_sym_throw_expression_token1] = ACTIONS(1076),
    [aux_sym_while_statement_token1] = ACTIONS(1076),
    [aux_sym_while_statement_token2] = ACTIONS(1076),
    [aux_sym_do_statement_token1] = ACTIONS(1076),
    [aux_sym_for_statement_token1] = ACTIONS(1076),
    [aux_sym_for_statement_token2] = ACTIONS(1076),
    [aux_sym_foreach_statement_token1] = ACTIONS(1076),
    [aux_sym_foreach_statement_token2] = ACTIONS(1076),
    [aux_sym_if_statement_token1] = ACTIONS(1076),
    [aux_sym_if_statement_token2] = ACTIONS(1076),
    [aux_sym_else_if_clause_token1] = ACTIONS(1076),
    [aux_sym_else_clause_token1] = ACTIONS(1076),
    [aux_sym_match_expression_token1] = ACTIONS(1076),
    [aux_sym_match_default_expression_token1] = ACTIONS(1076),
    [aux_sym_switch_statement_token1] = ACTIONS(1076),
    [aux_sym_switch_block_token1] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_BANG] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1074),
    [aux_sym_clone_expression_token1] = ACTIONS(1076),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1076),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1076),
    [anon_sym_DASH_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1074),
    [aux_sym__list_destructing_token1] = ACTIONS(1076),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_self] = ACTIONS(1076),
    [anon_sym_parent] = ACTIONS(1076),
    [aux_sym__argument_name_token1] = ACTIONS(1076),
    [aux_sym__argument_name_token2] = ACTIONS(1076),
    [anon_sym_POUND_LBRACK] = ACTIONS(1074),
    [aux_sym_encapsed_string_token1] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1074),
    [aux_sym_string_token1] = ACTIONS(1074),
    [anon_sym_SQUOTE] = ACTIONS(1074),
    [anon_sym_LT_LT_LT] = ACTIONS(1074),
    [anon_sym_BQUOTE] = ACTIONS(1074),
    [anon_sym_DOLLAR] = ACTIONS(1074),
    [aux_sym_yield_expression_token1] = ACTIONS(1076),
    [aux_sym_include_expression_token1] = ACTIONS(1076),
    [aux_sym_include_once_expression_token1] = ACTIONS(1076),
    [aux_sym_require_expression_token1] = ACTIONS(1076),
    [aux_sym_require_once_expression_token1] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_name] = ACTIONS(1464),
    [anon_sym_QMARK_GT] = ACTIONS(1462),
    [anon_sym_SEMI] = ACTIONS(1462),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1464),
    [aux_sym_global_declaration_token1] = ACTIONS(1464),
    [aux_sym_namespace_definition_token1] = ACTIONS(1464),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1464),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1464),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1464),
    [anon_sym_BSLASH] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [aux_sym_trait_declaration_token1] = ACTIONS(1464),
    [aux_sym_interface_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_declaration_token1] = ACTIONS(1464),
    [aux_sym_enum_case_token1] = ACTIONS(1464),
    [aux_sym_class_declaration_token1] = ACTIONS(1464),
    [aux_sym_final_modifier_token1] = ACTIONS(1464),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1464),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1464),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1464),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1464),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1464),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1462),
    [aux_sym_cast_type_token1] = ACTIONS(1464),
    [aux_sym_echo_statement_token1] = ACTIONS(1464),
    [anon_sym_unset] = ACTIONS(1464),
    [aux_sym_declare_statement_token1] = ACTIONS(1464),
    [aux_sym_declare_statement_token2] = ACTIONS(1464),
    [sym_float] = ACTIONS(1464),
    [aux_sym_try_statement_token1] = ACTIONS(1464),
    [aux_sym_goto_statement_token1] = ACTIONS(1464),
    [aux_sym_continue_statement_token1] = ACTIONS(1464),
    [aux_sym_break_statement_token1] = ACTIONS(1464),
    [sym_integer] = ACTIONS(1464),
    [aux_sym_return_statement_token1] = ACTIONS(1464),
    [aux_sym_throw_expression_token1] = ACTIONS(1464),
    [aux_sym_while_statement_token1] = ACTIONS(1464),
    [aux_sym_while_statement_token2] = ACTIONS(1464),
    [aux_sym_do_statement_token1] = ACTIONS(1464),
    [aux_sym_for_statement_token1] = ACTIONS(1464),
    [aux_sym_for_statement_token2] = ACTIONS(1464),
    [aux_sym_foreach_statement_token1] = ACTIONS(1464),
    [aux_sym_foreach_statement_token2] = ACTIONS(1464),
    [aux_sym_if_statement_token1] = ACTIONS(1464),
    [aux_sym_if_statement_token2] = ACTIONS(1464),
    [aux_sym_else_if_clause_token1] = ACTIONS(1464),
    [aux_sym_else_clause_token1] = ACTIONS(1464),
    [aux_sym_match_expression_token1] = ACTIONS(1464),
    [aux_sym_match_default_expression_token1] = ACTIONS(1464),
    [aux_sym_switch_statement_token1] = ACTIONS(1464),
    [aux_sym_switch_block_token1] = ACTIONS(1464),
    [anon_sym_PLUS] = ACTIONS(1464),
    [anon_sym_DASH] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_BANG] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1462),
    [aux_sym_clone_expression_token1] = ACTIONS(1464),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1464),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1464),
    [anon_sym_DASH_DASH] = ACTIONS(1462),
    [anon_sym_PLUS_PLUS] = ACTIONS(1462),
    [aux_sym__list_destructing_token1] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_self] = ACTIONS(1464),
    [anon_sym_parent] = ACTIONS(1464),
    [aux_sym__argument_name_token1] = ACTIONS(1464),
    [aux_sym__argument_name_token2] = ACTIONS(1464),
    [anon_sym_POUND_LBRACK] = ACTIONS(1462),
    [aux_sym_encapsed_string_token1] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1462),
    [aux_sym_string_token1] = ACTIONS(1462),
    [anon_sym_SQUOTE] = ACTIONS(1462),
    [anon_sym_LT_LT_LT] = ACTIONS(1462),
    [anon_sym_BQUOTE] = ACTIONS(1462),
    [anon_sym_DOLLAR] = ACTIONS(1462),
    [aux_sym_yield_expression_token1] = ACTIONS(1464),
    [aux_sym_include_expression_token1] = ACTIONS(1464),
    [aux_sym_include_once_expression_token1] = ACTIONS(1464),
    [aux_sym_require_expression_token1] = ACTIONS(1464),
    [aux_sym_require_once_expression_token1] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_name] = ACTIONS(1468),
    [anon_sym_QMARK_GT] = ACTIONS(1466),
    [anon_sym_SEMI] = ACTIONS(1466),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1468),
    [aux_sym_global_declaration_token1] = ACTIONS(1468),
    [aux_sym_namespace_definition_token1] = ACTIONS(1468),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1468),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1468),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1468),
    [anon_sym_BSLASH] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_RBRACE] = ACTIONS(1466),
    [aux_sym_trait_declaration_token1] = ACTIONS(1468),
    [aux_sym_interface_declaration_token1] = ACTIONS(1468),
    [aux_sym_enum_declaration_token1] = ACTIONS(1468),
    [aux_sym_enum_case_token1] = ACTIONS(1468),
    [aux_sym_class_declaration_token1] = ACTIONS(1468),
    [aux_sym_final_modifier_token1] = ACTIONS(1468),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1468),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1468),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1468),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1468),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1468),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [aux_sym_cast_type_token1] = ACTIONS(1468),
    [aux_sym_echo_statement_token1] = ACTIONS(1468),
    [anon_sym_unset] = ACTIONS(1468),
    [aux_sym_declare_statement_token1] = ACTIONS(1468),
    [aux_sym_declare_statement_token2] = ACTIONS(1468),
    [sym_float] = ACTIONS(1468),
    [aux_sym_try_statement_token1] = ACTIONS(1468),
    [aux_sym_goto_statement_token1] = ACTIONS(1468),
    [aux_sym_continue_statement_token1] = ACTIONS(1468),
    [aux_sym_break_statement_token1] = ACTIONS(1468),
    [sym_integer] = ACTIONS(1468),
    [aux_sym_return_statement_token1] = ACTIONS(1468),
    [aux_sym_throw_expression_token1] = ACTIONS(1468),
    [aux_sym_while_statement_token1] = ACTIONS(1468),
    [aux_sym_while_statement_token2] = ACTIONS(1468),
    [aux_sym_do_statement_token1] = ACTIONS(1468),
    [aux_sym_for_statement_token1] = ACTIONS(1468),
    [aux_sym_for_statement_token2] = ACTIONS(1468),
    [aux_sym_foreach_statement_token1] = ACTIONS(1468),
    [aux_sym_foreach_statement_token2] = ACTIONS(1468),
    [aux_sym_if_statement_token1] = ACTIONS(1468),
    [aux_sym_if_statement_token2] = ACTIONS(1468),
    [aux_sym_else_if_clause_token1] = ACTIONS(1468),
    [aux_sym_else_clause_token1] = ACTIONS(1468),
    [aux_sym_match_expression_token1] = ACTIONS(1468),
    [aux_sym_match_default_expression_token1] = ACTIONS(1468),
    [aux_sym_switch_statement_token1] = ACTIONS(1468),
    [aux_sym_switch_block_token1] = ACTIONS(1468),
    [anon_sym_PLUS] = ACTIONS(1468),
    [anon_sym_DASH] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_BANG] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1466),
    [aux_sym_clone_expression_token1] = ACTIONS(1468),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1468),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1468),
    [anon_sym_DASH_DASH] = ACTIONS(1466),
    [anon_sym_PLUS_PLUS] = ACTIONS(1466),
    [aux_sym__list_destructing_token1] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_self] = ACTIONS(1468),
    [anon_sym_parent] = ACTIONS(1468),
    [aux_sym__argument_name_token1] = ACTIONS(1468),
    [aux_sym__argument_name_token2] = ACTIONS(1468),
    [anon_sym_POUND_LBRACK] = ACTIONS(1466),
    [aux_sym_encapsed_string_token1] = ACTIONS(1466),
    [anon_sym_DQUOTE] = ACTIONS(1466),
    [aux_sym_string_token1] = ACTIONS(1466),
    [anon_sym_SQUOTE] = ACTIONS(1466),
    [anon_sym_LT_LT_LT] = ACTIONS(1466),
    [anon_sym_BQUOTE] = ACTIONS(1466),
    [anon_sym_DOLLAR] = ACTIONS(1466),
    [aux_sym_yield_expression_token1] = ACTIONS(1468),
    [aux_sym_include_expression_token1] = ACTIONS(1468),
    [aux_sym_include_once_expression_token1] = ACTIONS(1468),
    [aux_sym_require_expression_token1] = ACTIONS(1468),
    [aux_sym_require_once_expression_token1] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_name] = ACTIONS(1472),
    [anon_sym_QMARK_GT] = ACTIONS(1470),
    [anon_sym_SEMI] = ACTIONS(1470),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1472),
    [aux_sym_global_declaration_token1] = ACTIONS(1472),
    [aux_sym_namespace_definition_token1] = ACTIONS(1472),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1472),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1472),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1472),
    [anon_sym_BSLASH] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_RBRACE] = ACTIONS(1470),
    [aux_sym_trait_declaration_token1] = ACTIONS(1472),
    [aux_sym_interface_declaration_token1] = ACTIONS(1472),
    [aux_sym_enum_declaration_token1] = ACTIONS(1472),
    [aux_sym_enum_case_token1] = ACTIONS(1472),
    [aux_sym_class_declaration_token1] = ACTIONS(1472),
    [aux_sym_final_modifier_token1] = ACTIONS(1472),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1472),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1472),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1472),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1472),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1472),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [aux_sym_cast_type_token1] = ACTIONS(1472),
    [aux_sym_echo_statement_token1] = ACTIONS(1472),
    [anon_sym_unset] = ACTIONS(1472),
    [aux_sym_declare_statement_token1] = ACTIONS(1472),
    [aux_sym_declare_statement_token2] = ACTIONS(1472),
    [sym_float] = ACTIONS(1472),
    [aux_sym_try_statement_token1] = ACTIONS(1472),
    [aux_sym_goto_statement_token1] = ACTIONS(1472),
    [aux_sym_continue_statement_token1] = ACTIONS(1472),
    [aux_sym_break_statement_token1] = ACTIONS(1472),
    [sym_integer] = ACTIONS(1472),
    [aux_sym_return_statement_token1] = ACTIONS(1472),
    [aux_sym_throw_expression_token1] = ACTIONS(1472),
    [aux_sym_while_statement_token1] = ACTIONS(1472),
    [aux_sym_while_statement_token2] = ACTIONS(1472),
    [aux_sym_do_statement_token1] = ACTIONS(1472),
    [aux_sym_for_statement_token1] = ACTIONS(1472),
    [aux_sym_for_statement_token2] = ACTIONS(1472),
    [aux_sym_foreach_statement_token1] = ACTIONS(1472),
    [aux_sym_foreach_statement_token2] = ACTIONS(1472),
    [aux_sym_if_statement_token1] = ACTIONS(1472),
    [aux_sym_if_statement_token2] = ACTIONS(1472),
    [aux_sym_else_if_clause_token1] = ACTIONS(1472),
    [aux_sym_else_clause_token1] = ACTIONS(1472),
    [aux_sym_match_expression_token1] = ACTIONS(1472),
    [aux_sym_match_default_expression_token1] = ACTIONS(1472),
    [aux_sym_switch_statement_token1] = ACTIONS(1472),
    [aux_sym_switch_block_token1] = ACTIONS(1472),
    [anon_sym_PLUS] = ACTIONS(1472),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [aux_sym_clone_expression_token1] = ACTIONS(1472),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1472),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1472),
    [anon_sym_DASH_DASH] = ACTIONS(1470),
    [anon_sym_PLUS_PLUS] = ACTIONS(1470),
    [aux_sym__list_destructing_token1] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_self] = ACTIONS(1472),
    [anon_sym_parent] = ACTIONS(1472),
    [aux_sym__argument_name_token1] = ACTIONS(1472),
    [aux_sym__argument_name_token2] = ACTIONS(1472),
    [anon_sym_POUND_LBRACK] = ACTIONS(1470),
    [aux_sym_encapsed_string_token1] = ACTIONS(1470),
    [anon_sym_DQUOTE] = ACTIONS(1470),
    [aux_sym_string_token1] = ACTIONS(1470),
    [anon_sym_SQUOTE] = ACTIONS(1470),
    [anon_sym_LT_LT_LT] = ACTIONS(1470),
    [anon_sym_BQUOTE] = ACTIONS(1470),
    [anon_sym_DOLLAR] = ACTIONS(1470),
    [aux_sym_yield_expression_token1] = ACTIONS(1472),
    [aux_sym_include_expression_token1] = ACTIONS(1472),
    [aux_sym_include_once_expression_token1] = ACTIONS(1472),
    [aux_sym_require_expression_token1] = ACTIONS(1472),
    [aux_sym_require_once_expression_token1] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(1474),
    [sym_name] = ACTIONS(1476),
    [anon_sym_QMARK_GT] = ACTIONS(1474),
    [anon_sym_SEMI] = ACTIONS(1474),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1476),
    [aux_sym_global_declaration_token1] = ACTIONS(1476),
    [aux_sym_namespace_definition_token1] = ACTIONS(1476),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1476),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1476),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_RBRACE] = ACTIONS(1474),
    [aux_sym_trait_declaration_token1] = ACTIONS(1476),
    [aux_sym_interface_declaration_token1] = ACTIONS(1476),
    [aux_sym_enum_declaration_token1] = ACTIONS(1476),
    [aux_sym_enum_case_token1] = ACTIONS(1476),
    [aux_sym_class_declaration_token1] = ACTIONS(1476),
    [aux_sym_final_modifier_token1] = ACTIONS(1476),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1476),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1476),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1476),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1476),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1476),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1474),
    [aux_sym_cast_type_token1] = ACTIONS(1476),
    [aux_sym_echo_statement_token1] = ACTIONS(1476),
    [anon_sym_unset] = ACTIONS(1476),
    [aux_sym_declare_statement_token1] = ACTIONS(1476),
    [aux_sym_declare_statement_token2] = ACTIONS(1476),
    [sym_float] = ACTIONS(1476),
    [aux_sym_try_statement_token1] = ACTIONS(1476),
    [aux_sym_goto_statement_token1] = ACTIONS(1476),
    [aux_sym_continue_statement_token1] = ACTIONS(1476),
    [aux_sym_break_statement_token1] = ACTIONS(1476),
    [sym_integer] = ACTIONS(1476),
    [aux_sym_return_statement_token1] = ACTIONS(1476),
    [aux_sym_throw_expression_token1] = ACTIONS(1476),
    [aux_sym_while_statement_token1] = ACTIONS(1476),
    [aux_sym_while_statement_token2] = ACTIONS(1476),
    [aux_sym_do_statement_token1] = ACTIONS(1476),
    [aux_sym_for_statement_token1] = ACTIONS(1476),
    [aux_sym_for_statement_token2] = ACTIONS(1476),
    [aux_sym_foreach_statement_token1] = ACTIONS(1476),
    [aux_sym_foreach_statement_token2] = ACTIONS(1476),
    [aux_sym_if_statement_token1] = ACTIONS(1476),
    [aux_sym_if_statement_token2] = ACTIONS(1476),
    [aux_sym_else_if_clause_token1] = ACTIONS(1476),
    [aux_sym_else_clause_token1] = ACTIONS(1476),
    [aux_sym_match_expression_token1] = ACTIONS(1476),
    [aux_sym_match_default_expression_token1] = ACTIONS(1476),
    [aux_sym_switch_statement_token1] = ACTIONS(1476),
    [aux_sym_switch_block_token1] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_BANG] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [aux_sym_clone_expression_token1] = ACTIONS(1476),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1476),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1476),
    [anon_sym_DASH_DASH] = ACTIONS(1474),
    [anon_sym_PLUS_PLUS] = ACTIONS(1474),
    [aux_sym__list_destructing_token1] = ACTIONS(1476),
    [anon_sym_LBRACK] = ACTIONS(1474),
    [anon_sym_self] = ACTIONS(1476),
    [anon_sym_parent] = ACTIONS(1476),
    [aux_sym__argument_name_token1] = ACTIONS(1476),
    [aux_sym__argument_name_token2] = ACTIONS(1476),
    [anon_sym_POUND_LBRACK] = ACTIONS(1474),
    [aux_sym_encapsed_string_token1] = ACTIONS(1474),
    [anon_sym_DQUOTE] = ACTIONS(1474),
    [aux_sym_string_token1] = ACTIONS(1474),
    [anon_sym_SQUOTE] = ACTIONS(1474),
    [anon_sym_LT_LT_LT] = ACTIONS(1474),
    [anon_sym_BQUOTE] = ACTIONS(1474),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [aux_sym_yield_expression_token1] = ACTIONS(1476),
    [aux_sym_include_expression_token1] = ACTIONS(1476),
    [aux_sym_include_once_expression_token1] = ACTIONS(1476),
    [aux_sym_require_expression_token1] = ACTIONS(1476),
    [aux_sym_require_once_expression_token1] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1478),
    [sym_name] = ACTIONS(1480),
    [anon_sym_QMARK_GT] = ACTIONS(1478),
    [anon_sym_SEMI] = ACTIONS(1478),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1480),
    [aux_sym_global_declaration_token1] = ACTIONS(1480),
    [aux_sym_namespace_definition_token1] = ACTIONS(1480),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1480),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1480),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1480),
    [anon_sym_BSLASH] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_RBRACE] = ACTIONS(1478),
    [aux_sym_trait_declaration_token1] = ACTIONS(1480),
    [aux_sym_interface_declaration_token1] = ACTIONS(1480),
    [aux_sym_enum_declaration_token1] = ACTIONS(1480),
    [aux_sym_enum_case_token1] = ACTIONS(1480),
    [aux_sym_class_declaration_token1] = ACTIONS(1480),
    [aux_sym_final_modifier_token1] = ACTIONS(1480),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1480),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1480),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1480),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1480),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1480),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [aux_sym_cast_type_token1] = ACTIONS(1480),
    [aux_sym_echo_statement_token1] = ACTIONS(1480),
    [anon_sym_unset] = ACTIONS(1480),
    [aux_sym_declare_statement_token1] = ACTIONS(1480),
    [aux_sym_declare_statement_token2] = ACTIONS(1480),
    [sym_float] = ACTIONS(1480),
    [aux_sym_try_statement_token1] = ACTIONS(1480),
    [aux_sym_goto_statement_token1] = ACTIONS(1480),
    [aux_sym_continue_statement_token1] = ACTIONS(1480),
    [aux_sym_break_statement_token1] = ACTIONS(1480),
    [sym_integer] = ACTIONS(1480),
    [aux_sym_return_statement_token1] = ACTIONS(1480),
    [aux_sym_throw_expression_token1] = ACTIONS(1480),
    [aux_sym_while_statement_token1] = ACTIONS(1480),
    [aux_sym_while_statement_token2] = ACTIONS(1480),
    [aux_sym_do_statement_token1] = ACTIONS(1480),
    [aux_sym_for_statement_token1] = ACTIONS(1480),
    [aux_sym_for_statement_token2] = ACTIONS(1480),
    [aux_sym_foreach_statement_token1] = ACTIONS(1480),
    [aux_sym_foreach_statement_token2] = ACTIONS(1480),
    [aux_sym_if_statement_token1] = ACTIONS(1480),
    [aux_sym_if_statement_token2] = ACTIONS(1480),
    [aux_sym_else_if_clause_token1] = ACTIONS(1480),
    [aux_sym_else_clause_token1] = ACTIONS(1480),
    [aux_sym_match_expression_token1] = ACTIONS(1480),
    [aux_sym_match_default_expression_token1] = ACTIONS(1480),
    [aux_sym_switch_statement_token1] = ACTIONS(1480),
    [aux_sym_switch_block_token1] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(1480),
    [anon_sym_DASH] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_BANG] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [aux_sym_clone_expression_token1] = ACTIONS(1480),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1480),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1480),
    [anon_sym_DASH_DASH] = ACTIONS(1478),
    [anon_sym_PLUS_PLUS] = ACTIONS(1478),
    [aux_sym__list_destructing_token1] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_self] = ACTIONS(1480),
    [anon_sym_parent] = ACTIONS(1480),
    [aux_sym__argument_name_token1] = ACTIONS(1480),
    [aux_sym__argument_name_token2] = ACTIONS(1480),
    [anon_sym_POUND_LBRACK] = ACTIONS(1478),
    [aux_sym_encapsed_string_token1] = ACTIONS(1478),
    [anon_sym_DQUOTE] = ACTIONS(1478),
    [aux_sym_string_token1] = ACTIONS(1478),
    [anon_sym_SQUOTE] = ACTIONS(1478),
    [anon_sym_LT_LT_LT] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1478),
    [anon_sym_DOLLAR] = ACTIONS(1478),
    [aux_sym_yield_expression_token1] = ACTIONS(1480),
    [aux_sym_include_expression_token1] = ACTIONS(1480),
    [aux_sym_include_once_expression_token1] = ACTIONS(1480),
    [aux_sym_require_expression_token1] = ACTIONS(1480),
    [aux_sym_require_once_expression_token1] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_name] = ACTIONS(1484),
    [anon_sym_QMARK_GT] = ACTIONS(1482),
    [anon_sym_SEMI] = ACTIONS(1482),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1484),
    [aux_sym_global_declaration_token1] = ACTIONS(1484),
    [aux_sym_namespace_definition_token1] = ACTIONS(1484),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1484),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1484),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1484),
    [anon_sym_BSLASH] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_RBRACE] = ACTIONS(1482),
    [aux_sym_trait_declaration_token1] = ACTIONS(1484),
    [aux_sym_interface_declaration_token1] = ACTIONS(1484),
    [aux_sym_enum_declaration_token1] = ACTIONS(1484),
    [aux_sym_enum_case_token1] = ACTIONS(1484),
    [aux_sym_class_declaration_token1] = ACTIONS(1484),
    [aux_sym_final_modifier_token1] = ACTIONS(1484),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1484),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1484),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1484),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1484),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1484),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [aux_sym_cast_type_token1] = ACTIONS(1484),
    [aux_sym_echo_statement_token1] = ACTIONS(1484),
    [anon_sym_unset] = ACTIONS(1484),
    [aux_sym_declare_statement_token1] = ACTIONS(1484),
    [aux_sym_declare_statement_token2] = ACTIONS(1484),
    [sym_float] = ACTIONS(1484),
    [aux_sym_try_statement_token1] = ACTIONS(1484),
    [aux_sym_goto_statement_token1] = ACTIONS(1484),
    [aux_sym_continue_statement_token1] = ACTIONS(1484),
    [aux_sym_break_statement_token1] = ACTIONS(1484),
    [sym_integer] = ACTIONS(1484),
    [aux_sym_return_statement_token1] = ACTIONS(1484),
    [aux_sym_throw_expression_token1] = ACTIONS(1484),
    [aux_sym_while_statement_token1] = ACTIONS(1484),
    [aux_sym_while_statement_token2] = ACTIONS(1484),
    [aux_sym_do_statement_token1] = ACTIONS(1484),
    [aux_sym_for_statement_token1] = ACTIONS(1484),
    [aux_sym_for_statement_token2] = ACTIONS(1484),
    [aux_sym_foreach_statement_token1] = ACTIONS(1484),
    [aux_sym_foreach_statement_token2] = ACTIONS(1484),
    [aux_sym_if_statement_token1] = ACTIONS(1484),
    [aux_sym_if_statement_token2] = ACTIONS(1484),
    [aux_sym_else_if_clause_token1] = ACTIONS(1484),
    [aux_sym_else_clause_token1] = ACTIONS(1484),
    [aux_sym_match_expression_token1] = ACTIONS(1484),
    [aux_sym_match_default_expression_token1] = ACTIONS(1484),
    [aux_sym_switch_statement_token1] = ACTIONS(1484),
    [aux_sym_switch_block_token1] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_BANG] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [aux_sym_clone_expression_token1] = ACTIONS(1484),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1484),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1484),
    [anon_sym_DASH_DASH] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1482),
    [aux_sym__list_destructing_token1] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_self] = ACTIONS(1484),
    [anon_sym_parent] = ACTIONS(1484),
    [aux_sym__argument_name_token1] = ACTIONS(1484),
    [aux_sym__argument_name_token2] = ACTIONS(1484),
    [anon_sym_POUND_LBRACK] = ACTIONS(1482),
    [aux_sym_encapsed_string_token1] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(1482),
    [aux_sym_string_token1] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1482),
    [anon_sym_LT_LT_LT] = ACTIONS(1482),
    [anon_sym_BQUOTE] = ACTIONS(1482),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [aux_sym_yield_expression_token1] = ACTIONS(1484),
    [aux_sym_include_expression_token1] = ACTIONS(1484),
    [aux_sym_include_once_expression_token1] = ACTIONS(1484),
    [aux_sym_require_expression_token1] = ACTIONS(1484),
    [aux_sym_require_once_expression_token1] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_name] = ACTIONS(1444),
    [anon_sym_QMARK_GT] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1444),
    [aux_sym_global_declaration_token1] = ACTIONS(1444),
    [aux_sym_namespace_definition_token1] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1444),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1444),
    [anon_sym_BSLASH] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [aux_sym_trait_declaration_token1] = ACTIONS(1444),
    [aux_sym_interface_declaration_token1] = ACTIONS(1444),
    [aux_sym_enum_declaration_token1] = ACTIONS(1444),
    [aux_sym_enum_case_token1] = ACTIONS(1444),
    [aux_sym_class_declaration_token1] = ACTIONS(1444),
    [aux_sym_final_modifier_token1] = ACTIONS(1444),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1444),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1444),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1444),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [aux_sym_cast_type_token1] = ACTIONS(1444),
    [aux_sym_echo_statement_token1] = ACTIONS(1444),
    [anon_sym_unset] = ACTIONS(1444),
    [aux_sym_declare_statement_token1] = ACTIONS(1444),
    [aux_sym_declare_statement_token2] = ACTIONS(1444),
    [sym_float] = ACTIONS(1444),
    [aux_sym_try_statement_token1] = ACTIONS(1444),
    [aux_sym_goto_statement_token1] = ACTIONS(1444),
    [aux_sym_continue_statement_token1] = ACTIONS(1444),
    [aux_sym_break_statement_token1] = ACTIONS(1444),
    [sym_integer] = ACTIONS(1444),
    [aux_sym_return_statement_token1] = ACTIONS(1444),
    [aux_sym_throw_expression_token1] = ACTIONS(1444),
    [aux_sym_while_statement_token1] = ACTIONS(1444),
    [aux_sym_while_statement_token2] = ACTIONS(1444),
    [aux_sym_do_statement_token1] = ACTIONS(1444),
    [aux_sym_for_statement_token1] = ACTIONS(1444),
    [aux_sym_for_statement_token2] = ACTIONS(1444),
    [aux_sym_foreach_statement_token1] = ACTIONS(1444),
    [aux_sym_foreach_statement_token2] = ACTIONS(1444),
    [aux_sym_if_statement_token1] = ACTIONS(1444),
    [aux_sym_if_statement_token2] = ACTIONS(1444),
    [aux_sym_else_if_clause_token1] = ACTIONS(1444),
    [aux_sym_else_clause_token1] = ACTIONS(1444),
    [aux_sym_match_expression_token1] = ACTIONS(1444),
    [aux_sym_match_default_expression_token1] = ACTIONS(1444),
    [aux_sym_switch_statement_token1] = ACTIONS(1444),
    [aux_sym_switch_block_token1] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_BANG] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1442),
    [aux_sym_clone_expression_token1] = ACTIONS(1444),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1444),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1442),
    [anon_sym_PLUS_PLUS] = ACTIONS(1442),
    [aux_sym__list_destructing_token1] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_self] = ACTIONS(1444),
    [anon_sym_parent] = ACTIONS(1444),
    [aux_sym__argument_name_token1] = ACTIONS(1444),
    [aux_sym__argument_name_token2] = ACTIONS(1444),
    [anon_sym_POUND_LBRACK] = ACTIONS(1442),
    [aux_sym_encapsed_string_token1] = ACTIONS(1442),
    [anon_sym_DQUOTE] = ACTIONS(1442),
    [aux_sym_string_token1] = ACTIONS(1442),
    [anon_sym_SQUOTE] = ACTIONS(1442),
    [anon_sym_LT_LT_LT] = ACTIONS(1442),
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [anon_sym_DOLLAR] = ACTIONS(1442),
    [aux_sym_yield_expression_token1] = ACTIONS(1444),
    [aux_sym_include_expression_token1] = ACTIONS(1444),
    [aux_sym_include_once_expression_token1] = ACTIONS(1444),
    [aux_sym_require_expression_token1] = ACTIONS(1444),
    [aux_sym_require_once_expression_token1] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(1486),
    [sym_name] = ACTIONS(1488),
    [anon_sym_QMARK_GT] = ACTIONS(1486),
    [anon_sym_SEMI] = ACTIONS(1486),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1488),
    [aux_sym_global_declaration_token1] = ACTIONS(1488),
    [aux_sym_namespace_definition_token1] = ACTIONS(1488),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1488),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1488),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1488),
    [anon_sym_BSLASH] = ACTIONS(1486),
    [anon_sym_LBRACE] = ACTIONS(1486),
    [anon_sym_RBRACE] = ACTIONS(1486),
    [aux_sym_trait_declaration_token1] = ACTIONS(1488),
    [aux_sym_interface_declaration_token1] = ACTIONS(1488),
    [aux_sym_enum_declaration_token1] = ACTIONS(1488),
    [aux_sym_enum_case_token1] = ACTIONS(1488),
    [aux_sym_class_declaration_token1] = ACTIONS(1488),
    [aux_sym_final_modifier_token1] = ACTIONS(1488),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1488),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1488),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1488),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1488),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1488),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1488),
    [anon_sym_LPAREN] = ACTIONS(1486),
    [aux_sym_cast_type_token1] = ACTIONS(1488),
    [aux_sym_echo_statement_token1] = ACTIONS(1488),
    [anon_sym_unset] = ACTIONS(1488),
    [aux_sym_declare_statement_token1] = ACTIONS(1488),
    [aux_sym_declare_statement_token2] = ACTIONS(1488),
    [sym_float] = ACTIONS(1488),
    [aux_sym_try_statement_token1] = ACTIONS(1488),
    [aux_sym_goto_statement_token1] = ACTIONS(1488),
    [aux_sym_continue_statement_token1] = ACTIONS(1488),
    [aux_sym_break_statement_token1] = ACTIONS(1488),
    [sym_integer] = ACTIONS(1488),
    [aux_sym_return_statement_token1] = ACTIONS(1488),
    [aux_sym_throw_expression_token1] = ACTIONS(1488),
    [aux_sym_while_statement_token1] = ACTIONS(1488),
    [aux_sym_while_statement_token2] = ACTIONS(1488),
    [aux_sym_do_statement_token1] = ACTIONS(1488),
    [aux_sym_for_statement_token1] = ACTIONS(1488),
    [aux_sym_for_statement_token2] = ACTIONS(1488),
    [aux_sym_foreach_statement_token1] = ACTIONS(1488),
    [aux_sym_foreach_statement_token2] = ACTIONS(1488),
    [aux_sym_if_statement_token1] = ACTIONS(1488),
    [aux_sym_if_statement_token2] = ACTIONS(1488),
    [aux_sym_else_if_clause_token1] = ACTIONS(1488),
    [aux_sym_else_clause_token1] = ACTIONS(1488),
    [aux_sym_match_expression_token1] = ACTIONS(1488),
    [aux_sym_match_default_expression_token1] = ACTIONS(1488),
    [aux_sym_switch_statement_token1] = ACTIONS(1488),
    [aux_sym_switch_block_token1] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_TILDE] = ACTIONS(1486),
    [anon_sym_BANG] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(1486),
    [aux_sym_clone_expression_token1] = ACTIONS(1488),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1488),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1486),
    [anon_sym_PLUS_PLUS] = ACTIONS(1486),
    [aux_sym__list_destructing_token1] = ACTIONS(1488),
    [anon_sym_LBRACK] = ACTIONS(1486),
    [anon_sym_self] = ACTIONS(1488),
    [anon_sym_parent] = ACTIONS(1488),
    [aux_sym__argument_name_token1] = ACTIONS(1488),
    [aux_sym__argument_name_token2] = ACTIONS(1488),
    [anon_sym_POUND_LBRACK] = ACTIONS(1486),
    [aux_sym_encapsed_string_token1] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1486),
    [aux_sym_string_token1] = ACTIONS(1486),
    [anon_sym_SQUOTE] = ACTIONS(1486),
    [anon_sym_LT_LT_LT] = ACTIONS(1486),
    [anon_sym_BQUOTE] = ACTIONS(1486),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [aux_sym_yield_expression_token1] = ACTIONS(1488),
    [aux_sym_include_expression_token1] = ACTIONS(1488),
    [aux_sym_include_once_expression_token1] = ACTIONS(1488),
    [aux_sym_require_expression_token1] = ACTIONS(1488),
    [aux_sym_require_once_expression_token1] = ACTIONS(1488),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1490),
    [sym_name] = ACTIONS(1492),
    [anon_sym_QMARK_GT] = ACTIONS(1490),
    [anon_sym_SEMI] = ACTIONS(1490),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1492),
    [aux_sym_global_declaration_token1] = ACTIONS(1492),
    [aux_sym_namespace_definition_token1] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1492),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1492),
    [anon_sym_BSLASH] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1490),
    [anon_sym_RBRACE] = ACTIONS(1490),
    [aux_sym_trait_declaration_token1] = ACTIONS(1492),
    [aux_sym_interface_declaration_token1] = ACTIONS(1492),
    [aux_sym_enum_declaration_token1] = ACTIONS(1492),
    [aux_sym_enum_case_token1] = ACTIONS(1492),
    [aux_sym_class_declaration_token1] = ACTIONS(1492),
    [aux_sym_final_modifier_token1] = ACTIONS(1492),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1492),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1492),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1492),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [aux_sym_cast_type_token1] = ACTIONS(1492),
    [aux_sym_echo_statement_token1] = ACTIONS(1492),
    [anon_sym_unset] = ACTIONS(1492),
    [aux_sym_declare_statement_token1] = ACTIONS(1492),
    [aux_sym_declare_statement_token2] = ACTIONS(1492),
    [sym_float] = ACTIONS(1492),
    [aux_sym_try_statement_token1] = ACTIONS(1492),
    [aux_sym_goto_statement_token1] = ACTIONS(1492),
    [aux_sym_continue_statement_token1] = ACTIONS(1492),
    [aux_sym_break_statement_token1] = ACTIONS(1492),
    [sym_integer] = ACTIONS(1492),
    [aux_sym_return_statement_token1] = ACTIONS(1492),
    [aux_sym_throw_expression_token1] = ACTIONS(1492),
    [aux_sym_while_statement_token1] = ACTIONS(1492),
    [aux_sym_while_statement_token2] = ACTIONS(1492),
    [aux_sym_do_statement_token1] = ACTIONS(1492),
    [aux_sym_for_statement_token1] = ACTIONS(1492),
    [aux_sym_for_statement_token2] = ACTIONS(1492),
    [aux_sym_foreach_statement_token1] = ACTIONS(1492),
    [aux_sym_foreach_statement_token2] = ACTIONS(1492),
    [aux_sym_if_statement_token1] = ACTIONS(1492),
    [aux_sym_if_statement_token2] = ACTIONS(1492),
    [aux_sym_else_if_clause_token1] = ACTIONS(1492),
    [aux_sym_else_clause_token1] = ACTIONS(1492),
    [aux_sym_match_expression_token1] = ACTIONS(1492),
    [aux_sym_match_default_expression_token1] = ACTIONS(1492),
    [aux_sym_switch_statement_token1] = ACTIONS(1492),
    [aux_sym_switch_block_token1] = ACTIONS(1492),
    [anon_sym_PLUS] = ACTIONS(1492),
    [anon_sym_DASH] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1490),
    [anon_sym_BANG] = ACTIONS(1490),
    [anon_sym_AT] = ACTIONS(1490),
    [aux_sym_clone_expression_token1] = ACTIONS(1492),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1492),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1492),
    [anon_sym_DASH_DASH] = ACTIONS(1490),
    [anon_sym_PLUS_PLUS] = ACTIONS(1490),
    [aux_sym__list_destructing_token1] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_self] = ACTIONS(1492),
    [anon_sym_parent] = ACTIONS(1492),
    [aux_sym__argument_name_token1] = ACTIONS(1492),
    [aux_sym__argument_name_token2] = ACTIONS(1492),
    [anon_sym_POUND_LBRACK] = ACTIONS(1490),
    [aux_sym_encapsed_string_token1] = ACTIONS(1490),
    [anon_sym_DQUOTE] = ACTIONS(1490),
    [aux_sym_string_token1] = ACTIONS(1490),
    [anon_sym_SQUOTE] = ACTIONS(1490),
    [anon_sym_LT_LT_LT] = ACTIONS(1490),
    [anon_sym_BQUOTE] = ACTIONS(1490),
    [anon_sym_DOLLAR] = ACTIONS(1490),
    [aux_sym_yield_expression_token1] = ACTIONS(1492),
    [aux_sym_include_expression_token1] = ACTIONS(1492),
    [aux_sym_include_once_expression_token1] = ACTIONS(1492),
    [aux_sym_require_expression_token1] = ACTIONS(1492),
    [aux_sym_require_once_expression_token1] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_name] = ACTIONS(1496),
    [anon_sym_QMARK_GT] = ACTIONS(1494),
    [anon_sym_SEMI] = ACTIONS(1494),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1496),
    [aux_sym_global_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_definition_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1496),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1496),
    [anon_sym_BSLASH] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_RBRACE] = ACTIONS(1494),
    [aux_sym_trait_declaration_token1] = ACTIONS(1496),
    [aux_sym_interface_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_declaration_token1] = ACTIONS(1496),
    [aux_sym_enum_case_token1] = ACTIONS(1496),
    [aux_sym_class_declaration_token1] = ACTIONS(1496),
    [aux_sym_final_modifier_token1] = ACTIONS(1496),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1496),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1496),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1496),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1496),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [aux_sym_cast_type_token1] = ACTIONS(1496),
    [aux_sym_echo_statement_token1] = ACTIONS(1496),
    [anon_sym_unset] = ACTIONS(1496),
    [aux_sym_declare_statement_token1] = ACTIONS(1496),
    [aux_sym_declare_statement_token2] = ACTIONS(1496),
    [sym_float] = ACTIONS(1496),
    [aux_sym_try_statement_token1] = ACTIONS(1496),
    [aux_sym_goto_statement_token1] = ACTIONS(1496),
    [aux_sym_continue_statement_token1] = ACTIONS(1496),
    [aux_sym_break_statement_token1] = ACTIONS(1496),
    [sym_integer] = ACTIONS(1496),
    [aux_sym_return_statement_token1] = ACTIONS(1496),
    [aux_sym_throw_expression_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token1] = ACTIONS(1496),
    [aux_sym_while_statement_token2] = ACTIONS(1496),
    [aux_sym_do_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token1] = ACTIONS(1496),
    [aux_sym_for_statement_token2] = ACTIONS(1496),
    [aux_sym_foreach_statement_token1] = ACTIONS(1496),
    [aux_sym_foreach_statement_token2] = ACTIONS(1496),
    [aux_sym_if_statement_token1] = ACTIONS(1496),
    [aux_sym_if_statement_token2] = ACTIONS(1496),
    [aux_sym_else_if_clause_token1] = ACTIONS(1496),
    [aux_sym_else_clause_token1] = ACTIONS(1496),
    [aux_sym_match_expression_token1] = ACTIONS(1496),
    [aux_sym_match_default_expression_token1] = ACTIONS(1496),
    [aux_sym_switch_statement_token1] = ACTIONS(1496),
    [aux_sym_switch_block_token1] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_BANG] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [aux_sym_clone_expression_token1] = ACTIONS(1496),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1496),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1496),
    [anon_sym_DASH_DASH] = ACTIONS(1494),
    [anon_sym_PLUS_PLUS] = ACTIONS(1494),
    [aux_sym__list_destructing_token1] = ACTIONS(1496),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_self] = ACTIONS(1496),
    [anon_sym_parent] = ACTIONS(1496),
    [aux_sym__argument_name_token1] = ACTIONS(1496),
    [aux_sym__argument_name_token2] = ACTIONS(1496),
    [anon_sym_POUND_LBRACK] = ACTIONS(1494),
    [aux_sym_encapsed_string_token1] = ACTIONS(1494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [aux_sym_string_token1] = ACTIONS(1494),
    [anon_sym_SQUOTE] = ACTIONS(1494),
    [anon_sym_LT_LT_LT] = ACTIONS(1494),
    [anon_sym_BQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1494),
    [aux_sym_yield_expression_token1] = ACTIONS(1496),
    [aux_sym_include_expression_token1] = ACTIONS(1496),
    [aux_sym_include_once_expression_token1] = ACTIONS(1496),
    [aux_sym_require_expression_token1] = ACTIONS(1496),
    [aux_sym_require_once_expression_token1] = ACTIONS(1496),
    [sym_comment] = ACTIONS(3),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1498),
    [sym_name] = ACTIONS(1500),
    [anon_sym_QMARK_GT] = ACTIONS(1498),
    [anon_sym_SEMI] = ACTIONS(1498),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1500),
    [aux_sym_global_declaration_token1] = ACTIONS(1500),
    [aux_sym_namespace_definition_token1] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1500),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1500),
    [anon_sym_BSLASH] = ACTIONS(1498),
    [anon_sym_LBRACE] = ACTIONS(1498),
    [anon_sym_RBRACE] = ACTIONS(1498),
    [aux_sym_trait_declaration_token1] = ACTIONS(1500),
    [aux_sym_interface_declaration_token1] = ACTIONS(1500),
    [aux_sym_enum_declaration_token1] = ACTIONS(1500),
    [aux_sym_enum_case_token1] = ACTIONS(1500),
    [aux_sym_class_declaration_token1] = ACTIONS(1500),
    [aux_sym_final_modifier_token1] = ACTIONS(1500),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1500),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1500),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1500),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1500),
    [anon_sym_LPAREN] = ACTIONS(1498),
    [aux_sym_cast_type_token1] = ACTIONS(1500),
    [aux_sym_echo_statement_token1] = ACTIONS(1500),
    [anon_sym_unset] = ACTIONS(1500),
    [aux_sym_declare_statement_token1] = ACTIONS(1500),
    [aux_sym_declare_statement_token2] = ACTIONS(1500),
    [sym_float] = ACTIONS(1500),
    [aux_sym_try_statement_token1] = ACTIONS(1500),
    [aux_sym_goto_statement_token1] = ACTIONS(1500),
    [aux_sym_continue_statement_token1] = ACTIONS(1500),
    [aux_sym_break_statement_token1] = ACTIONS(1500),
    [sym_integer] = ACTIONS(1500),
    [aux_sym_return_statement_token1] = ACTIONS(1500),
    [aux_sym_throw_expression_token1] = ACTIONS(1500),
    [aux_sym_while_statement_token1] = ACTIONS(1500),
    [aux_sym_while_statement_token2] = ACTIONS(1500),
    [aux_sym_do_statement_token1] = ACTIONS(1500),
    [aux_sym_for_statement_token1] = ACTIONS(1500),
    [aux_sym_for_statement_token2] = ACTIONS(1500),
    [aux_sym_foreach_statement_token1] = ACTIONS(1500),
    [aux_sym_foreach_statement_token2] = ACTIONS(1500),
    [aux_sym_if_statement_token1] = ACTIONS(1500),
    [aux_sym_if_statement_token2] = ACTIONS(1500),
    [aux_sym_else_if_clause_token1] = ACTIONS(1500),
    [aux_sym_else_clause_token1] = ACTIONS(1500),
    [aux_sym_match_expression_token1] = ACTIONS(1500),
    [aux_sym_match_default_expression_token1] = ACTIONS(1500),
    [aux_sym_switch_statement_token1] = ACTIONS(1500),
    [aux_sym_switch_block_token1] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_TILDE] = ACTIONS(1498),
    [anon_sym_BANG] = ACTIONS(1498),
    [anon_sym_AT] = ACTIONS(1498),
    [aux_sym_clone_expression_token1] = ACTIONS(1500),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1500),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1500),
    [anon_sym_DASH_DASH] = ACTIONS(1498),
    [anon_sym_PLUS_PLUS] = ACTIONS(1498),
    [aux_sym__list_destructing_token1] = ACTIONS(1500),
    [anon_sym_LBRACK] = ACTIONS(1498),
    [anon_sym_self] = ACTIONS(1500),
    [anon_sym_parent] = ACTIONS(1500),
    [aux_sym__argument_name_token1] = ACTIONS(1500),
    [aux_sym__argument_name_token2] = ACTIONS(1500),
    [anon_sym_POUND_LBRACK] = ACTIONS(1498),
    [aux_sym_encapsed_string_token1] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1498),
    [aux_sym_string_token1] = ACTIONS(1498),
    [anon_sym_SQUOTE] = ACTIONS(1498),
    [anon_sym_LT_LT_LT] = ACTIONS(1498),
    [anon_sym_BQUOTE] = ACTIONS(1498),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [aux_sym_yield_expression_token1] = ACTIONS(1500),
    [aux_sym_include_expression_token1] = ACTIONS(1500),
    [aux_sym_include_once_expression_token1] = ACTIONS(1500),
    [aux_sym_require_expression_token1] = ACTIONS(1500),
    [aux_sym_require_once_expression_token1] = ACTIONS(1500),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(1502),
    [sym_name] = ACTIONS(1504),
    [anon_sym_QMARK_GT] = ACTIONS(1502),
    [anon_sym_SEMI] = ACTIONS(1502),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1504),
    [aux_sym_global_declaration_token1] = ACTIONS(1504),
    [aux_sym_namespace_definition_token1] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1504),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1504),
    [anon_sym_BSLASH] = ACTIONS(1502),
    [anon_sym_LBRACE] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1502),
    [aux_sym_trait_declaration_token1] = ACTIONS(1504),
    [aux_sym_interface_declaration_token1] = ACTIONS(1504),
    [aux_sym_enum_declaration_token1] = ACTIONS(1504),
    [aux_sym_enum_case_token1] = ACTIONS(1504),
    [aux_sym_class_declaration_token1] = ACTIONS(1504),
    [aux_sym_final_modifier_token1] = ACTIONS(1504),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1504),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1504),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1504),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1504),
    [anon_sym_LPAREN] = ACTIONS(1502),
    [aux_sym_cast_type_token1] = ACTIONS(1504),
    [aux_sym_echo_statement_token1] = ACTIONS(1504),
    [anon_sym_unset] = ACTIONS(1504),
    [aux_sym_declare_statement_token1] = ACTIONS(1504),
    [aux_sym_declare_statement_token2] = ACTIONS(1504),
    [sym_float] = ACTIONS(1504),
    [aux_sym_try_statement_token1] = ACTIONS(1504),
    [aux_sym_goto_statement_token1] = ACTIONS(1504),
    [aux_sym_continue_statement_token1] = ACTIONS(1504),
    [aux_sym_break_statement_token1] = ACTIONS(1504),
    [sym_integer] = ACTIONS(1504),
    [aux_sym_return_statement_token1] = ACTIONS(1504),
    [aux_sym_throw_expression_token1] = ACTIONS(1504),
    [aux_sym_while_statement_token1] = ACTIONS(1504),
    [aux_sym_while_statement_token2] = ACTIONS(1504),
    [aux_sym_do_statement_token1] = ACTIONS(1504),
    [aux_sym_for_statement_token1] = ACTIONS(1504),
    [aux_sym_for_statement_token2] = ACTIONS(1504),
    [aux_sym_foreach_statement_token1] = ACTIONS(1504),
    [aux_sym_foreach_statement_token2] = ACTIONS(1504),
    [aux_sym_if_statement_token1] = ACTIONS(1504),
    [aux_sym_if_statement_token2] = ACTIONS(1504),
    [aux_sym_else_if_clause_token1] = ACTIONS(1504),
    [aux_sym_else_clause_token1] = ACTIONS(1504),
    [aux_sym_match_expression_token1] = ACTIONS(1504),
    [aux_sym_match_default_expression_token1] = ACTIONS(1504),
    [aux_sym_switch_statement_token1] = ACTIONS(1504),
    [aux_sym_switch_block_token1] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_BANG] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1502),
    [aux_sym_clone_expression_token1] = ACTIONS(1504),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1504),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1504),
    [anon_sym_DASH_DASH] = ACTIONS(1502),
    [anon_sym_PLUS_PLUS] = ACTIONS(1502),
    [aux_sym__list_destructing_token1] = ACTIONS(1504),
    [anon_sym_LBRACK] = ACTIONS(1502),
    [anon_sym_self] = ACTIONS(1504),
    [anon_sym_parent] = ACTIONS(1504),
    [aux_sym__argument_name_token1] = ACTIONS(1504),
    [aux_sym__argument_name_token2] = ACTIONS(1504),
    [anon_sym_POUND_LBRACK] = ACTIONS(1502),
    [aux_sym_encapsed_string_token1] = ACTIONS(1502),
    [anon_sym_DQUOTE] = ACTIONS(1502),
    [aux_sym_string_token1] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(1502),
    [anon_sym_LT_LT_LT] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1502),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [aux_sym_yield_expression_token1] = ACTIONS(1504),
    [aux_sym_include_expression_token1] = ACTIONS(1504),
    [aux_sym_include_once_expression_token1] = ACTIONS(1504),
    [aux_sym_require_expression_token1] = ACTIONS(1504),
    [aux_sym_require_once_expression_token1] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1506),
    [sym_name] = ACTIONS(1508),
    [anon_sym_QMARK_GT] = ACTIONS(1506),
    [anon_sym_SEMI] = ACTIONS(1506),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1508),
    [aux_sym_global_declaration_token1] = ACTIONS(1508),
    [aux_sym_namespace_definition_token1] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1508),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1508),
    [anon_sym_BSLASH] = ACTIONS(1506),
    [anon_sym_LBRACE] = ACTIONS(1506),
    [anon_sym_RBRACE] = ACTIONS(1506),
    [aux_sym_trait_declaration_token1] = ACTIONS(1508),
    [aux_sym_interface_declaration_token1] = ACTIONS(1508),
    [aux_sym_enum_declaration_token1] = ACTIONS(1508),
    [aux_sym_enum_case_token1] = ACTIONS(1508),
    [aux_sym_class_declaration_token1] = ACTIONS(1508),
    [aux_sym_final_modifier_token1] = ACTIONS(1508),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1508),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1508),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1508),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1506),
    [aux_sym_cast_type_token1] = ACTIONS(1508),
    [aux_sym_echo_statement_token1] = ACTIONS(1508),
    [anon_sym_unset] = ACTIONS(1508),
    [aux_sym_declare_statement_token1] = ACTIONS(1508),
    [aux_sym_declare_statement_token2] = ACTIONS(1508),
    [sym_float] = ACTIONS(1508),
    [aux_sym_try_statement_token1] = ACTIONS(1508),
    [aux_sym_goto_statement_token1] = ACTIONS(1508),
    [aux_sym_continue_statement_token1] = ACTIONS(1508),
    [aux_sym_break_statement_token1] = ACTIONS(1508),
    [sym_integer] = ACTIONS(1508),
    [aux_sym_return_statement_token1] = ACTIONS(1508),
    [aux_sym_throw_expression_token1] = ACTIONS(1508),
    [aux_sym_while_statement_token1] = ACTIONS(1508),
    [aux_sym_while_statement_token2] = ACTIONS(1508),
    [aux_sym_do_statement_token1] = ACTIONS(1508),
    [aux_sym_for_statement_token1] = ACTIONS(1508),
    [aux_sym_for_statement_token2] = ACTIONS(1508),
    [aux_sym_foreach_statement_token1] = ACTIONS(1508),
    [aux_sym_foreach_statement_token2] = ACTIONS(1508),
    [aux_sym_if_statement_token1] = ACTIONS(1508),
    [aux_sym_if_statement_token2] = ACTIONS(1508),
    [aux_sym_else_if_clause_token1] = ACTIONS(1508),
    [aux_sym_else_clause_token1] = ACTIONS(1508),
    [aux_sym_match_expression_token1] = ACTIONS(1508),
    [aux_sym_match_default_expression_token1] = ACTIONS(1508),
    [aux_sym_switch_statement_token1] = ACTIONS(1508),
    [aux_sym_switch_block_token1] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1508),
    [anon_sym_DASH] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1506),
    [anon_sym_BANG] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(1506),
    [aux_sym_clone_expression_token1] = ACTIONS(1508),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1508),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1508),
    [anon_sym_DASH_DASH] = ACTIONS(1506),
    [anon_sym_PLUS_PLUS] = ACTIONS(1506),
    [aux_sym__list_destructing_token1] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1506),
    [anon_sym_self] = ACTIONS(1508),
    [anon_sym_parent] = ACTIONS(1508),
    [aux_sym__argument_name_token1] = ACTIONS(1508),
    [aux_sym__argument_name_token2] = ACTIONS(1508),
    [anon_sym_POUND_LBRACK] = ACTIONS(1506),
    [aux_sym_encapsed_string_token1] = ACTIONS(1506),
    [anon_sym_DQUOTE] = ACTIONS(1506),
    [aux_sym_string_token1] = ACTIONS(1506),
    [anon_sym_SQUOTE] = ACTIONS(1506),
    [anon_sym_LT_LT_LT] = ACTIONS(1506),
    [anon_sym_BQUOTE] = ACTIONS(1506),
    [anon_sym_DOLLAR] = ACTIONS(1506),
    [aux_sym_yield_expression_token1] = ACTIONS(1508),
    [aux_sym_include_expression_token1] = ACTIONS(1508),
    [aux_sym_include_once_expression_token1] = ACTIONS(1508),
    [aux_sym_require_expression_token1] = ACTIONS(1508),
    [aux_sym_require_once_expression_token1] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [sym_name] = ACTIONS(1512),
    [anon_sym_QMARK_GT] = ACTIONS(1510),
    [anon_sym_SEMI] = ACTIONS(1510),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1512),
    [aux_sym_global_declaration_token1] = ACTIONS(1512),
    [aux_sym_namespace_definition_token1] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1512),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1512),
    [anon_sym_BSLASH] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [aux_sym_trait_declaration_token1] = ACTIONS(1512),
    [aux_sym_interface_declaration_token1] = ACTIONS(1512),
    [aux_sym_enum_declaration_token1] = ACTIONS(1512),
    [aux_sym_enum_case_token1] = ACTIONS(1512),
    [aux_sym_class_declaration_token1] = ACTIONS(1512),
    [aux_sym_final_modifier_token1] = ACTIONS(1512),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1512),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1512),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1512),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1512),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [aux_sym_cast_type_token1] = ACTIONS(1512),
    [aux_sym_echo_statement_token1] = ACTIONS(1512),
    [anon_sym_unset] = ACTIONS(1512),
    [aux_sym_declare_statement_token1] = ACTIONS(1512),
    [aux_sym_declare_statement_token2] = ACTIONS(1512),
    [sym_float] = ACTIONS(1512),
    [aux_sym_try_statement_token1] = ACTIONS(1512),
    [aux_sym_goto_statement_token1] = ACTIONS(1512),
    [aux_sym_continue_statement_token1] = ACTIONS(1512),
    [aux_sym_break_statement_token1] = ACTIONS(1512),
    [sym_integer] = ACTIONS(1512),
    [aux_sym_return_statement_token1] = ACTIONS(1512),
    [aux_sym_throw_expression_token1] = ACTIONS(1512),
    [aux_sym_while_statement_token1] = ACTIONS(1512),
    [aux_sym_while_statement_token2] = ACTIONS(1512),
    [aux_sym_do_statement_token1] = ACTIONS(1512),
    [aux_sym_for_statement_token1] = ACTIONS(1512),
    [aux_sym_for_statement_token2] = ACTIONS(1512),
    [aux_sym_foreach_statement_token1] = ACTIONS(1512),
    [aux_sym_foreach_statement_token2] = ACTIONS(1512),
    [aux_sym_if_statement_token1] = ACTIONS(1512),
    [aux_sym_if_statement_token2] = ACTIONS(1512),
    [aux_sym_else_if_clause_token1] = ACTIONS(1512),
    [aux_sym_else_clause_token1] = ACTIONS(1512),
    [aux_sym_match_expression_token1] = ACTIONS(1512),
    [aux_sym_match_default_expression_token1] = ACTIONS(1512),
    [aux_sym_switch_statement_token1] = ACTIONS(1512),
    [aux_sym_switch_block_token1] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [aux_sym_clone_expression_token1] = ACTIONS(1512),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1512),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1512),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [aux_sym__list_destructing_token1] = ACTIONS(1512),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_self] = ACTIONS(1512),
    [anon_sym_parent] = ACTIONS(1512),
    [aux_sym__argument_name_token1] = ACTIONS(1512),
    [aux_sym__argument_name_token2] = ACTIONS(1512),
    [anon_sym_POUND_LBRACK] = ACTIONS(1510),
    [aux_sym_encapsed_string_token1] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [aux_sym_string_token1] = ACTIONS(1510),
    [anon_sym_SQUOTE] = ACTIONS(1510),
    [anon_sym_LT_LT_LT] = ACTIONS(1510),
    [anon_sym_BQUOTE] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1510),
    [aux_sym_yield_expression_token1] = ACTIONS(1512),
    [aux_sym_include_expression_token1] = ACTIONS(1512),
    [aux_sym_include_once_expression_token1] = ACTIONS(1512),
    [aux_sym_require_expression_token1] = ACTIONS(1512),
    [aux_sym_require_once_expression_token1] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1514),
    [sym_name] = ACTIONS(1516),
    [anon_sym_QMARK_GT] = ACTIONS(1514),
    [anon_sym_SEMI] = ACTIONS(1514),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1516),
    [aux_sym_global_declaration_token1] = ACTIONS(1516),
    [aux_sym_namespace_definition_token1] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1516),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1516),
    [anon_sym_BSLASH] = ACTIONS(1514),
    [anon_sym_LBRACE] = ACTIONS(1514),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [aux_sym_trait_declaration_token1] = ACTIONS(1516),
    [aux_sym_interface_declaration_token1] = ACTIONS(1516),
    [aux_sym_enum_declaration_token1] = ACTIONS(1516),
    [aux_sym_enum_case_token1] = ACTIONS(1516),
    [aux_sym_class_declaration_token1] = ACTIONS(1516),
    [aux_sym_final_modifier_token1] = ACTIONS(1516),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1516),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1516),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1516),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1514),
    [aux_sym_cast_type_token1] = ACTIONS(1516),
    [aux_sym_echo_statement_token1] = ACTIONS(1516),
    [anon_sym_unset] = ACTIONS(1516),
    [aux_sym_declare_statement_token1] = ACTIONS(1516),
    [aux_sym_declare_statement_token2] = ACTIONS(1516),
    [sym_float] = ACTIONS(1516),
    [aux_sym_try_statement_token1] = ACTIONS(1516),
    [aux_sym_goto_statement_token1] = ACTIONS(1516),
    [aux_sym_continue_statement_token1] = ACTIONS(1516),
    [aux_sym_break_statement_token1] = ACTIONS(1516),
    [sym_integer] = ACTIONS(1516),
    [aux_sym_return_statement_token1] = ACTIONS(1516),
    [aux_sym_throw_expression_token1] = ACTIONS(1516),
    [aux_sym_while_statement_token1] = ACTIONS(1516),
    [aux_sym_while_statement_token2] = ACTIONS(1516),
    [aux_sym_do_statement_token1] = ACTIONS(1516),
    [aux_sym_for_statement_token1] = ACTIONS(1516),
    [aux_sym_for_statement_token2] = ACTIONS(1516),
    [aux_sym_foreach_statement_token1] = ACTIONS(1516),
    [aux_sym_foreach_statement_token2] = ACTIONS(1516),
    [aux_sym_if_statement_token1] = ACTIONS(1516),
    [aux_sym_if_statement_token2] = ACTIONS(1516),
    [aux_sym_else_if_clause_token1] = ACTIONS(1516),
    [aux_sym_else_clause_token1] = ACTIONS(1516),
    [aux_sym_match_expression_token1] = ACTIONS(1516),
    [aux_sym_match_default_expression_token1] = ACTIONS(1516),
    [aux_sym_switch_statement_token1] = ACTIONS(1516),
    [aux_sym_switch_block_token1] = ACTIONS(1516),
    [anon_sym_PLUS] = ACTIONS(1516),
    [anon_sym_DASH] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1514),
    [anon_sym_BANG] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(1514),
    [aux_sym_clone_expression_token1] = ACTIONS(1516),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1516),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1516),
    [anon_sym_DASH_DASH] = ACTIONS(1514),
    [anon_sym_PLUS_PLUS] = ACTIONS(1514),
    [aux_sym__list_destructing_token1] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1514),
    [anon_sym_self] = ACTIONS(1516),
    [anon_sym_parent] = ACTIONS(1516),
    [aux_sym__argument_name_token1] = ACTIONS(1516),
    [aux_sym__argument_name_token2] = ACTIONS(1516),
    [anon_sym_POUND_LBRACK] = ACTIONS(1514),
    [aux_sym_encapsed_string_token1] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(1514),
    [aux_sym_string_token1] = ACTIONS(1514),
    [anon_sym_SQUOTE] = ACTIONS(1514),
    [anon_sym_LT_LT_LT] = ACTIONS(1514),
    [anon_sym_BQUOTE] = ACTIONS(1514),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [aux_sym_yield_expression_token1] = ACTIONS(1516),
    [aux_sym_include_expression_token1] = ACTIONS(1516),
    [aux_sym_include_once_expression_token1] = ACTIONS(1516),
    [aux_sym_require_expression_token1] = ACTIONS(1516),
    [aux_sym_require_once_expression_token1] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1290),
    [sym_name] = ACTIONS(1292),
    [anon_sym_QMARK_GT] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1292),
    [aux_sym_global_declaration_token1] = ACTIONS(1292),
    [aux_sym_namespace_definition_token1] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1292),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1292),
    [anon_sym_BSLASH] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [aux_sym_trait_declaration_token1] = ACTIONS(1292),
    [aux_sym_interface_declaration_token1] = ACTIONS(1292),
    [aux_sym_enum_declaration_token1] = ACTIONS(1292),
    [aux_sym_enum_case_token1] = ACTIONS(1292),
    [aux_sym_class_declaration_token1] = ACTIONS(1292),
    [aux_sym_final_modifier_token1] = ACTIONS(1292),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1292),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1292),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1292),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [aux_sym_cast_type_token1] = ACTIONS(1292),
    [aux_sym_echo_statement_token1] = ACTIONS(1292),
    [anon_sym_unset] = ACTIONS(1292),
    [aux_sym_declare_statement_token1] = ACTIONS(1292),
    [aux_sym_declare_statement_token2] = ACTIONS(1292),
    [sym_float] = ACTIONS(1292),
    [aux_sym_try_statement_token1] = ACTIONS(1292),
    [aux_sym_goto_statement_token1] = ACTIONS(1292),
    [aux_sym_continue_statement_token1] = ACTIONS(1292),
    [aux_sym_break_statement_token1] = ACTIONS(1292),
    [sym_integer] = ACTIONS(1292),
    [aux_sym_return_statement_token1] = ACTIONS(1292),
    [aux_sym_throw_expression_token1] = ACTIONS(1292),
    [aux_sym_while_statement_token1] = ACTIONS(1292),
    [aux_sym_while_statement_token2] = ACTIONS(1292),
    [aux_sym_do_statement_token1] = ACTIONS(1292),
    [aux_sym_for_statement_token1] = ACTIONS(1292),
    [aux_sym_for_statement_token2] = ACTIONS(1292),
    [aux_sym_foreach_statement_token1] = ACTIONS(1292),
    [aux_sym_foreach_statement_token2] = ACTIONS(1292),
    [aux_sym_if_statement_token1] = ACTIONS(1292),
    [aux_sym_if_statement_token2] = ACTIONS(1292),
    [aux_sym_else_if_clause_token1] = ACTIONS(1292),
    [aux_sym_else_clause_token1] = ACTIONS(1292),
    [aux_sym_match_expression_token1] = ACTIONS(1292),
    [aux_sym_match_default_expression_token1] = ACTIONS(1292),
    [aux_sym_switch_statement_token1] = ACTIONS(1292),
    [aux_sym_switch_block_token1] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(1290),
    [aux_sym_clone_expression_token1] = ACTIONS(1292),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1292),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [aux_sym__list_destructing_token1] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_self] = ACTIONS(1292),
    [anon_sym_parent] = ACTIONS(1292),
    [aux_sym__argument_name_token1] = ACTIONS(1292),
    [aux_sym__argument_name_token2] = ACTIONS(1292),
    [anon_sym_POUND_LBRACK] = ACTIONS(1290),
    [aux_sym_encapsed_string_token1] = ACTIONS(1290),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [aux_sym_string_token1] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(1290),
    [anon_sym_LT_LT_LT] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_DOLLAR] = ACTIONS(1290),
    [aux_sym_yield_expression_token1] = ACTIONS(1292),
    [aux_sym_include_expression_token1] = ACTIONS(1292),
    [aux_sym_include_once_expression_token1] = ACTIONS(1292),
    [aux_sym_require_expression_token1] = ACTIONS(1292),
    [aux_sym_require_once_expression_token1] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1518),
    [sym_name] = ACTIONS(1520),
    [anon_sym_QMARK_GT] = ACTIONS(1518),
    [anon_sym_SEMI] = ACTIONS(1518),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1520),
    [aux_sym_global_declaration_token1] = ACTIONS(1520),
    [aux_sym_namespace_definition_token1] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1520),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1520),
    [anon_sym_BSLASH] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [aux_sym_trait_declaration_token1] = ACTIONS(1520),
    [aux_sym_interface_declaration_token1] = ACTIONS(1520),
    [aux_sym_enum_declaration_token1] = ACTIONS(1520),
    [aux_sym_enum_case_token1] = ACTIONS(1520),
    [aux_sym_class_declaration_token1] = ACTIONS(1520),
    [aux_sym_final_modifier_token1] = ACTIONS(1520),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1520),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1520),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1520),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [aux_sym_cast_type_token1] = ACTIONS(1520),
    [aux_sym_echo_statement_token1] = ACTIONS(1520),
    [anon_sym_unset] = ACTIONS(1520),
    [aux_sym_declare_statement_token1] = ACTIONS(1520),
    [aux_sym_declare_statement_token2] = ACTIONS(1520),
    [sym_float] = ACTIONS(1520),
    [aux_sym_try_statement_token1] = ACTIONS(1520),
    [aux_sym_goto_statement_token1] = ACTIONS(1520),
    [aux_sym_continue_statement_token1] = ACTIONS(1520),
    [aux_sym_break_statement_token1] = ACTIONS(1520),
    [sym_integer] = ACTIONS(1520),
    [aux_sym_return_statement_token1] = ACTIONS(1520),
    [aux_sym_throw_expression_token1] = ACTIONS(1520),
    [aux_sym_while_statement_token1] = ACTIONS(1520),
    [aux_sym_while_statement_token2] = ACTIONS(1520),
    [aux_sym_do_statement_token1] = ACTIONS(1520),
    [aux_sym_for_statement_token1] = ACTIONS(1520),
    [aux_sym_for_statement_token2] = ACTIONS(1520),
    [aux_sym_foreach_statement_token1] = ACTIONS(1520),
    [aux_sym_foreach_statement_token2] = ACTIONS(1520),
    [aux_sym_if_statement_token1] = ACTIONS(1520),
    [aux_sym_if_statement_token2] = ACTIONS(1520),
    [aux_sym_else_if_clause_token1] = ACTIONS(1520),
    [aux_sym_else_clause_token1] = ACTIONS(1520),
    [aux_sym_match_expression_token1] = ACTIONS(1520),
    [aux_sym_match_default_expression_token1] = ACTIONS(1520),
    [aux_sym_switch_statement_token1] = ACTIONS(1520),
    [aux_sym_switch_block_token1] = ACTIONS(1520),
    [anon_sym_PLUS] = ACTIONS(1520),
    [anon_sym_DASH] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_BANG] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1518),
    [aux_sym_clone_expression_token1] = ACTIONS(1520),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1520),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1520),
    [anon_sym_DASH_DASH] = ACTIONS(1518),
    [anon_sym_PLUS_PLUS] = ACTIONS(1518),
    [aux_sym__list_destructing_token1] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_self] = ACTIONS(1520),
    [anon_sym_parent] = ACTIONS(1520),
    [aux_sym__argument_name_token1] = ACTIONS(1520),
    [aux_sym__argument_name_token2] = ACTIONS(1520),
    [anon_sym_POUND_LBRACK] = ACTIONS(1518),
    [aux_sym_encapsed_string_token1] = ACTIONS(1518),
    [anon_sym_DQUOTE] = ACTIONS(1518),
    [aux_sym_string_token1] = ACTIONS(1518),
    [anon_sym_SQUOTE] = ACTIONS(1518),
    [anon_sym_LT_LT_LT] = ACTIONS(1518),
    [anon_sym_BQUOTE] = ACTIONS(1518),
    [anon_sym_DOLLAR] = ACTIONS(1518),
    [aux_sym_yield_expression_token1] = ACTIONS(1520),
    [aux_sym_include_expression_token1] = ACTIONS(1520),
    [aux_sym_include_once_expression_token1] = ACTIONS(1520),
    [aux_sym_require_expression_token1] = ACTIONS(1520),
    [aux_sym_require_once_expression_token1] = ACTIONS(1520),
    [sym_comment] = ACTIONS(3),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_name] = ACTIONS(1524),
    [anon_sym_QMARK_GT] = ACTIONS(1522),
    [anon_sym_SEMI] = ACTIONS(1522),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1524),
    [aux_sym_global_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_definition_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1524),
    [anon_sym_BSLASH] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [aux_sym_trait_declaration_token1] = ACTIONS(1524),
    [aux_sym_interface_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_case_token1] = ACTIONS(1524),
    [aux_sym_class_declaration_token1] = ACTIONS(1524),
    [aux_sym_final_modifier_token1] = ACTIONS(1524),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1524),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1524),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [aux_sym_cast_type_token1] = ACTIONS(1524),
    [aux_sym_echo_statement_token1] = ACTIONS(1524),
    [anon_sym_unset] = ACTIONS(1524),
    [aux_sym_declare_statement_token1] = ACTIONS(1524),
    [aux_sym_declare_statement_token2] = ACTIONS(1524),
    [sym_float] = ACTIONS(1524),
    [aux_sym_try_statement_token1] = ACTIONS(1524),
    [aux_sym_goto_statement_token1] = ACTIONS(1524),
    [aux_sym_continue_statement_token1] = ACTIONS(1524),
    [aux_sym_break_statement_token1] = ACTIONS(1524),
    [sym_integer] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1524),
    [aux_sym_throw_expression_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token2] = ACTIONS(1524),
    [aux_sym_do_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token2] = ACTIONS(1524),
    [aux_sym_foreach_statement_token1] = ACTIONS(1524),
    [aux_sym_foreach_statement_token2] = ACTIONS(1524),
    [aux_sym_if_statement_token1] = ACTIONS(1524),
    [aux_sym_if_statement_token2] = ACTIONS(1524),
    [aux_sym_else_if_clause_token1] = ACTIONS(1524),
    [aux_sym_else_clause_token1] = ACTIONS(1524),
    [aux_sym_match_expression_token1] = ACTIONS(1524),
    [aux_sym_match_default_expression_token1] = ACTIONS(1524),
    [aux_sym_switch_statement_token1] = ACTIONS(1524),
    [aux_sym_switch_block_token1] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1522),
    [aux_sym_clone_expression_token1] = ACTIONS(1524),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1524),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1524),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [aux_sym__list_destructing_token1] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_self] = ACTIONS(1524),
    [anon_sym_parent] = ACTIONS(1524),
    [aux_sym__argument_name_token1] = ACTIONS(1524),
    [aux_sym__argument_name_token2] = ACTIONS(1524),
    [anon_sym_POUND_LBRACK] = ACTIONS(1522),
    [aux_sym_encapsed_string_token1] = ACTIONS(1522),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [aux_sym_string_token1] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(1522),
    [aux_sym_yield_expression_token1] = ACTIONS(1524),
    [aux_sym_include_expression_token1] = ACTIONS(1524),
    [aux_sym_include_once_expression_token1] = ACTIONS(1524),
    [aux_sym_require_expression_token1] = ACTIONS(1524),
    [aux_sym_require_once_expression_token1] = ACTIONS(1524),
    [sym_comment] = ACTIONS(3),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1526),
    [sym_name] = ACTIONS(1528),
    [anon_sym_QMARK_GT] = ACTIONS(1526),
    [anon_sym_SEMI] = ACTIONS(1526),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1528),
    [aux_sym_global_declaration_token1] = ACTIONS(1528),
    [aux_sym_namespace_definition_token1] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1528),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1528),
    [anon_sym_BSLASH] = ACTIONS(1526),
    [anon_sym_LBRACE] = ACTIONS(1526),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [aux_sym_trait_declaration_token1] = ACTIONS(1528),
    [aux_sym_interface_declaration_token1] = ACTIONS(1528),
    [aux_sym_enum_declaration_token1] = ACTIONS(1528),
    [aux_sym_enum_case_token1] = ACTIONS(1528),
    [aux_sym_class_declaration_token1] = ACTIONS(1528),
    [aux_sym_final_modifier_token1] = ACTIONS(1528),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1528),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1528),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1528),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1526),
    [aux_sym_cast_type_token1] = ACTIONS(1528),
    [aux_sym_echo_statement_token1] = ACTIONS(1528),
    [anon_sym_unset] = ACTIONS(1528),
    [aux_sym_declare_statement_token1] = ACTIONS(1528),
    [aux_sym_declare_statement_token2] = ACTIONS(1528),
    [sym_float] = ACTIONS(1528),
    [aux_sym_try_statement_token1] = ACTIONS(1528),
    [aux_sym_goto_statement_token1] = ACTIONS(1528),
    [aux_sym_continue_statement_token1] = ACTIONS(1528),
    [aux_sym_break_statement_token1] = ACTIONS(1528),
    [sym_integer] = ACTIONS(1528),
    [aux_sym_return_statement_token1] = ACTIONS(1528),
    [aux_sym_throw_expression_token1] = ACTIONS(1528),
    [aux_sym_while_statement_token1] = ACTIONS(1528),
    [aux_sym_while_statement_token2] = ACTIONS(1528),
    [aux_sym_do_statement_token1] = ACTIONS(1528),
    [aux_sym_for_statement_token1] = ACTIONS(1528),
    [aux_sym_for_statement_token2] = ACTIONS(1528),
    [aux_sym_foreach_statement_token1] = ACTIONS(1528),
    [aux_sym_foreach_statement_token2] = ACTIONS(1528),
    [aux_sym_if_statement_token1] = ACTIONS(1528),
    [aux_sym_if_statement_token2] = ACTIONS(1528),
    [aux_sym_else_if_clause_token1] = ACTIONS(1528),
    [aux_sym_else_clause_token1] = ACTIONS(1528),
    [aux_sym_match_expression_token1] = ACTIONS(1528),
    [aux_sym_match_default_expression_token1] = ACTIONS(1528),
    [aux_sym_switch_statement_token1] = ACTIONS(1528),
    [aux_sym_switch_block_token1] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_TILDE] = ACTIONS(1526),
    [anon_sym_BANG] = ACTIONS(1526),
    [anon_sym_AT] = ACTIONS(1526),
    [aux_sym_clone_expression_token1] = ACTIONS(1528),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1528),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1528),
    [anon_sym_DASH_DASH] = ACTIONS(1526),
    [anon_sym_PLUS_PLUS] = ACTIONS(1526),
    [aux_sym__list_destructing_token1] = ACTIONS(1528),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_self] = ACTIONS(1528),
    [anon_sym_parent] = ACTIONS(1528),
    [aux_sym__argument_name_token1] = ACTIONS(1528),
    [aux_sym__argument_name_token2] = ACTIONS(1528),
    [anon_sym_POUND_LBRACK] = ACTIONS(1526),
    [aux_sym_encapsed_string_token1] = ACTIONS(1526),
    [anon_sym_DQUOTE] = ACTIONS(1526),
    [aux_sym_string_token1] = ACTIONS(1526),
    [anon_sym_SQUOTE] = ACTIONS(1526),
    [anon_sym_LT_LT_LT] = ACTIONS(1526),
    [anon_sym_BQUOTE] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(1526),
    [aux_sym_yield_expression_token1] = ACTIONS(1528),
    [aux_sym_include_expression_token1] = ACTIONS(1528),
    [aux_sym_include_once_expression_token1] = ACTIONS(1528),
    [aux_sym_require_expression_token1] = ACTIONS(1528),
    [aux_sym_require_once_expression_token1] = ACTIONS(1528),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_name] = ACTIONS(1524),
    [anon_sym_QMARK_GT] = ACTIONS(1522),
    [anon_sym_SEMI] = ACTIONS(1522),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1524),
    [aux_sym_global_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_definition_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1524),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1524),
    [anon_sym_BSLASH] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_RBRACE] = ACTIONS(1522),
    [aux_sym_trait_declaration_token1] = ACTIONS(1524),
    [aux_sym_interface_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_declaration_token1] = ACTIONS(1524),
    [aux_sym_enum_case_token1] = ACTIONS(1524),
    [aux_sym_class_declaration_token1] = ACTIONS(1524),
    [aux_sym_final_modifier_token1] = ACTIONS(1524),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1524),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1524),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1524),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [aux_sym_cast_type_token1] = ACTIONS(1524),
    [aux_sym_echo_statement_token1] = ACTIONS(1524),
    [anon_sym_unset] = ACTIONS(1524),
    [aux_sym_declare_statement_token1] = ACTIONS(1524),
    [aux_sym_declare_statement_token2] = ACTIONS(1524),
    [sym_float] = ACTIONS(1524),
    [aux_sym_try_statement_token1] = ACTIONS(1524),
    [aux_sym_goto_statement_token1] = ACTIONS(1524),
    [aux_sym_continue_statement_token1] = ACTIONS(1524),
    [aux_sym_break_statement_token1] = ACTIONS(1524),
    [sym_integer] = ACTIONS(1524),
    [aux_sym_return_statement_token1] = ACTIONS(1524),
    [aux_sym_throw_expression_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token1] = ACTIONS(1524),
    [aux_sym_while_statement_token2] = ACTIONS(1524),
    [aux_sym_do_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token1] = ACTIONS(1524),
    [aux_sym_for_statement_token2] = ACTIONS(1524),
    [aux_sym_foreach_statement_token1] = ACTIONS(1524),
    [aux_sym_foreach_statement_token2] = ACTIONS(1524),
    [aux_sym_if_statement_token1] = ACTIONS(1524),
    [aux_sym_if_statement_token2] = ACTIONS(1524),
    [aux_sym_else_if_clause_token1] = ACTIONS(1524),
    [aux_sym_else_clause_token1] = ACTIONS(1524),
    [aux_sym_match_expression_token1] = ACTIONS(1524),
    [aux_sym_match_default_expression_token1] = ACTIONS(1524),
    [aux_sym_switch_statement_token1] = ACTIONS(1524),
    [aux_sym_switch_block_token1] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1522),
    [aux_sym_clone_expression_token1] = ACTIONS(1524),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1524),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1524),
    [anon_sym_DASH_DASH] = ACTIONS(1522),
    [anon_sym_PLUS_PLUS] = ACTIONS(1522),
    [aux_sym__list_destructing_token1] = ACTIONS(1524),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_self] = ACTIONS(1524),
    [anon_sym_parent] = ACTIONS(1524),
    [aux_sym__argument_name_token1] = ACTIONS(1524),
    [aux_sym__argument_name_token2] = ACTIONS(1524),
    [anon_sym_POUND_LBRACK] = ACTIONS(1522),
    [aux_sym_encapsed_string_token1] = ACTIONS(1522),
    [anon_sym_DQUOTE] = ACTIONS(1522),
    [aux_sym_string_token1] = ACTIONS(1522),
    [anon_sym_SQUOTE] = ACTIONS(1522),
    [anon_sym_LT_LT_LT] = ACTIONS(1522),
    [anon_sym_BQUOTE] = ACTIONS(1522),
    [anon_sym_DOLLAR] = ACTIONS(1522),
    [aux_sym_yield_expression_token1] = ACTIONS(1524),
    [aux_sym_include_expression_token1] = ACTIONS(1524),
    [aux_sym_include_once_expression_token1] = ACTIONS(1524),
    [aux_sym_require_expression_token1] = ACTIONS(1524),
    [aux_sym_require_once_expression_token1] = ACTIONS(1524),
    [sym_comment] = ACTIONS(3),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(1530),
    [sym_name] = ACTIONS(1532),
    [anon_sym_QMARK_GT] = ACTIONS(1530),
    [anon_sym_SEMI] = ACTIONS(1530),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1532),
    [aux_sym_global_declaration_token1] = ACTIONS(1532),
    [aux_sym_namespace_definition_token1] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1532),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1532),
    [anon_sym_BSLASH] = ACTIONS(1530),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [aux_sym_trait_declaration_token1] = ACTIONS(1532),
    [aux_sym_interface_declaration_token1] = ACTIONS(1532),
    [aux_sym_enum_declaration_token1] = ACTIONS(1532),
    [aux_sym_enum_case_token1] = ACTIONS(1532),
    [aux_sym_class_declaration_token1] = ACTIONS(1532),
    [aux_sym_final_modifier_token1] = ACTIONS(1532),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1532),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1532),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1532),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1530),
    [aux_sym_cast_type_token1] = ACTIONS(1532),
    [aux_sym_echo_statement_token1] = ACTIONS(1532),
    [anon_sym_unset] = ACTIONS(1532),
    [aux_sym_declare_statement_token1] = ACTIONS(1532),
    [aux_sym_declare_statement_token2] = ACTIONS(1532),
    [sym_float] = ACTIONS(1532),
    [aux_sym_try_statement_token1] = ACTIONS(1532),
    [aux_sym_goto_statement_token1] = ACTIONS(1532),
    [aux_sym_continue_statement_token1] = ACTIONS(1532),
    [aux_sym_break_statement_token1] = ACTIONS(1532),
    [sym_integer] = ACTIONS(1532),
    [aux_sym_return_statement_token1] = ACTIONS(1532),
    [aux_sym_throw_expression_token1] = ACTIONS(1532),
    [aux_sym_while_statement_token1] = ACTIONS(1532),
    [aux_sym_while_statement_token2] = ACTIONS(1532),
    [aux_sym_do_statement_token1] = ACTIONS(1532),
    [aux_sym_for_statement_token1] = ACTIONS(1532),
    [aux_sym_for_statement_token2] = ACTIONS(1532),
    [aux_sym_foreach_statement_token1] = ACTIONS(1532),
    [aux_sym_foreach_statement_token2] = ACTIONS(1532),
    [aux_sym_if_statement_token1] = ACTIONS(1532),
    [aux_sym_if_statement_token2] = ACTIONS(1532),
    [aux_sym_else_if_clause_token1] = ACTIONS(1532),
    [aux_sym_else_clause_token1] = ACTIONS(1532),
    [aux_sym_match_expression_token1] = ACTIONS(1532),
    [aux_sym_match_default_expression_token1] = ACTIONS(1532),
    [aux_sym_switch_statement_token1] = ACTIONS(1532),
    [aux_sym_switch_block_token1] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1530),
    [anon_sym_BANG] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1530),
    [aux_sym_clone_expression_token1] = ACTIONS(1532),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1532),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1532),
    [anon_sym_DASH_DASH] = ACTIONS(1530),
    [anon_sym_PLUS_PLUS] = ACTIONS(1530),
    [aux_sym__list_destructing_token1] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1530),
    [anon_sym_self] = ACTIONS(1532),
    [anon_sym_parent] = ACTIONS(1532),
    [aux_sym__argument_name_token1] = ACTIONS(1532),
    [aux_sym__argument_name_token2] = ACTIONS(1532),
    [anon_sym_POUND_LBRACK] = ACTIONS(1530),
    [aux_sym_encapsed_string_token1] = ACTIONS(1530),
    [anon_sym_DQUOTE] = ACTIONS(1530),
    [aux_sym_string_token1] = ACTIONS(1530),
    [anon_sym_SQUOTE] = ACTIONS(1530),
    [anon_sym_LT_LT_LT] = ACTIONS(1530),
    [anon_sym_BQUOTE] = ACTIONS(1530),
    [anon_sym_DOLLAR] = ACTIONS(1530),
    [aux_sym_yield_expression_token1] = ACTIONS(1532),
    [aux_sym_include_expression_token1] = ACTIONS(1532),
    [aux_sym_include_once_expression_token1] = ACTIONS(1532),
    [aux_sym_require_expression_token1] = ACTIONS(1532),
    [aux_sym_require_once_expression_token1] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(962),
    [sym_clone_expression] = STATE(962),
    [sym__primary_expression] = STATE(962),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(962),
    [sym_cast_variable] = STATE(595),
    [sym_member_access_expression] = STATE(595),
    [sym_nullsafe_member_access_expression] = STATE(595),
    [sym_scoped_property_access_expression] = STATE(595),
    [sym_function_call_expression] = STATE(576),
    [sym_scoped_call_expression] = STATE(576),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(576),
    [sym_nullsafe_member_call_expression] = STATE(576),
    [sym_subscript_expression] = STATE(576),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(576),
    [sym_variable_name] = STATE(576),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(665),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_BANG] = ACTIONS(673),
    [aux_sym_clone_expression_token1] = ACTIONS(677),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(687),
    [aux_sym_include_once_expression_token1] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
  },
  [562] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(962),
    [sym_clone_expression] = STATE(962),
    [sym__primary_expression] = STATE(962),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(962),
    [sym_cast_variable] = STATE(595),
    [sym_member_access_expression] = STATE(595),
    [sym_nullsafe_member_access_expression] = STATE(595),
    [sym_scoped_property_access_expression] = STATE(595),
    [sym_function_call_expression] = STATE(576),
    [sym_scoped_call_expression] = STATE(576),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(576),
    [sym_nullsafe_member_call_expression] = STATE(576),
    [sym_subscript_expression] = STATE(576),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(576),
    [sym_variable_name] = STATE(576),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(623),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [aux_sym_clone_expression_token1] = ACTIONS(635),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(645),
    [aux_sym_include_once_expression_token1] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
  },
  [563] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(962),
    [sym_clone_expression] = STATE(962),
    [sym__primary_expression] = STATE(962),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(962),
    [sym_cast_variable] = STATE(630),
    [sym_member_access_expression] = STATE(630),
    [sym_nullsafe_member_access_expression] = STATE(630),
    [sym_scoped_property_access_expression] = STATE(630),
    [sym_function_call_expression] = STATE(600),
    [sym_scoped_call_expression] = STATE(600),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(600),
    [sym_nullsafe_member_call_expression] = STATE(600),
    [sym_subscript_expression] = STATE(600),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(600),
    [sym_variable_name] = STATE(600),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(847),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [sym_qualified_name] = STATE(694),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__unary_expression] = STATE(962),
    [sym_unary_op_expression] = STATE(962),
    [sym_clone_expression] = STATE(962),
    [sym__primary_expression] = STATE(962),
    [sym_parenthesized_expression] = STATE(695),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_expression] = STATE(962),
    [sym_cast_variable] = STATE(595),
    [sym_member_access_expression] = STATE(595),
    [sym_nullsafe_member_access_expression] = STATE(595),
    [sym_scoped_property_access_expression] = STATE(595),
    [sym_function_call_expression] = STATE(576),
    [sym_scoped_call_expression] = STATE(576),
    [sym__scope_resolution_qualifier] = STATE(2468),
    [sym_relative_scope] = STATE(2468),
    [sym_member_call_expression] = STATE(576),
    [sym_nullsafe_member_call_expression] = STATE(576),
    [sym_subscript_expression] = STATE(576),
    [sym__dereferencable_expression] = STATE(1752),
    [sym_array_creation_expression] = STATE(695),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(695),
    [sym_string] = STATE(695),
    [sym_heredoc] = STATE(695),
    [sym_nowdoc] = STATE(695),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(695),
    [sym_dynamic_variable_name] = STATE(576),
    [sym_variable_name] = STATE(576),
    [sym_include_expression] = STATE(962),
    [sym_include_once_expression] = STATE(962),
    [sym__reserved_identifier] = STATE(1564),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(555),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(569),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [anon_sym_PLUS] = ACTIONS(581),
    [anon_sym_DASH] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(583),
    [aux_sym_clone_expression_token1] = ACTIONS(587),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [aux_sym_include_expression_token1] = ACTIONS(615),
    [aux_sym_include_once_expression_token1] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_qualified_name] = STATE(810),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym__unary_expression] = STATE(1060),
    [sym_unary_op_expression] = STATE(1060),
    [sym_clone_expression] = STATE(1060),
    [sym__primary_expression] = STATE(1060),
    [sym_parenthesized_expression] = STATE(814),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_expression] = STATE(1060),
    [sym_cast_variable] = STATE(633),
    [sym_member_access_expression] = STATE(633),
    [sym_nullsafe_member_access_expression] = STATE(633),
    [sym_scoped_property_access_expression] = STATE(633),
    [sym_function_call_expression] = STATE(599),
    [sym_scoped_call_expression] = STATE(599),
    [sym__scope_resolution_qualifier] = STATE(2616),
    [sym_relative_scope] = STATE(2616),
    [sym_member_call_expression] = STATE(599),
    [sym_nullsafe_member_call_expression] = STATE(599),
    [sym_subscript_expression] = STATE(599),
    [sym__dereferencable_expression] = STATE(1694),
    [sym_array_creation_expression] = STATE(814),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(814),
    [sym_string] = STATE(814),
    [sym_heredoc] = STATE(814),
    [sym_nowdoc] = STATE(814),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(814),
    [sym_dynamic_variable_name] = STATE(599),
    [sym_variable_name] = STATE(599),
    [sym_include_expression] = STATE(1060),
    [sym_include_once_expression] = STATE(1060),
    [sym__reserved_identifier] = STATE(1569),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(653),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [anon_sym_PLUS] = ACTIONS(87),
    [anon_sym_DASH] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [aux_sym_clone_expression_token1] = ACTIONS(93),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(121),
    [aux_sym_include_expression_token1] = ACTIONS(125),
    [aux_sym_include_once_expression_token1] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_name] = ACTIONS(1538),
    [anon_sym_SEMI] = ACTIONS(1540),
    [aux_sym_function_static_declaration_token1] = ACTIONS(1538),
    [aux_sym_global_declaration_token1] = ACTIONS(1538),
    [aux_sym_namespace_definition_token1] = ACTIONS(1538),
    [aux_sym_namespace_use_declaration_token1] = ACTIONS(1538),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(1538),
    [aux_sym_namespace_use_declaration_token3] = ACTIONS(1538),
    [anon_sym_BSLASH] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1540),
    [aux_sym_trait_declaration_token1] = ACTIONS(1538),
    [aux_sym_interface_declaration_token1] = ACTIONS(1538),
    [aux_sym_enum_declaration_token1] = ACTIONS(1538),
    [anon_sym_COLON] = ACTIONS(1540),
    [aux_sym_class_declaration_token1] = ACTIONS(1538),
    [aux_sym_final_modifier_token1] = ACTIONS(1538),
    [aux_sym_abstract_modifier_token1] = ACTIONS(1538),
    [aux_sym_readonly_modifier_token1] = ACTIONS(1538),
    [aux_sym_visibility_modifier_token1] = ACTIONS(1538),
    [aux_sym_visibility_modifier_token2] = ACTIONS(1538),
    [aux_sym_visibility_modifier_token3] = ACTIONS(1538),
    [aux_sym__arrow_function_header_token1] = ACTIONS(1538),
    [anon_sym_LPAREN] = ACTIONS(1540),
    [aux_sym_cast_type_token1] = ACTIONS(1538),
    [aux_sym_echo_statement_token1] = ACTIONS(1538),
    [anon_sym_unset] = ACTIONS(1538),
    [aux_sym_declare_statement_token1] = ACTIONS(1538),
    [sym_float] = ACTIONS(1538),
    [aux_sym_try_statement_token1] = ACTIONS(1538),
    [aux_sym_goto_statement_token1] = ACTIONS(1538),
    [aux_sym_continue_statement_token1] = ACTIONS(1538),
    [aux_sym_break_statement_token1] = ACTIONS(1538),
    [sym_integer] = ACTIONS(1538),
    [aux_sym_return_statement_token1] = ACTIONS(1538),
    [aux_sym_throw_expression_token1] = ACTIONS(1538),
    [aux_sym_while_statement_token1] = ACTIONS(1538),
    [aux_sym_do_statement_token1] = ACTIONS(1538),
    [aux_sym_for_statement_token1] = ACTIONS(1538),
    [aux_sym_foreach_statement_token1] = ACTIONS(1538),
    [aux_sym_if_statement_token1] = ACTIONS(1538),
    [aux_sym_match_expression_token1] = ACTIONS(1538),
    [aux_sym_switch_statement_token1] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_TILDE] = ACTIONS(1540),
    [anon_sym_BANG] = ACTIONS(1540),
    [anon_sym_AT] = ACTIONS(1540),
    [aux_sym_clone_expression_token1] = ACTIONS(1538),
    [aux_sym_print_intrinsic_token1] = ACTIONS(1538),
    [aux_sym_object_creation_expression_token1] = ACTIONS(1538),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [aux_sym__list_destructing_token1] = ACTIONS(1538),
    [anon_sym_LBRACK] = ACTIONS(1540),
    [anon_sym_self] = ACTIONS(1538),
    [anon_sym_parent] = ACTIONS(1538),
    [aux_sym__argument_name_token1] = ACTIONS(1538),
    [aux_sym__argument_name_token2] = ACTIONS(1538),
    [anon_sym_POUND_LBRACK] = ACTIONS(1540),
    [aux_sym_encapsed_string_token1] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [aux_sym_string_token1] = ACTIONS(1540),
    [anon_sym_SQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LT_LT] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [aux_sym_yield_expression_token1] = ACTIONS(1538),
    [aux_sym_include_expression_token1] = ACTIONS(1538),
    [aux_sym_include_once_expression_token1] = ACTIONS(1538),
    [aux_sym_require_expression_token1] = ACTIONS(1538),
    [aux_sym_require_once_expression_token1] = ACTIONS(1538),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2466),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__primary_expression] = STATE(912),
    [sym_parenthesized_expression] = STATE(696),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_variable] = STATE(706),
    [sym_member_access_expression] = STATE(706),
    [sym_nullsafe_member_access_expression] = STATE(706),
    [sym_scoped_property_access_expression] = STATE(706),
    [sym_function_call_expression] = STATE(650),
    [sym_scoped_call_expression] = STATE(650),
    [sym__scope_resolution_qualifier] = STATE(2612),
    [sym_relative_scope] = STATE(2612),
    [sym_member_call_expression] = STATE(650),
    [sym_nullsafe_member_call_expression] = STATE(650),
    [sym_subscript_expression] = STATE(650),
    [sym__dereferencable_expression] = STATE(1720),
    [sym_array_creation_expression] = STATE(696),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(696),
    [sym_string] = STATE(696),
    [sym_heredoc] = STATE(696),
    [sym_nowdoc] = STATE(696),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(696),
    [sym_dynamic_variable_name] = STATE(650),
    [sym_variable_name] = STATE(650),
    [sym__reserved_identifier] = STATE(1542),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(1542),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(577),
    [aux_sym_print_intrinsic_token1] = ACTIONS(589),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [sym_qualified_name] = STATE(822),
    [sym_namespace_name_as_prefix] = STATE(2628),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2620),
    [sym_arrow_function] = STATE(1037),
    [sym_throw_expression] = STATE(1037),
    [sym__primary_expression] = STATE(1130),
    [sym_parenthesized_expression] = STATE(821),
    [sym_class_constant_access_expression] = STATE(897),
    [sym_print_intrinsic] = STATE(1037),
    [sym_anonymous_function_creation_expression] = STATE(1037),
    [sym_object_creation_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_cast_variable] = STATE(843),
    [sym_member_access_expression] = STATE(843),
    [sym_nullsafe_member_access_expression] = STATE(843),
    [sym_scoped_property_access_expression] = STATE(843),
    [sym_function_call_expression] = STATE(777),
    [sym_scoped_call_expression] = STATE(777),
    [sym__scope_resolution_qualifier] = STATE(2573),
    [sym_relative_scope] = STATE(2573),
    [sym_member_call_expression] = STATE(777),
    [sym_nullsafe_member_call_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym__dereferencable_expression] = STATE(1671),
    [sym_array_creation_expression] = STATE(821),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1772),
    [sym_encapsed_string] = STATE(821),
    [sym_string] = STATE(821),
    [sym_heredoc] = STATE(821),
    [sym_nowdoc] = STATE(821),
    [sym_shell_command_expression] = STATE(1037),
    [sym_boolean] = STATE(1037),
    [sym_null] = STATE(1037),
    [sym__string] = STATE(821),
    [sym_dynamic_variable_name] = STATE(777),
    [sym_variable_name] = STATE(777),
    [sym__reserved_identifier] = STATE(1562),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(1548),
    [aux_sym_function_static_declaration_token1] = ACTIONS(657),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(659),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1550),
    [aux_sym_cast_type_token1] = ACTIONS(51),
    [sym_float] = ACTIONS(59),
    [sym_integer] = ACTIONS(59),
    [aux_sym_throw_expression_token1] = ACTIONS(71),
    [aux_sym_print_intrinsic_token1] = ACTIONS(95),
    [aux_sym_object_creation_expression_token1] = ACTIONS(97),
    [anon_sym_DASH_DASH] = ACTIONS(99),
    [anon_sym_PLUS_PLUS] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(107),
    [aux_sym__argument_name_token2] = ACTIONS(109),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(113),
    [aux_sym_string_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_LT_LT_LT] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
  },
  [569] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2456),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__primary_expression] = STATE(912),
    [sym_parenthesized_expression] = STATE(696),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_variable] = STATE(706),
    [sym_member_access_expression] = STATE(706),
    [sym_nullsafe_member_access_expression] = STATE(706),
    [sym_scoped_property_access_expression] = STATE(706),
    [sym_function_call_expression] = STATE(650),
    [sym_scoped_call_expression] = STATE(650),
    [sym__scope_resolution_qualifier] = STATE(2612),
    [sym_relative_scope] = STATE(2612),
    [sym_member_call_expression] = STATE(650),
    [sym_nullsafe_member_call_expression] = STATE(650),
    [sym_subscript_expression] = STATE(650),
    [sym__dereferencable_expression] = STATE(1720),
    [sym_array_creation_expression] = STATE(696),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(696),
    [sym_string] = STATE(696),
    [sym_heredoc] = STATE(696),
    [sym_nowdoc] = STATE(696),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(696),
    [sym_dynamic_variable_name] = STATE(650),
    [sym_variable_name] = STATE(650),
    [sym__reserved_identifier] = STATE(1542),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(1542),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(627),
    [aux_sym_print_intrinsic_token1] = ACTIONS(637),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [sym_qualified_name] = STATE(682),
    [sym_namespace_name_as_prefix] = STATE(2460),
    [sym_namespace_name] = STATE(2627),
    [sym_static_modifier] = STATE(2624),
    [sym__arrow_function_header] = STATE(2520),
    [sym_arrow_function] = STATE(959),
    [sym_throw_expression] = STATE(959),
    [sym__primary_expression] = STATE(912),
    [sym_parenthesized_expression] = STATE(696),
    [sym_class_constant_access_expression] = STATE(775),
    [sym_print_intrinsic] = STATE(959),
    [sym_anonymous_function_creation_expression] = STATE(959),
    [sym_object_creation_expression] = STATE(959),
    [sym_update_expression] = STATE(959),
    [sym_cast_variable] = STATE(706),
    [sym_member_access_expression] = STATE(706),
    [sym_nullsafe_member_access_expression] = STATE(706),
    [sym_scoped_property_access_expression] = STATE(706),
    [sym_function_call_expression] = STATE(650),
    [sym_scoped_call_expression] = STATE(650),
    [sym__scope_resolution_qualifier] = STATE(2612),
    [sym_relative_scope] = STATE(2612),
    [sym_member_call_expression] = STATE(650),
    [sym_nullsafe_member_call_expression] = STATE(650),
    [sym_subscript_expression] = STATE(650),
    [sym__dereferencable_expression] = STATE(1720),
    [sym_array_creation_expression] = STATE(696),
    [sym_attribute_group] = STATE(1346),
    [sym_attribute_list] = STATE(1778),
    [sym_encapsed_string] = STATE(696),
    [sym_string] = STATE(696),
    [sym_heredoc] = STATE(696),
    [sym_nowdoc] = STATE(696),
    [sym_shell_command_expression] = STATE(959),
    [sym_boolean] = STATE(959),
    [sym_null] = STATE(959),
    [sym__string] = STATE(696),
    [sym_dynamic_variable_name] = STATE(650),
    [sym_variable_name] = STATE(650),
    [sym__reserved_identifier] = STATE(1542),
    [aux_sym_attribute_list_repeat1] = STATE(1346),
    [sym_name] = ACTIONS(1542),
    [aux_sym_function_static_declaration_token1] = ACTIONS(561),
    [aux_sym_namespace_definition_token1] = ACTIONS(563),
    [aux_sym_namespace_use_declaration_token2] = ACTIONS(565),
    [anon_sym_BSLASH] = ACTIONS(27),
    [aux_sym__arrow_function_header_token1] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [aux_sym_cast_type_token1] = ACTIONS(573),
    [sym_float] = ACTIONS(575),
    [sym_integer] = ACTIONS(575),
    [aux_sym_throw_expression_token1] = ACTIONS(669),
    [aux_sym_print_intrinsic_token1] = ACTIONS(679),
    [aux_sym_object_creation_expression_token1] = ACTIONS(591),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_self] = ACTIONS(105),
    [anon_sym_parent] = ACTIONS(105),
    [aux_sym__argument_name_token1] = ACTIONS(597),
    [aux_sym__argument_name_token2] = ACTIONS(599),
    [anon_sym_POUND_LBRACK] = ACTIONS(111),
    [aux_sym_encapsed_string_token1] = ACTIONS(601),
    [anon_sym_DQUOTE] = ACTIONS(601),
    [aux_sym_string_token1] = ACTIONS(603),
    [anon_sym_SQUOTE] = ACTIONS(603),
    [anon_sym_LT_LT_LT] = ACTIONS(605),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1554), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [70] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1560), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [140] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1564), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [210] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1568), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_base_clause_token1,
      aux_sym_class_interface_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [280] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1574), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1572), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [353] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1582), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1588), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [434] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(590), 1,
      sym_arguments,
    ACTIONS(1592), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1590), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [507] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(589), 1,
      sym_arguments,
    ACTIONS(1596), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1594), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [580] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(593), 1,
      sym_arguments,
    ACTIONS(1600), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1598), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [653] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1604), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1602), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [726] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1608), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1606), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [794] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1612), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1610), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [862] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1616), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1614), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [930] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1620), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1618), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [998] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1622), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1066] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1626), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1134] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1630), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1202] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1636), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1634), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1270] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1640), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1638), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1338] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1644), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1642), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1406] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1648), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1646), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1474] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1652), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1650), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1542] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1656), 21,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1654), 39,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1610] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 16,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1689] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1588), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1764] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1662), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1664), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1842] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(623), 1,
      sym_arguments,
    ACTIONS(1596), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1594), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1911] = 12,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
    STATE(582), 1,
      sym_arguments,
    STATE(1998), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1994] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_EQ,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(628), 1,
      sym_arguments,
    ACTIONS(1670), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1588), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2071] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1582), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1588), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_RBRACK,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2148] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(620), 1,
      sym_arguments,
    ACTIONS(1574), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1572), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2217] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(617), 1,
      sym_arguments,
    ACTIONS(1604), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1602), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2286] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(622), 1,
      sym_arguments,
    ACTIONS(1592), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1590), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2355] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 16,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 20,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2428] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(609), 1,
      sym_arguments,
    ACTIONS(1600), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1598), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2497] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    ACTIONS(1672), 1,
      anon_sym_EQ,
    STATE(628), 1,
      sym_arguments,
    ACTIONS(1670), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1674), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2574] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1608), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1606), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2638] = 10,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1676), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2716] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1656), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1654), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2780] = 10,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1662), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1678), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1664), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2858] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1564), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2922] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1554), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2986] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1568), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3050] = 10,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1681), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3128] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1622), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3192] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1616), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1614), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3256] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1652), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1650), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3320] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1648), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1646), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3384] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1662), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1664), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3456] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1636), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1634), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3520] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1620), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1618), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3584] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1644), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1642), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3648] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1640), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1638), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3712] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1560), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3776] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1626), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3840] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1630), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3904] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1683), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1685), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 14,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3980] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1612), 20,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1610), 36,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [4044] = 10,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1662), 1,
      anon_sym_EQ,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1687), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 11,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1664), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4121] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1588), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_RBRACK,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4192] = 10,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
    STATE(1998), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4269] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_EQ,
    ACTIONS(1670), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1674), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4340] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1582), 1,
      anon_sym_EQ,
    ACTIONS(1670), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1588), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 15,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4411] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1683), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1685), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1578), 14,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4481] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1676), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4553] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1658), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1681), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1660), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4625] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1662), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1678), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 12,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1664), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4697] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1662), 1,
      anon_sym_EQ,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1687), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1578), 11,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1664), 13,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1580), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4768] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1690), 22,
      anon_sym_AMP,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_COLON,
      aux_sym_class_interface_clause_token1,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_self,
      anon_sym_parent,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
      sym_name,
    ACTIONS(1692), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4826] = 25,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(39), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(41), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1696), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(1698), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1702), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(1704), 1,
      sym_var_modifier,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1679), 1,
      sym_variable_name,
    STATE(1823), 1,
      sym__function_definition_header,
    STATE(1854), 1,
      sym_property_element,
    STATE(2036), 1,
      sym__type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(1706), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1029), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [4927] = 25,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(39), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(41), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1696), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(1698), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1702), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(1704), 1,
      sym_var_modifier,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1679), 1,
      sym_variable_name,
    STATE(1816), 1,
      sym_property_element,
    STATE(1817), 1,
      sym__function_definition_header,
    STATE(2152), 1,
      sym__type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(1706), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    STATE(1029), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5028] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(582), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5093] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(670), 1,
      sym_arguments,
    ACTIONS(1600), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5152] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1608), 13,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_class_interface_clause_token1,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5207] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5268] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_arguments,
    ACTIONS(1592), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5327] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(662), 1,
      sym_arguments,
    ACTIONS(1596), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5386] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(660), 1,
      sym_arguments,
    ACTIONS(1574), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5445] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1725), 1,
      anon_sym_COMMA,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1729), 1,
      anon_sym_RPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(921), 1,
      sym_attribute_list,
    STATE(1161), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1721), 1,
      sym__type,
    STATE(1940), 1,
      sym_reference_modifier,
    STATE(1943), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1937), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5546] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5609] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(745), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5674] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(668), 1,
      sym_arguments,
    ACTIONS(1604), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5733] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1745), 1,
      anon_sym_COMMA,
    ACTIONS(1747), 1,
      anon_sym_RPAREN,
    STATE(921), 1,
      sym_attribute_list,
    STATE(1161), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1721), 1,
      sym__type,
    STATE(1940), 1,
      sym_reference_modifier,
    STATE(1943), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1941), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [5834] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5899] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(582), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5964] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1751), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6022] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(591), 1,
      sym_arguments,
    ACTIONS(1755), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1753), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_use_instead_of_clause_token1,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6080] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1568), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6134] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6188] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1636), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6242] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1620), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6296] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1640), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6350] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6404] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1644), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6458] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1648), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6512] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1757), 1,
      anon_sym_RPAREN,
    STATE(921), 1,
      sym_attribute_list,
    STATE(1161), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1721), 1,
      sym__type,
    STATE(1940), 1,
      sym_reference_modifier,
    STATE(1943), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2365), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [6610] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1612), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6664] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1652), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6718] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1616), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6772] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1656), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6826] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1608), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6880] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1759), 1,
      sym_name,
    ACTIONS(1761), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2561), 1,
      sym_attribute_list,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(708), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    STATE(2647), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(709), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(710), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1730), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1572), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [6976] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7030] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1767), 1,
      anon_sym_RPAREN,
    STATE(921), 1,
      sym_attribute_list,
    STATE(1161), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1721), 1,
      sym__type,
    STATE(1940), 1,
      sym_reference_modifier,
    STATE(1943), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2365), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [7128] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1769), 1,
      anon_sym_RPAREN,
    STATE(921), 1,
      sym_attribute_list,
    STATE(1161), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1721), 1,
      sym__type,
    STATE(1940), 1,
      sym_reference_modifier,
    STATE(1943), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2365), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [7226] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1554), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7280] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1564), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7334] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(1771), 1,
      anon_sym_RPAREN,
    STATE(921), 1,
      sym_attribute_list,
    STATE(1161), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1721), 1,
      sym__type,
    STATE(1940), 1,
      sym_reference_modifier,
    STATE(1943), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2365), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [7432] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1773), 1,
      sym_name,
    ACTIONS(1777), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    STATE(2586), 1,
      sym_attribute_list,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(846), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    STATE(2533), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(1775), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(847), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(848), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1703), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1572), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [7528] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1560), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7582] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7637] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7696] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7753] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(593), 1,
      sym_arguments,
    ACTIONS(1600), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7810] = 22,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1781), 1,
      sym_name,
    ACTIONS(1783), 1,
      anon_sym_RBRACE,
    STATE(697), 1,
      aux_sym_use_list_repeat1,
    STATE(1573), 1,
      sym_class_constant_access_expression,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2287), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1738), 5,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1572), 14,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [7901] = 22,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1781), 1,
      sym_name,
    ACTIONS(1785), 1,
      anon_sym_RBRACE,
    STATE(685), 1,
      aux_sym_use_list_repeat1,
    STATE(1573), 1,
      sym_class_constant_access_expression,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2287), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1738), 5,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1572), 14,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [7992] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1574), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8049] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1789), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1787), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8108] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(734), 1,
      sym_arguments,
    ACTIONS(1600), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8165] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(589), 1,
      sym_arguments,
    ACTIONS(1596), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8222] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(736), 1,
      sym_arguments,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8279] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(590), 1,
      sym_arguments,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8334] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(590), 1,
      sym_arguments,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8391] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8450] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8509] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8568] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1791), 1,
      sym_name,
    ACTIONS(1797), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1800), 1,
      anon_sym_BSLASH,
    ACTIONS(1803), 1,
      anon_sym_RBRACE,
    ACTIONS(1805), 1,
      anon_sym_LPAREN,
    ACTIONS(1808), 1,
      aux_sym_cast_type_token1,
    ACTIONS(1811), 1,
      anon_sym_LBRACK,
    ACTIONS(1820), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1823), 1,
      anon_sym_DOLLAR,
    STATE(697), 1,
      aux_sym_use_list_repeat1,
    STATE(1573), 1,
      sym_class_constant_access_expression,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(1814), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(1817), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2287), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(1794), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1738), 5,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1572), 14,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [8659] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1574), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8714] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(755), 1,
      sym_arguments,
    ACTIONS(1596), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8771] = 24,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(101), 1,
      aux_sym__list_destructing_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(727), 1,
      anon_sym_AMP,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2212), 1,
      sym_by_ref,
    STATE(2215), 1,
      sym__list_destructing,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1738), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1574), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1459), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [8866] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8921] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(727), 1,
      sym_arguments,
    ACTIONS(1574), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8978] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9037] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9096] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(593), 1,
      sym_arguments,
    ACTIONS(1600), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9151] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1586), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9208] = 24,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(101), 1,
      aux_sym__list_destructing_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(727), 1,
      anon_sym_AMP,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2051), 1,
      sym__list_destructing,
    STATE(2052), 1,
      sym_by_ref,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1738), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1525), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1453), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [9303] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(745), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9362] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LPAREN,
    STATE(928), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9421] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(745), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9480] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(660), 1,
      sym_arguments,
    ACTIONS(1751), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9537] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1832), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1830), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9596] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_EQ,
    ACTIONS(1838), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1836), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1834), 30,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9653] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9712] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(589), 1,
      sym_arguments,
    ACTIONS(1596), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9767] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(758), 1,
      sym_arguments,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9824] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(665), 1,
      sym_arguments,
    ACTIONS(1755), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1753), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9881] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(921), 1,
      sym_attribute_list,
    STATE(1161), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1721), 1,
      sym__type,
    STATE(1940), 1,
      sym_reference_modifier,
    STATE(1943), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1315), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(2365), 3,
      sym_property_promotion_parameter,
      sym_simple_parameter,
      sym_variadic_parameter,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [9976] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1845), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1843), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10028] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1849), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1847), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10080] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1564), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10132] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1853), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1851), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10184] = 23,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(727), 1,
      anon_sym_AMP,
    ACTIONS(849), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2293), 1,
      sym_by_ref,
    STATE(2295), 1,
      sym__array_destructing,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1738), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1540), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1471), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [10276] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1857), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1855), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10328] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1554), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10380] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1620), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10432] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1636), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10484] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1861), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1859), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10536] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1865), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1863), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10588] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1869), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1867), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10640] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1616), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10692] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1873), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1871), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10744] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1877), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1875), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10796] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1656), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10848] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1881), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1879), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10900] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1652), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10952] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1885), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1883), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11004] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1648), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11056] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1560), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11108] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1612), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11160] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11212] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1889), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1887), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11264] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1893), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1891), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11316] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1608), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11370] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1610), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1899), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1897), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11424] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1836), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1834), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11476] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1903), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1901), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11528] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1907), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1905), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11580] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1911), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1909), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11632] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1915), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1913), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11684] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1919), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1917), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11736] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1923), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1921), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11788] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11840] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1927), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1925), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11892] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1640), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11944] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1568), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11996] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1538), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1540), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12048] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1644), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12100] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12152] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1832), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1830), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12205] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12258] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(628), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12319] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1017), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1015), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12370] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(582), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12431] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(793), 1,
      sym_arguments,
    ACTIONS(1604), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12486] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(789), 1,
      sym_arguments,
    ACTIONS(1596), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12541] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(786), 1,
      sym_arguments,
    ACTIONS(1574), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12596] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(792), 1,
      sym_arguments,
    ACTIONS(1600), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12651] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(790), 1,
      sym_arguments,
    ACTIONS(1592), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12706] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12759] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(856), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12820] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1838), 1,
      anon_sym_RPAREN,
    ACTIONS(1841), 1,
      anon_sym_EQ,
    ACTIONS(1836), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1834), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 18,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LBRACK,
      anon_sym_POUND_LBRACK,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
      anon_sym_LT_LT_LT,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(1933), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym__arrow_function_header_token1,
      aux_sym_cast_type_token1,
      sym_float,
      sym_integer,
      aux_sym_throw_expression_token1,
      aux_sym_match_expression_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_clone_expression_token1,
      aux_sym_print_intrinsic_token1,
      aux_sym_object_creation_expression_token1,
      aux_sym__list_destructing_token1,
      anon_sym_self,
      anon_sym_parent,
      aux_sym__argument_name_token1,
      aux_sym__argument_name_token2,
      aux_sym_yield_expression_token1,
      aux_sym_include_expression_token1,
      aux_sym_include_once_expression_token1,
      aux_sym_require_expression_token1,
      aux_sym_require_once_expression_token1,
      sym_name,
  [12926] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1789), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1787), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12979] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13032] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1013), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1011), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13083] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    ACTIONS(1670), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13142] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13203] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13260] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13310] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13360] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13410] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1937), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 21,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13472] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1564), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13522] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1939), 1,
      anon_sym_COLON,
    STATE(628), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 21,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13584] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1636), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13634] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1620), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13684] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1560), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13734] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1640), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13784] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1644), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13834] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1608), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13884] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1656), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13934] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1652), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13984] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1648), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14034] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1612), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14084] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1568), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14134] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1616), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14184] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1941), 1,
      anon_sym_COLON,
    STATE(582), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 21,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14246] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1554), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1945), 17,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LBRACK,
      anon_sym_POUND_LBRACK,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
      anon_sym_LT_LT_LT,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(1943), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym__arrow_function_header_token1,
      aux_sym_cast_type_token1,
      sym_float,
      sym_integer,
      aux_sym_throw_expression_token1,
      aux_sym_match_expression_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_clone_expression_token1,
      aux_sym_print_intrinsic_token1,
      aux_sym_object_creation_expression_token1,
      aux_sym__list_destructing_token1,
      anon_sym_self,
      anon_sym_parent,
      aux_sym__argument_name_token1,
      aux_sym__argument_name_token2,
      aux_sym_yield_expression_token1,
      aux_sym_include_expression_token1,
      aux_sym_include_once_expression_token1,
      aux_sym_require_expression_token1,
      aux_sym_require_once_expression_token1,
      sym_name,
  [14346] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(593), 1,
      sym_arguments,
    ACTIONS(1600), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14399] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(879), 1,
      sym_arguments,
    ACTIONS(1600), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14452] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1738), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(701), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1456), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [14535] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(590), 1,
      sym_arguments,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14586] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(1947), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(896), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1559), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2453), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1729), 4,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(816), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1577), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [14669] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(882), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14724] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14779] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(1947), 1,
      sym_name,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1559), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1729), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2588), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(899), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(850), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1577), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [14862] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14917] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(628), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14972] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(1951), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(704), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2599), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(714), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(761), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1740), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1572), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [15055] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(1947), 1,
      sym_name,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1559), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1729), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2588), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(900), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(806), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1577), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [15138] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(620), 1,
      sym_arguments,
    ACTIONS(1751), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15191] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(628), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15246] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(794), 1,
      sym_arguments,
    ACTIONS(1755), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1753), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15299] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(882), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1789), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1787), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15354] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(589), 1,
      sym_arguments,
    ACTIONS(1596), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15407] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(590), 1,
      sym_arguments,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15460] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1604), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15513] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(618), 1,
      sym_arguments,
    ACTIONS(1755), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1753), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15566] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15621] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15676] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1574), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15727] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1738), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1551), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1491), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [15810] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(589), 1,
      sym_arguments,
    ACTIONS(1596), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15861] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(1953), 1,
      sym_name,
    ACTIONS(1955), 1,
      anon_sym_LPAREN,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1568), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2632), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(760), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(712), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1578), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [15944] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1608), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15993] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1076), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1074), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16042] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1140), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1138), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16091] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(592), 1,
      sym_arguments,
    ACTIONS(1604), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16142] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(593), 1,
      sym_arguments,
    ACTIONS(1600), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1598), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16193] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(895), 1,
      sym_arguments,
    ACTIONS(1574), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16246] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(1953), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(774), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1568), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2522), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1732), 4,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(688), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1578), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16329] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1738), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1535), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1452), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16412] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(880), 1,
      sym_arguments,
    ACTIONS(1604), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1602), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16465] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1690), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1692), 30,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16514] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(1957), 1,
      sym_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(807), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2610), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(1775), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(809), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(898), 3,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1701), 3,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym__dereferencable_expression,
    STATE(1572), 11,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16597] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(889), 1,
      sym_arguments,
    ACTIONS(1592), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1590), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16650] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(588), 1,
      sym_arguments,
    ACTIONS(1574), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1572), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16703] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1959), 1,
      sym_name,
    ACTIONS(1961), 1,
      anon_sym_LPAREN,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1562), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1671), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2592), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(844), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(779), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1576), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16786] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(786), 1,
      sym_arguments,
    ACTIONS(1751), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1749), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16839] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1738), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1536), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(1437), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [16922] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1670), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16975] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17026] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(1953), 1,
      sym_name,
    ACTIONS(1955), 1,
      anon_sym_LPAREN,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1568), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1732), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2632), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(770), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(703), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1578), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [17109] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(856), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17164] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LPAREN,
    STATE(1078), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17219] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(856), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1741), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1739), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17274] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(890), 1,
      sym_arguments,
    ACTIONS(1596), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1594), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17327] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(882), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1832), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1830), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17382] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1826), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(774), 2,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
    STATE(1564), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(2468), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1738), 4,
      sym_class_constant_access_expression,
      sym_cast_variable,
      sym_scoped_property_access_expression,
      sym__dereferencable_expression,
    STATE(1440), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1572), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [17465] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(573), 1,
      aux_sym_cast_type_token1,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1534), 1,
      anon_sym_LBRACK,
    ACTIONS(1544), 1,
      anon_sym_LPAREN,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1965), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(1542), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    STATE(1720), 2,
      sym_class_constant_access_expression,
      sym__dereferencable_expression,
    STATE(2612), 2,
      sym__scope_resolution_qualifier,
      sym_relative_scope,
    ACTIONS(105), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(701), 4,
      sym_cast_variable,
      sym_member_access_expression,
      sym_nullsafe_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(645), 7,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_nullsafe_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(1544), 7,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [17548] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_EQ,
    ACTIONS(1836), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1834), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17599] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1648), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17647] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1538), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1540), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17695] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1610), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1899), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1897), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17745] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1881), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1879), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17793] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1893), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1891), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17841] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1873), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1871), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17889] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1849), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1847), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17937] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1845), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1843), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17985] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1869), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1867), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18033] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1865), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1863), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18081] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1616), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1614), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18129] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1861), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1859), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18177] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1857), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1855), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18225] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1853), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1851), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18273] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1907), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1905), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18321] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1911), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1909), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18369] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1877), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1875), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18417] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18465] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1608), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1606), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18515] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_EQ,
    ACTIONS(1836), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1834), 28,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18565] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1626), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18613] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1564), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18661] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1630), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18709] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1889), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1887), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18757] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_EQ,
    ACTIONS(1967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1836), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1834), 26,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18809] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1656), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1654), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18857] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1652), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1650), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18905] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1923), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1921), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18953] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1612), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1610), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19001] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1836), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1834), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19049] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1568), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19097] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1927), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1925), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19145] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1554), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19193] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1560), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19241] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1903), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1901), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19289] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1644), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1642), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19337] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1640), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19385] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1919), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1917), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19433] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1915), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1913), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19481] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1620), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1618), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19529] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1885), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1883), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19577] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1636), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1634), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19625] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1789), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1787), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19674] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1580), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19723] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1716), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19772] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1832), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1830), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19821] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1582), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19870] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1971), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1969), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19916] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1975), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1973), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [19962] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1979), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1977), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20008] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1983), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1981), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20054] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1987), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1985), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20100] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1991), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1989), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20146] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1995), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1993), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20192] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1999), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1997), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20238] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2003), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2001), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20284] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2007), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2005), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20330] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2011), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2009), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20376] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2015), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2013), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20422] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1560), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20468] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1568), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20514] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2019), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2017), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20560] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2023), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2021), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20606] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2027), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20652] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2031), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2029), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20698] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2035), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2033), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20744] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2039), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2037), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20790] = 20,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1727), 1,
      anon_sym_LPAREN,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(2041), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1145), 1,
      sym_visibility_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1711), 1,
      sym__type,
    STATE(1979), 1,
      sym_reference_modifier,
    STATE(1981), 1,
      sym_variable_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1570), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [20870] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2045), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2043), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20916] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2051), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(2049), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2047), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [20964] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2049), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2047), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21010] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2055), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2053), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21056] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2059), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2057), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21102] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2063), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2061), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21148] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1899), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1897), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21194] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2067), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2065), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21240] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2071), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2069), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21286] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2075), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2073), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21332] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2079), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2077), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21378] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2083), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21424] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2087), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2085), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21470] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2091), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2089), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21516] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2095), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2093), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21562] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2099), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2097), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21608] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2103), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2101), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21654] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2107), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2105), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21700] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2111), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2109), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21746] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2115), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2113), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21792] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2119), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2117), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21838] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2123), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2121), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21884] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2127), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2125), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21930] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2131), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2129), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [21976] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2135), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2133), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22022] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2139), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2137), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22068] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2143), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2141), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22114] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2147), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2145), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22160] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2151), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2149), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22206] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2155), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2153), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22252] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2159), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2157), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22298] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2163), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2161), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22344] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2167), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2165), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22390] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2171), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2169), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22436] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1564), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22482] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2175), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2173), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22528] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2179), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2177), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22574] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1580), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22620] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1554), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22666] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2183), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2181), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22712] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2187), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2185), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22758] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2191), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2189), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22804] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2195), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2193), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22850] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2199), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2197), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22896] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1140), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1138), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22941] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1076), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      aux_sym_else_clause_token1,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1074), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [22986] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2201), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23068] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 20,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [23122] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2243), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23204] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2247), 1,
      anon_sym_QMARK,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2245), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [23280] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2249), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [23356] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2251), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23438] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2253), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23520] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2255), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [23602] = 13,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 14,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [23666] = 15,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 13,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [23734] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 24,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [23784] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [23860] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 25,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [23906] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2259), 1,
      anon_sym_QMARK,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2257), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [23982] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [24058] = 21,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 8,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [24138] = 20,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 9,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [24216] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [24292] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 10,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [24368] = 17,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 12,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [24440] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2161), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24522] = 16,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 13,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [24592] = 14,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 14,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [24658] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24740] = 11,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1714), 18,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24800] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2267), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24882] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [24964] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2271), 7,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [25046] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 19,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [25102] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2273), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2177), 6,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
  [25186] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 22,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [25238] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 25,
      anon_sym_SEMI,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25284] = 16,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [25353] = 17,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [25424] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [25477] = 20,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25554] = 21,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [25633] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25708] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [25753] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [25828] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [25877] = 14,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [25942] = 15,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [26009] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2271), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26090] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2161), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26171] = 13,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [26234] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2251), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26315] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2253), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26396] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2255), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26477] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2243), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26558] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2315), 1,
      anon_sym_EQ_GT,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2177), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26641] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [26722] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2257), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26797] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2249), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26872] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [26947] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2267), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [27028] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_QMARK,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2245), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27103] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [27154] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [27209] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2201), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [27290] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
  [27371] = 10,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2319), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2324), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2327), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2330), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2333), 1,
      sym_var_modifier,
    ACTIONS(2336), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2322), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    STATE(1029), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
    ACTIONS(2317), 16,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [27428] = 11,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1714), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [27487] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [27562] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27607] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1975), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1973), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27649] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2147), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2145), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27691] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1586), 1,
      sym__type,
    STATE(1782), 1,
      sym_const_element,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2607), 1,
      sym__reserved_identifier,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [27759] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27803] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1580), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1578), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27845] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2055), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2053), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27887] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2151), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2149), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [27929] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2161), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [28009] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2023), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2021), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28051] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2135), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2133), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28093] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2067), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2065), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28135] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2063), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2061), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28177] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 18,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [28229] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2131), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2129), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28271] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2127), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2125), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28313] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2155), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2153), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28355] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2119), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2117), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28397] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2159), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2157), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28439] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2059), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2057), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28481] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2271), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [28561] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2071), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2069), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28603] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2075), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2073), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28645] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2257), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [28719] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2049), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2047), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28761] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2011), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2009), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28803] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2031), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2029), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28845] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1642), 1,
      sym__type,
    STATE(1911), 1,
      sym_const_element,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2607), 1,
      sym__reserved_identifier,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [28913] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2187), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2185), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28955] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2383), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(2049), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2047), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [28999] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2115), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2113), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29041] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2039), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2037), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29083] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2087), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2085), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29125] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1562), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1560), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29167] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1622), 1,
      sym__type,
    STATE(1909), 1,
      sym_const_element,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2607), 1,
      sym__reserved_identifier,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [29235] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2167), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2165), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29277] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1983), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1981), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29319] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2111), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2109), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29361] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2079), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2077), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29403] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2083), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2081), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29445] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2123), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2121), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29487] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2091), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2089), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29529] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2095), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2093), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29571] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2099), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2097), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29613] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2103), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2101), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29655] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1995), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1993), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29697] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1899), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1897), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29739] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2003), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2001), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29781] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [29855] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2035), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2033), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [29897] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 20,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [29947] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 17,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [30001] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [30075] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1556), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1554), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30117] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1592), 1,
      sym__type,
    STATE(1832), 1,
      sym_const_element,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2607), 1,
      sym__reserved_identifier,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [30185] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2045), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2043), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30227] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2107), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2105), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30269] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2179), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2177), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30311] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1566), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1564), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30353] = 11,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1714), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [30411] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1991), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1989), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30453] = 14,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [30517] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1017), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1015), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30559] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1608), 1,
      sym__type,
    STATE(1815), 1,
      sym_const_element,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2607), 1,
      sym__reserved_identifier,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [30627] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1570), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1568), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30669] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2143), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2141), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30711] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2019), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2017), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30753] = 16,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2339), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1648), 1,
      sym__type,
    STATE(1812), 1,
      sym_const_element,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2607), 1,
      sym__reserved_identifier,
    STATE(2627), 1,
      sym_namespace_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [30821] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2007), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2005), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [30863] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2265), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [30943] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2201), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [31023] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2267), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [31103] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2269), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [31183] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2027), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2025), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31225] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2171), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2169), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31267] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2183), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2181), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31309] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2249), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [31383] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2385), 1,
      anon_sym_EQ_GT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2177), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_binary_expression_token1,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [31465] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2175), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2173), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31507] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2191), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2189), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31549] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1979), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1977), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31591] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2195), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2193), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31633] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2255), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [31713] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2139), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2137), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31755] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1971), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1969), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [31797] = 16,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [31865] = 17,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 10,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [31935] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2245), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [32009] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2163), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2161), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32051] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2199), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2197), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32093] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1013), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1011), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32135] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2251), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32215] = 13,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [32277] = 15,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [32343] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2243), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32423] = 20,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 7,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [32499] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [32547] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [32621] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2015), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2013), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32663] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1999), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1997), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32705] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1987), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1985), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32747] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2253), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
  [32827] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [32871] = 21,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [32949] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33023] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2263), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33096] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2269), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33175] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(2063), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2061), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33218] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33291] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(2135), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2133), 22,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR_STAR,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33334] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 22,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [33377] = 13,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 11,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [33438] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [33511] = 17,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(43), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1189), 1,
      sym_readonly_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2099), 1,
      sym_variable_name,
    STATE(2357), 1,
      sym__type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [33580] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2255), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33659] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2251), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33738] = 15,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 10,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [33803] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2265), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [33882] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 17,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DOT,
  [33933] = 21,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 5,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
  [34010] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1716), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1714), 22,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [34053] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2257), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34126] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2271), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34205] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2249), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34278] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2245), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34351] = 19,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(2261), 7,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34424] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2201), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34503] = 20,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 6,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
  [34578] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 21,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [34625] = 17,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(43), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1194), 1,
      sym_readonly_modifier,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1974), 1,
      sym_variable_name,
    STATE(2417), 1,
      sym__type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [34694] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2161), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34773] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2253), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [34852] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 19,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [34901] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1716), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1714), 16,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [34954] = 11,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1716), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1714), 15,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35011] = 14,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(1716), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 11,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [35074] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2243), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35153] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2429), 1,
      anon_sym_EQ_GT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2177), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35234] = 16,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 10,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [35301] = 17,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_QMARK,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1714), 9,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      aux_sym_binary_expression_token4,
      anon_sym_PIPE_PIPE,
  [35370] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2267), 4,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      aux_sym_binary_expression_token1,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35449] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2433), 1,
      anon_sym_COMMA,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2431), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35529] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2435), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35607] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2433), 1,
      anon_sym_COMMA,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2437), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35687] = 24,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2439), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_EQ_GT,
    STATE(2050), 1,
      aux_sym_match_condition_list_repeat1,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35769] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2443), 1,
      anon_sym_EQ_GT,
    ACTIONS(2177), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35849] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2445), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [35927] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2447), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36005] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2449), 1,
      anon_sym_EQ_GT,
    ACTIONS(2177), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36085] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2451), 1,
      anon_sym_EQ_GT,
    ACTIONS(2177), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36165] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2453), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36242] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2455), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36319] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2457), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36396] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2459), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36473] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2437), 1,
      anon_sym_RPAREN,
    ACTIONS(2461), 1,
      anon_sym_COMMA,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [36552] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2471), 1,
      anon_sym_RBRACE,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [36627] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2485), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(1383), 1,
      sym__const_declaration,
    STATE(2614), 1,
      sym_visibility_modifier,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2487), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2483), 21,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [36674] = 15,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2139), 1,
      sym_variable_name,
    STATE(2246), 1,
      sym__type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [36737] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2485), 1,
      aux_sym_namespace_use_declaration_token3,
    STATE(1398), 1,
      sym__const_declaration,
    STATE(2614), 1,
      sym_visibility_modifier,
    ACTIONS(45), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    ACTIONS(2487), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2483), 21,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [36784] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2489), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2492), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2495), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2498), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2501), 1,
      anon_sym_RBRACE,
    ACTIONS(2503), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2506), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2509), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2512), 1,
      sym_var_modifier,
    ACTIONS(2518), 1,
      anon_sym_POUND_LBRACK,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2515), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [36859] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    ACTIONS(2521), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1202), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [36934] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2523), 1,
      anon_sym_EQ_GT,
    ACTIONS(2525), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37013] = 15,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2024), 1,
      sym_variable_name,
    STATE(2368), 1,
      sym__type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [37076] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2527), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37153] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2529), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37230] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2437), 1,
      anon_sym_SEMI,
    ACTIONS(2531), 1,
      anon_sym_COMMA,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37309] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2533), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37386] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2523), 1,
      anon_sym_EQ_GT,
    ACTIONS(2535), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37465] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2537), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37542] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2539), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37619] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    ACTIONS(2541), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [37694] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2523), 1,
      anon_sym_EQ_GT,
    ACTIONS(2543), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37773] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2545), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [37850] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    ACTIONS(2547), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1187), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [37925] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2549), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38002] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2551), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38079] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2553), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38156] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2555), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38233] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2557), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38310] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2559), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38387] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2523), 1,
      anon_sym_EQ_GT,
    ACTIONS(2561), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38466] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2431), 1,
      anon_sym_RPAREN,
    ACTIONS(2461), 1,
      anon_sym_COMMA,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38545] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2563), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38622] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2565), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38699] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2567), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38776] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2569), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38853] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2571), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [38930] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2573), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39007] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    ACTIONS(2575), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1224), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [39082] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2577), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39159] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    ACTIONS(2579), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1228), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [39234] = 23,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2431), 1,
      anon_sym_SEMI,
    ACTIONS(2531), 1,
      anon_sym_COMMA,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39313] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    ACTIONS(2581), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [39388] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2583), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39465] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2585), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39542] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2587), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39619] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2479), 1,
      sym_var_modifier,
    ACTIONS(2589), 1,
      anon_sym_RBRACE,
    STATE(1188), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1341), 1,
      sym_attribute_list,
    STATE(1392), 1,
      sym__const_declaration,
    STATE(1396), 1,
      sym__class_const_declaration,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(640), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
    STATE(1191), 5,
      sym__member_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_declaration_list_repeat1,
  [39694] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2591), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39771] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2593), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39848] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2595), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [39925] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2597), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40002] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2343), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2345), 1,
      anon_sym_AMP,
    ACTIONS(2347), 1,
      anon_sym_QMARK,
    ACTIONS(2349), 1,
      anon_sym_PIPE,
    ACTIONS(2353), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2355), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2357), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2359), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2361), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2363), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2365), 1,
      anon_sym_CARET,
    ACTIONS(2373), 1,
      anon_sym_GT_EQ,
    ACTIONS(2377), 1,
      anon_sym_DOT,
    ACTIONS(2381), 1,
      anon_sym_PERCENT,
    ACTIONS(2351), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2367), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2375), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2379), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2599), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(2371), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2369), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40079] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_AMP,
    ACTIONS(2389), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_PIPE,
    ACTIONS(2395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2397), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2399), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2401), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2403), 1,
      anon_sym_CARET,
    ACTIONS(2411), 1,
      anon_sym_GT_EQ,
    ACTIONS(2415), 1,
      anon_sym_DOT,
    ACTIONS(2419), 1,
      anon_sym_PERCENT,
    ACTIONS(2421), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2423), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2425), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2393), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2405), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2413), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2417), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2601), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2409), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2407), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40156] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2603), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40232] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2605), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40308] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2607), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40384] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2609), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40460] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2611), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40536] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2613), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40612] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2615), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40688] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2617), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40764] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2619), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40840] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2621), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40916] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2623), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [40992] = 14,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2625), 1,
      sym_name,
    ACTIONS(2629), 1,
      anon_sym_LPAREN,
    ACTIONS(2631), 1,
      anon_sym_QMARK,
    ACTIONS(2633), 1,
      sym_bottom_type,
    STATE(1728), 1,
      sym_qualified_name,
    STATE(2113), 1,
      sym__type,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(2143), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1532), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2627), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [41052] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2635), 1,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41128] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2637), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41204] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2639), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41280] = 14,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1708), 1,
      anon_sym_LPAREN,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2641), 1,
      sym_bottom_type,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2442), 1,
      sym__type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1485), 3,
      sym_union_type,
      sym_intersection_type,
      sym_disjunctive_normal_form_type,
    STATE(1420), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [41340] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2635), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41416] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2643), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41492] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2645), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41568] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2647), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41644] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2649), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41720] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2651), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41796] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2653), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41872] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2655), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [41948] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2657), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42024] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2659), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42100] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2661), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42176] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2663), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42252] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2665), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42328] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2667), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42404] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2671), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2669), 26,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [42442] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2673), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42518] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2675), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42594] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2677), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42670] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2679), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42746] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2681), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42822] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2683), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42898] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2685), 1,
      anon_sym_EQ_GT,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [42974] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2687), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43050] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2689), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43126] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2691), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43202] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2693), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43278] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2695), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43354] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2603), 1,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43430] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2697), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43506] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2699), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43582] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2701), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43658] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2703), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43734] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2705), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43810] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2707), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43886] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2709), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [43962] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2711), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44038] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2617), 1,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44114] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2615), 1,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44190] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2713), 1,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44266] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2715), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44342] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2717), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44418] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2713), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44494] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2719), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44570] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2721), 1,
      anon_sym_COLON,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44646] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2723), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44722] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_AMP,
    ACTIONS(2277), 1,
      anon_sym_PIPE,
    ACTIONS(2281), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2283), 1,
      anon_sym_CARET,
    ACTIONS(2291), 1,
      anon_sym_GT_EQ,
    ACTIONS(2295), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_PERCENT,
    ACTIONS(2301), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2303), 1,
      anon_sym_QMARK,
    ACTIONS(2305), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2307), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2309), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2311), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2313), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2723), 1,
      anon_sym_RBRACK,
    ACTIONS(2279), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2285), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2293), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2297), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2289), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2287), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44798] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2725), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44874] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2727), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [44950] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2729), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45026] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2731), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45102] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2733), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45178] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2735), 1,
      anon_sym_RPAREN,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45254] = 22,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_AMP,
    ACTIONS(2205), 1,
      anon_sym_QMARK,
    ACTIONS(2207), 1,
      anon_sym_PIPE,
    ACTIONS(2211), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2213), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2215), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(2217), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(2219), 1,
      aux_sym_binary_expression_token4,
    ACTIONS(2221), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2223), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2225), 1,
      anon_sym_CARET,
    ACTIONS(2233), 1,
      anon_sym_GT_EQ,
    ACTIONS(2237), 1,
      anon_sym_DOT,
    ACTIONS(2241), 1,
      anon_sym_PERCENT,
    ACTIONS(2737), 1,
      anon_sym_RBRACE,
    ACTIONS(2209), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2227), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2235), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2239), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2231), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(2229), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [45330] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2741), 1,
      anon_sym_RBRACE,
    ACTIONS(2743), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2745), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2747), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2749), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2751), 1,
      sym_var_modifier,
    STATE(1342), 1,
      sym_attribute_list,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2753), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1308), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1345), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45395] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2758), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2761), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2764), 1,
      anon_sym_RBRACE,
    ACTIONS(2766), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2769), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2772), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2775), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2778), 1,
      sym_var_modifier,
    ACTIONS(2784), 1,
      anon_sym_POUND_LBRACK,
    STATE(1342), 1,
      sym_attribute_list,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2781), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1305), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1345), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45460] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2743), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2745), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2747), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2749), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2751), 1,
      sym_var_modifier,
    ACTIONS(2787), 1,
      anon_sym_RBRACE,
    STATE(1342), 1,
      sym_attribute_list,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2753), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1305), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1345), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45525] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2791), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2789), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45562] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2743), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2745), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2747), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2749), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2751), 1,
      sym_var_modifier,
    ACTIONS(2793), 1,
      anon_sym_RBRACE,
    STATE(1342), 1,
      sym_attribute_list,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2753), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1305), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1345), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45627] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    ACTIONS(2465), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2743), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2745), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2747), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2749), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2751), 1,
      sym_var_modifier,
    ACTIONS(2795), 1,
      anon_sym_RBRACE,
    STATE(1342), 1,
      sym_attribute_list,
    STATE(1892), 1,
      sym__function_definition_header,
    STATE(1346), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2753), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1306), 5,
      sym__enum_member_declaration,
      sym_enum_case,
      sym_method_declaration,
      sym_use_declaration,
      aux_sym_enum_declaration_list_repeat1,
    STATE(1345), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [45692] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2799), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2797), 25,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45729] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2801), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2487), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2483), 24,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45768] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2805), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2803), 24,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45804] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2809), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2807), 24,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_string,
      anon_sym_int,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 1,
      anon_sym_POUND_LBRACK,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2813), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2811), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 1,
      anon_sym_POUND_LBRACK,
    STATE(1314), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2820), 6,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2818), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [45918] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2450), 1,
      sym_intersection_type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1945), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [45967] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1446), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46016] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1446), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46065] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2519), 1,
      sym_intersection_type,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1945), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46114] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2568), 1,
      sym_intersection_type,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1945), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46163] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2625), 1,
      sym_name,
    ACTIONS(2631), 1,
      anon_sym_QMARK,
    ACTIONS(2824), 1,
      anon_sym_LPAREN,
    STATE(1728), 1,
      sym_qualified_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1755), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2627), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46212] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2495), 1,
      sym_intersection_type,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1945), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 7,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2826), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 7,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2830), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 7,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_POUND_LBRACK,
      anon_sym_DOLLAR,
    ACTIONS(2834), 18,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46360] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2625), 1,
      sym_name,
    ACTIONS(2631), 1,
      anon_sym_QMARK,
    ACTIONS(2824), 1,
      anon_sym_LPAREN,
    STATE(1728), 1,
      sym_qualified_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1802), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2627), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46409] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1447), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46458] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1447), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46507] = 11,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2641), 1,
      sym_intersection_type,
    STATE(1945), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46556] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1445), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46602] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2625), 1,
      sym_name,
    ACTIONS(2631), 1,
      anon_sym_QMARK,
    STATE(1728), 1,
      sym_qualified_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1894), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2627), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46648] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1445), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46694] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1449), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46740] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2625), 1,
      sym_name,
    ACTIONS(2631), 1,
      anon_sym_QMARK,
    STATE(1728), 1,
      sym_qualified_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1801), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(2627), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46786] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    ACTIONS(1710), 1,
      anon_sym_QMARK,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1449), 4,
      sym__types,
      sym_named_type,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46832] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2791), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2789), 17,
      aux_sym_namespace_definition_token1,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_string,
      anon_sym_int,
      aux_sym_readonly_modifier_token1,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [46861] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1423), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46902] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2532), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1423), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(1700), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46943] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2625), 1,
      sym_name,
    STATE(1728), 1,
      sym_qualified_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1751), 2,
      sym_named_type,
      sym_primitive_type,
    ACTIONS(2627), 13,
      anon_sym_string,
      anon_sym_int,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
  [46984] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2805), 4,
      anon_sym_BSLASH,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOLLAR,
    ACTIONS(2803), 16,
      aux_sym_namespace_definition_token1,
      anon_sym_string,
      anon_sym_int,
      aux_sym_class_declaration_token1,
      anon_sym_array,
      aux_sym_primitive_type_token1,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_void,
      anon_sym_mixed,
      anon_sym_static,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      sym_name,
  [47012] = 14,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2463), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2469), 1,
      aux_sym_namespace_use_declaration_token3,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2477), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2838), 1,
      sym_var_modifier,
    STATE(1190), 1,
      sym_final_modifier,
    STATE(1311), 1,
      sym_visibility_modifier,
    STATE(1377), 1,
      sym__const_declaration,
    STATE(1855), 1,
      sym__function_definition_header,
    ACTIONS(2481), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(641), 5,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      aux_sym_property_declaration_repeat1,
  [47061] = 11,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2745), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2747), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2749), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2840), 1,
      aux_sym_enum_case_token1,
    ACTIONS(2842), 1,
      sym_var_modifier,
    STATE(1855), 1,
      sym__function_definition_header,
    ACTIONS(2753), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1343), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47103] = 10,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2745), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2747), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2749), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2844), 1,
      sym_var_modifier,
    STATE(1817), 1,
      sym__function_definition_header,
    ACTIONS(2753), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1347), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_POUND_LBRACK,
    STATE(1344), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2813), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
  [47169] = 10,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2467), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2739), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2745), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2747), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2749), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2844), 1,
      sym_var_modifier,
    STATE(1823), 1,
      sym__function_definition_header,
    ACTIONS(2753), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1347), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym_POUND_LBRACK,
    STATE(1344), 2,
      sym_attribute_group,
      aux_sym_attribute_list_repeat1,
    ACTIONS(2820), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
  [47235] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2322), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(2849), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(2852), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2855), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(2858), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(2861), 1,
      sym_var_modifier,
    ACTIONS(2864), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
    STATE(1347), 7,
      sym_final_modifier,
      sym_abstract_modifier,
      sym_readonly_modifier,
      sym__modifier,
      sym_static_modifier,
      sym_visibility_modifier,
      aux_sym_property_declaration_repeat1,
  [47271] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2867), 6,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_definition_token1,
      aux_sym_cast_type_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(1803), 10,
      anon_sym_BSLASH,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
      anon_sym_LT_LT_LT,
      anon_sym_DOLLAR,
  [47295] = 9,
    ACTIONS(605), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2869), 1,
      sym_float,
    ACTIONS(2871), 1,
      sym_integer,
    ACTIONS(2873), 1,
      aux_sym__argument_name_token1,
    ACTIONS(2875), 1,
      aux_sym__argument_name_token2,
    ACTIONS(601), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(603), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(2510), 7,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym_boolean,
      sym_null,
      sym__string,
  [47331] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 1,
      anon_sym_LBRACE,
    ACTIONS(2883), 1,
      anon_sym_BSLASHu,
    ACTIONS(2886), 1,
      sym__new_line,
    ACTIONS(2889), 1,
      anon_sym_DOLLAR,
    ACTIONS(2892), 1,
      sym_heredoc_end,
    STATE(1350), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1448), 1,
      sym_variable_name,
    STATE(1560), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2880), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1356), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [47391] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_LBRACE,
    ACTIONS(2898), 1,
      anon_sym_BSLASHu,
    ACTIONS(2900), 1,
      sym__new_line,
    ACTIONS(2903), 1,
      anon_sym_DOLLAR,
    ACTIONS(2905), 1,
      sym_heredoc_end,
    STATE(1350), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1448), 1,
      sym_variable_name,
    STATE(1560), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2896), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1356), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2836), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [47451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 15,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      aux_sym_enum_declaration_token1,
      aux_sym_enum_case_token1,
      aux_sym_class_declaration_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      aux_sym__arrow_function_header_token1,
      anon_sym_POUND_LBRACK,
  [47472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47492] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_LBRACE,
    ACTIONS(2903), 1,
      anon_sym_DOLLAR,
    ACTIONS(2911), 1,
      anon_sym_BSLASHu,
    STATE(1448), 1,
      sym_variable_name,
    STATE(1560), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2909), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    ACTIONS(2913), 2,
      sym_heredoc_end,
      sym__new_line,
    STATE(1367), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47706] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_LBRACE,
    ACTIONS(2903), 1,
      anon_sym_DOLLAR,
    ACTIONS(2911), 1,
      anon_sym_BSLASHu,
    STATE(1448), 1,
      sym_variable_name,
    STATE(1560), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2892), 2,
      sym_heredoc_end,
      sym__new_line,
    ACTIONS(2909), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1367), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_LBRACE,
    ACTIONS(2933), 1,
      anon_sym_BSLASHu,
    ACTIONS(2938), 1,
      anon_sym_DOLLAR,
    STATE(1448), 1,
      sym_variable_name,
    STATE(1560), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2930), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    ACTIONS(2936), 2,
      sym_heredoc_end,
      sym__new_line,
    STATE(1367), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47834] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_LBRACE,
    ACTIONS(2898), 1,
      anon_sym_BSLASHu,
    ACTIONS(2903), 1,
      anon_sym_DOLLAR,
    ACTIONS(2947), 1,
      sym__new_line,
    STATE(1352), 1,
      aux_sym_heredoc_body_repeat1,
    STATE(1448), 1,
      sym_variable_name,
    STATE(1560), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2896), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1356), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [47870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1011), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1015), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 14,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [47989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48008] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_LBRACE,
    ACTIONS(2961), 1,
      anon_sym_BSLASHu,
    ACTIONS(2963), 1,
      anon_sym_BQUOTE,
    ACTIONS(2965), 1,
      anon_sym_DOLLAR,
    STATE(1509), 1,
      sym_variable_name,
    STATE(1611), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2959), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1399), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48060] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LBRACE,
    ACTIONS(2973), 1,
      anon_sym_BSLASHu,
    ACTIONS(2975), 1,
      anon_sym_DQUOTE,
    ACTIONS(2977), 1,
      anon_sym_DOLLAR,
    STATE(1515), 1,
      sym_variable_name,
    STATE(1605), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2971), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1413), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [48093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2979), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48131] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2983), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(2985), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [48156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48175] = 10,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(2995), 1,
      anon_sym_BSLASH,
    STATE(1828), 1,
      sym_namespace_use_clause,
    STATE(2565), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2993), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
    STATE(1686), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [48210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48229] = 10,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(3001), 1,
      anon_sym_BSLASH,
    STATE(1800), 1,
      sym_namespace_use_clause,
    STATE(2609), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    ACTIONS(2999), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
    STATE(1686), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [48264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48302] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LBRACE,
    ACTIONS(2977), 1,
      anon_sym_DOLLAR,
    ACTIONS(3009), 1,
      anon_sym_BSLASHu,
    ACTIONS(3011), 1,
      anon_sym_DQUOTE,
    STATE(1515), 1,
      sym_variable_name,
    STATE(1605), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3007), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1404), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [48335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48354] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_LBRACE,
    ACTIONS(2961), 1,
      anon_sym_BSLASHu,
    ACTIONS(2965), 1,
      anon_sym_DOLLAR,
    ACTIONS(3015), 1,
      anon_sym_BQUOTE,
    STATE(1509), 1,
      sym_variable_name,
    STATE(1611), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2959), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1399), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48387] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_LBRACE,
    ACTIONS(2965), 1,
      anon_sym_DOLLAR,
    ACTIONS(3019), 1,
      anon_sym_BSLASHu,
    ACTIONS(3021), 1,
      anon_sym_BQUOTE,
    STATE(1509), 1,
      sym_variable_name,
    STATE(1611), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3017), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1393), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1398), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3023), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48458] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_LBRACE,
    ACTIONS(2965), 1,
      anon_sym_DOLLAR,
    ACTIONS(3027), 1,
      anon_sym_BSLASHu,
    ACTIONS(3029), 1,
      anon_sym_BQUOTE,
    STATE(1509), 1,
      sym_variable_name,
    STATE(1611), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3025), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1379), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3031), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48510] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_LBRACE,
    ACTIONS(3039), 1,
      anon_sym_BSLASHu,
    ACTIONS(3042), 1,
      anon_sym_BQUOTE,
    ACTIONS(3044), 1,
      anon_sym_DOLLAR,
    STATE(1509), 1,
      sym_variable_name,
    STATE(1611), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3036), 2,
      sym_execution_string_chars,
      sym_escape_sequence,
    STATE(1399), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_execution_operator_body,
      sym_dynamic_variable_name,
  [48543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48581] = 13,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(3047), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3049), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(3051), 1,
      aux_sym_enum_declaration_token1,
    ACTIONS(3053), 1,
      aux_sym_class_declaration_token1,
    ACTIONS(3055), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(3057), 1,
      aux_sym__arrow_function_header_token1,
    STATE(2299), 1,
      sym__function_definition_header,
    STATE(2549), 1,
      sym_static_modifier,
    STATE(2575), 1,
      sym_readonly_modifier,
    STATE(1929), 2,
      sym_final_modifier,
      sym_abstract_modifier,
  [48622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48641] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LBRACE,
    ACTIONS(2973), 1,
      anon_sym_BSLASHu,
    ACTIONS(2977), 1,
      anon_sym_DOLLAR,
    ACTIONS(3061), 1,
      anon_sym_DQUOTE,
    STATE(1515), 1,
      sym_variable_name,
    STATE(1605), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(2971), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1413), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [48674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1518), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3067), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48769] = 13,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2473), 1,
      aux_sym_final_modifier_token1,
    ACTIONS(2475), 1,
      aux_sym_abstract_modifier_token1,
    ACTIONS(3047), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3049), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(3055), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(3057), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3069), 1,
      aux_sym_enum_declaration_token1,
    ACTIONS(3071), 1,
      aux_sym_class_declaration_token1,
    STATE(2284), 1,
      sym__function_definition_header,
    STATE(2549), 1,
      sym_static_modifier,
    STATE(2550), 1,
      sym_readonly_modifier,
    STATE(1934), 2,
      sym_final_modifier,
      sym_abstract_modifier,
  [48810] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2969), 1,
      anon_sym_LBRACE,
    ACTIONS(2977), 1,
      anon_sym_DOLLAR,
    ACTIONS(3075), 1,
      anon_sym_BSLASHu,
    ACTIONS(3077), 1,
      anon_sym_DQUOTE,
    STATE(1515), 1,
      sym_variable_name,
    STATE(1605), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3073), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1381), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [48843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1466), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48862] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3079), 1,
      anon_sym_LBRACE,
    ACTIONS(3085), 1,
      anon_sym_BSLASHu,
    ACTIONS(3088), 1,
      anon_sym_DQUOTE,
    ACTIONS(3090), 1,
      anon_sym_DOLLAR,
    STATE(1515), 1,
      sym_variable_name,
    STATE(1605), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3082), 2,
      sym_encapsed_string_chars,
      sym_escape_sequence,
    STATE(1413), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body,
      sym_dynamic_variable_name,
  [48895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3093), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      anon_sym_RBRACE,
      aux_sym_enum_case_token1,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 13,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
      anon_sym_RBRACE,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
      anon_sym_POUND_LBRACK,
  [48933] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_name,
    ACTIONS(3097), 1,
      anon_sym_RBRACK,
    STATE(2398), 1,
      sym_attribute,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1774), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [48967] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_name,
    ACTIONS(3099), 1,
      anon_sym_RBRACK,
    STATE(2398), 1,
      sym_attribute,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1774), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49001] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_name,
    ACTIONS(3101), 1,
      anon_sym_RBRACK,
    STATE(2398), 1,
      sym_attribute,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1774), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49035] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_LBRACE,
    ACTIONS(3107), 1,
      anon_sym_BSLASHu,
    ACTIONS(3109), 1,
      anon_sym_DOLLAR,
    STATE(1448), 1,
      sym_variable_name,
    STATE(1560), 1,
      sym__simple_string_member_access_expression,
    ACTIONS(3105), 2,
      sym_encapsed_string_chars_heredoc,
      sym_escape_sequence,
    STATE(1366), 5,
      sym__complex_string_part,
      sym__simple_string_subscript_expression,
      sym__simple_string_part,
      aux_sym__interpolated_string_body_heredoc,
      sym_dynamic_variable_name,
  [49065] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_AMP,
    ACTIONS(3123), 1,
      anon_sym_PIPE,
    STATE(1439), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1474), 1,
      aux_sym_union_type_repeat1,
    STATE(1520), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3118), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3111), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [49095] = 10,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_name,
    ACTIONS(3125), 1,
      anon_sym_RBRACK,
    STATE(2398), 1,
      sym_attribute,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1774), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49129] = 6,
    ACTIONS(117), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3127), 1,
      sym_integer,
    ACTIONS(113), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(115), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(2230), 5,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [49154] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3129), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3131), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49173] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3133), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1808), 1,
      sym_variable_name,
    STATE(1825), 1,
      sym_static_variable_declaration,
    ACTIONS(1606), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49202] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_name,
    STATE(1953), 1,
      sym_attribute,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1774), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49233] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_name,
    STATE(1930), 1,
      sym_attribute,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1774), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49264] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3133), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(1808), 1,
      sym_variable_name,
    STATE(1813), 1,
      sym_static_variable_declaration,
    ACTIONS(1606), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49293] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_name,
    STATE(2398), 1,
      sym_attribute,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1774), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49324] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(3135), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(3137), 1,
      aux_sym_use_instead_of_clause_token1,
    STATE(582), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49353] = 6,
    ACTIONS(117), 1,
      anon_sym_LT_LT_LT,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3139), 1,
      sym_integer,
    ACTIONS(113), 2,
      aux_sym_encapsed_string_token1,
      anon_sym_DQUOTE,
    ACTIONS(115), 2,
      aux_sym_string_token1,
      anon_sym_SQUOTE,
    STATE(2207), 5,
      sym_encapsed_string,
      sym_string,
      sym_heredoc,
      sym_nowdoc,
      sym__string,
  [49378] = 9,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(3141), 1,
      anon_sym_BSLASH,
    STATE(1762), 1,
      sym_namespace_use_clause,
    STATE(2540), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1686), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49409] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    STATE(1972), 1,
      sym_namespace_use_clause,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1686), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49440] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2983), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(2985), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49459] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1941), 1,
      anon_sym_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3143), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1606), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49484] = 9,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2989), 1,
      sym_name,
    ACTIONS(3145), 1,
      anon_sym_BSLASH,
    STATE(1877), 1,
      sym_namespace_use_clause,
    STATE(2576), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1686), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49515] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3147), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3149), 7,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49534] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(3151), 1,
      anon_sym_COMMA,
    ACTIONS(3153), 1,
      anon_sym_RPAREN,
    STATE(582), 1,
      sym_arguments,
    STATE(1989), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49560] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3155), 1,
      sym_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1597), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49588] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_AMP,
    STATE(1442), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3157), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3159), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [49610] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1787), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49632] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3143), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1606), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49654] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3163), 1,
      anon_sym_AMP,
    STATE(1442), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3161), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3166), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [49676] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3168), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3170), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49694] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3172), 1,
      sym_name,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2628), 1,
      sym_namespace_name_as_prefix,
    STATE(1898), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49722] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3174), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3176), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49740] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3178), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3180), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49758] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3182), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3185), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [49776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3190), 1,
      anon_sym_DASH_GT,
    ACTIONS(3192), 1,
      anon_sym_LBRACK,
    ACTIONS(3196), 1,
      sym_encapsed_string_chars_after_variable_heredoc,
    ACTIONS(3188), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3194), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [49800] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3161), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3166), 6,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [49818] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3198), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1986), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49846] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3200), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(2158), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49874] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(3151), 1,
      anon_sym_COMMA,
    ACTIONS(3202), 1,
      anon_sym_RPAREN,
    STATE(582), 1,
      sym_arguments,
    STATE(2045), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49900] = 7,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(3204), 1,
      anon_sym_RPAREN,
    STATE(582), 1,
      sym_arguments,
    STATE(1913), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49926] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3206), 1,
      sym_name,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
    STATE(1895), 2,
      sym_qualified_name,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [49954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 5,
      sym_encapsed_string_chars_heredoc,
      sym_encapsed_string_chars_after_variable_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
    ACTIONS(1628), 5,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
  [49972] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1588), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [49994] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50017] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3208), 1,
      sym_name,
    ACTIONS(3210), 1,
      anon_sym_LBRACE,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(838), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50040] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(3212), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50061] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3214), 1,
      sym_name,
    ACTIONS(3216), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(577), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50084] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3218), 1,
      sym_name,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(578), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50107] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2805), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [50122] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3222), 1,
      sym_name,
    ACTIONS(3224), 1,
      anon_sym_LBRACE,
    STATE(1556), 1,
      sym__reserved_identifier,
    STATE(702), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50147] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50170] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3226), 1,
      sym_name,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1545), 1,
      sym_reference_modifier,
    STATE(1619), 1,
      sym_formal_parameters,
    STATE(2224), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50197] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3230), 1,
      sym_name,
    ACTIONS(3232), 1,
      anon_sym_LBRACE,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(825), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50220] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3234), 1,
      sym_name,
    ACTIONS(3236), 1,
      anon_sym_LBRACE,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(804), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50243] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3242), 1,
      anon_sym_PIPE,
    STATE(1481), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3240), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3238), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [50264] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(3244), 1,
      anon_sym_EQ,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2985), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2983), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [50287] = 6,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3246), 1,
      sym_name,
    ACTIONS(3250), 1,
      anon_sym_LBRACE,
    ACTIONS(3248), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(647), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50310] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(3252), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50331] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(2573), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50352] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3254), 1,
      sym_name,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    STATE(656), 1,
      sym__reserved_identifier,
    STATE(839), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50377] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3262), 1,
      anon_sym_PIPE,
    STATE(1478), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3260), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3258), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [50398] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3264), 1,
      sym_name,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(690), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50421] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3254), 1,
      sym_name,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    STATE(656), 1,
      sym__reserved_identifier,
    STATE(823), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50446] = 6,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3268), 1,
      sym_name,
    ACTIONS(3270), 1,
      anon_sym_LBRACE,
    ACTIONS(3248), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(646), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50469] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3272), 1,
      anon_sym_PIPE,
    STATE(1478), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3176), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3174), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [50490] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3275), 1,
      sym_name,
    ACTIONS(3277), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(693), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50513] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(2527), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50534] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3242), 1,
      anon_sym_PIPE,
    STATE(1486), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3281), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3279), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [50555] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 1,
      anon_sym_BSLASHu,
    ACTIONS(1626), 8,
      sym_encapsed_string_chars,
      sym_encapsed_string_chars_after_variable,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [50572] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50595] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2809), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [50610] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3283), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(3285), 5,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [50627] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3287), 1,
      anon_sym_PIPE,
    STATE(1486), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3180), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3178), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [50648] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3290), 1,
      sym_name,
    ACTIONS(3292), 1,
      anon_sym_LBRACE,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(818), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50671] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1941), 1,
      anon_sym_COLON,
    ACTIONS(1606), 7,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50690] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3294), 1,
      sym_name,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(849), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50713] = 7,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3254), 1,
      sym_name,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    STATE(656), 1,
      sym__reserved_identifier,
    STATE(575), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50738] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(3298), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [50759] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3254), 1,
      sym_name,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    STATE(656), 1,
      sym__reserved_identifier,
    STATE(687), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50784] = 6,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3300), 1,
      sym_name,
    ACTIONS(3304), 1,
      anon_sym_LBRACE,
    ACTIONS(3302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(603), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50807] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3306), 1,
      sym_name,
    ACTIONS(3308), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(716), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50830] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3310), 1,
      sym_name,
    ACTIONS(3312), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(699), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50853] = 6,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3314), 1,
      sym_name,
    ACTIONS(3318), 1,
      anon_sym_LBRACE,
    ACTIONS(3316), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(769), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50876] = 7,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3222), 1,
      sym_name,
    ACTIONS(3224), 1,
      anon_sym_LBRACE,
    STATE(1556), 1,
      sym__reserved_identifier,
    STATE(1553), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50901] = 7,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3320), 1,
      sym_name,
    ACTIONS(3322), 1,
      anon_sym_LBRACE,
    STATE(841), 1,
      sym__reserved_identifier,
    STATE(767), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50926] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3218), 1,
      sym_name,
    ACTIONS(3220), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(578), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [50949] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3254), 1,
      sym_name,
    ACTIONS(3256), 1,
      anon_sym_LBRACE,
    STATE(656), 1,
      sym__reserved_identifier,
    STATE(698), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50974] = 7,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3326), 1,
      sym_name,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    STATE(711), 1,
      sym__reserved_identifier,
    STATE(648), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [50999] = 6,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3330), 1,
      sym_name,
    ACTIONS(3332), 1,
      anon_sym_LBRACE,
    ACTIONS(3316), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(766), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51022] = 6,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3214), 1,
      sym_name,
    ACTIONS(3216), 1,
      anon_sym_LBRACE,
    ACTIONS(3324), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(577), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51045] = 6,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3334), 1,
      sym_name,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3302), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(597), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51068] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3226), 1,
      sym_name,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1571), 1,
      sym_reference_modifier,
    STATE(1633), 1,
      sym_formal_parameters,
    STATE(2224), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51095] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2791), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [51110] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(582), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51133] = 7,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3338), 1,
      sym_name,
    ACTIONS(3340), 1,
      anon_sym_LBRACE,
    STATE(813), 1,
      sym__reserved_identifier,
    STATE(601), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51158] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_BSLASHu,
    ACTIONS(3342), 1,
      anon_sym_DASH_GT,
    ACTIONS(3344), 1,
      anon_sym_LBRACK,
    ACTIONS(3346), 1,
      sym_execution_string_chars_after_variable,
    ACTIONS(3194), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [51181] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3348), 1,
      sym_name,
    ACTIONS(3350), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(692), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51204] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2799), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [51219] = 7,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3352), 1,
      sym_name,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(1566), 1,
      sym__reserved_identifier,
    STATE(1565), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51244] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2671), 9,
      aux_sym_function_static_declaration_token1,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_final_modifier_token1,
      aux_sym_abstract_modifier_token1,
      aux_sym_readonly_modifier_token1,
      sym_var_modifier,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [51259] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 1,
      anon_sym_BSLASHu,
    ACTIONS(1626), 8,
      sym_execution_string_chars,
      sym_execution_string_chars_after_variable,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [51276] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3188), 1,
      anon_sym_BSLASHu,
    ACTIONS(3356), 1,
      anon_sym_DASH_GT,
    ACTIONS(3358), 1,
      anon_sym_LBRACK,
    ACTIONS(3360), 1,
      sym_encapsed_string_chars_after_variable,
    ACTIONS(3194), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [51299] = 7,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3362), 1,
      sym_name,
    ACTIONS(3364), 1,
      anon_sym_LBRACE,
    STATE(1580), 1,
      sym__reserved_identifier,
    STATE(767), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51324] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3366), 1,
      sym_name,
    ACTIONS(3368), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(715), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51347] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3352), 1,
      sym_name,
    ACTIONS(3354), 1,
      anon_sym_LBRACE,
    STATE(1566), 1,
      sym__reserved_identifier,
    STATE(832), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51372] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(2459), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51393] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3242), 1,
      anon_sym_PIPE,
    STATE(1486), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3372), 3,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_DOLLAR,
    ACTIONS(3370), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51414] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(882), 1,
      sym_arguments,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51437] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(2457), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51458] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3374), 1,
      sym_name,
    ACTIONS(3376), 1,
      anon_sym_LBRACE,
    ACTIONS(2991), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
    STATE(817), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [51481] = 6,
    ACTIONS(971), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3378), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3380), 1,
      aux_sym_finally_clause_token1,
    ACTIONS(969), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    STATE(1530), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [51503] = 5,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_RPAREN,
    STATE(1913), 1,
      aux_sym__list_destructing_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51523] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(928), 1,
      sym_declaration_list,
    STATE(1634), 1,
      sym_arguments,
    STATE(1900), 1,
      sym_base_clause,
    STATE(2211), 1,
      sym_class_interface_clause,
  [51551] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1794), 1,
      sym_named_type,
    STATE(2038), 1,
      sym_type_list,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
  [51579] = 8,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(3390), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    STATE(1357), 1,
      sym_use_list,
    STATE(1641), 1,
      aux_sym_base_clause_repeat1,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [51605] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1078), 1,
      sym_declaration_list,
    STATE(1632), 1,
      sym_arguments,
    STATE(1791), 1,
      sym_base_clause,
    STATE(2338), 1,
      sym_class_interface_clause,
  [51633] = 6,
    ACTIONS(979), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3396), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3399), 1,
      aux_sym_finally_clause_token1,
    ACTIONS(977), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    STATE(1530), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [51655] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1895), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3133), 1,
      aux_sym_namespace_use_declaration_token2,
    ACTIONS(1606), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51675] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    ACTIONS(3404), 1,
      anon_sym_PIPE,
    STATE(1668), 1,
      aux_sym_intersection_type_repeat1,
    STATE(1723), 1,
      aux_sym_union_type_repeat1,
    STATE(1750), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3118), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [51699] = 9,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(1794), 1,
      sym_named_type,
    STATE(2043), 1,
      sym_type_list,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
  [51727] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(964), 1,
      sym_declaration_list,
    STATE(1615), 1,
      sym_arguments,
    STATE(1851), 1,
      sym_base_clause,
    STATE(2345), 1,
      sym_class_interface_clause,
  [51755] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3151), 1,
      anon_sym_COMMA,
    ACTIONS(3202), 1,
      anon_sym_RPAREN,
    STATE(2045), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51775] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3151), 1,
      anon_sym_COMMA,
    ACTIONS(3153), 1,
      anon_sym_RPAREN,
    STATE(1989), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51795] = 9,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_declaration_list,
    STATE(1631), 1,
      sym_arguments,
    STATE(1904), 1,
      sym_base_clause,
    STATE(2409), 1,
      sym_class_interface_clause,
  [51823] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3408), 1,
      anon_sym_DASH,
    ACTIONS(3406), 2,
      sym_integer,
      sym_name,
    STATE(2473), 3,
      sym__simple_string_subscript_unary_expression,
      sym__simple_string_array_access_argument,
      sym_variable_name,
  [51842] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2985), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [51859] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3252), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51874] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3408), 1,
      anon_sym_DASH,
    ACTIONS(3410), 2,
      sym_integer,
      sym_name,
    STATE(2483), 3,
      sym__simple_string_subscript_unary_expression,
      sym__simple_string_array_access_argument,
      sym_variable_name,
  [51893] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51910] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3414), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3417), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3412), 2,
      anon_sym_RBRACE,
      aux_sym_switch_block_token1,
    STATE(1543), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [51929] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51946] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      sym_name,
    STATE(1601), 1,
      sym_formal_parameters,
    STATE(2303), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [51967] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(738), 1,
      sym_arguments,
    ACTIONS(1753), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [51984] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1945), 3,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
    ACTIONS(1943), 4,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [51999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1632), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(1630), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(1622), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3422), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3424), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52044] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3298), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52059] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(794), 1,
      sym_arguments,
    ACTIONS(1753), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52076] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(727), 1,
      sym_arguments,
    ACTIONS(1572), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(1626), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3426), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3428), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52123] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(727), 1,
      sym_arguments,
    ACTIONS(1749), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3430), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3432), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52155] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(3436), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1938), 1,
      sym_namespace_aliasing_clause,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3434), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [52176] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(882), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3438), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(3440), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3442), 3,
      anon_sym_LBRACE,
      anon_sym_BSLASHu,
      anon_sym_DOLLAR,
    ACTIONS(2936), 4,
      sym_encapsed_string_chars_heredoc,
      sym_heredoc_end,
      sym_escape_sequence,
      sym__new_line,
  [52223] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52240] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(854), 1,
      sym_arguments,
    ACTIONS(1753), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52257] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52274] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(895), 1,
      sym_arguments,
    ACTIONS(1572), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52291] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(895), 1,
      sym_arguments,
    ACTIONS(1749), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52308] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3408), 1,
      anon_sym_DASH,
    ACTIONS(3444), 2,
      sym_integer,
      sym_name,
    STATE(2574), 3,
      sym__simple_string_subscript_unary_expression,
      sym__simple_string_array_access_argument,
      sym_variable_name,
  [52327] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52344] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1666), 1,
      anon_sym_LPAREN,
    STATE(628), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52361] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3446), 1,
      anon_sym_AMP,
    ACTIONS(3452), 1,
      anon_sym_PIPE,
    STATE(1724), 1,
      aux_sym_union_type_repeat1,
    STATE(1727), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    STATE(1779), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3118), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [52384] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    ACTIONS(3420), 1,
      sym_name,
    STATE(1587), 1,
      sym_formal_parameters,
    STATE(2303), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52405] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52422] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3135), 1,
      aux_sym_namespace_aliasing_clause_token1,
    ACTIONS(3137), 1,
      aux_sym_use_instead_of_clause_token1,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52439] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3212), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52454] = 8,
    ACTIONS(27), 1,
      anon_sym_BSLASH,
    ACTIONS(563), 1,
      aux_sym_namespace_definition_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1694), 1,
      sym_name,
    STATE(1433), 1,
      sym_qualified_name,
    STATE(2171), 1,
      sym_named_type,
    STATE(2460), 1,
      sym_namespace_name_as_prefix,
    STATE(2627), 1,
      sym_namespace_name,
  [52479] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(795), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52496] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    STATE(882), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52513] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_arguments,
    ACTIONS(1584), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52530] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3454), 1,
      sym_name,
    STATE(1726), 1,
      sym_reference_modifier,
    STATE(2411), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52551] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    STATE(786), 1,
      sym_arguments,
    ACTIONS(1749), 5,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_QMARK_DASH_GT,
      anon_sym_LBRACK,
  [52568] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3456), 1,
      aux_sym_if_statement_token2,
    ACTIONS(3458), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3460), 1,
      aux_sym_else_clause_token1,
    STATE(1646), 1,
      aux_sym_if_statement_repeat2,
    STATE(1990), 1,
      sym_else_if_clause_2,
    STATE(2461), 1,
      sym_else_clause_2,
  [52590] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3458), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3460), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3462), 1,
      aux_sym_if_statement_token2,
    STATE(1644), 1,
      aux_sym_if_statement_repeat2,
    STATE(1990), 1,
      sym_else_if_clause_2,
    STATE(2512), 1,
      sym_else_clause_2,
  [52612] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 1,
      anon_sym_BSLASHu,
    ACTIONS(1630), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [52626] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(919), 1,
      sym_compound_statement,
    STATE(1829), 1,
      sym_anonymous_function_use_clause,
    STATE(2439), 1,
      sym__return_type,
  [52648] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(915), 1,
      sym_compound_statement,
    STATE(1882), 1,
      sym_anonymous_function_use_clause,
    STATE(2268), 1,
      sym__return_type,
  [52670] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym_name,
    STATE(1754), 1,
      sym_const_element,
    STATE(2607), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52688] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1048), 1,
      sym_compound_statement,
    STATE(1765), 1,
      sym_anonymous_function_use_clause,
    STATE(2274), 1,
      sym__return_type,
  [52710] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(910), 1,
      sym_compound_statement,
    STATE(1890), 1,
      sym_anonymous_function_use_clause,
    STATE(2253), 1,
      sym__return_type,
  [52732] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(439), 1,
      sym_declaration_list,
    STATE(1867), 1,
      sym_base_clause,
    STATE(2194), 1,
      sym_class_interface_clause,
  [52754] = 7,
    ACTIONS(987), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3474), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3476), 1,
      aux_sym_else_clause_token1,
    STATE(1616), 1,
      aux_sym_if_statement_repeat1,
    STATE(2100), 1,
      sym_else_clause,
    STATE(2103), 1,
      sym_else_if_clause,
  [52776] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_declaration_list,
    STATE(1768), 1,
      sym_base_clause,
    STATE(2270), 1,
      sym_class_interface_clause,
  [52798] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym_name,
    STATE(1887), 1,
      sym_const_element,
    STATE(2607), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [52816] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1100), 1,
      sym_compound_statement,
    STATE(1837), 1,
      sym_anonymous_function_use_clause,
    STATE(2394), 1,
      sym__return_type,
  [52838] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_BSLASHu,
    ACTIONS(1622), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52852] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1719), 1,
      sym_declaration_list,
    STATE(1830), 1,
      sym_base_clause,
    STATE(2396), 1,
      sym_class_interface_clause,
  [52874] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(449), 1,
      sym_declaration_list,
    STATE(1789), 1,
      sym_base_clause,
    STATE(2323), 1,
      sym_class_interface_clause,
  [52896] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3390), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    STATE(1357), 1,
      sym_use_list,
    STATE(1641), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3388), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [52916] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1632), 1,
      anon_sym_BSLASHu,
    ACTIONS(1630), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [52930] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1070), 1,
      sym_compound_statement,
    STATE(1862), 1,
      sym_anonymous_function_use_clause,
    STATE(2202), 1,
      sym__return_type,
  [52952] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    STATE(2350), 1,
      sym_arguments,
    ACTIONS(3478), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52972] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1098), 1,
      sym_compound_statement,
    STATE(1861), 1,
      sym_anonymous_function_use_clause,
    STATE(2443), 1,
      sym__return_type,
  [52994] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_BSLASHu,
    ACTIONS(1622), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53008] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3426), 1,
      anon_sym_BSLASHu,
    ACTIONS(3428), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53022] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_BSLASHu,
    ACTIONS(3432), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53036] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_BSLASHu,
    ACTIONS(3440), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [53050] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3480), 1,
      anon_sym_RBRACE,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    STATE(1543), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53068] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_BSLASHu,
    ACTIONS(3424), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [53082] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym_name,
    STATE(1798), 1,
      sym_const_element,
    STATE(2607), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53100] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_declaration_list,
    STATE(1757), 1,
      sym_base_clause,
    STATE(2278), 1,
      sym_class_interface_clause,
  [53122] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    STATE(1809), 1,
      aux_sym_base_clause_repeat1,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3488), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [53142] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3438), 1,
      anon_sym_BSLASHu,
    ACTIONS(3440), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53156] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym_name,
    STATE(1985), 1,
      sym_const_element,
    STATE(2607), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53174] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1718), 1,
      sym_declaration_list,
    STATE(1857), 1,
      sym_base_clause,
    STATE(2335), 1,
      sym_class_interface_clause,
  [53196] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3490), 1,
      aux_sym_switch_block_token1,
    STATE(1647), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53214] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(961), 1,
      sym_declaration_list,
    STATE(1831), 1,
      sym_base_clause,
    STATE(2404), 1,
      sym_class_interface_clause,
  [53236] = 7,
    ACTIONS(1001), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3474), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3476), 1,
      aux_sym_else_clause_token1,
    STATE(1715), 1,
      aux_sym_if_statement_repeat1,
    STATE(2083), 1,
      sym_else_clause,
    STATE(2103), 1,
      sym_else_if_clause,
  [53258] = 7,
    ACTIONS(1001), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3492), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3495), 1,
      aux_sym_else_clause_token1,
    STATE(1715), 1,
      aux_sym_if_statement_repeat1,
    STATE(2083), 1,
      sym_else_clause,
    STATE(2103), 1,
      sym_else_if_clause,
  [53280] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3422), 1,
      anon_sym_BSLASHu,
    ACTIONS(3424), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53294] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1072), 1,
      sym_compound_statement,
    STATE(1753), 1,
      sym_anonymous_function_use_clause,
    STATE(2304), 1,
      sym__return_type,
  [53316] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1742), 1,
      sym_declaration_list,
    STATE(1893), 1,
      sym_base_clause,
    STATE(2252), 1,
      sym_class_interface_clause,
  [53338] = 7,
    ACTIONS(987), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3498), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3501), 1,
      aux_sym_else_clause_token1,
    STATE(1617), 1,
      aux_sym_if_statement_repeat1,
    STATE(2100), 1,
      sym_else_clause,
    STATE(2103), 1,
      sym_else_if_clause,
  [53360] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym_name,
    STATE(1821), 1,
      sym_const_element,
    STATE(2607), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53378] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(932), 1,
      sym_compound_statement,
    STATE(1856), 1,
      sym_anonymous_function_use_clause,
    STATE(2352), 1,
      sym__return_type,
  [53400] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3426), 1,
      anon_sym_BSLASHu,
    ACTIONS(3428), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [53414] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3430), 1,
      anon_sym_BSLASHu,
    ACTIONS(3432), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [53428] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3504), 1,
      anon_sym_RBRACE,
    STATE(1643), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53446] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3506), 1,
      aux_sym_switch_block_token1,
    STATE(1638), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53464] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1081), 1,
      sym_compound_statement,
    STATE(1871), 1,
      sym_anonymous_function_use_clause,
    STATE(2375), 1,
      sym__return_type,
  [53486] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(943), 1,
      sym_compound_statement,
    STATE(1885), 1,
      sym_anonymous_function_use_clause,
    STATE(2271), 1,
      sym__return_type,
  [53508] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(441), 1,
      sym_declaration_list,
    STATE(1878), 1,
      sym_base_clause,
    STATE(2381), 1,
      sym_class_interface_clause,
  [53530] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_declaration_list,
    STATE(1788), 1,
      sym_base_clause,
    STATE(2306), 1,
      sym_class_interface_clause,
  [53552] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_declaration_list,
    STATE(1907), 1,
      sym_base_clause,
    STATE(2356), 1,
      sym_class_interface_clause,
  [53574] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1087), 1,
      sym_compound_statement,
    STATE(1883), 1,
      sym_anonymous_function_use_clause,
    STATE(2384), 1,
      sym__return_type,
  [53596] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(920), 1,
      sym_declaration_list,
    STATE(1852), 1,
      sym_base_clause,
    STATE(2344), 1,
      sym_class_interface_clause,
  [53618] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1675), 1,
      sym_declaration_list,
    STATE(1848), 1,
      sym_base_clause,
    STATE(2387), 1,
      sym_class_interface_clause,
  [53640] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1699), 1,
      sym_declaration_list,
    STATE(1834), 1,
      sym_base_clause,
    STATE(2399), 1,
      sym_class_interface_clause,
  [53662] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1050), 1,
      sym_compound_statement,
    STATE(1761), 1,
      sym_anonymous_function_use_clause,
    STATE(2275), 1,
      sym__return_type,
  [53684] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3508), 1,
      aux_sym_switch_block_token1,
    STATE(1543), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53702] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1731), 1,
      sym_declaration_list,
    STATE(1827), 1,
      sym_base_clause,
    STATE(2436), 1,
      sym_class_interface_clause,
  [53724] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 1,
      anon_sym_BSLASHu,
    ACTIONS(1626), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [53738] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3390), 1,
      anon_sym_COMMA,
    ACTIONS(3392), 1,
      anon_sym_LBRACE,
    STATE(1368), 1,
      sym_use_list,
    STATE(1705), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3510), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [53758] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym_name,
    STATE(1872), 1,
      sym_const_element,
    STATE(2607), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53776] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3512), 1,
      anon_sym_RBRACE,
    STATE(1543), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53794] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3458), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3460), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3514), 1,
      aux_sym_if_statement_token2,
    STATE(1688), 1,
      aux_sym_if_statement_repeat2,
    STATE(1990), 1,
      sym_else_if_clause_2,
    STATE(2496), 1,
      sym_else_clause_2,
  [53816] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1628), 1,
      anon_sym_BSLASHu,
    ACTIONS(1626), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53830] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3458), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3460), 1,
      aux_sym_else_clause_token1,
    ACTIONS(3516), 1,
      aux_sym_if_statement_token2,
    STATE(1688), 1,
      aux_sym_if_statement_repeat2,
    STATE(1990), 1,
      sym_else_if_clause_2,
    STATE(2518), 1,
      sym_else_clause_2,
  [53852] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3518), 1,
      aux_sym_switch_block_token1,
    STATE(1543), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53870] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3468), 1,
      sym_name,
    STATE(1910), 1,
      sym_const_element,
    STATE(2607), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [53888] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3520), 1,
      anon_sym_BSLASHu,
    ACTIONS(3088), 5,
      sym_encapsed_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR,
  [53902] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3482), 1,
      aux_sym_enum_case_token1,
    ACTIONS(3484), 1,
      aux_sym_match_default_expression_token1,
    ACTIONS(3522), 1,
      anon_sym_RBRACE,
    STATE(1606), 3,
      sym_case_statement,
      sym_default_statement,
      aux_sym_switch_block_repeat1,
  [53920] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3524), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [53936] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(922), 1,
      sym_compound_statement,
    STATE(1824), 1,
      sym_anonymous_function_use_clause,
    STATE(2429), 1,
      sym__return_type,
  [53958] = 7,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_declaration_list,
    STATE(1908), 1,
      sym_base_clause,
    STATE(2388), 1,
      sym_class_interface_clause,
  [53980] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3526), 1,
      anon_sym_BSLASHu,
    ACTIONS(3042), 5,
      sym_execution_string_chars,
      anon_sym_LBRACE,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR,
  [53994] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(951), 1,
      sym_compound_statement,
    STATE(1842), 1,
      sym_anonymous_function_use_clause,
    STATE(2393), 1,
      sym__return_type,
  [54016] = 7,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3464), 1,
      aux_sym_namespace_use_declaration_token1,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(952), 1,
      sym_compound_statement,
    STATE(1840), 1,
      sym_anonymous_function_use_clause,
    STATE(2397), 1,
      sym__return_type,
  [54038] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3378), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3380), 1,
      aux_sym_finally_clause_token1,
    STATE(1524), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [54053] = 4,
    ACTIONS(1134), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1132), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3528), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54068] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1629), 1,
      sym_formal_parameters,
    STATE(2325), 1,
      sym_reference_modifier,
  [54087] = 5,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_BSLASH,
    STATE(549), 1,
      sym_compound_statement,
    ACTIONS(3530), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54104] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    ACTIONS(3534), 1,
      anon_sym_LBRACE,
    STATE(2040), 1,
      aux_sym_base_clause_repeat1,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
  [54123] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3536), 1,
      anon_sym_AMP,
    STATE(1662), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3166), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54138] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3539), 1,
      anon_sym_PIPE,
    STATE(1663), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3176), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54153] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3542), 1,
      sym_name,
    ACTIONS(3544), 1,
      anon_sym_LBRACE,
    ACTIONS(3546), 1,
      anon_sym_DOLLAR,
    STATE(1583), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54170] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3548), 1,
      anon_sym_PIPE,
    STATE(1665), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3180), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54185] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_BSLASH,
    STATE(1666), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3551), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [54200] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3558), 1,
      anon_sym_BSLASH,
    STATE(1693), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3556), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54215] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3402), 1,
      anon_sym_AMP,
    STATE(1662), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3159), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54230] = 6,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3561), 1,
      sym_name,
    ACTIONS(3563), 1,
      anon_sym_BSLASH,
    STATE(1690), 1,
      sym_namespace_name,
    STATE(2144), 1,
      sym_compound_statement,
  [54249] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    STATE(1685), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3281), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [54264] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3567), 1,
      anon_sym_LBRACE,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3571), 1,
      anon_sym_DASH_GT,
    ACTIONS(3573), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3575), 1,
      anon_sym_LBRACK,
  [54283] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3577), 1,
      anon_sym_AMP,
    ACTIONS(3579), 1,
      anon_sym_RPAREN,
    STATE(2184), 2,
      sym_variable_name,
      sym_variable_reference,
  [54300] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3583), 1,
      anon_sym_BSLASH,
    STATE(1666), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3581), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [54315] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_PIPE,
    STATE(1748), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3240), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54330] = 4,
    ACTIONS(1064), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1062), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3587), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54345] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3589), 1,
      sym_name,
    ACTIONS(3591), 1,
      anon_sym_LBRACE,
    ACTIONS(3593), 1,
      anon_sym_DOLLAR,
    STATE(1598), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54362] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COLON,
    STATE(2095), 1,
      sym__return_type,
    ACTIONS(3595), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54377] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3599), 1,
      sym_name,
    ACTIONS(3601), 1,
      anon_sym_LBRACE,
    ACTIONS(3603), 1,
      anon_sym_DOLLAR,
    STATE(1548), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54394] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_EQ,
    STATE(2156), 1,
      sym_property_initializer,
    ACTIONS(3605), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [54409] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    ACTIONS(3611), 1,
      anon_sym_COLON,
    STATE(2097), 1,
      sym_enum_declaration_list,
    STATE(2430), 1,
      sym_class_interface_clause,
  [54428] = 4,
    ACTIONS(1058), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1056), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3613), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54443] = 5,
    ACTIONS(609), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3615), 1,
      sym_name,
    ACTIONS(3617), 1,
      anon_sym_LBRACE,
    STATE(587), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54460] = 3,
    ACTIONS(1025), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1023), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [54473] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3583), 1,
      anon_sym_BSLASH,
    STATE(1673), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3556), 3,
      anon_sym_COMMA,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [54488] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3619), 1,
      anon_sym_PIPE,
    STATE(1685), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3180), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [54503] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3436), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(1938), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3434), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [54518] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3622), 1,
      anon_sym_PIPE,
    STATE(1687), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3176), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [54533] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3625), 1,
      aux_sym_if_statement_token2,
    ACTIONS(3627), 1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3630), 1,
      aux_sym_else_clause_token1,
    STATE(1688), 1,
      aux_sym_if_statement_repeat2,
    STATE(1990), 1,
      sym_else_if_clause_2,
  [54552] = 4,
    ACTIONS(1150), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1148), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3632), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54567] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_BSLASH,
    STATE(2132), 1,
      sym_compound_statement,
    ACTIONS(3634), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54584] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    ACTIONS(3638), 1,
      anon_sym_COLON,
    STATE(537), 1,
      sym_enum_declaration_list,
    STATE(2382), 1,
      sym_class_interface_clause,
  [54603] = 4,
    ACTIONS(1040), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1038), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3640), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54618] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3642), 1,
      anon_sym_BSLASH,
    STATE(1717), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3581), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54633] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3645), 1,
      anon_sym_LBRACE,
    ACTIONS(3647), 1,
      anon_sym_DASH_GT,
    ACTIONS(3649), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3651), 1,
      anon_sym_LBRACK,
  [54652] = 3,
    ACTIONS(1021), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1019), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [54665] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    ACTIONS(3653), 1,
      anon_sym_COLON,
    STATE(2127), 1,
      sym_enum_declaration_list,
    STATE(2256), 1,
      sym_class_interface_clause,
  [54684] = 4,
    ACTIONS(1144), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1142), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3655), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54699] = 4,
    ACTIONS(1122), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1120), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3657), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54714] = 4,
    ACTIONS(1046), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1044), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3659), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [54729] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3524), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [54744] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3661), 1,
      anon_sym_LBRACE,
    ACTIONS(3663), 1,
      anon_sym_DASH_GT,
    ACTIONS(3665), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3667), 1,
      anon_sym_LBRACK,
  [54763] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1779), 1,
      anon_sym_DOLLAR,
    ACTIONS(3669), 1,
      sym_name,
    ACTIONS(3671), 1,
      anon_sym_LBRACE,
    STATE(876), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54780] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3661), 1,
      anon_sym_LBRACE,
    ACTIONS(3667), 1,
      anon_sym_LBRACK,
    ACTIONS(3673), 1,
      anon_sym_DASH_GT,
    ACTIONS(3675), 1,
      anon_sym_QMARK_DASH_GT,
  [54799] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1921), 1,
      sym_formal_parameters,
    STATE(2280), 1,
      sym_reference_modifier,
  [54818] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3677), 1,
      anon_sym_COMMA,
    STATE(1705), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3524), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [54833] = 5,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3680), 1,
      sym_name,
    ACTIONS(3682), 1,
      anon_sym_LBRACE,
    STATE(626), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54850] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_LBRACE,
    ACTIONS(3603), 1,
      anon_sym_DOLLAR,
    ACTIONS(3684), 1,
      sym_name,
    STATE(1548), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54867] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3686), 1,
      sym_name,
    STATE(1869), 1,
      sym_namespace_name,
    STATE(2023), 1,
      sym_namespace_use_group_clause,
    ACTIONS(3688), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
  [54884] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_DOLLAR,
    ACTIONS(3690), 1,
      sym_name,
    ACTIONS(3692), 1,
      anon_sym_LBRACE,
    STATE(741), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54901] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3591), 1,
      anon_sym_LBRACE,
    ACTIONS(3593), 1,
      anon_sym_DOLLAR,
    ACTIONS(3694), 1,
      sym_name,
    STATE(1598), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54918] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3696), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2032), 1,
      sym_reference_modifier,
    STATE(2033), 1,
      sym_variable_name,
  [54937] = 5,
    ACTIONS(1552), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3698), 1,
      sym_name,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
    STATE(782), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54954] = 5,
    ACTIONS(1546), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3702), 1,
      sym_name,
    ACTIONS(3704), 1,
      anon_sym_LBRACE,
    STATE(663), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [54971] = 3,
    ACTIONS(1029), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1027), 4,
      aux_sym_catch_clause_token1,
      aux_sym_finally_clause_token1,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [54984] = 6,
    ACTIONS(1031), 1,
      aux_sym_while_statement_token1,
    ACTIONS(1033), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3706), 1,
      aux_sym_else_if_clause_token1,
    STATE(1715), 1,
      aux_sym_if_statement_repeat1,
    STATE(2103), 1,
      sym_else_if_clause,
  [55003] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3597), 1,
      anon_sym_COLON,
    STATE(2114), 1,
      sym__return_type,
    ACTIONS(3709), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55018] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3711), 1,
      anon_sym_BSLASH,
    STATE(1717), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(3551), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55033] = 4,
    ACTIONS(1070), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1068), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3714), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55048] = 4,
    ACTIONS(1110), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1108), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3716), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55063] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3718), 1,
      anon_sym_LBRACE,
    ACTIONS(3720), 1,
      anon_sym_DASH_GT,
    ACTIONS(3722), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3724), 1,
      anon_sym_LBRACK,
  [55082] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3726), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1976), 1,
      sym_reference_modifier,
    STATE(1977), 1,
      sym_variable_name,
  [55101] = 4,
    ACTIONS(1086), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1084), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3728), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55116] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_PIPE,
    STATE(1663), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3260), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55131] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3732), 1,
      anon_sym_PIPE,
    STATE(1687), 1,
      aux_sym_union_type_repeat1,
    ACTIONS(3260), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55146] = 4,
    ACTIONS(1092), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1090), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3734), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55161] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3736), 1,
      sym_name,
    STATE(2289), 1,
      sym__reserved_identifier,
    ACTIONS(2341), 3,
      aux_sym_function_static_declaration_token1,
      anon_sym_self,
      anon_sym_parent,
  [55176] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    STATE(1685), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3372), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55191] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2985), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [55202] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3661), 1,
      anon_sym_LBRACE,
    ACTIONS(3667), 1,
      anon_sym_LBRACK,
    ACTIONS(3738), 1,
      anon_sym_DASH_GT,
    ACTIONS(3740), 1,
      anon_sym_QMARK_DASH_GT,
  [55221] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3742), 1,
      anon_sym_LBRACE,
    ACTIONS(3744), 1,
      anon_sym_DASH_GT,
    ACTIONS(3746), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
  [55240] = 4,
    ACTIONS(1080), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1078), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3750), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55255] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3742), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3752), 1,
      anon_sym_DASH_GT,
    ACTIONS(3754), 1,
      anon_sym_QMARK_DASH_GT,
  [55274] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3756), 1,
      sym_name,
    STATE(2157), 1,
      sym_visibility_modifier,
    ACTIONS(3758), 3,
      aux_sym_visibility_modifier_token1,
      aux_sym_visibility_modifier_token2,
      aux_sym_visibility_modifier_token3,
  [55289] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3149), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [55300] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    STATE(1670), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3240), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55315] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3544), 1,
      anon_sym_LBRACE,
    ACTIONS(3546), 1,
      anon_sym_DOLLAR,
    ACTIONS(3760), 1,
      sym_name,
    STATE(1583), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [55332] = 6,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3561), 1,
      sym_name,
    ACTIONS(3563), 1,
      anon_sym_BSLASH,
    STATE(471), 1,
      sym_compound_statement,
    STATE(1660), 1,
      sym_namespace_name,
  [55351] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3762), 1,
      anon_sym_LBRACE,
    ACTIONS(3764), 1,
      anon_sym_DASH_GT,
    ACTIONS(3766), 1,
      anon_sym_QMARK_DASH_GT,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
  [55370] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3686), 1,
      sym_name,
    STATE(1869), 1,
      sym_namespace_name,
    STATE(2191), 1,
      sym_namespace_use_group_clause,
    ACTIONS(3688), 2,
      aux_sym_namespace_use_declaration_token2,
      aux_sym_namespace_use_declaration_token3,
  [55387] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3742), 1,
      anon_sym_LBRACE,
    ACTIONS(3748), 1,
      anon_sym_LBRACK,
    ACTIONS(3770), 1,
      anon_sym_DASH_GT,
    ACTIONS(3772), 1,
      anon_sym_QMARK_DASH_GT,
  [55406] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3577), 1,
      anon_sym_AMP,
    ACTIONS(3774), 1,
      anon_sym_RPAREN,
    STATE(2184), 2,
      sym_variable_name,
      sym_variable_reference,
  [55423] = 4,
    ACTIONS(1128), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1126), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3776), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55438] = 4,
    ACTIONS(1116), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1114), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3778), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55453] = 4,
    ACTIONS(1098), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1096), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3780), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55468] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3782), 1,
      aux_sym_catch_clause_token1,
    ACTIONS(3784), 1,
      aux_sym_finally_clause_token1,
    STATE(422), 3,
      sym_catch_clause,
      sym_finally_clause,
      aux_sym_try_statement_repeat1,
  [55483] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    ACTIONS(3786), 1,
      anon_sym_COLON,
    STATE(510), 1,
      sym_enum_declaration_list,
    STATE(2322), 1,
      sym_class_interface_clause,
  [55502] = 4,
    ACTIONS(1104), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1102), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3788), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55517] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_PIPE,
    STATE(1665), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3281), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55532] = 4,
    ACTIONS(1052), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1050), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
    ACTIONS(3790), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55547] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3585), 1,
      anon_sym_PIPE,
    STATE(1665), 1,
      aux_sym_disjunctive_normal_form_type_repeat1,
    ACTIONS(3372), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [55562] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3131), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [55573] = 6,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3762), 1,
      anon_sym_LBRACE,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
    ACTIONS(3792), 1,
      anon_sym_DASH_GT,
    ACTIONS(3794), 1,
      anon_sym_QMARK_DASH_GT,
  [55592] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1034), 1,
      sym_compound_statement,
    STATE(2441), 1,
      sym__return_type,
  [55608] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1865), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3796), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55622] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3180), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [55632] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3551), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LBRACE,
  [55642] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_declaration_list,
    STATE(2203), 1,
      sym_class_interface_clause,
  [55658] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3800), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55672] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3802), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [55682] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3804), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55696] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1073), 1,
      sym_compound_statement,
    STATE(2200), 1,
      sym__return_type,
  [55712] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1902), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3804), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55726] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    STATE(1845), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3808), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55740] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_COMMA,
    STATE(1844), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3812), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55754] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1075), 1,
      sym_compound_statement,
    STATE(2199), 1,
      sym__return_type,
  [55770] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1962), 1,
      sym_formal_parameters,
    STATE(2386), 1,
      sym_reference_modifier,
  [55786] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    STATE(535), 1,
      sym_enum_declaration_list,
    STATE(2198), 1,
      sym_class_interface_clause,
  [55802] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(442), 1,
      sym_declaration_list,
    STATE(2195), 1,
      sym_class_interface_clause,
  [55818] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1961), 1,
      sym_formal_parameters,
    STATE(2379), 1,
      sym_reference_modifier,
  [55834] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3816), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [55848] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1588), 1,
      sym_formal_parameters,
    STATE(2286), 1,
      sym_reference_modifier,
  [55864] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3047), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3057), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3818), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(2549), 1,
      sym_static_modifier,
  [55880] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 1,
      anon_sym_SQUOTE,
    ACTIONS(3822), 1,
      aux_sym_string_token2,
    ACTIONS(3824), 1,
      sym_string_value,
    STATE(1799), 1,
      aux_sym_string_repeat1,
  [55896] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    STATE(2350), 1,
      sym_arguments,
    ACTIONS(3478), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [55910] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2539), 1,
      sym_declare_directive,
    ACTIONS(3826), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [55922] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3830), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(2192), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3828), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [55936] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2508), 1,
      sym_declare_directive,
    ACTIONS(3826), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [55948] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3057), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(3832), 1,
      aux_sym_function_static_declaration_token1,
    ACTIONS(3834), 1,
      aux_sym_namespace_use_declaration_token2,
    STATE(2549), 1,
      sym_static_modifier,
  [55964] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3836), 1,
      anon_sym_AMP,
    STATE(1793), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3159), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [55978] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1629), 1,
      sym_formal_parameters,
    STATE(2325), 1,
      sym_reference_modifier,
  [55994] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    ACTIONS(3839), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      sym_declaration_list,
    STATE(2314), 1,
      sym_base_clause,
  [56010] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1787), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3841), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56024] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3843), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [56034] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3845), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56048] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3802), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [56058] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1633), 1,
      sym_formal_parameters,
    STATE(2319), 1,
      sym_reference_modifier,
  [56074] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56088] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1054), 1,
      sym_declaration_list,
    STATE(2217), 1,
      sym_class_interface_clause,
  [56104] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(436), 1,
      sym_declaration_list,
    STATE(2437), 1,
      sym_class_interface_clause,
  [56120] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1652), 1,
      sym_formal_parameters,
    STATE(2435), 1,
      sym_reference_modifier,
  [56136] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_declaration_list,
    STATE(2356), 1,
      sym_class_interface_clause,
  [56152] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1656), 1,
      sym_formal_parameters,
    STATE(2329), 1,
      sym_reference_modifier,
  [56168] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3849), 1,
      anon_sym_AMP,
    STATE(1793), 1,
      aux_sym_intersection_type_repeat1,
    ACTIONS(3166), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [56182] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3854), 1,
      anon_sym_PIPE,
    STATE(1849), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3852), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [56196] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3856), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [56206] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3858), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56220] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3860), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [56230] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1770), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3862), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_SQUOTE,
    ACTIONS(3866), 1,
      aux_sym_string_token2,
    ACTIONS(3869), 1,
      sym_string_value,
    STATE(1799), 1,
      aux_sym_string_repeat1,
  [56260] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1760), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3872), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56274] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3166), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_LBRACE,
  [56284] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3185), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [56294] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3551), 4,
      anon_sym_COMMA,
      anon_sym_BSLASH,
      aux_sym_namespace_aliasing_clause_token1,
      anon_sym_RBRACE,
  [56304] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(3563), 1,
      anon_sym_BSLASH,
    ACTIONS(3874), 1,
      sym_name,
    STATE(2606), 1,
      sym_namespace_name,
  [56320] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3876), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56334] = 5,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_EQ,
    ACTIONS(3880), 1,
      anon_sym_RPAREN,
    STATE(2000), 1,
      aux_sym__list_destructing_repeat1,
  [56350] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    STATE(1763), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3882), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56364] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3886), 1,
      anon_sym_EQ,
    ACTIONS(3884), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [56376] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3888), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [56390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3890), 1,
      anon_sym_SQUOTE,
    ACTIONS(3892), 1,
      aux_sym_string_token2,
    ACTIONS(3894), 1,
      sym_string_value,
    STATE(1863), 1,
      aux_sym_string_repeat1,
  [56406] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1692), 4,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [56416] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1805), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56430] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_COMMA,
    STATE(1764), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3896), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56444] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1593), 1,
      sym_formal_parameters,
    STATE(2182), 1,
      sym_reference_modifier,
  [56460] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1796), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3898), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56474] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1880), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3900), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56488] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3904), 1,
      anon_sym_SEMI,
    ACTIONS(3906), 1,
      anon_sym_LBRACE,
    ACTIONS(3908), 1,
      sym__automatic_semicolon,
    STATE(1362), 1,
      sym_compound_statement,
  [56504] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3577), 1,
      anon_sym_AMP,
    STATE(2184), 2,
      sym_variable_name,
      sym_variable_reference,
  [56518] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3910), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56532] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3912), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56546] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1836), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3914), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56560] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1637), 1,
      sym_formal_parameters,
    STATE(2385), 1,
      sym_reference_modifier,
  [56576] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_LBRACE,
    ACTIONS(3916), 1,
      anon_sym_SEMI,
    ACTIONS(3918), 1,
      sym__automatic_semicolon,
    STATE(1358), 1,
      sym_compound_statement,
  [56592] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(925), 1,
      sym_compound_statement,
    STATE(2392), 1,
      sym__return_type,
  [56608] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_COMMA,
    STATE(1875), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3920), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56622] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    STATE(1876), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3922), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56636] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_declaration_list,
    STATE(2390), 1,
      sym_class_interface_clause,
  [56652] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1879), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3924), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56666] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(907), 1,
      sym_compound_statement,
    STATE(2380), 1,
      sym__return_type,
  [56682] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1689), 1,
      sym_declaration_list,
    STATE(2400), 1,
      sym_class_interface_clause,
  [56698] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(931), 1,
      sym_declaration_list,
    STATE(2366), 1,
      sym_class_interface_clause,
  [56714] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1888), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3926), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56728] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(2021), 1,
      sym_formal_parameters,
    STATE(2377), 1,
      sym_reference_modifier,
  [56744] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1744), 1,
      sym_declaration_list,
    STATE(2358), 1,
      sym_class_interface_clause,
  [56760] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3384), 1,
      aux_sym_base_clause_token1,
    STATE(2128), 1,
      sym_declaration_list,
    STATE(2259), 1,
      sym_base_clause,
  [56776] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3928), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56790] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1068), 1,
      sym_compound_statement,
    STATE(2374), 1,
      sym__return_type,
  [56806] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1619), 1,
      sym_formal_parameters,
    STATE(2251), 1,
      sym_reference_modifier,
  [56822] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2556), 1,
      sym_declare_directive,
    ACTIONS(3826), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [56834] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(935), 1,
      sym_compound_statement,
    STATE(2351), 1,
      sym__return_type,
  [56850] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1891), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3930), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56864] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(937), 1,
      sym_compound_statement,
    STATE(2346), 1,
      sym__return_type,
  [56880] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    STATE(2058), 1,
      sym_enum_declaration_list,
    STATE(2343), 1,
      sym_class_interface_clause,
  [56896] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3934), 1,
      anon_sym_COMMA,
    STATE(1844), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3932), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56910] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3939), 1,
      anon_sym_COMMA,
    STATE(1845), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3937), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56924] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3524), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [56938] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3947), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3945), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [56952] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym_declaration_list,
    STATE(2340), 1,
      sym_class_interface_clause,
  [56968] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3854), 1,
      anon_sym_PIPE,
    STATE(1897), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3950), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [56982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3952), 1,
      anon_sym_SQUOTE,
    ACTIONS(3954), 1,
      aux_sym_string_token2,
    ACTIONS(3956), 1,
      sym_string_value,
    STATE(1773), 1,
      aux_sym_string_repeat1,
  [56998] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(961), 1,
      sym_declaration_list,
    STATE(2404), 1,
      sym_class_interface_clause,
  [57014] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(963), 1,
      sym_declaration_list,
    STATE(2405), 1,
      sym_class_interface_clause,
  [57030] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3860), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [57040] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1819), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3958), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57054] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_LBRACE,
    ACTIONS(3960), 1,
      anon_sym_SEMI,
    ACTIONS(3962), 1,
      sym__automatic_semicolon,
    STATE(1360), 1,
      sym_compound_statement,
  [57070] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(942), 1,
      sym_compound_statement,
    STATE(2326), 1,
      sym__return_type,
  [57086] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1697), 1,
      sym_declaration_list,
    STATE(2320), 1,
      sym_class_interface_clause,
  [57102] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2580), 1,
      sym_declare_directive,
    ACTIONS(3826), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [57114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3966), 1,
      sym_nowdoc_string,
    STATE(1903), 1,
      aux_sym_nowdoc_body_repeat1,
    ACTIONS(3964), 2,
      sym_heredoc_end,
      sym__new_line,
  [57128] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_AMP,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1921), 1,
      sym_formal_parameters,
    STATE(2280), 1,
      sym_reference_modifier,
  [57144] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1058), 1,
      sym_compound_statement,
    STATE(2349), 1,
      sym__return_type,
  [57160] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1049), 1,
      sym_compound_statement,
    STATE(2218), 1,
      sym__return_type,
  [57176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 1,
      aux_sym_string_token2,
    ACTIONS(3824), 1,
      sym_string_value,
    ACTIONS(3968), 1,
      anon_sym_SQUOTE,
    STATE(1799), 1,
      aux_sym_string_repeat1,
  [57192] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(3577), 1,
      anon_sym_AMP,
    STATE(2035), 2,
      sym_variable_name,
      sym_variable_reference,
  [57206] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3970), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57220] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3898), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57234] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_declaration_list,
    STATE(2219), 1,
      sym_class_interface_clause,
  [57250] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3972), 4,
      aux_sym_namespace_use_declaration_token1,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [57260] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3830), 1,
      aux_sym_namespace_aliasing_clause_token1,
    STATE(2263), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(3974), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [57274] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3978), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3976), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57288] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1077), 1,
      sym_compound_statement,
    STATE(2267), 1,
      sym__return_type,
  [57304] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1784), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3981), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57318] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    STATE(2092), 1,
      sym_enum_declaration_list,
    STATE(2431), 1,
      sym_class_interface_clause,
  [57334] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3972), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [57344] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_COMMA,
    STATE(1844), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(3983), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57358] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3810), 1,
      anon_sym_COMMA,
    STATE(1845), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(3985), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57372] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1886), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3987), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57386] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(437), 1,
      sym_declaration_list,
    STATE(2272), 1,
      sym_class_interface_clause,
  [57402] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3987), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57416] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3989), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57430] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3991), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57444] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(918), 1,
      sym_compound_statement,
    STATE(2438), 1,
      sym__return_type,
  [57460] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1038), 1,
      sym_compound_statement,
    STATE(2273), 1,
      sym__return_type,
  [57476] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1905), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(3993), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57490] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(949), 1,
      sym_compound_statement,
    STATE(2283), 1,
      sym__return_type,
  [57506] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(3995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57520] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1881), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3997), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57534] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3999), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57548] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4003), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(4001), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57562] = 5,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    STATE(904), 1,
      sym_compound_statement,
    STATE(2444), 1,
      sym__return_type,
  [57578] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(4006), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57592] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_LBRACE,
    ACTIONS(4008), 1,
      anon_sym_SEMI,
    ACTIONS(4010), 1,
      sym__automatic_semicolon,
    STATE(1376), 1,
      sym_compound_statement,
  [57608] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_declaration_list,
    STATE(2296), 1,
      sym_class_interface_clause,
  [57624] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3176), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [57634] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    STATE(1809), 1,
      aux_sym_base_clause_repeat1,
    ACTIONS(3488), 2,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [57648] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    STATE(490), 1,
      sym_enum_declaration_list,
    STATE(2336), 1,
      sym_class_interface_clause,
  [57664] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4014), 1,
      anon_sym_PIPE,
    STATE(1897), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(4012), 2,
      anon_sym_RPAREN,
      anon_sym_DOLLAR,
  [57678] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3524), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [57688] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3170), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PIPE,
  [57698] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    STATE(920), 1,
      sym_declaration_list,
    STATE(2344), 1,
      sym_class_interface_clause,
  [57714] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3843), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [57724] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3806), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(4017), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4021), 1,
      sym_nowdoc_string,
    STATE(1903), 1,
      aux_sym_nowdoc_body_repeat1,
    ACTIONS(4019), 2,
      sym_heredoc_end,
      sym__new_line,
  [57752] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_declaration_list,
    STATE(2306), 1,
      sym_class_interface_clause,
  [57768] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(4024), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57782] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4026), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [57792] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1111), 1,
      sym_declaration_list,
    STATE(2307), 1,
      sym_class_interface_clause,
  [57808] = 5,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3386), 1,
      aux_sym_class_interface_clause_token1,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_declaration_list,
    STATE(2279), 1,
      sym_class_interface_clause,
  [57824] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1820), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(3999), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57838] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1758), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(4028), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57852] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3798), 1,
      anon_sym_COMMA,
    STATE(1866), 1,
      aux_sym__const_declaration_repeat1,
    ACTIONS(4030), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [57866] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_EQ,
    ACTIONS(4032), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [57877] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4034), 1,
      anon_sym_RPAREN,
    STATE(2002), 1,
      aux_sym__list_destructing_repeat1,
  [57890] = 3,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1807), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [57901] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4036), 1,
      anon_sym_DQUOTE,
    ACTIONS(4038), 1,
      anon_sym_SQUOTE,
    ACTIONS(4040), 1,
      sym_heredoc_start,
  [57914] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_COMMA,
    ACTIONS(4044), 1,
      anon_sym_RPAREN,
    STATE(1966), 1,
      aux_sym_arguments_repeat1,
  [57927] = 4,
    ACTIONS(843), 1,
      anon_sym_RBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4046), 1,
      anon_sym_COMMA,
    STATE(2005), 1,
      aux_sym_array_creation_expression_repeat1,
  [57940] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3055), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4048), 1,
      aux_sym_class_declaration_token1,
    STATE(2445), 1,
      sym_readonly_modifier,
  [57953] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3099), 1,
      anon_sym_RBRACK,
    ACTIONS(4050), 1,
      anon_sym_COMMA,
    STATE(2007), 1,
      aux_sym_attribute_group_repeat1,
  [57966] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3563), 1,
      anon_sym_BSLASH,
    ACTIONS(3874), 1,
      sym_name,
    STATE(2606), 1,
      sym_namespace_name,
  [57979] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4052), 1,
      anon_sym_EQ_GT,
    STATE(2513), 1,
      sym__return_type,
  [57992] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COMMA,
    ACTIONS(4057), 1,
      anon_sym_RPAREN,
    STATE(1922), 1,
      aux_sym_array_creation_expression_repeat1,
  [58005] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4059), 1,
      anon_sym_COMMA,
    ACTIONS(4061), 1,
      anon_sym_RPAREN,
    STATE(1942), 1,
      aux_sym_array_creation_expression_repeat1,
  [58018] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4063), 1,
      anon_sym_LBRACE,
    ACTIONS(4065), 1,
      anon_sym_COLON,
    STATE(530), 1,
      sym_switch_block,
  [58031] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_EQ,
    ACTIONS(4067), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [58042] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4069), 1,
      anon_sym_COMMA,
    ACTIONS(4071), 1,
      anon_sym_RBRACK,
    STATE(1952), 1,
      aux_sym__array_destructing_repeat1,
  [58055] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4073), 1,
      anon_sym_COMMA,
    ACTIONS(4075), 1,
      anon_sym_RBRACK,
    STATE(1954), 1,
      aux_sym_array_creation_expression_repeat1,
  [58068] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4069), 1,
      anon_sym_COMMA,
    ACTIONS(4071), 1,
      anon_sym_RBRACK,
    STATE(1957), 1,
      aux_sym__array_destructing_repeat1,
  [58081] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3055), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4077), 1,
      aux_sym_class_declaration_token1,
    STATE(2584), 1,
      sym_readonly_modifier,
  [58094] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4079), 1,
      anon_sym_COMMA,
    ACTIONS(4081), 1,
      anon_sym_RBRACK,
    STATE(1958), 1,
      aux_sym_attribute_group_repeat1,
  [58107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 1,
      sym__new_line,
    ACTIONS(4085), 1,
      sym_heredoc_end,
    STATE(2355), 1,
      sym_heredoc_body,
  [58120] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1769), 1,
      anon_sym_RPAREN,
    ACTIONS(4087), 1,
      anon_sym_COMMA,
    STATE(2029), 1,
      aux_sym_formal_parameters_repeat1,
  [58133] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3055), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4089), 1,
      aux_sym_class_declaration_token1,
    STATE(2572), 1,
      sym_readonly_modifier,
  [58146] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3055), 1,
      aux_sym_readonly_modifier_token1,
    ACTIONS(4091), 1,
      aux_sym_class_declaration_token1,
    STATE(2475), 1,
      sym_readonly_modifier,
  [58159] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    STATE(1808), 1,
      sym_variable_name,
    STATE(1965), 1,
      sym_static_variable_declaration,
  [58172] = 3,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1967), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [58183] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4093), 1,
      anon_sym_COMMA,
    ACTIONS(4095), 1,
      anon_sym_RPAREN,
    STATE(1932), 1,
      aux_sym_formal_parameters_repeat1,
  [58196] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4097), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58205] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4099), 1,
      sym_name,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    STATE(2413), 1,
      sym_namespace_use_group,
  [58218] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4103), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1973), 1,
      sym_variable_name,
  [58231] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4105), 1,
      anon_sym_COMMA,
    ACTIONS(4107), 1,
      anon_sym_RPAREN,
    STATE(1975), 1,
      aux_sym_formal_parameters_repeat1,
  [58244] = 4,
    ACTIONS(831), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4109), 1,
      anon_sym_COMMA,
    STATE(1922), 1,
      aux_sym_array_creation_expression_repeat1,
  [58257] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4113), 1,
      anon_sym_EQ,
    ACTIONS(4111), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58268] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3709), 1,
      anon_sym_LBRACE,
    STATE(2447), 1,
      sym__return_type,
  [58281] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3116), 1,
      anon_sym_AMP,
    ACTIONS(4115), 1,
      anon_sym_RPAREN,
    STATE(1439), 1,
      aux_sym_intersection_type_repeat1,
  [58294] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4117), 1,
      anon_sym_EQ_GT,
    STATE(2449), 1,
      sym__return_type,
  [58307] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4119), 1,
      anon_sym_COMMA,
    ACTIONS(4121), 1,
      anon_sym_RPAREN,
    STATE(1988), 1,
      aux_sym_array_creation_expression_repeat1,
  [58320] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
    STATE(1998), 1,
      aux_sym__list_destructing_repeat1,
  [58333] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
    STATE(2002), 1,
      aux_sym__list_destructing_repeat1,
  [58346] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4123), 1,
      anon_sym_COMMA,
    ACTIONS(4125), 1,
      anon_sym_RBRACE,
    STATE(1997), 1,
      aux_sym_match_block_repeat1,
  [58359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 1,
      sym__new_line,
    ACTIONS(4127), 1,
      sym_heredoc_end,
    STATE(2288), 1,
      sym_heredoc_body,
  [58372] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4069), 1,
      anon_sym_COMMA,
    ACTIONS(4129), 1,
      anon_sym_RBRACK,
    STATE(1957), 1,
      aux_sym__array_destructing_repeat1,
  [58385] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4131), 1,
      anon_sym_COMMA,
    ACTIONS(4133), 1,
      anon_sym_RBRACK,
    STATE(1919), 1,
      aux_sym_attribute_group_repeat1,
  [58398] = 4,
    ACTIONS(835), 1,
      anon_sym_RBRACK,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4135), 1,
      anon_sym_COMMA,
    STATE(2005), 1,
      aux_sym_array_creation_expression_repeat1,
  [58411] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4137), 1,
      anon_sym_COMMA,
    ACTIONS(4139), 1,
      anon_sym_RBRACK,
    STATE(1917), 1,
      aux_sym_array_creation_expression_repeat1,
  [58424] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4141), 1,
      anon_sym_LBRACE,
    ACTIONS(4143), 1,
      anon_sym_COLON,
    STATE(2120), 1,
      sym_switch_block,
  [58437] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4145), 1,
      anon_sym_COMMA,
    ACTIONS(4148), 1,
      anon_sym_RBRACK,
    STATE(1957), 1,
      aux_sym__array_destructing_repeat1,
  [58450] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3125), 1,
      anon_sym_RBRACK,
    ACTIONS(4150), 1,
      anon_sym_COMMA,
    STATE(2007), 1,
      aux_sym_attribute_group_repeat1,
  [58463] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    STATE(2348), 1,
      sym_parenthesized_expression,
  [58476] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4154), 1,
      anon_sym_COMMA,
    ACTIONS(4156), 1,
      anon_sym_RPAREN,
    STATE(2015), 1,
      aux_sym_arguments_repeat1,
  [58489] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4158), 1,
      anon_sym_EQ_GT,
    STATE(2478), 1,
      sym__return_type,
  [58502] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4160), 1,
      anon_sym_EQ_GT,
    STATE(2480), 1,
      sym__return_type,
  [58515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 1,
      sym__new_line,
    ACTIONS(4162), 1,
      sym_heredoc_end,
    STATE(2403), 1,
      sym_heredoc_body,
  [58528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4164), 1,
      sym__new_line,
    ACTIONS(4166), 1,
      sym_heredoc_end,
    STATE(2402), 1,
      sym_nowdoc_body,
  [58541] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3932), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58550] = 4,
    ACTIONS(807), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4168), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [58563] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3937), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58572] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4170), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [58581] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4099), 1,
      sym_name,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    STATE(2372), 1,
      sym_namespace_use_group,
  [58594] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    ACTIONS(4172), 1,
      sym_name,
    STATE(2372), 1,
      sym_namespace_use_group,
  [58607] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4174), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58616] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3945), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58625] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_EQ,
    ACTIONS(4176), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58636] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4182), 1,
      anon_sym_EQ,
    ACTIONS(4180), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58647] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1771), 1,
      anon_sym_RPAREN,
    ACTIONS(4184), 1,
      anon_sym_COMMA,
    STATE(2029), 1,
      aux_sym_formal_parameters_repeat1,
  [58660] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4186), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2030), 1,
      sym_variable_name,
  [58673] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4190), 1,
      anon_sym_EQ,
    ACTIONS(4188), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58684] = 3,
    ACTIONS(1444), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1442), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58695] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2031), 1,
      sym_variable_name,
  [58708] = 3,
    ACTIONS(1252), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1250), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58719] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4196), 1,
      anon_sym_EQ,
    ACTIONS(4194), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58730] = 3,
    ACTIONS(1188), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1186), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58741] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(3595), 1,
      anon_sym_LBRACE,
    STATE(2492), 1,
      sym__return_type,
  [58754] = 3,
    ACTIONS(1276), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1274), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58765] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3976), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [58774] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    ACTIONS(3534), 1,
      anon_sym_LBRACE,
    STATE(2040), 1,
      aux_sym_base_clause_repeat1,
  [58787] = 3,
    ACTIONS(1256), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1254), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58798] = 4,
    ACTIONS(825), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4198), 1,
      anon_sym_COMMA,
    STATE(1922), 1,
      aux_sym_array_creation_expression_repeat1,
  [58811] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3151), 1,
      anon_sym_COMMA,
    ACTIONS(4200), 1,
      anon_sym_RPAREN,
    STATE(2042), 1,
      aux_sym_unset_statement_repeat1,
  [58824] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4204), 1,
      aux_sym_else_clause_token1,
    ACTIONS(4202), 2,
      aux_sym_if_statement_token2,
      aux_sym_else_if_clause_token1,
  [58835] = 3,
    ACTIONS(1160), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1158), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58846] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4206), 1,
      anon_sym_COMMA,
    ACTIONS(4208), 1,
      anon_sym_RBRACE,
    STATE(2046), 1,
      aux_sym_match_block_repeat1,
  [58859] = 3,
    ACTIONS(1372), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1370), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58870] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3878), 1,
      anon_sym_EQ,
    ACTIONS(4210), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [58881] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4212), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [58890] = 3,
    ACTIONS(1372), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1370), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58901] = 4,
    ACTIONS(858), 1,
      anon_sym_RBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4214), 1,
      anon_sym_COMMA,
    STATE(2164), 1,
      aux_sym_match_block_repeat1,
  [58914] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4216), 1,
      anon_sym_RPAREN,
    STATE(2002), 1,
      aux_sym__list_destructing_repeat1,
  [58927] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4218), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [58936] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4220), 1,
      anon_sym_RPAREN,
    STATE(2002), 1,
      aux_sym__list_destructing_repeat1,
  [58949] = 3,
    ACTIONS(1464), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1462), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58960] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_RPAREN,
    ACTIONS(4222), 1,
      anon_sym_COMMA,
    STATE(2002), 1,
      aux_sym__list_destructing_repeat1,
  [58973] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4057), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [58982] = 3,
    ACTIONS(1420), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1418), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [58993] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4057), 1,
      anon_sym_RBRACK,
    ACTIONS(4225), 1,
      anon_sym_COMMA,
    STATE(2005), 1,
      aux_sym_array_creation_expression_repeat1,
  [59006] = 3,
    ACTIONS(1344), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1342), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59017] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4228), 1,
      anon_sym_COMMA,
    ACTIONS(4231), 1,
      anon_sym_RBRACK,
    STATE(2007), 1,
      aux_sym_attribute_group_repeat1,
  [59030] = 3,
    ACTIONS(1228), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1226), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59041] = 3,
    ACTIONS(1228), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1226), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59052] = 3,
    ACTIONS(1404), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1402), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59063] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4083), 1,
      sym__new_line,
    ACTIONS(4233), 1,
      sym_heredoc_end,
    STATE(2291), 1,
      sym_heredoc_body,
  [59076] = 3,
    ACTIONS(1308), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1306), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4164), 1,
      sym__new_line,
    ACTIONS(4235), 1,
      sym_heredoc_end,
    STATE(2181), 1,
      sym_nowdoc_body,
  [59100] = 3,
    ACTIONS(1216), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1214), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59111] = 4,
    ACTIONS(801), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4237), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [59124] = 3,
    ACTIONS(1224), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1222), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59135] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4239), 1,
      anon_sym_EQ_GT,
    STATE(2558), 1,
      sym__return_type,
  [59148] = 3,
    ACTIONS(1232), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1230), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59159] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4241), 1,
      anon_sym_EQ_GT,
    STATE(2562), 1,
      sym__return_type,
  [59172] = 3,
    ACTIONS(1240), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1238), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59183] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4243), 1,
      anon_sym_EQ_GT,
    STATE(2567), 1,
      sym__return_type,
  [59196] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    ACTIONS(4172), 1,
      sym_name,
    STATE(2266), 1,
      sym_namespace_use_group,
  [59209] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4245), 1,
      anon_sym_COMMA,
    ACTIONS(4247), 1,
      anon_sym_RBRACE,
    STATE(2110), 1,
      aux_sym_namespace_use_group_repeat1,
  [59222] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4251), 1,
      anon_sym_EQ,
    ACTIONS(4249), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59233] = 3,
    ACTIONS(1328), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1326), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59244] = 3,
    ACTIONS(1428), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1426), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59255] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4255), 1,
      anon_sym_EQ,
    ACTIONS(4253), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59266] = 3,
    ACTIONS(1444), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1442), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59277] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4257), 1,
      anon_sym_COMMA,
    ACTIONS(4260), 1,
      anon_sym_RPAREN,
    STATE(2029), 1,
      aux_sym_formal_parameters_repeat1,
  [59290] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4264), 1,
      anon_sym_EQ,
    ACTIONS(4262), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59301] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4268), 1,
      anon_sym_EQ,
    ACTIONS(4266), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59312] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4270), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(2146), 1,
      sym_variable_name,
  [59325] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4274), 1,
      anon_sym_EQ,
    ACTIONS(4272), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [59336] = 3,
    ACTIONS(1244), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1242), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59347] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4276), 1,
      anon_sym_COMMA,
    ACTIONS(4278), 1,
      anon_sym_RPAREN,
    STATE(2151), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [59360] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    STATE(1679), 1,
      sym_variable_name,
    STATE(1841), 1,
      sym_property_element,
  [59373] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4282), 1,
      anon_sym_EQ,
    ACTIONS(4280), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [59384] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4284), 1,
      anon_sym_RPAREN,
    STATE(2494), 1,
      sym_variable_name,
  [59397] = 3,
    ACTIONS(1260), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1258), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59408] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_COMMA,
    ACTIONS(4286), 1,
      anon_sym_LBRACE,
    STATE(1846), 1,
      aux_sym_base_clause_repeat1,
  [59421] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    ACTIONS(4172), 1,
      sym_name,
    STATE(2376), 1,
      sym_namespace_use_group,
  [59434] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3298), 1,
      anon_sym_RPAREN,
    ACTIONS(4288), 1,
      anon_sym_COMMA,
    STATE(2042), 1,
      aux_sym_unset_statement_repeat1,
  [59447] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    ACTIONS(4291), 1,
      anon_sym_RPAREN,
    STATE(2605), 1,
      sym_variable_name,
  [59460] = 3,
    ACTIONS(1260), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1258), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59471] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3151), 1,
      anon_sym_COMMA,
    ACTIONS(4293), 1,
      anon_sym_RPAREN,
    STATE(2042), 1,
      aux_sym_unset_statement_repeat1,
  [59484] = 4,
    ACTIONS(862), 1,
      anon_sym_RBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4295), 1,
      anon_sym_COMMA,
    STATE(2164), 1,
      aux_sym_match_block_repeat1,
  [59497] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    ACTIONS(4172), 1,
      sym_name,
    STATE(2440), 1,
      sym_namespace_use_group,
  [59510] = 3,
    ACTIONS(1524), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1522), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59521] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4099), 1,
      sym_name,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    STATE(2440), 1,
      sym_namespace_use_group,
  [59534] = 4,
    ACTIONS(951), 1,
      anon_sym_EQ_GT,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4297), 1,
      anon_sym_COMMA,
    STATE(2165), 1,
      aux_sym_match_condition_list_repeat1,
  [59547] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
    STATE(2179), 1,
      aux_sym__list_destructing_repeat1,
  [59560] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3204), 1,
      anon_sym_RPAREN,
    STATE(1913), 1,
      aux_sym__list_destructing_repeat1,
  [59573] = 3,
    ACTIONS(1524), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1522), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59584] = 3,
    ACTIONS(1360), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1358), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59595] = 3,
    ACTIONS(1504), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1502), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59606] = 3,
    ACTIONS(1472), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1470), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59617] = 3,
    ACTIONS(1456), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1454), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59628] = 3,
    ACTIONS(1452), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1450), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59639] = 3,
    ACTIONS(1424), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1422), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59650] = 3,
    ACTIONS(1416), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1414), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59661] = 3,
    ACTIONS(1392), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1390), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59672] = 3,
    ACTIONS(1336), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1334), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59683] = 3,
    ACTIONS(1172), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1170), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59694] = 3,
    ACTIONS(1172), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1170), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59705] = 3,
    ACTIONS(1212), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1210), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59716] = 3,
    ACTIONS(1316), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1314), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59727] = 3,
    ACTIONS(1440), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1438), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59738] = 3,
    ACTIONS(1440), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1438), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59749] = 3,
    ACTIONS(1192), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1190), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59760] = 3,
    ACTIONS(1196), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1194), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59771] = 3,
    ACTIONS(1200), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1198), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59782] = 3,
    ACTIONS(1488), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1486), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59793] = 3,
    ACTIONS(1512), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1510), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59804] = 3,
    ACTIONS(1352), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1350), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59815] = 3,
    ACTIONS(1348), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1346), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59826] = 3,
    ACTIONS(1288), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1286), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59837] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4301), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [59846] = 3,
    ACTIONS(1236), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1234), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59857] = 3,
    ACTIONS(1448), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1446), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59868] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4303), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [59877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4305), 1,
      anon_sym_,
    ACTIONS(4307), 1,
      sym_nowdoc_string,
    STATE(1859), 1,
      aux_sym_nowdoc_body_repeat1,
  [59890] = 3,
    ACTIONS(1324), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1322), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59901] = 3,
    ACTIONS(1320), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1318), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59912] = 3,
    ACTIONS(1312), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1310), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59923] = 3,
    ACTIONS(1180), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1178), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59934] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4099), 1,
      sym_name,
    ACTIONS(4101), 1,
      anon_sym_LBRACE,
    STATE(2264), 1,
      sym_namespace_use_group,
  [59947] = 3,
    ACTIONS(1168), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1166), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59958] = 3,
    ACTIONS(1292), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1290), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59969] = 3,
    ACTIONS(1292), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1290), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59980] = 3,
    ACTIONS(1304), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1302), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [59991] = 3,
    ACTIONS(1436), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1434), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60002] = 3,
    ACTIONS(1296), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1294), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60013] = 3,
    ACTIONS(1204), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1202), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60024] = 3,
    ACTIONS(1176), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1174), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60035] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4309), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [60044] = 3,
    ACTIONS(1356), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1354), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60055] = 3,
    ACTIONS(1460), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1458), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60066] = 3,
    ACTIONS(1480), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1478), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60077] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4313), 1,
      anon_sym_EQ,
    ACTIONS(4311), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60088] = 3,
    ACTIONS(1516), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1514), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60099] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_COLON,
    ACTIONS(4315), 1,
      anon_sym_EQ_GT,
    STATE(2643), 1,
      sym__return_type,
  [60112] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4317), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_RPAREN,
    STATE(2112), 1,
      aux_sym_arguments_repeat1,
  [60125] = 3,
    ACTIONS(1508), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1506), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60136] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4321), 1,
      anon_sym_DQUOTE,
    ACTIONS(4323), 1,
      anon_sym_SQUOTE,
    ACTIONS(4325), 1,
      sym_heredoc_start,
  [60149] = 3,
    ACTIONS(1300), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1298), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60160] = 3,
    ACTIONS(1340), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1338), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60171] = 3,
    ACTIONS(1408), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1406), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60182] = 3,
    ACTIONS(1412), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1410), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60193] = 3,
    ACTIONS(1468), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1466), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60204] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4245), 1,
      anon_sym_COMMA,
    ACTIONS(4327), 1,
      anon_sym_RBRACE,
    STATE(2176), 1,
      aux_sym_namespace_use_group_repeat1,
  [60217] = 3,
    ACTIONS(1520), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1518), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60228] = 4,
    ACTIONS(771), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4329), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [60241] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4331), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [60250] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4333), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [60259] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4337), 1,
      anon_sym_EQ,
    ACTIONS(4335), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60270] = 3,
    ACTIONS(1388), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1386), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60281] = 3,
    ACTIONS(1376), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1374), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60292] = 3,
    ACTIONS(1364), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1362), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60303] = 3,
    ACTIONS(1164), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1162), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60314] = 3,
    ACTIONS(1432), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1430), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60325] = 3,
    ACTIONS(1396), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1394), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60336] = 3,
    ACTIONS(1268), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1266), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60347] = 3,
    ACTIONS(1272), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1270), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60358] = 3,
    ACTIONS(1280), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1278), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60369] = 3,
    ACTIONS(1284), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1282), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60380] = 3,
    ACTIONS(1332), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1330), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60391] = 3,
    ACTIONS(1368), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1366), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60402] = 3,
    ACTIONS(1380), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1378), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60413] = 3,
    ACTIONS(1384), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1382), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60424] = 3,
    ACTIONS(1400), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1398), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60435] = 3,
    ACTIONS(1476), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1474), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60446] = 3,
    ACTIONS(1496), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1494), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60457] = 3,
    ACTIONS(1500), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1498), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60468] = 3,
    ACTIONS(121), 1,
      anon_sym_DOLLAR,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1826), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [60479] = 3,
    ACTIONS(1528), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1526), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60490] = 3,
    ACTIONS(1156), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1154), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60501] = 3,
    ACTIONS(1208), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1206), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60512] = 3,
    ACTIONS(1184), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1182), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60523] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_EQ,
    ACTIONS(4339), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60534] = 3,
    ACTIONS(1532), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1530), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60545] = 3,
    ACTIONS(1248), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1246), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60556] = 3,
    ACTIONS(1484), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1482), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60567] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3285), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [60576] = 3,
    ACTIONS(1220), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1218), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60587] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4345), 1,
      anon_sym_EQ,
    ACTIONS(4343), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60598] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4349), 1,
      anon_sym_EQ,
    ACTIONS(4347), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60609] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4351), 1,
      anon_sym_COMMA,
    ACTIONS(4353), 1,
      anon_sym_RPAREN,
    STATE(2153), 1,
      aux_sym_arguments_repeat1,
  [60622] = 3,
    ACTIONS(1492), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1490), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60633] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2791), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      sym_name,
  [60642] = 3,
    ACTIONS(1264), 1,
      aux_sym_else_clause_token1,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1262), 2,
      aux_sym_while_statement_token1,
      aux_sym_else_if_clause_token1,
  [60653] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3579), 1,
      anon_sym_RPAREN,
    ACTIONS(4355), 1,
      anon_sym_COMMA,
    STATE(2174), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [60666] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    STATE(1679), 1,
      sym_variable_name,
    STATE(1884), 1,
      sym_property_element,
  [60679] = 4,
    ACTIONS(781), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4357), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [60692] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4359), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [60701] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_DOLLAR,
    STATE(1679), 1,
      sym_variable_name,
    STATE(2173), 1,
      sym_property_element,
  [60714] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4361), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [60723] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4363), 1,
      sym_name,
    ACTIONS(4365), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [60734] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3524), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      aux_sym_class_interface_clause_token1,
  [60743] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4369), 1,
      anon_sym_EQ,
    ACTIONS(4367), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [60754] = 4,
    ACTIONS(817), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [60767] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_COMMA,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
    STATE(2160), 1,
      aux_sym_arguments_repeat1,
  [60780] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4379), 1,
      aux_sym_else_clause_token1,
    ACTIONS(4377), 2,
      aux_sym_if_statement_token2,
      aux_sym_else_if_clause_token1,
  [60791] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_COMMA,
    ACTIONS(4384), 1,
      anon_sym_RPAREN,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [60804] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4386), 1,
      anon_sym_COMMA,
    ACTIONS(4389), 1,
      anon_sym_RBRACE,
    STATE(2164), 1,
      aux_sym_match_block_repeat1,
  [60817] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2571), 1,
      anon_sym_EQ_GT,
    ACTIONS(4391), 1,
      anon_sym_COMMA,
    STATE(2165), 1,
      aux_sym_match_condition_list_repeat1,
  [60830] = 4,
    ACTIONS(793), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4394), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [60843] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4396), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [60852] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4398), 1,
      anon_sym_COMMA,
    ACTIONS(4400), 1,
      anon_sym_RPAREN,
    STATE(2166), 1,
      aux_sym_arguments_repeat1,
  [60865] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4402), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [60874] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4404), 1,
      anon_sym_COMMA,
    ACTIONS(4406), 1,
      anon_sym_RPAREN,
    STATE(2172), 1,
      aux_sym_arguments_repeat1,
  [60887] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4012), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_DOLLAR,
  [60896] = 4,
    ACTIONS(783), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4408), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [60909] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4001), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [60918] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4410), 1,
      anon_sym_COMMA,
    ACTIONS(4413), 1,
      anon_sym_RPAREN,
    STATE(2174), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [60931] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4417), 1,
      anon_sym_EQ,
    ACTIONS(4415), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [60942] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4419), 1,
      anon_sym_COMMA,
    ACTIONS(4422), 1,
      anon_sym_RBRACE,
    STATE(2176), 1,
      aux_sym_namespace_use_group_repeat1,
  [60955] = 4,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4424), 1,
      anon_sym_COMMA,
    ACTIONS(4426), 1,
      anon_sym_RPAREN,
    STATE(2178), 1,
      aux_sym_arguments_repeat1,
  [60968] = 4,
    ACTIONS(785), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4428), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_arguments_repeat1,
  [60981] = 4,
    ACTIONS(854), 1,
      anon_sym_COMMA,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4430), 1,
      anon_sym_RPAREN,
    STATE(2002), 1,
      aux_sym__list_destructing_repeat1,
  [60994] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4432), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [61003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4434), 1,
      sym__new_line,
    ACTIONS(4436), 1,
      sym_heredoc_end,
  [61013] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1628), 1,
      sym_formal_parameters,
  [61023] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4438), 1,
      sym_name,
    STATE(2606), 1,
      sym_namespace_name,
  [61033] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4413), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61041] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4441), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61049] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4443), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61057] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_RPAREN,
    ACTIONS(4445), 1,
      anon_sym_EQ,
  [61067] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LBRACE,
    STATE(430), 1,
      sym_compound_statement,
  [61077] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1745), 1,
      sym_compound_statement,
  [61087] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4449), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61095] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4422), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61103] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4451), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61111] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym_parenthesized_expression,
  [61121] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_declaration_list,
  [61131] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(448), 1,
      sym_declaration_list,
  [61141] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4438), 1,
      sym_name,
    STATE(2585), 1,
      sym_namespace_name,
  [61151] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4438), 1,
      sym_name,
    STATE(2577), 1,
      sym_namespace_name,
  [61161] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    STATE(474), 1,
      sym_enum_declaration_list,
  [61171] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1046), 1,
      sym_compound_statement,
  [61181] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1047), 1,
      sym_compound_statement,
  [61191] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4455), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61199] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1051), 1,
      sym_compound_statement,
  [61209] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_declaration_list,
  [61219] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym_parenthesized_expression,
  [61229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3964), 2,
      sym_heredoc_end,
      sym__new_line,
  [61237] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    STATE(2250), 1,
      sym_parenthesized_expression,
  [61247] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4457), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61255] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    STATE(1924), 1,
      sym_parenthesized_expression,
  [61265] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1683), 1,
      sym_compound_statement,
  [61275] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(477), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61283] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(920), 1,
      sym_declaration_list,
  [61293] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3212), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61301] = 3,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(461), 1,
      sym_compound_statement,
  [61311] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3878), 2,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [61319] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4459), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61327] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4461), 1,
      anon_sym_SEMI,
    ACTIONS(4463), 1,
      sym__automatic_semicolon,
  [61337] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1062), 1,
      sym_declaration_list,
  [61347] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1115), 1,
      sym_compound_statement,
  [61357] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(434), 1,
      sym_declaration_list,
  [61367] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4389), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61375] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4465), 1,
      sym_name,
    STATE(2543), 1,
      sym_namespace_name,
  [61385] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4438), 1,
      sym_name,
    STATE(2499), 1,
      sym_namespace_name,
  [61395] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4468), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61403] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1944), 1,
      sym_formal_parameters,
  [61413] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3839), 1,
      anon_sym_LBRACE,
    STATE(515), 1,
      sym_declaration_list,
  [61423] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      sym_compound_statement,
  [61433] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(23), 1,
      sym_parenthesized_expression,
  [61443] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_LPAREN,
    ACTIONS(4472), 1,
      anon_sym_RPAREN,
  [61453] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4474), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61461] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4476), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61469] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(485), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61477] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4478), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61485] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4365), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61493] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4480), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61501] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4482), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61509] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_RPAREN,
    ACTIONS(4445), 1,
      anon_sym_EQ,
  [61519] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4484), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61527] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4486), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [61535] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4488), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61543] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4490), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61551] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2186), 1,
      sym_variable_name,
  [61561] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4492), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61569] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4494), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61577] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4496), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61585] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(2277), 1,
      aux_sym_namespace_name_repeat1,
  [61595] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2175), 1,
      sym_variable_name,
  [61605] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4498), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61613] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4500), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61621] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4502), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61629] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4504), 1,
      anon_sym_LBRACE,
    STATE(1033), 1,
      sym_match_block,
  [61639] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1601), 1,
      sym_formal_parameters,
  [61649] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1749), 1,
      sym_declaration_list,
  [61659] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(909), 1,
      sym_compound_statement,
  [61669] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4506), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [61677] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4174), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61685] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    STATE(2106), 1,
      sym_enum_declaration_list,
  [61695] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4509), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61703] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1657), 1,
      sym_compound_statement,
  [61713] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(2108), 1,
      sym_declaration_list,
  [61723] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(53), 1,
      sym_parenthesized_expression,
  [61733] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    STATE(2348), 1,
      sym_parenthesized_expression,
  [61743] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    STATE(1956), 1,
      sym_parenthesized_expression,
  [61753] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3828), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [61761] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61769] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(4511), 1,
      aux_sym_namespace_use_declaration_token2,
  [61779] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4513), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61787] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1088), 1,
      sym_compound_statement,
  [61797] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(934), 1,
      sym_compound_statement,
  [61807] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2437), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [61815] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(442), 1,
      sym_declaration_list,
  [61825] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(917), 1,
      sym_compound_statement,
  [61835] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_declaration_list,
  [61845] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1076), 1,
      sym_compound_statement,
  [61855] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1074), 1,
      sym_compound_statement,
  [61865] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1071), 1,
      sym_compound_statement,
  [61875] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(27), 1,
      sym_parenthesized_expression,
  [61885] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4515), 1,
      anon_sym_BSLASH,
    STATE(1666), 1,
      aux_sym_namespace_name_repeat1,
  [61895] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_declaration_list,
  [61905] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(445), 1,
      sym_declaration_list,
  [61915] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1946), 1,
      sym_formal_parameters,
  [61925] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2573), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61933] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4384), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [61941] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(911), 1,
      sym_compound_statement,
  [61951] = 3,
    ACTIONS(29), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(505), 1,
      sym_compound_statement,
  [61961] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1695), 1,
      sym_compound_statement,
  [61971] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1584), 1,
      sym_formal_parameters,
  [61981] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4518), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [61989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4520), 1,
      sym__new_line,
    ACTIONS(4522), 1,
      sym_heredoc_end,
  [61999] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_LPAREN,
    STATE(1677), 1,
      sym_formal_parameters,
  [62009] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4526), 2,
      anon_sym_string,
      anon_sym_int,
  [62017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 1,
      sym__new_line,
    ACTIONS(4530), 1,
      sym_heredoc_end,
  [62027] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4438), 1,
      sym_name,
    STATE(2470), 1,
      sym_namespace_name,
  [62037] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3252), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [62045] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2809), 1,
      aux_sym__arrow_function_header_token1,
    ACTIONS(4532), 1,
      aux_sym_namespace_use_declaration_token2,
  [62055] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4032), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [62063] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1743), 1,
      sym_declaration_list,
  [62073] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2310), 1,
      sym_parenthesized_expression,
  [62083] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2414), 1,
      sym_variable_name,
  [62093] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2074), 1,
      sym_compound_statement,
  [62103] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4536), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62111] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(63), 1,
      sym_parenthesized_expression,
  [62121] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4538), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62129] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1983), 1,
      sym_formal_parameters,
  [62139] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1105), 1,
      sym_compound_statement,
  [62149] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4540), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62157] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1054), 1,
      sym_declaration_list,
  [62167] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym_declaration_list,
  [62177] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4542), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62185] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4544), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62193] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4546), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62201] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4548), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62209] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4550), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62217] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(545), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62225] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3839), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_declaration_list,
  [62235] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4552), 1,
      anon_sym_SEMI,
    ACTIONS(4554), 1,
      sym__automatic_semicolon,
  [62245] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4556), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62253] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4558), 2,
      anon_sym_string,
      anon_sym_int,
  [62261] = 3,
    ACTIONS(469), 1,
      anon_sym_COLON,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2162), 1,
      sym_colon_block,
  [62271] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1587), 1,
      sym_formal_parameters,
  [62281] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1692), 1,
      sym_declaration_list,
  [62291] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_RPAREN,
    ACTIONS(4445), 1,
      anon_sym_EQ,
  [62301] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    STATE(502), 1,
      sym_enum_declaration_list,
  [62311] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(436), 1,
      sym_declaration_list,
  [62321] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(82), 1,
      sym_parenthesized_expression,
  [62331] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1585), 1,
      sym_formal_parameters,
  [62341] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(947), 1,
      sym_compound_statement,
  [62351] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4560), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62359] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(453), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62367] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1623), 1,
      sym_formal_parameters,
  [62377] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4562), 2,
      anon_sym_string,
      anon_sym_int,
  [62385] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4447), 1,
      anon_sym_LBRACE,
    STATE(431), 1,
      sym_compound_statement,
  [62395] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4564), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62403] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4566), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62411] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4568), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62419] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1697), 1,
      sym_declaration_list,
  [62429] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    STATE(465), 1,
      sym_enum_declaration_list,
  [62439] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_LPAREN,
    STATE(2424), 1,
      sym_parenthesized_expression,
  [62449] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_declaration_list,
  [62459] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3480), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62467] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1698), 1,
      sym_declaration_list,
  [62477] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2535), 1,
      anon_sym_RPAREN,
    ACTIONS(4445), 1,
      anon_sym_EQ,
  [62487] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4148), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [62495] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    STATE(2018), 1,
      sym_enum_declaration_list,
  [62505] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(963), 1,
      sym_declaration_list,
  [62515] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_declaration_list,
  [62525] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(945), 1,
      sym_compound_statement,
  [62535] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2239), 1,
      sym_variable_name,
  [62545] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4570), 1,
      anon_sym_LBRACE,
    STATE(902), 1,
      sym_match_block,
  [62555] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1041), 1,
      sym_compound_statement,
  [62565] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4572), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [62573] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(944), 1,
      sym_compound_statement,
  [62583] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(926), 1,
      sym_compound_statement,
  [62593] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2243), 1,
      sym_variable_name,
  [62603] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4574), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4576), 1,
      sym__new_line,
    ACTIONS(4578), 1,
      sym_heredoc_end,
  [62621] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1111), 1,
      sym_declaration_list,
  [62631] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2145), 1,
      sym_variable_name,
  [62641] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1658), 1,
      sym_declaration_list,
  [62651] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2247), 1,
      sym_variable_name,
  [62661] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4580), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62669] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2427), 1,
      anon_sym_COLON,
    ACTIONS(4470), 1,
      anon_sym_LPAREN,
  [62679] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2249), 1,
      sym_variable_name,
  [62689] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4582), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62697] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4584), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62705] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4260), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62713] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(941), 1,
      sym_declaration_list,
  [62723] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_SEMI,
    ACTIONS(4588), 1,
      sym__automatic_semicolon,
  [62733] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2115), 1,
      sym_variable_name,
  [62743] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4590), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62751] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(1714), 1,
      sym_compound_statement,
  [62761] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4592), 1,
      sym_name,
    STATE(1776), 1,
      sym_namespace_name,
  [62771] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4594), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62779] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4596), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62787] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1116), 1,
      sym_compound_statement,
  [62797] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1092), 1,
      sym_compound_statement,
  [62807] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4598), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [62815] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(2101), 1,
      sym_formal_parameters,
  [62825] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2527), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62833] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(2017), 1,
      sym_formal_parameters,
  [62843] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(939), 1,
      sym_compound_statement,
  [62853] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(437), 1,
      sym_declaration_list,
  [62863] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3636), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_enum_declaration_list,
  [62873] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4600), 2,
      anon_sym_string,
      anon_sym_int,
  [62881] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1039), 1,
      sym_compound_statement,
  [62891] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1599), 1,
      sym_formal_parameters,
  [62901] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(2019), 1,
      sym_formal_parameters,
  [62911] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym_declaration_list,
  [62921] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_declaration_list,
  [62931] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2459), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62939] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1725), 1,
      sym_declaration_list,
  [62949] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2457), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [62957] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(938), 1,
      sym_compound_statement,
  [62967] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(936), 1,
      sym_compound_statement,
  [62977] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1079), 1,
      sym_compound_statement,
  [62987] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(2129), 1,
      sym_declaration_list,
  [62997] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1689), 1,
      sym_declaration_list,
  [63007] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(933), 1,
      sym_compound_statement,
  [63017] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4231), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [63025] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1744), 1,
      sym_declaration_list,
  [63035] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1747), 1,
      sym_declaration_list,
  [63045] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4602), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [63053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4605), 1,
      sym__new_line,
    ACTIONS(4607), 1,
      sym_heredoc_end,
  [63063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4609), 1,
      sym__new_line,
    ACTIONS(4611), 1,
      sym_heredoc_end,
  [63073] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(931), 1,
      sym_declaration_list,
  [63083] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3382), 1,
      anon_sym_LBRACE,
    STATE(930), 1,
      sym_declaration_list,
  [63093] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4613), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63101] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1681), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63109] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_SEMI,
    ACTIONS(4617), 1,
      sym__automatic_semicolon,
  [63119] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_declaration_list,
  [63129] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3512), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63137] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4524), 1,
      anon_sym_LPAREN,
    STATE(1716), 1,
      sym_formal_parameters,
  [63147] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4619), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [63155] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4017), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63163] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4621), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [63171] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2369), 1,
      sym_variable_name,
  [63181] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2138), 1,
      sym_compound_statement,
  [63191] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2027), 1,
      sym_variable_name,
  [63201] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4623), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63209] = 3,
    ACTIONS(367), 1,
      anon_sym_COLON,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(2517), 1,
      sym_colon_block,
  [63219] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4152), 1,
      anon_sym_LPAREN,
    STATE(2318), 1,
      sym_parenthesized_expression,
  [63229] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4625), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63237] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(79), 1,
      sym_parenthesized_expression,
  [63247] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(28), 1,
      sym_parenthesized_expression,
  [63257] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4627), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63265] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4629), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63273] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    STATE(46), 1,
      sym_parenthesized_expression,
  [63283] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_RPAREN,
    ACTIONS(4445), 1,
      anon_sym_EQ,
  [63293] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2363), 1,
      sym_variable_name,
  [63303] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(950), 1,
      sym_compound_statement,
  [63313] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    STATE(2026), 1,
      sym_enum_declaration_list,
  [63323] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3609), 1,
      anon_sym_LBRACE,
    STATE(2071), 1,
      sym_enum_declaration_list,
  [63333] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4631), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63341] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2437), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63349] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(1737), 1,
      anon_sym_DOLLAR,
    STATE(2360), 1,
      sym_variable_name,
  [63359] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3228), 1,
      anon_sym_LPAREN,
    STATE(1655), 1,
      sym_formal_parameters,
  [63369] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3394), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_declaration_list,
  [63379] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3472), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_declaration_list,
  [63389] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(916), 1,
      sym_compound_statement,
  [63399] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(906), 1,
      sym_compound_statement,
  [63409] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4633), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [63417] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1057), 1,
      sym_compound_statement,
  [63427] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4331), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [63435] = 3,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_LBRACE,
    STATE(1064), 1,
      sym_compound_statement,
  [63445] = 3,
    ACTIONS(393), 1,
      anon_sym_LBRACE,
    ACTIONS(1558), 1,
      sym_comment,
    STATE(901), 1,
      sym_compound_statement,
  [63455] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4635), 1,
      aux_sym_class_declaration_token1,
  [63462] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4637), 1,
      sym_name,
  [63469] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4333), 1,
      anon_sym_LBRACE,
  [63476] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4639), 1,
      sym_name,
  [63483] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4641), 1,
      anon_sym_EQ_GT,
  [63490] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4643), 1,
      anon_sym_RPAREN,
  [63497] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4645), 1,
      anon_sym_RPAREN,
  [63504] = 2,
    ACTIONS(881), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [63511] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4647), 1,
      anon_sym_COLON_COLON,
  [63518] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_RPAREN,
  [63525] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4649), 1,
      anon_sym_EQ,
  [63532] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4651), 1,
      anon_sym_EQ_GT,
  [63539] = 2,
    ACTIONS(873), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [63546] = 2,
    ACTIONS(899), 1,
      anon_sym_SEMI,
    ACTIONS(1558), 1,
      sym_comment,
  [63553] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4653), 1,
      anon_sym_RPAREN,
  [63560] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4655), 1,
      sym_name,
  [63567] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4657), 1,
      aux_sym_if_statement_token2,
  [63574] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4208), 1,
      anon_sym_RBRACE,
  [63581] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4659), 1,
      anon_sym_EQ_GT,
  [63588] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4661), 1,
      anon_sym_EQ_GT,
  [63595] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4095), 1,
      anon_sym_RPAREN,
  [63602] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4663), 1,
      anon_sym_EQ_GT,
  [63609] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_EQ,
  [63616] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4665), 1,
      anon_sym_COLON_COLON,
  [63623] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3615), 1,
      sym_name,
  [63630] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4667), 1,
      anon_sym_BSLASH,
  [63637] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4669), 1,
      sym_name,
  [63644] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4671), 1,
      sym_integer,
  [63651] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4673), 1,
      anon_sym_RBRACK,
  [63658] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4675), 1,
      sym_heredoc_end,
  [63665] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4677), 1,
      aux_sym_class_declaration_token1,
  [63672] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4679), 1,
      sym_name,
  [63679] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4681), 1,
      anon_sym_RPAREN,
  [63686] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4683), 1,
      anon_sym_EQ_GT,
  [63693] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4685), 1,
      sym_heredoc_end,
  [63700] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4687), 1,
      anon_sym_EQ_GT,
  [63707] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4689), 1,
      sym_name,
  [63714] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4691), 1,
      sym_name,
  [63721] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4693), 1,
      anon_sym_RBRACK,
  [63728] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4695), 1,
      sym_heredoc_end,
  [63735] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4099), 1,
      sym_name,
  [63742] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4156), 1,
      anon_sym_RPAREN,
  [63749] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4697), 1,
      anon_sym_SQUOTE2,
  [63756] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4699), 1,
      anon_sym_DQUOTE2,
  [63763] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4701), 1,
      aux_sym_foreach_statement_token2,
  [63770] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4703), 1,
      sym_name,
  [63777] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4705), 1,
      anon_sym_RPAREN,
  [63784] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4309), 1,
      anon_sym_LBRACE,
  [63791] = 2,
    ACTIONS(889), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [63798] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4707), 1,
      anon_sym_RPAREN,
  [63805] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4709), 1,
      anon_sym_RPAREN,
  [63812] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4711), 1,
      aux_sym_if_statement_token2,
  [63819] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2535), 1,
      anon_sym_RPAREN,
  [63826] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4125), 1,
      anon_sym_RBRACE,
  [63833] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4713), 1,
      anon_sym_BSLASH,
  [63840] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4715), 1,
      sym_name,
  [63847] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4075), 1,
      anon_sym_RBRACK,
  [63854] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4717), 1,
      anon_sym_RPAREN,
  [63861] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4719), 1,
      anon_sym_SEMI,
  [63868] = 2,
    ACTIONS(895), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [63875] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4721), 1,
      aux_sym_while_statement_token2,
  [63882] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4723), 1,
      sym_name,
  [63889] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4725), 1,
      anon_sym_LPAREN,
  [63896] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4727), 1,
      anon_sym_RPAREN,
  [63903] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4729), 1,
      anon_sym_EQ,
  [63910] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4731), 1,
      anon_sym_RPAREN,
  [63917] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4121), 1,
      anon_sym_RPAREN,
  [63924] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4733), 1,
      aux_sym_if_statement_token2,
  [63931] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4735), 1,
      anon_sym_EQ_GT,
  [63938] = 2,
    ACTIONS(897), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [63945] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_SEMI,
  [63952] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_RPAREN,
  [63959] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4739), 1,
      aux_sym_if_statement_token2,
  [63966] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4741), 1,
      aux_sym_if_statement_token2,
  [63973] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4743), 1,
      anon_sym_RPAREN,
  [63980] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4745), 1,
      anon_sym_EQ_GT,
  [63987] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4747), 1,
      anon_sym_EQ,
  [63994] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4749), 1,
      anon_sym_COLON_COLON,
  [64001] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4751), 1,
      anon_sym_RPAREN,
  [64008] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4753), 1,
      sym_name,
  [64015] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4755), 1,
      sym_name,
  [64022] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4757), 1,
      anon_sym_LPAREN,
  [64029] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4759), 1,
      anon_sym_SQUOTE2,
  [64036] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4761), 1,
      anon_sym_DQUOTE2,
  [64043] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4763), 1,
      sym_name,
  [64050] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4765), 1,
      anon_sym_RPAREN,
  [64057] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4767), 1,
      anon_sym_RPAREN,
  [64064] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4769), 1,
      sym_name,
  [64071] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4771), 1,
      anon_sym_COLON_COLON,
  [64078] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4107), 1,
      anon_sym_RPAREN,
  [64085] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4773), 1,
      aux_sym_while_statement_token2,
  [64092] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4775), 1,
      sym_name,
  [64099] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4777), 1,
      sym_name,
  [64106] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4779), 1,
      anon_sym_RPAREN,
  [64113] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4781), 1,
      anon_sym_RPAREN,
  [64120] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4783), 1,
      anon_sym_BSLASH,
  [64127] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4785), 1,
      anon_sym_RPAREN,
  [64134] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4172), 1,
      sym_name,
  [64141] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4787), 1,
      anon_sym_BSLASH,
  [64148] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4139), 1,
      anon_sym_RBRACK,
  [64155] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4789), 1,
      anon_sym_RPAREN,
  [64162] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4791), 1,
      sym_name,
  [64169] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4793), 1,
      ts_builtin_sym_end,
  [64176] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4795), 1,
      sym_name,
  [64183] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4797), 1,
      aux_sym__arrow_function_header_token1,
  [64190] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4091), 1,
      aux_sym_class_declaration_token1,
  [64197] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4799), 1,
      sym_name,
  [64204] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4801), 1,
      sym_name,
  [64211] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4803), 1,
      sym_name,
  [64218] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4805), 1,
      sym_name,
  [64225] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_RBRACK,
  [64232] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4809), 1,
      anon_sym_RPAREN,
  [64239] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4811), 1,
      sym_heredoc_end,
  [64246] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4813), 1,
      anon_sym_EQ_GT,
  [64253] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4815), 1,
      sym_name,
  [64260] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4817), 1,
      sym_heredoc_start,
  [64267] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4819), 1,
      aux_sym_class_declaration_token1,
  [64274] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4821), 1,
      anon_sym_EQ_GT,
  [64281] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4089), 1,
      aux_sym_class_declaration_token1,
  [64288] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4823), 1,
      aux_sym_namespace_use_declaration_token3,
  [64295] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4825), 1,
      anon_sym_BSLASH,
  [64302] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4827), 1,
      sym_heredoc_start,
  [64309] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4829), 1,
      anon_sym_EQ_GT,
  [64316] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4831), 1,
      anon_sym_RPAREN,
  [64323] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4833), 1,
      aux_sym_while_statement_token1,
  [64330] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4835), 1,
      sym_heredoc_start,
  [64337] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4837), 1,
      sym_heredoc_start,
  [64344] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4839), 1,
      aux_sym_class_declaration_token1,
  [64351] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4841), 1,
      anon_sym_COLON_COLON,
  [64358] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4843), 1,
      anon_sym_RBRACK,
  [64365] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4077), 1,
      aux_sym_class_declaration_token1,
  [64372] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4845), 1,
      anon_sym_BSLASH,
  [64379] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4847), 1,
      anon_sym_BSLASH,
  [64386] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4849), 1,
      sym_name,
  [64393] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4470), 1,
      anon_sym_LPAREN,
  [64400] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4851), 1,
      anon_sym_RPAREN,
  [64407] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4853), 1,
      sym_name,
  [64414] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4855), 1,
      sym_name,
  [64421] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4857), 1,
      sym_name,
  [64428] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4859), 1,
      aux_sym_class_declaration_token1,
  [64435] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4861), 1,
      anon_sym_BSLASH,
  [64442] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4863), 1,
      aux_sym_class_declaration_token1,
  [64449] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4865), 1,
      sym_name,
  [64456] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4867), 1,
      anon_sym_COLON_COLON,
  [64463] = 2,
    ACTIONS(913), 1,
      anon_sym_SEMI,
    ACTIONS(1558), 1,
      sym_comment,
  [64470] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4869), 1,
      aux_sym_while_statement_token1,
  [64477] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4353), 1,
      anon_sym_RPAREN,
  [64484] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_COLON_COLON,
  [64491] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4061), 1,
      anon_sym_RPAREN,
  [64498] = 2,
    ACTIONS(917), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [64505] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4873), 1,
      anon_sym_RPAREN,
  [64512] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4875), 1,
      anon_sym_SEMI,
  [64519] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_RPAREN,
  [64526] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4472), 1,
      anon_sym_RPAREN,
  [64533] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4877), 1,
      anon_sym_COLON_COLON,
  [64540] = 2,
    ACTIONS(879), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [64547] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4879), 1,
      sym_name,
  [64554] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4881), 1,
      anon_sym_RPAREN,
  [64561] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
  [64568] = 2,
    ACTIONS(371), 1,
      ts_builtin_sym_end,
    ACTIONS(1558), 1,
      sym_comment,
  [64575] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4883), 1,
      anon_sym_RPAREN,
  [64582] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_BSLASH,
  [64589] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3244), 1,
      anon_sym_EQ,
  [64596] = 2,
    ACTIONS(871), 1,
      anon_sym_RPAREN,
    ACTIONS(1558), 1,
      sym_comment,
  [64603] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_BSLASH,
  [64610] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4887), 1,
      anon_sym_COLON_COLON,
  [64617] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4889), 1,
      sym_name,
  [64624] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4891), 1,
      anon_sym_COLON_COLON,
  [64631] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(3680), 1,
      sym_name,
  [64638] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4893), 1,
      aux_sym_namespace_use_declaration_token3,
  [64645] = 2,
    ACTIONS(375), 1,
      ts_builtin_sym_end,
    ACTIONS(1558), 1,
      sym_comment,
  [64652] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_COLON_COLON,
  [64659] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_RPAREN,
  [64666] = 2,
    ACTIONS(911), 1,
      anon_sym_SEMI,
    ACTIONS(1558), 1,
      sym_comment,
  [64673] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4897), 1,
      anon_sym_EQ,
  [64680] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4899), 1,
      anon_sym_EQ_GT,
  [64687] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4400), 1,
      anon_sym_RPAREN,
  [64694] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4901), 1,
      anon_sym_SEMI,
  [64701] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4903), 1,
      aux_sym_namespace_use_declaration_token3,
  [64708] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4905), 1,
      aux_sym__arrow_function_header_token1,
  [64715] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4048), 1,
      aux_sym_class_declaration_token1,
  [64722] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4319), 1,
      anon_sym_RPAREN,
  [64729] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4907), 1,
      anon_sym_BSLASH,
  [64736] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4909), 1,
      sym_name,
  [64743] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4911), 1,
      ts_builtin_sym_end,
  [64750] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4913), 1,
      anon_sym_RPAREN,
  [64757] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4915), 1,
      anon_sym_LPAREN,
  [64764] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4917), 1,
      anon_sym_COLON_COLON,
  [64771] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4919), 1,
      sym_heredoc_end,
  [64778] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4921), 1,
      anon_sym_LPAREN,
  [64785] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4923), 1,
      anon_sym_LPAREN,
  [64792] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4925), 1,
      sym_heredoc_end,
  [64799] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4927), 1,
      aux_sym_foreach_statement_token2,
  [64806] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4929), 1,
      anon_sym_LPAREN,
  [64813] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4931), 1,
      anon_sym_LPAREN,
  [64820] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4426), 1,
      anon_sym_RPAREN,
  [64827] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4933), 1,
      anon_sym_RPAREN,
  [64834] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4935), 1,
      anon_sym_LPAREN,
  [64841] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4937), 1,
      anon_sym_EQ_GT,
  [64848] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4939), 1,
      anon_sym_SEMI,
  [64855] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4941), 1,
      sym_name,
  [64862] = 2,
    ACTIONS(877), 1,
      anon_sym_SEMI,
    ACTIONS(1558), 1,
      sym_comment,
  [64869] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4943), 1,
      anon_sym_COLON_COLON,
  [64876] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4945), 1,
      anon_sym_LPAREN,
  [64883] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4947), 1,
      anon_sym_SEMI,
  [64890] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4949), 1,
      anon_sym_LPAREN,
  [64897] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
  [64904] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4953), 1,
      anon_sym_SEMI,
  [64911] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4955), 1,
      anon_sym_LPAREN,
  [64918] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4957), 1,
      anon_sym_LPAREN,
  [64925] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4959), 1,
      anon_sym_LPAREN,
  [64932] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4961), 1,
      sym_name,
  [64939] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4963), 1,
      sym_name,
  [64946] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4965), 1,
      sym_name,
  [64953] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4967), 1,
      anon_sym_SEMI,
  [64960] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4969), 1,
      sym_name,
  [64967] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4971), 1,
      anon_sym_LPAREN,
  [64974] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4406), 1,
      anon_sym_RPAREN,
  [64981] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
  [64988] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4975), 1,
      anon_sym_LPAREN,
  [64995] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4044), 1,
      anon_sym_RPAREN,
  [65002] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4977), 1,
      anon_sym_LPAREN,
  [65009] = 2,
    ACTIONS(1558), 1,
      sym_comment,
    ACTIONS(4979), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(571)] = 0,
  [SMALL_STATE(572)] = 70,
  [SMALL_STATE(573)] = 140,
  [SMALL_STATE(574)] = 210,
  [SMALL_STATE(575)] = 280,
  [SMALL_STATE(576)] = 353,
  [SMALL_STATE(577)] = 434,
  [SMALL_STATE(578)] = 507,
  [SMALL_STATE(579)] = 580,
  [SMALL_STATE(580)] = 653,
  [SMALL_STATE(581)] = 726,
  [SMALL_STATE(582)] = 794,
  [SMALL_STATE(583)] = 862,
  [SMALL_STATE(584)] = 930,
  [SMALL_STATE(585)] = 998,
  [SMALL_STATE(586)] = 1066,
  [SMALL_STATE(587)] = 1134,
  [SMALL_STATE(588)] = 1202,
  [SMALL_STATE(589)] = 1270,
  [SMALL_STATE(590)] = 1338,
  [SMALL_STATE(591)] = 1406,
  [SMALL_STATE(592)] = 1474,
  [SMALL_STATE(593)] = 1542,
  [SMALL_STATE(594)] = 1610,
  [SMALL_STATE(595)] = 1689,
  [SMALL_STATE(596)] = 1764,
  [SMALL_STATE(597)] = 1842,
  [SMALL_STATE(598)] = 1911,
  [SMALL_STATE(599)] = 1994,
  [SMALL_STATE(600)] = 2071,
  [SMALL_STATE(601)] = 2148,
  [SMALL_STATE(602)] = 2217,
  [SMALL_STATE(603)] = 2286,
  [SMALL_STATE(604)] = 2355,
  [SMALL_STATE(605)] = 2428,
  [SMALL_STATE(606)] = 2497,
  [SMALL_STATE(607)] = 2574,
  [SMALL_STATE(608)] = 2638,
  [SMALL_STATE(609)] = 2716,
  [SMALL_STATE(610)] = 2780,
  [SMALL_STATE(611)] = 2858,
  [SMALL_STATE(612)] = 2922,
  [SMALL_STATE(613)] = 2986,
  [SMALL_STATE(614)] = 3050,
  [SMALL_STATE(615)] = 3128,
  [SMALL_STATE(616)] = 3192,
  [SMALL_STATE(617)] = 3256,
  [SMALL_STATE(618)] = 3320,
  [SMALL_STATE(619)] = 3384,
  [SMALL_STATE(620)] = 3456,
  [SMALL_STATE(621)] = 3520,
  [SMALL_STATE(622)] = 3584,
  [SMALL_STATE(623)] = 3648,
  [SMALL_STATE(624)] = 3712,
  [SMALL_STATE(625)] = 3776,
  [SMALL_STATE(626)] = 3840,
  [SMALL_STATE(627)] = 3904,
  [SMALL_STATE(628)] = 3980,
  [SMALL_STATE(629)] = 4044,
  [SMALL_STATE(630)] = 4121,
  [SMALL_STATE(631)] = 4192,
  [SMALL_STATE(632)] = 4269,
  [SMALL_STATE(633)] = 4340,
  [SMALL_STATE(634)] = 4411,
  [SMALL_STATE(635)] = 4481,
  [SMALL_STATE(636)] = 4553,
  [SMALL_STATE(637)] = 4625,
  [SMALL_STATE(638)] = 4697,
  [SMALL_STATE(639)] = 4768,
  [SMALL_STATE(640)] = 4826,
  [SMALL_STATE(641)] = 4927,
  [SMALL_STATE(642)] = 5028,
  [SMALL_STATE(643)] = 5093,
  [SMALL_STATE(644)] = 5152,
  [SMALL_STATE(645)] = 5207,
  [SMALL_STATE(646)] = 5268,
  [SMALL_STATE(647)] = 5327,
  [SMALL_STATE(648)] = 5386,
  [SMALL_STATE(649)] = 5445,
  [SMALL_STATE(650)] = 5546,
  [SMALL_STATE(651)] = 5609,
  [SMALL_STATE(652)] = 5674,
  [SMALL_STATE(653)] = 5733,
  [SMALL_STATE(654)] = 5834,
  [SMALL_STATE(655)] = 5899,
  [SMALL_STATE(656)] = 5964,
  [SMALL_STATE(657)] = 6022,
  [SMALL_STATE(658)] = 6080,
  [SMALL_STATE(659)] = 6134,
  [SMALL_STATE(660)] = 6188,
  [SMALL_STATE(661)] = 6242,
  [SMALL_STATE(662)] = 6296,
  [SMALL_STATE(663)] = 6350,
  [SMALL_STATE(664)] = 6404,
  [SMALL_STATE(665)] = 6458,
  [SMALL_STATE(666)] = 6512,
  [SMALL_STATE(667)] = 6610,
  [SMALL_STATE(668)] = 6664,
  [SMALL_STATE(669)] = 6718,
  [SMALL_STATE(670)] = 6772,
  [SMALL_STATE(671)] = 6826,
  [SMALL_STATE(672)] = 6880,
  [SMALL_STATE(673)] = 6976,
  [SMALL_STATE(674)] = 7030,
  [SMALL_STATE(675)] = 7128,
  [SMALL_STATE(676)] = 7226,
  [SMALL_STATE(677)] = 7280,
  [SMALL_STATE(678)] = 7334,
  [SMALL_STATE(679)] = 7432,
  [SMALL_STATE(680)] = 7528,
  [SMALL_STATE(681)] = 7582,
  [SMALL_STATE(682)] = 7637,
  [SMALL_STATE(683)] = 7696,
  [SMALL_STATE(684)] = 7753,
  [SMALL_STATE(685)] = 7810,
  [SMALL_STATE(686)] = 7901,
  [SMALL_STATE(687)] = 7992,
  [SMALL_STATE(688)] = 8049,
  [SMALL_STATE(689)] = 8108,
  [SMALL_STATE(690)] = 8165,
  [SMALL_STATE(691)] = 8222,
  [SMALL_STATE(692)] = 8279,
  [SMALL_STATE(693)] = 8334,
  [SMALL_STATE(694)] = 8391,
  [SMALL_STATE(695)] = 8450,
  [SMALL_STATE(696)] = 8509,
  [SMALL_STATE(697)] = 8568,
  [SMALL_STATE(698)] = 8659,
  [SMALL_STATE(699)] = 8714,
  [SMALL_STATE(700)] = 8771,
  [SMALL_STATE(701)] = 8866,
  [SMALL_STATE(702)] = 8921,
  [SMALL_STATE(703)] = 8978,
  [SMALL_STATE(704)] = 9037,
  [SMALL_STATE(705)] = 9096,
  [SMALL_STATE(706)] = 9151,
  [SMALL_STATE(707)] = 9208,
  [SMALL_STATE(708)] = 9303,
  [SMALL_STATE(709)] = 9362,
  [SMALL_STATE(710)] = 9421,
  [SMALL_STATE(711)] = 9480,
  [SMALL_STATE(712)] = 9537,
  [SMALL_STATE(713)] = 9596,
  [SMALL_STATE(714)] = 9653,
  [SMALL_STATE(715)] = 9712,
  [SMALL_STATE(716)] = 9767,
  [SMALL_STATE(717)] = 9824,
  [SMALL_STATE(718)] = 9881,
  [SMALL_STATE(719)] = 9976,
  [SMALL_STATE(720)] = 10028,
  [SMALL_STATE(721)] = 10080,
  [SMALL_STATE(722)] = 10132,
  [SMALL_STATE(723)] = 10184,
  [SMALL_STATE(724)] = 10276,
  [SMALL_STATE(725)] = 10328,
  [SMALL_STATE(726)] = 10380,
  [SMALL_STATE(727)] = 10432,
  [SMALL_STATE(728)] = 10484,
  [SMALL_STATE(729)] = 10536,
  [SMALL_STATE(730)] = 10588,
  [SMALL_STATE(731)] = 10640,
  [SMALL_STATE(732)] = 10692,
  [SMALL_STATE(733)] = 10744,
  [SMALL_STATE(734)] = 10796,
  [SMALL_STATE(735)] = 10848,
  [SMALL_STATE(736)] = 10900,
  [SMALL_STATE(737)] = 10952,
  [SMALL_STATE(738)] = 11004,
  [SMALL_STATE(739)] = 11056,
  [SMALL_STATE(740)] = 11108,
  [SMALL_STATE(741)] = 11160,
  [SMALL_STATE(742)] = 11212,
  [SMALL_STATE(743)] = 11264,
  [SMALL_STATE(744)] = 11316,
  [SMALL_STATE(745)] = 11370,
  [SMALL_STATE(746)] = 11424,
  [SMALL_STATE(747)] = 11476,
  [SMALL_STATE(748)] = 11528,
  [SMALL_STATE(749)] = 11580,
  [SMALL_STATE(750)] = 11632,
  [SMALL_STATE(751)] = 11684,
  [SMALL_STATE(752)] = 11736,
  [SMALL_STATE(753)] = 11788,
  [SMALL_STATE(754)] = 11840,
  [SMALL_STATE(755)] = 11892,
  [SMALL_STATE(756)] = 11944,
  [SMALL_STATE(757)] = 11996,
  [SMALL_STATE(758)] = 12048,
  [SMALL_STATE(759)] = 12100,
  [SMALL_STATE(760)] = 12152,
  [SMALL_STATE(761)] = 12205,
  [SMALL_STATE(762)] = 12258,
  [SMALL_STATE(763)] = 12319,
  [SMALL_STATE(764)] = 12370,
  [SMALL_STATE(765)] = 12431,
  [SMALL_STATE(766)] = 12486,
  [SMALL_STATE(767)] = 12541,
  [SMALL_STATE(768)] = 12596,
  [SMALL_STATE(769)] = 12651,
  [SMALL_STATE(770)] = 12706,
  [SMALL_STATE(771)] = 12759,
  [SMALL_STATE(772)] = 12820,
  [SMALL_STATE(773)] = 12875,
  [SMALL_STATE(774)] = 12926,
  [SMALL_STATE(775)] = 12979,
  [SMALL_STATE(776)] = 13032,
  [SMALL_STATE(777)] = 13083,
  [SMALL_STATE(778)] = 13142,
  [SMALL_STATE(779)] = 13203,
  [SMALL_STATE(780)] = 13260,
  [SMALL_STATE(781)] = 13310,
  [SMALL_STATE(782)] = 13360,
  [SMALL_STATE(783)] = 13410,
  [SMALL_STATE(784)] = 13472,
  [SMALL_STATE(785)] = 13522,
  [SMALL_STATE(786)] = 13584,
  [SMALL_STATE(787)] = 13634,
  [SMALL_STATE(788)] = 13684,
  [SMALL_STATE(789)] = 13734,
  [SMALL_STATE(790)] = 13784,
  [SMALL_STATE(791)] = 13834,
  [SMALL_STATE(792)] = 13884,
  [SMALL_STATE(793)] = 13934,
  [SMALL_STATE(794)] = 13984,
  [SMALL_STATE(795)] = 14034,
  [SMALL_STATE(796)] = 14084,
  [SMALL_STATE(797)] = 14134,
  [SMALL_STATE(798)] = 14184,
  [SMALL_STATE(799)] = 14246,
  [SMALL_STATE(800)] = 14296,
  [SMALL_STATE(801)] = 14346,
  [SMALL_STATE(802)] = 14399,
  [SMALL_STATE(803)] = 14452,
  [SMALL_STATE(804)] = 14535,
  [SMALL_STATE(805)] = 14586,
  [SMALL_STATE(806)] = 14669,
  [SMALL_STATE(807)] = 14724,
  [SMALL_STATE(808)] = 14779,
  [SMALL_STATE(809)] = 14862,
  [SMALL_STATE(810)] = 14917,
  [SMALL_STATE(811)] = 14972,
  [SMALL_STATE(812)] = 15055,
  [SMALL_STATE(813)] = 15138,
  [SMALL_STATE(814)] = 15191,
  [SMALL_STATE(815)] = 15246,
  [SMALL_STATE(816)] = 15299,
  [SMALL_STATE(817)] = 15354,
  [SMALL_STATE(818)] = 15407,
  [SMALL_STATE(819)] = 15460,
  [SMALL_STATE(820)] = 15513,
  [SMALL_STATE(821)] = 15566,
  [SMALL_STATE(822)] = 15621,
  [SMALL_STATE(823)] = 15676,
  [SMALL_STATE(824)] = 15727,
  [SMALL_STATE(825)] = 15810,
  [SMALL_STATE(826)] = 15861,
  [SMALL_STATE(827)] = 15944,
  [SMALL_STATE(828)] = 15993,
  [SMALL_STATE(829)] = 16042,
  [SMALL_STATE(830)] = 16091,
  [SMALL_STATE(831)] = 16142,
  [SMALL_STATE(832)] = 16193,
  [SMALL_STATE(833)] = 16246,
  [SMALL_STATE(834)] = 16329,
  [SMALL_STATE(835)] = 16412,
  [SMALL_STATE(836)] = 16465,
  [SMALL_STATE(837)] = 16514,
  [SMALL_STATE(838)] = 16597,
  [SMALL_STATE(839)] = 16650,
  [SMALL_STATE(840)] = 16703,
  [SMALL_STATE(841)] = 16786,
  [SMALL_STATE(842)] = 16839,
  [SMALL_STATE(843)] = 16922,
  [SMALL_STATE(844)] = 16975,
  [SMALL_STATE(845)] = 17026,
  [SMALL_STATE(846)] = 17109,
  [SMALL_STATE(847)] = 17164,
  [SMALL_STATE(848)] = 17219,
  [SMALL_STATE(849)] = 17274,
  [SMALL_STATE(850)] = 17327,
  [SMALL_STATE(851)] = 17382,
  [SMALL_STATE(852)] = 17465,
  [SMALL_STATE(853)] = 17548,
  [SMALL_STATE(854)] = 17599,
  [SMALL_STATE(855)] = 17647,
  [SMALL_STATE(856)] = 17695,
  [SMALL_STATE(857)] = 17745,
  [SMALL_STATE(858)] = 17793,
  [SMALL_STATE(859)] = 17841,
  [SMALL_STATE(860)] = 17889,
  [SMALL_STATE(861)] = 17937,
  [SMALL_STATE(862)] = 17985,
  [SMALL_STATE(863)] = 18033,
  [SMALL_STATE(864)] = 18081,
  [SMALL_STATE(865)] = 18129,
  [SMALL_STATE(866)] = 18177,
  [SMALL_STATE(867)] = 18225,
  [SMALL_STATE(868)] = 18273,
  [SMALL_STATE(869)] = 18321,
  [SMALL_STATE(870)] = 18369,
  [SMALL_STATE(871)] = 18417,
  [SMALL_STATE(872)] = 18465,
  [SMALL_STATE(873)] = 18515,
  [SMALL_STATE(874)] = 18565,
  [SMALL_STATE(875)] = 18613,
  [SMALL_STATE(876)] = 18661,
  [SMALL_STATE(877)] = 18709,
  [SMALL_STATE(878)] = 18757,
  [SMALL_STATE(879)] = 18809,
  [SMALL_STATE(880)] = 18857,
  [SMALL_STATE(881)] = 18905,
  [SMALL_STATE(882)] = 18953,
  [SMALL_STATE(883)] = 19001,
  [SMALL_STATE(884)] = 19049,
  [SMALL_STATE(885)] = 19097,
  [SMALL_STATE(886)] = 19145,
  [SMALL_STATE(887)] = 19193,
  [SMALL_STATE(888)] = 19241,
  [SMALL_STATE(889)] = 19289,
  [SMALL_STATE(890)] = 19337,
  [SMALL_STATE(891)] = 19385,
  [SMALL_STATE(892)] = 19433,
  [SMALL_STATE(893)] = 19481,
  [SMALL_STATE(894)] = 19529,
  [SMALL_STATE(895)] = 19577,
  [SMALL_STATE(896)] = 19625,
  [SMALL_STATE(897)] = 19674,
  [SMALL_STATE(898)] = 19723,
  [SMALL_STATE(899)] = 19772,
  [SMALL_STATE(900)] = 19821,
  [SMALL_STATE(901)] = 19870,
  [SMALL_STATE(902)] = 19916,
  [SMALL_STATE(903)] = 19962,
  [SMALL_STATE(904)] = 20008,
  [SMALL_STATE(905)] = 20054,
  [SMALL_STATE(906)] = 20100,
  [SMALL_STATE(907)] = 20146,
  [SMALL_STATE(908)] = 20192,
  [SMALL_STATE(909)] = 20238,
  [SMALL_STATE(910)] = 20284,
  [SMALL_STATE(911)] = 20330,
  [SMALL_STATE(912)] = 20376,
  [SMALL_STATE(913)] = 20422,
  [SMALL_STATE(914)] = 20468,
  [SMALL_STATE(915)] = 20514,
  [SMALL_STATE(916)] = 20560,
  [SMALL_STATE(917)] = 20606,
  [SMALL_STATE(918)] = 20652,
  [SMALL_STATE(919)] = 20698,
  [SMALL_STATE(920)] = 20744,
  [SMALL_STATE(921)] = 20790,
  [SMALL_STATE(922)] = 20870,
  [SMALL_STATE(923)] = 20916,
  [SMALL_STATE(924)] = 20964,
  [SMALL_STATE(925)] = 21010,
  [SMALL_STATE(926)] = 21056,
  [SMALL_STATE(927)] = 21102,
  [SMALL_STATE(928)] = 21148,
  [SMALL_STATE(929)] = 21194,
  [SMALL_STATE(930)] = 21240,
  [SMALL_STATE(931)] = 21286,
  [SMALL_STATE(932)] = 21332,
  [SMALL_STATE(933)] = 21378,
  [SMALL_STATE(934)] = 21424,
  [SMALL_STATE(935)] = 21470,
  [SMALL_STATE(936)] = 21516,
  [SMALL_STATE(937)] = 21562,
  [SMALL_STATE(938)] = 21608,
  [SMALL_STATE(939)] = 21654,
  [SMALL_STATE(940)] = 21700,
  [SMALL_STATE(941)] = 21746,
  [SMALL_STATE(942)] = 21792,
  [SMALL_STATE(943)] = 21838,
  [SMALL_STATE(944)] = 21884,
  [SMALL_STATE(945)] = 21930,
  [SMALL_STATE(946)] = 21976,
  [SMALL_STATE(947)] = 22022,
  [SMALL_STATE(948)] = 22068,
  [SMALL_STATE(949)] = 22114,
  [SMALL_STATE(950)] = 22160,
  [SMALL_STATE(951)] = 22206,
  [SMALL_STATE(952)] = 22252,
  [SMALL_STATE(953)] = 22298,
  [SMALL_STATE(954)] = 22344,
  [SMALL_STATE(955)] = 22390,
  [SMALL_STATE(956)] = 22436,
  [SMALL_STATE(957)] = 22482,
  [SMALL_STATE(958)] = 22528,
  [SMALL_STATE(959)] = 22574,
  [SMALL_STATE(960)] = 22620,
  [SMALL_STATE(961)] = 22666,
  [SMALL_STATE(962)] = 22712,
  [SMALL_STATE(963)] = 22758,
  [SMALL_STATE(964)] = 22804,
  [SMALL_STATE(965)] = 22850,
  [SMALL_STATE(966)] = 22896,
  [SMALL_STATE(967)] = 22941,
  [SMALL_STATE(968)] = 22986,
  [SMALL_STATE(969)] = 23068,
  [SMALL_STATE(970)] = 23122,
  [SMALL_STATE(971)] = 23204,
  [SMALL_STATE(972)] = 23280,
  [SMALL_STATE(973)] = 23356,
  [SMALL_STATE(974)] = 23438,
  [SMALL_STATE(975)] = 23520,
  [SMALL_STATE(976)] = 23602,
  [SMALL_STATE(977)] = 23666,
  [SMALL_STATE(978)] = 23734,
  [SMALL_STATE(979)] = 23784,
  [SMALL_STATE(980)] = 23860,
  [SMALL_STATE(981)] = 23906,
  [SMALL_STATE(982)] = 23982,
  [SMALL_STATE(983)] = 24058,
  [SMALL_STATE(984)] = 24138,
  [SMALL_STATE(985)] = 24216,
  [SMALL_STATE(986)] = 24292,
  [SMALL_STATE(987)] = 24368,
  [SMALL_STATE(988)] = 24440,
  [SMALL_STATE(989)] = 24522,
  [SMALL_STATE(990)] = 24592,
  [SMALL_STATE(991)] = 24658,
  [SMALL_STATE(992)] = 24740,
  [SMALL_STATE(993)] = 24800,
  [SMALL_STATE(994)] = 24882,
  [SMALL_STATE(995)] = 24964,
  [SMALL_STATE(996)] = 25046,
  [SMALL_STATE(997)] = 25102,
  [SMALL_STATE(998)] = 25186,
  [SMALL_STATE(999)] = 25238,
  [SMALL_STATE(1000)] = 25284,
  [SMALL_STATE(1001)] = 25353,
  [SMALL_STATE(1002)] = 25424,
  [SMALL_STATE(1003)] = 25477,
  [SMALL_STATE(1004)] = 25554,
  [SMALL_STATE(1005)] = 25633,
  [SMALL_STATE(1006)] = 25708,
  [SMALL_STATE(1007)] = 25753,
  [SMALL_STATE(1008)] = 25828,
  [SMALL_STATE(1009)] = 25877,
  [SMALL_STATE(1010)] = 25942,
  [SMALL_STATE(1011)] = 26009,
  [SMALL_STATE(1012)] = 26090,
  [SMALL_STATE(1013)] = 26171,
  [SMALL_STATE(1014)] = 26234,
  [SMALL_STATE(1015)] = 26315,
  [SMALL_STATE(1016)] = 26396,
  [SMALL_STATE(1017)] = 26477,
  [SMALL_STATE(1018)] = 26558,
  [SMALL_STATE(1019)] = 26641,
  [SMALL_STATE(1020)] = 26722,
  [SMALL_STATE(1021)] = 26797,
  [SMALL_STATE(1022)] = 26872,
  [SMALL_STATE(1023)] = 26947,
  [SMALL_STATE(1024)] = 27028,
  [SMALL_STATE(1025)] = 27103,
  [SMALL_STATE(1026)] = 27154,
  [SMALL_STATE(1027)] = 27209,
  [SMALL_STATE(1028)] = 27290,
  [SMALL_STATE(1029)] = 27371,
  [SMALL_STATE(1030)] = 27428,
  [SMALL_STATE(1031)] = 27487,
  [SMALL_STATE(1032)] = 27562,
  [SMALL_STATE(1033)] = 27607,
  [SMALL_STATE(1034)] = 27649,
  [SMALL_STATE(1035)] = 27691,
  [SMALL_STATE(1036)] = 27759,
  [SMALL_STATE(1037)] = 27803,
  [SMALL_STATE(1038)] = 27845,
  [SMALL_STATE(1039)] = 27887,
  [SMALL_STATE(1040)] = 27929,
  [SMALL_STATE(1041)] = 28009,
  [SMALL_STATE(1042)] = 28051,
  [SMALL_STATE(1043)] = 28093,
  [SMALL_STATE(1044)] = 28135,
  [SMALL_STATE(1045)] = 28177,
  [SMALL_STATE(1046)] = 28229,
  [SMALL_STATE(1047)] = 28271,
  [SMALL_STATE(1048)] = 28313,
  [SMALL_STATE(1049)] = 28355,
  [SMALL_STATE(1050)] = 28397,
  [SMALL_STATE(1051)] = 28439,
  [SMALL_STATE(1052)] = 28481,
  [SMALL_STATE(1053)] = 28561,
  [SMALL_STATE(1054)] = 28603,
  [SMALL_STATE(1055)] = 28645,
  [SMALL_STATE(1056)] = 28719,
  [SMALL_STATE(1057)] = 28761,
  [SMALL_STATE(1058)] = 28803,
  [SMALL_STATE(1059)] = 28845,
  [SMALL_STATE(1060)] = 28913,
  [SMALL_STATE(1061)] = 28955,
  [SMALL_STATE(1062)] = 28999,
  [SMALL_STATE(1063)] = 29041,
  [SMALL_STATE(1064)] = 29083,
  [SMALL_STATE(1065)] = 29125,
  [SMALL_STATE(1066)] = 29167,
  [SMALL_STATE(1067)] = 29235,
  [SMALL_STATE(1068)] = 29277,
  [SMALL_STATE(1069)] = 29319,
  [SMALL_STATE(1070)] = 29361,
  [SMALL_STATE(1071)] = 29403,
  [SMALL_STATE(1072)] = 29445,
  [SMALL_STATE(1073)] = 29487,
  [SMALL_STATE(1074)] = 29529,
  [SMALL_STATE(1075)] = 29571,
  [SMALL_STATE(1076)] = 29613,
  [SMALL_STATE(1077)] = 29655,
  [SMALL_STATE(1078)] = 29697,
  [SMALL_STATE(1079)] = 29739,
  [SMALL_STATE(1080)] = 29781,
  [SMALL_STATE(1081)] = 29855,
  [SMALL_STATE(1082)] = 29897,
  [SMALL_STATE(1083)] = 29947,
  [SMALL_STATE(1084)] = 30001,
  [SMALL_STATE(1085)] = 30075,
  [SMALL_STATE(1086)] = 30117,
  [SMALL_STATE(1087)] = 30185,
  [SMALL_STATE(1088)] = 30227,
  [SMALL_STATE(1089)] = 30269,
  [SMALL_STATE(1090)] = 30311,
  [SMALL_STATE(1091)] = 30353,
  [SMALL_STATE(1092)] = 30411,
  [SMALL_STATE(1093)] = 30453,
  [SMALL_STATE(1094)] = 30517,
  [SMALL_STATE(1095)] = 30559,
  [SMALL_STATE(1096)] = 30627,
  [SMALL_STATE(1097)] = 30669,
  [SMALL_STATE(1098)] = 30711,
  [SMALL_STATE(1099)] = 30753,
  [SMALL_STATE(1100)] = 30821,
  [SMALL_STATE(1101)] = 30863,
  [SMALL_STATE(1102)] = 30943,
  [SMALL_STATE(1103)] = 31023,
  [SMALL_STATE(1104)] = 31103,
  [SMALL_STATE(1105)] = 31183,
  [SMALL_STATE(1106)] = 31225,
  [SMALL_STATE(1107)] = 31267,
  [SMALL_STATE(1108)] = 31309,
  [SMALL_STATE(1109)] = 31383,
  [SMALL_STATE(1110)] = 31465,
  [SMALL_STATE(1111)] = 31507,
  [SMALL_STATE(1112)] = 31549,
  [SMALL_STATE(1113)] = 31591,
  [SMALL_STATE(1114)] = 31633,
  [SMALL_STATE(1115)] = 31713,
  [SMALL_STATE(1116)] = 31755,
  [SMALL_STATE(1117)] = 31797,
  [SMALL_STATE(1118)] = 31865,
  [SMALL_STATE(1119)] = 31935,
  [SMALL_STATE(1120)] = 32009,
  [SMALL_STATE(1121)] = 32051,
  [SMALL_STATE(1122)] = 32093,
  [SMALL_STATE(1123)] = 32135,
  [SMALL_STATE(1124)] = 32215,
  [SMALL_STATE(1125)] = 32277,
  [SMALL_STATE(1126)] = 32343,
  [SMALL_STATE(1127)] = 32423,
  [SMALL_STATE(1128)] = 32499,
  [SMALL_STATE(1129)] = 32547,
  [SMALL_STATE(1130)] = 32621,
  [SMALL_STATE(1131)] = 32663,
  [SMALL_STATE(1132)] = 32705,
  [SMALL_STATE(1133)] = 32747,
  [SMALL_STATE(1134)] = 32827,
  [SMALL_STATE(1135)] = 32871,
  [SMALL_STATE(1136)] = 32949,
  [SMALL_STATE(1137)] = 33023,
  [SMALL_STATE(1138)] = 33096,
  [SMALL_STATE(1139)] = 33175,
  [SMALL_STATE(1140)] = 33218,
  [SMALL_STATE(1141)] = 33291,
  [SMALL_STATE(1142)] = 33334,
  [SMALL_STATE(1143)] = 33377,
  [SMALL_STATE(1144)] = 33438,
  [SMALL_STATE(1145)] = 33511,
  [SMALL_STATE(1146)] = 33580,
  [SMALL_STATE(1147)] = 33659,
  [SMALL_STATE(1148)] = 33738,
  [SMALL_STATE(1149)] = 33803,
  [SMALL_STATE(1150)] = 33882,
  [SMALL_STATE(1151)] = 33933,
  [SMALL_STATE(1152)] = 34010,
  [SMALL_STATE(1153)] = 34053,
  [SMALL_STATE(1154)] = 34126,
  [SMALL_STATE(1155)] = 34205,
  [SMALL_STATE(1156)] = 34278,
  [SMALL_STATE(1157)] = 34351,
  [SMALL_STATE(1158)] = 34424,
  [SMALL_STATE(1159)] = 34503,
  [SMALL_STATE(1160)] = 34578,
  [SMALL_STATE(1161)] = 34625,
  [SMALL_STATE(1162)] = 34694,
  [SMALL_STATE(1163)] = 34773,
  [SMALL_STATE(1164)] = 34852,
  [SMALL_STATE(1165)] = 34901,
  [SMALL_STATE(1166)] = 34954,
  [SMALL_STATE(1167)] = 35011,
  [SMALL_STATE(1168)] = 35074,
  [SMALL_STATE(1169)] = 35153,
  [SMALL_STATE(1170)] = 35234,
  [SMALL_STATE(1171)] = 35301,
  [SMALL_STATE(1172)] = 35370,
  [SMALL_STATE(1173)] = 35449,
  [SMALL_STATE(1174)] = 35529,
  [SMALL_STATE(1175)] = 35607,
  [SMALL_STATE(1176)] = 35687,
  [SMALL_STATE(1177)] = 35769,
  [SMALL_STATE(1178)] = 35849,
  [SMALL_STATE(1179)] = 35927,
  [SMALL_STATE(1180)] = 36005,
  [SMALL_STATE(1181)] = 36085,
  [SMALL_STATE(1182)] = 36165,
  [SMALL_STATE(1183)] = 36242,
  [SMALL_STATE(1184)] = 36319,
  [SMALL_STATE(1185)] = 36396,
  [SMALL_STATE(1186)] = 36473,
  [SMALL_STATE(1187)] = 36552,
  [SMALL_STATE(1188)] = 36627,
  [SMALL_STATE(1189)] = 36674,
  [SMALL_STATE(1190)] = 36737,
  [SMALL_STATE(1191)] = 36784,
  [SMALL_STATE(1192)] = 36859,
  [SMALL_STATE(1193)] = 36934,
  [SMALL_STATE(1194)] = 37013,
  [SMALL_STATE(1195)] = 37076,
  [SMALL_STATE(1196)] = 37153,
  [SMALL_STATE(1197)] = 37230,
  [SMALL_STATE(1198)] = 37309,
  [SMALL_STATE(1199)] = 37386,
  [SMALL_STATE(1200)] = 37465,
  [SMALL_STATE(1201)] = 37542,
  [SMALL_STATE(1202)] = 37619,
  [SMALL_STATE(1203)] = 37694,
  [SMALL_STATE(1204)] = 37773,
  [SMALL_STATE(1205)] = 37850,
  [SMALL_STATE(1206)] = 37925,
  [SMALL_STATE(1207)] = 38002,
  [SMALL_STATE(1208)] = 38079,
  [SMALL_STATE(1209)] = 38156,
  [SMALL_STATE(1210)] = 38233,
  [SMALL_STATE(1211)] = 38310,
  [SMALL_STATE(1212)] = 38387,
  [SMALL_STATE(1213)] = 38466,
  [SMALL_STATE(1214)] = 38545,
  [SMALL_STATE(1215)] = 38622,
  [SMALL_STATE(1216)] = 38699,
  [SMALL_STATE(1217)] = 38776,
  [SMALL_STATE(1218)] = 38853,
  [SMALL_STATE(1219)] = 38930,
  [SMALL_STATE(1220)] = 39007,
  [SMALL_STATE(1221)] = 39082,
  [SMALL_STATE(1222)] = 39159,
  [SMALL_STATE(1223)] = 39234,
  [SMALL_STATE(1224)] = 39313,
  [SMALL_STATE(1225)] = 39388,
  [SMALL_STATE(1226)] = 39465,
  [SMALL_STATE(1227)] = 39542,
  [SMALL_STATE(1228)] = 39619,
  [SMALL_STATE(1229)] = 39694,
  [SMALL_STATE(1230)] = 39771,
  [SMALL_STATE(1231)] = 39848,
  [SMALL_STATE(1232)] = 39925,
  [SMALL_STATE(1233)] = 40002,
  [SMALL_STATE(1234)] = 40079,
  [SMALL_STATE(1235)] = 40156,
  [SMALL_STATE(1236)] = 40232,
  [SMALL_STATE(1237)] = 40308,
  [SMALL_STATE(1238)] = 40384,
  [SMALL_STATE(1239)] = 40460,
  [SMALL_STATE(1240)] = 40536,
  [SMALL_STATE(1241)] = 40612,
  [SMALL_STATE(1242)] = 40688,
  [SMALL_STATE(1243)] = 40764,
  [SMALL_STATE(1244)] = 40840,
  [SMALL_STATE(1245)] = 40916,
  [SMALL_STATE(1246)] = 40992,
  [SMALL_STATE(1247)] = 41052,
  [SMALL_STATE(1248)] = 41128,
  [SMALL_STATE(1249)] = 41204,
  [SMALL_STATE(1250)] = 41280,
  [SMALL_STATE(1251)] = 41340,
  [SMALL_STATE(1252)] = 41416,
  [SMALL_STATE(1253)] = 41492,
  [SMALL_STATE(1254)] = 41568,
  [SMALL_STATE(1255)] = 41644,
  [SMALL_STATE(1256)] = 41720,
  [SMALL_STATE(1257)] = 41796,
  [SMALL_STATE(1258)] = 41872,
  [SMALL_STATE(1259)] = 41948,
  [SMALL_STATE(1260)] = 42024,
  [SMALL_STATE(1261)] = 42100,
  [SMALL_STATE(1262)] = 42176,
  [SMALL_STATE(1263)] = 42252,
  [SMALL_STATE(1264)] = 42328,
  [SMALL_STATE(1265)] = 42404,
  [SMALL_STATE(1266)] = 42442,
  [SMALL_STATE(1267)] = 42518,
  [SMALL_STATE(1268)] = 42594,
  [SMALL_STATE(1269)] = 42670,
  [SMALL_STATE(1270)] = 42746,
  [SMALL_STATE(1271)] = 42822,
  [SMALL_STATE(1272)] = 42898,
  [SMALL_STATE(1273)] = 42974,
  [SMALL_STATE(1274)] = 43050,
  [SMALL_STATE(1275)] = 43126,
  [SMALL_STATE(1276)] = 43202,
  [SMALL_STATE(1277)] = 43278,
  [SMALL_STATE(1278)] = 43354,
  [SMALL_STATE(1279)] = 43430,
  [SMALL_STATE(1280)] = 43506,
  [SMALL_STATE(1281)] = 43582,
  [SMALL_STATE(1282)] = 43658,
  [SMALL_STATE(1283)] = 43734,
  [SMALL_STATE(1284)] = 43810,
  [SMALL_STATE(1285)] = 43886,
  [SMALL_STATE(1286)] = 43962,
  [SMALL_STATE(1287)] = 44038,
  [SMALL_STATE(1288)] = 44114,
  [SMALL_STATE(1289)] = 44190,
  [SMALL_STATE(1290)] = 44266,
  [SMALL_STATE(1291)] = 44342,
  [SMALL_STATE(1292)] = 44418,
  [SMALL_STATE(1293)] = 44494,
  [SMALL_STATE(1294)] = 44570,
  [SMALL_STATE(1295)] = 44646,
  [SMALL_STATE(1296)] = 44722,
  [SMALL_STATE(1297)] = 44798,
  [SMALL_STATE(1298)] = 44874,
  [SMALL_STATE(1299)] = 44950,
  [SMALL_STATE(1300)] = 45026,
  [SMALL_STATE(1301)] = 45102,
  [SMALL_STATE(1302)] = 45178,
  [SMALL_STATE(1303)] = 45254,
  [SMALL_STATE(1304)] = 45330,
  [SMALL_STATE(1305)] = 45395,
  [SMALL_STATE(1306)] = 45460,
  [SMALL_STATE(1307)] = 45525,
  [SMALL_STATE(1308)] = 45562,
  [SMALL_STATE(1309)] = 45627,
  [SMALL_STATE(1310)] = 45692,
  [SMALL_STATE(1311)] = 45729,
  [SMALL_STATE(1312)] = 45768,
  [SMALL_STATE(1313)] = 45804,
  [SMALL_STATE(1314)] = 45840,
  [SMALL_STATE(1315)] = 45879,
  [SMALL_STATE(1316)] = 45918,
  [SMALL_STATE(1317)] = 45967,
  [SMALL_STATE(1318)] = 46016,
  [SMALL_STATE(1319)] = 46065,
  [SMALL_STATE(1320)] = 46114,
  [SMALL_STATE(1321)] = 46163,
  [SMALL_STATE(1322)] = 46212,
  [SMALL_STATE(1323)] = 46261,
  [SMALL_STATE(1324)] = 46294,
  [SMALL_STATE(1325)] = 46327,
  [SMALL_STATE(1326)] = 46360,
  [SMALL_STATE(1327)] = 46409,
  [SMALL_STATE(1328)] = 46458,
  [SMALL_STATE(1329)] = 46507,
  [SMALL_STATE(1330)] = 46556,
  [SMALL_STATE(1331)] = 46602,
  [SMALL_STATE(1332)] = 46648,
  [SMALL_STATE(1333)] = 46694,
  [SMALL_STATE(1334)] = 46740,
  [SMALL_STATE(1335)] = 46786,
  [SMALL_STATE(1336)] = 46832,
  [SMALL_STATE(1337)] = 46861,
  [SMALL_STATE(1338)] = 46902,
  [SMALL_STATE(1339)] = 46943,
  [SMALL_STATE(1340)] = 46984,
  [SMALL_STATE(1341)] = 47012,
  [SMALL_STATE(1342)] = 47061,
  [SMALL_STATE(1343)] = 47103,
  [SMALL_STATE(1344)] = 47142,
  [SMALL_STATE(1345)] = 47169,
  [SMALL_STATE(1346)] = 47208,
  [SMALL_STATE(1347)] = 47235,
  [SMALL_STATE(1348)] = 47271,
  [SMALL_STATE(1349)] = 47295,
  [SMALL_STATE(1350)] = 47331,
  [SMALL_STATE(1351)] = 47370,
  [SMALL_STATE(1352)] = 47391,
  [SMALL_STATE(1353)] = 47430,
  [SMALL_STATE(1354)] = 47451,
  [SMALL_STATE(1355)] = 47472,
  [SMALL_STATE(1356)] = 47492,
  [SMALL_STATE(1357)] = 47526,
  [SMALL_STATE(1358)] = 47546,
  [SMALL_STATE(1359)] = 47566,
  [SMALL_STATE(1360)] = 47586,
  [SMALL_STATE(1361)] = 47606,
  [SMALL_STATE(1362)] = 47626,
  [SMALL_STATE(1363)] = 47646,
  [SMALL_STATE(1364)] = 47666,
  [SMALL_STATE(1365)] = 47686,
  [SMALL_STATE(1366)] = 47706,
  [SMALL_STATE(1367)] = 47740,
  [SMALL_STATE(1368)] = 47774,
  [SMALL_STATE(1369)] = 47794,
  [SMALL_STATE(1370)] = 47814,
  [SMALL_STATE(1371)] = 47834,
  [SMALL_STATE(1372)] = 47870,
  [SMALL_STATE(1373)] = 47890,
  [SMALL_STATE(1374)] = 47910,
  [SMALL_STATE(1375)] = 47930,
  [SMALL_STATE(1376)] = 47950,
  [SMALL_STATE(1377)] = 47970,
  [SMALL_STATE(1378)] = 47989,
  [SMALL_STATE(1379)] = 48008,
  [SMALL_STATE(1380)] = 48041,
  [SMALL_STATE(1381)] = 48060,
  [SMALL_STATE(1382)] = 48093,
  [SMALL_STATE(1383)] = 48112,
  [SMALL_STATE(1384)] = 48131,
  [SMALL_STATE(1385)] = 48156,
  [SMALL_STATE(1386)] = 48175,
  [SMALL_STATE(1387)] = 48210,
  [SMALL_STATE(1388)] = 48229,
  [SMALL_STATE(1389)] = 48264,
  [SMALL_STATE(1390)] = 48283,
  [SMALL_STATE(1391)] = 48302,
  [SMALL_STATE(1392)] = 48335,
  [SMALL_STATE(1393)] = 48354,
  [SMALL_STATE(1394)] = 48387,
  [SMALL_STATE(1395)] = 48420,
  [SMALL_STATE(1396)] = 48439,
  [SMALL_STATE(1397)] = 48458,
  [SMALL_STATE(1398)] = 48491,
  [SMALL_STATE(1399)] = 48510,
  [SMALL_STATE(1400)] = 48543,
  [SMALL_STATE(1401)] = 48562,
  [SMALL_STATE(1402)] = 48581,
  [SMALL_STATE(1403)] = 48622,
  [SMALL_STATE(1404)] = 48641,
  [SMALL_STATE(1405)] = 48674,
  [SMALL_STATE(1406)] = 48693,
  [SMALL_STATE(1407)] = 48712,
  [SMALL_STATE(1408)] = 48731,
  [SMALL_STATE(1409)] = 48750,
  [SMALL_STATE(1410)] = 48769,
  [SMALL_STATE(1411)] = 48810,
  [SMALL_STATE(1412)] = 48843,
  [SMALL_STATE(1413)] = 48862,
  [SMALL_STATE(1414)] = 48895,
  [SMALL_STATE(1415)] = 48914,
  [SMALL_STATE(1416)] = 48933,
  [SMALL_STATE(1417)] = 48967,
  [SMALL_STATE(1418)] = 49001,
  [SMALL_STATE(1419)] = 49035,
  [SMALL_STATE(1420)] = 49065,
  [SMALL_STATE(1421)] = 49095,
  [SMALL_STATE(1422)] = 49129,
  [SMALL_STATE(1423)] = 49154,
  [SMALL_STATE(1424)] = 49173,
  [SMALL_STATE(1425)] = 49202,
  [SMALL_STATE(1426)] = 49233,
  [SMALL_STATE(1427)] = 49264,
  [SMALL_STATE(1428)] = 49293,
  [SMALL_STATE(1429)] = 49324,
  [SMALL_STATE(1430)] = 49353,
  [SMALL_STATE(1431)] = 49378,
  [SMALL_STATE(1432)] = 49409,
  [SMALL_STATE(1433)] = 49440,
  [SMALL_STATE(1434)] = 49459,
  [SMALL_STATE(1435)] = 49484,
  [SMALL_STATE(1436)] = 49515,
  [SMALL_STATE(1437)] = 49534,
  [SMALL_STATE(1438)] = 49560,
  [SMALL_STATE(1439)] = 49588,
  [SMALL_STATE(1440)] = 49610,
  [SMALL_STATE(1441)] = 49632,
  [SMALL_STATE(1442)] = 49654,
  [SMALL_STATE(1443)] = 49676,
  [SMALL_STATE(1444)] = 49694,
  [SMALL_STATE(1445)] = 49722,
  [SMALL_STATE(1446)] = 49740,
  [SMALL_STATE(1447)] = 49758,
  [SMALL_STATE(1448)] = 49776,
  [SMALL_STATE(1449)] = 49800,
  [SMALL_STATE(1450)] = 49818,
  [SMALL_STATE(1451)] = 49846,
  [SMALL_STATE(1452)] = 49874,
  [SMALL_STATE(1453)] = 49900,
  [SMALL_STATE(1454)] = 49926,
  [SMALL_STATE(1455)] = 49954,
  [SMALL_STATE(1456)] = 49972,
  [SMALL_STATE(1457)] = 49994,
  [SMALL_STATE(1458)] = 50017,
  [SMALL_STATE(1459)] = 50040,
  [SMALL_STATE(1460)] = 50061,
  [SMALL_STATE(1461)] = 50084,
  [SMALL_STATE(1462)] = 50107,
  [SMALL_STATE(1463)] = 50122,
  [SMALL_STATE(1464)] = 50147,
  [SMALL_STATE(1465)] = 50170,
  [SMALL_STATE(1466)] = 50197,
  [SMALL_STATE(1467)] = 50220,
  [SMALL_STATE(1468)] = 50243,
  [SMALL_STATE(1469)] = 50264,
  [SMALL_STATE(1470)] = 50287,
  [SMALL_STATE(1471)] = 50310,
  [SMALL_STATE(1472)] = 50331,
  [SMALL_STATE(1473)] = 50352,
  [SMALL_STATE(1474)] = 50377,
  [SMALL_STATE(1475)] = 50398,
  [SMALL_STATE(1476)] = 50421,
  [SMALL_STATE(1477)] = 50446,
  [SMALL_STATE(1478)] = 50469,
  [SMALL_STATE(1479)] = 50490,
  [SMALL_STATE(1480)] = 50513,
  [SMALL_STATE(1481)] = 50534,
  [SMALL_STATE(1482)] = 50555,
  [SMALL_STATE(1483)] = 50572,
  [SMALL_STATE(1484)] = 50595,
  [SMALL_STATE(1485)] = 50610,
  [SMALL_STATE(1486)] = 50627,
  [SMALL_STATE(1487)] = 50648,
  [SMALL_STATE(1488)] = 50671,
  [SMALL_STATE(1489)] = 50690,
  [SMALL_STATE(1490)] = 50713,
  [SMALL_STATE(1491)] = 50738,
  [SMALL_STATE(1492)] = 50759,
  [SMALL_STATE(1493)] = 50784,
  [SMALL_STATE(1494)] = 50807,
  [SMALL_STATE(1495)] = 50830,
  [SMALL_STATE(1496)] = 50853,
  [SMALL_STATE(1497)] = 50876,
  [SMALL_STATE(1498)] = 50901,
  [SMALL_STATE(1499)] = 50926,
  [SMALL_STATE(1500)] = 50949,
  [SMALL_STATE(1501)] = 50974,
  [SMALL_STATE(1502)] = 50999,
  [SMALL_STATE(1503)] = 51022,
  [SMALL_STATE(1504)] = 51045,
  [SMALL_STATE(1505)] = 51068,
  [SMALL_STATE(1506)] = 51095,
  [SMALL_STATE(1507)] = 51110,
  [SMALL_STATE(1508)] = 51133,
  [SMALL_STATE(1509)] = 51158,
  [SMALL_STATE(1510)] = 51181,
  [SMALL_STATE(1511)] = 51204,
  [SMALL_STATE(1512)] = 51219,
  [SMALL_STATE(1513)] = 51244,
  [SMALL_STATE(1514)] = 51259,
  [SMALL_STATE(1515)] = 51276,
  [SMALL_STATE(1516)] = 51299,
  [SMALL_STATE(1517)] = 51324,
  [SMALL_STATE(1518)] = 51347,
  [SMALL_STATE(1519)] = 51372,
  [SMALL_STATE(1520)] = 51393,
  [SMALL_STATE(1521)] = 51414,
  [SMALL_STATE(1522)] = 51437,
  [SMALL_STATE(1523)] = 51458,
  [SMALL_STATE(1524)] = 51481,
  [SMALL_STATE(1525)] = 51503,
  [SMALL_STATE(1526)] = 51523,
  [SMALL_STATE(1527)] = 51551,
  [SMALL_STATE(1528)] = 51579,
  [SMALL_STATE(1529)] = 51605,
  [SMALL_STATE(1530)] = 51633,
  [SMALL_STATE(1531)] = 51655,
  [SMALL_STATE(1532)] = 51675,
  [SMALL_STATE(1533)] = 51699,
  [SMALL_STATE(1534)] = 51727,
  [SMALL_STATE(1535)] = 51755,
  [SMALL_STATE(1536)] = 51775,
  [SMALL_STATE(1537)] = 51795,
  [SMALL_STATE(1538)] = 51823,
  [SMALL_STATE(1539)] = 51842,
  [SMALL_STATE(1540)] = 51859,
  [SMALL_STATE(1541)] = 51874,
  [SMALL_STATE(1542)] = 51893,
  [SMALL_STATE(1543)] = 51910,
  [SMALL_STATE(1544)] = 51929,
  [SMALL_STATE(1545)] = 51946,
  [SMALL_STATE(1546)] = 51967,
  [SMALL_STATE(1547)] = 51984,
  [SMALL_STATE(1548)] = 51999,
  [SMALL_STATE(1549)] = 52014,
  [SMALL_STATE(1550)] = 52029,
  [SMALL_STATE(1551)] = 52044,
  [SMALL_STATE(1552)] = 52059,
  [SMALL_STATE(1553)] = 52076,
  [SMALL_STATE(1554)] = 52093,
  [SMALL_STATE(1555)] = 52108,
  [SMALL_STATE(1556)] = 52123,
  [SMALL_STATE(1557)] = 52140,
  [SMALL_STATE(1558)] = 52155,
  [SMALL_STATE(1559)] = 52176,
  [SMALL_STATE(1560)] = 52193,
  [SMALL_STATE(1561)] = 52208,
  [SMALL_STATE(1562)] = 52223,
  [SMALL_STATE(1563)] = 52240,
  [SMALL_STATE(1564)] = 52257,
  [SMALL_STATE(1565)] = 52274,
  [SMALL_STATE(1566)] = 52291,
  [SMALL_STATE(1567)] = 52308,
  [SMALL_STATE(1568)] = 52327,
  [SMALL_STATE(1569)] = 52344,
  [SMALL_STATE(1570)] = 52361,
  [SMALL_STATE(1571)] = 52384,
  [SMALL_STATE(1572)] = 52405,
  [SMALL_STATE(1573)] = 52422,
  [SMALL_STATE(1574)] = 52439,
  [SMALL_STATE(1575)] = 52454,
  [SMALL_STATE(1576)] = 52479,
  [SMALL_STATE(1577)] = 52496,
  [SMALL_STATE(1578)] = 52513,
  [SMALL_STATE(1579)] = 52530,
  [SMALL_STATE(1580)] = 52551,
  [SMALL_STATE(1581)] = 52568,
  [SMALL_STATE(1582)] = 52590,
  [SMALL_STATE(1583)] = 52612,
  [SMALL_STATE(1584)] = 52626,
  [SMALL_STATE(1585)] = 52648,
  [SMALL_STATE(1586)] = 52670,
  [SMALL_STATE(1587)] = 52688,
  [SMALL_STATE(1588)] = 52710,
  [SMALL_STATE(1589)] = 52732,
  [SMALL_STATE(1590)] = 52754,
  [SMALL_STATE(1591)] = 52776,
  [SMALL_STATE(1592)] = 52798,
  [SMALL_STATE(1593)] = 52816,
  [SMALL_STATE(1594)] = 52838,
  [SMALL_STATE(1595)] = 52852,
  [SMALL_STATE(1596)] = 52874,
  [SMALL_STATE(1597)] = 52896,
  [SMALL_STATE(1598)] = 52916,
  [SMALL_STATE(1599)] = 52930,
  [SMALL_STATE(1600)] = 52952,
  [SMALL_STATE(1601)] = 52972,
  [SMALL_STATE(1602)] = 52994,
  [SMALL_STATE(1603)] = 53008,
  [SMALL_STATE(1604)] = 53022,
  [SMALL_STATE(1605)] = 53036,
  [SMALL_STATE(1606)] = 53050,
  [SMALL_STATE(1607)] = 53068,
  [SMALL_STATE(1608)] = 53082,
  [SMALL_STATE(1609)] = 53100,
  [SMALL_STATE(1610)] = 53122,
  [SMALL_STATE(1611)] = 53142,
  [SMALL_STATE(1612)] = 53156,
  [SMALL_STATE(1613)] = 53174,
  [SMALL_STATE(1614)] = 53196,
  [SMALL_STATE(1615)] = 53214,
  [SMALL_STATE(1616)] = 53236,
  [SMALL_STATE(1617)] = 53258,
  [SMALL_STATE(1618)] = 53280,
  [SMALL_STATE(1619)] = 53294,
  [SMALL_STATE(1620)] = 53316,
  [SMALL_STATE(1621)] = 53338,
  [SMALL_STATE(1622)] = 53360,
  [SMALL_STATE(1623)] = 53378,
  [SMALL_STATE(1624)] = 53400,
  [SMALL_STATE(1625)] = 53414,
  [SMALL_STATE(1626)] = 53428,
  [SMALL_STATE(1627)] = 53446,
  [SMALL_STATE(1628)] = 53464,
  [SMALL_STATE(1629)] = 53486,
  [SMALL_STATE(1630)] = 53508,
  [SMALL_STATE(1631)] = 53530,
  [SMALL_STATE(1632)] = 53552,
  [SMALL_STATE(1633)] = 53574,
  [SMALL_STATE(1634)] = 53596,
  [SMALL_STATE(1635)] = 53618,
  [SMALL_STATE(1636)] = 53640,
  [SMALL_STATE(1637)] = 53662,
  [SMALL_STATE(1638)] = 53684,
  [SMALL_STATE(1639)] = 53702,
  [SMALL_STATE(1640)] = 53724,
  [SMALL_STATE(1641)] = 53738,
  [SMALL_STATE(1642)] = 53758,
  [SMALL_STATE(1643)] = 53776,
  [SMALL_STATE(1644)] = 53794,
  [SMALL_STATE(1645)] = 53816,
  [SMALL_STATE(1646)] = 53830,
  [SMALL_STATE(1647)] = 53852,
  [SMALL_STATE(1648)] = 53870,
  [SMALL_STATE(1649)] = 53888,
  [SMALL_STATE(1650)] = 53902,
  [SMALL_STATE(1651)] = 53920,
  [SMALL_STATE(1652)] = 53936,
  [SMALL_STATE(1653)] = 53958,
  [SMALL_STATE(1654)] = 53980,
  [SMALL_STATE(1655)] = 53994,
  [SMALL_STATE(1656)] = 54016,
  [SMALL_STATE(1657)] = 54038,
  [SMALL_STATE(1658)] = 54053,
  [SMALL_STATE(1659)] = 54068,
  [SMALL_STATE(1660)] = 54087,
  [SMALL_STATE(1661)] = 54104,
  [SMALL_STATE(1662)] = 54123,
  [SMALL_STATE(1663)] = 54138,
  [SMALL_STATE(1664)] = 54153,
  [SMALL_STATE(1665)] = 54170,
  [SMALL_STATE(1666)] = 54185,
  [SMALL_STATE(1667)] = 54200,
  [SMALL_STATE(1668)] = 54215,
  [SMALL_STATE(1669)] = 54230,
  [SMALL_STATE(1670)] = 54249,
  [SMALL_STATE(1671)] = 54264,
  [SMALL_STATE(1672)] = 54283,
  [SMALL_STATE(1673)] = 54300,
  [SMALL_STATE(1674)] = 54315,
  [SMALL_STATE(1675)] = 54330,
  [SMALL_STATE(1676)] = 54345,
  [SMALL_STATE(1677)] = 54362,
  [SMALL_STATE(1678)] = 54377,
  [SMALL_STATE(1679)] = 54394,
  [SMALL_STATE(1680)] = 54409,
  [SMALL_STATE(1681)] = 54428,
  [SMALL_STATE(1682)] = 54443,
  [SMALL_STATE(1683)] = 54460,
  [SMALL_STATE(1684)] = 54473,
  [SMALL_STATE(1685)] = 54488,
  [SMALL_STATE(1686)] = 54503,
  [SMALL_STATE(1687)] = 54518,
  [SMALL_STATE(1688)] = 54533,
  [SMALL_STATE(1689)] = 54552,
  [SMALL_STATE(1690)] = 54567,
  [SMALL_STATE(1691)] = 54584,
  [SMALL_STATE(1692)] = 54603,
  [SMALL_STATE(1693)] = 54618,
  [SMALL_STATE(1694)] = 54633,
  [SMALL_STATE(1695)] = 54652,
  [SMALL_STATE(1696)] = 54665,
  [SMALL_STATE(1697)] = 54684,
  [SMALL_STATE(1698)] = 54699,
  [SMALL_STATE(1699)] = 54714,
  [SMALL_STATE(1700)] = 54729,
  [SMALL_STATE(1701)] = 54744,
  [SMALL_STATE(1702)] = 54763,
  [SMALL_STATE(1703)] = 54780,
  [SMALL_STATE(1704)] = 54799,
  [SMALL_STATE(1705)] = 54818,
  [SMALL_STATE(1706)] = 54833,
  [SMALL_STATE(1707)] = 54850,
  [SMALL_STATE(1708)] = 54867,
  [SMALL_STATE(1709)] = 54884,
  [SMALL_STATE(1710)] = 54901,
  [SMALL_STATE(1711)] = 54918,
  [SMALL_STATE(1712)] = 54937,
  [SMALL_STATE(1713)] = 54954,
  [SMALL_STATE(1714)] = 54971,
  [SMALL_STATE(1715)] = 54984,
  [SMALL_STATE(1716)] = 55003,
  [SMALL_STATE(1717)] = 55018,
  [SMALL_STATE(1718)] = 55033,
  [SMALL_STATE(1719)] = 55048,
  [SMALL_STATE(1720)] = 55063,
  [SMALL_STATE(1721)] = 55082,
  [SMALL_STATE(1722)] = 55101,
  [SMALL_STATE(1723)] = 55116,
  [SMALL_STATE(1724)] = 55131,
  [SMALL_STATE(1725)] = 55146,
  [SMALL_STATE(1726)] = 55161,
  [SMALL_STATE(1727)] = 55176,
  [SMALL_STATE(1728)] = 55191,
  [SMALL_STATE(1729)] = 55202,
  [SMALL_STATE(1730)] = 55221,
  [SMALL_STATE(1731)] = 55240,
  [SMALL_STATE(1732)] = 55255,
  [SMALL_STATE(1733)] = 55274,
  [SMALL_STATE(1734)] = 55289,
  [SMALL_STATE(1735)] = 55300,
  [SMALL_STATE(1736)] = 55315,
  [SMALL_STATE(1737)] = 55332,
  [SMALL_STATE(1738)] = 55351,
  [SMALL_STATE(1739)] = 55370,
  [SMALL_STATE(1740)] = 55387,
  [SMALL_STATE(1741)] = 55406,
  [SMALL_STATE(1742)] = 55423,
  [SMALL_STATE(1743)] = 55438,
  [SMALL_STATE(1744)] = 55453,
  [SMALL_STATE(1745)] = 55468,
  [SMALL_STATE(1746)] = 55483,
  [SMALL_STATE(1747)] = 55502,
  [SMALL_STATE(1748)] = 55517,
  [SMALL_STATE(1749)] = 55532,
  [SMALL_STATE(1750)] = 55547,
  [SMALL_STATE(1751)] = 55562,
  [SMALL_STATE(1752)] = 55573,
  [SMALL_STATE(1753)] = 55592,
  [SMALL_STATE(1754)] = 55608,
  [SMALL_STATE(1755)] = 55622,
  [SMALL_STATE(1756)] = 55632,
  [SMALL_STATE(1757)] = 55642,
  [SMALL_STATE(1758)] = 55658,
  [SMALL_STATE(1759)] = 55672,
  [SMALL_STATE(1760)] = 55682,
  [SMALL_STATE(1761)] = 55696,
  [SMALL_STATE(1762)] = 55712,
  [SMALL_STATE(1763)] = 55726,
  [SMALL_STATE(1764)] = 55740,
  [SMALL_STATE(1765)] = 55754,
  [SMALL_STATE(1766)] = 55770,
  [SMALL_STATE(1767)] = 55786,
  [SMALL_STATE(1768)] = 55802,
  [SMALL_STATE(1769)] = 55818,
  [SMALL_STATE(1770)] = 55834,
  [SMALL_STATE(1771)] = 55848,
  [SMALL_STATE(1772)] = 55864,
  [SMALL_STATE(1773)] = 55880,
  [SMALL_STATE(1774)] = 55896,
  [SMALL_STATE(1775)] = 55910,
  [SMALL_STATE(1776)] = 55922,
  [SMALL_STATE(1777)] = 55936,
  [SMALL_STATE(1778)] = 55948,
  [SMALL_STATE(1779)] = 55964,
  [SMALL_STATE(1780)] = 55978,
  [SMALL_STATE(1781)] = 55994,
  [SMALL_STATE(1782)] = 56010,
  [SMALL_STATE(1783)] = 56024,
  [SMALL_STATE(1784)] = 56034,
  [SMALL_STATE(1785)] = 56048,
  [SMALL_STATE(1786)] = 56058,
  [SMALL_STATE(1787)] = 56074,
  [SMALL_STATE(1788)] = 56088,
  [SMALL_STATE(1789)] = 56104,
  [SMALL_STATE(1790)] = 56120,
  [SMALL_STATE(1791)] = 56136,
  [SMALL_STATE(1792)] = 56152,
  [SMALL_STATE(1793)] = 56168,
  [SMALL_STATE(1794)] = 56182,
  [SMALL_STATE(1795)] = 56196,
  [SMALL_STATE(1796)] = 56206,
  [SMALL_STATE(1797)] = 56220,
  [SMALL_STATE(1798)] = 56230,
  [SMALL_STATE(1799)] = 56244,
  [SMALL_STATE(1800)] = 56260,
  [SMALL_STATE(1801)] = 56274,
  [SMALL_STATE(1802)] = 56284,
  [SMALL_STATE(1803)] = 56294,
  [SMALL_STATE(1804)] = 56304,
  [SMALL_STATE(1805)] = 56320,
  [SMALL_STATE(1806)] = 56334,
  [SMALL_STATE(1807)] = 56350,
  [SMALL_STATE(1808)] = 56364,
  [SMALL_STATE(1809)] = 56376,
  [SMALL_STATE(1810)] = 56390,
  [SMALL_STATE(1811)] = 56406,
  [SMALL_STATE(1812)] = 56416,
  [SMALL_STATE(1813)] = 56430,
  [SMALL_STATE(1814)] = 56444,
  [SMALL_STATE(1815)] = 56460,
  [SMALL_STATE(1816)] = 56474,
  [SMALL_STATE(1817)] = 56488,
  [SMALL_STATE(1818)] = 56504,
  [SMALL_STATE(1819)] = 56518,
  [SMALL_STATE(1820)] = 56532,
  [SMALL_STATE(1821)] = 56546,
  [SMALL_STATE(1822)] = 56560,
  [SMALL_STATE(1823)] = 56576,
  [SMALL_STATE(1824)] = 56592,
  [SMALL_STATE(1825)] = 56608,
  [SMALL_STATE(1826)] = 56622,
  [SMALL_STATE(1827)] = 56636,
  [SMALL_STATE(1828)] = 56652,
  [SMALL_STATE(1829)] = 56666,
  [SMALL_STATE(1830)] = 56682,
  [SMALL_STATE(1831)] = 56698,
  [SMALL_STATE(1832)] = 56714,
  [SMALL_STATE(1833)] = 56728,
  [SMALL_STATE(1834)] = 56744,
  [SMALL_STATE(1835)] = 56760,
  [SMALL_STATE(1836)] = 56776,
  [SMALL_STATE(1837)] = 56790,
  [SMALL_STATE(1838)] = 56806,
  [SMALL_STATE(1839)] = 56822,
  [SMALL_STATE(1840)] = 56834,
  [SMALL_STATE(1841)] = 56850,
  [SMALL_STATE(1842)] = 56864,
  [SMALL_STATE(1843)] = 56880,
  [SMALL_STATE(1844)] = 56896,
  [SMALL_STATE(1845)] = 56910,
  [SMALL_STATE(1846)] = 56924,
  [SMALL_STATE(1847)] = 56938,
  [SMALL_STATE(1848)] = 56952,
  [SMALL_STATE(1849)] = 56968,
  [SMALL_STATE(1850)] = 56982,
  [SMALL_STATE(1851)] = 56998,
  [SMALL_STATE(1852)] = 57014,
  [SMALL_STATE(1853)] = 57030,
  [SMALL_STATE(1854)] = 57040,
  [SMALL_STATE(1855)] = 57054,
  [SMALL_STATE(1856)] = 57070,
  [SMALL_STATE(1857)] = 57086,
  [SMALL_STATE(1858)] = 57102,
  [SMALL_STATE(1859)] = 57114,
  [SMALL_STATE(1860)] = 57128,
  [SMALL_STATE(1861)] = 57144,
  [SMALL_STATE(1862)] = 57160,
  [SMALL_STATE(1863)] = 57176,
  [SMALL_STATE(1864)] = 57192,
  [SMALL_STATE(1865)] = 57206,
  [SMALL_STATE(1866)] = 57220,
  [SMALL_STATE(1867)] = 57234,
  [SMALL_STATE(1868)] = 57250,
  [SMALL_STATE(1869)] = 57260,
  [SMALL_STATE(1870)] = 57274,
  [SMALL_STATE(1871)] = 57288,
  [SMALL_STATE(1872)] = 57304,
  [SMALL_STATE(1873)] = 57318,
  [SMALL_STATE(1874)] = 57334,
  [SMALL_STATE(1875)] = 57344,
  [SMALL_STATE(1876)] = 57358,
  [SMALL_STATE(1877)] = 57372,
  [SMALL_STATE(1878)] = 57386,
  [SMALL_STATE(1879)] = 57402,
  [SMALL_STATE(1880)] = 57416,
  [SMALL_STATE(1881)] = 57430,
  [SMALL_STATE(1882)] = 57444,
  [SMALL_STATE(1883)] = 57460,
  [SMALL_STATE(1884)] = 57476,
  [SMALL_STATE(1885)] = 57490,
  [SMALL_STATE(1886)] = 57506,
  [SMALL_STATE(1887)] = 57520,
  [SMALL_STATE(1888)] = 57534,
  [SMALL_STATE(1889)] = 57548,
  [SMALL_STATE(1890)] = 57562,
  [SMALL_STATE(1891)] = 57578,
  [SMALL_STATE(1892)] = 57592,
  [SMALL_STATE(1893)] = 57608,
  [SMALL_STATE(1894)] = 57624,
  [SMALL_STATE(1895)] = 57634,
  [SMALL_STATE(1896)] = 57648,
  [SMALL_STATE(1897)] = 57664,
  [SMALL_STATE(1898)] = 57678,
  [SMALL_STATE(1899)] = 57688,
  [SMALL_STATE(1900)] = 57698,
  [SMALL_STATE(1901)] = 57714,
  [SMALL_STATE(1902)] = 57724,
  [SMALL_STATE(1903)] = 57738,
  [SMALL_STATE(1904)] = 57752,
  [SMALL_STATE(1905)] = 57768,
  [SMALL_STATE(1906)] = 57782,
  [SMALL_STATE(1907)] = 57792,
  [SMALL_STATE(1908)] = 57808,
  [SMALL_STATE(1909)] = 57824,
  [SMALL_STATE(1910)] = 57838,
  [SMALL_STATE(1911)] = 57852,
  [SMALL_STATE(1912)] = 57866,
  [SMALL_STATE(1913)] = 57877,
  [SMALL_STATE(1914)] = 57890,
  [SMALL_STATE(1915)] = 57901,
  [SMALL_STATE(1916)] = 57914,
  [SMALL_STATE(1917)] = 57927,
  [SMALL_STATE(1918)] = 57940,
  [SMALL_STATE(1919)] = 57953,
  [SMALL_STATE(1920)] = 57966,
  [SMALL_STATE(1921)] = 57979,
  [SMALL_STATE(1922)] = 57992,
  [SMALL_STATE(1923)] = 58005,
  [SMALL_STATE(1924)] = 58018,
  [SMALL_STATE(1925)] = 58031,
  [SMALL_STATE(1926)] = 58042,
  [SMALL_STATE(1927)] = 58055,
  [SMALL_STATE(1928)] = 58068,
  [SMALL_STATE(1929)] = 58081,
  [SMALL_STATE(1930)] = 58094,
  [SMALL_STATE(1931)] = 58107,
  [SMALL_STATE(1932)] = 58120,
  [SMALL_STATE(1933)] = 58133,
  [SMALL_STATE(1934)] = 58146,
  [SMALL_STATE(1935)] = 58159,
  [SMALL_STATE(1936)] = 58172,
  [SMALL_STATE(1937)] = 58183,
  [SMALL_STATE(1938)] = 58196,
  [SMALL_STATE(1939)] = 58205,
  [SMALL_STATE(1940)] = 58218,
  [SMALL_STATE(1941)] = 58231,
  [SMALL_STATE(1942)] = 58244,
  [SMALL_STATE(1943)] = 58257,
  [SMALL_STATE(1944)] = 58268,
  [SMALL_STATE(1945)] = 58281,
  [SMALL_STATE(1946)] = 58294,
  [SMALL_STATE(1947)] = 58307,
  [SMALL_STATE(1948)] = 58320,
  [SMALL_STATE(1949)] = 58333,
  [SMALL_STATE(1950)] = 58346,
  [SMALL_STATE(1951)] = 58359,
  [SMALL_STATE(1952)] = 58372,
  [SMALL_STATE(1953)] = 58385,
  [SMALL_STATE(1954)] = 58398,
  [SMALL_STATE(1955)] = 58411,
  [SMALL_STATE(1956)] = 58424,
  [SMALL_STATE(1957)] = 58437,
  [SMALL_STATE(1958)] = 58450,
  [SMALL_STATE(1959)] = 58463,
  [SMALL_STATE(1960)] = 58476,
  [SMALL_STATE(1961)] = 58489,
  [SMALL_STATE(1962)] = 58502,
  [SMALL_STATE(1963)] = 58515,
  [SMALL_STATE(1964)] = 58528,
  [SMALL_STATE(1965)] = 58541,
  [SMALL_STATE(1966)] = 58550,
  [SMALL_STATE(1967)] = 58563,
  [SMALL_STATE(1968)] = 58572,
  [SMALL_STATE(1969)] = 58581,
  [SMALL_STATE(1970)] = 58594,
  [SMALL_STATE(1971)] = 58607,
  [SMALL_STATE(1972)] = 58616,
  [SMALL_STATE(1973)] = 58625,
  [SMALL_STATE(1974)] = 58636,
  [SMALL_STATE(1975)] = 58647,
  [SMALL_STATE(1976)] = 58660,
  [SMALL_STATE(1977)] = 58673,
  [SMALL_STATE(1978)] = 58684,
  [SMALL_STATE(1979)] = 58695,
  [SMALL_STATE(1980)] = 58708,
  [SMALL_STATE(1981)] = 58719,
  [SMALL_STATE(1982)] = 58730,
  [SMALL_STATE(1983)] = 58741,
  [SMALL_STATE(1984)] = 58754,
  [SMALL_STATE(1985)] = 58765,
  [SMALL_STATE(1986)] = 58774,
  [SMALL_STATE(1987)] = 58787,
  [SMALL_STATE(1988)] = 58798,
  [SMALL_STATE(1989)] = 58811,
  [SMALL_STATE(1990)] = 58824,
  [SMALL_STATE(1991)] = 58835,
  [SMALL_STATE(1992)] = 58846,
  [SMALL_STATE(1993)] = 58859,
  [SMALL_STATE(1994)] = 58870,
  [SMALL_STATE(1995)] = 58881,
  [SMALL_STATE(1996)] = 58890,
  [SMALL_STATE(1997)] = 58901,
  [SMALL_STATE(1998)] = 58914,
  [SMALL_STATE(1999)] = 58927,
  [SMALL_STATE(2000)] = 58936,
  [SMALL_STATE(2001)] = 58949,
  [SMALL_STATE(2002)] = 58960,
  [SMALL_STATE(2003)] = 58973,
  [SMALL_STATE(2004)] = 58982,
  [SMALL_STATE(2005)] = 58993,
  [SMALL_STATE(2006)] = 59006,
  [SMALL_STATE(2007)] = 59017,
  [SMALL_STATE(2008)] = 59030,
  [SMALL_STATE(2009)] = 59041,
  [SMALL_STATE(2010)] = 59052,
  [SMALL_STATE(2011)] = 59063,
  [SMALL_STATE(2012)] = 59076,
  [SMALL_STATE(2013)] = 59087,
  [SMALL_STATE(2014)] = 59100,
  [SMALL_STATE(2015)] = 59111,
  [SMALL_STATE(2016)] = 59124,
  [SMALL_STATE(2017)] = 59135,
  [SMALL_STATE(2018)] = 59148,
  [SMALL_STATE(2019)] = 59159,
  [SMALL_STATE(2020)] = 59172,
  [SMALL_STATE(2021)] = 59183,
  [SMALL_STATE(2022)] = 59196,
  [SMALL_STATE(2023)] = 59209,
  [SMALL_STATE(2024)] = 59222,
  [SMALL_STATE(2025)] = 59233,
  [SMALL_STATE(2026)] = 59244,
  [SMALL_STATE(2027)] = 59255,
  [SMALL_STATE(2028)] = 59266,
  [SMALL_STATE(2029)] = 59277,
  [SMALL_STATE(2030)] = 59290,
  [SMALL_STATE(2031)] = 59301,
  [SMALL_STATE(2032)] = 59312,
  [SMALL_STATE(2033)] = 59325,
  [SMALL_STATE(2034)] = 59336,
  [SMALL_STATE(2035)] = 59347,
  [SMALL_STATE(2036)] = 59360,
  [SMALL_STATE(2037)] = 59373,
  [SMALL_STATE(2038)] = 59384,
  [SMALL_STATE(2039)] = 59397,
  [SMALL_STATE(2040)] = 59408,
  [SMALL_STATE(2041)] = 59421,
  [SMALL_STATE(2042)] = 59434,
  [SMALL_STATE(2043)] = 59447,
  [SMALL_STATE(2044)] = 59460,
  [SMALL_STATE(2045)] = 59471,
  [SMALL_STATE(2046)] = 59484,
  [SMALL_STATE(2047)] = 59497,
  [SMALL_STATE(2048)] = 59510,
  [SMALL_STATE(2049)] = 59521,
  [SMALL_STATE(2050)] = 59534,
  [SMALL_STATE(2051)] = 59547,
  [SMALL_STATE(2052)] = 59560,
  [SMALL_STATE(2053)] = 59573,
  [SMALL_STATE(2054)] = 59584,
  [SMALL_STATE(2055)] = 59595,
  [SMALL_STATE(2056)] = 59606,
  [SMALL_STATE(2057)] = 59617,
  [SMALL_STATE(2058)] = 59628,
  [SMALL_STATE(2059)] = 59639,
  [SMALL_STATE(2060)] = 59650,
  [SMALL_STATE(2061)] = 59661,
  [SMALL_STATE(2062)] = 59672,
  [SMALL_STATE(2063)] = 59683,
  [SMALL_STATE(2064)] = 59694,
  [SMALL_STATE(2065)] = 59705,
  [SMALL_STATE(2066)] = 59716,
  [SMALL_STATE(2067)] = 59727,
  [SMALL_STATE(2068)] = 59738,
  [SMALL_STATE(2069)] = 59749,
  [SMALL_STATE(2070)] = 59760,
  [SMALL_STATE(2071)] = 59771,
  [SMALL_STATE(2072)] = 59782,
  [SMALL_STATE(2073)] = 59793,
  [SMALL_STATE(2074)] = 59804,
  [SMALL_STATE(2075)] = 59815,
  [SMALL_STATE(2076)] = 59826,
  [SMALL_STATE(2077)] = 59837,
  [SMALL_STATE(2078)] = 59846,
  [SMALL_STATE(2079)] = 59857,
  [SMALL_STATE(2080)] = 59868,
  [SMALL_STATE(2081)] = 59877,
  [SMALL_STATE(2082)] = 59890,
  [SMALL_STATE(2083)] = 59901,
  [SMALL_STATE(2084)] = 59912,
  [SMALL_STATE(2085)] = 59923,
  [SMALL_STATE(2086)] = 59934,
  [SMALL_STATE(2087)] = 59947,
  [SMALL_STATE(2088)] = 59958,
  [SMALL_STATE(2089)] = 59969,
  [SMALL_STATE(2090)] = 59980,
  [SMALL_STATE(2091)] = 59991,
  [SMALL_STATE(2092)] = 60002,
  [SMALL_STATE(2093)] = 60013,
  [SMALL_STATE(2094)] = 60024,
  [SMALL_STATE(2095)] = 60035,
  [SMALL_STATE(2096)] = 60044,
  [SMALL_STATE(2097)] = 60055,
  [SMALL_STATE(2098)] = 60066,
  [SMALL_STATE(2099)] = 60077,
  [SMALL_STATE(2100)] = 60088,
  [SMALL_STATE(2101)] = 60099,
  [SMALL_STATE(2102)] = 60112,
  [SMALL_STATE(2103)] = 60125,
  [SMALL_STATE(2104)] = 60136,
  [SMALL_STATE(2105)] = 60149,
  [SMALL_STATE(2106)] = 60160,
  [SMALL_STATE(2107)] = 60171,
  [SMALL_STATE(2108)] = 60182,
  [SMALL_STATE(2109)] = 60193,
  [SMALL_STATE(2110)] = 60204,
  [SMALL_STATE(2111)] = 60217,
  [SMALL_STATE(2112)] = 60228,
  [SMALL_STATE(2113)] = 60241,
  [SMALL_STATE(2114)] = 60250,
  [SMALL_STATE(2115)] = 60259,
  [SMALL_STATE(2116)] = 60270,
  [SMALL_STATE(2117)] = 60281,
  [SMALL_STATE(2118)] = 60292,
  [SMALL_STATE(2119)] = 60303,
  [SMALL_STATE(2120)] = 60314,
  [SMALL_STATE(2121)] = 60325,
  [SMALL_STATE(2122)] = 60336,
  [SMALL_STATE(2123)] = 60347,
  [SMALL_STATE(2124)] = 60358,
  [SMALL_STATE(2125)] = 60369,
  [SMALL_STATE(2126)] = 60380,
  [SMALL_STATE(2127)] = 60391,
  [SMALL_STATE(2128)] = 60402,
  [SMALL_STATE(2129)] = 60413,
  [SMALL_STATE(2130)] = 60424,
  [SMALL_STATE(2131)] = 60435,
  [SMALL_STATE(2132)] = 60446,
  [SMALL_STATE(2133)] = 60457,
  [SMALL_STATE(2134)] = 60468,
  [SMALL_STATE(2135)] = 60479,
  [SMALL_STATE(2136)] = 60490,
  [SMALL_STATE(2137)] = 60501,
  [SMALL_STATE(2138)] = 60512,
  [SMALL_STATE(2139)] = 60523,
  [SMALL_STATE(2140)] = 60534,
  [SMALL_STATE(2141)] = 60545,
  [SMALL_STATE(2142)] = 60556,
  [SMALL_STATE(2143)] = 60567,
  [SMALL_STATE(2144)] = 60576,
  [SMALL_STATE(2145)] = 60587,
  [SMALL_STATE(2146)] = 60598,
  [SMALL_STATE(2147)] = 60609,
  [SMALL_STATE(2148)] = 60622,
  [SMALL_STATE(2149)] = 60633,
  [SMALL_STATE(2150)] = 60642,
  [SMALL_STATE(2151)] = 60653,
  [SMALL_STATE(2152)] = 60666,
  [SMALL_STATE(2153)] = 60679,
  [SMALL_STATE(2154)] = 60692,
  [SMALL_STATE(2155)] = 60701,
  [SMALL_STATE(2156)] = 60714,
  [SMALL_STATE(2157)] = 60723,
  [SMALL_STATE(2158)] = 60734,
  [SMALL_STATE(2159)] = 60743,
  [SMALL_STATE(2160)] = 60754,
  [SMALL_STATE(2161)] = 60767,
  [SMALL_STATE(2162)] = 60780,
  [SMALL_STATE(2163)] = 60791,
  [SMALL_STATE(2164)] = 60804,
  [SMALL_STATE(2165)] = 60817,
  [SMALL_STATE(2166)] = 60830,
  [SMALL_STATE(2167)] = 60843,
  [SMALL_STATE(2168)] = 60852,
  [SMALL_STATE(2169)] = 60865,
  [SMALL_STATE(2170)] = 60874,
  [SMALL_STATE(2171)] = 60887,
  [SMALL_STATE(2172)] = 60896,
  [SMALL_STATE(2173)] = 60909,
  [SMALL_STATE(2174)] = 60918,
  [SMALL_STATE(2175)] = 60931,
  [SMALL_STATE(2176)] = 60942,
  [SMALL_STATE(2177)] = 60955,
  [SMALL_STATE(2178)] = 60968,
  [SMALL_STATE(2179)] = 60981,
  [SMALL_STATE(2180)] = 60994,
  [SMALL_STATE(2181)] = 61003,
  [SMALL_STATE(2182)] = 61013,
  [SMALL_STATE(2183)] = 61023,
  [SMALL_STATE(2184)] = 61033,
  [SMALL_STATE(2185)] = 61041,
  [SMALL_STATE(2186)] = 61049,
  [SMALL_STATE(2187)] = 61057,
  [SMALL_STATE(2188)] = 61067,
  [SMALL_STATE(2189)] = 61077,
  [SMALL_STATE(2190)] = 61087,
  [SMALL_STATE(2191)] = 61095,
  [SMALL_STATE(2192)] = 61103,
  [SMALL_STATE(2193)] = 61111,
  [SMALL_STATE(2194)] = 61121,
  [SMALL_STATE(2195)] = 61131,
  [SMALL_STATE(2196)] = 61141,
  [SMALL_STATE(2197)] = 61151,
  [SMALL_STATE(2198)] = 61161,
  [SMALL_STATE(2199)] = 61171,
  [SMALL_STATE(2200)] = 61181,
  [SMALL_STATE(2201)] = 61191,
  [SMALL_STATE(2202)] = 61199,
  [SMALL_STATE(2203)] = 61209,
  [SMALL_STATE(2204)] = 61219,
  [SMALL_STATE(2205)] = 61229,
  [SMALL_STATE(2206)] = 61237,
  [SMALL_STATE(2207)] = 61247,
  [SMALL_STATE(2208)] = 61255,
  [SMALL_STATE(2209)] = 61265,
  [SMALL_STATE(2210)] = 61275,
  [SMALL_STATE(2211)] = 61283,
  [SMALL_STATE(2212)] = 61293,
  [SMALL_STATE(2213)] = 61301,
  [SMALL_STATE(2214)] = 61311,
  [SMALL_STATE(2215)] = 61319,
  [SMALL_STATE(2216)] = 61327,
  [SMALL_STATE(2217)] = 61337,
  [SMALL_STATE(2218)] = 61347,
  [SMALL_STATE(2219)] = 61357,
  [SMALL_STATE(2220)] = 61367,
  [SMALL_STATE(2221)] = 61375,
  [SMALL_STATE(2222)] = 61385,
  [SMALL_STATE(2223)] = 61395,
  [SMALL_STATE(2224)] = 61403,
  [SMALL_STATE(2225)] = 61413,
  [SMALL_STATE(2226)] = 61423,
  [SMALL_STATE(2227)] = 61433,
  [SMALL_STATE(2228)] = 61443,
  [SMALL_STATE(2229)] = 61453,
  [SMALL_STATE(2230)] = 61461,
  [SMALL_STATE(2231)] = 61469,
  [SMALL_STATE(2232)] = 61477,
  [SMALL_STATE(2233)] = 61485,
  [SMALL_STATE(2234)] = 61493,
  [SMALL_STATE(2235)] = 61501,
  [SMALL_STATE(2236)] = 61509,
  [SMALL_STATE(2237)] = 61519,
  [SMALL_STATE(2238)] = 61527,
  [SMALL_STATE(2239)] = 61535,
  [SMALL_STATE(2240)] = 61543,
  [SMALL_STATE(2241)] = 61551,
  [SMALL_STATE(2242)] = 61561,
  [SMALL_STATE(2243)] = 61569,
  [SMALL_STATE(2244)] = 61577,
  [SMALL_STATE(2245)] = 61585,
  [SMALL_STATE(2246)] = 61595,
  [SMALL_STATE(2247)] = 61605,
  [SMALL_STATE(2248)] = 61613,
  [SMALL_STATE(2249)] = 61621,
  [SMALL_STATE(2250)] = 61629,
  [SMALL_STATE(2251)] = 61639,
  [SMALL_STATE(2252)] = 61649,
  [SMALL_STATE(2253)] = 61659,
  [SMALL_STATE(2254)] = 61669,
  [SMALL_STATE(2255)] = 61677,
  [SMALL_STATE(2256)] = 61685,
  [SMALL_STATE(2257)] = 61695,
  [SMALL_STATE(2258)] = 61703,
  [SMALL_STATE(2259)] = 61713,
  [SMALL_STATE(2260)] = 61723,
  [SMALL_STATE(2261)] = 61733,
  [SMALL_STATE(2262)] = 61743,
  [SMALL_STATE(2263)] = 61753,
  [SMALL_STATE(2264)] = 61761,
  [SMALL_STATE(2265)] = 61769,
  [SMALL_STATE(2266)] = 61779,
  [SMALL_STATE(2267)] = 61787,
  [SMALL_STATE(2268)] = 61797,
  [SMALL_STATE(2269)] = 61807,
  [SMALL_STATE(2270)] = 61815,
  [SMALL_STATE(2271)] = 61825,
  [SMALL_STATE(2272)] = 61835,
  [SMALL_STATE(2273)] = 61845,
  [SMALL_STATE(2274)] = 61855,
  [SMALL_STATE(2275)] = 61865,
  [SMALL_STATE(2276)] = 61875,
  [SMALL_STATE(2277)] = 61885,
  [SMALL_STATE(2278)] = 61895,
  [SMALL_STATE(2279)] = 61905,
  [SMALL_STATE(2280)] = 61915,
  [SMALL_STATE(2281)] = 61925,
  [SMALL_STATE(2282)] = 61933,
  [SMALL_STATE(2283)] = 61941,
  [SMALL_STATE(2284)] = 61951,
  [SMALL_STATE(2285)] = 61961,
  [SMALL_STATE(2286)] = 61971,
  [SMALL_STATE(2287)] = 61981,
  [SMALL_STATE(2288)] = 61989,
  [SMALL_STATE(2289)] = 61999,
  [SMALL_STATE(2290)] = 62009,
  [SMALL_STATE(2291)] = 62017,
  [SMALL_STATE(2292)] = 62027,
  [SMALL_STATE(2293)] = 62037,
  [SMALL_STATE(2294)] = 62045,
  [SMALL_STATE(2295)] = 62055,
  [SMALL_STATE(2296)] = 62063,
  [SMALL_STATE(2297)] = 62073,
  [SMALL_STATE(2298)] = 62083,
  [SMALL_STATE(2299)] = 62093,
  [SMALL_STATE(2300)] = 62103,
  [SMALL_STATE(2301)] = 62111,
  [SMALL_STATE(2302)] = 62121,
  [SMALL_STATE(2303)] = 62129,
  [SMALL_STATE(2304)] = 62139,
  [SMALL_STATE(2305)] = 62149,
  [SMALL_STATE(2306)] = 62157,
  [SMALL_STATE(2307)] = 62167,
  [SMALL_STATE(2308)] = 62177,
  [SMALL_STATE(2309)] = 62185,
  [SMALL_STATE(2310)] = 62193,
  [SMALL_STATE(2311)] = 62201,
  [SMALL_STATE(2312)] = 62209,
  [SMALL_STATE(2313)] = 62217,
  [SMALL_STATE(2314)] = 62225,
  [SMALL_STATE(2315)] = 62235,
  [SMALL_STATE(2316)] = 62245,
  [SMALL_STATE(2317)] = 62253,
  [SMALL_STATE(2318)] = 62261,
  [SMALL_STATE(2319)] = 62271,
  [SMALL_STATE(2320)] = 62281,
  [SMALL_STATE(2321)] = 62291,
  [SMALL_STATE(2322)] = 62301,
  [SMALL_STATE(2323)] = 62311,
  [SMALL_STATE(2324)] = 62321,
  [SMALL_STATE(2325)] = 62331,
  [SMALL_STATE(2326)] = 62341,
  [SMALL_STATE(2327)] = 62351,
  [SMALL_STATE(2328)] = 62359,
  [SMALL_STATE(2329)] = 62367,
  [SMALL_STATE(2330)] = 62377,
  [SMALL_STATE(2331)] = 62385,
  [SMALL_STATE(2332)] = 62395,
  [SMALL_STATE(2333)] = 62403,
  [SMALL_STATE(2334)] = 62411,
  [SMALL_STATE(2335)] = 62419,
  [SMALL_STATE(2336)] = 62429,
  [SMALL_STATE(2337)] = 62439,
  [SMALL_STATE(2338)] = 62449,
  [SMALL_STATE(2339)] = 62459,
  [SMALL_STATE(2340)] = 62467,
  [SMALL_STATE(2341)] = 62477,
  [SMALL_STATE(2342)] = 62487,
  [SMALL_STATE(2343)] = 62495,
  [SMALL_STATE(2344)] = 62505,
  [SMALL_STATE(2345)] = 62515,
  [SMALL_STATE(2346)] = 62525,
  [SMALL_STATE(2347)] = 62535,
  [SMALL_STATE(2348)] = 62545,
  [SMALL_STATE(2349)] = 62555,
  [SMALL_STATE(2350)] = 62565,
  [SMALL_STATE(2351)] = 62573,
  [SMALL_STATE(2352)] = 62583,
  [SMALL_STATE(2353)] = 62593,
  [SMALL_STATE(2354)] = 62603,
  [SMALL_STATE(2355)] = 62611,
  [SMALL_STATE(2356)] = 62621,
  [SMALL_STATE(2357)] = 62631,
  [SMALL_STATE(2358)] = 62641,
  [SMALL_STATE(2359)] = 62651,
  [SMALL_STATE(2360)] = 62661,
  [SMALL_STATE(2361)] = 62669,
  [SMALL_STATE(2362)] = 62679,
  [SMALL_STATE(2363)] = 62689,
  [SMALL_STATE(2364)] = 62697,
  [SMALL_STATE(2365)] = 62705,
  [SMALL_STATE(2366)] = 62713,
  [SMALL_STATE(2367)] = 62723,
  [SMALL_STATE(2368)] = 62733,
  [SMALL_STATE(2369)] = 62743,
  [SMALL_STATE(2370)] = 62751,
  [SMALL_STATE(2371)] = 62761,
  [SMALL_STATE(2372)] = 62771,
  [SMALL_STATE(2373)] = 62779,
  [SMALL_STATE(2374)] = 62787,
  [SMALL_STATE(2375)] = 62797,
  [SMALL_STATE(2376)] = 62807,
  [SMALL_STATE(2377)] = 62815,
  [SMALL_STATE(2378)] = 62825,
  [SMALL_STATE(2379)] = 62833,
  [SMALL_STATE(2380)] = 62843,
  [SMALL_STATE(2381)] = 62853,
  [SMALL_STATE(2382)] = 62863,
  [SMALL_STATE(2383)] = 62873,
  [SMALL_STATE(2384)] = 62881,
  [SMALL_STATE(2385)] = 62891,
  [SMALL_STATE(2386)] = 62901,
  [SMALL_STATE(2387)] = 62911,
  [SMALL_STATE(2388)] = 62921,
  [SMALL_STATE(2389)] = 62931,
  [SMALL_STATE(2390)] = 62939,
  [SMALL_STATE(2391)] = 62949,
  [SMALL_STATE(2392)] = 62957,
  [SMALL_STATE(2393)] = 62967,
  [SMALL_STATE(2394)] = 62977,
  [SMALL_STATE(2395)] = 62987,
  [SMALL_STATE(2396)] = 62997,
  [SMALL_STATE(2397)] = 63007,
  [SMALL_STATE(2398)] = 63017,
  [SMALL_STATE(2399)] = 63025,
  [SMALL_STATE(2400)] = 63035,
  [SMALL_STATE(2401)] = 63045,
  [SMALL_STATE(2402)] = 63053,
  [SMALL_STATE(2403)] = 63063,
  [SMALL_STATE(2404)] = 63073,
  [SMALL_STATE(2405)] = 63083,
  [SMALL_STATE(2406)] = 63093,
  [SMALL_STATE(2407)] = 63101,
  [SMALL_STATE(2408)] = 63109,
  [SMALL_STATE(2409)] = 63119,
  [SMALL_STATE(2410)] = 63129,
  [SMALL_STATE(2411)] = 63137,
  [SMALL_STATE(2412)] = 63147,
  [SMALL_STATE(2413)] = 63155,
  [SMALL_STATE(2414)] = 63163,
  [SMALL_STATE(2415)] = 63171,
  [SMALL_STATE(2416)] = 63181,
  [SMALL_STATE(2417)] = 63191,
  [SMALL_STATE(2418)] = 63201,
  [SMALL_STATE(2419)] = 63209,
  [SMALL_STATE(2420)] = 63219,
  [SMALL_STATE(2421)] = 63229,
  [SMALL_STATE(2422)] = 63237,
  [SMALL_STATE(2423)] = 63247,
  [SMALL_STATE(2424)] = 63257,
  [SMALL_STATE(2425)] = 63265,
  [SMALL_STATE(2426)] = 63273,
  [SMALL_STATE(2427)] = 63283,
  [SMALL_STATE(2428)] = 63293,
  [SMALL_STATE(2429)] = 63303,
  [SMALL_STATE(2430)] = 63313,
  [SMALL_STATE(2431)] = 63323,
  [SMALL_STATE(2432)] = 63333,
  [SMALL_STATE(2433)] = 63341,
  [SMALL_STATE(2434)] = 63349,
  [SMALL_STATE(2435)] = 63359,
  [SMALL_STATE(2436)] = 63369,
  [SMALL_STATE(2437)] = 63379,
  [SMALL_STATE(2438)] = 63389,
  [SMALL_STATE(2439)] = 63399,
  [SMALL_STATE(2440)] = 63409,
  [SMALL_STATE(2441)] = 63417,
  [SMALL_STATE(2442)] = 63427,
  [SMALL_STATE(2443)] = 63435,
  [SMALL_STATE(2444)] = 63445,
  [SMALL_STATE(2445)] = 63455,
  [SMALL_STATE(2446)] = 63462,
  [SMALL_STATE(2447)] = 63469,
  [SMALL_STATE(2448)] = 63476,
  [SMALL_STATE(2449)] = 63483,
  [SMALL_STATE(2450)] = 63490,
  [SMALL_STATE(2451)] = 63497,
  [SMALL_STATE(2452)] = 63504,
  [SMALL_STATE(2453)] = 63511,
  [SMALL_STATE(2454)] = 63518,
  [SMALL_STATE(2455)] = 63525,
  [SMALL_STATE(2456)] = 63532,
  [SMALL_STATE(2457)] = 63539,
  [SMALL_STATE(2458)] = 63546,
  [SMALL_STATE(2459)] = 63553,
  [SMALL_STATE(2460)] = 63560,
  [SMALL_STATE(2461)] = 63567,
  [SMALL_STATE(2462)] = 63574,
  [SMALL_STATE(2463)] = 63581,
  [SMALL_STATE(2464)] = 63588,
  [SMALL_STATE(2465)] = 63595,
  [SMALL_STATE(2466)] = 63602,
  [SMALL_STATE(2467)] = 63609,
  [SMALL_STATE(2468)] = 63616,
  [SMALL_STATE(2469)] = 63623,
  [SMALL_STATE(2470)] = 63630,
  [SMALL_STATE(2471)] = 63637,
  [SMALL_STATE(2472)] = 63644,
  [SMALL_STATE(2473)] = 63651,
  [SMALL_STATE(2474)] = 63658,
  [SMALL_STATE(2475)] = 63665,
  [SMALL_STATE(2476)] = 63672,
  [SMALL_STATE(2477)] = 63679,
  [SMALL_STATE(2478)] = 63686,
  [SMALL_STATE(2479)] = 63693,
  [SMALL_STATE(2480)] = 63700,
  [SMALL_STATE(2481)] = 63707,
  [SMALL_STATE(2482)] = 63714,
  [SMALL_STATE(2483)] = 63721,
  [SMALL_STATE(2484)] = 63728,
  [SMALL_STATE(2485)] = 63735,
  [SMALL_STATE(2486)] = 63742,
  [SMALL_STATE(2487)] = 63749,
  [SMALL_STATE(2488)] = 63756,
  [SMALL_STATE(2489)] = 63763,
  [SMALL_STATE(2490)] = 63770,
  [SMALL_STATE(2491)] = 63777,
  [SMALL_STATE(2492)] = 63784,
  [SMALL_STATE(2493)] = 63791,
  [SMALL_STATE(2494)] = 63798,
  [SMALL_STATE(2495)] = 63805,
  [SMALL_STATE(2496)] = 63812,
  [SMALL_STATE(2497)] = 63819,
  [SMALL_STATE(2498)] = 63826,
  [SMALL_STATE(2499)] = 63833,
  [SMALL_STATE(2500)] = 63840,
  [SMALL_STATE(2501)] = 63847,
  [SMALL_STATE(2502)] = 63854,
  [SMALL_STATE(2503)] = 63861,
  [SMALL_STATE(2504)] = 63868,
  [SMALL_STATE(2505)] = 63875,
  [SMALL_STATE(2506)] = 63882,
  [SMALL_STATE(2507)] = 63889,
  [SMALL_STATE(2508)] = 63896,
  [SMALL_STATE(2509)] = 63903,
  [SMALL_STATE(2510)] = 63910,
  [SMALL_STATE(2511)] = 63917,
  [SMALL_STATE(2512)] = 63924,
  [SMALL_STATE(2513)] = 63931,
  [SMALL_STATE(2514)] = 63938,
  [SMALL_STATE(2515)] = 63945,
  [SMALL_STATE(2516)] = 63952,
  [SMALL_STATE(2517)] = 63959,
  [SMALL_STATE(2518)] = 63966,
  [SMALL_STATE(2519)] = 63973,
  [SMALL_STATE(2520)] = 63980,
  [SMALL_STATE(2521)] = 63987,
  [SMALL_STATE(2522)] = 63994,
  [SMALL_STATE(2523)] = 64001,
  [SMALL_STATE(2524)] = 64008,
  [SMALL_STATE(2525)] = 64015,
  [SMALL_STATE(2526)] = 64022,
  [SMALL_STATE(2527)] = 64029,
  [SMALL_STATE(2528)] = 64036,
  [SMALL_STATE(2529)] = 64043,
  [SMALL_STATE(2530)] = 64050,
  [SMALL_STATE(2531)] = 64057,
  [SMALL_STATE(2532)] = 64064,
  [SMALL_STATE(2533)] = 64071,
  [SMALL_STATE(2534)] = 64078,
  [SMALL_STATE(2535)] = 64085,
  [SMALL_STATE(2536)] = 64092,
  [SMALL_STATE(2537)] = 64099,
  [SMALL_STATE(2538)] = 64106,
  [SMALL_STATE(2539)] = 64113,
  [SMALL_STATE(2540)] = 64120,
  [SMALL_STATE(2541)] = 64127,
  [SMALL_STATE(2542)] = 64134,
  [SMALL_STATE(2543)] = 64141,
  [SMALL_STATE(2544)] = 64148,
  [SMALL_STATE(2545)] = 64155,
  [SMALL_STATE(2546)] = 64162,
  [SMALL_STATE(2547)] = 64169,
  [SMALL_STATE(2548)] = 64176,
  [SMALL_STATE(2549)] = 64183,
  [SMALL_STATE(2550)] = 64190,
  [SMALL_STATE(2551)] = 64197,
  [SMALL_STATE(2552)] = 64204,
  [SMALL_STATE(2553)] = 64211,
  [SMALL_STATE(2554)] = 64218,
  [SMALL_STATE(2555)] = 64225,
  [SMALL_STATE(2556)] = 64232,
  [SMALL_STATE(2557)] = 64239,
  [SMALL_STATE(2558)] = 64246,
  [SMALL_STATE(2559)] = 64253,
  [SMALL_STATE(2560)] = 64260,
  [SMALL_STATE(2561)] = 64267,
  [SMALL_STATE(2562)] = 64274,
  [SMALL_STATE(2563)] = 64281,
  [SMALL_STATE(2564)] = 64288,
  [SMALL_STATE(2565)] = 64295,
  [SMALL_STATE(2566)] = 64302,
  [SMALL_STATE(2567)] = 64309,
  [SMALL_STATE(2568)] = 64316,
  [SMALL_STATE(2569)] = 64323,
  [SMALL_STATE(2570)] = 64330,
  [SMALL_STATE(2571)] = 64337,
  [SMALL_STATE(2572)] = 64344,
  [SMALL_STATE(2573)] = 64351,
  [SMALL_STATE(2574)] = 64358,
  [SMALL_STATE(2575)] = 64365,
  [SMALL_STATE(2576)] = 64372,
  [SMALL_STATE(2577)] = 64379,
  [SMALL_STATE(2578)] = 64386,
  [SMALL_STATE(2579)] = 64393,
  [SMALL_STATE(2580)] = 64400,
  [SMALL_STATE(2581)] = 64407,
  [SMALL_STATE(2582)] = 64414,
  [SMALL_STATE(2583)] = 64421,
  [SMALL_STATE(2584)] = 64428,
  [SMALL_STATE(2585)] = 64435,
  [SMALL_STATE(2586)] = 64442,
  [SMALL_STATE(2587)] = 64449,
  [SMALL_STATE(2588)] = 64456,
  [SMALL_STATE(2589)] = 64463,
  [SMALL_STATE(2590)] = 64470,
  [SMALL_STATE(2591)] = 64477,
  [SMALL_STATE(2592)] = 64484,
  [SMALL_STATE(2593)] = 64491,
  [SMALL_STATE(2594)] = 64498,
  [SMALL_STATE(2595)] = 64505,
  [SMALL_STATE(2596)] = 64512,
  [SMALL_STATE(2597)] = 64519,
  [SMALL_STATE(2598)] = 64526,
  [SMALL_STATE(2599)] = 64533,
  [SMALL_STATE(2600)] = 64540,
  [SMALL_STATE(2601)] = 64547,
  [SMALL_STATE(2602)] = 64554,
  [SMALL_STATE(2603)] = 64561,
  [SMALL_STATE(2604)] = 64568,
  [SMALL_STATE(2605)] = 64575,
  [SMALL_STATE(2606)] = 64582,
  [SMALL_STATE(2607)] = 64589,
  [SMALL_STATE(2608)] = 64596,
  [SMALL_STATE(2609)] = 64603,
  [SMALL_STATE(2610)] = 64610,
  [SMALL_STATE(2611)] = 64617,
  [SMALL_STATE(2612)] = 64624,
  [SMALL_STATE(2613)] = 64631,
  [SMALL_STATE(2614)] = 64638,
  [SMALL_STATE(2615)] = 64645,
  [SMALL_STATE(2616)] = 64652,
  [SMALL_STATE(2617)] = 64659,
  [SMALL_STATE(2618)] = 64666,
  [SMALL_STATE(2619)] = 64673,
  [SMALL_STATE(2620)] = 64680,
  [SMALL_STATE(2621)] = 64687,
  [SMALL_STATE(2622)] = 64694,
  [SMALL_STATE(2623)] = 64701,
  [SMALL_STATE(2624)] = 64708,
  [SMALL_STATE(2625)] = 64715,
  [SMALL_STATE(2626)] = 64722,
  [SMALL_STATE(2627)] = 64729,
  [SMALL_STATE(2628)] = 64736,
  [SMALL_STATE(2629)] = 64743,
  [SMALL_STATE(2630)] = 64750,
  [SMALL_STATE(2631)] = 64757,
  [SMALL_STATE(2632)] = 64764,
  [SMALL_STATE(2633)] = 64771,
  [SMALL_STATE(2634)] = 64778,
  [SMALL_STATE(2635)] = 64785,
  [SMALL_STATE(2636)] = 64792,
  [SMALL_STATE(2637)] = 64799,
  [SMALL_STATE(2638)] = 64806,
  [SMALL_STATE(2639)] = 64813,
  [SMALL_STATE(2640)] = 64820,
  [SMALL_STATE(2641)] = 64827,
  [SMALL_STATE(2642)] = 64834,
  [SMALL_STATE(2643)] = 64841,
  [SMALL_STATE(2644)] = 64848,
  [SMALL_STATE(2645)] = 64855,
  [SMALL_STATE(2646)] = 64862,
  [SMALL_STATE(2647)] = 64869,
  [SMALL_STATE(2648)] = 64876,
  [SMALL_STATE(2649)] = 64883,
  [SMALL_STATE(2650)] = 64890,
  [SMALL_STATE(2651)] = 64897,
  [SMALL_STATE(2652)] = 64904,
  [SMALL_STATE(2653)] = 64911,
  [SMALL_STATE(2654)] = 64918,
  [SMALL_STATE(2655)] = 64925,
  [SMALL_STATE(2656)] = 64932,
  [SMALL_STATE(2657)] = 64939,
  [SMALL_STATE(2658)] = 64946,
  [SMALL_STATE(2659)] = 64953,
  [SMALL_STATE(2660)] = 64960,
  [SMALL_STATE(2661)] = 64967,
  [SMALL_STATE(2662)] = 64974,
  [SMALL_STATE(2663)] = 64981,
  [SMALL_STATE(2664)] = 64988,
  [SMALL_STATE(2665)] = 64995,
  [SMALL_STATE(2666)] = 65002,
  [SMALL_STATE(2667)] = 65009,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2638),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(783),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(482),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1427),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1914),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1737),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1388),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1465),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1035),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2183),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(76),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2660),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2658),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2657),
  [174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2656),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1265),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1310),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1340),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1336),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1860),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(97),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2653),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(196),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2651),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2648),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1037),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2189),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2645),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(193),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(194),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(189),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(295),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2193),
  [233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(78),
  [236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2639),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2638),
  [242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2204),
  [245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2206),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2208),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(297),
  [254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(297),
  [257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(307),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(568),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(311),
  [266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(679),
  [269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(808),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2631),
  [275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(110),
  [278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(744),
  [281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1042),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1044),
  [287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1426),
  [290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1391),
  [293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1850),
  [296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1915),
  [299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1394),
  [302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1706),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(87),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(402),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(407),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(413),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(352),
  [320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 134),
  [322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 134),
  [324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 2),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 2),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 3),
  [330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 3),
  [332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 134),
  [334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 134),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 2),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2654),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2276),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2663),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2667),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2260),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 1),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2634),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2578),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2661),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2579),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2361),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1), SHIFT(857),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 1), SHIFT(735),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 1),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_placeholder, 1),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 3),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 2),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 3),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 3),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2507),
  [984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2331),
  [987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 18),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(2422),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(77),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 47),
  [1003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47),
  [1005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(2422),
  [1008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(77),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [1013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [1017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 184),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 184),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [1025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 3),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [1029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91),
  [1035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91), SHIFT_REPEAT(2422),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 186),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 186),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 42),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 42),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 107),
  [1058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 107),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 109),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 109),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [1070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 152),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 63),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 63),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [1086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 151),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [1098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 140),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 139),
  [1104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 139),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 88),
  [1116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 88),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 176),
  [1122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 176),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 12),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 12),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 170),
  [1134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 170),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 177),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 96),
  [1150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 96),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 3),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 3),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 9, .production_id = 167),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 9, .production_id = 167),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_label_statement, 2),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_label_statement, 2),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 18),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 18),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 47),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 47),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5, .production_id = 40),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5, .production_id = 40),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 89),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 89),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, .production_id = 9),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, .production_id = 9),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 6),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 6),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 88),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 88),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 131),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 131),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration_list, 3),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration_list, 3),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 46),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 46),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 151),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 151),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, .production_id = 3),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, .production_id = 3),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, .production_id = 175),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, .production_id = 175),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 55),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 55),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 140),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 140),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, .production_id = 167),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, .production_id = 167),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 12),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 12),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, .production_id = 186),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, .production_id = 186),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3),
  [1284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5, .production_id = 99),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5, .production_id = 99),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 5),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 5),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 87),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 87),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 12),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 12),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 5),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 5),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 152),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 152),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, .production_id = 3),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, .production_id = 3),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 3, .production_id = 18),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause, 3, .production_id = 18),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 90),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 90),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 18),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 18),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 139),
  [1328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 139),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_echo_statement, 3),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_echo_statement, 3),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 4),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 4),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 42),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 42),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 170),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 170),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 5),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 5),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, .production_id = 27),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, .production_id = 27),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 5),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 5),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 7),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 7),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 4),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 4),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 12),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 12),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 4),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 4),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 12),
  [1380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 12),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_declaration, 3, .production_id = 12),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_declaration, 3, .production_id = 12),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 4),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 4),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 96),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 96),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 18),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 18),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 3),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 3),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 8),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 8),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration_list, 2),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration_list, 2),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 42),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 42),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 97),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 97),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 176),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 176),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 6, .production_id = 99),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 6, .production_id = 99),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 107),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 107),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 18),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 18),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 42),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 42),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 90),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 90),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 149),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 149),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 107),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 107),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 63),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 63),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 177),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 177),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 4),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 4),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 109),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 109),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 3),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 3),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 6),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 6),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 1, .production_id = 1),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 1, .production_id = 1),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 12),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 12),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 11),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 11),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 7),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 7),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 45),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 45),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 63),
  [1512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 63),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 46),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 46),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__const_declaration, 4, .production_id = 40),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__const_declaration, 4, .production_id = 40),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 3),
  [1528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 3),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 24),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 24),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [1582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_variable, 4, .production_id = 44),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dereferencable_expression, 1),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_variable, 4, .production_id = 44),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_access_expression, 3, .production_id = 25),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_access_expression, 3, .production_id = 25),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, .production_id = 25),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, .production_id = 25),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_access_expression, 5, .production_id = 102),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_access_expression, 5, .production_id = 102),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 5, .production_id = 102),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 5, .production_id = 102),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__reserved_identifier, 1),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_expression, 2, .production_id = 8),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call_expression, 2, .production_id = 8),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 3),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 3),
  [1618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4),
  [1620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 4),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 4),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_name, 2),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_name, 2),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 2),
  [1632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 2),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 60),
  [1636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 60),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 4, .production_id = 61),
  [1640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 4, .production_id = 61),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_call_expression, 4, .production_id = 61),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_call_expression, 4, .production_id = 61),
  [1646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 141),
  [1648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 141),
  [1650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 6, .production_id = 142),
  [1652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 6, .production_id = 142),
  [1654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullsafe_member_call_expression, 6, .production_id = 142),
  [1656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullsafe_member_call_expression, 6, .production_id = 142),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 1),
  [1678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__array_destructing_element, 1),
  [1681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1), REDUCE(sym__array_destructing_element, 3),
  [1690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 2),
  [1692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 2),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [1714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 22),
  [1716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 22),
  [1718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(2446),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_constant_access_expression, 3),
  [1751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_constant_access_expression, 3),
  [1753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_constant_access_expression, 5, .production_id = 101),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_constant_access_expression, 5, .production_id = 101),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [1787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_by_ref, 2),
  [1789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_by_ref, 2),
  [1791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1429),
  [1794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(744),
  [1797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1920),
  [1800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2183),
  [1803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [1805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(89),
  [1808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2579),
  [1811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(123),
  [1814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1411),
  [1817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1810),
  [1820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(2104),
  [1823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1682),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 2),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 2),
  [1838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing, 2), REDUCE(sym_array_creation_expression, 2),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_destructing, 2),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_encapsed_string, 3),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_encapsed_string, 3),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_encapsed_string, 2),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_encapsed_string, 2),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 17),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 17),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 3, .production_id = 19),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 3, .production_id = 19),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 4, .production_id = 51),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 4, .production_id = 51),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 6, .production_id = 17),
  [1873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 6, .production_id = 17),
  [1875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3),
  [1883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 5, .production_id = 94),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 5, .production_id = 94),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5, .production_id = 17),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5, .production_id = 17),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 6, .production_id = 138),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 6, .production_id = 138),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_scope, 1),
  [1897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3),
  [1899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 6, .production_id = 137),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 6, .production_id = 137),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc, 7, .production_id = 169),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nowdoc, 7, .production_id = 169),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 7, .production_id = 168),
  [1911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 7, .production_id = 168),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 5, .production_id = 93),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 5, .production_id = 93),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc, 5, .production_id = 92),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_heredoc, 5, .production_id = 92),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 17),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__argument_name, 2, .production_id = 52),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_name, 2, .production_id = 52),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_modifier, 1),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_modifier, 1),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 2),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 114),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 114),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, .production_id = 18),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, .production_id = 18),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_command_expression, 3),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_command_expression, 3),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 69),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 69),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_op_expression, 2, .production_id = 5),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_op_expression, 2, .production_id = 5),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 112),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 112),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 113),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 113),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_suppression_expression, 2),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_suppression_expression, 2),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 68),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 68),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 28),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 28),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 83),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 83),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_clone_expression, 2),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_clone_expression, 2),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 36),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 36),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 126),
  [2023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 126),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 38),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 38),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 82),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 82),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 67),
  [2035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 67),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4),
  [2039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 62),
  [2045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 62),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [2049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 106),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 106),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 171),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 171),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4),
  [2067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4),
  [2069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 6),
  [2071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 6),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 6, .production_id = 48),
  [2075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 6, .production_id = 48),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 143),
  [2079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 143),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 144),
  [2083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 144),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 81),
  [2087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 81),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 145),
  [2091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 145),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 146),
  [2095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 146),
  [2097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 147),
  [2099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 147),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 148),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 148),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 154),
  [2107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 154),
  [2109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 5),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 5),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 7, .production_id = 48),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 7, .production_id = 48),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 172),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 172),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 14),
  [2123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 14),
  [2125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 173),
  [2127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 173),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 174),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 174),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1),
  [2135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 8, .production_id = 185),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 8, .production_id = 185),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 10),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 10),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 39),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 39),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 105),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 105),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 104),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 104),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 103),
  [2159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 103),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 3),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_initializer, 3),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2),
  [2167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shell_command_expression, 2),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shell_command_expression, 2),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 1),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_element_initializer, 1),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 5, .production_id = 48),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 5, .production_id = 48),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [2187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 5),
  [2191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 5),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4, .production_id = 48),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4, .production_id = 48),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_expression, 2),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_intrinsic, 2),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, .production_id = 58),
  [2247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, .production_id = 58),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_assignment_expression, 4, .production_id = 59),
  [2251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 21),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [2257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 100),
  [2259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 100),
  [2261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 22),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_once_expression, 2),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_once_expression, 2),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_expression, 2),
  [2271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_unpacking, 2),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [2319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1313),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [2324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1265),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1310),
  [2330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1312),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1029),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1307),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expressions, 1),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_initializer, 2),
  [2437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_condition_list, 1),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_element, 3),
  [2447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 3, .production_id = 29),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 117),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 155),
  [2457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, .production_id = 53),
  [2459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, .production_id = 54),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [2483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__modifier, 1),
  [2485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [2487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modifier, 1),
  [2489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1313),
  [2492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1438),
  [2495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1579),
  [2498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1059),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [2503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1265),
  [2506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1310),
  [2509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1312),
  [2512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(640),
  [2515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1307),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1426),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [2529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 178),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 179),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 6, .production_id = 180),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 6, .production_id = 181),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 79),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 115),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 7, .production_id = 187),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 119),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 125),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [2571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_condition_list_repeat1, 2),
  [2573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, .production_id = 95),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_conditional_expression, 3, .production_id = 133),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_default_expression, 3, .production_id = 132),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 162),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 160),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 158),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 157),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 156),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [2627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_final_modifier, 1),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_final_modifier, 1),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_pair, 3),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [2755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1484),
  [2758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1438),
  [2761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1579),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2),
  [2766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(2448),
  [2769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1513),
  [2772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1511),
  [2775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1462),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1345),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1506),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_list_repeat1, 2), SHIFT_REPEAT(1426),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 1),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_modifier, 1),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_modifier, 1),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_modifier, 1),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_modifier, 1),
  [2807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_modifier, 1),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_modifier, 1),
  [2811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [2815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(1425),
  [2818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 1),
  [2820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 1),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 5),
  [2828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 5),
  [2830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 4),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 4),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_group, 3),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_group, 3),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [2846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(1426),
  [2849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1484),
  [2852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1513),
  [2855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1511),
  [2858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1462),
  [2861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1347),
  [2864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(1506),
  [2867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(284),
  [2880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1356),
  [2883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1356),
  [2886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1419),
  [2889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1678),
  [2892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [2900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_heredoc_body, 2), SHIFT(1419),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [2905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_heredoc_body, 2),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 129),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_heredoc_body_repeat1, 1),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 130),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 27),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 128),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 165),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 164),
  [2927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(284),
  [2930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1367),
  [2933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1367),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2),
  [2938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2), SHIFT_REPEAT(1678),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 85),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 9),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 2, .production_id = 86),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 3, .production_id = 11),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [2961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 182),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 163),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 2, .production_id = 84),
  [2983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_type, 1),
  [2985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_type, 1),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 182),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [2993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 6, .production_id = 188),
  [2999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 40),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 5, .production_id = 183),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 1, .production_id = 1),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [3023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_declaration, 1, .production_id = 41),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_const_declaration, 3, .production_id = 127),
  [3033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(244),
  [3036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1399),
  [3039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1399),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2),
  [3044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2), SHIFT_REPEAT(1736),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 163),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 40),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [3079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(401),
  [3082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1413),
  [3085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1413),
  [3088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2),
  [3090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_body, 2), SHIFT_REPEAT(1710),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_case, 4, .production_id = 75),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [3111] = {.entry = {.count = 4, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3118] = {.entry = {.count = 4, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [3129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_type, 2),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [3147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1),
  [3149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [3157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [3161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_intersection_type_repeat1, 2),
  [3163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1335),
  [3166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2),
  [3168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 4),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 4),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [3174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_union_type_repeat1, 2),
  [3176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_union_type_repeat1, 2), REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2),
  [3188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_part, 1),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2546),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_part, 1),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 4),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [3230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [3238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 3, .dynamic_precedence = -1),
  [3240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 3, .dynamic_precedence = -1),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 3),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [3260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [3272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1332),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [3279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 4, .dynamic_precedence = -1),
  [3281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 4, .dynamic_precedence = -1),
  [3283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [3285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [3287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1317),
  [3290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2),
  [3300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [3302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_disjunctive_normal_form_type, 2, .dynamic_precedence = -1),
  [3372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_disjunctive_normal_form_type, 2, .dynamic_precedence = -1),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2642),
  [3399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(2209),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [3412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [3414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(294),
  [3417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(2412),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [3422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_subscript_expression, 4),
  [3424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_subscript_expression, 4),
  [3426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_member_access_expression, 3, .production_id = 25),
  [3428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_member_access_expression, 3, .production_id = 25),
  [3430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__complex_string_part, 3),
  [3432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__complex_string_part, 3),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 1),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [3438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_string_part, 1, .production_id = 7),
  [3440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_part, 1, .production_id = 7),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body_heredoc, 2),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [3446] = {.entry = {.count = 5, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_union_type, 1), REDUCE(sym_intersection_type, 1), REDUCE(sym_disjunctive_normal_form_type, 1, .dynamic_precedence = -1), SHIFT(1333),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [3488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_clause, 2),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [3492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(2324),
  [3495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 47), SHIFT(84),
  [3498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(2324),
  [3501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 18), SHIFT(84),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_body, 2),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2),
  [3526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_execution_operator_body, 2),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 2),
  [3536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1334),
  [3539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1331),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [3548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1321),
  [3551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2),
  [3553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(2446),
  [3556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 1),
  [3558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(2529),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution_qualifier, 1),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 2),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [3595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 35),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 1),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_disjunctive_normal_form_type_repeat1, 2), SHIFT_REPEAT(1318),
  [3622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_type_repeat1, 2), SHIFT_REPEAT(1330),
  [3625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 91),
  [3627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 91), SHIFT_REPEAT(2420),
  [3630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 91),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [3642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(2529),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [3677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2), SHIFT_REPEAT(1444),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 91), SHIFT_REPEAT(2324),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 3, .production_id = 13),
  [3711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(2529),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [3756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [3828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 2),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [3836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_intersection_type, 2), SHIFT(1333),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [3849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_intersection_type_repeat1, 2), SHIFT_REPEAT(1333),
  [3852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 1),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [3856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 3),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [3864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [3866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1799),
  [3869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1799),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [3878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 1),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 1, .production_id = 2),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_clause, 3),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2),
  [3934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2), SHIFT_REPEAT(1935),
  [3937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2),
  [3939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2), SHIFT_REPEAT(1936),
  [3942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_clause_repeat1, 2), SHIFT_REPEAT(1451),
  [3945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2),
  [3947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2), SHIFT_REPEAT(1432),
  [3950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 2),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [3964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nowdoc_body, 2),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [3972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [3974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 1),
  [3976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__const_declaration_repeat1, 2),
  [3978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__const_declaration_repeat1, 2), SHIFT_REPEAT(1612),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [4001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2),
  [4003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2), SHIFT_REPEAT(2155),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [4014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(1575),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_nowdoc_body_repeat1, 2),
  [4021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_nowdoc_body_repeat1, 2), SHIFT_REPEAT(1903),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing, 4),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [4032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 3, .production_id = 50),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [4052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 2, .production_id = 4),
  [4054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(148),
  [4057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_destructing_element, 1, .production_id = 6),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [4097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 2),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 2),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 1, .production_id = 2),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 1),
  [4117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 15),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [4145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 2), SHIFT_REPEAT(152),
  [4148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__array_destructing_repeat1, 2),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [4158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 20),
  [4160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 26),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 3),
  [4172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 3),
  [4174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_aliasing_clause, 2),
  [4176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 30),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [4180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 2, .production_id = 31),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [4188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 32),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [4194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 33),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [4202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 45),
  [4204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 45),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [4210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2, .production_id = 49),
  [4212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 4),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [4218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 4, .production_id = 50),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [4222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 2), SHIFT_REPEAT(155),
  [4225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(149),
  [4228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_group_repeat1, 2), SHIFT_REPEAT(1428),
  [4231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_group_repeat1, 2),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 56),
  [4241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 64),
  [4243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 66),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [4249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 71),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 72),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(718),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [4262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 74),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [4266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 76),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [4272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 78),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [4286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 3),
  [4288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2), SHIFT_REPEAT(824),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [4301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 5),
  [4303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 5, .production_id = 50),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [4309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 5, .production_id = 80),
  [4311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 3, .production_id = 77),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 110),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_type, 2, .production_id = 37),
  [4333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 34),
  [4335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 116),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 121),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 4, .production_id = 122),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [4347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 124),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 7),
  [4361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 2),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [4365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [4377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 18),
  [4379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 18),
  [4381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(137),
  [4384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [4386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(154),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2),
  [4391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_condition_list_repeat1, 2), SHIFT_REPEAT(309),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 7, .production_id = 136),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 6),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [4410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2), SHIFT_REPEAT(1818),
  [4413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2),
  [4415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_promotion_parameter, 5, .production_id = 159),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2), SHIFT_REPEAT(1739),
  [4422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [4432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_destructing, 6, .production_id = 136),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [4438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 1), SHIFT(2245),
  [4441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 5),
  [4443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 5, .production_id = 161),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [4449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 4),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 3),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [4459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__list_destructing_repeat1, 4, .production_id = 135),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [4465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 2), SHIFT(2245),
  [4468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 6),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [4472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_type, 1),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_instead_of_clause, 3),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 4),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_reference, 2),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 123),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 120),
  [4500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 4),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 118),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing_element, 1), REDUCE(sym_array_element_initializer, 1),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 3),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [4515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(2446),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 4),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 75),
  [4582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 73),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [4590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 70),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [4602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_destructing_element, 3), REDUCE(sym_array_element_initializer, 3),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [4621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 2, .production_id = 11),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [4641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 43),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [4669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name_as_prefix, 4),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [4683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 57),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [4687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 4, .production_id = 65),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_directive, 3),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [4735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 3, .production_id = 16),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [4739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause_2, 2, .production_id = 3),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [4807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_string_subscript_unary_expression, 2),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 98),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [4821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 108),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [4829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 5, .production_id = 111),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [4911] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [4937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow_function_header, 6, .production_id = 153),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token_encapsed_string_chars = 1,
  ts_external_token_encapsed_string_chars_after_variable = 2,
  ts_external_token_execution_string_chars = 3,
  ts_external_token_execution_string_chars_after_variable = 4,
  ts_external_token_encapsed_string_chars_heredoc = 5,
  ts_external_token_encapsed_string_chars_after_variable_heredoc = 6,
  ts_external_token__eof = 7,
  ts_external_token_heredoc_start = 8,
  ts_external_token_heredoc_end = 9,
  ts_external_token_nowdoc_string = 10,
  ts_external_token_sentinel_error = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token_encapsed_string_chars] = sym_encapsed_string_chars,
  [ts_external_token_encapsed_string_chars_after_variable] = sym_encapsed_string_chars_after_variable,
  [ts_external_token_execution_string_chars] = sym_execution_string_chars,
  [ts_external_token_execution_string_chars_after_variable] = sym_execution_string_chars_after_variable,
  [ts_external_token_encapsed_string_chars_heredoc] = sym_encapsed_string_chars_heredoc,
  [ts_external_token_encapsed_string_chars_after_variable_heredoc] = sym_encapsed_string_chars_after_variable_heredoc,
  [ts_external_token__eof] = sym__eof,
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token_heredoc_end] = sym_heredoc_end,
  [ts_external_token_nowdoc_string] = sym_nowdoc_string,
  [ts_external_token_sentinel_error] = sym_sentinel_error,
};

static const bool ts_external_scanner_states[14][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_encapsed_string_chars] = true,
    [ts_external_token_encapsed_string_chars_after_variable] = true,
    [ts_external_token_execution_string_chars] = true,
    [ts_external_token_execution_string_chars_after_variable] = true,
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_encapsed_string_chars_after_variable_heredoc] = true,
    [ts_external_token__eof] = true,
    [ts_external_token_heredoc_start] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_nowdoc_string] = true,
    [ts_external_token_sentinel_error] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [4] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
  },
  [5] = {
    [ts_external_token_execution_string_chars] = true,
  },
  [6] = {
    [ts_external_token_encapsed_string_chars] = true,
  },
  [7] = {
    [ts_external_token_encapsed_string_chars_heredoc] = true,
    [ts_external_token_encapsed_string_chars_after_variable_heredoc] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [8] = {
    [ts_external_token_encapsed_string_chars] = true,
    [ts_external_token_encapsed_string_chars_after_variable] = true,
  },
  [9] = {
    [ts_external_token_execution_string_chars] = true,
    [ts_external_token_execution_string_chars_after_variable] = true,
  },
  [10] = {
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_nowdoc_string] = true,
  },
  [11] = {
    [ts_external_token_heredoc_start] = true,
  },
  [12] = {
    [ts_external_token_heredoc_end] = true,
  },
  [13] = {
    [ts_external_token_nowdoc_string] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_php_only_external_scanner_create(void);
void tree_sitter_php_only_external_scanner_destroy(void *);
bool tree_sitter_php_only_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_php_only_external_scanner_serialize(void *, char *);
void tree_sitter_php_only_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_php_only(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_name,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_php_only_external_scanner_create,
      tree_sitter_php_only_external_scanner_destroy,
      tree_sitter_php_only_external_scanner_scan,
      tree_sitter_php_only_external_scanner_serialize,
      tree_sitter_php_only_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
